/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],J=function(B){for(var n=[],y=0,t=B.length;y<t;y++)n[y]=Z[B[y]];return n},Ue=this,Oe=typeof global=="object"?global:{},ue;(function(B){B.global=Ue;var n=function(){function y(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(y.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(y.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(y.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(y.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(y.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),y.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=y._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},y._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},y}();B.Environment=n})(ue||(ue={}));var ue;(function(B){var n=function(){function F(c,E,h){this.type=c,this.detail=E,this.timestamp=h}return F}();B.LoaderEvent=n;var y=function(){function F(c){this._events=[new n(1,"",c)]}return F.prototype.record=function(c,E){this._events.push(new n(c,E,B.Utilities.getHighPerformanceTimestamp()))},F.prototype.getEvents=function(){return this._events},F}();B.LoaderEventRecorder=y;var t=function(){function F(){}return F.prototype.record=function(c,E){},F.prototype.getEvents=function(){return[]},F.INSTANCE=new F,F}();B.NullLoaderEventRecorder=t})(ue||(ue={}));var ue;(function(B){var n=function(){function y(){}return y.fileUriToFilePath=function(t,F){if(F=decodeURI(F).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(F))return F.substr(8);if(/^file:\/\//.test(F))return F.substr(5)}else if(/^file:\/\//.test(F))return F.substr(7);return F},y.startsWith=function(t,F){return t.length>=F.length&&t.substr(0,F.length)===F},y.endsWith=function(t,F){return t.length>=F.length&&t.substr(t.length-F.length)===F},y.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},y.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},y.forEachProperty=function(t,F){if(t){var c=void 0;for(c in t)t.hasOwnProperty(c)&&F(c,t[c])}},y.isEmpty=function(t){var F=!0;return y.forEachProperty(t,function(){F=!1}),F},y.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var F=Array.isArray(t)?[]:{};return y.forEachProperty(t,function(c,E){E&&typeof E=="object"?F[c]=y.recursiveClone(E):F[c]=E}),F},y.generateAnonymousModule=function(){return"===anonymous"+y.NEXT_ANONYMOUS_ID+++"==="},y.isAnonymousModule=function(t){return y.startsWith(t,"===anonymous")},y.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()},y.NEXT_ANONYMOUS_ID=1,y.PERFORMANCE_NOW_PROBED=!1,y.HAS_PERFORMANCE_NOW=!1,y}();B.Utilities=n})(ue||(ue={}));var ue;(function(B){function n(F){if(F instanceof Error)return F;var c=new Error(F.message||String(F)||"Unknown Error");return F.stack&&(c.stack=F.stack),c}B.ensureError=n;var y=function(){function F(){}return F.validateConfigurationOptions=function(c){function E(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=E),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(B.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){var h=n(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",c.onError(h),c.nodeCachedData=void 0}return c},F.mergeConfigurationOptions=function(c,E){c===void 0&&(c=null),E===void 0&&(E=null);var h=B.Utilities.recursiveClone(E||{});return B.Utilities.forEachProperty(c,function(o,f){o==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(f):o==="paths"&&typeof h.paths<"u"?B.Utilities.forEachProperty(f,function(A,D){return h.paths[A]=D}):o==="config"&&typeof h.config<"u"?B.Utilities.forEachProperty(f,function(A,D){return h.config[A]=D}):h[o]=B.Utilities.recursiveClone(f)}),F.validateConfigurationOptions(h)},F}();B.ConfigurationOptionsUtil=y;var t=function(){function F(c,E){if(this._env=c,this.options=y.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var h=this.options.nodeRequire.main.filename,o=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,o+1)}}return F.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0},F.prototype._createSortedPathsRules=function(){var c=this;this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,function(E,h){Array.isArray(h)?c.sortedPathsRules.push({from:E,to:h}):c.sortedPathsRules.push({from:E,to:[h]})}),this.sortedPathsRules.sort(function(E,h){return h.from.length-E.from.length})},F.prototype.cloneAndMerge=function(c){return new F(this._env,y.mergeConfigurationOptions(c,this.options))},F.prototype.getOptionsLiteral=function(){return this.options},F.prototype._applyPaths=function(c){for(var E,h=0,o=this.sortedPathsRules.length;h<o;h++)if(E=this.sortedPathsRules[h],B.Utilities.startsWith(c,E.from)){for(var f=[],A=0,D=E.to.length;A<D;A++)f.push(E.to[A]+c.substr(E.from.length));return f}return[c]},F.prototype._addUrlArgsToUrl=function(c){return B.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs},F.prototype._addUrlArgsIfNecessaryToUrl=function(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c},F.prototype._addUrlArgsIfNecessaryToUrls=function(c){if(this.options.urlArgs)for(var E=0,h=c.length;E<h;E++)c[E]=this._addUrlArgsToUrl(c[E]);return c},F.prototype.moduleIdToPaths=function(c){if(this._env.isNode){var E=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c);if(E)return this.isBuild()?["empty:"]:["node|"+c]}var h=c,o;if(!B.Utilities.endsWith(h,".js")&&!B.Utilities.isAbsolutePath(h)){o=this._applyPaths(h);for(var f=0,A=o.length;f<A;f++)this.isBuild()&&o[f]==="empty:"||(B.Utilities.isAbsolutePath(o[f])||(o[f]=this.options.baseUrl+o[f]),!B.Utilities.endsWith(o[f],".js")&&!B.Utilities.containsQueryString(o[f])&&(o[f]=o[f]+".js"))}else!B.Utilities.endsWith(h,".js")&&!B.Utilities.containsQueryString(h)&&(h=h+".js"),o=[h];return this._addUrlArgsIfNecessaryToUrls(o)},F.prototype.requireToUrl=function(c){var E=c;return B.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],B.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)},F.prototype.isBuild=function(){return this.options.isBuild},F.prototype.shouldInvokeFactory=function(c){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])},F.prototype.isDuplicateMessageIgnoredFor=function(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)},F.prototype.getConfigForModule=function(c){if(this.options.config)return this.options.config[c]},F.prototype.shouldCatchError=function(){return this.options.catchError},F.prototype.shouldRecordStats=function(){return this.options.recordStats},F.prototype.onError=function(c){this.options.onError(c)},F}();B.Configuration=t})(ue||(ue={}));var ue;(function(B){var n=function(){function o(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(f,A,D,p){var b=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new F;else if(this._env.isElectronRenderer){var e=f.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new y:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new y;var N={callback:D,errorback:p};if(this._callbackMap.hasOwnProperty(A)){this._callbackMap[A].push(N);return}this._callbackMap[A]=[N],this._scriptLoader.load(f,A,function(){return b.triggerCallback(A)},function(R){return b.triggerErrorback(A,R)})},o.prototype.triggerCallback=function(f){var A=this._callbackMap[f];delete this._callbackMap[f];for(var D=0;D<A.length;D++)A[D].callback()},o.prototype.triggerErrorback=function(f,A){var D=this._callbackMap[f];delete this._callbackMap[f];for(var p=0;p<D.length;p++)D[p].errorback(A)},o}(),y=function(){function o(){}return o.prototype.attachListeners=function(f,A,D){var p=function(){f.removeEventListener("load",b),f.removeEventListener("error",e)},b=function(N){p(),A()},e=function(N){p(),D(N)};f.addEventListener("load",b),f.addEventListener("error",e)},o.prototype.load=function(f,A,D,p){if(/^node\|/.test(A)){var b=f.getConfig().getOptionsLiteral(),e=E(f.getRecorder(),b.nodeRequire||B.global.nodeRequire),N=A.split("|"),R=null;try{R=e(N[1])}catch(a){p(a);return}f.enqueueDefineAnonymousModule([],function(){return R}),D()}else{var C=document.createElement("script");C.setAttribute("async","async"),C.setAttribute("type","text/javascript"),this.attachListeners(C,D,p);var w=f.getConfig().getOptionsLiteral().trustedTypesPolicy;w&&(A=w.createScriptURL(A)),C.setAttribute("src",A);var i=f.getConfig().getOptionsLiteral().cspNonce;i&&C.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(C)}},o}();function t(o){var f=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var A=f?self.eval(f.createScript("","true")):new Function("true");return A.call(self),!0}catch{return!1}}var F=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(f)),this._cachedCanUseEval},o.prototype.load=function(f,A,D,p){if(/^node\|/.test(A)){var b=f.getConfig().getOptionsLiteral(),e=E(f.getRecorder(),b.nodeRequire||B.global.nodeRequire),N=A.split("|"),R=null;try{R=e(N[1])}catch(i){p(i);return}f.enqueueDefineAnonymousModule([],function(){return R}),D()}else{var C=f.getConfig().getOptionsLiteral().trustedTypesPolicy,w=/^((http:)|(https:)|(file:))/.test(A)&&A.substring(0,self.origin.length)!==self.origin;if(!w&&this._canUseEval(f)){fetch(A).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+A;var a=C?self.eval(C.createScript("",i)):new Function(i);a.call(self),D()}).then(void 0,p);return}try{C&&(A=C.createScriptURL(A)),importScripts(A),D()}catch(i){p(i)}}},o}(),c=function(){function o(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},o.prototype._initNodeRequire=function(f,A){var D=A.getConfig().getOptionsLiteral().nodeCachedData;if(!D||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var p=this,b=f("module");function e(N){var R=N.constructor,C=function(i){try{return N.require(i)}finally{}};return C.resolve=function(i,a){return R._resolveFilename(i,N,!1,a)},C.resolve.paths=function(i){return R._resolveLookupPaths(i,N)},C.main=process.mainModule,C.extensions=R._extensions,C.cache=R._cache,C}b.prototype._compile=function(N,R){var C=b.wrap(N.replace(/^#!.*/,"")),w=A.getRecorder(),i=p._getCachedDataPath(D,R),a={filename:R},s;try{var l=p._fs.readFileSync(i);s=l.slice(0,16),a.cachedData=l.slice(16),w.record(60,i)}catch{w.record(61,i)}var u=new p._vm.Script(C,a),g=u.runInThisContext(a),d=p._path.dirname(R),L=e(this),v=[this.exports,L,this,R,d,process,Oe,Buffer],m=g.apply(this.exports,v);return p._handleCachedData(u,C,i,!a.cachedData,A),p._verifyCachedData(u,C,i,s,A),m}},o.prototype.load=function(f,A,D,p){var b=this,e=f.getConfig().getOptionsLiteral(),N=E(f.getRecorder(),e.nodeRequire||B.global.nodeRequire),R=e.nodeInstrumenter||function(g){return g};this._init(N),this._initNodeRequire(N,f);var C=f.getRecorder();if(/^node\|/.test(A)){var w=A.split("|"),i=null;try{i=N(w[1])}catch(g){p(g);return}f.enqueueDefineAnonymousModule([],function(){return i}),D()}else{A=B.Utilities.fileUriToFilePath(this._env.isWindows,A);var a=this._path.normalize(A),s=this._getElectronRendererScriptPathOrUri(a),l=Boolean(e.nodeCachedData),u=l?this._getCachedDataPath(e.nodeCachedData,A):void 0;this._readSourceAndCachedData(a,u,C,function(g,d,L,v){if(g){p(g);return}var m;d.charCodeAt(0)===o._BOM?m=o._PREFIX+d.substring(1)+o._SUFFIX:m=o._PREFIX+d+o._SUFFIX,m=R(m,a);var _={filename:s,cachedData:L},M=b._createAndEvalScript(f,m,_,D,p);b._handleCachedData(M,m,u,l&&!L,f),b._verifyCachedData(M,m,u,v,f)})}},o.prototype._createAndEvalScript=function(f,A,D,p,b){var e=f.getRecorder();e.record(31,D.filename);var N=new this._vm.Script(A,D),R=N.runInThisContext(D),C=f.getGlobalAMDDefineFunc(),w=!1,i=function(){return w=!0,C.apply(null,arguments)};return i.amd=C.amd,R.call(B.global,f.getGlobalAMDRequireFunc(),i,D.filename,this._path.dirname(D.filename)),e.record(32,D.filename),w?p():b(new Error("Didn't receive define call in "+D.filename+"!")),N},o.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var A=f.match(/^([a-z])\:(.*)/i);return A?"file:///"+(A[1].toUpperCase()+":"+A[2]).replace(/\\/g,"/"):"file://"+f},o.prototype._getCachedDataPath=function(f,A){var D=this._crypto.createHash("md5").update(A,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),p=this._path.basename(A).replace(/\.js$/,"");return this._path.join(f.path,p+"-"+D+".code")},o.prototype._handleCachedData=function(f,A,D,p,b){var e=this;f.cachedDataRejected?this._fs.unlink(D,function(N){b.getRecorder().record(62,D),e._createAndWriteCachedData(f,A,D,b),N&&b.getConfig().onError(N)}):p&&this._createAndWriteCachedData(f,A,D,b)},o.prototype._createAndWriteCachedData=function(f,A,D,p){var b=this,e=Math.ceil(p.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),N=-1,R=0,C=void 0,w=function(){setTimeout(function(){C||(C=b._crypto.createHash("md5").update(A,"utf8").digest());var i=f.createCachedData();if(!(i.length===0||i.length===N||R>=5)){if(i.length<N){w();return}N=i.length,b._fs.writeFile(D,Buffer.concat([C,i]),function(a){a&&p.getConfig().onError(a),p.getRecorder().record(63,D),w()})}},e*Math.pow(4,R++))};w()},o.prototype._readSourceAndCachedData=function(f,A,D,p){if(!A)this._fs.readFile(f,{encoding:"utf8"},p);else{var b=void 0,e=void 0,N=void 0,R=2,C=function(w){w?p(w):--R===0&&p(void 0,b,e,N)};this._fs.readFile(f,{encoding:"utf8"},function(w,i){b=i,C(w)}),this._fs.readFile(A,function(w,i){!w&&i&&i.length>0?(N=i.slice(0,16),e=i.slice(16),D.record(60,A)):D.record(61,A),C()})}},o.prototype._verifyCachedData=function(f,A,D,p,b){var e=this;!p||f.cachedDataRejected||setTimeout(function(){var N=e._crypto.createHash("md5").update(A,"utf8").digest();p.equals(N)||(b.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+D+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(D,function(R){R&&b.getConfig().onError(R)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function E(o,f){if(f.__$__isRecorded)return f;var A=function(p){o.record(33,p);try{return f(p)}finally{o.record(34,p)}};return A.__$__isRecorded=!0,A}B.ensureRecordedNodeRequire=E;function h(o){return new n(o)}B.createScriptLoader=h})(ue||(ue={}));var ue;(function(B){var n=function(){function h(o){var f=o.lastIndexOf("/");f!==-1?this.fromModulePath=o.substr(0,f+1):this.fromModulePath=""}return h._normalizeModuleId=function(o){var f=o,A;for(A=/\/\.\//;A.test(f);)f=f.replace(A,"/");for(f=f.replace(/^\.\//g,""),A=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;A.test(f);)f=f.replace(A,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},h.prototype.resolveModule=function(o){var f=o;return B.Utilities.isAbsolutePath(f)||(B.Utilities.startsWith(f,"./")||B.Utilities.startsWith(f,"../"))&&(f=h._normalizeModuleId(this.fromModulePath+f)),f},h.ROOT=new h(""),h}();B.ModuleIdResolver=n;var y=function(){function h(o,f,A,D,p,b){this.id=o,this.strId=f,this.dependencies=A,this._callback=D,this._errorback=p,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return h._safeInvokeFunction=function(o,f){try{return{returnedValue:o.apply(B.global,f),producedError:null}}catch(A){return{returnedValue:null,producedError:A}}},h._invokeFactory=function(o,f,A,D){return o.shouldInvokeFactory(f)?o.shouldCatchError()?this._safeInvokeFunction(A,D):{returnedValue:A.apply(B.global,D),producedError:null}:{returnedValue:null,producedError:null}},h.prototype.complete=function(o,f,A,D){this._isComplete=!0;var p=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var b=h._invokeFactory(f,this.strId,this._callback,A);p=b.producedError,o.record(22,this.strId),!p&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(p){var e=B.ensureError(p);e.phase="factory",e.moduleId=this.strId,e.neededBy=D(this.id),this.error=e,f.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},h.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},h.prototype.isComplete=function(){return this._isComplete},h}();B.Module=y;var t=function(){function h(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return h.prototype.getMaxModuleId=function(){return this._nextId},h.prototype.getModuleId=function(o){var f=this._strModuleIdToIntModuleId.get(o);return typeof f>"u"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(o,f),this._intModuleIdToStrModuleId[f]=o),f},h.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},h}(),F=function(){function h(o){this.id=o}return h.EXPORTS=new h(0),h.MODULE=new h(1),h.REQUIRE=new h(2),h}();B.RegularDependency=F;var c=function(){function h(o,f,A){this.id=o,this.pluginId=f,this.pluginParam=A}return h}();B.PluginDependency=c;var E=function(){function h(o,f,A,D,p){p===void 0&&(p=0),this._env=o,this._scriptLoader=f,this._loaderAvailableTimestamp=p,this._defineFunc=A,this._requireFunc=D,this._moduleIdProvider=new t,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return h.prototype.reset=function(){return new h(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},h.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},h.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},h._findRelevantLocationInStack=function(o,f){for(var A=function(a){return a.replace(/\\/g,"/")},D=A(o),p=f.split(/\n/),b=0;b<p.length;b++){var e=p[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){var N=e[1],R=e[2],C=e[3],w=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(w),N=A(N),N===D){var i={line:parseInt(R,10),col:parseInt(C,10)};return i.line===1&&(i.col-=53),i}}}throw new Error("Could not correlate define call site for needle "+o)},h.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],f=0,A=0,D=this._modules2.length;A<D;A++){var p=this._modules2[A];if(!!p){var b=this._buildInfoPath[p.id]||null,e=this._buildInfoDefineStack[p.id]||null,N=this._buildInfoDependencies[p.id];o[f++]={id:p.strId,path:b,defineLocation:b&&e?h._findRelevantLocationInStack(b,e):null,dependencies:N,shim:null,exports:p.exports}}}return o},h.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder},h.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},h.prototype.enqueueDefineAnonymousModule=function(o,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var A=null;this._config.isBuild()&&(A=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:A,dependencies:o,callback:f}},h.prototype.defineModule=function(o,f,A,D,p,b){var e=this;b===void 0&&(b=new n(o));var N=this._moduleIdProvider.getModuleId(o);if(this._modules2[N]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var R=new y(N,o,this._normalizeDependencies(f,b),A,D,b);this._modules2[N]=R,this._config.isBuild()&&(this._buildInfoDefineStack[N]=p,this._buildInfoDependencies[N]=(R.dependencies||[]).map(function(C){return e._moduleIdProvider.getStrModuleId(C.id)})),this._resolve(R)},h.prototype._normalizeDependency=function(o,f){if(o==="exports")return F.EXPORTS;if(o==="module")return F.MODULE;if(o==="require")return F.REQUIRE;var A=o.indexOf("!");if(A>=0){var D=f.resolveModule(o.substr(0,A)),p=f.resolveModule(o.substr(A+1)),b=this._moduleIdProvider.getModuleId(D+"!"+p),e=this._moduleIdProvider.getModuleId(D);return new c(b,e,p)}return new F(this._moduleIdProvider.getModuleId(f.resolveModule(o)))},h.prototype._normalizeDependencies=function(o,f){for(var A=[],D=0,p=0,b=o.length;p<b;p++)A[D++]=this._normalizeDependency(o[p],f);return A},h.prototype._relativeRequire=function(o,f,A,D){if(typeof f=="string")return this.synchronousRequire(f,o);this.defineModule(B.Utilities.generateAnonymousModule(),f,A,D,null,o)},h.prototype.synchronousRequire=function(o,f){f===void 0&&(f=new n(o));var A=this._normalizeDependency(o,f),D=this._modules2[A.id];if(!D)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!D.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(D.error)throw D.error;return D.exports},h.prototype.configure=function(o,f){var A=this._config.shouldRecordStats();f?this._config=new B.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!A&&(this._recorder=null)},h.prototype.getConfig=function(){return this._config},h.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),f.dependencies,f.callback,null,f.stack)}},h.prototype._createLoadError=function(o,f){var A=this,D=this._moduleIdProvider.getStrModuleId(o),p=(this._inverseDependencies2[o]||[]).map(function(e){return A._moduleIdProvider.getStrModuleId(e)}),b=B.ensureError(f);return b.phase="loading",b.moduleId=D,b.neededBy=p,b},h.prototype._onLoadError=function(o,f){var A=this._createLoadError(o,f);this._modules2[o]||(this._modules2[o]=new y(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},null,null));for(var D=[],p=0,b=this._moduleIdProvider.getMaxModuleId();p<b;p++)D[p]=!1;var e=!1,N=[];for(N.push(o),D[o]=!0;N.length>0;){var R=N.shift(),C=this._modules2[R];C&&(e=C.onDependencyError(A)||e);var w=this._inverseDependencies2[R];if(w)for(var p=0,b=w.length;p<b;p++){var i=w[p];D[i]||(N.push(i),D[i]=!0)}}e||this._config.onError(A)},h.prototype._hasDependencyPath=function(o,f){var A=this._modules2[o];if(!A)return!1;for(var D=[],p=0,b=this._moduleIdProvider.getMaxModuleId();p<b;p++)D[p]=!1;var e=[];for(e.push(A),D[o]=!0;e.length>0;){var N=e.shift(),R=N.dependencies;if(R)for(var p=0,b=R.length;p<b;p++){var C=R[p];if(C.id===f)return!0;var w=this._modules2[C.id];w&&!D[C.id]&&(D[C.id]=!0,e.push(w))}}return!1},h.prototype._findCyclePath=function(o,f,A){if(o===f||A===50)return[o];var D=this._modules2[o];if(!D)return null;var p=D.dependencies;if(p)for(var b=0,e=p.length;b<e;b++){var N=this._findCyclePath(p[b].id,f,A+1);if(N!==null)return N.push(o),N}return null},h.prototype._createRequire=function(o){var f=this,A=function(D,p,b){return f._relativeRequire(o,D,p,b)};return A.toUrl=function(D){return f._config.requireToUrl(o.resolveModule(D))},A.getStats=function(){return f.getLoaderEvents()},A.hasDependencyCycle=function(){return f._hasDependencyCycle},A.config=function(D,p){p===void 0&&(p=!1),f.configure(D,p)},A.__$__nodeRequire=B.global.nodeRequire,A},h.prototype._loadModule=function(o){var f=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var A=this._moduleIdProvider.getStrModuleId(o),D=this._config.moduleIdToPaths(A),p=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(A.indexOf("/")===-1||p.test(A))&&D.push("node|"+A);var b=-1,e=function(N){if(b++,b>=D.length)f._onLoadError(o,N);else{var R=D[b],C=f.getRecorder();if(f._config.isBuild()&&R==="empty:"){f._buildInfoPath[o]=R,f.defineModule(f._moduleIdProvider.getStrModuleId(o),[],null,null,null),f._onLoad(o);return}C.record(10,R),f._scriptLoader.load(f,R,function(){f._config.isBuild()&&(f._buildInfoPath[o]=R),C.record(11,R),f._onLoad(o)},function(w){C.record(12,R),e(w)})}};e(null)}},h.prototype._loadPluginDependency=function(o,f){var A=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var D=function(p){A.defineModule(A._moduleIdProvider.getStrModuleId(f.id),[],p,null,null)};D.error=function(p){A._config.onError(A._createLoadError(f.id,p))},o.load(f.pluginParam,this._createRequire(n.ROOT),D,this._config.getOptionsLiteral())}},h.prototype._resolve=function(o){var f=this,A=o.dependencies;if(A)for(var D=0,p=A.length;D<p;D++){var b=A[D];if(b===F.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(b===F.MODULE){o.unresolvedDependenciesCount--;continue}if(b===F.REQUIRE){o.unresolvedDependenciesCount--;continue}var e=this._modules2[b.id];if(e&&e.isComplete()){if(e.error){o.onDependencyError(e.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var N=this._findCyclePath(b.id,o.id,0)||[];N.reverse(),N.push(b.id),console.warn(N.map(function(w){return f._moduleIdProvider.getStrModuleId(w)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(o.id),b instanceof c){var R=this._modules2[b.pluginId];if(R&&R.isComplete()){this._loadPluginDependency(R.exports,b);continue}var C=this._inversePluginDependencies2.get(b.pluginId);C||(C=[],this._inversePluginDependencies2.set(b.pluginId,C)),C.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},h.prototype._onModuleComplete=function(o){var f=this,A=this.getRecorder();if(!o.isComplete()){var D=o.dependencies,p=[];if(D)for(var b=0,e=D.length;b<e;b++){var N=D[b];if(N===F.EXPORTS){p[b]=o.exports;continue}if(N===F.MODULE){p[b]={id:o.strId,config:function(){return f._config.getConfigForModule(o.strId)}};continue}if(N===F.REQUIRE){p[b]=this._createRequire(o.moduleIdResolver);continue}var R=this._modules2[N.id];if(R){p[b]=R.exports;continue}p[b]=null}var C=function(l){return(f._inverseDependencies2[l]||[]).map(function(u){return f._moduleIdProvider.getStrModuleId(u)})};o.complete(A,this._config,p,C);var w=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,w)for(var b=0,e=w.length;b<e;b++){var i=w[b],a=this._modules2[i];a.unresolvedDependenciesCount--,a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}var s=this._inversePluginDependencies2.get(o.id);if(s){this._inversePluginDependencies2.delete(o.id);for(var b=0,e=s.length;b<e;b++)this._loadPluginDependency(o.exports,s[b])}}},h}();B.ModuleManager=E})(ue||(ue={}));var Y,ue;(function(B){var n=new B.Environment,y=null,t=function(h,o,f){typeof h!="string"&&(f=o,o=h,h=null),(typeof o!="object"||!Array.isArray(o))&&(f=o,o=null),o||(o=["require","exports","module"]),h?y.defineModule(h,o,f,null,null):y.enqueueDefineAnonymousModule(o,f)};t.amd={jQuery:!0};var F=function(h,o){o===void 0&&(o=!1),y.configure(h,o)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){F(arguments[0]);return}if(typeof arguments[0]=="string")return y.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){y.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=F,c.getConfig=function(){return y.getConfig().getOptionsLiteral()},c.reset=function(){y=y.reset()},c.getBuildInfo=function(){return y.getBuildInfo()},c.getStats=function(){return y.getLoaderEvents()},c.define=t;function E(){if(typeof B.global.require<"u"||typeof require<"u"){var h=B.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){var o=B.ensureRecordedNodeRequire(y.getRecorder(),h);B.global.nodeRequire=o,c.nodeRequire=o,c.__$__nodeRequire=o}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=c:(n.isElectronRenderer||(B.global.define=t),B.global.require=c)}B.init=E,(typeof B.global.define!="function"||!B.global.define.amd)&&(y=new B.ModuleManager(n,B.createScriptLoader(n),t,c,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&c.config(B.global.require),Y=function(){return t.apply(null,arguments)},Y.amd=t.amd,typeof doNotInitLoader>"u"&&E())})(ue||(ue={})),Y(Z[53],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=void 0;function y(h,o,f,A){if(A=A||{},(A["vs/css"]||{}).disabled){f({});return}const p=o.toUrl(h+".css");t(h,p,()=>{f({})},b=>{typeof f.error=="function"&&f.error("Could not find "+p+".")})}n.load=y;function t(h,o,f,A){if(F(h,o)){f();return}c(h,o,f,A)}function F(h,o){const f=document.getElementsByTagName("link");for(let A=0,D=f.length;A<D;A++){const p=f[A].getAttribute("data-name"),b=f[A].getAttribute("href");if(p===h||b===o)return!0}return!1}function c(h,o,f,A){const D=document.createElement("link");D.setAttribute("rel","stylesheet"),D.setAttribute("type","text/css"),D.setAttribute("data-name",h),E(h,D,f,A),D.setAttribute("href",o),(document.head||document.getElementsByTagName("head")[0]).appendChild(D)}function E(h,o,f,A){const D=()=>{o.removeEventListener("load",p),o.removeEventListener("error",b)},p=e=>{D(),f()},b=e=>{D(),A(e)};o.addEventListener("load",p),o.addEventListener("error",b)}}),Y("vs/nls",["require","exports"],function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let y=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const t="i-default";function F(e,N){let R;return N.length===0?R=e:R=e.replace(/\{(\d+)\}/g,(C,w)=>{const i=w[0],a=N[i];let s=C;return typeof a=="string"?s=a:(typeof a=="number"||typeof a=="boolean"||a===void 0||a===null)&&(s=String(a)),s}),y&&(R="\uFF3B"+R.replace(/[aouei]/g,"$&$&")+"\uFF3D"),R}function c(e,N){let R=e[N];return R||(R=e["*"],R)?R:null}function E(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function h(e,N,R){const C=E(e)+E(N)+"vscode/"+E(R),w=await fetch(C);if(w.ok)return await w.json();throw new Error(`${w.status} - ${w.statusText}`)}function o(e){return function(N,R){const C=Array.prototype.slice.call(arguments,2);return F(e[N],C)}}function f(e,N,...R){return F(N,R)}n.localize=f;function A(e){}n.getConfiguredDefaultLocale=A;function D(e){y=e}n.setPseudoTranslation=D;function p(e,N){return{localize:o(N[e]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??(R=>{})}}n.create=p;function b(e,N,R,C){const w=C["vs/nls"]??{};if(!e||e.length===0)return R({localize:f,getConfiguredDefaultLocale:()=>w.availableLanguages?.["*"]});const i=w.availableLanguages?c(w.availableLanguages,e):null,a=i===null||i===t;let s=".nls";a||(s=s+"."+i);const l=u=>{Array.isArray(u)?u.localize=o(u):u.localize=o(u[e]),u.getConfiguredDefaultLocale=()=>w.availableLanguages?.["*"],R(u)};typeof w.loadBundle=="function"?w.loadBundle(e,i,(u,g)=>{u?N([e+".nls"],l):l(g)}):w.translationServiceUrl&&!a?(async()=>{try{const u=await h(w.translationServiceUrl,i,e);return l(u)}catch(u){if(!i.includes("-"))return console.error(u),N([e+".nls"],l);try{const g=i.split("-")[0],d=await h(w.translationServiceUrl,g,e);return w.availableLanguages??={},w.availableLanguages["*"]=g,l(d)}catch(g){return console.error(g),N([e+".nls"],l)}}})():N([e+s],l,u=>{if(s===".nls"){console.error("Failed trying to load default language strings",u);return}console.error(`Failed to load message bundle for language ${i}. Falling back to the default language:`,u),N([e+".nls"],l)})}n.load=b}),function(){const B=self.MonacoEnvironment,n=B&&B.baseUrl?B.baseUrl:"../../../",y=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:f=>f,createScript:(f,...A)=>{const D=A.slice(0,-1).join(","),p=A.pop().toString();return`(function anonymous(${D}) { ${p}
})`}}):void 0;function t(){try{return(y?self.eval(y.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function F(){return new Promise((f,A)=>{if(typeof self.define=="function"&&self.define.amd)return f();const D=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(D)&&D.substring(0,self.origin.length)!==self.origin)&&t()){fetch(D).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${D}`,(y?self.eval(y.createScript("",b)):new Function(b)).call(self),f()}).then(void 0,A);return}y?importScripts(y.createScriptURL(D)):importScripts(D),f()})}function c(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:y,amdModulesPattern:/^vs\//})}function E(f){F().then(()=>{c(),require([f],function(A){setTimeout(function(){const D=A.create((p,b)=>{self.postMessage(p,b)},null);for(self.onmessage=p=>D.onmessage(p.data,p.ports);o.length>0;)self.onmessage(o.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&c();let h=!0;const o=[];self.onmessage=f=>{if(!h){o.push(f);return}h=!1,E(f.data)}}(),Y(Z[24],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.getClassNamesArray=n.Codicon=n.getCodiconAriaLabel=void 0;function y(E){return E?E.replace(/\$\((.*?)\)/g,(h,o)=>` ${o} `).trim():""}n.getCodiconAriaLabel=y;class t{constructor(h,o,f){this.id=h,this.definition=o,this.description=f,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}n.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function F(E,h){const o=["codicon","codicon-"+E];return h&&o.push("codicon-modifier-"+h),o}n.getClassNamesArray=F;var c;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function o(D){if(D instanceof t)return["codicon","codicon-"+D.id];const p=h.exec(D.id);if(!p)return o(t.error);const[,b,e]=p,N=["codicon","codicon-"+b];return e&&N.push("codicon-modifier-"+e.substr(1)),N}E.asClassNameArray=o;function f(D){return o(D).join(" ")}E.asClassName=f;function A(D){return"."+o(D).join(".")}E.asCSSSelector=A})(c=n.CSSIcon||(n.CSSIcon={}))}),Y(Z[25],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class y{constructor(F,c,E,h){this.originalStart=F,this.originalLength=c,this.modifiedStart=E,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=y}),Y(Z[6],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?i.isErrorNoTelemetry(l)?new i(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(u=>{u(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}n.ErrorHandler=y,n.errorHandler=new y;function t(s){n.errorHandler.setUnexpectedErrorHandler(s)}n.setUnexpectedErrorHandler=t;function F(s){o(s)||n.errorHandler.onUnexpectedError(s)}n.onUnexpectedError=F;function c(s){o(s)||n.errorHandler.onUnexpectedExternalError(s)}n.onUnexpectedExternalError=c;function E(s){if(s instanceof Error){const{name:l,message:u}=s,g=s.stacktrace||s.stack;return{$isError:!0,name:l,message:u,stack:g,noTelemetry:i.isErrorNoTelemetry(s)}}return s}n.transformErrorForSerialization=E;const h="Canceled";function o(s){return s instanceof f?!0:s instanceof Error&&s.name===h&&s.message===h}n.isCancellationError=o;class f extends Error{constructor(){super(h),this.name=this.message}}n.CancellationError=f;function A(){const s=new Error(h);return s.name=s.message,s}n.canceled=A;function D(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}n.illegalArgument=D;function p(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}n.illegalState=p;function b(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=b;function e(s){const l=new Error(`${s} has been disposed`);return l.name="DISPOSED",l}n.disposed=e;function N(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}n.getErrorMessage=N;class R extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}n.NotImplementedError=R;class C extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}n.NotSupportedError=C;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}n.ExpectedError=w;class i extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof i)return l;const u=new i;return u.message=l.message,u.stack=l.stack,u}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}n.ErrorNoTelemetry=i;class a extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype);debugger}}n.BugIndicatingError=a}),Y(Z[26],J([0,1,6]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushMany=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.lastOrDefault=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function t(S,k=0){return S[S.length-(1+k)]}n.tail=t;function F(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}n.tail2=F;function c(S,k,I=(V,H)=>V===H){if(S===k)return!0;if(!S||!k||S.length!==k.length)return!1;for(let V=0,H=S.length;V<H;V++)if(!I(S[V],k[V]))return!1;return!0}n.equals=c;function E(S,k){const I=S.length-1;k<I&&(S[k]=S[I]),S.pop()}n.removeFastWithoutKeepingOrder=E;function h(S,k,I){return o(S.length,V=>I(S[V],k))}n.binarySearch=h;function o(S,k){let I=0,V=S-1;for(;I<=V;){const H=(I+V)/2|0,se=k(H);if(se<0)I=H+1;else if(se>0)V=H-1;else return H}return-(I+1)}n.binarySearch2=o;function f(S,k){let I=0,V=S.length;if(V===0)return 0;for(;I<V;){const H=Math.floor((I+V)/2);k(S[H])?V=H:I=H+1}return I}n.findFirstInSorted=f;function A(S,k,I){if(S=S|0,S>=k.length)throw new TypeError("invalid index");const V=k[Math.floor(k.length*Math.random())],H=[],se=[],ie=[];for(const ce of k){const fe=I(ce,V);fe<0?H.push(ce):fe>0?se.push(ce):ie.push(ce)}return S<H.length?A(S,H,I):S<H.length+ie.length?ie[0]:A(S-(H.length+ie.length),se,I)}n.quickSelect=A;function D(S,k){const I=[];let V;for(const H of S.slice(0).sort(k))!V||k(V[0],H)!==0?(V=[H],I.push(V)):V.push(H);return I}n.groupBy=D;function p(S,k,I){const V=[];function H(ce,fe,ge){if(fe===0&&ge.length===0)return;const me=V[V.length-1];me&&me.start+me.deleteCount===ce?(me.deleteCount+=fe,me.toInsert.push(...ge)):V.push({start:ce,deleteCount:fe,toInsert:ge})}let se=0,ie=0;for(;;){if(se===S.length){H(se,0,k.slice(ie));break}if(ie===k.length){H(se,S.length-se,[]);break}const ce=S[se],fe=k[ie],ge=I(ce,fe);ge===0?(se+=1,ie+=1):ge<0?(H(se,1,[]),se+=1):ge>0&&(H(se,0,[fe]),ie+=1)}return V}n.sortedDiff=p;function b(S,k,I){const V=p(S,k,I),H=[],se=[];for(const ie of V)H.push(...S.slice(ie.start,ie.start+ie.deleteCount)),se.push(...ie.toInsert);return{removed:H,added:se}}n.delta=b;function e(S,k,I){if(I===0)return[];const V=S.slice(0,I).sort(k);return R(S,k,V,I,S.length),V}n.top=e;function N(S,k,I,V,H){return I===0?Promise.resolve([]):new Promise((se,ie)=>{(async()=>{const ce=S.length,fe=S.slice(0,I).sort(k);for(let ge=I,me=Math.min(I+V,ce);ge<ce;ge=me,me=Math.min(me+V,ce)){if(ge>I&&await new Promise(Se=>setTimeout(Se)),H&&H.isCancellationRequested)throw new y.CancellationError;R(S,k,fe,ge,me)}return fe})().then(se,ie)})}n.topAsync=N;function R(S,k,I,V,H){for(const se=I.length;V<H;V++){const ie=S[V];if(k(ie,I[se-1])<0){I.pop();const ce=f(I,fe=>k(ie,fe)<0);I.splice(ce,0,ie)}}}function C(S){return S.filter(k=>!!k)}n.coalesce=C;function w(S){let k=0;for(let I=0;I<S.length;I++)S[I]&&(S[k]=S[I],k+=1);S.length=k}n.coalesceInPlace=w;function i(S,k,I){S.splice(I,0,S.splice(k,1)[0])}n.move=i;function a(S){return!Array.isArray(S)||S.length===0}n.isFalsyOrEmpty=a;function s(S){return Array.isArray(S)&&S.length>0}n.isNonEmptyArray=s;function l(S,k=I=>I){const I=new Set;return S.filter(V=>{const H=k(V);return I.has(H)?!1:(I.add(H),!0)})}n.distinct=l;function u(S){const k=new Set;return I=>{const V=S(I);return k.has(V)?!1:(k.add(V),!0)}}n.uniqueFilter=u;function g(S,k){const I=d(S,k);if(I!==-1)return S[I]}n.findLast=g;function d(S,k){for(let I=S.length-1;I>=0;I--){const V=S[I];if(k(V))return I}return-1}n.lastIndex=d;function L(S,k){return S.length>0?S[0]:k}n.firstOrDefault=L;function v(S,k){return S.length>0?S[S.length-1]:k}n.lastOrDefault=v;function m(S,k,I=(V,H)=>V===H){let V=0;for(let H=0,se=Math.min(S.length,k.length);H<se&&I(S[H],k[H]);H++)V++;return V}n.commonPrefixLength=m;function _(S){return[].concat(...S)}n.flatten=_;function M(S,k){let I=typeof k=="number"?S:0;typeof k=="number"?I=S:(I=0,k=S);const V=[];if(I<=k)for(let H=I;H<k;H++)V.push(H);else for(let H=I;H>k;H--)V.push(H);return V}n.range=M;function T(S,k,I){return S.reduce((V,H)=>(V[k(H)]=I?I(H):H,V),Object.create(null))}n.index=T;function O(S,k){return S.push(k),()=>q(S,k)}n.insert=O;function q(S,k){const I=S.indexOf(k);if(I>-1)return S.splice(I,1),k}n.remove=q;function $(S,k,I){const V=S.slice(0,k),H=S.slice(k);return V.concat(I,H)}n.arrayInsert=$;function z(S,k){let I;if(typeof k=="number"){let V=k;I=()=>{const H=Math.sin(V++)*179426549;return H-Math.floor(H)}}else I=Math.random;for(let V=S.length-1;V>0;V-=1){const H=Math.floor(I()*(V+1)),se=S[V];S[V]=S[H],S[H]=se}}n.shuffle=z;function ne(S,k){const I=S.indexOf(k);I>-1&&(S.splice(I,1),S.unshift(k))}n.pushToStart=ne;function oe(S,k){const I=S.indexOf(k);I>-1&&(S.splice(I,1),S.push(k))}n.pushToEnd=oe;function re(S,k){for(const I of k)S.push(I)}n.pushMany=re;function ee(S,k){return Array.isArray(S)?S.map(k):k(S)}n.mapArrayOrNot=ee;function r(S){return Array.isArray(S)?S:[S]}n.asArray=r;function de(S){return S[Math.floor(Math.random()*S.length)]}n.getRandomElement=de;function Ee(S,k){for(const I of S){const V=k(I);if(V!==void 0)return V}}n.mapFind=Ee;function ye(S,k,I){const V=Le(S,k),H=S.length,se=I.length;S.length=H+se;for(let ie=H-1;ie>=V;ie--)S[ie+se]=S[ie];for(let ie=0;ie<se;ie++)S[ie+V]=I[ie]}n.insertInto=ye;function Ae(S,k,I,V){const H=Le(S,k),se=S.splice(H,I);return ye(S,H,V),se}n.splice=Ae;function Le(S,k){return k<0?Math.max(k+S.length,0):Math.min(k,S.length)}var pe;(function(S){function k(H){return H<0}S.isLessThan=k;function I(H){return H>0}S.isGreaterThan=I;function V(H){return H===0}S.isNeitherLessOrGreaterThan=V,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(pe=n.CompareResult||(n.CompareResult={}));function Me(S,k){return(I,V)=>k(S(I),S(V))}n.compareBy=Me;function De(...S){return(k,I)=>{for(const V of S){const H=V(k,I);if(!pe.isNeitherLessOrGreaterThan(H))return H}return pe.neitherLessOrGreaterThan}}n.tieBreakComparators=De;const Fe=(S,k)=>S-k;n.numberComparator=Fe;function x(S,k){if(S.length===0)return;let I=S[0];for(let V=1;V<S.length;V++){const H=S[V];k(H,I)>0&&(I=H)}return I}n.findMaxBy=x;function G(S,k){if(S.length===0)return;let I=S[0];for(let V=1;V<S.length;V++){const H=S[V];k(H,I)>=0&&(I=H)}return I}n.findLastMaxBy=G;function K(S,k){return x(S,(I,V)=>-k(I,V))}n.findMinBy=K;class X{constructor(k){this.items=k,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(k){let I=this.firstIdx;for(;I<this.items.length&&k(this.items[I]);)I++;const V=I===this.firstIdx?null:this.items.slice(this.firstIdx,I);return this.firstIdx=I,V}takeFromEndWhile(k){let I=this.lastIdx;for(;I>=0&&k(this.items[I]);)I--;const V=I===this.lastIdx?null:this.items.slice(I+1,this.lastIdx+1);return this.lastIdx=I,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const k=this.items[this.firstIdx];return this.firstIdx++,k}removeLast(){const k=this.items[this.lastIdx];return this.lastIdx--,k}takeCount(k){const I=this.items.slice(this.firstIdx,this.firstIdx+k);return this.firstIdx+=k,I}}n.ArrayQueue=X;class te{constructor(k){this.iterate=k}forEach(k){this.iterate(I=>(k(I),!0))}toArray(){const k=[];return this.iterate(I=>(k.push(I),!0)),k}filter(k){return new te(I=>this.iterate(V=>k(V)?I(V):!0))}map(k){return new te(I=>this.iterate(V=>I(k(V))))}some(k){let I=!1;return this.iterate(V=>(I=k(V),!I)),I}findFirst(k){let I;return this.iterate(V=>k(V)?(I=V,!1):!0),I}findLast(k){let I;return this.iterate(V=>(k(V)&&(I=V),!0)),I}findLastMaxBy(k){let I,V=!0;return this.iterate(H=>((V||pe.isGreaterThan(k(H,I)))&&(V=!1,I=H),!0)),I}}n.CallbackIterable=te,te.empty=new te(S=>{})}),Y(Z[9],J([0,1,6]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assert=n.assertNever=n.ok=void 0;function t(o,f){if(!o)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}n.ok=t;function F(o,f="Unreachable"){throw new Error(f)}n.assertNever=F;function c(o){if(!o)throw new y.BugIndicatingError("Assertion Failed")}n.assert=c;function E(o){if(!o()){debugger;o(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}n.assertFn=E;function h(o,f){let A=0;for(;A<o.length-1;){const D=o[A],p=o[A+1];if(!f(D,p))return!1;A++}return!0}n.checkAdjacentItems=h}),Y(Z[13],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function y(t){const F=this;let c=!1,E;return function(){return c||(c=!0,E=t.apply(F,arguments)),E}}n.once=y}),Y(Z[14],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var y;(function(t){function F(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=F;const c=Object.freeze([]);function E(){return c}t.empty=E;function*h(u){yield u}t.single=h;function o(u){return u||c}t.from=o;function f(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=f;function A(u){return u[Symbol.iterator]().next().value}t.first=A;function D(u,g){for(const d of u)if(g(d))return!0;return!1}t.some=D;function p(u,g){for(const d of u)if(g(d))return d}t.find=p;function*b(u,g){for(const d of u)g(d)&&(yield d)}t.filter=b;function*e(u,g){let d=0;for(const L of u)yield g(L,d++)}t.map=e;function*N(...u){for(const g of u)for(const d of g)yield d}t.concat=N;function*R(u){for(const g of u)for(const d of g)yield d}t.concatNested=R;function C(u,g,d){let L=d;for(const v of u)L=g(L,v);return L}t.reduce=C;function w(u,g){let d=0;for(const L of u)g(L,d++)}t.forEach=w;function*i(u,g,d=u.length){for(g<0&&(g+=u.length),d<0?d+=u.length:d>u.length&&(d=u.length);g<d;g++)yield u[g]}t.slice=i;function a(u,g=Number.POSITIVE_INFINITY){const d=[];if(g===0)return[d,u];const L=u[Symbol.iterator]();for(let v=0;v<g;v++){const m=L.next();if(m.done)return[d,t.empty()];d.push(m.value)}return[d,{[Symbol.iterator](){return L}}]}t.consume=a;function s(u){return a(u)[0]}t.collect=s;function l(u,g,d=(L,v)=>L===v){const L=u[Symbol.iterator](),v=g[Symbol.iterator]();for(;;){const m=L.next(),_=v.next();if(m.done!==_.done)return!1;if(m.done)return!0;if(!d(m.value,_.value))return!1}}t.equals=l})(y=n.Iterable||(n.Iterable={}))}),Y(Z[27],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(y=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class F{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,R){this._keyCodeToStr[N]=R,this._strToKeyCode[R.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const c=new F,E=new F,h=new F;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const o=[],f=Object.create(null),A=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>A[e]||0,toEnum:e=>f[e]||0,toString:e=>o[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",N=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],C=[];for(const w of N){const[i,a,s,l,u,g,d,L,v,m]=w;if(C[s]||(C[s]=!0,o[s]=l,f[l]=s,A[l.toLowerCase()]=s,a&&(n.IMMUTABLE_CODE_TO_KEY_CODE[s]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[u]=s))),!R[u]){if(R[u]=!0,!g)throw new Error(`String representation missing for key code ${u} around scan code ${l}`);c.define(u,g),E.define(u,v||g),h.define(u,m||v||g)}d&&(n.EVENT_KEY_CODE_MAP[d]=u),L&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[L]=u)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var D;(function(e){function N(s){return c.keyCodeToStr(s)}e.toString=N;function R(s){return c.strToKeyCode(s)}e.fromString=R;function C(s){return E.keyCodeToStr(s)}e.toUserSettingsUS=C;function w(s){return h.keyCodeToStr(s)}e.toUserSettingsGeneral=w;function i(s){return E.strToKeyCode(s)||h.strToKeyCode(s)}e.fromUserSettings=i;function a(s){if(s>=93&&s<=108)return null;switch(s){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(s)}e.toElectronAccelerator=a})(D=n.KeyCodeUtils||(n.KeyCodeUtils={}));var p;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(p=n.KeyMod||(n.KeyMod={}));function b(e,N){const R=(N&65535)<<16>>>0;return(e|R)>>>0}n.KeyChord=b}),Y(Z[28],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class y{constructor(F){this.executor=F,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(F){this._error=F}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(F){return new y(()=>F(this.getValue()))}}n.Lazy=y}),Y(Z[7],J([0,1,13,14]),function(B,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.disposeIfDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const F=!1;let c=null;function E(v){c=v}if(n.setDisposableTracker=E,F){const v="__is_disposable_tracked__";E(new class{trackDisposable(m){const _=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[v]||console.log(_)},3e3)}setParent(m,_){if(m&&m!==w.None)try{m[v]=!0}catch{}}markAsDisposed(m){if(m&&m!==w.None)try{m[v]=!0}catch{}}markAsSingleton(m){}})}function h(v){return c?.trackDisposable(v),v}function o(v){c?.markAsDisposed(v)}function f(v,m){c?.setParent(v,m)}function A(v,m){if(!!c)for(const _ of v)c.setParent(_,m)}function D(v){return c?.markAsSingleton(v),v}n.markAsSingleton=D;function p(v){return typeof v.dispose=="function"&&v.dispose.length===0}n.isDisposable=p;function b(v){if(t.Iterable.is(v)){const m=[];for(const _ of v)if(_)try{_.dispose()}catch(M){m.push(M)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}n.dispose=b;function e(v){for(const m of v)p(m)&&m.dispose();return[]}n.disposeIfDisposable=e;function N(...v){const m=R(()=>b(v));return A(v,m),m}n.combinedDisposable=N;function R(v){const m=h({dispose:(0,y.once)(()=>{o(m),v()})});return m}n.toDisposable=R;class C{constructor(){this._toDispose=new Set,this._isDisposed=!1,h(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{b(this._toDispose)}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return f(m,this),this._isDisposed?C.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}n.DisposableStore=C,C.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new C,h(this),f(this._store,this)}dispose(){o(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}n.Disposable=w,w.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,h(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){this._isDisposed||m===this._value||(this._value?.dispose(),m&&f(m,this),this._value=m)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const m=this._value;return this._value=void 0,m&&f(m,null),m}}n.MutableDisposable=i;class a{constructor(m){this._disposable=m,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=a;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(m){let _=m;return this.unset=()=>_=void 0,this.isset=()=>_!==void 0,this.dispose=()=>{_&&(_(),_=void 0,o(this))},this}}n.SafeDisposable=s;class l{constructor(){this.references=new Map}acquire(m,..._){let M=this.references.get(m);M||(M={counter:0,object:this.createReferencedObject(m,..._)},this.references.set(m,M));const{object:T}=M,O=(0,y.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(m,M.object),this.references.delete(m))});return M.counter++,{object:T,dispose:O}}}n.ReferenceCollection=l;class u{constructor(m){this.referenceCollection=m}async acquire(m,..._){const M=this.referenceCollection.acquire(m,..._);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}n.AsyncReferenceCollection=u;class g{constructor(m){this.object=m}dispose(){}}n.ImmortalReference=g;function d(v){const m=new C;try{v(m)}finally{m.dispose()}}n.disposeOnReturn=d;class L{constructor(){this._store=new Map,this._isDisposed=!1,h(this)}dispose(){o(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{b(this._store.values())}finally{this._store.clear()}}has(m){return this._store.has(m)}get(m){return this._store.get(m)}set(m,_,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(m)?.dispose(),this._store.set(m,_)}deleteAndDispose(m){this._store.get(m)?.dispose(),this._store.delete(m)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=L}),Y(Z[15],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class y{constructor(c){this.element=c,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class t{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let c=this._first;for(;c!==y.Undefined;){const E=c.next;c.prev=y.Undefined,c.next=y.Undefined,c=E}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(c){return this._insert(c,!1)}push(c){return this._insert(c,!0)}_insert(c,E){const h=new y(c);if(this._first===y.Undefined)this._first=h,this._last=h;else if(E){const f=this._last;this._last=h,h.prev=f,f.next=h}else{const f=this._first;this._first=h,h.next=f,f.prev=h}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(h))}}shift(){if(this._first!==y.Undefined){const c=this._first.element;return this._remove(this._first),c}}pop(){if(this._last!==y.Undefined){const c=this._last.element;return this._remove(this._last),c}}_remove(c){if(c.prev!==y.Undefined&&c.next!==y.Undefined){const E=c.prev;E.next=c.next,c.next.prev=E}else c.prev===y.Undefined&&c.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):c.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):c.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let c=this._first;for(;c!==y.Undefined;)yield c.element,c=c.next}}n.LinkedList=t}),Y(Z[29],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isStringArray=n.isString=void 0;function y(u){return typeof u=="string"}n.isString=y;function t(u){return Array.isArray(u)&&u.every(g=>y(g))}n.isStringArray=t;function F(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}n.isObject=F;function c(u){const g=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof g}n.isTypedArray=c;function E(u){return typeof u=="number"&&!isNaN(u)}n.isNumber=E;function h(u){return!!u&&typeof u[Symbol.iterator]=="function"}n.isIterable=h;function o(u){return u===!0||u===!1}n.isBoolean=o;function f(u){return typeof u>"u"}n.isUndefined=f;function A(u){return!D(u)}n.isDefined=A;function D(u){return f(u)||u===null}n.isUndefinedOrNull=D;function p(u,g){if(!u)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}n.assertType=p;function b(u){if(D(u))throw new Error("Assertion Failed: argument is undefined or null");return u}n.assertIsDefined=b;function e(...u){const g=[];for(let d=0;d<u.length;d++){const L=u[d];if(D(L))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);g.push(L)}return g}n.assertAllDefined=e;const N=Object.prototype.hasOwnProperty;function R(u){if(!F(u))return!1;for(const g in u)if(N.call(u,g))return!1;return!0}n.isEmptyObject=R;function C(u){return typeof u=="function"}n.isFunction=C;function w(...u){return u.length>0&&u.every(C)}n.areFunctions=w;function i(u,g){const d=Math.min(u.length,g.length);for(let L=0;L<d;L++)a(u[L],g[L])}n.validateConstraints=i;function a(u,g){if(y(g)){if(typeof u!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(C(g)){try{if(u instanceof g)return}catch{}if(!D(u)&&u.constructor===g||g.length===1&&g.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=a;function s(u){return u===null?void 0:u}n.withNullAsUndefined=s;function l(u){return typeof u>"u"?null:u}n.withUndefinedAsNull=l}),Y(Z[10],J([0,1,29]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.filter=n.getCaseInsensitive=n.distinct=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const w=Array.isArray(C)?[]:{};return Object.keys(C).forEach(i=>{C[i]&&typeof C[i]=="object"?w[i]=t(C[i]):w[i]=C[i]}),w}n.deepClone=t;function F(C){if(!C||typeof C!="object")return C;const w=[C];for(;w.length>0;){const i=w.shift();Object.freeze(i);for(const a in i)if(c.call(i,a)){const s=i[a];typeof s=="object"&&!Object.isFrozen(s)&&!(0,y.isTypedArray)(s)&&w.push(s)}}return C}n.deepFreeze=F;const c=Object.prototype.hasOwnProperty;function E(C,w){return h(C,w,new Set)}n.cloneAndChange=E;function h(C,w,i){if((0,y.isUndefinedOrNull)(C))return C;const a=w(C);if(typeof a<"u")return a;if(Array.isArray(C)){const s=[];for(const l of C)s.push(h(l,w,i));return s}if((0,y.isObject)(C)){if(i.has(C))throw new Error("Cannot clone recursive data-structure");i.add(C);const s={};for(const l in C)c.call(C,l)&&(s[l]=h(C[l],w,i));return i.delete(C),s}return C}function o(C,w,i=!0){return(0,y.isObject)(C)?((0,y.isObject)(w)&&Object.keys(w).forEach(a=>{a in C?i&&((0,y.isObject)(C[a])&&(0,y.isObject)(w[a])?o(C[a],w[a],i):C[a]=w[a]):C[a]=w[a]}),C):w}n.mixin=o;function f(C,w){if(C===w)return!0;if(C==null||w===null||w===void 0||typeof C!=typeof w||typeof C!="object"||Array.isArray(C)!==Array.isArray(w))return!1;let i,a;if(Array.isArray(C)){if(C.length!==w.length)return!1;for(i=0;i<C.length;i++)if(!f(C[i],w[i]))return!1}else{const s=[];for(a in C)s.push(a);s.sort();const l=[];for(a in w)l.push(a);if(l.sort(),!f(s,l))return!1;for(i=0;i<s.length;i++)if(!f(C[s[i]],w[s[i]]))return!1}return!0}n.equals=f;function A(C){const w=new Set;return JSON.stringify(C,(i,a)=>{if((0,y.isObject)(a)||Array.isArray(a)){if(w.has(a))return"[Circular]";w.add(a)}return a})}n.safeStringify=A;function D(C,w){const i=Object.create(null);return!C||!w||Object.keys(w).forEach(s=>{const l=C[s],u=w[s];f(l,u)||(i[s]=u)}),i}n.distinct=D;function p(C,w){const i=w.toLowerCase(),a=Object.keys(C).find(s=>s.toLowerCase()===i);return a?C[a]:C[w]}n.getCaseInsensitive=p;function b(C,w){const i=Object.create(null);for(const[a,s]of Object.entries(C))w(a,s)&&(i[a]=s);return i}n.filter=b;function e(C){let w=[],i=Object.getPrototypeOf(C);for(;Object.prototype!==i;)w=w.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return w}n.getAllPropertyNames=e;function N(C){const w=[];for(const i of e(C))typeof C[i]=="function"&&w.push(i);return w}n.getAllMethodNames=N;function R(C,w){const i=s=>function(){const l=Array.prototype.slice.call(arguments,0);return w(s,l)},a={};for(const s of C)a[s]=i(s);return a}n.createProxyObject=R}),Y(Z[16],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var y;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(y=n.Constants||(n.Constants={}));function t(c){return c<0?0:c>255?255:c|0}n.toUint8=t;function F(c){return c<0?0:c>4294967295?4294967295:c|0}n.toUint32=F}),Y(Z[17],J([0,1,16]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(h){const o=(0,y.toUint8)(h);this._defaultValue=o,this._asciiMap=t._createAsciiMap(o),this._map=new Map}static _createAsciiMap(h){const o=new Uint8Array(256);for(let f=0;f<256;f++)o[f]=h;return o}set(h,o){const f=(0,y.toUint8)(o);h>=0&&h<256?this._asciiMap[h]=f:this._map.set(h,f)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}}n.CharacterClassifier=t;var F;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(F||(F={}));class c{constructor(){this._actual=new t(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}}n.CharacterSet=c}),Y(Z[3],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class y{constructor(F,c){this.lineNumber=F,this.column=c}with(F=this.lineNumber,c=this.column){return F===this.lineNumber&&c===this.column?this:new y(F,c)}delta(F=0,c=0){return this.with(this.lineNumber+F,this.column+c)}equals(F){return y.equals(this,F)}static equals(F,c){return!F&&!c?!0:!!F&&!!c&&F.lineNumber===c.lineNumber&&F.column===c.column}isBefore(F){return y.isBefore(this,F)}static isBefore(F,c){return F.lineNumber<c.lineNumber?!0:c.lineNumber<F.lineNumber?!1:F.column<c.column}isBeforeOrEqual(F){return y.isBeforeOrEqual(this,F)}static isBeforeOrEqual(F,c){return F.lineNumber<c.lineNumber?!0:c.lineNumber<F.lineNumber?!1:F.column<=c.column}static compare(F,c){const E=F.lineNumber|0,h=c.lineNumber|0;if(E===h){const o=F.column|0,f=c.column|0;return o-f}return E-h}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(F){return new y(F.lineNumber,F.column)}static isIPosition(F){return F&&typeof F.lineNumber=="number"&&typeof F.column=="number"}}n.Position=y}),Y(Z[2],J([0,1,3]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(c,E,h,o){c>h||c===h&&E>o?(this.startLineNumber=h,this.startColumn=o,this.endLineNumber=c,this.endColumn=E):(this.startLineNumber=c,this.startColumn=E,this.endLineNumber=h,this.endColumn=o)}isEmpty(){return t.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return t.containsPosition(this,c)}static containsPosition(c,E){return!(E.lineNumber<c.startLineNumber||E.lineNumber>c.endLineNumber||E.lineNumber===c.startLineNumber&&E.column<c.startColumn||E.lineNumber===c.endLineNumber&&E.column>c.endColumn)}static strictContainsPosition(c,E){return!(E.lineNumber<c.startLineNumber||E.lineNumber>c.endLineNumber||E.lineNumber===c.startLineNumber&&E.column<=c.startColumn||E.lineNumber===c.endLineNumber&&E.column>=c.endColumn)}containsRange(c){return t.containsRange(this,c)}static containsRange(c,E){return!(E.startLineNumber<c.startLineNumber||E.endLineNumber<c.startLineNumber||E.startLineNumber>c.endLineNumber||E.endLineNumber>c.endLineNumber||E.startLineNumber===c.startLineNumber&&E.startColumn<c.startColumn||E.endLineNumber===c.endLineNumber&&E.endColumn>c.endColumn)}strictContainsRange(c){return t.strictContainsRange(this,c)}static strictContainsRange(c,E){return!(E.startLineNumber<c.startLineNumber||E.endLineNumber<c.startLineNumber||E.startLineNumber>c.endLineNumber||E.endLineNumber>c.endLineNumber||E.startLineNumber===c.startLineNumber&&E.startColumn<=c.startColumn||E.endLineNumber===c.endLineNumber&&E.endColumn>=c.endColumn)}plusRange(c){return t.plusRange(this,c)}static plusRange(c,E){let h,o,f,A;return E.startLineNumber<c.startLineNumber?(h=E.startLineNumber,o=E.startColumn):E.startLineNumber===c.startLineNumber?(h=E.startLineNumber,o=Math.min(E.startColumn,c.startColumn)):(h=c.startLineNumber,o=c.startColumn),E.endLineNumber>c.endLineNumber?(f=E.endLineNumber,A=E.endColumn):E.endLineNumber===c.endLineNumber?(f=E.endLineNumber,A=Math.max(E.endColumn,c.endColumn)):(f=c.endLineNumber,A=c.endColumn),new t(h,o,f,A)}intersectRanges(c){return t.intersectRanges(this,c)}static intersectRanges(c,E){let h=c.startLineNumber,o=c.startColumn,f=c.endLineNumber,A=c.endColumn;const D=E.startLineNumber,p=E.startColumn,b=E.endLineNumber,e=E.endColumn;return h<D?(h=D,o=p):h===D&&(o=Math.max(o,p)),f>b?(f=b,A=e):f===b&&(A=Math.min(A,e)),h>f||h===f&&o>A?null:new t(h,o,f,A)}equalsRange(c){return t.equalsRange(this,c)}static equalsRange(c,E){return!!c&&!!E&&c.startLineNumber===E.startLineNumber&&c.startColumn===E.startColumn&&c.endLineNumber===E.endLineNumber&&c.endColumn===E.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(c){return new y.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(c){return new y.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,E){return new t(this.startLineNumber,this.startColumn,c,E)}setStartPosition(c,E){return new t(c,E,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(c){return new t(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static collapseToStart(c){return new t(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}static fromPositions(c,E=c){return new t(c.lineNumber,c.column,E.lineNumber,E.column)}static lift(c){return c?new t(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,E){return!(c.endLineNumber<E.startLineNumber||c.endLineNumber===E.startLineNumber&&c.endColumn<E.startColumn||E.endLineNumber<c.startLineNumber||E.endLineNumber===c.startLineNumber&&E.endColumn<c.startColumn)}static areIntersecting(c,E){return!(c.endLineNumber<E.startLineNumber||c.endLineNumber===E.startLineNumber&&c.endColumn<=E.startColumn||E.endLineNumber<c.startLineNumber||E.endLineNumber===c.startLineNumber&&E.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,E){if(c&&E){const f=c.startLineNumber|0,A=E.startLineNumber|0;if(f===A){const D=c.startColumn|0,p=E.startColumn|0;if(D===p){const b=c.endLineNumber|0,e=E.endLineNumber|0;if(b===e){const N=c.endColumn|0,R=E.endColumn|0;return N-R}return b-e}return D-p}return f-A}return(c?1:0)-(E?1:0)}static compareRangesUsingEnds(c,E){return c.endLineNumber===E.endLineNumber?c.endColumn===E.endColumn?c.startLineNumber===E.startLineNumber?c.startColumn-E.startColumn:c.startLineNumber-E.startLineNumber:c.endColumn-E.endColumn:c.endLineNumber-E.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}n.Range=t}),Y(Z[30],J([0,1,3,2]),function(B,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var F;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(F=n.SelectionDirection||(n.SelectionDirection={}));class c extends t.Range{constructor(h,o,f,A){super(h,o,f,A),this.selectionStartLineNumber=h,this.selectionStartColumn=o,this.positionLineNumber=f,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return c.selectionsEqual(this,h)}static selectionsEqual(h,o){return h.selectionStartLineNumber===o.selectionStartLineNumber&&h.selectionStartColumn===o.selectionStartColumn&&h.positionLineNumber===o.positionLineNumber&&h.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,o){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,h,o):new c(h,o,this.startLineNumber,this.startColumn)}getPosition(){return new y.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new y.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,o){return this.getDirection()===0?new c(h,o,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,h,o)}static fromPositions(h,o=h){return new c(h.lineNumber,h.column,o.lineNumber,o.column)}static fromRange(h,o){return o===0?new c(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new c(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new c(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,o){if(h&&!o||!h&&o)return!1;if(!h&&!o)return!0;if(h.length!==o.length)return!1;for(let f=0,A=h.length;f<A;f++)if(!this.selectionsEqual(h[f],o[f]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,o,f,A,D){return D===0?new c(h,o,f,A):new c(f,A,h,o)}}n.Selection=c}),Y(Z[31],J([0,1,17]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(E){E[E.Regular=0]="Regular",E[E.Whitespace=1]="Whitespace",E[E.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class F extends y.CharacterClassifier{constructor(h){super(0);for(let o=0,f=h.length;o<f;o++)this.set(h.charCodeAt(o),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=F;function c(E){const h={};return o=>(h.hasOwnProperty(o)||(h[o]=E(o)),h[o])}n.getMapForWordSeparators=c(E=>new F(E))}),Y(Z[18],J([0,1,14,7,15]),function(B,n,y,t,F){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.setDefaultGetWordAtTextConfig=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(D=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const b of n.USUAL_WORD_SEPARATORS)D.indexOf(b)>=0||(p+="\\"+b);return p+="\\s]+)",new RegExp(p,"g")}n.DEFAULT_WORD_REGEXP=c();function E(D){let p=n.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)p=D;else{let b="g";D.ignoreCase&&(b+="i"),D.multiline&&(b+="m"),D.unicode&&(b+="u"),p=new RegExp(D.source,b)}return p.lastIndex=0,p}n.ensureValidWordDefinition=E;const h=new F.LinkedList;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function o(D){const p=h.unshift(D);return(0,t.toDisposable)(p)}n.setDefaultGetWordAtTextConfig=o;function f(D,p,b,e,N){if(N||(N=y.Iterable.first(h)),b.length>N.maxLen){let a=D-N.maxLen/2;return a<0?a=0:e+=a,b=b.substring(a,D+N.maxLen/2),f(D,p,b,e,N)}const R=Date.now(),C=D-1-e;let w=-1,i=null;for(let a=1;!(Date.now()-R>=N.timeBudget);a++){const s=C-N.windowSize*a;p.lastIndex=Math.max(0,s);const l=A(p,b,C,w);if(!l&&i||(i=l,s<=0))break;w=s}if(i){const a={word:i[0],startColumn:e+1+i.index,endColumn:e+1+i.index+i[0].length};return p.lastIndex=0,a}return null}n.getWordAtText=f;function A(D,p,b,e){let N;for(;N=D.exec(p);){const R=N.index||0;if(R<=b&&D.lastIndex>=b)return N;if(e>0&&R>e)return null}return null}}),Y(Z[11],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SequenceFromIntArray=n.OffsetRange=n.SequenceDiff=void 0;class y{constructor(E,h){this.seq1Range=E,this.seq2Range=h}}n.SequenceDiff=y;class t{constructor(E,h){this.start=E,this.endExclusive=h}get isEmpty(){return this.start===this.endExclusive}delta(E){return new t(this.start+E,this.endExclusive+E)}get length(){return this.endExclusive-this.start}}n.OffsetRange=t;class F{constructor(E){this.arr=E}getElement(E){return this.arr[E]}get length(){return this.arr.length}}n.SequenceFromIntArray=F}),Y(Z[32],J([0,1,11]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class t{compute(o,f){function A(i,a){for(;i<o.length&&a<f.length&&o.getElement(i)===f.getElement(a);)i++,a++;return i}let D=0;const p=new c;p.set(0,A(0,0));const b=new E;b.set(0,p.get(0)===0?null:new F(null,0,0,p.get(0)));let e=0;e:for(;;)for(D++,e=-D;e<=D;e+=2){const i=e===D?-1:p.get(e+1),a=e===-D?-1:p.get(e-1)+1,s=Math.min(Math.max(i,a),o.length),l=s-e,u=A(s,l);p.set(e,u);const g=s===i?b.get(e+1):b.get(e-1);if(b.set(e,u!==s?new F(g,s,l,u-s):g),p.get(e)===o.length&&p.get(e)-e===f.length)break e}let N=b.get(e);const R=[];let C=o.length,w=f.length;for(;;){const i=N?N.x+N.length:0,a=N?N.y+N.length:0;if((i!==C||a!==w)&&R.push(new y.SequenceDiff(new y.OffsetRange(i,C),new y.OffsetRange(a,w))),!N)break;C=N.x,w=N.y,N=N.prev}return R.reverse(),R}}n.MyersDiffAlgorithm=t;class F{constructor(o,f,A,D){this.prev=o,this.x=f,this.y=A,this.length=D}}class c{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,f){if(o<0){if(o=-o-1,o>=this.negativeArr.length){const A=this.negativeArr;this.negativeArr=new Int32Array(A.length*2),this.negativeArr.set(A)}this.negativeArr[o]=f}else{if(o>=this.positiveArr.length){const A=this.positiveArr;this.positiveArr=new Int32Array(A.length*2),this.positiveArr.set(A)}this.positiveArr[o]=f}}}class E{constructor(){this.positiveArr=[],this.negativeArr=[]}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,f){o<0?(o=-o-1,this.negativeArr[o]=f):this.positiveArr[o]=f}}}),Y(Z[33],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class y{constructor(F,c){this.width=F,this.height=c,this.array=[],this.array=new Array(F*c)}get(F,c){return this.array[F+c*this.width]}set(F,c,E){this.array[F+c*this.width]=E}}n.Array2D=y}),Y(Z[34],J([0,1,11,33]),function(B,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class F{compute(E,h,o){const f=new t.Array2D(E.length,h.length),A=new t.Array2D(E.length,h.length),D=new t.Array2D(E.length,h.length);for(let w=0;w<E.length;w++)for(let i=0;i<h.length;i++){const a=w===0?0:f.get(w-1,i),s=i===0?0:f.get(w,i-1);let l;E.getElement(w)===h.getElement(i)?(w===0||i===0?l=0:l=f.get(w-1,i-1),l+=o?o(w,i):1):l=-1;const u=Math.max(a,s,l);if(u===a)D.set(w,i,0),A.set(w,i,1);else if(u===s)D.set(w,i,0),A.set(w,i,2);else{const g=w>0&&i>0?D.get(w-1,i-1):0;D.set(w,i,g+1),A.set(w,i,3)}f.set(w,i,u)}const p=[];let b=E.length,e=h.length;function N(w,i){(w+1!==b||i+1!==e)&&p.push(new y.SequenceDiff(new y.OffsetRange(w+1,b),new y.OffsetRange(i+1,e))),b=w,e=i}let R=E.length-1,C=h.length-1;for(;R>=0&&C>=0;)A.get(R,C)===3?(N(R,C),R--,C--):A.get(R,C)===1?R--:C--;return N(-1,-1),p.reverse(),p}}n.DynamicProgrammingDiffing=F}),Y(Z[19],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=n.RangeMapping=n.LineRangeMapping=void 0;class y{constructor(E,h,o){this.originalRange=E,this.modifiedRange=h,this.innerChanges=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=y;class t{constructor(E,h){this.originalRange=E,this.modifiedRange=h}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=t;class F{constructor(E,h){this.startLineNumber=E,this.endLineNumberExclusive=h}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(E){return new F(this.startLineNumber+E,this.endLineNumberExclusive+E)}get length(){return this.endLineNumberExclusive-this.startLineNumber}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}join(E){return new F(Math.min(this.startLineNumber,E.startLineNumber),Math.max(this.endLineNumberExclusive,E.endLineNumberExclusive))}}n.LineRange=F}),Y(Z[35],J([0,1,9,3,2,11,34,32,19]),function(B,n,y,t,F,c,E,h,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class f{constructor(){this.dynamicProgrammingDiffing=new E.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new h.MyersDiffAlgorithm}computeDiff(e,N,R){const C=new Map;function w(_){let M=C.get(_);return M===void 0&&(M=C.size,C.set(_,M)),M}const i=e.map(_=>w(_.trim())),a=N.map(_=>w(_.trim())),s=new c.SequenceFromIntArray(i),l=new c.SequenceFromIntArray(a),u=(()=>s.length+l.length<1500?this.dynamicProgrammingDiffing.compute(s,l,(_,M)=>e[_]===N[M]?N[M].length===0?.1:1+Math.log(1+N[M].length):.99):this.myersDiffingAlgorithm.compute(s,l))(),g=[],d=_=>{for(let M=0;M<_;M++){const T=L+M,O=v+M;if(e[T]!==N[O]){const q=this.refineDiff(e,N,new c.SequenceDiff(new c.OffsetRange(T,T+1),new c.OffsetRange(O,O+1)));for(const $ of q)g.push($)}}};let L=0,v=0;for(const _ of u){(0,y.assertFn)(()=>_.seq1Range.start-L===_.seq2Range.start-v);const M=_.seq1Range.start-L;d(M),L=_.seq1Range.endExclusive,v=_.seq2Range.endExclusive;const T=this.refineDiff(e,N,_);for(const O of T)g.push(O)}d(e.length-L);const m=A(g);return{quitEarly:!1,changes:m}}refineDiff(e,N,R){const C=new p(e,R.seq1Range),w=new p(N,R.seq2Range);return this.myersDiffingAlgorithm.compute(C,w).map(s=>new o.RangeMapping(C.translateRange(s.seq1Range).delta(R.seq1Range.start),w.translateRange(s.seq2Range).delta(R.seq2Range.start)))}}n.StandardLinesDiffComputer=f;function A(b){const e=[];for(const N of D(b,(R,C)=>C.originalRange.startLineNumber-(R.originalRange.endLineNumber-(R.originalRange.endColumn>1?0:1))<=1||C.modifiedRange.startLineNumber-(R.modifiedRange.endLineNumber-(R.modifiedRange.endColumn>1?0:1))<=1)){const R=N[0],C=N[N.length-1];e.push(new o.LineRangeMapping(new o.LineRange(R.originalRange.startLineNumber,C.originalRange.endLineNumber+(C.originalRange.endColumn>1||C.modifiedRange.endColumn>1?1:0)),new o.LineRange(R.modifiedRange.startLineNumber,C.modifiedRange.endLineNumber+(C.originalRange.endColumn>1||C.modifiedRange.endColumn>1?1:0)),N))}return(0,y.assertFn)(()=>(0,y.checkAdjacentItems)(e,(N,R)=>R.originalRange.startLineNumber-N.originalRange.endLineNumberExclusive===R.modifiedRange.startLineNumber-N.modifiedRange.endLineNumberExclusive&&N.originalRange.endLineNumberExclusive<R.originalRange.startLineNumber&&N.modifiedRange.endLineNumberExclusive<R.modifiedRange.startLineNumber)),e}n.lineRangeMappingFromRangeMappings=A;function*D(b,e){let N,R;for(const C of b)R!==void 0&&e(R,C)?N.push(C):(N&&(yield N),N=[C]),R=C;N&&(yield N)}class p{constructor(e,N){this.lines=e,this.lineRange=N;let R=0;this.firstCharOnLineOffsets=new Int32Array(N.length);for(let w=N.start;w<N.endExclusive;w++)R+=e[w].length,this.firstCharOnLineOffsets[w-N.start]=R+1,R++;this.elements=new Int32Array(R);let C=0;for(let w=N.start;w<N.endExclusive;w++){const i=e[w];for(let a=0;a<i.length;a++)this.elements[C+a]=i.charCodeAt(a);C+=i.length,w<e.length-1&&(this.elements[C]=`
`.charCodeAt(0),C+=1)}}getElement(e){return this.elements[e]}get length(){return this.elements.length}translateOffset(e){let N=0,R=this.firstCharOnLineOffsets.length;for(;N<R;){const w=Math.floor((N+R)/2);this.firstCharOnLineOffsets[w]>e?R=w:N=w+1}const C=N===0?0:this.firstCharOnLineOffsets[N-1];return new t.Position(N+1,e-C+1)}translateRange(e){return F.Range.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}}}),Y(Z[36],J([0,1,17]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var t;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class F{constructor(e,N,R){const C=new Uint8Array(e*N);for(let w=0,i=e*N;w<i;w++)C[w]=R;this._data=C,this.rows=e,this.cols=N}get(e,N){return this._data[e*this.cols+N]}set(e,N,R){this._data[e*this.cols+N]=R}}n.Uint8Matrix=F;class c{constructor(e){let N=0,R=0;for(let w=0,i=e.length;w<i;w++){const[a,s,l]=e[w];s>N&&(N=s),a>R&&(R=a),l>R&&(R=l)}N++,R++;const C=new F(R,N,0);for(let w=0,i=e.length;w<i;w++){const[a,s,l]=e[w];C.set(a,s,l)}this._states=C,this._maxCharCode=N}nextState(e,N){return N<0||N>=this._maxCharCode?0:this._states.get(e,N)}}n.StateMachine=c;let E=null;function h(){return E===null&&(E=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var o;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(o||(o={}));let f=null;function A(){if(f===null){f=new y.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<b.length;N++)f.set(b.charCodeAt(N),1);const e=".,;:";for(let N=0;N<e.length;N++)f.set(e.charCodeAt(N),2)}return f}class D{static _createLink(e,N,R,C,w){let i=w-1;do{const a=N.charCodeAt(i);if(e.get(a)!==2)break;i--}while(i>C);if(C>0){const a=N.charCodeAt(C-1),s=N.charCodeAt(i);(a===40&&s===41||a===91&&s===93||a===123&&s===125)&&i--}return{range:{startLineNumber:R,startColumn:C+1,endLineNumber:R,endColumn:i+2},url:N.substring(C,i+1)}}static computeLinks(e,N=h()){const R=A(),C=[];for(let w=1,i=e.getLineCount();w<=i;w++){const a=e.getLineContent(w),s=a.length;let l=0,u=0,g=0,d=1,L=!1,v=!1,m=!1,_=!1;for(;l<s;){let M=!1;const T=a.charCodeAt(l);if(d===13){let O;switch(T){case 40:L=!0,O=0;break;case 41:O=L?0:1;break;case 91:m=!0,v=!0,O=0;break;case 93:m=!1,O=v?0:1;break;case 123:_=!0,O=0;break;case 125:O=_?0:1;break;case 39:O=g===39?1:0;break;case 34:O=g===34?1:0;break;case 96:O=g===96?1:0;break;case 42:O=g===42?1:0;break;case 124:O=g===124?1:0;break;case 32:O=m?0:1;break;default:O=R.get(T)}O===1&&(C.push(D._createLink(R,a,w,u,l)),M=!0)}else if(d===12){let O;T===91?(v=!0,O=0):O=R.get(T),O===1?M=!0:d=13}else d=N.nextState(d,T),d===0&&(M=!0);M&&(d=1,L=!1,v=!1,_=!1,u=l+1,g=T),l++}d===13&&C.push(D._createLink(R,a,w,u,s))}return C}}n.LinkComputer=D;function p(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:D.computeLinks(b)}n.computeLinks=p}),Y(Z[37],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class y{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(F,c,E,h,o){if(F&&c){const f=this.doNavigateValueSet(c,o);if(f)return{range:F,value:f}}if(E&&h){const f=this.doNavigateValueSet(h,o);if(f)return{range:E,value:f}}return null}doNavigateValueSet(F,c){const E=this.numberReplace(F,c);return E!==null?E:this.textReplace(F,c)}numberReplace(F,c){const E=Math.pow(10,F.length-(F.lastIndexOf(".")+1));let h=Number(F);const o=parseFloat(F);return!isNaN(h)&&!isNaN(o)&&h===o?h===0&&!c?null:(h=Math.floor(h*E),h+=c?E:-E,String(h/E)):null}textReplace(F,c){return this.valueSetsReplace(this._defaultValueSet,F,c)}valueSetsReplace(F,c,E){let h=null;for(let o=0,f=F.length;h===null&&o<f;o++)h=this.valueSetReplace(F[o],c,E);return h}valueSetReplace(F,c,E){let h=F.indexOf(c);return h>=0?(h+=E?1:-1,h<0?h=F.length-1:h%=F.length,F[h]):null}}n.BasicInplaceReplace=y,y.INSTANCE=new y}),Y(Z[38],J([0,1,10]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.isITextSnapshot=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var F;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(F=n.MinimapPosition||(n.MinimapPosition={}));var c;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(c=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var E;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(E=n.EndOfLinePreference||(n.EndOfLinePreference={}));var h;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(h=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var o;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(o=n.EndOfLineSequence||(n.EndOfLineSequence={}));class f{constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace),this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,y.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}n.TextModelResolvedOptions=f;class A{constructor(a,s){this._findMatchBrand=void 0,this.range=a,this.matches=s}}n.FindMatch=A;var D;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(D=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));function p(i){return i&&typeof i.read=="function"}n.isITextSnapshot=p;var b;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(b=n.PositionAffinity||(n.PositionAffinity={}));var e;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=n.ModelConstants||(n.ModelConstants={}));class N{constructor(a,s,l,u,g,d){this.identifier=a,this.range=s,this.text=l,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=g,this._isTracked=d}}n.ValidAnnotatedEditOperation=N;class R{constructor(a,s,l){this.regex=a,this.wordSeparators=s,this.simpleSearch=l}}n.SearchData=R;class C{constructor(a,s,l){this.reverseEdits=a,this.changes=s,this.trimAutoWhitespaceLineNumbers=l}}n.ApplyEditsResult=C;function w(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}n.shouldSynchronizeModel=w}),Y(Z[39],J([0,1,26,16]),function(B,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class F{constructor(o){this.values=o,this.prefixSum=new Uint32Array(o.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(o,f){o=(0,t.toUint32)(o);const A=this.values,D=this.prefixSum,p=f.length;return p===0?!1:(this.values=new Uint32Array(A.length+p),this.values.set(A.subarray(0,o),0),this.values.set(A.subarray(o),o+p),this.values.set(f,o),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(o,f){return o=(0,t.toUint32)(o),f=(0,t.toUint32)(f),this.values[o]===f?!1:(this.values[o]=f,o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),!0)}removeValues(o,f){o=(0,t.toUint32)(o),f=(0,t.toUint32)(f);const A=this.values,D=this.prefixSum;if(o>=A.length)return!1;const p=A.length-o;return f>=p&&(f=p),f===0?!1:(this.values=new Uint32Array(A.length-f),this.values.set(A.subarray(0,o),0),this.values.set(A.subarray(o+f),o),this.prefixSum=new Uint32Array(this.values.length),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(o){return o<0?0:(o=(0,t.toUint32)(o),this._getPrefixSum(o))}_getPrefixSum(o){if(o<=this.prefixSumValidIndex[0])return this.prefixSum[o];let f=this.prefixSumValidIndex[0]+1;f===0&&(this.prefixSum[0]=this.values[0],f++),o>=this.values.length&&(o=this.values.length-1);for(let A=f;A<=o;A++)this.prefixSum[A]=this.prefixSum[A-1]+this.values[A];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],o),this.prefixSum[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let f=0,A=this.values.length-1,D=0,p=0,b=0;for(;f<=A;)if(D=f+(A-f)/2|0,p=this.prefixSum[D],b=p-this.values[D],o<b)A=D-1;else if(o>=p)f=D+1;else break;return new E(D,o-b)}}n.PrefixSumComputer=F;class c{constructor(o){this._values=o,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(o){return this._ensureValid(),o===0?0:this._prefixSum[o-1]}getIndexOf(o){this._ensureValid();const f=this._indexBySum[o],A=f>0?this._prefixSum[f-1]:0;return new E(f,o-A)}removeValues(o,f){this._values.splice(o,f),this._invalidate(o)}insertValues(o,f){this._values=(0,y.arrayInsert)(this._values,o,f),this._invalidate(o)}_invalidate(o){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,o-1)}_ensureValid(){if(!this._isValid){for(let o=this._validEndIndex+1,f=this._values.length;o<f;o++){const A=this._values[o],D=o>0?this._prefixSum[o-1]:0;this._prefixSum[o]=D+A;for(let p=0;p<A;p++)this._indexBySum[D+p]=o}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(o,f){this._values[o]!==f&&(this._values[o]=f,this._invalidate(o))}}n.ConstantTimePrefixSumComputer=c;class E{constructor(o,f){this.index=o,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=f}}n.PrefixSumIndexOfResult=E}),Y(Z[40],J([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var y;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(y=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(t=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var F;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(F=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var c;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(c=n.CompletionItemKind||(n.CompletionItemKind={}));var E;(function(r){r[r.Deprecated=1]="Deprecated"})(E=n.CompletionItemTag||(n.CompletionItemTag={}));var h;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var o;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(o=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var f;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(f=n.CursorChangeReason||(n.CursorChangeReason={}));var A;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(A=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var D;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(D=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var p;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(p=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var b;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.dropIntoEditor=32]="dropIntoEditor",r[r.emptySelectionClipboard=33]="emptySelectionClipboard",r[r.extraEditorClassName=34]="extraEditorClassName",r[r.fastScrollSensitivity=35]="fastScrollSensitivity",r[r.find=36]="find",r[r.fixedOverflowWidgets=37]="fixedOverflowWidgets",r[r.folding=38]="folding",r[r.foldingStrategy=39]="foldingStrategy",r[r.foldingHighlight=40]="foldingHighlight",r[r.foldingImportsByDefault=41]="foldingImportsByDefault",r[r.foldingMaximumRegions=42]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=44]="fontFamily",r[r.fontInfo=45]="fontInfo",r[r.fontLigatures=46]="fontLigatures",r[r.fontSize=47]="fontSize",r[r.fontWeight=48]="fontWeight",r[r.formatOnPaste=49]="formatOnPaste",r[r.formatOnType=50]="formatOnType",r[r.glyphMargin=51]="glyphMargin",r[r.gotoLocation=52]="gotoLocation",r[r.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",r[r.hover=54]="hover",r[r.inDiffEditor=55]="inDiffEditor",r[r.inlineSuggest=56]="inlineSuggest",r[r.letterSpacing=57]="letterSpacing",r[r.lightbulb=58]="lightbulb",r[r.lineDecorationsWidth=59]="lineDecorationsWidth",r[r.lineHeight=60]="lineHeight",r[r.lineNumbers=61]="lineNumbers",r[r.lineNumbersMinChars=62]="lineNumbersMinChars",r[r.linkedEditing=63]="linkedEditing",r[r.links=64]="links",r[r.matchBrackets=65]="matchBrackets",r[r.minimap=66]="minimap",r[r.mouseStyle=67]="mouseStyle",r[r.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=69]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",r[r.multiCursorModifier=71]="multiCursorModifier",r[r.multiCursorPaste=72]="multiCursorPaste",r[r.occurrencesHighlight=73]="occurrencesHighlight",r[r.overviewRulerBorder=74]="overviewRulerBorder",r[r.overviewRulerLanes=75]="overviewRulerLanes",r[r.padding=76]="padding",r[r.parameterHints=77]="parameterHints",r[r.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",r[r.quickSuggestions=80]="quickSuggestions",r[r.quickSuggestionsDelay=81]="quickSuggestionsDelay",r[r.readOnly=82]="readOnly",r[r.renameOnType=83]="renameOnType",r[r.renderControlCharacters=84]="renderControlCharacters",r[r.renderFinalNewline=85]="renderFinalNewline",r[r.renderLineHighlight=86]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=88]="renderValidationDecorations",r[r.renderWhitespace=89]="renderWhitespace",r[r.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",r[r.roundedSelection=91]="roundedSelection",r[r.rulers=92]="rulers",r[r.scrollbar=93]="scrollbar",r[r.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=95]="scrollBeyondLastLine",r[r.scrollPredominantAxis=96]="scrollPredominantAxis",r[r.selectionClipboard=97]="selectionClipboard",r[r.selectionHighlight=98]="selectionHighlight",r[r.selectOnLineNumbers=99]="selectOnLineNumbers",r[r.showFoldingControls=100]="showFoldingControls",r[r.showUnused=101]="showUnused",r[r.snippetSuggestions=102]="snippetSuggestions",r[r.smartSelect=103]="smartSelect",r[r.smoothScrolling=104]="smoothScrolling",r[r.stickyScroll=105]="stickyScroll",r[r.stickyTabStops=106]="stickyTabStops",r[r.stopRenderingLineAfter=107]="stopRenderingLineAfter",r[r.suggest=108]="suggest",r[r.suggestFontSize=109]="suggestFontSize",r[r.suggestLineHeight=110]="suggestLineHeight",r[r.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",r[r.suggestSelection=112]="suggestSelection",r[r.tabCompletion=113]="tabCompletion",r[r.tabIndex=114]="tabIndex",r[r.unicodeHighlighting=115]="unicodeHighlighting",r[r.unusualLineTerminators=116]="unusualLineTerminators",r[r.useShadowDOM=117]="useShadowDOM",r[r.useTabStops=118]="useTabStops",r[r.wordSeparators=119]="wordSeparators",r[r.wordWrap=120]="wordWrap",r[r.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=123]="wordWrapColumn",r[r.wordWrapOverride1=124]="wordWrapOverride1",r[r.wordWrapOverride2=125]="wordWrapOverride2",r[r.wrappingIndent=126]="wrappingIndent",r[r.wrappingStrategy=127]="wrappingStrategy",r[r.showDeprecated=128]="showDeprecated",r[r.inlayHints=129]="inlayHints",r[r.editorClassName=130]="editorClassName",r[r.pixelRatio=131]="pixelRatio",r[r.tabFocusMode=132]="tabFocusMode",r[r.layoutInfo=133]="layoutInfo",r[r.wrappingInfo=134]="wrappingInfo"})(b=n.EditorOption||(n.EditorOption={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e=n.EndOfLinePreference||(n.EndOfLinePreference={}));var N;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(N=n.EndOfLineSequence||(n.EndOfLineSequence={}));var R;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(R=n.IndentAction||(n.IndentAction={}));var C;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(C=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var w;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(w=n.InlayHintKind||(n.InlayHintKind={}));var i;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(i=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var a;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.Clear=126]="Clear",r[r.MAX_VALUE=127]="MAX_VALUE"})(a=n.KeyCode||(n.KeyCode={}));var s;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(s=n.MarkerSeverity||(n.MarkerSeverity={}));var l;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(l=n.MarkerTag||(n.MarkerTag={}));var u;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(u=n.MinimapPosition||(n.MinimapPosition={}));var g;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(g=n.MouseTargetType||(n.MouseTargetType={}));var d;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(d=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var L;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(L=n.OverviewRulerLane||(n.OverviewRulerLane={}));var v;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(v=n.PositionAffinity||(n.PositionAffinity={}));var m;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(m=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var _;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(_=n.RenderMinimap||(n.RenderMinimap={}));var M;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(M=n.ScrollType||(n.ScrollType={}));var T;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(T=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var O;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(O=n.SelectionDirection||(n.SelectionDirection={}));var q;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(q=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var $;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})($=n.SymbolKind||(n.SymbolKind={}));var z;(function(r){r[r.Deprecated=1]="Deprecated"})(z=n.SymbolTag||(n.SymbolTag={}));var ne;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(ne=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var oe;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(oe=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var re;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(re=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var ee;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(ee=n.WrappingIndent||(n.WrappingIndent={}))}),Y(Z[41],J([54,55]),function(B,n){return B.create("vs/base/common/platform",n)}),Y(Z[5],J([0,1,41]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.setTimeout0IsFaster=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let t=!1,F=!1,c=!1,E=!1,h=!1,o=!1,f=!1,A=!1,D=!1,p=!1,b,e=n.LANGUAGE_DEFAULT,N,R;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let C;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?C=n.globals.vscode.process:typeof process<"u"&&(C=process);const w=typeof C?.versions?.electron=="string",i=w&&C?.type==="renderer";if(typeof navigator=="object"&&!i)R=navigator.userAgent,t=R.indexOf("Windows")>=0,F=R.indexOf("Macintosh")>=0,A=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=R.indexOf("Linux")>=0,p=R?.indexOf("Mobi")>=0,o=!0,b=y.getConfiguredDefaultLocale(y.localize(0,null))||n.LANGUAGE_DEFAULT,e=b;else if(typeof C=="object"){t=C.platform==="win32",F=C.platform==="darwin",c=C.platform==="linux",E=c&&!!C.env.SNAP&&!!C.env.SNAP_REVISION,f=w,D=!!C.env.CI||!!C.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=n.LANGUAGE_DEFAULT,e=n.LANGUAGE_DEFAULT;const m=C.env.VSCODE_NLS_CONFIG;if(m)try{const _=JSON.parse(m),M=_.availableLanguages["*"];b=_.locale,e=M||n.LANGUAGE_DEFAULT,N=_._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var a;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(a=n.Platform||(n.Platform={}));function s(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=s;let l=0;F?l=1:t?l=3:c&&(l=2),n.isWindows=t,n.isMacintosh=F,n.isLinux=c,n.isLinuxSnap=E,n.isNative=h,n.isElectron=f,n.isWeb=o,n.isWebWorker=o&&typeof n.globals.importScripts=="function",n.isIOS=A,n.isMobile=p,n.isCI=D,n.platform=l,n.userAgent=R,n.language=e;var u;(function(m){function _(){return n.language}m.value=_;function M(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}m.isDefaultVariant=M;function T(){return n.language==="en"}m.isDefault=T})(u=n.Language||(n.Language={})),n.locale=b,n.translationsConfigFile=N,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const m=[];n.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,O=m.length;T<O;T++){const q=m[T];if(q.id===M.data.vscodeScheduleAsyncWork){m.splice(T,1),q.callback();return}}});let _=0;return M=>{const T=++_;m.push({id:T,callback:M}),n.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return m=>setTimeout(m)})();var g;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(g=n.OperatingSystem||(n.OperatingSystem={})),n.OS=F||A?2:t?1:3;let d=!0,L=!1;function v(){if(!L){L=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,d=new Uint16Array(m.buffer)[0]===(2<<8)+1}return d}n.isLittleEndian=v,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(Z[42],J([0,1,5]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const F=y.globals.vscode.process;t={get platform(){return F.platform},get arch(){return F.arch},get env(){return F.env},cwd(){return F.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),Y(Z[43],J([0,1,42]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,F=97,c=90,E=122,h=46,o=47,f=92,A=58,D=63;class p extends Error{constructor(a,s,l){let u;typeof s=="string"&&s.indexOf("not ")===0?(u="must not be",s=s.replace(/^not /,"")):u="must be";const g=a.indexOf(".")!==-1?"property":"argument";let d=`The "${a}" ${g} ${u} of type ${s}`;d+=`. Received type ${typeof l}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function b(i,a){if(typeof i!="string")throw new p(a,"string",i)}function e(i){return i===o||i===f}function N(i){return i===o}function R(i){return i>=t&&i<=c||i>=F&&i<=E}function C(i,a,s,l){let u="",g=0,d=-1,L=0,v=0;for(let m=0;m<=i.length;++m){if(m<i.length)v=i.charCodeAt(m);else{if(l(v))break;v=o}if(l(v)){if(!(d===m-1||L===1))if(L===2){if(u.length<2||g!==2||u.charCodeAt(u.length-1)!==h||u.charCodeAt(u.length-2)!==h){if(u.length>2){const _=u.lastIndexOf(s);_===-1?(u="",g=0):(u=u.slice(0,_),g=u.length-1-u.lastIndexOf(s)),d=m,L=0;continue}else if(u.length!==0){u="",g=0,d=m,L=0;continue}}a&&(u+=u.length>0?`${s}..`:"..",g=2)}else u.length>0?u+=`${s}${i.slice(d+1,m)}`:u=i.slice(d+1,m),g=m-d-1;d=m,L=0}else v===h&&L!==-1?++L:L=-1}return u}function w(i,a){if(a===null||typeof a!="object")throw new p("pathObject","Object",a);const s=a.dir||a.root,l=a.base||`${a.name||""}${a.ext||""}`;return s?s===a.root?`${s}${l}`:`${s}${i}${l}`:l}n.win32={resolve(...i){let a="",s="",l=!1;for(let u=i.length-1;u>=-1;u--){let g;if(u>=0){if(g=i[u],b(g,"path"),g.length===0)continue}else a.length===0?g=y.cwd():(g=y.env[`=${a}`]||y.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==a.toLowerCase()&&g.charCodeAt(2)===f)&&(g=`${a}\\`));const d=g.length;let L=0,v="",m=!1;const _=g.charCodeAt(0);if(d===1)e(_)&&(L=1,m=!0);else if(e(_))if(m=!0,e(g.charCodeAt(1))){let M=2,T=M;for(;M<d&&!e(g.charCodeAt(M));)M++;if(M<d&&M!==T){const O=g.slice(T,M);for(T=M;M<d&&e(g.charCodeAt(M));)M++;if(M<d&&M!==T){for(T=M;M<d&&!e(g.charCodeAt(M));)M++;(M===d||M!==T)&&(v=`\\\\${O}\\${g.slice(T,M)}`,L=M)}}}else L=1;else R(_)&&g.charCodeAt(1)===A&&(v=g.slice(0,2),L=2,d>2&&e(g.charCodeAt(2))&&(m=!0,L=3));if(v.length>0)if(a.length>0){if(v.toLowerCase()!==a.toLowerCase())continue}else a=v;if(l){if(a.length>0)break}else if(s=`${g.slice(L)}\\${s}`,l=m,m&&a.length>0)break}return s=C(s,!l,"\\",e),l?`${a}\\${s}`:`${a}${s}`||"."},normalize(i){b(i,"path");const a=i.length;if(a===0)return".";let s=0,l,u=!1;const g=i.charCodeAt(0);if(a===1)return N(g)?"\\":i;if(e(g))if(u=!0,e(i.charCodeAt(1))){let L=2,v=L;for(;L<a&&!e(i.charCodeAt(L));)L++;if(L<a&&L!==v){const m=i.slice(v,L);for(v=L;L<a&&e(i.charCodeAt(L));)L++;if(L<a&&L!==v){for(v=L;L<a&&!e(i.charCodeAt(L));)L++;if(L===a)return`\\\\${m}\\${i.slice(v)}\\`;L!==v&&(l=`\\\\${m}\\${i.slice(v,L)}`,s=L)}}}else s=1;else R(g)&&i.charCodeAt(1)===A&&(l=i.slice(0,2),s=2,a>2&&e(i.charCodeAt(2))&&(u=!0,s=3));let d=s<a?C(i.slice(s),!u,"\\",e):"";return d.length===0&&!u&&(d="."),d.length>0&&e(i.charCodeAt(a-1))&&(d+="\\"),l===void 0?u?`\\${d}`:d:u?`${l}\\${d}`:`${l}${d}`},isAbsolute(i){b(i,"path");const a=i.length;if(a===0)return!1;const s=i.charCodeAt(0);return e(s)||a>2&&R(s)&&i.charCodeAt(1)===A&&e(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,s;for(let g=0;g<i.length;++g){const d=i[g];b(d,"path"),d.length>0&&(a===void 0?a=s=d:a+=`\\${d}`)}if(a===void 0)return".";let l=!0,u=0;if(typeof s=="string"&&e(s.charCodeAt(0))){++u;const g=s.length;g>1&&e(s.charCodeAt(1))&&(++u,g>2&&(e(s.charCodeAt(2))?++u:l=!1))}if(l){for(;u<a.length&&e(a.charCodeAt(u));)u++;u>=2&&(a=`\\${a.slice(u)}`)}return n.win32.normalize(a)},relative(i,a){if(b(i,"from"),b(a,"to"),i===a)return"";const s=n.win32.resolve(i),l=n.win32.resolve(a);if(s===l||(i=s.toLowerCase(),a=l.toLowerCase(),i===a))return"";let u=0;for(;u<i.length&&i.charCodeAt(u)===f;)u++;let g=i.length;for(;g-1>u&&i.charCodeAt(g-1)===f;)g--;const d=g-u;let L=0;for(;L<a.length&&a.charCodeAt(L)===f;)L++;let v=a.length;for(;v-1>L&&a.charCodeAt(v-1)===f;)v--;const m=v-L,_=d<m?d:m;let M=-1,T=0;for(;T<_;T++){const q=i.charCodeAt(u+T);if(q!==a.charCodeAt(L+T))break;q===f&&(M=T)}if(T!==_){if(M===-1)return l}else{if(m>_){if(a.charCodeAt(L+T)===f)return l.slice(L+T+1);if(T===2)return l.slice(L+T)}d>_&&(i.charCodeAt(u+T)===f?M=T:T===2&&(M=3)),M===-1&&(M=0)}let O="";for(T=u+M+1;T<=g;++T)(T===g||i.charCodeAt(T)===f)&&(O+=O.length===0?"..":"\\..");return L+=M,O.length>0?`${O}${l.slice(L,v)}`:(l.charCodeAt(L)===f&&++L,l.slice(L,v))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const a=n.win32.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const s=a.charCodeAt(2);if(s!==D&&s!==h)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(R(a.charCodeAt(0))&&a.charCodeAt(1)===A&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return i},dirname(i){b(i,"path");const a=i.length;if(a===0)return".";let s=-1,l=0;const u=i.charCodeAt(0);if(a===1)return e(u)?i:".";if(e(u)){if(s=l=1,e(i.charCodeAt(1))){let L=2,v=L;for(;L<a&&!e(i.charCodeAt(L));)L++;if(L<a&&L!==v){for(v=L;L<a&&e(i.charCodeAt(L));)L++;if(L<a&&L!==v){for(v=L;L<a&&!e(i.charCodeAt(L));)L++;if(L===a)return i;L!==v&&(s=l=L+1)}}}}else R(u)&&i.charCodeAt(1)===A&&(s=a>2&&e(i.charCodeAt(2))?3:2,l=s);let g=-1,d=!0;for(let L=a-1;L>=l;--L)if(e(i.charCodeAt(L))){if(!d){g=L;break}}else d=!1;if(g===-1){if(s===-1)return".";g=s}return i.slice(0,g)},basename(i,a){a!==void 0&&b(a,"ext"),b(i,"path");let s=0,l=-1,u=!0,g;if(i.length>=2&&R(i.charCodeAt(0))&&i.charCodeAt(1)===A&&(s=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let d=a.length-1,L=-1;for(g=i.length-1;g>=s;--g){const v=i.charCodeAt(g);if(e(v)){if(!u){s=g+1;break}}else L===-1&&(u=!1,L=g+1),d>=0&&(v===a.charCodeAt(d)?--d===-1&&(l=g):(d=-1,l=L))}return s===l?l=L:l===-1&&(l=i.length),i.slice(s,l)}for(g=i.length-1;g>=s;--g)if(e(i.charCodeAt(g))){if(!u){s=g+1;break}}else l===-1&&(u=!1,l=g+1);return l===-1?"":i.slice(s,l)},extname(i){b(i,"path");let a=0,s=-1,l=0,u=-1,g=!0,d=0;i.length>=2&&i.charCodeAt(1)===A&&R(i.charCodeAt(0))&&(a=l=2);for(let L=i.length-1;L>=a;--L){const v=i.charCodeAt(L);if(e(v)){if(!g){l=L+1;break}continue}u===-1&&(g=!1,u=L+1),v===h?s===-1?s=L:d!==1&&(d=1):s!==-1&&(d=-1)}return s===-1||u===-1||d===0||d===1&&s===u-1&&s===l+1?"":i.slice(s,u)},format:w.bind(null,"\\"),parse(i){b(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const s=i.length;let l=0,u=i.charCodeAt(0);if(s===1)return e(u)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(e(u)){if(l=1,e(i.charCodeAt(1))){let M=2,T=M;for(;M<s&&!e(i.charCodeAt(M));)M++;if(M<s&&M!==T){for(T=M;M<s&&e(i.charCodeAt(M));)M++;if(M<s&&M!==T){for(T=M;M<s&&!e(i.charCodeAt(M));)M++;M===s?l=M:M!==T&&(l=M+1)}}}}else if(R(u)&&i.charCodeAt(1)===A){if(s<=2)return a.root=a.dir=i,a;if(l=2,e(i.charCodeAt(2))){if(s===3)return a.root=a.dir=i,a;l=3}}l>0&&(a.root=i.slice(0,l));let g=-1,d=l,L=-1,v=!0,m=i.length-1,_=0;for(;m>=l;--m){if(u=i.charCodeAt(m),e(u)){if(!v){d=m+1;break}continue}L===-1&&(v=!1,L=m+1),u===h?g===-1?g=m:_!==1&&(_=1):g!==-1&&(_=-1)}return L!==-1&&(g===-1||_===0||_===1&&g===L-1&&g===d+1?a.base=a.name=i.slice(d,L):(a.name=i.slice(d,g),a.base=i.slice(d,L),a.ext=i.slice(g,L))),d>0&&d!==l?a.dir=i.slice(0,d-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...i){let a="",s=!1;for(let l=i.length-1;l>=-1&&!s;l--){const u=l>=0?i[l]:y.cwd();b(u,"path"),u.length!==0&&(a=`${u}/${a}`,s=u.charCodeAt(0)===o)}return a=C(a,!s,"/",N),s?`/${a}`:a.length>0?a:"."},normalize(i){if(b(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===o,s=i.charCodeAt(i.length-1)===o;return i=C(i,!a,"/",N),i.length===0?a?"/":s?"./":".":(s&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return b(i,"path"),i.length>0&&i.charCodeAt(0)===o},join(...i){if(i.length===0)return".";let a;for(let s=0;s<i.length;++s){const l=i[s];b(l,"path"),l.length>0&&(a===void 0?a=l:a+=`/${l}`)}return a===void 0?".":n.posix.normalize(a)},relative(i,a){if(b(i,"from"),b(a,"to"),i===a||(i=n.posix.resolve(i),a=n.posix.resolve(a),i===a))return"";const s=1,l=i.length,u=l-s,g=1,d=a.length-g,L=u<d?u:d;let v=-1,m=0;for(;m<L;m++){const M=i.charCodeAt(s+m);if(M!==a.charCodeAt(g+m))break;M===o&&(v=m)}if(m===L)if(d>L){if(a.charCodeAt(g+m)===o)return a.slice(g+m+1);if(m===0)return a.slice(g+m)}else u>L&&(i.charCodeAt(s+m)===o?v=m:m===0&&(v=0));let _="";for(m=s+v+1;m<=l;++m)(m===l||i.charCodeAt(m)===o)&&(_+=_.length===0?"..":"/..");return`${_}${a.slice(g+v)}`},toNamespacedPath(i){return i},dirname(i){if(b(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===o;let s=-1,l=!0;for(let u=i.length-1;u>=1;--u)if(i.charCodeAt(u)===o){if(!l){s=u;break}}else l=!1;return s===-1?a?"/":".":a&&s===1?"//":i.slice(0,s)},basename(i,a){a!==void 0&&b(a,"ext"),b(i,"path");let s=0,l=-1,u=!0,g;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let d=a.length-1,L=-1;for(g=i.length-1;g>=0;--g){const v=i.charCodeAt(g);if(v===o){if(!u){s=g+1;break}}else L===-1&&(u=!1,L=g+1),d>=0&&(v===a.charCodeAt(d)?--d===-1&&(l=g):(d=-1,l=L))}return s===l?l=L:l===-1&&(l=i.length),i.slice(s,l)}for(g=i.length-1;g>=0;--g)if(i.charCodeAt(g)===o){if(!u){s=g+1;break}}else l===-1&&(u=!1,l=g+1);return l===-1?"":i.slice(s,l)},extname(i){b(i,"path");let a=-1,s=0,l=-1,u=!0,g=0;for(let d=i.length-1;d>=0;--d){const L=i.charCodeAt(d);if(L===o){if(!u){s=d+1;break}continue}l===-1&&(u=!1,l=d+1),L===h?a===-1?a=d:g!==1&&(g=1):a!==-1&&(g=-1)}return a===-1||l===-1||g===0||g===1&&a===l-1&&a===s+1?"":i.slice(a,l)},format:w.bind(null,"/"),parse(i){b(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const s=i.charCodeAt(0)===o;let l;s?(a.root="/",l=1):l=0;let u=-1,g=0,d=-1,L=!0,v=i.length-1,m=0;for(;v>=l;--v){const _=i.charCodeAt(v);if(_===o){if(!L){g=v+1;break}continue}d===-1&&(L=!1,d=v+1),_===h?u===-1?u=v:m!==1&&(m=1):u!==-1&&(m=-1)}if(d!==-1){const _=g===0&&s?1:g;u===-1||m===0||m===1&&u===d-1&&u===g+1?a.base=a.name=i.slice(_,d):(a.name=i.slice(_,u),a.base=i.slice(_,d),a.ext=i.slice(u,d))}return g>0?a.dir=i.slice(0,g-1):s&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=y.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=y.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=y.platform==="win32"?n.win32.join:n.posix.join,n.resolve=y.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=y.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=y.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=y.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=y.platform==="win32"?n.win32.extname:n.posix.extname,n.format=y.platform==="win32"?n.win32.format:n.posix.format,n.parse=y.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=y.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=y.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=y.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),Y(Z[20],J([0,1,5]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=y.globals.performance&&typeof y.globals.performance.now=="function";class F{static create(E=!0){return new F(E)}constructor(E){this._highResolution=t&&E,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}n.StopWatch=F}),Y(Z[8],J([0,1,6,13,7,15,20]),function(B,n,y,t,F,c,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.EventDeliveryQueue=n.Emitter=n.setGlobalLeakWarningThreshold=n.EventProfiling=n.Event=void 0;const h=!1,o=!1;var f;(function(v){v.None=()=>F.Disposable.None;function m(x){if(o){const{onListenerDidAdd:G}=x,K=e.create();let X=0;x.onListenerDidAdd=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),G?.()}}}function _(x){return(G,K=null,X)=>{let te=!1,S;return S=x(k=>{if(!te)return S?S.dispose():te=!0,G.call(K,k)},null,X),te&&S.dispose(),S}}v.once=_;function M(x,G,K){return ne((X,te=null,S)=>x(k=>X.call(te,G(k)),null,S),K)}v.map=M;function T(x,G,K){return ne((X,te=null,S)=>x(k=>{G(k),X.call(te,k)},null,S),K)}v.forEach=T;function O(x,G,K){return ne((X,te=null,S)=>x(k=>G(k)&&X.call(te,k),null,S),K)}v.filter=O;function q(x){return x}v.signal=q;function $(...x){return(G,K=null,X)=>(0,F.combinedDisposable)(...x.map(te=>te(S=>G.call(K,S),null,X)))}v.any=$;function z(x,G,K,X){let te=K;return M(x,S=>(te=G(te,S),te),X)}v.reduce=z;function ne(x,G){let K;const X={onFirstListenerAdd(){K=x(te.fire,te)},onLastListenerRemove(){K?.dispose()}};G||m(X);const te=new R(X);return G?.add(te),te.event}function oe(x,G,K=100,X=!1,te,S){let k,I,V,H=0;const se={leakWarningThreshold:te,onFirstListenerAdd(){k=x(ce=>{H++,I=G(I,ce),X&&!V&&(ie.fire(I),I=void 0),clearTimeout(V),V=setTimeout(()=>{const fe=I;I=void 0,V=void 0,(!X||H>1)&&ie.fire(fe),H=0},K)})},onLastListenerRemove(){k.dispose()}};S||m(se);const ie=new R(se);return S?.add(ie),ie.event}v.debounce=oe;function re(x,G=(X,te)=>X===te,K){let X=!0,te;return O(x,S=>{const k=X||!G(S,te);return X=!1,te=S,k},K)}v.latch=re;function ee(x,G,K){return[v.filter(x,G,K),v.filter(x,X=>!G(X),K)]}v.split=ee;function r(x,G=!1,K=[]){let X=K.slice(),te=x(I=>{X?X.push(I):k.fire(I)});const S=()=>{X?.forEach(I=>k.fire(I)),X=null},k=new R({onFirstListenerAdd(){te||(te=x(I=>k.fire(I)))},onFirstListenerDidAdd(){X&&(G?setTimeout(S):S())},onLastListenerRemove(){te&&te.dispose(),te=null}});return k.event}v.buffer=r;class de{constructor(G){this.event=G,this.disposables=new F.DisposableStore}map(G){return new de(M(this.event,G,this.disposables))}forEach(G){return new de(T(this.event,G,this.disposables))}filter(G){return new de(O(this.event,G,this.disposables))}reduce(G,K){return new de(z(this.event,G,K,this.disposables))}latch(){return new de(re(this.event,void 0,this.disposables))}debounce(G,K=100,X=!1,te){return new de(oe(this.event,G,K,X,te,this.disposables))}on(G,K,X){return this.event(G,K,X)}once(G,K,X){return _(this.event)(G,K,X)}dispose(){this.disposables.dispose()}}function Ee(x){return new de(x)}v.chain=Ee;function ye(x,G,K=X=>X){const X=(...I)=>k.fire(K(...I)),te=()=>x.on(G,X),S=()=>x.removeListener(G,X),k=new R({onFirstListenerAdd:te,onLastListenerRemove:S});return k.event}v.fromNodeEventEmitter=ye;function Ae(x,G,K=X=>X){const X=(...I)=>k.fire(K(...I)),te=()=>x.addEventListener(G,X),S=()=>x.removeEventListener(G,X),k=new R({onFirstListenerAdd:te,onLastListenerRemove:S});return k.event}v.fromDOMEventEmitter=Ae;function Le(x){return new Promise(G=>_(x)(G))}v.toPromise=Le;function pe(x,G){return G(void 0),x(K=>G(K))}v.runAndSubscribe=pe;function Me(x,G){let K=null;function X(S){K?.dispose(),K=new F.DisposableStore,G(S,K)}X(void 0);const te=x(S=>X(S));return(0,F.toDisposable)(()=>{te.dispose(),K?.dispose()})}v.runAndSubscribeWithStore=Me;class De{constructor(G,K){this.obs=G,this._counter=0,this._hasChanged=!1;const X={onFirstListenerAdd:()=>{G.addObserver(this)},onLastListenerRemove:()=>{G.removeObserver(this)}};K||m(X),this.emitter=new R(X),K&&K.add(this.emitter)}beginUpdate(G){this._counter++}handleChange(G,K){this._hasChanged=!0}endUpdate(G){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Fe(x,G){return new De(x,G).emitter.event}v.fromObservable=Fe})(f=n.Event||(n.Event={}));class A{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${A._idPool++}`,A.all.add(this)}start(m){this._stopWatch=new E.StopWatch(!0),this.listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=A,A.all=new Set,A._idPool=0;let D=-1;function p(v){const m=D;return D=v,{dispose(){D=m}}}n.setGlobalLeakWarningThreshold=p;class b{constructor(m,_=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=_,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m,_){let M=D;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||_<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(m.value)||0;if(this._stacks.set(m.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let O,q=0;for(const[$,z]of this._stacks)(!O||q<z)&&(O=$,q=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${q}):`),console.warn(O)}return()=>{const O=this._stacks.get(m.value)||0;this._stacks.set(m.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class N{constructor(m,_,M){this.callback=m,this.callbackThis=_,this.stack=M,this.subscription=new F.SafeDisposable}invoke(m){this.callback.call(this.callbackThis,m)}}class R{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=D>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new A(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(h){const m=Array.from(this._listeners);queueMicrotask(()=>{for(const _ of m)_.subscription.isset()&&(_.subscription.unset(),_.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(m,_,M)=>{this._listeners||(this._listeners=new c.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,q;this._leakageMon&&this._listeners.size>=30&&(q=e.create(),O=this._leakageMon.check(q,this._listeners.size+1)),h&&(q=q??e.create());const $=new N(m,_,q),z=this._listeners.push($);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,_);const ne=$.subscription.set(()=>{O?.(),this._disposed||(z(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof F.DisposableStore?M.add(ne):Array.isArray(M)&&M.push(ne),ne}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new w);for(const _ of this._listeners)this._deliveryQueue.push(this,_,m);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=R;class C{constructor(){this._queue=new c.LinkedList}get size(){return this._queue.size}push(m,_,M){this._queue.push(new i(m,_,M))}clear(m){const _=new c.LinkedList;for(const M of this._queue)M.emitter!==m&&_.push(M);this._queue=_}deliver(){for(;this._queue.size>0;){const m=this._queue.shift();try{m.listener.invoke(m.event)}catch(_){(0,y.onUnexpectedError)(_)}}}}n.EventDeliveryQueue=C;class w extends C{clear(m){this._queue.clear()}}class i{constructor(m,_,M){this.emitter=m,this.listener=_,this.event=M}}class a extends R{async fireAsync(m,_,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new c.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,m]);for(;this._asyncDeliveryQueue.size>0&&!_.isCancellationRequested;){const[T,O]=this._asyncDeliveryQueue.shift(),q=[],$={...O,token:_,waitUntil:z=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");M&&(z=M(z,T.callback)),q.push(z)}};try{T.invoke($)}catch(z){(0,y.onUnexpectedError)(z);continue}Object.freeze(q),await Promise.allSettled(q).then(z=>{for(const ne of z)ne.status==="rejected"&&(0,y.onUnexpectedError)(ne.reason)})}}}}n.AsyncEmitter=a;class s extends R{constructor(m){super(m),this._isPaused=0,this._eventQueue=new c.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}n.PauseableEmitter=s;class l extends s{constructor(m){super(m),this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}n.DebounceEmitter=l;class u extends R{constructor(m){super(m),this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){!this.hasListeners()||(this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(_=>super.fire(_)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=u;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new R({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const _={event:m,listener:null};this.events.push(_),this.hasListeners&&this.hook(_);const M=()=>{this.hasListeners&&this.unhook(_);const T=this.events.indexOf(_);this.events.splice(T,1)};return(0,F.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(_=>this.emitter.fire(_))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=g;class d{constructor(){this.buffers=[]}wrapEvent(m){return(_,M,T)=>m(O=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>_.call(M,O)):_.call(M,O)},void 0,T)}bufferEvents(m){const _=[];this.buffers.push(_);const M=m();return this.buffers.pop(),_.forEach(T=>T()),M}}n.EventBufferer=d;class L{constructor(){this.listening=!1,this.inputEvent=f.None,this.inputEventListener=F.Disposable.None,this.emitter=new R({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=L}),Y(Z[21],J([0,1,8]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(h,o){const f=setTimeout(h.bind(o),0);return{dispose(){clearTimeout(f)}}});var F;(function(h){function o(f){return f===h.None||f===h.Cancelled||f instanceof c?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}h.isCancellationToken=o,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(F=n.CancellationToken||(n.CancellationToken={}));class c{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new c),this._token}cancel(){this._token?this._token instanceof c&&this._token.cancel():this._token=F.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof c&&this._token.dispose():this._token=F.None}}n.CancellationTokenSource=E}),Y(Z[44],J([0,1,21]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=n.Cache=void 0;class t{constructor(h){this.task=h,this.result=null}get(){if(this.result)return this.result;const h=new y.CancellationTokenSource,o=this.task(h.token);return this.result={promise:o,dispose:()=>{this.result=null,h.cancel(),h.dispose()}},this.result}}n.Cache=t;class F{constructor(h){this.fn=h,this.lastCache=void 0,this.lastArgKey=void 0}get(h){const o=JSON.stringify(h);return this.lastArgKey!==o&&(this.lastArgKey=o,this.lastCache=this.fn(h)),this.lastCache}}n.LRUCachedFunction=F;class c{get cachedValues(){return this._map}constructor(h){this.fn=h,this._map=new Map}get(h){if(this._map.has(h))return this._map.get(h);const o=this.fn(h);return this._map.set(h,o),o}}n.CachedFunction=c}),Y(Z[4],J([0,1,44,28]),function(B,n,y,t){"use strict";var F;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.charCount=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.replaceAsync=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function c(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=c;const E=/{(\d+)}/g;function h(P,...U){return U.length===0?P:P.replace(E,function(W,j){const Q=parseInt(j,10);return isNaN(Q)||Q<0||Q>=U.length?W:U[Q]})}n.format=h;const o=/{([^}]+)}/g;function f(P,U){return P.replace(o,(W,j)=>U[j]??W)}n.format2=f;function A(P){return P.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}n.escape=A;function D(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=D;function p(P,U){let W=0;const j=U.charCodeAt(0);for(let Q=P.length-1;Q>=0;Q--)P.charCodeAt(Q)===j&&W++;return W}n.count=p;function b(P,U,W="\u2026"){return P.length<=U?P:`${P.substr(0,U)}${W}`}n.truncate=b;function e(P,U=" "){const W=N(P,U);return R(W,U)}n.trim=e;function N(P,U){if(!P||!U)return P;const W=U.length;if(W===0||P.length===0)return P;let j=0;for(;P.indexOf(U,j)===j;)j=j+W;return P.substring(j)}n.ltrim=N;function R(P,U){if(!P||!U)return P;const W=U.length,j=P.length;if(W===0||j===0)return P;let Q=j,ae=-1;for(;ae=P.lastIndexOf(U,Q-1),!(ae===-1||ae+W!==Q);){if(ae===0)return"";Q=ae}return P.substring(0,Q)}n.rtrim=R;function C(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=C;function w(P){return P.replace(/\*/g,"")}n.stripWildcards=w;function i(P,U,W={}){if(!P)throw new Error("Cannot create regex from empty string");U||(P=D(P)),W.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let j="";return W.global&&(j+="g"),W.matchCase||(j+="i"),W.multiline&&(j+="m"),W.unicode&&(j+="u"),new RegExp(P,j)}n.createRegExp=i;function a(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=a;function s(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=s;function l(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}n.regExpFlags=l;function u(P){return P.split(/\r\n|\r|\n/)}n.splitLines=u;function g(P){for(let U=0,W=P.length;U<W;U++){const j=P.charCodeAt(U);if(j!==32&&j!==9)return U}return-1}n.firstNonWhitespaceIndex=g;function d(P,U=0,W=P.length){for(let j=U;j<W;j++){const Q=P.charCodeAt(j);if(Q!==32&&Q!==9)return P.substring(U,j)}return P.substring(U,W)}n.getLeadingWhitespace=d;function L(P,U=P.length-1){for(let W=U;W>=0;W--){const j=P.charCodeAt(W);if(j!==32&&j!==9)return W}return-1}n.lastNonWhitespaceIndex=L;function v(P,U,W){const j=[];let Q=0;for(const ae of P.matchAll(U)){if(j.push(P.slice(Q,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");Q=ae.index+ae[0].length,j.push(W(ae[0],...ae.slice(1),ae.index,P,ae.groups))}return j.push(P.slice(Q)),Promise.all(j).then(ae=>ae.join(""))}n.replaceAsync=v;function m(P,U){return P<U?-1:P>U?1:0}n.compare=m;function _(P,U,W=0,j=P.length,Q=0,ae=U.length){for(;W<j&&Q<ae;W++,Q++){const we=P.charCodeAt(W),le=U.charCodeAt(Q);if(we<le)return-1;if(we>le)return 1}const he=j-W,Ne=ae-Q;return he<Ne?-1:he>Ne?1:0}n.compareSubstring=_;function M(P,U){return T(P,U,0,P.length,0,U.length)}n.compareIgnoreCase=M;function T(P,U,W=0,j=P.length,Q=0,ae=U.length){for(;W<j&&Q<ae;W++,Q++){let we=P.charCodeAt(W),le=U.charCodeAt(Q);if(we===le)continue;if(we>=128||le>=128)return _(P.toLowerCase(),U.toLowerCase(),W,j,Q,ae);q(we)&&(we-=32),q(le)&&(le-=32);const be=we-le;if(be!==0)return be}const he=j-W,Ne=ae-Q;return he<Ne?-1:he>Ne?1:0}n.compareSubstringIgnoreCase=T;function O(P){return P>=48&&P<=57}n.isAsciiDigit=O;function q(P){return P>=97&&P<=122}n.isLowerAsciiLetter=q;function $(P){return P>=65&&P<=90}n.isUpperAsciiLetter=$;function z(P,U){return P.length===U.length&&T(P,U)===0}n.equalsIgnoreCase=z;function ne(P,U){const W=U.length;return U.length>P.length?!1:T(P,U,0,W)===0}n.startsWithIgnoreCase=ne;function oe(P,U){const W=Math.min(P.length,U.length);let j;for(j=0;j<W;j++)if(P.charCodeAt(j)!==U.charCodeAt(j))return j;return W}n.commonPrefixLength=oe;function re(P,U){const W=Math.min(P.length,U.length);let j;const Q=P.length-1,ae=U.length-1;for(j=0;j<W;j++)if(P.charCodeAt(Q-j)!==U.charCodeAt(ae-j))return j;return W}n.commonSuffixLength=re;function ee(P){return 55296<=P&&P<=56319}n.isHighSurrogate=ee;function r(P){return 56320<=P&&P<=57343}n.isLowSurrogate=r;function de(P,U){return(P-55296<<10)+(U-56320)+65536}n.computeCodePoint=de;function Ee(P,U,W){const j=P.charCodeAt(W);if(ee(j)&&W+1<U){const Q=P.charCodeAt(W+1);if(r(Q))return de(j,Q)}return j}n.getNextCodePoint=Ee;function ye(P,U){const W=P.charCodeAt(U-1);if(r(W)&&U>1){const j=P.charCodeAt(U-2);if(ee(j))return de(j,W)}return W}class Ae{get offset(){return this._offset}constructor(U,W=0){this._str=U,this._len=U.length,this._offset=W}setOffset(U){this._offset=U}prevCodePoint(){const U=ye(this._str,this._offset);return this._offset-=U>=65536?2:1,U}nextCodePoint(){const U=Ee(this._str,this._len,this._offset);return this._offset+=U>=65536?2:1,U}eol(){return this._offset>=this._len}}n.CodePointIterator=Ae;class Le{get offset(){return this._iterator.offset}constructor(U,W=0){this._iterator=new Ae(U,W)}nextGraphemeLength(){const U=Ce.getInstance(),W=this._iterator,j=W.offset;let Q=U.getGraphemeBreakType(W.nextCodePoint());for(;!W.eol();){const ae=W.offset,he=U.getGraphemeBreakType(W.nextCodePoint());if(Ie(Q,he)){W.setOffset(ae);break}Q=he}return W.offset-j}prevGraphemeLength(){const U=Ce.getInstance(),W=this._iterator,j=W.offset;let Q=U.getGraphemeBreakType(W.prevCodePoint());for(;W.offset>0;){const ae=W.offset,he=U.getGraphemeBreakType(W.prevCodePoint());if(Ie(he,Q)){W.setOffset(ae);break}Q=he}return j-W.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=Le;function pe(P,U){return new Le(P,U).nextGraphemeLength()}n.nextCharLength=pe;function Me(P,U){return new Le(P,U).prevGraphemeLength()}n.prevCharLength=Me;function De(P,U){U>0&&r(P.charCodeAt(U))&&U--;const W=U+pe(P,U);return[W-Me(P,W),W]}n.getCharContainingOffset=De;function Fe(P){const U=new Le(P);let W=0;for(;!U.eol();)W++,U.nextGraphemeLength();return W}n.charCount=Fe;let x;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(P){return x||(x=G()),x.test(P)}n.containsRTL=K;const X=/^[\t\n\r\x20-\x7E]*$/;function te(P){return X.test(P)}n.isBasicASCII=te,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function S(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=S;function k(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=k;function I(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=I;function V(P,U){if(P.length<U)return P;const W=/\b/g;let j=0;for(;W.test(P)&&!(P.length-W.lastIndex<U);)j=W.lastIndex,W.lastIndex+=1;return P.substring(j).replace(/^\s/,"")}n.lcut=V;const H=/\x1B\x5B[12]?K/g,se=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ce(P){return P&&(P=P.replace(H,""),P=P.replace(se,""),P=P.replace(ie,"")),P}n.removeAnsiEscapeCodes=ce,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function fe(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=fe;function ge(P){return fe(P)?P.substr(1):P}n.stripUTF8BOM=ge;function me(P,U){if(!P||!U||P.length<U.length)return!1;const W=U.length,j=P.toLowerCase();let Q=0,ae=-1;for(;Q<W;){const he=j.indexOf(U[Q],ae+1);if(he<0)return!1;ae=he,Q++}return!0}n.fuzzyContains=me;function Se(P,U=!1){return P?(U&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=Se;function Be(P){return P.charAt(0).toUpperCase()+P.slice(1)}n.uppercaseFirstLetter=Be;function qe(P,U=1){if(U===0)return"";let W=-1;do W=P.indexOf(`
`,W+1),U--;while(U>0&&W>=0);return W===-1?P:(P[W-1]==="\r"&&W--,P.substr(0,W))}n.getNLines=qe;function Ve(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=Ve;function We(P){return Ce.getInstance().getGraphemeBreakType(P)}n.getGraphemeBreakType=We;function Ie(P,U){return P===0?U!==5&&U!==7:P===2&&U===3?!1:P===4||P===2||P===3||U===4||U===2||U===3?!0:!(P===8&&(U===8||U===9||U===11||U===12)||(P===11||P===9)&&(U===9||U===10)||(P===12||P===10)&&U===10||U===5||U===13||U===7||P===1||P===13&&U===14||P===6&&U===6)}var He;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(He=n.GraphemeBreakType||(n.GraphemeBreakType={}));class Ce{static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const W=this._data,j=W.length/3;let Q=1;for(;Q<=j;)if(U<W[3*Q])Q=2*Q;else if(U>W[3*Q+1])Q=2*Q+1;else return W[3*Q+2];return 0}}Ce._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(P,U){if(P===0)return 0;const W=$e(P,U);if(W!==void 0)return W;const j=new Ae(U,P);return j.prevCodePoint(),j.offset}n.getLeftDeleteOffset=je;function $e(P,U){const W=new Ae(U,P);let j=W.prevCodePoint();for(;Ge(j)||j===65039||j===8419;){if(W.offset===0)return;j=W.prevCodePoint()}if(!I(j))return;let Q=W.offset;return Q>0&&W.prevCodePoint()===8205&&(Q=W.offset),Q}function Ge(P){return 127995<=P&&P<=127999}var Te;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),n.noBreakWhitespace="\xA0";class _e{static getInstance(U){return _e.cache.get(Array.from(U))}static getLocales(){return _e._locales.getValue()}constructor(U){this.confusableDictionary=U}isAmbiguous(U){return this.confusableDictionary.has(U)}getPrimaryConfusable(U){return this.confusableDictionary.get(U)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=_e,F=_e,_e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new y.LRUCachedFunction(P=>{function U(le){const be=new Map;for(let ve=0;ve<le.length;ve+=2)be.set(le[ve],le[ve+1]);return be}function W(le,be){const ve=new Map(le);for(const[Pe,ke]of be)ve.set(Pe,ke);return ve}function j(le,be){if(!le)return be;const ve=new Map;for(const[Pe,ke]of le)be.has(Pe)&&ve.set(Pe,ke);return ve}const Q=F.ambiguousCharacterData.getValue();let ae=P.filter(le=>!le.startsWith("_")&&le in Q);ae.length===0&&(ae=["_default"]);let he;for(const le of ae){const be=U(Q[le]);he=j(he,be)}const Ne=U(Q._common),we=W(Ne,he);return new _e(we)}),_e._locales=new t.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(P=>!P.startsWith("_")));class Re{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Re.getRawData())),this._data}static isInvisibleCharacter(U){return Re.getData().has(U)}static get codePoints(){return Re.getData()}}n.InvisibleCharacters=Re,Re._data=void 0}),Y(Z[45],J([0,1,4]),function(B,n,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(C){return F(C,0)}n.hash=t;function F(C,w){switch(typeof C){case"object":return C===null?c(349,w):Array.isArray(C)?o(C,w):f(C,w);case"string":return h(C,w);case"boolean":return E(C,w);case"number":return c(C,w);case"undefined":return c(937,w);default:return c(617,w)}}n.doHash=F;function c(C,w){return(w<<5)-w+C|0}n.numberHash=c;function E(C,w){return c(C?433:863,w)}function h(C,w){w=c(149417,w);for(let i=0,a=C.length;i<a;i++)w=c(C.charCodeAt(i),w);return w}n.stringHash=h;function o(C,w){return w=c(104579,w),C.reduce((i,a)=>F(a,i),w)}function f(C,w){return w=c(181387,w),Object.keys(C).sort().reduce((i,a)=>(i=h(a,i),F(C[a],i)),w)}class A{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=F(w,this._value),this._value}}n.Hasher=A;var D;(function(C){C[C.BLOCK_SIZE=64]="BLOCK_SIZE",C[C.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function p(C,w,i=32){const a=i-w,s=~((1<<a)-1);return(C<<w|(s&C)>>>a)>>>0}function b(C,w=0,i=C.byteLength,a=0){for(let s=0;s<i;s++)C[w+s]=a}function e(C,w,i="0"){for(;C.length<w;)C=i+C;return C}function N(C,w=32){return C instanceof ArrayBuffer?Array.from(new Uint8Array(C)).map(i=>i.toString(16).padStart(2,"0")).join(""):e((C>>>0).toString(16),w/4)}n.toHexString=N;class R{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const i=w.length;if(i===0)return;const a=this._buff;let s=this._buffLen,l=this._leftoverHighSurrogate,u,g;for(l!==0?(u=l,g=-1,l=0):(u=w.charCodeAt(0),g=0);;){let d=u;if(y.isHighSurrogate(u))if(g+1<i){const L=w.charCodeAt(g+1);y.isLowSurrogate(L)?(g++,d=y.computeCodePoint(u,L)):d=65533}else{l=u;break}else y.isLowSurrogate(u)&&(d=65533);if(s=this._push(a,s,d),g++,g<i)u=w.charCodeAt(g);else break}this._buffLen=s,this._leftoverHighSurrogate=l}_push(w,i,a){return a<128?w[i++]=a:a<2048?(w[i++]=192|(a&1984)>>>6,w[i++]=128|(a&63)>>>0):a<65536?(w[i++]=224|(a&61440)>>>12,w[i++]=128|(a&4032)>>>6,w[i++]=128|(a&63)>>>0):(w[i++]=240|(a&1835008)>>>18,w[i++]=128|(a&258048)>>>12,w[i++]=128|(a&4032)>>>6,w[i++]=128|(a&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),N(this._h0)+N(this._h1)+N(this._h2)+N(this._h3)+N(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=R._bigBlock32,i=this._buffDV;for(let m=0;m<64;m+=4)w.setUint32(m,i.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)w.setUint32(m,p(w.getUint32(m-12,!1)^w.getUint32(m-32,!1)^w.getUint32(m-56,!1)^w.getUint32(m-64,!1),1),!1);let a=this._h0,s=this._h1,l=this._h2,u=this._h3,g=this._h4,d,L,v;for(let m=0;m<80;m++)m<20?(d=s&l|~s&u,L=1518500249):m<40?(d=s^l^u,L=1859775393):m<60?(d=s&l|s&u|l&u,L=2400959708):(d=s^l^u,L=3395469782),v=p(a,5)+d+g+L+w.getUint32(m*4,!1)&4294967295,g=u,u=l,l=p(s,30),s=a,a=v;this._h0=this._h0+a&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+g&4294967295}}n.StringSHA1=R,R._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(Z[22],J([0,1,25,45]),function(B,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class F{constructor(p){this.source=p}getElements(){const p=this.source,b=new Int32Array(p.length);for(let e=0,N=p.length;e<N;e++)b[e]=p.charCodeAt(e);return b}}n.StringDiffSequence=F;function c(D,p,b){return new A(new F(D),new F(p)).ComputeDiff(b).changes}n.stringDiff=c;class E{static Assert(p,b){if(!p)throw new Error(b)}}n.Debug=E;class h{static Copy(p,b,e,N,R){for(let C=0;C<R;C++)e[N+C]=p[b+C]}static Copy2(p,b,e,N,R){for(let C=0;C<R;C++)e[N+C]=p[b+C]}}n.MyArray=h;var o;(function(D){D[D.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class f{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new y.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(p,b){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_originalCount++}AddModifiedElement(p,b){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class A{constructor(p,b,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=p,this._modifiedSequence=b;const[N,R,C]=A._getElements(p),[w,i,a]=A._getElements(b);this._hasStrings=C&&a,this._originalStringElements=N,this._originalElementsOrHash=R,this._modifiedStringElements=w,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(p){return p.length>0&&typeof p[0]=="string"}static _getElements(p){const b=p.getElements();if(A._isStringArray(b)){const e=new Int32Array(b.length);for(let N=0,R=b.length;N<R;N++)e[N]=(0,t.stringHash)(b[N],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}ElementsAreEqual(p,b){return this._originalElementsOrHash[p]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[p]===this._modifiedStringElements[b]:!0}ElementsAreStrictEqual(p,b){if(!this.ElementsAreEqual(p,b))return!1;const e=A._getStrictElement(this._originalSequence,p),N=A._getStrictElement(this._modifiedSequence,b);return e===N}static _getStrictElement(p,b){return typeof p.getStrictElement=="function"?p.getStrictElement(b):null}OriginalElementsAreEqual(p,b){return this._originalElementsOrHash[p]!==this._originalElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[p]===this._originalStringElements[b]:!0}ModifiedElementsAreEqual(p,b){return this._modifiedElementsOrHash[p]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._modifiedStringElements[p]===this._modifiedStringElements[b]:!0}ComputeDiff(p){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,p)}_ComputeDiff(p,b,e,N,R){const C=[!1];let w=this.ComputeDiffRecursive(p,b,e,N,C);return R&&(w=this.PrettifyChanges(w)),{quitEarly:C[0],changes:w}}ComputeDiffRecursive(p,b,e,N,R){for(R[0]=!1;p<=b&&e<=N&&this.ElementsAreEqual(p,e);)p++,e++;for(;b>=p&&N>=e&&this.ElementsAreEqual(b,N);)b--,N--;if(p>b||e>N){let l;return e<=N?(E.Assert(p===b+1,"originalStart should only be one more than originalEnd"),l=[new y.DiffChange(p,0,e,N-e+1)]):p<=b?(E.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),l=[new y.DiffChange(p,b-p+1,e,0)]):(E.Assert(p===b+1,"originalStart should only be one more than originalEnd"),E.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),l=[]),l}const C=[0],w=[0],i=this.ComputeRecursionPoint(p,b,e,N,C,w,R),a=C[0],s=w[0];if(i!==null)return i;if(!R[0]){const l=this.ComputeDiffRecursive(p,a,e,s,R);let u=[];return R[0]?u=[new y.DiffChange(a+1,b-(a+1)+1,s+1,N-(s+1)+1)]:u=this.ComputeDiffRecursive(a+1,b,s+1,N,R),this.ConcatenateChanges(l,u)}return[new y.DiffChange(p,b-p+1,e,N-e+1)]}WALKTRACE(p,b,e,N,R,C,w,i,a,s,l,u,g,d,L,v,m,_){let M=null,T=null,O=new f,q=b,$=e,z=g[0]-v[0]-N,ne=-1073741824,oe=this.m_forwardHistory.length-1;do{const re=z+p;re===q||re<$&&a[re-1]<a[re+1]?(l=a[re+1],d=l-z-N,l<ne&&O.MarkNextChange(),ne=l,O.AddModifiedElement(l+1,d),z=re+1-p):(l=a[re-1]+1,d=l-z-N,l<ne&&O.MarkNextChange(),ne=l-1,O.AddOriginalElement(l,d+1),z=re-1-p),oe>=0&&(a=this.m_forwardHistory[oe],p=a[0],q=1,$=a.length-1)}while(--oe>=-1);if(M=O.getReverseChanges(),_[0]){let re=g[0]+1,ee=v[0]+1;if(M!==null&&M.length>0){const r=M[M.length-1];re=Math.max(re,r.getOriginalEnd()),ee=Math.max(ee,r.getModifiedEnd())}T=[new y.DiffChange(re,u-re+1,ee,L-ee+1)]}else{O=new f,q=C,$=w,z=g[0]-v[0]-i,ne=1073741824,oe=m?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const re=z+R;re===q||re<$&&s[re-1]>=s[re+1]?(l=s[re+1]-1,d=l-z-i,l>ne&&O.MarkNextChange(),ne=l+1,O.AddOriginalElement(l+1,d+1),z=re+1-R):(l=s[re-1],d=l-z-i,l>ne&&O.MarkNextChange(),ne=l,O.AddModifiedElement(l+1,d+1),z=re-1-R),oe>=0&&(s=this.m_reverseHistory[oe],R=s[0],q=1,$=s.length-1)}while(--oe>=-1);T=O.getChanges()}return this.ConcatenateChanges(M,T)}ComputeRecursionPoint(p,b,e,N,R,C,w){let i=0,a=0,s=0,l=0,u=0,g=0;p--,e--,R[0]=0,C[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=b-p+(N-e),L=d+1,v=new Int32Array(L),m=new Int32Array(L),_=N-e,M=b-p,T=p-e,O=b-N,$=(M-_)%2===0;v[_]=p,m[M]=b,w[0]=!1;for(let z=1;z<=d/2+1;z++){let ne=0,oe=0;s=this.ClipDiagonalBound(_-z,z,_,L),l=this.ClipDiagonalBound(_+z,z,_,L);for(let ee=s;ee<=l;ee+=2){ee===s||ee<l&&v[ee-1]<v[ee+1]?i=v[ee+1]:i=v[ee-1]+1,a=i-(ee-_)-T;const r=i;for(;i<b&&a<N&&this.ElementsAreEqual(i+1,a+1);)i++,a++;if(v[ee]=i,i+a>ne+oe&&(ne=i,oe=a),!$&&Math.abs(ee-M)<=z-1&&i>=m[ee])return R[0]=i,C[0]=a,r<=m[ee]&&1447>0&&z<=1447+1?this.WALKTRACE(_,s,l,T,M,u,g,O,v,m,i,b,R,a,N,C,$,w):null}const re=(ne-p+(oe-e)-z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ne,re))return w[0]=!0,R[0]=ne,C[0]=oe,re>0&&1447>0&&z<=1447+1?this.WALKTRACE(_,s,l,T,M,u,g,O,v,m,i,b,R,a,N,C,$,w):(p++,e++,[new y.DiffChange(p,b-p+1,e,N-e+1)]);u=this.ClipDiagonalBound(M-z,z,M,L),g=this.ClipDiagonalBound(M+z,z,M,L);for(let ee=u;ee<=g;ee+=2){ee===u||ee<g&&m[ee-1]>=m[ee+1]?i=m[ee+1]-1:i=m[ee-1],a=i-(ee-M)-O;const r=i;for(;i>p&&a>e&&this.ElementsAreEqual(i,a);)i--,a--;if(m[ee]=i,$&&Math.abs(ee-_)<=z&&i<=v[ee])return R[0]=i,C[0]=a,r>=v[ee]&&1447>0&&z<=1447+1?this.WALKTRACE(_,s,l,T,M,u,g,O,v,m,i,b,R,a,N,C,$,w):null}if(z<=1447){let ee=new Int32Array(l-s+2);ee[0]=_-s+1,h.Copy2(v,s,ee,1,l-s+1),this.m_forwardHistory.push(ee),ee=new Int32Array(g-u+2),ee[0]=M-u+1,h.Copy2(m,u,ee,1,g-u+1),this.m_reverseHistory.push(ee)}}return this.WALKTRACE(_,s,l,T,M,u,g,O,v,m,i,b,R,a,N,C,$,w)}PrettifyChanges(p){for(let b=0;b<p.length;b++){const e=p[b],N=b<p.length-1?p[b+1].originalStart:this._originalElementsOrHash.length,R=b<p.length-1?p[b+1].modifiedStart:this._modifiedElementsOrHash.length,C=e.originalLength>0,w=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<R&&(!C||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!w||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const i=[null];if(b<p.length-1&&this.ChangesOverlap(p[b],p[b+1],i)){p[b]=i[0],p.splice(b+1,1),b--;continue}}for(let b=p.length-1;b>=0;b--){const e=p[b];let N=0,R=0;if(b>0){const l=p[b-1];N=l.originalStart+l.originalLength,R=l.modifiedStart+l.modifiedLength}const C=e.originalLength>0,w=e.modifiedLength>0;let i=0,a=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let l=1;;l++){const u=e.originalStart-l,g=e.modifiedStart-l;if(u<N||g<R||C&&!this.OriginalElementsAreEqual(u,u+e.originalLength)||w&&!this.ModifiedElementsAreEqual(g,g+e.modifiedLength))break;const L=(u===N&&g===R?5:0)+this._boundaryScore(u,e.originalLength,g,e.modifiedLength);L>a&&(a=L,i=l)}e.originalStart-=i,e.modifiedStart-=i;const s=[null];if(b>0&&this.ChangesOverlap(p[b-1],p[b],s)){p[b-1]=s[0],p.splice(b,1),b++;continue}}if(this._hasStrings)for(let b=1,e=p.length;b<e;b++){const N=p[b-1],R=p[b],C=R.originalStart-N.originalStart-N.originalLength,w=N.originalStart,i=R.originalStart+R.originalLength,a=i-w,s=N.modifiedStart,l=R.modifiedStart+R.modifiedLength,u=l-s;if(C<5&&a<20&&u<20){const g=this._findBetterContiguousSequence(w,a,s,u,C);if(g){const[d,L]=g;(d!==N.originalStart+N.originalLength||L!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=d-N.originalStart,N.modifiedLength=L-N.modifiedStart,R.originalStart=d+C,R.modifiedStart=L+C,R.originalLength=i-R.originalStart,R.modifiedLength=l-R.modifiedStart)}}}return p}_findBetterContiguousSequence(p,b,e,N,R){if(b<R||N<R)return null;const C=p+b-R+1,w=e+N-R+1;let i=0,a=0,s=0;for(let l=p;l<C;l++)for(let u=e;u<w;u++){const g=this._contiguousSequenceScore(l,u,R);g>0&&g>i&&(i=g,a=l,s=u)}return i>0?[a,s]:null}_contiguousSequenceScore(p,b,e){let N=0;for(let R=0;R<e;R++){if(!this.ElementsAreEqual(p+R,b+R))return 0;N+=this._originalStringElements[p+R].length}return N}_OriginalIsBoundary(p){return p<=0||p>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[p])}_OriginalRegionIsBoundary(p,b){if(this._OriginalIsBoundary(p)||this._OriginalIsBoundary(p-1))return!0;if(b>0){const e=p+b;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(p){return p<=0||p>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[p])}_ModifiedRegionIsBoundary(p,b){if(this._ModifiedIsBoundary(p)||this._ModifiedIsBoundary(p-1))return!0;if(b>0){const e=p+b;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(p,b,e,N){const R=this._OriginalRegionIsBoundary(p,b)?1:0,C=this._ModifiedRegionIsBoundary(e,N)?1:0;return R+C}ConcatenateChanges(p,b){const e=[];if(p.length===0||b.length===0)return b.length>0?b:p;if(this.ChangesOverlap(p[p.length-1],b[0],e)){const N=new Array(p.length+b.length-1);return h.Copy(p,0,N,0,p.length-1),N[p.length-1]=e[0],h.Copy(b,1,N,p.length,b.length-1),N}else{const N=new Array(p.length+b.length);return h.Copy(p,0,N,0,p.length),h.Copy(b,0,N,p.length,b.length),N}}ChangesOverlap(p,b,e){if(E.Assert(p.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),E.Assert(p.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),p.originalStart+p.originalLength>=b.originalStart||p.modifiedStart+p.modifiedLength>=b.modifiedStart){const N=p.originalStart;let R=p.originalLength;const C=p.modifiedStart;let w=p.modifiedLength;return p.originalStart+p.originalLength>=b.originalStart&&(R=b.originalStart+b.originalLength-p.originalStart),p.modifiedStart+p.modifiedLength>=b.modifiedStart&&(w=b.modifiedStart+b.modifiedLength-p.modifiedStart),e[0]=new y.DiffChange(N,R,C,w),!0}else return e[0]=null,!1}ClipDiagonalBound(p,b,e,N){if(p>=0&&p<N)return p;const R=e,C=N-e-1,w=b%2===0;if(p<0){const i=R%2===0;return w===i?0:1}else{const i=C%2===0;return w===i?N-1:N-2}}}n.LcsDiff=A}),Y(Z[12],J([0,1,43,5]),function(B,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const F=/^\w[\w\d+.-]*$/,c=/^\//,E=/^\/\//;function h(g,d){if(!g.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!F.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!c.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(g,d){return!g&&!d?"file":g}function f(g,d){switch(g){case"https":case"http":case"file":d?d[0]!==D&&(d=D+d):d=D;break}return d}const A="",D="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(d){return d instanceof b?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,L,v,m,_,M=!1){typeof d=="object"?(this.scheme=d.scheme||A,this.authority=d.authority||A,this.path=d.path||A,this.query=d.query||A,this.fragment=d.fragment||A):(this.scheme=o(d,M),this.authority=L||A,this.path=f(this.scheme,v||A),this.query=m||A,this.fragment=_||A,h(this,M))}get fsPath(){return i(this,!1)}with(d){if(!d)return this;let{scheme:L,authority:v,path:m,query:_,fragment:M}=d;return L===void 0?L=this.scheme:L===null&&(L=A),v===void 0?v=this.authority:v===null&&(v=A),m===void 0?m=this.path:m===null&&(m=A),_===void 0?_=this.query:_===null&&(_=A),M===void 0?M=this.fragment:M===null&&(M=A),L===this.scheme&&v===this.authority&&m===this.path&&_===this.query&&M===this.fragment?this:new N(L,v,m,_,M)}static parse(d,L=!1){const v=p.exec(d);return v?new N(v[2]||A,u(v[4]||A),u(v[5]||A),u(v[7]||A),u(v[9]||A),L):new N(A,A,A,A,A)}static file(d){let L=A;if(t.isWindows&&(d=d.replace(/\\/g,D)),d[0]===D&&d[1]===D){const v=d.indexOf(D,2);v===-1?(L=d.substring(2),d=D):(L=d.substring(2,v),d=d.substring(v)||D)}return new N("file",L,d,A,A)}static from(d){const L=new N(d.scheme,d.authority,d.path,d.query,d.fragment);return h(L,!0),L}static joinPath(d,...L){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return t.isWindows&&d.scheme==="file"?v=b.file(y.win32.join(i(d,!0),...L)).path:v=y.posix.join(d.path,...L),d.with({path:v})}toString(d=!1){return a(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof b)return d;{const L=new N(d);return L._formatted=d.external,L._fsPath=d._sep===e?d.fsPath:null,L}}else return d}}n.URI=b;const e=t.isWindows?1:void 0;class N extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(d=!1){return d?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=e),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const R={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function C(g,d){let L,v=-1;for(let m=0;m<g.length;m++){const _=g.charCodeAt(m);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||d&&_===47)v!==-1&&(L+=encodeURIComponent(g.substring(v,m)),v=-1),L!==void 0&&(L+=g.charAt(m));else{L===void 0&&(L=g.substr(0,m));const M=R[_];M!==void 0?(v!==-1&&(L+=encodeURIComponent(g.substring(v,m)),v=-1),L+=M):v===-1&&(v=m)}}return v!==-1&&(L+=encodeURIComponent(g.substring(v))),L!==void 0?L:g}function w(g){let d;for(let L=0;L<g.length;L++){const v=g.charCodeAt(L);v===35||v===63?(d===void 0&&(d=g.substr(0,L)),d+=R[v]):d!==void 0&&(d+=g[L])}return d!==void 0?d:g}function i(g,d){let L;return g.authority&&g.path.length>1&&g.scheme==="file"?L=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?d?L=g.path.substr(1):L=g.path[1].toLowerCase()+g.path.substr(2):L=g.path,t.isWindows&&(L=L.replace(/\//g,"\\")),L}n.uriToFsPath=i;function a(g,d){const L=d?w:C;let v="",{scheme:m,authority:_,path:M,query:T,fragment:O}=g;if(m&&(v+=m,v+=":"),(_||m==="file")&&(v+=D,v+=D),_){let q=_.indexOf("@");if(q!==-1){const $=_.substr(0,q);_=_.substr(q+1),q=$.indexOf(":"),q===-1?v+=L($,!1):(v+=L($.substr(0,q),!1),v+=":",v+=L($.substr(q+1),!1)),v+="@"}_=_.toLowerCase(),q=_.indexOf(":"),q===-1?v+=L(_,!1):(v+=L(_.substr(0,q),!1),v+=_.substr(q))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const q=M.charCodeAt(1);q>=65&&q<=90&&(M=`/${String.fromCharCode(q+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const q=M.charCodeAt(0);q>=65&&q<=90&&(M=`${String.fromCharCode(q+32)}:${M.substr(2)}`)}v+=L(M,!0)}return T&&(v+="?",v+=L(T,!1)),O&&(v+="#",v+=d?O:C(O,!1)),v}function s(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+s(g.substr(3)):g}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(g){return g.match(l)?g.replace(l,d=>s(d)):g}}),Y(Z[56],J([0,1,6,8,7,10,5,4]),function(B,n,y,t,F,c,E,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const o="$initialize";let f=!1;function A(g){!E.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(g.message))}n.logOnceWebWorkerWarning=A;var D;(function(g){g[g.Request=0]="Request",g[g.Reply=1]="Reply",g[g.SubscribeEvent=2]="SubscribeEvent",g[g.Event=3]="Event",g[g.UnsubscribeEvent=4]="UnsubscribeEvent"})(D||(D={}));class p{constructor(d,L,v,m){this.vsWorker=d,this.req=L,this.method=v,this.args=m,this.type=0}}class b{constructor(d,L,v,m){this.vsWorker=d,this.seq=L,this.res=v,this.err=m,this.type=1}}class e{constructor(d,L,v,m){this.vsWorker=d,this.req=L,this.eventName=v,this.arg=m,this.type=2}}class N{constructor(d,L,v){this.vsWorker=d,this.req=L,this.event=v,this.type=3}}class R{constructor(d,L){this.vsWorker=d,this.req=L,this.type=4}}class C{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(d){this._workerId=d}sendMessage(d,L){const v=String(++this._lastSentReq);return new Promise((m,_)=>{this._pendingReplies[v]={resolve:m,reject:_},this._send(new p(this._workerId,v,d,L))})}listen(d,L){let v=null;const m=new t.Emitter({onFirstListenerAdd:()=>{v=String(++this._lastSentReq),this._pendingEmitters.set(v,m),this._send(new e(this._workerId,v,d,L))},onLastListenerRemove:()=>{this._pendingEmitters.delete(v),this._send(new R(this._workerId,v)),v=null}});return m.event}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){switch(d.type){case 1:return this._handleReplyMessage(d);case 0:return this._handleRequestMessage(d);case 2:return this._handleSubscribeEventMessage(d);case 3:return this._handleEventMessage(d);case 4:return this._handleUnsubscribeEventMessage(d)}}_handleReplyMessage(d){if(!this._pendingReplies[d.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[d.seq];if(delete this._pendingReplies[d.seq],d.err){let v=d.err;d.err.$isError&&(v=new Error,v.name=d.err.name,v.message=d.err.message,v.stack=d.err.stack),L.reject(v);return}L.resolve(d.res)}_handleRequestMessage(d){const L=d.req;this._handler.handleMessage(d.method,d.args).then(m=>{this._send(new b(this._workerId,L,m,void 0))},m=>{m.detail instanceof Error&&(m.detail=(0,y.transformErrorForSerialization)(m.detail)),this._send(new b(this._workerId,L,void 0,(0,y.transformErrorForSerialization)(m)))})}_handleSubscribeEventMessage(d){const L=d.req,v=this._handler.handleEvent(d.eventName,d.arg)(m=>{this._send(new N(this._workerId,L,m))});this._pendingEvents.set(L,v)}_handleEventMessage(d){if(!this._pendingEmitters.has(d.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(d.req).fire(d.event)}_handleUnsubscribeEventMessage(d){if(!this._pendingEvents.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(d.req).dispose(),this._pendingEvents.delete(d.req)}_send(d){const L=[];if(d.type===0)for(let v=0;v<d.args.length;v++)d.args[v]instanceof ArrayBuffer&&L.push(d.args[v]);else d.type===1&&d.res instanceof ArrayBuffer&&L.push(d.res);this._handler.sendMessage(d,L)}}class w extends F.Disposable{constructor(d,L,v){super();let m=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",q=>{this._protocol.handleMessage(q)},q=>{m?.(q)})),this._protocol=new C({sendMessage:(q,$)=>{this._worker.postMessage(q,$)},handleMessage:(q,$)=>{if(typeof v[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(v[q].apply(v,$))}catch(z){return Promise.reject(z)}},handleEvent:(q,$)=>{if(a(q)){const z=v[q].call(v,$);if(typeof z!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return z}if(i(q)){const z=v[q];if(typeof z!="function")throw new Error(`Missing event ${q} on main thread host.`);return z}throw new Error(`Malformed event name ${q}`)}}),this._protocol.setWorkerId(this._worker.getId());let _=null;typeof E.globals.require<"u"&&typeof E.globals.require.getConfig=="function"?_=E.globals.require.getConfig():typeof E.globals.requirejs<"u"&&(_=E.globals.requirejs.s.contexts._.config);const M=(0,c.getAllMethodNames)(v);this._onModuleLoaded=this._protocol.sendMessage(o,[this._worker.getId(),JSON.parse(JSON.stringify(_)),L,M]);const T=(q,$)=>this._request(q,$),O=(q,$)=>this._protocol.listen(q,$);this._lazyProxy=new Promise((q,$)=>{m=$,this._onModuleLoaded.then(z=>{q(s(z,T,O))},z=>{$(z),this._onError("Worker failed to load "+L,z)})})}getProxyObject(){return this._lazyProxy}_request(d,L){return new Promise((v,m)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,L).then(v,m)},m)})}_onError(d,L){console.error(d),console.info(L)}}n.SimpleWorkerClient=w;function i(g){return g[0]==="o"&&g[1]==="n"&&h.isUpperAsciiLetter(g.charCodeAt(2))}function a(g){return/^onDynamic/.test(g)&&h.isUpperAsciiLetter(g.charCodeAt(9))}function s(g,d,L){const v=M=>function(){const T=Array.prototype.slice.call(arguments,0);return d(M,T)},m=M=>function(T){return L(M,T)},_={};for(const M of g){if(a(M)){_[M]=m(M);continue}if(i(M)){_[M]=L(M,void 0);continue}_[M]=v(M)}return _}class l{constructor(d,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new C({sendMessage:(v,m)=>{d(v,m)},handleMessage:(v,m)=>this._handleMessage(v,m),handleEvent:(v,m)=>this._handleEvent(v,m)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,L){if(d===o)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,L))}catch(v){return Promise.reject(v)}}_handleEvent(d,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(d)){const v=this._requestHandler[d].call(this._requestHandler,L);if(typeof v!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return v}if(i(d)){const v=this._requestHandler[d];if(typeof v!="function")throw new Error(`Missing event ${d} on request handler.`);return v}throw new Error(`Malformed event name ${d}`)}initialize(d,L,v,m){this._protocol.setWorkerId(d);const T=s(m,(O,q)=>this._protocol.sendMessage(O,q),(O,q)=>this._protocol.listen(O,q));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(T),Promise.resolve((0,c.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,E.globals.require.config(L)),new Promise((O,q)=>{(E.globals.require||B)([v],z=>{if(this._requestHandler=z.create(T),!this._requestHandler){q(new Error("No RequestHandler!"));return}O((0,c.getAllMethodNames)(this._requestHandler))},q)}))}}n.SimpleWorkerServer=l;function u(g){return new l(g,null)}n.create=u}),Y(Z[23],J([0,1,22,19,4,2,9]),function(B,n,y,t,F,c,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const h=3;class o{computeDiff(a,s,l){const g=new N(a,s,{maxComputationTime:l.maxComputationTime,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),d=[];let L=null;for(const v of g.changes){let m;v.originalEndLineNumber===0?m=new t.LineRange(v.originalStartLineNumber+1,v.originalStartLineNumber+1):m=new t.LineRange(v.originalStartLineNumber,v.originalEndLineNumber+1);let _;v.modifiedEndLineNumber===0?_=new t.LineRange(v.modifiedStartLineNumber+1,v.modifiedStartLineNumber+1):_=new t.LineRange(v.modifiedStartLineNumber,v.modifiedEndLineNumber+1);let M=new t.LineRangeMapping(m,_,v.charChanges?.map(T=>new t.RangeMapping(new c.Range(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new c.Range(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));L&&(L.modifiedRange.endLineNumberExclusive===M.modifiedRange.startLineNumber||L.originalRange.endLineNumberExclusive===M.originalRange.startLineNumber)&&(M=new t.LineRangeMapping(L.originalRange.join(M.originalRange),L.modifiedRange.join(M.modifiedRange),L.innerChanges&&M.innerChanges?L.innerChanges.concat(M.innerChanges):void 0),d.pop()),d.push(M),L=M}return(0,E.assertFn)(()=>(0,E.checkAdjacentItems)(d,(v,m)=>m.originalRange.startLineNumber-v.originalRange.endLineNumberExclusive===m.modifiedRange.startLineNumber-v.modifiedRange.endLineNumberExclusive&&v.originalRange.endLineNumberExclusive<m.originalRange.startLineNumber&&v.modifiedRange.endLineNumberExclusive<m.modifiedRange.startLineNumber)),{quitEarly:g.quitEarly,changes:d}}}n.SmartLinesDiffComputer=o;function f(i,a,s,l){return new y.LcsDiff(i,a,s).ComputeDiff(l)}class A{constructor(a){const s=[],l=[];for(let u=0,g=a.length;u<g;u++)s[u]=R(a[u],1),l[u]=C(a[u],1);this.lines=a,this._startColumns=s,this._endColumns=l}getElements(){const a=[];for(let s=0,l=this.lines.length;s<l;s++)a[s]=this.lines[s].substring(this._startColumns[s]-1,this._endColumns[s]-1);return a}getStrictElement(a){return this.lines[a]}getStartLineNumber(a){return a+1}getEndLineNumber(a){return a+1}createCharSequence(a,s,l){const u=[],g=[],d=[];let L=0;for(let v=s;v<=l;v++){const m=this.lines[v],_=a?this._startColumns[v]:1,M=a?this._endColumns[v]:m.length+1;for(let T=_;T<M;T++)u[L]=m.charCodeAt(T-1),g[L]=v+1,d[L]=T,L++;!a&&v<l&&(u[L]=10,g[L]=v+1,d[L]=m.length+1,L++)}return new D(u,g,d)}}class D{constructor(a,s,l){this._charCodes=a,this._lineNumbers=s,this._columns=l}toString(){return"["+this._charCodes.map((a,s)=>(a===10?"\\n":String.fromCharCode(a))+`-(${this._lineNumbers[s]},${this._columns[s]})`).join(", ")+"]"}_assertIndex(a,s){if(a<0||a>=s.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(a){return a>0&&a===this._lineNumbers.length?this.getEndLineNumber(a-1):(this._assertIndex(a,this._lineNumbers),this._lineNumbers[a])}getEndLineNumber(a){return a===-1?this.getStartLineNumber(a+1):(this._assertIndex(a,this._lineNumbers),this._charCodes[a]===10?this._lineNumbers[a]+1:this._lineNumbers[a])}getStartColumn(a){return a>0&&a===this._columns.length?this.getEndColumn(a-1):(this._assertIndex(a,this._columns),this._columns[a])}getEndColumn(a){return a===-1?this.getStartColumn(a+1):(this._assertIndex(a,this._columns),this._charCodes[a]===10?1:this._columns[a]+1)}}class p{constructor(a,s,l,u,g,d,L,v){this.originalStartLineNumber=a,this.originalStartColumn=s,this.originalEndLineNumber=l,this.originalEndColumn=u,this.modifiedStartLineNumber=g,this.modifiedStartColumn=d,this.modifiedEndLineNumber=L,this.modifiedEndColumn=v}static createFromDiffChange(a,s,l){const u=s.getStartLineNumber(a.originalStart),g=s.getStartColumn(a.originalStart),d=s.getEndLineNumber(a.originalStart+a.originalLength-1),L=s.getEndColumn(a.originalStart+a.originalLength-1),v=l.getStartLineNumber(a.modifiedStart),m=l.getStartColumn(a.modifiedStart),_=l.getEndLineNumber(a.modifiedStart+a.modifiedLength-1),M=l.getEndColumn(a.modifiedStart+a.modifiedLength-1);return new p(u,g,d,L,v,m,_,M)}}function b(i){if(i.length<=1)return i;const a=[i[0]];let s=a[0];for(let l=1,u=i.length;l<u;l++){const g=i[l],d=g.originalStart-(s.originalStart+s.originalLength),L=g.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(d,L)<h?(s.originalLength=g.originalStart+g.originalLength-s.originalStart,s.modifiedLength=g.modifiedStart+g.modifiedLength-s.modifiedStart):(a.push(g),s=g)}return a}class e{constructor(a,s,l,u,g){this.originalStartLineNumber=a,this.originalEndLineNumber=s,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=u,this.charChanges=g}static createFromDiffResult(a,s,l,u,g,d,L){let v,m,_,M,T;if(s.originalLength===0?(v=l.getStartLineNumber(s.originalStart)-1,m=0):(v=l.getStartLineNumber(s.originalStart),m=l.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(_=u.getStartLineNumber(s.modifiedStart)-1,M=0):(_=u.getStartLineNumber(s.modifiedStart),M=u.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),d&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&g()){const O=l.createCharSequence(a,s.originalStart,s.originalStart+s.originalLength-1),q=u.createCharSequence(a,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(O.getElements().length>0&&q.getElements().length>0){let $=f(O,q,g,!0).changes;L&&($=b($)),T=[];for(let z=0,ne=$.length;z<ne;z++)T.push(p.createFromDiffChange($[z],O,q))}}return new e(v,m,_,M,T)}}class N{constructor(a,s,l){this.shouldComputeCharChanges=l.shouldComputeCharChanges,this.shouldPostProcessCharChanges=l.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=l.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=l.shouldMakePrettyDiff,this.originalLines=a,this.modifiedLines=s,this.original=new A(a),this.modified=new A(s),this.continueLineDiff=w(l.maxComputationTime),this.continueCharDiff=w(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const a=f(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),s=a.changes,l=a.quitEarly;if(this.shouldIgnoreTrimWhitespace){const L=[];for(let v=0,m=s.length;v<m;v++)L.push(e.createFromDiffResult(this.shouldIgnoreTrimWhitespace,s[v],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:l,changes:L}}const u=[];let g=0,d=0;for(let L=-1,v=s.length;L<v;L++){const m=L+1<v?s[L+1]:null,_=m?m.originalStart:this.originalLines.length,M=m?m.modifiedStart:this.modifiedLines.length;for(;g<_&&d<M;){const T=this.originalLines[g],O=this.modifiedLines[d];if(T!==O){{let q=R(T,1),$=R(O,1);for(;q>1&&$>1;){const z=T.charCodeAt(q-2),ne=O.charCodeAt($-2);if(z!==ne)break;q--,$--}(q>1||$>1)&&this._pushTrimWhitespaceCharChange(u,g+1,1,q,d+1,1,$)}{let q=C(T,1),$=C(O,1);const z=T.length+1,ne=O.length+1;for(;q<z&&$<ne;){const oe=T.charCodeAt(q-1),re=T.charCodeAt($-1);if(oe!==re)break;q++,$++}(q<z||$<ne)&&this._pushTrimWhitespaceCharChange(u,g+1,q,z,d+1,$,ne)}}g++,d++}m&&(u.push(e.createFromDiffResult(this.shouldIgnoreTrimWhitespace,m,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),g+=m.originalLength,d+=m.modifiedLength)}return{quitEarly:l,changes:u}}_pushTrimWhitespaceCharChange(a,s,l,u,g,d,L){if(this._mergeTrimWhitespaceCharChange(a,s,l,u,g,d,L))return;let v;this.shouldComputeCharChanges&&(v=[new p(s,l,s,u,g,d,g,L)]),a.push(new e(s,s,g,g,v))}_mergeTrimWhitespaceCharChange(a,s,l,u,g,d,L){const v=a.length;if(v===0)return!1;const m=a[v-1];return m.originalEndLineNumber===0||m.modifiedEndLineNumber===0?!1:m.originalEndLineNumber+1===s&&m.modifiedEndLineNumber+1===g?(m.originalEndLineNumber=s,m.modifiedEndLineNumber=g,this.shouldComputeCharChanges&&m.charChanges&&m.charChanges.push(new p(s,l,s,u,g,d,g,L)),!0):!1}}n.DiffComputer=N;function R(i,a){const s=F.firstNonWhitespaceIndex(i);return s===-1?a:s+1}function C(i,a){const s=F.lastNonWhitespaceIndex(i);return s===-1?a:s+2}function w(i){if(i===0)return()=>!0;const a=Date.now();return()=>Date.now()-a<i}}),Y(Z[46],J([0,1,23,35]),function(B,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new y.SmartLinesDiffComputer,experimental:new t.StandardLinesDiffComputer}}),Y(Z[47],J([0,1,4,3,39]),function(B,n,y,t,F){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class c{constructor(h,o,f,A){this._uri=h,this._lines=o,this._eol=f,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(h){h.eol&&h.eol!==this._eol&&(this._eol=h.eol,this._lineStarts=null);const o=h.changes;for(const f of o)this._acceptDeleteRange(f.range),this._acceptInsertText(new t.Position(f.range.startLineNumber,f.range.startColumn),f.text);this._versionId=h.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const h=this._eol.length,o=this._lines.length,f=new Uint32Array(o);for(let A=0;A<o;A++)f[A]=this._lines[A].length+h;this._lineStarts=new F.PrefixSumComputer(f)}}_setLineText(h,o){this._lines[h]=o,this._lineStarts&&this._lineStarts.setValue(h,this._lines[h].length+this._eol.length)}_acceptDeleteRange(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.startLineNumber-1].substring(h.endColumn-1));return}this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.endLineNumber-1].substring(h.endColumn-1)),this._lines.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}_acceptInsertText(h,o){if(o.length===0)return;const f=(0,y.splitLines)(o);if(f.length===1){this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+f[0]+this._lines[h.lineNumber-1].substring(h.column-1));return}f[f.length-1]+=this._lines[h.lineNumber-1].substring(h.column-1),this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+f[0]);const A=new Uint32Array(f.length-1);for(let D=1;D<f.length;D++)this._lines.splice(h.lineNumber+D-1,0,f[D]),A[D-1]=f[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(h.lineNumber,A)}}n.MirrorTextModel=c}),Y(Z[48],J([0,1,4,31,3,2,38]),function(B,n,y,t,F,c,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const h=999;class o{constructor(w,i,a,s){this.searchString=w,this.isRegex=i,this.matchCase=a,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=f(this.searchString):w=this.searchString.indexOf(`
`)>=0;let i=null;try{i=y.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!i)return null;let a=!this.isRegex&&!w;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new E.SearchData(i,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}n.SearchParams=o;function f(C){if(!C||C.length===0)return!1;for(let w=0,i=C.length;w<i;w++){const a=C.charCodeAt(w);if(a===10)return!0;if(a===92){if(w++,w>=i)break;const s=C.charCodeAt(w);if(s===110||s===114||s===87)return!0}}return!1}n.isMultilineRegexSource=f;function A(C,w,i){if(!i)return new E.FindMatch(C,null);const a=[];for(let s=0,l=w.length;s<l;s++)a[s]=w[s];return new E.FindMatch(C,a)}n.createFindMatch=A;class D{constructor(w){const i=[];let a=0;for(let s=0,l=w.length;s<l;s++)w.charCodeAt(s)===10&&(i[a++]=s);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(w){const i=this._lineFeedsOffsets;let a=0,s=i.length-1;if(s===-1||w<=i[0])return 0;for(;a<s;){const l=a+((s-a)/2>>0);i[l]>=w?s=l-1:i[l+1]>=w?(a=l,s=l):a=l+1}return a+1}}class p{static findMatches(w,i,a,s,l){const u=i.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(w,a,new R(u.wordSeparators,u.regex),s,l):this._doFindMatchesLineByLine(w,a,u,s,l):[]}static _getMultilineMatchRange(w,i,a,s,l,u){let g,d=0;s?(d=s.findLineFeedCountBeforeOffset(l),g=i+l+d):g=i+l;let L;if(s){const M=s.findLineFeedCountBeforeOffset(l+u.length)-d;L=g+u.length+M}else L=g+u.length;const v=w.getPositionAt(g),m=w.getPositionAt(L);return new c.Range(v.lineNumber,v.column,m.lineNumber,m.column)}static _doFindMatchesMultiline(w,i,a,s,l){const u=w.getOffsetAt(i.getStartPosition()),g=w.getValueInRange(i,1),d=w.getEOL()===`\r
`?new D(g):null,L=[];let v=0,m;for(a.reset(0);m=a.next(g);)if(L[v++]=A(this._getMultilineMatchRange(w,u,g,d,m.index,m[0]),m,s),v>=l)return L;return L}static _doFindMatchesLineByLine(w,i,a,s,l){const u=[];let g=0;if(i.startLineNumber===i.endLineNumber){const L=w.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return g=this._findMatchesInLine(a,L,i.startLineNumber,i.startColumn-1,g,u,s,l),u}const d=w.getLineContent(i.startLineNumber).substring(i.startColumn-1);g=this._findMatchesInLine(a,d,i.startLineNumber,i.startColumn-1,g,u,s,l);for(let L=i.startLineNumber+1;L<i.endLineNumber&&g<l;L++)g=this._findMatchesInLine(a,w.getLineContent(L),L,0,g,u,s,l);if(g<l){const L=w.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);g=this._findMatchesInLine(a,L,i.endLineNumber,0,g,u,s,l)}return u}static _findMatchesInLine(w,i,a,s,l,u,g,d){const L=w.wordSeparators;if(!g&&w.simpleSearch){const _=w.simpleSearch,M=_.length,T=i.length;let O=-M;for(;(O=i.indexOf(_,O+M))!==-1;)if((!L||N(L,i,T,O,M))&&(u[l++]=new E.FindMatch(new c.Range(a,O+1+s,a,O+1+M+s),null),l>=d))return l;return l}const v=new R(w.wordSeparators,w.regex);let m;v.reset(0);do if(m=v.next(i),m&&(u[l++]=A(new c.Range(a,m.index+1+s,a,m.index+1+m[0].length+s),m,g),l>=d))return l;while(m);return l}static findNextMatch(w,i,a,s){const l=i.parseSearchRequest();if(!l)return null;const u=new R(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindNextMatchMultiline(w,a,u,s):this._doFindNextMatchLineByLine(w,a,u,s)}static _doFindNextMatchMultiline(w,i,a,s){const l=new F.Position(i.lineNumber,1),u=w.getOffsetAt(l),g=w.getLineCount(),d=w.getValueInRange(new c.Range(l.lineNumber,l.column,g,w.getLineMaxColumn(g)),1),L=w.getEOL()===`\r
`?new D(d):null;a.reset(i.column-1);const v=a.next(d);return v?A(this._getMultilineMatchRange(w,u,d,L,v.index,v[0]),v,s):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(w,new F.Position(1,1),a,s):null}static _doFindNextMatchLineByLine(w,i,a,s){const l=w.getLineCount(),u=i.lineNumber,g=w.getLineContent(u),d=this._findFirstMatchInLine(a,g,u,i.column,s);if(d)return d;for(let L=1;L<=l;L++){const v=(u+L-1)%l,m=w.getLineContent(v+1),_=this._findFirstMatchInLine(a,m,v+1,1,s);if(_)return _}return null}static _findFirstMatchInLine(w,i,a,s,l){w.reset(s-1);const u=w.next(i);return u?A(new c.Range(a,u.index+1,a,u.index+1+u[0].length),u,l):null}static findPreviousMatch(w,i,a,s){const l=i.parseSearchRequest();if(!l)return null;const u=new R(l.wordSeparators,l.regex);return l.regex.multiline?this._doFindPreviousMatchMultiline(w,a,u,s):this._doFindPreviousMatchLineByLine(w,a,u,s)}static _doFindPreviousMatchMultiline(w,i,a,s){const l=this._doFindMatchesMultiline(w,new c.Range(1,1,i.lineNumber,i.column),a,s,10*h);if(l.length>0)return l[l.length-1];const u=w.getLineCount();return i.lineNumber!==u||i.column!==w.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(w,new F.Position(u,w.getLineMaxColumn(u)),a,s):null}static _doFindPreviousMatchLineByLine(w,i,a,s){const l=w.getLineCount(),u=i.lineNumber,g=w.getLineContent(u).substring(0,i.column-1),d=this._findLastMatchInLine(a,g,u,s);if(d)return d;for(let L=1;L<=l;L++){const v=(l+u-L-1)%l,m=w.getLineContent(v+1),_=this._findLastMatchInLine(a,m,v+1,s);if(_)return _}return null}static _findLastMatchInLine(w,i,a,s){let l=null,u;for(w.reset(0);u=w.next(i);)l=A(new c.Range(a,u.index+1,a,u.index+1+u[0].length),u,s);return l}}n.TextModelSearch=p;function b(C,w,i,a,s){if(a===0)return!0;const l=w.charCodeAt(a-1);if(C.get(l)!==0||l===13||l===10)return!0;if(s>0){const u=w.charCodeAt(a);if(C.get(u)!==0)return!0}return!1}function e(C,w,i,a,s){if(a+s===i)return!0;const l=w.charCodeAt(a+s);if(C.get(l)!==0||l===13||l===10)return!0;if(s>0){const u=w.charCodeAt(a+s-1);if(C.get(u)!==0)return!0}return!1}function N(C,w,i,a,s){return b(C,w,i,a,s)&&e(C,w,i,a,s)}n.isValidMatch=N;class R{constructor(w,i){this._wordSeparators=w,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(w){this._searchRegex.lastIndex=w,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(w){const i=w.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(a=this._searchRegex.exec(w),!a))return null;const s=a.index,l=a[0].length;if(s===this._prevMatchStartIndex&&l===this._prevMatchLength){if(l===0){y.getNextCodePoint(w,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=s,this._prevMatchLength=l,!this._wordSeparators||N(this._wordSeparators,w,i,s,l))return a}while(a);return null}}n.Searcher=R}),Y(Z[49],J([0,1,2,48,4,9,18]),function(B,n,y,t,F,c,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class h{static computeUnicodeHighlights(e,N,R){const C=R?R.startLineNumber:1,w=R?R.endLineNumber:e.getLineCount(),i=new A(N),a=i.getCandidateCodePoints();let s;a==="allNonBasicAscii"?s=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):s=new RegExp(`${o(Array.from(a))}`,"g");const l=new t.Searcher(null,s),u=[];let g=!1,d,L=0,v=0,m=0;e:for(let _=C,M=w;_<=M;_++){const T=e.getLineContent(_),O=T.length;l.reset(0);do if(d=l.next(T),d){let q=d.index,$=d.index+d[0].length;if(q>0){const re=T.charCodeAt(q-1);F.isHighSurrogate(re)&&q--}if($+1<O){const re=T.charCodeAt($-1);F.isHighSurrogate(re)&&$++}const z=T.substring(q,$),ne=(0,E.getWordAtText)(q+1,E.DEFAULT_WORD_REGEXP,T,0),oe=i.shouldHighlightNonBasicASCII(z,ne?ne.word:null);if(oe!==0){oe===3?L++:oe===2?v++:oe===1?m++:(0,c.assertNever)(oe);const re=1e3;if(u.length>=re){g=!0;break e}u.push(new y.Range(_,q+1,_,$+1))}}while(d)}return{ranges:u,hasMore:g,ambiguousCharacterCount:L,invisibleCharacterCount:v,nonBasicAsciiCharacterCount:m}}static computeUnicodeHighlightReason(e,N){const R=new A(N);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const w=e.codePointAt(0),i=R.ambiguousCharacters.getPrimaryConfusable(w),a=F.AmbiguousCharacters.getLocales().filter(s=>!F.AmbiguousCharacters.getInstance(new Set([...N.allowedLocales,s])).isAmbiguous(w));return{kind:0,confusableWith:String.fromCodePoint(i),notAmbiguousInLocales:a}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=h;function o(b,e){return`[${F.escapeRegExpCharacters(b.map(R=>String.fromCodePoint(R)).join(""))}]`}var f;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(f=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class A{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=F.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const N of F.InvisibleCharacters.codePoints)D(String.fromCodePoint(N))||e.add(N);if(this.options.ambiguousCharacters)for(const N of this.ambiguousCharacters.getConfusableCodePoints())e.add(N);for(const N of this.allowedCodePoints)e.delete(N);return e}shouldHighlightNonBasicASCII(e,N){const R=e.codePointAt(0);if(this.allowedCodePoints.has(R))return 0;if(this.options.nonBasicASCII)return 1;let C=!1,w=!1;if(N)for(const i of N){const a=i.codePointAt(0),s=F.isBasicASCII(i);C=C||s,!s&&!this.ambiguousCharacters.isAmbiguous(a)&&!F.InvisibleCharacters.isInvisibleCharacter(a)&&(w=!0)}return!C&&w?0:this.options.invisibleCharacters&&!D(e)&&F.InvisibleCharacters.isInvisibleCharacter(R)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function D(b){return b===" "||b===`
`||b==="	"}var p;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})(p||(p={}))}),Y(Z[50],J([0,1,8,7]),function(B,n,y,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class F{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(h){this._onDidChange.fire({changedLanguages:h,changedColorMap:!1})}register(h,o){return this._map.set(h,o),this.fire([h]),(0,t.toDisposable)(()=>{this._map.get(h)===o&&(this._map.delete(h),this.fire([h]))})}registerFactory(h,o){this._factories.get(h)?.dispose();const f=new c(this,h,o);return this._factories.set(h,f),(0,t.toDisposable)(()=>{const A=this._factories.get(h);!A||A!==f||(this._factories.delete(h),A.dispose())})}async getOrCreate(h){const o=this.get(h);if(o)return o;const f=this._factories.get(h);return!f||f.isResolved?null:(await f.resolve(),this.get(h))}get(h){return this._map.get(h)||null}isResolved(h){if(this.get(h))return!0;const f=this._factories.get(h);return!!(!f||f.isResolved)}setColorMap(h){this._colorMap=h,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=F;class c extends t.Disposable{get isResolved(){return this._isResolved}constructor(h,o,f){super(),this._registry=h,this._languageId=o,this._factory=f,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const h=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,h&&!this._isDisposed&&this._register(this._registry.register(this._languageId,h))}}}),Y(Z[51],J([0,1,24,12,2,50]),function(B,n,y,t,F,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadState=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class E{constructor(M,T,O){this._tokenBrand=void 0,this.offset=M,this.type=T,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=E;class h{constructor(M,T){this._tokenizationResultBrand=void 0,this.tokens=M,this.endState=T}}n.TokenizationResult=h;class o{constructor(M,T){this._encodedTokenizationResultBrand=void 0,this.tokens=M,this.endState=T}}n.EncodedTokenizationResult=o;var f;(function(_){_[_.Method=0]="Method",_[_.Function=1]="Function",_[_.Constructor=2]="Constructor",_[_.Field=3]="Field",_[_.Variable=4]="Variable",_[_.Class=5]="Class",_[_.Struct=6]="Struct",_[_.Interface=7]="Interface",_[_.Module=8]="Module",_[_.Property=9]="Property",_[_.Event=10]="Event",_[_.Operator=11]="Operator",_[_.Unit=12]="Unit",_[_.Value=13]="Value",_[_.Constant=14]="Constant",_[_.Enum=15]="Enum",_[_.EnumMember=16]="EnumMember",_[_.Keyword=17]="Keyword",_[_.Text=18]="Text",_[_.Color=19]="Color",_[_.File=20]="File",_[_.Reference=21]="Reference",_[_.Customcolor=22]="Customcolor",_[_.Folder=23]="Folder",_[_.TypeParameter=24]="TypeParameter",_[_.User=25]="User",_[_.Issue=26]="Issue",_[_.Snippet=27]="Snippet"})(f=n.CompletionItemKind||(n.CompletionItemKind={}));var A;(function(_){const M=new Map;M.set(0,y.Codicon.symbolMethod),M.set(1,y.Codicon.symbolFunction),M.set(2,y.Codicon.symbolConstructor),M.set(3,y.Codicon.symbolField),M.set(4,y.Codicon.symbolVariable),M.set(5,y.Codicon.symbolClass),M.set(6,y.Codicon.symbolStruct),M.set(7,y.Codicon.symbolInterface),M.set(8,y.Codicon.symbolModule),M.set(9,y.Codicon.symbolProperty),M.set(10,y.Codicon.symbolEvent),M.set(11,y.Codicon.symbolOperator),M.set(12,y.Codicon.symbolUnit),M.set(13,y.Codicon.symbolValue),M.set(15,y.Codicon.symbolEnum),M.set(14,y.Codicon.symbolConstant),M.set(15,y.Codicon.symbolEnum),M.set(16,y.Codicon.symbolEnumMember),M.set(17,y.Codicon.symbolKeyword),M.set(27,y.Codicon.symbolSnippet),M.set(18,y.Codicon.symbolText),M.set(19,y.Codicon.symbolColor),M.set(20,y.Codicon.symbolFile),M.set(21,y.Codicon.symbolReference),M.set(22,y.Codicon.symbolCustomColor),M.set(23,y.Codicon.symbolFolder),M.set(24,y.Codicon.symbolTypeParameter),M.set(25,y.Codicon.account),M.set(26,y.Codicon.issues);function T($){let z=M.get($);return z||(console.info("No codicon found for CompletionItemKind "+$),z=y.Codicon.symbolProperty),z}_.toIcon=T;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function q($,z){let ne=O.get($);return typeof ne>"u"&&!z&&(ne=9),ne}_.fromString=q})(A=n.CompletionItemKinds||(n.CompletionItemKinds={}));var D;(function(_){_[_.Deprecated=1]="Deprecated"})(D=n.CompletionItemTag||(n.CompletionItemTag={}));var p;(function(_){_[_.KeepWhitespace=1]="KeepWhitespace",_[_.InsertAsSnippet=4]="InsertAsSnippet"})(p=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var b;(function(_){_[_.Invoke=0]="Invoke",_[_.TriggerCharacter=1]="TriggerCharacter",_[_.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var e;(function(_){_[_.Automatic=0]="Automatic",_[_.Explicit=1]="Explicit"})(e=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var N;(function(_){_[_.Invoke=1]="Invoke",_[_.Auto=2]="Auto"})(N=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var R;(function(_){_[_.Invoke=1]="Invoke",_[_.TriggerCharacter=2]="TriggerCharacter",_[_.ContentChange=3]="ContentChange"})(R=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var C;(function(_){_[_.Text=0]="Text",_[_.Read=1]="Read",_[_.Write=2]="Write"})(C=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function w(_){return _&&t.URI.isUri(_.uri)&&F.Range.isIRange(_.range)&&(F.Range.isIRange(_.originSelectionRange)||F.Range.isIRange(_.targetSelectionRange))}n.isLocationLink=w;var i;(function(_){_[_.File=0]="File",_[_.Module=1]="Module",_[_.Namespace=2]="Namespace",_[_.Package=3]="Package",_[_.Class=4]="Class",_[_.Method=5]="Method",_[_.Property=6]="Property",_[_.Field=7]="Field",_[_.Constructor=8]="Constructor",_[_.Enum=9]="Enum",_[_.Interface=10]="Interface",_[_.Function=11]="Function",_[_.Variable=12]="Variable",_[_.Constant=13]="Constant",_[_.String=14]="String",_[_.Number=15]="Number",_[_.Boolean=16]="Boolean",_[_.Array=17]="Array",_[_.Object=18]="Object",_[_.Key=19]="Key",_[_.Null=20]="Null",_[_.EnumMember=21]="EnumMember",_[_.Struct=22]="Struct",_[_.Event=23]="Event",_[_.Operator=24]="Operator",_[_.TypeParameter=25]="TypeParameter"})(i=n.SymbolKind||(n.SymbolKind={}));var a;(function(_){_[_.Deprecated=1]="Deprecated"})(a=n.SymbolTag||(n.SymbolTag={}));var s;(function(_){const M=new Map;M.set(0,y.Codicon.symbolFile),M.set(1,y.Codicon.symbolModule),M.set(2,y.Codicon.symbolNamespace),M.set(3,y.Codicon.symbolPackage),M.set(4,y.Codicon.symbolClass),M.set(5,y.Codicon.symbolMethod),M.set(6,y.Codicon.symbolProperty),M.set(7,y.Codicon.symbolField),M.set(8,y.Codicon.symbolConstructor),M.set(9,y.Codicon.symbolEnum),M.set(10,y.Codicon.symbolInterface),M.set(11,y.Codicon.symbolFunction),M.set(12,y.Codicon.symbolVariable),M.set(13,y.Codicon.symbolConstant),M.set(14,y.Codicon.symbolString),M.set(15,y.Codicon.symbolNumber),M.set(16,y.Codicon.symbolBoolean),M.set(17,y.Codicon.symbolArray),M.set(18,y.Codicon.symbolObject),M.set(19,y.Codicon.symbolKey),M.set(20,y.Codicon.symbolNull),M.set(21,y.Codicon.symbolEnumMember),M.set(22,y.Codicon.symbolStruct),M.set(23,y.Codicon.symbolEvent),M.set(24,y.Codicon.symbolOperator),M.set(25,y.Codicon.symbolTypeParameter);function T(O){let q=M.get(O);return q||(console.info("No codicon found for SymbolKind "+O),q=y.Codicon.symbolProperty),q}_.toIcon=T})(s=n.SymbolKinds||(n.SymbolKinds={}));class l{constructor(M){this.value=M}}n.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var u;(function(_){function M(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}_.is=M})(u=n.Command||(n.Command={}));var g;(function(_){_[_.Collapsed=0]="Collapsed",_[_.Expanded=1]="Expanded"})(g=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var d;(function(_){_[_.Unresolved=0]="Unresolved",_[_.Resolved=1]="Resolved"})(d=n.CommentThreadState||(n.CommentThreadState={}));var L;(function(_){_[_.Editing=0]="Editing",_[_.Preview=1]="Preview"})(L=n.CommentMode||(n.CommentMode={}));var v;(function(_){_[_.Type=1]="Type",_[_.Parameter=2]="Parameter"})(v=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new c.TokenizationRegistry;var m;(function(_){_[_.None=0]="None",_[_.Option=1]="Option",_[_.Default=2]="Default",_[_.Preferred=3]="Preferred"})(m=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),Y(Z[52],J([0,1,21,8,27,12,3,2,30,51,40]),function(B,n,y,t,F,c,E,h,o,f,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class D{static chord(e,N){return(0,F.KeyChord)(e,N)}}n.KeyMod=D,D.CtrlCmd=2048,D.Shift=1024,D.Alt=512,D.WinCtrl=256;function p(){return{editor:void 0,languages:void 0,CancellationTokenSource:y.CancellationTokenSource,Emitter:t.Emitter,KeyCode:A.KeyCode,KeyMod:D,Position:E.Position,Range:h.Range,Selection:o.Selection,SelectionDirection:A.SelectionDirection,MarkerSeverity:A.MarkerSeverity,MarkerTag:A.MarkerTag,Uri:c.URI,Token:f.Token}}n.createMonacoBaseAPI=p}),Y(Z[57],J([0,1,22,5,12,3,2,47,18,36,37,52,20,49,23,46,10]),function(B,n,y,t,F,c,E,h,o,f,A,D,p,b,e,N,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class C extends h.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(s){return this._lines[s-1]}getWordAtPosition(s,l){const u=(0,o.getWordAtText)(s.column,(0,o.ensureValidWordDefinition)(l),this._lines[s.lineNumber-1],0);return u?new E.Range(s.lineNumber,u.startColumn,s.lineNumber,u.endColumn):null}getWordUntilPosition(s,l){const u=this.getWordAtPosition(s,l);return u?{word:this._lines[s.lineNumber-1].substring(u.startColumn-1,s.column-1),startColumn:u.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const l=this._lines,u=this._wordenize.bind(this);let g=0,d="",L=0,v=[];return{*[Symbol.iterator](){for(;;)if(L<v.length){const m=d.substring(v[L].start,v[L].end);L+=1,yield m}else if(g<l.length)d=l[g],v=u(d,s),L=0,g+=1;else break}}}getLineWords(s,l){const u=this._lines[s-1],g=this._wordenize(u,l),d=[];for(const L of g)d.push({word:u.substring(L.start,L.end),startColumn:L.start+1,endColumn:L.end+1});return d}_wordenize(s,l){const u=[];let g;for(l.lastIndex=0;(g=l.exec(s))&&g[0].length!==0;)u.push({start:g.index,end:g.index+g[0].length});return u}getValueInRange(s){if(s=this._validateRange(s),s.startLineNumber===s.endLineNumber)return this._lines[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const l=this._eol,u=s.startLineNumber-1,g=s.endLineNumber-1,d=[];d.push(this._lines[u].substring(s.startColumn-1));for(let L=u+1;L<g;L++)d.push(this._lines[L]);return d.push(this._lines[g].substring(0,s.endColumn-1)),d.join(l)}offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(s),u=this._lines[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,u)}}_validateRange(s){const l=this._validatePosition({lineNumber:s.startLineNumber,column:s.startColumn}),u=this._validatePosition({lineNumber:s.endLineNumber,column:s.endColumn});return l.lineNumber!==s.startLineNumber||l.column!==s.startColumn||u.lineNumber!==s.endLineNumber||u.column!==s.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:u.lineNumber,endColumn:u.column}:s}_validatePosition(s){if(!c.Position.isIPosition(s))throw new Error("bad position");let{lineNumber:l,column:u}=s,g=!1;if(l<1)l=1,u=1,g=!0;else if(l>this._lines.length)l=this._lines.length,u=this._lines[l-1].length+1,g=!0;else{const d=this._lines[l-1].length+1;u<1?(u=1,g=!0):u>d&&(u=d,g=!0)}return g?{lineNumber:l,column:u}:s}}n.MirrorModel=C;class w{constructor(s,l){this._host=s,this._models=Object.create(null),this._foreignModuleFactory=l,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(s){return this._models[s]}_getModels(){const s=[];return Object.keys(this._models).forEach(l=>s.push(this._models[l])),s}acceptNewModel(s){this._models[s.url]=new C(F.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,l){if(!this._models[s])return;this._models[s].onEvents(l)}acceptRemovedModel(s){!this._models[s]||delete this._models[s]}async computeUnicodeHighlights(s,l,u){const g=this._getModel(s);return g?b.UnicodeTextModelHighlighter.computeUnicodeHighlights(g,l,u):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(s,l,u){const g=this._getModel(s),d=this._getModel(l);return!g||!d?null:w.computeDiff(g,d,u)}static computeDiff(s,l,u){const g=u.diffAlgorithm==="experimental"?N.linesDiffComputers.experimental:N.linesDiffComputers.smart,d=s.getLinesContent(),L=l.getLinesContent(),v=g.computeDiff(d,L,u);return{identical:v.changes.length>0?!1:this._modelsAreIdentical(s,l),quitEarly:v.quitEarly,changes:v.changes.map(_=>[_.originalRange.startLineNumber,_.originalRange.endLineNumberExclusive,_.modifiedRange.startLineNumber,_.modifiedRange.endLineNumberExclusive,_.innerChanges?.map(M=>[M.originalRange.startLineNumber,M.originalRange.startColumn,M.originalRange.endLineNumber,M.originalRange.endColumn,M.modifiedRange.startLineNumber,M.modifiedRange.startColumn,M.modifiedRange.endLineNumber,M.modifiedRange.endColumn])])}}static _modelsAreIdentical(s,l){const u=s.getLineCount(),g=l.getLineCount();if(u!==g)return!1;for(let d=1;d<=u;d++){const L=s.getLineContent(d),v=l.getLineContent(d);if(L!==v)return!1}return!0}async computeDirtyDiff(s,l,u){const g=this._getModel(s),d=this._getModel(l);if(!g||!d)return null;const L=g.getLinesContent(),v=d.getLinesContent();return new e.DiffComputer(L,v,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(s,l){const u=this._getModel(s);if(!u)return l;const g=[];let d;l=l.slice(0).sort((L,v)=>{if(L.range&&v.range)return E.Range.compareRangesUsingStarts(L.range,v.range);const m=L.range?0:1,_=v.range?0:1;return m-_});for(let{range:L,text:v,eol:m}of l){if(typeof m=="number"&&(d=m),E.Range.isEmpty(L)&&!v)continue;const _=u.getValueInRange(L);if(v=v.replace(/\r\n|\n|\r/g,u.eol),_===v)continue;if(Math.max(v.length,_.length)>w._diffLimit){g.push({range:L,text:v});continue}const M=(0,y.stringDiff)(_,v,!1),T=u.offsetAt(E.Range.lift(L).getStartPosition());for(const O of M){const q=u.positionAt(T+O.originalStart),$=u.positionAt(T+O.originalStart+O.originalLength),z={text:v.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:q.lineNumber,startColumn:q.column,endLineNumber:$.lineNumber,endColumn:$.column}};u.getValueInRange(z.range)!==z.text&&g.push(z)}}return typeof d=="number"&&g.push({eol:d,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),g}async computeLinks(s){const l=this._getModel(s);return l?(0,f.computeLinks)(l):null}async textualSuggest(s,l,u,g){const d=new p.StopWatch(!0),L=new RegExp(u,g),v=new Set;e:for(const m of s){const _=this._getModel(m);if(!!_){for(const M of _.words(L))if(!(M===l||!isNaN(Number(M)))&&(v.add(M),v.size>w._suggestionsLimit))break e}}return{words:Array.from(v),duration:d.elapsed()}}async computeWordRanges(s,l,u,g){const d=this._getModel(s);if(!d)return Object.create(null);const L=new RegExp(u,g),v=Object.create(null);for(let m=l.startLineNumber;m<l.endLineNumber;m++){const _=d.getLineWords(m,L);for(const M of _){if(!isNaN(Number(M.word)))continue;let T=v[M.word];T||(T=[],v[M.word]=T),T.push({startLineNumber:m,startColumn:M.startColumn,endLineNumber:m,endColumn:M.endColumn})}}return v}async navigateValueSet(s,l,u,g,d){const L=this._getModel(s);if(!L)return null;const v=new RegExp(g,d);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const m=L.getValueInRange(l),_=L.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},v);if(!_)return null;const M=L.getValueInRange(_);return A.BasicInplaceReplace.INSTANCE.navigateValueSet(l,m,_,M,u)}loadForeignModule(s,l,u){const g=(v,m)=>this._host.fhr(v,m),L={host:(0,R.createProxyObject)(u,g),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(L,l),Promise.resolve((0,R.getAllMethodNames)(this._foreignModule))):new Promise((v,m)=>{B([s],_=>{this._foreignModule=_.create(L,l),v((0,R.getAllMethodNames)(this._foreignModule))},m)})}fmr(s,l){if(!this._foreignModule||typeof this._foreignModule[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this._foreignModule[s].apply(this._foreignModule,l))}catch(u){return Promise.reject(u)}}}n.EditorSimpleWorker=w,w._diffLimit=1e5,w._suggestionsLimit=1e4;function i(a){return new w(a,null)}n.create=i,typeof importScripts=="function"&&(t.globals.monaco=(0,D.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bd1b7a384f8a5ab9fb5a6a0e8fea370e589f43a3/core/vs/base/worker/workerMain.js.map
