/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/types","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/cancellation","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],D=0,r=Q.length;D<r;D++)e[D]=ne[Q[D]];return e};define(ne[51],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(P,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=D;class r{constructor(P,E,b){this.id=P,this.definition=E,this.description=b,r._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return r._allCodicons}}e.Codicon=r,r._allCodicons=[],r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",r.circleFilled.definition),r.closeDirty=new r("close-dirty",r.circleFilled.definition),r.debugBreakpoint=new r("debug-breakpoint",r.circleFilled.definition),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",r.circleFilled.definition),r.debugHint=new r("debug-hint",r.circleFilled.definition),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circle=new r("circle",{fontCharacter:"\\eabc"}),r.circleOutline=new r("circle-outline",r.circle.definition),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",r.circle.definition),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolCustomColor=new r("symbol-customcolor",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.circleSmallFilled=new r("circle-small-filled",{fontCharacter:"\\eb8a"}),r.debugStackframeDot=new r("debug-stackframe-dot",r.circleSmallFilled.definition),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLarge=new r("circle-large",{fontCharacter:"\\ebb5"}),r.circleLargeOutline=new r("circle-large-outline",r.circleLarge.definition),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.layout=new r("layout",{fontCharacter:"\\ebeb"}),r.layoutActivitybarLeft=new r("layout-activitybar-left",{fontCharacter:"\\ebec"}),r.layoutActivitybarRight=new r("layout-activitybar-right",{fontCharacter:"\\ebed"}),r.layoutPanelLeft=new r("layout-panel-left",{fontCharacter:"\\ebee"}),r.layoutPanelCenter=new r("layout-panel-center",{fontCharacter:"\\ebef"}),r.layoutPanelJustify=new r("layout-panel-justify",{fontCharacter:"\\ebf0"}),r.layoutPanelRight=new r("layout-panel-right",{fontCharacter:"\\ebf1"}),r.layoutPanel=new r("layout-panel",{fontCharacter:"\\ebf2"}),r.layoutSidebarLeft=new r("layout-sidebar-left",{fontCharacter:"\\ebf3"}),r.layoutSidebarRight=new r("layout-sidebar-right",{fontCharacter:"\\ebf4"}),r.layoutStatusbar=new r("layout-statusbar",{fontCharacter:"\\ebf5"}),r.layoutMenubar=new r("layout-menubar",{fontCharacter:"\\ebf6"}),r.layoutCentered=new r("layout-centered",{fontCharacter:"\\ebf7"}),r.layoutSidebarRightOff=new r("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),r.layoutPanelOff=new r("layout-panel-off",{fontCharacter:"\\ec01"}),r.layoutSidebarLeftOff=new r("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),r.target=new r("target",{fontCharacter:"\\ebf8"}),r.indent=new r("indent",{fontCharacter:"\\ebf9"}),r.recordSmall=new r("record-small",{fontCharacter:"\\ebfa"}),r.errorSmall=new r("error-small",{fontCharacter:"\\ebfb"}),r.arrowCircleDown=new r("arrow-circle-down",{fontCharacter:"\\ebfc"}),r.arrowCircleLeft=new r("arrow-circle-left",{fontCharacter:"\\ebfd"}),r.arrowCircleRight=new r("arrow-circle-right",{fontCharacter:"\\ebfe"}),r.arrowCircleUp=new r("arrow-circle-up",{fontCharacter:"\\ebff"}),r.heartFilled=new r("heart-filled",{fontCharacter:"\\ec04"}),r.map=new r("map",{fontCharacter:"\\ec05"}),r.mapFilled=new r("map-filled",{fontCharacter:"\\ec06"}),r.circleSmall=new r("circle-small",{fontCharacter:"\\ec07"}),r.bellSlash=new r("bell-slash",{fontCharacter:"\\ec08"}),r.bellSlashDot=new r("bell-slash-dot",{fontCharacter:"\\ec09"}),r.commentUnresolved=new r("comment-unresolved",{fontCharacter:"\\ec0a"}),r.gitPullRequestGoToChanges=new r("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),r.gitPullRequestNewChanges=new r("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),r.searchFuzzy=new r("search-fuzzy",{fontCharacter:"\\ec0d"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function k(T,P){const E=["codicon","codicon-"+T];return P&&E.push("codicon-modifier-"+P),E}e.getClassNamesArray=k;var L;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function E(C){if(C instanceof r)return["codicon","codicon-"+C.id];const p=P.exec(C.id);if(!p)return E(r.error);const[,v,h]=p,y=["codicon","codicon-"+v];return h&&y.push("codicon-modifier-"+h.substr(1)),y}T.asClassNameArray=E;function b(C){return E(C).join(" ")}T.asClassName=b;function I(C){return"."+E(C).join(".")}T.asCSSSelector=I})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[63],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(T){return(P,E,b)=>{let I=null,C=null;if(typeof b.value=="function"?(I="value",C=b.value):typeof b.get=="function"&&(I="get",C=b.get),!C)throw new Error("not supported");b[I]=T(C,E)}}e.createDecorator=D;function r(T,P,E){let b=null,I=null;if(typeof E.value=="function"?(b="value",I=E.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",I=E.get),!I)throw new Error("not supported");const C=`$memoize$${P}`;E[b]=function(...p){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,p)}),this[C]}}e.memoize=r;function k(T,P,E){return D((b,I)=>{const C=`$debounce$${I}`,p=`$debounce$result$${I}`;return function(...v){this[p]||(this[p]=E?E():void 0),clearTimeout(this[C]),P&&(this[p]=P(this[p],...v),v=[this[p]]),this[C]=setTimeout(()=>{b.apply(this,v),this[p]=E?E():void 0},T)}})}e.debounce=k;function L(T,P,E){return D((b,I)=>{const C=`$throttle$timer$${I}`,p=`$throttle$result$${I}`,v=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...y){if(this[p]||(this[p]=E?E():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...y)),this[h])return;const w=this[v]+T;w<=Date.now()?(this[v]=Date.now(),b.apply(this,[this[p]]),this[p]=E?E():void 0):(this[h]=!0,this[C]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),b.apply(this,[this[p]]),this[p]=E?E():void 0},w-Date.now()))}})}e.throttle=L}),define(ne[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?c.isErrorNoTelemetry(n)?new c(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=D,e.errorHandler=new D;function r(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=r;function k(l){E(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=k;function L(l){E(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=L;function T(l){if(l instanceof Error){const{name:n,message:o}=l,t=l.stacktrace||l.stack;return{$isError:!0,name:n,message:o,stack:t,noTelemetry:c.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=T;const P="Canceled";function E(l){return l instanceof b?!0:l instanceof Error&&l.name===P&&l.message===P}e.isCancellationError=E;class b extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=b;function I(){const l=new Error(P);return l.name=l.message,l}e.canceled=I;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function p(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=p;function v(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(l){const n=new Error(`${l} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function y(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=y;class w extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=w;class d extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=d;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class c extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof c)return n;const o=new c;return o.message=n.message,o.stack=n.stack,o}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class g extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(ne[18],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(Z,ie=0){return Z[Z.length-(1+ie)]}e.tail=r;function k(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=k;function L(Z,ie,se=(ue,de)=>ue===de){if(Z===ie)return!0;if(!Z||!ie||Z.length!==ie.length)return!1;for(let ue=0,de=Z.length;ue<de;ue++)if(!se(Z[ue],ie[ue]))return!1;return!0}e.equals=L;function T(Z,ie){const se=Z.length-1;ie<se&&(Z[ie]=Z[se]),Z.pop()}e.removeFastWithoutKeepingOrder=T;function P(Z,ie,se){return E(Z.length,ue=>se(Z[ue],ie))}e.binarySearch=P;function E(Z,ie){let se=0,ue=Z-1;for(;se<=ue;){const de=(se+ue)/2|0,ve=ie(de);if(ve<0)se=de+1;else if(ve>0)ue=de-1;else return de}return-(se+1)}e.binarySearch2=E;function b(Z,ie){let se=0,ue=Z.length;if(ue===0)return 0;for(;se<ue;){const de=Math.floor((se+ue)/2);ie(Z[de])?ue=de:se=de+1}return se}e.findFirstInSorted=b;function I(Z,ie,se){if(Z=Z|0,Z>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],de=[],ve=[],we=[];for(const Ee of ie){const Ce=se(Ee,ue);Ce<0?de.push(Ee):Ce>0?ve.push(Ee):we.push(Ee)}return Z<de.length?I(Z,de,se):Z<de.length+we.length?we[0]:I(Z-(de.length+we.length),ve,se)}e.quickSelect=I;function C(Z,ie){const se=[];let ue;for(const de of Z.slice(0).sort(ie))!ue||ie(ue[0],de)!==0?(ue=[de],se.push(ue)):ue.push(de);return se}e.groupBy=C;function p(Z,ie,se){const ue=[];function de(Ee,Ce,Ue){if(Ce===0&&Ue.length===0)return;const $e=ue[ue.length-1];$e&&$e.start+$e.deleteCount===Ee?($e.deleteCount+=Ce,$e.toInsert.push(...Ue)):ue.push({start:Ee,deleteCount:Ce,toInsert:Ue})}let ve=0,we=0;for(;;){if(ve===Z.length){de(ve,0,ie.slice(we));break}if(we===ie.length){de(ve,Z.length-ve,[]);break}const Ee=Z[ve],Ce=ie[we],Ue=se(Ee,Ce);Ue===0?(ve+=1,we+=1):Ue<0?(de(ve,1,[]),ve+=1):Ue>0&&(de(ve,0,[Ce]),we+=1)}return ue}e.sortedDiff=p;function v(Z,ie,se){const ue=p(Z,ie,se),de=[],ve=[];for(const we of ue)de.push(...Z.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:de,added:ve}}e.delta=v;function h(Z,ie,se){if(se===0)return[];const ue=Z.slice(0,se).sort(ie);return w(Z,ie,ue,se,Z.length),ue}e.top=h;function y(Z,ie,se,ue,de){return se===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=Z.length,Ce=Z.slice(0,se).sort(ie);for(let Ue=se,$e=Math.min(se+ue,Ee);Ue<Ee;Ue=$e,$e=Math.min($e+ue,Ee)){if(Ue>se&&await new Promise(He=>setTimeout(He)),de&&de.isCancellationRequested)throw new D.CancellationError;w(Z,ie,Ce,Ue,$e)}return Ce})().then(ve,we)})}e.topAsync=y;function w(Z,ie,se,ue,de){for(const ve=se.length;ue<de;ue++){const we=Z[ue];if(ie(we,se[ve-1])<0){se.pop();const Ee=b(se,Ce=>ie(we,Ce)<0);se.splice(Ee,0,we)}}}function d(Z){return Z.filter(ie=>!!ie)}e.coalesce=d;function f(Z){let ie=0;for(let se=0;se<Z.length;se++)Z[se]&&(Z[ie]=Z[se],ie+=1);Z.length=ie}e.coalesceInPlace=f;function c(Z,ie,se){Z.splice(se,0,Z.splice(ie,1)[0])}e.move=c;function g(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=g;function l(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=l;function n(Z,ie=se=>se){const se=new Set;return Z.filter(ue=>{const de=ie(ue);return se.has(de)?!1:(se.add(de),!0)})}e.distinct=n;function o(Z){const ie=new Set;return se=>{const ue=Z(se);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=o;function t(Z,ie){const se=i(Z,ie);if(se!==-1)return Z[se]}e.findLast=t;function i(Z,ie){for(let se=Z.length-1;se>=0;se--){const ue=Z[se];if(ie(ue))return se}return-1}e.lastIndex=i;function s(Z,ie){return Z.length>0?Z[0]:ie}e.firstOrDefault=s;function u(Z,ie){return Z.length>0?Z[Z.length-1]:ie}e.lastOrDefault=u;function a(Z,ie,se=(ue,de)=>ue===de){let ue=0;for(let de=0,ve=Math.min(Z.length,ie.length);de<ve&&se(Z[de],ie[de]);de++)ue++;return ue}e.commonPrefixLength=a;function m(Z){return[].concat(...Z)}e.flatten=m;function S(Z,ie){let se=typeof ie=="number"?Z:0;typeof ie=="number"?se=Z:(se=0,ie=Z);const ue=[];if(se<=ie)for(let de=se;de<ie;de++)ue.push(de);else for(let de=se;de>ie;de--)ue.push(de);return ue}e.range=S;function _(Z,ie,se){return Z.reduce((ue,de)=>(ue[ie(de)]=se?se(de):de,ue),Object.create(null))}e.index=_;function $(Z,ie){return Z.push(ie),()=>A(Z,ie)}e.insert=$;function A(Z,ie){const se=Z.indexOf(ie);if(se>-1)return Z.splice(se,1),ie}e.remove=A;function U(Z,ie,se){const ue=Z.slice(0,ie),de=Z.slice(ie);return ue.concat(se,de)}e.arrayInsert=U;function R(Z,ie){let se;if(typeof ie=="number"){let ue=ie;se=()=>{const de=Math.sin(ue++)*179426549;return de-Math.floor(de)}}else se=Math.random;for(let ue=Z.length-1;ue>0;ue-=1){const de=Math.floor(se()*(ue+1)),ve=Z[ue];Z[ue]=Z[de],Z[de]=ve}}e.shuffle=R;function N(Z,ie){const se=Z.indexOf(ie);se>-1&&(Z.splice(se,1),Z.unshift(ie))}e.pushToStart=N;function F(Z,ie){const se=Z.indexOf(ie);se>-1&&(Z.splice(se,1),Z.push(ie))}e.pushToEnd=F;function q(Z,ie){for(const se of ie)Z.push(se)}e.pushMany=q;function J(Z,ie){return Array.isArray(Z)?Z.map(ie):ie(Z)}e.mapArrayOrNot=J;function j(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=j;function H(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=H;function W(Z,ie){for(const se of Z){const ue=ie(se);if(ue!==void 0)return ue}}e.mapFind=W;function z(Z,ie,se){const ue=X(Z,ie),de=Z.length,ve=se.length;Z.length=de+ve;for(let we=de-1;we>=ue;we--)Z[we+ve]=Z[we];for(let we=0;we<ve;we++)Z[we+ue]=se[we]}e.insertInto=z;function K(Z,ie,se,ue){const de=X(Z,ie),ve=Z.splice(de,se);return z(Z,de,ue),ve}e.splice=K;function X(Z,ie){return ie<0?Math.max(ie+Z.length,0):Math.min(ie,Z.length)}var ce;(function(Z){function ie(de){return de<0}Z.isLessThan=ie;function se(de){return de>0}Z.isGreaterThan=se;function ue(de){return de===0}Z.isNeitherLessOrGreaterThan=ue,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function B(Z,ie){return(se,ue)=>ie(Z(se),Z(ue))}e.compareBy=B;function G(...Z){return(ie,se)=>{for(const ue of Z){const de=ue(ie,se);if(!ce.isNeitherLessOrGreaterThan(de))return de}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=G;const O=(Z,ie)=>Z-ie;e.numberComparator=O;function M(Z,ie){if(Z.length===0)return;let se=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ie(de,se)>0&&(se=de)}return se}e.findMaxBy=M;function x(Z,ie){if(Z.length===0)return;let se=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ie(de,se)>=0&&(se=de)}return se}e.findLastMaxBy=x;function V(Z,ie){return M(Z,(se,ue)=>-ie(se,ue))}e.findMinBy=V;class ee{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let se=this.firstIdx;for(;se<this.items.length&&ie(this.items[se]);)se++;const ue=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ue}takeFromEndWhile(ie){let se=this.lastIdx;for(;se>=0&&ie(this.items[se]);)se--;const ue=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const se=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,se}}e.ArrayQueue=ee;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(se=>(ie(se),!0))}toArray(){const ie=[];return this.iterate(se=>(ie.push(se),!0)),ie}filter(ie){return new oe(se=>this.iterate(ue=>ie(ue)?se(ue):!0))}map(ie){return new oe(se=>this.iterate(ue=>se(ie(ue))))}some(ie){let se=!1;return this.iterate(ue=>(se=ie(ue),!se)),se}findFirst(ie){let se;return this.iterate(ue=>ie(ue)?(se=ue,!1):!0),se}findLast(ie){let se;return this.iterate(ue=>(ie(ue)&&(se=ue),!0)),se}findLastMaxBy(ie){let se,ue=!0;return this.iterate(de=>((ue||ce.isGreaterThan(ie(de,se)))&&(ue=!1,se=de),!0)),se}}e.CallbackIterable=oe,oe.empty=new oe(Z=>{})}),define(ne[116],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function r(E,b){if(!E)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=r;function k(E,b="Unreachable"){throw new Error(b)}e.assertNever=k;function L(E){if(!E)throw new D.BugIndicatingError("Assertion Failed")}e.assert=L;function T(E){if(!E()){debugger;E(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function P(E,b){let I=0;for(;I<E.length-1;){const C=E[I],p=E[I+1];if(!b(C,p))return!1;I++}return!0}e.checkAdjacentItems=P}),define(ne[79],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(r){const k=this;let L=!1,T;return function(){return L||(L=!0,T=r.apply(k,arguments)),T}}e.once=D}),define(ne[52],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(r){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}r.is=k;const L=Object.freeze([]);function T(){return L}r.empty=T;function*P(o){yield o}r.single=P;function E(o){return o||L}r.from=E;function b(o){return!o||o[Symbol.iterator]().next().done===!0}r.isEmpty=b;function I(o){return o[Symbol.iterator]().next().value}r.first=I;function C(o,t){for(const i of o)if(t(i))return!0;return!1}r.some=C;function p(o,t){for(const i of o)if(t(i))return i}r.find=p;function*v(o,t){for(const i of o)t(i)&&(yield i)}r.filter=v;function*h(o,t){let i=0;for(const s of o)yield t(s,i++)}r.map=h;function*y(...o){for(const t of o)for(const i of t)yield i}r.concat=y;function*w(o){for(const t of o)for(const i of t)yield i}r.concatNested=w;function d(o,t,i){let s=i;for(const u of o)s=t(s,u);return s}r.reduce=d;function f(o,t){let i=0;for(const s of o)t(s,i++)}r.forEach=f;function*c(o,t,i=o.length){for(t<0&&(t+=o.length),i<0?i+=o.length:i>o.length&&(i=o.length);t<i;t++)yield o[t]}r.slice=c;function g(o,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,o];const s=o[Symbol.iterator]();for(let u=0;u<t;u++){const a=s.next();if(a.done)return[i,r.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return s}}]}r.consume=g;function l(o){return g(o)[0]}r.collect=l;function n(o,t,i=(s,u)=>s===u){const s=o[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const a=s.next(),m=u.next();if(a.done!==m.done)return!1;if(a.done)return!0;if(!i(a.value,m.value))return!1}}r.equals=n})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var r;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(r=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function T(n,o=!1){let t=0;const i=n.length;let s="",u=0,a=16,m=0;function S(F){let q=0,J=0;for(;q<F;){const j=n.charCodeAt(t);if(j>=48&&j<=57)J=J*16+j-48;else if(j>=65&&j<=70)J=J*16+j-65+10;else if(j>=97&&j<=102)J=J*16+j-97+10;else break;t++,q++}return q<F&&(J=-1),J}function _(F){t=F,s="",u=0,a=16,m=0}function $(){const F=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&b(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&b(n.charCodeAt(t)))for(t++;t<n.length&&b(n.charCodeAt(t));)t++;else return m=3,n.substring(F,t);let q=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&b(n.charCodeAt(t))){for(t++;t<n.length&&b(n.charCodeAt(t));)t++;q=t}else m=3;return n.substring(F,q)}function A(){let F="",q=t;for(;;){if(t>=i){F+=n.substring(q,t),m=2;break}const J=n.charCodeAt(t);if(J===34){F+=n.substring(q,t),t++;break}if(J===92){if(F+=n.substring(q,t),t++,t>=i){m=2;break}switch(n.charCodeAt(t++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const H=S(4);H>=0?F+=String.fromCharCode(H):m=4;break}default:m=5}q=t;continue}if(J>=0&&J<=31)if(E(J)){F+=n.substring(q,t),m=2;break}else m=6;t++}return F}function U(){if(s="",m=0,u=t,t>=i)return u=i,a=17;let F=n.charCodeAt(t);if(P(F)){do t++,s+=String.fromCharCode(F),F=n.charCodeAt(t);while(P(F));return a=15}if(E(F))return t++,s+=String.fromCharCode(F),F===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),a=14;switch(F){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,s=A(),a=10;case 47:{const q=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!E(n.charCodeAt(t));)t++;return s=n.substring(q,t),a=12}if(n.charCodeAt(t+1)===42){t+=2;const J=i-1;let j=!1;for(;t<J;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,j=!0;break}t++}return j||(t++,m=1),s=n.substring(q,t),a=13}return s+=String.fromCharCode(F),t++,a=16}case 45:if(s+=String.fromCharCode(F),t++,t===i||!b(n.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=$(),a=11;default:for(;t<i&&R(F);)t++,F=n.charCodeAt(t);if(u!==t){switch(s=n.substring(u,t),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(F),t++,a=16}}function R(F){if(P(F)||E(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let F;do F=U();while(F>=12&&F<=15);return F}return{setPosition:_,getPosition:()=>t,scan:o?N:U,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>m}}e.createScanner=T;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function E(n){return n===10||n===13||n===8232||n===8233}function b(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function C(n,o){const t=[],i=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function m(S,_,$,A){u.value=S,u.offset=_,u.length=$,u.type=A,u.colonOffset=void 0,s=u}try{c(n,{onObjectBegin:(S,_)=>{if(o<=S)throw i;s=void 0,a=o>S,t.push("")},onObjectProperty:(S,_,$)=>{if(o<_||(m(S,_,$,"property"),t[t.length-1]=S,o<=_+$))throw i},onObjectEnd:(S,_)=>{if(o<=S)throw i;s=void 0,t.pop()},onArrayBegin:(S,_)=>{if(o<=S)throw i;s=void 0,t.push(0)},onArrayEnd:(S,_)=>{if(o<=S)throw i;s=void 0,t.pop()},onLiteralValue:(S,_,$)=>{if(o<_||(m(S,_,$,l(S)),o<=_+$))throw i},onSeparator:(S,_,$)=>{if(o<=_)throw i;if(S===":"&&s&&s.type==="property")s.colonOffset=_,a=!1,s=void 0;else if(S===","){const A=t[t.length-1];typeof A=="number"?t[t.length-1]=A+1:(a=!0,t[t.length-1]=""),s=void 0}}})}catch(S){if(S!==i)throw S}return{path:t,previousNode:s,isAtPropertyKey:a,matches:S=>{let _=0;for(let $=0;_<S.length&&$<t.length;$++)if(S[_]===t[$]||S[_]==="*")_++;else if(S[_]!=="**")return!1;return _===S.length}}}e.getLocation=C;function p(n,o=[],t=L.DEFAULT){let i=null,s=[];const u=[];function a(S){Array.isArray(s)?s.push(S):i!==null&&(s[i]=S)}return c(n,{onObjectBegin:()=>{const S={};a(S),u.push(s),s=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const S=[];a(S),u.push(s),s=S,i=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:a,onError:(S,_,$)=>{o.push({error:S,offset:_,length:$})}},t),s[0]}e.parse=p;function v(n,o=[],t=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(S){i.type==="property"&&(i.length=S-i.offset,i=i.parent)}function u(S){return i.children.push(S),S}c(n,{onObjectBegin:S=>{i=u({type:"object",offset:S,length:-1,parent:i,children:[]})},onObjectProperty:(S,_,$)=>{i=u({type:"property",offset:_,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:S,offset:_,length:$,parent:i})},onObjectEnd:(S,_)=>{i.length=S+_-i.offset,i=i.parent,s(S+_)},onArrayBegin:(S,_)=>{i=u({type:"array",offset:S,length:-1,parent:i,children:[]})},onArrayEnd:(S,_)=>{i.length=S+_-i.offset,i=i.parent,s(S+_)},onLiteralValue:(S,_,$)=>{u({type:l(S),offset:_,length:$,parent:i,value:S}),s(_+$)},onSeparator:(S,_,$)=>{i.type==="property"&&(S===":"?i.colonOffset=_:S===","&&s(_))},onError:(S,_,$)=>{o.push({error:S,offset:_,length:$})}},t);const m=i.children[0];return m&&delete m.parent,m}e.parseTree=v;function h(n,o){if(!n)return;let t=n;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===i){t=u.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=h;function y(n){if(!n.parent||!n.parent.children)return[];const o=y(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;o.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&o.push(t)}return o}e.getNodePath=y;function w(n){switch(n.type){case"array":return n.children.map(w);case"object":{const o=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(o[t.children[0].value]=w(i))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=w;function d(n,o,t=!1){return o>=n.offset&&o<n.offset+n.length||t&&o===n.offset+n.length}e.contains=d;function f(n,o,t=!1){if(d(n,o,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const u=f(i[s],o,t);if(u)return u}return n}}e.findNodeAtOffset=f;function c(n,o,t=L.DEFAULT){const i=T(n,!1);function s(B){return B?()=>B(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(B){return B?G=>B(G,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=s(o.onObjectBegin),m=u(o.onObjectProperty),S=s(o.onObjectEnd),_=s(o.onArrayBegin),$=s(o.onArrayEnd),A=u(o.onLiteralValue),U=u(o.onSeparator),R=s(o.onComment),N=u(o.onError),F=t&&t.disallowComments,q=t&&t.allowTrailingComma;function J(){for(;;){const B=i.scan();switch(i.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:F||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(B){case 12:case 13:F?j(10):R();break;case 16:j(1);break;case 15:case 14:break;default:return B}}}function j(B,G=[],O=[]){if(N(B),G.length+O.length>0){let M=i.getToken();for(;M!==17;){if(G.indexOf(M)!==-1){J();break}else if(O.indexOf(M)!==-1)break;M=J()}}}function H(B){const G=i.getTokenValue();return B?A(G):m(G),J(),!0}function W(){switch(i.getToken()){case 11:{let B=0;try{B=JSON.parse(i.getTokenValue()),typeof B!="number"&&(j(2),B=0)}catch{j(2)}A(B);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return J(),!0}function z(){return i.getToken()!==10?(j(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(U(":"),J(),ce()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function K(){a(),J();let B=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(B||j(4,[],[]),U(","),J(),i.getToken()===2&&q)break}else B&&j(6,[],[]);z()||j(4,[],[2,5]),B=!0}return S(),i.getToken()!==2?j(7,[2],[]):J(),!0}function X(){_(),J();let B=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(B||j(4,[],[]),U(","),J(),i.getToken()===4&&q)break}else B&&j(6,[],[]);ce()||j(4,[],[4,5]),B=!0}return $(),i.getToken()!==4?j(8,[4],[]):J(),!0}function ce(){switch(i.getToken()){case 3:return X();case 1:return K();case 10:return H(!0);default:return W()}}return J(),i.getToken()===17?t.allowEmptyContent?!0:(j(4,[],[]),!1):ce()?(i.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=c;function g(n,o){const t=T(n),i=[];let s,u=0,a;do switch(a=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:u!==a&&i.push(n.substring(u,a)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),u=t.getPosition();break}while(s!==17);return i.join("")}e.stripComments=g;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[46],re([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function r(b,I,C){let p,v,h,y,w;if(I){for(y=I.offset,w=y+I.length,h=y;h>0&&!E(b,h-1);)h--;let a=w;for(;a<b.length&&!E(b,a);)a++;v=b.substring(h,a),p=T(v,C)}else v=b,p=0,h=0,y=0,w=b.length;const d=P(C,b);let f=!1,c=0,g;C.insertSpaces?g=L(" ",C.tabSize||4):g="	";const l=(0,D.createScanner)(v,!1);let n=!1;function o(){return d+L(g,p+c)}function t(){let a=l.scan();for(f=!1;a===15||a===14;)f=f||a===14,a=l.scan();return n=a===16||l.getTokenError()!==0,a}const i=[];function s(a,m,S){!n&&m<w&&S>y&&b.substring(m,S)!==a&&i.push({offset:m,length:S-m,content:a})}let u=t();if(u!==17){const a=l.getTokenOffset()+h,m=L(g,p);s(m,h,a)}for(;u!==17;){let a=l.getTokenOffset()+l.getTokenLength()+h,m=t(),S="";for(;!f&&(m===12||m===13);){const $=l.getTokenOffset()+h;s(" ",a,$),a=l.getTokenOffset()+l.getTokenLength()+h,S=m===12?o():"",m=t()}if(m===2)u!==1&&(c--,S=o());else if(m===4)u!==3&&(c--,S=o());else{switch(u){case 3:case 1:c++,S=o();break;case 5:case 12:S=o();break;case 13:f?S=o():S=" ";break;case 6:S=" ";break;case 10:if(m===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?S=" ":m!==5&&m!==17&&(n=!0);break;case 16:n=!0;break}f&&(m===12||m===13)&&(S=o())}const _=l.getTokenOffset()+h;s(S,a,_),u=m}return i}e.format=r;function k(b,I){const C=JSON.stringify(b,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?C.replace(/\r\n|\r|\n/g,I.eol):C}e.toFormattedString=k;function L(b,I){let C="";for(let p=0;p<I;p++)C+=b;return C}function T(b,I){let C=0,p=0;const v=I.tabSize||4;for(;C<b.length;){const h=b.charAt(C);if(h===" ")p++;else if(h==="	")p+=v;else break;C++}return Math.floor(p/v)}function P(b,I){for(let C=0;C<I.length;C++){const p=I.charAt(C);if(p==="\r")return C+1<I.length&&I.charAt(C+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=P;function E(b,I){return`\r
`.indexOf(b.charAt(I))!==-1}e.isEOL=E}),define(ne[80],re([0,1,35,46]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(b,I,C){return L(b,I,void 0,C)}e.removeProperty=k;function L(b,I,C,p,v){const h=I.slice(),y=[],w=(0,D.parseTree)(b,y);let d,f;for(;h.length>0&&(f=h.pop(),d=(0,D.findNodeAtLocation)(w,h),d===void 0&&C!==void 0);)typeof f=="string"?C={[f]:C}:C=[C];if(d)if(d.type==="object"&&typeof f=="string"&&Array.isArray(d.children)){const c=(0,D.findNodeAtLocation)(d,[f]);if(c!==void 0)if(C===void 0){if(!c.parent)throw new Error("Malformed AST");const g=d.children.indexOf(c.parent);let l,n=c.parent.offset+c.parent.length;if(g>0){const o=d.children[g-1];l=o.offset+o.length}else l=d.offset+1,d.children.length>1&&(n=d.children[1].offset);return T(b,{offset:l,length:n-l,content:""},p)}else return T(b,{offset:c.offset,length:c.length,content:JSON.stringify(C)},p);else{if(C===void 0)return[];const g=`${JSON.stringify(f)}: ${JSON.stringify(C)}`,l=v?v(d.children.map(o=>o.children[0].value)):d.children.length;let n;if(l>0){const o=d.children[l-1];n={offset:o.offset+o.length,length:0,content:","+g}}else d.children.length===0?n={offset:d.offset+1,length:0,content:g}:n={offset:d.offset+1,length:0,content:g+","};return T(b,n,p)}}else if(d.type==="array"&&typeof f=="number"&&Array.isArray(d.children))if(C!==void 0){const c=`${JSON.stringify(C)}`;let g;if(d.children.length===0||f===0)g={offset:d.offset+1,length:0,content:d.children.length===0?c:c+","};else{const l=f===-1||f>d.children.length?d.children.length:f,n=d.children[l-1];g={offset:n.offset+n.length,length:0,content:","+c}}return T(b,g,p)}else{const c=f,g=d.children[c];let l;if(d.children.length===1)l={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===c){const n=d.children[c-1],o=n.offset+n.length,t=d.offset+d.length;l={offset:o,length:t-2-o,content:""}}else l={offset:g.offset,length:d.children[c+1].offset-g.offset,content:""};return T(b,l,p)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${d.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return T(b,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(C)},p)}}e.setProperty=L;function T(b,I,C){let p=P(b,I),v=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;v>0&&!(0,r.isEOL)(p,v-1);)v--;for(;h<p.length&&!(0,r.isEOL)(p,h);)h++}const y=(0,r.format)(p,{offset:v,length:h-v},C);for(let d=y.length-1;d>=0;d--){const f=y[d];p=P(p,f),v=Math.min(v,f.offset),h=Math.max(h,f.offset+f.length),h+=f.content.length-f.length}const w=b.length-(p.length-h)-v;return[{offset:v,length:w,content:p.substring(v,h)}]}e.withFormatting=T;function P(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}e.applyEdit=P;function E(b,I){const C=I.slice(0).sort((v,h)=>{const y=v.offset-h.offset;return y===0?v.length-h.length:y});let p=b.length;for(let v=C.length-1;v>=0;v--){const h=C[v];if(h.offset+h.length<=p)b=P(b,h);else throw new Error("Overlapping edit");p=h.offset}return b}e.applyEdits=E}),define(ne[117],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new D(()=>k(this.getValue()))}}e.Lazy=D}),define(ne[2],re([0,1,79,52]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let L=null;function T(u){L=u}if(e.setDisposableTracker=T,k){const u="__is_disposable_tracked__";T(new class{trackDisposable(a){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[u]||console.log(m)},3e3)}setParent(a,m){if(a&&a!==f.None)try{a[u]=!0}catch{}}markAsDisposed(a){if(a&&a!==f.None)try{a[u]=!0}catch{}}markAsSingleton(a){}})}function P(u){return L?.trackDisposable(u),u}function E(u){L?.markAsDisposed(u)}function b(u,a){L?.setParent(u,a)}function I(u,a){if(!!L)for(const m of u)L.setParent(m,a)}function C(u){return L?.markAsSingleton(u),u}e.markAsSingleton=C;function p(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=p;function v(u){if(r.Iterable.is(u)){const a=[];for(const m of u)if(m)try{m.dispose()}catch(S){a.push(S)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=v;function h(u){for(const a of u)p(a)&&a.dispose();return[]}e.disposeIfDisposable=h;function y(...u){const a=w(()=>v(u));return I(u,a),a}e.combinedDisposable=y;function w(u){const a=P({dispose:(0,D.once)(()=>{E(a),u()})});return a}e.toDisposable=w;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{v(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return b(a,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new d,P(this),b(this._store,this)}dispose(){E(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&b(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&b(a,null),a}}e.MutableDisposable=c;class g{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let m=a;return this.unset=()=>m=void 0,this.isset=()=>m!==void 0,this.dispose=()=>{m&&(m(),m=void 0,E(this))},this}}e.SafeDisposable=l;class n{constructor(){this.references=new Map}acquire(a,...m){let S=this.references.get(a);S||(S={counter:0,object:this.createReferencedObject(a,...m)},this.references.set(a,S));const{object:_}=S,$=(0,D.once)(()=>{--S.counter===0&&(this.destroyReferencedObject(a,S.object),this.references.delete(a))});return S.counter++,{object:_,dispose:$}}}e.ReferenceCollection=n;class o{constructor(a){this.referenceCollection=a}async acquire(a,...m){const S=this.referenceCollection.acquire(a,...m);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(_){throw S.dispose(),_}}}e.AsyncReferenceCollection=o;class t{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=t;function i(u){const a=new d;try{u(a)}finally{a.dispose()}}e.disposeOnReturn=i;class s{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){E(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{v(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,m,S=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),S||this._store.get(a)?.dispose(),this._store.set(a,m)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(ne[81],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class r{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const T=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,T){const P=new D(L);if(this._first===D.Undefined)this._first=P,this._last=P;else if(T){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const T=L.prev;T.next=L.next,L.next.prev=T}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=r}),function(){function Q(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function T(E){L.push(E,Date.now())}function P(){const E=[];for(let b=0;b<L.length;b+=2)E.push({name:L[b],startTime:L[b+1]});return E}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(k+T.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=D(r))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var r in D)(typeof exports=="object"?exports:Q)[r]=D[r]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(r){if(e[r])return e[r].exports;var k=e[r]={i:r,l:!1,exports:{}};return Q[r].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=Q,D.c=e,D.d=function(r,k,L){D.o(r,k)||Object.defineProperty(r,k,{enumerable:!0,get:L})},D.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},D.t=function(r,k){if(1&k&&(r=D(r)),8&k||4&k&&typeof r=="object"&&r&&r.__esModule)return r;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:r}),2&k&&typeof r!="string")for(var T in r)D.d(L,T,function(P){return r[P]}.bind(null,T));return L},D.n=function(r){var k=r&&r.__esModule?function(){return r.default}:function(){return r};return D.d(k,"a",k),k},D.o=function(r,k){return Object.prototype.hasOwnProperty.call(r,k)},D.p="",D(D.s=0)}([function(Q,e,D){(function(r){var k;e=Q.exports=O,k=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],E=e.src=[],b=0,I=b++;E[I]="0|[1-9]\\d*";var C=b++;E[C]="[0-9]+";var p=b++;E[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=b++;E[v]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var h=b++;E[h]="("+E[C]+")\\.("+E[C]+")\\.("+E[C]+")";var y=b++;E[y]="(?:"+E[I]+"|"+E[p]+")";var w=b++;E[w]="(?:"+E[C]+"|"+E[p]+")";var d=b++;E[d]="(?:-("+E[y]+"(?:\\."+E[y]+")*))";var f=b++;E[f]="(?:-?("+E[w]+"(?:\\."+E[w]+")*))";var c=b++;E[c]="[0-9A-Za-z-]+";var g=b++;E[g]="(?:\\+("+E[c]+"(?:\\."+E[c]+")*))";var l=b++,n="v?"+E[v]+E[d]+"?"+E[g]+"?";E[l]="^"+n+"$";var o="[v=\\s]*"+E[h]+E[f]+"?"+E[g]+"?",t=b++;E[t]="^"+o+"$";var i=b++;E[i]="((?:<|>)?=?)";var s=b++;E[s]=E[C]+"|x|X|\\*";var u=b++;E[u]=E[I]+"|x|X|\\*";var a=b++;E[a]="[v=\\s]*("+E[u]+")(?:\\.("+E[u]+")(?:\\.("+E[u]+")(?:"+E[d]+")?"+E[g]+"?)?)?";var m=b++;E[m]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[f]+")?"+E[g]+"?)?)?";var S=b++;E[S]="^"+E[i]+"\\s*"+E[a]+"$";var _=b++;E[_]="^"+E[i]+"\\s*"+E[m]+"$";var $=b++;E[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=b++;E[A]="(?:~>?)";var U=b++;E[U]="(\\s*)"+E[A]+"\\s+",P[U]=new RegExp(E[U],"g");var R=b++;E[R]="^"+E[A]+E[a]+"$";var N=b++;E[N]="^"+E[A]+E[m]+"$";var F=b++;E[F]="(?:\\^)";var q=b++;E[q]="(\\s*)"+E[F]+"\\s+",P[q]=new RegExp(E[q],"g");var J=b++;E[J]="^"+E[F]+E[a]+"$";var j=b++;E[j]="^"+E[F]+E[m]+"$";var H=b++;E[H]="^"+E[i]+"\\s*("+o+")$|^$";var W=b++;E[W]="^"+E[i]+"\\s*("+n+")$|^$";var z=b++;E[z]="(\\s*)"+E[i]+"\\s*("+o+"|"+E[a]+")",P[z]=new RegExp(E[z],"g");var K=b++;E[K]="^\\s*("+E[a]+")\\s+-\\s+("+E[a]+")\\s*$";var X=b++;E[X]="^\\s*("+E[m]+")\\s+-\\s+("+E[m]+")\\s*$";var ce=b++;E[ce]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,E[B]),P[B]||(P[B]=new RegExp(E[B]));function G(ae,fe){if(ae instanceof O)return ae;if(typeof ae!="string"||ae.length>L||!(fe?P[t]:P[l]).test(ae))return null;try{return new O(ae,fe)}catch{return null}}function O(ae,fe){if(ae instanceof O){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof O))return new O(ae,fe);k("SemVer",ae,fe),this.loose=fe;var ge=ae.trim().match(fe?P[t]:P[l]);if(!ge)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<T)return Ie}return be}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=G,e.valid=function(ae,fe){var ge=G(ae,fe);return ge?ge.version:null},e.clean=function(ae,fe){var ge=G(ae.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ae){return k("SemVer.compare",this.version,this.loose,ae),ae instanceof O||(ae=new O(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},O.prototype.compareMain=function(ae){return ae instanceof O||(ae=new O(ae,this.loose)),x(this.major,ae.major)||x(this.minor,ae.minor)||x(this.patch,ae.patch)},O.prototype.comparePre=function(ae){if(ae instanceof O||(ae=new O(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],be=ae.prerelease[fe];if(k("prerelease compare",fe,ge,be),ge===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ge===void 0)return-1;if(ge!==be)return x(ge,be)}while(++fe)},O.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,ge,be){typeof ge=="string"&&(be=ge,ge=void 0);try{return new O(ae,ge).inc(fe,be).version}catch{return null}},e.diff=function(ae,fe){if(Z(ae,fe))return null;var ge=G(ae),be=G(fe);if(ge.prerelease.length||be.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return Ie},e.compareIdentifiers=x;var M=/^[0-9]+$/;function x(ae,fe){var ge=M.test(ae),be=M.test(fe);return ge&&be&&(ae=+ae,fe=+fe),ge&&!be?-1:be&&!ge?1:ae<fe?-1:ae>fe?1:0}function V(ae,fe,ge){return new O(ae,ge).compare(new O(fe,ge))}function ee(ae,fe,ge){return V(ae,fe,ge)>0}function oe(ae,fe,ge){return V(ae,fe,ge)<0}function Z(ae,fe,ge){return V(ae,fe,ge)===0}function ie(ae,fe,ge){return V(ae,fe,ge)!==0}function se(ae,fe,ge){return V(ae,fe,ge)>=0}function ue(ae,fe,ge){return V(ae,fe,ge)<=0}function de(ae,fe,ge,be){var Ie;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae===ge;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae!==ge;break;case"":case"=":case"==":Ie=Z(ae,ge,be);break;case"!=":Ie=ie(ae,ge,be);break;case">":Ie=ee(ae,ge,be);break;case">=":Ie=se(ae,ge,be);break;case"<":Ie=oe(ae,ge,be);break;case"<=":Ie=ue(ae,ge,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function ve(ae,fe){if(ae instanceof ve){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,fe);k("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ae,fe){return x(fe,ae)},e.major=function(ae,fe){return new O(ae,fe).major},e.minor=function(ae,fe){return new O(ae,fe).minor},e.patch=function(ae,fe){return new O(ae,fe).patch},e.compare=V,e.compareLoose=function(ae,fe){return V(ae,fe,!0)},e.rcompare=function(ae,fe,ge){return V(fe,ae,ge)},e.sort=function(ae,fe){return ae.sort(function(ge,be){return e.compare(ge,be,fe)})},e.rsort=function(ae,fe){return ae.sort(function(ge,be){return e.rcompare(ge,be,fe)})},e.gt=ee,e.lt=oe,e.eq=Z,e.neq=ie,e.gte=se,e.lte=ue,e.cmp=de,e.Comparator=ve;var we={};function Ee(ae,fe){if(ae instanceof Ee)return ae.loose===fe?ae:new Ee(ae.raw,fe);if(ae instanceof ve)return new Ee(ae.value,fe);if(!(this instanceof Ee))return new Ee(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ce(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,fe,ge,be,Ie,Le,Re,Ne,Ae,Me,ze,ke,_e){return((fe=Ce(ge)?"":Ce(be)?">="+ge+".0.0":Ce(Ie)?">="+ge+"."+be+".0":">="+fe)+" "+(Ne=Ce(Ae)?"":Ce(Me)?"<"+(+Ae+1)+".0.0":Ce(ze)?"<"+Ae+"."+(+Me+1)+".0":ke?"<="+Ae+"."+Me+"."+ze+"-"+ke:"<="+Ne)).trim()}function $e(ae,fe){for(var ge=0;ge<ae.length;ge++)if(!ae[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ae.length;ge++)if(k(ae[ge].semver),ae[ge].semver!==we&&ae[ge].semver.prerelease.length>0){var be=ae[ge].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function He(ae,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ae)}function We(ae,fe,ge,be){var Ie,Le,Re,Ne,Ae;switch(ae=new O(ae,be),fe=new Ee(fe,be),ge){case">":Ie=ee,Le=ue,Re=oe,Ne=">",Ae=">=";break;case"<":Ie=oe,Le=se,Re=ee,Ne="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(He(ae,fe,be))return!1;for(var Me=0;Me<fe.set.length;++Me){var ze=fe.set[Me],ke=null,_e=null;if(ze.forEach(function(te){te.semver===we&&(te=new ve(">=0.0.0")),ke=ke||te,_e=_e||te,Ie(te.semver,ke.semver,be)?ke=te:Re(te.semver,_e.semver,be)&&(_e=te)}),ke.operator===Ne||ke.operator===Ae||(!_e.operator||_e.operator===Ne)&&Le(ae,_e.semver)||_e.operator===Ae&&Re(ae,_e.semver))return!1}return!0}ve.prototype.parse=function(ae){var fe=this.loose?P[H]:P[W],ge=ae.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ae);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new O(ge[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return k("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new O(ae,this.loose)),de(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,fe){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ae.value,fe),He(this.value,ge,fe);if(ae.operator==="")return ge=new Ee(this.value,fe),He(ae.semver,ge,fe);var be=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Le=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Ne=de(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=de(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return be||Ie||Le&&Re||Ne||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),k("range",ae,fe);var ge=fe?P[X]:P[K];ae=ae.replace(ge,Ue),k("hyphen replace",ae),ae=ae.replace(P[z],"$1$2$3"),k("comparator trim",ae,P[z]),ae=(ae=(ae=ae.replace(P[U],"$1~")).replace(P[q],"$1^")).split(/\s+/).join(" ");var be=fe?P[H]:P[W],Ie=ae.split(" ").map(function(Le){return function(Re,Ne){return k("comp",Re),Re=function(Ae,Me){return Ae.trim().split(/\s+/).map(function(ze){return function(ke,_e){k("caret",ke,_e);var te=_e?P[j]:P[J];return ke.replace(te,function(le,he,me,Se,Pe){var De;return k("caret",ke,le,he,me,Se,Pe),Ce(he)?De="":Ce(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Ce(Se)?De=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Pe?(k("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+Pe+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+Pe+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+Pe+" <"+(+he+1)+".0.0"):(k("no pr"),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),k("caret return",De),De})}(ze,Me)}).join(" ")}(Re,Ne),k("caret",Re),Re=function(Ae,Me){return Ae.trim().split(/\s+/).map(function(ze){return function(ke,_e){var te=_e?P[N]:P[R];return ke.replace(te,function(le,he,me,Se,Pe){var De;return k("tilde",ke,le,he,me,Se,Pe),Ce(he)?De="":Ce(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Ce(Se)?De=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Pe?(k("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=">="+he+"."+me+"."+Se+Pe+" <"+he+"."+(+me+1)+".0"):De=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",k("tilde return",De),De})}(ze,Me)}).join(" ")}(Re,Ne),k("tildes",Re),Re=function(Ae,Me){return k("replaceXRanges",Ae,Me),Ae.split(/\s+/).map(function(ze){return function(ke,_e){ke=ke.trim();var te=_e?P[_]:P[S];return ke.replace(te,function(le,he,me,Se,Pe,De){k("xRange",ke,le,he,me,Se,Pe,De);var Be=Ce(me),Fe=Be||Ce(Se),Te=Fe||Ce(Pe);return he==="="&&Te&&(he=""),Be?le=he===">"||he==="<"?"<0.0.0":"*":he&&Te?(Fe&&(Se=0),Te&&(Pe=0),he===">"?(he=">=",Fe?(me=+me+1,Se=0,Pe=0):Te&&(Se=+Se+1,Pe=0)):he==="<="&&(he="<",Fe?me=+me+1:Se=+Se+1),le=he+me+"."+Se+"."+Pe):Fe?le=">="+me+".0.0 <"+(+me+1)+".0.0":Te&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),k("xRange return",le),le})}(ze,Me)}).join(" ")}(Re,Ne),k("xrange",Re),Re=function(Ae,Me){return k("replaceStars",Ae,Me),Ae.trim().replace(P[ce],"")}(Re,Ne),k("stars",Re),Re}(Le,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Le){return!!Le.match(be)})),Ie=Ie.map(function(Le){return new ve(Le,fe)})},Ee.prototype.intersects=function(ae,fe){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(be){return ae.set.some(function(Ie){return Ie.every(function(Le){return be.intersects(Le,fe)})})})})},e.toComparators=function(ae,fe){return new Ee(ae,fe).set.map(function(ge){return ge.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new O(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if($e(this.set[fe],ae))return!0;return!1},e.satisfies=He,e.maxSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==-1||(Ie=new O(be=Re,ge)))}),be},e.minSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==1||(Ie=new O(be=Re,ge)))}),be},e.validRange=function(ae,fe){try{return new Ee(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,ge){return We(ae,fe,"<",ge)},e.gtr=function(ae,fe,ge){return We(ae,fe,">",ge)},e.outside=We,e.prerelease=function(ae,fe){var ge=G(ae,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ae,fe,ge){return ae=new Ee(ae,ge),fe=new Ee(fe,ge),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof O)return ae;if(typeof ae!="string")return null;var fe=ae.match(P[$]);return fe==null?null:G((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,r,k=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(w){if(D===setTimeout)return setTimeout(w,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(w,0);try{return D(w,0)}catch{try{return D.call(null,w,0)}catch{return D.call(this,w,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var E,b=[],I=!1,C=-1;function p(){I&&E&&(I=!1,E.length?b=E.concat(b):C=-1,b.length&&v())}function v(){if(!I){var w=P(p);I=!0;for(var d=b.length;d;){for(E=b,b=[];++C<d;)E&&E[C].run();C=-1,d=b.length}E=null,I=!1,function(f){if(r===clearTimeout)return clearTimeout(f);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(f);try{r(f)}catch{try{return r.call(null,f)}catch{return r.call(this,f)}}}(w)}}function h(w,d){this.fun=w,this.array=d}function y(){}k.nextTick=function(w){var d=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)d[f-1]=arguments[f];b.push(new h(w,d)),b.length!==1||I||P(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=y,k.addListener=y,k.once=y,k.off=y,k.removeListener=y,k.removeAllListeners=y,k.emit=y,k.prependListener=y,k.prependOnceListener=y,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[118],re([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class r{constructor(P,E,b){this.level=P,this.key=E,this.value=b,this.forward=[]}}const k=void 0;class L{constructor(P,E=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new r(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new r(this._maxLevel,k,k)}has(P){return Boolean(L._search(this,P,this.comparator))}get(P){return L._search(this,P,this.comparator)?.value}set(P,E){return L._insert(this,P,E,this.comparator)&&(this._size+=1),this}delete(P){const E=L._delete(this,P,this.comparator);return E&&(this._size-=1),E}forEach(P,E){let b=this._header.forward[0];for(;b;)P.call(E,b.value,b.key,this),b=b.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",E=this._header.forward[0];for(;E;)P+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return P}static _search(P,E,b){let I=P._header;for(let C=P._level-1;C>=0;C--)for(;I.forward[C]&&b(I.forward[C].key,E)<0;)I=I.forward[C];if(I=I.forward[0],I&&b(I.key,E)===0)return I}static _insert(P,E,b,I){const C=[];let p=P._header;for(let v=P._level-1;v>=0;v--){for(;p.forward[v]&&I(p.forward[v].key,E)<0;)p=p.forward[v];C[v]=p}if(p=p.forward[0],p&&I(p.key,E)===0)return p.value=b,!1;{const v=L._randomLevel(P);if(v>P._level){for(let h=P._level;h<v;h++)C[h]=P._header;P._level=v}p=new r(v,E,b);for(let h=0;h<v;h++)p.forward[h]=C[h].forward[h],C[h].forward[h]=p;return!0}}static _randomLevel(P,E=.5){let b=1;for(;Math.random()<E&&b<P._maxLevel;)b+=1;return b}static _delete(P,E,b){const I=[];let C=P._header;for(let p=P._level-1;p>=0;p--){for(;C.forward[p]&&b(C.forward[p].key,E)<0;)C=C.forward[p];I[p]=C}if(C=C.forward[0],!C||b(C.key,E)!==0)return!1;for(let p=0;p<P._level&&I[p].forward[p]===C;p++)I[p].forward[p]=C.forward[p];for(;P._level>0&&P._header.forward[P._level-1]===k;)P._level-=1;return!0}}e.SkipList=L}),define(ne[42],re([0,1,9,2]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(g){const l=g;return l?typeof l.read=="function":!1}e.isReadable=k;function L(g){const l=g;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=L;function T(g){const l=g;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function P(g,l){return new E(g,l)}e.newWriteableStream=P;class E{constructor(l,n){this.reducer=l,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(n=>n(l))}emitError(l){this.listeners.error.length===0?(0,D.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(n=>n(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,n){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(l,n){if(this.state.destroyed)return;let o;switch(l){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const t=o.indexOf(n);t>=0&&o.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(g,l){const n=[];let o;for(;(o=g.read())!==null;)n.push(o);return l(n)}e.consumeReadable=b;function I(g,l,n){const o=[];let t;for(;(t=g.read())!==null&&o.length<n;)o.push(t);return t===null&&o.length>0?l(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return g.read()}}}e.peekReadable=I;function C(g,l){return new Promise((n,o)=>{const t=[];p(g,{onData:i=>{l&&t.push(i)},onError:i=>{l?o(i):n(void 0)},onEnd:()=>{n(l?l(t):void 0)}})})}e.consumeStream=C;function p(g,l){let n=!1;return g.on("error",o=>{n||l.onError(o)}),g.on("end",()=>{n||l.onEnd()}),g.on("data",o=>{n||l.onData(o)}),(0,r.toDisposable)(()=>n=!0)}e.listenStream=p;function v(g,l){return new Promise((n,o)=>{const t=new r.DisposableStore,i=[],s=m=>{if(i.push(m),i.length>l)return t.dispose(),g.pause(),n({stream:g,buffer:i,ended:!1})},u=m=>o(m),a=()=>n({stream:g,buffer:i,ended:!0});t.add((0,r.toDisposable)(()=>g.removeListener("error",u))),g.on("error",u),t.add((0,r.toDisposable)(()=>g.removeListener("end",a))),g.on("end",a),t.add((0,r.toDisposable)(()=>g.removeListener("data",s))),g.on("data",s)})}e.peekStream=v;function h(g,l){const n=P(l);return n.end(g),n}e.toStream=h;function y(){const g=P(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=y;function w(g){let l=!1;return{read:()=>l?null:(l=!0,g)}}e.toReadable=w;function d(g,l,n){const o=P(n);return p(g,{onData:t=>o.write(l.data(t)),onError:t=>o.error(l.error?l.error(t):t),onEnd:()=>o.end()}),o}e.transform=d;function f(g,l,n){let o=!1;return{read:()=>{const t=l.read();return o?t:(o=!0,t!==null?n([g,t]):g)}}}e.prefixedReadable=f;function c(g,l,n){let o=!1;const t=P(n);return p(l,{onData:i=>o?t.write(i):(o=!0,t.write(n([g,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(g)),t.end()}}),t}e.prefixedStream=c}),define(ne[16],re([0,1,42]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer<"u";let k,L;class T{static alloc(m){return r?new T(Buffer.allocUnsafe(m)):new T(new Uint8Array(m))}static wrap(m){return r&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new T(m)}static fromString(m,S){return!(S?.dontUseNodeBuffer||!1)&&r?new T(Buffer.from(m)):(k||(k=new TextEncoder),new T(k.encode(m)))}static fromByteArray(m){const S=T.alloc(m.length);for(let _=0,$=m.length;_<$;_++)S.buffer[_]=m[_];return S}static concat(m,S){if(typeof S>"u"){S=0;for(let A=0,U=m.length;A<U;A++)S+=m[A].byteLength}const _=T.alloc(S);let $=0;for(let A=0,U=m.length;A<U;A++){const R=m[A];_.set(R,$),$+=R.byteLength}return _}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=T.alloc(this.byteLength);return m.set(this),m}toString(){return r?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(m,S){return new T(this.buffer.subarray(m,S))}set(m,S){if(m instanceof T)this.buffer.set(m.buffer,S);else if(m instanceof Uint8Array)this.buffer.set(m,S);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),S);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return b(this.buffer,m)}writeUInt32BE(m,S){I(this.buffer,m,S)}readUInt32LE(m){return C(this.buffer,m)}writeUInt32LE(m,S){p(this.buffer,m,S)}readUInt8(m){return v(this.buffer,m)}writeUInt8(m,S){h(this.buffer,m,S)}}e.VSBuffer=T;function P(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0}e.readUInt16LE=P;function E(a,m,S){a[S+0]=m&255,m=m>>>8,a[S+1]=m&255}e.writeUInt16LE=E;function b(a,m){return a[m]*2**24+a[m+1]*2**16+a[m+2]*2**8+a[m+3]}e.readUInt32BE=b;function I(a,m,S){a[S+3]=m,m=m>>>8,a[S+2]=m,m=m>>>8,a[S+1]=m,m=m>>>8,a[S]=m}e.writeUInt32BE=I;function C(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0|a[m+2]<<16>>>0|a[m+3]<<24>>>0}e.readUInt32LE=C;function p(a,m,S){a[S+0]=m&255,m=m>>>8,a[S+1]=m&255,m=m>>>8,a[S+2]=m&255,m=m>>>8,a[S+3]=m&255}e.writeUInt32LE=p;function v(a,m){return a[m]}e.readUInt8=v;function h(a,m,S){a[S]=m}e.writeUInt8=h;function y(a){return D.consumeReadable(a,m=>T.concat(m))}e.readableToBuffer=y;function w(a){return D.toReadable(a)}e.bufferToReadable=w;function d(a){return D.consumeStream(a,m=>T.concat(m))}e.streamToBuffer=d;async function f(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await d(a.stream)])}e.bufferedStreamToBuffer=f;function c(a){return D.toStream(a,m=>T.concat(m))}e.bufferToStream=c;function g(a){return D.transform(a,{data:m=>typeof m=="string"?T.fromString(m):T.wrap(m)},m=>T.concat(m))}e.streamToBufferReadableStream=g;function l(a){return D.newWriteableStream(m=>T.concat(m),a)}e.newWriteableBufferStream=l;function n(a,m){return D.prefixedReadable(a,m,S=>T.concat(S))}e.prefixedBufferReadable=n;function o(a,m){return D.prefixedStream(a,m,S=>T.concat(S))}e.prefixedBufferStream=o;function t(a){let m=0,S=0,_=0;const $=new Uint8Array(Math.floor(a.length/4*3)),A=R=>{switch(S){case 3:$[_++]=m|R,S=0;break;case 2:$[_++]=m|R>>>2,m=R<<6,S=3;break;case 1:$[_++]=m|R>>>4,m=R<<4,S=2;break;default:m=R<<2,S=1}};for(let R=0;R<a.length;R++){const N=a.charCodeAt(R);if(N>=65&&N<=90)A(N-65);else if(N>=97&&N<=122)A(N-97+26);else if(N>=48&&N<=57)A(N-48+52);else if(N===43||N===45)A(62);else if(N===47||N===95)A(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[R]}`)}}const U=_;for(;S>0;)A(0);return T.wrap($).slice(0,U)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:a},m=!0,S=!1){const _=S?s:i;let $="";const A=a.byteLength%3;let U=0;for(;U<a.byteLength-A;U+=3){const R=a[U+0],N=a[U+1],F=a[U+2];$+=_[R>>>2],$+=_[(R<<4|N>>>4)&63],$+=_[(N<<2|F>>>6)&63],$+=_[F&63]}if(A===1){const R=a[U+0];$+=_[R>>>2],$+=_[R<<4&63],m&&($+="==")}else if(A===2){const R=a[U+0],N=a[U+1];$+=_[R>>>2],$+=_[(R<<4|N>>>4)&63],$+=_[N<<2&63],m&&($+="=")}return $}e.encodeBase64=u}),define(ne[15],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(o){return typeof o=="string"}e.isString=D;function r(o){return Array.isArray(o)&&o.every(t=>D(t))}e.isStringArray=r;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function L(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.isTypedArray=L;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function E(o){return o===!0||o===!1}e.isBoolean=E;function b(o){return typeof o>"u"}e.isUndefined=b;function I(o){return!C(o)}e.isDefined=I;function C(o){return b(o)||o===null}e.isUndefinedOrNull=C;function p(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function v(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=v;function h(...o){const t=[];for(let i=0;i<o.length;i++){const s=o[i];if(C(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(s)}return t}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function w(o){if(!k(o))return!1;for(const t in o)if(y.call(o,t))return!1;return!0}e.isEmptyObject=w;function d(o){return typeof o=="function"}e.isFunction=d;function f(...o){return o.length>0&&o.every(d)}e.areFunctions=f;function c(o,t){const i=Math.min(o.length,t.length);for(let s=0;s<i;s++)g(o[s],t[s])}e.validateConstraints=c;function g(o,t){if(D(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(d(t)){try{if(o instanceof t)return}catch{}if(!C(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function l(o){return o===null?void 0:o}e.withNullAsUndefined=l;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(ne[32],re([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function r(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.keys(d).forEach(c=>{d[c]&&typeof d[c]=="object"?f[c]=r(d[c]):f[c]=d[c]}),f}e.deepClone=r;function k(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const c=f.shift();Object.freeze(c);for(const g in c)if(L.call(c,g)){const l=c[g];typeof l=="object"&&!Object.isFrozen(l)&&!(0,D.isTypedArray)(l)&&f.push(l)}}return d}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function T(d,f){return P(d,f,new Set)}e.cloneAndChange=T;function P(d,f,c){if((0,D.isUndefinedOrNull)(d))return d;const g=f(d);if(typeof g<"u")return g;if(Array.isArray(d)){const l=[];for(const n of d)l.push(P(n,f,c));return l}if((0,D.isObject)(d)){if(c.has(d))throw new Error("Cannot clone recursive data-structure");c.add(d);const l={};for(const n in d)L.call(d,n)&&(l[n]=P(d[n],f,c));return c.delete(d),l}return d}function E(d,f,c=!0){return(0,D.isObject)(d)?((0,D.isObject)(f)&&Object.keys(f).forEach(g=>{g in d?c&&((0,D.isObject)(d[g])&&(0,D.isObject)(f[g])?E(d[g],f[g],c):d[g]=f[g]):d[g]=f[g]}),d):f}e.mixin=E;function b(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let c,g;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(c=0;c<d.length;c++)if(!b(d[c],f[c]))return!1}else{const l=[];for(g in d)l.push(g);l.sort();const n=[];for(g in f)n.push(g);if(n.sort(),!b(l,n))return!1;for(c=0;c<l.length;c++)if(!b(d[l[c]],f[l[c]]))return!1}return!0}e.equals=b;function I(d){const f=new Set;return JSON.stringify(d,(c,g)=>{if((0,D.isObject)(g)||Array.isArray(g)){if(f.has(g))return"[Circular]";f.add(g)}return g})}e.safeStringify=I;function C(d,f){const c=Object.create(null);return!d||!f||Object.keys(f).forEach(l=>{const n=d[l],o=f[l];b(n,o)||(c[l]=o)}),c}e.distinct=C;function p(d,f){const c=f.toLowerCase(),g=Object.keys(d).find(l=>l.toLowerCase()===c);return g?d[g]:d[f]}e.getCaseInsensitive=p;function v(d,f){const c=Object.create(null);for(const[g,l]of Object.entries(d))f(g,l)&&(c[g]=l);return c}e.filter=v;function h(d){let f=[],c=Object.getPrototypeOf(d);for(;Object.prototype!==c;)f=f.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return f}e.getAllPropertyNames=h;function y(d){const f=[];for(const c of h(d))typeof d[c]=="function"&&f.push(c);return f}e.getAllMethodNames=y;function w(d,f){const c=l=>function(){const n=Array.prototype.slice.call(arguments,0);return f(l,n)},g={};for(const l of d)g[l]=c(l);return g}e.createProxyObject=w}),define(ne[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(k){return D.test(k)}e.isUUID=r,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let E=0;E<P.length;E++)P[E]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,b="";return b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b}}()}),define(ne[119],re([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const P=T.replace(/\-/g,":").toLowerCase();return!r.has(P)}function L(){const T=(0,D.networkInterfaces)();for(const P in T){const E=T[P];if(E){for(const{mac:b}of E)if(k(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[120],re([0,1,82]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function r(P,E,b,I=1){let C=!1;return new Promise(p=>{const v=setTimeout(()=>{if(!C)return C=!0,p(0)},b);k(P,E,I,h=>{if(!C)return C=!0,clearTimeout(v),p(h)})})}e.findFreePort=r;function k(P,E,b,I){if(E===0)return I(0);const C=new D.Socket;C.once("connect",()=>(T(C),k(P+b,E-1,b,I))),C.once("data",()=>{}),C.once("error",p=>(T(C),p.code!=="ECONNREFUSED"?k(P+b,E-1,b,I):I(P))),C.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,E,b){let I=!1,C,p=1;const v=D.createServer({pauseOnConnect:!0});function h(y,w){I||(I=!0,v.removeAllListeners(),v.close(),C&&clearTimeout(C),w(y))}return new Promise(y=>{C=setTimeout(()=>{h(0,y)},b),v.on("listening",()=>{h(P,y)}),v.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&p<E?(P++,p++,v.listen(P,"127.0.0.1")):h(0,y)}),v.on("close",()=>{h(0,y)}),v.listen(P,"127.0.0.1")})}e.findFreePortFaster=L;function T(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(E){console.error(E)}}}),define(ne[121],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function r(L){return L instanceof k?!0:L instanceof Error&&L.name===D&&L.message===D}e.isOfflineError=r;class k extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=k}),define(ne[122],re([0,1,16,9,121]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(E,b){if(!navigator.onLine)throw new k.OfflineError;E.proxyAuthorization&&(E.headers={...E.headers||{},"Proxy-Authorization":E.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((C,p)=>{I.open(E.type||"GET",E.url||"",!0,E.user,E.password),T(I,E),I.responseType="arraybuffer",I.onerror=v=>p(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=v=>{C({res:{statusCode:I.status,headers:P(I)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=v=>p(new Error(`XHR timeout: ${E.timeout}ms`)),E.timeout&&(I.timeout=E.timeout),I.send(E.data),b.onCancellationRequested(()=>{I.abort(),p((0,r.canceled)())})})}e.request=L;function T(E,b){if(b.headers){e:for(const I in b.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}E.setRequestHeader(I,b.headers[I])}}}function P(E){const b=Object.create(null);for(const I of E.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const C=I.indexOf(":");b[I.substr(0,C).trim().toLowerCase()]=I.substr(C+1).trim()}return b}}),define(ne[123],re([10,11]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[64],re([0,1,123]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const r=60,k=r*60,L=k*24,T=L*7,P=L*30,E=L*365;function b(C,p,v){typeof C!="number"&&(C=C.getTime());const h=Math.round((new Date().getTime()-C)/1e3);if(h<-30)return(0,D.localize)(0,null,b(new Date().getTime()+h*1e3,!1));if(h<30)return(0,D.localize)(1,null);let y;return h<r?(y=h,p?y===1?v?(0,D.localize)(2,null,y):(0,D.localize)(3,null,y):v?(0,D.localize)(4,null,y):(0,D.localize)(5,null,y):y===1?v?(0,D.localize)(6,null,y):(0,D.localize)(7,null,y):v?(0,D.localize)(8,null,y):(0,D.localize)(9,null,y)):h<k?(y=Math.floor(h/r),p?y===1?v?(0,D.localize)(10,null,y):(0,D.localize)(11,null,y):v?(0,D.localize)(12,null,y):(0,D.localize)(13,null,y):y===1?v?(0,D.localize)(14,null,y):(0,D.localize)(15,null,y):v?(0,D.localize)(16,null,y):(0,D.localize)(17,null,y)):h<L?(y=Math.floor(h/k),p?y===1?v?(0,D.localize)(18,null,y):(0,D.localize)(19,null,y):v?(0,D.localize)(20,null,y):(0,D.localize)(21,null,y):y===1?v?(0,D.localize)(22,null,y):(0,D.localize)(23,null,y):v?(0,D.localize)(24,null,y):(0,D.localize)(25,null,y)):h<T?(y=Math.floor(h/L),p?y===1?(0,D.localize)(26,null,y):(0,D.localize)(27,null,y):y===1?(0,D.localize)(28,null,y):(0,D.localize)(29,null,y)):h<P?(y=Math.floor(h/T),p?y===1?v?(0,D.localize)(30,null,y):(0,D.localize)(31,null,y):v?(0,D.localize)(32,null,y):(0,D.localize)(33,null,y):y===1?v?(0,D.localize)(34,null,y):(0,D.localize)(35,null,y):v?(0,D.localize)(36,null,y):(0,D.localize)(37,null,y)):h<E?(y=Math.floor(h/P),p?y===1?v?(0,D.localize)(38,null,y):(0,D.localize)(39,null,y):v?(0,D.localize)(40,null,y):(0,D.localize)(41,null,y):y===1?v?(0,D.localize)(42,null,y):(0,D.localize)(43,null,y):v?(0,D.localize)(44,null,y):(0,D.localize)(45,null,y)):(y=Math.floor(h/E),p?y===1?v?(0,D.localize)(46,null,y):(0,D.localize)(47,null,y):v?(0,D.localize)(48,null,y):(0,D.localize)(49,null,y):y===1?v?(0,D.localize)(50,null,y):(0,D.localize)(51,null,y):v?(0,D.localize)(52,null,y):(0,D.localize)(53,null,y))}e.fromNow=b;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ne[124],re([10,11]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,18,15,124]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(C,p){return p&&(C.stack||C.stacktrace)?k.localize(0,null,P(C),T(C.stack)||T(C.stacktrace)):P(C)}function T(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?k.localize(1,null,C.message):C.message||k.localize(2,null)}function E(C=null,p=!1){if(!C)return k.localize(3,null);if(Array.isArray(C)){const v=D.coalesce(C),h=E(v[0],p);return v.length>1?k.localize(4,null,h,v.length):h}if(r.isString(C))return C;if(C.detail){const v=C.detail;if(v.error)return L(v.error,p);if(v.exception)return L(v.exception,p)}return C.stack?L(C,p):C.message?C.message:k.localize(5,null)}e.toErrorMessage=E;function b(C){const p=C;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=b;function I(C,p){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=p,v}e.createErrorWithActions=I}),define(ne[125],re([10,11]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[126],re([0,1,125]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function r(k){switch(k){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=r}),define(ne[127],re([10,11]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,127]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let r=!1,k=!1,L=!1,T=!1,P=!1,E=!1,b=!1,I=!1,C=!1,p=!1,v,h=e.LANGUAGE_DEFAULT,y,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const f=typeof d?.versions?.electron=="string",c=f&&d?.type==="renderer";if(typeof navigator=="object"&&!c)w=navigator.userAgent,r=w.indexOf("Windows")>=0,k=w.indexOf("Macintosh")>=0,I=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=w.indexOf("Linux")>=0,p=w?.indexOf("Mobi")>=0,E=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,h=v;else if(typeof d=="object"){r=d.platform==="win32",k=d.platform==="darwin",L=d.platform==="linux",T=L&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,b=f,C=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const a=d.env.VSCODE_NLS_CONFIG;if(a)try{const m=JSON.parse(a),S=m.availableLanguages["*"];v=m.locale,h=S||e.LANGUAGE_DEFAULT,y=m._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var g;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function l(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let n=0;k?n=1:r?n=3:L&&(n=2),e.isWindows=r,e.isMacintosh=k,e.isLinux=L,e.isLinuxSnap=T,e.isNative=P,e.isElectron=b,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=p,e.isCI=C,e.platform=n,e.userAgent=w,e.language=h;var o;(function(a){function m(){return e.language}a.value=m;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=S;function _(){return e.language==="en"}a.isDefault=_})(o=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let _=0,$=a.length;_<$;_++){const A=a[_];if(A.id===S.data.vscodeScheduleAsyncWork){a.splice(_,1),A.callback();return}}});let m=0;return S=>{const _=++m;a.push({id:_,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:_},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||I?2:r?1:3;let i=!0,s=!1;function u(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,i=new Uint16Array(a.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[37],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let r;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const k=D.globals.vscode.process;r={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.platform=r.platform,e.arch=r.arch}),define(ne[12],re([0,1,37]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const r=65,k=97,L=90,T=122,P=46,E=47,b=92,I=58,C=63;class p extends Error{constructor(g,l,n){let o;typeof l=="string"&&l.indexOf("not ")===0?(o="must not be",l=l.replace(/^not /,"")):o="must be";const t=g.indexOf(".")!==-1?"property":"argument";let i=`The "${g}" ${t} ${o} of type ${l}`;i+=`. Received type ${typeof n}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function v(c,g){if(typeof c!="string")throw new p(g,"string",c)}function h(c){return c===E||c===b}function y(c){return c===E}function w(c){return c>=r&&c<=L||c>=k&&c<=T}function d(c,g,l,n){let o="",t=0,i=-1,s=0,u=0;for(let a=0;a<=c.length;++a){if(a<c.length)u=c.charCodeAt(a);else{if(n(u))break;u=E}if(n(u)){if(!(i===a-1||s===1))if(s===2){if(o.length<2||t!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const m=o.lastIndexOf(l);m===-1?(o="",t=0):(o=o.slice(0,m),t=o.length-1-o.lastIndexOf(l)),i=a,s=0;continue}else if(o.length!==0){o="",t=0,i=a,s=0;continue}}g&&(o+=o.length>0?`${l}..`:"..",t=2)}else o.length>0?o+=`${l}${c.slice(i+1,a)}`:o=c.slice(i+1,a),t=a-i-1;i=a,s=0}else u===P&&s!==-1?++s:s=-1}return o}function f(c,g){if(g===null||typeof g!="object")throw new p("pathObject","Object",g);const l=g.dir||g.root,n=g.base||`${g.name||""}${g.ext||""}`;return l?l===g.root?`${l}${n}`:`${l}${c}${n}`:n}e.win32={resolve(...c){let g="",l="",n=!1;for(let o=c.length-1;o>=-1;o--){let t;if(o>=0){if(t=c[o],v(t,"path"),t.length===0)continue}else g.length===0?t=D.cwd():(t=D.env[`=${g}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==g.toLowerCase()&&t.charCodeAt(2)===b)&&(t=`${g}\\`));const i=t.length;let s=0,u="",a=!1;const m=t.charCodeAt(0);if(i===1)h(m)&&(s=1,a=!0);else if(h(m))if(a=!0,h(t.charCodeAt(1))){let S=2,_=S;for(;S<i&&!h(t.charCodeAt(S));)S++;if(S<i&&S!==_){const $=t.slice(_,S);for(_=S;S<i&&h(t.charCodeAt(S));)S++;if(S<i&&S!==_){for(_=S;S<i&&!h(t.charCodeAt(S));)S++;(S===i||S!==_)&&(u=`\\\\${$}\\${t.slice(_,S)}`,s=S)}}}else s=1;else w(m)&&t.charCodeAt(1)===I&&(u=t.slice(0,2),s=2,i>2&&h(t.charCodeAt(2))&&(a=!0,s=3));if(u.length>0)if(g.length>0){if(u.toLowerCase()!==g.toLowerCase())continue}else g=u;if(n){if(g.length>0)break}else if(l=`${t.slice(s)}\\${l}`,n=a,a&&g.length>0)break}return l=d(l,!n,"\\",h),n?`${g}\\${l}`:`${g}${l}`||"."},normalize(c){v(c,"path");const g=c.length;if(g===0)return".";let l=0,n,o=!1;const t=c.charCodeAt(0);if(g===1)return y(t)?"\\":c;if(h(t))if(o=!0,h(c.charCodeAt(1))){let s=2,u=s;for(;s<g&&!h(c.charCodeAt(s));)s++;if(s<g&&s!==u){const a=c.slice(u,s);for(u=s;s<g&&h(c.charCodeAt(s));)s++;if(s<g&&s!==u){for(u=s;s<g&&!h(c.charCodeAt(s));)s++;if(s===g)return`\\\\${a}\\${c.slice(u)}\\`;s!==u&&(n=`\\\\${a}\\${c.slice(u,s)}`,l=s)}}}else l=1;else w(t)&&c.charCodeAt(1)===I&&(n=c.slice(0,2),l=2,g>2&&h(c.charCodeAt(2))&&(o=!0,l=3));let i=l<g?d(c.slice(l),!o,"\\",h):"";return i.length===0&&!o&&(i="."),i.length>0&&h(c.charCodeAt(g-1))&&(i+="\\"),n===void 0?o?`\\${i}`:i:o?`${n}\\${i}`:`${n}${i}`},isAbsolute(c){v(c,"path");const g=c.length;if(g===0)return!1;const l=c.charCodeAt(0);return h(l)||g>2&&w(l)&&c.charCodeAt(1)===I&&h(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let g,l;for(let t=0;t<c.length;++t){const i=c[t];v(i,"path"),i.length>0&&(g===void 0?g=l=i:g+=`\\${i}`)}if(g===void 0)return".";let n=!0,o=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++o;const t=l.length;t>1&&h(l.charCodeAt(1))&&(++o,t>2&&(h(l.charCodeAt(2))?++o:n=!1))}if(n){for(;o<g.length&&h(g.charCodeAt(o));)o++;o>=2&&(g=`\\${g.slice(o)}`)}return e.win32.normalize(g)},relative(c,g){if(v(c,"from"),v(g,"to"),c===g)return"";const l=e.win32.resolve(c),n=e.win32.resolve(g);if(l===n||(c=l.toLowerCase(),g=n.toLowerCase(),c===g))return"";let o=0;for(;o<c.length&&c.charCodeAt(o)===b;)o++;let t=c.length;for(;t-1>o&&c.charCodeAt(t-1)===b;)t--;const i=t-o;let s=0;for(;s<g.length&&g.charCodeAt(s)===b;)s++;let u=g.length;for(;u-1>s&&g.charCodeAt(u-1)===b;)u--;const a=u-s,m=i<a?i:a;let S=-1,_=0;for(;_<m;_++){const A=c.charCodeAt(o+_);if(A!==g.charCodeAt(s+_))break;A===b&&(S=_)}if(_!==m){if(S===-1)return n}else{if(a>m){if(g.charCodeAt(s+_)===b)return n.slice(s+_+1);if(_===2)return n.slice(s+_)}i>m&&(c.charCodeAt(o+_)===b?S=_:_===2&&(S=3)),S===-1&&(S=0)}let $="";for(_=o+S+1;_<=t;++_)(_===t||c.charCodeAt(_)===b)&&($+=$.length===0?"..":"\\..");return s+=S,$.length>0?`${$}${n.slice(s,u)}`:(n.charCodeAt(s)===b&&++s,n.slice(s,u))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const g=e.win32.resolve(c);if(g.length<=2)return c;if(g.charCodeAt(0)===b){if(g.charCodeAt(1)===b){const l=g.charCodeAt(2);if(l!==C&&l!==P)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(w(g.charCodeAt(0))&&g.charCodeAt(1)===I&&g.charCodeAt(2)===b)return`\\\\?\\${g}`;return c},dirname(c){v(c,"path");const g=c.length;if(g===0)return".";let l=-1,n=0;const o=c.charCodeAt(0);if(g===1)return h(o)?c:".";if(h(o)){if(l=n=1,h(c.charCodeAt(1))){let s=2,u=s;for(;s<g&&!h(c.charCodeAt(s));)s++;if(s<g&&s!==u){for(u=s;s<g&&h(c.charCodeAt(s));)s++;if(s<g&&s!==u){for(u=s;s<g&&!h(c.charCodeAt(s));)s++;if(s===g)return c;s!==u&&(l=n=s+1)}}}}else w(o)&&c.charCodeAt(1)===I&&(l=g>2&&h(c.charCodeAt(2))?3:2,n=l);let t=-1,i=!0;for(let s=g-1;s>=n;--s)if(h(c.charCodeAt(s))){if(!i){t=s;break}}else i=!1;if(t===-1){if(l===-1)return".";t=l}return c.slice(0,t)},basename(c,g){g!==void 0&&v(g,"ext"),v(c,"path");let l=0,n=-1,o=!0,t;if(c.length>=2&&w(c.charCodeAt(0))&&c.charCodeAt(1)===I&&(l=2),g!==void 0&&g.length>0&&g.length<=c.length){if(g===c)return"";let i=g.length-1,s=-1;for(t=c.length-1;t>=l;--t){const u=c.charCodeAt(t);if(h(u)){if(!o){l=t+1;break}}else s===-1&&(o=!1,s=t+1),i>=0&&(u===g.charCodeAt(i)?--i===-1&&(n=t):(i=-1,n=s))}return l===n?n=s:n===-1&&(n=c.length),c.slice(l,n)}for(t=c.length-1;t>=l;--t)if(h(c.charCodeAt(t))){if(!o){l=t+1;break}}else n===-1&&(o=!1,n=t+1);return n===-1?"":c.slice(l,n)},extname(c){v(c,"path");let g=0,l=-1,n=0,o=-1,t=!0,i=0;c.length>=2&&c.charCodeAt(1)===I&&w(c.charCodeAt(0))&&(g=n=2);for(let s=c.length-1;s>=g;--s){const u=c.charCodeAt(s);if(h(u)){if(!t){n=s+1;break}continue}o===-1&&(t=!1,o=s+1),u===P?l===-1?l=s:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||o===-1||i===0||i===1&&l===o-1&&l===n+1?"":c.slice(l,o)},format:f.bind(null,"\\"),parse(c){v(c,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return g;const l=c.length;let n=0,o=c.charCodeAt(0);if(l===1)return h(o)?(g.root=g.dir=c,g):(g.base=g.name=c,g);if(h(o)){if(n=1,h(c.charCodeAt(1))){let S=2,_=S;for(;S<l&&!h(c.charCodeAt(S));)S++;if(S<l&&S!==_){for(_=S;S<l&&h(c.charCodeAt(S));)S++;if(S<l&&S!==_){for(_=S;S<l&&!h(c.charCodeAt(S));)S++;S===l?n=S:S!==_&&(n=S+1)}}}}else if(w(o)&&c.charCodeAt(1)===I){if(l<=2)return g.root=g.dir=c,g;if(n=2,h(c.charCodeAt(2))){if(l===3)return g.root=g.dir=c,g;n=3}}n>0&&(g.root=c.slice(0,n));let t=-1,i=n,s=-1,u=!0,a=c.length-1,m=0;for(;a>=n;--a){if(o=c.charCodeAt(a),h(o)){if(!u){i=a+1;break}continue}s===-1&&(u=!1,s=a+1),o===P?t===-1?t=a:m!==1&&(m=1):t!==-1&&(m=-1)}return s!==-1&&(t===-1||m===0||m===1&&t===s-1&&t===i+1?g.base=g.name=c.slice(i,s):(g.name=c.slice(i,t),g.base=c.slice(i,s),g.ext=c.slice(t,s))),i>0&&i!==n?g.dir=c.slice(0,i-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let g="",l=!1;for(let n=c.length-1;n>=-1&&!l;n--){const o=n>=0?c[n]:D.cwd();v(o,"path"),o.length!==0&&(g=`${o}/${g}`,l=o.charCodeAt(0)===E)}return g=d(g,!l,"/",y),l?`/${g}`:g.length>0?g:"."},normalize(c){if(v(c,"path"),c.length===0)return".";const g=c.charCodeAt(0)===E,l=c.charCodeAt(c.length-1)===E;return c=d(c,!g,"/",y),c.length===0?g?"/":l?"./":".":(l&&(c+="/"),g?`/${c}`:c)},isAbsolute(c){return v(c,"path"),c.length>0&&c.charCodeAt(0)===E},join(...c){if(c.length===0)return".";let g;for(let l=0;l<c.length;++l){const n=c[l];v(n,"path"),n.length>0&&(g===void 0?g=n:g+=`/${n}`)}return g===void 0?".":e.posix.normalize(g)},relative(c,g){if(v(c,"from"),v(g,"to"),c===g||(c=e.posix.resolve(c),g=e.posix.resolve(g),c===g))return"";const l=1,n=c.length,o=n-l,t=1,i=g.length-t,s=o<i?o:i;let u=-1,a=0;for(;a<s;a++){const S=c.charCodeAt(l+a);if(S!==g.charCodeAt(t+a))break;S===E&&(u=a)}if(a===s)if(i>s){if(g.charCodeAt(t+a)===E)return g.slice(t+a+1);if(a===0)return g.slice(t+a)}else o>s&&(c.charCodeAt(l+a)===E?u=a:a===0&&(u=0));let m="";for(a=l+u+1;a<=n;++a)(a===n||c.charCodeAt(a)===E)&&(m+=m.length===0?"..":"/..");return`${m}${g.slice(t+u)}`},toNamespacedPath(c){return c},dirname(c){if(v(c,"path"),c.length===0)return".";const g=c.charCodeAt(0)===E;let l=-1,n=!0;for(let o=c.length-1;o>=1;--o)if(c.charCodeAt(o)===E){if(!n){l=o;break}}else n=!1;return l===-1?g?"/":".":g&&l===1?"//":c.slice(0,l)},basename(c,g){g!==void 0&&v(g,"ext"),v(c,"path");let l=0,n=-1,o=!0,t;if(g!==void 0&&g.length>0&&g.length<=c.length){if(g===c)return"";let i=g.length-1,s=-1;for(t=c.length-1;t>=0;--t){const u=c.charCodeAt(t);if(u===E){if(!o){l=t+1;break}}else s===-1&&(o=!1,s=t+1),i>=0&&(u===g.charCodeAt(i)?--i===-1&&(n=t):(i=-1,n=s))}return l===n?n=s:n===-1&&(n=c.length),c.slice(l,n)}for(t=c.length-1;t>=0;--t)if(c.charCodeAt(t)===E){if(!o){l=t+1;break}}else n===-1&&(o=!1,n=t+1);return n===-1?"":c.slice(l,n)},extname(c){v(c,"path");let g=-1,l=0,n=-1,o=!0,t=0;for(let i=c.length-1;i>=0;--i){const s=c.charCodeAt(i);if(s===E){if(!o){l=i+1;break}continue}n===-1&&(o=!1,n=i+1),s===P?g===-1?g=i:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||n===-1||t===0||t===1&&g===n-1&&g===l+1?"":c.slice(g,n)},format:f.bind(null,"/"),parse(c){v(c,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return g;const l=c.charCodeAt(0)===E;let n;l?(g.root="/",n=1):n=0;let o=-1,t=0,i=-1,s=!0,u=c.length-1,a=0;for(;u>=n;--u){const m=c.charCodeAt(u);if(m===E){if(!s){t=u+1;break}continue}i===-1&&(s=!1,i=u+1),m===P?o===-1?o=u:a!==1&&(a=1):o!==-1&&(a=-1)}if(i!==-1){const m=t===0&&l?1:t;o===-1||a===0||a===1&&o===i-1&&o===t+1?g.base=g.name=c.slice(m,i):(g.name=c.slice(m,o),g.base=c.slice(m,i),g.ext=c.slice(o,i))}return t>0?g.dir=c.slice(0,t-1):l&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[128],re([0,1,12]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(I){const C=(0,D.extname)(I),p=r[C.toLowerCase()];return p!==void 0?p:T(I)}e.getMediaOrTextMime=L;function T(I){const C=(0,D.extname)(I);return k[C.toLowerCase()]}e.getMediaMime=T;function P(I){for(const C in k)if(k[C]===I)return C}e.getExtensionForMimeType=P;const E=/^(.+)\/(.+?)(;.+)?$/;function b(I,C){const p=E.exec(I);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:C?void 0:I}e.normalizeMimeType=b}),define(ne[83],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var r;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(r=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(P,...E){const b=E.reduce((p,v)=>(p[v]=!0,p),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!b[p]).forEach(p=>{for(let v=0;v<I.length;v++)if(p.search(I[v])!==-1){delete P[p];break}})}e.sanitizeProcessEnvironment=L;function T(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[129],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=D.globals.performance&&typeof D.globals.performance.now=="function";class k{static create(T=!0){return new k(T)}constructor(T){this._highResolution=r&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ne[3],re([0,1,9,79,2,81,129]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,E=!1;var b;(function(u){u.None=()=>k.Disposable.None;function a(M){if(E){const{onListenerDidAdd:x}=M,V=h.create();let ee=0;M.onListenerDidAdd=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),x?.()}}}function m(M){return(x,V=null,ee)=>{let oe=!1,Z;return Z=M(ie=>{if(!oe)return Z?Z.dispose():oe=!0,x.call(V,ie)},null,ee),oe&&Z.dispose(),Z}}u.once=m;function S(M,x,V){return N((ee,oe=null,Z)=>M(ie=>ee.call(oe,x(ie)),null,Z),V)}u.map=S;function _(M,x,V){return N((ee,oe=null,Z)=>M(ie=>{x(ie),ee.call(oe,ie)},null,Z),V)}u.forEach=_;function $(M,x,V){return N((ee,oe=null,Z)=>M(ie=>x(ie)&&ee.call(oe,ie),null,Z),V)}u.filter=$;function A(M){return M}u.signal=A;function U(...M){return(x,V=null,ee)=>(0,k.combinedDisposable)(...M.map(oe=>oe(Z=>x.call(V,Z),null,ee)))}u.any=U;function R(M,x,V,ee){let oe=V;return S(M,Z=>(oe=x(oe,Z),oe),ee)}u.reduce=R;function N(M,x){let V;const ee={onFirstListenerAdd(){V=M(oe.fire,oe)},onLastListenerRemove(){V?.dispose()}};x||a(ee);const oe=new w(ee);return x?.add(oe),oe.event}function F(M,x,V=100,ee=!1,oe,Z){let ie,se,ue,de=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=M(Ee=>{de++,se=x(se,Ee),ee&&!ue&&(we.fire(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Ce=se;se=void 0,ue=void 0,(!ee||de>1)&&we.fire(Ce),de=0},V)})},onLastListenerRemove(){ie.dispose()}};Z||a(ve);const we=new w(ve);return Z?.add(we),we.event}u.debounce=F;function q(M,x=(ee,oe)=>ee===oe,V){let ee=!0,oe;return $(M,Z=>{const ie=ee||!x(Z,oe);return ee=!1,oe=Z,ie},V)}u.latch=q;function J(M,x,V){return[u.filter(M,x,V),u.filter(M,ee=>!x(ee),V)]}u.split=J;function j(M,x=!1,V=[]){let ee=V.slice(),oe=M(se=>{ee?ee.push(se):ie.fire(se)});const Z=()=>{ee?.forEach(se=>ie.fire(se)),ee=null},ie=new w({onFirstListenerAdd(){oe||(oe=M(se=>ie.fire(se)))},onFirstListenerDidAdd(){ee&&(x?setTimeout(Z):Z())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}u.buffer=j;class H{constructor(x){this.event=x,this.disposables=new k.DisposableStore}map(x){return new H(S(this.event,x,this.disposables))}forEach(x){return new H(_(this.event,x,this.disposables))}filter(x){return new H($(this.event,x,this.disposables))}reduce(x,V){return new H(R(this.event,x,V,this.disposables))}latch(){return new H(q(this.event,void 0,this.disposables))}debounce(x,V=100,ee=!1,oe){return new H(F(this.event,x,V,ee,oe,this.disposables))}on(x,V,ee){return this.event(x,V,ee)}once(x,V,ee){return m(this.event)(x,V,ee)}dispose(){this.disposables.dispose()}}function W(M){return new H(M)}u.chain=W;function z(M,x,V=ee=>ee){const ee=(...se)=>ie.fire(V(...se)),oe=()=>M.on(x,ee),Z=()=>M.removeListener(x,ee),ie=new w({onFirstListenerAdd:oe,onLastListenerRemove:Z});return ie.event}u.fromNodeEventEmitter=z;function K(M,x,V=ee=>ee){const ee=(...se)=>ie.fire(V(...se)),oe=()=>M.addEventListener(x,ee),Z=()=>M.removeEventListener(x,ee),ie=new w({onFirstListenerAdd:oe,onLastListenerRemove:Z});return ie.event}u.fromDOMEventEmitter=K;function X(M){return new Promise(x=>m(M)(x))}u.toPromise=X;function ce(M,x){return x(void 0),M(V=>x(V))}u.runAndSubscribe=ce;function B(M,x){let V=null;function ee(Z){V?.dispose(),V=new k.DisposableStore,x(Z,V)}ee(void 0);const oe=M(Z=>ee(Z));return(0,k.toDisposable)(()=>{oe.dispose(),V?.dispose()})}u.runAndSubscribeWithStore=B;class G{constructor(x,V){this.obs=x,this._counter=0,this._hasChanged=!1;const ee={onFirstListenerAdd:()=>{x.addObserver(this)},onLastListenerRemove:()=>{x.removeObserver(this)}};V||a(ee),this.emitter=new w(ee),V&&V.add(this.emitter)}beginUpdate(x){this._counter++}handleChange(x,V){this._hasChanged=!0}endUpdate(x){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function O(M,x){return new G(M,x).emitter.event}u.fromObservable=O})(b=e.Event||(e.Event={}));class I{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${I._idPool++}`,I.all.add(this)}start(a){this._stopWatch=new T.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I,I.all=new Set,I._idPool=0;let C=-1;function p(u){const a=C;return C=u,{dispose(){C=a}}}e.setGlobalLeakWarningThreshold=p;class v{constructor(a,m=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,m){let S=C;if(typeof this.customThreshold=="number"&&(S=this.customThreshold),S<=0||m<S)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=S*.5;let $,A=0;for(const[U,R]of this._stacks)(!$||A<R)&&($=U,A=R);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${A}):`),console.warn($)}return()=>{const $=this._stacks.get(a.value)||0;this._stacks.set(a.value,$-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(a,m,S){this.callback=a,this.callbackThis=m,this.stack=S,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class w{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=C>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const m of a)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,m,S)=>{this._listeners||(this._listeners=new L.LinkedList);const _=this._listeners.isEmpty();_&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let $,A;this._leakageMon&&this._listeners.size>=30&&(A=h.create(),$=this._leakageMon.check(A,this._listeners.size+1)),P&&(A=A??h.create());const U=new y(a,m,A),R=this._listeners.push(U);_&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,m);const N=U.subscription.set(()=>{$?.(),this._disposed||(R(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof k.DisposableStore?S.add(N):Array.isArray(S)&&S.push(N),N}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new f);for(const m of this._listeners)this._deliveryQueue.push(this,m,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class d{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(a,m,S){this._queue.push(new c(a,m,S))}clear(a){const m=new L.LinkedList;for(const S of this._queue)S.emitter!==a&&m.push(S);this._queue=m}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(m){(0,D.onUnexpectedError)(m)}}}}e.EventDeliveryQueue=d;class f extends d{clear(a){this._queue.clear()}}class c{constructor(a,m,S){this.emitter=a,this.listener=m,this.event=S}}class g extends w{async fireAsync(a,m,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,a]);for(;this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[_,$]=this._asyncDeliveryQueue.shift(),A=[],U={...$,token:m,waitUntil:R=>{if(Object.isFrozen(A))throw new Error("waitUntil can NOT be called asynchronous");S&&(R=S(R,_.callback)),A.push(R)}};try{_.invoke(U)}catch(R){(0,D.onUnexpectedError)(R);continue}Object.freeze(A),await Promise.allSettled(A).then(R=>{for(const N of R)N.status==="rejected"&&(0,D.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=g;class l extends w{constructor(a){super(a),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=l;class n extends l{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=n;class o extends w{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(m=>super.fire(m)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const m={event:a,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const S=()=>{this.hasListeners&&this.unhook(m);const _=this.events.indexOf(m);this.events.splice(_,1)};return(0,k.toDisposable)((0,r.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(m=>this.emitter.fire(m))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.buffers=[]}wrapEvent(a){return(m,S,_)=>a($=>{const A=this.buffers[this.buffers.length-1];A?A.push(()=>m.call(S,$)):m.call(S,$)},void 0,_)}bufferEvents(a){const m=[];this.buffers.push(m);const S=a();return this.buffers.pop(),m.forEach(_=>_()),S}}e.EventBufferer=i;class s{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=k.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ne[22],re([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const r=Object.freeze(function(P,E){const b=setTimeout(P.bind(E),0);return{dispose(){clearTimeout(b)}}});var k;(function(P){function E(b){return b===P.None||b===P.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=E,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(k=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=k.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(ne[130],re([0,1,22]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class r{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new D.CancellationTokenSource,E=this.task(P.token);return this.result={promise:E,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=r;class k{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const E=JSON.stringify(P);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=k;class L{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const E=this.fn(P);return this._map.set(P,E),E}}e.CachedFunction=L}),define(ne[84],re([0,1,3,2]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=T=>({onDidChange:D.Event.None,value:T});e.staticObservableValue=k;class L extends r.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=L}),define(ne[27],re([0,1,130,117]),function(Q,e,D,r){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=L;const T=/{(\d+)}/g;function P(te,...le){return le.length===0?te:te.replace(T,function(he,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?he:le[Se]})}e.format=P;const E=/{([^}]+)}/g;function b(te,le){return te.replace(E,(he,me)=>le[me]??he)}e.format2=b;function I(te){return te.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=I;function C(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function p(te,le){let he=0;const me=le.charCodeAt(0);for(let Se=te.length-1;Se>=0;Se--)te.charCodeAt(Se)===me&&he++;return he}e.count=p;function v(te,le,he="\u2026"){return te.length<=le?te:`${te.substr(0,le)}${he}`}e.truncate=v;function h(te,le=" "){const he=y(te,le);return w(he,le)}e.trim=h;function y(te,le){if(!te||!le)return te;const he=le.length;if(he===0||te.length===0)return te;let me=0;for(;te.indexOf(le,me)===me;)me=me+he;return te.substring(me)}e.ltrim=y;function w(te,le){if(!te||!le)return te;const he=le.length,me=te.length;if(he===0||me===0)return te;let Se=me,Pe=-1;for(;Pe=te.lastIndexOf(le,Se-1),!(Pe===-1||Pe+he!==Se);){if(Pe===0)return"";Se=Pe}return te.substring(0,Se)}e.rtrim=w;function d(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function f(te){return te.replace(/\*/g,"")}e.stripWildcards=f;function c(te,le,he={}){if(!te)throw new Error("Cannot create regex from empty string");le||(te=C(te)),he.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=c;function g(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function l(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function n(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=n;function o(te){return te.split(/\r\n|\r|\n/)}e.splitLines=o;function t(te){for(let le=0,he=te.length;le<he;le++){const me=te.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function i(te,le=0,he=te.length){for(let me=le;me<he;me++){const Se=te.charCodeAt(me);if(Se!==32&&Se!==9)return te.substring(le,me)}return te.substring(le,he)}e.getLeadingWhitespace=i;function s(te,le=te.length-1){for(let he=le;he>=0;he--){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function u(te,le,he){const me=[];let Se=0;for(const Pe of te.matchAll(le)){if(me.push(te.slice(Se,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Se=Pe.index+Pe[0].length,me.push(he(Pe[0],...Pe.slice(1),Pe.index,te,Pe.groups))}return me.push(te.slice(Se)),Promise.all(me).then(Pe=>Pe.join(""))}e.replaceAsync=u;function a(te,le){return te<le?-1:te>le?1:0}e.compare=a;function m(te,le,he=0,me=te.length,Se=0,Pe=le.length){for(;he<me&&Se<Pe;he++,Se++){const Fe=te.charCodeAt(he),Te=le.charCodeAt(Se);if(Fe<Te)return-1;if(Fe>Te)return 1}const De=me-he,Be=Pe-Se;return De<Be?-1:De>Be?1:0}e.compareSubstring=m;function S(te,le){return _(te,le,0,te.length,0,le.length)}e.compareIgnoreCase=S;function _(te,le,he=0,me=te.length,Se=0,Pe=le.length){for(;he<me&&Se<Pe;he++,Se++){let Fe=te.charCodeAt(he),Te=le.charCodeAt(Se);if(Fe===Te)continue;if(Fe>=128||Te>=128)return m(te.toLowerCase(),le.toLowerCase(),he,me,Se,Pe);A(Fe)&&(Fe-=32),A(Te)&&(Te-=32);const qe=Fe-Te;if(qe!==0)return qe}const De=me-he,Be=Pe-Se;return De<Be?-1:De>Be?1:0}e.compareSubstringIgnoreCase=_;function $(te){return te>=48&&te<=57}e.isAsciiDigit=$;function A(te){return te>=97&&te<=122}e.isLowerAsciiLetter=A;function U(te){return te>=65&&te<=90}e.isUpperAsciiLetter=U;function R(te,le){return te.length===le.length&&_(te,le)===0}e.equalsIgnoreCase=R;function N(te,le){const he=le.length;return le.length>te.length?!1:_(te,le,0,he)===0}e.startsWithIgnoreCase=N;function F(te,le){const he=Math.min(te.length,le.length);let me;for(me=0;me<he;me++)if(te.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=F;function q(te,le){const he=Math.min(te.length,le.length);let me;const Se=te.length-1,Pe=le.length-1;for(me=0;me<he;me++)if(te.charCodeAt(Se-me)!==le.charCodeAt(Pe-me))return me;return he}e.commonSuffixLength=q;function J(te){return 55296<=te&&te<=56319}e.isHighSurrogate=J;function j(te){return 56320<=te&&te<=57343}e.isLowSurrogate=j;function H(te,le){return(te-55296<<10)+(le-56320)+65536}e.computeCodePoint=H;function W(te,le,he){const me=te.charCodeAt(he);if(J(me)&&he+1<le){const Se=te.charCodeAt(he+1);if(j(Se))return H(me,Se)}return me}e.getNextCodePoint=W;function z(te,le){const he=te.charCodeAt(le-1);if(j(he)&&le>1){const me=te.charCodeAt(le-2);if(J(me))return H(me,he)}return he}class K{get offset(){return this._offset}constructor(le,he=0){this._str=le,this._len=le.length,this._offset=he}setOffset(le){this._offset=le}prevCodePoint(){const le=z(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=W(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=K;class X{get offset(){return this._iterator.offset}constructor(le,he=0){this._iterator=new K(le,he)}nextGraphemeLength(){const le=Le.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Pe=he.offset,De=le.getGraphemeBreakType(he.nextCodePoint());if(be(Se,De)){he.setOffset(Pe);break}Se=De}return he.offset-me}prevGraphemeLength(){const le=Le.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Pe=he.offset,De=le.getGraphemeBreakType(he.prevCodePoint());if(be(De,Se)){he.setOffset(Pe);break}Se=De}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function ce(te,le){return new X(te,le).nextGraphemeLength()}e.nextCharLength=ce;function B(te,le){return new X(te,le).prevGraphemeLength()}e.prevCharLength=B;function G(te,le){le>0&&j(te.charCodeAt(le))&&le--;const he=le+ce(te,le);return[he-B(te,he),he]}e.getCharContainingOffset=G;function O(te){const le=new X(te);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=O;let M;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function V(te){return M||(M=x()),M.test(te)}e.containsRTL=V;const ee=/^[\t\n\r\x20-\x7E]*$/;function oe(te){return ee.test(te)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=Z;function ie(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ie;function se(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=se;function ue(te,le){if(te.length<le)return te;const he=/\b/g;let me=0;for(;he.test(te)&&!(te.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=ue;const de=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Ee(te){return te&&(te=te.replace(de,""),te=te.replace(ve,""),te=te.replace(we,"")),te}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ue(te){return Ce(te)?te.substr(1):te}e.stripUTF8BOM=Ue;function $e(te,le){if(!te||!le||te.length<le.length)return!1;const he=le.length,me=te.toLowerCase();let Se=0,Pe=-1;for(;Se<he;){const De=me.indexOf(le[Se],Pe+1);if(De<0)return!1;Pe=De,Se++}return!0}e.fuzzyContains=$e;function He(te,le=!1){return te?(le&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=He;function We(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=We;function ae(te,le=1){if(le===0)return"";let he=-1;do he=te.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?te:(te[he-1]==="\r"&&he--,te.substr(0,he))}e.getNLines=ae;function fe(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=fe;function ge(te){return Le.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function be(te,le){return te===0?le!==5&&le!==7:te===2&&le===3?!1:te===4||te===2||te===3||le===4||le===2||le===3?!0:!(te===8&&(le===8||le===9||le===11||le===12)||(te===11||te===9)&&(le===9||le===10)||(te===12||te===10)&&le===10||le===5||le===13||le===7||te===1||te===13&&le===14||te===6&&le===6)}var Ie;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=Re()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this._data,me=he.length/3;let Se=1;for(;Se<=me;)if(le<he[3*Se])Se=2*Se;else if(le>he[3*Se+1])Se=2*Se+1;else return he[3*Se+2];return 0}}Le._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(te,le){if(te===0)return 0;const he=Ae(te,le);if(he!==void 0)return he;const me=new K(le,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Ne;function Ae(te,le){const he=new K(le,te);let me=he.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!se(me))return;let Se=he.offset;return Se>0&&he.prevCodePoint()===8205&&(Se=he.offset),Se}function Me(te){return 127995<=te&&te<=127999}var ze;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(le){return ke.cache.get(Array.from(le))}static getLocales(){return ke._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ke,k=ke,ke.ambiguousCharacterData=new r.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.cache=new D.LRUCachedFunction(te=>{function le(Te){const qe=new Map;for(let xe=0;xe<Te.length;xe+=2)qe.set(Te[xe],Te[xe+1]);return qe}function he(Te,qe){const xe=new Map(Te);for(const[Ze,rt]of qe)xe.set(Ze,rt);return xe}function me(Te,qe){if(!Te)return qe;const xe=new Map;for(const[Ze,rt]of Te)qe.has(Ze)&&xe.set(Ze,rt);return xe}const Se=k.ambiguousCharacterData.getValue();let Pe=te.filter(Te=>!Te.startsWith("_")&&Te in Se);Pe.length===0&&(Pe=["_default"]);let De;for(const Te of Pe){const qe=le(Se[Te]);De=me(De,qe)}const Be=le(Se._common),Fe=he(Be,De);return new ke(Fe)}),ke._locales=new r.Lazy(()=>Object.keys(ke.ambiguousCharacterData.getValue()).filter(te=>!te.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(le){return _e.getData().has(le)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ne[47],re([0,1,12,4,27,15]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function P(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function E(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=E;function b(s,u=D.posix.sep){if(!s)return"";const a=s.length,m=s.charCodeAt(0);if(T(m)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let _=3;const $=_;for(;_<a&&!T(s.charCodeAt(_));_++);if($!==_&&!T(s.charCodeAt(_+1))){for(_+=1;_<a;_++)if(T(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,u)}}return u}else if(d(m)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+u:s.slice(0,2);let S=s.indexOf("://");if(S!==-1){for(S+=3;S<a;S++)if(T(s.charCodeAt(S)))return s.slice(0,S+1)}return""}e.getRoot=b;function I(s){if(!r.isWindows||!s||s.length<5)return!1;let u=s.charCodeAt(0);if(u!==92||(u=s.charCodeAt(1),u!==92))return!1;let a=2;const m=a;for(;a<s.length&&(u=s.charCodeAt(a),u!==92);a++);return!(m===a||(u=s.charCodeAt(a+1),isNaN(u)||u===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,u=r.isWindows){const a=u?C:p;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||u&&v.test(s)||s==="."||s===".."||u&&s[s.length-1]==="."||u&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function y(s,u,a){const m=s===u;return!a||m?m:!s||!u?!1:(0,k.equalsIgnoreCase)(s,u)}e.isEqual=y;function w(s,u,a,m=D.sep){if(s===u)return!0;if(!s||!u||u.length>s.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(s,u))return!1;if(u.length===s.length)return!0;let _=u.length;return u.charAt(u.length-1)===m&&_--,s.charAt(_)===m}return u.charAt(u.length-1)!==m&&(u+=m),s.indexOf(u)===0}e.isEqualOrParent=w;function d(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=d;function f(s,u){return r.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(u,s)),s=(0,D.normalize)(s),r.isWindows?(s=(0,k.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,k.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=f;function c(s){const u=(0,D.normalize)(s);return r.isWindows?s.length>3?!1:g(u)&&(s.length===2||u.charCodeAt(2)===92):u===D.posix.sep}e.isRootOrDriveLetter=c;function g(s,u=r.isWindows){return u?d(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function l(s){return g(s)?s[0]:void 0}e.getDriveLetter=l;function n(s,u,a){return u.length>s.length?-1:s===u?0:(a&&(s=s.toLowerCase(),u=u.toLowerCase()),s.indexOf(u))}e.indexOfPath=n;function o(s){const u=s.split(":");let a,m,S;for(const _ of u){const $=Number(_);(0,L.isNumber)($)?m===void 0?m=$:S===void 0&&(S=$):a=a?[a,_].join(":"):_}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:m!==void 0?m:void 0,column:S!==void 0?S:m!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,u,a=8){let m="";for(let _=0;_<a;_++)m+=t.charAt(Math.floor(Math.random()*t.length));let S;return u?S=`${u}-${m}`:S=m,s?(0,D.join)(s,S):S}e.randomPath=i}),define(ne[65],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function r(d){return k(d,0)}e.hash=r;function k(d,f){switch(typeof d){case"object":return d===null?L(349,f):Array.isArray(d)?E(d,f):b(d,f);case"string":return P(d,f);case"boolean":return T(d,f);case"number":return L(d,f);case"undefined":return L(937,f);default:return L(617,f)}}e.doHash=k;function L(d,f){return(f<<5)-f+d|0}e.numberHash=L;function T(d,f){return L(d?433:863,f)}function P(d,f){f=L(149417,f);for(let c=0,g=d.length;c<g;c++)f=L(d.charCodeAt(c),f);return f}e.stringHash=P;function E(d,f){return f=L(104579,f),d.reduce((c,g)=>k(g,c),f)}function b(d,f){return f=L(181387,f),Object.keys(d).sort().reduce((c,g)=>(c=P(g,c),k(d[g],c)),f)}class I{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=k(f,this._value),this._value}}e.Hasher=I;var C;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function p(d,f,c=32){const g=c-f,l=~((1<<g)-1);return(d<<f|(l&d)>>>g)>>>0}function v(d,f=0,c=d.byteLength,g=0){for(let l=0;l<c;l++)d[f+l]=g}function h(d,f,c="0"){for(;d.length<f;)d=c+d;return d}function y(d,f=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(c=>c.toString(16).padStart(2,"0")).join(""):h((d>>>0).toString(16),f/4)}e.toHexString=y;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const c=f.length;if(c===0)return;const g=this._buff;let l=this._buffLen,n=this._leftoverHighSurrogate,o,t;for(n!==0?(o=n,t=-1,n=0):(o=f.charCodeAt(0),t=0);;){let i=o;if(D.isHighSurrogate(o))if(t+1<c){const s=f.charCodeAt(t+1);D.isLowSurrogate(s)?(t++,i=D.computeCodePoint(o,s)):i=65533}else{n=o;break}else D.isLowSurrogate(o)&&(i=65533);if(l=this._push(g,l,i),t++,t<c)o=f.charCodeAt(t);else break}this._buffLen=l,this._leftoverHighSurrogate=n}_push(f,c,g){return g<128?f[c++]=g:g<2048?(f[c++]=192|(g&1984)>>>6,f[c++]=128|(g&63)>>>0):g<65536?(f[c++]=224|(g&61440)>>>12,f[c++]=128|(g&4032)>>>6,f[c++]=128|(g&63)>>>0):(f[c++]=240|(g&1835008)>>>18,f[c++]=128|(g&258048)>>>12,f[c++]=128|(g&4032)>>>6,f[c++]=128|(g&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=w._bigBlock32,c=this._buffDV;for(let a=0;a<64;a+=4)f.setUint32(a,c.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)f.setUint32(a,p(f.getUint32(a-12,!1)^f.getUint32(a-32,!1)^f.getUint32(a-56,!1)^f.getUint32(a-64,!1),1),!1);let g=this._h0,l=this._h1,n=this._h2,o=this._h3,t=this._h4,i,s,u;for(let a=0;a<80;a++)a<20?(i=l&n|~l&o,s=1518500249):a<40?(i=l^n^o,s=1859775393):a<60?(i=l&n|l&o|n&o,s=2400959708):(i=l^n^o,s=3395469782),u=p(g,5)+i+t+s+f.getUint32(a*4,!1)&4294967295,t=o,o=n,n=p(l,30),l=g,g=u;this._h0=this._h0+g&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],re([0,1,18,27]),function(Q,e,D,r){"use strict";var k,L,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,i,s){let u=t.get(i);return u===void 0&&(u=s,t.set(i,u)),u}e.getOrSet=P;function E(t){const i=[];return t.forEach((s,u)=>{i.push(`${u} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=E;function b(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=b;class I{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=I;class C{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,r.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class p{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const u=this._value.charCodeAt(s);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,r.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var v;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(i,s){this._ignorePathCasing=i,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,r.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,r.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,r.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,r.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(w||(w={}));class d{static forUris(i=()=>!1,s=()=>!1){return new d(new h(i,s))}static forPaths(i=!1){return new d(new p(void 0,!i))}static forStrings(){return new d(new I)}static forConfigKeys(){return new d(new C)}constructor(i){this._iter=i}clear(){this._root=void 0}fill(i,s){if(s){const u=s.slice(0);(0,D.shuffle)(u);for(const a of u)this.set(a,i)}else{const u=i.slice(0);(0,D.shuffle)(u);for(const a of u)this.set(a[0],a[1])}}set(i,s){const u=this._iter.reset(i);let a;this._root||(this._root=new y,this._root.segment=u.value());const m=[];for(a=this._root;;){const _=u.cmp(a.segment);if(_>0)a.left||(a.left=new y,a.left.segment=u.value()),m.push([-1,a]),a=a.left;else if(_<0)a.right||(a.right=new y,a.right.segment=u.value()),m.push([1,a]),a=a.right;else if(u.hasNext())u.next(),a.mid||(a.mid=new y,a.mid.segment=u.value()),m.push([0,a]),a=a.mid;else break}const S=a.value;a.value=s,a.key=i;for(let _=m.length-1;_>=0;_--){const $=m[_][1];$.updateHeight();const A=$.balanceFactor();if(A<-1||A>1){const U=m[_][0],R=m[_+1][0];if(U===1&&R===1)m[_][1]=$.rotateLeft();else if(U===-1&&R===-1)m[_][1]=$.rotateRight();else if(U===1&&R===-1)$.right=m[_+1][1]=m[_+1][1].rotateRight(),m[_][1]=$.rotateLeft();else if(U===-1&&R===1)$.left=m[_+1][1]=m[_+1][1].rotateLeft(),m[_][1]=$.rotateRight();else throw new Error;if(_>0)switch(m[_-1][0]){case-1:m[_-1][1].left=m[_][1];break;case 1:m[_-1][1].right=m[_][1];break;case 0:m[_-1][1].mid=m[_][1];break}else this._root=m[0][1]}}return S}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let u=this._root;for(;u;){const a=s.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const u=this._iter.reset(i),a=[];let m=this._root;for(;m;){const S=u.cmp(m.segment);if(S>0)a.push([-1,m]),m=m.left;else if(S<0)a.push([1,m]),m=m.right;else if(u.hasNext())u.next(),a.push([0,m]),m=m.mid;else break}if(!!m){if(s?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const S=this._min(m.right);if(S.key){const{key:_,value:$,segment:A}=S;this._delete(S.key,!1),m.key=_,m.value=$,m.segment=A}}else{const S=m.left??m.right;if(a.length>0){const[_,$]=a[a.length-1];switch(_){case-1:$.left=S;break;case 0:$.mid=S;break;case 1:$.right=S;break}}else this._root=S}for(let S=a.length-1;S>=0;S--){const _=a[S][1];_.updateHeight();const $=_.balanceFactor();if($>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),a[S][1]=_.rotateLeft()):$<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),a[S][1]=_.rotateRight()),S>0)switch(a[S-1][0]){case-1:a[S-1][1].left=a[S][1];break;case 1:a[S-1][1].right=a[S][1];break;case 0:a[S-1][1].mid=a[S][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let u=this._root,a;for(;u;){const m=s.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(s.hasNext())s.next(),a=u.value||a,u=u.mid;else break}return u&&u.value||a}findSuperstr(i){const s=this._iter.reset(i);let u=this._root;for(;u;){const a=s.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[s,u]of this)i(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const s=[];return this._dfsEntries(i,s),s[Symbol.iterator]()}_dfsEntries(i,s){!i||(i.left&&this._dfsEntries(i.left,s),i.value&&s.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,s),i.right&&this._dfsEntries(i.right,s))}_isBalanced(){const i=s=>{if(!s)return!0;const u=s.balanceFactor();return u<-1||u>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=d;class f{constructor(i,s){this.uri=i,this.value=s}}class c{constructor(i,s){this[k]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new f(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[u,a]of this.map)i(a.value,a.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=t=>t.toString();class g{constructor(i,s){this[L]="ResourceSet",!i||typeof i=="function"?this._map=new c(i):(this._map=new c(s),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,s){this._map.forEach((u,a)=>i.call(s,a,a,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=g;var l;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class n{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const u=this._map.get(i);if(!!u)return s!==0&&this.touch(u,s),u.value}set(i,s,u=0){let a=this._map.get(i);if(a)a.value=s,u!==0&&this.touch(a,u);else{switch(a={key:i,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const u=this._state;let a=this._head;for(;a;){if(s?i.bind(s)(a.value,a.key,this):i(a.value,a.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,s=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:u.key,done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return a}values(){const i=this,s=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:u.value,done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return a}entries(){const i=this,s=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:[u.key,u.value],done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>i;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,u=i.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const u=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(u.previous=a,a.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const u=i.next,a=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=a,a.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,u)=>{i.push([u,s])}),i}fromJSON(i){this.clear();for(const[s,u]of i)this.set(s,u)}}e.LinkedMap=n;class o extends n{constructor(i,s=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(ne[85],re([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const r=new D.LRUCache(1e4);function k(b){return E(b,"NFC",r)}e.normalizeNFC=k;const L=new D.LRUCache(1e4);function T(b){return E(b,"NFD",L)}e.normalizeNFD=T;const P=/[^\u0000-\u0080]/;function E(b,I,C){if(!b)return b;const p=C.get(b);if(p)return p;let v;return P.test(b)?v=b.normalize(I):v=b,C.set(b,v),v}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(I){return T(I).replace(b,"")}}()}),define(ne[86],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var r;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(r||(r={})),function(k){const L="error",T="warning",P="warn",E="info",b="ignore";function I(p){return p?D.equalsIgnoreCase(L,p)?k.Error:D.equalsIgnoreCase(T,p)||D.equalsIgnoreCase(P,p)?k.Warning:D.equalsIgnoreCase(E,p)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function C(p){switch(p){case k.Error:return L;case k.Warning:return T;case k.Info:return E;default:return b}}k.toString=C}(r||(r={})),e.default=r}),define(ne[7],re([0,1,12,4]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,L=/^\//,T=/^\/\//;function P(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!k.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(t,i){return!t&&!i?"file":t}function b(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const I="",C="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(i){return i instanceof v?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,s,u,a,m,S=!1){typeof i=="object"?(this.scheme=i.scheme||I,this.authority=i.authority||I,this.path=i.path||I,this.query=i.query||I,this.fragment=i.fragment||I):(this.scheme=E(i,S),this.authority=s||I,this.path=b(this.scheme,u||I),this.query=a||I,this.fragment=m||I,P(this,S))}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:u,path:a,query:m,fragment:S}=i;return s===void 0?s=this.scheme:s===null&&(s=I),u===void 0?u=this.authority:u===null&&(u=I),a===void 0?a=this.path:a===null&&(a=I),m===void 0?m=this.query:m===null&&(m=I),S===void 0?S=this.fragment:S===null&&(S=I),s===this.scheme&&u===this.authority&&a===this.path&&m===this.query&&S===this.fragment?this:new y(s,u,a,m,S)}static parse(i,s=!1){const u=p.exec(i);return u?new y(u[2]||I,o(u[4]||I),o(u[5]||I),o(u[7]||I),o(u[9]||I),s):new y(I,I,I,I,I)}static file(i){let s=I;if(r.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const u=i.indexOf(C,2);u===-1?(s=i.substring(2),i=C):(s=i.substring(2,u),i=i.substring(u)||C)}return new y("file",s,i,I,I)}static from(i){const s=new y(i.scheme,i.authority,i.path,i.query,i.fragment);return P(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return r.isWindows&&i.scheme==="file"?u=v.file(D.win32.join(c(i,!0),...s)).path:u=D.posix.join(i.path,...s),i.with({path:u})}toString(i=!1){return g(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof v)return i;{const s=new y(i);return s._formatted=i.external,s._fsPath=i._sep===h?i.fsPath:null,s}}else return i}}e.URI=v;const h=r.isWindows?1:void 0;class y extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=h),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(t,i){let s,u=-1;for(let a=0;a<t.length;a++){const m=t.charCodeAt(a);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||i&&m===47)u!==-1&&(s+=encodeURIComponent(t.substring(u,a)),u=-1),s!==void 0&&(s+=t.charAt(a));else{s===void 0&&(s=t.substr(0,a));const S=w[m];S!==void 0?(u!==-1&&(s+=encodeURIComponent(t.substring(u,a)),u=-1),s+=S):u===-1&&(u=a)}}return u!==-1&&(s+=encodeURIComponent(t.substring(u))),s!==void 0?s:t}function f(t){let i;for(let s=0;s<t.length;s++){const u=t.charCodeAt(s);u===35||u===63?(i===void 0&&(i=t.substr(0,s)),i+=w[u]):i!==void 0&&(i+=t[s])}return i!==void 0?i:t}function c(t,i){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,r.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function g(t,i){const s=i?f:d;let u="",{scheme:a,authority:m,path:S,query:_,fragment:$}=t;if(a&&(u+=a,u+=":"),(m||a==="file")&&(u+=C,u+=C),m){let A=m.indexOf("@");if(A!==-1){const U=m.substr(0,A);m=m.substr(A+1),A=U.indexOf(":"),A===-1?u+=s(U,!1):(u+=s(U.substr(0,A),!1),u+=":",u+=s(U.substr(A+1),!1)),u+="@"}m=m.toLowerCase(),A=m.indexOf(":"),A===-1?u+=s(m,!1):(u+=s(m.substr(0,A),!1),u+=m.substr(A))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const A=S.charCodeAt(1);A>=65&&A<=90&&(S=`/${String.fromCharCode(A+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const A=S.charCodeAt(0);A>=65&&A<=90&&(S=`${String.fromCharCode(A+32)}:${S.substr(2)}`)}u+=s(S,!0)}return _&&(u+="?",u+=s(_,!1)),$&&(u+="#",u+=i?$:d($,!1)),u}function l(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+l(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(n)?t.replace(n,i=>l(i)):t}}),define(ne[131],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function r(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=r;function k(b){const I=[];let C;try{const p=JSON.parse(b.arguments),v=p[p.length-1];v&&v.__$stack&&(p.pop(),C=v.__$stack),I.push(...p)}catch{I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:C}}e.parse=k;function L(b){if(typeof b!="string")return L(k(b).stack);const I=b;if(I){const C=T(I),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function T(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function P(b,I){const{args:C,stack:p}=k(b),v=typeof C[0]=="string"&&C.length===1;let h=T(p);h&&(h=`(${h.trim()})`);let y=[];if(typeof C[0]=="string"?h&&v?y=[`%c[${I}] %c${C[0]} %c${h}`,E("blue"),E(""),E("grey")]:y=[`%c[${I}] %c${C[0]}`,E("blue"),E(""),...C.slice(1)]:y=[`%c[${I}]%`,E("blue"),...C],h&&!v&&y.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,y)}e.log=P;function E(b){return`color: ${b}`}}),define(ne[66],re([0,1,16,27,7]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(b){return JSON.stringify(b,P)}e.stringify=L;function T(b){let I=JSON.parse(b);return I=E(I),I}e.parse=T;function P(b,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,r.regExpFlags)(I)}:I}function E(b,I=0){if(!b||I>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return k.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof D.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let C=0;C<b.length;++C)b[C]=E(b[C],I+1);else for(const C in b)Object.hasOwnProperty.call(b,C)&&(b[C]=E(b[C],I+1))}return b}e.revive=E}),define(ne[23],re([0,1,4,7]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${k.vscodeRemoteResource}`}set(b,I,C){this._hosts[b]=I,this._ports[b]=C}setConnectionToken(b,I){this._connectionTokens[b]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const I=b.authority;let C=this._hosts[I];C&&C.indexOf(":")!==-1&&C.indexOf("[")===-1&&(C=`[${C}]`);const p=this._ports[I],v=this._connectionTokens[I];let h=`path=${encodeURIComponent(b.path)}`;return typeof v=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),r.URI.from({scheme:D.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${C}:${p}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new L;class T{asBrowserUri(b,I){const C=this.toUri(b,I);return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(b,I){const C=this.toUri(b,I);return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==T.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(b,I){return r.URI.isUri(b)?b:r.URI.parse(I.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var P;(function(E){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(b.get("3"));const I="vscode-coi";function C(v){let h;typeof v=="string"?h=new URL(v).searchParams:v instanceof URL?h=v.searchParams:r.URI.isUri(v)&&(h=new URL(v.toString(!0)).searchParams);const y=h?.get(I);if(!!y)return b.get(y)}E.getHeadersFromQuery=C;function p(v,h,y){if(!globalThis.crossOriginIsolated)return;const w=h&&y?"3":y?"2":"1";v instanceof URLSearchParams?v.set(I,w):v[I]=w}E.addSearchParam=p})(P=e.COI||(e.COI={}))}),define(ne[19],re([0,1,47,23,12,4,27,7]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(v){return(0,P.uriToFsPath)(v,!0)}e.originalFSPath=E;class b{constructor(h){this._ignorePathCasing=h}compare(h,y,w=!1){return h===y?0:(0,T.compare)(this.getComparisonKey(h,w),this.getComparisonKey(y,w))}isEqual(h,y,w=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,w)===this.getComparisonKey(y,w)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,w=!1){if(h.scheme===y.scheme){if(h.scheme===r.Schemas.file)return D.isEqualOrParent(E(h),E(y),this._ignorePathCasing(h))&&h.query===y.query&&(w||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return D.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(w||h.fragment===y.fragment)}return!1}joinPath(h,...y){return P.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===r.Schemas.file?y=P.URI.file(k.dirname(E(h))).path:(y=k.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===r.Schemas.file?y=P.URI.file(k.normalize(E(h))).path:y=k.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===r.Schemas.file){const f=k.relative(E(h),E(y));return L.isWindows?D.toSlashes(f):f}let w=h.path||"/";const d=y.path||"/";if(this._ignorePathCasing(h)){let f=0;for(const c=Math.min(w.length,d.length);f<c&&!(w.charCodeAt(f)!==d.charCodeAt(f)&&w.charAt(f).toLowerCase()!==d.charAt(f).toLowerCase());f++);w=d.substr(0,f)+w.substr(f)}return k.posix.relative(w,d)}resolvePath(h,y){if(h.scheme===r.Schemas.file){const w=P.URI.file(k.resolve(E(h),y));return h.with({authority:w.authority,path:w.path})}return y=D.toPosixPath(y),h.with({path:k.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,T.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=k.sep){if(h.scheme===r.Schemas.file){const w=E(h);return w.length>D.getRoot(w).length&&w[w.length-1]===y}else{const w=h.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=k.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=k.sep){let w=!1;if(h.scheme===r.Schemas.file){const d=E(h);w=d!==void 0&&d.length===D.getRoot(d).length&&d[d.length-1]===y}else{y="/";const d=h.path;w=d.length===1&&d.charCodeAt(d.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(v=>v.scheme===r.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new b(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(v,h){const y=[];for(let w=0;w<v.length;w++){const d=h(v[w]);v.some((f,c)=>c===w?!1:(0,e.isEqualOrParent)(d,h(f)))||y.push(v[w])}return y}e.distinctParents=I;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(y){const w=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(c=>{const[g,l]=c.split(":");g&&l&&w.set(g,l)});const f=y.path.substring(0,y.path.indexOf(";"));return f&&w.set(v.META_DATA_MIME,f),w}v.parseMetaData=h})(C=e.DataUri||(e.DataUri={}));function p(v,h,y){if(h){let w=v.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),v.with({scheme:y,authority:h,path:w})}return v.with({scheme:y})}e.toLocalResource=p}),define(ne[6],re([0,1,22,9,3,2,19,4]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(G){return!!G&&typeof G.then=="function"}e.isThenable=E;function b(G){const O=new D.CancellationTokenSource,M=G(O.token),x=new Promise((V,ee)=>{const oe=O.token.onCancellationRequested(()=>{oe.dispose(),O.dispose(),ee(new r.CancellationError)});Promise.resolve(M).then(Z=>{oe.dispose(),O.dispose(),V(Z)},Z=>{oe.dispose(),O.dispose(),ee(Z)})});return new class{cancel(){O.cancel()}then(V,ee){return x.then(V,ee)}catch(V){return this.then(void 0,V)}finally(V){return x.finally(V)}}}e.createCancelablePromise=b;function I(G,O,M){return new Promise((x,V)=>{const ee=O.onCancellationRequested(()=>{ee.dispose(),x(M)});G.then(x,V).finally(()=>ee.dispose())})}e.raceCancellation=I;function C(G,O){return new Promise((M,x)=>{const V=O.onCancellationRequested(()=>{V.dispose(),x(new r.CancellationError)});G.then(M,x).finally(()=>V.dispose())})}e.raceCancellationError=C;async function p(G){let O=-1;const M=G.map((V,ee)=>V.then(oe=>(O=ee,oe))),x=await Promise.race(M);return G.forEach((V,ee)=>{ee!==O&&V.cancel()}),x}e.raceCancellablePromises=p;function v(G,O,M){let x;const V=setTimeout(()=>{x?.(void 0),M?.()},O);return Promise.race([G.finally(()=>clearTimeout(V)),new Promise(ee=>x=ee)])}e.raceTimeout=v;function h(G){return new Promise((O,M)=>{const x=G();E(x)?x.then(O,M):O(x)})}e.asPromise=h;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(M,M).then(x)})}return new Promise((M,x)=>{this.queuedPromise.then(M,x)})}return this.activePromise=O(),new Promise((M,x)=>{this.activePromise.then(V=>{this.activePromise=null,M(V)},V=>{this.activePromise=null,x(V)})})}}e.Throttler=y;class w{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=w;class d{constructor(){this.promiseMap=new Map}queue(O,M){const V=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(O)===V&&this.promiseMap.delete(O)});return this.promiseMap.set(O,V),V}}e.SequencerByKey=d;const f=(G,O)=>{let M=!0;const x=setTimeout(()=>{M=!1,O()},G);return{isTriggered:()=>M,dispose:()=>{clearTimeout(x),M=!1}}},c=G=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,G())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,M=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,ee)=>{this.doResolve=V,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const x=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?c(x):f(M,x),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new r.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class l{constructor(O){this.delayer=new g(O),this.throttler=new y}trigger(O,M){return this.delayer.trigger(()=>this.throttler.queue(O),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class n{constructor(){this._isOpen=!1,this._promise=new Promise((O,M)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class o extends n{constructor(O){super(),this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function t(G,O){return O?new Promise((M,x)=>{const V=setTimeout(()=>{ee.dispose(),M()},G),ee=O.onCancellationRequested(()=>{clearTimeout(V),ee.dispose(),x(new r.CancellationError)})}):b(M=>t(G,M))}e.timeout=t;function i(G,O=0){const M=setTimeout(G,O);return(0,L.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=i;function s(G){const O=[];let M=0;const x=G.length;function V(){return M<x?G[M++]():null}function ee(oe){oe!=null&&O.push(oe);const Z=V();return Z?Z.then(ee):Promise.resolve(O)}return Promise.resolve(null).then(ee)}e.sequence=s;function u(G,O=x=>!!x,M=null){let x=0;const V=G.length,ee=()=>{if(x>=V)return Promise.resolve(M);const oe=G[x++];return Promise.resolve(oe()).then(ie=>O(ie)?Promise.resolve(ie):ee())};return ee()}e.first=u;function a(G,O=x=>!!x,M=null){if(G.length===0)return Promise.resolve(M);let x=G.length;const V=()=>{x=-1;for(const ee of G)ee.cancel?.()};return new Promise((ee,oe)=>{for(const Z of G)Z.then(ie=>{--x>=0&&O(ie)?(V(),ee(ie)):x===0&&ee(M)}).catch(ie=>{--x>=0&&(V(),oe(ie))})})}e.firstParallel=a;class m{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((M,x)=>{this.outstandingPromises.push({factory:O,c:M,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const M=O.factory();M.then(O.c,O.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class S extends m{constructor(){super(1)}}e.Queue=S;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new W;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,M=T.extUri){const x=M.getComparisonKey(O);let V=this.queues.get(x);return V||(V=new S,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(x),this.onDidQueueDrain()}),this.queues.set(x,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class ${constructor(O,M){this._token=-1,typeof O=="function"&&typeof M=="number"&&this.setIfNotSet(O,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},M)}setIfNotSet(O,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},M))}}e.TimeoutTimer=$;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setInterval(()=>{O()},M)}}e.IntervalTimer=A;class U{constructor(O,M){this.timeoutToken=-1,this.runner=O,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class R{constructor(O,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=R;class N extends U{constructor(O,M){super(O,M),this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class F extends L.Disposable{constructor(O,M){super(),this.options=O,this.handler=M,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,P.setTimeout0)(()=>{if(O)return;const M=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(G,O)=>{const M=requestIdleCallback(G,typeof O=="number"?{timeout:O}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(M))}}}}();class q{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function J(G,O,M){let x;for(let V=0;V<M;V++)try{return await G()}catch(ee){x=ee,await t(O)}throw x}e.retry=J;class j{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(O,M,x){return this._pending={taskId:O,cancel:()=>x?.(),promise:M},M.then(()=>this.donePending(O),()=>this.donePending(O)),M}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let M,x;const V=new Promise((ee,oe)=>{M=ee,x=oe});this._next={run:O,promise:V,promiseResolve:M,promiseReject:x}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=j;class H{constructor(O,M=()=>Date.now()){this.interval=O,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class W{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,M)=>{this.completeCallback=O,this.errorCallback=M})}complete(O){return new Promise(M=>{this.completeCallback(O),this.resolved=!0,M()})}error(O){return new Promise(M=>{this.errorCallback(O),this.rejected=!0,M()})}cancel(){new Promise(O=>{this.errorCallback(new r.CancellationError),this.rejected=!0,O()})}}e.DeferredPromise=W;var z;(function(G){async function O(x){let V;const ee=await Promise.all(x.map(oe=>oe.then(Z=>Z,Z=>{V||(V=Z)})));if(typeof V<"u")throw V;return ee}G.settled=O;function M(x){return new Promise(async(V,ee)=>{try{await x(V,ee)}catch(oe){ee(oe)}})}G.withAsyncBody=M})(z=e.Promises||(e.Promises={}));var K;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(K||(K={}));class X{static fromArray(O){return new X(M=>{M.emitMany(O)})}static fromPromise(O){return new X(async M=>{M.emitMany(await O)})}static fromPromises(O){return new X(async M=>{await Promise.all(O.map(async x=>M.emitOne(await x)))})}static merge(O){return new X(async M=>{await Promise.all(O.map(async x=>{for await(const V of x)M.emitOne(V)}))})}constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const M={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(O(M)),this.resolve()}catch(x){this.reject(x)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,M){return new X(async x=>{for await(const V of O)x.emitOne(M(V))})}map(O){return X.map(this,O)}static filter(O,M){return new X(async x=>{for await(const V of O)M(V)&&x.emitOne(V)})}filter(O){return X.filter(this,O)}static coalesce(O){return X.filter(O,M=>!!M)}coalesce(){return X.coalesce(this)}static async toPromise(O){const M=[];for await(const x of O)M.push(x);return M}toPromise(){return X.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class ce extends X{constructor(O,M){super(M),this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function B(G){const O=new D.CancellationTokenSource,M=G(O.token);return new ce(O,async x=>{const V=O.token.onCancellationRequested(()=>{V.dispose(),O.dispose(),x.reject(new r.CancellationError)});try{for await(const ee of M){if(O.token.isCancellationRequested)return;x.emitOne(ee)}V.dispose(),O.dispose()}catch(ee){V.dispose(),O.dispose(),x.reject(ee)}})}e.createCancelableAsyncIterable=B}),define(ne[87],re([0,1,18,6,47,34,12,4,27]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",C="[^/\\\\]",p=/\//g;function v(W,z){switch(W){case 0:return"";case 1:return`${C}*?`;default:return`(?:${I}|${C}+${I}${z?`|${I}${C}+`:""})*?`}}function h(W,z){if(!W)return[];const K=[];let X=!1,ce=!1,B="";for(const G of W){switch(G){case z:if(!X&&!ce){K.push(B),B="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}B+=G}return B&&K.push(B),K}e.splitGlobAware=h;function y(W){if(!W)return"";let z="";const K=h(W,e.GLOB_SPLIT);if(K.every(X=>X===e.GLOBSTAR))z=".*";else{let X=!1;K.forEach((ce,B)=>{if(ce===e.GLOBSTAR){if(X)return;z+=v(2,B===K.length-1)}else{let G=!1,O="",M=!1,x="";for(const V of ce){if(V!=="}"&&G){O+=V;continue}if(M&&(V!=="]"||!x)){let ee;V==="-"?ee=V:(V==="^"||V==="!")&&!x?ee="^":V===e.GLOB_SPLIT?ee="":ee=(0,E.escapeRegExpCharacters)(V),x+=ee;continue}switch(V){case"{":G=!0;continue;case"[":M=!0;continue;case"}":{z+=`(?:${h(O,",").map(Z=>y(Z)).join("|")})`,G=!1,O="";break}case"]":{z+="["+x+"]",M=!1,x="";break}case"?":z+=C;continue;case"*":z+=v(1);continue;default:z+=(0,E.escapeRegExpCharacters)(V)}}B<K.length-1&&(K[B+1]!==e.GLOBSTAR||B+2<K.length)&&(z+=I)}X=ce===e.GLOBSTAR})}return z}const w=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),o=function(){return!1},t=function(){return null};function i(W,z){if(!W)return t;let K;typeof W!="string"?K=W.pattern:K=W,K=K.trim();const X=`${K}_${!!z.trimForExclusions}`;let ce=n.get(X);if(ce)return s(ce,W);let B;return w.test(K)?ce=a(K.substr(4),K):(B=d.exec(u(K,z)))?ce=m(B[1],K):(z.trimForExclusions?c:f).test(K)?ce=S(K,z):(B=g.exec(u(K,z)))?ce=_(B[1].substr(1),K,!0):(B=l.exec(u(K,z)))?ce=_(B[1],K,!1):ce=$(K),n.set(X,ce),s(ce,W)}function s(W,z){if(typeof z=="string")return W;const K=function(X,ce){return(0,k.isEqualOrParent)(X,z.base,!P.isLinux)?W(X.substr(z.base.length+1),ce):null};return K.allBasenames=W.allBasenames,K.allPaths=W.allPaths,K.basenames=W.basenames,K.patterns=W.patterns,K}function u(W,z){return z.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function a(W,z){return function(K,X){return typeof K=="string"&&K.endsWith(W)?z:null}}function m(W,z){const K=`/${W}`,X=`\\${W}`,ce=function(G,O){return typeof G!="string"?null:O?O===W?z:null:G===W||G.endsWith(K)||G.endsWith(X)?z:null},B=[W];return ce.basenames=B,ce.patterns=[z],ce.allBasenames=B,ce}function S(W,z){const K=j(W.slice(1,-1).split(",").map(O=>i(O,z)).filter(O=>O!==t),W),X=K.length;if(!X)return t;if(X===1)return K[0];const ce=function(O,M){for(let x=0,V=K.length;x<V;x++)if(K[x](O,M))return W;return null},B=K.find(O=>!!O.allBasenames);B&&(ce.allBasenames=B.allBasenames);const G=K.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return G.length&&(ce.allPaths=G),ce}function _(W,z,K){const X=T.sep===T.posix.sep,ce=X?W:W.replace(p,T.sep),B=T.sep+ce,G=T.posix.sep+W;let O;return K?O=function(M,x){return typeof M=="string"&&(M===ce||M.endsWith(B)||!X&&(M===W||M.endsWith(G)))?z:null}:O=function(M,x){return typeof M=="string"&&(M===ce||!X&&M===W)?z:null},O.allPaths=[(K?"*/":"./")+W],O}function $(W){try{const z=new RegExp(`^${y(W)}$`);return function(K){return z.lastIndex=0,typeof K=="string"&&z.test(K)?W:null}}catch{return t}}function A(W,z,K){return!W||typeof z!="string"?!1:U(W)(z,void 0,K)}e.match=A;function U(W,z={}){if(!W)return o;if(typeof W=="string"||R(W)){const K=i(W,z);if(K===t)return o;const X=function(ce,B){return!!K(ce,B)};return K.allBasenames&&(X.allBasenames=K.allBasenames),K.allPaths&&(X.allPaths=K.allPaths),X}return q(W,z)}e.parse=U;function R(W){const z=W;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=R;function N(W){return W.allBasenames||[]}e.getBasenameTerms=N;function F(W){return W.allPaths||[]}e.getPathTerms=F;function q(W,z){const K=j(Object.getOwnPropertyNames(W).map(O=>J(O,W[O],z)).filter(O=>O!==t)),X=K.length;if(!X)return t;if(!K.some(O=>!!O.requiresSiblings)){if(X===1)return K[0];const O=function(V,ee){let oe;for(let Z=0,ie=K.length;Z<ie;Z++){const se=K[Z](V,ee);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(oe||(oe=[]),oe.push(se))}return oe?(async()=>{for(const Z of oe){const ie=await Z;if(typeof ie=="string")return ie}return null})():null},M=K.find(V=>!!V.allBasenames);M&&(O.allBasenames=M.allBasenames);const x=K.reduce((V,ee)=>ee.allPaths?V.concat(ee.allPaths):V,[]);return x.length&&(O.allPaths=x),O}const ce=function(O,M,x){let V,ee;for(let oe=0,Z=K.length;oe<Z;oe++){const ie=K[oe];ie.requiresSiblings&&x&&(M||(M=(0,T.basename)(O)),V||(V=M.substr(0,M.length-(0,T.extname)(O).length)));const se=ie(O,M,V,x);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(ee||(ee=[]),ee.push(se))}return ee?(async()=>{for(const oe of ee){const Z=await oe;if(typeof Z=="string")return Z}return null})():null},B=K.find(O=>!!O.allBasenames);B&&(ce.allBasenames=B.allBasenames);const G=K.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return G.length&&(ce.allPaths=G),ce}function J(W,z,K){if(z===!1)return t;const X=i(W,K);if(X===t)return t;if(typeof z=="boolean")return X;if(z){const ce=z.when;if(typeof ce=="string"){const B=(G,O,M,x)=>{if(!x||!X(G,O))return null;const V=ce.replace("$(basename)",M),ee=x(V);return(0,r.isThenable)(ee)?ee.then(oe=>oe?W:null):ee?W:null};return B.requiresSiblings=!0,B}}return X}function j(W,z){const K=W.filter(O=>!!O.basenames);if(K.length<2)return W;const X=K.reduce((O,M)=>{const x=M.basenames;return x?O.concat(x):O},[]);let ce;if(z){ce=[];for(let O=0,M=X.length;O<M;O++)ce.push(z)}else ce=K.reduce((O,M)=>{const x=M.patterns;return x?O.concat(x):O},[]);const B=function(O,M){if(typeof O!="string")return null;if(!M){let V;for(V=O.length;V>0;V--){const ee=O.charCodeAt(V-1);if(ee===47||ee===92)break}M=O.substr(V)}const x=X.indexOf(M);return x!==-1?ce[x]:null};B.basenames=X,B.patterns=ce,B.allBasenames=X;const G=W.filter(O=>!O.basenames);return G.push(B),G}function H(W,z){return(0,D.equals)(W,z,(K,X)=>typeof K=="string"&&typeof X=="string"?K===X:typeof K!="string"&&typeof X!="string"?K.base===X.base&&K.pattern===X.pattern:!1)}e.patternsEquals=H}),define(ne[132],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(I){return I.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const p=this._uriTransformer.transformIncoming(C);return p===C?C:r(D.URI.from(p))}transformOutgoing(C){const p=this._uriTransformer.transformOutgoing(C);return p===C?C:r(D.URI.from(p))}transformOutgoingURI(C){const p=this._uriTransformer.transformOutgoing(C);return p===C?C:D.URI.from(p)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,C,p){if(!I||p>200)return null;if(typeof I=="object"){if(I instanceof D.URI)return C.transformOutgoing(I);for(const v in I)if(Object.hasOwnProperty.call(I,v)){const h=L(I[v],C,p+1);h!==null&&(I[v]=h)}}return null}function T(I,C){const p=L(I,C,0);return p===null?I:p}e.transformOutgoingURIs=T;function P(I,C,p,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return p?D.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(const h in I)if(Object.hasOwnProperty.call(I,h)){const y=P(I[h],C,p,v+1);y!==null&&(I[h]=y)}}return null}function E(I,C){const p=P(I,C,!1,0);return p===null?I:p}e.transformIncomingURIs=E;function b(I,C){const p=P(I,C,!0,0);return p===null?I:p}e.transformAndReviveIncomingURIs=b}),define(ne[133],re([0,1,36,9,34,30,119]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,C=0;const p=(0,D.networkInterfaces)();for(const v in p){const h=p[v];if(h)for(const{mac:y,internal:w}of h)w||(C+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(I+=1))}this._value=C>0?I/C:0}return this._value}};let P;async function E(){return P||(P=(async()=>await b()||L.generateUuid())()),P}e.getMachineId=E;async function b(){try{const I=await new Promise((p,v)=>{Q(["crypto"],p,v)}),C=(0,T.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){r.onUnexpectedError(I);return}}}),define(ne[28],re([0,1,53,36,274,6,47,85,12,4,19,7]),function(Q,e,D,r,k,L,T,P,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function v(q,J=p.UNLINK){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return J===p.UNLINK?y(q):h(q)}async function h(q){try{const J=(0,T.randomPath)((0,r.tmpdir)());try{await D.promises.rename(q,J)}catch(j){return j.code==="ENOENT"?void 0:y(q)}y(J).catch(j=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function y(q){return(0,k.promisify)(D.rm)(q,{recursive:!0,force:!0,maxRetries:3})}function w(q){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function d(q,J){return g(await(J?f(q):(0,k.promisify)(D.readdir)(q)))}async function f(q){try{return await(0,k.promisify)(D.readdir)(q,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const J=[],j=await d(q);for(const H of j){let W=!1,z=!1,K=!1;try{const X=await e.Promises.lstat((0,E.join)(q,H));W=X.isFile(),z=X.isDirectory(),K=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}J.push({name:H,isFile:()=>W,isDirectory:()=>z,isSymbolicLink:()=>K})}return J}function c(q){return g(D.readdirSync(q))}e.readdirSync=c;function g(q){return q.map(J=>typeof J=="string"?b.isMacintosh?(0,P.normalizeNFC)(J):J:(J.name=b.isMacintosh?(0,P.normalizeNFC)(J.name):J.name,J))}async function l(q){const J=await d(q),j=[];for(const H of J)await o.existsDirectory((0,E.join)(q,H))&&j.push(H);return j}function n(q,J=1e3){return new Promise(j=>{let H=!1;const W=setInterval(()=>{H||(H=!0,D.access(q,z=>{H=!1,z&&(clearInterval(W),j(void 0))}))},J)})}e.whenDeleted=n;var o;(function(q){async function J(W){let z;try{if(z=await e.Promises.lstat(W),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(b.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw X}throw K}}q.stat=J;async function j(W){try{const{stat:z,symbolicLink:K}=await q.stat(W);return z.isFile()&&K?.dangling!==!0}catch{}return!1}q.existsFile=j;async function H(W){try{const{stat:z,symbolicLink:K}=await q.stat(W);return z.isDirectory()&&K?.dangling!==!0}catch{}return!1}q.existsDirectory=H})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function i(q,J,j){return t.queueFor(C.URI.file(q),I.extUriBiasedIgnorePathCase).queue(()=>{const H=S(j);return new Promise((W,z)=>a(q,J,H,K=>K?z(K):W()))})}let s=!0;function u(q){s=q}e.configureFlushOnWrite=u;function a(q,J,j,H){if(!s)return D.writeFile(q,J,{mode:j.mode,flag:j.flag},H);D.open(q,j.flag,j.mode,(W,z)=>{if(W)return H(W);D.writeFile(z,J,K=>{if(K)return D.close(z,()=>H(K));D.fdatasync(z,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),u(!1)),D.close(z,ce=>H(ce))))})})}function m(q,J,j){const H=S(j);if(!s)return D.writeFileSync(q,J,{mode:H.mode,flag:H.flag});const W=D.openSync(q,H.flag,H.mode);try{D.writeFileSync(W,J);try{D.fdatasyncSync(W)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),u(!1)}}finally{D.closeSync(W)}}e.writeFileSync=m;function S(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function _(q,J){if(q!==J)try{await e.Promises.rename(q,J)}catch(j){if(q.toLowerCase()!==J.toLowerCase()&&j.code==="EXDEV"||q.endsWith("."))await $(q,J,{preserveSymlinks:!1}),await v(q,p.MOVE);else throw j}}async function $(q,J,j){return U(q,J,{root:{source:q,target:J},options:j,handledSourcePaths:new Set})}const A=511;async function U(q,J,j){if(j.handledSourcePaths.has(q))return;j.handledSourcePaths.add(q);const{stat:H,symbolicLink:W}=await o.stat(q);if(W){if(j.options.preserveSymlinks)try{return await F(q,J,j)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(W.dangling)return}return H.isDirectory()?R(q,J,H.mode&A,j):N(q,J,H.mode&A)}async function R(q,J,j,H){await e.Promises.mkdir(J,{recursive:!0,mode:j});const W=await d(q);for(const z of W)await U((0,E.join)(q,z),(0,E.join)(J,z),H)}async function N(q,J,j){await e.Promises.copyFile(q,J),await e.Promises.chmod(J,j)}async function F(q,J,j){let H=await e.Promises.readlink(q);(0,T.isEqualOrParent)(H,j.root.source,!b.isLinux)&&(H=(0,E.join)(j.root.target,H.substr(j.root.source.length+1))),await e.Promises.symlink(H,J)}e.Promises=new class{get access(){return(0,k.promisify)(D.access)}get stat(){return(0,k.promisify)(D.stat)}get lstat(){return(0,k.promisify)(D.lstat)}get utimes(){return(0,k.promisify)(D.utimes)}get read(){return(q,J,j,H,W)=>new Promise((z,K)=>{D.read(q,J,j,H,W,(X,ce,B)=>X?K(X):z({bytesRead:ce,buffer:B}))})}get readFile(){return(0,k.promisify)(D.readFile)}get write(){return(q,J,j,H,W)=>new Promise((z,K)=>{D.write(q,J,j,H,W,(X,ce,B)=>X?K(X):z({bytesWritten:ce,buffer:B}))})}get appendFile(){return(0,k.promisify)(D.appendFile)}get fdatasync(){return(0,k.promisify)(D.fdatasync)}get truncate(){return(0,k.promisify)(D.truncate)}get rename(){return(0,k.promisify)(D.rename)}get copyFile(){return(0,k.promisify)(D.copyFile)}get open(){return(0,k.promisify)(D.open)}get close(){return(0,k.promisify)(D.close)}get symlink(){return(0,k.promisify)(D.symlink)}get readlink(){return(0,k.promisify)(D.readlink)}get chmod(){return(0,k.promisify)(D.chmod)}get mkdir(){return(0,k.promisify)(D.mkdir)}get unlink(){return(0,k.promisify)(D.unlink)}get rmdir(){return(0,k.promisify)(D.rmdir)}get realpath(){return(0,k.promisify)(D.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return v}get move(){return _}get copy(){return $}}}),define(ne[134],re([0,1,53,12,4,27,28]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(p){if(k.isLinux)return p;const v=(0,r.dirname)(p);if(p===v)return p;const h=((0,r.basename)(p)||p).toLowerCase();try{const w=(0,T.readdirSync)(v).filter(d=>d.toLowerCase()===h);if(w.length===1){const d=P(v);if(d)return(0,r.join)(d,w[0])}else if(w.length>1){const d=w.indexOf(h);if(d>=0){const f=P(v);if(f)return(0,r.join)(f,w[d])}}}catch{}return null}e.realcaseSync=P;async function E(p){if(k.isLinux)return p;const v=(0,r.dirname)(p);if(p===v)return p;const h=((0,r.basename)(p)||p).toLowerCase();try{const w=(await T.Promises.readdir(v)).filter(d=>d.toLowerCase()===h);if(w.length===1){const d=await E(v);if(d)return(0,r.join)(d,w[0])}else if(w.length>1){const d=w.indexOf(h);if(d>=0){const f=await E(v);if(f)return(0,r.join)(f,w[d])}}}catch{}return null}e.realcase=E;async function b(p){try{return await T.Promises.realpath(p)}catch{const h=C(p);return await T.Promises.access(h,D.constants.R_OK),h}}e.realpath=b;function I(p){try{return D.realpathSync(p)}catch{const h=C(p);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=I;function C(p){return(0,L.rtrim)((0,r.normalize)(p),r.sep)}}),define(ne[88],re([0,1,36,12,28]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var E;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(E||(E={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(l,n,o){this.exePath=l,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:g=!1}={}){return g?b===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:g=!1,findPreview:l=!1}={}){const n=p({useAlternateBitness:g});if(!n)return null;const o=r.join(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const a of await k.Promises.readdir(o)){let m=-1;if(l){const _=a.indexOf("-");if(_<0)continue;const $=a.substring(0,_);if(!L.test($)||a.substring(_+1)!=="preview")continue;m=parseInt($,10)}else{if(!L.test(a))continue;m=parseInt(a,10)}if(m<=t)continue;const S=r.join(o,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(S)||(i=S,t=m)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",u=l?" Preview":"";return new C(i,`PowerShell${u}${s}`,!0)}async function h({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const l=r.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=g?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(l))if(n.test(t)){const i=r.join(l,t,"pwsh.exe");return new C(i,o)}return null}function y(){const g=r.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(g,".NET Core PowerShell Global Tool")}function w(){const g=r.join(process.env.windir,b===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(g,"Windows PowerShell",!0)}async function*d(){let g=await v();g&&(yield g),g=await v({useAlternateBitness:!0}),g&&(yield g),g=await h(),g&&(yield g),g=y(),g&&(yield g),g=await v({findPreview:!0}),g&&(yield g),g=await h({findPreview:!0}),g&&(yield g),g=await v({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=w(),g&&(yield g)}async function*f(){for await(const g of d())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=f;async function c(){for await(const g of f())return g;return null}e.getFirstAvailablePowerShellInstallation=c}),define(ne[89],re([0,1,12,4,37,83,15,28]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(C=k.env){return C.comspec||"cmd.exe"}e.getWindowsShell=E;function b(C){let p=[],v=!1;const h=function(y){if(v){p.push(y);return}(!C.send(y,d=>{if(d&&console.error(d),v=!1,p.length>0){const f=p.slice(0);p=[],f.forEach(c=>h(c))}})||r.isWindows)&&(v=!0)};return{send:h}}e.createQueuedSender=b;var I;(function(C){async function p(v,h,y){if(D.isAbsolute(v))return v;if(h===void 0&&(h=k.cwd()),D.dirname(v)!=="."||(y===void 0&&T.isString(k.env.PATH)&&(y=k.env.PATH.split(D.delimiter)),y===void 0||y.length===0))return D.join(h,v);async function d(f){if(await P.Promises.exists(f)){let c;try{c=await P.Promises.stat(f)}catch(g){g.message.startsWith("EACCES")&&(c=await P.Promises.lstat(f))}return c?!c.isDirectory():!1}return!1}for(const f of y){let c;if(D.isAbsolute(f)?c=D.join(f,v):c=D.join(h,f,v),await d(c))return c;let g=c+".com";if(await d(g)||(g=c+".exe",await d(g)))return g}return D.join(h,v)}C.findExecutable=p})(I=e.win32||(e.win32={}))}),define(ne[135],re([0,1,54,23]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(T){return new Promise((P,E)=>{let b;const I=new Map;function C(v,h,y,w,d){const f=I.get(h);if(v===T||f){const c={name:p(y),cmd:y,pid:v,ppid:h,load:w,mem:d};I.set(v,c),v===T&&(b=c),f&&(f.children||(f.children=[]),f.children.push(c),f.children.length>1&&(f.children=f.children.sort((g,l)=>g.pid-l.pid)))}}function p(v){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,f=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,g=/\\pipe\\winpty-control/,l=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(c.exec(v))return"electron-crash-reporter";if(g.exec(v))return"winpty-process";if(l.exec(v))return"console-window-host (Windows internal process)";let o=n.exec(v);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(v)?"shared-process":y.exec(v)?"issue-reporter":w.exec(v)?"process-explorer":"window";if(o[1]==="utility"){if(d.exec(v))return"utility-network-service";if(f.exec(v))return"extension-host"}return o[1]}const t=/[a-zA-Z-]+\.js/g;let i="";do o=t.exec(v),o&&(i+=o+" ");while(o);return i&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${i}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{Q(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(T,y=>{if(!y){E(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(y,w=>{const d=new Map;w.forEach(f=>{const c=v(f.commandLine||"");d.set(f.pid,{name:p(c),cmd:c,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),b=d.get(T),b?(d.forEach(f=>{const c=d.get(f.ppid);c&&(c.children||(c.children=[]),c.children.push(f))}),d.forEach(f=>{f.children&&(f.children=f.children.sort((c,g)=>c.pid-g.pid))}),P(b)):E(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[b];const y=[];for(;h.length;){const d=h.shift();d&&(y.push(d.pid),d.children&&(h=h.concat(d.children)))}let w=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);w+=" "+y.join(" "),(0,D.exec)(w,{},(d,f,c)=>{if(d||c)E(d||new Error(c.toString()));else{const g=f.toString().split(`
`);for(let l=0;l<y.length;l++){const n=I.get(y[l]);n.load=parseFloat(g[l])}if(!b){E(new Error(`Root process ${T} not found`));return}P(b)}})};(0,D.exec)("which ps",{},(h,y,w)=>{if(h||w)if(process.platform!=="linux")E(h||new Error(w.toString()));else{const d=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(d,{},(f,c,g)=>{f||g?E(f||new Error(g.toString())):(L(c,C),v())})}else{const d=y.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${d} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,g,l)=>{c||l&&!l.includes("screen size is bogus")?E(c||new Error(l.toString())):(L(g,C),process.platform==="linux"?v():b?P(b):E(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=k;function L(T,P){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const I of b){const C=E.exec(I.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(ne[136],re([0,1,36,4,88,89]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(v,h){return v===1?r.isWindows?C():L.getWindowsShell(h):b(v,h)}e.getSystemShell=T;function P(v,h){return v===1?r.isWindows?p(h):L.getWindowsShell(h):b(v,h)}e.getSystemShellSync=P;let E=null;function b(v,h){if(r.isLinux&&v===2||r.isMacintosh&&v===3)return"/bin/bash";if(!E){let y;if(r.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,D.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}E=y}return E}let I=null;async function C(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function p(v){if(I)return I;const h=r.isWindows&&parseFloat((0,D.release)())>=10,y=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${v.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?w:L.getWindowsShell(v)}});var pe=this&&this.__decorate||function(Q,e,D,r){var k=arguments.length,L=k<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,D):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,D,r);else for(var P=Q.length-1;P>=0;P--)(T=Q[P])&&(L=(k<3?T(L):k>3?T(e,D,L):T(e,D))||L);return k>3&&L&&Object.defineProperty(e,D,L),L};define(ne[39],re([0,1,18,6,16,22,63,9,3,2,66,27,15]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function w(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(d||(d={}));class f{constructor(z){this.buffer=z,this.pos=0}read(z){const K=this.buffer.slice(this.pos,this.pos+z);return this.pos+=K.byteLength,K}}class c{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var g;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(g||(g={}));function l(W){const z=k.VSBuffer.alloc(4);return z.writeUInt32BE(W,0),z}function n(W){return W.read(4).readUInt32BE(0)}function o(W){const z=k.VSBuffer.alloc(1);return z.writeUInt8(W,0),z}const t={Undefined:o(g.Undefined),String:o(g.String),Buffer:o(g.Buffer),VSBuffer:o(g.VSBuffer),Array:o(g.Array),Object:o(g.Object)},i=typeof Buffer<"u";function s(W,z){if(typeof z>"u")W.write(t.Undefined);else if(typeof z=="string"){const K=k.VSBuffer.fromString(z);W.write(t.String),W.write(l(K.byteLength)),W.write(K)}else if(i&&Buffer.isBuffer(z)){const K=k.VSBuffer.wrap(z);W.write(t.Buffer),W.write(l(K.byteLength)),W.write(K)}else if(z instanceof k.VSBuffer)W.write(t.VSBuffer),W.write(l(z.byteLength)),W.write(z);else if(Array.isArray(z)){W.write(t.Array),W.write(l(z.length));for(const K of z)s(W,K)}else{const K=k.VSBuffer.fromString(JSON.stringify(z));W.write(t.Object),W.write(l(K.byteLength)),W.write(K)}}function u(W){switch(W.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return W.read(n(W)).toString();case g.Buffer:return W.read(n(W)).buffer;case g.VSBuffer:return W.read(n(W));case g.Array:{const K=n(W),X=[];for(let ce=0;ce<K;ce++)X.push(u(W));return X}case g.Object:return JSON.parse(W.read(n(W)).toString())}}class a{constructor(z,K,X=null,ce=1e3){this.protocol=z,this.ctx=K,this.logger=X,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(z,K){this.channels.set(z,K),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const K=this.send([z.type]);this.logger?.logOutgoing(K,0,1,w(z.type));return}case 201:case 202:case 204:case 203:{const K=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(K,z.id,1,w(z.type),z.data);return}}}send(z,K=void 0){const X=new c;return s(X,z),s(X,K),this.sendBuffer(X.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const K=new f(z),X=u(K),ce=u(K),B=X[0];switch(B){case 100:return this.logger?.logIncoming(z.byteLength,X[1],1,`${h(B)}: ${X[2]}.${X[3]}`,ce),this.onPromise({type:B,id:X[1],channelName:X[2],name:X[3],arg:ce});case 102:return this.logger?.logIncoming(z.byteLength,X[1],1,`${h(B)}: ${X[2]}.${X[3]}`,ce),this.onEventListen({type:B,id:X[1],channelName:X[2],name:X[3],arg:ce});case 101:return this.logger?.logIncoming(z.byteLength,X[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:X[1]});case 103:return this.logger?.logIncoming(z.byteLength,X[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:X[1]})}}onPromise(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const X=new L.CancellationTokenSource;let ce;try{ce=K.call(this.ctx,z.name,z.arg,X.token)}catch(O){ce=Promise.reject(O)}const B=z.id;ce.then(O=>{this.sendResponse({id:B,data:O,type:201}),this.activeRequests.delete(z.id)},O=>{O instanceof Error?this.sendResponse({id:B,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:B,data:O,type:203}),this.activeRequests.delete(z.id)});const G=(0,b.toDisposable)(()=>X.cancel());this.activeRequests.set(z.id,G)}onEventListen(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const X=z.id,B=K.listen(this.ctx,z.name,z.arg)(G=>this.sendResponse({id:X,data:G,type:204}));this.activeRequests.set(z.id,B)}disposeActiveRequest(z){const K=this.activeRequests.get(z.id);K&&(K.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let K=this.pendingRequests.get(z.channelName);K||(K=[],this.pendingRequests.set(z.channelName,K));const X=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:z,timeoutTimer:X})}flushPendingRequests(z){const K=this.pendingRequests.get(z);if(K){for(const X of K)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.onPromise(X.request);break;case 102:this.onEventListen(X.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var m;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(z,K=null){this.protocol=z,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(X=>this.onBuffer(X)),this.logger=K}getChannel(z){const K=this;return{call(X,ce,B){return K.isDisposed?Promise.reject(new P.CancellationError):K.requestPromise(z,X,ce,B)},listen(X,ce){return K.isDisposed?E.Event.None:K.requestEvent(z,X,ce)}}}requestPromise(z,K,X,ce=L.CancellationToken.None){const B=this.lastRequestId++,O={id:B,type:100,channelName:z,name:K,arg:X};if(ce.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((V,ee)=>{if(ce.isCancellationRequested)return ee(new P.CancellationError);const oe=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(B),V(de.data);break;case 202:{this.handlers.delete(B);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,ee(ve);break}case 203:this.handlers.delete(B),ee(de.data);break}};this.handlers.set(B,ue),this.sendRequest(O)};let Z=null;this.state===d.Idle?oe():(Z=(0,r.createCancelablePromise)(ue=>this.whenInitialized()),Z.then(()=>{Z=null,oe()}));const ie=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:B,type:101}),ee(new P.CancellationError)},se=ce.onCancellationRequested(ie);M=(0,b.combinedDisposable)((0,b.toDisposable)(ie),se),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(z,K,X){const ce=this.lastRequestId++,G={id:ce,type:102,channelName:z,name:K,arg:X};let O=null;const M=new E.Emitter({onFirstListenerAdd:()=>{O=(0,r.createCancelablePromise)(V=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(M),this.sendRequest(G)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(M),this.sendRequest({id:ce,type:103}))}}),x=V=>M.fire(V.data);return this.handlers.set(ce,x),M.event}sendRequest(z){switch(z.type){case 100:case 102:{const K=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger?.logOutgoing(K,z.id,0,`${h(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.send([z.type,z.id]);this.logger?.logOutgoing(K,z.id,0,h(z.type));return}}}send(z,K=void 0){const X=new c;return s(X,z),s(X,K),this.sendBuffer(X.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const K=new f(z),X=u(K),ce=u(K),B=X[0];switch(B){case 200:return this.logger?.logIncoming(z.byteLength,0,0,w(B)),this.onResponse({type:X[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(z.byteLength,X[1],0,w(B),ce),this.onResponse({type:X[0],id:X[1],data:ce})}}onResponse(z){if(z.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(z.id)?.(z)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([T.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class _{get connections(){const z=[];return this._connections.forEach(K=>z.push(K)),z}constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:K,onDidClientDisconnect:X})=>{E.Event.once(K.onMessage)(B=>{const G=new f(B),O=u(G),M=new a(K,O),x=new S(K);this.channels.forEach((ee,oe)=>M.registerChannel(oe,ee));const V={channelServer:M,channelClient:x,ctx:O};this._connections.add(V),this._onDidAddConnection.fire(V),X(()=>{M.dispose(),x.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}getChannel(z,K){const X=this;return{call(ce,B,G){let O;if((0,p.isFunction)(K)){const x=(0,D.getRandomElement)(X.connections.filter(K));O=x?Promise.resolve(x):E.Event.toPromise(E.Event.filter(X.onDidAddConnection,K))}else O=K.routeCall(X,ce,B);const M=O.then(x=>x.channelClient.getChannel(z));return A(M).call(ce,B,G)},listen(ce,B){if((0,p.isFunction)(K))return X.getMulticastEvent(z,K,ce,B);const G=K.routeEvent(X,ce,B).then(O=>O.channelClient.getChannel(z));return A(G).listen(ce,B)}}}getMulticastEvent(z,K,X,ce){const B=this;let G=new b.DisposableStore;const O=new E.Emitter({onFirstListenerAdd:()=>{G=new b.DisposableStore;const M=new E.EventMultiplexer,x=new Map,V=oe=>{const ie=oe.channelClient.getChannel(z).listen(X,ce),se=M.add(ie);x.set(oe,se)},ee=oe=>{const Z=x.get(oe);!Z||(Z.dispose(),x.delete(oe))};B.connections.filter(K).forEach(V),E.Event.filter(B.onDidAddConnection,K)(V,void 0,G),B.onDidRemoveConnection(ee,void 0,G),M.event(O.fire,O,G),G.add(M)},onLastListenerRemove:()=>{G.dispose()}});return O.event}registerChannel(z,K){this.channels.set(z,K),this._connections.forEach(X=>{X.channelServer.registerChannel(z,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class ${constructor(z,K,X=null){const ce=new c;s(ce,K),z.send(ce.buffer),this.channelClient=new S(z,X),this.channelServer=new a(z,K,X)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,K){this.channelServer.registerChannel(z,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=$;function A(W){return{call(z,K,X){return W.then(ce=>ce.call(z,K,X))},listen(z,K){const X=new E.Relay;return W.then(ce=>X.input=ce.listen(z,K)),X.event}}}e.getDelayedChannel=A;function U(W){let z=!1;return{call(K,X,ce){return z?W.call(K,X,ce):(0,r.timeout)(0).then(()=>z=!0).then(()=>W.call(K,X,ce))},listen(K,X){if(z)return W.listen(K,X);const ce=new E.Relay;return(0,r.timeout)(0).then(()=>z=!0).then(()=>ce.input=W.listen(K,X)),ce.event}}}e.getNextTickChannel=U;class R{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const K of z.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await E.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=R;var N;(function(W){function z(B,G){const O=B,M=G&&G.disableMarshalling,x=new Map;for(const V in O)X(V)&&x.set(V,E.Event.buffer(O[V],!0));return new class{listen(V,ee,oe){const Z=x.get(ee);if(Z)return Z;if(ce(ee)){const ie=O[ee];if(typeof ie=="function")return ie.call(O,oe)}throw new Error(`Event not found: ${ee}`)}call(V,ee,oe){const Z=O[ee];if(typeof Z=="function"){if(!M&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,I.revive)(oe[ie]);return Z.apply(O,oe)}throw new Error(`Method not found: ${ee}`)}}}W.fromService=z;function K(B,G){const O=G&&G.disableMarshalling;return new Proxy({},{get(M,x){if(typeof x=="string")return G?.properties?.has(x)?G.properties.get(x):ce(x)?function(V){return B.listen(x,V)}:X(x)?B.listen(x):async function(...V){let ee;G&&!(0,p.isUndefinedOrNull)(G.context)?ee=[G.context,...V]:ee=V;const oe=await B.call(x,ee);return O?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(x)}`)}})}W.toService=K;function X(B){return B[0]==="o"&&B[1]==="n"&&C.isUpperAsciiLetter(B.charCodeAt(2))}function ce(B){return/^onDynamic/.test(B)&&C.isUpperAsciiLetter(B.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const z=W.toString();if(z!=="[object Object]")return z}return W}function J(W){return Array.isArray(W)?W.map(q):q(W)}function j(W,z,K,X,ce,B,G){G=J(G);const O=F[ce],M=O[X%O.length];let x=[`%c[${W}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(B)?(x=x.concat(G),x.push(")")):x.push(G),console.log.apply(console,x)}e.logWithColors=j;class H{constructor(z,K){this._outgoingPrefix=z,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,K,X,ce,B){this._totalOutgoing+=z,j(this._outgoingPrefix,this._totalOutgoing,z,K,X,ce,B)}logIncoming(z,K,X,ce,B){this._totalIncoming+=z,j(this._incomingPrefix,this._totalIncoming,z,K,X,ce,B)}}e.IPCLogger=H}),define(ne[137],re([0,1,16,3,39]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(E){this.port=E,this.onMessage=r.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class T extends k.IPCClient{constructor(E,b){const I=new L(E);super(I,b),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[90],re([0,1,16,3,2,39]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let u=0;function a(S,_){if(!s.has(S)){const $=String(++u);s.set(S,$)}return s.get(S)}function m(S,_,$,A){if(!i.enableDiagnostics)return;const U=a(S,_);if(A instanceof D.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const R=D.VSBuffer.alloc(A.byteLength);R.set(A),i.records.push({timestamp:Date.now(),id:U,label:_,type:$,buff:R})}else i.records.push({timestamp:Date.now(),id:U,label:_,type:$,data:A})}i.traceSocketEvent=m})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function I(){return b||(b=D.VSBuffer.alloc(0)),b}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,u){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const _=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=s),_}if(this._chunks[0].byteLength>s){const _=this._chunks[0].slice(0,s);return u&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),_}const a=D.VSBuffer.alloc(s);let m=0,S=0;for(;s>0;){const _=this._chunks[S];if(_.byteLength>s){const $=_.slice(0,s);a.set($,m),m+=s,u&&(this._chunks[S]=_.slice(s),this._totalLength-=s),s-=s}else a.set(_,m),m+=_.byteLength,u?(this._chunks.shift(),this._totalLength-=_.byteLength):S++,s-=_.byteLength}return a}}e.ChunkStream=C;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function v(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(s,u,a,m){this.type=s,this.id=u,this.ack=a,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,m=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new y(a,m,S,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=D.VSBuffer.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(u,s.data)}_bufferAdd(s,u){const a=this._totalLength===0;return this._data.push(s,u),this._totalLength+=s.byteLength+u.byteLength,a}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,u){this._bufferAdd(s,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class f extends k.Disposable{constructor(s){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new y(1,0,0,s))}}e.Protocol=f;class c extends L.IPCClient{static fromSocket(s,u){return new c(new f(s),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,u,a=null){super(s,u,a),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class l{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,u=this._first;for(;u;)u=u.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let u=0,a=this._first;for(;a;)s[u++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const u=new l(s);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let u=0;u<o._HISTORY_LENGTH;u++)this.lastRuns[u]=s-1e3*u;setInterval(()=>{for(let u=o._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),u=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let m=0;m<o._HISTORY_LENGTH;m++)s-this.lastRuns[m]<=u&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class t{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,u=null,a=o.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),u&&this._socketReader.acceptChunk(u),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new y(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new y(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new y(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,u){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,I());this._socketWriter.write(s);const u=this._outgoingUnackMsg.toArray();for(let a=0,m=u.length;a<m;a++)this._socketWriter.write(u[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new y(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let a=0,m=u.length;a<m;a++)this._socketWriter.write(u[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new y(1,u,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const u=new y(2,0,0,s);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),u=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&a>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:a});return}const S=Math.max(2e4-u,2e4-a,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,I());this._socketWriter.write(s)}_sendKeepAlive(){const s=new y(9,0,0,I());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(ne[138],re([0,1,91,3,39,137]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends k.IPCServer{static getOnDidClientConnect(){const E=r.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,I)=>I);return r.Event.map(E,b=>{const{port1:I,port2:C}=new MessageChannel,v={protocol:new L.Protocol(I),onDidClientDisconnect:r.Event.fromDOMEventEmitter(I,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[C]),v})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[67],re([0,1,54,6,16,22,131,9,3,2,32,89,83,39]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(d){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",f=>k.VSBuffer.wrap(Buffer.from(f,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=h;class y{constructor(d,f){this.modulePath=d,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new r.Delayer(c),this.child=null,this._client=null}getChannel(d){const f=this;return{call(c,g,l){return f.requestPromise(d,c,g,l)},listen(c,g){return f.requestEvent(d,c,g)}}}requestPromise(d,f,c,g=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(d),n=(0,r.createCancelablePromise)(i=>l.call(f,c,i)),o=g.onCancellationRequested(()=>n.cancel()),t=(0,b.toDisposable)(()=>n.cancel());return this.activeRequests.add(t),n.finally(()=>{o.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(d,f,c){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let g;const l=new E.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(d).listen(f,c)(l.fire,l),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,p.removeDangerousEnvVariables)(f.env),this.child=(0,D.fork)(this.modulePath,d,f);const c=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.options.serverName}`);return}c.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const l=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&l.send(s.buffer.toString("base64")),o=c.event,t={send:n,onMessage:o};this._client=new v.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,u)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,b.dispose)(a)),this.activeRequests.clear(),s!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:u})})}return this._client}getCachedChannel(d){let f=this.channels.get(d);return f||(f=this.client.getChannel(d),this.channels.set(d,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(ne[139],re([0,1,16,9,3,2,12,4,30,39,90]),function(Q,e,D,r,k,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class p{traceSocketEvent(a,m){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,m)}constructor(a,m=""){this._canWrite=!0,this.debugLabel=m,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=S=>{if(this.traceSocketEvent("error",{code:S?.code,message:S?.message}),S){if(S.code==="EPIPE")return;(0,r.onUnexpectedError)(S)}},this.socket.on("error",this._errorListener),this._closeListener=S=>{this.traceSocketEvent("close",{hadError:S}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const m=S=>{this.traceSocketEvent("read",S),a(D.VSBuffer.wrap(S))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(a){const m=S=>{a({type:0,hadError:S,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(a){const m=()=>{a()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,r.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,r.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const S=()=>{this.socket.off("close",S),this.socket.off("end",S),this.socket.off("error",S),this.socket.off("timeout",S),this.socket.off("drain",S),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",S),this.socket.on("end",S),this.socket.on("error",S),this.socket.on("timeout",S),this.socket.on("drain",S)})}}e.NodeSocket=p;var v;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var h;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(h||(h={}));class y extends L.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,m){this.socket.traceSocketEvent(a,m)}constructor(a,m,S,_){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:S?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new w(this,m,S,_,this._onData,($,A)=>this._write($,A))),this._register(this._flowManager.onError($=>{console.error($),(0,r.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,m){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let S=2;a.byteLength<126?S+=0:a.byteLength<2**16?S+=2:S+=8;const _=D.VSBuffer.alloc(S);if(m?_.writeUInt8(194,0):_.writeUInt8(130,0),a.byteLength<126)_.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){_.writeUInt8(126,1);let $=1;_.writeUInt8(a.byteLength>>>8&255,++$),_.writeUInt8(a.byteLength>>>0&255,++$)}else{_.writeUInt8(127,1);let $=1;_.writeUInt8(0,++$),_.writeUInt8(0,++$),_.writeUInt8(0,++$),_.writeUInt8(0,++$),_.writeUInt8(a.byteLength>>>24&255,++$),_.writeUInt8(a.byteLength>>>16&255,++$),_.writeUInt8(a.byteLength>>>8&255,++$),_.writeUInt8(a.byteLength>>>0&255,++$)}this.socket.write(D.VSBuffer.concat([_,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),S=m.readUInt8(0),_=(S&128)>>>7,$=(S&64)>>>6,A=m.readUInt8(1),U=(A&128)>>>7,R=A&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(R===126?2:0)+(R===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),S=m.readUInt8(1),_=(S&128)>>>7;let $=S&127,A=1;$===126?$=m.readUInt8(++A)*2**8+m.readUInt8(++A):$===127&&($=m.readUInt8(++A)*0+m.readUInt8(++A)*0+m.readUInt8(++A)*0+m.readUInt8(++A)*0+m.readUInt8(++A)*2**24+m.readUInt8(++A)*2**16+m.readUInt8(++A)*2**8+m.readUInt8(++A));let U=0;_&&(U=m.readUInt8(++A)*2**24+m.readUInt8(++A)*2**16+m.readUInt8(++A)*2**8+m.readUInt8(++A)),this._state.state=3,this._state.readLen=$,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),c(m,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(m,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class w extends L.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(a,m,S,_,$,A){super(),this._tracer=a,this._onData=$,this._writeFn=A,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,m?(this._zlibInflateStream=this._register(new d(this._tracer,_,S,{windowBits:15})),this._zlibDeflateStream=this._register(new f(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const m=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(m,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,m){return new Promise((S,_)=>{a.write(m),a.flush($=>S($))})}acceptFrame(a,m,S){this._readQueue.push({data:a,isCompressed:m,isLastFrameOfMessage:S}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const m=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(m)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,m,S){return new Promise((_,$)=>{a.write(m),S&&a.write(D.VSBuffer.fromByteArray([0,0,255,255])),a.flush(A=>_(A))})}}class d extends L.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(a,m,S,_){super(),this._tracer=a,this._recordInflateBytes=m,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(_),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(D.VSBuffer.wrap($))}),S&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",S.buffer),this._zlibInflate.write(S.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const m=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(m)})}}class f extends L.Disposable{constructor(a,m){super(),this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",S=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:S?.message,code:S?.code}),this._onError.fire(S)}),this._zlibDeflate.on("data",S=>{this._tracer.traceSocketEvent("zlibDeflateData",S),this._pendingDeflateData.push(D.VSBuffer.wrap(S))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let m=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.byteLength-4),a(m)})}}function c(u,a){if(a===0)return;const m=u.byteLength>>>2;for(let R=0;R<m;R++){const N=u.readUInt32BE(R*4);u.writeUInt32BE(N^a,R*4)}const S=m*4,_=u.byteLength-S,$=a>>>24&255,A=a>>>16&255,U=a>>>8&255;_>=1&&u.writeUInt8(u.readUInt8(S)^$,S),_>=2&&u.writeUInt8(u.readUInt8(S+1)^A,S+1),_>=3&&u.writeUInt8(u.readUInt8(S+2)^U,S+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const g={[2]:107,[1]:103};function l(){const u=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):a=(0,T.join)(C().os.tmpdir(),`vscode-ipc-${u}.sock`),o(a),a}e.createRandomIPCHandle=l;function n(u,a,m){const S=C().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${S}-${m}-${a}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${S.substr(0,8)}-${m}-${a}.sock`):_=(0,T.join)(u,`${m}-${a}.sock`),o(_),_}e.createStaticIPCHandle=n;function o(u){const a=g[P.platform];typeof a=="number"&&u.length>=a&&console.warn(`WARNING: IPC handle "${u}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends b.IPCServer{static toClientConnectionEvent(a){const m=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(m,S=>({protocol:new I.Protocol(new p(S,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(S,"close"))}))}constructor(a){super(t.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function i(u){return new Promise((a,m)=>{const S=C().net.createServer();S.on("error",m),S.listen(u,()=>{S.removeListener("error",m),a(new t(S))})})}e.serve=i;function s(u,a){return new Promise((m,S)=>{const _=C().net.createConnection(u,()=>{_.removeListener("error",S),m(I.Client.fromSocket(new p(_,`ipc-client${a}`),a))});_.once("error",S)})}e.connect=s}),define(ne[68],re([0,1,6,3,2,15]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function P(C){const p=C;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var E;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class b extends k.Disposable{constructor(p,v=Object.create(null)){super(),this.database=p,this.options=v,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((v,h)=>this.accept(h,v)),p.deleted?.forEach(v=>this.accept(v,void 0))}accept(p,v){if(this.state===E.Closed)return;let h=!1;(0,L.isUndefinedOrNull)(v)?h=this.cache.delete(p):this.cache.get(p)!==v&&(this.cache.set(p,v),h=!0),h&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,v){const h=this.cache.get(p);return(0,L.isUndefinedOrNull)(h)?v:h}getBoolean(p,v){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?v:h==="true"}getNumber(p,v){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(p,v){if(this.state===E.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(p);const h=String(v);if(this.cache.get(p)!==h)return this.cache.set(p,h),this.pendingInserts.set(p,h),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===E.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((v,h)=>this.items.set(h,v)),p.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[140],re([10,11]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[141],re([10,11]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[142],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[143],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[144],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[145],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[146],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[147],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[148],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[149],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[150],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[151],re([10,11]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[152],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[153],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[154],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[155],re([10,11]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[156],re([10,11]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[157],re([10,11]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[158],re([10,11]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[159],re([10,11]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[160],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[161],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[162],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[163],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[164],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[165],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[166],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[167],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[168],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[169],re([10,11]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[92],re([0,1,64,63,23,12,37,19,7]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return E.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(E.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=T.env.VSCODE_PORTABLE;return y?E.URI.file((0,L.join)(y,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,L.resolve)(y):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,L.resolve)(y):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,L.resolve)(y);const w=T.env.VSCODE_EXTENSIONS;if(w)return w;const d=T.env.VSCODE_PORTABLE;return d?(0,L.join)(d,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(w=>/^[^:/?#]+?:\/\//.test(w)?E.URI.parse(w):E.URI.file((0,L.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?E.URI.parse(y):E.URI.file((0,L.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=T.env.VSCODE_PORTABLE;return y?E.URI.file((0,L.join)(y,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(y){this.args.continueOn=y}get args(){return this._args}constructor(y,w,d){this._args=y,this.paths=w,this.productService=d,this.editSessionId=this.args.editSessionId}}pe([r.memoize],b.prototype,"appRoot",null),pe([r.memoize],b.prototype,"userHome",null),pe([r.memoize],b.prototype,"userDataPath",null),pe([r.memoize],b.prototype,"appSettingsHome",null),pe([r.memoize],b.prototype,"tmpDir",null),pe([r.memoize],b.prototype,"cacheHome",null),pe([r.memoize],b.prototype,"stateResource",null),pe([r.memoize],b.prototype,"userRoamingDataHome",null),pe([r.memoize],b.prototype,"userDataSyncHome",null),pe([r.memoize],b.prototype,"userDataSyncLogResource",null),pe([r.memoize],b.prototype,"editSessionsLogResource",null),pe([r.memoize],b.prototype,"sync",null),pe([r.memoize],b.prototype,"machineSettingsResource",null),pe([r.memoize],b.prototype,"workspaceStorageHome",null),pe([r.memoize],b.prototype,"localHistoryHome",null),pe([r.memoize],b.prototype,"keyboardLayoutResource",null),pe([r.memoize],b.prototype,"argvResource",null),pe([r.memoize],b.prototype,"isExtensionDevelopment",null),pe([r.memoize],b.prototype,"untitledWorkspacesHome",null),pe([r.memoize],b.prototype,"installSourcePath",null),pe([r.memoize],b.prototype,"builtinExtensionsPath",null),pe([r.memoize],b.prototype,"extensionsPath",null),pe([r.memoize],b.prototype,"extensionDevelopmentLocationURI",null),pe([r.memoize],b.prototype,"extensionDevelopmentKind",null),pe([r.memoize],b.prototype,"extensionTestsLocationURI",null),pe([r.memoize],b.prototype,"debugExtensionHost",null),pe([r.memoize],b.prototype,"serviceMachineIdResource",null),pe([r.memoize],b.prototype,"telemetryLogResource",null),pe([r.memoize],b.prototype,"disableWorkspaceTrust",null),pe([r.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function I(h,y){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function C(h,y){return v(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=C;function p(h,y){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=p;function v(h,y,w,d,f,c){const l=Number(y||h)||(d?null:w),n=l?Boolean(!!y):!1;let o;if(c)try{o=JSON.parse(c)}catch{}return{port:l,break:n,debugId:f,env:o}}}),define(ne[170],re([0,1,275,4,142]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,y,w=T){const d={},f=["_"],c=[];for(const o in y){const t=y[o];t.alias&&(d[o]=t.alias),t.type==="string"||t.type==="string[]"?(f.push(o),t.deprecates&&f.push(...t.deprecates)):t.type==="boolean"&&(c.push(o),t.deprecates&&c.push(...t.deprecates))}const g=D(h,{string:f,boolean:c,alias:d}),l={},n=g;l._=g._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in y){const t=y[o];t.alias&&delete n[t.alias];let i=n[o];if(t.deprecates)for(const s of t.deprecates)n.hasOwnProperty(s)&&(i||(i=n[s],i&&w.onDeprecatedOption(s,t.deprecationMessage||(0,k.localize)(35,null,o))),delete n[s]);if(typeof i<"u"){if(t.type==="string[]"){if(Array.isArray(i)||(i=[i]),!t.allowEmptyValue){const s=i.filter(u=>u.length>0);s.length!==i.length&&(w.onEmptyValue(o),i=s.length>0?s:void 0)}}else t.type==="string"&&(Array.isArray(i)?(i=i.pop(),w.onMultipleValues(o,i)):!i&&!t.allowEmptyValue&&(w.onEmptyValue(o),i=void 0));l[o]=i,t.deprecationMessage&&w.onDeprecatedOption(o,t.deprecationMessage)}delete n[o]}for(const o in n)w.onUnknownOption(o);return l}e.parseArgs=P;function E(h,y){let w="";return y.args&&(Array.isArray(y.args)?w=` <${y.args.join("> <")}>`:w=` <${y.args}>`),y.alias?`-${y.alias} --${h}${w}`:`--${h}${w}`}function b(h,y){let w=0;const d=[];for(const l in h){const n=h[l],o=E(l,n);w=Math.max(w,o.length),d.push([o,n.description])}const f=w+2+1;if(y-f<25)return d.reduce((l,n)=>l.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const c=y-f-1,g=[];for(const l of d){const n=l[0],o=C(l[1],c),t=I(f-n.length-2);g.push("  "+n+t+o[0]);for(let i=1;i<o.length;i++)g.push(I(f)+o[i])}return g}e.formatOptions=b;function I(h){return" ".repeat(h)}function C(h,y){const w=[];for(;h.length;){const d=h.length<y?h.length:h.lastIndexOf(" ",y),f=h.slice(0,d).trim();h=h.slice(d),w.push(f)}return w}function p(h,y,w,d,f){const c=process.stdout.isTTY&&process.stdout.columns||80,g=f?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",l=[`${h} ${w}`];l.push(""),l.push(`${(0,k.localize)(37,null)}: ${y} [${(0,k.localize)(38,null)}]${g}`),l.push(""),f?.noPipe!==!0&&(r.isWindows?l.push((0,k.localize)(39,null,y)):l.push((0,k.localize)(40,null,y)),l.push(""));const n={};for(const o in d){const t=d[o];if(t.description&&t.cat){let i=n[t.cat];i||(n[t.cat]=i={}),i[o]=t}}for(const o in n){const t=o,i=n[t];i&&(l.push(L[t]),l.push(...b(i,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=p;function v(h,y){return`${h||(0,k.localize)(41,null)}
${y||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=v}),define(ne[171],re([0,1,276,143,170]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function T(p,v){const h={onUnknownOption:w=>{console.warn((0,r.localize)(0,null,w))},onMultipleValues:(w,d)=>{console.warn((0,r.localize)(1,null,w,d))},onEmptyValue:w=>{console.warn((0,r.localize)(2,null,w))},onDeprecatedOption:(w,d)=>{console.warn((0,r.localize)(3,null,w,d))}},y=(0,k.parseArgs)(p,k.OPTIONS,v?h:void 0);return y.goto&&y._.forEach(w=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,r.localize)(4,null))),y["max-memory"]&&D(parseInt(y["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),y}function P(p){const v=p.findIndex(h=>!/^-/.test(h));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function E(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=P(v)||[]);const h=!C(process.env);return T(v,h)}e.parseMainProcessArgv=E;function b(p){const[,,...v]=p;return T(v,!0)}e.parseCLIProcessArgv=b;function I(p,...v){const h=p.indexOf("--");return h===-1?p.push(...v):p.splice(h,0,...v),p}e.addArg=I;function C(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function Q(e,D,r){function k(T,P){const E=L(T,P),b=[E];return e.isAbsolute(E)||b.unshift(r),e.resolve(...b)}function L(T,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,P);const I=T["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(C,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,P)}return{getUserDataPath:k}}if(typeof define=="function")define(ne[172],re([277,36,37]),function(e,D,r){return Q(e,D,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Q(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[173],re([0,1,36,92,172]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends r.AbstractNativeEnvironmentService{constructor(P,E){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,E.nameShort)},E)}}e.NativeEnvironmentService=L}),define(ne[174],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const r=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(w){const d=w.match(T);return d?d[1]:null}function I(w){if(w.indexOf("://")===-1){const d=w.match(r);return d?b(d[2]):null}try{const d=D.URI.parse(w);if(d.authority)return b(d.authority)}catch{}return null}function C(w,d){const f=new Set;let c;for(;c=P.exec(w);){const l=I(c[1]);l&&f.add(l)}const g=new Set(d);return Array.from(f).map(l=>g.has(l)?l:l.replace(E,"a"))}e.getDomainsOfRemotes=C;function p(w){const d=w.match(L);return d?d[2]:null}function v(w,d,f){return w&&d?(f&&d.endsWith(".git")&&(d=d.substr(0,d.length-4)),d.indexOf("/")===0?`${w}${d}`:`${w}/${d}`):null}function h(w,d){if(w.indexOf("://")===-1){const f=w.match(k);if(f)return v(f[2],f[3],d)}try{const f=D.URI.parse(w);if(f.authority)return v(p(f.authority),f.path,d)}catch{}return null}function y(w,d=!1){const f=[];let c;for(;c=P.exec(w);){const g=h(c[1],d);g&&f.push(g)}return f}e.getRemotes=y}),define(ne[175],re([0,1,15,146]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(T,P,E){try{L(T,P,E)}catch{}return T}e.localizeManifest=k;function L(T,P,E){const b=(I,C,p)=>{const v=I[C];if((0,D.isString)(v)){const h=v,y=h.length;if(y>1&&h[0]==="%"&&h[y-1]==="%"){const w=h.substr(1,y-2);let d=P[w];d===void 0&&E&&(d=E[w]);const f=typeof d=="string"?d:d.message;if(f!==void 0){const c=E?.[w],g=typeof c=="string"?c:c?.message;if(p&&(C==="title"||C==="category")&&g&&g!==f){const l={value:f,original:g};I[C]=l}else I[C]=f}else console.warn(`[${T.name}]: ${(0,r.localize)(0,null,w)}`)}}else if((0,D.isObject)(v))for(const h in v)v.hasOwnProperty(h)&&(h==="commands"?b(v,h,!0):b(v,h,p));else if(Array.isArray(v))for(let h=0;h<v.length;h++)b(v,h,p)};for(const I in T)T.hasOwnProperty(I)&&b(T,I)}}),define(ne[176],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,T,P,E){return this.channel.call("promptImportantExtensionsInstallNotification",[L,T,P,E])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class r{constructor(L){this.service=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,P){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=r}),define(ne[69],re([0,1,19,86,151,55]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||T.test(d)}e.isValidVersionStr=E;function b(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=d.match(T);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=b;function I(d){if(!d)return null;const f=d.majorBase,c=d.majorMustEqual,g=d.minorBase;let l=d.minorMustEqual;const n=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(f===0||(l=!1),o=!1);let t=0;if(d.preRelease){const i=P.exec(d.preRelease);if(i){const[,s,u,a]=i;t=Date.UTC(Number(s),Number(u)-1,Number(a))}}return{majorBase:f,majorMustEqual:c,minorBase:g,minorMustEqual:l,patchBase:n,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:t}}e.normalizeVersion=I;function C(d,f,c){let g;typeof d=="string"?g=I(b(d)):g=d;let l;f instanceof Date?l=f.getTime():typeof f=="string"&&(l=new Date(f).getTime());let n;if(typeof c=="string"?n=I(b(c)):n=c,!g||!n)return!1;const o=g.majorBase,t=g.minorBase,i=g.patchBase;let s=n.majorBase,u=n.minorBase,a=n.patchBase;const m=n.notBefore;let S=n.majorMustEqual,_=n.minorMustEqual,$=n.patchMustEqual;return n.isMinimum?o>s?!0:o<s?!1:t>u?!0:t<u||l&&l<m?!1:i>=a:(o===1&&s===0&&(!S||!_||!$)&&(s=1,u=0,a=0,S=!0,_=!1,$=!1),o<s?!1:o>s?!S:t<u?!1:t>u?!_:i<a?!1:i>a?!$:!(l&&l<m))}e.isValidVersion=C;function p(d,f,c,g,l){const n=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return n.push([r.default.Error,k.localize(0,null)]),n;if(typeof g.name!="string")return n.push([r.default.Error,k.localize(1,null,"name")]),n;if(typeof g.version!="string")return n.push([r.default.Error,k.localize(2,null,"version")]),n;if(!g.engines)return n.push([r.default.Error,k.localize(3,null,"engines")]),n;if(typeof g.engines.vscode!="string")return n.push([r.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof g.extensionDependencies<"u"&&!w(g.extensionDependencies))return n.push([r.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof g.activationEvents<"u"){if(!w(g.activationEvents))return n.push([r.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof g.main>"u"&&typeof g.browser>"u")return n.push([r.default.Error,k.localize(7,null,"activationEvents","main")]),n}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&n.push([r.default.Warning,k.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return n.push([r.default.Error,k.localize(9,null,"main")]),n;{const i=(0,D.joinPath)(c,g.main);(0,D.isEqualOrParent)(i,c)||n.push([r.default.Warning,k.localize(10,null,i.path,c.path)])}if(typeof g.activationEvents>"u")return n.push([r.default.Error,k.localize(11,null,"activationEvents","main")]),n}if(typeof g.browser<"u"){if(typeof g.browser!="string")return n.push([r.default.Error,k.localize(12,null,"browser")]),n;{const i=(0,D.joinPath)(c,g.browser);(0,D.isEqualOrParent)(i,c)||n.push([r.default.Warning,k.localize(13,null,i.path,c.path)])}if(typeof g.activationEvents>"u")return n.push([r.default.Error,k.localize(14,null,"activationEvents","browser")]),n}if(!L.valid(g.version))return n.push([r.default.Error,k.localize(15,null)]),n;const o=[];if(!v(d,f,g,l,o))for(const i of o)n.push([r.default.Error,i]);return n}e.validateExtensionManifest=p;function v(d,f,c,g,l){return g||typeof c.main>"u"&&typeof c.browser>"u"?!0:y(d,f,c.engines.vscode,l)}e.isValidExtensionVersion=v;function h(d,f,c){return d==="*"||y(f,c,d)}e.isEngineValid=h;function y(d,f,c,g=[]){const l=I(b(c));if(!l)return g.push(k.localize(16,null,c)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return g.push(k.localize(17,null,c)),!1}else if(!l.majorMustEqual)return g.push(k.localize(18,null,c)),!1;return C(d,f,l)?!0:(g.push(k.localize(19,null,d,c)),!1)}function w(d){if(!Array.isArray(d))return!1;for(let f=0,c=d.length;f<c;f++)if(typeof d[f]!="string")return!1;return!0}}),define(ne[48],re([0,1,16,30]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,T,P){let E=P&&P.get("storage.serviceMachineId",-1)||null;if(E)return E;try{const I=(await T.readFile(L.serviceMachineIdResource)).value.toString();E=(0,r.isUUID)(I)?I:null}catch{E=null}if(!E){E=(0,r.generateUuid)();try{await T.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(E))}catch{}}return P?.store("storage.serviceMachineId",E,-1,1),E}e.getServiceMachineId=k}),define(ne[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(k,L=[],T=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(ne[93],re([0,1,56]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const r=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function L(P,E,b){E instanceof D.SyncDescriptor||(E=new D.SyncDescriptor(E,[],Boolean(b))),r.push([P,E])}e.registerSingleton=L;function T(){return r}e.getSingletonServiceDescriptors=T}),define(ne[177],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L,T){this.key=L,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class r{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const P=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(T);P.outgoing.set(E.key,E),E.incoming.set(P.key,P)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(const P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let P=this._nodes.get(T);return P||(P=new D(T,L),this._nodes.set(T,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[T,P]of this._nodes)L.push(`${T}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,T]of this._nodes){const P=new Set([L]),E=this._findCycle(T,P);if(E)return E}}_findCycle(L,T){for(const[P,E]of L.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const b=this._findCycle(E,T);if(b)return b;T.delete(P)}}}e.Graph=r}),define(ne[5],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(E){return E[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function r(T,P,E){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:T,index:E}):(P[D.DI_DEPENDENCIES]=[{id:T,index:E}],P[D.DI_TARGET]=P)}function k(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const P=function(E,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(P,E,I)};return P.toString=()=>T,D.serviceIds.set(T,P),P}e.createDecorator=k;function L(T){return T}e.refineServiceDecorator=L}),define(ne[178],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[17],re([0,1,15,7,5]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof r.URI)}e.isConfigurationOverrides=L;function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof r.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function b(d,f){const c=Object.create(null);for(const g in d)I(c,g,d[g],f);return c}e.toValuesTree=b;function I(d,f,c,g){const l=f.split("."),n=l.pop();let o=d;for(let t=0;t<l.length;t++){const i=l[t];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${f} as ${l.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[n]=c}catch{g(`Ignoring ${f} as ${l.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${f} as ${l.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=I;function C(d,f){const c=f.split(".");p(d,c)}e.removeFromValueTree=C;function p(d,f){const c=f.shift();if(f.length===0){delete d[c];return}if(Object.keys(d).indexOf(c)!==-1){const g=d[c];typeof g=="object"&&!Array.isArray(g)&&(p(g,f),Object.keys(g).length===0&&delete d[c])}}function v(d,f,c){function g(o,t){let i=o;for(const s of t){if(typeof i!="object"||i===null)return;i=i[s]}return i}const l=f.split("."),n=g(d,l);return typeof n>"u"?c:n}e.getConfigurationValue=v;function h(d,f,c){Object.keys(f).forEach(g=>{g!=="__proto__"&&(g in d?D.isObject(d[g])&&D.isObject(f[g])?h(d[g],f[g],c):c&&(d[g]=f[g]):d[g]=f[g])})}e.merge=h;function y(d,f,c){const g=d.inspect(f),l=d.inspect(c);return typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:g.defaultValue}e.getMigratedSettingValue=y;function w(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ne[179],re([0,1,4,27,5]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",D.isMacintosh),L.set("isLinux",D.isLinux),L.set("isWindows",D.isWindows),L.set("isWeb",D.isWeb),L.set("isMacNative",D.isMacintosh&&!D.isWeb),L.set("isEdge",D.isEdge),L.set("isFirefox",D.isFirefox),L.set("isChrome",D.isChrome),L.set("isSafari",D.isSafari);const T=Object.prototype.hasOwnProperty;var P;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return C.INSTANCE}static true(){return p.INSTANCE}static has(R){return v.create(R)}static equals(R,N){return h.create(R,N)}static notEquals(R,N){return d.create(R,N)}static regex(R,N){return t.create(R,N)}static in(R,N){return y.create(R,N)}static notIn(R,N){return w.create(R,N)}static not(R){return f.create(R)}static and(...R){return u.create(R,null)}static or(...R){return a.create(R,null,!0)}static greater(R,N){return g.create(R,N)}static greaterEquals(R,N){return l.create(R,N)}static smaller(R,N){return n.create(R,N)}static smallerEquals(R,N){return o.create(R,N)}static deserialize(R,N=!1){if(!!R)return this._deserializeOrExpression(R,N)}static _deserializeOrExpression(R,N){const F=R.split("||");return a.create(F.map(q=>this._deserializeAndExpression(q,N)),null,!0)}static _deserializeAndExpression(R,N){const F=R.split("&&");return u.create(F.map(q=>this._deserializeOne(q,N)),null)}static _deserializeOne(R,N){if(R=R.trim(),R.indexOf("!=")>=0){const F=R.split("!=");return d.create(F[0].trim(),this._deserializeValue(F[1],N))}if(R.indexOf("==")>=0){const F=R.split("==");return h.create(F[0].trim(),this._deserializeValue(F[1],N))}if(R.indexOf("=~")>=0){const F=R.split("=~");return t.create(F[0].trim(),this._deserializeRegexValue(F[1],N))}if(R.indexOf(" not in ")>=0){const F=R.split(" not in ");return w.create(F[0].trim(),this._deserializeValue(F[1],N))}if(R.indexOf(" in ")>=0){const F=R.split(" in ");return y.create(F[0].trim(),this._deserializeValue(F[1],N))}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const F=R.split(">=");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const F=R.split(">");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const F=R.split("<=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const F=R.split("<");return n.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(R)?f.create(R.substr(1).trim()):v.create(R)}static _deserializeValue(R,N){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;const F=/^'([^']*)'$/.exec(R);return F?F[1].trim():R}static _deserializeRegexValue(R,N){if((0,r.isFalsyOrWhitespace)(R)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=R.indexOf("/"),q=R.lastIndexOf("/");if(F===q||F<0){if(N)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}const J=R.slice(F+1,q),j=R[q+1]==="i"?"i":"";try{return new RegExp(J,j)}catch(H){if(N)throw new Error(`bad regexp-value '${R}', parse error: ${H}`);return console.warn(`bad regexp-value '${R}', parse error: ${H}`),null}}}e.ContextKeyExpr=E;function b(U,R){const N=U?U.substituteConstants():void 0,F=R?R.substituteConstants():void 0;return!N&&!F?!0:!N||!F?!1:N.equals(F)}e.expressionsAreEqualWithConstantSubstitution=b;function I(U,R){return U.cmp(R)}class C{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class p{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class v{static create(R,N=null){const F=L.get(R);return typeof F=="boolean"?F?p.INSTANCE:C.INSTANCE:new v(R,N)}constructor(R,N){this.key=R,this.negated=N,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:S(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?p.INSTANCE:C.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class h{static create(R,N,F=null){if(typeof N=="boolean")return N?v.create(R,F):f.create(R,F);const q=L.get(R);return typeof q=="boolean"?N===(q?"true":"false")?p.INSTANCE:C.INSTANCE:new h(R,N,F)}constructor(R,N,F){this.key=R,this.value=N,this.negated=F,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=L.get(this.key);if(typeof R=="boolean"){const N=R?"true":"false";return this.value===N?p.INSTANCE:C.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class y{static create(R,N){return new y(R,N)}constructor(R,N){this.key=R,this.valueKey=N,this.type=10,this.negated=null}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const N=R.getValue(this.valueKey),F=R.getValue(this.key);return Array.isArray(N)?N.includes(F):typeof F=="string"&&typeof N=="object"&&N!==null?T.call(N,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=y;class w{static create(R,N){return new w(R,N)}constructor(R,N){this.key=R,this.valueKey=N,this.type=11,this._negated=y.create(R,N)}cmp(R){return R.type!==this.type?this.type-R.type:this._negated.cmp(R._negated)}equals(R){return R.type===this.type?this._negated.equals(R._negated):!1}substituteConstants(){return this}evaluate(R){return!this._negated.evaluate(R)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(R){return R.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=w;class d{static create(R,N,F=null){if(typeof N=="boolean")return N?f.create(R,F):v.create(R,F);const q=L.get(R);return typeof q=="boolean"?N===(q?"true":"false")?C.INSTANCE:p.INSTANCE:new d(R,N,F)}constructor(R,N,F){this.key=R,this.value=N,this.negated=F,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=L.get(this.key);if(typeof R=="boolean"){const N=R?"true":"false";return this.value===N?C.INSTANCE:p.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class f{static create(R,N=null){const F=L.get(R);return typeof F=="boolean"?F?C.INSTANCE:p.INSTANCE:new f(R,N)}constructor(R,N){this.key=R,this.negated=N,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:S(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?C.INSTANCE:p.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function c(U,R){if(typeof U=="string"){const N=parseFloat(U);isNaN(N)||(U=N)}return typeof U=="string"||typeof U=="number"?R(U):C.INSTANCE}class g{static create(R,N,F=null){return c(N,q=>new g(R,q,F))}constructor(R,N,F){this.key=R,this.value=N,this.negated=F,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class l{static create(R,N,F=null){return c(N,q=>new l(R,q,F))}constructor(R,N,F){this.key=R,this.value=N,this.negated=F,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class n{static create(R,N,F=null){return c(N,q=>new n(R,q,F))}constructor(R,N,F){this.key=R,this.value=N,this.negated=F,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class o{static create(R,N,F=null){return c(N,q=>new o(R,q,F))}constructor(R,N,F){this.key=R,this.value=N,this.negated=F,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:_(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return typeof this.value=="string"?!1:parseFloat(R.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class t{static create(R,N){return new t(R,N)}constructor(R,N){this.key=R,this.regexp=N,this.type=7,this.negated=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const N=this.regexp?this.regexp.source:"",F=R.regexp?R.regexp.source:"";return N<F?-1:N>F?1:0}equals(R){if(R.type===this.type){const N=this.regexp?this.regexp.source:"",F=R.regexp?R.regexp.source:"";return this.key===R.key&&N===F}return!1}substituteConstants(){return this}evaluate(R){const N=R.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class i{static create(R){return new i(R)}constructor(R){this._actual=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new i(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(U){let R=null;for(let N=0,F=U.length;N<F;N++){const q=U[N].substituteConstants();if(U[N]!==q&&R===null){R=[];for(let J=0;J<N;J++)R[J]=U[J]}R!==null&&(R[N]=q)}return R===null?U:R}class u{static create(R,N){return u._normalizeArr(R,N)}constructor(R,N){this.expr=R,this.negated=N,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let N=0,F=this.expr.length;N<F;N++){const q=I(this.expr[N],R.expr[N]);if(q!==0)return q}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].equals(R.expr[N]))return!1;return!0}return!1}substituteConstants(){const R=s(this.expr);return R===this.expr?this:u.create(R,this.negated)}evaluate(R){for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].evaluate(R))return!1;return!0}static _normalizeArr(R,N){const F=[];let q=!1;for(const J of R)if(!!J){if(J.type===1){q=!0;continue}if(J.type===0)return C.INSTANCE;if(J.type===6){F.push(...J.expr);continue}F.push(J)}if(F.length===0&&q)return p.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(I);for(let J=1;J<F.length;J++)F[J-1].equals(F[J])&&(F.splice(J,1),J--);if(F.length===1)return F[0];for(;F.length>1;){const J=F[F.length-1];if(J.type!==9)break;F.pop();const j=F.pop(),H=F.length===0,W=a.create(J.expr.map(z=>u.create([z,j],null)),null,H);W&&(F.push(W),F.sort(I))}return F.length===1?F[0]:new u(F,N)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const N of this.expr)R.push(...N.keys());return R}map(R){return new u(this.expr.map(N=>N.map(R)),null)}negate(){if(!this.negated){const R=[];for(const N of this.expr)R.push(N.negate());this.negated=a.create(R,this,!0)}return this.negated}}class a{static create(R,N,F){return a._normalizeArr(R,N,F)}constructor(R,N){this.expr=R,this.negated=N,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let N=0,F=this.expr.length;N<F;N++){const q=I(this.expr[N],R.expr[N]);if(q!==0)return q}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].equals(R.expr[N]))return!1;return!0}return!1}substituteConstants(){const R=s(this.expr);return R===this.expr?this:a.create(R,this.negated,!1)}evaluate(R){for(let N=0,F=this.expr.length;N<F;N++)if(this.expr[N].evaluate(R))return!0;return!1}static _normalizeArr(R,N,F){let q=[],J=!1;if(R){for(let j=0,H=R.length;j<H;j++){const W=R[j];if(!!W){if(W.type===0){J=!0;continue}if(W.type===1)return p.INSTANCE;if(W.type===9){q=q.concat(W.expr);continue}q.push(W)}}if(q.length===0&&J)return C.INSTANCE;q.sort(I)}if(q.length!==0){if(q.length===1)return q[0];for(let j=1;j<q.length;j++)q[j-1].equals(q[j])&&(q.splice(j,1),j--);if(q.length===1)return q[0];if(F){for(let j=0;j<q.length;j++)for(let H=j+1;H<q.length;H++)$(q[j],q[H])&&(q.splice(H,1),H--);if(q.length===1)return q[0]}return new a(q,N)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const N of this.expr)R.push(...N.keys());return R}map(R){return new a(this.expr.map(N=>N.map(R)),null)}negate(){if(!this.negated){const R=[];for(const N of this.expr)R.push(N.negate());for(;R.length>1;){const N=R.shift(),F=R.shift(),q=[];for(const j of A(N))for(const H of A(F))q.push(u.create([j,H],null));const J=R.length===0;R.unshift(a.create(q,null,J))}this.negated=R[0]}return this.negated}}class m extends v{static all(){return m._info.values()}constructor(R,N,F){super(R,null),this._defaultValue=N,typeof F=="object"?m._info.push({...F,key:R}):F!==!0&&m._info.push({key:R,description:F,type:N!=null?typeof N:void 0})}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return h.create(this.key,R)}notEqualsTo(R){return d.create(this.key,R)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function S(U,R){return U<R?-1:U>R?1:0}function _(U,R,N,F){return U<N?-1:U>N?1:R<F?-1:R>F?1:0}function $(U,R){if(R.type===6&&U.type!==9&&U.type!==6){for(const q of R.expr)if(U.equals(q))return!0}const N=U.negate(),F=A(N).concat(A(R));F.sort(I);for(let q=0;q<F.length;q++){const j=F[q].negate();for(let H=q+1;H<F.length;H++){const W=F[H];if(j.equals(W))return!0}}return!1}e.implies=$;function A(U){return U.type===9?U.expr:[U]}}),define(ne[94],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function r(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=r;class k{async getPerformanceInfo(T,P){return{}}async getSystemInfo(T,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,P){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=k}),define(ne[95],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[14],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],re([0,1,145,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function T(d,f){switch(d){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function P(d,f){return f==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function E(d,f,c){return P(f,c)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===c?!0:b(c).includes(d)}e.isTargetPlatformCompatible=E;function b(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function I(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=I;var C;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var p;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var v;(function(d){d.Install="install",d.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,r.createDecorator)("extensionGalleryService");var y;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(f,c){super(f),this.code=c,this.name=c}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,r.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,r.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,r.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ne[180],re([0,1,3,2,66,32,7,132,29]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(w,d){return T.URI.revive(d?d.transformIncoming(w):w)}function I(w,d){return d?d.transformOutgoingURI(w):w}function C(w,d){d=d||P.DefaultURITransformer;const f=w.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...w,manifest:void 0},d),manifest:f}}function p(w,d){return d?(0,L.cloneAndChange)(w,f=>f instanceof T.URI?d.transformOutgoingURI(f):void 0):w}class v{constructor(d,f){this.service=d,this.getUriTransformer=f,this.onInstallExtension=D.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,f){const c=this.getUriTransformer(d);switch(f){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,g=>g.map(l=>({...l,local:l.local?p(l.local,c):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,f,c){const g=this.getUriTransformer(d);switch(f){case"zip":return this.service.zip(C(c[0],g)).then(l=>I(l,g));case"unzip":return this.service.unzip(b(c[0],g));case"install":return this.service.install(b(c[0],g),(0,k.revive)(c[1]));case"getManifest":return this.service.getManifest(b(c[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(c[0]);case"installFromGallery":return this.service.installFromGallery(c[0],(0,k.revive)(c[1]));case"uninstall":return this.service.uninstall(C(c[0],g),(0,k.revive)(c[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(C(c[0],g));case"getInstalled":return this.service.getInstalled(c[0],T.URI.revive(c[1])).then(l=>l.map(n=>p(n,g)));case"getMetadata":return this.service.getMetadata(C(c[0],g));case"updateMetadata":return this.service.updateMetadata(C(c[0],g),c[1]).then(l=>p(l,g));case"updateExtensionScope":return this.service.updateExtensionScope(C(c[0],g),c[1]).then(l=>p(l,g));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends r.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(d){super(),this.channel=d,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(f=>this._onInstallExtension.fire({identifier:f.identifier,source:this.isUriComponents(f.source)?T.URI.revive(f.source):f.source,profileLocation:T.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(f=>this._onDidInstallExtensions.fire(f.map(c=>({...c,local:c.local?C(c.local,null):c.local,source:this.isUriComponents(c.source)?T.URI.revive(c.source):c.source,profileLocation:T.URI.revive(c.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(f=>this._onUninstallExtension.fire({identifier:f.identifier,profileLocation:T.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(f=>this._onDidUninstallExtension.fire({...f,profileLocation:T.URI.revive(f.profileLocation)})))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const f=await this.getTargetPlatform();return d.allTargetPlatforms.some(c=>(0,E.isTargetPlatformCompatible)(c,d.allTargetPlatforms,f))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(f=>T.URI.revive(f)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,f){return Promise.resolve(this.channel.call("install",[d,f])).then(c=>C(c,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,f){return Promise.resolve(this.channel.call("installFromGallery",[d,f])).then(c=>C(c,null))}uninstall(d,f){return Promise.resolve(this.channel.call("uninstall",[d,f]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null,f){return Promise.resolve(this.channel.call("getInstalled",[d,f])).then(c=>c.map(g=>C(g,null)))}getMetadata(d){return Promise.resolve(this.channel.call("getMetadata",[d]))}updateMetadata(d,f){return Promise.resolve(this.channel.call("updateMetadata",[d,f])).then(c=>C(c,null))}updateExtensionScope(d,f){return Promise.resolve(this.channel.call("updateExtensionScope",[d,f])).then(c=>C(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class y{constructor(d){this.service=d}listen(d,f){throw new Error("Invalid listen")}call(d,f,c){switch(f){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(ne[96],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var r;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(r=e.RecommendationSource||(e.RecommendationSource={}));function k(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var L;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],re([0,1,34,12,27,15,7,153,5]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function b(j){return j.create===!0}e.isFileOpenForWriteOptions=b;var I;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function(j){j[j.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var p;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=v;function h(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=y;function w(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function d(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=d;function f(j){return v(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;var c;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(H,W){super(H),this.code=W}}e.FileSystemProviderError=g;function l(j,H){const W=new g(j.toString(),H);return o(W,H),W}e.createFileSystemProviderError=l;function n(j){return j||l((0,P.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=n;function o(j,H){return j.name=H?`${H} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=o;function t(j){if(!j)return c.Unknown;if(j instanceof g)return j.code;const H=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!H)return c.Unknown;switch(H[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=t;function i(j){if(j instanceof _)return j.fileOperationResult;switch(t(j)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(H,W,z){this.resource=H,this.operation=W,this.target=z}isOperation(H){return this.operation===H}}e.FileOperationEvent=u;var a;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class m{constructor(H,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const z=new Map;for(const K of H){const X=z.get(K.type);switch(X?X.push([K.resource,K]):z.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,X]of z)switch(K){case 1:this.added=D.TernarySearchTree.forUris(()=>W),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>W),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>W),this.deleted.fill(X);break}}contains(H,...W){return this.doContains(H,{includeChildren:!1},...W)}affects(H,...W){return this.doContains(H,{includeChildren:!0},...W)}doContains(H,W,...z){if(!H)return!1;const K=z.length>0;return!!((!K||z.includes(1))&&(this.added?.get(H)||W.includeChildren&&this.added?.findSuperstr(H))||(!K||z.includes(0))&&(this.updated?.get(H)||W.includeChildren&&this.updated?.findSuperstr(H))||(!K||z.includes(2))&&(this.deleted?.findSubstr(H)||W.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function S(j,H,W){return!j||!H||j===H||H.length>j.length?!1:(H.charAt(H.length-1)!==r.sep&&(H+=r.sep),W?(0,k.startsWithIgnoreCase)(j,H):j.indexOf(H)===0)}e.isParent=S;class _ extends Error{constructor(H,W,z){super(H),this.fileOperationResult=W,this.options=z}}e.FileOperationError=_;class $ extends _{constructor(H,W,z){super(H,2,z),this.stat=W}}e.NotModifiedSinceFileOperationError=$;var A;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=R;async function N(j,H){if(!H.hasProvider(T.URI.from({scheme:j.scheme})))return new Promise(W=>{const z=H.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===j.scheme&&K.added&&(z.dispose(),W())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(H){return(0,L.isNumber)(H)||(H=0),H<F.KB?(0,P.localize)(1,null,H.toFixed(0)):H<F.MB?(0,P.localize)(2,null,(H/F.KB).toFixed(2)):H<F.GB?(0,P.localize)(3,null,(H/F.MB).toFixed(2)):H<F.TB?(0,P.localize)(4,null,(H/F.GB).toFixed(2)):(0,P.localize)(5,null,(H/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var q;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function J(j){return{maxFileSize:j===0?300*F.MB:16*F.GB,maxHeapSize:j===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=J});var Y=this&&this.__param||function(Q,e){return function(D,r){e(D,r,Q)}};define(ne[181],re([0,1,97,42,13]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}async checksum(P){const E=(await this.fileService.readFileStream(P)).value;return new Promise((b,I)=>{const C=(0,D.createHash)("md5");(0,r.listenStream)(E,{onData:p=>C.update(p.buffer),onError:p=>I(p),onEnd:()=>b(C.digest("base64").replace(/=+$/,""))})})}};L=pe([Y(0,k.IFileService)],L),e.ChecksumService=L}),define(ne[182],re([0,1,16,38,9,3,2,42,7,30,13]),function(Q,e,D,r,k,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends T.Disposable{constructor(v,h){super(),this.channel=v,this.extraCapabilities=h,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,h){const{buffer:y}=await this.channel.call("readFile",[v,h]);return y}readFileStream(v,h,y){const w=(0,P.newWriteableStream)(f=>D.VSBuffer.concat(f.map(c=>D.VSBuffer.wrap(c))).buffer),d=this.channel.listen("readFileStream",[v,h])(f=>{if(f instanceof D.VSBuffer)w.write(f.buffer);else{if(f==="end")w.end();else{let c=f;c instanceof Error||(c=(0,I.createFileSystemProviderError)((0,r.toErrorMessage)(c),I.FileSystemProviderErrorCode.Unknown)),w.error(c),w.end()}d.dispose()}});return y.onCancellationRequested(()=>{w.error((0,k.canceled)()),w.end(),d.dispose()}),w}writeFile(v,h,y){return this.channel.call("writeFile",[v,D.VSBuffer.wrap(h),y])}open(v,h){return this.channel.call("open",[v,h])}close(v){return this.channel.call("close",[v])}async read(v,h,y,w,d){const[f,c]=await this.channel.call("read",[v,h,d]);return y.set(f.buffer.slice(0,c),w),c}write(v,h,y,w,d){return this.channel.call("write",[v,h,D.VSBuffer.wrap(y),w,d])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,h){return this.channel.call("delete",[v,h])}rename(v,h,y){return this.channel.call("rename",[v,h,y])}copy(v,h,y){return this.channel.call("copy",[v,h,y])}cloneFile(v,h){return this.channel.call("cloneFile",[v,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const h=v;this._onDidChange.fire(h.map(y=>({resource:E.URI.revive(y.resource),type:y.type})))}else{const h=v;this._onDidWatchError.fire(h)}}))}watch(v,h){const y=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,y,v,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=C}),define(ne[98],re([0,1,16,9,154,13]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(I,C,p,v,h,y){let w;try{await P(I,C,p,v,h,y)}catch(d){w=d}finally{w&&h.errorTransformer&&(w=h.errorTransformer(w)),typeof w<"u"&&p.error(w),p.end()}}e.readFileIntoStream=T;async function P(I,C,p,v,h,y){E(y);const w=await I.open(C,{create:!1});try{E(y);let d=0,f=0,c=h&&typeof h.length=="number"?h.length:void 0,g=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof c=="number"?c:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,n=0;do f=await I.read(w,l,g.buffer,n,g.byteLength-n),l+=f,n+=f,d+=f,typeof c=="number"&&(c-=f),n===g.byteLength&&(await p.write(v(g)),g=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof c=="number"?c:h.bufferSize)),n=0);while(f>0&&(typeof c!="number"||c>0)&&E(y)&&b(d,h));if(n>0){let o=n;typeof c=="number"&&(o=Math.min(n,c)),p.write(v(g.slice(0,o)))}}catch(d){throw(0,L.ensureFileSystemProviderError)(d)}finally{await I.close(w)}}function E(I){if(I.isCancellationRequested)throw(0,r.canceled)();return!0}function b(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,87,2,12,4,7,13]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(d){return d.recursive===!0}e.isRecursiveWatchRequest=E;class b extends r.Disposable{constructor(f,c,g,l){super(),this.onFileChanges=f,this.onLogMessage=c,this.verboseLogging=g,this.options=l,this.watcherDisposables=this._register(new r.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const f=new r.DisposableStore;this.watcherDisposables.value=f,this.watcher=this.createWatcher(f),this.watcher.setVerboseLogging(this.verboseLogging),f.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),f.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),f.add(this.watcher.onDidError(c=>this.onError(c)))}onError(f){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${f}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${f}`):this.error(f)}restart(f){this.restartCounter++,this.init(),this.watch(f)}async watch(f){this.requests=f,await this.watcher?.watch(f)}async setVerboseLogging(f){this.verboseLogging=f,await this.watcher?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${f}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class I extends b{constructor(f,c,g){super(f,c,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class C extends b{constructor(f,c,g){super(f,c,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function p(d){return d.map(f=>({type:f.type,resource:T.URI.file(f.path)}))}e.toFileChanges=p;function v(d){const f=new w;for(const c of d)f.processEvent(c);return f.coalesce()}e.coalesceEvents=v;function h(d,f){return typeof f=="string"&&!f.startsWith(D.GLOBSTAR)&&!(0,k.isAbsolute)(f)?{base:d,pattern:f}:f}e.normalizeWatcherPattern=h;function y(d,f){const c=[];for(const g of f)c.push((0,D.parse)(h(d,g)));return c}e.parseWatcherPatterns=y;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(f){return L.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const c=this.mapPathToChange.get(this.toKey(f));let g=!1;if(c){const l=c.type,n=f.type;c.path!==f.path&&(f.type===2||f.type===1)?g=!0:l===1&&n===2?(this.mapPathToChange.delete(this.toKey(f)),this.coalesced.delete(c)):l===2&&n===1?c.type=0:l===1&&n===0||(c.type=n)}else g=!0;g&&(this.coalesced.add(f),this.mapPathToChange.set(this.toKey(f),f))}coalesce(){const f=[],c=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(f.push(g),!1):!0).sort((g,l)=>g.path.length-l.path.length).filter(g=>c.some(l=>(0,P.isParent)(g.path,l,!L.isLinux))?!1:(c.push(g.path),!0)).concat(f)}}}),define(ne[183],re([0,1,53,6,22,47,2,85,12,4,134,28,57]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends T.Disposable{constructor(w,d,f,c){super(),this.request=w,this.onDidFilesChange=d,this.onLogMessage=f,this.verboseLogging=c,this.throttledFileChangesWorker=new r.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g)),this.fileChangesDelayer=this._register(new r.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await C.Promises.stat(w);this._register(await this.doWatch(w,d.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let d=w.path;try{d=await C.Promises.realpath(w.path),w.path===d&&(d=await(0,I.realcase)(w.path)??w.path),w.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${d})`)}catch{}return d}async doWatch(w,d){if(b.isMacintosh&&(0,L.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const f=new k.CancellationTokenSource(this.cts.token),c=new T.DisposableStore;try{const g=(0,E.basename)(w),l=(0,D.watch)(w);c.add((0,T.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${w}'`);const n=new Set;if(d)try{for(const t of await C.Promises.readdir(w))n.add(t)}catch(t){this.error(t)}const o=new Map;c.add((0,T.toDisposable)(()=>{for(const[,t]of o)t.dispose();o.clear()})),l.on("error",(t,i)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),l.on("change",(t,i)=>{if(f.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${i}`);let s="";if(i&&(s=i.toString(),b.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(d)if(t==="rename"){o.get(s)?.dispose();const u=setTimeout(async()=>{if(o.delete(s),s===g&&!await C.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,E.join)(w,s));if(f.token.isCancellationRequested)return;let m;a?n.has(s)?m=0:(m=1,n.add(s)):(n.delete(s),m=2),this.onFileChange({path:(0,E.join)(this.request.path,s),type:m})},v.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let u;n.has(s)?u=0:(u=1,n.add(s)),this.onFileChange({path:(0,E.join)(this.request.path,s),type:u})}else if(t==="rename"||s!==g){const u=setTimeout(async()=>{const a=await C.Promises.exists(w);f.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,T.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(g){await C.Promises.exists(w)&&!f.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${g.toString()})`)}return(0,T.toDisposable)(()=>{f.dispose(!0),c.dispose()})}async onFileChange(w,d=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!d&&this.excludes.some(f=>f(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(f=>f(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const c=(0,p.coalesceEvents)(f);if(c.length>0){if(this.verboseLogging)for(const l of c)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(c)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(b.isLinux)return C.Promises.exists(w);try{const d=(0,E.basename)(w);return(await C.Promises.readdir((0,E.dirname)(w))).some(c=>c===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function h(y,w,d,f,c=512){const g=await C.Promises.open(y,"r"),l=Buffer.allocUnsafe(c),n=new k.CancellationTokenSource(f);let o,t=!1;const i={path:y,excludes:[],recursive:!1},s=new v(i,u=>{(async()=>{for(const{type:a}of u)if(a===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:m}=await C.Promises.read(g,l,0,c,null);if(!m||n.token.isCancellationRequested)break;w(l.slice(0,m))}}catch(m){o=new Error(m),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,d(),new Promise((u,a)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await C.Promises.close(g)}catch(m){o=new Error(m)}o?a(o):u()})})}e.watchFileContents=h}),define(ne[184],re([0,1,3,87,2,4,183]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const I=this.normalizeRequests(b),C=I.filter(v=>{const h=this.watchers.get(v.path);return h?!(0,r.patternsEquals)(h.request.excludes,v.excludes)||!(0,r.patternsEquals)(h.request.includes,v.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:v})=>!I.find(h=>h.path===v.path&&(0,r.patternsEquals)(h.excludes,v.excludes)&&(0,r.patternsEquals)(h.includes,v.includes))).map(({request:v})=>v.path);C.length&&this.trace(`Request to start watching: ${C.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const v of p)this.stopWatching(v);for(const v of C)this.startWatching(v)}startWatching(b){const I=new T.NodeJSFileWatcherLibrary(b,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),C={request:b,instance:I};this.watchers.set(b.path,C)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const I=this.watchers.get(b);I&&(this.watchers.delete(b),I.instance.dispose())}normalizeRequests(b){const I=new Map;for(const C of b){const p=L.isLinux?C.path:C.path.toLowerCase();I.set(p,C)}return Array.from(I.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,I]of this.watchers)I.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,I){return I?`[File Watcher (node.js)] ${b} (path: ${I.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=P}),define(ne[185],re([0,1,57,184]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends D.AbstractNonRecursiveWatcherClient{constructor(T,P,E){super(T,P,E),this.init()}createWatcher(){return new r.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ne[186],re([0,1,23,39,67,57]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends L.AbstractUniversalWatcherClient{constructor(E,b,I){super(E,b,I),this.init()}createWatcher(E){const b=E.add(new k.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),r.ProxyChannel.toService((0,r.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[70],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...k){this._entries=new Map;for(const[L,T]of k)this.set(L,T)}set(k,L){const T=this._entries.get(k);return this._entries.set(k,L),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=D}),define(ne[187],re([0,1,6,9,2,56,177,5,70,81]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class C extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class p{constructor(w=new E.ServiceCollection,d=!1,f,c=I){this._services=w,this._strict=d,this._parent=f,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=c?f?._globalGraph??new T.Graph(g=>g):void 0}createChild(w){return new p(w,this._strict,this,this._enableTracing)}invokeFunction(w,...d){const f=h.traceInvocation(this._enableTracing,w);let c=!1;try{return w({get:l=>{if(c)throw(0,r.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(l,f);if(!n)throw new Error(`[invokeFunction] unknown service '${l}'`);return n}},...d)}finally{c=!0,f.stop()}}createInstance(w,...d){let f,c;return w instanceof L.SyncDescriptor?(f=h.traceCreation(this._enableTracing,w.ctor),c=this._createInstance(w.ctor,w.staticArguments.concat(d),f)):(f=h.traceCreation(this._enableTracing,w),c=this._createInstance(w,d,f)),f.stop(),c}_createInstance(w,d=[],f){const c=P._util.getServiceDependencies(w).sort((n,o)=>n.index-o.index),g=[];for(const n of c){const o=this._getOrCreateServiceInstance(n.id,f);o||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${n.id}.`,!1),g.push(o)}const l=c.length>0?c[0].index:d.length;if(d.length!==l){console.trace(`[createInstance] First service dependency of ${w.name} at position ${l+1} conflicts with ${d.length} static arguments`);const n=l-d.length;n>0?d=d.concat(new Array(n)):d=d.slice(0,l)}return Reflect.construct(w,d.concat(g))}_setServiceInstance(w,d){if(this._services.get(w)instanceof L.SyncDescriptor)this._services.set(w,d);else if(this._parent)this._parent._setServiceInstance(w,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const d=this._services.get(w);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):d}_getOrCreateServiceInstance(w,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const f=this._getServiceInstanceOrDescriptor(w);return f instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,f,d.branch(w,!0)):(d.branch(w,!1),f)}_safeCreateAndCacheServiceInstance(w,d,f){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,d,f)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,d,f){const c=new T.Graph(n=>n.id.toString());let g=0;const l=[{id:w,desc:d,_trace:f}];for(;l.length;){const n=l.pop();if(c.lookupOrInsertNode(n),g++>1e3)throw new C(c);for(const o of P._util.getServiceDependencies(n.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(o.id);if(t||this._throwIfStrict(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(o.id)),t instanceof L.SyncDescriptor){const i={id:o.id,desc:t,_trace:n._trace.branch(o.id,!0)};c.insertEdge(n,i),l.push(i)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new C(c);break}for(const{data:o}of n){if(this._getServiceInstanceOrDescriptor(o.id)instanceof L.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}c.removeNode(o)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,d,f=[],c,g){if(this._services.get(w)instanceof L.SyncDescriptor)return this._createServiceInstance(w,d,f,c,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,d,f,c,g);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(w,d,f=[],c,g){if(c){const l=new p(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(w);const n=new Map,o=new D.IdleValue(()=>{const t=l._createInstance(d,f,g);for(const[i,s]of n){const u=t[i];if(typeof u=="function")for(const a of s)u.apply(t,a)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=n.get(i);return a||(a=new b.LinkedList,n.set(i,a)),(S,_,$)=>{const A=a.push([S,_,$]);return(0,k.toDisposable)(A)}}if(i in t)return t[i];const s=o.value;let u=s[i];return typeof u!="function"||(u=u.bind(s),t[i]=u),u},set(t,i,s){return o.value[i]=s,!0}})}else return this._createInstance(d,f,g)}_throwIfStrict(w,d){if(d&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=p;var v;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(v||(v={}));class h{static traceInvocation(w,d){return w?new h(1,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h._None}static traceCreation(w,d){return w?new h(0,d.name):h._None}constructor(w,d){this.type=w,this.name=d,this._start=Date.now(),this._dep=[]}branch(w,d){const f=new h(2,w.toString());return this._dep.push([w,d,f]),f}stop(){const w=Date.now()-this._start;h._totals+=w;let d=!1;function f(g,l){const n=[],o=new Array(g+1).join("	");for(const[t,i,s]of l._dep)if(i&&s){d=!0,n.push(`${o}CREATES -> ${t}`);const u=f(g+1,s);u&&n.push(u)}else n.push(`${o}uses -> ${t}`);return n.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(w>2||d)&&h.all.add(c.join(`
`))}}e.Trace=h,h.all=new Set,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(ne[188],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(k,L){this.server=k,this.router=L}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,L){this.server.registerChannel(k,L)}}e.MessagePortMainProcessService=D}),define(ne[58],re([0,1,39,56,93,5]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(v,h,y,w){const d=y.getChannel(v);return P(h)?w.createInstance(new r.SyncDescriptor(h.channelClientCtor,[d])):D.ProxyChannel.toService(d,h?.proxyOptions)}}function P(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let E=class extends T{constructor(v,h,y,w){super(v,h,y,w)}};E=pe([Y(2,e.IMainProcessService),Y(3,L.IInstantiationService)],E);function b(p,v,h){(0,k.registerSingleton)(p,new r.SyncDescriptor(E,[v,h],!0))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let I=class extends T{constructor(v,h,y,w){super(v,h,y,w)}};I=pe([Y(2,e.ISharedProcessService),Y(3,L.IInstantiationService)],I);function C(p,v,h){(0,k.registerSingleton)(p,new r.SyncDescriptor(I,[v,h],!0))}e.registerSharedProcessRemoteService=C}),define(ne[71],re([0,1,22,2,4,156,29,5]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let E=class extends r.Disposable{constructor(I){super(),this.extensionGalleryService=I}async getAvailableLanguages(){const I=new D.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let C;try{C=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const v=C.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(y=>y.startsWith("lp-"))).map(h=>{const y=h.properties.localizedLanguages?.[0],w=this.getLocale(h);return{...this.createQuickPickItem(w,y,h),extensionId:h.identifier.id,galleryExtension:h}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(I){return I.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(I,C,p){const v=C??I;let h;if(v!==I&&(h=`(${I})`),I.toLowerCase()===k.language.toLowerCase()&&(h??="",h+=(0,L.localize)(0,null)),p?.installCount){h??="";const y=p.installCount;let w;y>1e6?w=`${Math.floor(y/1e5)/10}M`:y>1e3?w=`${Math.floor(y/1e3)}K`:w=String(y),h+=` $(cloud-download) ${w}`}return{id:I,label:v,description:h}}};E=pe([Y(0,T.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(ne[189],re([0,1,2,71]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends D.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=pe([Y(0,r.ILanguagePackService)],k),e.LocalizationsUpdater=k}),define(ne[8],re([0,1,38,3,2,4,5]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function P(){return new Date().toISOString()}var E;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(o,t,i){switch(t){case E.Trace:o.trace(i);break;case E.Debug:o.debug(i);break;case E.Info:o.info(i);break;case E.Warning:o.warn(i);break;case E.Error:o.error(i);break;case E.Critical:o.critical(i);break;default:throw new Error("Invalid log level")}}e.log=b;function I(o){let t="";for(let i=0;i<o.length;i++){let s=o[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}t+=(i>0?" ":"")+s}return t}e.format=I;class C extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new r.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class p extends C{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(E.Trace)&&this.log(E.Trace,I([t,...i]))}debug(t,...i){this.checkLogLevel(E.Debug)&&this.log(E.Debug,I([t,...i]))}info(t,...i){this.checkLogLevel(E.Info)&&this.log(E.Info,I([t,...i]))}warn(t,...i){this.checkLogLevel(E.Warning)&&this.log(E.Warning,I([t,...i]))}error(t,...i){if(this.checkLogLevel(E.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(E.Error,I(s))}else this.log(E.Error,I([t,...i]))}critical(t,...i){this.checkLogLevel(E.Critical)&&this.log(E.Critical,I([t,...i]))}flush(){}}e.AbstractMessageLogger=p;class v extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!L.isWindows}trace(t,...i){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}debug(t,...i){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}info(t,...i){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}warn(t,...i){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,t,...i):console.warn(`[main ${P()}]`,t,...i))}error(t,...i){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}critical(t,...i){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${P()}]\x1B[0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...i){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=h;class y extends C{constructor(t,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class w extends C{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=w;class d extends k.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=d;class f extends k.Disposable{constructor(t,i){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,i?.always?E.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class c{constructor(){this.onDidChangeLogLevel=new r.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=c;function g(o){if(o.verbose)return E.Trace;if(typeof o.logLevel=="string"){const t=l(o.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function l(o){switch(o){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=l;function n(o){switch(o){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=n}),define(ne[190],re([0,1,6,9,2,12,28,14,8]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends k.Disposable{constructor(C,p){super(),this.environmentService=C,this.logService=p,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,L.basename)(this.environmentService.logsPath),p=(0,L.dirname)(this.environmentService.logsPath),y=(await T.Promises.readdir(p)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==C),w=y.slice(0,Math.max(0,y.length-9));w.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(d=>T.Promises.rm((0,L.join)(p,d)))))}catch(C){(0,r.onUnexpectedError)(C)}}};b=pe([Y(0,P.IEnvironmentService),Y(1,E.ILogService)],b),e.LogsDataCleaner=b}),define(ne[191],re([0,1,18,6,9,3,2,12,57,8]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends T.Disposable{constructor(p,v){super(),this.logService=p,this.options=v,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new r.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}watch(p,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,v):this.watchNonRecursive(p,v)}watchUniversal(p,v){const h={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:v.recursive},y=(0,D.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,k.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,E.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&p.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,v){const h={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:!1},y=(0,D.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,k.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,E.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(ne[192],re([0,1,18,6,16,22,3,65,52,2,34,23,193,19,42,152,13,98,8]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends b.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new r.ResourceQueue)}registerProvider(l,n){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${l}`);const o=new b.DisposableStore;return this.provider.set(l,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:n}),o.add(n.onDidChangeFile(t=>this._onDidFilesChange.fire(new w.FileChangesEvent(t,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&o.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),o.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:l}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:n}),this.provider.delete(l),(0,b.dispose)(o)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(o){n.push(o)}}),!this.provider.has(l)&&await r.Promises.settled(n)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,n){const o=this.provider.get(l.scheme);return!!(o&&o.capabilities&n)}listCapabilities(){return E.Iterable.map(this.provider,([l,n])=>({scheme:l,capabilities:n.capabilities}))}async withProvider(l){if(!(0,v.isAbsolutePath)(l))throw new w.FileOperationError((0,y.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const n=this.provider.get(l.scheme);if(!n){const o=new Error;throw o.name="ENOPRO",o.message=(0,y.localize)(1,null,l.toString()),o}return n}async withReadProvider(l){const n=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)||(0,w.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const n=await this.withProvider(l);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,n){try{return await this.doResolveFile(l,n)}catch(o){throw(0,w.toFileSystemProviderErrorCode)(o)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,y.localize)(2,null,this.resourceForError(l)),1):(0,w.ensureFileSystemProviderError)(o)}}async doResolveFile(l,n){const o=await this.withProvider(l),t=this.isPathCaseSensitive(o),i=n?.resolveTo,s=n?.resolveSingleChildDescendants,u=n?.resolveMetadata,a=await o.stat(l);let m;return this.toFileStat(o,l,a,void 0,!!u,(S,_)=>(m||(m=I.TernarySearchTree.forUris(()=>!t),m.set(l,!0),i&&m.fill(!0,i)),m.get(S.resource)||m.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&s?_===1:!1))}async toFileStat(l,n,o,t,i,s){const{providerExtUri:u}=this.getExtUri(l),a={resource:n,name:u.basename(n),isFile:(o.type&w.FileType.File)!==0,isDirectory:(o.type&w.FileType.Directory)!==0,isSymbolicLink:(o.type&w.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&w.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,w.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(a.isDirectory&&s(a,t)){try{const m=await l.readdir(n),S=await r.Promises.settled(m.map(async([_,$])=>{try{const A=u.joinPath(n,_),U=i?await l.stat(A):{type:$};return await this.toFileStat(l,A,U,m.length,i,s)}catch(A){return this.logService.trace(A),null}}));a.children=(0,D.coalesce)(S)}catch(m){this.logService.trace(m),a.children=[]}return a}return a}async resolveAll(l){return r.Promises.settled(l.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(l){const n=await this.withProvider(l),o=await n.stat(l);return this.toFileStat(n,l,o,void 0,!0,()=>!1)}async exists(l){const n=await this.withProvider(l);try{return!!await n.stat(l)}catch{return!1}}async canCreateFile(l,n){try{await this.doValidateCreateFile(l,n)}catch(o){return o}return!0}async doValidateCreateFile(l,n){if(!n?.overwrite&&await this.exists(l))throw new w.FileOperationError((0,y.localize)(3,null,this.resourceForError(l)),3,n)}async createFile(l,n=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(l,o);const t=await this.writeFile(l,n);return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,t)),t}async writeFile(l,n,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:i}=this.getExtUri(t);try{await this.validateWriteFile(t,l,o)||await this.mkdirp(t,i.dirname(l));let u;if((0,w.hasReadWriteCapability)(t)&&!(n instanceof k.VSBuffer))if((0,h.isReadableStream)(n)){const a=await(0,h.peekStream)(n,3);a.ended?u=k.VSBuffer.concat(a.buffer):u=a}else u=(0,h.peekReadable)(n,a=>k.VSBuffer.concat(a),3);else u=n;!(0,w.hasOpenReadWriteCloseCapability)(t)||(0,w.hasReadWriteCapability)(t)&&u instanceof k.VSBuffer?await this.doWriteUnbuffered(t,l,o,u):await this.doWriteBuffered(t,l,o,u instanceof k.VSBuffer?(0,k.bufferToReadable)(u):u),this._onDidRunOperation.fire(new w.FileOperationEvent(l,4))}catch(s){throw new w.FileOperationError((0,y.localize)(4,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),o)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,n,o){if(!!o?.unlock&&!(l.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(n)));let i;try{i=await l.stat(n)}catch{return}if((i.type&w.FileType.Directory)!==0)throw new w.FileOperationError((0,y.localize)(6,null,this.resourceForError(n)),0,o);if(this.throwIfFileIsReadonly(n,i),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==w.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&o.mtime<i.mtime&&o.etag!==(0,w.etag)({mtime:o.mtime,size:i.size}))throw new w.FileOperationError((0,y.localize)(7,null),3,o);return i}async readFile(l,n,o){const t=await this.withReadProvider(l);return n?.atomic?this.doReadFileAtomic(t,l,n,o):this.doReadFile(t,l,n,o)}async doReadFileAtomic(l,n,o,t){return new Promise((i,s)=>{this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(l,n,o,t);i(u)}catch(u){s(u)}})})}async doReadFile(l,n,o,t){const i=await this.doReadFileStream(l,n,{...o,preferUnbuffered:!0},t);return{...i,value:await(0,k.streamToBuffer)(i.value)}}async readFileStream(l,n,o){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,n,o)}async doReadFileStream(l,n,o,t){const i=new L.CancellationTokenSource(t),s=this.validateReadFile(n,o).then(a=>a,a=>{throw i.cancel(),a});let u;try{return typeof o?.etag=="string"&&o.etag!==w.ETAG_DISABLED&&await s,o?.atomic&&(0,w.hasFileAtomicReadCapability)(l)||!((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasFileReadStreamCapability)(l))||(0,w.hasReadWriteCapability)(l)&&o?.preferUnbuffered?u=this.readFileUnbuffered(l,n,o):(0,w.hasFileReadStreamCapability)(l)?u=this.readFileStreamed(l,n,i.token,o):u=this.readFileBuffered(l,n,i.token,o),{...await s,value:u}}catch(a){u&&await(0,h.consumeStream)(u);const m=(0,y.localize)(8,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(a).toString());throw a instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(m,a.stat,o):new w.FileOperationError(m,(0,w.toFileOperationResult)(a),o)}}readFileStreamed(l,n,o,t=Object.create(null)){const i=l.readFileStream(n,t,o);return(0,h.transform)(i,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new w.FileOperationError((0,y.localize)(9,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),t)},s=>k.VSBuffer.concat(s))}readFileBuffered(l,n,o,t=Object.create(null)){const i=(0,k.newWriteableBufferStream)();return(0,d.readFileIntoStream)(l,n,i,s=>s,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new w.FileOperationError((0,y.localize)(10,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),t)},o),i}readFileUnbuffered(l,n,o){const t=(0,h.newWriteableStream)(i=>k.VSBuffer.concat(i));return(async()=>{try{let i;o?.atomic&&(0,w.hasFileAtomicReadCapability)(l)?i=await l.readFile(n,{atomic:!0}):i=await l.readFile(n),typeof o?.position=="number"&&(i=i.slice(o.position)),typeof o?.length=="number"&&(i=i.slice(0,o.length)),this.validateReadFileLimits(n,i.byteLength,o),t.end(k.VSBuffer.wrap(i))}catch(i){t.error(i),t.end()}})(),t}async validateReadFile(l,n){const o=await this.resolve(l,{resolveMetadata:!0});if(o.isDirectory)throw new w.FileOperationError((0,y.localize)(11,null,this.resourceForError(l)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&n.etag===o.etag)throw new w.NotModifiedSinceFileOperationError((0,y.localize)(12,null),o,n);return this.validateReadFileLimits(l,o.size,n),o}validateReadFileLimits(l,n,o){if(o?.limits){let t;if(typeof o.limits.memory=="number"&&n>o.limits.memory&&(t=9),typeof o.limits.size=="number"&&n>o.limits.size&&(t=7),typeof t=="number")throw new w.FileOperationError((0,y.localize)(13,null,this.resourceForError(l)),t)}}async canMove(l,n,o){return this.doCanMoveCopy(l,n,"move",o)}async canCopy(l,n,o){return this.doCanMoveCopy(l,n,"copy",o)}async doCanMoveCopy(l,n,o,t){if(l.toString()!==n.toString())try{const i=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(i,l,s,n,o,t)}catch(i){return i}return!0}async move(l,n,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(t,l,i,n,"move",!!o),u=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,s==="move"?2:3,u)),u}async copy(l,n,o){const t=await this.withReadProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(t,l,i,n,"copy",!!o),u=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,s==="copy"?3:2,u)),u}async doMoveCopy(l,n,o,t,i,s){if(n.toString()===t.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(l,n,o,t,i,s);if(u&&!a&&s&&await this.del(t,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(t)),i==="copy"){if(l===o&&(0,w.hasFileFolderCopyCapability)(l))await l.copy(n,t,{overwrite:s});else{const m=await this.resolve(n);m.isDirectory?await this.doCopyFolder(l,m,o,t):await this.doCopyFile(l,n,o,t)}return i}else return l===o?(await l.rename(n,t,{overwrite:s}),i):(await this.doMoveCopy(l,n,o,t,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(l,n,o,t){if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(l,n,o,t);if((0,w.hasOpenReadWriteCloseCapability)(l)&&(0,w.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(l,n,o,t);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(l,n,o,t);if((0,w.hasReadWriteCapability)(l)&&(0,w.hasReadWriteCapability)(o))return this.doPipeUnbuffered(l,n,o,t)}async doCopyFolder(l,n,o,t){await o.mkdir(t),Array.isArray(n.children)&&await r.Promises.settled(n.children.map(async i=>{const s=this.getExtUri(o).providerExtUri.joinPath(t,i.name);return i.isDirectory?this.doCopyFolder(l,await this.resolve(i.resource),o,s):this.doCopyFile(l,i.resource,o,s)}))}async doValidateMoveCopy(l,n,o,t,i,s){let u=!1;if(l===o){const{providerExtUri:m,isPathCaseSensitive:S}=this.getExtUri(l);if(S||(u=m.isEqual(n,t)),u&&i==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(n),this.resourceForError(t)));if(!u&&m.isEqualOrParent(t,n))throw new Error((0,y.localize)(15,null,this.resourceForError(n),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!u){if(!s)throw new w.FileOperationError((0,y.localize)(16,null,this.resourceForError(n),this.resourceForError(t)),4);if(l===o){const{providerExtUri:m}=this.getExtUri(l);if(m.isEqualOrParent(n,t))throw new Error((0,y.localize)(17,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:u}}getExtUri(l){const n=this.isPathCaseSensitive(l);return{providerExtUri:n?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(n,l);const o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(l,0,o)),o}async mkdirp(l,n){const o=[],{providerExtUri:t}=this.getExtUri(l);for(;!t.isEqual(n,t.dirname(n));)try{if(((await l.stat(n)).type&w.FileType.Directory)===0)throw new Error((0,y.localize)(18,null,this.resourceForError(n)));break}catch(i){if((0,w.toFileSystemProviderErrorCode)(i)!==w.FileSystemProviderErrorCode.FileNotFound)throw i;o.push(t.basename(n)),n=t.dirname(n)}for(let i=o.length-1;i>=0;i--){n=t.joinPath(n,o[i]);try{await l.mkdir(n)}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,n){try{await this.doValidateDelete(l,n)}catch(o){return o}return!0}async doValidateDelete(l,n){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!n?.useTrash&&!(o.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(l)));let i;try{i=await o.stat(l)}catch{}if(i)this.throwIfFileIsReadonly(l,i);else throw new w.FileOperationError((0,y.localize)(20,null,this.resourceForError(l)),1);if(!!!n?.recursive){const u=await this.resolve(l);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,y.localize)(21,null,this.resourceForError(l)))}return o}async del(l,n){const o=await this.doValidateDelete(l,n),t=!!n?.useTrash,i=!!n?.recursive;await o.delete(l,{recursive:i,useTrash:t}),this._onDidRunOperation.fire(new w.FileOperationEvent(l,1))}async cloneFile(l,n){const o=await this.withProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(o===t&&this.getExtUri(o).providerExtUri.isEqual(l,n))return;if(o===t&&(0,w.hasFileCloneCapability)(o))return o.cloneFile(l,n);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n));const i=this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri);return o===t&&(0,w.hasFileFolderCopyCapability)(o)?i.queue(()=>o.copy(l,n,{overwrite:!0})):i.queue(()=>this.doCopyFile(o,l,t,n))}watch(l,n={recursive:!1,excludes:[]}){const o=new b.DisposableStore;let t=!1,i=()=>{t=!0};return o.add((0,b.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(l,n);t?(0,b.dispose)(s):i=()=>(0,b.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(l,n){const o=await this.withProvider(l),t=(0,P.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(l),n]);let i=this.activeWatchers.get(t);return i||(i={count:0,disposable:o.watch(l,n)},this.activeWatchers.set(t,i)),i.count+=1,(0,b.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,b.dispose)(i.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,b.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,n,o,t){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{const i=await l.open(n,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(t)||(0,h.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(l,i,t):await this.doWriteReadableBufferedQueued(l,i,t)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await l.close(i)}})}async doWriteStreamBufferedQueued(l,n,o){let t=0,i;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(l,n,s,s.byteLength,t,0),t+=s.byteLength}if(o.ended)return;i=o.stream}else i=o;return new Promise((s,u)=>{(0,h.listenStream)(i,{onData:async a=>{i.pause();try{await this.doWriteBuffer(l,n,a,a.byteLength,t,0)}catch(m){return u(m)}t+=a.byteLength,setTimeout(()=>i.resume())},onError:a=>u(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,n,o){let t=0,i;for(;(i=o.read())!==null;)await this.doWriteBuffer(l,n,i,i.byteLength,t,0),t+=i.byteLength}async doWriteBuffer(l,n,o,t,i,s){let u=0;for(;u<t;)u+=await l.write(n,i+u,o.buffer,s+u,t-u)}async doWriteUnbuffered(l,n,o,t){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,n,o,t))}async doWriteUnbufferedQueued(l,n,o,t){let i;t instanceof k.VSBuffer?i=t:(0,h.isReadableStream)(t)?i=await(0,k.streamToBuffer)(t):(0,h.isReadableBufferedStream)(t)?i=await(0,k.bufferedStreamToBuffer)(t):i=(0,k.readableToBuffer)(t),await l.writeFile(n,i.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(l,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,n,o,t))}async doPipeBufferedQueued(l,n,o,t){let i,s;try{i=await l.open(n,{create:!1}),s=await o.open(t,{create:!0,unlock:!1});const u=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,m=0,S=0;do S=await l.read(i,a,u.buffer,m,u.byteLength-m),await this.doWriteBuffer(o,s,u,S,a,m),a+=S,m+=S,m===u.byteLength&&(m=0);while(S>0)}catch(u){throw(0,w.ensureFileSystemProviderError)(u)}finally{await r.Promises.settled([typeof i=="number"?l.close(i):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,n,o,t))}async doPipeUnbufferedQueued(l,n,o,t){return o.writeFile(t,await l.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,n,o,t))}async doPipeUnbufferedToBufferedQueued(l,n,o,t){const i=await o.open(t,{create:!0,unlock:!1});try{const s=await l.readFile(n);await this.doWriteBuffer(o,i,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await o.close(i)}}async doPipeBufferedToUnbuffered(l,n,o,t){const i=await(0,k.streamToBuffer)(this.readFileBuffered(l,n,L.CancellationToken.None));await this.doWriteUnbuffered(o,t,void 0,i)}throwIfFileSystemIsReadonly(l,n){if(l.capabilities&2048)throw new w.FileOperationError((0,y.localize)(22,null,this.resourceForError(n)),6);return l}throwIfFileIsReadonly(l,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,y.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===C.Schemas.file?l.fsPath:l.toString(!0)}};c=pe([Y(0,f.ILogService)],c),e.FileService=c}),define(ne[194],re([0,1,53,278,6,34,16,3,47,2,12,4,19,42,28,155,13,98,191,38,186,185]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,r.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(o)}`)}})();class n extends f.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(t){try{const i=await h.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async u=>{try{let a;u.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(t,u.name))).type:a=this.toType(u),s.push([u.name,a])}catch(a){this.logService.trace(a)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let s;return i?.dangling?s=w.FileType.Unknown:t.isFile()?s=w.FileType.File:t.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,i&&(s|=w.FileType.SymbolicLink),s}async createResourceLock(t){const i=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const u=new k.Barrier;return this.resourceLocks.set(t,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,b.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),s=await this.createResourceLock(t));const u=this.toFilePath(t);return await h.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{s?.dispose()}}traceLock(t){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,i,s){const u=(0,v.newWriteableStream)(a=>T.VSBuffer.concat(a.map(m=>T.VSBuffer.wrap(m))).buffer);return(0,d.readFileIntoStream)(this,t,u,a=>a.buffer,{...i,bufferSize:256*1024},s),u}async writeFile(t,i,s){let u;try{const a=this.toFilePath(t);if(!s.create||!s.overwrite){if(await h.Promises.exists(a)){if(!s.overwrite)throw(0,w.createFileSystemProviderError)((0,y.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.createFileSystemProviderError)((0,y.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(u,0,i,0,i.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(t){n.canFlush=t}async open(t,i){const s=this.toFilePath(t);let u;(0,w.isFileOpenForWriteOptions)(i)&&(u=await this.createResourceLock(t));let a;try{if((0,w.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:S}=await h.SymlinkSupport.stat(s);S.mode&128||await h.Promises.chmod(s,S.mode|128)}catch(S){this.logService.trace(S)}let m;if((0,w.isFileOpenForWriteOptions)(i)){if(C.isWindows)try{await h.Promises.truncate(s,0),m="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}m||(m="w")}else m="r";a=await h.Promises.open(s,m)}catch(m){throw u?.dispose(),(0,w.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,m):this.toFileSystemProviderError(m)}if(this.mapHandleToPos.set(a,0),(0,w.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,t),u){const m=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,u),m&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),m.dispose())}return a}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await h.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(t)}catch(s){throw this.toFileSystemProviderError(s)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,u,a){const m=this.normalizePos(t,i);let S=null;try{S=(await h.Promises.read(t,s,u,a,m)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(t,m,S)}return S}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,s){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(t,u+s):this.mapHandleToPos.delete(t)))}async write(t,i,s,u,a){return(0,k.retry)(()=>this.doWrite(t,i,s,u,a),100,3)}async doWrite(t,i,s,u,a){const m=this.normalizePos(t,i);let S=null;try{S=(await h.Promises.write(t,s,u,a,m)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),_)}finally{this.updatePos(t,m,S)}return S}async mkdir(t){try{await h.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const s=this.toFilePath(t);i.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(t,i,s){const u=this.toFilePath(t),a=this.toFilePath(i);if(u!==a)try{await this.validateTargetDeleted(t,i,"move",s.overwrite),await h.Promises.move(u,a)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,y.localize)(2,null,(0,I.basename)(u),(0,I.basename)((0,I.dirname)(a)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(t,i,s){const u=this.toFilePath(t),a=this.toFilePath(i);if(u!==a)try{await this.validateTargetDeleted(t,i,"copy",s.overwrite),await h.Promises.copy(u,a,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,y.localize)(3,null,(0,I.basename)(u),(0,I.basename)((0,I.dirname)(a)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(t,i,s,u){const a=this.toFilePath(t),m=this.toFilePath(i);let S=!1;if(!!(this.capabilities&1024)||(S=(0,E.isEqual)(a,m,!0)),S&&s==="copy")throw(0,w.createFileSystemProviderError)((0,y.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!S&&await h.Promises.exists(m)){if(!u)throw(0,w.createFileSystemProviderError)((0,y.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,s){const u=this.toFilePath(t),a=this.toFilePath(i),m=!!(this.capabilities&1024);if((0,E.isEqual)(u,a,!m))return;const S=new b.DisposableStore;try{const[_,$]=await Promise.all([this.createResourceLock(t),this.createResourceLock(i)]);S.add(_),S.add($),s&&await h.Promises.mkdir((0,I.dirname)(a),{recursive:!0}),await h.Promises.copyFile(u,a)}catch(_){if(_.code==="ENOENT"&&!s)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(_)}finally{S.dispose()}}createUniversalWatcher(t,i,s){return new g.UniversalWatcherClient(u=>t(u),u=>i(u),s)}createNonRecursiveWatcher(t,i,s){return new l.NodeJSWatcherClient(u=>t(u),u=>i(u),s)}toFileSystemProviderError(t){if(t instanceof w.FileSystemProviderError)return t;let i;switch(t.code){case"ENOENT":i=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=w.FileSystemProviderErrorCode.NoPermissions;break;default:i=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(t,i)}async toFileSystemProviderWriteError(t,i){let s=this.toFileSystemProviderError(i);if(t&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await h.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(s=(0,w.createFileSystemProviderError)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return s}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(ne[99],re([0,1,3,7,8]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(p){this.service=p,this.onDidChangeLogLevel=D.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=L;class T{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){T.setLevel(this.channel,p)}static setLevel(p,v){return p.call("setLevel",v)}}e.LogLevelChannelClient=T;class P{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,v){throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"createLogger":this.createLogger(r.URI.revive(h[0]),h[1]);return;case"log":return this.log(r.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(p,v){this.loggers.set(p.toString(),this.loggerService.createLogger(p,v))}consoleLog(p,v){let h=console.log;switch(p){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(p,v){const h=this.loggers.get(p.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,w]of v)(0,k.log)(h,y,w)}}e.LoggerChannel=P;class E extends k.AbstractLoggerService{constructor(p,v,h){super(p,v),this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(p,v)=>{this.channel.call("consoleLog",[p,v])}})}doCreateLogger(p,v,h){return new b(this.channel,p,v,h)}}e.LoggerChannelClient=E;class b extends k.AbstractMessageLogger{constructor(p,v,h,y){super(y?.always),this.channel=p,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,v){const h=[[p,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(p){this.channel.call("log",[this.file,p])}}class I extends k.LogService{constructor(p,v){super(v),this.parent=p,this._register(p.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=I}),define(ne[59],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[60],re([0,1,3,52,2,5]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class T extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(b){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...b,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(b),r.Iterable.reduce(this.policies.entries(),(C,[p,v])=>({...C,[p]:v}),{})}getPolicyValue(b){return this.policies.get(b)}serialize(){return r.Iterable.reduce(Object.entries(this.policyDefinitions),(b,[I,C])=>({...b,[I]:{definition:C,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=T;class P{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ne[195],re([0,1,3,2,60]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(E){this.service=E,this.disposables=new r.DisposableStore}listen(E,b){switch(b){case"onDidChange":return D.Event.map(this.service.onDidChange,I=>I.reduce((C,p)=>({...C,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${b}`)}call(E,b,I){switch(b){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${b}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class T extends k.AbstractPolicyService{constructor(E,b){super(),this.channel=b;for(const I in E){const{definition:C,value:p}=E[I];this.policyDefinitions[I]=C,p!==void 0&&this.policies.set(I,p)}this.channel.listen("onDidChange")(I=>{for(const C in I){const p=I[C];p===null?this.policies.delete(C):this.policies.set(C,p)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(E){const b=await this.channel.call("registerPolicyDefinitions",E);for(const I in b)this.policies.set(I,b[I])}}e.PolicyChannelClient=T}),define(ne[100],re([0,1,23,4,37,19]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof r.globals.vscode<"u"&&typeof r.globals.vscode.context<"u"){const P=r.globals.vscode.context.configuration();if(P)T=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const P=(0,L.dirname)(D.FileAccess.asFileUri("",Q));if(T=Q.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath),k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const E=Q.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);Object.assign(T,{version:E.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ne[25],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[196],re([0,1,6,9,2,12,28,8,25]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends k.Disposable{constructor(C,p,v){super(),this.productService=p,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},3e4)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),v=(0,L.dirname)(C),h=(0,L.basename)(C),y=await T.Promises.readdir(v);await Promise.all(y.map(async w=>{if(w===h)return;const d=(0,L.join)(v,w),f=await T.Promises.stat(d);if(f.isDirectory()&&p-f.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),T.Promises.rm(d)}))}catch(p){(0,r.onUnexpectedError)(p)}}};b=pe([Y(1,E.IProductService),Y(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(ne[197],re([0,1,6,9,2,12,28,14,8,25]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends k.Disposable{constructor(p,v,h){super(),this.environmentService=p,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),v=JSON.parse(await T.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(v)){const c=v[f];p[`${c.hash}.${f}`]=!0}const h=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const w=await T.Promises.readdir(h);for(const f of w){if(p[f]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await T.Promises.rm((0,L.join)(h,f))}const d=Date.now();for(const f of Object.keys(p)){const c=(0,L.join)(h,f),g=await T.Promises.readdir(c);for(const l of g){if(l==="tcf.json")continue;const n=(0,L.join)(c,l),o=await T.Promises.stat(n);o.isDirectory()&&d-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(f,l)}`),await T.Promises.rm(n))}}}catch(p){(0,r.onUnexpectedError)(p)}}};I=pe([Y(0,P.INativeEnvironmentService),Y(1,E.ILogService),Y(2,b.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(ne[198],re([0,1,12,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,r.createDecorator)("IV8InspectProfilingService");var k;(function(L){function T(P,E="noAbsolutePaths"){for(const b of P.nodes)b.callFrame&&b.callFrame.url&&((0,D.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(b.callFrame.url))&&(b.callFrame.url=(0,D.join)(E,(0,D.basename)(b.callFrame.url)));return P}L.rewriteAbsolutePaths=T})(k=e.Utils||(e.Utils={}))}),define(ne[199],re([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class r{constructor(){this._sessions=new Map}async startProfiling(L){const P=await(await new Promise((b,I)=>{Q(["v8-inspect-profiler"],b,I)})).startProfiling({port:L.port,checkForPaused:!0}),E=(0,D.generateUuid)();return this._sessions.set(E,P),E}async stopProfiling(L){const T=this._sessions.get(L);if(!T)throw new Error(`UNKNOWN session '${L}'`);const P=await T.stop();return this._sessions.delete(L),P.profile}}e.InspectProfilingService=r}),define(ne[40],re([0,1,116,15]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,P){D.ok(r.isString(T)),D.ok(r.isObject(P)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ne[101],re([0,1,3,40]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,b){this.schemasById[k(E)]=b,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;r.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[43],re([0,1,18,3,15,141,17,101,40]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=E.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const t=this.doRegisterConfigurations(n,o);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(n){const o=this.doDeregisterConfigurations(n);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const t=[];t.push(...this.doDeregisterConfigurations(o)),t.push(...this.doRegisterConfigurations(n,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(n){const o=[],t=[];for(const{overrides:i,source:s}of n)for(const u in i)if(o.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const a=this.configurationDefaultsOverrides.get(u),m=a?.valuesSources??new Map;if(s)for(const A of Object.keys(i[u]))m.set(A,s);const S={...a?.value||{},...i[u]};this.configurationDefaultsOverrides.set(u,{source:s,value:S,valuesSources:m});const _=(0,T.getLanguageTagSettingPlainKey)(u),$={type:"object",default:S,description:L.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:k.isString(s)?void 0:s,defaultValueSource:s};t.push(...y(u)),this.configurationProperties[u]=$,this.defaultLanguageConfigurationOverridesNode.properties[u]=$}else{this.configurationDefaultsOverrides.set(u,{value:i[u],source:s});const a=this.configurationProperties[u];a&&(this.updatePropertyDefaultValue(u,a),this.updateSchema(u,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const o=[];for(const{overrides:t,source:i}of n)for(const s in t){const u=this.configurationDefaultsOverrides.get(s),a=k.isString(i)?i:i?.id,m=k.isString(u?.source)?u?.source:u?.source?.id;if(a===m)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const S=this.configurationProperties[s];S&&(this.updatePropertyDefaultValue(s,S),this.updateSchema(s,S))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o){const t=[];return n.forEach(i=>{t.push(...this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),t}doDeregisterConfigurations(n){const o=[],t=i=>{if(i.properties)for(const s in i.properties){o.push(s);const u=this.configurationProperties[s];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(n,o=!0,t,i,s=3){s=k.isUndefinedOrNull(n.scope)?s:n.scope;const u=[],a=n.properties;if(a)for(const S in a){const _=a[S];if(o&&c(S,_)){delete a[S];continue}if(_.source=t,_.defaultDefaultValue=a[S].default,this.updatePropertyDefaultValue(S,_),e.OVERRIDE_PROPERTY_REGEX.test(S)?_.scope=void 0:(_.scope=k.isUndefinedOrNull(_.scope)?s:_.scope,_.restricted=k.isUndefinedOrNull(_.restricted)?!!i?.includes(S):_.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.excludedConfigurationProperties[S]=a[S],delete a[S];continue}else this.configurationProperties[S]=a[S],a[S].policy?.name&&this.policyConfigurations.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),u.push(S)}const m=n.allOf;if(m)for(const S of m)u.push(...this.validateAndRegisterProperties(S,o,t,i,s));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=t=>{const i=t.properties;if(i)for(const u in i)this.updateSchema(u,i[u]);t.allOf?.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const t=this.configurationDefaultsOverrides.get(n);let i=t?.value,s=t?.source;k.isUndefined(i)&&(i=o.defaultDefaultValue,s=void 0),k.isUndefined(i)&&(i=d(o.type)),o.default=i,o.defaultValueSource=s}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(l){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let o=h.exec(l);for(;o?.length;){const t=o[1].trim();t&&n.push(t),o=h.exec(l)}}return(0,D.distinct)(n)}e.overrideIdentifiersFromKey=y;function w(l){return l.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=w;function d(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const f=new p;E.Registry.add(e.Extensions.Configuration,f);function c(l,n){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?L.localize(7,null,l):f.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):n.policy?.name&&f.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,l,n.policy?.name,f.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.validateProperty=c;function g(){const l=[],n=f.getConfigurationProperties();for(const o of Object.keys(n))l.push([o,n[o].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=g}),define(ne[72],re([0,1,18,3,35,2,34,32,15,7,17,43,40]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(n={},o=[],t=[],i){this._contents=n,this._keys=o,this._overrides=t,this.raw=i,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(o=>{if(o instanceof v)return o;const t=new h("");return t.parseRaw(o),t.configurationModel});this._rawConfiguration=n.reduce((o,t)=>t===o?t:o.merge(t),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}inspect(n,o){const t=this.rawConfiguration.getValue(n),i=o?this.rawConfiguration.getOverrideValue(n,o):void 0,s=o?this.rawConfiguration.override(o).getValue(n):t;return{value:t,override:i,merged:s}}getOverrideValue(n,o){const t=this.getContentsForOverrideIdentifer(o);return t?n?(0,I.getConfigurationValue)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const t of this.overrides)t.identifiers.includes(n)&&o.push(...t.keys);return D.distinct(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return D.distinct(n)}override(n){let o=this.overrideConfigurations.get(n);return o||(o=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,o)),o}merge(...n){const o=P.deepClone(this.contents),t=P.deepClone(this.overrides),i=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const u of n)if(s.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.mergeContents(o,u.contents);for(const a of u.overrides){const[m]=t.filter(S=>D.equals(S.identifiers,a.identifiers));m?(this.mergeContents(m.contents,a.contents),m.keys.push(...a.keys),m.keys=D.distinct(m.keys)):t.push(P.deepClone(a))}for(const a of u.keys)i.indexOf(a)===-1&&i.push(a)}return new v(o,i,t,s.every(u=>u instanceof v)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new v(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(n){const o=this.getContentsForOverrideIdentifer(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const t={};for(const i of D.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[i];const u=o[i];u&&(typeof s=="object"&&typeof u=="object"?(s=P.deepClone(s),this.mergeContents(s,u)):s=u),t[i]=s}return new v(t,this.keys,this.overrides)}mergeContents(n,o){for(const t of Object.keys(o)){if(t in n&&E.isObject(n[t])&&E.isObject(o[t])){this.mergeContents(n[t],o[t]);continue}n[t]=P.deepClone(o[t])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?P.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let o=null,t=null;const i=s=>{s&&(t?this.mergeContents(t,s):t=P.deepClone(s))};for(const s of this.overrides)D.equals(s.identifiers,[n])?o=s.contents:s.identifiers.includes(n)&&i(s.contents);return i(o),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,o){this.addKey(n),(0,I.addToValueTree)(this.contents,n,o,t=>{throw new Error(t)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let o=this.keys.length;for(let t=0;t<o;t++)n.indexOf(this.keys[t])===0&&(o=t);this.keys.splice(o,1,n)}removeKey(n){const o=this.keys.indexOf(n);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,o){if(!E.isUndefinedOrNull(n)){const t=this.doParseContent(n);this.parseRaw(t,o)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,o){this._raw=n;const{contents:t,keys:i,overrides:s,restricted:u,hasExcludedProperties:a}=this.doParseRaw(n,o);this._configurationModel=new v(t,i,s,a?[n]:void 0),this._restrictedConfigurations=u||[]}doParseContent(n){let o={},t=null,i=[];const s=[],u=[];function a(S){Array.isArray(i)?i.push(S):t!==null&&(i[t]=S)}const m={onObjectBegin:()=>{const S={};a(S),s.push(i),i=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{const S=[];a(S),s.push(i),i=S,t=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:a,onError:(S,_,$)=>{u.push({error:S,offset:_,length:$})}};if(n)try{k.visit(n,m),o=i[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return o}doParseRaw(n,o){const t=p.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),i=this.filter(n,t,!0,o);n=i.raw;const s=(0,I.toValuesTree)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),u=Object.keys(n),a=this.toOverrides(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:s,keys:u,overrides:a,restricted:i.restricted,hasExcludedProperties:i.hasExcludedProperties}}filter(n,o,t,i){let s=!1;if(!i?.scopes&&!i?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:s};const u={},a=[];for(const m in n)if(C.OVERRIDE_PROPERTY_REGEX.test(m)&&t){const S=this.filter(n[m],o,!1,i);u[m]=S.raw,s=s||S.hasExcludedProperties,a.push(...S.restricted)}else{const S=o[m],_=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&a.push(m),(_===void 0||i.scopes===void 0||i.scopes.includes(_))&&!(i.skipRestricted&&S?.restricted)?u[m]=n[m]:s=!0}return{raw:u,restricted:a,hasExcludedProperties:s}}toOverrides(n,o){const t=[];for(const i of Object.keys(n))if(C.OVERRIDE_PROPERTY_REGEX.test(i)){const s={};for(const u in n[i])s[u]=n[i][u];t.push({identifiers:(0,C.overrideIdentifiersFromKey)(i),keys:Object.keys(s),contents:(0,I.toValuesTree)(s,o)})}return t}}e.ConfigurationModelParser=h;class y extends L.Disposable{constructor(n,o,t,i){super(),this.userSettingsResource=n,this.scopes=o,this.fileService=i,this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(r.Event.any(r.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),r.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&t.isEqual(s.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class w{constructor(n,o,t,i,s=new v,u=new v,a=new T.ResourceMap,m=new v,S=new T.ResourceMap,_=!0){this._defaultConfiguration=n,this._policyConfiguration=o,this._applicationConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=a,this._memoryConfiguration=m,this._memoryConfigurationByResource=S,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,o,t){return this.getConsolidatedConfigurationModel(n,o,t).getValue(n)}updateValue(n,o,t={}){let i;t.resource?(i=this._memoryConfigurationByResource.get(t.resource),i||(i=new v,this._memoryConfigurationByResource.set(t.resource,i))):i=this._memoryConfiguration,o===void 0?i.removeValue(n):i.setValue(n,o),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,o,t){const i=this.getConsolidatedConfigurationModel(n,o,t),s=this.getFolderConfigurationModelForResource(o.resource,t),u=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,a=this._defaultConfiguration.inspect(n,o.overrideIdentifier),m=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(n),S=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(n),_=this.userConfiguration.freeze().inspect(n,o.overrideIdentifier),$=this.localUserConfiguration.freeze().inspect(n,o.overrideIdentifier),A=this.remoteUserConfiguration.freeze().inspect(n,o.overrideIdentifier),U=t?this._workspaceConfiguration.freeze().inspect(n,o.overrideIdentifier):void 0,R=s?s.freeze().inspect(n,o.overrideIdentifier):void 0,N=u.inspect(n,o.overrideIdentifier),F=i.getValue(n),q=D.distinct(i.overrides.map(J=>J.identifiers).flat()).filter(J=>i.getOverrideValue(n,J)!==void 0);return{defaultValue:a?a.merged:void 0,policyValue:m?m.merged:void 0,applicationValue:S?S.merged:void 0,userValue:_?_.merged:void 0,userLocalValue:$?$.merged:void 0,userRemoteValue:A?A.merged:void 0,workspaceValue:U?U.merged:void 0,workspaceFolderValue:R?R.merged:void 0,memoryValue:N?N.merged:void 0,value:F,default:a.value!==void 0||a.override!==void 0?{value:a.value,override:a.override}:void 0,policy:m?.value!==void 0?{value:m.value}:void 0,application:S?.value!==void 0||S?.override!==void 0?{value:S.value,override:S.override}:void 0,user:_.value!==void 0||_.override!==void 0?{value:_.value,override:_.override}:void 0,userLocal:$.value!==void 0||$.override!==void 0?{value:$.value,override:$.override}:void 0,userRemote:A.value!==void 0||A.override!==void 0?{value:A.value,override:A.override}:void 0,workspace:U?.value!==void 0||U?.override!==void 0?{value:U.value,override:U.override}:void 0,workspaceFolder:R?.value!==void 0||R?.override!==void 0?{value:R.value,override:R.override}:void 0,memory:N.value!==void 0||N.override!==void 0?{value:N.value,override:N.override}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(n){const o=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,o){this._folderConfigurations.set(n,o),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const t=[];if(!o){const{added:i,updated:s,removed:u}=c(this._defaultConfiguration,n);o=[...i,...s,...u]}for(const i of o)for(const s of(0,C.overrideIdentifiersFromKey)(i)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(s),a=n.getKeysForOverrideIdentifier(s),m=[...a.filter(S=>u.indexOf(S)===-1),...u.filter(S=>a.indexOf(S)===-1),...u.filter(S=>!P.equals(this._defaultConfiguration.override(s).getValue(S),n.override(s).getValue(S)))];t.push([s,m])}return this.updateDefaultConfiguration(n),{keys:o,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:t,removed:i}=c(this._policyConfiguration,n),s=[...o,...t,...i];return s.length&&this.updatePolicyConfiguration(n),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:t,removed:i,overrides:s}=c(this.applicationConfiguration,n),u=[...o,...t,...i];return u.length&&this.updateApplicationConfiguration(n),{keys:u,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:t,removed:i,overrides:s}=c(this.localUserConfiguration,n),u=[...o,...t,...i];return u.length&&this.updateLocalUserConfiguration(n),{keys:u,overrides:s}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:t,removed:i,overrides:s}=c(this.remoteUserConfiguration,n),u=[...o,...t,...i];return u.length&&this.updateRemoteUserConfiguration(n),{keys:u,overrides:s}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:t,removed:i,overrides:s}=c(this.workspaceConfiguration,n),u=[...o,...t,...i];return u.length&&this.updateWorkspaceConfiguration(n),{keys:u,overrides:s}}compareAndUpdateFolderConfiguration(n,o){const t=this.folderConfigurations.get(n),{added:i,updated:s,removed:u,overrides:a}=c(t,o),m=[...i,...s,...u];return(m.length||!t)&&this.updateFolderConfiguration(n,o),{keys:m,overrides:a}}compareAndDeleteFolderConfiguration(n){const o=this.folderConfigurations.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:i,removed:s,overrides:u}=c(o,void 0);return{keys:[...t,...i,...s],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,o,t){let i=this.getConsolidatedConfigurationModelForResource(o,t);return o.overrideIdentifier&&(i=i.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:n},o){let t=this.getWorkspaceConsolidatedConfiguration();if(o&&n){const i=o.getFolder(n);i&&(t=this.getFolderConsolidatedConfiguration(i.uri)||t);const s=this._memoryConfigurationByResource.get(n);s&&(t=t.merge(s))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let o=this._foldersConsolidatedConfigurations.get(n);if(!o){const t=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(n);i?(o=t.merge(i),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(n,o)):o=t}return o}getFolderConfigurationModelForResource(n,o){if(o&&n){const t=o.getFolder(n);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,o)=>{const{contents:t,overrides:i,keys:s}=this._folderConfigurations.get(o);return n.push([o,{contents:t,overrides:i,keys:s}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>n.add(o)),this.userConfiguration.freeze().keys.forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(t=>n.add(t))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>o.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>o.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>o.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i))),[...o.values()]}static parse(n){const o=this.parseConfigurationModel(n.defaults),t=this.parseConfigurationModel(n.policy),i=this.parseConfigurationModel(n.application),s=this.parseConfigurationModel(n.user),u=this.parseConfigurationModel(n.workspace),a=n.folders.reduce((m,S)=>(m.set(b.URI.revive(S[0]),this.parseConfigurationModel(S[1])),m),new T.ResourceMap);return new w(o,t,i,s,new v,u,a,new v,new T.ResourceMap,!1)}static parseConfigurationModel(n){return new v(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=w;function d(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const n=new Set,o=new Map;for(const i of l)i.keys.forEach(s=>n.add(s)),i.overrides.forEach(([s,u])=>{const a=(0,T.getOrSet)(o,s,new Set);u.forEach(m=>a.add(m))});const t=[];return o.forEach((i,s)=>t.push([s,[...i.values()]])),{keys:[...n.values()],overrides:t}}e.mergeChanges=d;class f{constructor(n,o,t,i){this.change=n,this.previous=o,this.currentConfiguraiton=t,this.currentWorkspace=i,this._previousConfiguration=void 0;const s=new Set;n.keys.forEach(a=>s.add(a)),n.overrides.forEach(([,a])=>a.forEach(m=>s.add(m))),this.affectedKeys=[...s.values()];const u=new v;this.affectedKeys.forEach(a=>u.setValue(a,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(o){const t=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(n,o,this.currentWorkspace);return!P.equals(t,i)}return!0}return!1}doesAffectedKeysTreeContains(n,o){let t=(0,I.toValuesTree)({[o]:!0},()=>{}),i;for(;typeof t=="object"&&(i=Object.keys(t)[0]);){if(n=n[i],!n)return!1;t=t[i]}return!0}}e.ConfigurationChangeEvent=f;function c(l,n){const{added:o,removed:t,updated:i}=g(n,l),s=[],u=l?.getAllOverrideIdentifiers()||[],a=n?.getAllOverrideIdentifiers()||[];if(n){const m=a.filter(S=>!u.includes(S));for(const S of m)s.push([S,n.getKeysForOverrideIdentifier(S)])}if(l){const m=u.filter(S=>!a.includes(S));for(const S of m)s.push([S,l.getKeysForOverrideIdentifier(S)])}if(n&&l){for(const m of u)if(a.includes(m)){const S=g({contents:l.getOverrideValue(void 0,m)||{},keys:l.getKeysForOverrideIdentifier(m)},{contents:n.getOverrideValue(void 0,m)||{},keys:n.getKeysForOverrideIdentifier(m)});s.push([m,[...S.added,...S.removed,...S.updated]])}}return{added:o,removed:t,updated:i,overrides:s}}function g(l,n){const o=l?n?l.keys.filter(s=>n.keys.indexOf(s)===-1):[...l.keys]:[],t=n?l?n.keys.filter(s=>l.keys.indexOf(s)===-1):[...n.keys]:[],i=[];if(l&&n){for(const s of n.keys)if(l.keys.indexOf(s)!==-1){const u=(0,I.getConfigurationValue)(n.contents,s),a=(0,I.getConfigurationValue)(l.contents,s);P.equals(u,a)||i.push(s)}}return{added:o,removed:t,updated:i}}}),define(ne[200],re([0,1,18,3,2,32,15,17,72,43,8,60,40]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:c})=>this.onDidUpdateConfiguration(f,c))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(f,c){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:f})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class h extends E.ConfigurationModel{constructor(f={}){const c=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),g=Object.keys(c),l=Object.create(null),n=[];for(const o in c){const t=f[o],i=t!==void 0?t:c[o].default;(0,P.addToValueTree)(l,o,i,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(l))b.OVERRIDE_PROPERTY_REGEX.test(o)&&n.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(l[o]),contents:(0,P.toValuesTree)(l[o],t=>console.error(`Conflict in default settings file: ${t}`))});super(l,g,n)}}e.DefaultConfigurationModel=h;class y{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let w=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(f,c,g){super(),this.defaultConfiguration=f,this.policyService=c,this.logService=g,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(f=>this.onDidChangePolicies(f))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:f})=>this.update(await this.registerPolicyDefinitions(f),!0))),this._configurationModel}async registerPolicyDefinitions(f){const c={},g=[],l=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const n of f){const o=l[n];if(!o){g.push(n);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}g.push(n),c[o.policy.name]={type:o.type}}}return(0,T.isEmptyObject)(c)||await this.policyService.registerPolicyDefinitions(c),g}onDidChangePolicies(f){const c=p.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),g=(0,D.coalesce)(f.map(l=>c.get(l)));this.update(g,!0)}update(f,c){const g=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),l=[],n=this._configurationModel.isEmpty();for(const o of f){const t=g[o]?.policy?.name;if(t){const i=this.policyService.getPolicyValue(t);(n?i!==void 0:!(0,L.equals)(this._configurationModel.getValue(o),i))&&l.push([o,i])}else this._configurationModel.getValue(o)!==void 0&&l.push([o,void 0])}if(l.length){const o=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const t of o.keys)this._configurationModel.setValue(t,o.getValue(t));for(const[t,i]of l)i===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,i);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=pe([Y(1,C.IPolicyService),Y(2,I.ILogService)],w),e.PolicyConfiguration=w}),define(ne[201],re([0,1,6,3,2,19,17,72,200,60]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(p,v,h,y){super(),this.settingsResource=p,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration),this.policyConfiguration=h instanceof b.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,h,y)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:d})=>this.onDidDefaultConfigurationChange(w,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,v,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(p,v,new P.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(p,v){const h=typeof p=="string"?p:void 0,y=(0,T.isConfigurationOverrides)(p)?p:(0,T.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,y,void 0)}updateValue(p,v,h,y){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(h,v,2)}onDidDefaultConfigurationChange(p,v){const h=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(p,v);this.trigger(y,h,7)}onDidPolicyConfigurationChange(p){const v=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(h,v,7)}trigger(p,v,h){const y=new P.ConfigurationChangeEvent(p,{data:v},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(p){switch(p){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ne[202],re([0,1,9,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var k;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends D.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===k.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===k.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}constructor(P,E=k.Unknown,b){super(P),this._message=P,this._code=E,this._detail=b,this.isHandled=E===k.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(ne[102],re([0,1,23]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function r(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=r;function k(b){if(!b)return;const I=b.indexOf("+");return I<0?b:b.substr(0,I)}e.getRemoteName=k;function L(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=L;function T(b){const{host:I,port:C}=E(b);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:C}}e.parseAuthorityWithPort=T;function P(b,I){let{host:C,port:p}=E(b);return typeof p>"u"&&(p=I),{host:C,port:p}}e.parseAuthorityWithOptionalPort=P;function E(b){const I=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const C=b.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const p=b.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:b,port:void 0}}}),define(ne[44],re([0,1,27,5,102]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=L;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var E;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class b{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,w){if(typeof y>"u"||y===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof y=="string"||typeof w=="string"){const d=typeof y=="string"?y:y.value,f=typeof w=="string"?w:w.value;return D.equalsIgnoreCase(d,f)}return y._lower===w._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=b;function I(h){return C(h)}e.isApplicationScopedExtension=I;function C(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function p(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function v(h,y){if(y){const w=`onResolveRemoteAuthority:${(0,k.getRemoteName)(y)}`;return h.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,r.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],re([0,1,27,29,44,4,7,9,37]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,D.compareIgnoreCase)(o.id,t.id)===0}e.areSameExtensions=b;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{static create(t){const i=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new C(t.identifier,i,s)}static parse(t){const i=I.exec(t);return i&&i[1]&&i[2]?new C({id:i[1]},i[2],i[4]||void 0):null}constructor(t,i,s="undefined"){this.version=i,this.targetPlatform=s,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof C?b(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=C;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const t=p.exec(o);return t&&t[1]?[y(t[1]),t[2]]:[y(o),void 0]}e.getIdAndVersion=v;function h(o,t){return`${o}.${t}`}e.getExtensionId=h;function y(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function w(o,t){return y(h(o,t))}e.getGalleryExtensionId=w;function d(o,t){const i=[],s=u=>{for(const a of i)if(a.some(m=>b(t(m),t(u))))return a;return null};for(const u of o){const a=s(u);a?a.push(u):i.push([u])}return i}e.groupByExtension=d;function f(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function c(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(o,t){const i=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const u=s.shift();if(u&&i.every(a=>!b(a.identifier,{id:u}))){const a=o.filter(m=>b(m.identifier,{id:u}));a.length===1&&(i.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=g;async function l(o,t){if(!L.isLinux)return!1;let i;try{i=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(u))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function n(o,t){const i=await l(o,t),s=(0,r.getTargetPlatform)(i?"alpine":L.platform,E.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(ne[49],re([0,1,6,16,2,34,7,33,13,5,8]),function(Q,e,D,r,k,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let C=class extends k.Disposable{constructor(v,h){super(),this.fileService=v,this.logService=h,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,h){return this.withProfileExtensions(h,y=>(y=y.filter(w=>v.some(([d])=>!(0,P.areSameExtensions)(w.identifier,d.identifier))),y.push(...v.map(([w,d])=>({identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:d}))),y))}removeExtensionFromProfile(v,h){return this.withProfileExtensions(h,y=>y.filter(w=>!(0,P.areSameExtensions)(w.identifier,v)))}async withProfileExtensions(v,h){return this.getResourceAccessQueue(v).queue(async()=>{let y=[];try{const w=await this.fileService.readFile(v),d=JSON.parse(w.value.toString());for(const f of d){if(!f.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",f);continue}if(!f.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",f);continue}if(!f.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",f);continue}y.push({identifier:f.identifier,location:T.URI.revive(f.location),version:f.version,metadata:f.metadata})}}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}if(h){y=h(y);const w=y.map(d=>({identifier:d.identifier,version:d.version,location:d.location.toJSON(),metadata:d.metadata}));await this.fileService.writeFile(v,r.VSBuffer.fromString(JSON.stringify(w)))}return y})}getResourceAccessQueue(v){let h=this.resourcesAccessQueueMap.get(v);return h||(h=new D.Queue,this.resourcesAccessQueueMap.set(v,h)),h}};C=pe([Y(0,E.IFileService),Y(1,I.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(ne[203],re([0,1,22,33]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function k(L,T,P,E,b){try{const I=await L.getExtensionsControlManifest();if(!I.deprecated)return;const C=await L.getInstalled(1);for(const[p,v]of Object.entries(I.deprecated)){if(!v?.extension)continue;const{id:h,autoMigrate:y,preRelease:w}=v.extension;if(!y)continue;const d=C.find(c=>(0,r.areSameExtensions)(c.identifier,{id:p}));if(!d)continue;const f=(await T.getExtensions([{id:h,preRelease:w}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!f){b.info(`Skipping migrating '${d.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{b.info(`Migrating '${d.identifier.id}' extension to '${h}' extension...`);const c=!E.getDisabledExtensions().some(l=>(0,r.areSameExtensions)(l,d.identifier));await L.uninstall(d),b.info(`Uninstalled the unsupported extension '${d.identifier.id}'`);let g=C.find(l=>(0,r.areSameExtensions)(l.identifier,{id:h}));(!g||!g.isPreReleaseVersion&&c)&&(g=await L.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:d.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${g.identifier.id}'`),c||(await E.disableExtension(g.identifier),b.info(`Disabled the pre-release extension '${g.identifier.id}' because the unsupported extension '${d.identifier.id}' is disabled`)),y.storage&&(P.addToMigrationList((0,r.getExtensionId)(d.manifest.publisher,d.manifest.name),(0,r.getExtensionId)(g.manifest.publisher,g.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${d.identifier.id}' extension to '${h}' extension.`)}catch(c){b.error(c)}}}catch(I){b.error(I)}}e.migrateUnsupportedExtensions=k}),define(ne[204],re([0,1,6,9,2,4,19,55,7,30,28,14,29,33,13,8]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let w=class extends k.Disposable{constructor(f,c,g,l){super(),this.fileService=c,this.extensionGalleryService=g,this.logService=l,this.extensionsDownloadDir=E.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,c){await this.cleanUpPromise;const g=this.getName(f),l=(0,T.joinPath)(this.extensionsDownloadDir,g);if(!await this.fileService.exists(l)){const n=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(f,n,c);try{await this.rename(n,l,Date.now()+2*60*1e3)}catch(o){try{await this.fileService.del(n)}catch{}if(o.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,r.getErrorMessage)(o)}. Deleted the vsix from downloaded location`,n.path),o}}return l}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,c,g){try{await I.Promises.rename(f.fsPath,c.fsPath)}catch(l){if(L.isWindows&&l&&l.code==="EPERM"&&Date.now()<g)return this.logService.info(`Failed renaming ${f} to ${c} with 'EPERM' error. Trying again...`),this.rename(f,c,g);throw l}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const c=[],g=[];for(const o of f.children){const t=v.ExtensionKey.parse(o.name);t&&g.push([t,o])}const l=(0,v.groupByExtension)(g,([o])=>o),n=[];for(const o of l)o.sort((t,i)=>P.rcompare(t[0].version,i[0].version)),c.push(...o.slice(1).map(t=>t[1].resource)),n.push(o[0][1]);n.sort((o,t)=>o.mtime-t.mtime),c.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(o=>o.resource)),await D.Promises.settled(c.map(o=>(this.logService.trace("Deleting vsix from cache",o.path),this.fileService.del(o))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?v.ExtensionKey.create(f).toString().toLowerCase():(0,b.generateUuid)()}};w=pe([Y(0,C.INativeEnvironmentService),Y(1,h.IFileService),Y(2,p.IExtensionGalleryService),Y(3,y.ILogService)],w),e.ExtensionsDownloader=w}),define(ne[205],re([0,1,2,12,28,44]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(E,b){super(),this.environmentService=E,this.extensionsManifestCache=(0,r.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(b.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(E){E.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[206],re([0,1,97,18,6,2,23,12,28,14,29,33,8,71]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends v.LanguagePackBaseService{constructor(f,c,g,l){super(g),this.extensionManagementService=f,this.logService=l,this.cache=this._register(new y(c,l)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getInstalledLanguages(){const f=await this.cache.getLanguagePacks(),c=Object.keys(f).map(g=>{const l=f[g];return{...this.createQuickPickItem(g,l.label),extensionId:l.extensions[0].extensionIdentifier.id}});return c.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),c.sort((g,l)=>g.label.localeCompare(l.label)),c}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const c=await this.cache.getLanguagePacks();Object.keys(c).some(g=>c[g]&&c[g].extensions.some(l=>(0,C.areSameExtensions)(l.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(c);return!(0,r.equals)(Object.keys(f),Object.keys(g))}};h=pe([Y(0,I.IExtensionManagementService),Y(1,b.INativeEnvironmentService),Y(2,I.IExtensionGalleryService),Y(3,p.ILogService)],h),e.NativeLanguagePackService=h;let y=class extends L.Disposable{constructor(f,c){super(),this.logService=c,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(c=>{Object.keys(c).forEach(g=>delete c[g]),this.createLanguagePacksFromExtensions(c,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...c){for(const g of c)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,g);Object.keys(f).forEach(g=>this.updateHash(f[g]))}createLanguagePacksFromExtension(f,c){const g=c.identifier,l=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const n of l)if(c.location.scheme===T.Schemas.file&&w(n)){let o=f[n.languageId];o||(o={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},f[n.languageId]=o);const t=o.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,g))[0];t?t.version=c.manifest.version:o.extensions.push({extensionIdentifier:g,version:c.manifest.version});for(const i of n.translations)o.translations[i.id]=(0,P.join)(c.location.fsPath,i.path)}}updateHash(f){if(f){const c=(0,D.createHash)("md5");for(const g of f.extensions)c.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);f.hash=c.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(c=f(g),g)).then(g=>{for(const n of Object.keys(g))g[n]||delete g[n];this.languagePacks=g,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),E.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>c,g=>this.logService.error(g))})}};y=pe([Y(0,b.INativeEnvironmentService),Y(1,p.ILogService)],y);function w(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const f of d.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(ne[207],re([0,1,6,16,22,9,3,2,30,90,202,102]),function(Q,e,D,r,k,L,T,P,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var v;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function h(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function y(B){const G=new k.CancellationTokenSource;return setTimeout(()=>G.cancel(),B),G.token}function w(B,G){if(B.isCancellationRequested||G.isCancellationRequested)return k.CancellationToken.Cancelled;const O=new k.CancellationTokenSource;return B.onCancellationRequested(()=>O.cancel()),G.onCancellationRequested(()=>O.cancel()),O.token}class d{get didTimeout(){return this._state==="timedout"}constructor(G){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((O,M)=>{this._resolvePromise=O,this._rejectPromise=M}),G.isCancellationRequested?this._timeout():this._disposables.add(G.onCancellationRequested(()=>this._timeout()))}registerDisposable(G){this._state==="pending"?this._disposables.add(G):G.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(G))}reject(G){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(G))}}function f(B,G){const O=new d(G);return O.registerDisposable(B.onControlMessage(M=>{const x=JSON.parse(M.toString()),V=W(x);V?O.reject(V):O.resolve(x)})),O.promise}function c(B,G,O,M,x,V,ee,oe){const Z=new d(oe);return G.connect(O,M,x,V,ee,(ie,se)=>{Z.didTimeout?(ie&&B.error(ie),se?.dispose()):ie||!se?Z.reject(ie):Z.resolve(se)}),Z.promise}function g(B,G){const O=new d(G);return B.then(M=>{O.didTimeout||O.resolve(M)},M=>{O.didTimeout||O.reject(M)}),O.promise}async function l(B,G,O,M){const x=X(B,G);B.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let V;try{V=await c(B.logService,B.socketFactory,B.host,B.port,(0,C.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${h(G)}-${B.reconnectionToken}`,M)}catch(se){throw B.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),B.logService.error(se),se}B.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,oe;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),ee=B.reconnectionProtocol,oe=!1):(ee=new b.PersistentProtocol(V,null),oe=!0),B.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Z=await g(B.signService.createNewMessage((0,E.generateUuid)()),M),ie={type:"auth",auth:B.connectionToken||"00000000000000000000",data:Z.data};ee.sendControl(r.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await f(ee,w(M,y(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(B.logService.trace(`${x} 4/6. received SignRequest control message.`),!await g(B.signService.validate(Z,se.signedData),M)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const de=await g(B.signService.sign(se.data),M),ve={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:G};return O&&(ve.args=O),B.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(r.VSBuffer.fromString(JSON.stringify(ve))),{protocol:ee,ownsProtocol:oe}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(B.logService.error(`${x} the handshake timed out. Error:`),B.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${x} received error control message when negotiating connection. Error:`),B.logService.error(se)),oe&&H(ee),se}}async function n(B,G,O,M){const x=Date.now(),V=X(B,G),{protocol:ee,ownsProtocol:oe}=await l(B,G,O,M),Z=new d(M);return Z.registerDisposable(ee.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),ue=W(se);ue?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(ue),oe&&H(ee),Z.reject(ue)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ce(x)}!`),Z.resolve({protocol:ee,firstMessage:se}))})),Z.promise}async function o(B,G){const{protocol:O}=await n(B,1,void 0,G);return{protocol:O}}async function t(B,G,O){const{protocol:M,firstMessage:x}=await n(B,2,G,O),V=x&&x.debugPort;return{protocol:M,debugPort:V}}async function i(B,G,O){const M=Date.now(),x=X(B,3),{protocol:V}=await l(B,3,G,O);return B.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${ce(M)}!`),V}async function s(B,G,O){const{host:M,port:x,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:M,port:x,connectionToken:V,reconnectionToken:G,reconnectionProtocol:O,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function u(B,G,O){return m(B,async M=>{const{protocol:x}=await o(M,k.CancellationToken.None);return new J(B,G,O,M.reconnectionToken,x)})}e.connectRemoteAgentManagement=u;async function a(B,G){return m(B,async O=>{const{protocol:M,debugPort:x}=await t(O,G,k.CancellationToken.None);return new j(B,G,O.reconnectionToken,M,x)})}e.connectRemoteAgentExtensionHost=a;async function m(B,G){for(let M=1;;M++)try{const x=(0,E.generateUuid)(),V=await s(B,x,null);return await G(V)}catch(x){if(M<5)B.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(x);else throw B.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(x),q.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(x)),x}}async function S(B,G,O){const M=await s(B,(0,E.generateUuid)(),null);return await i(M,{host:G,port:O},k.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function _(B){return(0,D.createCancelablePromise)(G=>new Promise((O,M)=>{const x=setTimeout(O,B*1e3);G.onCancellationRequested(()=>{clearTimeout(x),O()})}))}var $;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})($=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(G,O){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=A;class U{constructor(G,O,M,x){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.durationSeconds=M,this.cancellableTimer=x,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class R{constructor(G,O,M){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=R;class N{constructor(G,O,M){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=4}}e.ConnectionGainEvent=N;class F{constructor(G,O,M,x){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.attempt=M,this.handled=x,this.type=3}}e.ReconnectionPermanentFailureEvent=F;class q extends P.Disposable{static triggerPermanentFailure(G,O,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=G,this._permanentFailureAttempt=O,this._permanentFailureHandled=M,this._instances.forEach(x=>x._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(G=>G._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(G=>G._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||q._permanentFailure}constructor(G,O,M,x,V){super(),this._connectionType=G,this._options=O,this.reconnectionToken=M,this.protocol=x,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(x.onSocketClose(ee=>{const oe=K(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(x.onSocketTimeout(ee=>{const oe=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),q._instances.push(this),this._register((0,P.toDisposable)(()=>{const ee=q._instances.indexOf(this);ee>=0&&q._instances.splice(ee,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(q._permanentFailureMillisSinceLastIncomingData,q._permanentFailureAttempt,q._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const G=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const x=M<O.length?O[M]:O[O.length-1];try{if(x>0){const ee=_(x);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this._options.logService.info(`${G} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${G} resolving connection...`);const V=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${G} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,y(p)),this._options.logService.info(`${G} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,L.isCancellationError)(V)){this._options.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,I.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(G,O,M){this._reconnectionFailureIsFatal?q.triggerPermanentFailure(G,O,M):this._gotoPermanentFailure(G,O,M)}_gotoPermanentFailure(G,O,M){this._onDidStateChange.fire(new F(this.reconnectionToken,G,O,M)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=q,q._permanentFailure=!1,q._permanentFailureMillisSinceLastIncomingData=0,q._permanentFailureAttempt=0,q._permanentFailureHandled=!1,q._instances=[];class J extends q{constructor(G,O,M,x,V){super(1,G,x,V,!0),this.client=this._register(new b.Client(V,{remoteAuthority:O,clientId:M},G.ipcLogger))}async _reconnect(G,O){await o(G,O)}}e.ManagementPersistentConnection=J;class j extends q{constructor(G,O,M,x,V){super(2,G,M,x,!1),this._startArguments=O,this.debugPort=V}async _reconnect(G,O){await t(G,this._startArguments,O)}}e.ExtensionHostPersistentConnection=j;function H(B){try{B.acceptDisconnect();const G=B.getSocket();B.dispose(),G.dispose()}catch(G){(0,L.onUnexpectedError)(G)}}function W(B){if(B&&B.type==="error"){const G=new Error(`Connection error: ${B.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function z(B,G){for(;B.length<G;)B+=" ";return B}function K(B,G,O){return`[remote-connection][${z(h(B),13)}][${G.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function X(B,G){return`${K(G,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function ce(B){return`${Date.now()-B} ms`}}),define(ne[208],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[209],re([0,1,82,139]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,L,T,P,E,b){const I=p=>b(p,void 0),C=D.createConnection({host:k,port:L},()=>{C.removeListener("error",I);const p=Buffer.alloc(16);for(let w=0;w<16;w++)p[w]=Math.round(Math.random()*256);const v=p.toString("base64"),h=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${L}${T}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`];C.write(h.join(`\r
`)+`\r
\r
`);const y=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",y),b(void 0,new r.NodeSocket(C,E)))};C.on("data",y)});C.setNoDelay(!0),C.once("error",I)}}}),define(ne[210],re([0,1,122,17,8]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,E){this.configurationService=P,this.logService=E}async request(P,E){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const b=await(0,D.request)(P,E);return this.logService.trace("RequestService#request (browser) - success",P.url),b}catch(b){throw this.logService.error("RequestService#request (browser) - error",P.url,b),b}}async resolveProxy(P){}};L=pe([Y(0,r.IConfigurationService),Y(1,k.ILogService)],L),e.RequestService=L}),define(ne[45],re([0,1,16,157,43,5,40]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=P;function E(y){return y.res.statusCode===204}async function b(y){return E(y)?null:(await(0,D.streamToBuffer)(y.stream)).toString()}e.asText=b;async function I(y){if(!P(y))throw new Error("Server returned "+y.res.statusCode);return b(y)}e.asTextOrError=I;async function C(y){if(!P(y))throw new Error("Server returned "+y.res.statusCode);if(E(y))return null;const d=(await(0,D.streamToBuffer)(y.stream)).toString();try{return JSON.parse(d)}catch(f){throw f.message+=`:
`+d,f}}e.asJson=C;function p(y){h(y)}e.updateProxyConfigurationsScope=p;let v;function h(y){const w=T.Registry.as(k.Extensions.Configuration),d=v;v={id:"http",order:15,title:(0,r.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,r.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,r.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,r.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,r.localize)(4,null),(0,r.localize)(5,null),(0,r.localize)(6,null),(0,r.localize)(7,null)],default:"override",description:(0,r.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,r.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[v],remove:d?[d]:[]})}h(2)}),define(ne[211],re([0,1,22,23,13,45]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(E,b){this.requestService=E,this.fileService=b}async download(E,b,I=D.CancellationToken.None){if(E.scheme===r.Schemas.file||E.scheme===r.Schemas.vscodeRemote){await this.fileService.copy(E,b);return}const C={type:"GET",url:E.toString(!0)},p=await this.requestService.request(C,I);if(p.res.statusCode===200)await this.fileService.writeFile(b,p.stream);else{const v=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${v}`)}}};T=pe([Y(0,L.IRequestService),Y(1,k.IFileService)],T),e.DownloadService=T}),define(ne[212],re([0,1,18,22,2,19,174,13,8,25,45]),function(Q,e,D,r,k,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=class extends k.Disposable{constructor(v,h,y,w){super(),this.fileService=v,this.productService=h,this.requestService=y,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,d])=>this.allConfigBasedTips.set(d.configPath,d))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const h=[];for(const[y,w]of this.allConfigBasedTips)if(!(w.configScheme&&w.configScheme!==v.scheme))try{const d=await this.fileService.readFile((0,L.joinPath)(v,y)),f=new Map;Object.entries(w.recommendations).forEach(([g,l])=>{if((0,D.isNonEmptyArray)(l.remotes))for(const n of l.remotes)f.set(n,{extensionId:g,extensionName:l.name,configName:w.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled});else h.push({extensionId:g,extensionName:l.name,configName:w.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})});const c=(0,T.getDomainsOfRemotes)(d.value.toString(),[...f.keys()]);for(const g of c){const l=f.get(g);l&&h.push(l)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const v=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},r.CancellationToken.None);if(v.res.statusCode!==200)return[];const h=await(0,I.asJson)(v);return h?h.workspaceRecommendations||[]:[]}catch(v){return this.logService.error(v),[]}}};C=pe([Y(0,P.IFileService),Y(1,b.IProductService),Y(2,I.IRequestService),Y(3,E.ILogService)],C),e.ExtensionTipsService=C}),define(ne[213],re([0,1,16,22]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(P){this.service=P}listen(P,E){throw new Error("Invalid listen")}call(P,E,b,I=r.CancellationToken.None){switch(E){case"request":return this.service.request(b[0],I).then(async({res:C,stream:p})=>{const v=await(0,D.streamToBuffer)(p);return[{statusCode:C.statusCode,headers:C.headers},v]});case"resolveProxy":return this.service.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class L{constructor(P){this.channel=P}async request(P,E){const[b,I]=await this.channel.call("request",[P],E);return{res:b,stream:(0,D.bufferToStream)(I)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=L}),define(ne[214],re([0,1,210,213]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(T,P,E){this.configurationService=P,this.logService=E,this.browserRequestService=new D.RequestService(P,E),this.mainRequestService=new r.RequestChannelClient(T.getChannel("request"))}request(T,P){return this.getRequestService().request(T,P)}async resolveProxy(T){return this.getRequestService().resolveProxy(T)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=k}),define(ne[103],re([0,1,65,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(L){return(0,D.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,r.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[215],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(r){r.Spawn="vscode:shared-process->shared-process-worker=spawn",r.Terminate="vscode:shared-process->shared-process-worker=terminate",r.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",r.Ready="vscode:shared-process-worker->shared-process=ready",r.Ack="vscode:shared-process-worker->shared-process=ack",r.Trace="vscode:shared-process-worker->shared-process=trace",r.Info="vscode:shared-process-worker->shared-process=info",r.Warn="vscode:shared-process-worker->shared-process=warn",r.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[216],re([0,1,91,6,22,3,2,23,30,8,103,215]),function(Q,e,D,r,k,L,T,P,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(y){this.logService=y,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(y){const w=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${w})`);const d=(0,I.hash)(y);this.processeDisposables.has(d)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${w})`),this.doDisposeWorker(y));const f=new k.CancellationTokenSource;let c,g,l;this.processeDisposables.set(d,i=>{f.dispose(!0),c?.terminate(y,k.CancellationToken.None),g?.close(),l?.close(),this.processeDisposables.delete(d);const s=this.processResolvers.get(d);s&&(this.processResolvers.delete(d),s({reason:i}))}),c=await this.getOrCreateWebWorker(y);const n=new Promise(i=>{this.processResolvers.set(d,i)});if(f.token.isCancellationRequested)return n;const{port1:o,port2:t}=new MessageChannel;return g=o,l=t,await c.spawn(y,l,f.token),f.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${w})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[g])),n}getOrCreateWebWorker(y){let w=this.workers.get(y.process.moduleId);if(!w){this.logService.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const d=new v(y.process.type,this.logService);w=d.init(),d.onDidProcessSelfTerminate(({configuration:f,reason:c})=>{this.doDisposeWorker(f,c)}),this.workers.set(y.process.moduleId,w)}return w}async disposeWorker(y){return this.doDisposeWorker(y)}doDisposeWorker(y,w){const d=this.processeDisposables.get((0,I.hash)(y));d&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),d(w))}};p=pe([Y(0,b.ILogService)],p),e.SharedProcessWorkerService=p;class v extends T.Disposable{constructor(y,w){super(),this.type=y,this.logService=w,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const y=new r.DeferredPromise,w=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return w.onerror=d=>{this.logService.error(`SharedProcess: worker error (${this.type})`,d.message)},w.onmessageerror=d=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,d)},w.onmessage=d=>{const{id:f,message:c,configuration:g,nonce:l}=d.data;switch(f){case C.SharedProcessWorkerMessages.Ready:y.complete(w);break;case C.SharedProcessWorkerMessages.Ack:if(l){const n=this.mapMessageNonceToPendingMessageResolve.get(l);n&&(this.mapMessageNonceToPendingMessageResolve.delete(l),n())}break;case C.SharedProcessWorkerMessages.SelfTerminated:g&&c&&this._onDidProcessSelfTerminate.fire({configuration:g,reason:JSON.parse(c)});break;case C.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,c);break;case C.SharedProcessWorkerMessages.Info:c&&this.logService.info(c);break;case C.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,c);break;case C.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,c);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,d)}},w.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async send(y,w,d){const f=await this.workerReady;if(!w.isCancellationRequested)return new Promise(c=>{const g=(0,E.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(g,c);const l={...y,nonce:g};d?f.postMessage(l,[d]):f.postMessage(l),w.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(g)&&c()})})}spawn(y,w,d){const f={id:C.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(f,d,w)}terminate(y,w){const d={id:C.SharedProcessWorkerMessages.Terminate,configuration:y};return this.send(d,w)}}}),define(ne[217],re([0,1,63,23,173]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}}pe([D.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[218],re([0,1,54,12,158,22,38,9,4,30,136,171,6]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let h;async function y(d,f,c){return f["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(c)&&!f["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(c)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=p.Promises.withAsyncBody(async(g,l)=>{const n=new L.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),l(new Error((0,k.localize)(0,null)))},v);try{g(await w(d,n.token))}catch(t){!(0,P.isCancellationError)(t)&&!n.token.isCancellationRequested?l(new Error((0,k.localize)(1,null,(0,T.toErrorMessage)(t)))):g({})}finally{clearTimeout(o),n.dispose()}})),h)}e.getResolvedShellEnv=y;async function w(d,f){const c=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",c);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",g);const l=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(l+"(.*)"+l),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",o);const t=await(0,I.getSystemShell)(E.OS,o);return d.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if(f.isCancellationRequested)return s((0,P.canceled)());const u=(0,r.basename)(t);let a,m;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(a=`& '${process.execPath}' ${S} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,m=["-Login","-Command"]):(a=`'${process.execPath}' ${S} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,u==="tcsh"?m=["-ic"]:m=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),a);const _=(0,D.spawn)(t,[...m,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(_.kill(),s((0,P.canceled)()))),_.on("error",U=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(U)),s(U)});const $=[];_.stdout.on("data",U=>$.push(U));const A=[];_.stderr.on("data",U=>A.push(U)),_.on("close",(U,R)=>{const N=Buffer.concat($).toString("utf8");d.trace("getUnixShellEnvironment#raw",N);const F=Buffer.concat(A).toString("utf8");if(F.trim()&&d.trace("getUnixShellEnvironment#stderr",F),U||R)return s(new Error((0,k.localize)(2,null,U,R)));const q=n.exec(N),J=q?q[1]:"{}";try{const j=JSON.parse(J);c?j.ELECTRON_RUN_AS_NODE=c:delete j.ELECTRON_RUN_AS_NODE,g?j.ELECTRON_NO_ATTACH_CONSOLE=g:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",j),i(j)}catch(j){d.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(j)),s(j)}})})}}),define(ne[104],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[219],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((k,L)=>Q(["vsda"],k,L))}async createNewMessage(k){try{const L=await this.vsda(),T=new L.validator;if(T){const P=String(D._nextId++);return this.validators.set(P,T),{id:P,data:T.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,L){if(!k.id)return!0;const T=this.validators.get(k.id);if(!T)return!1;this.validators.delete(k.id);try{return T.validate(L)==="ok"}catch{return!1}}async sign(k){try{const L=await this.vsda(),T=new L.signer;if(T)return T.sign(k)}catch{}return k}}e.SignService=D,D._nextId=1}),define(ne[73],re([0,1,3,2]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class k extends r.Disposable{constructor(C,p,v){super(),this.channel=C,this.profile=p,this.workspace=v}async getItems(){const C={profile:this.profile,workspace:this.workspace},p=await this.channel.call("getItems",C);return new Map(p)}updateItems(C){const p={profile:this.profile,workspace:this.workspace};return C.insert&&(p.insert=Array.from(C.insert.entries())),C.delete&&(p.delete=Array.from(C.delete.values())),this.channel.call("updateItems",p)}}class L extends k{constructor(C,p){super(C,p,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(C=>this.onDidChangeStorage(C)))}onDidChangeStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}}class T extends L{constructor(C){super(C,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class P extends L{constructor(C,p){super(C,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class E extends k{constructor(C,p){super(C,void 0,p),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=E;class b{constructor(C){this.channel=C}isUsed(C){const p={payload:C,profile:void 0,workspace:void 0};return this.channel.call("isUsed",p)}}e.StorageClient=b}),define(ne[105],re([0,1,4,37,7,30]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,I,C,p,v,h,y,w,d,f){const c=Object.create(null);c["common.machineId"]=y,c.sessionID=(0,L.generateUuid)()+Date.now(),c.commitHash=v,c.version=h,c["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.PlatformToString)(D.platform),c["common.nodePlatform"]=r.platform,c["common.nodeArch"]=p,c["common.product"]=f||"desktop",w&&(c["common.msftInternal"]=w);let g=0;const l=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),D.isLinuxSnap&&(c["common.snap"]="true");const n=T(C);n&&(c["common.platformDetail"]=n);try{const o=await b.readFile(k.URI.file(d));c["common.source"]=o.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=P;function E(b){const I=r.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return b.some(p=>C===p)}e.verifyMicrosoftInternalDomain=E}),define(ne[24],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var r;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(r=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[220],re([0,1,36,52,6,35,23,12,4,7,133,28,135,94,13,25,24]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const d=new Map;async function f(o,t){const i=`${o}::${t.join(":")}`,s=d.get(i);if(s)return s;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,m=new Map,S=2e4;function _(A,U,R,N){const F=U.substring(A.length+1);return k.Promises.withAsyncBody(async q=>{let J;try{J=await C.Promises.readdir(U,{withFileTypes:!0})}catch{q();return}if(N.count>=S){N.count+=J.length,N.maxReached=!0,q();return}let j=J.length;if(j===0){q();return}let H=J;N.count+J.length>S&&(N.maxReached=!0,j=S-N.count,H=J.slice(0,j)),N.count+=J.length;for(const W of H)if(W.isDirectory()){if(R.includes(W.name)||await _(A,(0,P.join)(U,W.name),R,N),--j===0){q();return}}else{const z=W.name.lastIndexOf(".");if(z>=0){const K=W.name.substring(z+1);K&&a.set(K,(a.get(K)??0)+1)}for(const K of u)K.relativePathPattern?.test(F)!==!1&&K.filePattern.test(W.name)&&m.set(K.tag,(m.get(K.tag)??0)+1);if(--j===0){q();return}}})}const $=k.Promises.withAsyncBody(async A=>{const U={count:0,maxReached:!1};await _(o,o,t,U);const R=await l(o);A({configFiles:c(m),fileTypes:c(a),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:R})});return d.set(i,$),$}e.collectWorkspaceStats=f;function c(o){return[...r.Iterable.map(o.entries(),([t,i])=>({name:t,count:i}))].sort((t,i)=>i.count-t.count)}function g(){const o={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(o.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),o}e.getMachineInfo=g;async function l(o){try{const t=new Map,i=(0,P.join)(o,".vscode","launch.json"),s=await C.Promises.readFile(i),u=[],a=(0,L.parse)(s.toString(),u);if(u.length)return console.log(`Unable to parse ${i}`),[];if((0,L.getNodeType)(a)==="object"&&a.configurations)for(const m of a.configurations){const S=m.type;S&&(t.has(S)?t.set(S,t.get(S)+1):t.set(S,1))}return c(t)}catch{return[]}}e.collectLaunchConfigs=l;let n=class{constructor(t,i){this.telemetryService=t,this.productService=i}formatMachineInfo(t){const i=[];return i.push(`OS Version:       ${t.os}`),i.push(`CPUs:             ${t.cpus}`),i.push(`Memory (System):  ${t.memory}`),i.push(`VM:               ${t.vmHint}`),i.join(`
`)}formatEnvironment(t){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const s=D.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||i.push(`Load (avg):       ${D.loadavg().map(u=>Math.round(u)).join(", ")}`),i.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${t.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(t,i){return Promise.all([(0,p.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async s=>{let[u,a]=s,m=this.formatProcessList(t,u);return i.forEach(S=>{if((0,v.isRemoteDiagnosticError)(S))m+=`
${S.errorMessage}`,a+=`
${S.errorMessage}`;else if(m+=`

Remote: ${S.hostName}`,S.processes&&(m+=`
${this.formatProcessList(t,S.processes)}`),S.workspaceMetadata){a+=`
|  Remote: ${S.hostName}`;for(const _ of Object.keys(S.workspaceMetadata)){const $=S.workspaceMetadata[_];let A=`${$.fileCount} files`;$.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${_}): ${A}`,a+=this.formatWorkspaceStats($)}}}),{processInfo:m,workspaceInfo:a}})}async getSystemInfo(t,i){const{memory:s,vmHint:u,os:a,cpus:m}=g(),S={os:a,memory:s,cpus:m,vmHint:u,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:i};return E.isWindows||(S.load=`${D.loadavg().map(_=>Math.round(_)).join(", ")}`),E.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(t,i){const s=[];return(0,p.listProcesses)(t.mainPID).then(async u=>(s.push(""),s.push(this.formatEnvironment(t)),s.push(""),s.push(this.formatProcessList(t,u)),t.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(t))),i.forEach(a=>{if((0,v.isRemoteDiagnosticError)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.formatMachineInfo(a.machineInfo)),a.processes&&s.push(this.formatProcessList(t,a.processes)),a.workspaceMetadata)for(const m of Object.keys(a.workspaceMetadata)){const S=a.workspaceMetadata[m];let _=`${S.fileCount} files`;S.maxFilesReached&&(_=`more than ${_}`),s.push(`Folder (${m}): ${_}`),s.push(this.formatWorkspaceStats(S))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(t){const i=[];let u=0;const a=($,A)=>{const U=` ${$}(${A})`;u+U.length>60?(i.push(m),m="|                 ",u=m.length):u+=U.length,m+=U};let m="|      File types:";const S=10,_=t.fileTypes.length>S?S:t.fileTypes.length;for(let $=0;$<_;$++){const A=t.fileTypes[$];a(A.name,A.count)}if(i.push(m),t.configFiles.length>=0&&(m="|      Conf files:",u=0,t.configFiles.forEach($=>{a($.name,$.count)}),i.push(m)),t.launchConfigFiles.length>0){let $="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{$+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),i.push($)}return i.join(`
`)}expandGPUFeatures(t){const i=Math.max(...Object.keys(t).map(s=>s.length));return Object.keys(t).map(s=>`${s}:  ${" ".repeat(i-s.length)}  ${t[s]}`).join(`
                  `)}formatWorkspaceMetadata(t){const i=[],s=[];return t.windows.forEach(u=>{u.folderURIs.length===0||!!u.remoteAuthority||(i.push(`|  Window (${u.title})`),u.folderURIs.forEach(a=>{const m=b.URI.revive(a);if(m.scheme===T.Schemas.file){const S=m.fsPath;s.push(f(S,["node_modules",".git"]).then(_=>{let $=`${_.fileCount} files`;_.maxFilesReached&&($=`more than ${$}`),i.push(`|    Folder (${(0,P.basename)(S)}): ${$}`),i.push(this.formatWorkspaceStats(_))}).catch(_=>{i.push(`|      Error: Unable to collect workspace stats for folder ${S} (${_.toString()})`)}))}else i.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(u=>i.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(t,i){const s=new Map;t.windows.forEach(a=>s.set(a.pid,a.title));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(t.mainPID,s,u,i,0),u.join(`
`)}formatProcessItem(t,i,s,u,a){const m=a===0;let S;m?S=u.pid===t?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(a)} ${u.name}`,u.name==="window"&&(S=`${S} (${i.get(u.pid)})`));const _=process.platform==="win32"?u.mem:D.totalmem()*(u.mem/100);s.push(`${u.load.toFixed(0).padStart(5," ")}	${(_/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(u.children)&&u.children.forEach($=>this.formatProcessItem(t,i,s,$,a+1))}async getWorkspaceFileExtensions(t){const i=new Set;for(const{uri:s}of t.folders){const u=b.URI.revive(s);if(u.scheme!==T.Schemas.file)continue;const a=u.fsPath;try{(await f(a,["node_modules",".git"])).fileTypes.forEach(S=>i.add(S.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(t){for(const{uri:i}of t.folders){const s=b.URI.revive(i);if(s.scheme!==T.Schemas.file)continue;const u=s.fsPath;try{const a=await f(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),a.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})}),a.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})}),a.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};n=pe([Y(0,w.ITelemetryService),Y(1,y.IProductService)],n),e.DiagnosticsService=n}),define(ne[106],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appenders=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,{eventName:P,data:E}){return this.appenders.forEach(b=>b.log(P,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class r{constructor(L){this.channel=L}log(L,T){return this.channel.call("log",{eventName:L,data:T}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=r}),define(ne[50],re([0,1,32,84,15,17,105,24]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,r.staticObservableValue)(0)}publicLog(n,o){return Promise.resolve(void 0)}publicLog2(n,o){return this.publicLog(n,o)}publicLogError(n,o){return Promise.resolve(void 0)}publicLogError2(n,o){return this.publicLogError(n,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class b{async publicLog(n,o,t){}async publicLogError(n,o,t){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(l,n){return n.onDidChangeConfiguration(o=>{o.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(o.source),configurationKeys:d(o.sourceConfig)})})}e.configurationTelemetry=I;function C(l,n){return!(n.disableTelemetry||!l.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=C;function p(l){const n=l.getValue(P.TELEMETRY_SETTING_ID),o=l.getValue("telemetry.enableCrashReporter");if(l.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function v(l){const n={},o={},t={};w(l,t);for(let i in t){i=i.length>150?i.substr(i.length-149):i;const s=t[i];typeof s=="number"?o[i]=s:typeof s=="boolean"?o[i]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${s.length}`),n[i]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(n[i]=s)}return{properties:n,measurements:o}}e.validateTelemetryData=v;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function y(l){if(!l)return"none";for(const n of h)if(l.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=y;function w(l,n,o=0,t){if(!!l)for(const i of Object.getOwnPropertyNames(l)){const s=l[i],u=t?t+i:i;Array.isArray(s)?n[u]=(0,D.safeStringify)(s):s instanceof Date?n[u]=s.toISOString():(0,k.isObject)(s)?o<2?w(s,n,o+1,u+"."):n[u]=(0,D.safeStringify)(s):n[u]=s}}function d(l){if(!l)return[];const n=[];return f(n,"",l),n}function f(l,n,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(t=>f(l,n?`${n}.${t}`:t,o[t])):l.push(n)}function c(l,n){const o=l.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(o)||t}e.isInternalTelemetry=c;function g(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=g}),define(ne[221],re([0,1,48,50]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(L,T,P,E,b,I,C){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${T.nameShort})`};if((0,r.supportsTelemetry)(T,P)&&(0,r.getTelemetryLevel)(E)===3){const v=await(0,D.getServiceMachineId)(P,b,I),{sessionId:h}=await C.getTelemetryInfo();p["X-Market-User-Id"]=v,p["VSCode-SessionId"]=h}return p}e.resolveMarketplaceHeaders=k}),define(ne[222],re([0,1,9,32,50]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(E,b,I){const C=await new Promise((w,d)=>{Q(["@microsoft/1ds-core-js"],w,d)}),p=await new Promise((w,d)=>{Q(["@microsoft/1ds-post-js"],w,d)}),v=new C.AppInsightsCore,h=new p.PostChannel,y={instrumentationKey:E,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(I){y.extensionConfig={};const w={alwaysUseXhrOverride:!0,httpXHROverride:I};y.extensionConfig[h.identifier]=w}return v.initialize(y,[]),v.addTelemetryInitializer(w=>{b&&(w.ext=w.ext??{},w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),v}class P{constructor(b,I,C,p,v){this._isInternalTelemetry=b,this._eventPrefix=I,this._defaultData=C,this._xhrOverride=v,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(b){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{b(I)},I=>{(0,D.onUnexpectedError)(I),console.error(I)})}}log(b,I){if(!this._aiCoreOrKey)return;I=(0,r.mixin)(I,this._defaultData),I=(0,k.validateTelemetryData)(I);const C=this._eventPrefix+"/"+b;try{this._withAIClient(p=>{p.pluginVersionString=I?.properties.version??"Unknown",p.track({name:C,baseData:{name:C,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(ne[107],re([0,1,2,14,8,50]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(E,b,I=""){super(),this.prefix=I;const C=E.getLogger(b.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(E.createLogger(b.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,b){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,L.validateTelemetryData)(b))}};T=pe([Y(0,k.ILoggerService),Y(1,r.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[108],re([0,1,2,32,84,4,27,159,17,43,100,25,40,24,50]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(f,c,g){this._configurationService=c,this._productService=g,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(f,c){this._experimentProperties[f]=c}_updateTelemetryLevel(){let f=(0,h.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const g=c.usage?3:c.error?2:0;f=Math.min(f,g)}this.telemetryLevel.value=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const f=await this._commonProperties,c=f.sessionID,g=f["common.machineId"],l=f["common.firstSessionDate"],n=f["common.msftInternal"];return{sessionId:c,machineId:g,firstSessionDate:l,msftInternal:n}}dispose(){this._disposables.dispose()}_log(f,c,g,l){return this.telemetryLevel.value<c?Promise.resolve(void 0):this._commonProperties.then(n=>{g=(0,r.mixin)(g,n),g=(0,r.mixin)(g,this._experimentProperties),g=(0,r.cloneAndChange)(g,o=>{if(typeof o=="string")return this._cleanupInfo(o,l)}),this._appenders.forEach(o=>o.log(f,g))},n=>{console.error(n)})}publicLog(f,c,g){return this._log(f,3,c,g)}publicLog2(f,c,g){return this.publicLog(f,c,g)}publicLogError(f,c){return this._sendErrorTelemetry?this._log(f,2,c,!0):Promise.resolve(void 0)}publicLogError2(f,c){return this.publicLogError(f,c)}_anonymizeFilePaths(f){let c=f;const g=[];for(const t of this._cleanupPatterns)for(;;){const i=t.exec(f);if(!i)break;g.push([i.index,t.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(c="";;){const t=n.exec(f);if(!t)break;!l.test(t[0])&&g.every(([i,s])=>t.index<i||t.index>=s)&&(c+=f.substring(o,t.index)+"<REDACTED: user-file-path>",o=n.lastIndex)}return o<f.length&&(c+=f.substr(o)),c}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const c=f.toLowerCase(),g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of g)if(l.regex.test(c))return`<REDACTED: ${l.label}>`;return f}_cleanupInfo(f,c){let g=f;c&&(g=this._anonymizeFilePaths(g));for(const l of this._cleanupPatterns)g=g.replace(l,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=pe([Y(1,E.IConfigurationService),Y(2,C.IProductService)],y),e.TelemetryService=y;function w(){const d=(0,P.localize)(0,null,I.default.nameLong),f=I.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=L.isWeb?"":(0,P.localize)(3,null),g=(0,P.localize)(4,null),l=(0,P.localize)(5,null),n=(0,P.localize)(6,null),o=(0,P.localize)(7,null),t=`
|       | ${g} | ${l} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,P.localize)(8,null);return`
${d} ${f} ${c}

&nbsp;

${o}
${t}

&nbsp;

${i}
`}p.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,P.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,P.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[223],re([0,1,279,222]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends r.AbstractOneDataSystemAppender{constructor(T,P,E,b){const I={sendPOST:(C,p)=>{const v={method:"POST",headers:{...C.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(C.data)}};try{const h=D.request(C.urlString,v,y=>{y.on("data",function(w){p(y.statusCode??200,y.headers,w.toString())}),y.on("error",function(w){p(0,{})})});h.write(C.data),h.end()}catch{p(0,{})}}};super(T,P,E,b,I)}}e.OneDataSystemAppender=k}),define(ne[224],re([0,1,23,67,17,14,8,25,24,106,107,108]),function(Q,e,D,r,k,L,T,P,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(h,y,w,d,f){this.configurationService=h,this.telemetryService=y,this.loggerService=w,this.environmentService=d,this.productService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:y,sessionId:w}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=y,d["common.vscodesessionid"]=w;const f=[h.id,JSON.stringify(d),h.aiKey],g=new r.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new b.TelemetryAppenderClient(g),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `)];this.customTelemetryServices.set(h.id,new C.TelemetryService({appenders:l,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,y,w){await(await this.getCustomTelemetryService(h)).publicLog(y,w)}async publicLogError(h,y,w){await(await this.getCustomTelemetryService(h)).publicLogError(y,w)}};p=pe([Y(0,k.IConfigurationService),Y(1,E.ITelemetryService),Y(2,T.ILoggerService),Y(3,L.IEnvironmentService),Y(4,P.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(ne[225],re([0,1,6,22,3,2,8]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(b,I){super(),this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((I,C)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,I),this._onCreateRequest.fire({requestId:p,...b});const v=new r.CancellationTokenSource;(0,D.timeout)(this._timeout,v.token).then(()=>C(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,L.toDisposable)(()=>v.cancel())])})}acceptReply(b,I){const C=this._pendingRequests.get(b);C?(this._pendingRequests.delete(b),(0,L.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),C(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=pe([Y(1,T.ILogService)],P),e.RequestStore=P}),define(ne[109],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var r;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(r=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(c){c.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var P;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var I;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(c){c.TerminalView="view",c.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}));var d;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(d=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var f;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(f=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[226],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[227],re([0,1,36,23,32,12,4,37,27,15,28]),function(Q,e,D,r,k,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let l=0;return g&&g.length===4&&(l=parseInt(g[3])),l}e.getWindowsBuildNumber=C;async function p(g,l,n,o=P.env,t=I.Promises.exists){if(L.isAbsolute(g))return await t(g)?g:void 0;if(l===void 0&&(l=P.cwd()),L.dirname(g)!=="."){const a=L.join(l,g);return await t(a)?a:void 0}const s=(0,k.getCaseInsensitive)(o,"PATH");if(n===void 0&&(0,b.isString)(s)&&(n=s.split(L.delimiter)),n===void 0||n.length===0){const a=L.join(l,g);return await t(a)?a:void 0}for(const a of n){let m;if(L.isAbsolute(a)?m=L.join(a,g):m=L.join(l,a,g),await t(m))return m;if(T.isWindows){let S=m+".com";if(await t(S)||(S=m+".exe",await t(S)))return S}}const u=L.join(l,g);return await t(u)?u:void 0}e.findExecutable=p;function v(g,l,n,o,t){if(!l.shellIntegration.enabled||!g.executable||g.isFeatureTerminal||g.hideFromUser||g.ignoreShellIntegration||T.isWindows&&!l.windowsEnableConpty)return;const i=g.args,s=P.platform==="win32"?L.basename(g.executable).toLowerCase():L.basename(g.executable),u=L.dirname(r.FileAccess.asFileUri("",Q).fsPath);let a;const m={VSCODE_INJECTION:"1"};if(T.isWindows){if(s==="pwsh.exe")return!i||f(i)?a=e.shellIntegrationArgs.get(h.WindowsPwsh):d(i)&&(a=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),a?(a=[...a],a[a.length-1]=(0,E.format)(a[a.length-1],u,""),{newArgs:a,envMixin:m}):void 0;o.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args);return}switch(s){case"bash":return!i||i.length===0?a=e.shellIntegrationArgs.get(h.Bash):c(i)&&(m.VSCODE_SHELL_LOGIN="1",a=e.shellIntegrationArgs.get(h.Bash)),a?(a=[...a],a[a.length-1]=(0,E.format)(a[a.length-1],u),{newArgs:a,envMixin:m}):void 0;case"pwsh":return!i||f(i)?a=e.shellIntegrationArgs.get(h.Pwsh):d(i)&&(a=e.shellIntegrationArgs.get(h.PwshLogin)),a?(a=[...a],a[a.length-1]=(0,E.format)(a[a.length-1],u,""),{newArgs:a,envMixin:m}):void 0;case"zsh":{if(!i||i.length===0?a=e.shellIntegrationArgs.get(h.Zsh):c(i)?a=e.shellIntegrationArgs.get(h.ZshLogin):(i===e.shellIntegrationArgs.get(h.Zsh)||i===e.shellIntegrationArgs.get(h.ZshLogin))&&(a=i),!a)return;a=[...a],a[a.length-1]=(0,E.format)(a[a.length-1],u);const S=L.join(D.tmpdir(),`${D.userInfo().username}-${t.applicationName}-zsh`);m.ZDOTDIR=S;const _=n?.ZDOTDIR??D.homedir()??"~";m.USER_ZDOTDIR=_;const $=[];return $.push({source:L.join(u,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(S,".zshrc")}),$.push({source:L.join(u,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(S,".zprofile")}),$.push({source:L.join(u,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(S,".zshenv")}),$.push({source:L.join(u,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(S,".zlogin")}),{newArgs:a,envMixin:m,filesToCopy:$}}}o.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args)}e.getShellIntegrationInjection=v;var h;(function(g){g.WindowsPwsh="windows-pwsh",g.WindowsPwshLogin="windows-pwsh-login",g.Pwsh="pwsh",g.PwshLogin="pwsh-login",g.Zsh="zsh",g.ZshLogin="zsh-login",g.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],w=["-nol","-nologo"];function d(g){return typeof g=="string"?y.includes(g.toLowerCase()):g.length===1&&y.includes(g[0].toLowerCase())||g.length===2&&(y.includes(g[0].toLowerCase())||y.includes(g[1].toLowerCase()))&&(w.includes(g[0].toLowerCase())||w.includes(g[1].toLowerCase()))}function f(g){return typeof g=="string"?w.includes(g.toLowerCase()):g.length===0||g?.length===1&&w.includes(g[0].toLowerCase())}function c(g){return g==="string"&&y.includes(g.toLowerCase())||typeof g!="string"&&g.length===1&&y.includes(g[0].toLowerCase())}}),define(ne[228],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function r(L){return L===D.HIGH_CONTRAST_DARK||L===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=r;function k(L){return L===D.DARK||L===D.HIGH_CONTRAST_DARK}e.isDark=k}),define(ne[110],re([0,1,51,3,2,5,40,228]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(w){function d(f){return f&&typeof f=="object"&&typeof f.id=="string"}w.isThemeColor=d})(E=e.ThemeColor||(e.ThemeColor={}));function b(w){return{id:w}}e.themeColorFromId=b;var I;(function(w){function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||E.isThemeColor(i.color))}w.isThemeIcon=d;const f=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function c(i){const s=f.exec(i);if(!s)return;const[,u]=s;return{id:u}}w.fromString=c;function g(i){return{id:i}}w.fromId=g;function l(i,s){let u=i.id;const a=u.lastIndexOf("~");return a!==-1&&(u=u.substring(0,a)),s&&(u=`${u}~${s}`),{id:u}}w.modify=l;function n(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}w.getModifier=n;function o(i,s){return i.id===s.id&&i.color?.id===s.color?.id}w.isEqual=o;function t(i,s){return{id:i.id,color:s?b(s):void 0}}w.asThemeIcon=t,w.asClassNameArray=D.CSSIcon.asClassNameArray,w.asClassName=D.CSSIcon.asClassName,w.asCSSSelector=D.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(w){switch(w){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new r.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,k.toDisposable)(()=>{const f=this.themingParticipants.indexOf(d);this.themingParticipants.splice(f,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new p;T.Registry.add(e.Extensions.ThemingContribution,v);function h(w){return v.onColorThemeChange(w)}e.registerThemingParticipant=h;class y extends k.Disposable{constructor(d){super(),this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(f=>this.onThemeChange(f)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,f){let c=this.theme.getColor(d);return c&&f&&(c=f(c,this.theme)),c?c.toString():null}}e.Themable=y}),define(ne[229],re([0,1,51,7,161,110]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(p,v){const h=[{name:null,description:(0,k.localize)(0,null)}];return h.push(...p.map(y=>({name:y.profileName,description:P(y)}))),v&&h.push(...v.map(y=>({name:y.title,description:E(y)}))),{values:h.map(y=>y.name),markdownDescriptions:h.map(y=>y.description)}}e.createProfileSchemaEnums=T;function P(p){let v=`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?v+=`
- args: "${p.args}"`:v+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(v+=`
- overrideName: ${p.overrideName}`),p.color&&(v+=`
- color: ${p.color}`),p.env&&(v+=`
- env: ${JSON.stringify(p.env)}`),v}function E(p){return`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function b(p,v){if(!p&&!v)return!0;if(typeof p=="string"&&typeof v=="string")return p===v;if(Array.isArray(p)&&Array.isArray(v)){if(p.length!==v.length)return!1;for(let h=0;h<p.length;h++)if(p[h]!==v[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function I(p,v){if(!p&&!v)return!0;if(!p||!v)return!1;if(L.ThemeIcon.isThemeIcon(p)&&L.ThemeIcon.isThemeIcon(v))return p.id===v.id&&p.color===v.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof v=="object"&&"light"in v&&"dark"in v){const h=p,y=v;if((r.URI.isUri(h.light)||C(h.light))&&(r.URI.isUri(h.dark)||C(h.dark))&&(r.URI.isUri(y.light)||C(y.light))&&(r.URI.isUri(y.dark)||C(y.dark)))return h.light.path===y.light.path&&h.dark.path===y.dark.path}if(r.URI.isUri(p)&&r.URI.isUri(v)||C(p)||C(v)){const h=p,y=v;return h.path===y.path&&h.scheme===y.scheme}return!1}e.terminalIconsEqual=I;function C(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=C}),define(ne[230],re([0,1,51,160,43,40,229]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),g=>g.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),g=>`$(${g.id})`)};const P={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...P}},I=(0,r.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,r.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,r.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,r.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,r.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,r.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,r.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,r.localize)(26,null)}},{type:"string",markdownDescription:(0,r.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(30,null),type:"string"},id:{description:(0,r.localize)(31,null),type:"string"},title:{description:(0,r.localize)(32,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(34,null),type:"string"},id:{description:(0,r.localize)(35,null),type:"string"},title:{description:(0,r.localize)(36,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(38,null),type:"string"},id:{description:(0,r.localize)(39,null),type:"string"},title:{description:(0,r.localize)(40,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){L.Registry.as(k.Extensions.Configuration).registerConfiguration(w),c()}e.registerTerminalPlatformConfiguration=d;let f;function c(g,l){const n=L.Registry.as(k.Extensions.Configuration);let o;g&&(o=(0,T.createProfileSchemaEnums)(g?.profiles,l));const t=f;f={id:"terminal",order:100,title:(0,r.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:g?.os===3?o?.values:void 0,markdownEnumDescriptions:g?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:g?.os===2?o?.values:void 0,markdownEnumDescriptions:g?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:g?.os===1?o?.values:void 0,markdownEnumDescriptions:g?.os===1?o?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[f],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(ne[231],re([0,1,54,51,12,4,28,88,227,110]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,C=!0;function p(o,t,i,s,u=process.env,a,m,S,_){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},L.isWindows?v(i,a,u,m,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),_,S):g(a,m,i,o&&typeof o=="object"?{...o}:s.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),_,S,u)}e.detectAvailableProfiles=p;async function v(o,t,i,s,u,a,m,S,_){const $=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),A=`${process.env.windir}\\${$?"Sysnative":"System32"}`;let U=!1;(0,E.getWindowsBuildNumber)()>=16299&&(U=!0),await w(S);const R=new Map;o&&(R.set("PowerShell",{source:"PowerShell",icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),R.set("Windows PowerShell",{path:`${A}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),R.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),R.set("Command Prompt",{path:`${A}\\cmd.exe`,icon:r.Codicon.terminalCmd,isAutoDetected:!0})),l(a,R);const N=await h(R.entries(),m,t,i,s,_);if(o||u)try{const F=await f(`${A}\\${U?"wsl":"bash"}.exe`,m);for(const q of F)(!a||!(q.profileName in a))&&N.push(q)}catch{C&&(s?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return N}async function h(o,t,i,s=process.env,u,a){const m=[];for(const[S,_]of o){if(_===null)continue;let $,A,U;if("source"in _){const F=I?.get(_.source);if(!F)continue;$=F.paths,A=_.args||F.args,_.icon?U=y(_.icon):F.icon&&(U=F.icon)}else $=Array.isArray(_.path)?_.path:[_.path],A=L.isWindows||Array.isArray(_.args)?_.args:void 0,U=y(_.icon);const R=await a?.($)||$.slice(),N=await n(S,t,R,i,s,A,_.env,_.overrideName,_.isAutoDetected,u);N?(N.isAutoDetected=_.isAutoDetected,N.icon=U,N.color=_.color,m.push(N)):u?.debug("Terminal profile not validated",S,$)}return u?.debug("Validated terminal profiles",m),m}function y(o){return typeof o=="string"?{id:o}:o}async function w(o){I&&!o||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:o||await d(),icon:b.ThemeIcon.asThemeIcon(r.Codicon.terminalPowershell)}))}async function d(){const o=[];for await(const t of(0,P.enumeratePowerShellInstallations)())o.push(t.exePath);return o}async function f(o,t){const i=[],s=await new Promise((m,S)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(_,$)=>{if(_)return S("Problem occurred when getting wsl distros");m($)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),a=s.split(u).filter(m=>m.trim().length>0&&m!=="");for(const m of a){if(m===""||m.startsWith("docker-desktop"))continue;const S=`${m} (WSL)`,_={profileName:S,path:o,args:["-d",`${m}`],isDefault:S===t,icon:c(m),isAutoDetected:!1};i.push(_)}return i}function c(o){return o.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(r.Codicon.terminalUbuntu):o.includes("Debian")?b.ThemeIcon.asThemeIcon(r.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(r.Codicon.terminalLinux)}async function g(o,t,i,s,u,a,m,S){const _=new Map;if(i){const $=(await o.readFile("/etc/shells")).toString(),A=a||$.split(`
`).filter(R=>R.trim().indexOf("#")!==0&&R.trim().length>0),U=new Map;for(const R of A){let N=(0,k.basename)(R),F=U.get(N)||0;F++,F>1&&(N=`${N} (${F})`),U.set(N,F),_.set(N,{path:R,isAutoDetected:!0})}}return l(s,_),await h(_.entries(),u,o,S,t,m)}function l(o,t){if(!!o)for(const[i,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?t.delete(i):(s.icon=s.icon||t.get(i)?.icon,t.set(i,s))}async function n(o,t,i,s,u,a,m,S,_,$){if(i.length===0)return Promise.resolve(void 0);const A=i.shift();if(A==="")return n(o,t,i,s,u,a,m,S,_);const U={profileName:o,path:A,args:a,env:m,overrideName:S,isAutoDetected:_,isDefault:o===t};if((0,k.basename)(A)===A){const N=u.PATH?u.PATH.split(k.delimiter):void 0,F=await(0,E.findExecutable)(A,void 0,N,void 0,s.existsFile);return F?(U.path=F,U.isFromPath=!0,U):n(o,t,i,s,u,a)}return await s.existsFile((0,k.normalize)(A))?U:n(o,t,i,s,u,a,m,S,_)}}),define(ne[232],re([0,1,3,2,23,4,39,67,17,14,92,218,8,99,225,109,230,231]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let c=0,g=class extends r.Disposable{constructor(n,o,t,i){super(),this._reconnectConstants=n,this._configurationService=o,this._environmentService=t,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,w.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,r.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?n.debugBrk=o.port:!o.break&&o.port&&(n.debug=o.port));const t=new P.Client(k.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,n);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const s=t.getChannel(y.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const u=T.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(a=>this._onProcessData.fire(a))),this._register(u.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(u.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(u.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(u.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(u.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(u.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,o,t,i,s,u,a,m,S,_,$){const A=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),U=await this._proxy.createProcess(n,o,t,i,s,u,a,m,S,_,$);return clearTimeout(A),c=Math.max(c,U),U}updateTitle(n,o,t){return this._proxy.updateTitle(n,o,t)}updateIcon(n,o,t,i){return this._proxy.updateIcon(n,o,t,i)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n,o){return this._proxy.detachFromProcess(n,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,o){return this._proxy.shutdown(n,o)}input(n,o){return this._proxy.input(n,o)}processBinary(n,o){return this._proxy.processBinary(n,o)}resize(n,o,t){return this._proxy.resize(n,o,t)}acknowledgeDataEvent(n,o){return this._proxy.acknowledgeDataEvent(n,o)}setUnicodeVersion(n,o){return this._proxy.setUnicodeVersion(n,o)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,o){return this._proxy.installAutoReply(n,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,o,t,i=!1){const s=await this._shellEnv;return(0,d.detectAvailableProfiles)(o,t,i,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}getRevivedPtyNewId(n){return this._proxy.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,o){return this._proxy.requestDetachInstance(n,o)}async acceptDetachInstanceReply(n,o){return this._proxy.acceptDetachInstanceReply(n,o)}async freePortKillProcess(n){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(n)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,o){return this._proxy.reviveTerminalProcesses(n,o)}async refreshProperty(n,o){return this._proxy.refreshProperty(n,o)}async updateProperty(n,o,t){return this._proxy.updateProperty(n,o,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:o})}async acceptPtyHostResolvedVariables(n,o){this._resolveVariablesRequestStore.acceptReply(n,o)}};g=pe([Y(1,E.IConfigurationService),Y(2,b.IEnvironmentService),Y(3,p.ILogService)],g),e.PtyHostService=g}),define(ne[74],re([0,1,3,4,5,8]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var T;(function(y){y.Http="http",y.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=C;function p(y,w){return w?w!==1&&y<1024:!r.isWindows&&y<1024}e.isPortPrivileged=p;class v{constructor(w,d,f){this.remoteAddress=w,this.localAddress=d,this._dispose=f,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let h=class{constructor(w){this.logService=w,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],d=Array.from(this._tunnels.values());for(const f of d){const c=Array.from(f.values());for(const g of c){const l=await g.value;l&&w.push(l)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:d}of w.values())await d.then(f=>f?.dispose());w.clear()}this._tunnels.clear()}setEnvironmentTunnel(w,d,f,c,g){this.addTunnelToMap(w,d,Promise.resolve({tunnelRemoteHost:w,tunnelRemotePort:d,localAddress:f,privacy:c,protocol:g,dispose:()=>Promise.resolve()}))}openTunnel(w,d,f,c,g=!1,l,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${f} on local port ${c}.`),!w)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(f)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(w,d,f,c,g,l,n);return o?o.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,f);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(t);return(t.tunnelRemoteHost!==d||t.tunnelRemotePort!==f)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const d=this._tunnels.get(w.tunnelRemoteHost);if(d){const f=d.get(w.tunnelRemotePort);f&&(f.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,f))}}}}async tryDisposeTunnel(w,d,f){if(f.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${d}.`);const c=f.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(d),c}}async closeTunnel(w,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${d} `);const f=this._tunnels.get(w);if(f&&f.has(d)){const c=f.get(d);c.refcount=0,await this.tryDisposeTunnel(w,d,c)}}addTunnelToMap(w,d,f){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(d,{refcount:1,value:f})}async removeEmptyTunnelFromMap(w,d){const f=this._tunnels.get(w);f&&(await f.get(d)||f.delete(d),f.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,d){const f=[w];I(w)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):C(w)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const c=f.map(g=>this._tunnels.get(g));for(const g of c){const l=g?.get(d);if(l)return l}}canTunnel(w){return!!b(w)}doIsPortPrivileged(w,d,f,c){if(d)return!1;if(f){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(g?.length===4){const l=parseInt(g[1]),n=parseInt(g[2]);if(l>10||l===10&&n>=14)return!1}}return w<1024}createWithProvider(w,d,f,c,g,l,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${f} on local port ${c}.`);const o=f;this._factoryInProgress.add(o);const t=c===void 0?f:c,i={elevationRequired:g?this.isPortPrivileged(t):!1},s={remoteAddress:{host:d,port:f},localAddressPort:c,privacy:l,public:l?l!==P.Private:void 0,protocol:n},u=w.forwardPort(s,i);return u?(this.addTunnelToMap(d,f,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),u}};h=pe([Y(0,L.ILogService)],h),e.AbstractTunnelService=h}),define(ne[233],re([0,1,8,74,2,9,6]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends k.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let E=class Dt extends k.Disposable{constructor(I,C){super(),this._tunnelService=I,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Dt._lastId)}}async startTunnel(I,C,p,v,h,y){const w=new P,d=await Promise.resolve(this._tunnelService.openTunnel(I,w,p,v,h,y));if(!d)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${v} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),w.dispose(),await d.dispose(),(0,L.canceled)();return w.setTunnel(d),this._tunnels.set(C,w),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${d.localAddress} (local) to ${p}:${v} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(I,C){const p=this._tunnels.get(I);!p||p.setAddress(C)}async destroyTunnel(I){const C=this._tunnels.get(I);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await C.dispose();return}this._disposedTunnels.add(I)}};E._lastId=0,E=pe([Y(0,r.ISharedTunnelsService),Y(1,D.ILogService)],E),e.SharedProcessTunnelService=E}),define(ne[234],re([0,1,82,36,120,209,6,2,17,8,25,207,74,104,4]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(g,l,n,o,t){let i;for(let s=3;s&&(i?.dispose(),i=await new w(g,l,n,o,t).waitForReady(),!(t&&k.BROWSER_RESTRICTED_PORTS[t]||!k.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));s--);return i}class w extends P.Disposable{constructor(l,n,o,t,i){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=i,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){let l=await(0,k.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),n=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address(),n||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),n=this._server.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async _onConnection(l){l.pause();const n=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,C.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=o.getSocket().socket,i=o.readEntireBuffer();o.dispose(),i.byteLength>0&&l.write(i.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),t.end()}),l.on("close",()=>t.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),t.destroy()}),t.on("end",()=>l.end()),t.on("close",()=>l.end()),t.on("error",()=>{l.destroy()}),l.pipe(t),t.pipe(l),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),t.end()})}}let d=class extends p.AbstractTunnelService{constructor(l,n,o,t,i){super(n),this.socketFactory=l,this.signService=o,this.productService=t,this.configurationService=i}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}isPortPrivileged(l){return this.doIsPortPrivileged(l,h.isWindows,h.isMacintosh,r.release())}retainOrCreateTunnel(l,n,o,t,i,s,u){const a=this.getTunnelFromMap(n,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,o,t,i,s,u);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${o} on local port ${t}.`);const m={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},S=y(m,this.defaultTunnelHost,n,o,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,o,S),S}}};d=pe([Y(1,b.ILogService),Y(2,v.ISignService),Y(3,I.IProductService),Y(4,E.IConfigurationService)],d),e.BaseTunnelService=d;let f=class extends d{constructor(l,n,o,t){super(L.nodeSocketFactory,l,n,o,t)}};f=pe([Y(0,b.ILogService),Y(1,v.ISignService),Y(2,I.IProductService),Y(3,E.IConfigurationService)],f),e.TunnelService=f;let c=class extends P.Disposable{constructor(l,n,o,t){super(),this.logService=l,this.productService=n,this.signService=o,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(l,n,o,t,i,s,u,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${t} on local port ${i}.`),!this._tunnelServices.has(l)){const m=new f(this.logService,this.signService,this.productService,this.configurationService);this._register(m),this._tunnelServices.set(l,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(n,o,t,i,s,u,a)}};c=pe([Y(0,b.ILogService),Y(1,I.IProductService),Y(2,v.ISignService),Y(3,E.IConfigurationService)],c),e.SharedTunnelsService=c}),define(ne[31],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[235],re([0,1,3,2,7,14,33,13,8,31]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends r.Disposable{constructor(p,v,h,y,w){super(),this.extensionsManagementService=p,this.logService=y,this.uriIdentityService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(f=>{this.installedExtensions=f.map(c=>c.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(f=>this.onInstallExtension(f))),this._register(p.onDidInstallExtensions(f=>this.onDidInstallExtensions(f))),this._register(p.onDidUninstallExtension(f=>this.onDidUninstallExtension(f)));const d=k.URI.file(h.extensionsPath);this._register(v.watch(d)),this._register(D.Event.filter(v.onDidFilesChange,f=>f.rawChanges.some(c=>this.doesChangeAffects(c,d)))(()=>this.onDidChange()))}doesChangeAffects(p,v){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),v)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const v of p)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(v=>!(0,T.areSameExtensions)(v,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,T.areSameExtensions)(v,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),v=p.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,T.areSameExtensions)(w,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),h=this.installedExtensions.filter(y=>this.installingExtensions.some(w=>(0,T.areSameExtensions)(w,y))?!1:p.every(w=>!(0,T.areSameExtensions)(w.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=p.map(y=>y.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};I=pe([Y(1,P.IFileService),Y(2,L.INativeEnvironmentService),Y(3,E.ILogService),Y(4,b.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(ne[236],re([0,1,31,93,13,19,118,3,2]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(p){this.uri=p,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let I=class{constructor(p){this._fileService=p,this._dispooables=new E.DisposableStore,this._limit=2**16;const v=new Map,h=y=>{let w=v.get(y.scheme);return w===void 0&&(w=p.hasProvider(y)&&!this._fileService.hasCapability(y,1024),v.set(y.scheme,w)),w};this._dispooables.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(y=>{v.delete(y.scheme)})),this.extUri=new L.ExtUri(h),this._canonicalUris=new T.SkipList((y,w)=>this.extUri.compare(y,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,L.normalizePath)(p));const v=this._canonicalUris.get(p);return v?v.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new b(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(p[h][0],p[h][1].touch())}};I=pe([Y(0,k.IFileService)],I),e.UriIdentityService=I,(0,r.registerSingleton)(D.IUriIdentityService,I,1)}),define(ne[237],re([0,1,3,2,13,42,34,16]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class E extends r.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(I,C,p,v){super(),this.fileSystemScheme=I,this.fileSystemProvider=C,this.userDataScheme=p,this.logService=v,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(h=>this.handleFileChanges(h)))}watch(I,C){this.watchResources.set(I,I);const p=this.fileSystemProvider.watch(this.toFileSystemResource(I),C);return(0,r.toDisposable)(()=>{this.watchResources.delete(I),p.dispose()})}stat(I){return this.fileSystemProvider.stat(this.toFileSystemResource(I))}mkdir(I){return this.fileSystemProvider.mkdir(this.toFileSystemResource(I))}rename(I,C,p){return this.fileSystemProvider.rename(this.toFileSystemResource(I),this.toFileSystemResource(C),p)}readFile(I){return this.fileSystemProvider.readFile(this.toFileSystemResource(I),{atomic:!0})}readFileStream(I,C,p){const v=(0,L.newWriteableStream)(h=>P.VSBuffer.concat(h.map(y=>P.VSBuffer.wrap(y))).buffer);return(async()=>{try{const h=await this.readFile(I);v.end(h)}catch(h){v.error(h),v.end()}})(),v}readdir(I){return this.fileSystemProvider.readdir(this.toFileSystemResource(I))}writeFile(I,C,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(I),C,p)}delete(I,C){return this.fileSystemProvider.delete(this.toFileSystemResource(I),C)}copy(I,C,p){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(I),this.toFileSystemResource(C),p);throw new Error("copy not supported")}handleFileChanges(I){const C=[];for(const p of I){if(p.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(p.resource);this.watchResources.findSubstr(v)&&C.push({resource:v,type:p.type})}C.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(C))}toFileSystemResource(I){return I.with({scheme:this.fileSystemScheme})}toUserDataResource(I){return I.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=E}),define(ne[61],re([0,1,80]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function r(T,P,E,b){const I=(0,D.setProperty)(T,P,E,b)[0];return I&&(T=T.substring(0,I.offset)+I.content+T.substring(I.offset+I.length)),T}e.edit=r;function k(T,P,E){let b=E;for(;b>=0;){if(T.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&T.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=k;function L(T,P,E){let b=E;for(;b>=0;)if(T.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&T.charAt(b)===P.charAt(1)))return b;return T.length-1}e.getLineEndOffset=L}),define(ne[238],re([0,1,32,55,15]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(v,h,y,w,d,f){const c=[],g=[],l=[];if(!h){const F=v.filter(({identifier:q})=>d.every(J=>J.toLowerCase()!==q.id.toLowerCase()));return{local:{added:c,removed:g,updated:l},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}v=v.map(C),h=h.map(C),y=y?y.map(C):null;const n=new Map,o=F=>{F.uuid&&n.set(F.id.toLowerCase(),F.uuid)};v.forEach(({identifier:F})=>o(F)),h.forEach(({identifier:F})=>o(F)),y?.forEach(({identifier:F})=>o(F));const t=F=>{const q=F.identifier.uuid||n.get(F.identifier.id.toLowerCase());return q?`uuid:${q}`:`id:${F.identifier.id.toLowerCase()}`},i=(F,q)=>(F.set(t(q),q),F),s=v.reduce(i,new Map),u=h.reduce(i,new Map),a=h.reduce((F,q)=>i(F,(0,D.deepClone)(q)),new Map),m=y?y.reduce(i,new Map):null,S=w.reduce(i,new Map),_=d.reduce((F,q)=>{const J=n.get(q.toLowerCase());return F.add(J?`uuid:${J}`:`id:${q.toLowerCase()}`)},new Set),$=f.reduce((F,{id:q,uuid:J})=>(J=J??n.get(q.toLowerCase()),F.add(J?`uuid:${J}`:`id:${q.toLowerCase()}`)),new Set),A=T(s,u,_,!1);if(A.added.size>0||A.removed.size>0||A.updated.size>0){const F=T(m,s,_,!1),q=T(m,u,_,!0),J=(j,H,W,z)=>({...z,installed:H.installed||W.installed,version:W.version&&(!H.installed||r.gt(W.version,H.version))?W.version:H.version,state:E(H,W,m?.get(j)),preRelease:(H.installed?z.preRelease:W.preRelease)??H.preRelease});for(const j of q.removed.values()){const H=s.get(j);if(!H)continue;const W=(0,k.assertIsDefined)(m?.get(j)),z=!$.has(j)&&W.installed;H.installed&&z?g.push(H.identifier):a.set(j,H)}for(const j of q.added.values()){const H=(0,k.assertIsDefined)(u.get(j)),W=s.get(j);if(W){if(A.updated.has(j)){const z=J(j,W,H,H);P(W,H,!1,!1)||l.push(p(z,j)),a.set(j,z)}}else H.installed&&c.push(p(H,j))}for(const j of q.updated.values()){const H=(0,k.assertIsDefined)(u.get(j)),W=(0,k.assertIsDefined)(m?.get(j)),z=s.get(j);if(z)if(!$.has(j)&&W.installed&&z.installed&&!H.installed)g.push(z.identifier);else{const X=J(j,z,H,H);l.push(p(X,j)),a.set(j,X)}else H.installed&&c.push(p(H,j))}for(const j of F.added.values())q.added.has(j)||a.set(j,(0,k.assertIsDefined)(s.get(j)));for(const j of F.updated.values()){if(q.removed.has(j)||q.updated.has(j))continue;const H=(0,k.assertIsDefined)(s.get(j)),W=(0,k.assertIsDefined)(u.get(j));a.set(j,J(j,H,W,H))}for(const j of F.removed.values())q.updated.has(j)||q.removed.has(j)||S.has(j)||!(0,k.assertIsDefined)(u.get(j)).installed||$.has(j)||!(0,k.assertIsDefined)(m?.get(j)).installed||a.delete(j)}const U=[],R=T(u,a,new Set,!0),N=R.added.size>0||R.updated.size>0||R.removed.size>0;return N&&a.forEach((F,q)=>U.push(p(F,q))),{local:{added:c,removed:g,updated:l},remote:N?{added:[...R.added].map(F=>a.get(F)),updated:[...R.updated].map(F=>a.get(F)),removed:[...R.removed].map(F=>u.get(F)),all:U}:null}}e.merge=L;function T(v,h,y,w){const d=v?[...v.keys()].filter(n=>!y.has(n)):[],f=[...h.keys()].filter(n=>!y.has(n)),c=f.filter(n=>d.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),g=d.filter(n=>f.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),l=new Set;for(const n of d){if(g.has(n))continue;const o=v.get(n),t=h.get(n);(!t||!P(o,t,w,!0))&&l.add(n)}return{added:c,removed:g,updated:l}}function P(v,h,y,w){return!(v.disabled!==h.disabled||w&&v.installed!==h.installed||v.installed&&h.installed&&v.preRelease!==h.preRelease||!I(v.state,h.state)||y&&v.version!==h.version)}function E(v,h,y){const w=v.state,d=h.state,f=y?.state;if(!h.version||w&&r.gt(v.version,h.version))return w;if(d&&r.gt(h.version,v.version)||!w)return d;if(!d)return w;const c=(0,D.deepClone)(w),g=f?b(f,d):{added:Object.keys(d).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set},l=f?b(f,w):{added:Object.keys(w).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set};for(const n of[...g.added.values(),...g.updated.values()])c[n]=d[n];for(const n of g.removed.values())l.updated.has(n)||delete c[n];return c}function b(v,h){const y=Object.keys(v),w=Object.keys(h),d=w.filter(g=>y.indexOf(g)===-1).reduce((g,l)=>(g.add(l),g),new Set),f=y.filter(g=>w.indexOf(g)===-1).reduce((g,l)=>(g.add(l),g),new Set),c=new Set;for(const g of y){if(f.has(g))continue;const l=v[g],n=h[g];(0,D.equals)(l,n)||c.add(g)}return{added:d,removed:f,updated:c}}function I(v={},h={}){const{added:y,removed:w,updated:d}=b(v,h);return y.size===0&&w.size===0&&d.size===0}function C(v){return{...v,disabled:!!v.disabled,installed:!!v.installed}}function p(v,h){const y={identifier:{id:v.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!v.preRelease};return v.version&&(y.version=v.version),v.disabled&&(y.disabled=!0),v.installed&&(y.installed=!0),v.state&&(y.state=v.state),y}}),define(ne[111],re([0,1,18,17,5]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),E&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(P,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),E&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(P){const E=P.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),I=[],C=[];if(Array.isArray(b))for(const p of b)p.startsWith("-")?C.push(p.substring(1)):I.push(p);return(0,D.distinct)([...E,...I].filter(p=>C.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};L=pe([Y(0,r.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[239],re([0,1,18,35,32,179,61]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(g){return(0,r.parse)(g)||[]}e.parseKeybindings=P;async function E(g,l,n,o,t){const i=P(g),s=P(l),u=n?P(n):null,a=[...i,...s,...u||[]].map(J=>J.key),m=await t.resolveUserBindings(a),S=I(i,s,u,m);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const _=p(i),$=p(s),A=u?p(u):null,U=h(_,$,m),R=A?h(A,_,m):{added:[..._.keys()].reduce((J,j)=>(J.add(j),J),new Set),removed:new Set,updated:new Set},N=A?h(A,$,m):{added:[...$.keys()].reduce((J,j)=>(J.add(j),J),new Set),removed:new Set,updated:new Set},F=b(U,R,N);let q=g;for(const J of F.removed.values())F.conflicts.has(J)||(q=f(q,J,o));for(const J of F.added.values()){if(F.conflicts.has(J))continue;const j=$.get(J);if(j.some(H=>H.command!==`-${J}`&&S.conflicts.has(m[H.key]))){F.conflicts.add(J);continue}q=d(q,j,o)}for(const J of F.updated.values()){if(F.conflicts.has(J))continue;const j=$.get(J);if(j.some(H=>H.command!==`-${J}`&&S.conflicts.has(m[H.key]))){F.conflicts.add(J);continue}q=c(q,J,j,o)}return{mergeContent:q,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=E;function b(g,l,n){const o=new Set,t=new Set,i=new Set,s=new Set;for(const u of l.removed.values())n.updated.has(u)&&s.add(u);for(const u of n.removed.values())s.has(u)||(l.updated.has(u)?s.add(u):t.add(u));for(const u of l.added.values())s.has(u)||n.added.has(u)&&g.updated.has(u)&&s.add(u);for(const u of n.added.values())s.has(u)||(l.added.has(u)?g.updated.has(u)&&s.add(u):o.add(u));for(const u of l.updated.values())s.has(u)||n.updated.has(u)&&g.updated.has(u)&&s.add(u);for(const u of n.updated.values())s.has(u)||(l.updated.has(u)?g.updated.has(u)&&s.add(u):i.add(u));return{added:o,removed:t,updated:i,conflicts:s}}function I(g,l,n,o){const t=new Set,i=C(g,o),s=C(l,o),u=n?C(n,o):null,a=v(i,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const m=u?v(u,i):{added:[...i.keys()].reduce((R,N)=>(R.add(N),R),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const S=u?v(u,s):{added:[...s.keys()].reduce((R,N)=>(R.add(N),R),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:_,removed:$,updated:A,conflicts:U}=b(a,m,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:_,removed:$,updated:A,conflicts:U}}function C(g,l){const n=new Map;for(const o of g){const t=l[o.key];let i=n.get(t);i||(i=[],n.set(t,i)),i.push(o)}return n}function p(g){const l=new Map;for(const n of g){const o=n.command[0]==="-"?n.command.substring(1):n.command;let t=l.get(o);t||(t=[],l.set(o,t)),t.push(n)}return l}function v(g,l){const n=[...g.keys()],o=[...l.keys()],t=o.filter(u=>n.indexOf(u)===-1).reduce((u,a)=>(u.add(a),u),new Set),i=n.filter(u=>o.indexOf(u)===-1).reduce((u,a)=>(u.add(a),u),new Set),s=new Set;for(const u of n){if(i.has(u))continue;const a=g.get(u).map(S=>({...S,key:u})),m=l.get(u).map(S=>({...S,key:u}));(0,D.equals)(a,m,(S,_)=>w(S,_))||s.add(u)}return{added:t,removed:i,updated:s}}function h(g,l,n){const o=[...g.keys()],t=[...l.keys()],i=t.filter(a=>o.indexOf(a)===-1).reduce((a,m)=>(a.add(m),a),new Set),s=o.filter(a=>t.indexOf(a)===-1).reduce((a,m)=>(a.add(m),a),new Set),u=new Set;for(const a of o){if(s.has(a))continue;const m=g.get(a).map(_=>({..._,key:n[_.key]})),S=l.get(a).map(_=>({..._,key:n[_.key]}));y(m,S)||u.add(a)}return{added:i,removed:s,updated:u}}function y(g,l){return!(!(0,D.equals)(g.filter(({command:n})=>n[0]!=="-"),l.filter(({command:n})=>n[0]!=="-"),(n,o)=>w(n,o))||!(0,D.equals)(g.filter(({command:n})=>n[0]==="-"),l.filter(({command:n})=>n[0]==="-"),(n,o)=>w(n,o)))}function w(g,l){if(g.command!==l.command||g.key!==l.key)return!1;const n=L.ContextKeyExpr.deserialize(g.when),o=L.ContextKeyExpr.deserialize(l.when);return!(n&&!o||!n&&o||n&&o&&!n.equals(o)||!k.equals(g.args,l.args))}function d(g,l,n){for(const o of l)g=T.edit(g,[-1],o,n);return g}function f(g,l,n){const o=P(g);for(let t=o.length-1;t>=0;t--)(o[t].command===l||o[t].command===`-${l}`)&&(g=T.edit(g,[t],void 0,n));return g}function c(g,l,n,o){const t=P(g),i=t.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=t.length-1;s>=0;s--)(t[s].command===l||t[s].command===`-${l}`)&&(g=T.edit(g,[s],void 0,o));for(let s=n.length-1;s>=0;s--)g=T.edit(g,[i],n[s],o);return g}}),define(ne[240],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(L,T,P){const E={},b={},I=new Set;if(!T)return{local:{added:E,updated:b,removed:[...I.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const C=r(L,T);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:E,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=r(P,L),v=r(P,T),h={},y={},w=new Set,d=new Set;for(const f of p.removed.values())v.updated.has(f)?E[f]=T[f]:w.add(f);for(const f of v.removed.values())d.has(f)||(p.updated.has(f)?d.add(f):I.add(f));for(const f of p.updated.values())d.has(f)||(v.updated.has(f)?C.updated.has(f)&&d.add(f):y[f]=L[f]);for(const f of v.updated.values())d.has(f)||(p.updated.has(f)?C.updated.has(f)&&d.add(f):L[f]!==void 0&&(b[f]=T[f]));for(const f of p.added.values())d.has(f)||(v.added.has(f)?C.updated.has(f)&&d.add(f):h[f]=L[f]);for(const f of v.added.values())d.has(f)||(p.added.has(f)?C.updated.has(f)&&d.add(f):E[f]=T[f]);return{local:{added:E,removed:[...I.values()],updated:b},remote:{added:h,removed:[...w.values()],updated:y},conflicts:[...d.values()]}}e.merge=D;function r(L,T){const P=L?Object.keys(L):[],E=T?Object.keys(T):[],b=E.filter(p=>P.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),I=P.filter(p=>E.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),C=new Set;for(const p of P){if(I.has(p))continue;const v=L[p],h=T[p];v!==h&&C.add(p)}return{added:b,removed:I,updated:C}}function k(L,T){const{added:P,removed:E,updated:b}=r(L,T);return P.size===0&&E.size===0&&b.size===0}e.areSame=k}),define(ne[241],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(k,L,T,P){const E={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!L){const I=k.filter(({id:C})=>!P.includes(C));return I.length?E.remote.added=I:E.remote=null,E}const b=r(k,L,P);if(b.added.length>0||b.removed.length>0||b.updated.length>0){const I=r(T,k,P),C=r(T,L,P);for(const p of C.removed){const v=k.find(h=>h.id===p);v&&E.local.removed.push(v)}for(const p of C.added){const v=L.find(h=>h.id===p);I.added.includes(p)?b.updated.includes(p)&&E.local.updated.push(v):E.local.added.push(v)}for(const p of C.updated)E.local.updated.push(L.find(v=>v.id===p));for(const p of I.added)C.added.includes(p)||E.remote.added.push(k.find(v=>v.id===p));for(const p of I.updated)C.removed.includes(p)||C.updated.includes(p)||E.remote.updated.push(k.find(v=>v.id===p));for(const p of I.removed)E.remote.removed.push(L.find(v=>v.id===p))}return E.remote.added.length===0&&E.remote.removed.length===0&&E.remote.updated.length===0&&(E.remote=null),E}e.merge=D;function r(k,L,T){k=k?k.filter(({id:p})=>!T.includes(p)):[],L=L.filter(({id:p})=>!T.includes(p));const P=k.map(({id:p})=>p),E=L.map(({id:p})=>p),b=E.filter(p=>P.indexOf(p)===-1),I=P.filter(p=>E.indexOf(p)===-1),C=[];for(const{id:p,name:v,shortName:h}of k){if(I.includes(p))continue;const y=L.find(w=>w.id===p);(!y||y.name!==v||y.shortName!==h)&&C.push(p)}return{added:b,removed:I,updated:C}}}),define(ne[26],re([0,1,18,15,167,43,29,5,101,40]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const s=b.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(u=>!!s[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function C(){const s=b.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(s).filter(S=>!!s[S].ignoreSync),a=Object.keys(s).filter(S=>s[S].scope===2||s[S].scope===6),m=I();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...a,...m])}e.getDefaultIgnoredSettings=C,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const s="vscode://schemas/ignoredSettings",u=b.Registry.as(L.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,k.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,k.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,k.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,k.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,k.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=b.Registry.as(E.Extensions.JSONContribution),m=()=>{const S=I(),_=C().filter(R=>R!==e.CONFIGURATION_SYNC_STORE_KEY),$=Object.keys(L.allSettings.properties).filter(R=>_.indexOf(R)===-1),A=_.filter(R=>S.indexOf(R)===-1),U={items:{type:"string",enum:[...$,...A.map(R=>`-${R}`)]}};a.registerSchema(s,U)};return u.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=p;function v(s){return s&&(0,r.isObject)(s)&&(0,r.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=v;var h;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(s,...u){return s?[s,...u]:u}e.getPathSegments=y;function w(s,u,a,m){return m.joinPath(a.userDataSyncHome,...y(s,u,`lastSync${u}.json`))}e.getLastSyncResourceUri=w,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function d(s){const u={};return u[e.HEADER_EXECUTION_ID]=s,u}e.createSyncHeaders=d;var f;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(f=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class c extends Error{constructor(u,a,m,S){super(u),this.code=a,this.resource=m,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class g extends c{constructor(u,a,m,S,_){super(u,m,void 0,_),this.url=a,this.serverCode=S}}e.UserDataSyncStoreError=g;class l extends c{constructor(u,a){super(u,a)}}e.UserDataAutoSyncError=l,function(s){function u(a){if(a instanceof s)return a;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(m&&m[1]){const S=m[2]==="unknown"?void 0:m[2],_=m[3]==="unknown"?void 0:m[3];return new s(a.message,m[1],S,_)}return new s(a.message,"Unknown")}s.toUserDataSyncError=u}(c=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var o;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(s){return`sync.enable.${s}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ne[242],re([0,1,32,26]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(P,E,b,I,C){if(!E)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const p=L(P,E);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=b?L(b,E):{added:Object.keys(E).reduce((f,c)=>(f.add(c),f),new Set),removed:new Set,updated:new Set},h=b?L(b,P):{added:Object.keys(P).reduce((f,c)=>(f.add(c),f),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},w=D.deepClone(E),d=!b;for(const f of h.added.values())f!==r.SYNC_SERVICE_URL_TYPE&&d&&v.added.has(f)||(w[f]=P[f]);for(const f of h.updated.values())w[f]=P[f];for(const f of h.removed.values())I.unregistered.includes(f)||delete w[f];for(const f of v.added.values()){const c=E[f];if(I.machine.includes(f)){C.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(f))continue;const g=P[f];g&&g.value===c.value||f===r.SYNC_SERVICE_URL_TYPE&&d&&h.added.has(f)||(g?y.updated[f]=c:y.added[f]=c)}for(const f of v.updated.values()){const c=E[f];if(I.machine.includes(f)){C.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(f)||h.removed.has(f))continue;const g=P[f];g&&g.value===c.value||(y.updated[f]=c)}for(const f of v.removed.values()){if(I.machine.includes(f)){C.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}h.updated.has(f)||h.removed.has(f)||y.removed.push(f)}return{local:y,remote:T(w,E)?null:w}}e.merge=k;function L(P,E){const b=Object.keys(P),I=Object.keys(E),C=I.filter(h=>b.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),p=b.filter(h=>I.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),v=new Set;for(const h of b){if(p.has(h))continue;const y=P[h],w=E[h];D.equals(y,w)||v.add(h)}return{added:C,removed:p,updated:v}}function T(P,E){const{added:b,removed:I,updated:C}=L(P,E);return b.size===0&&I.size===0&&C.size===0}}),define(ne[243],re([0,1,18,35,80,46,32,61,26]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function b(a,m,S){let _=[];S?_=C(S):_=I(m);const $=[],A=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(_))for(const U of _)U.startsWith("-")?A.push(U.substring(1)):$.push(U);return(0,D.distinct)([...a,...$].filter(U=>A.indexOf(U)===-1))}e.getIgnoredSettings=b;function I(a){let m=a.inspect("settingsSync.ignoredSettings").userValue;return m!==void 0||(m=a.inspect("sync.ignoredSettings").userValue,m!==void 0)?m:a.getValue("settingsSync.ignoredSettings")||[]}function C(a){const m=(0,r.parse)(a);return m?m["settingsSync.ignoredSettings"]||m["sync.ignoredSettings"]||[]:[]}function p(a,m){const S=(0,r.parse)(a)||{};let _="{}";for(const $ of Object.keys(S)){const A=(0,k.setProperty)(_,[$],S[$],m);_=(0,k.applyEdits)(_,A)}return _}e.removeComments=p;function v(a,m,S,_){if(S.length){const $=u(m),A=(0,r.parse)(m)||{},U=(0,r.parse)(a);if(!U)return a;const R=[];for(const N of S){const F=A[N],q=U[N];F===void 0?a=P.edit(a,[N],void 0,_):q!==void 0?a=P.edit(a,[N],F,_):R.push(n(N,$))}R.sort((N,F)=>N.startOffset-F.startOffset),R.forEach(N=>a=f(N.setting.key,m,a,_))}return a}e.updateIgnoredSettings=v;function h(a,m,S,_,$,A){const U=v(a,m,_,A),R=S!==U,N=S!==m;if(!R&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(R&&!N)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(N&&!R)return{conflictsSettings:[],localContent:v(m,a,_,A),remoteContent:null,hasConflicts:!1};if(S===null&&w(a)){const V=y(a,m,_)?null:v(m,a,_,A);return{conflictsSettings:[],localContent:V,remoteContent:null,hasConflicts:!1}}let F=a,q=m;const J=(0,r.parse)(a),j=(0,r.parse)(m),H=S?(0,r.parse)(S):null,W=_.reduce((V,ee)=>(V.add(ee),V),new Set),z=d(J,j,W),K=d(H,J,W),X=d(H,j,W),ce=new Map,B=new Set,G=V=>{B.add(V);const ee=$.filter(({key:oe})=>oe===V)[0];ee?(F=P.edit(F,[V],ee.value,A),q=P.edit(q,[V],ee.value,A)):ce.set(V,{key:V,localValue:J[V],remoteValue:j[V]})};for(const V of K.removed.values())X.updated.has(V)?G(V):q=P.edit(q,[V],void 0,A);for(const V of X.removed.values())B.has(V)||(K.updated.has(V)?G(V):F=P.edit(F,[V],void 0,A));for(const V of K.updated.values())B.has(V)||(X.updated.has(V)?z.updated.has(V)&&G(V):q=P.edit(q,[V],J[V],A));for(const V of X.updated.values())B.has(V)||(K.updated.has(V)?z.updated.has(V)&&G(V):F=P.edit(F,[V],j[V],A));for(const V of K.added.values())B.has(V)||(X.added.has(V)?z.updated.has(V)&&G(V):q=f(V,F,q,A));for(const V of X.added.values())B.has(V)||(K.added.has(V)?z.updated.has(V)&&G(V):F=f(V,q,F,A));const O=ce.size>0||!y(F,q,_),M=O||!y(F,a,[]),x=O||!y(q,m,[]);return{localContent:M?F:null,remoteContent:x?q:null,conflictsSettings:[...ce.values()],hasConflicts:O}}e.merge=h;function y(a,m,S){if(a===m)return!0;const _=(0,r.parse)(a),$=(0,r.parse)(m),A=S.reduce((N,F)=>(N.add(F),N),new Set),U=u(a).filter(N=>!(N.setting&&A.has(N.setting.key))),R=u(m).filter(N=>!(N.setting&&A.has(N.setting.key)));if(U.length!==R.length)return!1;for(let N=0;N<U.length;N++){const F=U[N],q=R[N];if(F.setting&&q.setting){if(F.setting.key!==q.setting.key||!T.equals(_[F.setting.key],$[F.setting.key]))return!1}else if(!F.setting&&!q.setting){if(F.value!==q.value)return!1}else return!1}return!0}e.areSame=y;function w(a){return a?u(a).length===0:!0}e.isEmpty=w;function d(a,m,S){const _=a?Object.keys(a).filter(N=>!S.has(N)):[],$=Object.keys(m).filter(N=>!S.has(N)),A=$.filter(N=>_.indexOf(N)===-1).reduce((N,F)=>(N.add(F),N),new Set),U=_.filter(N=>$.indexOf(N)===-1).reduce((N,F)=>(N.add(F),N),new Set),R=new Set;if(a)for(const N of _){if(U.has(N))continue;const F=a[N],q=m[N];T.equals(F,q)||R.add(N)}return{added:A,removed:U,updated:R}}function f(a,m,S,_){const $=(0,r.parse)(m),A=u(m),U=u(S),R=c(a,A,U);return g(S,a,$[a],R,U,_)}e.addSetting=f;function c(a,m,S){const _=m.findIndex(A=>A.setting?.key===a),$=m[_-1];if($){if($.setting){const U=n($.setting.key,S);if(U)return{index:S.indexOf(U),insertAfter:!0}}else{const U=o(_,m);if(U){const R=n(U.setting.key,S);if(R){const N=t(S.indexOf(R),S),F=i(m,U,m[_]);if(N){const q=i(S,R,N),J=s(F,q);return J?{index:S.indexOf(J),insertAfter:!0}:{index:S.indexOf(N),insertAfter:!1}}else{const q=i(S,R,S[S.length-1]),J=s(F,q);return J?{index:S.indexOf(J),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const A=m[_+1];if(A)if(A.setting){const U=n(A.setting.key,S);if(U)return{index:S.indexOf(U),insertAfter:!1}}else{const U=t(_,m);if(U){const R=n(U.setting.key,S);if(R){const N=o(S.indexOf(R),S),F=i(m,m[_],U);if(N){const q=i(S,N,R),J=s(F.reverse(),q.reverse());return J?{index:S.indexOf(J),insertAfter:!1}:{index:S.indexOf(N),insertAfter:!0}}else{const q=i(S,S[0],R),J=s(F.reverse(),q.reverse());return J?{index:S.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function g(a,m,S,_,$,A){let U;return _.index===-1?U=(0,k.setProperty)(a,[m],S,A):U=l(a,m,S,_,$,A).map(R=>(0,k.withFormatting)(a,R,A)[0]),(0,k.applyEdits)(a,U)}function l(a,m,S,_,$,A){const U=`${JSON.stringify(m)}: ${JSON.stringify(S)}`,R=(0,L.getEOL)(A,a),N=$[_.index];if(_.insertAfter){const F=[];if(N.setting)F.push({offset:N.endOffset,length:0,content:","+U});else{const q=t(_.index,$),J=o(_.index,$),j=J?.setting?.commaOffset;J&&j===void 0&&F.push({offset:J.endOffset,length:0,content:","});const H=j!==void 0&&j>N.endOffset;F.push({offset:H?j+1:N.endOffset,length:0,content:q?R+U+",":R+U})}return F}else{if(N.setting)return[{offset:N.startOffset,length:0,content:U+","}];const F=($[_.index-1]&&!$[_.index-1].setting?R:"")+U+(t(_.index,$)?",":"")+R;return[{offset:N.startOffset,length:0,content:F}]}}function n(a,m){return m.filter(S=>S.setting?.key===a)[0]}function o(a,m){for(let S=a-1;S>=0;S--)if(m[S].setting)return m[S]}function t(a,m){for(let S=a+1;S<m.length;S++)if(m[S].setting)return m[S]}function i(a,m,S){const _=a.indexOf(m),$=a.indexOf(S);return a.filter((A,U)=>_<U&&U<$)}function s(a,m){if(a.length&&m.length){let S=0;for(;S<m.length&&S<a.length;S++)if(a[S].value!==m[S].value)return m[S-1];return m[S-1]}}function u(a){const m=[];let S=-1,_,$;const A={onObjectBegin:U=>{S++},onObjectProperty:(U,R,N)=>{S===0&&(_=R,$=U)},onObjectEnd:(U,R)=>{S--,S===0&&m.push({startOffset:_,endOffset:U+R,value:a.substring(_,U+R),setting:{key:$,commaOffset:void 0}})},onArrayBegin:(U,R)=>{S++},onArrayEnd:(U,R)=>{S--,S===0&&m.push({startOffset:_,endOffset:U+R,value:a.substring(_,U+R),setting:{key:$,commaOffset:void 0}})},onLiteralValue:(U,R,N)=>{S===0&&m.push({startOffset:_,endOffset:R+N,value:a.substring(_,R+N),setting:{key:$,commaOffset:void 0}})},onSeparator:(U,R,N)=>{if(S===0&&U===","){let F=m.length-1;for(;F>=0&&!m[F].setting;F--);const q=m[F];q&&m.splice(F,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:R}})}},onComment:(U,R)=>{S===0&&m.push({startOffset:U,endOffset:U+R,value:a.substring(U,U+R)})}};return(0,r.visit)(a,A),m}}),define(ne[75],re([0,1,3,2,5,26]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let T=class extends r.Disposable{get account(){return this._account}constructor(E,b){super(),this.userDataSyncStoreService=E,this.logService=b,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};T=pe([Y(0,L.IUserDataSyncStoreService),Y(1,L.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[244],re([0,1,2,7]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(p){this.service=p}listen(p,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class L{constructor(p){this.service=p}listen(p,v){throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(r.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class T{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=T;class P{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class E{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class b{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class I extends D.Disposable{constructor(p){super(),this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:r.URI.revive(p.url),type:p.type,defaultUrl:r.URI.revive(p.defaultUrl),insidersUrl:r.URI.revive(p.insidersUrl),stableUrl:r.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(ne[245],re([0,1,14,8]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends r.AbstractLogger{constructor(T,P){super(),this.logger=this._register(T.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...P){this.logger.trace(T,...P)}debug(T,...P){this.logger.debug(T,...P)}info(T,...P){this.logger.info(T,...P)}warn(T,...P){this.logger.warn(T,...P)}error(T,...P){this.logger.error(T,...P)}critical(T,...P){this.logger.critical(T,...P)}flush(){this.logger.flush()}};k=pe([Y(0,r.ILoggerService),Y(1,D.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ne[246],re([0,1,6,3,2]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends k.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:E,getActiveWindowId:b}){super(),this.disposables=this._register(new k.DisposableStore),r.Event.latch(r.Event.any(P,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[112],re([0,1,169,12,34,19,7,5,23]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function b(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(o,t){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,r.basename)(o)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=o;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=I;function C(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=C;function p(o){const t=o;if(t?.uri)return{id:t.id,uri:T.URI.revive(t.uri)};const i=o;if(i?.configPath)return{id:i.id,configPath:T.URI.revive(i.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=p;var v;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(o){const t=o;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=h;function y(o){const t=o;return!!(t&&typeof t=="object"&&T.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=y;class w{constructor(t,i,s,u,a){this._id=t,this._transient=s,this._configuration=u,this._ignorePathCasing=a,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class d{constructor(t,i){this.raw=i,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function f(o){return new d({uri:o,index:0,name:(0,L.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(o,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(o,t.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function g(o){let t;return T.URI.isUri(o)?t=o:t=o.configuration,t?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=g;function l(o,t){return!c(o,t)&&!g(o)}e.isSavedWorkspace=l;function n(o){return(typeof o=="string"?(0,r.extname)(o):(0,L.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ne[20],re([0,1,65,3,2,19,15,7,162,14,13,5,8,112,34,31,6,30,27]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function c(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&P.URI.isUri(i.location)&&P.URI.isUri(i.globalStorageHome)&&P.URI.isUri(i.settingsResource)&&P.URI.isUri(i.keybindingsResource)&&P.URI.isUri(i.tasksResource)&&P.URI.isUri(i.snippetsHome)&&((0,T.isUndefined)(i.extensionsResource)||P.URI.isUri(i.extensionsResource)))}e.isUserDataProfile=c,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function g(t,i){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:P.URI.revive(t.location).with({scheme:i}),globalStorageHome:P.URI.revive(t.globalStorageHome).with({scheme:i}),settingsResource:P.URI.revive(t.settingsResource).with({scheme:i}),keybindingsResource:P.URI.revive(t.keybindingsResource).with({scheme:i}),tasksResource:P.URI.revive(t.tasksResource).with({scheme:i}),snippetsHome:P.URI.revive(t.snippetsHome).with({scheme:i}),extensionsResource:P.URI.revive(t.extensionsResource)?.with({scheme:i}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=g,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function l(t,i,s,u){return{id:t,name:i,location:s,isDefault:!1,shortName:u?.shortName,globalStorageHome:(0,L.joinPath)(s,"globalStorage"),settingsResource:(0,L.joinPath)(s,"settings.json"),keybindingsResource:(0,L.joinPath)(s,"keybindings.json"),tasksResource:(0,L.joinPath)(s,"tasks.json"),snippetsHome:(0,L.joinPath)(s,"snippets"),extensionsResource:(0,L.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}e.toUserDataProfile=l;let n=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,s,u,a){super(),this.environmentService=i,this.fileService=s,this.uriIdentityService=u,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new r.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new r.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new r.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new r.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(m=>l((0,L.basename)(m.location),m.name,m.location,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags})):[];let s;const u=new h.ResourceMap,a=l((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,E.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||i.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),i.length){const m=this.getStoredProfileAssociations();if(m.workspaces)for(const[S,_]of Object.entries(m.workspaces)){const $=P.URI.parse(S),A=P.URI.parse(_),U=i.find(R=>this.uriIdentityService.extUri.isEqual(R.location,A));U&&u.set($,U)}if(m.emptyWindow){const S=P.URI.parse(m.emptyWindow);s=i.find(_=>this.uriIdentityService.extUri.isEqual(_.location,S))}}this._profilesObject={profiles:i,workspaces:u,emptyWindow:s}}return this._profilesObject}async createTransientProfile(i){const s="Temp",u=new RegExp(`${(0,f.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const S of this.profiles){const _=u.exec(S.name),$=_?parseInt(_[1]):0;a=$>a?$:a}const m=`${s} ${a+1}`;return this.createProfile((0,D.hash)((0,d.generateUuid)()).toString(16),m,{transient:!0},i)}async createNamedProfile(i,s,u){return this.createProfile((0,D.hash)((0,d.generateUuid)()).toString(16),i,s,u)}async createProfile(i,s,u,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const m=await this.doCreateProfile(i,s,u);return a&&await this.setProfileForWorkspace(a,m),m}async doCreateProfile(i,s,u){let a=this.profileCreationPromises.get(s);return a||(a=(async()=>{try{const m=this.profiles.find($=>$.name===s||$.id===i);if(m)return m;const S=l(i,s,(0,L.joinPath)(this.profilesHome,i),u);await this.fileService.createFolder(S.location);const _=[];return this._onWillCreateProfile.fire({profile:S,join($){_.push($)}}),await w.Promises.settled(_),this.updateProfiles([S],[],[]),S}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,a)),a}async updateProfile(i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let u=this.profiles.find(a=>a.id===i.id);if(!u)throw new Error(`Profile '${i.name}' does not exist`);return u=l(u.id,s.name??u.name,u.location,{shortName:s.shortName??u.shortName,transient:s.transient??u.isTransient,useDefaultFlags:s.useDefaultFlags??u.useDefaultFlags}),this.updateProfiles([],[],[u]),u}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:s,join(a){u.push(a)}});try{await Promise.allSettled(u)}catch(a){this.logService.error(a)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(i,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let u=this.getProfileForWorkspace(i);return u||(u=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,u)),u}async setProfileForWorkspace(i,s){this.setProfileForWorkspaceSync(i,s)}setProfileForWorkspaceSync(i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=this.profiles.find(a=>a.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(i,u)}unsetWorkspace(i,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(s=>s.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(i.map(s=>this.removeProfile(s)))}getProfileForWorkspace(i){const s=this.getWorkspace(i);return P.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,v.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,v.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,i.location)))}updateProfiles(i,s,u){const a=[...this.profiles,...i],m=[];this.transientProfilesObject.profiles=[];for(let S of a)S.isDefault||s.some(_=>S.id===_.id)||(S=u.find(_=>S.id===_.id)??S,S.isTransient?this.transientProfilesObject.profiles.push(S):m.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.saveStoredProfiles(m),this._profilesObject=void 0,this.triggerProfilesChanges(i,s,u)}triggerProfilesChanges(i,s,u){this._onDidChangeProfiles.fire({added:i,removed:s,updated:u,all:this.profiles})}updateWorkspaceAssociation(i,s,u){u=s?.isTransient?!0:u,u||this.updateWorkspaceAssociation(i,void 0,!0);const a=this.getWorkspace(i),m=u?this.transientProfilesObject:this.profilesObject;P.URI.isUri(a)?(m.workspaces.delete(a),s&&m.workspaces.set(a,s)):m.emptyWindow=s,u||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[u,a]of this.profilesObject.workspaces.entries())i[u.toString()]=a.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",n=pe([Y(0,b.IEnvironmentService),Y(1,I.IFileService),Y(2,y.IUriIdentityService),Y(3,p.ILogService)],n),e.UserDataProfilesService=n;class o extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=o}),define(ne[247],re([0,1,6,2,20]),function(Q,e,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends r.Disposable{constructor(P){super(),this._register(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};L=pe([Y(0,k.IUserDataProfilesService)],L),e.UserDataProfilesCleaner=L}),define(ne[248],re([0,1,18,6,22,9,3,2,4,7,144,29,33,44,8,25,24,20]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,i,s,u,a){super(),this.galleryService=t,this.telemetryService=i,this.logService=s,this.productService=u,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:m})=>m.cancel()),this.uninstallingExtensions.forEach(m=>m.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const i=await this.getTargetPlatform();return t.allTargetPlatforms.some(s=>(0,C.isTargetPlatformCompatible)(s,t.allTargetPlatforms,i))}async installFromGallery(t,i={}){try{if(!this.galleryService.isEnabled())throw new C.ExtensionManagementError(I.localize(0,null),C.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(t,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,i)}catch(s){throw l(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:s}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(s),g(s)}}async uninstall(t,i={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,i)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const i=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:i,compatible:!0},k.CancellationToken.None);if(!s)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,i,s){const u=A=>`${p.ExtensionKey.create(A).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!b.URI.isUri(i)){const A=this.installingExtensions.get(u(i));if(A){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:U}=await A.task.waitUntilTaskIsFinished();return U}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],m=[],S=[],_=this.createInstallExtensionTask(t,i,s);b.URI.isUri(i)||this.installingExtensions.set(u(i),{task:_,waitingTasks:[]}),this._onInstallExtension.fire({identifier:_.identifier,source:i,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",_.identifier.id),a.push({task:_,manifest:t});let $=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const U=await this.getAllDepsAndPackExtensions(_.identifier,t,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),R=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:N,manifest:F}of U){$=$||!!F.extensionDependencies?.some(j=>(0,p.areSameExtensions)({id:j},_.identifier));const q=u(N),J=this.installingExtensions.get(q);if(J){if(this.canWaitForTask(_,J.task)){this.logService.info("Waiting for already requested installing extension",N.identifier.id,_.identifier.id),J.waitingTasks.push(_);const j=J.task.identifier;m.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,H=>H.some(W=>(0,p.areSameExtensions)(W.identifier,j)))).then(H=>{if(!H.find(z=>(0,p.areSameExtensions)(z.identifier,j))?.local)throw new Error(`Extension ${j.id} is not installed`)}))}}else if(!R.some(({identifier:j})=>(0,p.areSameExtensions)(j,N.identifier))){const j=this.createInstallExtensionTask(F,N,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(q,{task:j,waitingTasks:[_]}),this._onInstallExtension.fire({identifier:j.identifier,source:N,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",j.identifier.id,_.identifier.id),a.push({task:j,manifest:F})}}}catch(U){if(b.URI.isUri(_.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",_.identifier.id,U.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",_.identifier.id,U.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),U}const A=a.reduce((U,{task:R,manifest:N})=>(U.set(R.identifier.id.toLowerCase(),{task:R,manifest:N}),U),new Map);for(;A.size;){let U;const R=[...A.values()].filter(({manifest:N})=>!N.extensionDependencies?.some(F=>A.has(F.toLowerCase())));R.length?U=A.size===1?R:R.filter(({task:N})=>!(N===_&&!$)):(this.logService.info("Found extensions with circular dependencies",R.map(({task:N})=>N.identifier.id)),U=[...A.values()]),await this.joinAllSettled(U.map(async({task:N})=>{const F=new Date().getTime();try{const{local:q}=await N.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(q,N.source,s,k.CancellationToken.None))),!b.URI.isUri(N.source)){const J=N.operation===3,j=J?void 0:(new Date().getTime()-N.source.lastUpdated)/1e3;if(l(this.telemetryService,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(N.source),duration:new Date().getTime()-F,durationSinceUpdate:j}),E.isWeb&&N.operation!==3)try{await this.galleryService.reportStatistic(q.manifest.publisher,q.manifest.name,q.manifest.version,"install")}catch{}}S.push({local:q,identifier:N.identifier,operation:N.operation,source:N.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:q.isApplicationScoped})}catch(q){throw b.URI.isUri(N.source)||l(this.telemetryService,N.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(N.source),duration:new Date().getTime()-F,error:q}),this.logService.error("Error while installing the extension:",N.identifier.id),q}finally{A.delete(N.identifier.id.toLowerCase())}}))}return m.length&&await this.joinAllSettled(m),S.forEach(({identifier:U})=>this.logService.info("Extension installed successfully:",U.id)),this._onDidInstallExtensions.fire(S),S.filter(({identifier:U})=>(0,p.areSameExtensions)(U,_.identifier))[0].local}catch(A){if(a.forEach(({task:U})=>U.cancel()),S.length)try{const U=await Promise.allSettled(S.map(({local:R})=>this.createUninstallExtensionTask(R,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let R=0;R<U.length;R++){const N=U[R],{identifier:F}=S[R];N.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,L.getErrorMessage)(N.reason))}}catch(U){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(U),S.map(({identifier:R})=>R.id))}throw this._onDidInstallExtensions.fire(a.map(({task:U})=>({identifier:U.identifier,operation:2,source:U.source,context:s.context,profileLocation:s.profileLocation}))),A}finally{for(const[A,{task:U,waitingTasks:R}]of this.installingExtensions.entries()){const N=R.indexOf(_);N!==-1&&R.splice(N,1),R.length===0&&(U===_||N!==-1)&&this.installingExtensions.delete(A)}}}canWaitForTask(t,i){for(const[,{task:s,waitingTasks:u}]of this.installingExtensions.entries())if(s===t&&(u.includes(i)||u.some(a=>this.canWaitForTask(a,i)))||s===i&&u[0]&&!this.canWaitForTask(t,u[0]))return!1;return!0}async joinAllSettled(t){const i=[],s=[],u=await Promise.allSettled(t);for(const a of u)a.status==="fulfilled"?i.push(a.value):s.push(a.reason);if(s.length)throw c(s);return i}async getAllDepsAndPackExtensions(t,i,s,u,a){if(!this.galleryService.isEnabled())return[];const m=await this.getInstalled(void 0,a),S=[t],_=[],$=async(A,U)=>{const R=U.extensionDependencies||[],N=[...R];if(U.extensionPack){const F=s?m.find(q=>(0,p.areSameExtensions)(q.identifier,A)):void 0;for(const q of U.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(J=>(0,p.areSameExtensions)({id:J},{id:q}))||N.every(J=>!(0,p.areSameExtensions)({id:J},{id:q}))&&N.push(q)}if(N.length){const F=[...S,..._.map(J=>J.gallery.identifier)],q=N.filter(J=>F.every(j=>!(0,p.areSameExtensions)(j,{id:J})));if(q.length){const J=await this.galleryService.getExtensions(q.map(j=>({id:j,preRelease:u})),k.CancellationToken.None);for(const j of J){if(F.find(z=>(0,p.areSameExtensions)(z,j.identifier)))continue;const H=R.some(z=>(0,p.areSameExtensions)({id:z},j.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(j,!1,u)}catch(z){if(z instanceof C.ExtensionManagementError&&z.code===C.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!H){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw z}_.push({gallery:W.extension,manifest:W.manifest}),await $(W.extension.identifier,W.manifest)}}}};return await $(t,i),_}async checkAndGetCompatibleVersion(t,i,s){if((await this.getExtensionsControlManifest()).malicious.some(S=>(0,p.areSameExtensions)(t.identifier,S)))throw new C.ExtensionManagementError(I.localize(3,null,t.identifier.id),C.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const S=await this.getTargetPlatform();throw new C.ExtensionManagementError(I.localize(4,null,t.identifier.id,this.productService.nameLong,(0,C.TargetPlatformToString)(S)),C.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,i,s);if(a){if(s&&!i&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new C.ExtensionManagementError(I.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],k.CancellationToken.None))[0]?new C.ExtensionManagementError(I.localize(6,null,t.identifier.id),C.ExtensionManagementErrorCode.ReleaseVersionNotFound):new C.ExtensionManagementError(I.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const m=await this.galleryService.getManifest(a,k.CancellationToken.None);if(m===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);if(m.version!==a.version)throw new C.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:m}}async getCompatibleVersion(t,i,s){const u=await this.getTargetPlatform();let a=null;return!i&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==s&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:s}],{targetPlatform:u,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,s,u)&&(a=t),a||(i?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:u,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,s,u)),a}async uninstallExtension(t,i){const s=$=>`${$.id.toLowerCase()}${i.versionOnly?`-${t.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,u=this.uninstallingExtensions.get(s(t.identifier));if(u)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),u.waitUntilTaskIsFinished();const a=($,A)=>{const U=this.createUninstallExtensionTask($,A);return this.uninstallingExtensions.set(s(U.extension.identifier),U),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${$.identifier.id}@${$.manifest.version}`),this._onUninstallExtension.fire({identifier:$.identifier,profileLocation:i.profileLocation,applicationScoped:$.isApplicationScoped}),U},m=($,A)=>{A?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,i.profileLocation.toString(),A.message):this.logService.error("Failed to uninstall extension:",`${$.identifier.id}@${$.manifest.version}`,A.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${$.identifier.id}@${$.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${$.identifier.id}@${$.manifest.version}`),l(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)($),error:A}),this._onDidUninstallExtension.fire({identifier:$.identifier,version:$.manifest.version,error:A?.code,profileLocation:i.profileLocation,applicationScoped:$.isApplicationScoped})},S=[],_=[];try{S.push(a(t,i));const $=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const A=this.getAllPackExtensionsToUninstall(t,$);for(const U of A)this.uninstallingExtensions.has(s(U.identifier))?this.logService.info("Extensions is already requested to uninstall",U.identifier.id):S.push(a(U,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(S.map(A=>A.extension),$,t),await this.joinAllSettled(S.map(async A=>{try{if(await A.run(),await this.joinAllSettled(this.participants.map(U=>U.postUninstall(A.extension,i,k.CancellationToken.None))),A.extension.identifier.uuid)try{await this.galleryService.reportStatistic(A.extension.manifest.publisher,A.extension.manifest.name,A.extension.manifest.version,"uninstall")}catch{}m(A.extension)}catch(U){const R=U instanceof C.ExtensionManagementError?U:new C.ExtensionManagementError((0,L.getErrorMessage)(U),C.ExtensionManagementErrorCode.Internal);throw m(A.extension,R),R}finally{_.push(A)}}))}catch($){const A=$ instanceof C.ExtensionManagementError?$:new C.ExtensionManagementError((0,L.getErrorMessage)($),C.ExtensionManagementErrorCode.Internal);for(const U of S){try{U.cancel()}catch{}_.includes(U)||m(U.extension,A)}throw A}finally{for(const $ of S)this.uninstallingExtensions.delete(s($.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",$.extension.identifier.id)}}checkForDependents(t,i,s){for(const u of t){const a=this.getDependents(u,i);if(a.length){const m=a.filter(S=>!t.some(_=>(0,p.areSameExtensions)(_.identifier,S.identifier)));if(m.length)throw new Error(this.getDependentsErrorMessage(u,m,s))}}}getDependentsErrorMessage(t,i,s){return s===t?i.length===1?I.localize(8,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?I.localize(9,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):I.localize(10,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?I.localize(11,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?I.localize(12,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):I.localize(13,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(t,i,s=[]){if(s.indexOf(t)!==-1)return[];s.push(t);const u=t.manifest.extensionPack?t.manifest.extensionPack:[];if(u.length){const a=i.filter(S=>!S.isBuiltin&&u.some(_=>(0,p.areSameExtensions)({id:_},S.identifier))),m=[];for(const S of a)m.push(...this.getAllPackExtensionsToUninstall(S,i,s));return[...a,...m]}return[]}getDependents(t,i){return i.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(u=>(0,p.areSameExtensions)({id:u},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,i,s){return s.profileLocation&&(0,v.isApplicationScopedExtension)(t)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,i,s)}createUninstallExtensionTask(t,i){return i.profileLocation&&t.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,i)}};f=pe([Y(0,C.IExtensionGalleryService),Y(1,w.ITelemetryService),Y(2,h.ILogService),Y(3,y.IProductService),Y(4,d.IUserDataProfilesService)],f),e.AbstractExtensionManagementService=f;function c(o){const t=Array.isArray(o)?o:[o];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((i,s)=>new Error(`${i.message}${i.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=c;function g(o){if(o instanceof C.ExtensionManagementError)return o;const t=new C.ExtensionManagementError(o.message,C.ExtensionManagementErrorCode.Internal);return t.stack=o.stack,t}function l(o,t,{extensionData:i,duration:s,error:u,durationSinceUpdate:a}){const m=u?u instanceof C.ExtensionManagementError?u.code:C.ExtensionManagementErrorCode.Internal:void 0;o.publicLog(t,{...i,success:!u,duration:s,errorcode:m,durationSinceUpdate:a})}e.reportTelemetry=l;class n{constructor(){this.barrier=new r.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>new Promise((i,s)=>{const u=t.onCancellationRequested(()=>{u.dispose(),s(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(ne[76],re([0,1,18,6,32,16,9,35,126,2,23,12,4,19,55,86,15,7,147,14,33,44,69,13,5,8,25,3,66,49,20,31,175]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g,l,n,o,t,i,s,u,a,m,S,_,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var A;(function(j){function H(W,z){if(W===z)return!0;const K=Object.keys(W),X=new Set;for(const ce of Object.keys(z))X.add(ce);if(K.length!==X.size)return!1;for(const ce of K){if(W[ce]!==z[ce])return!1;X.delete(ce)}return X.size===0}j.equals=H})(A=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let U=class extends b.Disposable{constructor(H,W,z,K,X,ce,B,G,O,M,x){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=W,this.extensionsControlLocation=z,this.cacheLocation=K,this.userDataProfilesService=X,this.extensionsProfileScannerService=ce,this.fileService=B,this.logService=G,this.environmentService=O,this.productService=M,this.instantiationService=x,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(F,(0,v.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(F,(0,v.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(N,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(H,W,z){const[K,X]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(W)]),ce=z?await this.scanExtensionsUnderDevelopment(H,[...K,...X]):[];return this.dedupExtensions(K,X,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const W=[];W.push(this.scanDefaultSystemExtensions(!!H.useCache,H.language)),W.push(this.scanDevSystemExtensions(H.language,!!H.checkControlFile));const[z,K]=await Promise.all(W);return this.applyScanOptions([...z,...K],0,H,!1)}async scanUserExtensions(H){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(H.profileLocation??this.userExtensionsLocation,!!H.profileLocation,1,!H.includeUninstalled,H.language);let K=await(H.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return K=await this.applyScanOptions(K,1,H,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(H,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(K=>K.scheme===I.Schemas.file).map(async K=>{const X=await this.createExtensionScannerInput(K,!1,1,!0,H.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(X)).map(B=>(B.type=W.find(G=>(0,g.areSameExtensions)(G.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,X)))}))).flat();return this.applyScanOptions(z,"development",H,!0)}return[]}async scanExistingExtension(H,W,z){const K=await this.createExtensionScannerInput(H,!1,W,!0,z.language),X=await this.extensionsScanner.scanExtension(K);return!X||!z.includeInvalid&&!X.isValid?null:X}async scanOneOrMultipleExtensions(H,W,z){const K=await this.createExtensionScannerInput(H,!1,W,!0,z.language),X=await this.extensionsScanner.scanOneOrMultipleExtensions(K);return this.applyScanOptions(X,W,z,!0)}async scanMetadata(H){const W=(0,v.joinPath)(H,"package.json"),z=(await this.fileService.readFile(W)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(H,W){const z=(0,v.joinPath)(H,"package.json"),K=(await this.fileService.readFile(z)).value.toString(),X=JSON.parse(K);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,X.__metadata={...X.__metadata,...W},await this.fileService.writeFile((0,v.joinPath)(H,"package.json"),L.VSBuffer.fromString(JSON.stringify(X,null,"	")))}async applyScanOptions(H,W,z,K){return z.includeAllVersions||(H=this.dedupExtensions(W===0?H:void 0,W===1?H:void 0,W==="development"?H:void 0,await this.getTargetPlatform(),K)),z.includeInvalid||(H=H.filter(X=>X.isValid)),H.sort((X,ce)=>{const B=C.basename(X.location.fsPath),G=C.basename(ce.location.fsPath);return B<G?-1:B>G?1:0})}dedupExtensions(H,W,z,K,X){const ce=(G,O,M)=>{if(G.isValid&&!O.isValid)return!1;if(G.isValid===O.isValid){if(X&&h.gt(G.manifest.version,O.manifest.version))return this.logService.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(h.eq(G.manifest.version,O.manifest.version)){if(G.type===0)return this.logService.debug(`Skipping extension ${O.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===K)return this.logService.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${G.location.path} with ${O.location.path}.`):this.logService.debug(`Overwriting user extension ${G.location.path} with ${O.location.path}.`),!0},B=new Map;return H?.forEach(G=>{const O=l.ExtensionIdentifier.toKey(G.identifier.id),M=B.get(O);(!M||ce(M,G,!1))&&B.set(O,G)}),W?.forEach(G=>{const O=l.ExtensionIdentifier.toKey(G.identifier.id),M=B.get(O);if(!M&&H&&G.type===0){this.logService.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!M||ce(M,G,!1))&&B.set(O,G)}),z?.forEach(G=>{const O=l.ExtensionIdentifier.toKey(G.identifier.id),M=B.get(O);(!M||ce(M,G,!0))&&B.set(O,G),B.set(O,G)}),[...B.values()]}async scanDefaultSystemExtensions(H,W){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),X=await(H&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",X.length),X}async scanDevSystemExtensions(H,W){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const K=W?await this.getBuiltInExtensionControl():{},X=[],ce=d.URI.file(C.normalize(C.join(I.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const G of z){const O=K[G.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":X.push((0,v.joinPath)(ce,G.name));break;default:X.push(d.URI.file(O));break}}const B=await Promise.all(X.map(async G=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(G,!1,0,!0,H))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,D.coalesce)(B)}async getBuiltInExtensionControl(){try{const H=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(H.value.toString())}catch{return{}}}async createExtensionScannerInput(H,W,z,K,X,ce=!0){const B=await this.getTranslations(X??p.language),G=await this.getMtime(H),O=W?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=O?await this.getMtime(O):void 0;return new R(H,G,O,M,W,z,K,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,X,B)}async getMtime(H){try{const W=await this.fileService.stat(H);if(typeof W.mtime=="number")return W.mtime}catch{}}};U=pe([Y(4,S.IUserDataProfilesService),Y(5,m.IExtensionsProfileScannerService),Y(6,o.IFileService),Y(7,i.ILogService),Y(8,c.IEnvironmentService),Y(9,s.IProductService),Y(10,t.IInstantiationService)],U),e.AbstractExtensionsScannerService=U;class R{constructor(H,W,z,K,X,ce,B,G,O,M,x,V,ee,oe){this.location=H,this.mtime=W,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=K,this.profile=X,this.type=ce,this.excludeObsolete=B,this.validate=G,this.productVersion=O,this.productDate=M,this.productCommit=x,this.devMode=V,this.language=ee,this.translations=oe}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,W){return(0,v.isEqual)(H.location,W.location)&&H.mtime===W.mtime&&(0,v.isEqual)(H.applicationExtensionslocation,W.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&H.profile===W.profile&&H.type===W.type&&H.excludeObsolete===W.excludeObsolete&&H.validate===W.validate&&H.productVersion===W.productVersion&&H.productDate===W.productDate&&H.productCommit===W.productCommit&&H.devMode===W.devMode&&H.language===W.language&&A.equals(H.translations,W.translations)}}let N=class extends b.Disposable{constructor(H,W,z,K,X){super(),this.obsoleteFile=H,this.extensionsProfileScannerService=W,this.uriIdentityService=z,this.fileService=K,this.logService=X}async scanExtensions(H){const W=H.profile?await this.scanExtensionsFromProfile(H):await this.scanExtensionsFromLocation(H);let z={};if(H.excludeObsolete&&H.type===1)try{const K=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(K)}catch{}return(0,w.isEmptyObject)(z)?W:W.filter(K=>!z[g.ExtensionKey.create(K).toString()])}async scanExtensionsFromLocation(H){const W=await this.fileService.resolve(H.location);if(!W.children?.length)return[];const z=await Promise.all(W.children.map(async K=>{if(!K.isDirectory||H.type===1&&(0,v.basename)(K.resource).indexOf(".")===0)return null;const X=new R(K.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(X)}));return(0,D.coalesce)(z).sort((K,X)=>K.location.path<X.location.path?-1:1)}async scanExtensionsFromProfile(H){let W=await this.scanExtensionsFromProfileResource(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(H.location,H.applicationExtensionslocation)){W=W.filter(K=>!K.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(H.applicationExtensionslocation,K=>!!K.metadata?.isApplicationScoped,H);W.push(...z)}return W}async scanExtensionsFromProfileResource(H,W,z){const K=await this.extensionsProfileScannerService.scanProfileExtensions(H);if(!K.length)return[];const X=await Promise.all(K.map(async ce=>{if(W(ce)){const B=new R(ce.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(B,ce.metadata)}return null}));return(0,D.coalesce)(X)}async scanOneOrMultipleExtensions(H){try{if(await this.fileService.exists((0,v.joinPath)(H.location,"package.json"))){const W=await this.scanExtension(H);return W?[W]:[]}else return await this.scanExtensions(H)}catch(W){return this.logService.error(`Error scanning extensions at ${H.location.path}:`,(0,T.getErrorMessage)(W)),[]}}async scanExtension(H,W){try{let z=await this.scanExtensionManifest(H.location);if(z){z.publisher||(z.publisher=l.UNDEFINED_PUBLISHER),W=W??z.__metadata,delete z.__metadata;const K=(0,g.getGalleryExtensionId)(z.publisher,z.name),X=W?.id?{id:K,uuid:W.id}:{id:K},ce=W?.isSystem?0:H.type,B=ce===0||!!W?.isBuiltin;z=await this.translateManifest(H.location,z,R.createNlsConfiguration(H));const G={type:ce,identifier:X,manifest:z,location:H.location,isBuiltin:B,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return H.validate?this.validate(G,H):G}}catch(z){H.type!==0&&this.logService.error(z)}return null}validate(H,W){let z=!0;const K=(0,n.validateExtensionManifest)(W.productVersion,W.productDate,W.location,H.manifest,H.isBuiltin);for(const[X,ce]of K)X===y.default.Error&&(z=!1,this.logService.error(this.formatMessage(W.location,ce)));return H.isValid=z,H.validations=K,H}async scanExtensionManifest(H){const W=(0,v.joinPath)(H,"package.json");let z;try{z=(await this.fileService.readFile(W)).value.toString()}catch(X){return(0,o.toFileOperationResult)(X)!==1&&this.logService.error(this.formatMessage(H,(0,f.localize)(0,null,W.path,X.message))),null}let K;try{K=JSON.parse(z)}catch{const ce=[];(0,P.parse)(z,ce);for(const B of ce)this.logService.error(this.formatMessage(H,(0,f.localize)(1,null,W.path,B.offset,B.length,(0,E.getParseErrorMessage)(B.error))));return null}return(0,P.getNodeType)(K)!=="object"?(this.logService.error(this.formatMessage(H,(0,f.localize)(2,null,W.path))),null):K}async translateManifest(H,W,z){const K=await this.getLocalizedMessages(H,W,z);if(K)try{const X=[],ce=await this.resolveOriginalMessageBundle(K.default,X);if(X.length>0)return X.forEach(G=>{this.logService.error(this.formatMessage(H,(0,f.localize)(3,null,K.default?.path,(0,E.getParseErrorMessage)(G.error))))}),W;if((0,P.getNodeType)(K)!=="object")return this.logService.error(this.formatMessage(H,(0,f.localize)(4,null,K.default?.path))),W;const B=K.values||Object.create(null);return(0,$.localizeManifest)(W,B,ce)}catch{}return W}async getLocalizedMessages(H,W,z){const K=(0,v.joinPath)(H,"package.nls.json"),X=(O,M)=>{M.forEach(x=>{this.logService.error(this.formatMessage(H,(0,f.localize)(5,null,O?.path,(0,E.getParseErrorMessage)(x.error))))})},ce=O=>{this.logService.error(this.formatMessage(H,(0,f.localize)(6,null,O?.path)))},B=`${W.publisher}.${W.name}`,G=z.translations[B];if(G)try{const O=d.URI.file(G),M=(await this.fileService.readFile(O)).value.toString(),x=[],V=(0,P.parse)(M,x);return x.length>0?(X(O,x),{values:void 0,default:K}):(0,P.getNodeType)(V)!=="object"?(ce(O),{values:void 0,default:K}):{values:V.contents?V.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.fileService.exists(K))return;let M;try{M=await this.findMessageBundles(H,z)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const x=(await this.fileService.readFile(M.localized)).value.toString(),V=[],ee=(0,P.parse)(x,V);return V.length>0?(X(M.localized,V),{values:void 0,default:M.original}):(0,P.getNodeType)(ee)!=="object"?(ce(M.localized),{values:void 0,default:M.original}):{values:ee,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(H,W){if(H)try{const z=(await this.fileService.readFile(H)).value.toString();return(0,P.parse)(z,W)}catch{}}findMessageBundles(H,W){return new Promise((z,K)=>{const X=ce=>{const B=(0,v.joinPath)(H,`package.nls.${ce}.json`);this.fileService.exists(B).then(G=>{G&&z({localized:B,original:(0,v.joinPath)(H,"package.nls.json")});const O=ce.lastIndexOf("-");O===-1?z({localized:(0,v.joinPath)(H,"package.nls.json"),original:null}):(ce=ce.substring(0,O),X(ce))})};if(W.devMode||W.pseudo||!W.language)return z({localized:(0,v.joinPath)(H,"package.nls.json"),original:null});X(W.language)})}formatMessage(H,W){return`[${H.path}]: ${W}`}};N=pe([Y(1,m.IExtensionsProfileScannerService),Y(2,_.IUriIdentityService),Y(3,o.IFileService),Y(4,i.ILogService)],N);let F=class extends N{constructor(H,W,z,K,X,ce){super(W,z,K,X,ce),this.cacheFile=H,this.cacheValidatorThrottler=this._register(new r.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(H){const W=await this.readExtensionCache();if(this.input=H,W&&W.input&&R.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(K=>(K.location=d.URI.revive(K.location),K));const z=await super.scanExtensions(H);return await this.writeExtensionCache({input:H,result:z}),z}async readExtensionCache(){try{const H=await this.fileService.readFile(this.cacheFile),W=JSON.parse(H.value.toString());return{result:W.result,input:(0,a.revive)(W.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(H))}return null}async writeExtensionCache(H){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(H)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const H=await this.readExtensionCache();if(!H)return;const W=H.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(z,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(K){this.logService.error(K)}}};F=pe([Y(2,m.IExtensionsProfileScannerService),Y(3,_.IUriIdentityService),Y(4,o.IFileService),Y(5,i.ILogService)],F);function q(j,H){const W=(0,g.getExtensionId)(j.manifest.publisher,j.manifest.name);return{id:W,identifier:new l.ExtensionIdentifier(W),isBuiltin:j.type===0,isUserBuiltin:j.type===1&&j.isBuiltin,isUnderDevelopment:H,extensionLocation:j.location,uuid:j.identifier.uuid,targetPlatform:j.targetPlatform,...j.manifest}}e.toExtensionDescription=q;class J extends U{constructor(H,W,z,K,X,ce,B,G,O,M,x){super(H,W,(0,v.joinPath)(z,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(K,l.MANIFEST_CACHE_FOLDER),X,ce,B,G,O,M,x),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const V=await this.fileService.readFile(d.URI.file(p.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations(H){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(ne[249],re([0,1,54,6,38,3,2,23,12,28,8,20]),function(Q,e,D,r,k,L,T,P,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends T.Disposable{constructor(h,y){super(),this.userDataProfilesService=h,this.logService=y,this.processesLimiter=new r.Limiter(5)}async postUninstall(h){const y=this.parseScript(h,"uninstall");return y&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${w}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(h,y){const w=`vscode:${y}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[w]=="string"){const d=h.manifest.scripts[w].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${w} should be a node script`),null):{script:(0,E.join)(h.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(h,y,w,d,f){return new Promise((c,g)=>{const l=this.start(h,y,w,f);let n;const o=t=>{n&&(clearTimeout(n),n=null),t?g(t):c(void 0)};l.on("error",t=>{o((0,k.toErrorMessage)(t)||"Unknown")}),l.on("exit",(t,i)=>{o(t?`post-${y} process exited with code ${t}`:void 0)}),d&&(n=setTimeout(()=>{n=null,l.kill(),g("timed out")},5e3))})}start(h,y,w,d){const f={silent:!0,execArgv:void 0},c=(0,D.fork)(h,[`--type=extension-post-${y}`,...w],f);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const g=L.Event.fromNodeEventEmitter(c.stdout,"data"),l=L.Event.fromNodeEventEmitter(c.stderr,"data");g(t=>this.logService.info(d.identifier.id,d.manifest.version,`post-${y}`,t)),l(t=>this.logService.error(d.identifier.id,d.manifest.version,`post-${y}`,t));const n=L.Event.any(L.Event.map(g,t=>({data:`%c${t}`,format:[""]})),L.Event.map(l,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(d.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),c}getExtensionStoragePath(h){return(0,E.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};p=pe([Y(0,C.IUserDataProfilesService),Y(1,I.ILogService)],p),e.ExtensionsLifecycle=p}),define(ne[250],re([0,1,7,14,49,76,13,5,8,25,20]),function(Q,e,D,r,k,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let C=class extends L.NativeExtensionsScannerService{constructor(v,h,y,w,d,f,c){super(D.URI.file(d.builtinExtensionsPath),D.URI.file(d.extensionsPath),d.userHome,D.URI.file(d.userDataPath),v,h,y,w,d,f,c)}};C=pe([Y(0,I.IUserDataProfilesService),Y(1,k.IExtensionsProfileScannerService),Y(2,T.IFileService),Y(3,E.ILogService),Y(4,r.INativeEnvironmentService),Y(5,b.IProductService),Y(6,P.IInstantiationService)],C),e.ExtensionsScannerService=C}),define(ne[21],re([0,1,6,3,2,193,15,68,5,20]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,E.createDecorator)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var p;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function v(f){const c=f.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=v;class h extends k.Disposable{constructor(c={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new r.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,g){if(g===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:g,target:this.getKeyTargets(c)[g]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,g,l){return this.getStorage(g)?.get(c,l)}getBoolean(c,g,l){return this.getStorage(g)?.getBoolean(c,l)}getNumber(c,g,l){return this.getStorage(g)?.getNumber(c,l)}store(c,g,l,n){if((0,T.isUndefinedOrNull)(g)){this.remove(c,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,l,n),this.getStorage(l)?.set(c,g)})}remove(c,g){this.withPausedEmitters(()=>{this.updateKeyTarget(c,g,void 0),this.getStorage(g)?.delete(c)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,g){const l=[],n=this.getKeyTargets(c);for(const o of Object.keys(n))n[o]===g&&l.push(o);return l}updateKeyTarget(c,g,l){const n=this.getKeyTargets(g);typeof l=="number"?n[c]!==l&&(n[c]=l,this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[c]=="number"&&(delete n[c],this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const g=this.getStorage(c);return g?v(g):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=I.NONE){this._onWillSaveState.fire({reason:c});const g=this.getStorage(-1),l=this.getStorage(0),n=this.getStorage(1);switch(c){case I.NONE:await D.Promises.settled([g?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([g?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return d(c,g,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(c,g){return this.emitWillSaveState(I.NONE),(0,b.isUserDataProfile)(c)?this.switchToProfile(c,g):this.switchToWorkspace(c,g)}canSwitchProfile(c,g){return!(c.id===g.id||y(g)&&y(c))}switchData(c,g,l,n){this.withPausedEmitters(()=>{if(n)for(const[o,t]of c)g.set(o,t);else{const o=new Set;for(const[t,i]of c)o.add(t),g.get(t)!==i&&this.emitDidChangeValue(l,t);for(const[t]of g.items)o.has(t)||this.emitDidChangeValue(l,t)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function y(f){return f.isDefault||!!f.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class w extends h{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(c){return!1}}e.InMemoryStorageService=w;async function d(f,c,g,l,n,o){const t=A=>{try{return JSON.parse(A)}catch{return A}},i=new Map,s=new Map;f.forEach((A,U)=>{i.set(U,A),s.set(U,t(A))});const u=new Map,a=new Map;c.forEach((A,U)=>{u.set(U,A),a.set(U,t(A))});const m=new Map,S=new Map;g.forEach((A,U)=>{m.set(U,A),S.set(U,t(A))}),console.group(l!==n?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const _=[];if(i.forEach((A,U)=>{_.push({key:U,value:A})}),console.table(_),console.groupEnd(),console.log(s),l!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const A=[];u.forEach((U,R)=>{A.push({key:R,value:U})}),console.table(A),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const $=[];m.forEach((A,U)=>{$.push({key:U,value:A})}),console.table($),console.groupEnd(),console.log(S)}e.logStorage=d}),define(ne[113],re([0,1,3,2,15,29,33,21]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends r.Disposable{constructor(C,p){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(C)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"}))),this._register(p.onDidInstallExtensions(v=>v.forEach(({local:h,operation:y})=>{h&&y===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(C,p){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:p}),!0):!1}async disableExtension(C,p){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){const p=this.getDisabledExtensions();return p.every(v=>!(0,T.areSameExtensions)(v,C))?(p.push(C),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(C){const p=this.getDisabledExtensions();for(let v=0;v<p.length;v++){const h=p[v];if((0,T.areSameExtensions)(h,C))return p.splice(v,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(C){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,p){this.storageManger.set(C,p,0)}};E=pe([Y(0,P.IStorageService),Y(1,L.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class b extends r.Disposable{constructor(C){super(),this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(C,p){let v;return p===0?((0,k.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,p)),v=this.storage[C]):v=this._get(C,p),JSON.parse(v)}set(C,p,v){const h=JSON.stringify(p.map(({id:w,uuid:d})=>({id:w,uuid:d})));this._get(C,v)!==h&&(v===0&&(p.length?this.storage[C]=h:delete this.storage[C]),this._set(C,p.length?h:void 0,v))}onDidStorageChange(C){if(C.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const v=this.get(C.key,C.scope);delete this.storage[C.key];const h=this.get(C.key,C.scope),y=v.filter(d=>!h.some(f=>(0,T.areSameExtensions)(d,f))),w=h.filter(d=>!v.some(f=>(0,T.areSameExtensions)(f,d)));(y.length||w.length)&&this._onDidChange.fire([...y,...w])}}_get(C,p){return this.storageService.get(C,p,"[]")}_set(C,p,v){p?this.storageService.store(C,p,v,1):this.storageService.remove(C,v)}}e.StorageManager=b}),define(ne[251],re([0,1,18,22,9,4,37,15,7,17,14,29,33,69,13,8,25,45,221,21,24]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=L.isWeb?"web":(0,C.getTargetPlatform)(L.platform,T.arch);var n;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function o(...O){return String(O.reduce((M,x)=>M|x,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class m{constructor(M=a){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(M,x=this.state.pageSize){return new m({...this.state,pageNumber:M,pageSize:x})}withFilter(M,...x){const V=[...this.state.criteria,...x.length?x.map(ee=>({filterType:M,value:ee})):[{filterType:M}]];return new m({...this.state,criteria:V})}withSortBy(M){return new m({...this.state,sortBy:M})}withSortOrder(M){return new m({...this.state,sortOrder:M})}withFlags(...M){return new m({...this.state,flags:M.reduce((x,V)=>x|V,0)})}withAssetTypes(...M){return new m({...this.state,assetTypes:M})}withSource(M){return new m({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:x,pageSize:V,sortBy:ee,sortOrder:oe,flags:Z,assetTypes:ie}=this.state;return{filters:[{criteria:M,pageNumber:x,pageSize:V,sortBy:ee,sortOrder:oe}],assetTypes:ie,flags:Z}}get searchText(){const M=this.state.criteria.filter(x=>x.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function S(O,M){const x=(O||[]).filter(V=>V.statisticName===M)[0];return x?x.value:0}function _(O){const M="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(V=>V.assetType.indexOf(M)===0).reduce((V,ee)=>{const oe=U(O,ee.assetType);return oe&&V.push([ee.assetType.substring(M.length),oe]),V},[])}function $(O){if(O.properties){const M=O.properties.filter(ee=>ee.key===i.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=M.filter(ee=>x.test(ee.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return U(O,i.Repository)}function A(O){return{uri:`${O.fallbackAssetUri}/${i.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${i.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function U(O,M){return O.files.filter(V=>V.assetType===M)[0]?{uri:`${O.assetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function R(O,M){const x=O.properties?O.properties.filter(ee=>ee.key===M):[],V=x.length>0&&x[0].value;return V?V.split(",").map(ee=>(0,p.adoptToGalleryExtensionId)(ee)):[]}function N(O){const M=O.properties?O.properties.filter(x=>x.key===s.Engine):[];return M.length>0&&M[0].value||""}function F(O){const M=O.properties?O.properties.filter(x=>x.key===s.PreRelease):[];return M.length>0&&M[0].value==="true"}function q(O){const M=O.properties?O.properties.filter(V=>V.key===s.LocalizedLanguages):[],x=M.length>0&&M[0].value||"";return x?x.split(","):[]}function J(O){return O.properties?.find(M=>M.key===s.SponsorLink)?.value}function j(O){return O.indexOf("preview")!==-1}function H(O){return O.targetPlatform?(0,C.toTargetPlatform)(O.targetPlatform):"undefined"}function W(O){const M=(0,D.distinct)(O.versions.map(H)),x=!!O.tags?.includes(C.WEB_EXTENSION_TAG),V=M.indexOf("web");return x?V===-1&&M.push("web"):V!==-1&&M.splice(V,1),M}function z(O,M){const x=(0,C.getFallbackTargetPlarforms)(M);for(let V=0;V<O.length;V++){const ee=O[V];if(ee.version===O[V-1]?.version){let oe=V;const Z=H(ee);if(Z===M)for(;oe>0&&O[oe-1].version===ee.version;)oe--;else if(x.includes(Z))for(;oe>0&&O[oe-1].version===ee.version&&H(O[oe-1])!==M;)oe--;oe!==V&&(O.splice(V,1),O.splice(oe,0,ee))}}return O}e.sortExtensionVersions=z;function K(O,M,x){O.telemetryData={index:M,querySource:x}}function X(O,M,x){const V=O.versions[0],ee={manifest:U(M,i.Manifest),readme:U(M,i.Details),changelog:U(M,i.Changelog),license:U(M,i.License),repository:$(M),download:A(M),icon:U(M,i.Icon),coreTranslations:_(M)};return{identifier:{id:(0,p.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:M.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(V),description:O.shortDescription||"",installCount:S(O.statistics,"install"),rating:S(O.statistics,"averagerating"),ratingCount:S(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:x,assets:ee,properties:{dependencies:R(M,s.Dependency),extensionPack:R(M,s.ExtensionPack),engine:N(M),localizedLanguages:q(M),targetPlatform:H(M),isPreReleaseVersion:F(M)},hasPreReleaseVersion:F(V),hasReleaseVersion:!0,preview:j(O.flags)}}let ce=class{constructor(M,x,V,ee,oe,Z,ie,se){this.requestService=x,this.logService=V,this.environmentService=ee,this.telemetryService=oe,this.fileService=Z,this.productService=ie,this.configurationService=se;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue?.serviceUrl,this.extensionsGallerySearchUrl=ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,f.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,x,V){const ee=r.CancellationToken.isCancellationToken(x)?{}:x,oe=r.CancellationToken.isCancellationToken(x)?x:V,Z=[],ie=[],se=[],ue=[];let de=!0;for(const Ee of M){Ee.uuid?ie.push(Ee.uuid):Z.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),de=de&&!!Ee.hasPreRelease&&!Ce}if(!ie.length&&!Z.length)return[];let ve=new m().withPage(1,M.length);ie.length&&(ve=ve.withFilter(t.ExtensionId,...ie)),Z.length&&(ve=ve.withFilter(t.ExtensionName,...Z)),(ee.queryAllVersions||de)&&(ve=ve.withFlags(ve.flags,n.IncludeVersions)),ee.source&&(ve=ve.withSource(ee.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:ee.targetPlatform??l,includePreRelease:se,versions:ue,compatible:!!ee.compatible},oe);return ee.source&&we.forEach((Ee,Ce)=>K(Ee,Ce,ee.source)),we}async getCompatibleExtension(M,x,V){if((0,C.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(M,x,V))return M;const ee=new m().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(ee,{targetPlatform:V,compatible:!0,includePreRelease:x},r.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(M,x,V){if(!(0,C.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,V)||!x&&M.properties.isPreReleaseVersion)return!1;let ee=M.properties.engine;if(!ee){const oe=await this.getManifest(M,r.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");ee=oe.engines.vscode}return(0,v.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(M,x,V,ee,oe){if(!(0,C.isTargetPlatformCompatible)(H(M),ee,oe)||x!=="any"&&F(M)!==(x==="prerelease"))return!1;if(V)try{const Z=await this.getEngine(M);if(!(0,v.isEngineValid)(Z,this.productService.version,this.productService.date))return!1}catch(Z){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,k.getErrorMessage)(Z)),!1}return!0}async query(M,x){let V=M.text||"";const ee=M.pageSize??50;let oe=new m().withPage(1,ee);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(oe=oe.withFilter(t.Category,we||ve),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(oe=oe.withFilter(t.Tag,we||ve),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),oe=oe.withFilter(t.SearchText,V)),oe=oe.withSortBy(0)):M.ids?oe=oe.withFilter(t.ExtensionId,...M.ids):M.names?oe=oe.withFilter(t.ExtensionName,...M.names):oe=oe.withSortBy(4),typeof M.sortBy=="number"&&(oe=oe.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(oe=oe.withSortOrder(M.sortOrder)),M.source&&(oe=oe.withSource(M.source));const Z=async(de,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(de,{targetPlatform:l,compatible:!1,includePreRelease:!!M.includePreRelease},ve);return we.forEach((Ce,Ue)=>K(Ce,(de.pageNumber-1)*de.pageSize+Ue,M.source)),{extensions:we,total:Ee}},{extensions:ie,total:se}=await Z(oe,x),ue=async(de,ve)=>{if(ve.isCancellationRequested)throw new k.CancellationError;const{extensions:we}=await Z(oe.withPage(de+1),ve);return we};return{firstPage:ie,total:se,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(M,x,V){const ee=M.flags;!!(M.flags&n.IncludeLatestVersionOnly)&&!!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(M.flags&n.IncludeLatestVersionOnly)&&!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags,n.IncludeLatestVersionOnly)),x.versions?.length&&(M=M.withFlags(M.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),M=M.withFlags(M.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:oe,total:Z}=await this.queryRawGalleryExtensions(M,V);if(!(M.flags&n.IncludeLatestVersionOnly)){const de=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,x);we&&de.push(we)}return{extensions:de,total:Z}}const se=[],ue=new Map;for(let de=0;de<oe.length;de++){const ve=oe[de],we={id:(0,p.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Ue=>(0,p.areSameExtensions)(Ue,we))?.includePreRelease;if(x.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(W(ve),x.targetPlatform))continue;const Ce=await this.toGalleryExtensionWithCriteria(ve,x);!Ce||Ce.properties.isPreReleaseVersion&&(!Ee||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==x.targetPlatform&&Ce.hasPreReleaseVersion?ue.set(ve.extensionId,de):se.push([de,Ce])}if(ue.size){const de=new Date().getTime(),ve=new m().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,x,V);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:ue.size});for(const Ee of we){const Ce=ue.get(Ee.identifier.uuid);se.push([Ce,Ee])}}return{extensions:se.sort((de,ve)=>de[0]-ve[0]).map(([,de])=>de),total:Z}}async toGalleryExtensionWithCriteria(M,x){const V={id:(0,p.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},ee=x.versions?.find(se=>(0,p.areSameExtensions)(se,V))?.version,oe=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(se=>(0,p.areSameExtensions)(se,V))?.includePreRelease,Z=W(M),ie=z(M.versions,x.targetPlatform);if(x.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(Z,x.targetPlatform))return null;for(let se=0;se<ie.length;se++){const ue=ie[se];if(!(ee&&ue.version!==ee)){if(await this.isValidVersion(ue,oe?"any":"release",x.compatible,Z,x.targetPlatform))return X(M,ue,Z);if(ee&&ue.version===ee)return null}}return ee||x.compatible?null:X(M,M.versions[0],Z)}async queryRawGalleryExtensions(M,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,o(n.Unpublished));const V=await this.commonHeadersPromise,ee=JSON.stringify(M.raw),oe={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new Date().getTime();let ie,se,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&M.criteria.some(ve=>ve.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ee,headers:oe},x),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,d.asJson)(ie);if(de){const ve=de.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(de){throw se=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-Z,success:!!ie&&(0,d.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:se?(0,k.isCancellationError)(se)?"canceled":(0,k.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(M,x,V,ee){if(!this.isEnabled())return;const oe=L.isWeb?this.api(`/itemName/${M}.${x}/version/${V}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${x}/${V}/stats?statType=${ee}`),Z=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:Z};try{await this.requestService.request({type:"POST",url:oe,headers:se},r.CancellationToken.None)}catch{}}async download(M,x,V){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const ee=(0,p.getGalleryExtensionTelemetryData)(M),oe=new Date().getTime(),Z=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:de}),ie=V===2?"install":V===3?"update":"",se=ie?{uri:`${M.assets.download.uri}${E.URI.parse(M.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${M.assets.download.fallbackUri}${E.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:M.assets.download,ue=await this.getAsset(se);await this.fileService.writeFile(x,ue.stream),Z(new Date().getTime()-oe)}async getReadme(M,x){if(M.assets.readme){const V=await this.getAsset(M.assets.readme,{},x);return await(0,d.asTextOrError)(V)||""}return""}async getManifest(M,x){if(M.assets.manifest){const V=await this.getAsset(M.assets.manifest,{},x),ee=await(0,d.asTextOrError)(V);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(M,x){const V=U(M,i.Manifest);if(!V)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},oe=await this.getAsset(V,{headers:ee});return await(0,d.asJson)(oe)}async getCoreTranslation(M,x){const V=M.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(V){const ee=await this.getAsset(V[1]),oe=await(0,d.asTextOrError)(ee);return oe?JSON.parse(oe):null}return null}async getChangelog(M,x){if(M.assets.changelog){const V=await this.getAsset(M.assets.changelog,{},x);return await(0,d.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(M,x,V){let ee=new m().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?ee=ee.withFilter(t.ExtensionId,M.identifier.uuid):ee=ee.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(ee,r.CancellationToken.None);if(!oe.length)return[];const Z=W(oe[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(Z,V))return[];const ie=[];await Promise.all(oe[0].versions.map(async de=>{try{await this.isValidVersion(de,x?"any":"release",!0,Z,V)&&ie.push(de)}catch{}}));const se=[],ue=new Set;for(const de of z(ie,V))ue.has(de.version)||(ue.add(de.version),se.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:F(de)}));return se}async getAsset(M,x={},V=r.CancellationToken.None){const ee=await this.commonHeadersPromise,oe={type:"GET"},Z={...ee,...x.headers||{}};x={...x,...oe,headers:Z};const ie=M.uri,se=M.fallbackUri,ue={...x,url:ie};try{const de=await this.requestService.request(ue,V);if(de.res.statusCode===200)return de;const ve=await(0,d.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ve}`)}catch(de){if((0,k.isCancellationError)(de))throw de;const ve=(0,k.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...x,url:se};return this.requestService.request(we,V)}}async getEngine(M){let x=N(M);if(!x){const V=await this.getManifestFromRawExtensionVersion(M,r.CancellationToken.None);if(!V)throw new Error("Manifest was not found");x=V.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,d.asJson)(M),V=[],ee={};if(x){for(const oe of x.malicious)V.push({id:oe});if(x.migrateToPreRelease)for(const[oe,Z]of Object.entries(x.migrateToPreRelease))(!Z.engine||(0,v.isEngineValid)(Z.engine,this.productService.version,this.productService.date))&&(ee[oe.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[oe,Z]of Object.entries(x.deprecated))Z&&(ee[oe.toLowerCase()]=(0,P.isBoolean)(Z)?{}:Z)}return{malicious:V,deprecated:ee}}};ce=pe([Y(1,d.IRequestService),Y(2,y.ILogService),Y(3,I.IEnvironmentService),Y(4,g.ITelemetryService),Y(5,h.IFileService),Y(6,w.IProductService),Y(7,b.IConfigurationService)],ce);let B=class extends ce{constructor(M,x,V,ee,oe,Z,ie,se){super(M,x,V,ee,oe,Z,ie,se)}};B=pe([Y(0,c.IStorageService),Y(1,d.IRequestService),Y(2,y.ILogService),Y(3,I.IEnvironmentService),Y(4,g.ITelemetryService),Y(5,h.IFileService),Y(6,w.IProductService),Y(7,b.IConfigurationService)],B),e.ExtensionGalleryService=B;let G=class extends ce{constructor(M,x,V,ee,oe,Z,ie){super(void 0,M,x,V,ee,oe,Z,ie)}};G=pe([Y(0,d.IRequestService),Y(1,y.ILogService),Y(2,I.IEnvironmentService),Y(3,g.ITelemetryService),Y(4,h.IFileService),Y(5,w.IProductService),Y(6,b.IConfigurationService)],G),e.ExtensionGalleryServiceWithNoStorageService=G}),define(ne[77],re([0,1,5,3,2,21,33,25,18,8,15]),function(Q,e,D,r,k,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Xe extends k.Disposable{static toKey(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const y=C.exec(h);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(h,y){const w=await h.getInstalled(),d=[];for(const[f,c]of Xe.readAllExtensionsWithKeysForSync(y)){const g=w.find(l=>(0,T.areSameExtensions)(l.identifier,{id:f}))?.manifest.version;for(const l of c)g!==l&&d.push(Xe.toKey({id:f,version:l}))}for(const f of d)y.remove(f,0)}static readAllExtensionsWithKeysForSync(h){const y=new Map,w=h.keys(0,1);for(const d of w){const f=Xe.fromKey(d);if(f){let c=y.get(f.id.toLowerCase());c||y.set(f.id.toLowerCase(),c=[]),c.push(f.version)}}return y}constructor(h,y,w){super(),this.storageService=h,this.productService=y,this.logService=w,this._onDidChangeExtensionStorageToSync=this._register(new r.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Xe.readAllExtensionsWithKeysForSync(h),this._register(this.storageService.onDidChangeValue(d=>this.onDidChangeStorageValue(d)))}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const y=Xe.fromKey(h.key);if(y){if(this.storageService.get(h.key,0)===void 0)this.extensionsWithKeysForSync.delete(y.id.toLowerCase());else{let w=this.extensionsWithKeysForSync.get(y.id.toLowerCase());w||this.extensionsWithKeysForSync.set(y.id.toLowerCase(),w=[]),w.push(y.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(h){if((0,I.isString)(h))return h;const y=h.manifest?h.manifest.publisher:h.publisher,w=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(y,w)}getExtensionState(h,y){const w=this.getExtensionId(h),d=this.storageService.get(w,y?0:1);if(d)try{return JSON.parse(d)}catch(f){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${y}): ${f}`)}}setExtensionState(h,y,w){const d=this.getExtensionId(h);y===void 0?this.storageService.remove(d,w?0:1):this.storageService.store(d,JSON.stringify(y),w?0:1,1)}setKeysForSync(h,y){this.storageService.store(Xe.toKey(h),JSON.stringify(y),0,1)}getKeysForSync(h){const y=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],w=this.storageService.get(Xe.toKey(h),0),d=w?JSON.parse(w):void 0;return d&&y?(0,E.distinct)([...d,...y]):d||y}addToMigrationList(h,y){if(h!==y){const w=this.migrationList.filter(d=>!d.includes(h)&&!d.includes(y));w.push([h,y]),this.migrationList=w}}getSourceExtensionToMigrate(h){const y=this.migrationList.find(([,w])=>h===w);return y?y[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(h);if(Array.isArray(y))return y}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=pe([Y(0,L.IStorageService),Y(1,P.IProductService),Y(2,b.ILogService)],p),e.ExtensionStorageService=p}),define(ne[252],re([0,1,18,6,3,12,4,37,7,148,14,29,33,212,96,13,8,59,25,45,21,24]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",o="extensionTips/lastPromptedMediumImpExeTime";let t=class extends v.ExtensionTipsService{constructor(s,u,a,m,S,_,$,A,U,R){super($,A,U,R),this.environmentService=s,this.telemetryService=u,this.extensionManagementService=a,this.storageService=m,this.nativeHostService=S,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,A.exeBasedExtensionTips&&Object.entries(A.exeBasedExtensionTips).forEach(([N,F])=>{const q=[],J=[],j=[];Object.entries(F.recommendations).forEach(([H,W])=>{W.important?F.important?q.push({extensionId:H,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):J.push({extensionId:H,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):j.push({extensionId:H,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),q.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:q}),J.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:J}),j.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:j})}),(0,r.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...u]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(u,a)}groupImportantTipsByExe(s,u){const a=new Map;s.forEach(A=>a.set(A.extensionId.toLowerCase(),A));const{installed:m,uninstalled:S}=this.groupByInstalled([...a.keys()],u);for(const A of m){const U=a.get(A);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:A,exeName:U.exeName})}for(const A of S){const U=a.get(A);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:A,exeName:U.exeName})}const _=this.getPromptedExecutableTips(),$=new Map;for(const A of S){const U=a.get(A);if(U&&(!_[U.exeName]||!_[U.exeName].includes(U.extensionId))){let R=$.get(U.exeName);R||(R=[],$.set(U.exeName,R)),R.push(U)}}return $}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,u]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(u).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(u[0].exeName,u);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const m=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(m(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const m=this._register((0,r.disposableTimeout)(()=>{m.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),u=Date.now()-s,a=7*24*60*60*1e3;if(u<a){const _=this._register((0,r.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},a-u));return}const[m,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(m),this.addToRecommendedExecutables(S[0].exeName,S);const $=this._register((0,r.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(m),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const $=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register($(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const $=this._register((0,r.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(s){const u=await this.extensionManagementService.getInstalled(1),a=s.filter(S=>!S.whenNotInstalled||S.whenNotInstalled.every(_=>u.every($=>!(0,p.areSameExtensions)($.identifier,{id:_})))).map(({extensionId:S})=>S.toLowerCase()),m=(0,b.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,m,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(o,-1);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(o,s,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,-1,"{}"))}addToRecommendedExecutables(s,u){const a=this.getPromptedExecutableTips();a[s]=u.map(({extensionId:m})=>m.toLowerCase()),this.storageService.store(n,JSON.stringify(a),-1,0)}groupByInstalled(s,u){const a=[],m=[],S=u.reduce((_,$)=>(_.add($.identifier.id.toLowerCase()),_),new Set);return s.forEach(_=>{S.has(_.toLowerCase())?a.push(_):m.push(_)}),{installed:a,uninstalled:m}}async getValidExecutableBasedExtensionTips(s){const u=[],a=new Map;for(const m of s.keys()){const S=s.get(m);if(!S||!(0,D.isNonEmptyArray)(S.recommendations))continue;const _=[];T.isWindows?S.windowsPath&&_.push(S.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(_.push((0,L.join)("/usr/local/bin",m)),_.push((0,L.join)("/usr/bin",m)),_.push((0,L.join)(this.environmentService.userHome.fsPath,m)));for(const $ of _){let A=a.get($);if(A===void 0&&(A=await this.fileService.exists(E.URI.file($)),a.set($,A)),A)for(const{extensionId:U,extensionName:R,isExtensionPack:N,whenNotInstalled:F}of S.recommendations)u.push({extensionId:U,extensionName:R,isExtensionPack:N,exeName:m,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath,whenNotInstalled:F})}}return u}};t=pe([Y(0,I.INativeEnvironmentService),Y(1,l.ITelemetryService),Y(2,C.IExtensionManagementService),Y(3,g.IStorageService),Y(4,d.INativeHostService),Y(5,h.IExtensionRecommendationNotificationService),Y(6,y.IFileService),Y(7,f.IProductService),Y(8,c.IRequestService),Y(9,w.ILogService)],t),e.ExtensionTipsService=t}),define(ne[253],re([0,1,6,2,19,68,21,73,20]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends T.AbstractStorageService{constructor(C,p,v,h){super(),this.initialWorkspace=C,this.initialProfiles=p,this.mainProcessService=v,this.environmentService=h,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new r.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new r.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const C=this._register(new P.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),p=this._register(new L.Storage(C));return this._register(p.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),p}createProfileStorage(C){this.profileStorageDisposables.clear(),this.profileStorageProfile=C;let p;if((0,T.isProfileUsingDefaultStorage)(C))p=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),C));p=this.profileStorageDisposables.add(new L.Storage(v))}return this.profileStorageDisposables.add(p.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),p}createWorkspaceStorage(C){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=C?.id;let p;if(C){const v=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),C));p=this.workspaceStorageDisposables.add(new L.Storage(v)),this.workspaceStorageDisposables.add(p.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)))}return p}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(C){switch(C){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(C,p){if(!this.canSwitchProfile(this.profileStorageProfile,C))return;const v=this.profileStorage,h=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(C),await this.profileStorage.init(),this.switchData(h,this.profileStorage,0,p)}async switchToWorkspace(C,p){const v=this.workspaceStorage,h=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init(),this.switchData(h,this.workspaceStorage,1,p)}hasScope(C){return(0,E.isUserDataProfile)(C)?this.profileStorageProfile.id===C.id:this.workspaceStorageId===C.id}}e.NativeStorageService=b}),define(ne[254],re([0,1,3,2,19,14,58,20]),function(Q,e,D,r,k,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let E=class extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(I,C,p){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=C.getChannel("userDataProfiles"),this.profilesHome=(0,k.joinPath)(p.userRoamingDataHome,"profiles"),this._profiles=I.map(v=>(0,P.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const h=v.added.map(d=>(0,P.reviveProfile)(d,this.profilesHome.scheme)),y=v.removed.map(d=>(0,P.reviveProfile)(d,this.profilesHome.scheme)),w=v.updated.map(d=>(0,P.reviveProfile)(d,this.profilesHome.scheme));this._profiles=v.all.map(d=>(0,P.reviveProfile)(d,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:h,removed:y,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}async createNamedProfile(I,C,p){const v=await this.channel.call("createNamedProfile",[I,C,p]);return(0,P.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(I,C,p,v){const h=await this.channel.call("createProfile",[I,C,p,v]);return(0,P.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(I){const C=await this.channel.call("createTransientProfile",[I]);return(0,P.reviveProfile)(C,this.profilesHome.scheme)}async setProfileForWorkspace(I,C){await this.channel.call("setProfileForWorkspace",[I,C])}removeProfile(I){return this.channel.call("removeProfile",[I])}async updateProfile(I,C){const p=await this.channel.call("updateProfile",[I,C]);return(0,P.reviveProfile)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};E=pe([Y(1,T.IMainProcessService),Y(2,L.IEnvironmentService)],E),e.UserDataProfilesNativeService=E}),define(ne[41],re([0,1,18,6,16,22,3,35,2,27,15,7,163,17,14,13,8,48,21,24,31,26,20]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=o;let t=class extends E.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(m,S,_,$,A,U,R,N,F,q,J,j){super(),this.syncResource=m,this.collection=S,this.fileService=_,this.environmentService=$,this.userDataSyncStoreService=U,this.userDataSyncBackupStoreService=R,this.userDataSyncEnablementService=N,this.telemetryService=F,this.logService=q,this.configurationService=J,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new r.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=`${(0,b.uppercaseFirstLetter)(this.resource)}${m.profile.isDefault?"":` (${m.profile.name})`}`,this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath($.userDataSyncHome,...(0,l.getPathSegments)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,$,this.extUri),this.currentMachineIdPromise=(0,d.getServiceMachineId)($,_,A)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const m=await this.syncPreviewPromise;this.syncPreviewPromise=null;const S=await this.performSync(m.remoteUserData,m.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(S)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.hasRemoteChanged(m):!0)&&this._onDidChangeLocal.fire()}}setStatus(m){this._status!==m&&(this._status=m,this._onDidChangStatus.fire(m))}async sync(m,S={}){await this._sync(m,!0,this.getUserDataSyncConfiguration(),S)}async preview(m,S,_={}){return this._sync(m,!1,S,_)}async apply(m,S={}){try{this.syncHeaders={...S};const _=await this.doApply(m);return this.setStatus(_),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(m,S,_,$){try{if(this.syncHeaders={...$},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const U=await this.getLastSyncUserData(),R=await this.getLatestRemoteUserData(m,U);return A=await this.performSync(R,U,S,_),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(m){const S=await this.resolveContent(m);if(!S)return!1;const _=this.parseSyncData(S);if(!_)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const $=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,$),U=await this.isRemoteDataFromCurrentMachine(A),R=await this.generateSyncPreview({ref:A.ref,syncData:_},$,U,this.getUserDataSyncConfiguration(),L.CancellationToken.None),N=[];for(const F of R){const q=await this.getAcceptResult(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,L.CancellationToken.None);N.push([F,{...q,remoteChange:J!==0?J:2}])}await this.applyResult(A,$,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(m){const S=await this.currentMachineIdPromise;return!!m.syncData?.machineId&&m.syncData.machineId===S}async getLatestRemoteUserData(m,S){if(S){const _=m?m[this.resource]:void 0;if(S.ref===_||_===void 0&&S.syncData===null)return S}return this.getRemoteUserData(S)}async performSync(m,S,_,$){if(m.syncData&&m.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(m,S,_,$)}catch(A){if(A instanceof l.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(m,S,_,$);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),S=await this.getLastSyncUserData(),this.performSync(m,S,_,$)}throw A}}async doSync(m,S,_,$){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,r.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(m,S,_,$,U)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":_?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(m){return await this.updateSyncResourcePreview(m,async S=>{const _=await this.getMergeResult(S,L.CancellationToken.None);await this.fileService.writeFile(S.previewResource,k.VSBuffer.fromString(_?.content||""));const $=_&&!_.hasConflicts?await this.getAcceptResult(S,S.previewResource,void 0,L.CancellationToken.None):void 0;return S.acceptResult=$,S.mergeState=_.hasConflicts?"conflict":$?"accepted":"preview",S.localChange=$?$.localChange:_.localChange,S.remoteChange=$?$.remoteChange:_.remoteChange,S}),this.syncPreviewPromise}async accept(m,S){return await this.updateSyncResourcePreview(m,async _=>{const $=await this.getAcceptResult(_,m,S,L.CancellationToken.None);return _.acceptResult=$,_.mergeState="accepted",_.localChange=$.localChange,_.remoteChange=$.remoteChange,_}),this.syncPreviewPromise}async discard(m){return await this.updateSyncResourcePreview(m,async S=>{const _=await this.getMergeResult(S,L.CancellationToken.None);return await this.fileService.writeFile(S.previewResource,k.VSBuffer.fromString(_.content||"")),S.acceptResult=void 0,S.mergeState="preview",S.localChange=_.localChange,S.remoteChange=_.remoteChange,S}),this.syncPreviewPromise}async updateSyncResourcePreview(m,S){if(!this.syncPreviewPromise)return;let _=await this.syncPreviewPromise;const $=_.resourcePreviews.findIndex(({localResource:A,remoteResource:U,previewResource:R})=>this.extUri.isEqual(A,m)||this.extUri.isEqual(U,m)||this.extUri.isEqual(R,m));$!==-1&&(this.syncPreviewPromise=(0,r.createCancelablePromise)(async A=>{const U=[..._.resourcePreviews];return U[$]=await S(U[$]),{..._,resourcePreviews:U}}),_=await this.syncPreviewPromise,this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(m){if(!this.syncPreviewPromise)return"idle";const S=await this.syncPreviewPromise;return S.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":S.resourcePreviews.some(({mergeState:_})=>_!=="accepted")?"syncing":(await this.applyResult(S.remoteUserData,S.lastSyncUserData,S.resourcePreviews.map(_=>[_,_.acceptResult]),m),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(m){const S=m.filter(({mergeState:_})=>_==="conflict");(0,D.equals)(this._conflicts,S,(_,$)=>this.extUri.isEqual(_.previewResource,$.previewResource))||(this._conflicts=S,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllResourceRefs(this.resource,this.collection)).map(({created:S,ref:_})=>({created:S,uri:this.toRemoteBackupResource(_)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.syncResource.profile,this.resource)).map(({created:S,ref:_})=>({created:S,uri:this.toLocalBackupResource(_)}))}toRemoteBackupResource(m){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.syncResource.profile.isDefault?"":`${this.syncResource.profile.id}/`}${this.resource}/${m}`})}toLocalBackupResource(m){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.syncResource.profile.id}/${this.resource}/${m}`})}async getMachineId({uri:m}){const S=this.extUri.basename(m);if(this.extUri.isEqual(m,this.toRemoteBackupResource(S))){const{content:_}=await this.getUserData(S);if(_)return this.parseSyncData(_)?.machineId}}async resolveContent(m){const S=this.extUri.basename(m);if(this.extUri.isEqual(m,this.toRemoteBackupResource(S))){const{content:_}=await this.getUserData(S);return _}return this.extUri.isEqual(m,this.toLocalBackupResource(S))?this.userDataSyncBackupStoreService.resolveContent(this.syncResource.profile,this.resource,S):null}async resolvePreviewContent(m){const S=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(S)for(const _ of S.resourcePreviews){if(this.extUri.isEqual(_.acceptedResource,m))return _.acceptResult?_.acceptResult.content:null;if(this.extUri.isEqual(_.remoteResource,m))return _.remoteContent;if(this.extUri.isEqual(_.localResource,m))return _.localContent;if(this.extUri.isEqual(_.baseResource,m))return _.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(m,S,_,$,A){const U=await this.isRemoteDataFromCurrentMachine(m),R=await this.generateSyncPreview(m,S,U,$,A),N=[];for(const F of R){const q=F.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)N.push({...F,acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=_?await this.getMergeResult(F,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,k.VSBuffer.fromString(J?.content||""));const j=J&&!J.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,A):void 0;N.push({...F,acceptResult:j,mergeState:J?.hasConflicts?"conflict":j?"accepted":"preview",localChange:j?j.localChange:J?J.localChange:F.localChange,remoteChange:j?j.remoteChange:J?J.remoteChange:F.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:S,resourcePreviews:N,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const m=await this.fileService.readFile(this.lastSyncResource),S=JSON.parse(m.value.toString()),_=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=S.version&&_&&S.version!==_,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${S.version} is not compatible with current sync state version ${_}.`),await this.resetLocal(),null;const $=S;if($.content===null)return{ref:S.ref,syncData:null};const A=JSON.parse($.content);if(o(A))return{...S,syncData:A,content:void 0}}catch(m){m instanceof y.FileOperationError&&m.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(m)}return null}async updateLastSyncUserData(m,S={}){if(S.ref||S.content||S.version)throw new Error("Cannot have core properties as additional");const _=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),$={ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null,version:_,...S};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify($)))}async getRemoteUserData(m){const{ref:S,content:_}=await this.getUserData(m);let $=null;return _!==null&&($=this.parseSyncData(_)),{ref:S,syncData:$}}parseSyncData(m){try{const S=JSON.parse(m);if(o(S))return S}catch(S){this.logService.error(S)}throw new l.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(m){if((0,I.isString)(m)){const S=await this.userDataSyncStoreService.resolveResourceContent(this.resource,m,this.collection);return{ref:m,content:S}}else{const S=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,S,this.collection,this.syncHeaders)}}async updateRemoteUserData(m,S){const _=await this.currentMachineIdPromise,$={version:this.version,machineId:_,content:m};try{return S=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify($),S,this.collection,this.syncHeaders),{ref:S,syncData:$}}catch(A){throw A instanceof l.UserDataSyncError&&A.code==="TooLarge"&&(A=new l.UserDataSyncError(A.message,A.code,this.resource)),A}}async backupLocal(m){const S={version:this.version,content:m};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(S))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=pe([Y(2,y.IFileService),Y(3,h.IEnvironmentService),Y(4,f.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncEnablementService),Y(8,c.ITelemetryService),Y(9,l.IUserDataSyncLogService),Y(10,v.IConfigurationService),Y(11,g.IUriIdentityService)],t),e.AbstractSynchroniser=t;let i=class extends t{constructor(m,S,_,$,A,U,R,N,F,q,J,j,H){super(S,_,$,A,U,R,N,F,q,J,j,H),this.file=m,this._register(this.fileService.watch(this.extUri.dirname(m))),this._register(this.fileService.onDidFilesChange(W=>this.onFileChanges(W)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(m,S,_){try{S?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(m),_?void 0:S):await this.fileService.createFile(this.file,k.VSBuffer.fromString(m),{overwrite:_})}catch($){throw $ instanceof y.FileOperationError&&$.fileOperationResult===1||$ instanceof y.FileOperationError&&$.fileOperationResult===3?new l.UserDataSyncError($.message,"LocalPreconditionFailed"):$}}onFileChanges(m){!m.contains(this.file)||this.triggerLocalChange()}};i=pe([Y(3,y.IFileService),Y(4,h.IEnvironmentService),Y(5,f.IStorageService),Y(6,l.IUserDataSyncStoreService),Y(7,l.IUserDataSyncBackupStoreService),Y(8,l.IUserDataSyncEnablementService),Y(9,c.ITelemetryService),Y(10,l.IUserDataSyncLogService),Y(11,v.IConfigurationService),Y(12,g.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let s=class extends i{constructor(m,S,_,$,A,U,R,N,F,q,J,j,H,W){super(m,S,_,$,A,U,R,N,F,q,J,H,W),this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(m,S){const _=[],$=(0,P.parse)(m,_,{allowEmptyContent:!0,allowTrailingComma:!0});return _.length>0||!(0,I.isUndefined)($)&&S!==Array.isArray($)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};s=pe([Y(3,y.IFileService),Y(4,h.IEnvironmentService),Y(5,f.IStorageService),Y(6,l.IUserDataSyncStoreService),Y(7,l.IUserDataSyncBackupStoreService),Y(8,l.IUserDataSyncEnablementService),Y(9,c.ITelemetryService),Y(10,l.IUserDataSyncLogService),Y(11,l.IUserDataSyncUtilService),Y(12,v.IConfigurationService),Y(13,g.IUriIdentityService)],s),e.AbstractJsonFileSynchroniser=s;let u=class{constructor(m,S,_,$,A,U){this.resource=m,this.userDataProfilesService=S,this.environmentService=_,this.logService=$,this.fileService=A,this.extUri=U.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(void 0,this.resource,_,this.extUri)}async initialize({ref:m,content:S}){if(!S){this.logService.info("Remote content does not exist.",this.resource);return}const _=this.parseSyncData(S);if(!!_)try{await this.doInitialize({ref:m,syncData:_})}catch($){this.logService.error($)}}parseSyncData(m){try{const S=JSON.parse(m);if(o(S))return S}catch(S){this.logService.error(S)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(m,S={}){const _={ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null,...S};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(_)))}};u=pe([Y(1,n.IUserDataProfilesService),Y(2,h.IEnvironmentService),Y(3,w.ILogService),Y(4,y.IFileService),Y(5,g.IUriIdentityService)],u),e.AbstractInitializer=u}),define(ne[255],re([0,1,18,16,3,35,4,15,164,17,14,13,21,24,31,20,41,239,26]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function c(n,o,t){try{const i=JSON.parse(n);if(!o)return(0,P.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,P.isUndefined)(i.mac)?null:i.mac;case 3:return(0,P.isUndefined)(i.linux)?null:i.linux;case 1:return(0,P.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=c;let g=class extends w.AbstractJsonFileSynchroniser{constructor(o,t,i,s,u,a,m,S,_,$,A,U,R){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},t,S,_,$,i,s,m,U,u,A,a,R),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(a.onDidChangeConfiguration,N=>N.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,i,s){const u=o.syncData?c(o.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&i?o:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,m=await this.getLocalFileContent(),S=await this.getFormattingOptions();let _=null,$=!1,A=!1,U=!1;if(u){let F=m?m.value.toString():"[]";if(F=F||"[]",this.hasErrors(F,!0))throw new f.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==F||a!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const q=await(0,d.merge)(F,u,a,S,this.userDataSyncUtilService);q.hasChanges&&(_=q.mergeContent,U=q.hasConflicts,$=U||q.mergeContent!==F,A=U||q.mergeContent!==u)}}else m&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),_=m.value.toString(),A=!0);const R={content:U?a:_,localChange:$?m?2:1:0,remoteChange:A?2:0,hasConflicts:U},N=m?m.value.toString():null;return[{fileContent:m,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:N,localChange:R.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:R.remoteChange,previewResource:this.previewResource,previewResult:R,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getKeybindingsContentFromLastSyncUserData(o);if(t===null)return!0;const i=await this.getLocalFileContent(),s=i?i.value.toString():"",u=await this.getFormattingOptions(),a=await(0,d.merge)(s||"[]",t,t,u,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==t}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,i,s){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,i,s){const{fileContent:u}=i[0][0];let{content:a,localChange:m,remoteChange:S}=i[0][1];if(m===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new f.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(m!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),u&&await this.backupLocal(this.toSyncContent(u.value.toString())),await this.updateLocalFileContent(a||"[]",u,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),S!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const _=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(_,s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,L.parse)(o.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"keybindings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(o)){case"keybindings.json":return c(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:c(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,t){let i={};try{i=JSON.parse(t||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=o,T.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=pe([Y(2,f.IUserDataSyncStoreService),Y(3,f.IUserDataSyncBackupStoreService),Y(4,f.IUserDataSyncLogService),Y(5,b.IConfigurationService),Y(6,f.IUserDataSyncEnablementService),Y(7,C.IFileService),Y(8,I.IEnvironmentService),Y(9,p.IStorageService),Y(10,f.IUserDataSyncUtilService),Y(11,v.ITelemetryService),Y(12,h.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let l=class extends w.AbstractInitializer{constructor(o,t,i,s,u){super("keybindings",t,i,s,o,u)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,r.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,L.parse)(o.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return c(o,!0,this.logService)}catch(t){return this.logService.error(t),null}}};l=pe([Y(0,C.IFileService),Y(1,y.IUserDataProfilesService),Y(2,I.IEnvironmentService),Y(3,f.IUserDataSyncLogService),Y(4,h.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(ne[256],re([0,1,16,3,165,17,72,14,29,13,21,24,31,20,41,61,243,26]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function c(n){const o=JSON.parse(n);return f(o)?o:{settings:n}}e.parseSettingsSyncContent=c;let g=class extends h.AbstractJsonFileSynchroniser{constructor(o,t,i,s,u,a,m,S,_,$,A,U,R,N){super(o.settingsResource,{syncResource:"settings",profile:o},t,i,s,u,a,m,A,U,S,_,$,N),this.extensionManagementService=R,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(o){const t=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(o,t),s=this.getSettingsSyncContent(i),u=new T.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&u.parse(s.settings),u.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(o,t,i){const s=await this.getLocalFileContent(),u=await this.getFormattingOptions(),a=this.getSettingsSyncContent(o);t=t===null&&i?o:t;const m=t?this.getSettingsSyncContent(t):null,S=await this.getIgnoredSettings();let _=null,$=!1,A=!1,U=!1;if(a){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const J=(0,w.merge)(q,a.settings,m?m.settings:null,S,[],u);_=J.localContent||J.remoteContent,$=J.localContent!==null,A=J.remoteContent!==null,U=J.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),_=s.value.toString().trim()||"{}",this.validateContent(_),A=!0);const R=s?s.value.toString():null,N=m?.settings??null,F={content:U?N:_,localChange:$?2:0,remoteChange:A?2:0,hasConflicts:U};return[{fileContent:s,baseResource:this.baseResource,baseContent:N,localResource:this.localResource,localContent:R,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getSettingsSyncContent(o);if(t===null)return!0;const i=await this.getLocalFileContent(),s=i?i.value.toString().trim():"",u=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,w.merge)(s||"{}",t.settings,t.settings,u,[],a).remoteContent!==null}async getMergeResult(o,t){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...o.previewResult,content:o.previewResult.content?(0,w.updateIgnoredSettings)(o.previewResult.content,"{}",s,i):null}}async getAcceptResult(o,t,i,s){const u=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?(0,w.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",a,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent!==null?(0,w.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",a,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i!==null?(0,w.updateIgnoredSettings)(i,o.fileContent?o.fileContent.value.toString():"{}",a,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,i,s){const{fileContent:u}=i[0][0];let{content:a,localChange:m,remoteChange:S}=i[0][1];if(m===0&&S===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),m!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(a,u,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),S!==0){const _=await this.getFormattingOptions(),$=this.getSettingsSyncContent(o),A=await this.getIgnoredSettings(a);a=(0,w.updateIgnoredSettings)(a,$?$.settings:"{}",A,_),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),o=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(o),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=await this.getFormattingOptions(),i=(0,y.edit)(o.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,w.isEmpty)(i)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"settings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)||this.extUri.isEqual(this.baseResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const i=this.parseSyncData(t);if(i){const s=this.parseSettingsSyncContent(i.content);if(s)switch(this.extUri.basename(o)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(o){let t=await super.resolvePreviewContent(o);if(t){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();t=(0,w.updateIgnoredSettings)(t,"{}",s,i)}return t}getSettingsSyncContent(o){return o.syncData?this.parseSettingsSyncContent(o.syncData.content):null}parseSettingsSyncContent(o){try{return c(o)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(o){return{settings:o}}async getIgnoredSettings(o){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=r.Event.any(r.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:u})=>!!u)),r.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(t,this.configurationService,o)}validateContent(o){if(this.hasErrors(o,!1))throw new d.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};g=pe([Y(2,b.IFileService),Y(3,P.IEnvironmentService),Y(4,I.IStorageService),Y(5,d.IUserDataSyncStoreService),Y(6,d.IUserDataSyncBackupStoreService),Y(7,d.IUserDataSyncLogService),Y(8,d.IUserDataSyncUtilService),Y(9,L.IConfigurationService),Y(10,d.IUserDataSyncEnablementService),Y(11,C.ITelemetryService),Y(12,E.IExtensionManagementService),Y(13,p.IUriIdentityService)],g),e.SettingsSynchroniser=g;let l=class extends h.AbstractInitializer{constructor(o,t,i,s,u){super("settings",t,i,s,o,u)}async doInitialize(o){const t=o.syncData?this.parseSettingsSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,w.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}parseSettingsSyncContent(o){try{return c(o)}catch(t){this.logService.error(t)}return null}};l=pe([Y(0,b.IFileService),Y(1,v.IUserDataProfilesService),Y(2,P.IEnvironmentService),Y(3,d.IUserDataSyncLogService),Y(4,p.IUriIdentityService)],l),e.SettingsInitializer=l}),define(ne[257],re([0,1,16,3,32,17,14,13,21,24,31,20,41,240,26]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let y=class extends p.AbstractSynchroniser{constructor(f,c,g,l,n,o,t,i,s,u,a,m){super({syncResource:"snippets",profile:f},c,l,g,n,o,t,u,a,i,s,m),this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(r.Event.filter(this.fileService.onDidFilesChange,S=>S.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,c,g){const l=await this.getSnippetsFileContents(),n=this.toSnippetsContents(l),o=f.syncData?this.parseSnippets(f.syncData):null;c=c===null&&g?f:c;const t=c&&c.syncData?this.parseSnippets(c.syncData):null;o?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,v.merge)(n,o,t);return this.getResourcePreviews(i,l,o||{},t||{})}async hasRemoteChanged(f){const c=f.syncData?this.parseSnippets(f.syncData):null;if(c===null)return!0;const g=await this.getSnippetsFileContents(),l=this.toSnippetsContents(g),n=(0,v.merge)(l,c,c);return Object.keys(n.remote.added).length>0||Object.keys(n.remote.updated).length>0||n.remote.removed.length>0||n.conflicts.length>0}async getMergeResult(f,c){return f.previewResult}async getAcceptResult(f,c,g,l){if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder))return g===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:g,localChange:g===null?f.fileContent!==null?3:0:2,remoteChange:g===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(f,c,g,l){const n=g.map(([o,t])=>({...o,acceptResult:t}));n.every(({localChange:o,remoteChange:t})=>o===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),n.some(({localChange:o})=>o!==0)&&(await this.updateLocalBackup(n),await this.updateLocalSnippets(n,l)),n.some(({remoteChange:o})=>o!==0)&&(f=await this.updateRemoteSnippets(n,f,l)),c?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:o}of n)try{await this.fileService.del(o)}catch{}}getResourcePreviews(f,c,g,l){const n=new Map;for(const o of Object.keys(f.local.added)){const t={content:f.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};n.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(f.local.updated)){const t={content:f.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0},i=c[o]?c[o].value.toString():null;n.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[o],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of f.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=c[o]?c[o].value.toString():null;n.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[o],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(f.remote.added)){const t={content:f.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1},i=c[o]?c[o].value.toString():null;n.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[o],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(f.remote.updated)){const t={content:f.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2},i=c[o]?c[o].value.toString():null;n.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[o],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of f.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};n.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of f.conflicts){const t={content:l[o]??null,hasConflicts:!0,localChange:c[o]?2:1,remoteChange:g[o]?2:1},i=c[o]?c[o].value.toString():null;n.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[o]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(c))if(!n.has(o)){const t={content:c[o]?c[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=c[o]?c[o].value.toString():null;n.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[o]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...n.values()]}async getAssociatedResources({uri:f}){const c=await super.resolveContent(f);if(c){const g=this.parseSyncData(c);if(g){const l=this.parseSnippets(g),n=[];for(const o of Object.keys(l)){const t=this.extUri.joinPath(f,o),i=this.extUri.joinPath(this.snippetsFolder,o),s=await this.fileService.exists(i);n.push({resource:t,comparableResource:s?i:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return n}}return[]}async resolveContent(f){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(f);let c=await super.resolveContent(f);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(f)),c){const g=this.parseSyncData(c);if(g)return this.parseSnippets(g)[this.extUri.basename(f)]||null}return null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch{}return!1}async updateLocalBackup(f){const c={};for(const g of f)g.fileContent&&(c[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(c)))}async updateLocalSnippets(f,c){for(const{fileContent:g,acceptResult:l,localResource:n,remoteResource:o,localChange:t}of f)if(t!==0){const i=o?this.extUri.basename(o):this.extUri.basename(n),s=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(s)),await this.fileService.del(s),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(s))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(s)),await this.fileService.createFile(s,D.VSBuffer.fromString(l.content),{overwrite:c}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(s))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(s)),await this.fileService.writeFile(s,D.VSBuffer.fromString(l.content),c?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(s)))}}async updateRemoteSnippets(f,c,g){const l=c.syncData?this.parseSnippets(c.syncData):{},n=(0,k.deepClone)(l);for(const{acceptResult:o,localResource:t,remoteResource:i,remoteChange:s}of f)if(s!==0){const u=t?this.extUri.basename(t):this.extUri.basename(i);s===3?delete n[u]:n[u]=o.content}return(0,v.areSame)(l,n)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),c=await this.updateRemoteUserData(JSON.stringify(n),g?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),c}parseSnippets(f){return JSON.parse(f.content)}toSnippetsContents(f){const c={};for(const g of Object.keys(f))c[g]=f[g].value.toString();return c}async getSnippetsFileContents(){const f={};let c;try{c=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof P.FileOperationError&&g.fileOperationResult===1)return f;throw g}for(const g of c.children||[]){const l=g.resource,n=this.extUri.extname(l);if(n===".json"||n===".code-snippets"){const o=this.extUri.relativePath(this.snippetsFolder,l),t=await this.fileService.readFile(l);f[o]=t}}return f}};y=pe([Y(2,T.IEnvironmentService),Y(3,P.IFileService),Y(4,E.IStorageService),Y(5,h.IUserDataSyncStoreService),Y(6,h.IUserDataSyncBackupStoreService),Y(7,h.IUserDataSyncLogService),Y(8,L.IConfigurationService),Y(9,h.IUserDataSyncEnablementService),Y(10,b.ITelemetryService),Y(11,I.IUriIdentityService)],y),e.SnippetsSynchroniser=y;let w=class extends p.AbstractInitializer{constructor(f,c,g,l,n){super("snippets",c,g,l,f,n)}async doInitialize(f){const c=f.syncData?JSON.parse(f.syncData.content):null;if(!c){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(c)){const n=c[l];if(n){const o=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,l);await this.fileService.createFile(o,D.VSBuffer.fromString(n)),this.logService.info("Created snippet",this.extUri.basename(o))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};w=pe([Y(0,P.IFileService),Y(1,C.IUserDataProfilesService),Y(2,T.IEnvironmentService),Y(3,h.IUserDataSyncLogService),Y(4,I.IUriIdentityService)],w),e.SnippetsInitializer=w}),define(ne[258],re([0,1,16,17,14,13,21,24,31,20,41,26]),function(Q,e,D,r,k,L,T,P,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(w,d){try{return JSON.parse(w).tasks}catch(f){return d.error(f),null}}e.getTasksContentFromSyncContent=p;let v=class extends I.AbstractFileSynchroniser{constructor(d,f,c,g,l,n,o,t,i,s,u,a){super(d.tasksResource,{syncResource:"tasks",profile:d},f,t,i,s,c,g,o,u,l,n,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(d,f,c,g){const l=d.syncData?p(d.syncData.content,this.logService):null;f=f===null&&c?d:f;const n=f?.syncData?p(f.syncData.content,this.logService):null,o=await this.getLocalFileContent();let t=null,i=!1,s=!1,u=!1;if(l){const S=o?o.value.toString():null;if(!n||n!==S||n!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const _=y(S,l,n);t=_.content,u=_.hasConflicts,i=_.hasLocalChanged,s=_.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=o.value.toString(),s=!0);const a={content:u?n:t,localChange:i?o?2:1:0,remoteChange:s?2:0,hasConflicts:u},m=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:n,localResource:this.localResource,localContent:m,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const f=d?.syncData?p(d.syncData.content,this.logService):null;if(f===null)return!0;const c=await this.getLocalFileContent(),g=c?c.value.toString():null,l=y(g,f,f);return l.hasLocalChanged||l.hasRemoteChanged}async getMergeResult(d,f){return d.previewResult}async getAcceptResult(d,f,c,g){if(this.extUri.isEqual(f,this.localResource))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(f,this.remoteResource))return{content:d.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(f,this.previewResource))return c===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:c,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async applyResult(d,f,c,g){const{fileContent:l}=c[0][0],{content:n,localChange:o,remoteChange:t}=c[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),l&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(l.value.toString()))),await this.updateLocalFileContent(n||"{}",l,g),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(n||"{}"));d=await this.updateRemoteUserData(i,g?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}f?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:d}){const f=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(d,"tasks.json"),comparableResource:f}]}async resolveContent(d){if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.baseResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let f=await super.resolveContent(d);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(d)),f){const c=this.parseSyncData(f);if(c)switch(this.extUri.basename(d)){case"tasks.json":return p(c.content,this.logService)}}return null}toTasksSyncContent(d){return{tasks:d}}};v=pe([Y(2,C.IUserDataSyncStoreService),Y(3,C.IUserDataSyncBackupStoreService),Y(4,C.IUserDataSyncLogService),Y(5,r.IConfigurationService),Y(6,C.IUserDataSyncEnablementService),Y(7,L.IFileService),Y(8,k.IEnvironmentService),Y(9,T.IStorageService),Y(10,P.ITelemetryService),Y(11,E.IUriIdentityService)],v),e.TasksSynchroniser=v;let h=class extends I.AbstractInitializer{constructor(d,f,c,g,l){super("tasks",f,c,g,d,l),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(d){const f=d.syncData?p(d.syncData.content,this.logService):null;if(!f){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(f)),await this.updateLastSyncUserData(d)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};h=pe([Y(0,L.IFileService),Y(1,b.IUserDataProfilesService),Y(2,k.IEnvironmentService),Y(3,C.IUserDataSyncLogService),Y(4,E.IUriIdentityService)],h),e.TasksInitializer=h;function y(w,d,f){if(w===null&&d===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===d)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const c=f!==w,g=f!==d;return!c&&!g?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:c&&!g?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:g&&!c?{content:d,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[259],re([0,1,46,7,17,14,13,21,24,31,20,41,241,26]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0;let h=class mt extends C.AbstractSynchroniser{constructor(d,f,c,g,l,n,o,t,i,s,u,a,m){super({syncResource:"profiles",profile:d},f,g,l,n,o,t,u,a,i,s,m),this.userDataProfilesService=c,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const d=await this.getLastSyncUserData();return d?.syncData?y(d.syncData):null}async getRemoteSyncedProfiles(d){const f=await this.getLastSyncUserData(),c=await this.getLatestRemoteUserData(d,f);return c?.syncData?y(c.syncData):null}async generateSyncPreview(d,f,c){const g=d.syncData?y(d.syncData):null,l=f?.syncData?y(f.syncData):null,n=this.getLocalUserDataProfiles(),{local:o,remote:t}=(0,p.merge)(n,g,l,[]),i={local:o,remote:t,content:l?this.stringifyRemoteProfiles(l):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:t!==null?2:0},s=this.stringifyLocalProfiles(n,!1);return[{baseResource:this.baseResource,baseContent:l?this.stringifyRemoteProfiles(l):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:g?this.stringifyRemoteProfiles(g):null,remoteProfiles:g,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const f=d?.syncData?y(d.syncData):null,c=this.getLocalUserDataProfiles(),{remote:g}=(0,p.merge)(c,f,f,[]);return!!g?.added.length||!!g?.removed.length||!!g?.updated.length}async getMergeResult(d,f){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,f,c,g){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(f,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(d){const f=this.getLocalUserDataProfiles(),c=(0,p.merge)(f,null,null,[]),{local:g,remote:l}=c;return{content:d.localContent,local:g,remote:l,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?2:0,remoteChange:l!==null?2:0}}async acceptRemote(d){const f=d.remoteContent?JSON.parse(d.remoteContent):null,c=[],g=[];for(const l of this.getLocalUserDataProfiles()){const n=f?.find(o=>o.id===l.id);n&&(c.push({id:l.id,name:l.name,collection:n.collection}),g.push(l))}if(f!==null){const l=(0,p.merge)(g,f,c,[]),{local:n,remote:o}=l;return{content:d.remoteContent,local:n,remote:o,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:d.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(d,f,c,g){const{local:l,remote:n,localChange:o,remoteChange:t}=c[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),o!==0){await this.backupLocal(this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!1));const i=[];for(const s of l.added)i.push(this.userDataProfilesService.createProfile(s.id,s.name,{shortName:s.shortName}));for(const s of l.removed)i.push(this.userDataProfilesService.removeProfile(s));for(const s of l.updated){const u=this.userDataProfilesService.profiles.find(a=>a.id===s.id);u?i.push(this.userDataProfilesService.updateProfile(u,{name:s.name,shortName:s.shortName})):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(i)}if(t!==0){const i=c[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const s of n?.added||[]){const u=await this.userDataSyncStoreService.createCollection(this.syncHeaders);i.push({id:s.id,name:s.name,collection:u,shortName:s.shortName})}for(const s of n?.removed||[])i.splice(i.findIndex(({id:u})=>s.id===u),1);for(const s of n?.updated||[]){const u=i.find(({id:a})=>s.id===a);u&&i.splice(i.indexOf(u),1,{id:s.id,name:s.name,collection:u.collection,shortName:s.shortName})}d=await this.updateRemoteUserData(this.stringifyRemoteProfiles(i),g?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${n?.added.length?` Added: ${JSON.stringify(n.added.map(s=>s.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(s=>s.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(s=>s.name))}.`:""}`);for(const s of n?.removed||[])await this.userDataSyncStoreService.deleteCollection(s.collection,this.syncHeaders)}f?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"profiles.json"),comparableResource:mt.PROFILES_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,mt.PROFILES_DATA_URI))return this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!0);if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.baseResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d)){const c=await this.resolvePreviewContent(d);return c&&(0,D.toFormattedString)(JSON.parse(c),{})}let f=await super.resolveContent(d);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(d)),f){const c=this.parseSyncData(f);if(c)switch(this.extUri.basename(d)){case"profiles.json":return(0,D.toFormattedString)(y(c),{})}}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(d=>!d.isDefault&&!d.isTransient)}stringifyRemoteProfiles(d){return JSON.stringify([...d].sort((f,c)=>f.name.localeCompare(c.name)))}stringifyLocalProfiles(d,f){const c=[...d].sort((g,l)=>g.name.localeCompare(l.name)).map(g=>({id:g.id,name:g.name}));return f?(0,D.toFormattedString)(c,{}):JSON.stringify(c)}};h.PROFILES_DATA_URI=r.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"profiles",path:"/profiles.json"}),h=pe([Y(2,I.IUserDataProfilesService),Y(3,T.IFileService),Y(4,L.IEnvironmentService),Y(5,P.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncLogService),Y(9,k.IConfigurationService),Y(10,v.IUserDataSyncEnablementService),Y(11,E.ITelemetryService),Y(12,b.IUriIdentityService)],h),e.UserDataProfilesManifestSynchroniser=h;function y(w){return JSON.parse(w.content)}}),define(ne[260],re([0,1,6,16,64,2,19,17,14,13,20,26]),function(Q,e,D,r,k,L,T,P,E,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends L.Disposable{constructor(h,y,w,d,f){super(),this.environmentService=h,this.fileService=y,this.configurationService=w,this.logService=d,this.userDataProfilesService=f;for(const c of this.userDataProfilesService.profiles)for(const g of C.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(c,g))}async getAllRefs(h,y){const w=this.getResourceBackupHome(h,y),d=await this.fileService.resolve(w);return d.children?d.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort().reverse().map(c=>({ref:c.name,created:this.getCreationTime(c)})):[]}async resolveContent(h,y,w){if(!w){const d=await this.getAllRefs(h,y);d.length&&(w=d[d.length-1].ref)}if(w){const d=(0,T.joinPath)(this.environmentService.userDataSyncHome,y,w);return(await this.fileService.readFile(d)).value.toString()}return null}async backup(h,y,w){const d=this.getResourceBackupHome(h,y),f=(0,T.joinPath)(d,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,r.VSBuffer.fromString(w))}catch(c){this.logService.error(c)}try{this.cleanUpBackup(d)}catch{}}getResourceBackupHome(h,y){return(0,T.joinPath)(this.environmentService.userDataSyncHome,...h.isDefault?[y]:[h.id,y])}async cleanUpBackup(h){try{try{if(!await this.fileService.exists(h))return}catch{return}const y=await this.fileService.resolve(h);if(y.children){const w=y.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),d=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let f=w.filter(g=>Date.now()-this.getCreationTime(g)>d);const c=w.length-f.length;c<10&&(f=f.slice(10-c)),await D.Promises.settled(f.map(async g=>{this.logService.info("Deleting from backup",g.resource.path),await this.fileService.del(g.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};p=pe([Y(0,E.IEnvironmentService),Y(1,b.IFileService),Y(2,P.IConfigurationService),Y(3,C.IUserDataSyncLogService),Y(4,I.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(ne[261],re([0,1,3,2,4,14,21,24,26]),function(Q,e,D,r,k,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let I=class extends r.Disposable{constructor(p,v,h,y){super(),this.storageService=p,this.telemetryService=v,this.environmentService=h,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(b,{enabled:p}),this.storageService.store(b,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,E.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,v){if(this.isResourceEnabled(p)!==v){const h=(0,E.getEnablementKey)(p);this.storeResourceEnablement(h,v)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,v){this.storageService.store(p,v,-1,k.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(b===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const v=E.ALL_SYNC_RESOURCES.filter(h=>(0,E.getEnablementKey)(h)===p.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}};I=pe([Y(0,T.IStorageService),Y(1,P.ITelemetryService),Y(2,L.IEnvironmentService),Y(3,E.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(ne[78],re([0,1,3,2,4,27,168,14,13,5,25,48,21,26]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",y="Safari",w="Chrome",d="Edge",f="Firefox",c="Android";function g(o){switch(o){case y:case w:case d:case f:case c:case(0,k.PlatformToString)(0):return!0}return!1}e.isWebPlatform=g;function l(){return k.isSafari?y:k.isChrome?w:k.isEdge?d:k.isFirefox?f:k.isAndroid?c:(0,k.PlatformToString)(k.isWeb?0:k.platform)}let n=class nt extends r.Disposable{constructor(t,i,s,u,a,m){super(),this.storageService=s,this.userDataSyncStoreService=u,this.logService=a,this.productService=m,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(t,i,s)}async getMachines(t){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(u=>({...u,isCurrent:u.id===i}))}async addCurrentMachine(t){const i=await this.currentMachineIdPromise,s=await this.readMachinesData(t);s.machines.some(({id:u})=>u===i)||(s.machines.push({id:i,name:this.computeCurrentMachineName(s.machines),platform:l()}),await this.writeMachinesData(s))}async removeCurrentMachine(t){const i=await this.currentMachineIdPromise,s=await this.readMachinesData(t),u=s.machines.filter(({id:a})=>a!==i);u.length!==s.machines.length&&(s.machines=u,await this.writeMachinesData(s))}async renameMachine(t,i,s){const u=await this.readMachinesData(s),a=u.machines.find(({id:m})=>m===t);if(a){a.name=i,await this.writeMachinesData(u);const m=await this.currentMachineIdPromise;t===m&&this.storageService.store(h,i,-1,1)}}async setEnablements(t){const i=await this.readMachinesData();for(const[s,u]of t){const a=i.machines.find(m=>m.id===s);a&&(a.disabled=u?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(t){const i=this.storageService.get(h,-1);if(i)return i;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,u=new RegExp(`${(0,L.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let a=0;for(const m of t){const S=u.exec(m.name),_=S?parseInt(S[1]):0;a=_>a?_:a}return`${s} #${a+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const i=this.parse(this.userData);if(i.version!==nt.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(t){const i=JSON.stringify(t),s=await this.userDataSyncStoreService.writeResource(nt.RESOURCE,i,this.userData?.ref||null);this.userData={ref:s,content:i},this._onDidChange.fire()}async readUserData(t){if(this.userData){const i=t&&t.latest?t.latest[nt.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(nt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.logService.error(i)}return{version:nt.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",n=pe([Y(0,P.IEnvironmentService),Y(1,E.IFileService),Y(2,p.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncLogService),Y(5,I.IProductService)],n),e.UserDataSyncMachinesService=n}),define(ne[262],re([0,1,6,64,38,9,3,2,4,19,7,166,25,21,24,26,75,78]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const f="sync.disableMachineEventually",c="sync.sessionId",g="sync.storeUrl",l="sync.productQuality";let n=class extends P.Disposable{get syncUrl(){const i=this.storageService.get(g,-1);return i?I.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(g,i.toString(),-1,1):this.storageService.remove(g,-1)}get productQuality(){return this.storageService.get(l,-1)}set productQuality(i){i?this.storageService.store(l,i,-1,1):this.storageService.remove(l,-1)}constructor(i,s,u,a,m,S,_,$,A,U){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=u,this.userDataSyncEnablementService=a,this.userDataSyncService=m,this.logService=S,this.userDataSyncAccountService=_,this.telemetryService=$,this.userDataSyncMachinesService=A,this.storageService=U,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(u.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(m.onDidChangeLocal(R=>this.triggerSync([R],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,R])=>R)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:i,message:s}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(u=>this.onDidFinishSync(u))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,r.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,s,u){try{this.userDataSyncAccountService.account&&!u&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),s)this.updateEnablement(!1);else throw a}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const s=y.UserDataSyncError.toUserDataSyncError(i);s instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?E.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(f,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(f,-1)}async triggerSync(i,s,u){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",u)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};n=pe([Y(0,p.IProductService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,y.IUserDataSyncStoreService),Y(3,y.IUserDataSyncEnablementService),Y(4,y.IUserDataSyncService),Y(5,y.IUserDataSyncLogService),Y(6,w.IUserDataSyncAccountService),Y(7,h.ITelemetryService),Y(8,d.IUserDataSyncMachinesService),Y(9,v.IStorageService)],n),e.UserDataAutoSyncService=n;class o extends P.Disposable{constructor(i,s,u,a,m,S,_,$){super(),this.lastSyncUrl=i,this.interval=s,this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=a,this.userDataSyncService=m,this.userDataSyncMachinesService=S,this.logService=_,this.storageService=$,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(i,s){const u=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(m){if((0,L.isCancellationError)(m))return}return this.doSync(i,s,a)});return this.syncPromise=u,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!i&&(!(0,b.isEqual)(s.defaultUrl,i.defaultUrl)||!(0,b.isEqual)(s.insidersUrl,i.insidersUrl)||!(0,b.isEqual)(s.stableUrl,i.stableUrl))}async doSync(i,s,u){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),u.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const m=this.storageService.get(c,-1);if(m&&this.manifest&&m!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const S=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(u.isCancellationRequested)return;const _=S.find($=>$.isCurrent);if(_?.disabled)throw new y.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch($){throw new y.UserDataAutoSyncError((0,k.toErrorMessage)($),$ instanceof y.UserDataSyncError?$.code:"Unknown")}if(this.manifest&&this.manifest.session!==m&&this.storageService.store(c,this.manifest.session,-1,1),u.isCancellationRequested)return;_||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(m){this.logService.error(m),a=m}this._onDidFinishSync.fire(a)}register(i){return super._register(i)}}o.INTERVAL_SYNCING="Interval"}),define(ne[62],re([0,1,2,68,5,21]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,k.createDecorator)("IUserDataSyncProfilesStorageService");let T=class extends D.Disposable{constructor(b){super(),this.storageService=b}async readStorageData(b){return this.withProfileScopedStorageService(b,async I=>this.getItems(I))}async updateStorageData(b,I,C){return this.withProfileScopedStorageService(b,async p=>this.writeItems(p,I,C))}async withProfileScopedStorageService(b,I){if(this.storageService.hasScope(b))return I(this.storageService);const C=await this.createStorageDatabase(b),p=new P(C);try{await p.initialize();const v=await I(p);return await p.flush(),v}finally{p.dispose(),await this.closeAndDispose(C)}}getItems(b){const I=new Map,C=p=>{for(const v of b.keys(0,p))I.set(v,{value:b.get(v,0),target:p})};return C(0),C(1),I}writeItems(b,I,C){for(const[p,v]of I)b.store(p,v,0,C)}async closeAndDispose(b){try{await b.close()}finally{(0,D.isDisposable)(b)&&b.dispose()}}};T=pe([Y(0,L.IStorageService)],T),e.AbstractUserDataSyncProfilesStorageService=T;class P extends L.AbstractStorageService{constructor(b){super({flushInterval:100}),this.profileStorage=this._register(new r.Storage(b))}doInitialize(){return this.profileStorage.init()}getStorage(b){return b===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ne[263],re([0,1,6,22,9,3,46,2,27,7,17,14,113,29,33,77,13,5,70,8,21,24,31,20,41,238,111,26,62]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g,l,n,o,t,i,s,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function m($,A){const U=JSON.parse($.content);if($.version===1||$.version===2){const R=(await A.getInstalled(0)).filter(N=>N.isBuiltin);for(const N of U)$.version===1&&(N.enabled===!1&&(N.disabled=!0),delete N.enabled),$.version===2&&R.every(F=>!(0,h.areSameExtensions)(F.identifier,N.identifier))&&(N.installed=!0)}return U}let S=class pt extends t.AbstractSynchroniser{constructor(A,U,R,N,F,q,J,j,H,W,z,K,X,ce,B,G,O,M){super({syncResource:"extensions",profile:A},U,N,R,F,q,J,X,ce,W,K,G),this.extensionManagementService=j,this.ignoredExtensionsManagementService=H,this.extensionGalleryService=z,this.userDataSyncProfilesStorageService=O,this.instantiationService=M,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.profileLocation=A.extensionsResource,this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:V})=>!!V)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),L.Event.filter(O.onDidChange,x=>x.valueChanges.some(({profile:V,changes:ee})=>this.syncResource.profile.id===V.id&&ee.some(oe=>oe.key===v.DISABLED_EXTENSIONS_STORAGE_PATH))),B.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(A,U){const R=A.syncData?await m(A.syncData,this.extensionManagementService):null,N=U?.skippedExtensions||[],F=U?.builtinExtensions||[],q=U?.syncData?await m(U.syncData,this.extensionManagementService):null,J=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),j=await this.getLocalExtensions(J),H=this.ignoredExtensionsManagementService.getIgnoredExtensions(J);R?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:z}=(0,i.merge)(j,R,q,N,H,F),K={local:W,remote:z,content:this.getPreviewContent(j,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:z!==null?2:0},X=this.stringify(j,!1);return[{skippedExtensions:N,builtinExtensions:F,baseResource:this.baseResource,baseContent:q?this.stringify(q,!1):X,localResource:this.localResource,localContent:X,localExtensions:j,remoteResource:this.remoteResource,remoteExtensions:R,remoteContent:R?this.stringify(R,!1):null,previewResource:this.previewResource,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(A){const U=A.syncData?await m(A.syncData,this.extensionManagementService):null,R=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),N=await this.getLocalExtensions(R),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(R),{remote:q}=(0,i.merge)(N,U,U,A.skippedExtensions||[],F,A.builtinExtensions||[]);return q!==null}getPreviewContent(A,U,R,N){const F=[...U,...R],q=new Set,J=j=>{q.add(j.id.toLowerCase()),j.uuid&&q.add(j.uuid)};F.forEach(({identifier:j})=>J(j)),N.forEach(J);for(const j of A)q.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&q.has(j.identifier.uuid)||F.push(j);return this.stringify(F,!1)}async getMergeResult(A,U){return{...A.previewResult,hasConflicts:!1}}async getAcceptResult(A,U,R,N){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(A);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(A);if(this.extUri.isEqual(U,this.previewResource))return A.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(A){const U=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),R=this.ignoredExtensionsManagementService.getIgnoredExtensions(U),N=(0,i.merge)(A.localExtensions,null,null,A.skippedExtensions,R,A.builtinExtensions),{local:F,remote:q}=N;return{content:A.localContent,local:F,remote:q,localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:q!==null?2:0}}async acceptRemote(A){const U=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),R=this.ignoredExtensionsManagementService.getIgnoredExtensions(U),N=A.remoteContent?JSON.parse(A.remoteContent):null;if(N!==null){const F=(0,i.merge)(A.localExtensions,N,A.localExtensions,[],R,A.builtinExtensions),{local:q,remote:J}=F;return{content:A.remoteContent,local:q,remote:J,localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:A.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(A,U,R,N){let{skippedExtensions:F,localExtensions:q}=R[0][0];const{local:J,remote:j,localChange:H,remoteChange:W}=R[0][1];if(H===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),H!==0&&(await this.backupLocal(JSON.stringify(q)),F=await this.updateLocalExtensions(J.added,J.removed,J.updated,F)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const z=JSON.stringify(j.all);A=await this.updateRemoteUserData(z,N?null:A.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${j.added.length?` Added: ${JSON.stringify(j.added.map(K=>K.identifier.id))}.`:""}${j.updated.length?` Updated: ${JSON.stringify(j.updated.map(K=>K.identifier.id))}.`:""}${j.removed.length?` Removed: ${JSON.stringify(j.removed.map(K=>K.identifier.id))}.`:""}`)}if(U?.ref!==A.ref){this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`);const z=q.filter(K=>!K.installed).map(K=>K.identifier);await this.updateLastSyncUserData(A,{skippedExtensions:F,builtinExtensions:z}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${F.length?` Skipped: ${JSON.stringify(F.map(K=>K.identifier.id))}.`:""}`)}}async getAssociatedResources({uri:A}){return[{resource:this.extUri.joinPath(A,"extensions.json"),comparableResource:pt.EXTENSIONS_DATA_URI}]}async resolveContent(A){if(this.extUri.isEqual(A,pt.EXTENSIONS_DATA_URI)){const R=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(R),F=(await this.getLocalExtensions(R)).filter(q=>!N.some(J=>(0,h.areSameExtensions)({id:J},q.identifier)));return this.stringify(F,!0)}if(this.extUri.isEqual(this.remoteResource,A)||this.extUri.isEqual(this.baseResource,A)||this.extUri.isEqual(this.localResource,A)||this.extUri.isEqual(this.acceptedResource,A)){const R=await this.resolvePreviewContent(A);return R&&this.stringify(JSON.parse(R),!0)}let U=await super.resolveContent(A);if(U)return U;if(U=await super.resolveContent(this.extUri.dirname(A)),U){const R=this.parseSyncData(U);if(R)switch(this.extUri.basename(A)){case"extensions.json":return this.stringify(this.parseExtensions(R),!0)}}return null}stringify(A,U){return A.sort((R,N)=>!R.identifier.uuid&&N.identifier.uuid?-1:R.identifier.uuid&&!N.identifier.uuid?1:(0,E.compare)(R.identifier.id,N.identifier.id)),U?(0,T.toFormattedString)(A,{}):JSON.stringify(A)}async hasLocalData(){try{const A=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if((await this.getLocalExtensions(A)).some(R=>R.installed||R.disabled))return!0}catch{}return!1}async updateLocalExtensions(A,U,R,N){return this.withProfileScopedServices(async(F,q)=>{const J=[],j=[],H=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(U.length){const z=H.filter(({identifier:K,isBuiltin:X})=>!X&&U.some(ce=>(0,h.areSameExtensions)(K,ce)));await D.Promises.settled(z.map(async K=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,K.identifier.id),await this.extensionManagementService.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,K.identifier.id),J.push(K.identifier)}))}(A.length||R.length)&&await D.Promises.settled([...A,...R].map(async z=>{const K=H.find(ce=>(0,h.areSameExtensions)(ce.identifier,z.identifier));if(K&&K.isBuiltin){z.state&&K.manifest.version===z.version&&this.updateExtensionState(z.state,K,K.manifest.version,q),F.getDisabledExtensions().some(B=>(0,h.areSameExtensions)(B,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await F.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await F.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id))),J.push(z.identifier);return}const X=(await this.extensionGalleryService.getExtensions([{...z.identifier,preRelease:z.preRelease}],r.CancellationToken.None))[0];if(z.state&&(K?K.manifest.version===z.version:!!X)&&this.updateExtensionState(z.state,K||X,K?.manifest.version,q),X)try{F.getDisabledExtensions().some(B=>(0,h.areSameExtensions)(B,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,X.version),await F.disableExtension(X.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,X.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,X.version),await F.enableExtension(X.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,X.version))),(!K||K.preRelease!==z.preRelease)&&(await this.extensionManagementService.canInstall(X)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,X.version),await this.extensionManagementService.installFromGallery(X,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:z.preRelease,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,X.version),J.push(X.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,X.displayName||X.identifier.id),j.push(z)))}catch(ce){j.push(z),ce instanceof v.ExtensionManagementError&&[v.ExtensionManagementErrorCode.Incompatible,v.ExtensionManagementErrorCode.IncompatiblePreRelease,v.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ce.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,X.displayName||X.identifier.id):(this.logService.error(ce),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,X.displayName||X.identifier.id))}else j.push(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,z.identifier.id)}));const W=[];for(const z of N)J.some(K=>(0,h.areSameExtensions)(K,z.identifier))||W.push(z);for(const z of j)W.some(K=>(0,h.areSameExtensions)(K.identifier,z.identifier))||W.push(z);return W})}updateExtensionState(A,U,R,N){const F=N.getExtensionState(U,!0)||{},q=R?N.getKeysForSync({id:U.identifier.id,version:R}):void 0;q?q.forEach(J=>{F[J]=A[J]}):Object.keys(A).forEach(J=>F[J]=A[J]),N.setExtensionState(U,F,!0)}parseExtensions(A){return JSON.parse(A.content)}getLocalExtensions(A){return this.withProfileScopedServices(async(U,R)=>{const N=U.getDisabledExtensions();return A.map(F=>{const{identifier:q,isBuiltin:J,manifest:j,preRelease:H}=F,W={identifier:q,preRelease:H,version:j.version};N.some(z=>(0,h.areSameExtensions)(z,q))&&(W.disabled=!0),J||(W.installed=!0);try{const z=R.getKeysForSync({id:q.id,version:j.version});if(z){const K=R.getExtensionState(F,!0)||{};W.state=Object.keys(K).reduce((X,ce)=>(z.includes(ce)&&(X[ce]=K[ce]),X),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(z))}return W})})}async withProfileScopedServices(A){return this.userDataSyncProfilesStorageService.withProfileScopedStorageService(this.syncResource.profile,async U=>{const R=new P.DisposableStore,N=this.instantiationService.createChild(new f.ServiceCollection([g.IStorageService,U])),F=R.add(N.createInstance(p.GlobalExtensionEnablementService)),q=R.add(N.createInstance(y.ExtensionStorageService));try{return await A(F,q)}finally{R.dispose()}})}};S.EXTENSIONS_DATA_URI=b.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),S=pe([Y(2,C.IEnvironmentService),Y(3,w.IFileService),Y(4,g.IStorageService),Y(5,u.IUserDataSyncStoreService),Y(6,u.IUserDataSyncBackupStoreService),Y(7,v.IExtensionManagementService),Y(8,s.IIgnoredExtensionsManagementService),Y(9,u.IUserDataSyncLogService),Y(10,v.IExtensionGalleryService),Y(11,I.IConfigurationService),Y(12,u.IUserDataSyncEnablementService),Y(13,l.ITelemetryService),Y(14,y.IExtensionStorageService),Y(15,n.IUriIdentityService),Y(16,a.IUserDataSyncProfilesStorageService),Y(17,d.IInstantiationService)],S),e.ExtensionsSynchroniser=S;let _=class extends t.AbstractInitializer{constructor(A,U,R,N,F,q,J){super("extensions",N,F,q,R,J),this.extensionManagementService=A,this.ignoredExtensionsManagementService=U}async parseExtensions(A){return A.syncData?await m(A.syncData,this.extensionManagementService):null}generatePreview(A,U){const R=[],N=[],F=[];for(const q of A){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(q.identifier.id))continue;const J=U.find(j=>(0,h.areSameExtensions)(j.identifier,q.identifier));J?(R.push(J),q.disabled&&F.push(q.identifier)):q.installed&&(N.push({...q.identifier,preRelease:!!q.preRelease}),q.disabled&&F.push(q.identifier))}return{installedExtensions:R,newExtensions:N,disabledExtensions:F,remoteExtensions:A}}};_=pe([Y(0,v.IExtensionManagementService),Y(1,s.IIgnoredExtensionsManagementService),Y(2,w.IFileService),Y(3,o.IUserDataProfilesService),Y(4,C.IEnvironmentService),Y(5,c.ILogService),Y(6,n.IUriIdentityService)],_),e.AbstractExtensionsInitializer=_}),define(ne[264],re([0,1,16,9,3,35,46,4,7,30,17,14,13,8,48,21,24,31,41,61,242,26,20,62]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g,l,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",i=["locale"];function s(_,$){const A=_.storage?Object.keys(_.storage).sort():[],U={};return A.forEach(R=>U[R]=_.storage[R]),_.storage=U,$?(0,T.toFormattedString)(_,{}):JSON.stringify(_)}const u=1;let a=class vt extends f.AbstractSynchroniser{constructor($,A,U,R,N,F,q,J,j,H,W,z,K){super({syncResource:"globalState",profile:$},A,R,J,z,N,F,j,H,q,W,K),this.userDataSyncProfilesStorageService=U,this.version=u,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(R.onDidFilesChange,X=>X.contains(this.environmentService.argvResource)),k.Event.filter(this.userDataSyncProfilesStorageService.onDidChange,X=>!!(X.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||X.valueChanges.some(({profile:ce,changes:B})=>this.syncResource.profile.id===ce.id&&B.some(G=>G.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview($,A,U){const R=$.syncData?JSON.parse($.syncData.content):null;A=A===null&&U?$:A;const N=A&&A.syncData?JSON.parse(A.syncData.content):null,F=await this.getLocalGlobalState();R?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=await this.getStorageKeys(N),{local:J,remote:j}=(0,g.merge)(F.storage,R?R.storage:null,N?N.storage:null,q,this.logService),H={content:null,local:J,remote:j,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:j!==null?2:0},W=s(F,!1);return[{baseResource:this.baseResource,baseContent:N?s(N,!1):W,localResource:this.localResource,localContent:W,localUserData:F,remoteResource:this.remoteResource,remoteContent:R?s(R,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async hasRemoteChanged($){const A=$.syncData?JSON.parse($.syncData.content):null;if(A===null)return!0;const U=await this.getLocalGlobalState(),R=await this.getStorageKeys(A),{remote:N}=(0,g.merge)(U.storage,A.storage,A.storage,R,this.logService);return N!==null}async getMergeResult($,A){return{...$.previewResult,hasConflicts:!1}}async getAcceptResult($,A,U,R){if(this.extUri.isEqual(A,this.localResource))return this.acceptLocal($);if(this.extUri.isEqual(A,this.remoteResource))return this.acceptRemote($);if(this.extUri.isEqual(A,this.previewResource))return $.previewResult;throw new Error(`Invalid Resource: ${A.toString()}`)}async acceptLocal($){return{content:$.localContent,local:{added:{},removed:[],updated:{}},remote:$.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote($){if($.remoteContent!==null){const A=JSON.parse($.remoteContent),{local:U,remote:R}=(0,g.merge)($.localUserData.storage,A.storage,null,$.storageKeys,this.logService);return{content:$.remoteContent,local:U,remote:R,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:R!==null?2:0}}else return{content:$.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult($,A,U,R){const{localUserData:N}=U[0][0],{local:F,remote:q,localChange:J,remoteChange:j}=U[0][1];if(J===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(F),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const H=JSON.stringify({storage:q});$=await this.updateRemoteUserData(H,R?null:$.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}A?.ref!==$.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData($),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:$}){return[{resource:this.extUri.joinPath($,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent($){if(this.extUri.isEqual($,vt.GLOBAL_STATE_DATA_URI)){const U=await this.getLocalGlobalState();return s(U,!0)}if(this.extUri.isEqual(this.remoteResource,$)||this.extUri.isEqual(this.baseResource,$)||this.extUri.isEqual(this.localResource,$)||this.extUri.isEqual(this.acceptedResource,$)){const U=await this.resolvePreviewContent($);return U&&s(JSON.parse(U),!0)}let A=await super.resolveContent($);if(A)return A;if(A=await super.resolveContent(this.extUri.dirname($)),A){const U=this.parseSyncData(A);if(U)switch(this.extUri.basename($)){case"globalState.json":return s(JSON.parse(U.content),!0)}}return null}async hasLocalData(){try{const{storage:$}=await this.getLocalGlobalState();if(Object.keys($).length>1||$[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const $={};if(this.syncResource.profile.isDefault){const U=await this.getLocalArgvContent(),R=(0,L.parse)(U);for(const N of i)R[N]!==void 0&&($[`${t}${N}`]={version:1,value:R[N]})}const A=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile);for(const[U,R]of A)R.value&&R.target===0&&($[U]={version:1,value:R.value});return{storage:$}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const $=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),$.value.toString()}catch($){this.logService.debug((0,r.getErrorMessage)($))}return"{}"}async writeLocalGlobalState({added:$,removed:A,updated:U}){const R={},N=new Map,F=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),q=(J,j)=>{for(const H of J){if(H.startsWith(t)){R[H.substring(t.length)]=j?j[H].value:void 0;continue}if(j){const W=j[H];W.value!==F.get(H)?.value&&N.set(H,W.value)}else F.get(H)!==void 0&&N.set(H,void 0)}};q(Object.keys($),$),q(Object.keys(U),U),q(A),Object.keys(R).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(R),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),N.size&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(this.syncResource.profile,N,0),this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,[...N.keys()]))}async updateArgv($){const A=await this.getLocalArgvContent();let U=A;for(const R of Object.keys($))U=(0,c.edit)(U,[R],$[R],{});A!==U&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(U)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}async getStorageKeys($){const A=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),U=[],R=[];for(const[q,J]of A)J.target===0?U.push(q):J.target===1&&R.push(q);const N=[...U,...R],F=$?.storage?Object.keys($.storage).filter(q=>!q.startsWith(t)&&!N.includes(q)&&A.get(q)!==void 0):[];if(!P.isWeb){const q=[...l.ALL_SYNC_RESOURCES.map(J=>(0,l.getEnablementKey)(J)),l.SYNC_SERVICE_URL_TYPE];F.push(...q),R.push(...q)}return{user:U,machine:R,unregistered:F}}};a.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=pe([Y(2,o.IUserDataSyncProfilesStorageService),Y(3,p.IFileService),Y(4,l.IUserDataSyncStoreService),Y(5,l.IUserDataSyncBackupStoreService),Y(6,l.IUserDataSyncLogService),Y(7,C.IEnvironmentService),Y(8,l.IUserDataSyncEnablementService),Y(9,w.ITelemetryService),Y(10,I.IConfigurationService),Y(11,y.IStorageService),Y(12,d.IUriIdentityService)],a),e.GlobalStateSynchroniser=a;let m=class extends f.AbstractInitializer{constructor($,A,U,R,N,F){super("globalState",U,R,N,A,F),this.storageService=$}async doInitialize($){const A=$.syncData?JSON.parse($.syncData.content):null;if(!A){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const U={},R={};for(const N of Object.keys(A.storage))N.startsWith(t)?U[N.substring(t.length)]=A.storage[N].value:this.storageService.get(N,0)===void 0&&(R[N]=A.storage[N].value);if(Object.keys(U).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const F of Object.keys(U))N=(0,c.edit)(N,[F],U[F],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(N))}if(Object.keys(R).length)for(const N of Object.keys(R))this.storageService.store(N,R[N],0,0)}};m=pe([Y(0,y.IStorageService),Y(1,p.IFileService),Y(2,n.IUserDataProfilesService),Y(3,C.IEnvironmentService),Y(4,l.IUserDataSyncLogService),Y(5,d.IUriIdentityService)],m),e.GlobalStateInitializer=m;let S=class{constructor($,A,U,R,N){this.userDataSyncStoreClient=$,this.storageService=A,this.environmentService=U,this.fileService=R,this.logService=N}getSyncStoreType($){return this.parseGlobalState($)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync($){const A=(0,l.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync($,A)}catch(U){if(U instanceof l.UserDataSyncError)switch(U.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync($,A)}throw U}}async doSync($,A){const U=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,A),R=this.parseGlobalState(U)||{storage:{}};R.storage[l.SYNC_SERVICE_URL_TYPE]={value:$,version:u};const N=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),F={version:u,machineId:N,content:s(R,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(F),U.ref,void 0,A)}parseGlobalState({content:$}){if(!$)return null;const A=JSON.parse($);if((0,f.isSyncData)(A))return A?JSON.parse(A.content):null;throw new Error("Invalid remote data")}};S=pe([Y(1,y.IStorageService),Y(2,C.IEnvironmentService),Y(3,p.IFileService),Y(4,v.ILogService)],S),e.UserDataSyncStoreTypeSynchronizer=S}),define(ne[265],re([0,1,18,6,22,38,3,2,19,15,30,17,14,29,5,25,21,24,20,263,264,255,256,257,258,259,26]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g,l,n,o,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const u="sync.lastSyncTime";let a=class extends P.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(A,U,R,N,F,q,J,j,H,W){super(),this.userDataSyncStoreService=A,this.userDataSyncStoreManagementService=U,this.instantiationService=R,this.logService=N,this.telemetryService=F,this.storageService=q,this.userDataSyncEnablementService=J,this.userDataProfilesService=j,this.productService=H,this.environmentService=W,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=U.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(u,-1,void 0),this._register((0,P.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(A,U){this.checkEnablement(),this.logService.info("Sync started.");const R=new Date().getTime(),N=(0,I.generateUuid)();try{const j=(0,s.createSyncHeaders)(N);U&&(j["Cache-Control"]="no-cache"),A=await this.userDataSyncStoreService.manifest(A,j)}catch(j){const H=s.UserDataSyncError.toUserDataSyncError(j);throw _(H,N,this.userDataSyncStoreManagementService,this.telemetryService),H}const F=!1,q=this;let J;return{manifest:A,async run(){if(F)throw new Error("Can run a task only once");J=(0,r.createCancelablePromise)(j=>q.sync(A,!1,N,j)),await J.finally(()=>J=void 0),q.logService.info(`Sync done. Took ${new Date().getTime()-R}ms`),q.updateLastSyncTime()},stop(){return J?.cancel(),q.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const A=new Date().getTime(),U=(0,I.generateUuid)(),R=(0,s.createSyncHeaders)(U);let N;try{N=await this.userDataSyncStoreService.manifest(null,R)}catch(J){const j=s.UserDataSyncError.toUserDataSyncError(J);throw _(j,U,this.userDataSyncStoreManagementService,this.telemetryService),j}await this.resetLocal();const F=this,q=new k.CancellationTokenSource;return{id:U,async merge(){return F.sync(N,!0,U,q.token)},async apply(){await F.applyManualSync(N,U,q.token),F.logService.info(`Sync done. Took ${new Date().getTime()-A}ms`),F.updateLastSyncTime()},stop(){return q.cancel(),F.stop()},dispose(){q.cancel(),F.stop()}}}async sync(A,U,R,N){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,A,U,R,N));const q=F.enabled.find(J=>J.resource==="profiles");if(q){const J=await q.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(J,A,U,R,N)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(A,U,R,N,F){for(const q of A){if(F.isCancellationRequested)return;const J=this.userDataProfilesService.profiles.find(H=>H.id===q.id);if(!J){this.logService.error(`Settings Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",q.name);const j=this.getOrCreateActiveProfileSynchronizer(J,q);this._syncErrors.push(...await this.syncProfile(j,U,R,N,F))}}async applyManualSync(A,U,R){const N=this.getActiveProfileSynchronizers();for(const H of N){if(R.isCancellationRequested)return;await H.apply(U,R)}const F=N.find(H=>H.profile.isDefault);if(!F)return;const q=F.enabled.find(H=>H.resource==="profiles");if(!q)return;const j=(await q.getRemoteSyncedProfiles(A?.latest??null)||[]).filter(H=>N.every(W=>W.profile.id!==H.id));j.length&&await this.syncRemoteProfiles(j,A,!1,U,R)}async syncProfile(A,U,R,N,F){return(await A.sync(U,R,N,F)).map(([J,j])=>({profile:A.profile,syncResource:J,error:j}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(A=>A.stop()))}async resolveContent(A){for(const U of this.userDataProfilesService.profiles){const R=await this.performAction(U,async N=>{const F=await N.resolveContent(A);if(F)return F});if(!(0,b.isUndefinedOrNull)(R))return R}return null}async replace(A,U){this.checkEnablement(),await this.performAction(A.profile,async R=>{if(A.syncResource===R.resource)return await R.replace(U),!0})}async accept(A,U,R,N){this.checkEnablement(),await this.performAction(A.profile,async F=>{if(A.syncResource===F.resource)return await F.accept(U,R),N&&await F.apply((0,b.isBoolean)(N)?!1:N.force,(0,s.createSyncHeaders)((0,I.generateUuid)())),!0})}async getRemoteSyncResourceHandles(A){return await this.performAction(A.profile,async R=>{if(R.resource===A.syncResource)return R.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(A){return await this.performAction(A.profile,async R=>{if(R.resource===A.syncResource)return R.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(A,U){return await this.performAction(A.profile,async N=>{if(N.resource===A.syncResource)return N.getAssociatedResources(U)})||[]}async getMachineId(A,U){return await this.performAction(A.profile,async N=>{if(N.resource===A.syncResource)return await N.getMachineId(U)||null})||void 0}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async U=>{if(U.resource!=="globalState"&&await U.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async U=>{if(await U.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(A){this.logService.error(A)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this.storageService.remove(u,-1);for(const[A]of this.activeProfileSynchronizers.values())try{await A.resetLocal()}catch(U){this.logService.error(U)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(A,U){const R=new P.DisposableStore;try{const N=this.activeProfileSynchronizers.get(A.id);if(N){const H=await this.performActionWithProfileSynchronizer(N[0],U,R);return(0,b.isUndefined)(H)?null:H}if(A.isDefault){const H=R.add(this.instantiationService.createInstance(m,A,void 0)),W=await this.performActionWithProfileSynchronizer(H,U,R);return(0,b.isUndefined)(W)?null:W}if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,E.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl)))return null;const F=R.add(this.instantiationService.createInstance(i.UserDataProfilesManifestSynchroniser,A,void 0)),q=await this.userDataSyncStoreService.manifest(null),j=(await F.getRemoteSyncedProfiles(q?.latest??null)||[]).find(H=>H.id===A.id);if(j){const H=R.add(this.instantiationService.createInstance(m,A,j.collection)),W=await this.performActionWithProfileSynchronizer(H,U,R);return(0,b.isUndefined)(W)?null:W}return null}finally{R.dispose()}}async performActionWithProfileSynchronizer(A,U,R){const N=[...A.enabled,...A.disabled.map(F=>R.add(A.createSynchronizer(F)))];for(const F of N){const q=await U(F);if(!(0,b.isUndefined)(q))return q}}setStatus(A){const U=this._status;this._status!==A&&(this._status=A,this._onDidChangeStatus.fire(A),U==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const A=this.getActiveProfileSynchronizers().map(U=>U.conflicts).flat();(0,D.equals)(this._conflicts,A,(U,R)=>U.profile.id===R.profile.id&&U.syncResource===R.syncResource&&(0,D.equals)(U.conflicts,R.conflicts,(N,F)=>(0,E.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=A,this._onDidChangeConflicts.fire(A))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(u,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(A,U){let R=this.activeProfileSynchronizers.get(A.id);if(!R){const N=new P.DisposableStore,F=N.add(this.instantiationService.createInstance(m,A,U?.collection));N.add(F.onDidChangeStatus(q=>this.setStatus(q))),N.add(F.onDidChangeConflicts(q=>this.updateConflicts())),N.add(F.onDidChangeLocal(q=>this._onDidChangeLocal.fire(q))),this.activeProfileSynchronizers.set(A.id,R=[F,N])}return R[0]}getActiveProfileSynchronizers(){const A=[];for(const[U]of this.activeProfileSynchronizers.values())A.push(U);return A}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,A])=>A.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=pe([Y(0,s.IUserDataSyncStoreService),Y(1,s.IUserDataSyncStoreManagementService),Y(2,h.IInstantiationService),Y(3,s.IUserDataSyncLogService),Y(4,d.ITelemetryService),Y(5,w.IStorageService),Y(6,s.IUserDataSyncEnablementService),Y(7,f.IUserDataProfilesService),Y(8,y.IProductService),Y(9,p.IEnvironmentService)],a),e.UserDataSyncService=a;let m=class extends P.Disposable{get enabled(){return this._enabled.sort((A,U)=>A[1]-U[1]).map(([A])=>A)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(A=>!this.userDataSyncEnablementService.isResourceEnabled(A))}get status(){return this._status}get conflicts(){return this._conflicts}get profile(){return this._profile}constructor(A,U,R,N,F,q,J,j,H,W,z,K){super(),this._profile=A,this.collection=U,this.userDataSyncEnablementService=R,this.instantiationService=N,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=q,this.telemetryService=J,this.logService=j,this.productService=H,this.configurationService=z,this.environmentService=K,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._profile.isDefault&&this._register(W.onDidChangeProfiles(()=>{if(W.defaultProfile.extensionsResource&&!this._profile.extensionsResource||!W.defaultProfile.extensionsResource&&this._profile.extensionsResource){this._profile=W.defaultProfile;for(const[X]of this._enabled)X instanceof c.ExtensionsSynchroniser&&(X.profileLocation=this._profile.extensionsResource)}})),this._register(R.onDidChangeResourceEnablement(([X,ce])=>this.onDidChangeResourceEnablement(X,ce))),this._register((0,P.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,X])=>X.dispose())));for(const X of s.ALL_SYNC_RESOURCES)R.isResourceEnabled(X)&&this.registerSynchronizer(X)}onDidChangeResourceEnablement(A,U){U?this.registerSynchronizer(A):this.deRegisterSynchronizer(A)}registerSynchronizer(A){if(this._enabled.some(([F])=>F.resource===A))return;if(A==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(A==="profiles"){if(!this._profile.isDefault)return;if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,E.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl))){this.logService.debug("Skipping profiles sync");return}}const U=new P.DisposableStore,R=U.add(this.createSynchronizer(A));U.add(R.onDidChangeStatus(()=>this.updateStatus())),U.add(R.onDidChangeConflicts(()=>this.updateConflicts())),U.add(R.onDidChangeLocal(()=>this._onDidChangeLocal.fire(A)));const N=this.getOrder(A);this._enabled.push([R,N,U])}deRegisterSynchronizer(A){const U=this._enabled.findIndex(([R])=>R.resource===A);if(U!==-1){const R=this._enabled.splice(U,1);for(const[N,,F]of R){if(N.status!=="idle"){const q=N.conflicts.conflicts.length>0;N.stop(),q&&this.updateConflicts(),this.updateStatus()}F.dispose()}}}createSynchronizer(A){switch(A){case"settings":return this.instantiationService.createInstance(n.SettingsSynchroniser,this._profile,this.collection);case"keybindings":return this.instantiationService.createInstance(l.KeybindingsSynchroniser,this._profile,this.collection);case"snippets":return this.instantiationService.createInstance(o.SnippetsSynchroniser,this._profile,this.collection);case"tasks":return this.instantiationService.createInstance(t.TasksSynchroniser,this._profile,this.collection);case"globalState":return this.instantiationService.createInstance(g.GlobalStateSynchroniser,this._profile,this.collection);case"extensions":return this.instantiationService.createInstance(c.ExtensionsSynchroniser,this._profile,this.collection);case"profiles":return this.instantiationService.createInstance(i.UserDataProfilesManifestSynchroniser,this._profile,this.collection)}}async sync(A,U,R,N){if(N.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const q=[],J=(0,s.createSyncHeaders)(R),j=(this.collection?A?.collections?.[this.collection]?.latest:A?.latest)??null,H=U?await this.getUserDataSyncConfiguration(j):{};for(const W of F){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(W.resource))return[];try{if(U){const z=await W.preview(j,H,J);if(z)for(const K of z.resourcePreviews)(K.localChange!==0||K.remoteChange!==0)&&K.mergeState==="preview"&&await W.merge(K.previewResource)}else await W.sync(j,J)}catch(z){const K=s.UserDataSyncError.toUserDataSyncError(z);if(_(K,R,this.userDataSyncStoreManagementService,this.telemetryService),S(z))throw K;this.logService.error(z),this.logService.error(`${W.resource}: ${(0,L.toErrorMessage)(z)}`),q.push([W.resource,K])}}return q}finally{this.updateStatus()}}async apply(A,U){const R=(0,s.createSyncHeaders)(A);for(const N of this.enabled){if(U.isCancellationRequested)return;try{await N.apply(!1,R)}catch(F){const q=s.UserDataSyncError.toUserDataSyncError(F);if(_(q,A,this.userDataSyncStoreManagementService,this.telemetryService),S(F))throw q;this.logService.error(F),this.logService.error(`${N.resource}: ${(0,L.toErrorMessage)(F)}`)}}}async stop(){for(const A of this.enabled)try{A.status!=="idle"&&await A.stop()}catch(U){this.logService.error(U)}}async resetLocal(){for(const A of this.enabled)try{await A.resetLocal()}catch(U){this.logService.error(`${A.resource}: ${(0,L.toErrorMessage)(U)}`),this.logService.error(U)}}async getUserDataSyncConfiguration(A){if(!this.profile.isDefault)return{};const U=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),R=this.enabled.find(N=>N instanceof n.SettingsSynchroniser);if(R){const N=await R.getRemoteUserDataSyncConfiguration(A);return{...U,...N}}return U}setStatus(A){this._status!==A&&(this._status=A,this._onDidChangeStatus.fire(A))}updateStatus(){return this.updateConflicts(),this.enabled.some(A=>A.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(A=>A.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const A=this.enabled.filter(U=>U.status==="hasConflicts").filter(U=>U.conflicts.conflicts.length>0).map(U=>U.conflicts);(0,D.equals)(this._conflicts,A,(U,R)=>U.syncResource===R.syncResource&&(0,D.equals)(U.conflicts,R.conflicts,(N,F)=>(0,E.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=A,this._onDidChangeConflicts.fire(A))}getOrder(A){switch(A){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};m=pe([Y(2,s.IUserDataSyncEnablementService),Y(3,h.IInstantiationService),Y(4,v.IExtensionGalleryService),Y(5,s.IUserDataSyncStoreManagementService),Y(6,d.ITelemetryService),Y(7,s.IUserDataSyncLogService),Y(8,y.IProductService),Y(9,f.IUserDataProfilesService),Y(10,C.IConfigurationService),Y(11,p.IEnvironmentService)],m);function S($){if($ instanceof s.UserDataSyncError)switch($.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function _($,A,U,R){R.publicLog2("sync/error",{code:$.code,serverCode:$ instanceof s.UserDataSyncStoreError?String($.serverCode):void 0,url:$ instanceof s.UserDataSyncStoreError?$.url:void 0,resource:$.resource,executionId:A,service:U.userDataSyncStore.url.toString()})}}),define(ne[266],re([0,1,3,2,7,20,26]),function(Q,e,D,r,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(C,p){return{...C,profile:(0,L.reviveProfile)(C.profile,p.profilesHome.scheme)}}class E{constructor(p,v,h){this.service=p,this.userDataProfilesService=v,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(p,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(p,v,h){try{return await this._call(p,v,h)}catch(y){throw this.logService.error(y),y}}async _call(p,v,h){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(k.URI.revive(h[0]));case"accept":return this.service.accept(P(h[0],this.userDataProfilesService),k.URI.revive(h[1]),h[2],h[3]);case"replace":return this.service.replace(P(h[0],this.userDataProfilesService),k.URI.revive(h[1]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(P(h[0],this.userDataProfilesService));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(P(h[0],this.userDataProfilesService));case"getAssociatedResources":return this.service.getAssociatedResources(P(h[0],this.userDataProfilesService),{created:h[1].created,uri:k.URI.revive(h[1].uri)});case"getMachineId":return this.service.getMachineId(P(h[0],this.userDataProfilesService),{created:h[1].created,uri:k.URI.revive(h[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const y=v.substring(11),w=h[0],d=this.getManualSyncTask(w);switch(h=h.slice(1),y){case"merge":return d.merge();case"apply":return d.apply();case"stop":return d.stop();case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(p){const v=this.manualSyncTasks.get(this.createKey(p));if(!v)throw new Error(`Manual sync taks not found: ${p}`);return v.manualSyncTask}async createManualSyncTask(){const p=new r.DisposableStore,v=p.add(await this.service.createManualSyncTask());return this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:p}),v.id}disposeManualSyncTask(p){p.dispose();const v=this.createKey(p.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=E;let b=class extends r.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(p,v){super(),this.userDataProfilesService=v,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,y,w){return p.call(h,y,w).then(null,d=>{throw T.UserDataSyncError.toUserDataSyncError(d)})},listen(h,y){return p.listen(h,y)}},this.channel.call("_getInitialData").then(([h,y,w])=>{this.updateStatus(h),this.updateConflicts(y),w&&this.updateLastSyncTime(w),this._register(this.channel.listen("onDidChangeStatus")(d=>this.updateStatus(d))),this._register(this.channel.listen("onDidChangeLastSyncTime")(d=>this.updateLastSyncTime(d)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(y=>({...y,error:T.UserDataSyncError.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.channel.call("createManualSyncTask"),v=this;return new I(p,{async call(y,w,d){return v.channel.call(`manualSync/${y}`,[p,...Array.isArray(w)?w:[w]],d)},listen(){throw new Error("not supported")}})}replace(p,v){return this.channel.call("replace",[p,v])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(p,v,h,y){return this.channel.call("accept",[p,v,h,y])}resolveContent(p){return this.channel.call("resolveContent",[p])}async getLocalSyncResourceHandles(p){return(await this.channel.call("getLocalSyncResourceHandles",[p])).map(({created:h,uri:y})=>({created:h,uri:k.URI.revive(y)}))}async getRemoteSyncResourceHandles(p){return(await this.channel.call("getRemoteSyncResourceHandles",[p])).map(({created:h,uri:y})=>({created:h,uri:k.URI.revive(y)}))}async getAssociatedResources(p,v){return(await this.channel.call("getAssociatedResources",[p,v])).map(({resource:y,comparableResource:w})=>({resource:k.URI.revive(y),comparableResource:k.URI.revive(w)}))}async getMachineId(p,v){return this.channel.call("getMachineId",[p,v])}async updateStatus(p){this._status=p,this._onDidChangeStatus.fire(p)}async updateConflicts(p){this._conflicts=p.map(v=>({syncResource:v.syncResource,profile:(0,L.reviveProfile)(v.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:v.conflicts.map(h=>({...h,baseResource:k.URI.revive(h.baseResource),localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(p){this._lastSyncTime!==p&&(this._lastSyncTime=p,this._onDidChangeLastSyncTime.fire(p))}};b=pe([Y(1,L.IUserDataProfilesService)],b),e.UserDataSyncChannelClient=b;class I extends r.Disposable{constructor(p,v){super(),this.id=p,this.channel=v}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(ne[267],re([0,1,6,22,9,3,2,128,4,19,15,7,30,17,14,13,25,45,48,21,26]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",n="sync.donot-make-requests-until",o="sync.user-session-id",t="sync.machine-session-id",i=100,s=1e3*60*5;let u=class extends T.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(g.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(A){this.storageService.store(g.SYNC_SERVICE_URL_TYPE,A,-1,E.isWeb?0:1)}constructor(A,U,R){super(),this.productService=A,this.configurationService=U,this.storageService=R,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(R.onDidChangeValue,N=>N.key===g.SYNC_SERVICE_URL_TYPE&&N.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[g.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(g.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,U){A=E.isWeb&&A?.web?{...A,...A.web}:A;const R={...A||{},...U||{}};if(R&&(0,I.isString)(R.url)&&(0,I.isObject)(R.authenticationProviders)&&Object.keys(R.authenticationProviders).every(N=>Array.isArray(R.authenticationProviders[N].scopes))){const N=R,F=!!N.canSwitch&&!U?.url,q=N.url===N.insidersUrl?"insiders":"stable",J=(F?this.userDataSyncStoreType:void 0)||q,j=U?.url||(J==="insiders"?N.insidersUrl:J==="stable"?N.stableUrl:N.url);return{url:C.URI.parse(j),type:J,defaultType:q,defaultUrl:C.URI.parse(N.url),stableUrl:C.URI.parse(N.stableUrl),insidersUrl:C.URI.parse(N.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(N.authenticationProviders).reduce((H,W)=>(H.push({id:W,scopes:N.authenticationProviders[W].scopes}),H),[])}}}};u=pe([Y(0,w.IProductService),Y(1,v.IConfigurationService),Y(2,c.IStorageService)],u),e.AbstractUserDataSyncStoreManagementService=u;let a=class extends u{constructor(A,U,R){super(A,U,R);const N=this.storageService.get(l,-1);N&&(this.previousConfigurationSyncStore=JSON.parse(N));const F=this.productService[g.CONFIGURATION_SYNC_STORE_KEY];F?this.storageService.store(l,JSON.stringify(F),-1,1):this.storageService.remove(l,-1)}async switch(A){A!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=A,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=pe([Y(0,w.IProductService),Y(1,v.IConfigurationService),Y(2,c.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let m=class extends T.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(A,U,R,N,F,q,J){super(),this.requestService=R,this.logService=N,this.storageService=J,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=(0,f.getServiceMachineId)(F,q,J).then(j=>{const H={"X-Client-Name":`${U.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(H["X-Client-Commit"]=U.commit),H}),this.session=new _(i,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(A,U){this.authToken={token:A,type:U}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?(0,b.joinPath)(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(n,-1);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){this._donotMakeRequestsUntil?.getTime()!==A?.getTime()&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(U=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]="application/json";const R=await this.request(U,{type:"GET",headers:A},[],r.CancellationToken.None);return await(0,d.asJson)(R)||[]}async createCollection(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]=P.Mimes.text;const R=await this.request(U,{type:"POST",headers:A},[],r.CancellationToken.None),N=await(0,d.asTextOrError)(R);if(!N)throw new g.UserDataSyncStoreError("Server did not return the collection id",U,"NoCollection",R.res.statusCode,R.res.headers[g.HEADER_OPERATION_ID]);return N}async deleteCollection(A,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=A?(0,b.joinPath)(this.userDataSyncStoreUrl,"collection",A).toString():(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},await this.request(R,{type:"DELETE",headers:U},[],r.CancellationToken.None)}async getAllResourceRefs(A,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=this.getResourceUrl(this.userDataSyncStoreUrl,U,A),N={},F=await this.request(R.toString(),{type:"GET",headers:N},[],r.CancellationToken.None);return(await(0,d.asJson)(F)||[]).map(({url:J,created:j})=>({ref:(0,b.relativePath)(R,R.with({path:J})),created:j*1e3}))}async resolveResourceContent(A,U,R,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,R,A),U).toString();N={...N},N["Cache-Control"]="no-cache";const q=await this.request(F,{type:"GET",headers:N},[],r.CancellationToken.None);return await(0,d.asTextOrError)(q)}async deleteResource(A,U,R){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=U!==null?(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,R,A),U).toString():this.getResourceUrl(this.userDataSyncStoreUrl,R,A).toString(),F={};await this.request(N,{type:"DELETE",headers:F},[],r.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":P.Mimes.text};await this.request(A,{type:"DELETE",headers:U},[],r.CancellationToken.None)}async readResource(A,U,R,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,R,A),"latest").toString();N={...N},N["Cache-Control"]="no-cache",U&&(N["If-None-Match"]=U.ref);const q=await this.request(F,{type:"GET",headers:N},[304],r.CancellationToken.None);let J=null;if(q.res.statusCode===304&&(J=U),J===null){const j=q.res.headers.etag;if(!j)throw new g.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",q.res.statusCode,q.res.headers[g.HEADER_OPERATION_ID]);const H=await(0,d.asTextOrError)(q);if(!H&&q.res.statusCode===304)throw new g.UserDataSyncStoreError("Empty response",F,"EmptyResponse",q.res.statusCode,q.res.headers[g.HEADER_OPERATION_ID]);J={ref:j,content:H}}return J}async writeResource(A,U,R,N,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=this.getResourceUrl(this.userDataSyncStoreUrl,N,A).toString();F={...F},F["Content-Type"]=P.Mimes.text,R&&(F["If-Match"]=R);const J=await this.request(q,{type:"POST",data:U,headers:F},[],r.CancellationToken.None),j=J.res.headers.etag;if(!j)throw new g.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",J.res.statusCode,J.res.headers[g.HEADER_OPERATION_ID]);return j}async manifest(A,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const R=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",A&&(U["If-None-Match"]=A.ref);const N=await this.request(R,{type:"GET",headers:U},[304],r.CancellationToken.None);let F=null;if(N.res.statusCode===304&&(F=A),!F){const J=N.res.headers.etag;if(!J)throw new g.UserDataSyncStoreError("Server did not return the ref",R,"NoRef",N.res.statusCode,N.res.headers[g.HEADER_OPERATION_ID]);const j=await(0,d.asTextOrError)(N);if(!j&&N.res.statusCode===304)throw new g.UserDataSyncStoreError("Empty response",R,"EmptyResponse",N.res.statusCode,N.res.headers[g.HEADER_OPERATION_ID]);j&&(F={...JSON.parse(j),ref:J})}const q=this.storageService.get(o,-1);return q&&F&&q!==F.session&&this.clearSession(),F===null&&q&&this.clearSession(),F&&this.storageService.store(o,F.session,-1,1),F}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(A,U,R){return U?(0,b.joinPath)(A,"collection",U,"resource",R):(0,b.joinPath)(A,"resource",R)}clearSession(){this.storageService.remove(o,-1),this.storageService.remove(t,-1)}async request(A,U,R,N){if(!this.authToken)throw new g.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new g.UserDataSyncStoreError(`${U.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const F=await this.commonHeadersPromise;U.headers={...U.headers||{},...F,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:A,type:U.type,headers:{...U.headers,authorization:void 0}});let q;try{q=await this.session.request(A,U,N)}catch(W){if(!(W instanceof g.UserDataSyncStoreError)){let z="RequestFailed";const K=(0,k.getErrorMessage)(W).toLowerCase();K.includes("xhr timeout")?z="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?z="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":K.includes("headers must be an object")?z="RequestHeadersNotObject":(0,k.isCancellationError)(W)&&(z="RequestCanceled"),W=new g.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,z,void 0,void 0)}throw this.logService.info("Request failed",A),W}const J=q.res.headers[g.HEADER_OPERATION_ID],j={url:A,status:q.res.statusCode,"execution-id":U.headers[g.HEADER_EXECUTION_ID],"operation-id":J},H=(0,d.isSuccess)(q)||q.res.statusCode&&R.indexOf(q.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),q.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new g.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",q.res.statusCode,J);if(this._onTokenSucceed.fire(),q.res.statusCode===409)throw new g.UserDataSyncStoreError(`${U.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",q.res.statusCode,J);if(q.res.statusCode===410)throw new g.UserDataSyncStoreError(`${U.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",q.res.statusCode,J);if(q.res.statusCode===412)throw new g.UserDataSyncStoreError(`${U.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",q.res.statusCode,J);if(q.res.statusCode===413)throw new g.UserDataSyncStoreError(`${U.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",q.res.statusCode,J);if(q.res.statusCode===426)throw new g.UserDataSyncStoreError(`${U.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",q.res.statusCode,J);if(q.res.statusCode===429){const W=q.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new g.UserDataSyncStoreError(`${U.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",q.res.statusCode,J)):new g.UserDataSyncStoreError(`${U.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",q.res.statusCode,J)}if(!H)throw new g.UserDataSyncStoreError("Server returned "+q.res.statusCode,A,"Unknown",q.res.statusCode,J);return q}addSessionHeaders(A){let U=this.storageService.get(t,-1);U===void 0&&(U=(0,p.generateUuid)(),this.storageService.store(t,U,-1,1)),A["X-Machine-Session-Id"]=U;const R=this.storageService.get(o,-1);R!==void 0&&(A["X-User-Session-Id"]=R)}};m=pe([Y(1,w.IProductService),Y(2,d.IRequestService),Y(3,g.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,y.IFileService),Y(6,c.IStorageService)],m),e.UserDataSyncStoreClient=m;let S=class extends m{constructor(A,U,R,N,F,q,J){super(A.userDataSyncStore?.url,U,R,N,F,q,J),this._register(A.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(A.userDataSyncStore?.url)))}};S=pe([Y(0,g.IUserDataSyncStoreManagementService),Y(1,w.IProductService),Y(2,d.IRequestService),Y(3,g.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,y.IFileService),Y(6,c.IStorageService)],S),e.UserDataSyncStoreService=S;class _{constructor(A,U,R,N){this.limit=A,this.interval=U,this.requestService=R,this.logService=N,this.requests=[],this.startTime=void 0}request(A,U,R){if(this.isExpired()&&this.reset(),U.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new g.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(U,R)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=_}),define(ne[268],re([0,1,3,59,25,21,24,262,26,75,78]),function(Q,e,D,r,k,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(v,h,y,w,d,f,c,g,l,n,o){super(v,h,y,w,d,c,g,l,n,o),this._register(D.Event.debounce(D.Event.any(D.Event.map(f.onDidFocusWindow,()=>"windowFocus"),D.Event.map(f.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};C=pe([Y(0,k.IProductService),Y(1,E.IUserDataSyncStoreManagementService),Y(2,E.IUserDataSyncStoreService),Y(3,E.IUserDataSyncEnablementService),Y(4,E.IUserDataSyncService),Y(5,r.INativeHostService),Y(6,E.IUserDataSyncLogService),Y(7,b.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,I.IUserDataSyncMachinesService),Y(10,L.IStorageService)],C),e.UserDataAutoSyncService=C}),define(ne[269],re([0,1,3,2,58,8,62,21,73,20]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let I=class extends T.AbstractUserDataSyncProfilesStorageService{constructor(p,v,h,y){super(h),this.mainProcessService=p;const w=p.getChannel("profileStorageListener"),d=this._register(new r.MutableDisposable);this._onDidChange=this._register(new D.Emitter({onFirstListenerAdd:()=>{d.value=w.listen("onDidChange")(f=>{y.trace("profile storage changes",f),this._onDidChange.fire({targetChanges:f.targetChanges.map(c=>(0,b.reviveProfile)(c,v.profilesHome.scheme)),valueChanges:f.valueChanges.map(c=>({...c,profile:(0,b.reviveProfile)(c.profile,v.profilesHome.scheme)}))})})},onLastListenerRemove:()=>d.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(p){const v=this.mainProcessService.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(p)?new E.ApplicationStorageDatabaseClient(v):new E.ProfileStorageDatabaseClient(v,p)}};I=pe([Y(0,k.IMainProcessService),Y(1,b.IUserDataProfilesService),Y(2,P.IStorageService),Y(3,L.ILogService)],I),e.UserDataSyncProfilesStorageService=I}),define(ne[270],re([0,1,97,23,4,19]),function(Q,e,D,r,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(b){function I(){let C=b.scheme===r.Schemas.file?(0,L.originalFSPath)(b):b.toString();return k.isLinux||(C=C.toLowerCase()),(0,D.createHash)("md5").update(C).digest("hex")}return{id:I(),configPath:b}}e.getWorkspaceIdentifier=T;function P(b,I){function C(){if(b.scheme!==r.Schemas.file)return(0,D.createHash)("md5").update(b.toString()).digest("hex");if(!I)return;let v;return k.isLinux?v=I.ino:k.isMacintosh?v=I.birthtime.getTime():k.isWindows&&(typeof I.birthtimeMs=="number"?v=Math.floor(I.birthtimeMs):v=I.birthtime.getTime()),(0,D.createHash)("md5").update(b.fsPath).update(v?String(v):"").digest("hex")}const p=C();if(typeof p=="string")return{id:p,uri:b}}e.getSingleFolderWorkspaceIdentifier=P;function E(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=E}),define(ne[271],re([0,1,6,9,2,12,28,14,58,8,59,73,112,270]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends k.Disposable{constructor(w,d,f,c){super(),this.environmentService=w,this.logService=d,this.nativeHostService=f,this.mainProcessService=c,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const w=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),d=new C.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(w.map(async f=>{const c=(0,L.join)(this.environmentService.workspaceStorageHome.fsPath,f);f.length===v.NON_EMPTY_WORKSPACE_ID_LENGTH||f===p.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===f)||await d.isUsed(c)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${f} as it seems to be an unused empty workspace.`),await T.Promises.rm(c))}))}catch(w){(0,r.onUnexpectedError)(w)}}};h=pe([Y(0,P.INativeEnvironmentService),Y(1,b.ILogService),Y(2,I.INativeHostService),Y(3,E.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(ne[114],re([0,1,53,6,12,15,28,140,280,281]),function(Q,e,D,r,k,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(n,o){let t=o.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=o}}e.ExtractError=I;function C(l){const n=l.externalFileAttributes>>16||33188;return[448,56,7].map(o=>n&o).reduce((o,t)=>o+t,n&61440)}function p(l){if(l instanceof I)return l;let n;return/end of central directory record signature not found/.test(l.message)&&(n="CorruptZip"),new I(n,l)}function v(l,n,o,t,i,s){const u=k.dirname(n),a=k.join(t,u);if(!a.startsWith(t))return Promise.reject(new Error(P.localize(0,null,n)));const m=k.join(t,n);let S;return s.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(T.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((_,$)=>{if(!s.isCancellationRequested)try{S=(0,D.createWriteStream)(m,{mode:o}),S.once("close",()=>_()),S.once("error",$),l.once("error",$),l.pipe(S)}catch(A){$(A)}}))}function h(l,n,o,t){let i=(0,r.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{i.cancel(),l.close()}),new Promise((u,a)=>{const m=new r.Sequencer,S=_=>{_.isCancellationRequested||(s++,l.readEntry())};l.once("error",a),l.once("close",()=>i.then(()=>{t.isCancellationRequested||l.entryCount===s?u():a(new I("Incomplete",new Error(P.localize(1,null,s,l.entryCount))))},a)),l.readEntry(),l.on("entry",_=>{if(t.isCancellationRequested)return;if(!o.sourcePathRegex.test(_.fileName)){S(t);return}const $=_.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test($)){const R=k.join(n,$);i=(0,r.createCancelablePromise)(N=>T.Promises.mkdir(R,{recursive:!0}).then(()=>S(N)).then(void 0,a));return}const A=w(l,_),U=C(_);i=(0,r.createCancelablePromise)(R=>m.queue(()=>A.then(N=>v(N,$,U,n,o,R).then(()=>S(R)))).then(null,a))})})}function y(l,n=!1){return new Promise((o,t)=>{(0,E.open)(l,n?{lazyEntries:!0}:void 0,(i,s)=>{i?t(p(i)):o((0,L.assertIsDefined)(s))})})}function w(l,n){return new Promise((o,t)=>{l.openReadStream(n,(i,s)=>{i?t(p(i)):o((0,L.assertIsDefined)(s))})})}function d(l,n){return new Promise((o,t)=>{const i=new b.ZipFile;n.forEach(u=>{u.contents?i.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&i.addFile(u.localPath,u.path)}),i.end();const s=(0,D.createWriteStream)(l);i.outputStream.pipe(s),i.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>o(l))})}e.zip=d;function f(l,n,o={},t){const i=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=y(l,!0);return o.overwrite&&(s=s.then(u=>T.Promises.rm(n).then(()=>u))),s.then(u=>h(u,n,{sourcePathRegex:i},t))}e.extract=f;function c(l,n){return y(l).then(o=>new Promise((t,i)=>{o.on("entry",s=>{s.fileName===n&&w(o,s).then(u=>t(u),u=>i(u))}),o.once("close",()=>i(new Error(P.localize(2,null,n))))}))}function g(l,n){return c(l,n).then(o=>new Promise((t,i)=>{const s=[];o.once("error",i),o.on("data",u=>s.push(u)),o.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=g}),define(ne[272],re([0,1,114,150]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,D.buffer)(L,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,r.localize)(0,null))}})}e.getManifest=k}),define(ne[115],re([0,1,6,38,9,2,23,12,4,19,55,15,7,30,28,114,149,95,14,248,29,33,49,76,204,249,272,205,235,44,69,13,5,8,25,24,31,20]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g,l,n,o,t,i,s,u,a,m,S,_,$,A,U,R,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,$.refineServiceDecorator)(g.IExtensionManagementService);let q=class extends c.AbstractExtensionManagementService{constructor(B,G,O,M,x,V,ee,oe,Z,ie,se,ue){super(B,G,O,ie,ue),this.extensionsScannerService=x,this.extensionsProfileScannerService=V,this.downloadService=ee,this.fileService=Z,this.installGalleryExtensionsTasks=new Map;const de=this._register(oe.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(J,we=>de.postUninstall(we))),this.manifestCache=this._register(new u.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const ve=this._register(new a.ExtensionsWatcher(this,Z,M,O,se));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Ce=>({identifier:Ce.identifier,operation:1,local:Ce}))),Ee.forEach(Ce=>this._onDidUninstallExtension.fire({identifier:Ce}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const G=await this.collectFiles(B),O=await(0,y.zip)((0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,G);return p.URI.file(O)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:G,cleanup:O}=await this.downloadVsix(B),M=P.resolve(G.fsPath);try{return await(0,s.getManifest)(M)}finally{await O()}}getInstalled(B,G){return this.extensionsScanner.scanExtensions(B??null,G)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(B,G={}){this.logService.trace("ExtensionManagementService#install",B.toString());const{location:O,cleanup:M}=await this.downloadVsix(B);try{const x=await(0,s.getManifest)(P.resolve(O.fsPath));if(x.engines&&x.engines.vscode&&!(0,S.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(w.localize(0,null,(0,l.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return await this.installExtension(x,O,G)}finally{await M()}}getMetadata(B){return this.extensionsScannerService.scanMetadata(B.location)}async updateMetadata(B,G){this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id);const O={...G};return G.isPreReleaseVersion&&(O.preRelease=!0),B=await this.extensionsScanner.updateMetadata(B,O),this.manifestCache.invalidate(),B}async updateExtensionScope(B,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.updateMetadata(B,{isMachineScoped:G}),this.manifestCache.invalidate(),B}removeUninstalledExtensions(B){return this.extensionsScanner.cleanUp(B)}async downloadVsix(B){if(B.scheme===T.Schemas.file)return{location:B,async cleanup(){}};this.logService.trace("Downloading extension from",B.toString());const G=(0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(B,G),this.logService.info("Downloaded extension to",G.toString()),{location:G,cleanup:async()=>{try{await this.fileService.del(G)}catch(M){this.logService.error(M)}}}}doCreateInstallExtensionTask(B,G,O){let M;if(p.URI.isUri(G))M=new W(B,G,O,this.galleryService,this.extensionsScanner,this.logService);else{const x=l.ExtensionKey.create(G).toString();M=this.installGalleryExtensionsTasks.get(x),M||(this.installGalleryExtensionsTasks.set(x,M=new H(B,G,O,this.extensionsDownloader,this.extensionsScanner,this.logService)),M.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(x)))}return O.profileLocation?new z(M,O.profileLocation,this.extensionsProfileScannerService):M}doCreateUninstallExtensionTask(B,G){return G.profileLocation?new X(B,G.profileLocation,this.extensionsProfileScannerService):new K(B,G,this.extensionsScanner)}async collectFiles(B){const G=async M=>{let x=await h.Promises.readdir(M);x=x.map(oe=>P.join(M,oe));const V=await Promise.all(x.map(oe=>h.Promises.stat(oe)));let ee=Promise.resolve([]);return V.forEach((oe,Z)=>{const ie=x[Z];oe.isFile()&&(ee=ee.then(se=>[...se,ie])),oe.isDirectory()&&(ee=ee.then(se=>G(ie).then(ue=>[...se,...ue])))}),ee};return(await G(B.location.fsPath)).map(M=>({path:`extension/${P.relative(B.location.fsPath,M)}`,localPath:M}))}};q=pe([Y(0,g.IExtensionGalleryService),Y(1,R.ITelemetryService),Y(2,A.ILogService),Y(3,f.INativeEnvironmentService),Y(4,o.IExtensionsScannerService),Y(5,n.IExtensionsProfileScannerService),Y(6,d.IDownloadService),Y(7,$.IInstantiationService),Y(8,_.IFileService),Y(9,U.IProductService),Y(10,N.IUriIdentityService),Y(11,F.IUserDataProfilesService)],q),e.ExtensionManagementService=q;let J=class extends L.Disposable{constructor(B,G,O,M){super(),this.beforeRemovingExtension=B,this.fileService=G,this.extensionsScannerService=O,this.logService=M,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(B){await this.removeUninstalledExtensions(),B&&await this.removeOutdatedExtensions()}async scanExtensions(B,G){const O={includeInvalid:!0,profileLocation:G};let M=[];return B===null||B===0?M.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O,!1)):B===1&&M.push(...await this.extensionsScannerService.scanUserExtensions(O)),M=B!==null?M.filter(x=>x.type===B):M,Promise.all(M.map(x=>this.toLocalExtension(x)))}async scanUserExtensions(B){const G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(G.map(O=>this.toLocalExtension(O)))}async extractUserExtension(B,G,O,M){const x=B.toString(),V=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),ee=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,x);try{await h.Promises.rm(ee)}catch{throw new g.ExtensionManagementError(w.localize(1,null,ee,B.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(B,G,V,M),await this.extensionsScannerService.updateMetadata(p.URI.file(V),O);try{await this.rename(B,V,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(oe){try{await h.Promises.rm(V)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(oe)}. Deleted from extracted location`,V),oe}return this.scanLocalExtension(p.URI.file(ee),1)}async updateMetadata(B,G){return await this.extensionsScannerService.updateMetadata(B.location,G),this.scanLocalExtension(B.location,B.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...B){const G=B.map(O=>l.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>{G.forEach(M=>O[M.toString()]=!0)})}async setInstalled(B){await this.withUninstalledExtensions(M=>delete M[B.toString()]);const O=(await this.scanUserExtensions(!0)).find(M=>l.ExtensionKey.create(M).equals(B))||null;return O?this.updateMetadata(O,{installedTimestamp:Date.now()}):null}async removeExtension(B,G){this.logService.trace(`Deleting ${G} extension from disk`,B.identifier.id,B.location.fsPath),await h.Promises.rm(B.location.fsPath),this.logService.info("Deleted from disk",B.identifier.id,B.location.fsPath)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.withUninstalledExtensions(G=>delete G[l.ExtensionKey.create(B).toString()])}async withUninstalledExtensions(B){return this.uninstalledFileLimiter.queue(async()=>{let G;try{G=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(M){if(M.code!=="ENOENT")throw M}let O={};if(G)try{O=JSON.parse(G)}catch{}return B&&(B(O),Object.keys(O).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await h.Promises.rm(this.uninstalledPath)),O})}async extractAtLocation(B,G,O,M){this.logService.trace(`Started extracting the extension from ${G} to ${O}`);try{await h.Promises.rm(O)}catch(x){throw new g.ExtensionManagementError(this.joinErrors(x).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(G,O,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${O}:`,B.id)}catch(x){try{await h.Promises.rm(O)}catch{}let V=g.ExtensionManagementErrorCode.Extract;throw x instanceof y.ExtractError&&(x.type==="CorruptZip"?V=g.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(V=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(x.message,V)}}async rename(B,G,O,M){try{await h.Promises.rename(G,O)}catch(x){if(E.isWindows&&x&&x.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${G} to ${O} with 'EPERM' error. Trying again...`,B.id),this.rename(B,G,O,M);throw new g.ExtensionManagementError(x.message||w.localize(2,null,G,O),x.code||g.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(B,G){const O=await this.extensionsScannerService.scanExistingExtension(B,G,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(w.localize(3,null,B.path))}async toLocalExtension(B){const G=await this.fileService.resolve(B.location);let O,M;return G.children&&(O=G.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,M=G.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:O,changelogUrl:M,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated}}async removeUninstalledExtensions(){const B=await this.getUninstalledExtensions(),G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const V of G)B[l.ExtensionKey.create(V).toString()]||O.add(V.identifier.id.toLowerCase());const M=(0,l.groupByExtension)(G,V=>V.identifier);await D.Promises.settled(M.map(async V=>{const ee=V.sort((oe,Z)=>I.rcompare(oe.manifest.version,Z.manifest.version))[0];O.has(ee.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ee))}));const x=G.filter(V=>B[l.ExtensionKey.create(V).toString()]);await D.Promises.settled(x.map(V=>this.removeUninstalledExtension(V)))}async removeOutdatedExtensions(){const B=await this.extensionsScannerService.scanSystemExtensions({}),G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=[],M=await this.extensionsScannerService.getTargetPlatform(),x=(0,l.groupByExtension)(G,V=>V.identifier);for(const V of x)if(V.length>1&&O.push(...V.sort((ee,oe)=>{const Z=I.rcompare(ee.manifest.version,oe.manifest.version);return Z!==0?Z:ee.targetPlatform===M?-1:1}).slice(1)),V[0].type===0){const ee=B.find(oe=>(0,l.areSameExtensions)(oe.identifier,V[0].identifier));(!ee||I.gte(ee.manifest.version,V[0].manifest.version))&&O.push(V[0])}await D.Promises.settled(O.map(V=>this.removeExtension(V,"outdated")))}joinErrors(B){const G=Array.isArray(B)?B:[B];return G.length===1?G[0]instanceof Error?G[0]:new Error(G[0]):G.reduce((O,M)=>new Error(`${O.message}${O.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};J=pe([Y(1,_.IFileService),Y(2,o.IExtensionsScannerService),Y(3,A.ILogService)],J);class j extends c.AbstractExtensionTask{get operation(){return(0,C.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(B,G,O,M,x){super(),this.identifier=B,this.source=G,this.options=O,this.extensionsScanner=M,this.logService=x,this._operation=2}async installExtension(B,G){try{const O=await this.unsetUninstalledAndGetLocal(B.key);if(O)return this.extensionsScanner.updateMetadata(O,B.metadata)}catch{throw E.isMacintosh?new g.ExtensionManagementError(w.localize(4,null),g.ExtensionManagementErrorCode.Internal):new g.ExtensionManagementError(w.localize(5,null),g.ExtensionManagementErrorCode.Internal)}return this.extract(B,G)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const O=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),O}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.toString()]}async extract({zipPath:B,key:G,metadata:O},M){const x=await this.extensionsScanner.extractUserExtension(G,B,O,M);return this.logService.info("Extracting completed.",G.id),x}}class H extends j{constructor(B,G,O,M,x,V){super(G.identifier,G,O,x,V),this.manifest=B,this.gallery=G,this.extensionsDownloader=M}async doRun(B){const O=(await this.extensionsScanner.scanExtensions(null,void 0)).find(V=>(0,l.areSameExtensions)(V.identifier,this.gallery.identifier));O&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,m.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,C.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(O,M),metadata:M};const x=await this.downloadExtension(this.gallery,this._operation);try{const V=await this.installExtension({zipPath:x,key:l.ExtensionKey.create(this.gallery),metadata:M},B);return O&&!this.options.profileLocation&&(O.targetPlatform!==V.targetPlatform||I.neq(O.manifest.version,V.manifest.version))&&await this.extensionsScanner.setUninstalled(O),{local:V,metadata:M}}catch(V){throw await this.deleteDownloadedVSIX(x),V}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(p.URI.file(B))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,k.getErrorMessage)(G))}}async downloadExtension(B,G){let O;try{this.logService.trace("Started downloading extension:",B.identifier.id),O=(await this.extensionsDownloader.downloadExtension(B,G)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,O)}catch(M){throw new g.ExtensionManagementError((0,c.joinErrors)(M).message,g.ExtensionManagementErrorCode.Download)}try{return await(0,s.getManifest)(O),O}catch(M){throw await this.deleteDownloadedVSIX(O),new g.ExtensionManagementError((0,c.joinErrors)(M).message,g.ExtensionManagementErrorCode.Invalid)}}}class W extends j{constructor(B,G,O,M,x,V){super({id:(0,l.getGalleryExtensionId)(B.publisher,B.name)},G,O,x,V),this.manifest=B,this.location=G,this.galleryService=M}async doRun(B){const G=new l.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,void 0)).find(ee=>(0,l.areSameExtensions)(this.identifier,ee.identifier)),x=await this.getMetadata(this.identifier.id,this.manifest.version,B);if(x.isApplicationScoped=(0,m.isApplicationScopedExtension)(this.manifest),x.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||M?.isBuiltin,x.installedTimestamp=Date.now(),M)if(this._operation=3,G.equals(new l.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(w.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const ee=await this.unsetUninstalledAndGetLocal(G);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(w.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:G,metadata:x},B),metadata:x}}async getMetadata(B,G,O){try{let[M]=await this.galleryService.getExtensions([{id:B,version:G}],O);if(M||([M]=await this.galleryService.getExtensions([{id:B}],O)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class z{constructor(B,G,O){this.task=B,this.profileLocation=G,this.extensionsProfileScannerService=O,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const B=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[B.local,B.metadata]],this.profileLocation),B}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class K extends c.AbstractExtensionTask{constructor(B,G,O){super(),this.extension=B,this.options=G,this.extensionsScanner=O}async doRun(B){const G=[],O=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=l.ExtensionKey.create(this.extension);G.push(...O.filter(x=>M.equals(l.ExtensionKey.create(x))))}else G.push(...O.filter(M=>(0,l.areSameExtensions)(M.identifier,this.extension.identifier)));if(!G.length)throw new Error(w.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const M of G)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(x){throw new Error(w.localize(9,null,(0,r.toErrorMessage)(x)))}}}class X extends c.AbstractExtensionTask{constructor(B,G,O){super(),this.extension=B,this.profileLocation=G,this.extensionsProfileScannerService=O}async doRun(B){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[273],re([0,1,2,29,33,49,77,203,115,44,5,8,21,31,20]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const y={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let w=class extends D.Disposable{constructor(c,g,l,n,o,t,i,s){super(),this.userDataProfilesService=g,c.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,P.migrateUnsupportedExtensions)(c,l,n,o,s),T.ExtensionStorageService.removeOutdatedExtensionVersions(c,i),this._register(t.createInstance(d))}};w=pe([Y(0,E.INativeServerExtensionManagementService),Y(1,h.IUserDataProfilesService),Y(2,r.IExtensionGalleryService),Y(3,T.IExtensionStorageService),Y(4,r.IGlobalExtensionEnablementService),Y(5,I.IInstantiationService),Y(6,p.IStorageService),Y(7,C.ILogService)],w),e.ExtensionsCleaner=w;let d=class extends D.Disposable{constructor(c,g,l,n,o){super(),this.extensionManagementService=c,this.userDataProfilesService=g,this.extensionsProfileScannerService=l,this.uriIdentityService=n,this.logService=o,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:c,removed:g,all:l}){try{await Promise.all(g.map(n=>n.extensionsResource?this.removeExtensionsFromProfile(n.extensionsResource):Promise.resolve()))}catch(n){this.logService.error(n)}if(l.length===1){this.profileModeDisposables.clear();const n=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{n.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{c.length&&(await Promise.all(c.map(n=>n.extensionsResource?this.populateExtensionsFromProfile(n.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(n=>this.onDidChangeProfiles(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(n=>this.onDidUninstallExtension(n))),await this.uninstallExtensionsNotInProfiles()))}catch(n){this.logService.error(n)}}async uninstallExtensionsNotInProfiles(){const g=(await this.extensionManagementService.getAllUserInstalled()).filter(l=>l.installedTimestamp&&!this.profileExtensionsLocations.has(this.getKey(l.identifier,l.manifest.version)));g.length&&await Promise.all(g.map(l=>this.extensionManagementService.uninstall(l,y)))}async onDidInstallExtensions(c){for(const{local:g,profileLocation:l}of c)!g||!l||this.addExtensionWithKey(this.getKey(g.identifier,g.manifest.version),l)}async onDidUninstallExtension(c){!c.profileLocation||!c.version||this.removeExtensionWithKey(this.getKey(c.identifier,c.version),c.profileLocation)&&await this.uninstallExtensions([{identifier:c.identifier,version:c.version}])}async populateExtensionsFromProfile(c){const g=await this.extensionsProfileScannerService.scanProfileExtensions(c);for(const l of g)this.addExtensionWithKey(this.getKey(l.identifier,l.version),c)}async removeExtensionsFromProfile(c){const g=[];for(const l of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(l,c))continue;const n=this.fromKey(l);n&&g.push(n)}g.length&&await this.uninstallExtensions(g)}addExtensionWithKey(c,g){let l=this.profileExtensionsLocations.get(c);l||(l=[],this.profileExtensionsLocations.set(c,l)),l.push(g)}removeExtensionWithKey(c,g){const l=this.profileExtensionsLocations.get(c);if(l){const n=l.findIndex(o=>this.uriIdentityService.extUri.isEqual(o,g));n>-1&&l.splice(n,1)}return l?.length?!1:(this.profileExtensionsLocations.delete(c),!0)}async uninstallExtensions(c){const l=(await this.extensionManagementService.getAllUserInstalled()).filter(n=>n.installedTimestamp&&c.some(o=>this.getKey(n.identifier,n.manifest.version)===this.getKey(o.identifier,o.version)));l.length&&await Promise.all(l.map(n=>this.extensionManagementService.uninstall(n,y)))}getKey(c,g){return`${b.ExtensionIdentifier.toKey(c.id)}@${g}`}fromKey(c){const[g,l]=(0,k.getIdAndVersion)(c);return l?{identifier:{id:g},version:l}:void 0}};d=pe([Y(0,E.INativeServerExtensionManagementService),Y(1,h.IUserDataProfilesService),Y(2,L.IExtensionsProfileScannerService),Y(3,v.IUriIdentityService),Y(4,C.ILogService)],d)}),define(ne[282],re([0,1,91,36,38,9,2,23,19,7,39,138,196,273,197,189,190,271,178,181,17,201,94,220,95,211,14,217,113,251,29,180,252,115,96,176,13,192,194,56,5,187,70,188,58,71,206,8,99,59,100,25,45,21,253,105,24,106,107,108,50,224,109,226,232,77,111,26,75,260,244,245,78,261,265,266,267,268,269,62,246,104,219,74,234,208,233,103,216,31,236,4,237,182,199,198,76,250,20,49,195,60,254,214,223,247]),function(Q,e,D,r,k,L,T,P,E,b,I,C,p,v,h,y,w,d,f,c,g,l,n,o,t,i,s,u,a,m,S,_,$,A,U,R,N,F,q,J,j,H,W,z,K,X,ce,B,G,O,M,x,V,ee,oe,Z,ie,se,ue,de,ve,we,Ee,Ce,Ue,$e,He,We,ae,fe,ge,be,Ie,Le,Re,Ne,Ae,Me,ze,ke,_e,te,le,he,me,Se,Pe,De,Be,Fe,Te,qe,xe,Ze,rt,St,Rt,kt,yt,wt,Lt,Et,Tt,At,_t,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ut extends T.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(Ge,et)=>{this.onDisposeWorker(et)};D.ipcRenderer.on(Oe,je),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const je=Oe.get(B.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(h.LanguagePackCachedDataCleaner),ye.createInstance(d.UnusedWorkspaceStorageDataCleaner),ye.createInstance(w.LogsDataCleaner),ye.createInstance(y.LocalizationsUpdater),ye.createInstance(v.ExtensionsCleaner),ye.createInstance(Ot.UserDataProfilesCleaner)))}async initServices(){const ye=new W.ServiceCollection,Oe={_serviceBrand:void 0,...M.default};ye.set(x.IProductService,Oe);const je=new I.StaticRouter(Je=>Je==="main"),Ge=new z.MessagePortMainProcessService(this.server,je);ye.set(K.IMainProcessService,Ge);const et=this.configuration.policiesData?new Lt.PolicyChannelClient(this.configuration.policiesData,Ge.getChannel("policy")):new Et.NullPolicyService;ye.set(Et.IPolicyService,et);const Ve=new u.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(s.INativeEnvironmentService,Ve);const at=new G.LogLevelChannelClient(this.server.getChannel("logLevel",je)),tt=new G.LoggerChannelClient(this.configuration.logLevel,at.onDidChangeLogLevel,Ge.getChannel("logger"));ye.set(B.ILoggerService,tt);const ut=this._register(new B.MultiplexLogService([this._register(new B.ConsoleLogger(this.configuration.logLevel)),this._register(tt.createLogger((0,E.joinPath)(b.URI.file(Ve.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ke=this._register(new G.FollowerLogService(at,ut));ye.set(B.ILogService,Ke),this.sharedProcessWorkerService=new Be.SharedProcessWorkerService(Ke),ye.set(De.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Qe=this._register(new F.FileService(Ke));ye.set(N.IFileService,Qe);const ht=this._register(new q.DiskFileSystemProvider(Ke));Qe.registerProvider(P.Schemas.file,ht);const dt=this._register(new xe.FileUserDataProvider(P.Schemas.file,this._register(new Ze.DiskFileSystemProviderClient(Ge.getChannel(Ze.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,Ke));Qe.registerProvider(P.Schemas.vscodeUserData,dt);const it=this._register(new Tt.UserDataProfilesNativeService(this.configuration.profiles,Ge,Ve));ye.set(yt.IUserDataProfilesService,it);const Ye=this._register(new l.ConfigurationService(it.defaultProfile.settingsResource,Qe,et,Ke));ye.set(g.IConfigurationService,Ye);const st=new oe.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},Ge,Ve);ye.set(ee.IStorageService,st),this._register((0,T.toDisposable)(()=>st.flush())),await Promise.all([Ye.initialize(),st.initialize()]),ye.set(Fe.IUriIdentityService,new Te.UriIdentityService(Qe)),ye.set(V.IRequestService,new At.SharedProcessRequestService(Ge,Ye,Ke)),ye.set(f.IChecksumService,new J.SyncDescriptor(c.ChecksumService,void 0,!1)),ye.set(St.IV8InspectProfilingService,new J.SyncDescriptor(rt.InspectProfilingService,void 0,!1));const ct=I.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(O.INativeHostService,ct),ye.set(t.IDownloadService,new J.SyncDescriptor(i.DownloadService,void 0,!0));const ft=this._register(new _e.ActiveWindowManager(ct)),Nt=new I.StaticRouter(Je=>ft.getActiveClientId().then(gt=>Je===gt));ye.set(U.IExtensionRecommendationNotificationService,new R.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Nt)));let lt;const ot=[],Ct=(0,ve.isInternalTelemetry)(Oe,Ye);if((0,ve.supportsTelemetry)(Oe,Ve)){const Je=new ue.TelemetryLogAppender(tt,Ve);ot.push(Je);const{installSourcePath:gt}=Ve;if(Oe.aiConfig?.ariaKey){const It=new _t.OneDataSystemAppender(Ct,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>It.flush())),ot.push(It)}lt=new de.TelemetryService({appenders:ot,commonProperties:(0,Z.resolveCommonProperties)(Qe,(0,r.release)(),(0,r.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Ct,gt),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Ve)},Ye,Oe)}else{lt=ve.NullTelemetryService;const Je=ve.NullAppender;ot.push(Je)}this.server.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(ot)),ye.set(ie.ITelemetryService,lt);const Ft=new we.CustomEndpointTelemetryService(Ye,lt,tt,Ve,Oe);ye.set(ie.ICustomEndpointTelemetryService,Ft),ye.set(wt.IExtensionsProfileScannerService,new J.SyncDescriptor(wt.ExtensionsProfileScannerService,void 0,!0)),ye.set(Rt.IExtensionsScannerService,new J.SyncDescriptor(kt.ExtensionsScannerService,void 0,!0)),ye.set(A.INativeServerExtensionManagementService,new J.SyncDescriptor(A.ExtensionManagementService,void 0,!0)),ye.set(S.IExtensionGalleryService,new J.SyncDescriptor(m.ExtensionGalleryService,void 0,!0)),ye.set(S.IExtensionTipsService,new J.SyncDescriptor($.ExtensionTipsService,void 0,!1)),ye.set(X.ILanguagePackService,new J.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(n.IDiagnosticsService,new J.SyncDescriptor(o.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new J.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(be.UserDataSyncLogService,void 0,!0)),ye.set(We.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),ye.set(S.IGlobalExtensionEnablementService,new J.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),ye.set(He.IIgnoredExtensionsManagementService,new J.SyncDescriptor(He.IgnoredExtensionsManagementService,void 0,!0)),ye.set($e.IExtensionStorageService,new J.SyncDescriptor($e.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService,void 0,!0)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(fe.UserDataSyncBackupStoreService,void 0,!1)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Le.UserDataSyncEnablementService,void 0,!0)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(Re.UserDataSyncService,void 0,!1)),ye.set(ke.IUserDataSyncProfilesStorageService,new J.SyncDescriptor(ze.UserDataSyncProfilesStorageService,void 0,!0));const Pt=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100},Ye,Ve,Ke);return Pt.initialize(),ye.set(Ce.ILocalPtyService,this._register(Pt)),ye.set(te.ISignService,new J.SyncDescriptor(le.SignService,void 0,!1)),ye.set(he.ISharedTunnelsService,new J.SyncDescriptor(me.SharedTunnelsService)),ye.set(Se.ISharedProcessTunnelService,new J.SyncDescriptor(Pe.SharedProcessTunnelService)),new H.InstantiationService(ye)}initChannels(ye){const Oe=new _.ExtensionManagementChannel(ye.get(S.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=I.ProxyChannel.fromService(ye.get(X.ILanguagePackService));this.server.registerChannel("languagePacks",je);const Ge=I.ProxyChannel.fromService(ye.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const et=new _.ExtensionTipsChannel(ye.get(S.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Ve=I.ProxyChannel.fromService(ye.get(f.IChecksumService));this.server.registerChannel("checksum",Ve);const at=I.ProxyChannel.fromService(ye.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",at);const tt=new ge.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",tt);const ut=I.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ut);const Ke=new ge.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const Qe=new ge.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const ht=new Ne.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(yt.IUserDataProfilesService),ye.get(B.ILogService));this.server.registerChannel("userDataSync",ht);const dt=this._register(ye.get(j.IInstantiationService).createInstance(Me.UserDataAutoSyncService)),it=new ge.UserDataAutoSyncChannel(dt);this.server.registerChannel("userDataAutoSync",it);const Ye=ye.get(Ce.ILocalPtyService),st=I.ProxyChannel.fromService(Ye);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,st);const ct=I.ProxyChannel.fromService(ye.get(Se.ISharedProcessTunnelService));this.server.registerChannel(Se.ipcSharedProcessTunnelChannelName,ct);const ft=I.ProxyChannel.fromService(ye.get(De.ISharedProcessWorkerService));this.server.registerChannel(De.ipcSharedProcessWorkerChannelName,ft)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const je=(0,k.toErrorMessage)(Oe,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Mt(bt){const ye=new Ut(bt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Mt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bd1b7a384f8a5ab9fb5a6a0e8fea370e589f43a3/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
