/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/node/pfs","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/common/profiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/userDataSync/electron-main/userDataSyncProfilesStorageIpc","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ie=function(z){for(var e=[],S=0,t=z.length;S<t;S++)e[S]=te[z[S]];return e};define(te[120],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function S(D){return D?D.replace(/\$\((.*?)\)/g,(b,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=S;class t{constructor(b,u,p){this.id=b,this.definition=u,this.description=p,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,b){const u=["codicon","codicon-"+D];return b&&u.push("codicon-modifier-"+b),u}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function u(y){if(y instanceof t)return["codicon","codicon-"+y.id];const E=b.exec(y.id);if(!E)return u(t.error);const[,h,f]=E,P=["codicon","codicon-"+h];return f&&P.push("codicon-modifier-"+f.substr(1)),P}D.asClassNameArray=u;function p(y){return u(y).join(" ")}D.asClassName=p;function C(y){return"."+u(y).join(".")}D.asCSSSelector=C})(R=e.CSSIcon||(e.CSSIcon={}))}),define(te[121],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(b,u){const p=Math.pow(10,u);return Math.round(b*p)/p}class t{constructor(u,p,C,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,C))|0,this.a=S(Math.max(Math.min(1,y),0),3)}static equals(u,p){return u.r===p.r&&u.g===p.g&&u.b===p.b&&u.a===p.a}}e.RGBA=t;class k{constructor(u,p,C,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=S(Math.max(Math.min(1,p),0),3),this.l=S(Math.max(Math.min(1,C),0),3),this.a=S(Math.max(Math.min(1,y),0),3)}static equals(u,p){return u.h===p.h&&u.s===p.s&&u.l===p.l&&u.a===p.a}static fromRGBA(u){const p=u.r/255,C=u.g/255,y=u.b/255,E=u.a,h=Math.max(p,C,y),f=Math.min(p,C,y);let P=0,w=0;const m=(f+h)/2,v=h-f;if(v>0){switch(w=Math.min(m<=.5?v/(2*m):v/(2-2*m),1),h){case p:P=(C-y)/v+(C<y?6:0);break;case C:P=(y-p)/v+2;break;case y:P=(p-C)/v+4;break}P*=60,P=Math.round(P)}return new k(P,w,m,E)}static _hue2rgb(u,p,C){return C<0&&(C+=1),C>1&&(C-=1),C<1/6?u+(p-u)*6*C:C<1/2?p:C<2/3?u+(p-u)*(2/3-C)*6:u}static toRGBA(u){const p=u.h/360,{s:C,l:y,a:E}=u;let h,f,P;if(C===0)h=f=P=y;else{const w=y<.5?y*(1+C):y+C-y*C,m=2*y-w;h=k._hue2rgb(m,w,p+1/3),f=k._hue2rgb(m,w,p),P=k._hue2rgb(m,w,p-1/3)}return new t(Math.round(h*255),Math.round(f*255),Math.round(P*255),E)}}e.HSLA=k;class R{constructor(u,p,C,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=S(Math.max(Math.min(1,p),0),3),this.v=S(Math.max(Math.min(1,C),0),3),this.a=S(Math.max(Math.min(1,y),0),3)}static equals(u,p){return u.h===p.h&&u.s===p.s&&u.v===p.v&&u.a===p.a}static fromRGBA(u){const p=u.r/255,C=u.g/255,y=u.b/255,E=Math.max(p,C,y),h=Math.min(p,C,y),f=E-h,P=E===0?0:f/E;let w;return f===0?w=0:E===p?w=((C-y)/f%6+6)%6:E===C?w=(y-p)/f+2:w=(p-C)/f+4,new R(Math.round(w*60),P,E,u.a)}static toRGBA(u){const{h:p,s:C,v:y,a:E}=u,h=y*C,f=h*(1-Math.abs(p/60%2-1)),P=y-h;let[w,m,v]=[0,0,0];return p<60?(w=h,m=f):p<120?(w=f,m=h):p<180?(m=h,v=f):p<240?(m=f,v=h):p<300?(w=f,v=h):p<=360&&(w=h,v=f),w=Math.round((w+P)*255),m=Math.round((m+P)*255),v=Math.round((v+P)*255),new t(w,m,v,E)}}e.HSVA=R;class D{static fromHex(u){return D.Format.CSS.parseHex(u)||D.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof t)this.rgba=u;else if(u instanceof k)this._hsla=u,this.rgba=k.toRGBA(u);else if(u instanceof R)this._hsva=u,this.rgba=R.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&t.equals(this.rgba,u.rgba)&&k.equals(this.hsla,u.hsla)&&R.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=D._relativeLuminanceForComponent(this.rgba.r),p=D._relativeLuminanceForComponent(this.rgba.g),C=D._relativeLuminanceForComponent(this.rgba.b),y=.2126*u+.7152*p+.0722*C;return S(y,4)}static _relativeLuminanceForComponent(u){const p=u/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(u){const p=this.getRelativeLuminance(),C=u.getRelativeLuminance();return p>C?(p+.05)/(C+.05):(C+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const p=this.getRelativeLuminance(),C=u.getRelativeLuminance();return p>C}isDarkerThan(u){const p=this.getRelativeLuminance(),C=u.getRelativeLuminance();return p<C}lighten(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:p,g:C,b:y,a:E}=this.rgba;return new D(new t(p,C,y,E*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const p=u.rgba,C=this.rgba.a,y=p.a,E=C+y*(1-C);if(E<1e-6)return D.transparent;const h=this.rgba.r*C/E+p.r*y*(1-C)/E,f=this.rgba.g*C/E+p.g*y*(1-C)/E,P=this.rgba.b*C/E+p.b*y*(1-C)/E;return new D(new t(h,f,P,E))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:p,g:C,b:y,a:E}=this.rgba;return new D(new t(u.rgba.r-E*(u.rgba.r-p),u.rgba.g-E*(u.rgba.g-C),u.rgba.b-E*(u.rgba.b-y),1))}flatten(...u){const p=u.reduceRight((C,y)=>D._flatten(y,C));return D._flatten(this,p)}static _flatten(u,p){const C=1-u.rgba.a;return new D(new t(C*p.rgba.r+u.rgba.a*u.rgba.r,C*p.rgba.g+u.rgba.a*u.rgba.g,C*p.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(u,p,C){if(u.isLighterThan(p))return u;C=C||.5;const y=u.getRelativeLuminance(),E=p.getRelativeLuminance();return C=C*(E-y)/E,u.lighten(C)}static getDarkerColor(u,p,C){if(u.isDarkerThan(p))return u;C=C||.5;const y=u.getRelativeLuminance(),E=p.getRelativeLuminance();return C=C*(y-E)/y,u.darken(C)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(b){let u;(function(p){let C;(function(y){function E(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:b.Format.CSS.formatRGBA(i)}y.formatRGB=E;function h(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}y.formatRGBA=h;function f(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(i)}y.formatHSL=f;function P(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}y.formatHSLA=P;function w(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function m(i){return`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}`}y.formatHex=m;function v(i,o=!1){return o&&i.rgba.a===1?b.Format.CSS.formatHex(i):`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}${w(Math.round(i.rgba.a*255))}`}y.formatHexA=v;function d(i){return i.isOpaque()?b.Format.CSS.formatHex(i):b.Format.CSS.formatRGBA(i)}y.format=d;function g(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const n=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),r=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),s=16*c(i.charCodeAt(5))+c(i.charCodeAt(6));return new b(new t(n,r,s,1))}if(o===9){const n=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),r=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),s=16*c(i.charCodeAt(5))+c(i.charCodeAt(6)),l=16*c(i.charCodeAt(7))+c(i.charCodeAt(8));return new b(new t(n,r,s,l/255))}if(o===4){const n=c(i.charCodeAt(1)),r=c(i.charCodeAt(2)),s=c(i.charCodeAt(3));return new b(new t(16*n+n,16*r+r,16*s+s))}if(o===5){const n=c(i.charCodeAt(1)),r=c(i.charCodeAt(2)),s=c(i.charCodeAt(3)),l=c(i.charCodeAt(4));return new b(new t(16*n+n,16*r+r,16*s+s,(16*l+l)/255))}return null}y.parseHex=g;function c(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(C=p.CSS||(p.CSS={}))})(u=b.Format||(b.Format={}))}(D=e.Color||(e.Color={}))}),define(te[53],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(D){return(b,u,p)=>{let C=null,y=null;if(typeof p.value=="function"?(C="value",y=p.value):typeof p.get=="function"&&(C="get",y=p.get),!y)throw new Error("not supported");p[C]=D(y,u)}}e.createDecorator=S;function t(D,b,u){let p=null,C=null;if(typeof u.value=="function"?(p="value",C=u.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(p="get",C=u.get),!C)throw new Error("not supported");const y=`$memoize$${b}`;u[p]=function(...E){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,E)}),this[y]}}e.memoize=t;function k(D,b,u){return S((p,C)=>{const y=`$debounce$${C}`,E=`$debounce$result$${C}`;return function(...h){this[E]||(this[E]=u?u():void 0),clearTimeout(this[y]),b&&(this[E]=b(this[E],...h),h=[this[E]]),this[y]=setTimeout(()=>{p.apply(this,h),this[E]=u?u():void 0},D)}})}e.debounce=k;function R(D,b,u){return S((p,C)=>{const y=`$throttle$timer$${C}`,E=`$throttle$result$${C}`,h=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...P){if(this[E]||(this[E]=u?u():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),b&&(this[E]=b(this[E],...P)),this[f])return;const w=this[h]+D;w<=Date.now()?(this[h]=Date.now(),p.apply(this,[this[E]]),this[E]=u?u():void 0):(this[f]=!0,this[y]=setTimeout(()=>{this[f]=!1,this[h]=Date.now(),p.apply(this,[this[E]]),this[E]=u?u():void 0},w-Date.now()))}})}e.throttle=R}),define(te[17],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=S,e.errorHandler=new S;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){u(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){u(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:i,message:o}=c,n=c.stacktrace||c.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:d.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const b="Canceled";function u(c){return c instanceof p?!0:c instanceof Error&&c.name===b&&c.message===b}e.isCancellationError=u;class p extends Error{constructor(){super(b),this.name=this.message}}e.CancellationError=p;function C(){const c=new Error(b);return c.name=c.message,c}e.canceled=C;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=y;function E(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=E;function h(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function f(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=f;function P(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=P;class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=w;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const o=new d;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=d;class g extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(te[24],ie([0,1,17]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(q,re=0){return q[q.length-(1+re)]}e.tail=t;function k(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=k;function R(q,re,ne=(ce,ge)=>ce===ge){if(q===re)return!0;if(!q||!re||q.length!==re.length)return!1;for(let ce=0,ge=q.length;ce<ge;ce++)if(!ne(q[ce],re[ce]))return!1;return!0}e.equals=R;function D(q,re){const ne=q.length-1;re<ne&&(q[re]=q[ne]),q.pop()}e.removeFastWithoutKeepingOrder=D;function b(q,re,ne){return u(q.length,ce=>ne(q[ce],re))}e.binarySearch=b;function u(q,re){let ne=0,ce=q-1;for(;ne<=ce;){const ge=(ne+ce)/2|0,De=re(ge);if(De<0)ne=ge+1;else if(De>0)ce=ge-1;else return ge}return-(ne+1)}e.binarySearch2=u;function p(q,re){let ne=0,ce=q.length;if(ce===0)return 0;for(;ne<ce;){const ge=Math.floor((ne+ce)/2);re(q[ge])?ce=ge:ne=ge+1}return ne}e.findFirstInSorted=p;function C(q,re,ne){if(q=q|0,q>=re.length)throw new TypeError("invalid index");const ce=re[Math.floor(re.length*Math.random())],ge=[],De=[],Ae=[];for(const ke of re){const Le=ne(ke,ce);Le<0?ge.push(ke):Le>0?De.push(ke):Ae.push(ke)}return q<ge.length?C(q,ge,ne):q<ge.length+Ae.length?Ae[0]:C(q-(ge.length+Ae.length),De,ne)}e.quickSelect=C;function y(q,re){const ne=[];let ce;for(const ge of q.slice(0).sort(re))!ce||re(ce[0],ge)!==0?(ce=[ge],ne.push(ce)):ce.push(ge);return ne}e.groupBy=y;function E(q,re,ne){const ce=[];function ge(ke,Le,qe){if(Le===0&&qe.length===0)return;const me=ce[ce.length-1];me&&me.start+me.deleteCount===ke?(me.deleteCount+=Le,me.toInsert.push(...qe)):ce.push({start:ke,deleteCount:Le,toInsert:qe})}let De=0,Ae=0;for(;;){if(De===q.length){ge(De,0,re.slice(Ae));break}if(Ae===re.length){ge(De,q.length-De,[]);break}const ke=q[De],Le=re[Ae],qe=ne(ke,Le);qe===0?(De+=1,Ae+=1):qe<0?(ge(De,1,[]),De+=1):qe>0&&(ge(De,0,[Le]),Ae+=1)}return ce}e.sortedDiff=E;function h(q,re,ne){const ce=E(q,re,ne),ge=[],De=[];for(const Ae of ce)ge.push(...q.slice(Ae.start,Ae.start+Ae.deleteCount)),De.push(...Ae.toInsert);return{removed:ge,added:De}}e.delta=h;function f(q,re,ne){if(ne===0)return[];const ce=q.slice(0,ne).sort(re);return w(q,re,ce,ne,q.length),ce}e.top=f;function P(q,re,ne,ce,ge){return ne===0?Promise.resolve([]):new Promise((De,Ae)=>{(async()=>{const ke=q.length,Le=q.slice(0,ne).sort(re);for(let qe=ne,me=Math.min(ne+ce,ke);qe<ke;qe=me,me=Math.min(me+ce,ke)){if(qe>ne&&await new Promise(we=>setTimeout(we)),ge&&ge.isCancellationRequested)throw new S.CancellationError;w(q,re,Le,qe,me)}return Le})().then(De,Ae)})}e.topAsync=P;function w(q,re,ne,ce,ge){for(const De=ne.length;ce<ge;ce++){const Ae=q[ce];if(re(Ae,ne[De-1])<0){ne.pop();const ke=p(ne,Le=>re(Ae,Le)<0);ne.splice(ke,0,Ae)}}}function m(q){return q.filter(re=>!!re)}e.coalesce=m;function v(q){let re=0;for(let ne=0;ne<q.length;ne++)q[ne]&&(q[re]=q[ne],re+=1);q.length=re}e.coalesceInPlace=v;function d(q,re,ne){q.splice(ne,0,q.splice(re,1)[0])}e.move=d;function g(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=g;function c(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=c;function i(q,re=ne=>ne){const ne=new Set;return q.filter(ce=>{const ge=re(ce);return ne.has(ge)?!1:(ne.add(ge),!0)})}e.distinct=i;function o(q){const re=new Set;return ne=>{const ce=q(ne);return re.has(ce)?!1:(re.add(ce),!0)}}e.uniqueFilter=o;function n(q,re){const ne=r(q,re);if(ne!==-1)return q[ne]}e.findLast=n;function r(q,re){for(let ne=q.length-1;ne>=0;ne--){const ce=q[ne];if(re(ce))return ne}return-1}e.lastIndex=r;function s(q,re){return q.length>0?q[0]:re}e.firstOrDefault=s;function l(q,re){return q.length>0?q[q.length-1]:re}e.lastOrDefault=l;function a(q,re,ne=(ce,ge)=>ce===ge){let ce=0;for(let ge=0,De=Math.min(q.length,re.length);ge<De&&ne(q[ge],re[ge]);ge++)ce++;return ce}e.commonPrefixLength=a;function I(q){return[].concat(...q)}e.flatten=I;function M(q,re){let ne=typeof re=="number"?q:0;typeof re=="number"?ne=q:(ne=0,re=q);const ce=[];if(ne<=re)for(let ge=ne;ge<re;ge++)ce.push(ge);else for(let ge=ne;ge>re;ge--)ce.push(ge);return ce}e.range=M;function T(q,re,ne){return q.reduce((ce,ge)=>(ce[re(ge)]=ne?ne(ge):ge,ce),Object.create(null))}e.index=T;function N(q,re){return q.push(re),()=>X(q,re)}e.insert=N;function X(q,re){const ne=q.indexOf(re);if(ne>-1)return q.splice(ne,1),re}e.remove=X;function ae(q,re,ne){const ce=q.slice(0,re),ge=q.slice(re);return ce.concat(ne,ge)}e.arrayInsert=ae;function Q(q,re){let ne;if(typeof re=="number"){let ce=re;ne=()=>{const ge=Math.sin(ce++)*179426549;return ge-Math.floor(ge)}}else ne=Math.random;for(let ce=q.length-1;ce>0;ce-=1){const ge=Math.floor(ne()*(ce+1)),De=q[ce];q[ce]=q[ge],q[ge]=De}}e.shuffle=Q;function G(q,re){const ne=q.indexOf(re);ne>-1&&(q.splice(ne,1),q.unshift(re))}e.pushToStart=G;function Z(q,re){const ne=q.indexOf(re);ne>-1&&(q.splice(ne,1),q.push(re))}e.pushToEnd=Z;function se(q,re){for(const ne of re)q.push(ne)}e.pushMany=se;function he(q,re){return Array.isArray(q)?q.map(re):re(q)}e.mapArrayOrNot=he;function V(q){return Array.isArray(q)?q:[q]}e.asArray=V;function H(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=H;function W(q,re){for(const ne of q){const ce=re(ne);if(ce!==void 0)return ce}}e.mapFind=W;function A(q,re,ne){const ce=U(q,re),ge=q.length,De=ne.length;q.length=ge+De;for(let Ae=ge-1;Ae>=ce;Ae--)q[Ae+De]=q[Ae];for(let Ae=0;Ae<De;Ae++)q[Ae+ce]=ne[Ae]}e.insertInto=A;function F(q,re,ne,ce){const ge=U(q,re),De=q.splice(ge,ne);return A(q,ge,ce),De}e.splice=F;function U(q,re){return re<0?Math.max(re+q.length,0):Math.min(re,q.length)}var J;(function(q){function re(ge){return ge<0}q.isLessThan=re;function ne(ge){return ge>0}q.isGreaterThan=ne;function ce(ge){return ge===0}q.isNeitherLessOrGreaterThan=ce,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function B(q,re){return(ne,ce)=>re(q(ne),q(ce))}e.compareBy=B;function $(...q){return(re,ne)=>{for(const ce of q){const ge=ce(re,ne);if(!J.isNeitherLessOrGreaterThan(ge))return ge}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const L=(q,re)=>q-re;e.numberComparator=L;function O(q,re){if(q.length===0)return;let ne=q[0];for(let ce=1;ce<q.length;ce++){const ge=q[ce];re(ge,ne)>0&&(ne=ge)}return ne}e.findMaxBy=O;function _(q,re){if(q.length===0)return;let ne=q[0];for(let ce=1;ce<q.length;ce++){const ge=q[ce];re(ge,ne)>=0&&(ne=ge)}return ne}e.findLastMaxBy=_;function j(q,re){return O(q,(ne,ce)=>-re(ne,ce))}e.findMinBy=j;class Y{constructor(re){this.items=re,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(re){let ne=this.firstIdx;for(;ne<this.items.length&&re(this.items[ne]);)ne++;const ce=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ce}takeFromEndWhile(re){let ne=this.lastIdx;for(;ne>=0&&re(this.items[ne]);)ne--;const ce=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const re=this.items[this.firstIdx];return this.firstIdx++,re}removeLast(){const re=this.items[this.lastIdx];return this.lastIdx--,re}takeCount(re){const ne=this.items.slice(this.firstIdx,this.firstIdx+re);return this.firstIdx+=re,ne}}e.ArrayQueue=Y;class oe{constructor(re){this.iterate=re}forEach(re){this.iterate(ne=>(re(ne),!0))}toArray(){const re=[];return this.iterate(ne=>(re.push(ne),!0)),re}filter(re){return new oe(ne=>this.iterate(ce=>re(ce)?ne(ce):!0))}map(re){return new oe(ne=>this.iterate(ce=>ne(re(ce))))}some(re){let ne=!1;return this.iterate(ce=>(ne=re(ce),!ne)),ne}findFirst(re){let ne;return this.iterate(ce=>re(ce)?(ne=ce,!1):!0),ne}findLast(re){let ne;return this.iterate(ce=>(re(ce)&&(ne=ce),!0)),ne}findLastMaxBy(re){let ne,ce=!0;return this.iterate(ge=>((ce||J.isGreaterThan(re(ge,ne)))&&(ce=!1,ne=ge),!0)),ne}}e.CallbackIterable=oe,oe.empty=new oe(q=>{})}),define(te[122],ie([0,1,17]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(u,p){if(!u)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=t;function k(u,p="Unreachable"){throw new Error(p)}e.assertNever=k;function R(u){if(!u)throw new S.BugIndicatingError("Assertion Failed")}e.assert=R;function D(u){if(!u()){debugger;u(),(0,S.onUnexpectedError)(new S.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function b(u,p){let C=0;for(;C<u.length-1;){const y=u[C],E=u[C+1];if(!p(y,E))return!1;C++}return!0}e.checkAdjacentItems=b}),define(te[49],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=S}),define(te[57],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(t){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*b(o){yield o}t.single=b;function u(o){return o||R}t.from=u;function p(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=p;function C(o){return o[Symbol.iterator]().next().value}t.first=C;function y(o,n){for(const r of o)if(n(r))return!0;return!1}t.some=y;function E(o,n){for(const r of o)if(n(r))return r}t.find=E;function*h(o,n){for(const r of o)n(r)&&(yield r)}t.filter=h;function*f(o,n){let r=0;for(const s of o)yield n(s,r++)}t.map=f;function*P(...o){for(const n of o)for(const r of n)yield r}t.concat=P;function*w(o){for(const n of o)for(const r of n)yield r}t.concatNested=w;function m(o,n,r){let s=r;for(const l of o)s=n(s,l);return s}t.reduce=m;function v(o,n){let r=0;for(const s of o)n(s,r++)}t.forEach=v;function*d(o,n,r=o.length){for(n<0&&(n+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);n<r;n++)yield o[n]}t.slice=d;function g(o,n=Number.POSITIVE_INFINITY){const r=[];if(n===0)return[r,o];const s=o[Symbol.iterator]();for(let l=0;l<n;l++){const a=s.next();if(a.done)return[r,t.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return s}}]}t.consume=g;function c(o){return g(o)[0]}t.collect=c;function i(o,n,r=(s,l)=>s===l){const s=o[Symbol.iterator](),l=n[Symbol.iterator]();for(;;){const a=s.next(),I=l.next();if(a.done!==I.done)return!1;if(a.done)return!0;if(!r(a.value,I.value))return!1}}t.equals=i})(S=e.Iterable||(e.Iterable={}))}),define(te[43],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(i,o=!1){let n=0;const r=i.length;let s="",l=0,a=16,I=0;function M(Z){let se=0,he=0;for(;se<Z;){const V=i.charCodeAt(n);if(V>=48&&V<=57)he=he*16+V-48;else if(V>=65&&V<=70)he=he*16+V-65+10;else if(V>=97&&V<=102)he=he*16+V-97+10;else break;n++,se++}return se<Z&&(he=-1),he}function T(Z){n=Z,s="",l=0,a=16,I=0}function N(){const Z=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&p(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&p(i.charCodeAt(n)))for(n++;n<i.length&&p(i.charCodeAt(n));)n++;else return I=3,i.substring(Z,n);let se=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&p(i.charCodeAt(n))){for(n++;n<i.length&&p(i.charCodeAt(n));)n++;se=n}else I=3;return i.substring(Z,se)}function X(){let Z="",se=n;for(;;){if(n>=r){Z+=i.substring(se,n),I=2;break}const he=i.charCodeAt(n);if(he===34){Z+=i.substring(se,n),n++;break}if(he===92){if(Z+=i.substring(se,n),n++,n>=r){I=2;break}switch(i.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:{const H=M(4);H>=0?Z+=String.fromCharCode(H):I=4;break}default:I=5}se=n;continue}if(he>=0&&he<=31)if(u(he)){Z+=i.substring(se,n),I=2;break}else I=6;n++}return Z}function ae(){if(s="",I=0,l=n,n>=r)return l=r,a=17;let Z=i.charCodeAt(n);if(b(Z)){do n++,s+=String.fromCharCode(Z),Z=i.charCodeAt(n);while(b(Z));return a=15}if(u(Z))return n++,s+=String.fromCharCode(Z),Z===13&&i.charCodeAt(n)===10&&(n++,s+=`
`),a=14;switch(Z){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,s=X(),a=10;case 47:{const se=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<r&&!u(i.charCodeAt(n));)n++;return s=i.substring(se,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const he=r-1;let V=!1;for(;n<he;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,V=!0;break}n++}return V||(n++,I=1),s=i.substring(se,n),a=13}return s+=String.fromCharCode(Z),n++,a=16}case 45:if(s+=String.fromCharCode(Z),n++,n===r||!p(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),a=11;default:for(;n<r&&Q(Z);)n++,Z=i.charCodeAt(n);if(l!==n){switch(s=i.substring(l,n),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(Z),n++,a=16}}function Q(Z){if(b(Z)||u(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let Z;do Z=ae();while(Z>=12&&Z<=15);return Z}return{setPosition:T,getPosition:()=>n,scan:o?G:ae,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>I}}e.createScanner=D;function b(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function p(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function y(i,o){const n=[],r=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function I(M,T,N,X){l.value=M,l.offset=T,l.length=N,l.type=X,l.colonOffset=void 0,s=l}try{d(i,{onObjectBegin:(M,T)=>{if(o<=M)throw r;s=void 0,a=o>M,n.push("")},onObjectProperty:(M,T,N)=>{if(o<T||(I(M,T,N,"property"),n[n.length-1]=M,o<=T+N))throw r},onObjectEnd:(M,T)=>{if(o<=M)throw r;s=void 0,n.pop()},onArrayBegin:(M,T)=>{if(o<=M)throw r;s=void 0,n.push(0)},onArrayEnd:(M,T)=>{if(o<=M)throw r;s=void 0,n.pop()},onLiteralValue:(M,T,N)=>{if(o<T||(I(M,T,N,c(M)),o<=T+N))throw r},onSeparator:(M,T,N)=>{if(o<=T)throw r;if(M===":"&&s&&s.type==="property")s.colonOffset=T,a=!1,s=void 0;else if(M===","){const X=n[n.length-1];typeof X=="number"?n[n.length-1]=X+1:(a=!0,n[n.length-1]=""),s=void 0}}})}catch(M){if(M!==r)throw M}return{path:n,previousNode:s,isAtPropertyKey:a,matches:M=>{let T=0;for(let N=0;T<M.length&&N<n.length;N++)if(M[T]===n[N]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=y;function E(i,o=[],n=R.DEFAULT){let r=null,s=[];const l=[];function a(M){Array.isArray(s)?s.push(M):r!==null&&(s[r]=M)}return d(i,{onObjectBegin:()=>{const M={};a(M),l.push(s),s=M,r=null},onObjectProperty:M=>{r=M},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const M=[];a(M),l.push(s),s=M,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:a,onError:(M,T,N)=>{o.push({error:M,offset:T,length:N})}},n),s[0]}e.parse=E;function h(i,o=[],n=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(M){r.type==="property"&&(r.length=M-r.offset,r=r.parent)}function l(M){return r.children.push(M),M}d(i,{onObjectBegin:M=>{r=l({type:"object",offset:M,length:-1,parent:r,children:[]})},onObjectProperty:(M,T,N)=>{r=l({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:M,offset:T,length:N,parent:r})},onObjectEnd:(M,T)=>{r.length=M+T-r.offset,r=r.parent,s(M+T)},onArrayBegin:(M,T)=>{r=l({type:"array",offset:M,length:-1,parent:r,children:[]})},onArrayEnd:(M,T)=>{r.length=M+T-r.offset,r=r.parent,s(M+T)},onLiteralValue:(M,T,N)=>{l({type:c(M),offset:T,length:N,parent:r,value:M}),s(T+N)},onSeparator:(M,T,N)=>{r.type==="property"&&(M===":"?r.colonOffset=T:M===","&&s(T))},onError:(M,T,N)=>{o.push({error:M,offset:T,length:N})}},n);const I=r.children[0];return I&&delete I.parent,I}e.parseTree=h;function f(i,o){if(!i)return;let n=i;for(const r of o)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===r){n=l.children[1],s=!0;break}if(!s)return}else{const s=r;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=f;function P(i){if(!i.parent||!i.parent.children)return[];const o=P(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.getNodePath=P;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const o=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(o[n.children[0].value]=w(r))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=w;function m(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.contains=m;function v(i,o,n=!1){if(m(i,o,n)){const r=i.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=o;s++){const l=v(r[s],o,n);if(l)return l}return i}}e.findNodeAtOffset=v;function d(i,o,n=R.DEFAULT){const r=D(i,!1);function s(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(B){return B?$=>B($,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=s(o.onObjectBegin),I=l(o.onObjectProperty),M=s(o.onObjectEnd),T=s(o.onArrayBegin),N=s(o.onArrayEnd),X=l(o.onLiteralValue),ae=l(o.onSeparator),Q=s(o.onComment),G=l(o.onError),Z=n&&n.disallowComments,se=n&&n.allowTrailingComma;function he(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:Z||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(B){case 12:case 13:Z?V(10):Q();break;case 16:V(1);break;case 15:case 14:break;default:return B}}}function V(B,$=[],L=[]){if(G(B),$.length+L.length>0){let O=r.getToken();for(;O!==17;){if($.indexOf(O)!==-1){he();break}else if(L.indexOf(O)!==-1)break;O=he()}}}function H(B){const $=r.getTokenValue();return B?X($):I($),he(),!0}function W(){switch(r.getToken()){case 11:{let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(V(2),B=0)}catch{V(2)}X(B);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return he(),!0}function A(){return r.getToken()!==10?(V(3,[],[2,5]),!1):(H(!1),r.getToken()===6?(ae(":"),he(),J()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function F(){a(),he();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||V(4,[],[]),ae(","),he(),r.getToken()===2&&se)break}else B&&V(6,[],[]);A()||V(4,[],[2,5]),B=!0}return M(),r.getToken()!==2?V(7,[2],[]):he(),!0}function U(){T(),he();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||V(4,[],[]),ae(","),he(),r.getToken()===4&&se)break}else B&&V(6,[],[]);J()||V(4,[],[4,5]),B=!0}return N(),r.getToken()!==4?V(8,[4],[]):he(),!0}function J(){switch(r.getToken()){case 3:return U();case 1:return F();case 10:return H(!0);default:return W()}}return he(),r.getToken()===17?n.allowEmptyContent?!0:(V(4,[],[]),!1):J()?(r.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=d;function g(i,o){const n=D(i),r=[];let s,l=0,a;do switch(a=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:l!==a&&r.push(i.substring(l,a)),o!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,o)),l=n.getPosition();break}while(s!==17);return r.join("")}e.stripComments=g;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(te[123],ie([0,1,43]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(p,C,y){let E,h,f,P,w;if(C){for(P=C.offset,w=P+C.length,f=P;f>0&&!u(p,f-1);)f--;let a=w;for(;a<p.length&&!u(p,a);)a++;h=p.substring(f,a),E=D(h,y)}else h=p,E=0,f=0,P=0,w=p.length;const m=b(y,p);let v=!1,d=0,g;y.insertSpaces?g=R(" ",y.tabSize||4):g="	";const c=(0,S.createScanner)(h,!1);let i=!1;function o(){return m+R(g,E+d)}function n(){let a=c.scan();for(v=!1;a===15||a===14;)v=v||a===14,a=c.scan();return i=a===16||c.getTokenError()!==0,a}const r=[];function s(a,I,M){!i&&I<w&&M>P&&p.substring(I,M)!==a&&r.push({offset:I,length:M-I,content:a})}let l=n();if(l!==17){const a=c.getTokenOffset()+f,I=R(g,E);s(I,f,a)}for(;l!==17;){let a=c.getTokenOffset()+c.getTokenLength()+f,I=n(),M="";for(;!v&&(I===12||I===13);){const N=c.getTokenOffset()+f;s(" ",a,N),a=c.getTokenOffset()+c.getTokenLength()+f,M=I===12?o():"",I=n()}if(I===2)l!==1&&(d--,M=o());else if(I===4)l!==3&&(d--,M=o());else{switch(l){case 3:case 1:d++,M=o();break;case 5:case 12:M=o();break;case 13:v?M=o():M=" ";break;case 6:M=" ";break;case 10:if(I===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?M=" ":I!==5&&I!==17&&(i=!0);break;case 16:i=!0;break}v&&(I===12||I===13)&&(M=o())}const T=c.getTokenOffset()+f;s(M,a,T),l=I}return r}e.format=t;function k(p,C){const y=JSON.stringify(p,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?y.replace(/\r\n|\r|\n/g,C.eol):y}e.toFormattedString=k;function R(p,C){let y="";for(let E=0;E<C;E++)y+=p;return y}function D(p,C){let y=0,E=0;const h=C.tabSize||4;for(;y<p.length;){const f=p.charAt(y);if(f===" ")E++;else if(f==="	")E+=h;else break;y++}return Math.floor(E/h)}function b(p,C){for(let y=0;y<C.length;y++){const E=C.charAt(y);if(E==="\r")return y+1<C.length&&C.charAt(y+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=b;function u(p,C){return`\r
`.indexOf(p.charAt(C))!==-1}e.isEOL=u}),define(te[124],ie([0,1,43,123]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(p,C,y){return R(p,C,void 0,y)}e.removeProperty=k;function R(p,C,y,E,h){const f=C.slice(),P=[],w=(0,S.parseTree)(p,P);let m,v;for(;f.length>0&&(v=f.pop(),m=(0,S.findNodeAtLocation)(w,f),m===void 0&&y!==void 0);)typeof v=="string"?y={[v]:y}:y=[y];if(m)if(m.type==="object"&&typeof v=="string"&&Array.isArray(m.children)){const d=(0,S.findNodeAtLocation)(m,[v]);if(d!==void 0)if(y===void 0){if(!d.parent)throw new Error("Malformed AST");const g=m.children.indexOf(d.parent);let c,i=d.parent.offset+d.parent.length;if(g>0){const o=m.children[g-1];c=o.offset+o.length}else c=m.offset+1,m.children.length>1&&(i=m.children[1].offset);return D(p,{offset:c,length:i-c,content:""},E)}else return D(p,{offset:d.offset,length:d.length,content:JSON.stringify(y)},E);else{if(y===void 0)return[];const g=`${JSON.stringify(v)}: ${JSON.stringify(y)}`,c=h?h(m.children.map(o=>o.children[0].value)):m.children.length;let i;if(c>0){const o=m.children[c-1];i={offset:o.offset+o.length,length:0,content:","+g}}else m.children.length===0?i={offset:m.offset+1,length:0,content:g}:i={offset:m.offset+1,length:0,content:g+","};return D(p,i,E)}}else if(m.type==="array"&&typeof v=="number"&&Array.isArray(m.children))if(y!==void 0){const d=`${JSON.stringify(y)}`;let g;if(m.children.length===0||v===0)g={offset:m.offset+1,length:0,content:m.children.length===0?d:d+","};else{const c=v===-1||v>m.children.length?m.children.length:v,i=m.children[c-1];g={offset:i.offset+i.length,length:0,content:","+d}}return D(p,g,E)}else{const d=v,g=m.children[d];let c;if(m.children.length===1)c={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===d){const i=m.children[d-1],o=i.offset+i.length,n=m.offset+m.length;c={offset:o,length:n-2-o,content:""}}else c={offset:g.offset,length:m.children[d+1].offset-g.offset,content:""};return D(p,c,E)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${m.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return D(p,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(y)},E)}}e.setProperty=R;function D(p,C,y){let E=b(p,C),h=C.offset,f=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;h>0&&!(0,t.isEOL)(E,h-1);)h--;for(;f<E.length&&!(0,t.isEOL)(E,f);)f++}const P=(0,t.format)(E,{offset:h,length:f-h},y);for(let m=P.length-1;m>=0;m--){const v=P[m];E=b(E,v),h=Math.min(h,v.offset),f=Math.max(f,v.offset+v.length),f+=v.content.length-v.length}const w=p.length-(E.length-f)-h;return[{offset:h,length:w,content:E.substring(h,f)}]}e.withFormatting=D;function b(p,C){return p.substring(0,C.offset)+C.content+p.substring(C.offset+C.length)}e.applyEdit=b;function u(p,C){const y=C.slice(0).sort((h,f)=>{const P=h.offset-f.offset;return P===0?h.length-f.length:P});let E=p.length;for(let h=y.length-1;h>=0;h--){const f=y[h];if(f.offset+f.length<=E)p=b(p,f);else throw new Error("Overlapping edit");E=f.offset}return p}e.applyEdits=u}),define(te[125],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new S(()=>k(this.getValue()))}}e.Lazy=S}),define(te[2],ie([0,1,49,57]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(l){R=l}if(e.setDisposableTracker=D,k){const l="__is_disposable_tracked__";D(new class{trackDisposable(a){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(I)},3e3)}setParent(a,I){if(a&&a!==v.None)try{a[l]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[l]=!0}catch{}}markAsSingleton(a){}})}function b(l){return R?.trackDisposable(l),l}function u(l){R?.markAsDisposed(l)}function p(l,a){R?.setParent(l,a)}function C(l,a){if(!!R)for(const I of l)R.setParent(I,a)}function y(l){return R?.markAsSingleton(l),l}e.markAsSingleton=y;function E(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=E;function h(l){if(t.Iterable.is(l)){const a=[];for(const I of l)if(I)try{I.dispose()}catch(M){a.push(M)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=h;function f(l){for(const a of l)E(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function P(...l){const a=w(()=>h(l));return C(l,a),a}e.combinedDisposable=P;function w(l){const a=b({dispose:(0,S.once)(()=>{u(a),l()})});return a}e.toDisposable=w;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return p(a,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new m,b(this),p(this._store,this)}dispose(){u(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&p(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&p(a,null),a}}e.MutableDisposable=d;class g{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(a){let I=a;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,u(this))},this}}e.SafeDisposable=c;class i{constructor(){this.references=new Map}acquire(a,...I){let M=this.references.get(a);M||(M={counter:0,object:this.createReferencedObject(a,...I)},this.references.set(a,M));const{object:T}=M,N=(0,S.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(a,M.object),this.references.delete(a))});return M.counter++,{object:T,dispose:N}}}e.ReferenceCollection=i;class o{constructor(a){this.referenceCollection=a}async acquire(a,...I){const M=this.referenceCollection.acquire(a,...I);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.AsyncReferenceCollection=o;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function r(l){const a=new m;try{l(a)}finally{a.dispose()}}e.disposeOnReturn=r;class s{constructor(){this._store=new Map,this._isDisposed=!1,b(this)}dispose(){u(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{h(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,I,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(a)?.dispose(),this._store.set(a,I)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(te[94],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(R){this.element=R,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class t{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let R=this._first;for(;R!==S.Undefined;){const D=R.next;R.prev=S.Undefined,R.next=S.Undefined,R=D}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const b=new S(R);if(this._first===S.Undefined)this._first=b,this._last=b;else if(D){const p=this._last;this._last=b,b.prev=p,p.next=b}else{const p=this._first;this._first=b,b.next=p,p.prev=b}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(b))}}shift(){if(this._first!==S.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==S.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==S.Undefined&&R.next!==S.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===S.Undefined&&R.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):R.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):R.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==S.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function z(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(u){R.push(u,Date.now())}function b(){const u=[];for(let p=0;p<R.length;p+=2)u.push({name:R[p],startTime:R[p+1]});return u}return{mark:D,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function S(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=S(t))}(),function(z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var t in S)(typeof exports=="object"?exports:z)[t]=S[t]}}(typeof self<"u"?self:this,function(){return function(z){var e={};function S(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return z[t].call(k.exports,k,k.exports,S),k.l=!0,k.exports}return S.m=z,S.c=e,S.d=function(t,k,R){S.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},S.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},S.t=function(t,k){if(1&k&&(t=S(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)S.d(R,D,function(b){return t[b]}.bind(null,D));return R},S.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return S.d(k,"a",k),k},S.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},S.p="",S(S.s=0)}([function(z,e,S){(function(t){var k;e=z.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],u=e.src=[],p=0,C=p++;u[C]="0|[1-9]\\d*";var y=p++;u[y]="[0-9]+";var E=p++;u[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=p++;u[h]="("+u[C]+")\\.("+u[C]+")\\.("+u[C]+")";var f=p++;u[f]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var P=p++;u[P]="(?:"+u[C]+"|"+u[E]+")";var w=p++;u[w]="(?:"+u[y]+"|"+u[E]+")";var m=p++;u[m]="(?:-("+u[P]+"(?:\\."+u[P]+")*))";var v=p++;u[v]="(?:-?("+u[w]+"(?:\\."+u[w]+")*))";var d=p++;u[d]="[0-9A-Za-z-]+";var g=p++;u[g]="(?:\\+("+u[d]+"(?:\\."+u[d]+")*))";var c=p++,i="v?"+u[h]+u[m]+"?"+u[g]+"?";u[c]="^"+i+"$";var o="[v=\\s]*"+u[f]+u[v]+"?"+u[g]+"?",n=p++;u[n]="^"+o+"$";var r=p++;u[r]="((?:<|>)?=?)";var s=p++;u[s]=u[y]+"|x|X|\\*";var l=p++;u[l]=u[C]+"|x|X|\\*";var a=p++;u[a]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[m]+")?"+u[g]+"?)?)?";var I=p++;u[I]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[v]+")?"+u[g]+"?)?)?";var M=p++;u[M]="^"+u[r]+"\\s*"+u[a]+"$";var T=p++;u[T]="^"+u[r]+"\\s*"+u[I]+"$";var N=p++;u[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=p++;u[X]="(?:~>?)";var ae=p++;u[ae]="(\\s*)"+u[X]+"\\s+",b[ae]=new RegExp(u[ae],"g");var Q=p++;u[Q]="^"+u[X]+u[a]+"$";var G=p++;u[G]="^"+u[X]+u[I]+"$";var Z=p++;u[Z]="(?:\\^)";var se=p++;u[se]="(\\s*)"+u[Z]+"\\s+",b[se]=new RegExp(u[se],"g");var he=p++;u[he]="^"+u[Z]+u[a]+"$";var V=p++;u[V]="^"+u[Z]+u[I]+"$";var H=p++;u[H]="^"+u[r]+"\\s*("+o+")$|^$";var W=p++;u[W]="^"+u[r]+"\\s*("+i+")$|^$";var A=p++;u[A]="(\\s*)"+u[r]+"\\s*("+o+"|"+u[a]+")",b[A]=new RegExp(u[A],"g");var F=p++;u[F]="^\\s*("+u[a]+")\\s+-\\s+("+u[a]+")\\s*$";var U=p++;u[U]="^\\s*("+u[I]+")\\s+-\\s+("+u[I]+")\\s*$";var J=p++;u[J]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,u[B]),b[B]||(b[B]=new RegExp(u[B]));function $(x,le){if(x instanceof L)return x;if(typeof x!="string"||x.length>R||!(le?b[n]:b[c]).test(x))return null;try{return new L(x,le)}catch{return null}}function L(x,le){if(x instanceof L){if(x.loose===le)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(x,le);k("SemVer",x,le),this.loose=le;var fe=x.trim().match(le?b[n]:b[c]);if(!fe)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ie=+Se;if(Ie>=0&&Ie<D)return Ie}return Se}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=$,e.valid=function(x,le){var fe=$(x,le);return fe?fe.version:null},e.clean=function(x,le){var fe=$(x.trim().replace(/^[=v]+/,""),le);return fe?fe.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof L||(x=new L(x,this.loose)),this.compareMain(x)||this.comparePre(x)},L.prototype.compareMain=function(x){return x instanceof L||(x=new L(x,this.loose)),_(this.major,x.major)||_(this.minor,x.minor)||_(this.patch,x.patch)},L.prototype.comparePre=function(x){if(x instanceof L||(x=new L(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var le=0;do{var fe=this.prerelease[le],Se=x.prerelease[le];if(k("prerelease compare",le,fe,Se),fe===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(fe===void 0)return-1;if(fe!==Se)return _(fe,Se)}while(++le)},L.prototype.inc=function(x,le){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,le,fe,Se){typeof fe=="string"&&(Se=fe,fe=void 0);try{return new L(x,fe).inc(le,Se).version}catch{return null}},e.diff=function(x,le){if(q(x,le))return null;var fe=$(x),Se=$(le);if(fe.prerelease.length||Se.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Se[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Se[Ie])return Ie},e.compareIdentifiers=_;var O=/^[0-9]+$/;function _(x,le){var fe=O.test(x),Se=O.test(le);return fe&&Se&&(x=+x,le=+le),fe&&!Se?-1:Se&&!fe?1:x<le?-1:x>le?1:0}function j(x,le,fe){return new L(x,fe).compare(new L(le,fe))}function Y(x,le,fe){return j(x,le,fe)>0}function oe(x,le,fe){return j(x,le,fe)<0}function q(x,le,fe){return j(x,le,fe)===0}function re(x,le,fe){return j(x,le,fe)!==0}function ne(x,le,fe){return j(x,le,fe)>=0}function ce(x,le,fe){return j(x,le,fe)<=0}function ge(x,le,fe,Se){var Ie;switch(le){case"===":typeof x=="object"&&(x=x.version),typeof fe=="object"&&(fe=fe.version),Ie=x===fe;break;case"!==":typeof x=="object"&&(x=x.version),typeof fe=="object"&&(fe=fe.version),Ie=x!==fe;break;case"":case"=":case"==":Ie=q(x,fe,Se);break;case"!=":Ie=re(x,fe,Se);break;case">":Ie=Y(x,fe,Se);break;case">=":Ie=ne(x,fe,Se);break;case"<":Ie=oe(x,fe,Se);break;case"<=":Ie=ce(x,fe,Se);break;default:throw new TypeError("Invalid operator: "+le)}return Ie}function De(x,le){if(x instanceof De){if(x.loose===le)return x;x=x.value}if(!(this instanceof De))return new De(x,le);k("comparator",x,le),this.loose=le,this.parse(x),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,le){return _(le,x)},e.major=function(x,le){return new L(x,le).major},e.minor=function(x,le){return new L(x,le).minor},e.patch=function(x,le){return new L(x,le).patch},e.compare=j,e.compareLoose=function(x,le){return j(x,le,!0)},e.rcompare=function(x,le,fe){return j(le,x,fe)},e.sort=function(x,le){return x.sort(function(fe,Se){return e.compare(fe,Se,le)})},e.rsort=function(x,le){return x.sort(function(fe,Se){return e.rcompare(fe,Se,le)})},e.gt=Y,e.lt=oe,e.eq=q,e.neq=re,e.gte=ne,e.lte=ce,e.cmp=ge,e.Comparator=De;var Ae={};function ke(x,le){if(x instanceof ke)return x.loose===le?x:new ke(x.raw,le);if(x instanceof De)return new ke(x.value,le);if(!(this instanceof ke))return new ke(x,le);if(this.loose=le,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Le(x){return!x||x.toLowerCase()==="x"||x==="*"}function qe(x,le,fe,Se,Ie,Te,Oe,Ne,Be,ze,Ke,Ue,Ge){return((le=Le(fe)?"":Le(Se)?">="+fe+".0.0":Le(Ie)?">="+fe+"."+Se+".0":">="+le)+" "+(Ne=Le(Be)?"":Le(ze)?"<"+(+Be+1)+".0.0":Le(Ke)?"<"+Be+"."+(+ze+1)+".0":Ue?"<="+Be+"."+ze+"."+Ke+"-"+Ue:"<="+Ne)).trim()}function me(x,le){for(var fe=0;fe<x.length;fe++)if(!x[fe].test(le))return!1;if(le.prerelease.length){for(fe=0;fe<x.length;fe++)if(k(x[fe].semver),x[fe].semver!==Ae&&x[fe].semver.prerelease.length>0){var Se=x[fe].semver;if(Se.major===le.major&&Se.minor===le.minor&&Se.patch===le.patch)return!0}return!1}return!0}function we(x,le,fe){try{le=new ke(le,fe)}catch{return!1}return le.test(x)}function Ee(x,le,fe,Se){var Ie,Te,Oe,Ne,Be;switch(x=new L(x,Se),le=new ke(le,Se),fe){case">":Ie=Y,Te=ce,Oe=oe,Ne=">",Be=">=";break;case"<":Ie=oe,Te=ne,Oe=Y,Ne="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(x,le,Se))return!1;for(var ze=0;ze<le.set.length;++ze){var Ke=le.set[ze],Ue=null,Ge=null;if(Ke.forEach(function(K){K.semver===Ae&&(K=new De(">=0.0.0")),Ue=Ue||K,Ge=Ge||K,Ie(K.semver,Ue.semver,Se)?Ue=K:Oe(K.semver,Ge.semver,Se)&&(Ge=K)}),Ue.operator===Ne||Ue.operator===Be||(!Ge.operator||Ge.operator===Ne)&&Te(x,Ge.semver)||Ge.operator===Be&&Oe(x,Ge.semver))return!1}return!0}De.prototype.parse=function(x){var le=this.loose?b[H]:b[W],fe=x.match(le);if(!fe)throw new TypeError("Invalid comparator: "+x);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new L(fe[2],this.loose):this.semver=Ae},De.prototype.toString=function(){return this.value},De.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===Ae||(typeof x=="string"&&(x=new L(x,this.loose)),ge(x,this.operator,this.semver,this.loose))},De.prototype.intersects=function(x,le){if(!(x instanceof De))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new ke(x.value,le),we(this.value,fe,le);if(x.operator==="")return fe=new ke(this.value,le),we(x.semver,fe,le);var Se=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Te=this.semver.version===x.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Ne=ge(this.semver,"<",x.semver,le)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Be=ge(this.semver,">",x.semver,le)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return Se||Ie||Te&&Oe||Ne||Be},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(x){var le=this.loose;x=x.trim(),k("range",x,le);var fe=le?b[U]:b[F];x=x.replace(fe,qe),k("hyphen replace",x),x=x.replace(b[A],"$1$2$3"),k("comparator trim",x,b[A]),x=(x=(x=x.replace(b[ae],"$1~")).replace(b[se],"$1^")).split(/\s+/).join(" ");var Se=le?b[H]:b[W],Ie=x.split(" ").map(function(Te){return function(Oe,Ne){return k("comp",Oe),Oe=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ke){return function(Ue,Ge){k("caret",Ue,Ge);var K=Ge?b[V]:b[he];return Ue.replace(K,function(ue,de,pe,ye,Re){var _e;return k("caret",Ue,ue,de,pe,ye,Re),Le(de)?_e="":Le(pe)?_e=">="+de+".0.0 <"+(+de+1)+".0.0":Le(ye)?_e=de==="0"?">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+".0 <"+(+de+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),_e=de==="0"?pe==="0"?">="+de+"."+pe+"."+ye+Re+" <"+de+"."+pe+"."+(+ye+1):">="+de+"."+pe+"."+ye+Re+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+ye+Re+" <"+(+de+1)+".0.0"):(k("no pr"),_e=de==="0"?pe==="0"?">="+de+"."+pe+"."+ye+" <"+de+"."+pe+"."+(+ye+1):">="+de+"."+pe+"."+ye+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+ye+" <"+(+de+1)+".0.0"),k("caret return",_e),_e})}(Ke,ze)}).join(" ")}(Oe,Ne),k("caret",Oe),Oe=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ke){return function(Ue,Ge){var K=Ge?b[G]:b[Q];return Ue.replace(K,function(ue,de,pe,ye,Re){var _e;return k("tilde",Ue,ue,de,pe,ye,Re),Le(de)?_e="":Le(pe)?_e=">="+de+".0.0 <"+(+de+1)+".0.0":Le(ye)?_e=">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),_e=">="+de+"."+pe+"."+ye+Re+" <"+de+"."+(+pe+1)+".0"):_e=">="+de+"."+pe+"."+ye+" <"+de+"."+(+pe+1)+".0",k("tilde return",_e),_e})}(Ke,ze)}).join(" ")}(Oe,Ne),k("tildes",Oe),Oe=function(Be,ze){return k("replaceXRanges",Be,ze),Be.split(/\s+/).map(function(Ke){return function(Ue,Ge){Ue=Ue.trim();var K=Ge?b[T]:b[M];return Ue.replace(K,function(ue,de,pe,ye,Re,_e){k("xRange",Ue,ue,de,pe,ye,Re,_e);var it=Le(pe),xe=it||Le(ye),je=xe||Le(Re);return de==="="&&je&&(de=""),it?ue=de===">"||de==="<"?"<0.0.0":"*":de&&je?(xe&&(ye=0),je&&(Re=0),de===">"?(de=">=",xe?(pe=+pe+1,ye=0,Re=0):je&&(ye=+ye+1,Re=0)):de==="<="&&(de="<",xe?pe=+pe+1:ye=+ye+1),ue=de+pe+"."+ye+"."+Re):xe?ue=">="+pe+".0.0 <"+(+pe+1)+".0.0":je&&(ue=">="+pe+"."+ye+".0 <"+pe+"."+(+ye+1)+".0"),k("xRange return",ue),ue})}(Ke,ze)}).join(" ")}(Oe,Ne),k("xrange",Oe),Oe=function(Be,ze){return k("replaceStars",Be,ze),Be.trim().replace(b[J],"")}(Oe,Ne),k("stars",Oe),Oe}(Te,le)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Te){return!!Te.match(Se)})),Ie=Ie.map(function(Te){return new De(Te,le)})},ke.prototype.intersects=function(x,le){if(!(x instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Se){return x.set.some(function(Ie){return Ie.every(function(Te){return Se.intersects(Te,le)})})})})},e.toComparators=function(x,le){return new ke(x,le).set.map(function(fe){return fe.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new L(x,this.loose));for(var le=0;le<this.set.length;le++)if(me(this.set[le],x))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(x,le,fe){var Se=null,Ie=null;try{var Te=new ke(le,fe)}catch{return null}return x.forEach(function(Oe){Te.test(Oe)&&(Se&&Ie.compare(Oe)!==-1||(Ie=new L(Se=Oe,fe)))}),Se},e.minSatisfying=function(x,le,fe){var Se=null,Ie=null;try{var Te=new ke(le,fe)}catch{return null}return x.forEach(function(Oe){Te.test(Oe)&&(Se&&Ie.compare(Oe)!==1||(Ie=new L(Se=Oe,fe)))}),Se},e.validRange=function(x,le){try{return new ke(x,le).range||"*"}catch{return null}},e.ltr=function(x,le,fe){return Ee(x,le,"<",fe)},e.gtr=function(x,le,fe){return Ee(x,le,">",fe)},e.outside=Ee,e.prerelease=function(x,le){var fe=$(x,le);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(x,le,fe){return x=new ke(x,fe),le=new ke(le,fe),x.intersects(le)},e.coerce=function(x){if(x instanceof L)return x;if(typeof x!="string")return null;var le=x.match(b[N]);return le==null?null:$((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,S(1))},function(z,e){var S,t,k=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function b(w){if(S===setTimeout)return setTimeout(w,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(w,0);try{return S(w,0)}catch{try{return S.call(null,w,0)}catch{return S.call(this,w,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var u,p=[],C=!1,y=-1;function E(){C&&u&&(C=!1,u.length?p=u.concat(p):y=-1,p.length&&h())}function h(){if(!C){var w=b(E);C=!0;for(var m=p.length;m;){for(u=p,p=[];++y<m;)u&&u[y].run();y=-1,m=p.length}u=null,C=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(w)}}function f(w,m){this.fun=w,this.array=m}function P(){}k.nextTick=function(w){var m=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)m[v-1]=arguments[v];p.push(new f(w,m)),p.length!==1||C||b(h)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=P,k.addListener=P,k.once=P,k.off=P,k.removeListener=P,k.removeAllListeners=P,k.emit=P,k.prependListener=P,k.prependOnceListener=P,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[126],ie([0,1]),function(z,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(b,u,p){this.level=b,this.key=u,this.value=p,this.forward=[]}}const k=void 0;class R{constructor(b,u=2**16){this.comparator=b,this[S]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(b){return Boolean(R._search(this,b,this.comparator))}get(b){return R._search(this,b,this.comparator)?.value}set(b,u){return R._insert(this,b,u,this.comparator)&&(this._size+=1),this}delete(b){const u=R._delete(this,b,this.comparator);return u&&(this._size-=1),u}forEach(b,u){let p=this._header.forward[0];for(;p;)b.call(u,p.value,p.key,this),p=p.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",u=this._header.forward[0];for(;u;)b+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return b}static _search(b,u,p){let C=b._header;for(let y=b._level-1;y>=0;y--)for(;C.forward[y]&&p(C.forward[y].key,u)<0;)C=C.forward[y];if(C=C.forward[0],C&&p(C.key,u)===0)return C}static _insert(b,u,p,C){const y=[];let E=b._header;for(let h=b._level-1;h>=0;h--){for(;E.forward[h]&&C(E.forward[h].key,u)<0;)E=E.forward[h];y[h]=E}if(E=E.forward[0],E&&C(E.key,u)===0)return E.value=p,!1;{const h=R._randomLevel(b);if(h>b._level){for(let f=b._level;f<h;f++)y[f]=b._header;b._level=h}E=new t(h,u,p);for(let f=0;f<h;f++)E.forward[f]=y[f].forward[f],y[f].forward[f]=E;return!0}}static _randomLevel(b,u=.5){let p=1;for(;Math.random()<u&&p<b._maxLevel;)p+=1;return p}static _delete(b,u,p){const C=[];let y=b._header;for(let E=b._level-1;E>=0;E--){for(;y.forward[E]&&p(y.forward[E].key,u)<0;)y=y.forward[E];C[E]=y}if(y=y.forward[0],!y||p(y.key,u)!==0)return!1;for(let E=0;E<b._level&&C[E].forward[E]===y;E++)C[E].forward[E]=y.forward[E];for(;b._level>0&&b._header.forward[b._level-1]===k;)b._level-=1;return!0}}e.SkipList=R}),define(te[58],ie([0,1,17,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(g){const c=g;return c?typeof c.read=="function":!1}e.isReadable=k;function R(g){const c=g;return c?[c.on,c.pause,c.resume,c.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function D(g){const c=g;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function b(g,c){return new u(g,c)}e.newWriteableStream=b;class u{constructor(c,i){this.reducer=c,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(i=>i(c))}emitError(c){this.listeners.error.length===0?(0,S.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(i=>i(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,i){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(c,i){if(this.state.destroyed)return;let o;switch(c){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(g,c){const i=[];let o;for(;(o=g.read())!==null;)i.push(o);return c(i)}e.consumeReadable=p;function C(g,c,i){const o=[];let n;for(;(n=g.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const r=n;return n=void 0,r}return g.read()}}}e.peekReadable=C;function y(g,c){return new Promise((i,o)=>{const n=[];E(g,{onData:r=>{c&&n.push(r)},onError:r=>{c?o(r):i(void 0)},onEnd:()=>{i(c?c(n):void 0)}})})}e.consumeStream=y;function E(g,c){let i=!1;return g.on("error",o=>{i||c.onError(o)}),g.on("end",()=>{i||c.onEnd()}),g.on("data",o=>{i||c.onData(o)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=E;function h(g,c){return new Promise((i,o)=>{const n=new t.DisposableStore,r=[],s=I=>{if(r.push(I),r.length>c)return n.dispose(),g.pause(),i({stream:g,buffer:r,ended:!1})},l=I=>o(I),a=()=>i({stream:g,buffer:r,ended:!0});n.add((0,t.toDisposable)(()=>g.removeListener("error",l))),g.on("error",l),n.add((0,t.toDisposable)(()=>g.removeListener("end",a))),g.on("end",a),n.add((0,t.toDisposable)(()=>g.removeListener("data",s))),g.on("data",s)})}e.peekStream=h;function f(g,c){const i=b(c);return i.end(g),i}e.toStream=f;function P(){const g=b(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=P;function w(g){let c=!1;return{read:()=>c?null:(c=!0,g)}}e.toReadable=w;function m(g,c,i){const o=b(i);return E(g,{onData:n=>o.write(c.data(n)),onError:n=>o.error(c.error?c.error(n):n),onEnd:()=>o.end()}),o}e.transform=m;function v(g,c,i){let o=!1;return{read:()=>{const n=c.read();return o?n:(o=!0,n!==null?i([g,n]):g)}}}e.prefixedReadable=v;function d(g,c,i){let o=!1;const n=b(i);return E(c,{onData:r=>o?n.write(r):(o=!0,n.write(i([g,r]))),onError:r=>n.error(r),onEnd:()=>{o||(o=!0,n.write(g)),n.end()}}),n}e.prefixedStream=d}),define(te[18],ie([0,1,58]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class D{static alloc(I){return t?new D(Buffer.allocUnsafe(I)):new D(new Uint8Array(I))}static wrap(I){return t&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new D(I)}static fromString(I,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(I)):(k||(k=new TextEncoder),new D(k.encode(I)))}static fromByteArray(I){const M=D.alloc(I.length);for(let T=0,N=I.length;T<N;T++)M.buffer[T]=I[T];return M}static concat(I,M){if(typeof M>"u"){M=0;for(let X=0,ae=I.length;X<ae;X++)M+=I[X].byteLength}const T=D.alloc(M);let N=0;for(let X=0,ae=I.length;X<ae;X++){const Q=I[X];T.set(Q,N),N+=Q.byteLength}return T}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=D.alloc(this.byteLength);return I.set(this),I}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(I,M){return new D(this.buffer.subarray(I,M))}set(I,M){if(I instanceof D)this.buffer.set(I.buffer,M);else if(I instanceof Uint8Array)this.buffer.set(I,M);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),M);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return p(this.buffer,I)}writeUInt32BE(I,M){C(this.buffer,I,M)}readUInt32LE(I){return y(this.buffer,I)}writeUInt32LE(I,M){E(this.buffer,I,M)}readUInt8(I){return h(this.buffer,I)}writeUInt8(I,M){f(this.buffer,I,M)}}e.VSBuffer=D;function b(a,I){return a[I+0]<<0>>>0|a[I+1]<<8>>>0}e.readUInt16LE=b;function u(a,I,M){a[M+0]=I&255,I=I>>>8,a[M+1]=I&255}e.writeUInt16LE=u;function p(a,I){return a[I]*2**24+a[I+1]*2**16+a[I+2]*2**8+a[I+3]}e.readUInt32BE=p;function C(a,I,M){a[M+3]=I,I=I>>>8,a[M+2]=I,I=I>>>8,a[M+1]=I,I=I>>>8,a[M]=I}e.writeUInt32BE=C;function y(a,I){return a[I+0]<<0>>>0|a[I+1]<<8>>>0|a[I+2]<<16>>>0|a[I+3]<<24>>>0}e.readUInt32LE=y;function E(a,I,M){a[M+0]=I&255,I=I>>>8,a[M+1]=I&255,I=I>>>8,a[M+2]=I&255,I=I>>>8,a[M+3]=I&255}e.writeUInt32LE=E;function h(a,I){return a[I]}e.readUInt8=h;function f(a,I,M){a[M]=I}e.writeUInt8=f;function P(a){return S.consumeReadable(a,I=>D.concat(I))}e.readableToBuffer=P;function w(a){return S.toReadable(a)}e.bufferToReadable=w;function m(a){return S.consumeStream(a,I=>D.concat(I))}e.streamToBuffer=m;async function v(a){return a.ended?D.concat(a.buffer):D.concat([...a.buffer,await m(a.stream)])}e.bufferedStreamToBuffer=v;function d(a){return S.toStream(a,I=>D.concat(I))}e.bufferToStream=d;function g(a){return S.transform(a,{data:I=>typeof I=="string"?D.fromString(I):D.wrap(I)},I=>D.concat(I))}e.streamToBufferReadableStream=g;function c(a){return S.newWriteableStream(I=>D.concat(I),a)}e.newWriteableBufferStream=c;function i(a,I){return S.prefixedReadable(a,I,M=>D.concat(M))}e.prefixedBufferReadable=i;function o(a,I){return S.prefixedStream(a,I,M=>D.concat(M))}e.prefixedBufferStream=o;function n(a){let I=0,M=0,T=0;const N=new Uint8Array(Math.floor(a.length/4*3)),X=Q=>{switch(M){case 3:N[T++]=I|Q,M=0;break;case 2:N[T++]=I|Q>>>2,I=Q<<6,M=3;break;case 1:N[T++]=I|Q>>>4,I=Q<<4,M=2;break;default:I=Q<<2,M=1}};for(let Q=0;Q<a.length;Q++){const G=a.charCodeAt(Q);if(G>=65&&G<=90)X(G-65);else if(G>=97&&G<=122)X(G-97+26);else if(G>=48&&G<=57)X(G-48+52);else if(G===43||G===45)X(62);else if(G===47||G===95)X(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${a[Q]}`)}}const ae=T;for(;M>0;)X(0);return D.wrap(N).slice(0,ae)}e.decodeBase64=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},I=!0,M=!1){const T=M?s:r;let N="";const X=a.byteLength%3;let ae=0;for(;ae<a.byteLength-X;ae+=3){const Q=a[ae+0],G=a[ae+1],Z=a[ae+2];N+=T[Q>>>2],N+=T[(Q<<4|G>>>4)&63],N+=T[(G<<2|Z>>>6)&63],N+=T[Z&63]}if(X===1){const Q=a[ae+0];N+=T[Q>>>2],N+=T[Q<<4&63],I&&(N+="==")}else if(X===2){const Q=a[ae+0],G=a[ae+1];N+=T[Q>>>2],N+=T[(Q<<4|G>>>4)&63],N+=T[G<<2&63],I&&(N+="=")}return N}e.encodeBase64=l}),define(te[12],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function S(o){return typeof o=="string"}e.isString=S;function t(o){return Array.isArray(o)&&o.every(n=>S(n))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function R(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=R;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=b;function u(o){return o===!0||o===!1}e.isBoolean=u;function p(o){return typeof o>"u"}e.isUndefined=p;function C(o){return!y(o)}e.isDefined=C;function y(o){return p(o)||o===null}e.isUndefinedOrNull=y;function E(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=E;function h(o){if(y(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=h;function f(...o){const n=[];for(let r=0;r<o.length;r++){const s=o[r];if(y(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);n.push(s)}return n}e.assertAllDefined=f;const P=Object.prototype.hasOwnProperty;function w(o){if(!k(o))return!1;for(const n in o)if(P.call(o,n))return!1;return!0}e.isEmptyObject=w;function m(o){return typeof o=="function"}e.isFunction=m;function v(...o){return o.length>0&&o.every(m)}e.areFunctions=v;function d(o,n){const r=Math.min(o.length,n.length);for(let s=0;s<r;s++)g(o[s],n[s])}e.validateConstraints=d;function g(o,n){if(S(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(m(n)){try{if(o instanceof n)return}catch{}if(!y(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function c(o){return o===null?void 0:o}e.withNullAsUndefined=c;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(te[50],ie([0,1,12]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.keys(m).forEach(d=>{m[d]&&typeof m[d]=="object"?v[d]=t(m[d]):v[d]=m[d]}),v}e.deepClone=t;function k(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const d=v.shift();Object.freeze(d);for(const g in d)if(R.call(d,g)){const c=d[g];typeof c=="object"&&!Object.isFrozen(c)&&!(0,S.isTypedArray)(c)&&v.push(c)}}return m}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(m,v){return b(m,v,new Set)}e.cloneAndChange=D;function b(m,v,d){if((0,S.isUndefinedOrNull)(m))return m;const g=v(m);if(typeof g<"u")return g;if(Array.isArray(m)){const c=[];for(const i of m)c.push(b(i,v,d));return c}if((0,S.isObject)(m)){if(d.has(m))throw new Error("Cannot clone recursive data-structure");d.add(m);const c={};for(const i in m)R.call(m,i)&&(c[i]=b(m[i],v,d));return d.delete(m),c}return m}function u(m,v,d=!0){return(0,S.isObject)(m)?((0,S.isObject)(v)&&Object.keys(v).forEach(g=>{g in m?d&&((0,S.isObject)(m[g])&&(0,S.isObject)(v[g])?u(m[g],v[g],d):m[g]=v[g]):m[g]=v[g]}),m):v}e.mixin=u;function p(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let d,g;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(d=0;d<m.length;d++)if(!p(m[d],v[d]))return!1}else{const c=[];for(g in m)c.push(g);c.sort();const i=[];for(g in v)i.push(g);if(i.sort(),!p(c,i))return!1;for(d=0;d<c.length;d++)if(!p(m[c[d]],v[c[d]]))return!1}return!0}e.equals=p;function C(m){const v=new Set;return JSON.stringify(m,(d,g)=>{if((0,S.isObject)(g)||Array.isArray(g)){if(v.has(g))return"[Circular]";v.add(g)}return g})}e.safeStringify=C;function y(m,v){const d=Object.create(null);return!m||!v||Object.keys(v).forEach(c=>{const i=m[c],o=v[c];p(i,o)||(d[c]=o)}),d}e.distinct=y;function E(m,v){const d=v.toLowerCase(),g=Object.keys(m).find(c=>c.toLowerCase()===d);return g?m[g]:m[v]}e.getCaseInsensitive=E;function h(m,v){const d=Object.create(null);for(const[g,c]of Object.entries(m))v(g,c)&&(d[g]=c);return d}e.filter=h;function f(m){let v=[],d=Object.getPrototypeOf(m);for(;Object.prototype!==d;)v=v.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return v}e.getAllPropertyNames=f;function P(m){const v=[];for(const d of f(m))typeof m[d]=="function"&&v.push(d);return v}e.getAllMethodNames=P;function w(m,v){const d=c=>function(){const i=Array.prototype.slice.call(arguments,0);return v(c,i)},g={};for(const c of m)g[c]=d(c);return g}e.createProxyObject=w}),define(te[29],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return S.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let u=0;u<b.length;u++)b[u]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),D=[];for(let b=0;b<256;b++)D.push(b.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let u=0,p="";return p+=D[R[u++]],p+=D[R[u++]],p+=D[R[u++]],p+=D[R[u++]],p+="-",p+=D[R[u++]],p+=D[R[u++]],p+="-",p+=D[R[u++]],p+=D[R[u++]],p+="-",p+=D[R[u++]],p+=D[R[u++]],p+="-",p+=D[R[u++]],p+=D[R[u++]],p+=D[R[u++]],p+=D[R[u++]],p+=D[R[u++]],p+=D[R[u++]],p}}()}),define(te[127],ie([0,1,76,40,49]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,b){if(await new Promise((C,y)=>{const E=t.createReadStream(D),h=S.createHash("sha1");E.pipe(h);const f=(0,k.once)((P,w)=>{E.removeAllListeners(),h.removeAllListeners(),P?y(P):C(w)});E.once("error",f),E.once("end",f),h.once("error",f),h.once("data",P=>f(void 0,P.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=R}),define(te[128],ie([0,1,25]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const b=D.replace(/\-/g,":").toLowerCase();return!t.has(b)}function R(){const D=(0,S.networkInterfaces)();for(const b in D){const u=D[b];if(u){for(const{mac:p}of u)if(k(p))return p}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(te[95],ie([0,1,77]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(b,u,p,C=1){let y=!1;return new Promise(E=>{const h=setTimeout(()=>{if(!y)return y=!0,E(0)},p);k(b,u,C,f=>{if(!y)return y=!0,clearTimeout(h),E(f)})})}e.findFreePort=t;function k(b,u,p,C){if(u===0)return C(0);const y=new S.Socket;y.once("connect",()=>(D(y),k(b+p,u-1,p,C))),y.once("data",()=>{}),y.once("error",E=>(D(y),E.code!=="ECONNREFUSED"?k(b+p,u-1,p,C):C(b))),y.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,u,p){let C=!1,y,E=1;const h=S.createServer({pauseOnConnect:!0});function f(P,w){C||(C=!0,h.removeAllListeners(),h.close(),y&&clearTimeout(y),w(P))}return new Promise(P=>{y=setTimeout(()=>{f(0,P)},p),h.on("listening",()=>{f(b,P)}),h.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&E<u?(b++,E++,h.listen(b,"127.0.0.1")):f(0,P)}),h.on("close",()=>{f(0,P)}),h.listen(b,"127.0.0.1")})}e.findFreePortFaster=R;function D(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(u){console.error(u)}}}),define(te[129],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[130],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=S}),define(te[41],ie([0,1,15,17]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,b){const u=(p,...C)=>{this.validateEvent(D,p)&&b(p,...C)};return this.mapListenerToWrapper.set(b,u),S.ipcMain.on(D,u),this}once(D,b){return S.ipcMain.once(D,(u,...p)=>{this.validateEvent(D,u)&&b(u,...p)}),this}handle(D,b){return S.ipcMain.handle(D,(u,...p)=>this.validateEvent(D,u)?b(u,...p):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return S.ipcMain.removeHandler(D),this}removeListener(D,b){const u=this.mapListenerToWrapper.get(b);return u&&(S.ipcMain.removeListener(D,u),this.mapListenerToWrapper.delete(b)),this}validateEvent(D,b){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const u=b.senderFrame,p=u.url;if(!p)return!0;let C="unknown";try{C=new URL(p).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${p}'.`),!1}return C!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${C}'.`),!1):u.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${C}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(te[131],ie([0,1,15,41,12,129]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(u,p,C,y,E)=>{const h=b(u,y,C);h.popup({window:(0,k.withNullAsUndefined)(S.BrowserWindow.fromWebContents(u.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{h&&u.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,p)}})})}e.registerContextMenuListener=D;function b(u,p,C){const y=new S.Menu;return C.forEach(E=>{let h;E.type==="separator"?h=new S.MenuItem({type:E.type}):Array.isArray(E.submenu)?h=new S.MenuItem({submenu:b(u,p,E.submenu),label:E.label}):h=new S.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(f,P,w)=>u.sender.send(p,E.id,w)}),y.append(h)}),y}}),define(te[132],ie([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(te[133],ie([0,1,132]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,b=R*30,u=R*365;function p(y,E,h){typeof y!="number"&&(y=y.getTime());const f=Math.round((new Date().getTime()-y)/1e3);if(f<-30)return(0,S.localize)(0,null,p(new Date().getTime()+f*1e3,!1));if(f<30)return(0,S.localize)(1,null);let P;return f<t?(P=f,E?P===1?h?(0,S.localize)(2,null,P):(0,S.localize)(3,null,P):h?(0,S.localize)(4,null,P):(0,S.localize)(5,null,P):P===1?h?(0,S.localize)(6,null,P):(0,S.localize)(7,null,P):h?(0,S.localize)(8,null,P):(0,S.localize)(9,null,P)):f<k?(P=Math.floor(f/t),E?P===1?h?(0,S.localize)(10,null,P):(0,S.localize)(11,null,P):h?(0,S.localize)(12,null,P):(0,S.localize)(13,null,P):P===1?h?(0,S.localize)(14,null,P):(0,S.localize)(15,null,P):h?(0,S.localize)(16,null,P):(0,S.localize)(17,null,P)):f<R?(P=Math.floor(f/k),E?P===1?h?(0,S.localize)(18,null,P):(0,S.localize)(19,null,P):h?(0,S.localize)(20,null,P):(0,S.localize)(21,null,P):P===1?h?(0,S.localize)(22,null,P):(0,S.localize)(23,null,P):h?(0,S.localize)(24,null,P):(0,S.localize)(25,null,P)):f<D?(P=Math.floor(f/R),E?P===1?(0,S.localize)(26,null,P):(0,S.localize)(27,null,P):P===1?(0,S.localize)(28,null,P):(0,S.localize)(29,null,P)):f<b?(P=Math.floor(f/D),E?P===1?h?(0,S.localize)(30,null,P):(0,S.localize)(31,null,P):h?(0,S.localize)(32,null,P):(0,S.localize)(33,null,P):P===1?h?(0,S.localize)(34,null,P):(0,S.localize)(35,null,P):h?(0,S.localize)(36,null,P):(0,S.localize)(37,null,P)):f<u?(P=Math.floor(f/b),E?P===1?h?(0,S.localize)(38,null,P):(0,S.localize)(39,null,P):h?(0,S.localize)(40,null,P):(0,S.localize)(41,null,P):P===1?h?(0,S.localize)(42,null,P):(0,S.localize)(43,null,P):h?(0,S.localize)(44,null,P):(0,S.localize)(45,null,P)):(P=Math.floor(f/u),E?P===1?h?(0,S.localize)(46,null,P):(0,S.localize)(47,null,P):h?(0,S.localize)(48,null,P):(0,S.localize)(49,null,P):P===1?h?(0,S.localize)(50,null,P):(0,S.localize)(51,null,P):h?(0,S.localize)(52,null,P):(0,S.localize)(53,null,P))}e.fromNow=p;function C(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(te[134],ie([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(te[44],ie([0,1,24,12,134]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(y,E){return E&&(y.stack||y.stacktrace)?k.localize(0,null,b(y),D(y.stack)||D(y.stacktrace)):b(y)}function D(y){return Array.isArray(y)?y.join(`
`):y}function b(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function u(y=null,E=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const h=S.coalesce(y),f=u(h[0],E);return h.length>1?k.localize(4,null,f,h.length):f}if(t.isString(y))return y;if(y.detail){const h=y.detail;if(h.error)return R(h.error,E);if(h.exception)return R(h.exception,E)}return y.stack?R(y,E):y.message?y.message:k.localize(5,null)}e.toErrorMessage=u;function p(y){const E=y;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=p;function C(y,E){let h;return typeof y=="string"?h=new Error(y):h=y,h.actions=E,h}e.createErrorWithActions=C}),define(te[135],ie([11,10]),function(z,e){return z.create("vs/base/common/jsonErrorMessages",e)}),define(te[136],ie([0,1,135]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(te[137],ie([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,137]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,D=!1,b=!1,u=!1,p=!1,C=!1,y=!1,E=!1,h,f=e.LANGUAGE_DEFAULT,P,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const v=typeof m?.versions?.electron=="string",d=v&&m?.type==="renderer";if(typeof navigator=="object"&&!d)w=navigator.userAgent,t=w.indexOf("Windows")>=0,k=w.indexOf("Macintosh")>=0,C=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=w.indexOf("Linux")>=0,E=w?.indexOf("Mobi")>=0,u=!0,h=S.getConfiguredDefaultLocale(S.localize(0,null))||e.LANGUAGE_DEFAULT,f=h;else if(typeof m=="object"){t=m.platform==="win32",k=m.platform==="darwin",R=m.platform==="linux",D=R&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,p=v,y=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const a=m.env.VSCODE_NLS_CONFIG;if(a)try{const I=JSON.parse(a),M=I.availableLanguages["*"];h=I.locale,f=M||e.LANGUAGE_DEFAULT,P=I._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var g;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function c(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let i=0;k?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=D,e.isNative=b,e.isElectron=p,e.isWeb=u,e.isWebWorker=u&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=E,e.isCI=y,e.platform=i,e.userAgent=w,e.language=f;var o;(function(a){function I(){return e.language}a.value=I;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=M;function T(){return e.language==="en"}a.isDefault=T})(o=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=P,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,N=a.length;T<N;T++){const X=a[T];if(X.id===M.data.vscodeScheduleAsyncWork){a.splice(T,1),X.callback();return}}});let I=0;return M=>{const T=++I;a.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return a=>setTimeout(a)})();var n;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||C?2:t?1:3;let r=!0,s=!1;function l(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,r=new Uint16Array(a.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[34],ie([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.process<"u"){const k=S.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[9],ie([0,1,34]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,b=46,u=47,p=92,C=58,y=63;class E extends Error{constructor(g,c,i){let o;typeof c=="string"&&c.indexOf("not ")===0?(o="must not be",c=c.replace(/^not /,"")):o="must be";const n=g.indexOf(".")!==-1?"property":"argument";let r=`The "${g}" ${n} ${o} of type ${c}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function h(d,g){if(typeof d!="string")throw new E(g,"string",d)}function f(d){return d===u||d===p}function P(d){return d===u}function w(d){return d>=t&&d<=R||d>=k&&d<=D}function m(d,g,c,i){let o="",n=0,r=-1,s=0,l=0;for(let a=0;a<=d.length;++a){if(a<d.length)l=d.charCodeAt(a);else{if(i(l))break;l=u}if(i(l)){if(!(r===a-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==b||o.charCodeAt(o.length-2)!==b){if(o.length>2){const I=o.lastIndexOf(c);I===-1?(o="",n=0):(o=o.slice(0,I),n=o.length-1-o.lastIndexOf(c)),r=a,s=0;continue}else if(o.length!==0){o="",n=0,r=a,s=0;continue}}g&&(o+=o.length>0?`${c}..`:"..",n=2)}else o.length>0?o+=`${c}${d.slice(r+1,a)}`:o=d.slice(r+1,a),n=a-r-1;r=a,s=0}else l===b&&s!==-1?++s:s=-1}return o}function v(d,g){if(g===null||typeof g!="object")throw new E("pathObject","Object",g);const c=g.dir||g.root,i=g.base||`${g.name||""}${g.ext||""}`;return c?c===g.root?`${c}${i}`:`${c}${d}${i}`:i}e.win32={resolve(...d){let g="",c="",i=!1;for(let o=d.length-1;o>=-1;o--){let n;if(o>=0){if(n=d[o],h(n,"path"),n.length===0)continue}else g.length===0?n=S.cwd():(n=S.env[`=${g}`]||S.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==g.toLowerCase()&&n.charCodeAt(2)===p)&&(n=`${g}\\`));const r=n.length;let s=0,l="",a=!1;const I=n.charCodeAt(0);if(r===1)f(I)&&(s=1,a=!0);else if(f(I))if(a=!0,f(n.charCodeAt(1))){let M=2,T=M;for(;M<r&&!f(n.charCodeAt(M));)M++;if(M<r&&M!==T){const N=n.slice(T,M);for(T=M;M<r&&f(n.charCodeAt(M));)M++;if(M<r&&M!==T){for(T=M;M<r&&!f(n.charCodeAt(M));)M++;(M===r||M!==T)&&(l=`\\\\${N}\\${n.slice(T,M)}`,s=M)}}}else s=1;else w(I)&&n.charCodeAt(1)===C&&(l=n.slice(0,2),s=2,r>2&&f(n.charCodeAt(2))&&(a=!0,s=3));if(l.length>0)if(g.length>0){if(l.toLowerCase()!==g.toLowerCase())continue}else g=l;if(i){if(g.length>0)break}else if(c=`${n.slice(s)}\\${c}`,i=a,a&&g.length>0)break}return c=m(c,!i,"\\",f),i?`${g}\\${c}`:`${g}${c}`||"."},normalize(d){h(d,"path");const g=d.length;if(g===0)return".";let c=0,i,o=!1;const n=d.charCodeAt(0);if(g===1)return P(n)?"\\":d;if(f(n))if(o=!0,f(d.charCodeAt(1))){let s=2,l=s;for(;s<g&&!f(d.charCodeAt(s));)s++;if(s<g&&s!==l){const a=d.slice(l,s);for(l=s;s<g&&f(d.charCodeAt(s));)s++;if(s<g&&s!==l){for(l=s;s<g&&!f(d.charCodeAt(s));)s++;if(s===g)return`\\\\${a}\\${d.slice(l)}\\`;s!==l&&(i=`\\\\${a}\\${d.slice(l,s)}`,c=s)}}}else c=1;else w(n)&&d.charCodeAt(1)===C&&(i=d.slice(0,2),c=2,g>2&&f(d.charCodeAt(2))&&(o=!0,c=3));let r=c<g?m(d.slice(c),!o,"\\",f):"";return r.length===0&&!o&&(r="."),r.length>0&&f(d.charCodeAt(g-1))&&(r+="\\"),i===void 0?o?`\\${r}`:r:o?`${i}\\${r}`:`${i}${r}`},isAbsolute(d){h(d,"path");const g=d.length;if(g===0)return!1;const c=d.charCodeAt(0);return f(c)||g>2&&w(c)&&d.charCodeAt(1)===C&&f(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let g,c;for(let n=0;n<d.length;++n){const r=d[n];h(r,"path"),r.length>0&&(g===void 0?g=c=r:g+=`\\${r}`)}if(g===void 0)return".";let i=!0,o=0;if(typeof c=="string"&&f(c.charCodeAt(0))){++o;const n=c.length;n>1&&f(c.charCodeAt(1))&&(++o,n>2&&(f(c.charCodeAt(2))?++o:i=!1))}if(i){for(;o<g.length&&f(g.charCodeAt(o));)o++;o>=2&&(g=`\\${g.slice(o)}`)}return e.win32.normalize(g)},relative(d,g){if(h(d,"from"),h(g,"to"),d===g)return"";const c=e.win32.resolve(d),i=e.win32.resolve(g);if(c===i||(d=c.toLowerCase(),g=i.toLowerCase(),d===g))return"";let o=0;for(;o<d.length&&d.charCodeAt(o)===p;)o++;let n=d.length;for(;n-1>o&&d.charCodeAt(n-1)===p;)n--;const r=n-o;let s=0;for(;s<g.length&&g.charCodeAt(s)===p;)s++;let l=g.length;for(;l-1>s&&g.charCodeAt(l-1)===p;)l--;const a=l-s,I=r<a?r:a;let M=-1,T=0;for(;T<I;T++){const X=d.charCodeAt(o+T);if(X!==g.charCodeAt(s+T))break;X===p&&(M=T)}if(T!==I){if(M===-1)return i}else{if(a>I){if(g.charCodeAt(s+T)===p)return i.slice(s+T+1);if(T===2)return i.slice(s+T)}r>I&&(d.charCodeAt(o+T)===p?M=T:T===2&&(M=3)),M===-1&&(M=0)}let N="";for(T=o+M+1;T<=n;++T)(T===n||d.charCodeAt(T)===p)&&(N+=N.length===0?"..":"\\..");return s+=M,N.length>0?`${N}${i.slice(s,l)}`:(i.charCodeAt(s)===p&&++s,i.slice(s,l))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const g=e.win32.resolve(d);if(g.length<=2)return d;if(g.charCodeAt(0)===p){if(g.charCodeAt(1)===p){const c=g.charCodeAt(2);if(c!==y&&c!==b)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(w(g.charCodeAt(0))&&g.charCodeAt(1)===C&&g.charCodeAt(2)===p)return`\\\\?\\${g}`;return d},dirname(d){h(d,"path");const g=d.length;if(g===0)return".";let c=-1,i=0;const o=d.charCodeAt(0);if(g===1)return f(o)?d:".";if(f(o)){if(c=i=1,f(d.charCodeAt(1))){let s=2,l=s;for(;s<g&&!f(d.charCodeAt(s));)s++;if(s<g&&s!==l){for(l=s;s<g&&f(d.charCodeAt(s));)s++;if(s<g&&s!==l){for(l=s;s<g&&!f(d.charCodeAt(s));)s++;if(s===g)return d;s!==l&&(c=i=s+1)}}}}else w(o)&&d.charCodeAt(1)===C&&(c=g>2&&f(d.charCodeAt(2))?3:2,i=c);let n=-1,r=!0;for(let s=g-1;s>=i;--s)if(f(d.charCodeAt(s))){if(!r){n=s;break}}else r=!1;if(n===-1){if(c===-1)return".";n=c}return d.slice(0,n)},basename(d,g){g!==void 0&&h(g,"ext"),h(d,"path");let c=0,i=-1,o=!0,n;if(d.length>=2&&w(d.charCodeAt(0))&&d.charCodeAt(1)===C&&(c=2),g!==void 0&&g.length>0&&g.length<=d.length){if(g===d)return"";let r=g.length-1,s=-1;for(n=d.length-1;n>=c;--n){const l=d.charCodeAt(n);if(f(l)){if(!o){c=n+1;break}}else s===-1&&(o=!1,s=n+1),r>=0&&(l===g.charCodeAt(r)?--r===-1&&(i=n):(r=-1,i=s))}return c===i?i=s:i===-1&&(i=d.length),d.slice(c,i)}for(n=d.length-1;n>=c;--n)if(f(d.charCodeAt(n))){if(!o){c=n+1;break}}else i===-1&&(o=!1,i=n+1);return i===-1?"":d.slice(c,i)},extname(d){h(d,"path");let g=0,c=-1,i=0,o=-1,n=!0,r=0;d.length>=2&&d.charCodeAt(1)===C&&w(d.charCodeAt(0))&&(g=i=2);for(let s=d.length-1;s>=g;--s){const l=d.charCodeAt(s);if(f(l)){if(!n){i=s+1;break}continue}o===-1&&(n=!1,o=s+1),l===b?c===-1?c=s:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||o===-1||r===0||r===1&&c===o-1&&c===i+1?"":d.slice(c,o)},format:v.bind(null,"\\"),parse(d){h(d,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return g;const c=d.length;let i=0,o=d.charCodeAt(0);if(c===1)return f(o)?(g.root=g.dir=d,g):(g.base=g.name=d,g);if(f(o)){if(i=1,f(d.charCodeAt(1))){let M=2,T=M;for(;M<c&&!f(d.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&f(d.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&!f(d.charCodeAt(M));)M++;M===c?i=M:M!==T&&(i=M+1)}}}}else if(w(o)&&d.charCodeAt(1)===C){if(c<=2)return g.root=g.dir=d,g;if(i=2,f(d.charCodeAt(2))){if(c===3)return g.root=g.dir=d,g;i=3}}i>0&&(g.root=d.slice(0,i));let n=-1,r=i,s=-1,l=!0,a=d.length-1,I=0;for(;a>=i;--a){if(o=d.charCodeAt(a),f(o)){if(!l){r=a+1;break}continue}s===-1&&(l=!1,s=a+1),o===b?n===-1?n=a:I!==1&&(I=1):n!==-1&&(I=-1)}return s!==-1&&(n===-1||I===0||I===1&&n===s-1&&n===r+1?g.base=g.name=d.slice(r,s):(g.name=d.slice(r,n),g.base=d.slice(r,s),g.ext=d.slice(n,s))),r>0&&r!==i?g.dir=d.slice(0,r-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let g="",c=!1;for(let i=d.length-1;i>=-1&&!c;i--){const o=i>=0?d[i]:S.cwd();h(o,"path"),o.length!==0&&(g=`${o}/${g}`,c=o.charCodeAt(0)===u)}return g=m(g,!c,"/",P),c?`/${g}`:g.length>0?g:"."},normalize(d){if(h(d,"path"),d.length===0)return".";const g=d.charCodeAt(0)===u,c=d.charCodeAt(d.length-1)===u;return d=m(d,!g,"/",P),d.length===0?g?"/":c?"./":".":(c&&(d+="/"),g?`/${d}`:d)},isAbsolute(d){return h(d,"path"),d.length>0&&d.charCodeAt(0)===u},join(...d){if(d.length===0)return".";let g;for(let c=0;c<d.length;++c){const i=d[c];h(i,"path"),i.length>0&&(g===void 0?g=i:g+=`/${i}`)}return g===void 0?".":e.posix.normalize(g)},relative(d,g){if(h(d,"from"),h(g,"to"),d===g||(d=e.posix.resolve(d),g=e.posix.resolve(g),d===g))return"";const c=1,i=d.length,o=i-c,n=1,r=g.length-n,s=o<r?o:r;let l=-1,a=0;for(;a<s;a++){const M=d.charCodeAt(c+a);if(M!==g.charCodeAt(n+a))break;M===u&&(l=a)}if(a===s)if(r>s){if(g.charCodeAt(n+a)===u)return g.slice(n+a+1);if(a===0)return g.slice(n+a)}else o>s&&(d.charCodeAt(c+a)===u?l=a:a===0&&(l=0));let I="";for(a=c+l+1;a<=i;++a)(a===i||d.charCodeAt(a)===u)&&(I+=I.length===0?"..":"/..");return`${I}${g.slice(n+l)}`},toNamespacedPath(d){return d},dirname(d){if(h(d,"path"),d.length===0)return".";const g=d.charCodeAt(0)===u;let c=-1,i=!0;for(let o=d.length-1;o>=1;--o)if(d.charCodeAt(o)===u){if(!i){c=o;break}}else i=!1;return c===-1?g?"/":".":g&&c===1?"//":d.slice(0,c)},basename(d,g){g!==void 0&&h(g,"ext"),h(d,"path");let c=0,i=-1,o=!0,n;if(g!==void 0&&g.length>0&&g.length<=d.length){if(g===d)return"";let r=g.length-1,s=-1;for(n=d.length-1;n>=0;--n){const l=d.charCodeAt(n);if(l===u){if(!o){c=n+1;break}}else s===-1&&(o=!1,s=n+1),r>=0&&(l===g.charCodeAt(r)?--r===-1&&(i=n):(r=-1,i=s))}return c===i?i=s:i===-1&&(i=d.length),d.slice(c,i)}for(n=d.length-1;n>=0;--n)if(d.charCodeAt(n)===u){if(!o){c=n+1;break}}else i===-1&&(o=!1,i=n+1);return i===-1?"":d.slice(c,i)},extname(d){h(d,"path");let g=-1,c=0,i=-1,o=!0,n=0;for(let r=d.length-1;r>=0;--r){const s=d.charCodeAt(r);if(s===u){if(!o){c=r+1;break}continue}i===-1&&(o=!1,i=r+1),s===b?g===-1?g=r:n!==1&&(n=1):g!==-1&&(n=-1)}return g===-1||i===-1||n===0||n===1&&g===i-1&&g===c+1?"":d.slice(g,i)},format:v.bind(null,"/"),parse(d){h(d,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return g;const c=d.charCodeAt(0)===u;let i;c?(g.root="/",i=1):i=0;let o=-1,n=0,r=-1,s=!0,l=d.length-1,a=0;for(;l>=i;--l){const I=d.charCodeAt(l);if(I===u){if(!s){n=l+1;break}continue}r===-1&&(s=!1,r=l+1),I===b?o===-1?o=l:a!==1&&(a=1):o!==-1&&(a=-1)}if(r!==-1){const I=n===0&&c?1:n;o===-1||a===0||a===1&&o===r-1&&o===n+1?g.base=g.name=d.slice(I,r):(g.name=d.slice(I,o),g.base=d.slice(I,r),g.ext=d.slice(o,r))}return n>0?g.dir=d.slice(0,n-1):c&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[78],ie([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(b,...u){const p=u.reduce((E,h)=>(E[h]=!0,E),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(E=>!p[E]).forEach(E=>{for(let h=0;h<C.length;h++)if(E.search(C[h])!==-1){delete b[E];break}})}e.sanitizeProcessEnvironment=R;function D(b){!b||(delete b.DEBUG,S.isMacintosh&&delete b.DYLD_LIBRARY_PATH,S.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(te[79],ie([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=S.globals.performance&&typeof S.globals.performance.now=="function";class k{static create(D=!0){return new k(D)}constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=k}),define(te[3],ie([0,1,17,49,2,94,79]),function(z,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const b=!1,u=!1;var p;(function(l){l.None=()=>k.Disposable.None;function a(O){if(u){const{onListenerDidAdd:_}=O,j=f.create();let Y=0;O.onListenerDidAdd=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),_?.()}}}function I(O){return(_,j=null,Y)=>{let oe=!1,q;return q=O(re=>{if(!oe)return q?q.dispose():oe=!0,_.call(j,re)},null,Y),oe&&q.dispose(),q}}l.once=I;function M(O,_,j){return G((Y,oe=null,q)=>O(re=>Y.call(oe,_(re)),null,q),j)}l.map=M;function T(O,_,j){return G((Y,oe=null,q)=>O(re=>{_(re),Y.call(oe,re)},null,q),j)}l.forEach=T;function N(O,_,j){return G((Y,oe=null,q)=>O(re=>_(re)&&Y.call(oe,re),null,q),j)}l.filter=N;function X(O){return O}l.signal=X;function ae(...O){return(_,j=null,Y)=>(0,k.combinedDisposable)(...O.map(oe=>oe(q=>_.call(j,q),null,Y)))}l.any=ae;function Q(O,_,j,Y){let oe=j;return M(O,q=>(oe=_(oe,q),oe),Y)}l.reduce=Q;function G(O,_){let j;const Y={onFirstListenerAdd(){j=O(oe.fire,oe)},onLastListenerRemove(){j?.dispose()}};_||a(Y);const oe=new w(Y);return _?.add(oe),oe.event}function Z(O,_,j=100,Y=!1,oe,q){let re,ne,ce,ge=0;const De={leakWarningThreshold:oe,onFirstListenerAdd(){re=O(ke=>{ge++,ne=_(ne,ke),Y&&!ce&&(Ae.fire(ne),ne=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Le=ne;ne=void 0,ce=void 0,(!Y||ge>1)&&Ae.fire(Le),ge=0},j)})},onLastListenerRemove(){re.dispose()}};q||a(De);const Ae=new w(De);return q?.add(Ae),Ae.event}l.debounce=Z;function se(O,_=(Y,oe)=>Y===oe,j){let Y=!0,oe;return N(O,q=>{const re=Y||!_(q,oe);return Y=!1,oe=q,re},j)}l.latch=se;function he(O,_,j){return[l.filter(O,_,j),l.filter(O,Y=>!_(Y),j)]}l.split=he;function V(O,_=!1,j=[]){let Y=j.slice(),oe=O(ne=>{Y?Y.push(ne):re.fire(ne)});const q=()=>{Y?.forEach(ne=>re.fire(ne)),Y=null},re=new w({onFirstListenerAdd(){oe||(oe=O(ne=>re.fire(ne)))},onFirstListenerDidAdd(){Y&&(_?setTimeout(q):q())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return re.event}l.buffer=V;class H{constructor(_){this.event=_,this.disposables=new k.DisposableStore}map(_){return new H(M(this.event,_,this.disposables))}forEach(_){return new H(T(this.event,_,this.disposables))}filter(_){return new H(N(this.event,_,this.disposables))}reduce(_,j){return new H(Q(this.event,_,j,this.disposables))}latch(){return new H(se(this.event,void 0,this.disposables))}debounce(_,j=100,Y=!1,oe){return new H(Z(this.event,_,j,Y,oe,this.disposables))}on(_,j,Y){return this.event(_,j,Y)}once(_,j,Y){return I(this.event)(_,j,Y)}dispose(){this.disposables.dispose()}}function W(O){return new H(O)}l.chain=W;function A(O,_,j=Y=>Y){const Y=(...ne)=>re.fire(j(...ne)),oe=()=>O.on(_,Y),q=()=>O.removeListener(_,Y),re=new w({onFirstListenerAdd:oe,onLastListenerRemove:q});return re.event}l.fromNodeEventEmitter=A;function F(O,_,j=Y=>Y){const Y=(...ne)=>re.fire(j(...ne)),oe=()=>O.addEventListener(_,Y),q=()=>O.removeEventListener(_,Y),re=new w({onFirstListenerAdd:oe,onLastListenerRemove:q});return re.event}l.fromDOMEventEmitter=F;function U(O){return new Promise(_=>I(O)(_))}l.toPromise=U;function J(O,_){return _(void 0),O(j=>_(j))}l.runAndSubscribe=J;function B(O,_){let j=null;function Y(q){j?.dispose(),j=new k.DisposableStore,_(q,j)}Y(void 0);const oe=O(q=>Y(q));return(0,k.toDisposable)(()=>{oe.dispose(),j?.dispose()})}l.runAndSubscribeWithStore=B;class ${constructor(_,j){this.obs=_,this._counter=0,this._hasChanged=!1;const Y={onFirstListenerAdd:()=>{_.addObserver(this)},onLastListenerRemove:()=>{_.removeObserver(this)}};j||a(Y),this.emitter=new w(Y),j&&j.add(this.emitter)}beginUpdate(_){this._counter++}handleChange(_,j){this._hasChanged=!0}endUpdate(_){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,_){return new $(O,_).emitter.event}l.fromObservable=L})(p=e.Event||(e.Event={}));class C{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${C._idPool++}`,C.all.add(this)}start(a){this._stopWatch=new D.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=C,C.all=new Set,C._idPool=0;let y=-1;function E(l){const a=y;return y=l,{dispose(){y=a}}}e.setGlobalLeakWarningThreshold=E;class h{constructor(a,I=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=I,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,I){let M=y;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||I<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let N,X=0;for(const[ae,Q]of this._stacks)(!N||X<Q)&&(N=ae,X=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${X}):`),console.warn(N)}return()=>{const N=this._stacks.get(a.value)||0;this._stacks.set(a.value,N-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class P{constructor(a,I,M){this.callback=a,this.callbackThis=I,this.stack=M,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class w{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=y>0?new h(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const I of a)I.subscription.isset()&&(I.subscription.unset(),I.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,I,M)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let N,X;this._leakageMon&&this._listeners.size>=30&&(X=f.create(),N=this._leakageMon.check(X,this._listeners.size+1)),b&&(X=X??f.create());const ae=new P(a,I,X),Q=this._listeners.push(ae);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,I);const G=ae.subscription.set(()=>{N?.(),this._disposed||(Q(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(G):Array.isArray(M)&&M.push(G),G}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const I of this._listeners)this._deliveryQueue.push(this,I,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class m{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(a,I,M){this._queue.push(new d(a,I,M))}clear(a){const I=new R.LinkedList;for(const M of this._queue)M.emitter!==a&&I.push(M);this._queue=I}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(I){(0,S.onUnexpectedError)(I)}}}}e.EventDeliveryQueue=m;class v extends m{clear(a){this._queue.clear()}}class d{constructor(a,I,M){this.emitter=a,this.listener=I,this.event=M}}class g extends w{async fireAsync(a,I,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,a]);for(;this._asyncDeliveryQueue.size>0&&!I.isCancellationRequested;){const[T,N]=this._asyncDeliveryQueue.shift(),X=[],ae={...N,token:I,waitUntil:Q=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");M&&(Q=M(Q,T.callback)),X.push(Q)}};try{T.invoke(ae)}catch(Q){(0,S.onUnexpectedError)(Q);continue}Object.freeze(X),await Promise.allSettled(X).then(Q=>{for(const G of Q)G.status==="rejected"&&(0,S.onUnexpectedError)(G.reason)})}}}}e.AsyncEmitter=g;class c extends w{constructor(a){super(a),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=c;class i extends c{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=i;class o extends w{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(I=>super.fire(I)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const I={event:a,listener:null};this.events.push(I),this.hasListeners&&this.hook(I);const M=()=>{this.hasListeners&&this.unhook(I);const T=this.events.indexOf(I);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(I=>this.emitter.fire(I))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class r{constructor(){this.buffers=[]}wrapEvent(a){return(I,M,T)=>a(N=>{const X=this.buffers[this.buffers.length-1];X?X.push(()=>I.call(M,N)):I.call(M,N)},void 0,T)}bufferEvents(a){const I=[];this.buffers.push(I);const M=a();return this.buffers.pop(),I.forEach(T=>T()),M}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=p.None,this.inputEventListener=k.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(te[23],ie([0,1,3]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(b,u){const p=setTimeout(b.bind(u),0);return{dispose(){clearTimeout(p)}}});var k;(function(b){function u(p){return p===b.None||p===b.Cancelled||p instanceof R?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}b.isCancellationToken=u,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(te[138],ie([0,1,23]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new S.CancellationTokenSource,u=this.task(b.token);return this.result={promise:u,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=t;class k{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const u=JSON.stringify(b);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=k;class R{get cachedValues(){return this._map}constructor(b){this.fn=b,this._map=new Map}get(b){if(this._map.has(b))return this._map.get(b);const u=this.fn(b);return this._map.set(b,u),u}}e.CachedFunction=R}),define(te[96],ie([0,1,3,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:S.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}constructor(b){super(),this._value=b,this.changeEmitter=this._register(new S.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=R}),define(te[26],ie([0,1,138,125]),function(z,e,S,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function b(K,...ue){return ue.length===0?K:K.replace(D,function(de,pe){const ye=parseInt(pe,10);return isNaN(ye)||ye<0||ye>=ue.length?de:ue[ye]})}e.format=b;const u=/{([^}]+)}/g;function p(K,ue){return K.replace(u,(de,pe)=>ue[pe]??de)}e.format2=p;function C(K){return K.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=C;function y(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function E(K,ue){let de=0;const pe=ue.charCodeAt(0);for(let ye=K.length-1;ye>=0;ye--)K.charCodeAt(ye)===pe&&de++;return de}e.count=E;function h(K,ue,de="\u2026"){return K.length<=ue?K:`${K.substr(0,ue)}${de}`}e.truncate=h;function f(K,ue=" "){const de=P(K,ue);return w(de,ue)}e.trim=f;function P(K,ue){if(!K||!ue)return K;const de=ue.length;if(de===0||K.length===0)return K;let pe=0;for(;K.indexOf(ue,pe)===pe;)pe=pe+de;return K.substring(pe)}e.ltrim=P;function w(K,ue){if(!K||!ue)return K;const de=ue.length,pe=K.length;if(de===0||pe===0)return K;let ye=pe,Re=-1;for(;Re=K.lastIndexOf(ue,ye-1),!(Re===-1||Re+de!==ye);){if(Re===0)return"";ye=Re}return K.substring(0,ye)}e.rtrim=w;function m(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function v(K){return K.replace(/\*/g,"")}e.stripWildcards=v;function d(K,ue,de={}){if(!K)throw new Error("Cannot create regex from empty string");ue||(K=y(K)),de.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let pe="";return de.global&&(pe+="g"),de.matchCase||(pe+="i"),de.multiline&&(pe+="m"),de.unicode&&(pe+="u"),new RegExp(K,pe)}e.createRegExp=d;function g(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function c(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function i(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=i;function o(K){return K.split(/\r\n|\r|\n/)}e.splitLines=o;function n(K){for(let ue=0,de=K.length;ue<de;ue++){const pe=K.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}e.firstNonWhitespaceIndex=n;function r(K,ue=0,de=K.length){for(let pe=ue;pe<de;pe++){const ye=K.charCodeAt(pe);if(ye!==32&&ye!==9)return K.substring(ue,pe)}return K.substring(ue,de)}e.getLeadingWhitespace=r;function s(K,ue=K.length-1){for(let de=ue;de>=0;de--){const pe=K.charCodeAt(de);if(pe!==32&&pe!==9)return de}return-1}e.lastNonWhitespaceIndex=s;function l(K,ue,de){const pe=[];let ye=0;for(const Re of K.matchAll(ue)){if(pe.push(K.slice(ye,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ye=Re.index+Re[0].length,pe.push(de(Re[0],...Re.slice(1),Re.index,K,Re.groups))}return pe.push(K.slice(ye)),Promise.all(pe).then(Re=>Re.join(""))}e.replaceAsync=l;function a(K,ue){return K<ue?-1:K>ue?1:0}e.compare=a;function I(K,ue,de=0,pe=K.length,ye=0,Re=ue.length){for(;de<pe&&ye<Re;de++,ye++){const xe=K.charCodeAt(de),je=ue.charCodeAt(ye);if(xe<je)return-1;if(xe>je)return 1}const _e=pe-de,it=Re-ye;return _e<it?-1:_e>it?1:0}e.compareSubstring=I;function M(K,ue){return T(K,ue,0,K.length,0,ue.length)}e.compareIgnoreCase=M;function T(K,ue,de=0,pe=K.length,ye=0,Re=ue.length){for(;de<pe&&ye<Re;de++,ye++){let xe=K.charCodeAt(de),je=ue.charCodeAt(ye);if(xe===je)continue;if(xe>=128||je>=128)return I(K.toLowerCase(),ue.toLowerCase(),de,pe,ye,Re);X(xe)&&(xe-=32),X(je)&&(je-=32);const et=xe-je;if(et!==0)return et}const _e=pe-de,it=Re-ye;return _e<it?-1:_e>it?1:0}e.compareSubstringIgnoreCase=T;function N(K){return K>=48&&K<=57}e.isAsciiDigit=N;function X(K){return K>=97&&K<=122}e.isLowerAsciiLetter=X;function ae(K){return K>=65&&K<=90}e.isUpperAsciiLetter=ae;function Q(K,ue){return K.length===ue.length&&T(K,ue)===0}e.equalsIgnoreCase=Q;function G(K,ue){const de=ue.length;return ue.length>K.length?!1:T(K,ue,0,de)===0}e.startsWithIgnoreCase=G;function Z(K,ue){const de=Math.min(K.length,ue.length);let pe;for(pe=0;pe<de;pe++)if(K.charCodeAt(pe)!==ue.charCodeAt(pe))return pe;return de}e.commonPrefixLength=Z;function se(K,ue){const de=Math.min(K.length,ue.length);let pe;const ye=K.length-1,Re=ue.length-1;for(pe=0;pe<de;pe++)if(K.charCodeAt(ye-pe)!==ue.charCodeAt(Re-pe))return pe;return de}e.commonSuffixLength=se;function he(K){return 55296<=K&&K<=56319}e.isHighSurrogate=he;function V(K){return 56320<=K&&K<=57343}e.isLowSurrogate=V;function H(K,ue){return(K-55296<<10)+(ue-56320)+65536}e.computeCodePoint=H;function W(K,ue,de){const pe=K.charCodeAt(de);if(he(pe)&&de+1<ue){const ye=K.charCodeAt(de+1);if(V(ye))return H(pe,ye)}return pe}e.getNextCodePoint=W;function A(K,ue){const de=K.charCodeAt(ue-1);if(V(de)&&ue>1){const pe=K.charCodeAt(ue-2);if(he(pe))return H(pe,de)}return de}class F{get offset(){return this._offset}constructor(ue,de=0){this._str=ue,this._len=ue.length,this._offset=de}setOffset(ue){this._offset=ue}prevCodePoint(){const ue=A(this._str,this._offset);return this._offset-=ue>=65536?2:1,ue}nextCodePoint(){const ue=W(this._str,this._len,this._offset);return this._offset+=ue>=65536?2:1,ue}eol(){return this._offset>=this._len}}e.CodePointIterator=F;class U{get offset(){return this._iterator.offset}constructor(ue,de=0){this._iterator=new F(ue,de)}nextGraphemeLength(){const ue=Te.getInstance(),de=this._iterator,pe=de.offset;let ye=ue.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const Re=de.offset,_e=ue.getGraphemeBreakType(de.nextCodePoint());if(Se(ye,_e)){de.setOffset(Re);break}ye=_e}return de.offset-pe}prevGraphemeLength(){const ue=Te.getInstance(),de=this._iterator,pe=de.offset;let ye=ue.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const Re=de.offset,_e=ue.getGraphemeBreakType(de.prevCodePoint());if(Se(_e,ye)){de.setOffset(Re);break}ye=_e}return pe-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=U;function J(K,ue){return new U(K,ue).nextGraphemeLength()}e.nextCharLength=J;function B(K,ue){return new U(K,ue).prevGraphemeLength()}e.prevCharLength=B;function $(K,ue){ue>0&&V(K.charCodeAt(ue))&&ue--;const de=ue+J(K,ue);return[de-B(K,de),de]}e.getCharContainingOffset=$;function L(K){const ue=new U(K);let de=0;for(;!ue.eol();)de++,ue.nextGraphemeLength();return de}e.charCount=L;let O;function _(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(K){return O||(O=_()),O.test(K)}e.containsRTL=j;const Y=/^[\t\n\r\x20-\x7E]*$/;function oe(K){return Y.test(K)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=q;function re(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=re;function ne(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ne;function ce(K,ue){if(K.length<ue)return K;const de=/\b/g;let pe=0;for(;de.test(K)&&!(K.length-de.lastIndex<ue);)pe=de.lastIndex,de.lastIndex+=1;return K.substring(pe).replace(/^\s/,"")}e.lcut=ce;const ge=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function ke(K){return K&&(K=K.replace(ge,""),K=K.replace(De,""),K=K.replace(Ae,"")),K}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function qe(K){return Le(K)?K.substr(1):K}e.stripUTF8BOM=qe;function me(K,ue){if(!K||!ue||K.length<ue.length)return!1;const de=ue.length,pe=K.toLowerCase();let ye=0,Re=-1;for(;ye<de;){const _e=pe.indexOf(ue[ye],Re+1);if(_e<0)return!1;Re=_e,ye++}return!0}e.fuzzyContains=me;function we(K,ue=!1){return K?(ue&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=we;function Ee(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ee;function x(K,ue=1){if(ue===0)return"";let de=-1;do de=K.indexOf(`
`,de+1),ue--;while(ue>0&&de>=0);return de===-1?K:(K[de-1]==="\r"&&de--,K.substr(0,de))}e.getNLines=x;function le(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=le;function fe(K){return Te.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=fe;function Se(K,ue){return K===0?ue!==5&&ue!==7:K===2&&ue===3?!1:K===4||K===2||K===3||ue===4||ue===2||ue===3?!0:!(K===8&&(ue===8||ue===9||ue===11||ue===12)||(K===11||K===9)&&(ue===9||ue===10)||(K===12||K===10)&&ue===10||ue===5||ue===13||ue===7||K===1||K===13&&ue===14||K===6&&ue===6)}var Ie;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Te{static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}constructor(){this._data=Oe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const de=this._data,pe=de.length/3;let ye=1;for(;ye<=pe;)if(ue<de[3*ye])ye=2*ye;else if(ue>de[3*ye+1])ye=2*ye+1;else return de[3*ye+2];return 0}}Te._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(K,ue){if(K===0)return 0;const de=Be(K,ue);if(de!==void 0)return de;const pe=new F(ue,K);return pe.prevCodePoint(),pe.offset}e.getLeftDeleteOffset=Ne;function Be(K,ue){const de=new F(ue,K);let pe=de.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(de.offset===0)return;pe=de.prevCodePoint()}if(!ne(pe))return;let ye=de.offset;return ye>0&&de.prevCodePoint()===8205&&(ye=de.offset),ye}function ze(K){return 127995<=K&&K<=127999}var Ke;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ke||(Ke={})),e.noBreakWhitespace="\xA0";class Ue{static getInstance(ue){return Ue.cache.get(Array.from(ue))}static getLocales(){return Ue._locales.getValue()}constructor(ue){this.confusableDictionary=ue}isAmbiguous(ue){return this.confusableDictionary.has(ue)}getPrimaryConfusable(ue){return this.confusableDictionary.get(ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ue,k=Ue,Ue.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.cache=new S.LRUCachedFunction(K=>{function ue(je){const et=new Map;for(let nt=0;nt<je.length;nt+=2)et.set(je[nt],je[nt+1]);return et}function de(je,et){const nt=new Map(je);for(const[lt,gt]of et)nt.set(lt,gt);return nt}function pe(je,et){if(!je)return et;const nt=new Map;for(const[lt,gt]of je)et.has(lt)&&nt.set(lt,gt);return nt}const ye=k.ambiguousCharacterData.getValue();let Re=K.filter(je=>!je.startsWith("_")&&je in ye);Re.length===0&&(Re=["_default"]);let _e;for(const je of Re){const et=ue(ye[je]);_e=pe(_e,et)}const it=ue(ye._common),xe=de(it,_e);return new Ue(xe)}),Ue._locales=new t.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(ue){return Ge.getData().has(ue)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(te[30],ie([0,1,9,4,26,12]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function b(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=b;function u(s){return s.indexOf("/")===-1&&(s=b(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=u;function p(s,l=S.posix.sep){if(!s)return"";const a=s.length,I=s.charCodeAt(0);if(D(I)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let T=3;const N=T;for(;T<a&&!D(s.charCodeAt(T));T++);if(N!==T&&!D(s.charCodeAt(T+1))){for(T+=1;T<a;T++)if(D(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,l)}}return l}else if(m(I)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let M=s.indexOf("://");if(M!==-1){for(M+=3;M<a;M++)if(D(s.charCodeAt(M)))return s.slice(0,M+1)}return""}e.getRoot=p;function C(s){if(!t.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let a=2;const I=a;for(;a<s.length&&(l=s.charCodeAt(a),l!==92);a++);return!(I===a||(l=s.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=C;const y=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,l=t.isWindows){const a=l?y:E;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||l&&h.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function P(s,l,a){const I=s===l;return!a||I?I:!s||!l?!1:(0,k.equalsIgnoreCase)(s,l)}e.isEqual=P;function w(s,l,a,I=S.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(s,l))return!1;if(l.length===s.length)return!0;let T=l.length;return l.charAt(l.length-1)===I&&T--,s.charAt(T)===I}return l.charAt(l.length-1)!==I&&(l+=I),s.indexOf(l)===0}e.isEqualOrParent=w;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function v(s,l){return t.isWindows&&s.endsWith(":")&&(s+=S.sep),(0,S.isAbsolute)(s)||(s=(0,S.join)(l,s)),s=(0,S.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=(0,k.rtrim)(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=v;function d(s){const l=(0,S.normalize)(s);return t.isWindows?s.length>3?!1:g(l)&&(s.length===2||l.charCodeAt(2)===92):l===S.posix.sep}e.isRootOrDriveLetter=d;function g(s,l=t.isWindows){return l?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function c(s){return g(s)?s[0]:void 0}e.getDriveLetter=c;function i(s,l,a){return l.length>s.length?-1:s===l?0:(a&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=i;function o(s){const l=s.split(":");let a,I,M;for(const T of l){const N=Number(T);(0,R.isNumber)(N)?I===void 0?I=N:M===void 0&&(M=N):a=a?[a,T].join(":"):T}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:I!==void 0?I:void 0,column:M!==void 0?M:I!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,l,a=8){let I="";for(let T=0;T<a;T++)I+=n.charAt(Math.floor(Math.random()*n.length));let M;return l?M=`${l}-${I}`:M=I,s?(0,S.join)(s,M):M}e.randomPath=r}),define(te[66],ie([0,1,26]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return k(m,0)}e.hash=t;function k(m,v){switch(typeof m){case"object":return m===null?R(349,v):Array.isArray(m)?u(m,v):p(m,v);case"string":return b(m,v);case"boolean":return D(m,v);case"number":return R(m,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=k;function R(m,v){return(v<<5)-v+m|0}e.numberHash=R;function D(m,v){return R(m?433:863,v)}function b(m,v){v=R(149417,v);for(let d=0,g=m.length;d<g;d++)v=R(m.charCodeAt(d),v);return v}e.stringHash=b;function u(m,v){return v=R(104579,v),m.reduce((d,g)=>k(g,d),v)}function p(m,v){return v=R(181387,v),Object.keys(m).sort().reduce((d,g)=>(d=b(g,d),k(m[g],d)),v)}class C{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=k(v,this._value),this._value}}e.Hasher=C;var y;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function E(m,v,d=32){const g=d-v,c=~((1<<g)-1);return(m<<v|(c&m)>>>g)>>>0}function h(m,v=0,d=m.byteLength,g=0){for(let c=0;c<d;c++)m[v+c]=g}function f(m,v,d="0"){for(;m.length<v;)m=d+m;return m}function P(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(d=>d.toString(16).padStart(2,"0")).join(""):f((m>>>0).toString(16),v/4)}e.toHexString=P;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const d=v.length;if(d===0)return;const g=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,o,n;for(i!==0?(o=i,n=-1,i=0):(o=v.charCodeAt(0),n=0);;){let r=o;if(S.isHighSurrogate(o))if(n+1<d){const s=v.charCodeAt(n+1);S.isLowSurrogate(s)?(n++,r=S.computeCodePoint(o,s)):r=65533}else{i=o;break}else S.isLowSurrogate(o)&&(r=65533);if(c=this._push(g,c,r),n++,n<d)o=v.charCodeAt(n);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(v,d,g){return g<128?v[d++]=g:g<2048?(v[d++]=192|(g&1984)>>>6,v[d++]=128|(g&63)>>>0):g<65536?(v[d++]=224|(g&61440)>>>12,v[d++]=128|(g&4032)>>>6,v[d++]=128|(g&63)>>>0):(v[d++]=240|(g&1835008)>>>18,v[d++]=128|(g&258048)>>>12,v[d++]=128|(g&4032)>>>6,v[d++]=128|(g&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),P(this._h0)+P(this._h1)+P(this._h2)+P(this._h3)+P(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=w._bigBlock32,d=this._buffDV;for(let a=0;a<64;a+=4)v.setUint32(a,d.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)v.setUint32(a,E(v.getUint32(a-12,!1)^v.getUint32(a-32,!1)^v.getUint32(a-56,!1)^v.getUint32(a-64,!1),1),!1);let g=this._h0,c=this._h1,i=this._h2,o=this._h3,n=this._h4,r,s,l;for(let a=0;a<80;a++)a<20?(r=c&i|~c&o,s=1518500249):a<40?(r=c^i^o,s=1859775393):a<60?(r=c&i|c&o|i&o,s=2400959708):(r=c^i^o,s=3395469782),l=E(g,5)+r+n+s+v.getUint32(a*4,!1)&4294967295,n=o,o=i,i=E(c,30),c=g,g=l;this._h0=this._h0+g&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(te[31],ie([0,1,24,26]),function(z,e,S,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(n,r,s){let l=n.get(r);return l===void 0&&(l=s,n.set(r,l)),l}e.getOrSet=b;function u(n){const r=[];return n.forEach((s,l)=>{r.push(`${l} => ${s}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.mapToString=u;function p(n){const r=[];return n.forEach(s=>{r.push(s)}),`Set(${n.size}) {${r.join(", ")}}`}e.setToString=p;class C{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=C;class y{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class E{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const l=this._value.charCodeAt(s);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var h;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(h||(h={}));class f{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(w||(w={}));class m{static forUris(r=()=>!1,s=()=>!1){return new m(new f(r,s))}static forPaths(r=!1){return new m(new E(void 0,!r))}static forStrings(){return new m(new C)}static forConfigKeys(){return new m(new y)}constructor(r){this._iter=r}clear(){this._root=void 0}fill(r,s){if(s){const l=s.slice(0);(0,S.shuffle)(l);for(const a of l)this.set(a,r)}else{const l=r.slice(0);(0,S.shuffle)(l);for(const a of l)this.set(a[0],a[1])}}set(r,s){const l=this._iter.reset(r);let a;this._root||(this._root=new P,this._root.segment=l.value());const I=[];for(a=this._root;;){const T=l.cmp(a.segment);if(T>0)a.left||(a.left=new P,a.left.segment=l.value()),I.push([-1,a]),a=a.left;else if(T<0)a.right||(a.right=new P,a.right.segment=l.value()),I.push([1,a]),a=a.right;else if(l.hasNext())l.next(),a.mid||(a.mid=new P,a.mid.segment=l.value()),I.push([0,a]),a=a.mid;else break}const M=a.value;a.value=s,a.key=r;for(let T=I.length-1;T>=0;T--){const N=I[T][1];N.updateHeight();const X=N.balanceFactor();if(X<-1||X>1){const ae=I[T][0],Q=I[T+1][0];if(ae===1&&Q===1)I[T][1]=N.rotateLeft();else if(ae===-1&&Q===-1)I[T][1]=N.rotateRight();else if(ae===1&&Q===-1)N.right=I[T+1][1]=I[T+1][1].rotateRight(),I[T][1]=N.rotateLeft();else if(ae===-1&&Q===1)N.left=I[T+1][1]=I[T+1][1].rotateLeft(),I[T][1]=N.rotateRight();else throw new Error;if(T>0)switch(I[T-1][0]){case-1:I[T-1][1].left=I[T][1];break;case 1:I[T-1][1].right=I[T][1];break;case 0:I[T-1][1].mid=I[T][1];break}else this._root=I[0][1]}}return M}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const a=s.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const l=this._iter.reset(r),a=[];let I=this._root;for(;I;){const M=l.cmp(I.segment);if(M>0)a.push([-1,I]),I=I.left;else if(M<0)a.push([1,I]),I=I.right;else if(l.hasNext())l.next(),a.push([0,I]),I=I.mid;else break}if(!!I){if(s?(I.left=void 0,I.mid=void 0,I.right=void 0,I.height=1):(I.key=void 0,I.value=void 0),!I.mid&&!I.value)if(I.left&&I.right){const M=this._min(I.right);if(M.key){const{key:T,value:N,segment:X}=M;this._delete(M.key,!1),I.key=T,I.value=N,I.segment=X}}else{const M=I.left??I.right;if(a.length>0){const[T,N]=a[a.length-1];switch(T){case-1:N.left=M;break;case 0:N.mid=M;break;case 1:N.right=M;break}}else this._root=M}for(let M=a.length-1;M>=0;M--){const T=a[M][1];T.updateHeight();const N=T.balanceFactor();if(N>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),a[M][1]=T.rotateLeft()):N<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),a[M][1]=T.rotateRight()),M>0)switch(a[M-1][0]){case-1:a[M-1][1].left=a[M][1];break;case 1:a[M-1][1].right=a[M][1];break;case 0:a[M-1][1].mid=a[M][1];break}else this._root=a[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let l=this._root,a;for(;l;){const I=s.cmp(l.segment);if(I>0)l=l.left;else if(I<0)l=l.right;else if(s.hasNext())s.next(),a=l.value||a,l=l.mid;else break}return l&&l.value||a}findSuperstr(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const a=s.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[s,l]of this)r(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const l=s.balanceFactor();return l<-1||l>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=m;class v{constructor(r,s){this.uri=r,this.value=s}}class d{constructor(r,s){this[k]="ResourceMap",r instanceof d?(this.map=new Map(r.map),this.toKey=s??d.defaultToKey):(this.map=new Map,this.toKey=r??d.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new v(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[l,a]of this.map)r(a.value,a.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=d,d.defaultToKey=n=>n.toString();class g{constructor(r,s){this[R]="ResourceSet",!r||typeof r=="function"?this._map=new d(r):(this._map=new d(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((l,a)=>r.call(s,a,a,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=g;var c;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class i{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const l=this._map.get(r);if(!!l)return s!==0&&this.touch(l,s),l.value}set(r,s,l=0){let a=this._map.get(r);if(a)a.value=s,l!==0&&this.touch(a,l);else{switch(a={key:r,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(r,a),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const l=this._state;let a=this._head;for(;a;){if(s?r.bind(s)(a.value,a.key,this):r(a.value,a.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const r=this,s=this._state;let l=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const I={value:l.key,done:!1};return l=l.next,I}else return{value:void 0,done:!0}}};return a}values(){const r=this,s=this._state;let l=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const I={value:l.value,done:!1};return l=l.next,I}else return{value:void 0,done:!0}}};return a}entries(){const r=this,s=this._state;let l=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const I={value:[l.key,l.value],done:!1};return l=l.next,I}else return{value:void 0,done:!0}}};return a}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>r;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,l=r.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const l=r.next,a=r.previous;r===this._tail?(a.next=void 0,this._tail=a):(l.previous=a,a.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const l=r.next,a=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=a,a.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,l)=>{r.push([l,s])}),r}fromJSON(r){this.clear();for(const[s,l]of r)this.set(s,l)}}e.LinkedMap=i;class o extends i{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(te[80],ie([0,1,31]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new S.LRUCache(1e4);function k(p){return u(p,"NFC",t)}e.normalizeNFC=k;const R=new S.LRUCache(1e4);function D(p){return u(p,"NFD",R)}e.normalizeNFD=D;const b=/[^\u0000-\u0080]/;function u(p,C,y){if(!p)return p;const E=y.get(p);if(E)return E;let h;return b.test(p)?h=p.normalize(C):h=p,y.set(p,h),h}e.removeAccents=function(){const p=/[\u0300-\u036f]/g;return function(C){return D(C).replace(p,"")}}()}),define(te[97],ie([0,1,26]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",b="warn",u="info",p="ignore";function C(E){return E?S.equalsIgnoreCase(R,E)?k.Error:S.equalsIgnoreCase(D,E)||S.equalsIgnoreCase(b,E)?k.Warning:S.equalsIgnoreCase(u,E)?k.Info:k.Ignore:k.Ignore}k.fromValue=C;function y(E){switch(E){case k.Error:return R;case k.Warning:return D;case k.Info:return u;default:return p}}k.toString=y}(t||(t={})),e.default=t}),define(te[7],ie([0,1,9,4]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function b(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(n,r){return!n&&!r?"file":n}function p(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==y&&(r=y+r):r=y;break}return r}const C="",y="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(r){return r instanceof h?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,s,l,a,I,M=!1){typeof r=="object"?(this.scheme=r.scheme||C,this.authority=r.authority||C,this.path=r.path||C,this.query=r.query||C,this.fragment=r.fragment||C):(this.scheme=u(r,M),this.authority=s||C,this.path=p(this.scheme,l||C),this.query=a||C,this.fragment=I||C,b(this,M))}get fsPath(){return d(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:l,path:a,query:I,fragment:M}=r;return s===void 0?s=this.scheme:s===null&&(s=C),l===void 0?l=this.authority:l===null&&(l=C),a===void 0?a=this.path:a===null&&(a=C),I===void 0?I=this.query:I===null&&(I=C),M===void 0?M=this.fragment:M===null&&(M=C),s===this.scheme&&l===this.authority&&a===this.path&&I===this.query&&M===this.fragment?this:new P(s,l,a,I,M)}static parse(r,s=!1){const l=E.exec(r);return l?new P(l[2]||C,o(l[4]||C),o(l[5]||C),o(l[7]||C),o(l[9]||C),s):new P(C,C,C,C,C)}static file(r){let s=C;if(t.isWindows&&(r=r.replace(/\\/g,y)),r[0]===y&&r[1]===y){const l=r.indexOf(y,2);l===-1?(s=r.substring(2),r=y):(s=r.substring(2,l),r=r.substring(l)||y)}return new P("file",s,r,C,C)}static from(r){const s=new P(r.scheme,r.authority,r.path,r.query,r.fragment);return b(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&r.scheme==="file"?l=h.file(S.win32.join(d(r,!0),...s)).path:l=S.posix.join(r.path,...s),r.with({path:l})}toString(r=!1){return g(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof h)return r;{const s=new P(r);return s._formatted=r.external,s._fsPath=r._sep===f?r.fsPath:null,s}}else return r}}e.URI=h;const f=t.isWindows?1:void 0;class P extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(r=!1){return r?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=f),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,r){let s,l=-1;for(let a=0;a<n.length;a++){const I=n.charCodeAt(a);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||r&&I===47)l!==-1&&(s+=encodeURIComponent(n.substring(l,a)),l=-1),s!==void 0&&(s+=n.charAt(a));else{s===void 0&&(s=n.substr(0,a));const M=w[I];M!==void 0?(l!==-1&&(s+=encodeURIComponent(n.substring(l,a)),l=-1),s+=M):l===-1&&(l=a)}}return l!==-1&&(s+=encodeURIComponent(n.substring(l))),s!==void 0?s:n}function v(n){let r;for(let s=0;s<n.length;s++){const l=n.charCodeAt(s);l===35||l===63?(r===void 0&&(r=n.substr(0,s)),r+=w[l]):r!==void 0&&(r+=n[s])}return r!==void 0?r:n}function d(n,r){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=d;function g(n,r){const s=r?v:m;let l="",{scheme:a,authority:I,path:M,query:T,fragment:N}=n;if(a&&(l+=a,l+=":"),(I||a==="file")&&(l+=y,l+=y),I){let X=I.indexOf("@");if(X!==-1){const ae=I.substr(0,X);I=I.substr(X+1),X=ae.indexOf(":"),X===-1?l+=s(ae,!1):(l+=s(ae.substr(0,X),!1),l+=":",l+=s(ae.substr(X+1),!1)),l+="@"}I=I.toLowerCase(),X=I.indexOf(":"),X===-1?l+=s(I,!1):(l+=s(I.substr(0,X),!1),l+=I.substr(X))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const X=M.charCodeAt(1);X>=65&&X<=90&&(M=`/${String.fromCharCode(X+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const X=M.charCodeAt(0);X>=65&&X<=90&&(M=`${String.fromCharCode(X+32)}:${M.substr(2)}`)}l+=s(M,!0)}return T&&(l+="?",l+=s(T,!1)),N&&(l+="#",l+=r?N:m(N,!1)),l}function c(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+c(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(i)?n.replace(i,r=>c(r)):n}}),define(te[139],ie([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(p){const C=p;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=t;function k(p){const C=[];let y;try{const E=JSON.parse(p.arguments),h=E[E.length-1];h&&h.__$stack&&(E.pop(),y=h.__$stack),C.push(...E)}catch{C.push("Unable to log remote console arguments",p.arguments)}return{args:C,stack:y}}e.parse=k;function R(p){if(typeof p!="string")return R(k(p).stack);const C=p;if(C){const y=D(C),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(E&&E.length===4)return{uri:S.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=R;function D(p){if(!p)return p;const C=p.indexOf(`
`);return C===-1?p:p.substring(0,C)}function b(p,C){const{args:y,stack:E}=k(p),h=typeof y[0]=="string"&&y.length===1;let f=D(E);f&&(f=`(${f.trim()})`);let P=[];if(typeof y[0]=="string"?f&&h?P=[`%c[${C}] %c${y[0]} %c${f}`,u("blue"),u(""),u("grey")]:P=[`%c[${C}] %c${y[0]}`,u("blue"),u(""),...y.slice(1)]:P=[`%c[${C}]%`,u("blue"),...y],f&&!h&&P.push(f),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,P)}e.log=b;function u(p){return`color: ${p}`}}),define(te[67],ie([0,1,18,26,7]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(p){return JSON.stringify(p,b)}e.stringify=R;function D(p){let C=JSON.parse(p);return C=u(C),C}e.parse=D;function b(p,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function u(p,C=0){if(!p||C>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return k.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 14:return new Date(p.source)}if(p instanceof S.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let y=0;y<p.length;++y)p[y]=u(p[y],C+1);else for(const y in p)Object.hasOwnProperty.call(p,y)&&(p[y]=u(p[y],C+1))}return p}e.revive=u}),define(te[13],ie([0,1,4,7]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebook="vscode-notebook",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p){this._remoteResourcesPath=`${p}/${k.vscodeRemoteResource}`}set(p,C,y){this._hosts[p]=C,this._ports[p]=y}setConnectionToken(p,C){this._connectionTokens[p]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)return this._delegate(p);const C=p.authority;let y=this._hosts[C];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const E=this._ports[C],h=this._connectionTokens[C];let f=`path=${encodeURIComponent(p.path)}`;return typeof h=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),t.URI.from({scheme:S.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${y}:${E}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new R;class D{asBrowserUri(p,C){const y=this.toUri(p,C);return y.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===k.file&&(S.isNative||S.isWebWorker&&S.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?y.with({scheme:k.vscodeFileResource,authority:y.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(p,C){const y=this.toUri(p,C);return y.scheme===k.vscodeFileResource?y.with({scheme:k.file,authority:y.authority!==D.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(p,C){return t.URI.isUri(p)?p:t.URI.parse(C.toUrl(p))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var b;(function(u){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(p.get("3"));const C="vscode-coi";function y(h){let f;typeof h=="string"?f=new URL(h).searchParams:h instanceof URL?f=h.searchParams:t.URI.isUri(h)&&(f=new URL(h.toString(!0)).searchParams);const P=f?.get(C);if(!!P)return p.get(P)}u.getHeadersFromQuery=y;function E(h,f,P){if(!globalThis.crossOriginIsolated)return;const w=f&&P?"3":P?"2":"1";h instanceof URLSearchParams?h.set(C,w):h[C]=w}u.addSearchParam=E})(b=e.COI||(e.COI={}))}),define(te[16],ie([0,1,30,13,9,4,26,7]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function u(h){return(0,b.uriToFsPath)(h,!0)}e.originalFSPath=u;class p{constructor(f){this._ignorePathCasing=f}compare(f,P,w=!1){return f===P?0:(0,D.compare)(this.getComparisonKey(f,w),this.getComparisonKey(P,w))}isEqual(f,P,w=!1){return f===P?!0:!f||!P?!1:this.getComparisonKey(f,w)===this.getComparisonKey(P,w)}getComparisonKey(f,P=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:P?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,P,w=!1){if(f.scheme===P.scheme){if(f.scheme===t.Schemas.file)return S.isEqualOrParent(u(f),u(P),this._ignorePathCasing(f))&&f.query===P.query&&(w||f.fragment===P.fragment);if((0,e.isEqualAuthority)(f.authority,P.authority))return S.isEqualOrParent(f.path,P.path,this._ignorePathCasing(f),"/")&&f.query===P.query&&(w||f.fragment===P.fragment)}return!1}joinPath(f,...P){return b.URI.joinPath(f,...P)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return k.posix.basename(f.path)}extname(f){return k.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let P;return f.scheme===t.Schemas.file?P=b.URI.file(k.dirname(u(f))).path:(P=k.posix.dirname(f.path),f.authority&&P.length&&P.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),P="/")),f.with({path:P})}normalizePath(f){if(!f.path.length)return f;let P;return f.scheme===t.Schemas.file?P=b.URI.file(k.normalize(u(f))).path:P=k.posix.normalize(f.path),f.with({path:P})}relativePath(f,P){if(f.scheme!==P.scheme||!(0,e.isEqualAuthority)(f.authority,P.authority))return;if(f.scheme===t.Schemas.file){const v=k.relative(u(f),u(P));return R.isWindows?S.toSlashes(v):v}let w=f.path||"/";const m=P.path||"/";if(this._ignorePathCasing(f)){let v=0;for(const d=Math.min(w.length,m.length);v<d&&!(w.charCodeAt(v)!==m.charCodeAt(v)&&w.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);w=m.substr(0,v)+w.substr(v)}return k.posix.relative(w,m)}resolvePath(f,P){if(f.scheme===t.Schemas.file){const w=b.URI.file(k.resolve(u(f),P));return f.with({authority:w.authority,path:w.path})}return P=S.toPosixPath(P),f.with({path:k.posix.resolve(f.path,P)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,P){return f===P||f!==void 0&&P!==void 0&&(0,D.equalsIgnoreCase)(f,P)}hasTrailingPathSeparator(f,P=k.sep){if(f.scheme===t.Schemas.file){const w=u(f);return w.length>S.getRoot(w).length&&w[w.length-1]===P}else{const w=f.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,P=k.sep){return(0,e.hasTrailingPathSeparator)(f,P)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,P=k.sep){let w=!1;if(f.scheme===t.Schemas.file){const m=u(f);w=m!==void 0&&m.length===S.getRoot(m).length&&m[m.length-1]===P}else{P="/";const m=f.path;w=m.length===1&&m.charCodeAt(m.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(f,P)?f.with({path:f.path+"/"}):f}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(h=>h.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new p(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(h,f){const P=[];for(let w=0;w<h.length;w++){const m=f(h[w]);h.some((v,d)=>d===w?!1:(0,e.isEqualOrParent)(m,f(v)))||P.push(h[w])}return P}e.distinctParents=C;var y;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function f(P){const w=new Map;P.path.substring(P.path.indexOf(";")+1,P.path.lastIndexOf(";")).split(";").forEach(d=>{const[g,c]=d.split(":");g&&c&&w.set(g,c)});const v=P.path.substring(0,P.path.indexOf(";"));return v&&w.set(h.META_DATA_MIME,v),w}h.parseMetaData=f})(y=e.DataUri||(e.DataUri={}));function E(h,f,P){if(f){let w=h.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),h.with({scheme:P,authority:f,path:w})}return h.with({scheme:P})}e.toLocalResource=E}),define(te[8],ie([0,1,23,17,3,2,16,4]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function u($){return!!$&&typeof $.then=="function"}e.isThenable=u;function p($){const L=new S.CancellationTokenSource,O=$(L.token),_=new Promise((j,Y)=>{const oe=L.token.onCancellationRequested(()=>{oe.dispose(),L.dispose(),Y(new t.CancellationError)});Promise.resolve(O).then(q=>{oe.dispose(),L.dispose(),j(q)},q=>{oe.dispose(),L.dispose(),Y(q)})});return new class{cancel(){L.cancel()}then(j,Y){return _.then(j,Y)}catch(j){return this.then(void 0,j)}finally(j){return _.finally(j)}}}e.createCancelablePromise=p;function C($,L,O){return new Promise((_,j)=>{const Y=L.onCancellationRequested(()=>{Y.dispose(),_(O)});$.then(_,j).finally(()=>Y.dispose())})}e.raceCancellation=C;function y($,L){return new Promise((O,_)=>{const j=L.onCancellationRequested(()=>{j.dispose(),_(new t.CancellationError)});$.then(O,_).finally(()=>j.dispose())})}e.raceCancellationError=y;async function E($){let L=-1;const O=$.map((j,Y)=>j.then(oe=>(L=Y,oe))),_=await Promise.race(O);return $.forEach((j,Y)=>{Y!==L&&j.cancel()}),_}e.raceCancellablePromises=E;function h($,L,O){let _;const j=setTimeout(()=>{_?.(void 0),O?.()},L);return Promise.race([$.finally(()=>clearTimeout(j)),new Promise(Y=>_=Y)])}e.raceTimeout=h;function f($){return new Promise((L,O)=>{const _=$();u(_)?_.then(L,O):L(_)})}e.asPromise=f;class P{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=L(),new Promise((O,_)=>{this.activePromise.then(j=>{this.activePromise=null,O(j)},j=>{this.activePromise=null,_(j)})})}}e.Throttler=P;class w{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=w;class m{constructor(){this.promiseMap=new Map}queue(L,O){const j=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===j&&this.promiseMap.delete(L)});return this.promiseMap.set(L,j),j}}e.SequencerByKey=m;const v=($,L)=>{let O=!0;const _=setTimeout(()=>{O=!1,L()},$);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},d=$=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,$())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Y)=>{this.doResolve=j,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?d(_):v(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class c{constructor(L){this.delayer=new g(L),this.throttler=new P}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class i{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class o extends i{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function n($,L){return L?new Promise((O,_)=>{const j=setTimeout(()=>{Y.dispose(),O()},$),Y=L.onCancellationRequested(()=>{clearTimeout(j),Y.dispose(),_(new t.CancellationError)})}):p(O=>n($,O))}e.timeout=n;function r($,L=0){const O=setTimeout($,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=r;function s($){const L=[];let O=0;const _=$.length;function j(){return O<_?$[O++]():null}function Y(oe){oe!=null&&L.push(oe);const q=j();return q?q.then(Y):Promise.resolve(L)}return Promise.resolve(null).then(Y)}e.sequence=s;function l($,L=_=>!!_,O=null){let _=0;const j=$.length,Y=()=>{if(_>=j)return Promise.resolve(O);const oe=$[_++];return Promise.resolve(oe()).then(re=>L(re)?Promise.resolve(re):Y())};return Y()}e.first=l;function a($,L=_=>!!_,O=null){if($.length===0)return Promise.resolve(O);let _=$.length;const j=()=>{_=-1;for(const Y of $)Y.cancel?.()};return new Promise((Y,oe)=>{for(const q of $)q.then(re=>{--_>=0&&L(re)?(j(),Y(re)):_===0&&Y(O)}).catch(re=>{--_>=0&&(j(),oe(re))})})}e.firstParallel=a;class I{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:L,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=I;class M extends I{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new W;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const _=O.getComparisonKey(L);let j=this.queues.get(_);return j||(j=new M,k.Event.once(j.onDrained)(()=>{j?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,j)),j}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class N{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=N;class X{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=X;class ae{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ae;class Q{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Q;class G extends ae{constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=G;class Z extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ae(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,b.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=($,L)=>{const O=requestIdleCallback($,typeof L=="number"?{timeout:L}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function he($,L,O){let _;for(let j=0;j<O;j++)try{return await $()}catch(Y){_=Y,await n(L)}throw _}e.retry=he;class V{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,_){return this._pending={taskId:L,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,_;const j=new Promise((Y,oe)=>{O=Y,_=oe});this._next={run:L,promise:j,promiseResolve:O,promiseReject:_}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=V;class H{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class W{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=W;var A;(function($){async function L(_){let j;const Y=await Promise.all(_.map(oe=>oe.then(q=>q,q=>{j||(j=q)})));if(typeof j<"u")throw j;return Y}$.settled=L;function O(_){return new Promise(async(j,Y)=>{try{await _(j,Y)}catch(oe){Y(oe)}})}$.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var F;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(F||(F={}));class U{static fromArray(L){return new U(O=>{O.emitMany(L)})}static fromPromise(L){return new U(async O=>{O.emitMany(await L)})}static fromPromises(L){return new U(async O=>{await Promise.all(L.map(async _=>O.emitOne(await _)))})}static merge(L){return new U(async O=>{await Promise.all(L.map(async _=>{for await(const j of _)O.emitOne(j)}))})}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(L(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new U(async _=>{for await(const j of L)_.emitOne(O(j))})}map(L){return U.map(this,L)}static filter(L,O){return new U(async _=>{for await(const j of L)O(j)&&_.emitOne(j)})}filter(L){return U.filter(this,L)}static coalesce(L){return U.filter(L,O=>!!O)}coalesce(){return U.coalesce(this)}static async toPromise(L){const O=[];for await(const _ of L)O.push(_);return O}toPromise(){return U.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=U,U.EMPTY=U.fromArray([]);class J extends U{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function B($){const L=new S.CancellationTokenSource,O=$(L.token);return new J(L,async _=>{const j=L.token.onCancellationRequested(()=>{j.dispose(),L.dispose(),_.reject(new t.CancellationError)});try{for await(const Y of O){if(L.token.isCancellationRequested)return;_.emitOne(Y)}j.dispose(),L.dispose()}catch(Y){j.dispose(),L.dispose(),_.reject(Y)}})}e.createCancelableAsyncIterable=B}),define(te[98],ie([0,1,24,8,30,31,9,4,26]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function p(){return Object.create(null)}e.getEmptyExpression=p,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",y="[^/\\\\]",E=/\//g;function h(W,A){switch(W){case 0:return"";case 1:return`${y}*?`;default:return`(?:${C}|${y}+${C}${A?`|${C}${y}+`:""})*?`}}function f(W,A){if(!W)return[];const F=[];let U=!1,J=!1,B="";for(const $ of W){switch($){case A:if(!U&&!J){F.push(B),B="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":J=!0;break;case"]":J=!1;break}B+=$}return B&&F.push(B),F}e.splitGlobAware=f;function P(W){if(!W)return"";let A="";const F=f(W,e.GLOB_SPLIT);if(F.every(U=>U===e.GLOBSTAR))A=".*";else{let U=!1;F.forEach((J,B)=>{if(J===e.GLOBSTAR){if(U)return;A+=h(2,B===F.length-1)}else{let $=!1,L="",O=!1,_="";for(const j of J){if(j!=="}"&&$){L+=j;continue}if(O&&(j!=="]"||!_)){let Y;j==="-"?Y=j:(j==="^"||j==="!")&&!_?Y="^":j===e.GLOB_SPLIT?Y="":Y=(0,u.escapeRegExpCharacters)(j),_+=Y;continue}switch(j){case"{":$=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${f(L,",").map(q=>P(q)).join("|")})`,$=!1,L="";break}case"]":{A+="["+_+"]",O=!1,_="";break}case"?":A+=y;continue;case"*":A+=h(1);continue;default:A+=(0,u.escapeRegExpCharacters)(j)}}B<F.length-1&&(F[B+1]!==e.GLOBSTAR||B+2<F.length)&&(A+=C)}U=J===e.GLOBSTAR})}return A}const w=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),o=function(){return!1},n=function(){return null};function r(W,A){if(!W)return n;let F;typeof W!="string"?F=W.pattern:F=W,F=F.trim();const U=`${F}_${!!A.trimForExclusions}`;let J=i.get(U);if(J)return s(J,W);let B;return w.test(F)?J=a(F.substr(4),F):(B=m.exec(l(F,A)))?J=I(B[1],F):(A.trimForExclusions?d:v).test(F)?J=M(F,A):(B=g.exec(l(F,A)))?J=T(B[1].substr(1),F,!0):(B=c.exec(l(F,A)))?J=T(B[1],F,!1):J=N(F),i.set(U,J),s(J,W)}function s(W,A){if(typeof A=="string")return W;const F=function(U,J){return(0,k.isEqualOrParent)(U,A.base,!b.isLinux)?W(U.substr(A.base.length+1),J):null};return F.allBasenames=W.allBasenames,F.allPaths=W.allPaths,F.basenames=W.basenames,F.patterns=W.patterns,F}function l(W,A){return A.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function a(W,A){return function(F,U){return typeof F=="string"&&F.endsWith(W)?A:null}}function I(W,A){const F=`/${W}`,U=`\\${W}`,J=function($,L){return typeof $!="string"?null:L?L===W?A:null:$===W||$.endsWith(F)||$.endsWith(U)?A:null},B=[W];return J.basenames=B,J.patterns=[A],J.allBasenames=B,J}function M(W,A){const F=V(W.slice(1,-1).split(",").map(L=>r(L,A)).filter(L=>L!==n),W),U=F.length;if(!U)return n;if(U===1)return F[0];const J=function(L,O){for(let _=0,j=F.length;_<j;_++)if(F[_](L,O))return W;return null},B=F.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=F.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function T(W,A,F){const U=D.sep===D.posix.sep,J=U?W:W.replace(E,D.sep),B=D.sep+J,$=D.posix.sep+W;let L;return F?L=function(O,_){return typeof O=="string"&&(O===J||O.endsWith(B)||!U&&(O===W||O.endsWith($)))?A:null}:L=function(O,_){return typeof O=="string"&&(O===J||!U&&O===W)?A:null},L.allPaths=[(F?"*/":"./")+W],L}function N(W){try{const A=new RegExp(`^${P(W)}$`);return function(F){return A.lastIndex=0,typeof F=="string"&&A.test(F)?W:null}}catch{return n}}function X(W,A,F){return!W||typeof A!="string"?!1:ae(W)(A,void 0,F)}e.match=X;function ae(W,A={}){if(!W)return o;if(typeof W=="string"||Q(W)){const F=r(W,A);if(F===n)return o;const U=function(J,B){return!!F(J,B)};return F.allBasenames&&(U.allBasenames=F.allBasenames),F.allPaths&&(U.allPaths=F.allPaths),U}return se(W,A)}e.parse=ae;function Q(W){const A=W;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=Q;function G(W){return W.allBasenames||[]}e.getBasenameTerms=G;function Z(W){return W.allPaths||[]}e.getPathTerms=Z;function se(W,A){const F=V(Object.getOwnPropertyNames(W).map(L=>he(L,W[L],A)).filter(L=>L!==n)),U=F.length;if(!U)return n;if(!F.some(L=>!!L.requiresSiblings)){if(U===1)return F[0];const L=function(j,Y){let oe;for(let q=0,re=F.length;q<re;q++){const ne=F[q](j,Y);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(oe||(oe=[]),oe.push(ne))}return oe?(async()=>{for(const q of oe){const re=await q;if(typeof re=="string")return re}return null})():null},O=F.find(j=>!!j.allBasenames);O&&(L.allBasenames=O.allBasenames);const _=F.reduce((j,Y)=>Y.allPaths?j.concat(Y.allPaths):j,[]);return _.length&&(L.allPaths=_),L}const J=function(L,O,_){let j,Y;for(let oe=0,q=F.length;oe<q;oe++){const re=F[oe];re.requiresSiblings&&_&&(O||(O=(0,D.basename)(L)),j||(j=O.substr(0,O.length-(0,D.extname)(L).length)));const ne=re(L,O,j,_);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(Y||(Y=[]),Y.push(ne))}return Y?(async()=>{for(const oe of Y){const q=await oe;if(typeof q=="string")return q}return null})():null},B=F.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=F.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function he(W,A,F){if(A===!1)return n;const U=r(W,F);if(U===n)return n;if(typeof A=="boolean")return U;if(A){const J=A.when;if(typeof J=="string"){const B=($,L,O,_)=>{if(!_||!U($,L))return null;const j=J.replace("$(basename)",O),Y=_(j);return(0,t.isThenable)(Y)?Y.then(oe=>oe?W:null):Y?W:null};return B.requiresSiblings=!0,B}}return U}function V(W,A){const F=W.filter(L=>!!L.basenames);if(F.length<2)return W;const U=F.reduce((L,O)=>{const _=O.basenames;return _?L.concat(_):L},[]);let J;if(A){J=[];for(let L=0,O=U.length;L<O;L++)J.push(A)}else J=F.reduce((L,O)=>{const _=O.patterns;return _?L.concat(_):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let j;for(j=L.length;j>0;j--){const Y=L.charCodeAt(j-1);if(Y===47||Y===92)break}O=L.substr(j)}const _=U.indexOf(O);return _!==-1?J[_]:null};B.basenames=U,B.patterns=J,B.allBasenames=U;const $=W.filter(L=>!L.basenames);return $.push(B),$}function H(W,A){return(0,S.equals)(W,A,(F,U)=>typeof F=="string"&&typeof U=="string"?F===U:typeof F!="string"&&typeof U!="string"?F.base===U.base&&F.pattern===U.pattern:!1)}e.patternsEquals=H}),define(te[35],ie([0,1,24,30,9,4,16,26]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function u(n,r){const{os:s,tildify:l,relative:a}=r;if(a){const T=p(n,a,s);if(typeof T=="string")return T}let I=n.fsPath;if(s===1&&!R.isWindows?I=I.replace(/\//g,"\\"):s!==1&&R.isWindows&&(I=I.replace(/\\/g,"/")),s!==1&&l?.userHome){const T=l.userHome.fsPath;let N;n.scheme!==l.userHome.scheme&&n.path.startsWith(k.posix.sep)?N=l.userHome.with({path:n.path}).fsPath:N=n.fsPath,I=E(N,T,s)}return(s===1?k.win32:k.posix).normalize(C(I,s===1))}e.getPathLabel=u;function p(n,r,s){const l=s===1?k.win32:k.posix,a=s===3?D.extUri:D.extUriIgnorePathCase,I=r.getWorkspace(),M=(0,S.firstOrDefault)(I.folders);if(!M)return;n.scheme!==M.uri.scheme&&n.path.startsWith(k.posix.sep)&&(n=M.uri.with({path:n.path}));const T=r.getWorkspaceFolder(n);if(!T)return;let N;if(a.isEqual(T.uri,n)?N="":N=a.relativePath(T.uri,n)??"",N&&(N=l.normalize(N)),I.folders.length>1&&!r.noPrefix){const X=T.name?T.name:a.basenameOrAuthority(T.uri);N=N?`${X} \u2022 ${N}`:X}return N}function C(n,r=R.isWindows){return(0,t.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=C;let y=Object.create(null);function E(n,r,s=R.OS){if(s===1||!n||!r)return n;let l=y.original===r?y.normalized:void 0;l||(l=r,R.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,b.rtrim)(l,k.posix.sep)}${k.posix.sep}`,y={original:r,normalized:l});let a=n;return R.isWindows&&(a=(0,t.toSlashes)(a)),(s===3?a.startsWith(l):(0,b.startsWithIgnoreCase)(a,l))?`~/${a.substr(l.length)}`:n}e.tildify=E;function h(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=h;const f="\u2026",P="\\\\",w="~";function m(n,r=k.sep){const s=new Array(n.length);let l=!1;for(let a=0;a<n.length;a++){const I=n[a];if(I===""){s[a]=`.${r}`;continue}if(!I){s[a]=I;continue}l=!0;let M="",T=I;T.indexOf(P)===0?(M=T.substr(0,T.indexOf(P)+P.length),T=T.substr(T.indexOf(P)+P.length)):T.indexOf(r)===0?(M=T.substr(0,T.indexOf(r)+r.length),T=T.substr(T.indexOf(r)+r.length)):T.indexOf(w)===0&&(M=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length));const N=T.split(r);for(let X=1;l&&X<=N.length;X++)for(let ae=N.length-X;l&&ae>=0;ae--){l=!1;let Q=N.slice(ae,ae+X).join(r);for(let G=0;!l&&G<n.length;G++)if(G!==a&&n[G]&&n[G].indexOf(Q)>-1){const Z=ae+X===N.length,se=ae>0&&n[G].indexOf(r)>-1?r+Q:Q,he=n[G].endsWith(se);l=!Z||he}if(!l){let G="";(N[0].endsWith(":")||M!=="")&&(ae===1&&(ae=0,X++,Q=N[0]+r+Q),ae>0&&(G=N[0]+r),G=M+G),ae>0&&(G=G+f+r),G=G+Q,ae+X<N.length&&(G=G+r+f),s[a]=G}}l&&(s[a]=I)}return s}e.shorten=m;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function d(n,r=Object.create(null)){const s=[];let l=!1,a="";for(const I of n)if(I==="$"||l&&I==="{")a&&s.push({value:a,type:v.TEXT}),a="",l=!0;else if(I==="}"&&l){const M=r[a];if(typeof M=="string")M.length&&s.push({value:M,type:v.VARIABLE});else if(M){const T=s[s.length-1];(!T||T.type!==v.SEPARATOR)&&s.push({value:M.label,type:v.SEPARATOR})}a="",l=!1}else a+=I;return a&&!l&&s.push({value:a,type:v.TEXT}),s.filter((I,M)=>{if(I.type===v.SEPARATOR){const T=s[M-1],N=s[M+1];return[T,N].every(X=>X&&(X.type===v.VARIABLE||X.type===v.TEXT)&&X.value.length>0)}return!0}).map(I=>I.value).join("")}e.template=d;function g(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function c(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(n){const r=n.indexOf("/")!==-1?k.posix:k.win32,s=r.basename(n),l=r.dirname(n);return s.length?{name:s,parentPath:l}:{name:l,parentPath:""}}e.splitName=o}),define(te[140],ie([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(C){return C.toJSON()}class k{constructor(y){this._uriTransformer=y}transformIncoming(y){const E=this._uriTransformer.transformIncoming(y);return E===y?y:t(S.URI.from(E))}transformOutgoing(y){const E=this._uriTransformer.transformOutgoing(y);return E===y?y:t(S.URI.from(E))}transformOutgoingURI(y){const E=this._uriTransformer.transformOutgoing(y);return E===y?y:S.URI.from(E)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,y,E){if(!C||E>200)return null;if(typeof C=="object"){if(C instanceof S.URI)return y.transformOutgoing(C);for(const h in C)if(Object.hasOwnProperty.call(C,h)){const f=R(C[h],y,E+1);f!==null&&(C[h]=f)}}return null}function D(C,y){const E=R(C,y,0);return E===null?C:E}e.transformOutgoingURIs=D;function b(C,y,E,h){if(!C||h>200)return null;if(typeof C=="object"){if(C.$mid===1)return E?S.URI.revive(y.transformIncoming(C)):y.transformIncoming(C);for(const f in C)if(Object.hasOwnProperty.call(C,f)){const P=b(C[f],y,E,h+1);P!==null&&(C[f]=P)}}return null}function u(C,y){const E=b(C,y,!1,0);return E===null?C:E}e.transformIncomingURIs=u;function p(C,y){const E=b(C,y,!0,0);return E===null?C:E}e.transformAndReviveIncomingURIs=p}),define(te[81],ie([0,1,25,17,31,29,128]),function(z,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,y=0;const E=(0,S.networkInterfaces)();for(const h in E){const f=E[h];if(f)for(const{mac:P,internal:w}of f)w||(y+=1,this._isVirtualMachineMacAddress(P.toUpperCase())&&(C+=1))}this._value=y>0?C/y:0}return this._value}};let b;async function u(){return b||(b=(async()=>await p()||R.generateUuid())()),b}e.getMachineId=u;async function p(){try{const C=await new Promise((E,h)=>{z(["crypto"],E,h)}),y=(0,D.getMac)();return C.createHash("sha256").update(y,"utf8").digest("hex")}catch(C){t.onUnexpectedError(C);return}}}),define(te[21],ie([0,1,40,25,141,8,30,80,9,4,16,7]),function(z,e,S,t,k,R,D,b,u,p,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(se,he=E.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return he===E.UNLINK?P(se):f(se)}async function f(se){try{const he=(0,D.randomPath)((0,t.tmpdir)());try{await S.promises.rename(se,he)}catch(V){return V.code==="ENOENT"?void 0:P(se)}P(he).catch(V=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function P(se){return(0,k.promisify)(S.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function w(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function m(se,he){return g(await(he?v(se):(0,k.promisify)(S.readdir)(se)))}async function v(se){try{return await(0,k.promisify)(S.readdir)(se,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const he=[],V=await m(se);for(const H of V){let W=!1,A=!1,F=!1;try{const U=await e.Promises.lstat((0,u.join)(se,H));W=U.isFile(),A=U.isDirectory(),F=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}he.push({name:H,isFile:()=>W,isDirectory:()=>A,isSymbolicLink:()=>F})}return he}function d(se){return g(S.readdirSync(se))}e.readdirSync=d;function g(se){return se.map(he=>typeof he=="string"?p.isMacintosh?(0,b.normalizeNFC)(he):he:(he.name=p.isMacintosh?(0,b.normalizeNFC)(he.name):he.name,he))}async function c(se){const he=await m(se),V=[];for(const H of he)await o.existsDirectory((0,u.join)(se,H))&&V.push(H);return V}function i(se,he=1e3){return new Promise(V=>{let H=!1;const W=setInterval(()=>{H||(H=!0,S.access(se,A=>{H=!1,A&&(clearInterval(W),V(void 0))}))},he)})}e.whenDeleted=i;var o;(function(se){async function he(W){let A;try{if(A=await e.Promises.lstat(W),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(p.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw U}throw F}}se.stat=he;async function V(W){try{const{stat:A,symbolicLink:F}=await se.stat(W);return A.isFile()&&F?.dangling!==!0}catch{}return!1}se.existsFile=V;async function H(W){try{const{stat:A,symbolicLink:F}=await se.stat(W);return A.isDirectory()&&F?.dangling!==!0}catch{}return!1}se.existsDirectory=H})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function r(se,he,V){return n.queueFor(y.URI.file(se),C.extUriBiasedIgnorePathCase).queue(()=>{const H=M(V);return new Promise((W,A)=>a(se,he,H,F=>F?A(F):W()))})}let s=!0;function l(se){s=se}e.configureFlushOnWrite=l;function a(se,he,V,H){if(!s)return S.writeFile(se,he,{mode:V.mode,flag:V.flag},H);S.open(se,V.flag,V.mode,(W,A)=>{if(W)return H(W);S.writeFile(A,he,F=>{if(F)return S.close(A,()=>H(F));S.fdatasync(A,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),l(!1)),S.close(A,J=>H(J))))})})}function I(se,he,V){const H=M(V);if(!s)return S.writeFileSync(se,he,{mode:H.mode,flag:H.flag});const W=S.openSync(se,H.flag,H.mode);try{S.writeFileSync(W,he);try{S.fdatasyncSync(W)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),l(!1)}}finally{S.closeSync(W)}}e.writeFileSync=I;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,he){if(se!==he)try{await e.Promises.rename(se,he)}catch(V){if(se.toLowerCase()!==he.toLowerCase()&&V.code==="EXDEV"||se.endsWith("."))await N(se,he,{preserveSymlinks:!1}),await h(se,E.MOVE);else throw V}}async function N(se,he,V){return ae(se,he,{root:{source:se,target:he},options:V,handledSourcePaths:new Set})}const X=511;async function ae(se,he,V){if(V.handledSourcePaths.has(se))return;V.handledSourcePaths.add(se);const{stat:H,symbolicLink:W}=await o.stat(se);if(W){if(V.options.preserveSymlinks)try{return await Z(se,he,V)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(W.dangling)return}return H.isDirectory()?Q(se,he,H.mode&X,V):G(se,he,H.mode&X)}async function Q(se,he,V,H){await e.Promises.mkdir(he,{recursive:!0,mode:V});const W=await m(se);for(const A of W)await ae((0,u.join)(se,A),(0,u.join)(he,A),H)}async function G(se,he,V){await e.Promises.copyFile(se,he),await e.Promises.chmod(he,V)}async function Z(se,he,V){let H=await e.Promises.readlink(se);(0,D.isEqualOrParent)(H,V.root.source,!p.isLinux)&&(H=(0,u.join)(V.root.target,H.substr(V.root.source.length+1))),await e.Promises.symlink(H,he)}e.Promises=new class{get access(){return(0,k.promisify)(S.access)}get stat(){return(0,k.promisify)(S.stat)}get lstat(){return(0,k.promisify)(S.lstat)}get utimes(){return(0,k.promisify)(S.utimes)}get read(){return(se,he,V,H,W)=>new Promise((A,F)=>{S.read(se,he,V,H,W,(U,J,B)=>U?F(U):A({bytesRead:J,buffer:B}))})}get readFile(){return(0,k.promisify)(S.readFile)}get write(){return(se,he,V,H,W)=>new Promise((A,F)=>{S.write(se,he,V,H,W,(U,J,B)=>U?F(U):A({bytesWritten:J,buffer:B}))})}get appendFile(){return(0,k.promisify)(S.appendFile)}get fdatasync(){return(0,k.promisify)(S.fdatasync)}get truncate(){return(0,k.promisify)(S.truncate)}get rename(){return(0,k.promisify)(S.rename)}get copyFile(){return(0,k.promisify)(S.copyFile)}get open(){return(0,k.promisify)(S.open)}get close(){return(0,k.promisify)(S.close)}get symlink(){return(0,k.promisify)(S.symlink)}get readlink(){return(0,k.promisify)(S.readlink)}get chmod(){return(0,k.promisify)(S.chmod)}get mkdir(){return(0,k.promisify)(S.mkdir)}get unlink(){return(0,k.promisify)(S.unlink)}get rmdir(){return(0,k.promisify)(S.rmdir)}get realpath(){return(0,k.promisify)(S.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return c}get writeFile(){return r}get rm(){return h}get move(){return T}get copy(){return N}}}),define(te[99],ie([0,1,40,9,4,26,21]),function(z,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(E){if(k.isLinux)return E;const h=(0,t.dirname)(E);if(E===h)return E;const f=((0,t.basename)(E)||E).toLowerCase();try{const w=(0,D.readdirSync)(h).filter(m=>m.toLowerCase()===f);if(w.length===1){const m=b(h);if(m)return(0,t.join)(m,w[0])}else if(w.length>1){const m=w.indexOf(f);if(m>=0){const v=b(h);if(v)return(0,t.join)(v,w[m])}}}catch{}return null}e.realcaseSync=b;async function u(E){if(k.isLinux)return E;const h=(0,t.dirname)(E);if(E===h)return E;const f=((0,t.basename)(E)||E).toLowerCase();try{const w=(await D.Promises.readdir(h)).filter(m=>m.toLowerCase()===f);if(w.length===1){const m=await u(h);if(m)return(0,t.join)(m,w[0])}else if(w.length>1){const m=w.indexOf(f);if(m>=0){const v=await u(h);if(v)return(0,t.join)(v,w[m])}}}catch{}return null}e.realcase=u;async function p(E){try{return await D.Promises.realpath(E)}catch{const f=y(E);return await D.Promises.access(f,S.constants.R_OK),f}}e.realpath=p;function C(E){try{return S.realpathSync(E)}catch{const f=y(E);return S.accessSync(f,S.constants.R_OK),f}}e.realpathSync=C;function y(E){return(0,R.rtrim)((0,t.normalize)(E),t.sep)}}),define(te[142],ie([0,1,25,9,21]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var u;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(u||(u={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class y{constructor(c,i,o){this.exePath=c,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:g=!1}={}){return g?p===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:g=!1,findPreview:c=!1}={}){const i=E({useAlternateBitness:g});if(!i)return null;const o=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let n=-1,r=null;for(const a of await k.Promises.readdir(o)){let I=-1;if(c){const T=a.indexOf("-");if(T<0)continue;const N=a.substring(0,T);if(!R.test(N)||a.substring(T+1)!=="preview")continue;I=parseInt(N,10)}else{if(!R.test(a))continue;I=parseInt(a,10)}if(I<=n)continue;const M=t.join(o,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(r=M,n=I)}if(!r)return null;const s=i.includes("x86")?" (x86)":"",l=c?" Preview":"";return new y(r,`PowerShell${l}${s}`,!0)}async function f({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=g?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(c))if(i.test(n)){const r=t.join(c,n,"pwsh.exe");return new y(r,o)}return null}function P(){const g=t.join(S.homedir(),".dotnet","tools","pwsh.exe");return new y(g,".NET Core PowerShell Global Tool")}function w(){const g=t.join(process.env.windir,p===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(g,"Windows PowerShell",!0)}async function*m(){let g=await h();g&&(yield g),g=await h({useAlternateBitness:!0}),g&&(yield g),g=await f(),g&&(yield g),g=P(),g&&(yield g),g=await h({findPreview:!0}),g&&(yield g),g=await f({findPreview:!0}),g&&(yield g),g=await h({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=w(),g&&(yield g)}async function*v(){for await(const g of m())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=v;async function d(){for await(const g of v())return g;return null}e.getFirstAvailablePowerShellInstallation=d}),define(te[82],ie([0,1,9,4,34,78,12,21]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function u(y=k.env){return y.comspec||"cmd.exe"}e.getWindowsShell=u;function p(y){let E=[],h=!1;const f=function(P){if(h){E.push(P);return}(!y.send(P,m=>{if(m&&console.error(m),h=!1,E.length>0){const v=E.slice(0);E=[],v.forEach(d=>f(d))}})||t.isWindows)&&(h=!0)};return{send:f}}e.createQueuedSender=p;var C;(function(y){async function E(h,f,P){if(S.isAbsolute(h))return h;if(f===void 0&&(f=k.cwd()),S.dirname(h)!=="."||(P===void 0&&D.isString(k.env.PATH)&&(P=k.env.PATH.split(S.delimiter)),P===void 0||P.length===0))return S.join(f,h);async function m(v){if(await b.Promises.exists(v)){let d;try{d=await b.Promises.stat(v)}catch(g){g.message.startsWith("EACCES")&&(d=await b.Promises.lstat(v))}return d?!d.isDirectory():!1}return!1}for(const v of P){let d;if(S.isAbsolute(v)?d=S.join(v,h):d=S.join(f,v,h),await m(d))return d;let g=d+".com";if(await m(g)||(g=d+".exe",await m(g)))return g}return S.join(f,h)}y.findExecutable=E})(C=e.win32||(e.win32={}))}),define(te[100],ie([0,1,45,13]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((b,u)=>{let p;const C=new Map;function y(h,f,P,w,m){const v=C.get(f);if(h===D||v){const d={name:E(P),cmd:P,pid:h,ppid:f,load:w,mem:m};C.set(h,d),h===D&&(p=d),v&&(v.children||(v.children=[]),v.children.push(d),v.children.length>1&&(v.children=v.children.sort((g,c)=>g.pid-c.pid)))}}function E(h){const f=/--vscode-window-kind=shared-process/,P=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,d=/--crashes-directory/,g=/\\pipe\\winpty-control/,c=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(d.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-process";if(c.exec(h))return"console-window-host (Windows internal process)";let o=i.exec(h);if(o&&o.length===2){if(o[1]==="renderer")return f.exec(h)?"shared-process":P.exec(h)?"issue-reporter":w.exec(h)?"process-explorer":"window";if(o[1]==="utility"){if(m.exec(h))return"utility-network-service";if(v.exec(h))return"extension-host"}return o[1]}const n=/[a-zA-Z-]+\.js/g;let r="";do o=n.exec(h),o&&(r+=o+" ");while(o);return r&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${r}`:h}if(process.platform==="win32"){const h=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,P)=>{z(["windows-process-tree"],f,P)}).then(f=>{f.getProcessList(D,P=>{if(!P){u(new Error(`Root process ${D} not found`));return}f.getProcessCpuUsage(P,w=>{const m=new Map;w.forEach(v=>{const d=h(v.commandLine||"");m.set(v.pid,{name:E(d),cmd:d,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),p=m.get(D),p?(m.forEach(v=>{const d=m.get(v.ppid);d&&(d.children||(d.children=[]),d.children.push(v))}),m.forEach(v=>{v.children&&(v.children=v.children.sort((d,g)=>d.pid-g.pid))}),b(p)):u(new Error(`Root process ${D} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let h=function(){let f=[p];const P=[];for(;f.length;){const m=f.shift();m&&(P.push(m.pid),m.children&&(f=f.concat(m.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);w+=" "+P.join(" "),(0,S.exec)(w,{},(m,v,d)=>{if(m||d)u(m||new Error(d.toString()));else{const g=v.toString().split(`
`);for(let c=0;c<P.length;c++){const i=C.get(P[c]);i.load=parseFloat(g[c])}if(!p){u(new Error(`Root process ${D} not found`));return}b(p)}})};(0,S.exec)("which ps",{},(f,P,w)=>{if(f||w)if(process.platform!=="linux")u(f||new Error(w.toString()));else{const m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,S.exec)(m,{},(v,d,g)=>{v||g?u(v||new Error(g.toString())):(R(d,y),h())})}else{const m=P.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${m} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,g,c)=>{d||c&&!c.includes("screen size is bogus")?u(d||new Error(c.toString())):(R(g,y),process.platform==="linux"?h():p?b(p):u(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,b){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=D.toString().split(`
`);for(const C of p){const y=u.exec(C.trim());y&&y.length===6&&b(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(te[143],ie([0,1,25,4,142,82]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(h,f){return h===1?t.isWindows?y():R.getWindowsShell(f):p(h,f)}e.getSystemShell=D;function b(h,f){return h===1?t.isWindows?E(f):R.getWindowsShell(f):p(h,f)}e.getSystemShellSync=b;let u=null;function p(h,f){if(t.isLinux&&h===2||t.isMacintosh&&h===3)return"/bin/bash";if(!u){let P;if(t.isWindows)P="/bin/bash";else{if(P=f.SHELL,!P)try{P=(0,S.userInfo)().shell}catch{}P||(P="sh"),P==="/bin/false"&&(P="/bin/bash")}u=P}return u}let C=null;async function y(){return C||(C=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),C}function E(h){if(C)return C;const f=t.isWindows&&parseFloat((0,S.release)())>=10,P=h.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${h.windir}\\${P?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?w:R.getWindowsShell(h)}});var ve=this&&this.__decorate||function(z,e,S,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,S):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,S,t);else for(var b=z.length-1;b>=0;b--)(D=z[b])&&(R=(k<3?D(R):k>3?D(e,S,R):D(e,S))||R);return k>3&&R&&Object.defineProperty(e,S,R),R};define(te[46],ie([0,1,24,8,18,23,53,17,3,2,67,26,12]),function(z,e,S,t,k,R,D,b,u,p,C,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var h;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(h=e.RequestType||(e.RequestType={}));function f(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var P;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(P=e.ResponseType||(e.ResponseType={}));function w(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(m||(m={}));class v{constructor(A){this.buffer=A,this.pos=0}read(A){const F=this.buffer.slice(this.pos,this.pos+A);return this.pos+=F.byteLength,F}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var g;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(g||(g={}));function c(W){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(W,0),A}function i(W){return W.read(4).readUInt32BE(0)}function o(W){const A=k.VSBuffer.alloc(1);return A.writeUInt8(W,0),A}const n={Undefined:o(g.Undefined),String:o(g.String),Buffer:o(g.Buffer),VSBuffer:o(g.VSBuffer),Array:o(g.Array),Object:o(g.Object)},r=typeof Buffer<"u";function s(W,A){if(typeof A>"u")W.write(n.Undefined);else if(typeof A=="string"){const F=k.VSBuffer.fromString(A);W.write(n.String),W.write(c(F.byteLength)),W.write(F)}else if(r&&Buffer.isBuffer(A)){const F=k.VSBuffer.wrap(A);W.write(n.Buffer),W.write(c(F.byteLength)),W.write(F)}else if(A instanceof k.VSBuffer)W.write(n.VSBuffer),W.write(c(A.byteLength)),W.write(A);else if(Array.isArray(A)){W.write(n.Array),W.write(c(A.length));for(const F of A)s(W,F)}else{const F=k.VSBuffer.fromString(JSON.stringify(A));W.write(n.Object),W.write(c(F.byteLength)),W.write(F)}}function l(W){switch(W.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return W.read(i(W)).toString();case g.Buffer:return W.read(i(W)).buffer;case g.VSBuffer:return W.read(i(W));case g.Array:{const F=i(W),U=[];for(let J=0;J<F;J++)U.push(l(W));return U}case g.Object:return JSON.parse(W.read(i(W)).toString())}}class a{constructor(A,F,U=null,J=1e3){this.protocol=A,this.ctx=F,this.logger=U,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,F){this.channels.set(A,F),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const F=this.send([A.type]);this.logger?.logOutgoing(F,0,1,w(A.type));return}case 201:case 202:case 204:case 203:{const F=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(F,A.id,1,w(A.type),A.data);return}}}send(A,F=void 0){const U=new d;return s(U,A),s(U,F),this.sendBuffer(U.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const F=new v(A),U=l(F),J=l(F),B=U[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,U[1],1,`${f(B)}: ${U[2]}.${U[3]}`,J),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:J});case 102:return this.logger?.logIncoming(A.byteLength,U[1],1,`${f(B)}: ${U[2]}.${U[3]}`,J),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:J});case 101:return this.logger?.logIncoming(A.byteLength,U[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger?.logIncoming(A.byteLength,U[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise(A){const F=this.channels.get(A.channelName);if(!F){this.collectPendingRequest(A);return}const U=new R.CancellationTokenSource;let J;try{J=F.call(this.ctx,A.name,A.arg,U.token)}catch(L){J=Promise.reject(L)}const B=A.id;J.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const $=(0,p.toDisposable)(()=>U.cancel());this.activeRequests.set(A.id,$)}onEventListen(A){const F=this.channels.get(A.channelName);if(!F){this.collectPendingRequest(A);return}const U=A.id,B=F.listen(this.ctx,A.name,A.arg)($=>this.sendResponse({id:U,data:$,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const F=this.activeRequests.get(A.id);F&&(F.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let F=this.pendingRequests.get(A.channelName);F||(F=[],this.pendingRequests.set(A.channelName,F));const U=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:A,timeoutTimer:U})}flushPendingRequests(A){const F=this.pendingRequests.get(A);if(F){for(const U of F)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var I;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,F=null){this.protocol=A,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=F}getChannel(A){const F=this;return{call(U,J,B){return F.isDisposed?Promise.reject(new b.CancellationError):F.requestPromise(A,U,J,B)},listen(U,J){return F.isDisposed?u.Event.None:F.requestEvent(A,U,J)}}}requestPromise(A,F,U,J=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:F,arg:U};if(J.isCancellationRequested)return Promise.reject(new b.CancellationError);let O;return new Promise((j,Y)=>{if(J.isCancellationRequested)return Y(new b.CancellationError);const oe=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(B),j(ge.data);break;case 202:{this.handlers.delete(B);const De=new Error(ge.data.message);De.stack=ge.data.stack,De.name=ge.data.name,Y(De);break}case 203:this.handlers.delete(B),Y(ge.data);break}};this.handlers.set(B,ce),this.sendRequest(L)};let q=null;this.state===m.Idle?oe():(q=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),q.then(()=>{q=null,oe()}));const re=()=>{q?(q.cancel(),q=null):this.sendRequest({id:B,type:101}),Y(new b.CancellationError)},ne=J.onCancellationRequested(re);O=(0,p.combinedDisposable)((0,p.toDisposable)(re),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,F,U){const J=this.lastRequestId++,$={id:J,type:102,channelName:A,name:F,arg:U};let L=null;const O=new u.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(j=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest($)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:J,type:103}))}}),_=j=>O.fire(j.data);return this.handlers.set(J,_),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const F=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(F,A.id,0,`${f(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const F=this.send([A.type,A.id]);this.logger?.logOutgoing(F,A.id,0,f(A.type));return}}}send(A,F=void 0){const U=new d;return s(U,A),s(U,F),this.sendBuffer(U.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const F=new v(A),U=l(F),J=l(F),B=U[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,w(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,U[1],0,w(B),J),this.onResponse({type:U[0],id:U[1],data:J})}}onResponse(A){if(A.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{get connections(){const A=[];return this._connections.forEach(F=>A.push(F)),A}constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:F,onDidClientDisconnect:U})=>{u.Event.once(F.onMessage)(B=>{const $=new v(B),L=l($),O=new a(F,L),_=new M(F);this.channels.forEach((Y,oe)=>O.registerChannel(oe,Y));const j={channelServer:O,channelClient:_,ctx:L};this._connections.add(j),this._onDidAddConnection.fire(j),U(()=>{O.dispose(),_.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}getChannel(A,F){const U=this;return{call(J,B,$){let L;if((0,E.isFunction)(F)){const _=(0,S.getRandomElement)(U.connections.filter(F));L=_?Promise.resolve(_):u.Event.toPromise(u.Event.filter(U.onDidAddConnection,F))}else L=F.routeCall(U,J,B);const O=L.then(_=>_.channelClient.getChannel(A));return X(O).call(J,B,$)},listen(J,B){if((0,E.isFunction)(F))return U.getMulticastEvent(A,F,J,B);const $=F.routeEvent(U,J,B).then(L=>L.channelClient.getChannel(A));return X($).listen(J,B)}}}getMulticastEvent(A,F,U,J){const B=this;let $=new p.DisposableStore;const L=new u.Emitter({onFirstListenerAdd:()=>{$=new p.DisposableStore;const O=new u.EventMultiplexer,_=new Map,j=oe=>{const re=oe.channelClient.getChannel(A).listen(U,J),ne=O.add(re);_.set(oe,ne)},Y=oe=>{const q=_.get(oe);!q||(q.dispose(),_.delete(oe))};B.connections.filter(F).forEach(j),u.Event.filter(B.onDidAddConnection,F)(j,void 0,$),B.onDidRemoveConnection(Y,void 0,$),O.event(L.fire,L,$),$.add(O)},onLastListenerRemove:()=>{$.dispose()}});return L.event}registerChannel(A,F){this.channels.set(A,F),this._connections.forEach(U=>{U.channelServer.registerChannel(A,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class N{constructor(A,F,U=null){const J=new d;s(J,F),A.send(J.buffer),this.channelClient=new M(A,U),this.channelServer=new a(A,F,U)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,F){this.channelServer.registerChannel(A,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function X(W){return{call(A,F,U){return W.then(J=>J.call(A,F,U))},listen(A,F){const U=new u.Relay;return W.then(J=>U.input=J.listen(A,F)),U.event}}}e.getDelayedChannel=X;function ae(W){let A=!1;return{call(F,U,J){return A?W.call(F,U,J):(0,t.timeout)(0).then(()=>A=!0).then(()=>W.call(F,U,J))},listen(F,U){if(A)return W.listen(F,U);const J=new u.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>J.input=W.listen(F,U)),J.event}}}e.getNextTickChannel=ae;class Q{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const F of A.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await u.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=Q;var G;(function(W){function A(B,$){const L=B,O=$&&$.disableMarshalling,_=new Map;for(const j in L)U(j)&&_.set(j,u.Event.buffer(L[j],!0));return new class{listen(j,Y,oe){const q=_.get(Y);if(q)return q;if(J(Y)){const re=L[Y];if(typeof re=="function")return re.call(L,oe)}throw new Error(`Event not found: ${Y}`)}call(j,Y,oe){const q=L[Y];if(typeof q=="function"){if(!O&&Array.isArray(oe))for(let re=0;re<oe.length;re++)oe[re]=(0,C.revive)(oe[re]);return q.apply(L,oe)}throw new Error(`Method not found: ${Y}`)}}}W.fromService=A;function F(B,$){const L=$&&$.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return $?.properties?.has(_)?$.properties.get(_):J(_)?function(j){return B.listen(_,j)}:U(_)?B.listen(_):async function(...j){let Y;$&&!(0,E.isUndefinedOrNull)($.context)?Y=[$.context,...j]:Y=j;const oe=await B.call(_,Y);return L?oe:(0,C.revive)(oe)};throw new Error(`Property not found: ${String(_)}`)}})}W.toService=F;function U(B){return B[0]==="o"&&B[1]==="n"&&y.isUpperAsciiLetter(B.charCodeAt(2))}function J(B){return/^onDynamic/.test(B)&&y.isUpperAsciiLetter(B.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const A=W.toString();if(A!=="[object Object]")return A}return W}function he(W){return Array.isArray(W)?W.map(se):se(W)}function V(W,A,F,U,J,B,$){$=he($);const L=Z[J],O=L[U%L.length];let _=[`%c[${W}]%c[${String(A).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(_=_.concat($),_.push(")")):_.push($),console.log.apply(console,_)}e.logWithColors=V;class H{constructor(A,F){this._outgoingPrefix=A,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,F,U,J,B){this._totalOutgoing+=A,V(this._outgoingPrefix,this._totalOutgoing,A,F,U,J,B)}logIncoming(A,F,U,J,B){this._totalIncoming+=A,V(this._incomingPrefix,this._totalIncoming,A,F,U,J,B)}}e.IPCLogger=H}),define(te[144],ie([0,1,18,3,46]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(u){this.port=u,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",p=>S.VSBuffer.wrap(p.data)),u.start()}send(u){this.port.postMessage(u.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(u,p){const C=new R(u);super(C,p),this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=D}),define(te[101],ie([0,1,18,3,2,46]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let l=0;function a(M,T){if(!s.has(M)){const N=String(++l);s.set(M,N)}return s.get(M)}function I(M,T,N,X){if(!r.enableDiagnostics)return;const ae=a(M,T);if(X instanceof S.VSBuffer||X instanceof Uint8Array||X instanceof ArrayBuffer||ArrayBuffer.isView(X)){const Q=S.VSBuffer.alloc(X.byteLength);Q.set(X),r.records.push({timestamp:Date.now(),id:ae,label:T,type:N,buff:Q})}else r.records.push({timestamp:Date.now(),id:ae,label:T,type:N,data:X})}r.traceSocketEvent=I})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var u;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function C(){return p||(p=S.VSBuffer.alloc(0)),p}class y{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return C();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const a=S.VSBuffer.alloc(s);let I=0,M=0;for(;s>0;){const T=this._chunks[M];if(T.byteLength>s){const N=T.slice(0,s);a.set(N,I),I+=s,l&&(this._chunks[M]=T.slice(s),this._totalLength-=s),s-=s}else a.set(T,I),I+=T.byteLength,l?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,s-=T.byteLength}return a}}e.ChunkStream=y;var E;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(E||(E={}));function h(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class P{constructor(s,l,a,I){this.type=s,this.id=l,this.ack=a,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:h(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,I=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new P(a,I,M,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=S.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:h(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(l,s.data)}_bufferAdd(s,l){const a=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,a}_bufferTake(){const s=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class v extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new P(1,0,0,s))}}e.Protocol=v;class d extends R.IPCClient{static fromSocket(s,l){return new d(new v(s),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,l,a=null){super(s,l,a),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=d;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class c{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,l=this._first;for(;l;)l=l.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let l=0,a=this._first;for(;a;)s[l++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new c(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<o._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=o._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),l=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let I=0;I<o._HISTORY_LENGTH;I++)s-this.lastRuns[I]<=l&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,l=null,a=o.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(I=>this._receiveMessage(I))),this._socketDisposables.push(this._socket.onClose(I=>this._onSocketClose.fire(I))),l&&this._socketReader.acceptChunk(l),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new P(5,0,0,C());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new P(7,0,0,C());this._socketWriter.write(s)}sendResume(){const s=new P(8,0,0,C());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new P(3,0,this._incomingAckId,C());this._socketWriter.write(s);const l=this._outgoingUnackMsg.toArray();for(let a=0,I=l.length;a<I;a++)this._socketWriter.write(l[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new P(6,0,0,C())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let a=0,I=l.length;a<I;a++)this._socketWriter.write(l[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new P(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const l=new P(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,I=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&a>=2e4&&I>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:a});return}const M=Math.max(2e4-l,2e4-a,2e4-I,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new P(3,0,this._incomingAckId,C());this._socketWriter.write(s)}_sendKeepAlive(){const s=new P(9,0,0,C());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(te[145],ie([0,1,41,18,3,2,46,130]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function u(C,y){const E=k.Event.fromNodeEventEmitter(S.validatedIpcMain,y,(f,P)=>({event:f,message:P})),h=k.Event.filter(E,({event:f})=>f.sender.id===C);return k.Event.map(h,({message:f})=>f&&t.VSBuffer.wrap(f))}class p extends D.IPCServer{static getOnDidClientConnect(){const y=k.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:hello",({sender:E})=>E);return k.Event.map(y,E=>{const h=E.id;p.Clients.get(h)?.dispose();const P=new k.Emitter;p.Clients.set(h,(0,R.toDisposable)(()=>P.fire()));const w=u(h,"vscode:message"),m=k.Event.any(k.Event.signal(u(h,"vscode:disconnect")),P.event);return{protocol:new b.Protocol(E,w),onDidClientDisconnect:m}})}constructor(){super(p.getOnDidClientConnect())}}e.Server=p,p.Clients=new Map}),define(te[102],ie([0,1,41,3,29,144]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(p,C){super({addEventListener:(y,E)=>p.addListener(y,E),removeEventListener:(y,E)=>p.removeListener(y,E),postMessage:y=>p.postMessage(y),start:()=>p.start(),close:()=>p.close()},C)}}e.Client=D;async function b(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=(0,k.generateUuid)();u.webContents.send("vscode:createMessageChannel",p);const C=t.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:createMessageChannelResult",(E,h)=>({nonce:h,port:E.ports[0]})),{port:y}=await t.Event.toPromise(t.Event.once(t.Event.filter(C,E=>E.nonce===p)));return y}e.connect=b}),define(te[146],ie([0,1,45,8,18,23,139,17,3,2,50,82,78,46]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends h.ChannelServer{constructor(m){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",v=>k.VSBuffer.wrap(Buffer.from(v,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=f;class P{constructor(m,v){this.modulePath=m,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new t.Delayer(d),this.child=null,this._client=null}getChannel(m){const v=this;return{call(d,g,c){return v.requestPromise(m,d,g,c)},listen(d,g){return v.requestEvent(m,d,g)}}}requestPromise(m,v,d,g=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(m),i=(0,t.createCancelablePromise)(r=>c.call(v,d,r)),o=g.onCancellationRequested(()=>i.cancel()),n=(0,p.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(m,v,d){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let g;const c=new u.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(m).listen(v,d)(c.fire,c),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,E.removeDangerousEnvVariables)(v.env),this.child=(0,S.fork)(this.modulePath,m,v);const d=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.options.serverName}`);return}d.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,i=s=>this.child&&this.child.connected&&c.send(s.buffer.toString("base64")),o=d.event,n={send:i,onMessage:o};this._client=new h.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(a=>(0,p.dispose)(a)),this.activeRequests.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:l})})}return this._client}getCachedChannel(m){let v=this.channels.get(m);return v||(v=this.client.getChannel(m),this.channels.set(m,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=P}),define(te[83],ie([0,1,18,17,3,2,9,4,29,46,101]),function(z,e,S,t,k,R,D,b,u,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class E{traceSocketEvent(a,I){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,I)}constructor(a,I=""){this._canWrite=!0,this.debugLabel=I,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener),this._closeListener=M=>{this.traceSocketEvent("close",{hadError:M}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const I=M=>{this.traceSocketEvent("read",M),a(S.VSBuffer.wrap(M))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(a){const I=M=>{a({type:0,hadError:M,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(a){const I=()=>{a()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,t.onUnexpectedError)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,t.onUnexpectedError)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=E;var h;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var f;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(f||(f={}));class P extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,I){this.socket.traceSocketEvent(a,I)}constructor(a,I,M,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new w(this,I,M,T,this._onData,(N,X)=>this._write(N,X))),this._register(this._flowManager.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,I){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let M=2;a.byteLength<126?M+=0:a.byteLength<2**16?M+=2:M+=8;const T=S.VSBuffer.alloc(M);if(I?T.writeUInt8(194,0):T.writeUInt8(130,0),a.byteLength<126)T.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){T.writeUInt8(126,1);let N=1;T.writeUInt8(a.byteLength>>>8&255,++N),T.writeUInt8(a.byteLength>>>0&255,++N)}else{T.writeUInt8(127,1);let N=1;T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(a.byteLength>>>24&255,++N),T.writeUInt8(a.byteLength>>>16&255,++N),T.writeUInt8(a.byteLength>>>8&255,++N),T.writeUInt8(a.byteLength>>>0&255,++N)}this.socket.write(S.VSBuffer.concat([T,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const I=this._incomingData.peek(this._state.readLen),M=I.readUInt8(0),T=(M&128)>>>7,N=(M&64)>>>6,X=I.readUInt8(1),ae=(X&128)>>>7,Q=X&127;this._state.state=2,this._state.readLen=2+(ae?4:0)+(Q===126?2:0)+(Q===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(N)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const I=this._incomingData.read(this._state.readLen),M=I.readUInt8(1),T=(M&128)>>>7;let N=M&127,X=1;N===126?N=I.readUInt8(++X)*2**8+I.readUInt8(++X):N===127&&(N=I.readUInt8(++X)*0+I.readUInt8(++X)*0+I.readUInt8(++X)*0+I.readUInt8(++X)*0+I.readUInt8(++X)*2**24+I.readUInt8(++X)*2**16+I.readUInt8(++X)*2**8+I.readUInt8(++X));let ae=0;T&&(ae=I.readUInt8(++X)*2**24+I.readUInt8(++X)*2**16+I.readUInt8(++X)*2**8+I.readUInt8(++X)),this._state.state=3,this._state.readLen=N,this._state.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const I=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),d(I,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(I,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class w extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:S.VSBuffer.alloc(0)}constructor(a,I,M,T,N,X){super(),this._tracer=a,this._onData=N,this._writeFn=X,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,I?(this._zlibInflateStream=this._register(new m(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ae=>this._onError.fire(ae))),this._register(this._zlibDeflateStream.onError(ae=>this._onError.fire(ae)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const I=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(I,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,I){return new Promise((M,T)=>{a.write(I),a.flush(N=>M(N))})}acceptFrame(a,I,M){this._readQueue.push({data:a,isCompressed:I,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const I=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(I)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,I,M){return new Promise((T,N)=>{a.write(I),M&&a.write(S.VSBuffer.fromByteArray([0,0,255,255])),a.flush(X=>T(X))})}}class m extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.concat(this._recordedInflateBytes):S.VSBuffer.alloc(0)}constructor(a,I,M,T){super(),this._tracer=a,this._recordInflateBytes=I,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=y().zlib.createInflateRaw(T),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(S.VSBuffer.wrap(N))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const I=S.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(I)})}}class v extends R.Disposable{constructor(a,I){super(),this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=y().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(S.VSBuffer.wrap(M))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let I=S.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,I=I.slice(0,I.byteLength-4),a(I)})}}function d(l,a){if(a===0)return;const I=l.byteLength>>>2;for(let Q=0;Q<I;Q++){const G=l.readUInt32BE(Q*4);l.writeUInt32BE(G^a,Q*4)}const M=I*4,T=l.byteLength-M,N=a>>>24&255,X=a>>>16&255,ae=a>>>8&255;T>=1&&l.writeUInt8(l.readUInt8(M)^N,M),T>=2&&l.writeUInt8(l.readUInt8(M+1)^X,M+1),T>=3&&l.writeUInt8(l.readUInt8(M+2)^ae,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const g={[2]:107,[1]:103};function c(){const l=(0,u.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):a=(0,D.join)(y().os.tmpdir(),`vscode-ipc-${l}.sock`),o(a),a}e.createRandomIPCHandle=c;function i(l,a,I){const M=y().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${I}-${a}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${I}-${a}.sock`):T=(0,D.join)(l,`${I}-${a}.sock`),o(T),T}e.createStaticIPCHandle=i;function o(l){const a=g[b.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class n extends p.IPCServer{static toClientConnectionEvent(a){const I=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(I,M=>({protocol:new C.Protocol(new E(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}constructor(a){super(n.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function r(l){return new Promise((a,I)=>{const M=y().net.createServer();M.on("error",I),M.listen(l,()=>{M.removeListener("error",I),a(new n(M))})})}e.serve=r;function s(l,a){return new Promise((I,M)=>{const T=y().net.createConnection(l,()=>{T.removeListener("error",M),I(C.Client.fromSocket(new E(T,`ipc-client${a}`),a))});T.once("error",M)})}e.connect=s}),define(te[103],ie([0,1,8,3,2,12]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function b(y){const E=y;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var u;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(u=e.StorageState||(e.StorageState={}));class p extends k.Disposable{constructor(E,h=Object.create(null)){super(),this.database=E,this.options=h,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=new S.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((h,f)=>this.accept(f,h)),E.deleted?.forEach(h=>this.accept(h,void 0))}accept(E,h){if(this.state===u.Closed)return;let f=!1;(0,R.isUndefinedOrNull)(h)?f=this.cache.delete(E):this.cache.get(E)!==h&&(this.cache.set(E,h),f=!0),f&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,h){const f=this.cache.get(E);return(0,R.isUndefinedOrNull)(f)?h:f}getBoolean(E,h){const f=this.get(E);return(0,R.isUndefinedOrNull)(f)?h:f==="true"}getNumber(E,h){const f=this.get(E);return(0,R.isUndefinedOrNull)(f)?h:parseInt(f,10)}async set(E,h){if(this.state===u.Closed)return;if((0,R.isUndefinedOrNull)(h))return this.delete(E);const f=String(h);if(this.cache.get(E)!==f)return this.cache.set(E,f),this.pendingInserts.set(E,f),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async delete(E){if(!(this.state===u.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(E){if(!!this.hasPending)return this.doFlush(E)}async doFlush(E){return this.flushDelayer.trigger(()=>this.flushPending(),E)}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert?.forEach((h,f)=>this.items.set(f,h)),E.delete?.forEach(h=>this.items.delete(h))}async close(){}}e.InMemoryStorageDatabase=C}),define(te[147],ie([0,1,8,3,31,9,21]),function(z,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class b{get onDidChangeItemsExternal(){return t.Event.None}constructor(C,y=Object.create(null)){this.path=C,this.options=y,this.name=(0,R.basename)(this.path),this.logger=new u(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const C=await this.whenConnected,y=new Map;return(await this.all(C,"SELECT * FROM ItemTable")).forEach(h=>y.set(h.key,h.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${y.size} rows`),y}async updateItems(C){const y=await this.whenConnected;return this.doUpdateItems(y,C)}doUpdateItems(C,y){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${y.insert?(0,k.mapToString)(y.insert):"0"}), delete(${y.delete?(0,k.setToString)(y.delete):"0"})`),this.transaction(C,()=>{const E=y.insert,h=y.delete;if(E&&E.size>0){const f=[];f.push([]);let P=0;E.forEach((w,m)=>{let v=f[P];v.length>b.MAX_HOST_PARAMETERS&&(P++,v=[],f.push(v)),v.push(m,w)}),f.forEach(w=>{this.prepare(C,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,m=>m.run(w),()=>{const m=[];let v=0;return E.forEach((d,g)=>{m.push(g),v+=d.length}),`Keys: ${m.join(", ")} Length: ${v}`})})}if(h&&h.size){const f=[];f.push([]);let P=0;h.forEach(w=>{let m=f[P];m.length>b.MAX_HOST_PARAMETERS&&(P++,m=[],f.push(m)),m.push(w)}),f.forEach(w=>{this.prepare(C,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,m=>m.run(w),()=>{const m=[];return h.forEach(v=>{m.push(v)}),`Keys: ${m.join(", ")}`})})}})}async close(C){this.logger.trace(`[storage ${this.name}] close()`);const y=await this.whenConnected;return this.doClose(y,C)}doClose(C,y){return new Promise((E,h)=>{C.db.close(f=>(f&&this.handleSQLiteError(C,`[storage ${this.name}] close(): ${f}`),this.path===b.IN_MEMORY_PATH?E():!C.isErroneous&&!C.isInMemory?this.backup().then(E,P=>(this.logger.error(`[storage ${this.name}] backup(): ${P}`),E())):typeof y=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(P=>{const w=()=>this.doClose(P,void 0);return this.doUpdateItems(P,{insert:y()}).then(()=>w(),m=>(w(),Promise.reject(m)))})).then(E,h):h(f||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const C=this.toBackupPath(this.path);return D.Promises.copy(this.path,C,{preserveSymlinks:!1})}toBackupPath(C){return`${C}.backup`}async checkIntegrity(C){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${C})`);const y=await this.whenConnected,E=await this.get(y,C?"PRAGMA integrity_check":"PRAGMA quick_check"),h=C?E.integrity_check:E.quick_check;return y.isErroneous?`${h} (last error: ${y.lastError})`:y.isInMemory?`${h} (in-memory!)`:h}async connect(C,y=!0){this.logger.trace(`[storage ${this.name}] open(${C}, retryOnBusy: ${y})`);try{return await this.doConnect(C)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&y)return await(0,S.timeout)(b.BUSY_OPEN_TIMEOUT),this.connect(C,!1);try{await D.Promises.unlink(C);try{await D.Promises.rename(this.toBackupPath(C),C)}catch{}return await this.doConnect(C)}catch(h){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${h}`),this.doConnect(b.IN_MEMORY_PATH)}}}handleSQLiteError(C,y){C.isErroneous=!0,C.lastError=y,this.logger.error(y)}doConnect(C){return new Promise((y,E)=>{new Promise((h,f)=>{z(["@vscode/sqlite3"],h,f)}).then(h=>{const f={db:new(this.logger.isTracing?h.verbose().Database:h.Database)(C,P=>P?f.db&&P.code!=="SQLITE_CANTOPEN"?f.db.close(()=>E(P)):E(P):this.exec(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(f),w=>f.db.close(()=>E(w)))),isInMemory:C===b.IN_MEMORY_PATH};f.db.on("error",P=>this.handleSQLiteError(f,`[storage ${this.name}] Error (event): ${P}`)),this.logger.isTracing&&f.db.on("trace",P=>this.logger.trace(`[storage ${this.name}] Trace (event): ${P}`))},E)})}exec(C,y){return new Promise((E,h)=>{C.db.exec(y,f=>f?(this.handleSQLiteError(C,`[storage ${this.name}] exec(): ${f}`),h(f)):E())})}get(C,y){return new Promise((E,h)=>{C.db.get(y,(f,P)=>f?(this.handleSQLiteError(C,`[storage ${this.name}] get(): ${f}`),h(f)):E(P))})}all(C,y){return new Promise((E,h)=>{C.db.all(y,(f,P)=>f?(this.handleSQLiteError(C,`[storage ${this.name}] all(): ${f}`),h(f)):E(P))})}transaction(C,y){return new Promise((E,h)=>{C.db.serialize(()=>{C.db.run("BEGIN TRANSACTION"),y(),C.db.run("END TRANSACTION",f=>f?(this.handleSQLiteError(C,`[storage ${this.name}] transaction(): ${f}`),h(f)):E())})})}prepare(C,y,E,h){const f=C.db.prepare(y),P=w=>{this.handleSQLiteError(C,`[storage ${this.name}] prepare(): ${w} (${y}). Details: ${h()}`)};f.on("error",P),E(f),f.finalize(w=>{w&&P(w),f.removeListener("error",P)})}}e.SQLiteStorageDatabase=b,b.IN_MEMORY_PATH=":memory:",b.BUSY_OPEN_TIMEOUT=2e3,b.MAX_HOST_PARAMETERS=256;class u{constructor(C){C&&typeof C.logTrace=="function"&&process.env[u.VSCODE_TRACE_STORAGE]&&(this.logTrace=C.logTrace),C&&typeof C.logError=="function"&&(this.logError=C.logError)}get isTracing(){return!!this.logTrace}trace(C){this.logTrace?.(C)}error(C){this.logError?.(C)}}u.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[148],ie([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(te[149],ie([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[150],ie([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[151],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(te[152],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(te[153],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[154],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[155],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[156],ie([11,10]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[157],ie([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[158],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(te[159],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(te[160],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(te[161],ie([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[162],ie([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[163],ie([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[164],ie([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[165],ie([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[166],ie([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(te[167],ie([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(te[168],ie([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[169],ie([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(te[170],ie([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[171],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[172],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[173],ie([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(te[174],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[175],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[176],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function S(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=S;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(te[177],ie([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(D){let b=[];try{Array.isArray(D.workspaces)&&(b=D.workspaces.map(u=>({workspace:{id:u.id,configPath:S.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return b}e.deserializeWorkspaceInfos=k;function R(D){let b=[];try{Array.isArray(D.folders)&&(b=D.folders.map(u=>({folderUri:S.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return b}e.deserializeFolderInfos=R}),define(te[178],ie([0,1,3,2]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new S.Emitter,this._onReloadEmitter=new S.Emitter,this._onTerminateEmitter=new S.Emitter,this._onAttachEmitter=new S.Emitter}call(b,u,p){switch(u){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(b,u,p){switch(u){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(b){super(),this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,u,p){this.channel.call("attach",[b,u,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,u){this.channel.call("terminate",[b,u])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,u){return this.channel.call("openExtensionDevelopmentHostWindow",[b,u])}}e.ExtensionHostDebugChannelClient=R}),define(te[179],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class S{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>z(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=S}),define(te[180],ie([0,1,133,53,13,9,34,16,7]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",z).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const P=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",P)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return u.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(u.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const P=D.env.VSCODE_PORTABLE;return P?u.URI.file((0,R.join)(P,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const P=this.args["builtin-extensions-dir"];return P?(0,R.resolve)(P):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const P=this.args["extensions-download-dir"];return P?(0,R.resolve)(P):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const P=this.args["extensions-dir"];if(P)return(0,R.resolve)(P);const w=D.env.VSCODE_EXTENSIONS;if(w)return w;const m=D.env.VSCODE_PORTABLE;return m?(0,R.join)(m,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const P=this.args.extensionDevelopmentPath;if(Array.isArray(P))return P.map(w=>/^[^:/?#]+?:\/\//.test(w)?u.URI.parse(w):u.URI.file((0,R.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(P=>P==="ui"||P==="workspace"||P==="web"?P:"workspace")}get extensionTestsLocationURI(){const P=this.args.extensionTestsPath;if(P)return/^[^:/?#]+?:\/\//.test(P)?u.URI.parse(P):u.URI.file((0,R.normalize)(P))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const P=this.args["disable-extension"];if(P){if(typeof P=="string")return[P];if(Array.isArray(P)&&P.length>0)return P}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const P=D.env.VSCODE_PORTABLE;return P?u.URI.file((0,R.join)(P,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(P){this.args.continueOn=P}get args(){return this._args}constructor(P,w,m){this._args=P,this.paths=w,this.productService=m,this.editSessionId=this.args.editSessionId}}ve([t.memoize],p.prototype,"appRoot",null),ve([t.memoize],p.prototype,"userHome",null),ve([t.memoize],p.prototype,"userDataPath",null),ve([t.memoize],p.prototype,"appSettingsHome",null),ve([t.memoize],p.prototype,"tmpDir",null),ve([t.memoize],p.prototype,"cacheHome",null),ve([t.memoize],p.prototype,"stateResource",null),ve([t.memoize],p.prototype,"userRoamingDataHome",null),ve([t.memoize],p.prototype,"userDataSyncHome",null),ve([t.memoize],p.prototype,"userDataSyncLogResource",null),ve([t.memoize],p.prototype,"editSessionsLogResource",null),ve([t.memoize],p.prototype,"sync",null),ve([t.memoize],p.prototype,"machineSettingsResource",null),ve([t.memoize],p.prototype,"workspaceStorageHome",null),ve([t.memoize],p.prototype,"localHistoryHome",null),ve([t.memoize],p.prototype,"keyboardLayoutResource",null),ve([t.memoize],p.prototype,"argvResource",null),ve([t.memoize],p.prototype,"isExtensionDevelopment",null),ve([t.memoize],p.prototype,"untitledWorkspacesHome",null),ve([t.memoize],p.prototype,"installSourcePath",null),ve([t.memoize],p.prototype,"builtinExtensionsPath",null),ve([t.memoize],p.prototype,"extensionsPath",null),ve([t.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],p.prototype,"extensionDevelopmentKind",null),ve([t.memoize],p.prototype,"extensionTestsLocationURI",null),ve([t.memoize],p.prototype,"debugExtensionHost",null),ve([t.memoize],p.prototype,"serviceMachineIdResource",null),ve([t.memoize],p.prototype,"telemetryLogResource",null),ve([t.memoize],p.prototype,"disableWorkspaceTrust",null),ve([t.memoize],p.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=p;function C(f,P){return h(f["inspect-extensions"],f["inspect-brk-extensions"],5870,P,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=C;function y(f,P){return h(f["inspect-search"],f["inspect-brk-search"],5876,P,f.extensionEnvironment)}e.parseSearchPort=y;function E(f,P){return h(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,P,f.extensionEnvironment)}e.parsePtyHostPort=E;function h(f,P,w,m,v,d){const c=Number(P||f)||(m?null:w),i=c?Boolean(!!P):!1;let o;if(d)try{o=JSON.parse(d)}catch{}return{port:c,break:i,debugId:v,env:o}}}),define(te[104],ie([0,1,277,4,151]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(f,P,w=D){const m={},v=["_"],d=[];for(const o in P){const n=P[o];n.alias&&(m[o]=n.alias),n.type==="string"||n.type==="string[]"?(v.push(o),n.deprecates&&v.push(...n.deprecates)):n.type==="boolean"&&(d.push(o),n.deprecates&&d.push(...n.deprecates))}const g=S(f,{string:v,boolean:d,alias:m}),c={},i=g;c._=g._.map(o=>String(o)).filter(o=>o.length>0),delete i._;for(const o in P){const n=P[o];n.alias&&delete i[n.alias];let r=i[o];if(n.deprecates)for(const s of n.deprecates)i.hasOwnProperty(s)&&(r||(r=i[s],r&&w.onDeprecatedOption(s,n.deprecationMessage||(0,k.localize)(35,null,o))),delete i[s]);if(typeof r<"u"){if(n.type==="string[]"){if(Array.isArray(r)||(r=[r]),!n.allowEmptyValue){const s=r.filter(l=>l.length>0);s.length!==r.length&&(w.onEmptyValue(o),r=s.length>0?s:void 0)}}else n.type==="string"&&(Array.isArray(r)?(r=r.pop(),w.onMultipleValues(o,r)):!r&&!n.allowEmptyValue&&(w.onEmptyValue(o),r=void 0));c[o]=r,n.deprecationMessage&&w.onDeprecatedOption(o,n.deprecationMessage)}delete i[o]}for(const o in i)w.onUnknownOption(o);return c}e.parseArgs=b;function u(f,P){let w="";return P.args&&(Array.isArray(P.args)?w=` <${P.args.join("> <")}>`:w=` <${P.args}>`),P.alias?`-${P.alias} --${f}${w}`:`--${f}${w}`}function p(f,P){let w=0;const m=[];for(const c in f){const i=f[c],o=u(c,i);w=Math.max(w,o.length),m.push([o,i.description])}const v=w+2+1;if(P-v<25)return m.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const d=P-v-1,g=[];for(const c of m){const i=c[0],o=y(c[1],d),n=C(v-i.length-2);g.push("  "+i+n+o[0]);for(let r=1;r<o.length;r++)g.push(C(v)+o[r])}return g}e.formatOptions=p;function C(f){return" ".repeat(f)}function y(f,P){const w=[];for(;f.length;){const m=f.length<P?f.length:f.lastIndexOf(" ",P),v=f.slice(0,m).trim();f=f.slice(m),w.push(v)}return w}function E(f,P,w,m,v){const d=process.stdout.isTTY&&process.stdout.columns||80,g=v?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",c=[`${f} ${w}`];c.push(""),c.push(`${(0,k.localize)(37,null)}: ${P} [${(0,k.localize)(38,null)}]${g}`),c.push(""),v?.noPipe!==!0&&(t.isWindows?c.push((0,k.localize)(39,null,P)):c.push((0,k.localize)(40,null,P)),c.push(""));const i={};for(const o in m){const n=m[o];if(n.description&&n.cat){let r=i[n.cat];r||(i[n.cat]=r={}),r[o]=n}}for(const o in i){const n=o,r=i[n];r&&(c.push(R[n]),c.push(...p(r,d)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=E;function h(f,P){return`${f||(0,k.localize)(41,null)}
${P||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=h}),define(te[181],ie([0,1,77,178,104]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(b,u){super(),this.windowsMainService=b,this.userDataProfilesMainService=u}call(b,u,p){return u==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1]):super.call(b,u,p)}async openExtensionDevelopmentHostWindow(b,u){const p=(0,k.parseArgs)(b,k.OPTIONS);p.debugRenderer=u;const C=p.extensionDevelopmentPath;if(!C)return{success:!1};const[y]=await this.windowsMainService.openExtensionDevelopmentHostWindow(C,{context:5,cli:p,profile:await this.userDataProfilesMainService.checkAndCreateProfileFromCli(p)});if(!u)return{success:!0};const E=y.win;if(!E)return{success:!0};const h=E.webContents.debugger;let f=h.isAttached()?1/0:0;const P=(0,S.createServer)(w=>{f++===0&&h.attach();let m=!1;const v=c=>{m||w.write(JSON.stringify(c)+"\0")},d=(c,i,o,n)=>v({method:i,params:o,sessionId:n});E.on("close",()=>{h.removeListener("message",d),w.end(),m=!0}),h.addListener("message",d);let g=Buffer.alloc(0);w.on("data",c=>{g=Buffer.concat([g,c]);for(let i=g.indexOf(0);i!==-1;i=g.indexOf(0)){let o;try{const n=g.slice(0,i).toString("utf8");g=g.slice(i+1),o=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}h.sendCommand(o.method,o.params,o.sessionId).then(n=>v({id:o.id,sessionId:o.sessionId,result:n})).catch(n=>v({id:o.id,sessionId:o.sessionId,error:{code:0,message:n.message}}))}}),w.on("error",c=>{console.error("error on cdp pipe:",c)}),w.on("close",()=>{m=!0,--f===0&&h.detach()})});return await new Promise(w=>P.listen(0,w)),E.on("close",()=>P.close()),{rendererDebugPort:P.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(te[59],ie([0,1,278,152,104]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(E,h){const f={onUnknownOption:w=>{console.warn((0,t.localize)(0,null,w))},onMultipleValues:(w,m)=>{console.warn((0,t.localize)(1,null,w,m))},onEmptyValue:w=>{console.warn((0,t.localize)(2,null,w))},onDeprecatedOption:(w,m)=>{console.warn((0,t.localize)(3,null,w,m))}},P=(0,k.parseArgs)(E,k.OPTIONS,h?f:void 0);return P.goto&&P._.forEach(w=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,t.localize)(4,null))),P["max-memory"]&&S(parseInt(P["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),P}function b(E){const h=E.findIndex(f=>!/^-/.test(f));if(h>-1)return[...E.slice(0,h),...E.slice(h+1)]}function u(E){let[,...h]=E;process.env.VSCODE_DEV&&(h=b(h)||[]);const f=!y(process.env);return D(h,f)}e.parseMainProcessArgv=u;function p(E){const[,,...h]=E;return D(h,!0)}e.parseCLIProcessArgv=p;function C(E,...h){const f=E.indexOf("--");return f===-1?E.push(...h):E.splice(f,0,...h),E}e.addArg=C;function y(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function z(e,S,t){function k(D,b){const u=R(D,b),p=[u];return e.isAbsolute(u)||p.unshift(t),e.resolve(...p)}function R(D,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return e.join(p,b);const C=D["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=e.join(y,"AppData","Roaming")}break;case"darwin":p=e.join(S.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(p,b)}return{getUserDataPath:k}}if(typeof define=="function")define(te[182],ie([183,25,34]),function(e,S,t){return z(e,S,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=z(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[184],ie([0,1,25,180,182]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(b,u){super(b,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b,u.nameShort)},u)}}e.NativeEnvironmentService=R}),define(te[185],ie([0,1,40,25,30]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const b=(0,k.randomPath)((0,t.tmpdir)());try{return(0,S.writeFileSync)(b,""),D&&console.log(`Marker file for --wait created: ${b}`),b}catch(u){D&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.createWaitMarkerFileSync=R}),define(te[186],ie([0,1,12,154]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,b,u){try{R(D,b,u)}catch{}return D}e.localizeManifest=k;function R(D,b,u){const p=(C,y,E)=>{const h=C[y];if((0,S.isString)(h)){const f=h,P=f.length;if(P>1&&f[0]==="%"&&f[P-1]==="%"){const w=f.substr(1,P-2);let m=b[w];m===void 0&&u&&(m=u[w]);const v=typeof m=="string"?m:m.message;if(v!==void 0){const d=u?.[w],g=typeof d=="string"?d:d?.message;if(E&&(y==="title"||y==="category")&&g&&g!==v){const c={value:v,original:g};C[y]=c}else C[y]=v}else console.warn(`[${D.name}]: ${(0,t.localize)(0,null,w)}`)}}else if((0,S.isObject)(h))for(const f in h)h.hasOwnProperty(f)&&(f==="commands"?p(h,f,!0):p(h,f,E));else if(Array.isArray(h))for(let f=0;f<h.length;f++)p(h,f,E)};for(const C in D)D.hasOwnProperty(C)&&p(D,C)}}),define(te[187],ie([0,1,16,97,156,188]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function u(m){return m=m.trim(),m==="*"||D.test(m)}e.isValidVersionStr=u;function p(m){if(!u(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=m.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=p;function C(m){if(!m)return null;const v=m.majorBase,d=m.majorMustEqual,g=m.minorBase;let c=m.minorMustEqual;const i=m.patchBase;let o=m.patchMustEqual;m.hasCaret&&(v===0||(c=!1),o=!1);let n=0;if(m.preRelease){const r=b.exec(m.preRelease);if(r){const[,s,l,a]=r;n=Date.UTC(Number(s),Number(l)-1,Number(a))}}return{majorBase:v,majorMustEqual:d,minorBase:g,minorMustEqual:c,patchBase:i,patchMustEqual:o,isMinimum:m.hasGreaterEquals,notBefore:n}}e.normalizeVersion=C;function y(m,v,d){let g;typeof m=="string"?g=C(p(m)):g=m;let c;v instanceof Date?c=v.getTime():typeof v=="string"&&(c=new Date(v).getTime());let i;if(typeof d=="string"?i=C(p(d)):i=d,!g||!i)return!1;const o=g.majorBase,n=g.minorBase,r=g.patchBase;let s=i.majorBase,l=i.minorBase,a=i.patchBase;const I=i.notBefore;let M=i.majorMustEqual,T=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:n>l?!0:n<l||c&&c<I?!1:r>=a:(o===1&&s===0&&(!M||!T||!N)&&(s=1,l=0,a=0,M=!0,T=!1,N=!1),o<s?!1:o>s?!M:n<l?!1:n>l?!T:r<a?!1:r>a?!N:!(c&&c<I))}e.isValidVersion=y;function E(m,v,d,g,c){const i=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof g.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof g.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!g.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof g.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof g.extensionDependencies<"u"&&!w(g.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof g.activationEvents<"u"){if(!w(g.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof g.main>"u"&&typeof g.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const r=(0,S.joinPath)(d,g.main);(0,S.isEqualOrParent)(r,d)||i.push([t.default.Warning,k.localize(10,null,r.path,d.path)])}if(typeof g.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof g.browser<"u"){if(typeof g.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const r=(0,S.joinPath)(d,g.browser);(0,S.isEqualOrParent)(r,d)||i.push([t.default.Warning,k.localize(13,null,r.path,d.path)])}if(typeof g.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(g.version))return i.push([t.default.Error,k.localize(15,null)]),i;const o=[];if(!h(m,v,g,c,o))for(const r of o)i.push([t.default.Error,r]);return i}e.validateExtensionManifest=E;function h(m,v,d,g,c){return g||typeof d.main>"u"&&typeof d.browser>"u"?!0:P(m,v,d.engines.vscode,c)}e.isValidExtensionVersion=h;function f(m,v,d){return m==="*"||P(v,d,m)}e.isEngineValid=f;function P(m,v,d,g=[]){const c=C(p(d));if(!c)return g.push(k.localize(16,null,d)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return g.push(k.localize(17,null,d)),!1}else if(!c.majorMustEqual)return g.push(k.localize(18,null,d)),!1;return y(m,v,c)?!0:(g.push(k.localize(19,null,m,d)),!1)}function w(m){if(!Array.isArray(m))return!1;for(let v=0,d=m.length;v<d;v++)if(typeof m[v]!="string")return!1;return!0}}),define(te[189],ie([0,1,18,29]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,b){let u=b&&b.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const C=(await D.readFile(R.serviceMachineIdResource)).value.toString();u=(0,t.isUUID)(C)?C:null}catch{u=null}if(!u){u=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,S.VSBuffer.fromString(u))}catch{}}return b?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=k}),define(te[68],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=S}),define(te[190],ie([0,1,68]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(b,u,p){u instanceof S.SyncDescriptor||(u=new S.SyncDescriptor(u,[],Boolean(p))),t.push([b,u])}e.registerSingleton=R;function D(){return t}e.getSingletonServiceDescriptors=D}),define(te[191],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const b=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(D);b.outgoing.set(u.key,u),u.incoming.set(b.key,b)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const b of this._nodes.values())b.outgoing.delete(D),b.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let b=this._nodes.get(D);return b||(b=new S(D,R),this._nodes.set(D,b)),b}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,b]of this._nodes)R.push(`${D}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const b=new Set([R]),u=this._findCycle(D,b);if(u)return u}}_findCycle(R,D){for(const[b,u]of R.outgoing){if(D.has(b))return[...D,b].join(" -> ");D.add(b);const p=this._findCycle(u,D);if(p)return p;D.delete(b)}}}e.Graph=t}),define(te[5],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function b(u){return u[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=b})(S=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,b,u){b[S.DI_TARGET]===b?b[S.DI_DEPENDENCIES].push({id:D,index:u}):(b[S.DI_DEPENDENCIES]=[{id:D,index:u}],b[S.DI_TARGET]=b)}function k(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const b=function(u,p,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(b,u,C)};return b.toString=()=>D,S.serviceIds.set(D,b),b}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(te[60],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,S.createDecorator)("backupMainService")}),define(te[19],ie([0,1,12,7,5]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var b;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function u(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function p(m,v){const d=Object.create(null);for(const g in m)C(d,g,m[g],v);return d}e.toValuesTree=p;function C(m,v,d,g){const c=v.split("."),i=c.pop();let o=m;for(let n=0;n<c.length;n++){const r=c[n];let s=o[r];switch(typeof s){case"undefined":s=o[r]=Object.create(null);break;case"object":break;default:g(`Ignoring ${v} as ${c.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[i]=d}catch{g(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=C;function y(m,v){const d=v.split(".");E(m,d)}e.removeFromValueTree=y;function E(m,v){const d=v.shift();if(v.length===0){delete m[d];return}if(Object.keys(m).indexOf(d)!==-1){const g=m[d];typeof g=="object"&&!Array.isArray(g)&&(E(g,v),Object.keys(g).length===0&&delete m[d])}}function h(m,v,d){function g(o,n){let r=o;for(const s of n){if(typeof r!="object"||r===null)return;r=r[s]}return r}const c=v.split("."),i=g(m,c);return typeof i>"u"?d:i}e.getConfigurationValue=h;function f(m,v,d){Object.keys(v).forEach(g=>{g!=="__proto__"&&(g in m?S.isObject(m[g])&&S.isObject(v[g])?f(m[g],v[g],d):d&&(m[g]=v[g]):m[g]=v[g])})}e.merge=f;function P(m,v,d){const g=m.inspect(v),c=m.inspect(d);return typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:g.defaultValue}e.getMigratedSettingValue=P;function w(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(te[69],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,b){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=b}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const b of Object.keys(this.secretVault[R]||{}))D.push({account:b,password:this.secretVault[R][b]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(te[84],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,b){return{}}async getSystemInfo(D,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,b){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(te[105],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(te[36],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(te[27],ie([0,1,53,9,83,36,184,5]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(R.IEnvironmentService);class u extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([S.memoize],u.prototype,"cachedLanguagesPath",null),ve([S.memoize],u.prototype,"backupHome",null),ve([S.memoize],u.prototype,"mainIPCHandle",null),ve([S.memoize],u.prototype,"mainLockfile",null),ve([S.memoize],u.prototype,"disableUpdates",null),ve([S.memoize],u.prototype,"disableKeytar",null),ve([S.memoize],u.prototype,"crossOriginIsolated",null),ve([S.memoize],u.prototype,"codeCachePath",null),ve([S.memoize],u.prototype,"useCodeCache",null),e.EnvironmentMainService=u}),define(te[192],ie([0,1,153,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(m,v){switch(m){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function b(m,v){return v==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function u(m,v,d){return b(v,d)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===d?!0:p(d).includes(m)}e.isTargetPlatformCompatible=u;function p(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function C(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=C;var y;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var E;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var h;(function(m){m.Install="install",m.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var f;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var P;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(v,d){super(v),this.code=d,this.name=d}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(te[193],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,S.createDecorator)("extensionUrlTrustService")}),define(te[194],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,S.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[106],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,S.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,S.createDecorator)("externalTerminal")}),define(te[195],ie([0,1,45,13,9,4,78,21,82,157,106]),function(z,e,S,t,k,R,D,b,u,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=p.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await P.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends E{openTerminal(g,c){return this.spawnTerminal(S,g,u.getWindowsShell(),c)}spawnTerminal(g,c,i,o){const n=c.windowsExec||h.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const r=k.basename(n).toLowerCase();if(r==="cmder"||r==="cmder.exe")return g.spawn(n,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return n.indexOf(" ")>=0&&s.push('""'),s.push(n),(r==="wt"||r==="wt.exe")&&s.push("-d ."),new Promise((l,a)=>{const I=w(process),M=g.spawn(i,s,{cwd:o,env:I});M.on("error",a),M.on("exit",()=>l())})}runInTerminal(g,c,i,o,n){const r="windowsExec"in n&&n.windowsExec?n.windowsExec:h.getDefaultTerminalWindows();return new Promise((s,l)=>{const a=`"${c} - ${y}"`,I=`""${i.join('" "')}" & pause"`,M=["/c","start",a,"/wait",r,"/c",I],T=Object.assign({},w(process),o);Object.keys(T).filter(ae=>T[ae]===null).forEach(ae=>delete T[ae]);const N={cwd:c,env:T,windowsVerbatimArguments:!0};S.spawn(h.CMD,M,N).on("error",ae=>{l(m(ae))}),s(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=h,h.CMD="cmd.exe";class f extends E{openTerminal(g,c){return this.spawnTerminal(S,g,c)}runInTerminal(g,c,i,o,n){const r=n.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((s,l)=>{if(r===C.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const a=r===C.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,z).fsPath,"-t",g||y,"-w",c];for(const X of i)M.push("-a"),M.push(X);if(o){const X=Object.assign({},w(process),o);for(const ae in X){const Q=X[ae];Q===null?(M.push("-u"),M.push(ae)):(M.push("-e"),M.push(`${ae}=${Q}`))}}let T="";const N=S.spawn(f.OSASCRIPT,M);N.on("error",X=>{l(m(X))}),N.stderr.on("data",X=>{T+=X.toString()}),N.on("exit",X=>{if(X===0)s(void 0);else if(T){const ae=T.split(`
`,1);l(new Error(ae[0]))}else l(new Error(p.localize(1,null,a,X)))})}else l(new Error(p.localize(2,null,r)))})}spawnTerminal(g,c,i){const o=c.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((n,r)=>{const s=["-a",o];i&&s.push(i);const l=w(process),a=g.spawn("/usr/bin/open",s,{cwd:i,env:l});a.on("error",r),a.on("exit",()=>n())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class P extends E{openTerminal(g,c){return this.spawnTerminal(S,g,c)}runInTerminal(g,c,i,o,n){const r=n.linuxExec?Promise.resolve(n.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{const a=[];r.then(I=>{I.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const M=`${v(i)}; echo; read -p "${P.WAIT_MESSAGE}" -n1;`;a.push(`''${M}''`);const T=Object.assign({},w(process),o);Object.keys(T).filter(Q=>T[Q]===null).forEach(Q=>delete T[Q]);const N={cwd:c,env:T};let X="";const ae=S.spawn(I,a,N);ae.on("error",Q=>{l(m(Q))}),ae.stderr.on("data",Q=>{X+=Q.toString()}),ae.on("exit",Q=>{if(Q===0)s(void 0);else if(X){const G=X.split(`
`,1);l(new Error(G[0]))}else l(new Error(p.localize(4,null,I,Q)))})})})}static async getDefaultTerminalLinuxReady(){if(!P._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)P._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const g=await b.Promises.exists("/etc/debian_version");P._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{g?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return P._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(g,c,i){const o=c.linuxExec?Promise.resolve(c.linuxExec):P.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{o.then(s=>{const l=w(process),a=g.spawn(s,[],{cwd:i,env:l});a.on("error",r),a.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=P,P.WAIT_MESSAGE=p.localize(3,null);function w(d){const g={...d.env};return(0,D.sanitizeProcessEnvironment)(g),g}function m(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(p.localize(5,null,d.path)):d}function v(d){let g="";for(const c of d)c.indexOf(" ")>=0?g+='"'+c+'"':g+=c,g+=" ";return g}}),define(te[14],ie([0,1,31,9,26,12,7,159,5]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,u.createDecorator)("fileService");function p(V){return V.create===!0}e.isFileOpenForWriteOptions=p;var C;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var y;(function(V){V[V.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var E;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=h;function f(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=f;function P(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=P;function w(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function m(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=m;function v(V){return h(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var d;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(H,W){super(H),this.code=W}}e.FileSystemProviderError=g;function c(V,H){const W=new g(V.toString(),H);return o(W,H),W}e.createFileSystemProviderError=c;function i(V){return V||c((0,b.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=i;function o(V,H){return V.name=H?`${H} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=o;function n(V){if(!V)return d.Unknown;if(V instanceof g)return V.code;const H=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!H)return d.Unknown;switch(H[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=n;function r(V){if(V instanceof T)return V.fileOperationResult;switch(n(V)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(H,W,A){this.resource=H,this.operation=W,this.target=A}isOperation(H){return this.operation===H}}e.FileOperationEvent=l;var a;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class I{constructor(H,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const A=new Map;for(const F of H){const U=A.get(F.type);switch(U?U.push([F.resource,F]):A.set(F.type,[[F.resource,F]]),F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}}for(const[F,U]of A)switch(F){case 1:this.added=S.TernarySearchTree.forUris(()=>W),this.added.fill(U);break;case 0:this.updated=S.TernarySearchTree.forUris(()=>W),this.updated.fill(U);break;case 2:this.deleted=S.TernarySearchTree.forUris(()=>W),this.deleted.fill(U);break}}contains(H,...W){return this.doContains(H,{includeChildren:!1},...W)}affects(H,...W){return this.doContains(H,{includeChildren:!0},...W)}doContains(H,W,...A){if(!H)return!1;const F=A.length>0;return!!((!F||A.includes(1))&&(this.added?.get(H)||W.includeChildren&&this.added?.findSuperstr(H))||(!F||A.includes(0))&&(this.updated?.get(H)||W.includeChildren&&this.updated?.findSuperstr(H))||(!F||A.includes(2))&&(this.deleted?.findSubstr(H)||W.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=I;function M(V,H,W){return!V||!H||V===H||H.length>V.length?!1:(H.charAt(H.length-1)!==t.sep&&(H+=t.sep),W?(0,k.startsWithIgnoreCase)(V,H):V.indexOf(H)===0)}e.isParent=M;class T extends Error{constructor(H,W,A){super(H),this.fileOperationResult=W,this.options=A}}e.FileOperationError=T;class N extends T{constructor(H,W,A){super(H,2,A),this.stat=W}}e.NotModifiedSinceFileOperationError=N;var X;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(X=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=Q;async function G(V,H){if(!H.hasProvider(D.URI.from({scheme:V.scheme})))return new Promise(W=>{const A=H.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&(A.dispose(),W())})})}e.whenProviderRegistered=G,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Z{static formatSize(H){return(0,R.isNumber)(H)||(H=0),H<Z.KB?(0,b.localize)(1,null,H.toFixed(0)):H<Z.MB?(0,b.localize)(2,null,(H/Z.KB).toFixed(2)):H<Z.GB?(0,b.localize)(3,null,(H/Z.MB).toFixed(2)):H<Z.TB?(0,b.localize)(4,null,(H/Z.GB).toFixed(2)):(0,b.localize)(5,null,(H/Z.TB).toFixed(2))}}e.ByteSize=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;var se;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*Z.MB:16*Z.GB,maxHeapSize:V===0?700*Z.MB:2*700*Z.MB}}e.getPlatformLimits=he}),define(te[196],ie([0,1,18,44,17,3,2,58,7,29,14]),function(z,e,S,t,k,R,D,b,u,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends D.Disposable{constructor(h,f){super(),this.channel=h,this.extraCapabilities=f,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,p.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(h){return this.channel.call("stat",[h])}readdir(h){return this.channel.call("readdir",[h])}async readFile(h,f){const{buffer:P}=await this.channel.call("readFile",[h,f]);return P}readFileStream(h,f,P){const w=(0,b.newWriteableStream)(v=>S.VSBuffer.concat(v.map(d=>S.VSBuffer.wrap(d))).buffer),m=this.channel.listen("readFileStream",[h,f])(v=>{if(v instanceof S.VSBuffer)w.write(v.buffer);else{if(v==="end")w.end();else{let d=v;d instanceof Error||(d=(0,C.createFileSystemProviderError)((0,t.toErrorMessage)(d),C.FileSystemProviderErrorCode.Unknown)),w.error(d),w.end()}m.dispose()}});return P.onCancellationRequested(()=>{w.error((0,k.canceled)()),w.end(),m.dispose()}),w}writeFile(h,f,P){return this.channel.call("writeFile",[h,S.VSBuffer.wrap(f),P])}open(h,f){return this.channel.call("open",[h,f])}close(h){return this.channel.call("close",[h])}async read(h,f,P,w,m){const[v,d]=await this.channel.call("read",[h,f,m]);return P.set(v.buffer.slice(0,d),w),d}write(h,f,P,w,m){return this.channel.call("write",[h,f,S.VSBuffer.wrap(P),w,m])}mkdir(h){return this.channel.call("mkdir",[h])}delete(h,f){return this.channel.call("delete",[h,f])}rename(h,f,P){return this.channel.call("rename",[h,f,P])}copy(h,f,P){return this.channel.call("copy",[h,f,P])}cloneFile(h,f){return this.channel.call("cloneFile",[h,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(h=>{if(Array.isArray(h)){const f=h;this._onDidChange.fire(f.map(P=>({resource:u.URI.revive(P.resource),type:P.type})))}else{const f=h;this._onDidWatchError.fire(f)}}))}watch(h,f){const P=(0,p.generateUuid)();return this.channel.call("watch",[this.sessionId,P,h,f]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,P]))}}e.DiskFileSystemProviderClient=y}),define(te[107],ie([0,1,18,17,160,14]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(C,y,E,h,f,P){let w;try{await b(C,y,E,h,f,P)}catch(m){w=m}finally{w&&f.errorTransformer&&(w=f.errorTransformer(w)),typeof w<"u"&&E.error(w),E.end()}}e.readFileIntoStream=D;async function b(C,y,E,h,f,P){u(P);const w=await C.open(y,{create:!1});try{u(P);let m=0,v=0,d=f&&typeof f.length=="number"?f.length:void 0,g=S.VSBuffer.alloc(Math.min(f.bufferSize,typeof d=="number"?d:f.bufferSize)),c=f&&typeof f.position=="number"?f.position:0,i=0;do v=await C.read(w,c,g.buffer,i,g.byteLength-i),c+=v,i+=v,m+=v,typeof d=="number"&&(d-=v),i===g.byteLength&&(await E.write(h(g)),g=S.VSBuffer.alloc(Math.min(f.bufferSize,typeof d=="number"?d:f.bufferSize)),i=0);while(v>0&&(typeof d!="number"||d>0)&&u(P)&&p(m,f));if(i>0){let o=i;typeof d=="number"&&(o=Math.min(i,d)),E.write(h(g.slice(0,o)))}}catch(m){throw(0,R.ensureFileSystemProviderError)(m)}finally{await C.close(w)}}function u(C){if(C.isCancellationRequested)throw(0,t.canceled)();return!0}function p(C,y){if(y?.limits){if(typeof y.limits.memory=="number"&&C>y.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&C>y.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[70],ie([0,1,98,2,9,4,7,14]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function u(m){return m.recursive===!0}e.isRecursiveWatchRequest=u;class p extends t.Disposable{constructor(v,d,g,c){super(),this.onFileChanges=v,this.onLogMessage=d,this.verboseLogging=g,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const v=new t.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),v.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),v.add(this.watcher.onDidError(d=>this.onError(d)))}onError(v){this.options.restartOnError?this.restartCounter<p.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${v}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${v}`):this.error(v)}restart(v){this.restartCounter++,this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=p,p.MAX_RESTARTS=5;class C extends p{constructor(v,d,g){super(v,d,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class y extends p{constructor(v,d,g){super(v,d,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function E(m){return m.map(v=>({type:v.type,resource:D.URI.file(v.path)}))}e.toFileChanges=E;function h(m){const v=new w;for(const d of m)v.processEvent(d);return v.coalesce()}e.coalesceEvents=h;function f(m,v){return typeof v=="string"&&!v.startsWith(S.GLOBSTAR)&&!(0,k.isAbsolute)(v)?{base:m,pattern:v}:v}e.normalizeWatcherPattern=f;function P(m,v){const d=[];for(const g of v)d.push((0,S.parse)(f(m,g)));return d}e.parseWatcherPatterns=P;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return R.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const d=this.mapPathToChange.get(this.toKey(v));let g=!1;if(d){const c=d.type,i=v.type;d.path!==v.path&&(v.type===2||v.type===1)?g=!0:c===1&&i===2?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(d)):c===2&&i===1?d.type=0:c===1&&i===0||(d.type=i)}else g=!0;g&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],d=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(v.push(g),!1):!0).sort((g,c)=>g.path.length-c.path.length).filter(g=>d.some(c=>(0,b.isParent)(g.path,c,!R.isLinux))?!1:(d.push(g.path),!0)).concat(v)}}}),define(te[197],ie([0,1,40,8,23,30,2,80,9,4,99,21,70]),function(z,e,S,t,k,R,D,b,u,p,C,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends D.Disposable{constructor(w,m,v,d){super(),this.request=w,this.onDidFilesChange=m,this.onLogMessage=v,this.verboseLogging=d,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(h.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,E.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,E.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await y.Promises.stat(w);this._register(await this.doWatch(w,m.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let m=w.path;try{m=await y.Promises.realpath(w.path),w.path===m&&(m=await(0,C.realcase)(w.path)??w.path),w.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${m})`)}catch{}return m}async doWatch(w,m){if(p.isMacintosh&&(0,R.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const v=new k.CancellationTokenSource(this.cts.token),d=new D.DisposableStore;try{const g=(0,u.basename)(w),c=(0,S.watch)(w);d.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${w}'`);const i=new Set;if(m)try{for(const n of await y.Promises.readdir(w))i.add(n)}catch(n){this.error(n)}const o=new Map;d.add((0,D.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),c.on("error",(n,r)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${n}, ${r})`),this.dispose()}),c.on("change",(n,r)=>{if(v.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${r}`);let s="";if(r&&(s=r.toString(),p.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(m)if(n==="rename"){o.get(s)?.dispose();const l=setTimeout(async()=>{if(o.delete(s),s===g&&!await y.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,u.join)(w,s));if(v.token.isCancellationRequested)return;let I;a?i.has(s)?I=0:(I=1,i.add(s)):(i.delete(s),I=2),this.onFileChange({path:(0,u.join)(this.request.path,s),type:I})},h.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,D.toDisposable)(()=>clearTimeout(l)))}else{let l;i.has(s)?l=0:(l=1,i.add(s)),this.onFileChange({path:(0,u.join)(this.request.path,s),type:l})}else if(n==="rename"||s!==g){const l=setTimeout(async()=>{const a=await y.Promises.exists(w);v.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),d.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);d.clear(),d.add((0,D.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(g){await y.Promises.exists(w)&&!v.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${g.toString()})`)}return(0,D.toDisposable)(()=>{v.dispose(!0),d.dispose()})}async onFileChange(w,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!m&&this.excludes.some(v=>v(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,E.coalesceEvents)(v);if(d.length>0){if(this.verboseLogging)for(const c of d)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(d)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(p.isLinux)return y.Promises.exists(w);try{const m=(0,u.basename)(w);return(await y.Promises.readdir((0,u.dirname)(w))).some(d=>d===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.FILE_DELETE_HANDLER_DELAY=100,h.FILE_CHANGES_HANDLER_DELAY=50;async function f(P,w,m,v,d=512){const g=await y.Promises.open(P,"r"),c=Buffer.allocUnsafe(d),i=new k.CancellationTokenSource(v);let o,n=!1;const r={path:P,excludes:[],recursive:!1},s=new h(r,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:I}=await y.Promises.read(g,c,0,d,null);if(!I||i.token.isCancellationRequested)break;w(c.slice(0,I))}}catch(I){o=new Error(I),i.dispose(!0)}finally{n=!1}}})()});return await s.ready,m(),new Promise((l,a)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await y.Promises.close(g)}catch(I){o=new Error(I)}o?a(o):l()})})}e.watchFileContents=f}),define(te[198],ie([0,1,3,98,2,4,197]),function(z,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new S.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=S.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(p){const C=this.normalizeRequests(p),y=C.filter(h=>{const f=this.watchers.get(h.path);return f?!(0,t.patternsEquals)(f.request.excludes,h.excludes)||!(0,t.patternsEquals)(f.request.includes,h.includes):!0}),E=Array.from(this.watchers.values()).filter(({request:h})=>!C.find(f=>f.path===h.path&&(0,t.patternsEquals)(f.excludes,h.excludes)&&(0,t.patternsEquals)(f.includes,h.includes))).map(({request:h})=>h.path);y.length&&this.trace(`Request to start watching: ${y.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),E.length&&this.trace(`Request to stop watching: ${E.join(",")}`);for(const h of E)this.stopWatching(h);for(const h of y)this.startWatching(h)}startWatching(p){const C=new D.NodeJSFileWatcherLibrary(p,E=>this._onDidChangeFile.fire(E),E=>this._onDidLogMessage.fire(E),this.verboseLogging),y={request:p,instance:C};this.watchers.set(p.path,y)}async stop(){for(const[p]of this.watchers)this.stopWatching(p);this.watchers.clear()}stopWatching(p){const C=this.watchers.get(p);C&&(this.watchers.delete(p),C.instance.dispose())}normalizeRequests(p){const C=new Map;for(const y of p){const E=R.isLinux?y.path:y.path.toLowerCase();C.set(E,y)}return Array.from(C.values())}async setVerboseLogging(p){this.verboseLogging=p;for(const[,C]of this.watchers)C.instance.setVerboseLogging(p)}trace(p){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(p)})}toMessage(p,C){return C?`[File Watcher (node.js)] ${p} (path: ${C.request.path})`:`[File Watcher (node.js)] ${p}`}}e.NodeJSWatcher=b}),define(te[199],ie([0,1,70,198]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends S.AbstractNonRecursiveWatcherClient{constructor(D,b,u){super(D,b,u),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(te[200],ie([0,1,13,46,146,70]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(u,p,C){super(u,p,C),this.init()}createWatcher(u){const p=u.add(new k.Client(S.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(p.onDidProcessExit(({code:C,signal:y})=>this.onError(`terminated by itself with code ${C}, signal: ${y}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(p.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(te[85],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=S}),define(te[201],ie([0,1,8,17,2,68,191,5,85,94]),function(z,e,S,t,k,R,D,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class y extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class E{constructor(w=new u.ServiceCollection,m=!1,v,d=C){this._services=w,this._strict=m,this._parent=v,this._enableTracing=d,this._activeInstantiations=new Set,this._services.set(b.IInstantiationService,this),this._globalGraph=d?v?._globalGraph??new D.Graph(g=>g):void 0}createChild(w){return new E(w,this._strict,this,this._enableTracing)}invokeFunction(w,...m){const v=f.traceInvocation(this._enableTracing,w);let d=!1;try{return w({get:c=>{if(d)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(c,v);if(!i)throw new Error(`[invokeFunction] unknown service '${c}'`);return i}},...m)}finally{d=!0,v.stop()}}createInstance(w,...m){let v,d;return w instanceof R.SyncDescriptor?(v=f.traceCreation(this._enableTracing,w.ctor),d=this._createInstance(w.ctor,w.staticArguments.concat(m),v)):(v=f.traceCreation(this._enableTracing,w),d=this._createInstance(w,m,v)),v.stop(),d}_createInstance(w,m=[],v){const d=b._util.getServiceDependencies(w).sort((i,o)=>i.index-o.index),g=[];for(const i of d){const o=this._getOrCreateServiceInstance(i.id,v);o||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),g.push(o)}const c=d.length>0?d[0].index:m.length;if(m.length!==c){console.trace(`[createInstance] First service dependency of ${w.name} at position ${c+1} conflicts with ${m.length} static arguments`);const i=c-m.length;i>0?m=m.concat(new Array(i)):m=m.slice(0,c)}return Reflect.construct(w,m.concat(g))}_setServiceInstance(w,m){if(this._services.get(w)instanceof R.SyncDescriptor)this._services.set(w,m);else if(this._parent)this._parent._setServiceInstance(w,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const m=this._services.get(w);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):m}_getOrCreateServiceInstance(w,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const v=this._getServiceInstanceOrDescriptor(w);return v instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,v,m.branch(w,!0)):(m.branch(w,!1),v)}_safeCreateAndCacheServiceInstance(w,m,v){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,m,v)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,m,v){const d=new D.Graph(i=>i.id.toString());let g=0;const c=[{id:w,desc:m,_trace:v}];for(;c.length;){const i=c.pop();if(d.lookupOrInsertNode(i),g++>1e3)throw new y(d);for(const o of b._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof R.SyncDescriptor){const r={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};d.insertEdge(i,r),c.push(r)}}}for(;;){const i=d.roots();if(i.length===0){if(!d.isEmpty())throw new y(d);break}for(const{data:o}of i){if(this._getServiceInstanceOrDescriptor(o.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}d.removeNode(o)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,m,v=[],d,g){if(this._services.get(w)instanceof R.SyncDescriptor)return this._createServiceInstance(w,m,v,d,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,m,v,d,g);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(w,m,v=[],d,g){if(d){const c=new E(void 0,this._strict,this,this._enableTracing);c._globalGraphImplicitDependency=String(w);const i=new Map,o=new S.IdleValue(()=>{const n=c._createInstance(m,v,g);for(const[r,s]of i){const l=n[r];if(typeof l=="function")for(const a of s)l.apply(n,a)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,r){if(!o.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=i.get(r);return a||(a=new p.LinkedList,i.set(r,a)),(M,T,N)=>{const X=a.push([M,T,N]);return(0,k.toDisposable)(X)}}if(r in n)return n[r];const s=o.value;let l=s[r];return typeof l!="function"||(l=l.bind(s),n[r]=l),l},set(n,r,s){return o.value[r]=s,!0}})}else return this._createInstance(m,v,g)}_throwIfStrict(w,m){if(m&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=E;var h;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(h||(h={}));class f{static traceInvocation(w,m){return w?new f(1,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(w,m){return w?new f(0,m.name):f._None}constructor(w,m){this.type=w,this.name=m,this._start=Date.now(),this._dep=[]}branch(w,m){const v=new f(2,w.toString());return this._dep.push([w,m,v]),v}stop(){const w=Date.now()-this._start;f._totals+=w;let m=!1;function v(g,c){const i=[],o=new Array(g+1).join("	");for(const[n,r,s]of c._dep)if(r&&s){m=!0,i.push(`${o}CREATES -> ${n}`);const l=v(g+1,s);l&&i.push(l)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(w>2||m)&&f.all.add(d.join(`
`))}}e.Trace=f,f.all=new Set,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[6],ie([0,1,44,3,2,4,5]),function(z,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function b(){return new Date().toISOString()}var u;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(u=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=u.Info;function p(o,n,r){switch(n){case u.Trace:o.trace(r);break;case u.Debug:o.debug(r);break;case u.Info:o.info(r);break;case u.Warning:o.warn(r);break;case u.Error:o.error(r);break;case u.Critical:o.critical(r);break;default:throw new Error("Invalid log level")}}e.log=p;function C(o){let n="";for(let r=0;r<o.length;r++){let s=o[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(r>0?" ":"")+s}return n}e.format=C;class y extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class E extends y{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...r){this.checkLogLevel(u.Trace)&&this.log(u.Trace,C([n,...r]))}debug(n,...r){this.checkLogLevel(u.Debug)&&this.log(u.Debug,C([n,...r]))}info(n,...r){this.checkLogLevel(u.Info)&&this.log(u.Info,C([n,...r]))}warn(n,...r){this.checkLogLevel(u.Warning)&&this.log(u.Warning,C([n,...r]))}error(n,...r){if(this.checkLogLevel(u.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(u.Error,C(s))}else this.log(u.Error,C([n,...r]))}critical(n,...r){this.checkLogLevel(u.Critical)&&this.log(u.Critical,C([n,...r]))}flush(){}}e.AbstractMessageLogger=E;class h extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!R.isWindows}trace(n,...r){this.getLevel()<=u.Trace&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,n,...r):console.log(`[main ${b()}]`,n,...r))}debug(n,...r){this.getLevel()<=u.Debug&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,n,...r):console.log(`[main ${b()}]`,n,...r))}info(n,...r){this.getLevel()<=u.Info&&(this.useColors?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,n,...r):console.log(`[main ${b()}]`,n,...r))}warn(n,...r){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,n,...r):console.warn(`[main ${b()}]`,n,...r))}error(n,...r){this.getLevel()<=u.Error&&(this.useColors?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,n,...r):console.error(`[main ${b()}]`,n,...r))}critical(n,...r){this.getLevel()<=u.Critical&&(this.useColors?console.error(`\x1B[90m[main ${b()}]\x1B[0m`,n,...r):console.error(`[main ${b()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class f extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",n,...r)}critical(n,...r){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=f;class P extends y{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(r)}trace(n,...r){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(n),...r])}debug(n,...r){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(n),...r])}info(n,...r){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(n),...r])}warn(n,...r){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(n),...r])}error(n,...r){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(n),...r])}critical(n,...r){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(n),...r])}extractMessage(n){return typeof n=="string"?n:(0,S.toErrorMessage)(n,this.getLevel()<=u.Trace)}dispose(){}flush(){}}e.AdapterLogger=P;class w extends y{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.logServices)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const s of this.logServices)s.trace(n,...r)}debug(n,...r){for(const s of this.logServices)s.debug(n,...r)}info(n,...r){for(const s of this.logServices)s.info(n,...r)}warn(n,...r){for(const s of this.logServices)s.warn(n,...r)}error(n,...r){for(const s of this.logServices)s.error(n,...r)}critical(n,...r){for(const s of this.logServices)s.critical(n,...r)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=w;class m extends k.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...r){this.logger.trace(n,...r)}debug(n,...r){this.logger.debug(n,...r)}info(n,...r){this.logger.info(n,...r)}warn(n,...r){this.logger.warn(n,...r)}error(n,...r){this.logger.error(n,...r)}critical(n,...r){this.logger.critical(n,...r)}flush(){this.logger.flush()}}e.LogService=m;class v extends k.Disposable{constructor(n,r){super(),this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,r){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,r?.always?u.Trace:this.logLevel,r),this.loggers.set(n.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class d{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return u.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogService=d;function g(o){if(o.verbose)return u.Trace;if(typeof o.logLevel=="string"){const n=c(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function c(o){switch(o){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}e.parseLogLevel=c;function i(o){switch(o){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}e.LogLevelToString=i});var ee=this&&this.__param||function(z,e){return function(S,t){e(S,t,z)}};define(te[202],ie([0,1,69,3,2,6,4,8]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let u=class Et extends k.Disposable{constructor(C){super(),this.logService=C,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(C,y){this.logService.trace("Getting password from keytar:",C,y);let E;try{E=await this.withKeytar()}catch{return null}const h=await(0,b.retry)(()=>E.getPassword(C,y),50,3);if(!h)return this.logService.trace("Did not get a password from keytar for account:",y),h;let f,P;try{const w=JSON.parse(h);f=w.content,P=w.hasNextChunk}catch{}if(!f||!P)return this.logService.trace("Got password from keytar for account:",y),h;try{let w=1;for(;P;){const m=await(0,b.retry)(()=>E.getPassword(C,`${y}-${w}`),50,3),v=JSON.parse(m);f+=v.content,P=v.hasNextChunk,w++}return this.logService.trace(`Got ${w}-chunked password from keytar for account:`,y),f}catch(w){return this.logService.error(w),h}}async setPassword(C,y,E){this.logService.trace("Setting password using keytar:",C,y);let h;try{h=await this.withKeytar()}catch(f){throw this.surfaceKeytarLoadError?.(f),f}if(D.isWindows&&E.length>Et.MAX_PASSWORD_LENGTH){let f=0,P=0,w=!0;for(;w;){const m=E.substring(f,f+Et.PASSWORD_CHUNK_SIZE);f+=Et.PASSWORD_CHUNK_SIZE,w=E.length-f>0;const v={content:m,hasNextChunk:w};await(0,b.retry)(()=>h.setPassword(C,P?`${y}-${P}`:y,JSON.stringify(v)),50,3),P++}this.logService.trace(`Got${P?` ${P}-chunked`:""} password from keytar for account:`,y)}else await(0,b.retry)(()=>h.setPassword(C,y,E),50,3),this.logService.trace("Got password from keytar for account:",y);this._onDidChangePassword.fire({service:C,account:y})}async deletePassword(C,y){this.logService.trace("Deleting password using keytar:",C,y);let E;try{E=await this.withKeytar()}catch(m){throw this.surfaceKeytarLoadError?.(m),m}const h=await E.getPassword(C,y);if(!h)return this.logService.trace("Did not get a password to delete from keytar for account:",y),!1;let f,P;try{const m=JSON.parse(h);f=m.content,P=m.hasNextChunk}catch{}let w=0;if(f&&P)try{for(w++;P;){const m=`${y}-${w}`,v=await E.getPassword(C,m);await E.deletePassword(C,m),P=JSON.parse(v).hasNextChunk,w++}}catch(m){this.logService.error(m)}return await E.deletePassword(C,y)?(this._onDidChangePassword.fire({service:C,account:y}),this.logService.trace(`Deleted${w?` ${w}-chunked`:""} password from keytar for account:`,y),!0):(this.logService.trace(`Keytar failed to delete${w?` ${w}-chunked`:""} password for account:`,y),!1)}async findPassword(C){let y;try{y=await this.withKeytar()}catch{return null}return await y.findPassword(C)}async findCredentials(C){let y;try{y=await this.withKeytar()}catch{return[]}return await y.findCredentials(C)}clear(){return this._keytarCache instanceof S.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};u.MAX_PASSWORD_LENGTH=2500,u.PASSWORD_CHUNK_SIZE=u.MAX_PASSWORD_LENGTH-100,u=ve([ee(0,R.ILogService)],u),e.BaseCredentialsMainService=u}),define(te[203],ie([0,1,24,8,17,3,2,9,70,6]),function(z,e,S,t,k,R,D,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends D.Disposable{constructor(E,h){super(),this.logService=E,this.options=h,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(E,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,h):this.watchNonRecursive(E,h)}watchUniversal(E,h){const f={path:this.toFilePath(E),excludes:h.excludes,includes:h.includes,recursive:h.recursive},P=(0,S.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,k.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,u.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const h of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const h of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(h)&&E.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,h){const f={path:this.toFilePath(E),excludes:h.excludes,includes:h.includes,recursive:!1},P=(0,S.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{P(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,k.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,u.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,b.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(te[204],ie([0,1,24,8,18,23,3,66,57,2,31,13,71,16,58,158,14,107,6]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends p.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,i){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${c}`);const o=new p.DisposableStore;return this.provider.set(c,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:i}),o.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new w.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&o.add(i.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),o.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:c}))),(0,p.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:i}),this.provider.delete(c),(0,p.dispose)(o)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(o){i.push(o)}}),!this.provider.has(c)&&await t.Promises.settled(i)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,i){const o=this.provider.get(c.scheme);return!!(o&&o.capabilities&i)}listCapabilities(){return u.Iterable.map(this.provider,([c,i])=>({scheme:c,capabilities:i.capabilities}))}async withProvider(c){if(!(0,h.isAbsolutePath)(c))throw new w.FileOperationError((0,P.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const i=this.provider.get(c.scheme);if(!i){const o=new Error;throw o.name="ENOPRO",o.message=(0,P.localize)(1,null,c.toString()),o}return i}async withReadProvider(c){const i=await this.withProvider(c);if((0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)||(0,w.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const i=await this.withProvider(c);if((0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,i){try{return await this.doResolveFile(c,i)}catch(o){throw(0,w.toFileSystemProviderErrorCode)(o)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,P.localize)(2,null,this.resourceForError(c)),1):(0,w.ensureFileSystemProviderError)(o)}}async doResolveFile(c,i){const o=await this.withProvider(c),n=this.isPathCaseSensitive(o),r=i?.resolveTo,s=i?.resolveSingleChildDescendants,l=i?.resolveMetadata,a=await o.stat(c);let I;return this.toFileStat(o,c,a,void 0,!!l,(M,T)=>(I||(I=C.TernarySearchTree.forUris(()=>!n),I.set(c,!0),r&&I.fill(!0,r)),I.get(M.resource)||I.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&s?T===1:!1))}async toFileStat(c,i,o,n,r,s){const{providerExtUri:l}=this.getExtUri(c),a={resource:i,name:l.basename(i),isFile:(o.type&w.FileType.File)!==0,isDirectory:(o.type&w.FileType.Directory)!==0,isSymbolicLink:(o.type&w.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&w.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,w.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(a.isDirectory&&s(a,n)){try{const I=await c.readdir(i),M=await t.Promises.settled(I.map(async([T,N])=>{try{const X=l.joinPath(i,T),ae=r?await c.stat(X):{type:N};return await this.toFileStat(c,X,ae,I.length,r,s)}catch(X){return this.logService.trace(X),null}}));a.children=(0,S.coalesce)(M)}catch(I){this.logService.trace(I),a.children=[]}return a}return a}async resolveAll(c){return t.Promises.settled(c.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(c){const i=await this.withProvider(c),o=await i.stat(c);return this.toFileStat(i,c,o,void 0,!0,()=>!1)}async exists(c){const i=await this.withProvider(c);try{return!!await i.stat(c)}catch{return!1}}async canCreateFile(c,i){try{await this.doValidateCreateFile(c,i)}catch(o){return o}return!0}async doValidateCreateFile(c,i){if(!i?.overwrite&&await this.exists(c))throw new w.FileOperationError((0,P.localize)(3,null,this.resourceForError(c)),3,i)}async createFile(c,i=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(c,o);const n=await this.writeFile(c,i);return this._onDidRunOperation.fire(new w.FileOperationEvent(c,0,n)),n}async writeFile(c,i,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,c,o)||await this.mkdirp(n,r.dirname(c));let l;if((0,w.hasReadWriteCapability)(n)&&!(i instanceof k.VSBuffer))if((0,f.isReadableStream)(i)){const a=await(0,f.peekStream)(i,3);a.ended?l=k.VSBuffer.concat(a.buffer):l=a}else l=(0,f.peekReadable)(i,a=>k.VSBuffer.concat(a),3);else l=i;!(0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(n,c,o,l):await this.doWriteBuffered(n,c,o,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this._onDidRunOperation.fire(new w.FileOperationEvent(c,4))}catch(s){throw new w.FileOperationError((0,P.localize)(4,null,this.resourceForError(c),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),o)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,i,o){if(!!o?.unlock&&!(c.capabilities&8192))throw new Error((0,P.localize)(5,null,this.resourceForError(i)));let r;try{r=await c.stat(i)}catch{return}if((r.type&w.FileType.Directory)!==0)throw new w.FileOperationError((0,P.localize)(6,null,this.resourceForError(i)),0,o);if(this.throwIfFileIsReadonly(i,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==w.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,w.etag)({mtime:o.mtime,size:r.size}))throw new w.FileOperationError((0,P.localize)(7,null),3,o);return r}async readFile(c,i,o){const n=await this.withReadProvider(c);return i?.atomic?this.doReadFileAtomic(n,c,i,o):this.doReadFile(n,c,i,o)}async doReadFileAtomic(c,i,o,n){return new Promise((r,s)=>{this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(c,i,o,n);r(l)}catch(l){s(l)}})})}async doReadFile(c,i,o,n){const r=await this.doReadFileStream(c,i,{...o,preferUnbuffered:!0},n);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(c,i,o){const n=await this.withReadProvider(c);return this.doReadFileStream(n,c,i,o)}async doReadFileStream(c,i,o,n){const r=new R.CancellationTokenSource(n),s=this.validateReadFile(i,o).then(a=>a,a=>{throw r.cancel(),a});let l;try{return typeof o?.etag=="string"&&o.etag!==w.ETAG_DISABLED&&await s,o?.atomic&&(0,w.hasFileAtomicReadCapability)(c)||!((0,w.hasOpenReadWriteCloseCapability)(c)||(0,w.hasFileReadStreamCapability)(c))||(0,w.hasReadWriteCapability)(c)&&o?.preferUnbuffered?l=this.readFileUnbuffered(c,i,o):(0,w.hasFileReadStreamCapability)(c)?l=this.readFileStreamed(c,i,r.token,o):l=this.readFileBuffered(c,i,r.token,o),{...await s,value:l}}catch(a){l&&await(0,f.consumeStream)(l);const I=(0,P.localize)(8,null,this.resourceForError(i),(0,w.ensureFileSystemProviderError)(a).toString());throw a instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(I,a.stat,o):new w.FileOperationError(I,(0,w.toFileOperationResult)(a),o)}}readFileStreamed(c,i,o,n=Object.create(null)){const r=c.readFileStream(i,n,o);return(0,f.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new w.FileOperationError((0,P.localize)(9,null,this.resourceForError(i),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),n)},s=>k.VSBuffer.concat(s))}readFileBuffered(c,i,o,n=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,m.readFileIntoStream)(c,i,r,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new w.FileOperationError((0,P.localize)(10,null,this.resourceForError(i),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),n)},o),r}readFileUnbuffered(c,i,o){const n=(0,f.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,w.hasFileAtomicReadCapability)(c)?r=await c.readFile(i,{atomic:!0}):r=await c.readFile(i),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(i,r.byteLength,o),n.end(k.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(c,i){const o=await this.resolve(c,{resolveMetadata:!0});if(o.isDirectory)throw new w.FileOperationError((0,P.localize)(11,null,this.resourceForError(c)),0,i);if(typeof i?.etag=="string"&&i.etag!==w.ETAG_DISABLED&&i.etag===o.etag)throw new w.NotModifiedSinceFileOperationError((0,P.localize)(12,null),o,i);return this.validateReadFileLimits(c,o.size,i),o}validateReadFileLimits(c,i,o){if(o?.limits){let n;if(typeof o.limits.memory=="number"&&i>o.limits.memory&&(n=9),typeof o.limits.size=="number"&&i>o.limits.size&&(n=7),typeof n=="number")throw new w.FileOperationError((0,P.localize)(13,null,this.resourceForError(c)),n)}}async canMove(c,i,o){return this.doCanMoveCopy(c,i,"move",o)}async canCopy(c,i,o){return this.doCanMoveCopy(c,i,"copy",o)}async doCanMoveCopy(c,i,o,n){if(c.toString()!==i.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,c,s,i,o,n)}catch(r){return r}return!0}async move(c,i,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,c,r,i,"move",!!o),l=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,s==="move"?2:3,l)),l}async copy(c,i,o){const n=await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,c,r,i,"copy",!!o),l=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,s==="copy"?3:2,l)),l}async doMoveCopy(c,i,o,n,r,s){if(i.toString()===n.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,i,o,n,r,s);if(l&&!a&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(n)),r==="copy"){if(c===o&&(0,w.hasFileFolderCopyCapability)(c))await c.copy(i,n,{overwrite:s});else{const I=await this.resolve(i);I.isDirectory?await this.doCopyFolder(c,I,o,n):await this.doCopyFile(c,i,o,n)}return r}else return c===o?(await c.rename(i,n,{overwrite:s}),r):(await this.doMoveCopy(c,i,o,n,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(c,i,o,n){if((0,w.hasOpenReadWriteCloseCapability)(c)&&(0,w.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(c,i,o,n);if((0,w.hasOpenReadWriteCloseCapability)(c)&&(0,w.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(c,i,o,n);if((0,w.hasReadWriteCapability)(c)&&(0,w.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(c,i,o,n);if((0,w.hasReadWriteCapability)(c)&&(0,w.hasReadWriteCapability)(o))return this.doPipeUnbuffered(c,i,o,n)}async doCopyFolder(c,i,o,n){await o.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async r=>{const s=this.getExtUri(o).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(c,await this.resolve(r.resource),o,s):this.doCopyFile(c,r.resource,o,s)}))}async doValidateMoveCopy(c,i,o,n,r,s){let l=!1;if(c===o){const{providerExtUri:I,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(l=I.isEqual(i,n)),l&&r==="copy")throw new Error((0,P.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!l&&I.isEqualOrParent(n,i))throw new Error((0,P.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const a=await this.exists(n);if(a&&!l){if(!s)throw new w.FileOperationError((0,P.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(c===o){const{providerExtUri:I}=this.getExtUri(c);if(I.isEqualOrParent(i,n))throw new Error((0,P.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}getExtUri(c){const i=this.isPathCaseSensitive(c);return{providerExtUri:i?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(i,c);const o=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,0,o)),o}async mkdirp(c,i){const o=[],{providerExtUri:n}=this.getExtUri(c);for(;!n.isEqual(i,n.dirname(i));)try{if(((await c.stat(i)).type&w.FileType.Directory)===0)throw new Error((0,P.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(n.basename(i)),i=n.dirname(i)}for(let r=o.length-1;r>=0;r--){i=n.joinPath(i,o[r]);try{await c.mkdir(i)}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,i){try{await this.doValidateDelete(c,i)}catch(o){return o}return!0}async doValidateDelete(c,i){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!i?.useTrash&&!(o.capabilities&4096))throw new Error((0,P.localize)(19,null,this.resourceForError(c)));let r;try{r=await o.stat(c)}catch{}if(r)this.throwIfFileIsReadonly(c,r);else throw new w.FileOperationError((0,P.localize)(20,null,this.resourceForError(c)),1);if(!!!i?.recursive){const l=await this.resolve(c);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,P.localize)(21,null,this.resourceForError(c)))}return o}async del(c,i){const o=await this.doValidateDelete(c,i),n=!!i?.useTrash,r=!!i?.recursive;await o.delete(c,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new w.FileOperationEvent(c,1))}async cloneFile(c,i){const o=await this.withProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(o===n&&this.getExtUri(o).providerExtUri.isEqual(c,i))return;if(o===n&&(0,w.hasFileCloneCapability)(o))return o.cloneFile(c,i);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri);return o===n&&(0,w.hasFileFolderCopyCapability)(o)?r.queue(()=>o.copy(c,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(o,c,n,i))}watch(c,i={recursive:!1,excludes:[]}){const o=new p.DisposableStore;let n=!1,r=()=>{n=!0};return o.add((0,p.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(c,i);n?(0,p.dispose)(s):r=()=>(0,p.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(c,i){const o=await this.withProvider(c),n=(0,b.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(c),i]);let r=this.activeWatchers.get(n);return r||(r={count:0,disposable:o.watch(c,i)},this.activeWatchers.set(n,r)),r.count+=1,(0,p.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,p.dispose)(r.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,p.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,i,o,n){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{const r=await c.open(i,{create:!0,unlock:o?.unlock??!1});try{(0,f.isReadableStream)(n)||(0,f.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(c,r,n):await this.doWriteReadableBufferedQueued(c,r,n)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await c.close(r)}})}async doWriteStreamBufferedQueued(c,i,o){let n=0,r;if((0,f.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(c,i,s,s.byteLength,n,0),n+=s.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((s,l)=>{(0,f.listenStream)(r,{onData:async a=>{r.pause();try{await this.doWriteBuffer(c,i,a,a.byteLength,n,0)}catch(I){return l(I)}n+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>l(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,i,o){let n=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(c,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(c,i,o,n,r,s){let l=0;for(;l<n;)l+=await c.write(i,r+l,o.buffer,s+l,n-l)}async doWriteUnbuffered(c,i,o,n){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,i,o,n))}async doWriteUnbufferedQueued(c,i,o,n){let r;n instanceof k.VSBuffer?r=n:(0,f.isReadableStream)(n)?r=await(0,k.streamToBuffer)(n):(0,f.isReadableBufferedStream)(n)?r=await(0,k.bufferedStreamToBuffer)(n):r=(0,k.readableToBuffer)(n),await c.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(c,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,i,o,n))}async doPipeBufferedQueued(c,i,o,n){let r,s;try{r=await c.open(i,{create:!1}),s=await o.open(n,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,I=0,M=0;do M=await c.read(r,a,l.buffer,I,l.byteLength-I),await this.doWriteBuffer(o,s,l,M,a,I),a+=M,I+=M,I===l.byteLength&&(I=0);while(M>0)}catch(l){throw(0,w.ensureFileSystemProviderError)(l)}finally{await t.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,i,o,n))}async doPipeUnbufferedQueued(c,i,o,n){return o.writeFile(n,await c.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,i,o,n))}async doPipeUnbufferedToBufferedQueued(c,i,o,n){const r=await o.open(n,{create:!0,unlock:!1});try{const s=await c.readFile(i);await this.doWriteBuffer(o,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(c,i,o,n){const r=await(0,k.streamToBuffer)(this.readFileBuffered(c,i,R.CancellationToken.None));await this.doWriteUnbuffered(o,n,void 0,r)}throwIfFileSystemIsReadonly(c,i){if(c.capabilities&2048)throw new w.FileOperationError((0,P.localize)(22,null,this.resourceForError(i)),6);return c}throwIfFileIsReadonly(c,i){if((i.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,P.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===y.Schemas.file?c.fsPath:c.toString(!0)}};d=ve([ee(0,v.ILogService)],d),e.FileService=d}),define(te[86],ie([0,1,40,279,8,31,18,3,30,2,9,4,16,58,21,162,14,107,203,44,200,199]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(S)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(o)}`)}})();class i extends v.AbstractDiskFileSystemProvider{constructor(n,r){super(n,r),this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new R.ResourceMap(s=>E.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,y.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:s}=await f.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(n){try{const r=await f.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,E.joinPath)(n,l.name))).type:a=this.toType(l),s.push([l.name,a])}catch(a){this.logService.trace(a)}})),s}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let s;return r?.dangling?s=w.FileType.Unknown:n.isFile()?s=w.FileType.File:n.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,r&&(s|=w.FileType.SymbolicLink),s}async createResourceLock(n){const r=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const l=new k.Barrier;return this.resourceLocks.set(n,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,p.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(n)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),l.open()})}async readFile(n,r){let s;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const l=this.toFilePath(n);return await f.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{s?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,r,s){const l=(0,h.newWriteableStream)(a=>D.VSBuffer.concat(a.map(I=>D.VSBuffer.wrap(I))).buffer);return(0,m.readFileIntoStream)(this,n,l,a=>a.buffer,{...r,bufferSize:256*1024},s),l}async writeFile(n,r,s){let l;try{const a=this.toFilePath(n);if(!s.create||!s.overwrite){if(await f.Promises.exists(a)){if(!s.overwrite)throw(0,w.createFileSystemProviderError)((0,P.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.createFileSystemProviderError)((0,P.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(l,0,r,0,r.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(n,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(n){i.canFlush=n}async open(n,r){const s=this.toFilePath(n);let l;(0,w.isFileOpenForWriteOptions)(r)&&(l=await this.createResourceLock(n));let a;try{if((0,w.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:M}=await f.SymlinkSupport.stat(s);M.mode&128||await f.Promises.chmod(s,M.mode|128)}catch(M){this.logService.trace(M)}let I;if((0,w.isFileOpenForWriteOptions)(r)){if(y.isWindows)try{await f.Promises.truncate(s,0),I="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}I||(I="w")}else I="r";a=await f.Promises.open(s,I)}catch(I){throw l?.dispose(),(0,w.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,I):this.toFileSystemProviderError(I)}if(this.mapHandleToPos.set(a,0),(0,w.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(a,n),l){const I=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,l),I&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),I.dispose())}return a}async close(n){const r=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await f.Promises.fdatasync(n)}catch(s){i.configureFlushOnWrite(!1),this.logService.error(s)}return await f.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}finally{r&&(this.mapHandleToLock.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),r.dispose())}}async read(n,r,s,l,a){const I=this.normalizePos(n,r);let M=null;try{M=(await f.Promises.read(n,s,l,a,I)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(n,I,M)}return M}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,s){const l=this.mapHandleToPos.get(n);typeof l=="number"&&(typeof r=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,l+s):this.mapHandleToPos.delete(n)))}async write(n,r,s,l,a){return(0,k.retry)(()=>this.doWrite(n,r,s,l,a),100,3)}async doWrite(n,r,s,l,a){const I=this.normalizePos(n,r);let M=null;try{M=(await f.Promises.write(n,s,l,a,I)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),T)}finally{this.updatePos(n,I,M)}return M}async mkdir(n){try{await f.Promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const s=this.toFilePath(n);r.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,r,s){const l=this.toFilePath(n),a=this.toFilePath(r);if(l!==a)try{await this.validateTargetDeleted(n,r,"move",s.overwrite),await f.Promises.move(l,a)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,P.localize)(2,null,(0,C.basename)(l),(0,C.basename)((0,C.dirname)(a)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(n,r,s){const l=this.toFilePath(n),a=this.toFilePath(r);if(l!==a)try{await this.validateTargetDeleted(n,r,"copy",s.overwrite),await f.Promises.copy(l,a,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,P.localize)(3,null,(0,C.basename)(l),(0,C.basename)((0,C.dirname)(a)),I.toString()))),this.toFileSystemProviderError(I)}}async validateTargetDeleted(n,r,s,l){const a=this.toFilePath(n),I=this.toFilePath(r);let M=!1;if(!!(this.capabilities&1024)||(M=(0,u.isEqual)(a,I,!0)),M&&s==="copy")throw(0,w.createFileSystemProviderError)((0,P.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!M&&await f.Promises.exists(I)){if(!l)throw(0,w.createFileSystemProviderError)((0,P.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(n,r){return this.doCloneFile(n,r,!1)}async doCloneFile(n,r,s){const l=this.toFilePath(n),a=this.toFilePath(r),I=!!(this.capabilities&1024);if((0,u.isEqual)(l,a,!I))return;const M=new p.DisposableStore;try{const[T,N]=await Promise.all([this.createResourceLock(n),this.createResourceLock(r)]);M.add(T),M.add(N),s&&await f.Promises.mkdir((0,C.dirname)(a),{recursive:!0}),await f.Promises.copyFile(l,a)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(n,r,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(n,r,s){return new g.UniversalWatcherClient(l=>n(l),l=>r(l),s)}createNonRecursiveWatcher(n,r,s){return new c.NodeJSWatcherClient(l=>n(l),l=>r(l),s)}toFileSystemProviderError(n){if(n instanceof w.FileSystemProviderError)return n;let r;switch(n.code){case"ENOENT":r=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=w.FileSystemProviderErrorCode.NoPermissions;break;default:r=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(n,r){let s=this.toFileSystemProviderError(r);if(n&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await f.SymlinkSupport.stat(this.toFilePath(n));l.mode&128||(s=(0,w.createFileSystemProviderError)(r,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return s}}e.DiskFileSystemProvider=i,i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0}),define(te[205],ie([0,1,3,86,2,18,58,23]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class u extends k.Disposable{constructor(y,E){super(),this.provider=y,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(y,E,h){const f=this.getUriTransformer(y);switch(E){case"stat":return this.stat(f,h[0]);case"readdir":return this.readdir(f,h[0]);case"open":return this.open(f,h[0],h[1]);case"close":return this.close(h[0]);case"read":return this.read(h[0],h[1],h[2]);case"readFile":return this.readFile(f,h[0],h[1]);case"write":return this.write(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.writeFile(f,h[0],h[1],h[2]);case"rename":return this.rename(f,h[0],h[1],h[2]);case"copy":return this.copy(f,h[0],h[1],h[2]);case"cloneFile":return this.cloneFile(f,h[0],h[1]);case"mkdir":return this.mkdir(f,h[0]);case"delete":return this.delete(f,h[0],h[1]);case"watch":return this.watch(f,h[0],h[1],h[2],h[3]);case"unwatch":return this.unwatch(h[0],h[1])}throw new Error(`IPC Command ${E} not found`)}listen(y,E,h){const f=this.getUriTransformer(y);switch(E){case"fileChange":return this.onFileChange(f,h[0]);case"readFileStream":return this.onReadFileStream(f,h[0],h[1])}throw new Error(`Unknown event ${E}`)}stat(y,E){const h=this.transformIncoming(y,E,!0);return this.provider.stat(h)}readdir(y,E){const h=this.transformIncoming(y,E);return this.provider.readdir(h)}async readFile(y,E,h){const f=this.transformIncoming(y,E,!0),P=await this.provider.readFile(f,h);return R.VSBuffer.wrap(P)}onReadFileStream(y,E,h){const f=this.transformIncoming(y,E,!0),P=new b.CancellationTokenSource,w=new S.Emitter({onLastListenerRemove:()=>{P.cancel()}}),m=this.provider.readFileStream(f,h,P.token);return(0,D.listenStream)(m,{onData:v=>w.fire(R.VSBuffer.wrap(v)),onError:v=>w.fire(v),onEnd:()=>{w.fire("end"),w.dispose(),P.dispose()}}),w.event}writeFile(y,E,h,f){const P=this.transformIncoming(y,E);return this.provider.writeFile(P,h.buffer,f)}open(y,E,h){const f=this.transformIncoming(y,E,!0);return this.provider.open(f,h)}close(y){return this.provider.close(y)}async read(y,E,h){const f=R.VSBuffer.alloc(h),P=0,w=await this.provider.read(y,E,f.buffer,P,h);return[f,w]}write(y,E,h,f,P){return this.provider.write(y,E,h.buffer,f,P)}mkdir(y,E){const h=this.transformIncoming(y,E);return this.provider.mkdir(h)}delete(y,E,h){const f=this.transformIncoming(y,E);return this.provider.delete(f,h)}rename(y,E,h,f){const P=this.transformIncoming(y,E),w=this.transformIncoming(y,h);return this.provider.rename(P,w,f)}copy(y,E,h,f){const P=this.transformIncoming(y,E),w=this.transformIncoming(y,h);return this.provider.copy(P,w,f)}cloneFile(y,E,h){const f=this.transformIncoming(y,E),P=this.transformIncoming(y,h);return this.provider.cloneFile(f,P)}onFileChange(y,E){const h=new S.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(y,h))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return h.event}async watch(y,E,h,f,P){const w=this.sessionToWatcher.get(E);if(w){const m=this.transformIncoming(y,f),v=w.watch(h,m,P);this.watchRequests.set(E+h,v)}}async unwatch(y,E){const h=y+E,f=this.watchRequests.get(h);f&&((0,k.dispose)(f),this.watchRequests.delete(h))}dispose(){super.dispose();for(const[,y]of this.watchRequests)y.dispose();this.watchRequests.clear();for(const[,y]of this.sessionToWatcher)y.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=u;class p extends k.Disposable{constructor(y,E,h,f){super(),this.uriTransformer=y,this.logService=h,this.environmentService=f,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(E)}registerListeners(y){const E=this._register(new S.Emitter);this._register(E.event(h=>{y.fire(h.map(f=>({resource:this.uriTransformer.transformOutgoingURI(f.resource),type:f.type})))})),this._register(this.fileWatcher.onDidChangeFile(h=>E.fire(h))),this._register(this.fileWatcher.onDidWatchError(h=>y.fire(h)))}getRecursiveWatcherOptions(y){}getExtraExcludes(y){}watch(y,E,h){const f=this.getExtraExcludes(this.environmentService);return Array.isArray(f)&&(h.excludes=[...h.excludes,...f]),this.watcherRequests.set(y,this.fileWatcher.watch(E,h)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(y)),this.watcherRequests.delete(y)})}dispose(){super.dispose();for(const[,y]of this.watcherRequests)y.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=p}),define(te[206],ie([0,1,15,161,4,7,14,9,205,140]),function(z,e,S,t,k,R,D,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class C extends u.AbstractDiskFileSystemProviderChannel{constructor(h,f,P){super(h,f),this.environmentService=P}getUriTransformer(h){return p.DefaultURITransformer}transformIncoming(h,f){return R.URI.revive(f)}async delete(h,f,P){if(!P.useTrash)return super.delete(h,f,P);const w=this.transformIncoming(h,f),m=(0,b.normalize)(w.fsPath);try{await S.shell.trashItem(m)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,b.basename)(m)):(0,t.localize)(1,null,(0,b.basename)(m)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(h,f){return new y(h,f,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=C;class y extends u.AbstractSessionFileWatcher{watch(h,f,P){if(P.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(h,f,P)}}}),define(te[108],ie([0,1,6]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case S.LogLevel.Trace:return R.trace;case S.LogLevel.Debug:return R.debug;case S.LogLevel.Info:return R.info;case S.LogLevel.Warning:return R.warn;case S.LogLevel.Error:return R.error;case S.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends S.AbstractLogger{constructor(D=S.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(b=>{this._logger?.setLevel(b)}))}set logger(D){this._logger=D;for(const{level:b,args:u}of this.buffer)t(D,b).apply(D,u);this.buffer=[]}_log(D,...b){this._logger?t(this._logger,D).apply(this._logger,b):this.getLevel()<=D&&this.buffer.push({level:D,args:b})}trace(D,...b){this._log(S.LogLevel.Trace,D,...b)}debug(D,...b){this._log(S.LogLevel.Debug,D,...b)}info(D,...b){this._log(S.LogLevel.Info,D,...b)}warn(D,...b){this._log(S.LogLevel.Warning,D,...b)}error(D,...b){this._log(S.LogLevel.Error,D,...b)}critical(D,...b){this._log(S.LogLevel.Critical,D,...b)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(te[207],ie([0,1,8,18,16,14,5,108,6]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*R.ByteSize.MB;let C=class extends u.AbstractLogger{constructor(h,f,P,w,m){super(),this.name=h,this.resource=f,this.donotUseFormatters=w,this.fileService=m,this.backupIndex=1,this.setLevel(P),this.queue=this._register(new S.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=u.LogLevel.Trace&&this._log(u.LogLevel.Trace,(0,u.format)(arguments))}debug(){this.getLevel()<=u.LogLevel.Debug&&this._log(u.LogLevel.Debug,(0,u.format)(arguments))}info(){this.getLevel()<=u.LogLevel.Info&&this._log(u.LogLevel.Info,(0,u.format)(arguments))}warn(){this.getLevel()<=u.LogLevel.Warning&&this._log(u.LogLevel.Warning,(0,u.format)(arguments))}error(){if(this.getLevel()<=u.LogLevel.Error){const h=arguments[0];if(h instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=h.stack,this._log(u.LogLevel.Error,(0,u.format)(f))}else this._log(u.LogLevel.Error,(0,u.format)(arguments))}}critical(){this.getLevel()<=u.LogLevel.Critical&&this._log(u.LogLevel.Critical,(0,u.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(h){if(h.fileOperationResult!==3)throw h}}_log(h,f){this.queue.queue(async()=>{await this.initializePromise;let P=await this.loadContent();P.length>p&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(P)),P=""),this.donotUseFormatters?P+=f:P+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(h)}] ${f}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(P))})}getCurrentTimestamp(){const h=w=>w<10?`0${w}`:w,f=w=>w<10?`00${w}`:w<100?`0${w}`:w,P=new Date;return`${P.getFullYear()}-${h(P.getMonth()+1)}-${h(P.getDate())} ${h(P.getHours())}:${h(P.getMinutes())}:${h(P.getSeconds())}.${f(P.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(h){switch(h){case u.LogLevel.Critical:return"critical";case u.LogLevel.Debug:return"debug";case u.LogLevel.Error:return"error";case u.LogLevel.Info:return"info";case u.LogLevel.Trace:return"trace";case u.LogLevel.Warning:return"warning"}return""}};C=ve([ee(4,R.IFileService)],C),e.FileLogger=C;let y=class extends u.AbstractLoggerService{constructor(h,f,P){super(h.getLevel(),h.onDidChangeLogLevel),this.instantiationService=f,this.fileService=P}doCreateLogger(h,f,P){const w=new b.BufferLogService(f);return(0,R.whenProviderRegistered)(h,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(C,P?.name||(0,k.basename)(h),h,w.getLevel(),!!P?.donotUseFormatters)),w}};y=ve([ee(0,u.ILogService),ee(1,D.IInstantiationService),ee(2,R.IFileService)],y),e.FileLoggerService=y}),define(te[208],ie([0,1,3,7,6]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(E){this.service=E,this.onDidChangeLogLevel=S.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,h){switch(h){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${h}`)}async call(E,h,f){switch(h){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${h}`)}}e.LogLevelChannel=R;class D{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){D.setLevel(this.channel,E)}static setLevel(E,h){return E.call("setLevel",h)}}e.LogLevelChannelClient=D;class b{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,h){throw new Error(`Event not found: ${h}`)}async call(E,h,f){switch(h){case"createLogger":this.createLogger(t.URI.revive(f[0]),f[1]);return;case"log":return this.log(t.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${h}`)}createLogger(E,h){this.loggers.set(E.toString(),this.loggerService.createLogger(E,h))}consoleLog(E,h){let f=console.log;switch(E){case k.LogLevel.Error:f=console.error;break;case k.LogLevel.Warning:f=console.warn;break;case k.LogLevel.Info:f=console.info;break}f.call(console,...h)}log(E,h){const f=this.loggers.get(E.toString());if(!f)throw new Error("Create the logger before logging");for(const[P,w]of h)(0,k.log)(f,P,w)}}e.LoggerChannel=b;class u extends k.AbstractLoggerService{constructor(E,h,f){super(E,h),this.channel=f}createConsoleMainLogger(){return new k.AdapterLogger({log:(E,h)=>{this.channel.call("consoleLog",[E,h])}})}doCreateLogger(E,h,f){return new p(this.channel,E,h,f)}}e.LoggerChannelClient=u;class p extends k.AbstractMessageLogger{constructor(E,h,f,P){super(P?.always),this.channel=E,this.file=h,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[h,P]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,h){const f=[[E,h]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(E){this.channel.call("log",[this.file,E])}}class C extends k.LogService{constructor(E,h){super(h),this.parent=E,this._register(E.onDidChangeLogLevel(f=>h.setLevel(f)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=C}),define(te[109],ie([0,1,14,6]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(b,u,p,C,y){try{const E=await new Promise((f,P)=>{z(["spdlog"],f,P)});E.setFlushOn(t.LogLevel.Trace);const h=await E.createAsyncRotatingLogger(b,u,p,C);return y&&h.clearFormatters(),h}catch(E){console.error(E)}return null}function R(b,u,p){switch(u){case t.LogLevel.Trace:b.trace(p);break;case t.LogLevel.Debug:b.debug(p);break;case t.LogLevel.Info:b.info(p);break;case t.LogLevel.Warning:b.warn(p);break;case t.LogLevel.Error:b.error(p);break;case t.LogLevel.Critical:b.critical(p);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(u,p,C,y,E){super(),this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(u,p,C,y),this._register(this.onDidChangeLogLevel(h=>{this._logger?.setLevel(h)}))}async _createSpdLogLogger(u,p,C,y){const E=C?6:1,h=30/E*S.ByteSize.MB,f=await k(u,p,h,E,y);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:P,message:w}of this.buffer)R(this._logger,P,w);this.buffer=[]}}log(u,p){this._logger?R(this._logger,u,p):this.getLevel()<=u&&this.buffer.push({level:u,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(te[209],ie([0,1,13,16,29,14,207,6,109]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends b.AbstractLoggerService{constructor(y,E){super(y.getLevel(),y.onDidChangeLogLevel),this.fileService=E}doCreateLogger(y,E,h){return y.scheme===S.Schemas.file?new u.SpdLogLogger(h?.name||(0,k.generateUuid)(),y.fsPath,!h?.donotRotate,!!h?.donotUseFormatters,E):new D.FileLogger(h?.name??(0,t.basename)(y),y,E,!!h?.donotUseFormatters,this.fileService)}};p=ve([ee(0,b.ILogService),ee(1,R.IFileService)],p),e.LoggerService=p}),define(te[210],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function S(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=S;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!S(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(te[37],ie([0,1,3,57,2,5]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(p){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...p,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(p),t.Iterable.reduce(this.policies.entries(),(y,[E,h])=>({...y,[E]:h}),{})}getPolicyValue(p){return this.policies.get(p)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(p,[C,y])=>({...p,[C]:{definition:y,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=D;class b{constructor(){this.onDidChange=S.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(te[211],ie([0,1,8,3,57,12,14,6,37]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function p(y,E){const h=[];for(const f of k.Iterable.concat(y.keys(),E.keys()))y.get(f)!==E.get(f)&&h.push(f);return h}let C=class extends u.AbstractPolicyService{constructor(E,h,f){super(),this.file=E,this.fileService=h,this.logService=f,this.throttledDelayer=this._register(new S.ThrottledDelayer(500));const P=t.Event.filter(h.onDidFilesChange,w=>w.affects(E));this._register(h.watch(E)),this._register(P(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(E){await this.refresh()}async read(){const E=new Map;try{const h=await this.fileService.readFile(this.file),f=JSON.parse(h.value.toString());if(!(0,R.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const P of Object.keys(f))this.policyDefinitions[P]&&E.set(P,f[P])}catch(h){h.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",h)}return E}async refresh(){const E=await this.read(),h=p(this.policies,E);this.policies=E,h.length>0&&this._onDidChange.fire(h)}};C=ve([ee(1,D.IFileService),ee(2,b.ILogService)],C),e.FilePolicyService=C}),define(te[212],ie([0,1,3,2,37]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(u){this.service=u,this.disposables=new t.DisposableStore}listen(u,p){switch(p){case"onDidChange":return S.Event.map(this.service.onDidChange,C=>C.reduce((y,E)=>({...y,[E]:this.service.getPolicyValue(E)??null}),{}),this.disposables)}throw new Error(`Event not found: ${p}`)}call(u,p,C){switch(p){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(C)}throw new Error(`Call not found: ${p}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(u,p){super(),this.channel=p;for(const C in u){const{definition:y,value:E}=u[C];this.policyDefinitions[C]=y,E!==void 0&&this.policies.set(C,E)}this.channel.listen("onDidChange")(C=>{for(const y in C){const E=C[y];E===null?this.policies.delete(y):this.policies.set(y,E)}this._onDidChange.fire(Object.keys(C))})}async initializePolicies(u){const p=await this.channel.call("registerPolicyDefinitions",u);for(const C in p)this.policies.set(C,p[C])}}e.PolicyChannelClient=D}),define(te[54],ie([0,1,13,4,34,16]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const b=t.globals.vscode.context.configuration();if(b)D=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const b=(0,R.dirname)(S.FileAccess.asFileUri("",z));if(D=z.__$__nodeRequire((0,R.joinPath)(b,"product.json").fsPath),k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const u=z.__$__nodeRequire((0,R.joinPath)(b,"package.json").fsPath);Object.assign(D,{version:u.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(te[20],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[213],ie([0,1,76,6,20]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(b,u){this.productService=b,this.logService=u,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,u){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(u);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",u),!1;const[,C,y]=p;let E=this.trustedExtensionUrlPublicKeys.get(b);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[b],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...E])}const h=Buffer.from(decodeURIComponent(y),"base64");if(h.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",u),!1;const f=h.slice(0,6),P=h.readUIntBE(0,6),w=Date.now()-P;if(w<0||w>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",u),!1;const m=h.slice(6),v=S.createVerify("SHA256");v.write(f),v.write(Buffer.from(C)),v.end();for(let d=0;d<E.length;d++){let g=E[d];if(g!==null){if(typeof g=="string")try{g=S.createPublicKey({key:Buffer.from(g,"base64"),format:"der",type:"spki"}),E[d]=g}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${b}:`,c),E[d]=null;continue}if(v.verify(g,m))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",u),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",u),!1}};R=ve([ee(0,k.IProductService),ee(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(te[214],ie([0,1,9,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var k;(function(R){function D(b,u="noAbsolutePaths"){for(const p of b.nodes)p.callFrame&&p.callFrame.url&&((0,S.isAbsolute)(p.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(p.callFrame.url))&&(p.callFrame.url=(0,S.join)(u,(0,S.basename)(p.callFrame.url)));return b}R.rewriteAbsolutePaths=D})(k=e.Utils||(e.Utils={}))}),define(te[61],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,S.createDecorator)("protocolMainService")}),define(te[47],ie([0,1,122,12]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,b){S.ok(t.isString(D)),S.ok(t.isObject(b)),S.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,b)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(te[215],ie([0,1,3,47]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,p){this.schemasById[k(u)]=p,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(te[62],ie([0,1,24,3,12,149,19,215,47]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var p;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(p=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=u.Registry.as(b.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=this.doRegisterConfigurations(i,o);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const o=this.doDeregisterConfigurations(i);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=[];n.push(...this.doDeregisterConfigurations(o)),n.push(...this.doRegisterConfigurations(i,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,S.distinct)(n)})}registerDefaultConfigurations(i){const o=[],n=[];for(const{overrides:r,source:s}of i)for(const l in r)if(o.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.configurationDefaultsOverrides.get(l),I=a?.valuesSources??new Map;if(s)for(const X of Object.keys(r[l]))I.set(X,s);const M={...a?.value||{},...r[l]};this.configurationDefaultsOverrides.set(l,{source:s,value:M,valuesSources:I});const T=(0,D.getLanguageTagSettingPlainKey)(l),N={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(s)?void 0:s,defaultValueSource:s};n.push(...P(l)),this.configurationProperties[l]=N,this.defaultLanguageConfigurationOverridesNode.properties[l]=N}else{this.configurationDefaultsOverrides.set(l,{value:r[l],source:s});const a=this.configurationProperties[l];a&&(this.updatePropertyDefaultValue(l,a),this.updateSchema(l,a))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const o=[];for(const{overrides:n,source:r}of i)for(const s in n){const l=this.configurationDefaultsOverrides.get(s),a=k.isString(r)?r:r?.id,I=k.isString(l?.source)?l?.source:l?.source?.id;if(a===I)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const M=this.configurationProperties[s];M&&(this.updatePropertyDefaultValue(s,M),this.updateSchema(s,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o){const n=[];return i.forEach(r=>{n.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),n}doDeregisterConfigurations(i){const o=[],n=r=>{if(r.properties)for(const s in r.properties){o.push(s);const l=this.configurationProperties[s];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>n(s))};for(const r of i){n(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(i,o=!0,n,r,s=3){s=k.isUndefinedOrNull(i.scope)?s:i.scope;const l=[],a=i.properties;if(a)for(const M in a){const T=a[M];if(o&&d(M,T)){delete a[M];continue}if(T.source=n,T.defaultDefaultValue=a[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!r?.includes(M):T.restricted),a[M].hasOwnProperty("included")&&!a[M].included){this.excludedConfigurationProperties[M]=a[M],delete a[M];continue}else this.configurationProperties[M]=a[M],a[M].policy?.name&&this.policyConfigurations.set(a[M].policy.name,M);!a[M].deprecationMessage&&a[M].markdownDeprecationMessage&&(a[M].deprecationMessage=a[M].markdownDeprecationMessage),l.push(M)}const I=i.allOf;if(I)for(const M of I)l.push(...this.validateAndRegisterProperties(M,o,n,r,s));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=n=>{const r=n.properties;if(r)for(const l in r)this.updateSchema(l,r[l]);n.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const n=this.configurationDefaultsOverrides.get(i);let r=n?.value,s=n?.source;k.isUndefined(r)&&(r=o.defaultDefaultValue,s=void 0),k.isUndefined(r)&&(r=m(o.type)),o.default=r,o.defaultValueSource=s}}const h="\\[([^\\]]+)\\]",f=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function P(c){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let o=f.exec(c);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=f.exec(c)}}return(0,S.distinct)(i)}e.overrideIdentifiersFromKey=P;function w(c){return c.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=w;function m(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new E;u.Registry.add(e.Extensions.Configuration,v);function d(c,i){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):v.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,c,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=d;function g(){const c=[],i=v.getConfigurationProperties();for(const o of Object.keys(i))c.push([o,i[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=g}),define(te[110],ie([0,1,24,3,43,2,31,50,12,7,19,62,47]),function(z,e,S,t,k,R,D,b,u,p,C,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class h{constructor(i={},o=[],n=[],r){this._contents=i,this._keys=o,this._overrides=n,this.raw=r,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof h)return o;const n=new f("");return n.parseRaw(o),n.configurationModel});this._rawConfiguration=i.reduce((o,n)=>n===o?n:o.merge(n),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,C.getConfigurationValue)(this.contents,i):this.contents}inspect(i,o){const n=this.rawConfiguration.getValue(i),r=o?this.rawConfiguration.getOverrideValue(i,o):void 0,s=o?this.rawConfiguration.override(o).getValue(i):n;return{value:n,override:r,merged:s}}getOverrideValue(i,o){const n=this.getContentsForOverrideIdentifer(o);return n?i?(0,C.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const n of this.overrides)n.identifiers.includes(i)&&o.push(...n.keys);return S.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return S.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=b.deepClone(this.contents),n=b.deepClone(this.overrides),r=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const l of i)if(s.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.mergeContents(o,l.contents);for(const a of l.overrides){const[I]=n.filter(M=>S.equals(M.identifiers,a.identifiers));I?(this.mergeContents(I.contents,a.contents),I.keys.push(...a.keys),I.keys=S.distinct(I.keys)):n.push(b.deepClone(a))}for(const a of l.keys)r.indexOf(a)===-1&&r.push(a)}return new h(o,r,n,s.every(l=>l instanceof h)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new h(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const n={};for(const r of S.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[r];const l=o[r];l&&(typeof s=="object"&&typeof l=="object"?(s=b.deepClone(s),this.mergeContents(s,l)):s=l),n[r]=s}return new h(n,this.keys,this.overrides)}mergeContents(i,o){for(const n of Object.keys(o)){if(n in i&&u.isObject(i[n])&&u.isObject(o[n])){this.mergeContents(i[n],o[n]);continue}i[n]=b.deepClone(o[n])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?b.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let o=null,n=null;const r=s=>{s&&(n?this.mergeContents(n,s):n=b.deepClone(s))};for(const s of this.overrides)S.equals(s.identifiers,[i])?o=s.contents:s.identifiers.includes(i)&&r(s.contents);return r(o),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,C.addToValueTree)(this.contents,i,o,n=>{throw new Error(n)})}removeValue(i){this.removeKey(i)&&(0,C.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let n=0;n<o;n++)i.indexOf(this.keys[n])===0&&(o=n);this.keys.splice(o,1,i)}removeKey(i){const o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=h;class f{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!u.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:n,keys:r,overrides:s,restricted:l,hasExcludedProperties:a}=this.doParseRaw(i,o);this._configurationModel=new h(n,r,s,a?[i]:void 0),this._restrictedConfigurations=l||[]}doParseContent(i){let o={},n=null,r=[];const s=[],l=[];function a(M){Array.isArray(r)?r.push(M):n!==null&&(r[n]=M)}const I={onObjectBegin:()=>{const M={};a(M),s.push(r),r=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const M=[];a(M),s.push(r),r=M,n=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:a,onError:(M,T,N)=>{l.push({error:M,offset:T,length:N})}};if(i)try{k.visit(i,I),o=r[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return o}doParseRaw(i,o){const n=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,n,!0,o);i=r.raw;const s=(0,C.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),l=Object.keys(i),a=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:s,keys:l,overrides:a,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(i,o,n,r){let s=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const l={},a=[];for(const I in i)if(y.OVERRIDE_PROPERTY_REGEX.test(I)&&n){const M=this.filter(i[I],o,!1,r);l[I]=M.raw,s=s||M.hasExcludedProperties,a.push(...M.restricted)}else{const M=o[I],T=M?typeof M.scope<"u"?M.scope:3:void 0;M?.restricted&&a.push(I),(T===void 0||r.scopes===void 0||r.scopes.includes(T))&&!(r.skipRestricted&&M?.restricted)?l[I]=i[I]:s=!0}return{raw:l,restricted:a,hasExcludedProperties:s}}toOverrides(i,o){const n=[];for(const r of Object.keys(i))if(y.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const l in i[r])s[l]=i[r][l];n.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,C.toValuesTree)(s,o)})}return n}}e.ConfigurationModelParser=f;class P extends R.Disposable{constructor(i,o,n,r){super(),this.userSettingsResource=i,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class w{constructor(i,o,n,r,s=new h,l=new h,a=new D.ResourceMap,I=new h,M=new D.ResourceMap,T=!0){this._defaultConfiguration=i,this._policyConfiguration=o,this._applicationConfiguration=n,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=l,this._folderConfigurations=a,this._memoryConfiguration=I,this._memoryConfigurationByResource=M,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(i,o,n){return this.getConsolidatedConfigurationModel(i,o,n).getValue(i)}updateValue(i,o,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new h,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(i):r.setValue(i,o),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,n){const r=this.getConsolidatedConfigurationModel(i,o,n),s=this.getFolderConfigurationModelForResource(o.resource,n),l=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,a=this._defaultConfiguration.inspect(i,o.overrideIdentifier),I=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(i),M=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(i),T=this.userConfiguration.freeze().inspect(i,o.overrideIdentifier),N=this.localUserConfiguration.freeze().inspect(i,o.overrideIdentifier),X=this.remoteUserConfiguration.freeze().inspect(i,o.overrideIdentifier),ae=n?this._workspaceConfiguration.freeze().inspect(i,o.overrideIdentifier):void 0,Q=s?s.freeze().inspect(i,o.overrideIdentifier):void 0,G=l.inspect(i,o.overrideIdentifier),Z=r.getValue(i),se=S.distinct(r.overrides.map(he=>he.identifiers).flat()).filter(he=>r.getOverrideValue(i,he)!==void 0);return{defaultValue:a?a.merged:void 0,policyValue:I?I.merged:void 0,applicationValue:M?M.merged:void 0,userValue:T?T.merged:void 0,userLocalValue:N?N.merged:void 0,userRemoteValue:X?X.merged:void 0,workspaceValue:ae?ae.merged:void 0,workspaceFolderValue:Q?Q.merged:void 0,memoryValue:G?G.merged:void 0,value:Z,default:a.value!==void 0||a.override!==void 0?{value:a.value,override:a.override}:void 0,policy:I?.value!==void 0?{value:I.value}:void 0,application:M?.value!==void 0||M?.override!==void 0?{value:M.value,override:M.override}:void 0,user:T.value!==void 0||T.override!==void 0?{value:T.value,override:T.override}:void 0,userLocal:N.value!==void 0||N.override!==void 0?{value:N.value,override:N.override}:void 0,userRemote:X.value!==void 0||X.override!==void 0?{value:X.value,override:X.override}:void 0,workspace:ae?.value!==void 0||ae?.override!==void 0?{value:ae.value,override:ae.override}:void 0,workspaceFolder:Q?.value!==void 0||Q?.override!==void 0?{value:Q.value,override:Q.override}:void 0,memory:G.value!==void 0||G.override!==void 0?{value:G.value,override:G.override}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const n=[];if(!o){const{added:r,updated:s,removed:l}=d(this._defaultConfiguration,i);o=[...r,...s,...l]}for(const r of o)for(const s of(0,y.overrideIdentifiersFromKey)(r)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(s),a=i.getKeysForOverrideIdentifier(s),I=[...a.filter(M=>l.indexOf(M)===-1),...l.filter(M=>a.indexOf(M)===-1),...l.filter(M=>!b.equals(this._defaultConfiguration.override(s).getValue(M),i.override(s).getValue(M)))];n.push([s,I])}return this.updateDefaultConfiguration(i),{keys:o,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:n,removed:r}=d(this._policyConfiguration,i),s=[...o,...n,...r];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=d(this.applicationConfiguration,i),l=[...o,...n,...r];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=d(this.localUserConfiguration,i),l=[...o,...n,...r];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=d(this.remoteUserConfiguration,i),l=[...o,...n,...r];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=d(this.workspaceConfiguration,i),l=[...o,...n,...r];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(i,o){const n=this.folderConfigurations.get(i),{added:r,updated:s,removed:l,overrides:a}=d(n,o),I=[...r,...s,...l];return(I.length||!n)&&this.updateFolderConfiguration(i,o),{keys:I,overrides:a}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:s,overrides:l}=d(o,void 0);return{keys:[...n,...r,...s],overrides:l}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,o,n){let r=this.getConsolidatedConfigurationModelForResource(o,n);return o.overrideIdentifier&&(r=r.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:i},o){let n=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const r=o.getFolder(i);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const s=this._memoryConfigurationByResource.get(i);s&&(n=n.merge(s))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(o=n.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=n}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const n=o.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:n,overrides:r,keys:s}=this._folderConfigurations.get(o);return i.push([o,{contents:n,overrides:r,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(n=>i.add(n))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.policy),r=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),l=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((I,M)=>(I.set(p.URI.revive(M[0]),this.parseConfigurationModel(M[1])),I),new D.ResourceMap);return new w(o,n,r,s,new h,l,a,new h,new D.ResourceMap,!1)}static parseConfigurationModel(i){return new h(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=w;function m(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,o=new Map;for(const r of c)r.keys.forEach(s=>i.add(s)),r.overrides.forEach(([s,l])=>{const a=(0,D.getOrSet)(o,s,new Set);l.forEach(I=>a.add(I))});const n=[];return o.forEach((r,s)=>n.push([s,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=m;class v{constructor(i,o,n,r){this.change=i,this.previous=o,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(a=>s.add(a)),i.overrides.forEach(([,a])=>a.forEach(I=>s.add(I))),this.affectedKeys=[...s.values()];const l=new h;this.affectedKeys.forEach(a=>l.setValue(a,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const n=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!b.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let n=(0,C.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(i=i[r],!i)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=v;function d(c,i){const{added:o,removed:n,updated:r}=g(i,c),s=[],l=c?.getAllOverrideIdentifiers()||[],a=i?.getAllOverrideIdentifiers()||[];if(i){const I=a.filter(M=>!l.includes(M));for(const M of I)s.push([M,i.getKeysForOverrideIdentifier(M)])}if(c){const I=l.filter(M=>!a.includes(M));for(const M of I)s.push([M,c.getKeysForOverrideIdentifier(M)])}if(i&&c){for(const I of l)if(a.includes(I)){const M=g({contents:c.getOverrideValue(void 0,I)||{},keys:c.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});s.push([I,[...M.added,...M.removed,...M.updated]])}}return{added:o,removed:n,updated:r,overrides:s}}function g(c,i){const o=c?i?c.keys.filter(s=>i.keys.indexOf(s)===-1):[...c.keys]:[],n=i?c?i.keys.filter(s=>c.keys.indexOf(s)===-1):[...i.keys]:[],r=[];if(c&&i){for(const s of i.keys)if(c.keys.indexOf(s)!==-1){const l=(0,C.getConfigurationValue)(i.contents,s),a=(0,C.getConfigurationValue)(c.contents,s);b.equals(l,a)||r.push(s)}}return{added:o,removed:n,updated:r}}}),define(te[216],ie([0,1,24,3,2,50,12,19,110,62,6,37,47]),function(z,e,S,t,k,R,D,b,u,p,C,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class h extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(E.Registry.as(p.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:d})=>this.onDidUpdateConfiguration(v,d))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(v,d){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=h;class f extends u.ConfigurationModel{constructor(v={}){const d=E.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),g=Object.keys(d),c=Object.create(null),i=[];for(const o in d){const n=v[o],r=n!==void 0?n:d[o].default;(0,b.addToValueTree)(c,o,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(c))p.OVERRIDE_PROPERTY_REGEX.test(o)&&i.push({identifiers:(0,p.overrideIdentifiersFromKey)(o),keys:Object.keys(c[o]),contents:(0,b.toValuesTree)(c[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(c,g,i)}}e.DefaultConfigurationModel=f;class P{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new u.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=P;let w=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(v,d,g){super(),this.defaultConfiguration=v,this.policyService=d,this.logService=g,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new u.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.registerPolicyDefinitions(v),!0))),this._configurationModel}async registerPolicyDefinitions(v){const d={},g=[],c=E.Registry.as(p.Extensions.Configuration).getConfigurationProperties();for(const i of v){const o=c[i];if(!o){g.push(i);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}g.push(i),d[o.policy.name]={type:o.type}}}return(0,D.isEmptyObject)(d)||await this.policyService.registerPolicyDefinitions(d),g}onDidChangePolicies(v){const d=E.Registry.as(p.Extensions.Configuration).getPolicyConfigurations(),g=(0,S.coalesce)(v.map(c=>d.get(c)));this.update(g,!0)}update(v,d){const g=E.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),c=[],i=this._configurationModel.isEmpty();for(const o of v){const n=g[o]?.policy?.name;if(n){const r=this.policyService.getPolicyValue(n);(i?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(o),r))&&c.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&c.push([o,void 0])}if(c.length){const o=this._configurationModel;this._configurationModel=new u.ConfigurationModel;for(const n of o.keys)this._configurationModel.setValue(n,o.getValue(n));for(const[n,r]of c)r===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,r);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=ve([ee(1,y.IPolicyService),ee(2,C.ILogService)],w),e.PolicyConfiguration=w}),define(te[217],ie([0,1,8,3,2,16,19,110,216,37]),function(z,e,S,t,k,R,D,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends k.Disposable{constructor(E,h,f,P){super(),this.settingsResource=E,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=f instanceof p.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,f,P)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,h)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:m})=>this.onDidDefaultConfigurationChange(w,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[E,h,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(E,h,new b.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(E,h){const f=typeof E=="string"?E:void 0,P=(0,D.isConfigurationOverrides)(E)?E:(0,D.isConfigurationOverrides)(h)?h:{};return this.configuration.getValue(f,P,void 0)}updateValue(E,h,f,P){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const h=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(f,h,2)}onDidDefaultConfigurationChange(E,h){const f=this.configuration.toData(),P=this.configuration.compareAndUpdateDefaultConfiguration(E,h);this.trigger(P,f,7)}onDidPolicyConfigurationChange(E){const h=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(E);this.trigger(f,h,7)}trigger(E,h,f){const P=new b.ConfigurationChangeEvent(E,{data:h},this.configuration);P.source=f,P.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(P)}getTargetConfiguration(E){switch(E){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(te[218],ie([0,1,17,5]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends S.ErrorNoTelemetry{static isTemporarilyNotAvailable(b){return b instanceof R&&b._code===k.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof R&&b._code===k.NoResolverFound}static isHandled(b){return b instanceof R&&b.isHandled}constructor(b,u=k.Unknown,p){super(b),this._message=b,this._code=u,this._detail=p,this.isHandled=u===k.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(te[63],ie([0,1,13]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(p){return p.scheme===S.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=t;function k(p){if(!p)return;const C=p.indexOf("+");return C<0?p:p.substr(0,C)}e.getRemoteName=k;function R(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(p){const{host:C,port:y}=u(p);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:y}}e.parseAuthorityWithPort=D;function b(p,C){let{host:y,port:E}=u(p);return typeof E>"u"&&(E=C),{host:y,port:E}}e.parseAuthorityWithOptionalPort=b;function u(p){const C=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const y=p.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const E=p.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:p,port:void 0}}}),define(te[111],ie([0,1,26,5,63]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=R;function D(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var u;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(u=e.TargetPlatform||(e.TargetPlatform={}));class p{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,w){if(typeof P>"u"||P===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof P=="string"||typeof w=="string"){const m=typeof P=="string"?P:P.value,v=typeof w=="string"?w:w.value;return S.equalsIgnoreCase(m,v)}return P._lower===w._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=p;function C(f){return y(f)}e.isApplicationScopedExtension=C;function y(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function E(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function h(f,P){if(P){const w=`onResolveRemoteAuthority:${(0,k.getRemoteName)(P)}`;return f.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[112],ie([0,1,26,192,111,4,7,17,34]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,S.compareIgnoreCase)(o.id,n.id)===0}e.areSameExtensions=p;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(n){const r=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new y(n.identifier,r,s)}static parse(n){const r=C.exec(n);return r&&r[1]&&r[2]?new y({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof y?p(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=y;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(o){const n=E.exec(o);return n&&n[1]?[P(n[1]),n[2]]:[P(o),void 0]}e.getIdAndVersion=h;function f(o,n){return`${o}.${n}`}e.getExtensionId=f;function P(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function w(o,n){return P(f(o,n))}e.getGalleryExtensionId=w;function m(o,n){const r=[],s=l=>{for(const a of r)if(a.some(I=>p(n(I),n(l))))return a;return null};for(const l of o){const a=s(l);a?a.push(l):r.push([l])}return r}e.groupByExtension=m;function v(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function d(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(o,n){const r=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&r.every(a=>!p(a.identifier,{id:l}))){const a=o.filter(I=>p(I.identifier,{id:l}));a.length===1&&(r.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=g;async function c(o,n){if(!R.isLinux)return!1;let r;try{r=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function i(o,n){const r=await c(o,n),s=(0,t.getTargetPlatform)(r?"alpine":R.platform,u.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(te[72],ie([0,1,8,18,2,31,7,112,14,5,6]),function(z,e,S,t,k,R,D,b,u,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let y=class extends k.Disposable{constructor(h,f){super(),this.fileService=h,this.logService=f,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(h){return this.withProfileExtensions(h)}addExtensionsToProfile(h,f){return this.withProfileExtensions(f,P=>(P=P.filter(w=>h.some(([m])=>!(0,b.areSameExtensions)(w.identifier,m.identifier))),P.push(...h.map(([w,m])=>({identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:m}))),P))}removeExtensionFromProfile(h,f){return this.withProfileExtensions(f,P=>P.filter(w=>!(0,b.areSameExtensions)(w.identifier,h)))}async withProfileExtensions(h,f){return this.getResourceAccessQueue(h).queue(async()=>{let P=[];try{const w=await this.fileService.readFile(h),m=JSON.parse(w.value.toString());for(const v of m){if(!v.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",v);continue}if(!v.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",v);continue}if(!v.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",v);continue}P.push({identifier:v.identifier,location:D.URI.revive(v.location),version:v.version,metadata:v.metadata})}}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}if(f){P=f(P);const w=P.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.fileService.writeFile(h,t.VSBuffer.fromString(JSON.stringify(w)))}return P})}getResourceAccessQueue(h){let f=this.resourcesAccessQueueMap.get(h);return f||(f=new S.Queue,this.resourcesAccessQueueMap.set(h,f)),f}};y=ve([ee(0,u.IFileService),ee(1,C.ILogService)],y),e.ExtensionsProfileScannerService=y}),define(te[219],ie([0,1,8,18,23,17,3,2,29,101,218,63]),function(z,e,S,t,k,R,D,b,u,p,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var h;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(h=e.ConnectionType||(e.ConnectionType={}));function f(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function P(B){const $=new k.CancellationTokenSource;return setTimeout(()=>$.cancel(),B),$.token}function w(B,$){if(B.isCancellationRequested||$.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),$.onCancellationRequested(()=>L.cancel()),L.token}class m{get didTimeout(){return this._state==="timedout"}constructor($){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),$.isCancellationRequested?this._timeout():this._disposables.add($.onCancellationRequested(()=>this._timeout()))}registerDisposable($){this._state==="pending"?this._disposables.add($):$.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise($))}reject($){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise($))}}function v(B,$){const L=new m($);return L.registerDisposable(B.onControlMessage(O=>{const _=JSON.parse(O.toString()),j=W(_);j?L.reject(j):L.resolve(_)})),L.promise}function d(B,$,L,O,_,j,Y,oe){const q=new m(oe);return $.connect(L,O,_,j,Y,(re,ne)=>{q.didTimeout?(re&&B.error(re),ne?.dispose()):re||!ne?q.reject(re):q.resolve(ne)}),q.promise}function g(B,$){const L=new m($);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function c(B,$,L,O){const _=U(B,$);B.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let j;try{j=await d(B.logService,B.socketFactory,B.host,B.port,(0,y.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${f($)}-${B.reconnectionToken}`,O)}catch(ne){throw B.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ne),ne}B.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let Y,oe;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(j,null),Y=B.reconnectionProtocol,oe=!1):(Y=new p.PersistentProtocol(j,null),oe=!0),B.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const q=await g(B.signService.createNewMessage((0,u.generateUuid)()),O),re={type:"auth",auth:B.connectionToken||"00000000000000000000",data:q.data};Y.sendControl(t.VSBuffer.fromString(JSON.stringify(re)));try{const ne=await v(Y,w(O,P(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(B.logService.trace(`${_} 4/6. received SignRequest control message.`),!await g(B.signService.validate(q,ne.signedData),O)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const ge=await g(B.signService.sign(ne.data),O),De={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:$};return L&&(De.args=L),B.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:Y,ownsProtocol:oe}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(B.logService.error(`${_} the handshake timed out. Error:`),B.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${_} received error control message when negotiating connection. Error:`),B.logService.error(ne)),oe&&H(Y),ne}}async function i(B,$,L,O){const _=Date.now(),j=U(B,$),{protocol:Y,ownsProtocol:oe}=await c(B,$,L,O),q=new m(O);return q.registerDisposable(Y.onControlMessage(re=>{const ne=JSON.parse(re.toString()),ce=W(ne);ce?(B.logService.error(`${j} received error control message when negotiating connection. Error:`),B.logService.error(ce),oe&&H(Y),q.reject(ce)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${J(_)}!`),q.resolve({protocol:Y,firstMessage:ne}))})),q.promise}async function o(B,$){const{protocol:L}=await i(B,1,void 0,$);return{protocol:L}}async function n(B,$,L){const{protocol:O,firstMessage:_}=await i(B,2,$,L),j=_&&_.debugPort;return{protocol:O,debugPort:j}}async function r(B,$,L){const O=Date.now(),_=U(B,3),{protocol:j}=await c(B,3,$,L);return B.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${J(O)}!`),j}async function s(B,$,L){const{host:O,port:_,connectionToken:j}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:_,connectionToken:j,reconnectionToken:$,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function l(B,$,L){return I(B,async O=>{const{protocol:_}=await o(O,k.CancellationToken.None);return new he(B,$,L,O.reconnectionToken,_)})}e.connectRemoteAgentManagement=l;async function a(B,$){return I(B,async L=>{const{protocol:O,debugPort:_}=await n(L,$,k.CancellationToken.None);return new V(B,$,L.reconnectionToken,O,_)})}e.connectRemoteAgentExtensionHost=a;async function I(B,$){for(let O=1;;O++)try{const _=(0,u.generateUuid)(),j=await s(B,_,null);return await $(j)}catch(_){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(_);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(_),se.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(_)),_}}async function M(B,$,L){const O=await s(B,(0,u.generateUuid)(),null);return await r(O,{host:$,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(B){return(0,S.createCancelablePromise)($=>new Promise((L,O)=>{const _=setTimeout(L,B*1e3);$.onCancellationRequested(()=>{clearTimeout(_),L()})}))}var N;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class X{constructor($,L){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=X;class ae{constructor($,L,O,_){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=ae;class Q{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=Q;class G{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=G;class Z{constructor($,L,O,_){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=Z;class se extends b.Disposable{static triggerPermanentFailure($,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=$,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach($=>$._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach($=>$._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}constructor($,L,O,_,j){super(),this._connectionType=$,this._options=L,this.reconnectionToken=O,this.protocol=_,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new G(this.reconnectionToken,0,0)),this._register(_.onSocketClose(Y=>{const oe=F(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(Y=>{const oe=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,b.toDisposable)(()=>{const Y=se._instances.indexOf(this);Y>=0&&se._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const $=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const _=O<L.length?L[O]:L[L.length-1];try{if(_>0){const Y=T(_);this._onDidStateChange.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,Y)),this._options.logService.info(`${$} waiting for ${_} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${$} resolving connection...`);const j=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${$} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,P(E)),this._options.logService.info(`${$} reconnected!`),this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,R.isCancellationError)(j)){this._options.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,C.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure($,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure($,L,O):this._gotoPermanentFailure($,L,O)}_gotoPermanentFailure($,L,O){this._onDidStateChange.fire(new Z(this.reconnectionToken,$,L,O)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class he extends se{constructor($,L,O,_,j){super(1,$,_,j,!0),this.client=this._register(new p.Client(j,{remoteAuthority:L,clientId:O},$.ipcLogger))}async _reconnect($,L){await o($,L)}}e.ManagementPersistentConnection=he;class V extends se{constructor($,L,O,_,j){super(2,$,O,_,!1),this._startArguments=L,this.debugPort=j}async _reconnect($,L){await n($,this._startArguments,L)}}e.ExtensionHostPersistentConnection=V;function H(B){try{B.acceptDisconnect();const $=B.getSocket();B.dispose(),$.dispose()}catch($){(0,R.onUnexpectedError)($)}}function W(B){if(B&&B.type==="error"){const $=new Error(`Connection error: ${B.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function A(B,$){for(;B.length<$;)B+=" ";return B}function F(B,$,L){return`[remote-connection][${A(f(B),13)}][${$.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function U(B,$){return`${F($,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function J(B){return`${Date.now()-B} ms`}}),define(te[220],ie([0,1,77,83]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,b,u,p){const C=E=>p(E,void 0),y=S.createConnection({host:k,port:R},()=>{y.removeListener("error",C);const E=Buffer.alloc(16);for(let w=0;w<16;w++)E[w]=Math.round(Math.random()*256);const h=E.toString("base64"),f=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];y.write(f.join(`\r
`)+`\r
\r
`);const P=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",P),p(void 0,new t.NodeSocket(y,u)))};y.on("data",P)});y.setNoDelay(!0),y.once("error",C)}}}),define(te[221],ie([0,1,25,45,40,183]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function b(h=!1){return(D===void 0||h)&&(D=u()),D}e.hasWSLFeatureInstalled=b;async function u(){const h=p();if(h===void 0)return!1;if(h>=22e3){const f=y();if(f)return new Promise(P=>{t.execFile(f,["--status"],w=>P(!w))})}else{const f=E();if(f)try{if((await k.promises.stat(f)).isFile())return!0}catch{}}return!1}function p(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(h)return parseInt(h[3])}function C(h){const f=process.env.SystemRoot;if(f){const P=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,P?"Sysnative":"System32",h)}}function y(){return C("wsl.exe")}function E(){return C("lxss\\LxssManager.dll")}}),define(te[55],ie([0,1,18,166,62,5,47]),function(z,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function b(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}e.isSuccess=b;function u(P){return P.res.statusCode===204}async function p(P){return u(P)?null:(await(0,S.streamToBuffer)(P.stream)).toString()}e.asText=p;async function C(P){if(!b(P))throw new Error("Server returned "+P.res.statusCode);return p(P)}e.asTextOrError=C;async function y(P){if(!b(P))throw new Error("Server returned "+P.res.statusCode);if(u(P))return null;const m=(await(0,S.streamToBuffer)(P.stream)).toString();try{return JSON.parse(m)}catch(v){throw v.message+=`:
`+m,v}}e.asJson=y;function E(P){f(P)}e.updateProxyConfigurationsScope=E;let h;function f(P){const w=D.Registry.as(k.Extensions.Configuration),m=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[h],remove:m?[m]:[]})}f(2)}),define(te[222],ie([0,1,18,23]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(b){this.service=b}listen(b,u){throw new Error("Invalid listen")}call(b,u,p,C=t.CancellationToken.None){switch(u){case"request":return this.service.request(p[0],C).then(async({res:y,stream:E})=>{const h=await(0,S.streamToBuffer)(E);return[{statusCode:y.statusCode,headers:y.headers},h]});case"resolveProxy":return this.service.resolveProxy(p[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(b){this.channel=b}async request(b,u){const[p,C]=await this.channel.call("request",[b],u);return{res:p,stream:(0,S.bufferToStream)(C)}}async resolveProxy(b){return this.channel.call("resolveProxy",[b])}}e.RequestChannelClient=R}),define(te[223],ie([0,1,224,12]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,b){return D.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:D.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function R(D,b,u={}){const p=(0,S.parse)(D),C=u.proxyUrl||k(p,b);if(!C)return null;const y=(0,S.parse)(C);if(!/^https?:$/.test(y.protocol||""))return null;const E={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,t.isBoolean)(u.strictSSL)?u.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((h,f)=>{z(["http-proxy-agent"],h,f)}))(E):new(await new Promise((h,f)=>{z(["https-proxy-agent"],h,f)}))(E)}e.getProxyAgent=R}),define(te[113],ie([0,1,45,9,167,23,44,17,4,29,143,59,8]),function(z,e,S,t,k,R,D,b,u,p,C,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const h=1e4;let f;async function P(m,v,d){return v["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(d)&&!v["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(d)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=E.Promises.withAsyncBody(async(g,c)=>{const i=new R.CancellationTokenSource,o=setTimeout(()=>{i.dispose(!0),c(new Error((0,k.localize)(0,null)))},h);try{g(await w(m,i.token))}catch(n){!(0,b.isCancellationError)(n)&&!i.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(n)))):g({})}finally{clearTimeout(o),i.dispose()}})),f)}e.getResolvedShellEnv=P;async function w(m,v){const d=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",d);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",g);const c=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",o);const n=await(0,C.getSystemShell)(u.OS,o);return m.trace("getUnixShellEnvironment#shell",n),new Promise((r,s)=>{if(v.isCancellationRequested)return s((0,b.canceled)());const l=(0,t.basename)(n);let a,I;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,I=["-Login","-Command"]):(a=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"?I=["-ic"]:I=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),a);const T=(0,S.spawn)(n,[...I,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});v.onCancellationRequested(()=>(T.kill(),s((0,b.canceled)()))),T.on("error",ae=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ae)),s(ae)});const N=[];T.stdout.on("data",ae=>N.push(ae));const X=[];T.stderr.on("data",ae=>X.push(ae)),T.on("close",(ae,Q)=>{const G=Buffer.concat(N).toString("utf8");m.trace("getUnixShellEnvironment#raw",G);const Z=Buffer.concat(X).toString("utf8");if(Z.trim()&&m.trace("getUnixShellEnvironment#stderr",Z),ae||Q)return s(new Error((0,k.localize)(2,null,ae,Q)));const se=i.exec(G),he=se?se[1]:"{}";try{const V=JSON.parse(he);d?V.ELECTRON_RUN_AS_NODE=d:delete V.ELECTRON_RUN_AS_NODE,g?V.ELECTRON_NO_ATTACH_CONSOLE=g:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",V),r(V)}catch(V){m.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(V)),s(V)}})})}}),define(te[87],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,S.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[225],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class S{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>z(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const b=String(S._nextId++);return this.validators.set(b,D),{id:b,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=S,S._nextId=1}),define(te[38],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,S.createDecorator)("stateMainService")}),define(te[22],ie([0,1,15,41,8,3,2,4,34,12,5,6,38,27]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,C.createDecorator)("lifecycleMainService");var f;(function(m){m[m.QUIT=1]="QUIT",m[m.KILL=2]="KILL"})(f=e.ShutdownReason||(e.ShutdownReason={}));var P;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen",m[m.Eventually=4]="Eventually"})(P=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let w=class Ct extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(v,d,g){super(),this.logService=v,this.stateMainService=d,this.environmentMainService=g,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Ct.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),b.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};S.app.addListener("before-quit",v);const d=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!b.isMacintosh)&&S.app.quit()};S.app.addListener("window-all-closed",d),S.app.once("will-quit",g=>{this.trace("Lifecycle#app.on(will-quit)"),g.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),S.app.removeListener("before-quit",v),S.app.removeListener("window-all-closed",d),S.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const d=[];return this._onWillShutdown.fire({reason:v,join(g){d.push(g)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(d)}catch(g){this.logService.error(g)}try{await this.stateMainService.close()}catch(g){this.logService.error(g)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const d=this.phaseWhen.get(this._phase);d&&(d.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let d=this.phaseWhen.get(v);d||(d=new k.Barrier,this.phaseWhen.set(v,d)),await d.wait()}registerWindow(v){const d=new D.DisposableStore;this.windowCounter++,d.add(v.onWillLoad(c=>this._onWillLoadWindow.fire({window:v,workspace:c.workspace,reason:c.reason})));const g=(0,p.assertIsDefined)(v.win);g.on("close",c=>{const i=v.id;if(this.windowToCloseRequest.has(i)){this.windowToCloseRequest.delete(i);return}this.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),c.preventDefault(),this.unload(v,1).then(o=>{if(o){this.windowToCloseRequest.delete(i);return}this.windowToCloseRequest.add(i),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this._onBeforeCloseWindow.fire(v),v.close()})}),g.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,d.dispose(),this.windowCounter===0&&(!b.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(v,d){await this.unload(v,3)||v.reload(d)}unload(v,d){const g=this.mapWindowIdToPendingUnload.get(v.id);if(g)return g;const c=this.doUnload(v,d).finally(()=>{this.mapWindowIdToPendingUnload.delete(v.id)});return this.mapWindowIdToPendingUnload.set(v.id,c),c}async doUnload(v,d){if(!v.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${v.id}`);const g=this._quitRequested?2:d,c=await this.onBeforeUnloadWindowInRenderer(v,g);return c?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(c)):(await this.onWillUnloadWindowInRenderer(v,g),!1)}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,d){return new Promise(g=>{const c=this.oneTimeListenerTokenGenerator++,i=`vscode:ok${c}`,o=`vscode:cancel${c}`;t.validatedIpcMain.once(i,()=>{g(!1)}),t.validatedIpcMain.once(o,()=>{g(!0)}),v.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:o,reason:d})})}onWillUnloadWindowInRenderer(v,d){return new Promise(g=>{const i=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(i,()=>g()),v.send("vscode:onWillUnload",{replyChannel:i,reason:d})})}quit(v){return this.trace(`Lifecycle#quit() - begin (willRestart: ${v})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(v&&this.stateMainService.setItem(Ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(d=>{this.pendingQuitPromiseResolve=d,this.trace("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.pendingQuitPromise)}trace(v){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(v):this.logService.trace(v)}async relaunch(v){this.trace("Lifecycle#relaunch()");const d=process.argv.slice(1);if(v?.addArgs&&d.push(...v.addArgs),v?.removeArgs)for(const i of v.removeArgs){const o=d.indexOf(i);o>=0&&d.splice(o,1)}const g=()=>{try{if(b.isWindows){const i=(0,u.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.logService.error(i)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:d})};S.app.once("quit",g),await this.quit(!0)&&S.app.removeListener("quit",g)}async kill(v){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const d of S.BrowserWindow.getAllWindows())if(d&&!d.isDestroyed()){let g;d.webContents&&!d.webContents.isDestroyed()?g=new Promise(c=>d.once("closed",c)):g=Promise.resolve(),d.destroy(),await g}})()]),S.app.exit(v)}};w.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",w=ve([ee(0,y.ILogService),ee(1,E.IStateMainService),ee(2,h.IEnvironmentMainService)],w),e.LifecycleMainService=w}),define(te[226],ie([0,1,4,3,2,5,22]),function(z,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let b=class extends k.Disposable{constructor(C){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,C.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const C=await new Promise((y,E)=>{z(["native-keymap"],y,E)});this._keyboardLayoutData=u(C),S.isCI||C.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=u(C),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};b=ve([ee(0,D.ILifecycleMainService)],b),e.KeyboardLayoutMainService=b;function u(p){const C=p.getKeyMap(),y=p.getCurrentKeyboardLayout();return{keyboardMapping:C,keyboardLayoutInfo:y}}}),define(te[227],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,S.createDecorator)("stateService")}),define(te[228],ie([0,1,8,18,12,36,14,6]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class u{constructor(y,E,h){this.storagePath=y,this.logService=E,this.fileService=h,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new S.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,E){const h=this.storage[y];return(0,k.isUndefinedOrNull)(h)?E:h}setItem(y,E){this.setItems([{key:y,data:E}])}setItems(y){let E=!1;for(const{key:h,data:f}of y)this.storage[h]!==f&&((0,k.isUndefinedOrNull)(f)?(0,k.isUndefined)(this.storage[h])||(this.storage[h]=void 0,E=!0):(this.storage[h]=f,E=!0));E&&this.save()}removeItem(y){(0,k.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(E){this.logService.error(E)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=u;let p=class{constructor(y,E,h){this.fileStorage=new u(y.stateResource,E,h)}async init(){await this.fileStorage.init()}getItem(y,E){return this.fileStorage.getItem(y,E)}};p=ve([ee(0,R.IEnvironmentService),ee(1,b.ILogService),ee(2,D.IFileService)],p),e.StateService=p}),define(te[229],ie([0,1,228]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends S.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(te[114],ie([0,1,4,34,7,29]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(p){if(S.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function b(p,C,y,E,h,f,P,w,m,v){const d=Object.create(null);d["common.machineId"]=P,d.sessionID=(0,R.generateUuid)()+Date.now(),d.commitHash=h,d.version=f,d["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,S.PlatformToString)(S.platform),d["common.nodePlatform"]=t.platform,d["common.nodeArch"]=E,d["common.product"]=v||"desktop",w&&(d["common.msftInternal"]=w);let g=0;const c=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),S.isLinuxSnap&&(d["common.snap"]="true");const i=D(y);i&&(d["common.platformDetail"]=i);try{const o=await p.readFile(k.URI.file(m));d["common.source"]=o.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=b;function u(p){const C=t.env.USERDNSDOMAIN;if(!C)return!1;const y=C.toLowerCase();return p.some(E=>y===E)}e.verifyMicrosoftInternalDomain=u}),define(te[32],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[230],ie([0,1,25,57,8,43,13,9,4,7,81,21,100,84,14,20,32]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function v(o,n){const r=`${o}::${n.join(":")}`,s=m.get(r);if(s)return s;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,I=new Map,M=2e4;function T(X,ae,Q,G){const Z=ae.substring(X.length+1);return k.Promises.withAsyncBody(async se=>{let he;try{he=await y.Promises.readdir(ae,{withFileTypes:!0})}catch{se();return}if(G.count>=M){G.count+=he.length,G.maxReached=!0,se();return}let V=he.length;if(V===0){se();return}let H=he;G.count+he.length>M&&(G.maxReached=!0,V=M-G.count,H=he.slice(0,V)),G.count+=he.length;for(const W of H)if(W.isDirectory()){if(Q.includes(W.name)||await T(X,(0,b.join)(ae,W.name),Q,G),--V===0){se();return}}else{const A=W.name.lastIndexOf(".");if(A>=0){const F=W.name.substring(A+1);F&&a.set(F,(a.get(F)??0)+1)}for(const F of l)F.relativePathPattern?.test(Z)!==!1&&F.filePattern.test(W.name)&&I.set(F.tag,(I.get(F.tag)??0)+1);if(--V===0){se();return}}})}const N=k.Promises.withAsyncBody(async X=>{const ae={count:0,maxReached:!1};await T(o,o,n,ae);const Q=await c(o);X({configFiles:d(I),fileTypes:d(a),fileCount:ae.count,maxFilesReached:ae.maxReached,launchConfigFiles:Q})});return m.set(r,N),N}e.collectWorkspaceStats=v;function d(o){return[...t.Iterable.map(o.entries(),([n,r])=>({name:n,count:r}))].sort((n,r)=>r.count-n.count)}function g(){const o={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},n=S.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}e.getMachineInfo=g;async function c(o){try{const n=new Map,r=(0,b.join)(o,".vscode","launch.json"),s=await y.Promises.readFile(r),l=[],a=(0,R.parse)(s.toString(),l);if(l.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(a)==="object"&&a.configurations)for(const I of a.configurations){const M=I.type;M&&(n.has(M)?n.set(M,n.get(M)+1):n.set(M,1))}return d(n)}catch{return[]}}e.collectLaunchConfigs=c;let i=class{constructor(n,r){this.telemetryService=n,this.productService=r}formatMachineInfo(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}formatEnvironment(n){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const s=S.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),u.isWindows||r.push(`Load (avg):       ${S.loadavg().map(l=>Math.round(l)).join(", ")}`),r.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,E.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async s=>{let[l,a]=s,I=this.formatProcessList(n,l);return r.forEach(M=>{if((0,h.isRemoteDiagnosticError)(M))I+=`
${M.errorMessage}`,a+=`
${M.errorMessage}`;else if(I+=`

Remote: ${M.hostName}`,M.processes&&(I+=`
${this.formatProcessList(n,M.processes)}`),M.workspaceMetadata){a+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const N=M.workspaceMetadata[T];let X=`${N.fileCount} files`;N.maxFilesReached&&(X=`more than ${X}`),a+=`|    Folder (${T}): ${X}`,a+=this.formatWorkspaceStats(N)}}}),{processInfo:I,workspaceInfo:a}})}async getSystemInfo(n,r){const{memory:s,vmHint:l,os:a,cpus:I}=g(),M={os:a,memory:s,cpus:I,vmHint:l,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return u.isWindows||(M.load=`${S.loadavg().map(T=>Math.round(T)).join(", ")}`),u.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(n,r){const s=[];return(0,E.listProcesses)(n.mainPID).then(async l=>(s.push(""),s.push(this.formatEnvironment(n)),s.push(""),s.push(this.formatProcessList(n,l)),n.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(n))),r.forEach(a=>{if((0,h.isRemoteDiagnosticError)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.formatMachineInfo(a.machineInfo)),a.processes&&s.push(this.formatProcessList(n,a.processes)),a.workspaceMetadata)for(const I of Object.keys(a.workspaceMetadata)){const M=a.workspaceMetadata[I];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${I}): ${T}`),s.push(this.formatWorkspaceStats(M))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(n){const r=[];let l=0;const a=(N,X)=>{const ae=` ${N}(${X})`;l+ae.length>60?(r.push(I),I="|                 ",l=I.length):l+=ae.length,I+=ae};let I="|      File types:";const M=10,T=n.fileTypes.length>M?M:n.fileTypes.length;for(let N=0;N<T;N++){const X=n.fileTypes[N];a(X.name,X.count)}if(r.push(I),n.configFiles.length>=0&&(I="|      Conf files:",l=0,n.configFiles.forEach(N=>{a(N.name,N.count)}),r.push(I)),n.launchConfigFiles.length>0){let N="|      Launch Configs:";n.launchConfigFiles.forEach(X=>{N+=X.count>1?` ${X.name}(${X.count})`:` ${X.name}`}),r.push(N)}return r.join(`
`)}expandGPUFeatures(n){const r=Math.max(...Object.keys(n).map(s=>s.length));return Object.keys(n).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${n[s]}`).join(`
                  `)}formatWorkspaceMetadata(n){const r=[],s=[];return n.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(r.push(`|  Window (${l.title})`),l.folderURIs.forEach(a=>{const I=p.URI.revive(a);if(I.scheme===D.Schemas.file){const M=I.fsPath;s.push(v(M,["node_modules",".git"]).then(T=>{let N=`${T.fileCount} files`;T.maxFilesReached&&(N=`more than ${N}`),r.push(`|    Folder (${(0,b.basename)(M)}): ${N}`),r.push(this.formatWorkspaceStats(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else r.push(`|    Folder (${I.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(l=>r.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(n,r){const s=new Map;n.windows.forEach(a=>s.set(a.pid,a.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(n.mainPID,s,l,r,0),l.join(`
`)}formatProcessItem(n,r,s,l,a){const I=a===0;let M;I?M=l.pid===n?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(a)} ${l.name}`,l.name==="window"&&(M=`${M} (${r.get(l.pid)})`));const T=process.platform==="win32"?l.mem:S.totalmem()*(l.mem/100);s.push(`${l.load.toFixed(0).padStart(5," ")}	${(T/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(l.children)&&l.children.forEach(N=>this.formatProcessItem(n,r,s,N,a+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:s}of n.folders){const l=p.URI.revive(s);if(l.scheme!==D.Schemas.file)continue;const a=l.fsPath;try{(await v(a,["node_modules",".git"])).fileTypes.forEach(M=>r.add(M.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const s=p.URI.revive(r);if(s.scheme!==D.Schemas.file)continue;const l=s.fsPath;try{const a=await v(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),a.fileTypes.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:I.name,count:I.count})}),a.launchConfigFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:I.name,count:I.count})}),a.configFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:I.name,count:I.count})})}catch{}}}};i=ve([ee(0,w.ITelemetryService),ee(1,P.IProductService)],i),e.DiagnosticsService=i}),define(te[231],ie([0,1,8,2,6,21,25,9,32,214]),function(z,e,S,t,k,R,D,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;class C{constructor(h,f){this.node=h,this.callFrame=f,this.children=[],this.selfTime=-1,this.totalTime=-1}toString(){return`${this.callFrame.url}#${this.callFrame.functionName}@${this.callFrame.lineNumber}:${this.callFrame.columnNumber}`}static makeTotals(h){if(h.totalTime!==-1)return h.totalTime;let f=h.selfTime;for(const P of h.children)f+=C.makeTotals(P);return h.totalTime=f,f}}let y=class{constructor(h,f,P,w){this._window=h,this._sessionId=f,this._logService=P,this._telemetryService=w,this._profileAtOrAfter=0,this._session=new t.DisposableStore,this._isStarted=!1}async stop(){await this._isProfiling,this._logService.warn("[perf] STOPPING to monitor renderer",this._sessionId),this._session.clear();try{const h=this._window.webContents.debugger;await h.sendCommand("Profiler.disable"),h.detach()}catch{this._logService.error("[perf] FAILED to disable profiler",this._sessionId)}}receiveHeartbeat(){this._profileAtOrAfter=Date.now()+1e3}async start(){if(this._isStarted){this._logService.warn("[perf] already STARTED, ignoring request",this._sessionId);return}try{const f=this._window.webContents.debugger;f.attach(),await f.sendCommand("Profiler.enable")}catch{this._logService.error("[perf] FAILED to enable profiler",this._sessionId);return}this._logService.warn("[perf] started to EXPECT frequent heartbeat",this._sessionId),this._session.clear(),this._profileAtOrAfter=Date.now();const h=setInterval(()=>{Date.now()>=this._profileAtOrAfter&&(clearInterval(h),this._captureRendererProfile())},500);this._session.add((0,t.toDisposable)(()=>{this._isStarted=!1,clearInterval(h)}))}async _captureRendererProfile(){this._logService.warn("[perf] MISSED heartbeat, trying to profile renderer",this._sessionId);const h=(async()=>{const f=this._window.webContents.debugger;await f.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,S.timeout)(5e3);const P=await f.sendCommand("Profiler.stop");this._logService.warn("[perf] profiling DONE",this._sessionId),await this._store(P.profile),this._digest(P.profile)})();this._isProfiling=h.catch(f=>{this._logService.error("[perf] profiling the renderer FAILED",this._sessionId),this._logService.error(f)}).finally(()=>{this._isProfiling=void 0})}async _store(h){try{const f=(0,b.join)((0,D.tmpdir)(),`renderer-profile-${Date.now()}.cpuprofile`);await R.Promises.writeFile(f,JSON.stringify(h)),this._logService.info("[perf] stored profile to DISK",this._sessionId,f)}catch(f){this._logService.error("[perf] FAILED to write profile to disk",this._sessionId,f)}}_digest(h){if(!h.samples||!h.timeDeltas){this._logService.warn("[perf] INVALID profile: no samples or timeDeltas",this._sessionId);return}p.Utils.rewriteAbsolutePaths(h,"piiRemoved");const f=new Map;for(const d of h.nodes)f.set(d.id,new C(d,d.callFrame));for(const d of h.nodes)if(d.children){const g=f.get(d.id);for(const c of d.children){const i=f.get(c);g.children.push(i),i.parent=g}}let w=h.endTime-h.startTime-h.timeDeltas[0];for(let d=0;d<h.samples.length-1;d++){const g=h.samples[d],c=f.get(g);if(c){const i=h.timeDeltas[d+1];c.selfTime+=i,w-=i}}const m=f.get(h.samples[h.samples.length-1]);m&&(m.selfTime+=w),f.forEach(C.makeTotals);const v=Array.from(f.values()).sort((d,g)=>g.selfTime-d.selfTime);if(v[0].callFrame.functionName==="(idle)"){this._logService.warn("[perf] top stack is IDLE, ignoring this profile...",this._sessionId),this._telemetryService.publicLog2("prof.sample",{sessionId:this._sessionId,selfTime:0,totalTime:0,functionName:"(idle)",callstack:""});return}for(let d=0;d<v.length&&!(d>4);d++){const g=v[d],c=[];let i=g;for(;i;)c.push(i.toString()),i=i.parent;const o={sessionId:this._sessionId,selfTime:g.selfTime/1e3,totalTime:g.totalTime/1e3,functionName:g.callFrame.functionName,callstack:c.join(`
`)};this._telemetryService.publicLog2("prof.freeze.sample",o)}}};y=ve([ee(2,k.ILogService),ee(3,u.ITelemetryService)],y),e.WindowProfiler=y}),define(te[232],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:b,data:u}){return this.appenders.forEach(p=>p.log(b,u)),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[73],ie([0,1,50,96,12,19,114,32]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class u{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(i,o){return Promise.resolve(void 0)}publicLog2(i,o){return this.publicLog(i,o)}publicLogError(i,o){return Promise.resolve(void 0)}publicLogError2(i,o){return this.publicLogError(i,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class p{async publicLog(i,o,n){}async publicLogError(i,o,n){}}e.NullEndpointTelemetryService=p,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(c,i){return i.onDidChangeConfiguration(o=>{o.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:m(o.sourceConfig)})})}e.configurationTelemetry=C;function y(c,i){return!(i.disableTelemetry||!c.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=y;function E(c){const i=c.getValue(b.TELEMETRY_SETTING_ID),o=c.getValue("telemetry.enableCrashReporter");if(c.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function h(c){const i={},o={},n={};w(c,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const s=n[r];typeof s=="number"?o[r]=s:typeof s=="boolean"?o[r]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${s.length}`),i[r]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(i[r]=s)}return{properties:i,measurements:o}}e.validateTelemetryData=h;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function P(c){if(!c)return"none";for(const i of f)if(c.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=P;function w(c,i,o=0,n){if(!!c)for(const r of Object.getOwnPropertyNames(c)){const s=c[r],l=n?n+r:r;Array.isArray(s)?i[l]=(0,S.safeStringify)(s):s instanceof Date?i[l]=s.toISOString():(0,k.isObject)(s)?o<2?w(s,i,o+1,l+"."):i[l]=(0,S.safeStringify)(s):i[l]=s}}function m(c){if(!c)return[];const i=[];return v(i,"",c),i}function v(c,i,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(n=>v(c,i?`${i}.${n}`:n,o[n])):c.push(i)}function d(c,i){const o=c.msftInternalDomains||[],n=i.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(o)||n}e.isInternalTelemetry=d;function g(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=g}),define(te[233],ie([0,1,189,73]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,b,u,p,C,y){const E={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,t.supportsTelemetry)(D,b)&&(0,t.getTelemetryLevel)(u)===3){const h=await(0,S.getServiceMachineId)(b,p,C),{sessionId:f}=await y.getTelemetryInfo();E["X-Market-User-Id"]=h,E["VSCode-SessionId"]=f}return E}e.resolveMarketplaceHeaders=k}),define(te[234],ie([0,1,2,50,96,4,26,168,19,62,54,20,47,32,73]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let P=class{constructor(v,d,g){this._configurationService=d,this._productService=g,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,d){this._experimentProperties[v]=d}_updateTelemetryLevel(){let v=(0,f.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const g=d.usage?3:d.error?2:0;v=Math.min(v,g)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties,d=v.sessionID,g=v["common.machineId"],c=v["common.firstSessionDate"],i=v["common.msftInternal"];return{sessionId:d,machineId:g,firstSessionDate:c,msftInternal:i}}dispose(){this._disposables.dispose()}_log(v,d,g,c){return this.telemetryLevel.value<d?Promise.resolve(void 0):this._commonProperties.then(i=>{g=(0,t.mixin)(g,i),g=(0,t.mixin)(g,this._experimentProperties),g=(0,t.cloneAndChange)(g,o=>{if(typeof o=="string")return this._cleanupInfo(o,c)}),this._appenders.forEach(o=>o.log(v,g))},i=>{console.error(i)})}publicLog(v,d,g){return this._log(v,3,d,g)}publicLog2(v,d,g){return this.publicLog(v,d,g)}publicLogError(v,d){return this._sendErrorTelemetry?this._log(v,2,d,!0):Promise.resolve(void 0)}publicLogError2(v,d){return this.publicLogError(v,d)}_anonymizeFilePaths(v){let d=v;const g=[];for(const n of this._cleanupPatterns)for(;;){const r=n.exec(v);if(!r)break;g.push([r.index,n.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(d="";;){const n=i.exec(v);if(!n)break;!c.test(n[0])&&g.every(([r,s])=>n.index<r||n.index>=s)&&(d+=v.substring(o,n.index)+"<REDACTED: user-file-path>",o=i.lastIndex)}return o<v.length&&(d+=v.substr(o)),d}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const d=v.toLowerCase(),g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of g)if(c.regex.test(d))return`<REDACTED: ${c.label}>`;return v}_cleanupInfo(v,d){let g=v;d&&(g=this._anonymizeFilePaths(g));for(const c of this._cleanupPatterns)g=g.replace(c,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};P.IDLE_START_EVENT_NAME="UserIdleStart",P.IDLE_STOP_EVENT_NAME="UserIdleStop",P=ve([ee(1,u.IConfigurationService),ee(2,y.IProductService)],P),e.TelemetryService=P;function w(){const m=(0,b.localize)(0,null,C.default.nameLong),v=C.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=R.isWeb?"":(0,b.localize)(3,null),g=(0,b.localize)(4,null),c=(0,b.localize)(5,null),i=(0,b.localize)(6,null),o=(0,b.localize)(7,null),n=`
|       | ${g} | ${c} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,b.localize)(8,null);return`
${m} ${v} ${d}

&nbsp;

${o}
${n}

&nbsp;

${r}
`}E.Registry.as(p.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[h.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(p.Extensions.Configuration).registerConfiguration({id:h.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[h.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,b.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,b.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${h.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[235],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var S;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(S=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===S.HIGH_CONTRAST_DARK||R===S.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===S.DARK||R===S.HIGH_CONTRAST_DARK}e.isDark=k}),define(te[236],ie([0,1,120,3,2,5,47,235]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var u;(function(w){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}w.isThemeColor=m})(u=e.ThemeColor||(e.ThemeColor={}));function p(w){return{id:w}}e.themeColorFromId=p;var C;(function(w){function m(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||u.isThemeColor(r.color))}w.isThemeIcon=m;const v=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function d(r){const s=v.exec(r);if(!s)return;const[,l]=s;return{id:l}}w.fromString=d;function g(r){return{id:r}}w.fromId=g;function c(r,s){let l=r.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),s&&(l=`${l}~${s}`),{id:l}}w.modify=c;function i(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}w.getModifier=i;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}w.isEqual=o;function n(r,s){return{id:r.id,color:s?p(s):void 0}}w.asThemeIcon=n,w.asClassNameArray=S.CSSIcon.asClassNameArray,w.asClassName=S.CSSIcon.asClassName,w.asCSSSelector=S.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function y(w){switch(w){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,k.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const h=new E;D.Registry.add(e.Extensions.ThemingContribution,h);function f(w){return h.onColorThemeChange(w)}e.registerThemingParticipant=f;class P extends k.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let d=this.theme.getColor(m);return d&&v&&(d=v(d,this.theme)),d?d.toString():null}}e.Themable=P}),define(te[64],ie([0,1,15,3,2,4,19,5,38]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const p="#FFFFFF",C="#1E1E1E",y="#000000",E="#FFFFFF",h="theme",f="themeBackground",P="windowSplash";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let w=class extends k.Disposable{constructor(v,d){super(),this.stateMainService=v,this.configurationService=d,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,S.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return v.dark?y:E;let d=this.stateMainService.getItem(f,null);if(!d)switch(this.stateMainService.getItem(h,"vs-dark").split(" ")[0]){case"vs":d=p;break;case"hc-black":d=y;break;case"hc-light":d=E;break;default:d=C}return R.isMacintosh&&d.toUpperCase()===C&&(d="#171717"),d}saveWindowSplash(v,d){this.stateMainService.setItems([{key:h,data:d.baseTheme},{key:f,data:d.colorInfo.background},{key:P,data:d}]),typeof v=="number"&&this.updateBackgroundColor(v,d)}updateBackgroundColor(v,d){for(const g of S.BrowserWindow.getAllWindows())if(g.id===v){g.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};w=ve([ee(0,u.IStateMainService),ee(1,D.IConfigurationService)],w),e.ThemeMainService=w}),define(te[115],ie([0,1,3,4,5,6]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(P){P.Http="http",P.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(P){P.ConstantPrivate="constantPrivate",P.Private="private",P.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var u;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore",P[P.OpenBrowserOnce=6]="OpenBrowserOnce"})(u=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function p(P){if(P.scheme!=="http"&&P.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}e.isAllInterfaces=y;function E(P,w){return w?w!==1&&P<1024:!t.isWindows&&P<1024}e.isPortPrivileged=E;class h{constructor(w,m,v){this.remoteAddress=w,this.localAddress=m,this._dispose=v,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=h;let f=class{constructor(w){this.logService=w,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],m=Array.from(this._tunnels.values());for(const v of m){const d=Array.from(v.values());for(const g of d){const c=await g.value;c&&w.push(c)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:m}of w.values())await m.then(v=>v?.dispose());w.clear()}this._tunnels.clear()}setEnvironmentTunnel(w,m,v,d,g){this.addTunnelToMap(w,m,Promise.resolve({tunnelRemoteHost:w,tunnelRemotePort:m,localAddress:v,privacy:d,protocol:g,dispose:()=>Promise.resolve()}))}openTunnel(w,m,v,d,g=!1,c,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${v} on local port ${d}.`),!w)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(w,m,v,d,g,c,i);return o?o.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(n);return(n.tunnelRemoteHost!==m||n.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const m=this._tunnels.get(w.tunnelRemoteHost);if(m){const v=m.get(w.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,v))}}}}async tryDisposeTunnel(w,m,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${m}.`);const d=v.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(m),d}}async closeTunnel(w,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${m} `);const v=this._tunnels.get(w);if(v&&v.has(m)){const d=v.get(m);d.refcount=0,await this.tryDisposeTunnel(w,m,d)}}addTunnelToMap(w,m,v){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(m,{refcount:1,value:v})}async removeEmptyTunnelFromMap(w,m){const v=this._tunnels.get(w);v&&(await v.get(m)||v.delete(m),v.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,m){const v=[w];C(w)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):y(w)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const d=v.map(g=>this._tunnels.get(g));for(const g of d){const c=g?.get(m);if(c)return c}}canTunnel(w){return!!p(w)}doIsPortPrivileged(w,m,v,d){if(m)return!1;if(v){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(g?.length===4){const c=parseInt(g[1]),i=parseInt(g[2]);if(c>10||c===10&&i>=14)return!1}}return w<1024}createWithProvider(w,m,v,d,g,c,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${v} on local port ${d}.`);const o=v;this._factoryInProgress.add(o);const n=d===void 0?v:d,r={elevationRequired:g?this.isPortPrivileged(n):!1},s={remoteAddress:{host:m,port:v},localAddressPort:d,privacy:c,public:c?c!==b.Private:void 0,protocol:i},l=w.forwardPort(s,r);return l?(this.addTunnelToMap(m,v,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),l}};f=ve([ee(0,R.ILogService)],f),e.AbstractTunnelService=f}),define(te[237],ie([0,1,77,25,95,220,8,2,19,6,20,219,115,87,4]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function P(g,c,i,o,n){let r;for(let s=3;s&&(r?.dispose(),r=await new w(g,c,i,o,n).waitForReady(),!(n&&k.BROWSER_RESTRICTED_PORTS[n]||!k.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));s--);return r}class w extends b.Disposable{constructor(c,i,o,n,r){super(),this.defaultTunnelHost=i,this.suggestedLocalPort=r,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=S.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(i=>{i()})}async waitForReady(){let c=await(0,k.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),i=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(c){c.pause();const i=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,y.connectRemoteAgentTunnel)(this._options,i,this.tunnelRemotePort),n=o.getSocket().socket,r=o.readEntireBuffer();o.dispose(),r.byteLength>0&&c.write(r.buffer),c.on("end",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),n.end()}),c.on("close",()=>n.end()),c.on("error",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),n.destroy()}),n.on("end",()=>c.end()),n.on("close",()=>c.end()),n.on("error",()=>{c.destroy()}),c.pipe(n),n.pipe(c),c.localAddress&&this._socketsDispose.set(c.localAddress,()=>{c.end(),n.end()})}}let m=class extends E.AbstractTunnelService{constructor(c,i,o,n,r){super(i),this.socketFactory=c,this.signService=o,this.productService=n,this.configurationService=r}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}isPortPrivileged(c){return this.doIsPortPrivileged(c,f.isWindows,f.isMacintosh,t.release())}retainOrCreateTunnel(c,i,o,n,r,s,l){const a=this.getTunnelFromMap(i,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,i,o,n,r,s,l);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${o} on local port ${n}.`);const I={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},M=P(I,this.defaultTunnelHost,i,o,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(i,o,M),M}}};m=ve([ee(1,p.ILogService),ee(2,h.ISignService),ee(3,C.IProductService),ee(4,u.IConfigurationService)],m),e.BaseTunnelService=m;let v=class extends m{constructor(c,i,o,n){super(R.nodeSocketFactory,c,i,o,n)}};v=ve([ee(0,p.ILogService),ee(1,h.ISignService),ee(2,C.IProductService),ee(3,u.IConfigurationService)],v),e.TunnelService=v;let d=class extends b.Disposable{constructor(c,i,o,n){super(),this.logService=c,this.productService=i,this.signService=o,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(c,i,o,n,r,s,l,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${n} on local port ${r}.`),!this._tunnelServices.has(c)){const I=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(I),this._tunnelServices.set(c,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(i,o,n,r,s,l,a)}};d=ve([ee(0,p.ILogService),ee(1,C.IProductService),ee(2,h.ISignService),ee(3,u.IConfigurationService)],d),e.SharedTunnelsService=d}),define(te[48],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,S.createDecorator)("updateService")}),define(te[238],ie([0,1,4,169,62,47]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[239],ie([0,1,3,48]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(b){this.service=b}listen(b,u){switch(u){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${u}`)}call(b,u,p){switch(u){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(p)}throw new Error(`Call not found: ${u}`)}}e.UpdateChannel=k;class R{get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}constructor(b){this.channel=b,this._onStateChange=new S.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(u=>this.state=u),this.channel.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(b){return this.channel.call("_applySpecificUpdate",b)}}e.UpdateChannelClient=R}),define(te[88],ie([0,1,8,23,3,19,27,22,6,20,55,48]),function(z,e,S,t,k,R,D,b,u,p,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(f,P,w){return`${w.updateUrl}/api/update/${f}/${P}/${w.commit}`}e.createUpdateURL=E;let h=class{get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}constructor(P,w,m,v,d,g){this.lifecycleMainService=P,this.configurationService=w,this.environmentMainService=m,this.requestService=v,this.logService=d,this.productService=g,this._state=y.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const P=this.getUpdateMode(),w=this.getProductQuality(P);if(!w){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(w),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(y.State.Idle(this.getUpdateType())),P==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}P==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(P){return P==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(P=60*60*1e3){return(0,S.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(P){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(P){}getUpdateType(){return 1}doQuitAndInstall(){}};h=ve([ee(0,b.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,D.IEnvironmentMainService),ee(3,C.IRequestService),ee(4,u.ILogService),ee(5,p.IProductService)],h),e.AbstractUpdateService=h}),define(te[240],ie([0,1,15,53,3,2,19,27,22,6,20,55,32,48,88]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let P=class extends f.AbstractUpdateService{get onRawError(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"error",(m,v)=>v)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(m,v,d)=>({url:v,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(m,v,d,g)=>({releaseNotes:v,version:d,productVersion:d,date:g}))}constructor(m,v,d,g,c,i,o){super(m,v,g,c,i,o),this.telemetryService=d,this.disposables=new R.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(m){this.logService.error("UpdateService error:",m);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?m:void 0;this.setState(h.State.Idle(1,d))}buildUpdateFeedUrl(m){let v;this.productService.darwinUniversalAssetId?v=this.productService.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,f.createUpdateURL)(v,m,this.productService);try{S.autoUpdater.setFeedURL({url:d})}catch(g){this.logService.error("Failed to set update feed URL",g);return}return d}doCheckForUpdates(m){this.setState(h.State.CheckingForUpdates(m)),S.autoUpdater.checkForUpdates()}onUpdateAvailable(m){this.state.type==="checking for updates"&&this.setState(h.State.Downloading(m))}onUpdateDownloaded(m){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:m.version}),this.setState(h.State.Ready(m)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(h.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],P.prototype,"onRawError",null),ve([t.memoize],P.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],P.prototype,"onRawUpdateAvailable",null),ve([t.memoize],P.prototype,"onRawUpdateDownloaded",null),P=ve([ee(0,u.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,E.ITelemetryService),ee(3,b.IEnvironmentMainService),ee(4,y.IRequestService),ee(5,p.ILogService),ee(6,C.IProductService)],P),e.DarwinUpdateService=P}),define(te[241],ie([0,1,45,40,8,3,9,27,22,6,32,48]),function(z,e,S,t,k,R,D,b,u,p,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{get state(){return this._state}setState(P){this.logService.info("update#setState",P.type),this._state=P,this._onStateChange.fire(P)}constructor(P,w,m){if(this.lifecycleMainService=P,this.logService=m,this._state=y.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,w.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(y.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}scheduleCheckForUpdates(P=60*60*1e3){return(0,k.timeout)(P).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(P){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(P)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(P){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(P=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${P}`),!P&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(P){}};E=ve([ee(0,u.ILifecycleMainService),ee(1,b.IEnvironmentMainService),ee(2,p.ILogService)],E);let h=class extends E{constructor(P,w,m,v,d,g){super(m,v,d),this.snap=P,this.snapRevision=w,this.telemetryService=g;const c=(0,t.watch)(D.dirname(this.snap)),i=R.Event.fromNodeEventEmitter(c,"change",(s,l)=>l),o=R.Event.filter(i,s=>s==="current"),r=R.Event.debounce(o,(s,l)=>l,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{r.dispose(),c.close()})}doCheckForUpdates(){this.setState(y.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(P=>{P?this.setState(y.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2)))},P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2,P.message||P))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const P=await new Promise((m,v)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(d,g)=>d?v(d):m(g))),w=D.basename(P);return this.snapRevision!==w}isLatestVersion(){return this.isUpdateAvailable().then(void 0,P=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=ve([ee(2,u.ILifecycleMainService),ee(3,b.IEnvironmentMainService),ee(4,p.ILogService),ee(5,C.ITelemetryService)],h),e.SnapUpdateService=h}),define(te[51],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(te[242],ie([0,1,51,190,14,16,126,3,2]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class p{constructor(E){this.uri=E,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let C=class{constructor(E){this._fileService=E,this._dispooables=new u.DisposableStore,this._limit=2**16;const h=new Map,f=P=>{let w=h.get(P.scheme);return w===void 0&&(w=E.hasProvider(P)&&!this._fileService.hasCapability(P,1024),h.set(P.scheme,w)),w};this._dispooables.add(b.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(P=>{h.delete(P.scheme)})),this.extUri=new R.ExtUri(f),this._canonicalUris=new D.SkipList((P,w)=>this.extUri.compare(P,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(E){this._fileService.hasProvider(E)&&(E=(0,R.normalizePath)(E));const h=this._canonicalUris.get(E);return h?h.touch().uri.with({fragment:E.fragment}):(this._canonicalUris.set(E,new p(E)),this._checkTrim(),E)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const E=[...this._canonicalUris.entries()].sort((f,P)=>f[1].touch<P[1].touch?1:f[1].touch>P[1].touch?-1:0);p._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let f=0;f<h;f++)this._canonicalUris.set(E[f][0],E[f][1].touch())}};C=ve([ee(0,k.IFileService)],C),e.UriIdentityService=C,(0,t.registerSingleton)(S.IUriIdentityService,C,1)}),define(te[116],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,S.createDecorator)("urlService")}),define(te[243],ie([0,1,7]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(b){this.handler=b}listen(b,u){throw new Error(`Event not found: ${u}`)}call(b,u,p){switch(u){case"handleURL":return this.handler.handleURL(S.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${u}`)}}e.URLHandlerChannel=t;class k{constructor(b){this.channel=b}handleURL(b,u){return this.channel.call("handleURL",[b.toJSON(),u])}}e.URLHandlerChannelClient=k;class R{constructor(b){this.next=b}async routeCall(b,u,p,C){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(p){const y=S.URI.revive(p);if(y&&y.query){const E=/\bwindowId=(\d+)/.exec(y.query);if(E){const h=E[1],f=new RegExp(`window:${h}`),P=b.connections.find(w=>f.test(w.ctx));if(P)return P}}}return this.next.routeCall(b,u,p,C)}routeEvent(b,u){throw new Error(`Event not found: ${u}`)}}e.URLHandlerRouter=R}),define(te[244],ie([0,1,8,2,7,20]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(p,C){const y=[...this.handlers.values()];return(0,S.first)(y.map(E=>()=>E.handleURL(p,C)),void 0,!1).then(E=>E||!1)}registerHandler(p){return this.handlers.add(p),(0,t.toDisposable)(()=>this.handlers.delete(p))}}e.AbstractURLService=D;let b=class extends D{constructor(p){super(),this.productService=p}create(p){let{authority:C,path:y,query:E,fragment:h}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return C&&y&&y.indexOf("/")!==0&&(y=`/${y}`),k.URI.from({scheme:this.productService.urlProtocol,authority:C,path:y,query:E,fragment:h})}};b=ve([ee(0,R.IProductService)],b),e.NativeURLService=b}),define(te[245],ie([0,1,15,8,3,2,4,7]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function u(C){try{return b.URI.parse(C)}catch{return null}}class p{constructor(y,E,h,f,P){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=y,D.isWindows){const v=f.isBuilt?[]:[`"${f.appRoot}"`];v.push("--open-url","--"),S.app.setAsDefaultProtocolClient(P.urlProtocol,process.execPath,v)}const w=k.Event.map(k.Event.fromNodeEventEmitter(S.app,"open-url",(v,d)=>({event:v,url:d})),({event:v,url:d})=>(v.preventDefault(),d));this.disposables.add(w(v=>{const d=u(v);!d||this.urlService.open(d,{originalUrl:v})})),h.getWindows().filter(v=>v.isReady).length>0?this.flush():k.Event.once(h.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const y=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||y.push(E);y.length!==0&&(this.uris=y,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(te[246],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,S.createDecorator)("webviewManagerService")}),define(te[247],ie([0,1,15,2,13,7]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const u=this.handleWebviewRequest.bind(this);S.protocol.registerFileProtocol(k.Schemas.vscodeWebview,u)}handleWebviewRequest(u,p){try{const C=R.URI.parse(u.url),y=D.validWebviewFilePaths.get(C.path);if(typeof y=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${y}`,h=k.FileAccess.asFileUri(E,z);return p({path:decodeURIComponent(h.fsPath),headers:{...k.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return p({error:-10})}catch{}return p({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[74],ie([0,1,4]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(C){return!!C.workspaceUri}e.isWorkspaceToOpen=t;function k(C){return!!C.folderUri}e.isFolderToOpen=k;function R(C){return!!C.fileUri}e.isFileToOpen=R;function D(C){const y=b(C),E=C.getValue("window.menuBarVisibility");return E==="default"||y==="native"&&E==="compact"||S.isMacintosh&&S.isNative?"classic":E}e.getMenuBarVisibility=D;function b(C){if(S.isWeb)return"custom";const y=C.getValue("window");if(y){if(S.isMacintosh&&y.nativeTabs===!0||S.isMacintosh&&y.nativeFullScreen===!1)return"native";const f=y.titleBarStyle;if(f==="native"||f==="custom")return f}return S.isLinux?"native":"custom"}e.getTitleBarStyle=b;function u(C){if(!S.isWindows||S.isWeb||b(C)==="native")return!1;const y=C.getValue("window.experimental.windowControlsOverlay.enabled");return typeof y=="boolean"?y:!1}e.useWindowControlsOverlay=u;function p(C=0){return Math.pow(1.2,C)}e.zoomLevelToZoomFactor=p}),define(te[117],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var S;(function(b){b[b.INITIAL=1]="INITIAL",b[b.LOAD=2]="LOAD",b[b.RELOAD=3]="RELOAD"})(S=e.LoadReason||(e.LoadReason={}));var t;(function(b){b[b.CLOSE=1]="CLOSE",b[b.QUIT=2]="QUIT",b[b.RELOAD=3]="RELOAD",b[b.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(b=1){return{width:1024,height:768,mode:b}};e.defaultWindowState=k;var R;(function(b){b[b.Maximized=0]="Maximized",b[b.Normal=1]="Normal",b[b.Minimized=2]="Minimized",b[b.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(b){b[b.UNRESPONSIVE=1]="UNRESPONSIVE",b[b.PROCESS_GONE=2]="PROCESS_GONE",b[b.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(te[33],ie([0,1,5]),function(z,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(te[248],ie([0,1,15,23,3,66,2,29,69,105,6,20,33]),function(z,e,S,t,k,R,D,b,u,p,C,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(P){P[P.Initial=1]="Initial",P[P.StoredCredentialsUsed=2]="StoredCredentialsUsed",P[P.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let f=class extends D.Disposable{constructor(w,m,v,d,g){super(),this.logService=w,this.windowsMainService=m,this.credentialsService=v,this.encryptionMainService=d,this.productService=g,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=h.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const w=k.Event.fromNodeEventEmitter(S.app,"login",(m,v,d,g,c)=>({event:m,webContents:v,req:d,authInfo:g,callback:c}));this._register(w(this.onLogin,this))}async onLogin({event:w,authInfo:m,req:v,callback:d}){if(!m.isProxy)return;if(!this.pendingProxyResolve&&this.state===h.LoginDialogShown&&v.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let g;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),g=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(m);try{g=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(g?.username,g?.password)}async resolveProxyCredentials(w){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const m=await this.doResolveProxyCredentials(w);if(m)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),m;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(w){this.logService.trace("auth#doResolveProxyCredentials - enter",w);const m=String((0,R.hash)({scheme:w.scheme,host:w.host,port:w.port}));let v,d;try{const o=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,m);if(o){const n=JSON.parse(await this.encryptionMainService.decrypt(o));v=n.username,d=n.password}}catch(o){this.logService.error(o)}if(this.state!==h.StoredCredentialsUsed&&typeof v=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=h.StoredCredentialsUsed,{username:v,password:d};const g=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!g){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${g.id} to handle proxy login`);const c={authInfo:w,username:this.sessionCredentials?.username??v,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};g.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=h.LoginDialogShown;const i=await new Promise(o=>{const n=async(r,s,l)=>{if(s===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${g.id}`),g.win?.webContents.off("ipc-message",n),l){const a={username:l.username,password:l.password};try{if(l.remember){const I=await this.encryptionMainService.encrypt(JSON.stringify(a));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,m,I)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,m)}catch(I){this.logService.error(I)}o({username:a.username,password:a.password})}else o(void 0)};g.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=i,i}};f=ve([ee(0,C.ILogService),ee(1,E.IWindowsMainService),ee(2,u.ICredentialsMainService),ee(3,p.IEncryptionMainService),ee(4,y.IProductService)],f),e.ProxyAuthHandler=f}),define(te[249],ie([0,1,69,6,36,20,33,202]),function(z,e,S,t,k,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let u=class extends b.BaseCredentialsMainService{constructor(C,y,E,h){super(C),this.environmentMainService=y,this.productService=E,this.windowsMainService=h,this.surfaceKeytarLoadError=f=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",f.message??f)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new S.InMemoryCredentialsProvider,this._keytarCache;const C=await new Promise((y,E)=>{z(["keytar"],y,E)});return await C.findCredentials("test-keytar-loads"),this._keytarCache=C,this._keytarCache}};u=ve([ee(0,t.ILogService),ee(1,k.INativeEnvironmentService),ee(2,R.IProductService),ee(3,D.IWindowsMainService)],u),e.CredentialsNativeMainService=u}),define(te[250],ie([0,1,17,2,3,6,22,79,45,280,8,13,50,4,34,15,33]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const m=P.UtilityProcess,v=typeof m<"u";let d=class Ut{constructor(o,n,r){this._logService=o,this._windowsMainService=r,this._shutdown=!1,this._extHosts=new Map,n.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(o){const n=this._extHosts.get(o);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(o){return this._getExtHost(o).onStdout}onDynamicStderr(o){return this._getExtHost(o).onStderr}onDynamicMessage(o){return this._getExtHost(o).onMessage}onDynamicError(o){return this._getExtHost(o).onError}onDynamicExit(o){return this._getExtHost(o).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(o){if(this._shutdown)throw(0,S.canceled)();const n=String(++Ut._lastId);let r;if(o){if(!v)throw new Error("Cannot use UtilityProcess!");r=new c(n,this._logService,this._windowsMainService)}else r=new g(n,this._logService);return this._extHosts.set(n,r),r.onExit(({pid:s,code:l,signal:a})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${l}, signal: ${a}.`),setTimeout(()=>{r.dispose(),this._extHosts.delete(n)})}),{id:n}}async start(o,n){if(this._shutdown)throw(0,S.canceled)();return this._getExtHost(o).start(n)}async enableInspectPort(o){if(this._shutdown)throw(0,S.canceled)();const n=this._extHosts.get(o);return n?n.enableInspectPort():!1}async kill(o){if(this._shutdown)throw(0,S.canceled)();const n=this._extHosts.get(o);!n||n.kill()}async _killAllNow(){for(const[,o]of this._extHosts)o.kill()}async _waitForAllExit(o){const n=[];for(const[,r]of this._extHosts)n.push(r.waitForExit(o));return C.Promises.settled(n).then(()=>{})}};d._lastId=0,d=ve([ee(0,R.ILogService),ee(1,D.ILifecycleMainService),ee(2,w.IWindowsMainService)],d),e.ExtensionHostStarter=d;let g=class extends t.Disposable{constructor(o,n){super(),this.id=o,this._logService=n,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){h.isCI&&this._logService.info("Calling fork to start extension host...");const n=b.StopWatch.create(!1);this._process=(0,u.fork)(y.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,E.mixin)({cwd:(0,f.cwd)()},o));const r=n.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${r} ms).`);const l=new p.StringDecoder("utf-8");this._process.stdout?.on("data",I=>{const M=typeof I=="string"?I:l.write(I);this._onStdout.fire(M)});const a=new p.StringDecoder("utf-8");this._process.stderr?.on("data",I=>{const M=typeof I=="string"?I:a.write(I);this._onStderr.fire(M)}),this._process.on("message",I=>{this._onMessage.fire(I)}),this._process.on("error",I=>{this._onError.fire({error:(0,S.transformErrorForSerialization)(I)})}),this._process.on("exit",(I,M)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:I,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):h.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const n=this._process.pid;this._logService.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,C.timeout)(o)]),this._hasExited||(this._logService.info(`Extension host with pid ${n} did not exit within ${o}ms.`),this._process.kill())}};g=ve([ee(1,R.ILogService)],g);let c=class extends t.Disposable{constructor(o,n,r){super(),this.id=o,this._logService=n,this._windowsMainService=r,this.onError=k.Event.None,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){const n=this._windowsMainService.getWindowById(o.responseWindowId);if(!n){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=n.win;if(!r||r.isDestroyed()||r.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,l=y.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,a=["--type=extensionHost","--skipWorkspaceStorageLock"],I=o.execArgv||[],M={...o.env},T=!0;for(const Z of Object.keys(M))M[Z]=String(M[Z]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new m(l,a,{serviceName:s,env:M,execArgv:I,allowLoadingUnsignedLibraries:T});const N=new p.StringDecoder("utf-8");this._process.stdout?.on("data",Z=>{const se=typeof Z=="string"?Z:N.write(Z);this._onStdout.fire(se)});const X=new p.StringDecoder("utf-8");this._process.stderr?.on("data",Z=>{const se=typeof Z=="string"?Z:X.write(Z);this._onStderr.fire(se)}),this._process.on("message",Z=>{this._onMessage.fire(Z)}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const ae=k.Event.fromNodeEventEmitter(this._process,"exit",(Z,se)=>se);this._register(ae(Z=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${Z}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:Z,signal:""})}));const{port1:Q,port2:G}=new P.MessageChannelMain;this._process.postMessage("null",[G]),r.webContents.postMessage(o.responseChannel,o.responseNonce,[Q])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):!1):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const n=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,C.timeout)(o)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${o}ms, will kill it now.`),this._process.kill())}};c=ve([ee(1,R.ILogService),ee(2,w.IWindowsMainService)],c)}),define(te[251],ie([0,1,15,3,2,247,33]),function(z,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends k.Disposable{constructor(p){super(),this.windowsMainService=p,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(p,C){let y;if(typeof p.windowId=="number"){const{windowId:E}=p,h=this.windowsMainService.getWindowById(E);if(!h?.win)throw new Error(`Invalid windowId: ${E}`);y=h.win.webContents}else{const{webContentsId:E}=p;if(y=S.webContents.fromId(E),!y)throw new Error(`Invalid webContentsId: ${E}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(C)}async findInFrame(p,C,y,E){const f=this.getFrameByName(p,C);if(typeof f.findInFrame=="function"){f.findInFrame(y,{findNext:E.findNext,forward:E.forward});const P=(w,m)=>{m.finalUpdate&&(this._onFoundInFrame.fire(m),f.removeListener("found-in-frame",P))};f.on("found-in-frame",P)}}async stopFindInFrame(p,C,y){const h=this.getFrameByName(p,C);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}getFrameByName(p,C){const y=this.windowsMainService.getWindowById(p.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${p}`);const E=y.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===C);if(!E)throw new Error(`Unknown frame: ${C}`);return E}};b=ve([ee(0,D.IWindowsMainService)],b),e.WebviewMainService=b}),define(te[252],ie([0,1,8,3,2]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:u,getActiveWindowId:p}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(b,u))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,S.createCancelablePromise)(()=>p()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(te[28],ie([0,1,173,9,31,16,7,5,13]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function p(o){const n=o;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function C(o,n){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=o;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=C;function y(o){const n=o;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=y;function E(o){const n=o;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=o;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=E;var h;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function f(o){const n=o;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=f;function P(o){const n=o;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=P;class w{constructor(n,r,s,l,a){this._id=n,this._transient=s,this._configuration=l,this._ignorePathCasing=a,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class m{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function v(o){return new m({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(o,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,n.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function g(o){let n;return D.URI.isUri(o)?n=o:n=o.configuration,n?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=g;function c(o,n){return!d(o,n)&&!g(o)}e.isSavedWorkspace=c;function i(o){return(typeof o=="string"?(0,t.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(te[56],ie([0,1,15,8,66,35,2,80,4,12,21,150,5,6,28]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,E.createDecorator)("dialogMainService");let P=class{constructor(m){this.logService=m,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(m,v){return this.doPick({...m,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},v)}pickFolder(m,v){return this.doPick({...m,pickFolders:!0,title:(0,y.localize)(1,null)},v)}pickFile(m,v){return this.doPick({...m,pickFiles:!0,title:(0,y.localize)(2,null)},v)}pickWorkspace(m,v){const d=(0,y.localize)(3,null),g=(0,R.mnemonicButtonLabel)((0,y.localize)(4,null)),c=f.WORKSPACE_FILTER;return this.doPick({...m,pickFiles:!0,title:d,filters:c,buttonLabel:g},v)}async doPick(m,v){const d={title:m.title,buttonLabel:m.buttonLabel,filters:m.filters,defaultPath:m.defaultPath};(typeof m.pickFiles=="boolean"||typeof m.pickFolders=="boolean")&&(d.properties=void 0,m.pickFiles&&m.pickFolders&&(d.properties=["multiSelections","openDirectory","openFile","createDirectory"])),d.properties||(d.properties=["multiSelections",m.pickFolders?"openDirectory":"openFile","createDirectory"]),u.isMacintosh&&d.properties.push("treatPackageAsDirectory");const g=await this.showOpenDialog(d,(0,p.withNullAsUndefined)(v||S.BrowserWindow.getFocusedWindow()));if(g&&g.filePaths&&g.filePaths.length>0)return g.filePaths}getWindowDialogQueue(m){if(m){let v=this.windowDialogQueues.get(m.id);return v||(v=new t.Queue,this.windowDialogQueues.set(m.id,v)),v}else return this.noWindowDialogueQueue}showMessageBox(m,v){return this.getWindowDialogQueue(v).queue(async()=>v?S.dialog.showMessageBox(v,m):S.dialog.showMessageBox(m))}async showSaveDialog(m,v){const d=this.acquireFileDialogLock(m,v);if(!d)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(v).queue(async()=>{let g;return v?g=await S.dialog.showSaveDialog(v,m):g=await S.dialog.showSaveDialog(m),g.filePath=this.normalizePath(g.filePath),g})}finally{(0,D.dispose)(d)}}normalizePath(m){return m&&u.isMacintosh&&(m=(0,b.normalizeNFC)(m)),m}normalizePaths(m){return m.map(v=>this.normalizePath(v))}async showOpenDialog(m,v){m.defaultPath&&(await C.Promises.exists(m.defaultPath)||(m.defaultPath=void 0));const d=this.acquireFileDialogLock(m,v);if(!d)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(v).queue(async()=>{let g;return v?g=await S.dialog.showOpenDialog(v,m):g=await S.dialog.showOpenDialog(m),g.filePaths=this.normalizePaths(g.filePaths),g})}finally{(0,D.dispose)(d)}}acquireFileDialogLock(m,v){if(!v)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",m);let d=this.windowFileDialogLocks.get(v.id);d||(d=new Set,this.windowFileDialogLocks.set(v.id,d));const g=(0,k.hash)(m);if(!d.has(g))return this.logService.trace("[DialogMainService]: new file dialog lock created",m),d.add(g),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",m),d?.delete(g),d?.size===0&&this.windowFileDialogLocks.delete(v.id)})}};P=ve([ee(0,h.ILogService)],P),e.DialogMainService=P}),define(te[253],ie([0,1,3,2,67,28]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(u,p){super(),this.logService=u,this.storageMainService=p,this.onDidChangeApplicationStorageEmitter=this._register(new S.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(p.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(u,p){this._register(S.Event.debounce(u.onDidChangeStorage,(C,y)=>(C?C.push(y):C=[y],C),D.STORAGE_CHANGE_DEBOUNCE_TIME)(C=>{C.length&&p.fire(this.serializeStorageChangeEvents(C,u))}))}serializeStorageChangeEvents(u,p){const C=new Map,y=new Set;return u.forEach(E=>{const h=p.get(E.key);typeof h=="string"?C.set(E.key,h):y.add(E.key)}),{changed:Array.from(C.entries()),deleted:Array.from(y.values())}}listen(u,p,C){switch(p){case"onDidChangeStorage":{const y=C.profile?(0,k.revive)(C.profile):void 0;if(!y)return this.onDidChangeApplicationStorageEmitter.event;let E=this.mapProfileToOnDidChangeProfileStorageEmitter.get(y.id);return E||(E=this._register(new S.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(y),E),this.mapProfileToOnDidChangeProfileStorageEmitter.set(y.id,E)),E.event}}throw new Error(`Event not found: ${p}`)}async call(u,p,C){const y=C.profile?(0,k.revive)(C.profile):void 0,E=(0,R.reviveIdentifier)(C.workspace),h=await this.withStorageInitialized(y,E);switch(p){case"getItems":return Array.from(h.items.entries());case"updateItems":{const f=C;if(f.insert)for(const[P,w]of f.insert)h.set(P,w);f.delete?.forEach(P=>h.delete(P));break}case"isUsed":{const f=C.payload;if(typeof f=="string")return this.storageMainService.isUsed(f)}default:throw new Error(`Call not found: ${p}`)}}async withStorageInitialized(u,p){let C;p?C=this.storageMainService.workspaceStorage(p):u?C=this.storageMainService.profileStorage(u):C=this.storageMainService.applicationStorage;try{await C.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${p?"workspace":u?"profile":"application"} storage due to ${y}`)}return C}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(te[39],ie([0,1,66,3,2,16,12,7,170,36,14,5,6,28,31,51,8,29,26]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function d(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&b.URI.isUri(r.location)&&b.URI.isUri(r.globalStorageHome)&&b.URI.isUri(r.settingsResource)&&b.URI.isUri(r.keybindingsResource)&&b.URI.isUri(r.tasksResource)&&b.URI.isUri(r.snippetsHome)&&((0,D.isUndefined)(r.extensionsResource)||b.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=d,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function g(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:b.URI.revive(n.location).with({scheme:r}),globalStorageHome:b.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:b.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:b.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:b.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:b.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:b.URI.revive(n.extensionsResource)?.with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=g,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(n,r,s,l){return{id:n,name:r,location:s,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,R.joinPath)(s,"globalStorage"),settingsResource:(0,R.joinPath)(s,"settings.json"),keybindingsResource:(0,R.joinPath)(s,"keybindings.json"),tasksResource:(0,R.joinPath)(s,"tasks.json"),snippetsHome:(0,R.joinPath)(s,"snippets"),extensionsResource:(0,R.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=c;let i=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,s,l,a){super(),this.environmentService=r,this.fileService=s,this.uriIdentityService=l,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(I=>c((0,R.basename)(I.location),I.name,I.location,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags})):[];let s;const l=new f.ResourceMap,a=c((0,S.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,u.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),r.length){const I=this.getStoredProfileAssociations();if(I.workspaces)for(const[M,T]of Object.entries(I.workspaces)){const N=b.URI.parse(M),X=b.URI.parse(T),ae=r.find(Q=>this.uriIdentityService.extUri.isEqual(Q.location,X));ae&&l.set(N,ae)}if(I.emptyWindow){const M=b.URI.parse(I.emptyWindow);s=r.find(T=>this.uriIdentityService.extUri.isEqual(T.location,M))}}this._profilesObject={profiles:r,workspaces:l,emptyWindow:s}}return this._profilesObject}async createTransientProfile(r){const s="Temp",l=new RegExp(`${(0,v.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const M of this.profiles){const T=l.exec(M.name),N=T?parseInt(T[1]):0;a=N>a?N:a}const I=`${s} ${a+1}`;return this.createProfile((0,S.hash)((0,m.generateUuid)()).toString(16),I,{transient:!0},r)}async createNamedProfile(r,s,l){return this.createProfile((0,S.hash)((0,m.generateUuid)()).toString(16),r,s,l)}async createProfile(r,s,l,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const I=await this.doCreateProfile(r,s,l);return a&&await this.setProfileForWorkspace(a,I),I}async doCreateProfile(r,s,l){let a=this.profileCreationPromises.get(s);return a||(a=(async()=>{try{const I=this.profiles.find(N=>N.name===s||N.id===r);if(I)return I;const M=c(r,s,(0,R.joinPath)(this.profilesHome,r),l);await this.fileService.createFolder(M.location);const T=[];return this._onWillCreateProfile.fire({profile:M,join(N){T.push(N)}}),await w.Promises.settled(T),this.updateProfiles([M],[],[]),M}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,a)),a}async updateProfile(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(a=>a.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);return l=c(l.id,s.name??l.name,l.location,{shortName:s.shortName??l.shortName,transient:s.transient??l.isTransient,useDefaultFlags:s.useDefaultFlags??l.useDefaultFlags}),this.updateProfiles([],[],[l]),l}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);const l=[];this._onWillRemoveProfile.fire({profile:s,join(a){l.push(a)}});try{await Promise.allSettled(l)}catch(a){this.logService.error(a)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(r,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let l=this.getProfileForWorkspace(r);return l||(l=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,l)),l}async setProfileForWorkspace(r,s){this.setProfileForWorkspaceSync(r,s)}setProfileForWorkspaceSync(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=this.profiles.find(a=>a.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(r,l)}unsetWorkspace(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(s=>s.isDirectory&&this.profiles.every(l=>!this.uriIdentityService.extUri.isEqual(l.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(r.map(s=>this.removeProfile(s)))}getProfileForWorkspace(r){const s=this.getWorkspace(r);return b.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(r){return(0,h.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,h.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}isProfileAssociatedToWorkspace(r){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,r.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,r.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location)))}updateProfiles(r,s,l){const a=[...this.profiles,...r],I=[];this.transientProfilesObject.profiles=[];for(let M of a)M.isDefault||s.some(T=>M.id===T.id)||(M=l.find(T=>M.id===T.id)??M,M.isTransient?this.transientProfilesObject.profiles.push(M):I.push({location:M.location,name:M.name,shortName:M.shortName,useDefaultFlags:M.useDefaultFlags}));this.saveStoredProfiles(I),this._profilesObject=void 0,this.triggerProfilesChanges(r,s,l)}triggerProfilesChanges(r,s,l){this._onDidChangeProfiles.fire({added:r,removed:s,updated:l,all:this.profiles})}updateWorkspaceAssociation(r,s,l){l=s?.isTransient?!0:l,l||this.updateWorkspaceAssociation(r,void 0,!0);const a=this.getWorkspace(r),I=l?this.transientProfilesObject:this.profilesObject;b.URI.isUri(a)?(I.workspaces.delete(a),s&&I.workspaces.set(a,s)):I.emptyWindow=s,l||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[l,a]of this.profilesObject.workspaces.entries())r[l.toString()]=a.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=ve([ee(0,p.IEnvironmentService),ee(1,C.IFileService),ee(2,P.IUriIdentityService),ee(3,E.ILogService)],i),e.UserDataProfilesService=i;class o extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=o}),define(te[89],ie([0,1,24,8,50,18,17,43,136,2,13,9,4,16,188,97,12,7,155,36,112,111,187,14,5,6,20,3,67,72,39,51,186]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c,i,o,n,r,s,l,a,I,M,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(V){function H(W,A){if(W===A)return!0;const F=Object.keys(W),U=new Set;for(const J of Object.keys(A))U.add(J);if(F.length!==U.size)return!1;for(const J of F){if(W[J]!==A[J])return!1;U.delete(J)}return U.size===0}V.equals=H})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let ae=class extends p.Disposable{constructor(H,W,A,F,U,J,B,$,L,O,_){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=W,this.extensionsControlLocation=A,this.cacheLocation=F,this.userDataProfilesService=U,this.extensionsProfileScannerService=J,this.fileService=B,this.logService=$,this.environmentService=L,this.productService=O,this.instantiationService=_,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,(0,h.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,(0,h.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(G,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(H,W,A){const[F,U]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(W)]),J=A?await this.scanExtensionsUnderDevelopment(H,[...F,...U]):[];return this.dedupExtensions(F,U,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const W=[];W.push(this.scanDefaultSystemExtensions(!!H.useCache,H.language)),W.push(this.scanDevSystemExtensions(H.language,!!H.checkControlFile));const[A,F]=await Promise.all(W);return this.applyScanOptions([...A,...F],0,H,!1)}async scanUserExtensions(H){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(H.profileLocation??this.userExtensionsLocation,!!H.profileLocation,1,!H.includeUninstalled,H.language);let F=await(H.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return F=await this.applyScanOptions(F,1,H,!0),this.logService.trace("Scanned user extensions:",F.length),F}async scanExtensionsUnderDevelopment(H,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(F=>F.scheme===C.Schemas.file).map(async F=>{const U=await this.createExtensionScannerInput(F,!1,1,!0,H.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(U)).map(B=>(B.type=W.find($=>(0,g.areSameExtensions)($.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,U)))}))).flat();return this.applyScanOptions(A,"development",H,!0)}return[]}async scanExistingExtension(H,W,A){const F=await this.createExtensionScannerInput(H,!1,W,!0,A.language),U=await this.extensionsScanner.scanExtension(F);return!U||!A.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(H,W,A){const F=await this.createExtensionScannerInput(H,!1,W,!0,A.language),U=await this.extensionsScanner.scanOneOrMultipleExtensions(F);return this.applyScanOptions(U,W,A,!0)}async scanMetadata(H){const W=(0,h.joinPath)(H,"package.json"),A=(await this.fileService.readFile(W)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(H,W){const A=(0,h.joinPath)(H,"package.json"),F=(await this.fileService.readFile(A)).value.toString(),U=JSON.parse(F);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,U.__metadata={...U.__metadata,...W},await this.fileService.writeFile((0,h.joinPath)(H,"package.json"),R.VSBuffer.fromString(JSON.stringify(U,null,"	")))}async applyScanOptions(H,W,A,F){return A.includeAllVersions||(H=this.dedupExtensions(W===0?H:void 0,W===1?H:void 0,W==="development"?H:void 0,await this.getTargetPlatform(),F)),A.includeInvalid||(H=H.filter(U=>U.isValid)),H.sort((U,J)=>{const B=y.basename(U.location.fsPath),$=y.basename(J.location.fsPath);return B<$?-1:B>$?1:0})}dedupExtensions(H,W,A,F,U){const J=($,L,O)=>{if($.isValid&&!L.isValid)return!1;if($.isValid===L.isValid){if(U&&f.gt($.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(f.eq($.manifest.version,L.manifest.version)){if($.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===F)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${$.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${$.location.path} with ${L.location.path}.`),!0},B=new Map;return H?.forEach($=>{const L=c.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!1))&&B.set(L,$)}),W?.forEach($=>{const L=c.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);if(!O&&H&&$.type===0){this.logService.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!O||J(O,$,!1))&&B.set(L,$)}),A?.forEach($=>{const L=c.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!0))&&B.set(L,$),B.set(L,$)}),[...B.values()]}async scanDefaultSystemExtensions(H,W){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),U=await(H&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",U.length),U}async scanDevSystemExtensions(H,W){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const F=W?await this.getBuiltInExtensionControl():{},U=[],J=m.URI.file(y.normalize(y.join(C.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions")));for(const $ of A){const L=F[$.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":U.push((0,h.joinPath)(J,$.name));break;default:U.push(m.URI.file(L));break}}const B=await Promise.all(U.map(async $=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput($,!1,0,!0,H))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,S.coalesce)(B)}async getBuiltInExtensionControl(){try{const H=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(H.value.toString())}catch{return{}}}async createExtensionScannerInput(H,W,A,F,U,J=!0){const B=await this.getTranslations(U??E.language),$=await this.getMtime(H),L=W?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new Q(H,$,L,O,W,A,F,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,U,B)}async getMtime(H){try{const W=await this.fileService.stat(H);if(typeof W.mtime=="number")return W.mtime}catch{}}};ae=ve([ee(4,M.IUserDataProfilesService),ee(5,I.IExtensionsProfileScannerService),ee(6,o.IFileService),ee(7,r.ILogService),ee(8,d.IEnvironmentService),ee(9,s.IProductService),ee(10,n.IInstantiationService)],ae),e.AbstractExtensionsScannerService=ae;class Q{constructor(H,W,A,F,U,J,B,$,L,O,_,j,Y,oe){this.location=H,this.mtime=W,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=F,this.profile=U,this.type=J,this.excludeObsolete=B,this.validate=$,this.productVersion=L,this.productDate=O,this.productCommit=_,this.devMode=j,this.language=Y,this.translations=oe}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,W){return(0,h.isEqual)(H.location,W.location)&&H.mtime===W.mtime&&(0,h.isEqual)(H.applicationExtensionslocation,W.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&H.profile===W.profile&&H.type===W.type&&H.excludeObsolete===W.excludeObsolete&&H.validate===W.validate&&H.productVersion===W.productVersion&&H.productDate===W.productDate&&H.productCommit===W.productCommit&&H.devMode===W.devMode&&H.language===W.language&&X.equals(H.translations,W.translations)}}let G=class extends p.Disposable{constructor(H,W,A,F,U){super(),this.obsoleteFile=H,this.extensionsProfileScannerService=W,this.uriIdentityService=A,this.fileService=F,this.logService=U}async scanExtensions(H){const W=H.profile?await this.scanExtensionsFromProfile(H):await this.scanExtensionsFromLocation(H);let A={};if(H.excludeObsolete&&H.type===1)try{const F=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(F)}catch{}return(0,w.isEmptyObject)(A)?W:W.filter(F=>!A[g.ExtensionKey.create(F).toString()])}async scanExtensionsFromLocation(H){const W=await this.fileService.resolve(H.location);if(!W.children?.length)return[];const A=await Promise.all(W.children.map(async F=>{if(!F.isDirectory||H.type===1&&(0,h.basename)(F.resource).indexOf(".")===0)return null;const U=new Q(F.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(U)}));return(0,S.coalesce)(A).sort((F,U)=>F.location.path<U.location.path?-1:1)}async scanExtensionsFromProfile(H){let W=await this.scanExtensionsFromProfileResource(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(H.location,H.applicationExtensionslocation)){W=W.filter(F=>!F.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(H.applicationExtensionslocation,F=>!!F.metadata?.isApplicationScoped,H);W.push(...A)}return W}async scanExtensionsFromProfileResource(H,W,A){const F=await this.extensionsProfileScannerService.scanProfileExtensions(H);if(!F.length)return[];const U=await Promise.all(F.map(async J=>{if(W(J)){const B=new Q(J.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,J.metadata)}return null}));return(0,S.coalesce)(U)}async scanOneOrMultipleExtensions(H){try{if(await this.fileService.exists((0,h.joinPath)(H.location,"package.json"))){const W=await this.scanExtension(H);return W?[W]:[]}else return await this.scanExtensions(H)}catch(W){return this.logService.error(`Error scanning extensions at ${H.location.path}:`,(0,D.getErrorMessage)(W)),[]}}async scanExtension(H,W){try{let A=await this.scanExtensionManifest(H.location);if(A){A.publisher||(A.publisher=c.UNDEFINED_PUBLISHER),W=W??A.__metadata,delete A.__metadata;const F=(0,g.getGalleryExtensionId)(A.publisher,A.name),U=W?.id?{id:F,uuid:W.id}:{id:F},J=W?.isSystem?0:H.type,B=J===0||!!W?.isBuiltin;A=await this.translateManifest(H.location,A,Q.createNlsConfiguration(H));const $={type:J,identifier:U,manifest:A,location:H.location,isBuiltin:B,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return H.validate?this.validate($,H):$}}catch(A){H.type!==0&&this.logService.error(A)}return null}validate(H,W){let A=!0;const F=(0,i.validateExtensionManifest)(W.productVersion,W.productDate,W.location,H.manifest,H.isBuiltin);for(const[U,J]of F)U===P.default.Error&&(A=!1,this.logService.error(this.formatMessage(W.location,J)));return H.isValid=A,H.validations=F,H}async scanExtensionManifest(H){const W=(0,h.joinPath)(H,"package.json");let A;try{A=(await this.fileService.readFile(W)).value.toString()}catch(U){return(0,o.toFileOperationResult)(U)!==1&&this.logService.error(this.formatMessage(H,(0,v.localize)(0,null,W.path,U.message))),null}let F;try{F=JSON.parse(A)}catch{const J=[];(0,b.parse)(A,J);for(const B of J)this.logService.error(this.formatMessage(H,(0,v.localize)(1,null,W.path,B.offset,B.length,(0,u.getParseErrorMessage)(B.error))));return null}return(0,b.getNodeType)(F)!=="object"?(this.logService.error(this.formatMessage(H,(0,v.localize)(2,null,W.path))),null):F}async translateManifest(H,W,A){const F=await this.getLocalizedMessages(H,W,A);if(F)try{const U=[],J=await this.resolveOriginalMessageBundle(F.default,U);if(U.length>0)return U.forEach($=>{this.logService.error(this.formatMessage(H,(0,v.localize)(3,null,F.default?.path,(0,u.getParseErrorMessage)($.error))))}),W;if((0,b.getNodeType)(F)!=="object")return this.logService.error(this.formatMessage(H,(0,v.localize)(4,null,F.default?.path))),W;const B=F.values||Object.create(null);return(0,N.localizeManifest)(W,B,J)}catch{}return W}async getLocalizedMessages(H,W,A){const F=(0,h.joinPath)(H,"package.nls.json"),U=(L,O)=>{O.forEach(_=>{this.logService.error(this.formatMessage(H,(0,v.localize)(5,null,L?.path,(0,u.getParseErrorMessage)(_.error))))})},J=L=>{this.logService.error(this.formatMessage(H,(0,v.localize)(6,null,L?.path)))},B=`${W.publisher}.${W.name}`,$=A.translations[B];if($)try{const L=m.URI.file($),O=(await this.fileService.readFile(L)).value.toString(),_=[],j=(0,b.parse)(O,_);return _.length>0?(U(L,_),{values:void 0,default:F}):(0,b.getNodeType)(j)!=="object"?(J(L),{values:void 0,default:F}):{values:j.contents?j.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.fileService.exists(F))return;let O;try{O=await this.findMessageBundles(H,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const _=(await this.fileService.readFile(O.localized)).value.toString(),j=[],Y=(0,b.parse)(_,j);return j.length>0?(U(O.localized,j),{values:void 0,default:O.original}):(0,b.getNodeType)(Y)!=="object"?(J(O.localized),{values:void 0,default:O.original}):{values:Y,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(H,W){if(H)try{const A=(await this.fileService.readFile(H)).value.toString();return(0,b.parse)(A,W)}catch{}}findMessageBundles(H,W){return new Promise((A,F)=>{const U=J=>{const B=(0,h.joinPath)(H,`package.nls.${J}.json`);this.fileService.exists(B).then($=>{$&&A({localized:B,original:(0,h.joinPath)(H,"package.nls.json")});const L=J.lastIndexOf("-");L===-1?A({localized:(0,h.joinPath)(H,"package.nls.json"),original:null}):(J=J.substring(0,L),U(J))})};if(W.devMode||W.pseudo||!W.language)return A({localized:(0,h.joinPath)(H,"package.nls.json"),original:null});U(W.language)})}formatMessage(H,W){return`[${H.path}]: ${W}`}};G=ve([ee(1,I.IExtensionsProfileScannerService),ee(2,T.IUriIdentityService),ee(3,o.IFileService),ee(4,r.ILogService)],G);let Z=class extends G{constructor(H,W,A,F,U,J){super(W,A,F,U,J),this.cacheFile=H,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(H){const W=await this.readExtensionCache();if(this.input=H,W&&W.input&&Q.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(F=>(F.location=m.URI.revive(F.location),F));const A=await super.scanExtensions(H);return await this.writeExtensionCache({input:H,result:A}),A}async readExtensionCache(){try{const H=await this.fileService.readFile(this.cacheFile),W=JSON.parse(H.value.toString());return{result:W.result,input:(0,a.revive)(W.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(H))}return null}async writeExtensionCache(H){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(H)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const H=await this.readExtensionCache();if(!H)return;const W=H.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(F){this.logService.error(F)}}};Z=ve([ee(2,I.IExtensionsProfileScannerService),ee(3,T.IUriIdentityService),ee(4,o.IFileService),ee(5,r.ILogService)],Z);function se(V,H){const W=(0,g.getExtensionId)(V.manifest.publisher,V.manifest.name);return{id:W,identifier:new c.ExtensionIdentifier(W),isBuiltin:V.type===0,isUserBuiltin:V.type===1&&V.isBuiltin,isUnderDevelopment:H,extensionLocation:V.location,uuid:V.identifier.uuid,targetPlatform:V.targetPlatform,...V.manifest}}e.toExtensionDescription=se;class he extends ae{constructor(H,W,A,F,U,J,B,$,L,O,_){super(H,W,(0,h.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(F,c.MANIFEST_CACHE_FOLDER),U,J,B,$,L,O,_),this.translationsPromise=(async()=>{if(E.translationsConfigFile)try{const j=await this.fileService.readFile(m.URI.file(E.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}getTranslations(H){return this.translationsPromise}}e.NativeExtensionsScannerService=he}),define(te[254],ie([0,1,7,36,72,89,14,5,6,20,39]),function(z,e,S,t,k,R,D,b,u,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends R.NativeExtensionsScannerService{constructor(h,f,P,w,m,v,d){super(S.URI.file(m.builtinExtensionsPath),S.URI.file(m.extensionsPath),m.userHome,S.URI.file(m.userDataPath),h,f,P,w,m,v,d)}};y=ve([ee(0,C.IUserDataProfilesService),ee(1,k.IExtensionsProfileScannerService),ee(2,D.IFileService),ee(3,u.ILogService),ee(4,t.INativeEnvironmentService),ee(5,p.IProductService),ee(6,b.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(te[255],ie([0,1,15,41,2,31,13,9,4,7,29,36,6,39]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let f=class extends k.Disposable{constructor(w,m,v){super(),this.environmentService=w,this.logService=v,this.validRoots=R.TernarySearchTree.forPaths(!u.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(w.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:w}=S.session;w.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(m,v)=>this.handleResourceRequest(m,v)),w.protocol.interceptFileProtocol(D.Schemas.file,(m,v)=>this.handleFileRequest(m,v)),this._register((0,k.toDisposable)(()=>{w.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(w){const m=(0,b.normalize)(w);return this.validRoots.get(m)?k.Disposable.None:(this.validRoots.set(m,!0),(0,k.toDisposable)(()=>this.validRoots.delete(m)))}handleFileRequest(w,m){const v=p.URI.parse(w.url);return this.logService.error(`Refused to load resource ${v.fsPath} from ${D.Schemas.file}: protocol (original URL: ${w.url})`),m({error:-3})}handleResourceRequest(w,m){const v=this.requestToNormalizedFilePath(w);let d;return this.environmentService.crossOriginIsolated&&((0,b.basename)(v)==="workbench.html"||(0,b.basename)(v)==="workbench-dev.html"?d=D.COI.CoopAndCoep:d=D.COI.getHeadersFromQuery(w.url)),this.validRoots.findSubstr(v)?m({path:v,headers:d}):this.validExtensions.has((0,b.extname)(v).toLowerCase())?m({path:v}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),m({error:-3}))}requestToNormalizedFilePath(w){const m=p.URI.parse(w.url),v=D.FileAccess.asFileUri(m);return(0,b.normalize)(v.fsPath)}createIPCObjectUrl(){let w;const m=p.URI.from({scheme:"vscode",path:(0,C.generateUuid)()}),v=m.toString(),d=async()=>w;return t.validatedIpcMain.handle(v,d),this.logService.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:m,update:g=>w=g,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${v}.`),t.validatedIpcMain.removeHandler(v)}}}};f=ve([ee(0,y.INativeEnvironmentService),ee(1,h.IUserDataProfilesService),ee(2,E.ILogService)],f),e.ProtocolMainService=f}),define(te[256],ie([0,1,15,41,8,3,2,13,12,102,27,22,6,54,61,64,44,39,37]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let d=class extends D.Disposable{constructor(c,i,o,n,r,s,l,a,I){super(),this.machineId=c,this.userEnv=i,this.environmentMainService=o,this.userDataProfilesService=n,this.lifecycleMainService=r,this.logService=s,this.policyService=l,this.themeMainService=a,this.protocolMainService=I,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,i)=>this.onWindowConnection(c,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,i)=>this.onWorkerConnection(c,i)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,i){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(c.sender.isDestroyed())return o.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[o])}onWorkerConnection(c,i){this.logService.trace("SharedProcess: onWorkerConnection",i);const o=new D.DisposableStore,n=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,i),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",i))},r=S.BrowserWindow.fromId(i.reply.windowId);if(!r||r.isDestroyed()||r.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}o.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===r)(()=>n("load"))),o.add(R.Event.fromNodeEventEmitter(r,"closed")(()=>n("closed"))),r.webContents.postMessage(i.reply.channel,i.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...i){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...i)}catch(o){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,w.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new S.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:h.default,policiesData:this.policyService.serialize()}),this.window.loadURL(b.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,i)=>this._onDidError.fire({type:2,details:i})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,i,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:i}})))}async connect(){await this.whenIpcReady;const c=(0,u.assertIsDefined)(this.window);return(0,p.connect)(c)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};d=ve([ee(2,C.IEnvironmentMainService),ee(3,m.IUserDataProfilesService),ee(4,y.ILifecycleMainService),ee(5,E.ILogService),ee(6,v.IPolicyService),ee(7,P.IThemeMainService),ee(8,f.IProtocolMainService)],d),e.SharedProcess=d}),define(te[90],ie([0,1,8,3,2,71,12,103,5,39]),function(z,e,S,t,k,R,D,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var C;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var E;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));function h(v){const d=v.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=h;class f extends k.Disposable{constructor(d={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=d,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,g){if(g===e.TARGET_KEY){switch(d){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:d})}else this._onDidChangeValue.fire({scope:d,key:g,target:this.getKeyTargets(d)[g]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,g,c){return this.getStorage(g)?.get(d,c)}getBoolean(d,g,c){return this.getStorage(g)?.getBoolean(d,c)}getNumber(d,g,c){return this.getStorage(g)?.getNumber(d,c)}store(d,g,c,i){if((0,D.isUndefinedOrNull)(g)){this.remove(d,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,c,i),this.getStorage(c)?.set(d,g)})}remove(d,g){this.withPausedEmitters(()=>{this.updateKeyTarget(d,g,void 0),this.getStorage(g)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,g){const c=[],i=this.getKeyTargets(d);for(const o of Object.keys(i))i[o]===g&&c.push(o);return c}updateKeyTarget(d,g,c){const i=this.getKeyTargets(g);typeof c=="number"?i[d]!==c&&(i[d]=c,this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[d]=="number"&&(delete i[d],this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(d){switch(d){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(d){const g=this.getStorage(d);return g?h(g):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=C.NONE){this._onWillSaveState.fire({reason:d});const g=this.getStorage(-1),c=this.getStorage(0),i=this.getStorage(1);switch(d){case C.NONE:await S.Promises.settled([g?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await S.Promises.settled([g?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return m(d,g,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(d,g){return this.emitWillSaveState(C.NONE),(0,p.isUserDataProfile)(d)?this.switchToProfile(d,g):this.switchToWorkspace(d,g)}canSwitchProfile(d,g){return!(d.id===g.id||P(g)&&P(d))}switchData(d,g,c,i){this.withPausedEmitters(()=>{if(i)for(const[o,n]of d)g.set(o,n);else{const o=new Set;for(const[n,r]of d)o.add(n),g.get(n)!==r&&this.emitDidChangeValue(c,n);for(const[n]of g.items)o.has(n)||this.emitDidChangeValue(c,n)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function P(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=P;class w extends f{constructor(){super(),this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.profileStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),this._register(this.applicationStorage.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d)))}getStorage(d){switch(d){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(d){return!1}}e.InMemoryStorageService=w;async function m(v,d,g,c,i,o){const n=X=>{try{return JSON.parse(X)}catch{return X}},r=new Map,s=new Map;v.forEach((X,ae)=>{r.set(ae,X),s.set(ae,n(X))});const l=new Map,a=new Map;d.forEach((X,ae)=>{l.set(ae,X),a.set(ae,n(X))});const I=new Map,M=new Map;g.forEach((X,ae)=>{I.set(ae,X),M.set(ae,n(X))}),console.group(c!==i?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const T=[];if(r.forEach((X,ae)=>{T.push({key:ae,value:X})}),console.table(T),console.groupEnd(),console.log(s),c!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const X=[];l.forEach((ae,Q)=>{X.push({key:Q,value:ae})}),console.table(X),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const N=[];I.forEach((X,ae)=>{N.push({key:ae,value:X})}),console.table(N),console.groupEnd(),console.log(M)}e.logStorage=m}),define(te[257],ie([0,1,24,8,3,2,9,79,7,21,103,147,6,90,32,28]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class w extends R.Disposable{get storage(){return this._storage}constructor(o,n){super(),this.logService=o,this.fileService=n,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new C.Storage(new C.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=C.StorageState.None}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===C.StorageState.None)try{const o=await this.doCreate();this._storage.dispose(),this._storage=o,this._register(o.onDidChangeStorage(r=>this._onDidChangeStorage.fire({key:r}))),await this.doInit(o);const n=o.getBoolean(h.IS_NEW_KEY);n===void 0?o.set(h.IS_NEW_KEY,!0):n&&o.set(h.IS_NEW_KEY,!1)}catch(o){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.state=C.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===E.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this._storage.items}get(o,n){return this._storage.get(o,n)}set(o,n){return this._storage.set(o,n)}delete(o){return this._storage.delete(o)}async close(){const o=new b.StopWatch(!1);await this.doClose(),o.stop(),o.elapsed()>w.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(o),this._onDidCloseStorage.fire()}async logSlowClose(o){if(!!this.path)try{const n=(0,S.top)(Array.from(this._storage.items.entries()).map(([s,l])=>({key:s,length:l.length})),(s,l)=>l.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),r=(await this.fileService.stat(u.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${r}b, Large Keys: ${n}`)}catch(n){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=C.StorageState.Closed,await this._storage.close()}}w.LOG_SLOW_CLOSE_THRESHOLD=2e3;class m extends w{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,m.STORAGE_NAME)}constructor(o,n,r,s){super(r,s),this.profile=o,this.options=n}async doCreate(){return new C.Storage(new y.SQLiteStorageDatabase(this.path??y.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}m.STORAGE_NAME="state.vscdb";class v extends m{constructor(o,n,r,s){super(o,n,r,s)}}e.ProfileStorageMain=v;class d extends m{constructor(o,n,r,s){super(n.defaultProfile,o,r,s)}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(f.firstSessionDateStorageKey,void 0)===void 0&&o.set(f.firstSessionDateStorageKey,new Date().toUTCString());const r=o.get(f.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();o.set(f.lastSessionDateStorageKey,typeof r>"u"?null:r),o.set(f.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=d;class g extends w{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,g.WORKSPACE_STORAGE_NAME)}constructor(o,n,r,s,l){super(r,l),this.workspace=o,this.options=n,this.environmentService=s}async doCreate(){const{storageFilePath:o,wasCreated:n}=await this.prepareWorkspaceStorageFolder();return new C.Storage(new y.SQLiteStorageDatabase(o,{logging:this.createLoggingOptions()}),{hint:n?C.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:y.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),n=(0,D.join)(o,g.WORKSPACE_STORAGE_NAME);return await p.Promises.exists(o)?{storageFilePath:n,wasCreated:!1}:(await p.Promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:n,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let n;if((0,P.isSingleFolderWorkspaceIdentifier)(this.workspace)?n={folder:this.workspace.uri.toString()}:(0,P.isWorkspaceIdentifier)(this.workspace)&&(n={workspace:this.workspace.configPath.toString()}),n)try{const r=(0,D.join)(o,g.WORKSPACE_META_NAME);await p.Promises.exists(r)||await p.Promises.writeFile(r,JSON.stringify(n,void 0,2))}catch(r){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json";class c extends w{get path(){}async doCreate(){return new C.Storage(new C.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(te[258],ie([0,1,67,36,14,6,227,51,39]),function(z,e,S,t,k,R,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let p=class At extends u.UserDataProfilesService{constructor(y,E,h,f,P){super(h,f,E,P),this.stateService=y}getStoredProfiles(){return(0,S.revive)(this.stateService.getItem(At.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,S.revive)(this.stateService.getItem(At.PROFILE_ASSOCIATIONS_KEY,{}))}};p=ve([ee(0,D.IStateService),ee(1,b.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,k.IFileService),ee(4,R.ILogService)],p),e.UserDataProfilesService=p}),define(te[42],ie([0,1,7,36,14,5,6,38,51,39,258]),function(z,e,S,t,k,R,D,b,u,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(p.IUserDataProfilesService);let y=class dt extends C.UserDataProfilesService{constructor(h,f,P,w,m){super(h,f,P,w,m),this.stateMainService=h}setEnablement(h){super.setEnablement(h),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(h){if(!!this.isEnabled()){if(h.profile){const f=this.profiles.find(P=>P.name===h.profile);return f?Promise.resolve(f):this.createNamedProfile(h.profile)}if(h["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(h){h.length?this.stateMainService.setItem(dt.PROFILES_KEY,h):this.stateMainService.removeItem(dt.PROFILES_KEY)}saveStoredProfileAssociations(h){h.emptyWindow||h.workspaces?this.stateMainService.setItem(dt.PROFILE_ASSOCIATIONS_KEY,h):this.stateMainService.removeItem(dt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const h="workspaceAndProfileInfo",f=this.stateMainService.getItem(h,void 0);if(f){this.stateMainService.removeItem(h);const P=f.reduce((w,{workspace:m,profile:v})=>(w[S.URI.revive(m).toString()]=S.URI.revive(v).toString(),w),{});this.stateMainService.setItem(dt.PROFILE_ASSOCIATIONS_KEY,{workspaces:P})}return super.getStoredProfileAssociations()}};y=ve([ee(0,b.IStateMainService),ee(1,u.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,k.IFileService),ee(4,D.ILogService)],y),e.UserDataProfilesMainService=y}),define(te[259],ie([0,1,2,16,72,89,14,6,39,42]),function(z,e,S,t,k,R,D,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let C=class extends S.Disposable{constructor(E,h,f,P,w){super(),this.userDataProfilesService=E,this.fileService=h,this.extensionsScannerService=f,this.extensionsProfileScannerService=P,E.isEnabled()?(this._register(E.onWillCreateProfile(m=>{E.profiles.length===1&&m.join(this.initialize())})),this._register(E.onDidChangeProfiles(m=>{E.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,m=>w.error(m))}async initialize(){const E=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(E)}catch{}const h=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(h.map(f=>[f,f.metadata]),E)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,u.EXTENSIONS_RESOURCE_NAME)}};C=ve([ee(0,p.IUserDataProfilesMainService),ee(1,D.IFileService),ee(2,R.IExtensionsScannerService),ee(3,k.IExtensionsProfileScannerService),ee(4,b.ILogService)],C),e.DefaultExtensionsProfileInitHandler=C}),define(te[260],ie([0,1,15,24,4,7,21,19,59,5,6,116,33,42]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,p.createDecorator)(e.ID);let f=class{constructor(w,m,v,d,g){this.logService=w,this.windowsMainService=m,this.urlService=v,this.configurationService=d,this.userDataProfilesMainService=g}async start(w,m){this.logService.trace("Received data from other instance: ",w,m),k.isMacintosh&&S.app.focus({steal:!0});const v=this.parseOpenUrl(w);if(v.length){let d=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));g&&(d=g.ready())}d.then(()=>{for(const{uri:g,url:c}of v)this.urlService.open(g,{originalUrl:c})})}else return this.startOpenWindow(w,m)}parseOpenUrl(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,t.coalesce)(w._urls.map(m=>{try{return{uri:R.URI.parse(m),url:m}}catch{return null}})):[]}async startOpenWindow(w,m){const v=(0,u.isLaunchedFromCli)(m)?0:4;let d=[];const g=w.wait&&w.waitMarkerFilePath?R.URI.file(w.waitMarkerFilePath):void 0,c=w.remote||void 0,i=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(w),o={context:v,cli:w,userEnv:m,waitMarkerFileURI:g,remoteAuthority:c,profile:i};if(w.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,o);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let n=!1;if(w["new-window"]||w["unity-launch"]||i)n=!0;else if(w["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!k.isMacintosh}if(n)d=await this.windowsMainService.open({...o,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,o),d=[r]):d=await this.windowsMainService.open({...o,forceEmpty:!0})}}else d=await this.windowsMainService.open({...o,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(g&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,D.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};f=ve([ee(0,C.ILogService),ee(1,E.IWindowsMainService),ee(2,y.IURLService),ee(3,b.IConfigurationService),ee(4,h.IUserDataProfilesMainService)],f),e.LaunchMainService=f}),define(te[91],ie([0,1,7,49,3,2,36,14,5,22,6,90,257,39,42,51]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,u.createDecorator)("storageMainService");let w=class extends R.Disposable{constructor(d,g,c,i,o,n){super(),this.logService=d,this.environmentService=g,this.userDataProfilesService=c,this.lifecycleMainService=i,this.fileService=o,this.uriIdentityService=n,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new k.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(d=>{d.window.profile&&this.profileStorage(d.window.profile).init(),d.workspace&&this.workspaceStorage(d.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(d=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=d.reason,d.join(this.applicationStorage.close());for(const[,g]of this.mapProfileToStorage)d.join(g.close());for(const[,g]of this.mapWorkspaceToStorage)d.join(g.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(d=>{d.join((async()=>{await this.fileService.exists(d.profile.globalStorageHome)||await this.fileService.createFolder(d.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(d=>{const g=this.mapProfileToStorage.get(d.profile.id);g&&d.join(g.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const d=new E.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(d.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),d}profileStorage(d){if((0,y.isProfileUsingDefaultStorage)(d))return this.applicationStorage;let g=this.mapProfileToStorage.get(d.id);if(!g){this.logService.trace(`StorageMainService: creating profile storage (${d.name})`),g=this.createProfileStorage(d),this.mapProfileToStorage.set(d.id,g);const c=this._register(g.onDidChangeStorage(i=>this._onDidChangeProfileStorage.fire({...i,storage:g,profile:d})));(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${d.name})`),this.mapProfileToStorage.delete(d.id),c.dispose()})}return g}createProfileStorage(d){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.ProfileStorageMain(d,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(d){let g=this.mapWorkspaceToStorage.get(d.id);return g||(this.logService.trace(`StorageMainService: creating workspace storage (${d.id})`),g=this.createWorkspaceStorage(d),this.mapWorkspaceToStorage.set(d.id,g),(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${d.id})`),this.mapWorkspaceToStorage.delete(d.id)})),g}createWorkspaceStorage(d){return this.shutdownReason===2?new E.InMemoryStorageMain(this.logService,this.fileService):new E.WorkspaceStorageMain(d,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(d){const g=S.URI.file(d);for(const c of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!c.path&&this.uriIdentityService.extUri.isEqualOrParent(S.URI.file(c.path),g))return!0;return!1}};w=ve([ee(0,C.ILogService),ee(1,D.IEnvironmentService),ee(2,f.IUserDataProfilesMainService),ee(3,p.ILifecycleMainService),ee(4,b.IFileService),ee(5,P.IUriIdentityService)],w),e.StorageMainService=w,e.IApplicationStorageMainService=(0,u.createDecorator)("applicationStorageMainService");let m=class extends y.AbstractStorageService{constructor(d,g){super(),this.userDataProfilesService=d,this.storageMainService=g,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(d){if(d===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(d){if(d===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};m=ve([ee(0,h.IUserDataProfilesService),ee(1,e.IStorageMainService)],m),e.ApplicationStorageMainService=m}),define(te[261],ie([0,1,2,22,42]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends S.Disposable{constructor(b,u){super(),this.userDataProfilesService=u,this._register(b.onWillLoadWindow(p=>{p.reason===2&&this.unsetTransientProfileForWorkspace(p.window.openedWorkspace??"empty-window")})),this._register(b.onBeforeCloseWindow(p=>this.unsetTransientProfileForWorkspace(p.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(b){this.userDataProfilesService.getOrSetProfileForWorkspace(b).isTransient&&(this.userDataProfilesService.unsetWorkspace(b,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([ee(0,t.ILifecycleMainService),ee(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(te[262],ie([0,1,3,2,90]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(b,u,p){super(),this.storageMainService=b,this.userDataProfilesService=u,this.logService=p;const C=this._register(new t.MutableDisposable);this._onDidChange=this._register(new S.Emitter({onFirstListenerAdd:()=>C.value=this.registerStorageChangeListeners(),onLastListenerRemove:()=>C.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const b=new t.DisposableStore;return b.add(S.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(u,p)=>(u?u.push(p.key):u=[p.key],u),100)(u=>this.onDidChangeApplicationStorage(u))),b.add(S.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(u,p)=>{u||(u=new Map);let C=u.get(p.profile.id);return C||u.set(p.profile.id,C={profile:p.profile,keys:[],storage:p.storage}),C.keys.push(p.key),u},100)(u=>this.onDidChangeProfileStorage(u))),b}onDidChangeApplicationStorage(b){const u=b.includes(k.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],p=[];if(b=b.filter(C=>C!==k.TARGET_KEY),b.length){const C=(0,k.loadKeyTargets)(this.storageMainService.applicationStorage.storage);p.push({profile:this.userDataProfilesService.defaultProfile,changes:b.map(y=>({key:y,scope:0,target:C[y]}))})}this.triggerEvents(u,p)}onDidChangeProfileStorage(b){const u=[],p=new Map;for(const[C,y]of b.entries()){y.keys.includes(k.TARGET_KEY)&&u.push(y.profile);const E=y.keys.filter(h=>h!==k.TARGET_KEY);if(E.length){const h=(0,k.loadKeyTargets)(y.storage.storage);p.set(C,{profile:y.profile,changes:E.map(f=>({key:f,scope:0,target:h[f]}))})}}this.triggerEvents(u,[...p.values()])}triggerEvents(b,u){(b.length||u.length)&&this._onDidChange.fire({valueChanges:u,targetChanges:b})}listen(b,u,p){switch(u){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${u}`)}async call(b,u){throw new Error(`Call not found: ${u}`)}}e.ProfileStorageChangesListenerChannel=R}),define(te[118],ie([0,1,16,7,28]),function(z,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(u,p,C){for(const E of u){const h=E.openedWorkspace;if((0,k.isWorkspaceIdentifier)(h)){const f=await C(h);if(f){if(f.folders.some(P=>S.extUriBiasedIgnorePathCase.isEqualOrParent(p,P.uri)))return E}else if(S.extUriBiasedIgnorePathCase.isEqualOrParent(p,h.configPath))return E}}const y=u.filter(E=>(0,k.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqualOrParent(p,E.openedWorkspace.uri));if(y.length)return y.sort((E,h)=>-(E.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(u,p){for(const C of u)if((0,k.isWorkspaceIdentifier)(C.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.configPath,p)||(0,k.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.uri,p))return C}e.findWindowOnWorkspaceOrFolder=D;function b(u,p){const C=y=>p.some(E=>S.extUriBiasedIgnorePathCase.isEqual(t.URI.file(E),t.URI.file(y)));for(const y of u)if(y.config?.extensionDevelopmentPath?.some(E=>C(E)))return y}e.findWindowOnExtensionDevelopmentPath=b}),define(te[263],ie([0,1,15,2,4,16,7,19,22,6,38,33,117,28]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let f=class Tt extends t.Disposable{get state(){return this._state}constructor(g,c,i,o,n){super(),this.windowsMainService=g,this.stateMainService=c,this.lifecycleMainService=i,this.logService=o,this.configurationService=n,this._state=P(this.stateMainService.getItem(Tt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){S.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(g=>this.onBeforeCloseWindow(g)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(g=>{g.newCount-g.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(g=>this.onBeforeCloseWindow(g))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const g=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),n&&(c.lastActiveWindow=this.toWindowState(n),c.lastActiveWindow.uiState.mode===3&&g.add(c.lastActiveWindow.uiState.display))}const i=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(i),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(g.has(c.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!i.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=1):g.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const r=this.toWindowState(n);return r.uiState.mode===3&&(g.has(r.uiState.display)?k.isMacintosh&&r.windowId!==c.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(r.uiState.mode=1):g.add(r.uiState.display)),r}));const o=m(c);this.stateMainService.setItem(Tt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(g){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(g);g.isExtensionDevelopmentHost&&!g.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!g.isExtensionDevelopmentHost&&g.openedWorkspace&&this._state.openedWindows.forEach(i=>{const o=(0,h.isWorkspaceIdentifier)(g.openedWorkspace)&&i.workspace?.id===g.openedWorkspace.id,n=(0,h.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,g.openedWorkspace.uri);(o||n)&&(i.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(g){return{windowId:g.id,workspace:(0,h.isWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace.uri:void 0,backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.serializeWindowState()}}getNewWindowState(g){const c=this.doGetNewWindowState(g),i=this.configurationService.getValue("window");if(c.mode===3){let o;c.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||i?.restoreFullscreen),o||(c.mode=1)}return c}doGetNewWindowState(g){const c=this.windowsMainService.getLastActiveWindow();if(!g.extensionTestsPath){if(!!g.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=g.workspace;if((0,h.isWorkspaceIdentifier)(l)){const I=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===l.id).map(M=>M.uiState);if(I.length)return I[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(l)){const I=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,l.uri)).map(M=>M.uiState);if(I.length)return I[0]}else if(g.backupPath){const I=this.state.openedWindows.filter(M=>M.backupPath===g.backupPath).map(M=>M.uiState);if(I.length)return I[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!c&&a)return a.uiState}let i;const o=S.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(k.isMacintosh){const l=S.screen.getCursorScreenPoint();i=S.screen.getDisplayNearestPoint(l)}!i&&c&&(i=S.screen.getDisplayMatching(c.getBounds())),i||(i=S.screen.getPrimaryDisplay()||o[0])}let n=(0,E.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")n.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")n.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&c){const l=c.serializeWindowState();l.mode===3?n.mode=3:n=l,s=n.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(g){if(this.windowsMainService.getWindows().length===0)return g;g.x=typeof g.x=="number"?g.x:0,g.y=typeof g.y=="number"?g.y:0;const c=this.windowsMainService.getWindows().map(i=>i.getBounds());for(;c.some(i=>i.x===g.x||i.y===g.y);)g.x+=30,g.y+=30;return g}};f.windowsStateStorageKey="windowsState",f=ve([ee(0,y.IWindowsMainService),ee(1,C.IStateMainService),ee(2,u.ILifecycleMainService),ee(3,p.ILogService),ee(4,b.IConfigurationService)],f),e.WindowsStateHandler=f;function P(d){const g={openedWindows:[]},c=d||{openedWindows:[]};return c.lastActiveWindow&&(g.lastActiveWindow=w(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(g.lastPluginDevelopmentHostWindow=w(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(g.openedWindows=c.openedWindows.map(i=>w(i))),g}e.restoreWindowsState=P;function w(d){const g={uiState:d.uiState};return d.backupPath&&(g.backupPath=d.backupPath),d.remoteAuthority&&(g.remoteAuthority=d.remoteAuthority),d.folder&&(g.folderUri=D.URI.parse(d.folder)),d.workspaceIdentifier&&(g.workspace={id:d.workspaceIdentifier.id,configPath:D.URI.parse(d.workspaceIdentifier.configURIPath)}),g}function m(d){return{lastActiveWindow:d.lastActiveWindow&&v(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&v(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(g=>v(g))}}e.getWindowsStateStoreData=m;function v(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(te[92],ie([0,1,30,43,124,35,13,9,4,16,7,5,63,28]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function f(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=f;function P(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=P;function w(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=w;function m(M){return v(M)||d(M)}e.isStoredWorkspaceFolder=m;function v(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function d(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function g(M,T,N,X,ae){if(M.scheme!==X.scheme)return{name:N,uri:M.toString(!0)};let Q=T?void 0:ae.relativePath(X,M);if(Q!==void 0)Q.length===0?Q=".":u.isWindows&&(Q=c(Q));else if(M.scheme===D.Schemas.file)Q=M.fsPath,u.isWindows&&(Q=c(Q));else if(ae.isEqualAuthority(M.authority,X.authority))Q=M.path;else return{name:N,uri:M.toString(!0)};return{name:N,path:Q}}e.getStoredWorkspaceFolder=g;function c(M){return M=(0,R.normalizeDriveLetter)(M),(0,S.isUNC)(M)||(M=(0,S.toSlashes)(M)),M}function i(M,T,N){const X=[],ae=new Set,Q=N.dirname(T);for(const G of M){let Z;if(v(G))G.path&&(Z=N.resolvePath(Q,G.path));else if(d(G))try{Z=C.URI.parse(G.uri),Z.path[0]!==b.posix.sep&&(Z=Z.with({path:b.posix.sep+Z.path}))}catch(se){console.warn(se)}if(Z){const se=N.getComparisonKey(Z);if(!ae.has(se)){ae.add(se);const he=G.name||N.basenameOrAuthority(Z);X.push(new h.WorkspaceFolder({uri:Z,name:he,index:X.length},G))}}}return X}e.toWorkspaceFolders=i;function o(M,T,N,X,ae){const Q=n(T,M),G=ae.dirname(T),Z=ae.dirname(X),se=[];for(const W of Q.folders){const A=v(W)?ae.resolvePath(G,W.path):C.URI.parse(W.uri);let F;N?F=!1:F=!v(W)||(0,b.isAbsolute)(W.path),se.push(g(A,F,W.name,Z,ae))}const he={insertSpaces:!1,tabSize:4,eol:u.isLinux||u.isMacintosh?`
`:`\r
`},V=k.setProperty(M,["folders"],se,he);let H=k.applyEdits(M,V);return(0,p.isEqualAuthority)(Q.remoteAuthority,(0,E.getRemoteAuthority)(X))&&(H=k.applyEdits(H,k.removeProperty(H,["remoteAuthority"],he))),H}e.rewriteWorkspaceFileForNewLocation=o;function n(M,T){const N=t.parse(T);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(X=>m(X));else throw new Error(`${M} looks like an invalid workspace file.`);return N}function r(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function s(M){return typeof M.folderUri=="string"}function l(M){return typeof M.fileUri=="string"}function a(M,T){const N={workspaces:[],files:[]};if(M){const X=function(Q,G){for(let Z=0;Z<Q.length;Z++)try{G(Q[Z],Z)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(Q[Z])}: ${se.toString()}. Skip entry.`)}},ae=M;Array.isArray(ae.entries)&&X(ae.entries,Q=>{const G=Q.label,Z=Q.remoteAuthority;r(Q)?N.workspaces.push({label:G,remoteAuthority:Z,workspace:{id:Q.workspace.id,configPath:C.URI.parse(Q.workspace.configPath)}}):s(Q)?N.workspaces.push({label:G,remoteAuthority:Z,folderUri:C.URI.parse(Q.folderUri)}):l(Q)&&N.files.push({label:G,remoteAuthority:Z,fileUri:C.URI.parse(Q.fileUri)})})}return N}e.restoreRecentlyOpened=a;function I(M){const T={entries:[]};for(const N of M.workspaces)P(N)?T.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):T.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of M.files)T.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return T}e.toStoreData=I}),define(te[93],ie([0,1,76,13,4,16]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(p){function C(){let y=p.scheme===t.Schemas.file?(0,R.originalFSPath)(p):p.toString();return k.isLinux||(y=y.toLowerCase()),(0,S.createHash)("md5").update(y).digest("hex")}return{id:C(),configPath:p}}e.getWorkspaceIdentifier=D;function b(p,C){function y(){if(p.scheme!==t.Schemas.file)return(0,S.createHash)("md5").update(p.toString()).digest("hex");if(!C)return;let h;return k.isLinux?h=C.ino:k.isMacintosh?h=C.birthtime.getTime():k.isWindows&&(typeof C.birthtimeMs=="number"?h=Math.floor(C.birthtimeMs):h=C.birthtime.getTime()),(0,S.createHash)("md5").update(p.fsPath).update(h?String(h):"").digest("hex")}const E=y();if(typeof E=="string")return{id:E,uri:p}}e.getSingleFolderWorkspaceIdentifier=b;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=u}),define(te[264],ie([0,1,76,30,13,9,4,16,21,177,19,27,38,14,6,176,28,93]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class Ot{constructor(g,c,i,o){this.environmentMainService=g,this.configurationService=c,this.logService=i,this.stateMainService=o,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=b.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,r)=>(0,t.isEqual)(n,r,!D.isLinux)}}async initialize(){const g=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(g.emptyWindows),this.workspaces=await this.validateWorkspaces((0,p.deserializeWorkspaceInfos)(g)),this.folders=await this.validateFolders((0,p.deserializeFolderInfos)(g)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let g=this.stateMainService.getItem(Ot.backupWorkspacesMetadataStorageKey);if(!g)try{const c=(0,R.join)(this.backupHome,"workspaces.json"),i=await u.Promises.readFile(c,"utf8");try{await u.Promises.unlink(c)}catch{}const o=JSON.parse(i);g={workspaces:Array.isArray(o.rootURIWorkspaces)?o.rootURIWorkspaces:[],folders:Array.isArray(o.folderWorkspaceInfos)?o.folderWorkspaceInfos:[],emptyWindows:Array.isArray(o.emptyWorkspaceInfos)?o.emptyWorkspaceInfos:[]}}catch(c){c.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${c.toString()}`)}return g??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(g,c){this.workspaces.some(o=>g.workspace.id===o.workspace.id)||(this.workspaces.push(g),this.storeWorkspacesMetadata());const i=(0,R.join)(this.backupHome,g.workspace.id);return c?this.moveBackupFolder(i,c).then(()=>i):i}async moveBackupFolder(g,c){if(await u.Promises.exists(g)&&await this.convertToEmptyWindowBackup(g),await u.Promises.exists(c))try{await u.Promises.rename(c,g)}catch(i){this.logService.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(g){return this.folders.some(c=>this.backupUriComparer.isEqual(g.folderUri,c.folderUri))||(this.folders.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(g))}registerEmptyWindowBackup(g){return this.emptyWindows.some(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,g.backupFolder))||(this.emptyWindows.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,g.backupFolder)}async validateWorkspaces(g){if(!Array.isArray(g))return[];const c=new Set,i=[];for(const o of g){const n=o.workspace;if(!(0,w.isWorkspaceIdentifier)(n))return[];if(!c.has(n.id)){c.add(n.id);const r=(0,R.join)(this.backupHome,n.id);await this.doHasBackups(r)?n.configPath.scheme!==k.Schemas.file||await u.Promises.exists(n.configPath.fsPath)?i.push(o):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return i}async validateFolders(g){if(!Array.isArray(g))return[];const c=[],i=new Set;for(const o of g){const n=o.folderUri,r=this.backupUriComparer.getComparisonKey(n);if(!i.has(r)){i.add(r);const s=(0,R.join)(this.backupHome,this.getFolderHash(o));await this.doHasBackups(s)?n.scheme!==k.Schemas.file||await u.Promises.exists(n.fsPath)?c.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(g){if(!Array.isArray(g))return[];const c=[],i=new Set;for(const o of g){const n=o.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const r=(0,R.join)(this.backupHome,n);await this.doHasBackups(r)?c.push(o):await this.deleteStaleBackup(r)}}return c}async deleteStaleBackup(g){try{await u.Promises.rm(g,u.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}prepareNewEmptyWindowBackup(){let g=(0,m.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,g.id));)g=(0,m.createEmptyWorkspaceIdentifier)();return{backupFolder:g.id}}async convertToEmptyWindowBackup(g){const c=this.prepareNewEmptyWindowBackup(),i=(0,R.join)(this.backupHome,c.backupFolder);try{await u.Promises.rename(g,i)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push(c),!0}async getDirtyWorkspaces(){const g=[];for(const c of this.workspaces)await this.hasBackups(c)&&g.push(c);for(const c of this.folders)await this.hasBackups(c)&&g.push(c);return g}hasBackups(g){let c;return(0,p.isEmptyWindowBackupInfo)(g)?c=(0,R.join)(this.backupHome,g.backupFolder):(0,P.isFolderBackupInfo)(g)?c=(0,R.join)(this.backupHome,this.getFolderHash(g)):c=(0,R.join)(this.backupHome,g.workspace.id),this.doHasBackups(c)}async doHasBackups(g){try{const c=await u.Promises.readdir(g);for(const i of c)try{if((await u.Promises.readdir((0,R.join)(g,i))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const g={workspaces:this.workspaces.map(({workspace:c,remoteAuthority:i})=>{const o={id:c.id,configURIPath:c.configPath.toString()};return i&&(o.remoteAuthority=i),o}),folders:this.folders.map(({folderUri:c,remoteAuthority:i})=>{const o={folderUri:c.toString()};return i&&(o.remoteAuthority=i),o}),emptyWindows:this.emptyWindows.map(({backupFolder:c,remoteAuthority:i})=>{const o={backupFolder:c};return i&&(o.remoteAuthority=i),o})};this.stateMainService.setItem(Ot.backupWorkspacesMetadataStorageKey,g)}getFolderHash(g){const c=g.folderUri;let i;return c.scheme===k.Schemas.file?i=D.isLinux?c.fsPath:c.fsPath.toLowerCase():i=c.toString().toLowerCase(),(0,S.createHash)("md5").update(i).digest("hex")}};v.backupWorkspacesMetadataStorageKey="backupWorkspaces",v=ve([ee(0,y.IEnvironmentMainService),ee(1,C.IConfigurationService),ee(2,f.ILogService),ee(3,E.IStateMainService)],v),e.BackupMainService=v}),define(te[52],ie([0,1,15,3,43,35,2,13,9,16,12,21,175,60,56,27,5,6,20,42,118,28,92,93]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let n=class extends D.Disposable{constructor(s,l,a,I,M,T){super(),this.environmentMainService=s,this.logService=l,this.userDataProfilesMainService=a,this.backupMainService=I,this.dialogMainService=M,this.productService=T,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const s=(await y.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(l=>(0,p.joinPath)(this.untitledWorkspacesHome,l,c.UNTITLED_WORKSPACE_NAME));for(const l of s){const a=(0,o.getWorkspaceIdentifier)(l),I=await this.resolveLocalWorkspace(l);I?this.untitledWorkspaces.push({workspace:a,remoteAuthority:I.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(s){s.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${s}).`)}}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,l=>y.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(s,l){if(!!this.isWorkspacePath(s)&&s.scheme===b.Schemas.file)try{const a=l(s.fsPath);return a instanceof Promise?a.then(I=>this.doResolveWorkspace(s,I),I=>{}):this.doResolveWorkspace(s,a)}catch{return}}isWorkspacePath(s){return(0,c.isUntitledWorkspace)(s,this.environmentMainService)||(0,c.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,l){try{const a=this.doParseStoredWorkspace(s,l),I=(0,o.getWorkspaceIdentifier)(s);return{id:I.id,configPath:I.configPath,folders:(0,i.toWorkspaceFolders)(a.folders,I.configPath,p.extUriBiasedIgnorePathCase),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.logService.warn(a.toString())}}doParseStoredWorkspace(s,l){const a=(0,k.parse)(l);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(I=>(0,i.isStoredWorkspaceFolder)(I));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(s,l){const{workspace:a,storedWorkspace:I}=this.newUntitledWorkspace(s,l),M=a.configPath.fsPath;return await y.Promises.mkdir((0,u.dirname)(M),{recursive:!0}),await y.Promises.writeFile(M,JSON.stringify(I,null,"	")),this.untitledWorkspaces.push({workspace:a,remoteAuthority:l}),a}newUntitledWorkspace(s=[],l){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),I=(0,p.joinPath)(this.untitledWorkspacesHome,a),M=(0,p.joinPath)(I,c.UNTITLED_WORKSPACE_NAME),T=[];for(const N of s)T.push((0,i.getStoredWorkspaceFolder)(N.uri,!0,N.name,I,p.extUriBiasedIgnorePathCase));return{workspace:(0,o.getWorkspaceIdentifier)(M),storedWorkspace:{folders:T,remoteAuthority:l}}}async getWorkspaceIdentifier(s){return(0,o.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,c.isUntitledWorkspace)(s.configPath,this.environmentMainService)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.doDeleteUntitledWorkspace(s),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(s),this._onDidDeleteUntitledWorkspace.fire(s))}async doDeleteUntitledWorkspace(s){const l=(0,p.originalFSPath)(s.configPath);try{await y.Promises.rm((0,u.dirname)(l));const a=(0,u.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);await y.Promises.exists(a)&&await y.Promises.writeFile((0,u.join)(a,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(I=>I.workspace.id!==s.id)}catch(a){this.logService.warn(`Unable to delete untitled workspace ${l} (${a}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(s,l,a){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,l,a))return;const M=await this.doEnterWorkspace(s,(0,o.getWorkspaceIdentifier)(a));if(!!M)return this._onDidEnterWorkspace.fire({window:s,workspace:M.workspace}),M}async isValidTargetWorkspacePath(s,l,a){if(!a)return!0;if((0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,a))return!1;if((0,g.findWindowOnWorkspaceOrFolder)(l,a)){const I={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(0,null))],message:(0,E.localize)(1,null,(0,p.basename)(a)),detail:(0,E.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(I,(0,C.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(s,l){if(!s.config)return;s.focus();let a;return s.config.extensionDevelopmentPath||(s.config.backupPath?a=await this.backupMainService.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority},s.config.backupPath):a=this.backupMainService.registerWorkspaceBackup({workspace:l,remoteAuthority:s.remoteAuthority})),(0,c.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=l,s.config.backupPath=a,{workspace:l,backupPath:a}}};n=ve([ee(0,P.IEnvironmentMainService),ee(1,m.ILogService),ee(2,d.IUserDataProfilesMainService),ee(3,h.IBackupMainService),ee(4,f.IDialogMainService),ee(5,v.IProductService)],n),e.WorkspacesManagementMainService=n}),define(te[119],ie([0,1,15,41,23,5,33,28,52,12,6]),function(z,e,S,t,k,R,D,b,u,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let y=class{constructor(h,f,P){this.windowsMainService=h,this.workspacesManagementMainService=f,this.logService=P}async getRemoteDiagnostics(h){const f=this.windowsMainService.getWindows();return(await Promise.all(f.map(async w=>{const m=w.remoteAuthority;if(!m)return;const v=`vscode:getDiagnosticInfoResponse${w.id}`,d={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.getFolderURIs(w):void 0};return new Promise(g=>{w.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:v,args:d}),t.validatedIpcMain.once(v,(c,i)=>{i||g({hostName:m,errorMessage:`Unable to resolve connection to '${m}'.`}),g(i)}),setTimeout(()=>{g({hostName:m,errorMessage:`Connection to '${m}' could not be established`})},5e3)})}))).filter(w=>!!w)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const h=[];for(const f of S.BrowserWindow.getAllWindows()){const P=this.windowsMainService.getWindowById(f.id);P?h.push(await this.codeWindowToInfo(P)):h.push(this.browserWindowToInfo(f))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async codeWindowToInfo(h){const f=await this.getFolderURIs(h),P=(0,p.assertIsDefined)(h.win);return this.browserWindowToInfo(P,f,h.remoteAuthority)}browserWindowToInfo(h,f=[],P){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:f,remoteAuthority:P}}async getFolderURIs(h){const f=[],P=h.openedWorkspace;if((0,b.isSingleFolderWorkspaceIdentifier)(P))f.push(P.uri);else if((0,b.isWorkspaceIdentifier)(P)){const w=await this.workspacesManagementMainService.resolveLocalWorkspace(P.configPath);w&&w.folders.forEach(v=>{f.push(v.uri)})}return f}};y=ve([ee(0,D.IWindowsMainService),ee(1,u.IWorkspacesManagementMainService),ee(2,C.ILogService)],y),e.DiagnosticsMainService=y}),define(te[65],ie([0,1,45,15,25,141,53,3,35,2,13,9,4,7,99,81,21,95,165,56,27,5,22,6,20,64,33,28,52,18,221,231,32]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c,i,o,n,r,s,l,a,I,M,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let X=class extends p.Disposable{constructor(Q,G,Z,se,he,V,H,W,A,F){super(),this.sharedProcess=Q,this.windowsMainService=G,this.dialogMainService=Z,this.lifecycleMainService=se,this.environmentMainService=he,this.logService=V,this.productService=H,this.themeMainService=W,this.workspacesManagementMainService=A,this.telemetryService=F,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,U=>U.id),this.onDidTriggerSystemContextMenu=b.Event.filter(b.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:U,x:J,y:B})=>({windowId:U.id,x:J,y:B})),({windowId:U})=>!!this.windowsMainService.getWindowById(U)),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),U=>!!U),U=>U.id),b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(U,J,B)=>B),U=>!(Array.isArray(U)&&U.length===1&&U[0]==="workArea")),b.Event.fromNodeEventEmitter(t.screen,"display-added"),b.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100),this._profilingSessions=new Map}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(G=>({id:G.id,workspace:G.openedWorkspace??(0,l.toWorkspaceIdentifier)(G.backupPath,G.isExtensionDevelopmentHost),title:G.win?.getTitle()??"",filename:G.getRepresentedFilename(),dirty:G.isDocumentEdited()}))}async getWindowCount(Q){return this.windowsMainService.getWindowCount()}async getActiveWindowId(Q){const G=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(G)return G.id}openWindow(Q,G,Z){return Array.isArray(G)?this.doOpenWindow(Q,G,Z):this.doOpenEmptyWindow(Q,G)}async doOpenWindow(Q,G,Z=Object.create(null)){G.length>0&&await this.windowsMainService.open({context:5,contextWindowId:Q,urisToOpen:G,cli:this.environmentMainService.args,forceNewWindow:Z.forceNewWindow,forceReuseWindow:Z.forceReuseWindow,preferNewWindow:Z.preferNewWindow,diffMode:Z.diffMode,mergeMode:Z.mergeMode,addMode:Z.addMode,gotoLineMode:Z.gotoLineMode,noRecentEntry:Z.noRecentEntry,waitMarkerFileURI:Z.waitMarkerFileURI,remoteAuthority:Z.remoteAuthority||void 0})}async doOpenEmptyWindow(Q,G){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:Q},G)}async toggleFullScreen(Q){this.windowById(Q)?.toggleFullScreen()}async handleTitleDoubleClick(Q){this.windowById(Q)?.handleTitleDoubleClick()}async isMaximized(Q){const G=this.windowById(Q);return G?.win?G.win.isMaximized():!1}async maximizeWindow(Q){const G=this.windowById(Q);G?.win&&G.win.maximize()}async unmaximizeWindow(Q){const G=this.windowById(Q);G?.win&&G.win.unmaximize()}async minimizeWindow(Q){const G=this.windowById(Q);G?.win&&G.win.minimize()}async updateWindowControls(Q,G){const Z=this.windowById(Q);Z&&Z.updateWindowControls(G)}async focusWindow(Q,G){G&&typeof G.windowId=="number"&&(Q=G.windowId),this.windowById(Q)?.focus({force:G?.force??!1})}async setMinimumSize(Q,G,Z){const se=this.windowById(Q);if(se?.win){const[he,V]=se.win.getSize(),[H,W]=se.win.getMinimumSize(),[A,F]=[G??H,Z??W],[U,J]=[Math.max(he,A),Math.max(V,F)];(H!==A||W!==F)&&se.win.setMinimumSize(A,F),(he!==U||V!==J)&&se.win.setSize(U,J)}}async saveWindowSplash(Q,G){this.themeMainService.saveWindowSplash(Q,G)}async installShellCommand(Q){const{source:G,target:Z}=await this.getShellCommandLink();try{const{symbolicLink:se}=await w.SymlinkSupport.stat(G);if(se&&!se.dangling){const he=await(0,f.realpath)(G);if(Z===he)return}await w.Promises.unlink(G)}catch(se){if(se.code!=="ENOENT")throw se}try{await w.Promises.symlink(Z,G)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:he}=await this.showMessageBox(Q,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,u.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(he===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Z}' '${G}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(V)}catch{throw new Error((0,v.localize)(3,null,G))}}}async uninstallShellCommand(Q){const{source:G}=await this.getShellCommandLink();try{await w.Promises.unlink(G)}catch(Z){switch(Z.code){case"EACCES":{const{response:se}=await this.showMessageBox(Q,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,u.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const he=`osascript -e "do shell script \\"rm '${G}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(he)}catch{throw new Error((0,v.localize)(7,null,G))}break}case"ENOENT":break;default:throw Z}}}async getShellCommandLink(){const Q=(0,y.resolve)(this.environmentMainService.appRoot,"bin","code"),G=`/usr/local/bin/${this.productService.applicationName}`;if(!await w.Promises.exists(Q))throw new Error((0,v.localize)(8,null,Q));return{source:G,target:Q}}async showMessageBox(Q,G){return this.dialogMainService.showMessageBox(G,this.toBrowserWindow(Q))}async showSaveDialog(Q,G){return this.dialogMainService.showSaveDialog(G,this.toBrowserWindow(Q))}async showOpenDialog(Q,G){return this.dialogMainService.showOpenDialog(G,this.toBrowserWindow(Q))}toBrowserWindow(Q){const G=this.windowById(Q);if(G?.win)return G.win}async pickFileFolderAndOpen(Q,G){const Z=await this.dialogMainService.pickFileFolder(G);Z&&await this.doOpenPicked(await Promise.all(Z.map(async se=>await w.SymlinkSupport.existsDirectory(se)?{folderUri:h.URI.file(se)}:{fileUri:h.URI.file(se)})),G,Q)}async pickFolderAndOpen(Q,G){const Z=await this.dialogMainService.pickFolder(G);Z&&await this.doOpenPicked(Z.map(se=>({folderUri:h.URI.file(se)})),G,Q)}async pickFileAndOpen(Q,G){const Z=await this.dialogMainService.pickFile(G);Z&&await this.doOpenPicked(Z.map(se=>({fileUri:h.URI.file(se)})),G,Q)}async pickWorkspaceAndOpen(Q,G){const Z=await this.dialogMainService.pickWorkspace(G);Z&&await this.doOpenPicked(Z.map(se=>({workspaceUri:h.URI.file(se)})),G,Q)}async doOpenPicked(Q,G,Z){await this.windowsMainService.open({context:3,contextWindowId:Z,cli:this.environmentMainService.args,urisToOpen:Q,forceNewWindow:G.forceNewWindow})}async showItemInFolder(Q,G){t.shell.showItemInFolder(G)}async setRepresentedFilename(Q,G){this.windowById(Q)?.setRepresentedFilename(G)}async setDocumentEdited(Q,G){this.windowById(Q)?.setDocumentEdited(G)}async openExternal(Q,G){return E.isLinuxSnap?this.safeSnapOpenExternal(G):t.shell.openExternal(G),!0}safeSnapOpenExternal(Q){const G=process.env.GDK_PIXBUF_MODULE_FILE,Z=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(Q),process.env.GDK_PIXBUF_MODULE_FILE=G,process.env.GDK_PIXBUF_MODULEDIR=Z}moveItemToTrash(Q,G){return t.shell.trashItem(G)}async isAdmin(){let Q;return E.isWindows?Q=(await new Promise((G,Z)=>{z(["native-is-elevated"],G,Z)}))():Q=process.getuid()===0,Q}async writeElevated(Q,G,Z,se){const he=await new Promise((V,H)=>{z(["@vscode/sudo-prompt"],V,H)});return new Promise((V,H)=>{const W=[`"${this.cliPath}"`];se?.unlock&&W.push("--file-chmod"),W.push("--file-write",`"${G.fsPath}"`,`"${Z.fsPath}"`);const A={name:this.productService.nameLong.replace("-",""),icns:E.isMacintosh&&this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};he.exec(W.join(" "),A,(F,U,J)=>{U&&this.logService.trace(`[sudo-prompt] received stdout: ${U}`),J&&this.logService.trace(`[sudo-prompt] received stderr: ${J}`),F?H(F):V(void 0)})})}get cliPath(){return E.isWindows?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):E.isLinux?this.environmentMainService.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,y.join)(this.environmentMainService.appRoot,"bin","code"):(0,y.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return P.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return E.isWindows&&(0,M.hasWSLFeatureInstalled)()}async killProcess(Q,G,Z){process.kill(G,Z)}async readClipboardText(Q,G){return t.clipboard.readText(G)}async writeClipboardText(Q,G,Z){return t.clipboard.writeText(G,Z)}async readClipboardFindText(Q){return t.clipboard.readFindText()}async writeClipboardFindText(Q,G){return t.clipboard.writeFindText(G)}async writeClipboardBuffer(Q,G,Z,se){return t.clipboard.writeBuffer(G,Buffer.from(Z.buffer),se)}async readClipboardBuffer(Q,G){return I.VSBuffer.wrap(t.clipboard.readBuffer(G))}async hasClipboard(Q,G,Z){return t.clipboard.has(G,Z)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(Q,G){this.windowById(Q)?.updateTouchBar(G)}async notifyReady(Q){this.windowById(Q)?.setReady()}async relaunch(Q,G){return this.lifecycleMainService.relaunch(G)}async reload(Q,G){const Z=this.windowById(Q);if(Z){if((0,l.isWorkspaceIdentifier)(Z.openedWorkspace)){const se=Z.openedWorkspace.configPath;if(se.scheme===C.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(se))?.transient)return this.openWindow(Z.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Z,G?.disableExtensions!==void 0?{_:[],"disable-extensions":G.disableExtensions}:void 0)}}async closeWindow(Q){this.closeWindowById(Q,Q)}async closeWindowById(Q,G){const Z=this.windowById(G);if(Z?.win)return Z.win.close()}async quit(Q){const G=this.windowsMainService.getLastActiveWindow();G?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&G.win?G.win.close():this.lifecycleMainService.quit()}async exit(Q,G){await this.lifecycleMainService.kill(G)}async resolveProxy(Q,G){const se=this.windowById(Q)?.win?.webContents?.session;if(se)return se.resolveProxy(G)}findFreePort(Q,G,Z,se,he=1){return(0,m.findFreePort)(G,Z,se,he)}async openDevTools(Q,G){const Z=this.windowById(Q);Z?.win&&Z.win.webContents.openDevTools(G)}async toggleDevTools(Q){const G=this.windowById(Q);G?.win&&G.win.webContents.toggleDevTools()}async sendInputEvent(Q,G){const Z=this.windowById(Q);Z?.win&&(G.type==="mouseDown"||G.type==="mouseUp")&&Z.win.webContents.sendInputEvent(G)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async startHeartbeat(Q,G){const Z=this.windowById(Q);if(!Z||!Z.win)return!1;if(!this._profilingSessions.has(Z.id)){const se=new T.WindowProfiler(Z.win,G,this.logService,this.telemetryService);this._profilingSessions.set(Z.id,se),se.start()}return!0}async sendHeartbeat(Q,G){const Z=this.windowById(Q);return!Z||!this._profilingSessions.has(Z.id)||this._profilingSessions.get(Z.id).receiveHeartbeat(),!1}async stopHeartbeat(Q,G){const Z=this.windowById(Q);return!Z||!this._profilingSessions.has(Z.id)||(this._profilingSessions.get(Z.id).stop(),this._profilingSessions.delete(Z.id)),!1}async windowsGetStringRegKey(Q,G,Z,se){if(!E.isWindows)return;const he=await new Promise((V,H)=>{z(["@vscode/windows-registry"],V,H)});try{return he.GetStringRegKey(G,Z,se)}catch{return}}windowById(Q){if(typeof Q=="number")return this.windowsMainService.getWindowById(Q)}};ve([D.memoize],X.prototype,"cliPath",null),X=ve([ee(1,s.IWindowsMainService),ee(2,d.IDialogMainService),ee(3,i.ILifecycleMainService),ee(4,g.IEnvironmentMainService),ee(5,o.ILogService),ee(6,n.IProductService),ee(7,r.IThemeMainService),ee(8,a.IWorkspacesManagementMainService),ee(9,N.ITelemetryService)],X),e.NativeHostMainService=X}),define(te[265],ie([0,1,15,41,25,35,2,13,4,100,163,84,119,56,27,5,6,65,54,20,61,74,30,12]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,P.createDecorator)("issueMainService");let n=class Nt{constructor(s,l,a,I,M,T,N,X,ae){this.userEnv=s,this.environmentMainService=l,this.logService=a,this.diagnosticsService=I,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=N,this.protocolMainService=X,this.productService=ae,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[l,a]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),I=await this.diagnosticsService.getSystemInfo(l,a);this.safeSend(s,"vscode:issueSystemInfoResponse",I)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const l=[];try{l.push({name:(0,C.localize)(0,null),rootProcess:await(0,p.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(I=>{(0,y.isRemoteDiagnosticError)(I)?l.push({name:I.hostName,rootProcess:I}):I.processes&&l.push({name:I.hostName,rootProcess:I.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const l={title:this.productService.nameLong,message:(0,C.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(l,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const l=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",l)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,C.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,l)=>{const{id:a,from:I,args:M}=l;let T;switch(I){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${I}`)}T?.webContents.send("vscode:runAction",{id:a,from:I,args:M})}),t.validatedIpcMain.on("vscode:openExternal",(s,l)=>{this.nativeHostMainService.openExternal(void 0,l)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const l=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",l.windows)})}safeSend(s,l,...a){s.sender.isDestroyed()||s.sender.send(l,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const l=new D.DisposableStore,a=l.add(this.protocolMainService.createIPCObjectUrl()),I=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(I,a,{backgroundColor:s.styles.backgroundColor,title:(0,C.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:v.default}),this.issueReporterWindow.loadURL(b.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,l.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,l.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const l=new D.DisposableStore,a=l.add(this.protocolMainService.createIPCObjectUrl()),I=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(I,a,{backgroundColor:s.styles.backgroundColor,title:(0,C.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:v.default}),this.processExplorerWindow.loadURL(b.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,l.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,l.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,l,a,I){const M=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||Nt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,`--vscode-window-kind=${I}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return M.setMenuBarVisibility(!1),M}async getSystemStatus(){const[s,l]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,l)}getWindowPosition(s,l,a){let I;const M=S.screen.getAllDisplays();if(M.length===1)I=M[0];else{if(u.isMacintosh){const X=S.screen.getCursorScreenPoint();I=S.screen.getDisplayNearestPoint(X)}!I&&s&&(I=S.screen.getDisplayMatching(s.getBounds())),I||(I=S.screen.getPrimaryDisplay()||M[0])}const T={width:l,height:a},N=I.bounds;return T.x=N.x+N.width/2-T.width/2,T.y=N.y+N.height/2-T.height/2,N.width>0&&N.height>0&&(T.x<N.x&&(T.x=N.x),T.y<N.y&&(T.y=N.y),T.x>N.x+N.width&&(T.x=N.x),T.y>N.y+N.height&&(T.y=N.y),T.width>N.width&&(T.width=N.width),T.height>N.height&&(T.height=N.height)),T}async getPerformanceInfo(){try{const[s,l]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,l)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await S.contentTracing.stopRecording(`${(0,i.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,C.localize)(9,null),detail:(0,C.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(11,null))],defaultId:0,noLink:!0},(0,o.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};n.DEFAULT_BACKGROUND_COLOR="#1E1E1E",n=ve([ee(1,f.IEnvironmentMainService),ee(2,w.ILogService),ee(3,y.IDiagnosticsService),ee(4,E.IDiagnosticsMainService),ee(5,h.IDialogMainService),ee(6,m.INativeHostMainService),ee(7,g.IProtocolMainService),ee(8,d.IProductService)],n),e.IssueMainService=n}),define(te[266],ie([0,1,23,19,27,22,6,65,20,55,32,48,88]),function(z,e,S,t,k,R,D,b,u,p,C,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends E.AbstractUpdateService{constructor(P,w,m,v,d,g,c,i){super(P,w,v,d,g,i),this.telemetryService=m,this.nativeHostMainService=c}buildUpdateFeedUrl(P){return(0,E.createUpdateURL)(`linux-${process.arch}`,P,this.productService)}doCheckForUpdates(P){!this.url||(this.setState(y.State.CheckingForUpdates(P)),this.requestService.request({url:this.url},S.CancellationToken.None).then(p.asJson).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P}),this.setState(y.State.Idle(1))):this.setState(y.State.AvailableForDownload(w))}).then(void 0,w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!P});const m=P?w.message||w:void 0;this.setState(y.State.Idle(1,m))}))}async doDownloadUpdate(P){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):P.update.url&&this.nativeHostMainService.openExternal(void 0,P.update.url),this.setState(y.State.Idle(1))}};h=ve([ee(0,R.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,C.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,p.IRequestService),ee(5,D.ILogService),ee(6,b.INativeHostMainService),ee(7,u.IProductService)],h),e.LinuxUpdateService=h}),define(te[267],ie([0,1,45,40,25,8,23,53,9,7,127,21,19,27,14,22,6,65,20,55,32,48,88]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(l,a=1e3){for(;!l();)await(0,R.timeout)(a)}let n;function r(){return typeof n>"u"&&(n=t.existsSync(u.join(u.dirname(process.execPath),"unins000.exe"))?0:1),n}let s=class extends i.AbstractUpdateService{get cachePath(){const a=u.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return y.Promises.mkdir(a,{recursive:!0}).then(()=>a)}constructor(a,I,M,T,N,X,ae,Q,G){super(a,I,T,N,X,G),this.telemetryService=M,this.fileService=ae,this.nativeHostMainService=Q}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(a){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),r()===1?I+="-archive":this.productService.target==="user"&&(I+="-user"),(0,i.createUpdateURL)(I,a,this.productService)}doCheckForUpdates(a){!this.url||(this.setState(c.State.CheckingForUpdates(a)),this.requestService.request({url:this.url},D.CancellationToken.None).then(d.asJson).then(I=>{const M=r();return!I||!I.url||!I.version||!I.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(I)),Promise.resolve(null)):(this.setState(c.State.Downloading(I)),this.cleanup(I.version).then(()=>this.getUpdatePackagePath(I.version).then(T=>y.Promises.exists(T).then(N=>{if(N)return Promise.resolve(T);const X=I.url,ae=I.hash,Q=`${T}.tmp`;return this.requestService.request({url:X},D.CancellationToken.None).then(G=>this.fileService.writeFile(p.URI.file(Q),G.stream)).then(ae?()=>(0,C.checksum)(Q,I.hash):()=>{}).then(()=>y.Promises.rename(Q,T)).then(()=>T)})).then(T=>{const N=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},N&&I.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(I)):this.setState(c.State.Ready(I))})))}).then(void 0,I=>{this.logService.error(I),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a});const M=a?I.message||I:void 0;this.setState(c.State.Idle(r(),M))}))}async doDownloadUpdate(a){a.update.url&&this.nativeHostMainService.openExternal(void 0,a.update.url),this.setState(c.State.Idle(r()))}async getUpdatePackagePath(a){const I=await this.cachePath;return u.join(I,`CodeSetup-${this.productService.quality}-${a}.exe`)}async cleanup(a=null){const I=a?X=>!new RegExp(`${this.productService.quality}-${a}\\.exe$`).test(X):()=>!0,M=await this.cachePath,N=(await y.Promises.readdir(M)).filter(I).map(async X=>{try{await y.Promises.unlink(u.join(M,X))}catch{}});await Promise.all(N)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const a=this.state.update;this.setState(c.State.Updating(a));const I=await this.cachePath;this.availableUpdate.updateFilePath=u.join(I,`CodeSetup-${this.productService.quality}-${a.version}.flag`),await y.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,S.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(r()))});const T=`${this.productService.win32MutexName}-ready`,N=await new Promise((X,ae)=>{z(["windows-mutex"],X,ae)});o(()=>N.isActive(T)).then(()=>this.setState(c.State.Ready(a)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,S.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}async _applySpecificUpdate(a){if(this.state.type!=="idle")return;const I=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!I};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:a},I?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};ve([b.memoize],s.prototype,"cachePath",null),s=ve([ee(0,P.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,g.ITelemetryService),ee(3,h.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,w.ILogService),ee(6,f.IFileService),ee(7,m.INativeHostMainService),ee(8,v.IProductService)],s),e.Win32UpdateService=s}),define(te[268],ie([0,1,15,8,23,44,3,35,2,13,9,71,4,7,171,60,19,56,27,59,14,22,6,20,61,233,91,32,236,64,74,33,28,52,117,121,37,38,54,42]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c,i,o,n,r,s,l,a,I,M,T,N,X,ae,Q,G,Z,se,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(W){W[W.NONE=0]="NONE",W[W.NAVIGATING=1]="NAVIGATING",W[W.READY=2]="READY"})(V||(V={}));let H=class Ft extends u.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(A,F,U,J,B,$,L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae){super(),this.logService=F,this.environmentMainService=U,this.policyService=J,this.userDataProfilesService=B,this.fileService=$,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=_,this.themeMainService=j,this.workspacesManagementMainService=Y,this.backupMainService=oe,this.telemetryService=q,this.dialogMainService=re,this.lifecycleMainService=ne,this.productService=ce,this.protocolMainService=ge,this.windowsMainService=De,this.stateMainService=Ae,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ke,Le]=this.restoreWindowState(A.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const qe=this.windowState.mode===0||this.windowState.mode===3,me=this.configurationService.getValue("window");let we=!1;typeof me?.experimental?.useSandbox=="boolean"?we=me.experimental.useSandbox:we=typeof se.default.quality=="string"&&se.default.quality!=="stable";const Ee={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!qe,title:this.productService.nameLong,webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(me?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...we?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};E.isLinux?Ee.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):E.isWindows&&!this.environmentMainService.isBuilt&&(Ee.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),E.isMacintosh&&!this.useNativeFullScreen()&&(Ee.fullscreenable=!1),E.isMacintosh&&(Ee.acceptFirstMouse=!0,me?.clickThroughInactive===!1&&(Ee.acceptFirstMouse=!1));const x=E.isMacintosh&&me?.nativeTabs===!0;x&&(Ee.tabbingIdentifier=this.productService.nameShort);const le=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(Ee.titleBarStyle="hidden",E.isMacintosh||(Ee.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService))){const fe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Se=Q.Color.fromHex(fe).isDarker()?"#FFFFFF":"#000000";Ee.titleBarOverlay={height:29,color:fe,symbolColor:Se},this.hasWindowControlOverlay=!0}if((0,y.mark)("code/willCreateCodeBrowserWindow"),this._win=new S.BrowserWindow(Ee),(0,y.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,E.isMacintosh&&le&&this._win.setSheetOffset(22),le&&(E.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService)||E.isMacintosh)){const fe=this.stateMainService.getItem(Ft.windowControlHeightStateStorageKey);fe&&this.updateWindowControls({height:fe})}E.isWindows&&le&&this._win.hookWindowMessage(278,()=>{const[Se,Ie]=this._win.getPosition(),Te=S.screen.getCursorScreenPoint(),Oe=Te.x-Se,Ne=Te.y-Ie;return(()=>!(Oe>30&&Ne>=0&&Ne<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:Ne})),0}),(E.isMacintosh||E.isWindows)&&Le&&(!x||S.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(fe=>typeof fe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),qe&&((0,y.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,y.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(A){E.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return E.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){E.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return E.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){E.isMacintosh&&A?.force&&S.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function F(){U.dispose(),J.dispose(),A()}const U=this.onDidClose(()=>F()),J=this.onWillLoad(()=>F())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(F,U)=>this.onWindowError(2,U)),this._win.webContents.on("did-fail-load",(F,U,J)=>this.onWindowError(3,{reason:J,exitCode:U})),this._win.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",F=>{this._config&&(this._config.maximized=!0),S.app.emit("browser-window-maximize",F,this._win)}),this._win.on("unmaximize",F=>{this._config&&(this._config.maximized=!1),S.app.emit("browser-window-unmaximize",F,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(F=>this.onConfigurationUpdated(F))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(F=>this.onDidDeleteUntitledWorkspace(F)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(F,U)=>{const J=await this.getMarketplaceHeaders();U({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,J)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,F){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:F?.reason,code:F?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,f.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,f.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,f.localize)(2,null))],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,f.localize)(5,null):void 0},this._win);if(U.response!==1){const J=U.response===0;await this.destroyWindow(J,U.checkboxChecked)}}else if(A===2){let U;F?U=(0,f.localize)(7,null,F.reason,F.exitCode??"<unknown>"):U=(0,f.localize)(6,null);const J=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,f.localize)(8,null)),(0,b.mnemonicButtonLabel)((0,f.localize)(9,null))],message:U,detail:(0,f.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,f.localize)(11,null):void 0},this._win),B=J.response===0;await this.destroyWindow(B,J.checkboxChecked)}break}}async destroyWindow(A,F){const U=this._config?.workspace;if(F&&U)try{const J=this.storageMainService.workspaceStorage(U);await J.init(),J.delete("memento/workbench.parts.editor"),await J.close()}catch(J){this.logService.error(J)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let J,B;(0,N.isSingleFolderWorkspaceIdentifier)(U)?J={folderUri:U.uri}:(0,N.isWorkspaceIdentifier)(U)?J={workspaceUri:U.configPath}:B=!0;const[$]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});$.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const F=this.getMenuBarVisibility();F!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=F,this.setMenuBarVisibility(F));let U=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const J=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.currentHttpProxy||J!==this.currentNoProxy)){this.currentHttpProxy=U,this.currentNoProxy=J;const B=U||"",$=J?`${J},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(A){E.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,F=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!F.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,F),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(p.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0));const U=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:F.isReload?3:U?2:1})}updateConfiguration(A,F){const U=(this._config??this.pendingLoadConfig)?.userEnv;if(U){const J=(0,d.isLaunchedFromCli)(U)&&!(0,d.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(J||B)&&(A.userEnv={...U,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(A["disable-extensions"]=F.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,y.mark)("code/willOpenNewWindow"),A.perfMarks=(0,y.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const F=Object.assign({},this._config);F.workspace=await this.validateWorkspaceBeforeReload(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&A&&(F.verbose=A.verbose,F.debugId=A.debugId,F.extensionEnvironment=A.extensionEnvironment,F["inspect-extensions"]=A["inspect-extensions"],F["inspect-brk-extensions"]=A["inspect-brk-extensions"],F["extensions-dir"]=A["extensions-dir"]),F.isInitialStartup=!1,F.policiesData=this.policyService.serialize(),F.continueOn=this.environmentMainService.continueOn,F.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(F,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,N.isWorkspaceIdentifier)(A.workspace)){const F=A.workspace.configPath;if(F.scheme===p.Schemas.file&&!await this.fileService.exists(F))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(A.workspace)){const F=A.workspace.uri;if(F.scheme===p.Schemas.file&&!await this.fileService.exists(F))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,ae.defaultWindowState)();if(this.isFullScreen){let U;try{U=S.screen.getDisplayMatching(this.getBounds())}catch{}const J=(0,ae.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||J.width,height:this.windowState.height||J.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let F;if(!E.isMacintosh&&this._win.isMaximized()?F=0:F=1,F===0?A.mode=0:A.mode=1,F===1||F===0){let U;F===1?U=this.getBounds():U=this._win.getNormalBounds(),A.x=U.x,A.y=U.y,A.width=U.width,A.height=U.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Ft.windowControlHeightStateStorageKey,A.height),E.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):E.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,y.mark)("code/willRestoreCodeWindowState");let F=!1;if(A)try{const U=S.screen.getAllDisplays();F=U.length>1,A=this.validateWindowState(A,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,y.mark)("code/didRestoreCodeWindowState"),[A||(0,ae.defaultWindowState)(),F]}validateWindowState(A,F){if(this.logService.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const B=this.getWorkingArea(F[0]);if(B){let $=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),$(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),$()}return A}if(A.display&&A.mode===3){const B=F.find($=>$.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,ae.defaultWindowState)(3);return $.x=B.bounds.x,$.y=B.bounds.y,$}}let U,J;try{U=S.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),J=this.getWorkingArea(U)}catch{}if(U&&J&&A.x+A.width>J.x&&A.y+A.height>J.y&&A.x<J.x+J.width&&A.y<J.y+J.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",J),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,F]=this._win.getPosition(),[U,J]=this._win.getSize();return{x:A,y:F,width:U,height:J}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return E.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){E.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,F=!0){E.isMacintosh||(A==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,f.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const F=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!F),this._win.autoHideMenuBar=F;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(E.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,F,...U){this.isReady?this.send(A,...U):this.ready().then(()=>{F.isCancellationRequested||this.send(A,...U)})}send(A,...F){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...F)}catch(U){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(U)}`)}}}updateTouchBar(A){!E.isMacintosh||this.touchBarGroups.forEach((F,U)=>{const J=A[U];F.segments=this.createTouchBarGroupSegments(J)})}createTouchBar(){if(!!E.isMacintosh){for(let A=0;A<10;A++){const F=this.createTouchBarGroup();this.touchBarGroups.push(F)}this._win.setTouchBar(new S.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const F=this.createTouchBarGroupSegments(A),U=new S.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:J=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:U.segments[J].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(A=[]){return A.map(U=>{let J;U.icon&&!a.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===p.Schemas.file&&(J=S.nativeImage.createFromPath(h.URI.revive(U.icon.dark).fsPath),J.isEmpty()&&(J=void 0));let B;return typeof U.title=="string"?B=U.title:B=U.title.value,{id:U.id,label:J?void 0:B,icon:J}})}dispose(){super.dispose(),this._win=null}};H.windowControlHeightStateStorageKey="windowControlHeight",H=ve([ee(1,i.ILogService),ee(2,v.IEnvironmentMainService),ee(3,G.IPolicyService),ee(4,he.IUserDataProfilesMainService),ee(5,g.IFileService),ee(6,s.IApplicationStorageMainService),ee(7,s.IStorageMainService),ee(8,w.IConfigurationService),ee(9,I.IThemeMainService),ee(10,X.IWorkspacesManagementMainService),ee(11,P.IBackupMainService),ee(12,l.ITelemetryService),ee(13,m.IDialogMainService),ee(14,c.ILifecycleMainService),ee(15,o.IProductService),ee(16,n.IProtocolMainService),ee(17,T.IWindowsMainService),ee(18,Z.IStateMainService)],H),e.CodeWindow=H}),define(te[75],ie([0,1,15,24,8,3,35,2,13,4,16,7,21,174,5,22,6,91,92,28,52,31]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,f.createDecorator)("workspacesHistoryMainService");let i=class rt extends b.Disposable{constructor(n,r,s,l){super(),this.logService=n,this.workspacesManagementMainService=r,this.lifecycleMainService=s,this.applicationStorageMainService=l,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let r=[],s=[];for(const a of n)if((0,v.isRecentWorkspace)(a))!this.workspacesManagementMainService.isUntitledWorkspace(a.workspace)&&!this.containsWorkspace(r,a.workspace)&&r.push(a);else if((0,v.isRecentFolder)(a))this.containsFolder(r,a.folderUri)||r.push(a);else{const I=this.containsFile(s,a.fileUri),M=a.fileUri.scheme===u.Schemas.file&&rt.COMMON_FILES_FILTER.indexOf((0,C.basename)(a.fileUri))>=0;!I&&!M&&(s.push(a),p.isWindows&&a.fileUri.scheme===u.Schemas.file&&S.app.addRecentDocument(a.fileUri.fsPath))}const l=await this.mergeEntriesFromStorage({workspaces:r,files:s});r=l.workspaces,s=l.files,r.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=rt.MAX_TOTAL_RECENT_ENTRIES),s.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=rt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:r,files:s}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(n){const r=I=>{const M=this.location(I);for(const T of n)if(C.extUriBiasedIgnorePathCase.isEqual(T,M))return!1;return!0},s=await this.getRecentlyOpened(),l=s.workspaces.filter(r),a=s.files.filter(r);(l.length!==s.workspaces.length||a.length!==s.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:l}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(n){const r=new c.ResourceMap(a=>C.extUriBiasedIgnorePathCase.getComparisonKey(a));if(n?.workspaces)for(const a of n.workspaces)r.set(this.location(a),a);const s=new c.ResourceMap(a=>C.extUriBiasedIgnorePathCase.getComparisonKey(a));if(n?.files)for(const a of n.files)s.set(this.location(a),a);const l=await this.getRecentlyOpenedFromStorage();for(const a of l.workspaces){const I=r.get(this.location(a));I?I.label=I.label??a.label:r.set(this.location(a),a)}for(const a of l.files){const I=s.get(this.location(a));I?I.label=I.label??a.label:s.set(this.location(a),a)}return{workspaces:[...r.values()],files:[...s.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let n;const r=this.applicationStorageMainService.get(rt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof r=="string")try{n=JSON.parse(r)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}return(0,v.restoreRecentlyOpened)(n,this.logService)}async saveRecentlyOpened(n){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(rt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,v.toStoreData)(n)),-1,1)}location(n){return(0,v.isRecentFolder)(n)?n.folderUri:(0,v.isRecentFile)(n)?n.fileUri:n.workspace.configPath}containsWorkspace(n,r){return!!n.find(s=>(0,v.isRecentWorkspace)(s)&&s.workspace.id===r.id)}containsFolder(n,r){return!!n.find(s=>(0,v.isRecentFolder)(s)&&C.extUriBiasedIgnorePathCase.isEqual(s.folderUri,r))}containsFile(n,r){return!!n.find(s=>C.extUriBiasedIgnorePathCase.isEqual(s.fileUri,r))}async handleWindowsJumpList(){!p.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!p.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const r=[];for(const a of S.app.getJumpListSettings().removedItems){const I=a.args;if(I){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);M&&r.push(y.URI.parse(M[2]))}}await this.removeRecentlyOpened(r);let s=!1;const l=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const I=(0,v.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:M,description:T}=this.getWindowsJumpListLabel(I,a.label);let N;return y.URI.isUri(I)?N=`--folder-uri "${I.toString()}"`:(s=!0,N=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:T.substr(0,255),program:process.execPath,args:N,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&n.push({type:"custom",name:s?(0,h.localize)(2,null):(0,h.localize)(3,null),items:l})}n.push({type:"recent"});try{const r=S.app.setJumpList(n);r&&r!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${r}`)}catch(r){this.logService.warn("updateWindowsJumpList#setJumpList",r)}}getWindowsJumpListLabel(n,r){if(r)return{title:(0,D.splitName)(r).name,description:r};if(y.URI.isUri(n))return{title:(0,C.basename)(n),description:this.renderJumpListPathDescription(n)};if(this.workspacesManagementMainService.isUntitledWorkspace(n))return{title:(0,h.localize)(4,null),description:""};let s=(0,C.basename)(n.configPath);return s.endsWith(d.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-d.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,s),description:this.renderJumpListPathDescription(n.configPath)}}renderJumpListPathDescription(n){return n.scheme==="file"?(0,D.normalizeDriveLetter)(n.fsPath):n.toString()}async updateMacOSRecentDocuments(){if(!p.isMacintosh)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),r=[];let s=0;for(let a=0;a<n.workspaces.length&&s<rt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const I=this.location(n.workspaces[a]);if(I.scheme===u.Schemas.file){const M=(0,C.originalFSPath)(I);await E.Promises.exists(M)&&(r.push(M),s++)}}const l=[];for(let a=0;a<n.files.length&&s<rt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const I=this.location(n.files[a]);if(I.scheme===u.Schemas.file){const M=(0,C.originalFSPath)(I);if(rt.COMMON_FILES_FILTER.includes((0,C.basename)(I))||r.includes(M))continue;await E.Promises.exists(M)&&(l.push(M),s++)}}l.reverse().forEach(a=>S.app.addRecentDocument(a)),r.reverse().forEach(a=>S.app.addRecentDocument(a))}};i.MAX_TOTAL_RECENT_ENTRIES=500,i.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",i.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,i.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,i.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,i.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],i=ve([ee(0,w.ILogService),ee(1,g.IWorkspacesManagementMainService),ee(2,P.ILifecycleMainService),ee(3,m.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(te[269],ie([0,1,15,8,23,35,4,7,164,19,27,22,6,210,65,20,38,32,48,74,33,75]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let o=class Wt{constructor(s,l,a,I,M,T,N,X,ae,Q,G){this.updateService=s,this.configurationService=l,this.windowsMainService=a,this.environmentMainService=I,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=N,this.lifecycleMainService=X,this.logService=ae,this.nativeHostMainService=Q,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Wt.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,N,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,N,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,N,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,N,X)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,N,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const l=this.productService.requestFeatureUrl;l&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(l,"openUserVoiceUrl"));const a=this.productService.reportIssueUrl;a&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(a,"openReportIssues"));const I=this.productService.licenseUrl;I&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=I.indexOf("?")>0?"&":"?";this.openUrl(`${I}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(I,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&I&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,l){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Wt.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=S.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(D.isMacintosh?new S.Menu:null);return}const l=new S.Menu;let a;if(D.isMacintosh){const M=new S.Menu;a=new S.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),l.append(a)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new S.Menu;M.append(new S.MenuItem({label:this.mnemonicLabel(u.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(1,null)),submenu:M});this.setMenuById(M,"File"),l.append(T)}if(this.shouldDrawMenu("Edit")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),l.append(T)}if(this.shouldDrawMenu("Selection")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),l.append(T)}if(this.shouldDrawMenu("View")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(4,null)),submenu:M});this.setMenuById(M,"View"),l.append(T)}if(this.shouldDrawMenu("Go")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),l.append(T)}if(this.shouldDrawMenu("Run")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),l.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),l.append(T)}let I;if(this.shouldDrawMenu("Window")){const M=new S.Menu;I=new S.MenuItem({label:this.mnemonicLabel(u.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(I&&l.append(I),this.shouldDrawMenu("Help")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(u.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),l.append(T)}l.items&&l.items.length>0?S.Menu.setApplicationMenu(l):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const l=this.createMenuItem(u.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),a=this.getUpdateMenuItems();let I;if(this.shouldDrawMenu("Preferences")){const Z=new S.Menu;this.setMenuById(Z,"Preferences"),I=new S.MenuItem({label:this.mnemonicLabel(u.localize(11,null)),submenu:Z})}const M=new S.Menu,T=new S.MenuItem({label:u.localize(12,null),role:"services",submenu:M}),N=new S.MenuItem({label:u.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new S.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ae=new S.MenuItem({label:u.localize(15,null),role:"unhide"}),Q=new S.MenuItem(this.likeAction("workbench.action.quit",{label:u.localize(16,null,this.productService.nameLong),click:async(Z,se,he)=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&await this.confirmBeforeQuit(he)&&this.nativeHostMainService.quit(void 0)}})),G=[l];G.push(...a),I&&G.push(n(),I),G.push(n(),T,n(),N,X,ae,n(),Q),G.forEach(Z=>s.append(Z))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const l=this.configurationService.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.isKeyboardEvent(s)){const a={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(u.localize(17,null)),(0,R.mnemonicButtonLabel)(u.localize(18,null))],message:u.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:I}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,a);return I===0}return!0}shouldDrawMenu(s){if(!D.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,l){l.forEach(a=>{if((0,h.isMenubarMenuItemSeparator)(a))s.append(n());else if((0,h.isMenubarMenuItemSubmenu)(a)){const I=new S.Menu,M=new S.MenuItem({label:this.mnemonicLabel(a.label),submenu:I});this.setMenu(I,a.submenu.items),s.append(M)}else(0,h.isMenubarMenuItemRecentAction)(a)?s.append(this.createOpenRecentMenuItem(a)):(0,h.isMenubarMenuItemAction)(a)&&(a.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[a.id]?s.append(new S.MenuItem(this.likeAction(a.id,{label:this.mnemonicLabel(a.label),click:this.fallbackMenuHandlers[a.id]}))):s.append(this.createMenuItem(a.label,a.id,!1,a.checked)):s.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)):s.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)))})}setMenuById(s,l){this.menubarMenus&&this.menubarMenus[l]&&this.setMenu(s,this.menubarMenus[l].items)}insertCheckForUpdatesItems(s){const l=this.getUpdateMenuItems();l.length&&(l.forEach(a=>s.append(a)),s.append(n()))}createOpenRecentMenuItem(s){const l=b.URI.revive(s.uri),a=s.id,I=a==="openRecentFile"?{fileUri:l}:a==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new S.MenuItem(this.likeAction(a,{label:s.label,click:async(M,T,N)=>{const X=this.isOptionClick(N);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[I],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([l])}},!1))}isOptionClick(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,l,a){const I={label:this.mnemonicLabel(s),role:a,enabled:!0};return new S.MenuItem(this.withKeybinding(l,I))}setMacWindowMenu(s){const l=new S.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),a=new S.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),I=new S.MenuItem({label:u.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(u.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(n()),T.push(this.createMenuItem(u.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,a,n(),M,...T,n(),I].forEach(N=>s.append(N))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(u.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(u.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(u.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(u.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,l,a,I){const M=this.mnemonicLabel(s),T=typeof l=="function"?l:(G,Z,se)=>{const he=G?G.userSettingsLabel:null;let V=l;Array.isArray(l)&&(V=this.isOptionClick(se)?l[1]:l[0]),he&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:he}):this.runActionInRenderer({type:"commandId",commandId:V})},N=typeof a=="boolean"?a:this.windowsMainService.getWindowCount()>0,X=typeof I=="boolean"?I:!1,ae={label:M,click:T,enabled:N};X&&(ae.type="checkbox",ae.checked=X);let Q;return typeof l=="string"?Q=l:Array.isArray(l)&&(Q=l[0]),D.isMacintosh&&(Q==="editor.action.clipboardCutAction"?ae.role="cut":Q==="editor.action.clipboardCopyAction"?ae.role="copy":Q==="editor.action.clipboardPasteAction"&&(ae.role="paste"),Q==="undo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):Q==="redo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):Q==="editor.action.selectAll"&&(ae.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(Q,ae))}makeContextAwareClickHandler(s,l){return(a,I,M)=>{const T=S.BrowserWindow.getFocusedWindow();if(!T)return l.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return l.inDevTools(T.webContents.devToolsWebContents);s(a,I||T,M)}}runActionInRenderer(s){let l=S.BrowserWindow.getFocusedWindow();if(!l){const I=this.windowsMainService.getLastActiveWindow();I?.isMinimized()&&(l=I.win)}const a=l?this.windowsMainService.getWindowById(l.id):void 0;if(a){if(this.logService.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.environmentMainService.isBuilt&&!a.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const I={id:s.commandId,from:"menu"};a.sendWhenReady("vscode:runAction",k.CancellationToken.None,I)}else{const I={userSettingsLabel:s.userSettingsLabel};a.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,I)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,l){const a=typeof s=="string"?this.keybindings[s]:void 0;if(a?.label){if(a.isNative!==!1)l.accelerator=a.label,l.userSettingsLabel=a.userSettingsLabel;else if(typeof l.label=="string"){const I=l.label.indexOf("[");I>=0?l.label=`${l.label.substr(0,I)} [${a.label}]`:l.label=`${l.label} [${a.label}]`}}else l.accelerator=void 0;return l}likeAction(s,l,a=!l.accelerator){a&&(l=this.withKeybinding(s,l));const I=l.click;return l.click=(M,T,N)=>{this.reportMenuActionTelemetry(s),I?.(M,T,N)},l}openUrl(s,l){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(l)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:i})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=ve([ee(0,v.IUpdateService),ee(1,p.IConfigurationService),ee(2,g.IWindowsMainService),ee(3,C.IEnvironmentMainService),ee(4,m.ITelemetryService),ee(5,c.IWorkspacesHistoryMainService),ee(6,w.IStateMainService),ee(7,y.ILifecycleMainService),ee(8,E.ILogService),ee(9,f.INativeHostMainService),ee(10,P.IProductService)],o),e.Menubar=o;function n(){return new S.MenuItem({type:"separator"})}}),define(te[270],ie([0,1,5,22,6,269]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,S.createDecorator)("menubarMainService");let D=class{constructor(u,p,C){this.instantiationService=u,this.lifecycleMainService=p,this.logService=C,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(u,p){this.logService.trace("menubarService#updateMenubar",u),(await this.menubar).updateMenu(p,u)}};D=ve([ee(0,S.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,k.ILogService)],D),e.MenubarMainService=D}),define(te[271],ie([0,1,15,21,25,24,23,3,30,49,35,2,13,9,71,4,34,16,12,7,172,60,19,56,27,14,5,22,6,54,20,61,63,38,74,268,118,263,28,93,75,52,64,37,42]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c,i,o,n,r,s,l,a,I,M,T,N,X,ae,Q,G,Z,se,he,V,H,W,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U($){return(0,se.isWorkspaceIdentifier)($?.workspace)}function J($){return(0,se.isSingleFolderWorkspaceIdentifier)($?.workspace)}let B=class ft extends y.Disposable{constructor(L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae,ke,Le,qe,me,we){super(),this.machineId=L,this.initialUserEnv=O,this.logService=_,this.stateMainService=j,this.policyService=Y,this.environmentMainService=oe,this.userDataProfilesMainService=q,this.lifecycleMainService=re,this.backupMainService=ne,this.configurationService=ce,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=De,this.instantiationService=Ae,this.dialogMainService=ke,this.fileService=Le,this.productService=qe,this.protocolMainService=me,this.themeMainService=we,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new b.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new Z.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new y.DisposableStore;if(O.add(b.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const _ of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(_));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const _=this.environmentMainService.args,j=O?.remoteAuthority||void 0,Y=!0,oe=O?.forceReuseWindow,q=!oe;return this.open({...L,cli:_,forceEmpty:Y,forceNewWindow:q,forceReuseWindow:oe,remoteAuthority:j})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],_=[],j=[],Y=[],oe=[];let q,re=0;const ne=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const ke of ne)J(ke)?L.addMode?O.push(ke):_.push(ke):U(ke)?j.push(ke):ke.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),q.filesToOpenOrCreate.push(ke)):ke.backupPath?oe.push({backupFolder:(0,h.basename)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):re++;L.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),L.mergeMode&&q&&q.filesToOpenOrCreate.length===4&&(q.filesToMerge=q.filesToOpenOrCreate.slice(0,4),q.filesToOpenOrCreate=[],q.filesToDiff=[]),q&&L.waitMarkerFileURI&&(q.filesToWait={paths:(0,R.coalesce)([...q.filesToDiff,q.filesToMerge[3],...q.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(Y.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),j.push(...Y),oe.push(...this.backupMainService.getEmptyWindowBackups())):oe.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.doOpen(L,j,_,oe,re,q,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${_.length}, emptyToRestore: ${oe.length}, emptyToOpen: ${re})`),ce.length>1)if(ge)ge.focus();else{const ke=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Le=!0,qe=!0;if(ke){const me=ce.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Le=!1,qe=!1)}if(Le)for(let me=ce.length-1;me>=0;me--){const we=ce[me];if(!(we.openedWorkspace&&Y.some(Ee=>we.openedWorkspace&&Ee.workspace.id===we.openedWorkspace.id)||we.backupPath&&oe.some(Ee=>we.backupPath&&Ee.backupFolder===(0,h.basename)(we.backupPath)))){we.focus(),qe=!1;break}}qe&&ce[ce.length-1].focus()}const De=q&&q.filesToDiff.length>0,Ae=q&&q.filesToMerge.length>0;if(!ce.some(ke=>ke.isExtensionDevelopmentHost)&&!De&&!Ae&&!L.noRecentEntry){const ke=[];for(const Le of ne)U(Le)&&!Le.transient?ke.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):J(Le)?ke.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&ke.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ke)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const _=L.waitMarkerFileURI;L.context===0&&_&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}async doOpen(L,O,_,j,Y,oe,q){const re=[];let ne;function ce(me,we){re.push(me),we&&(ne=me,oe=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:De}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&q.length>0){const me=q[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(me);we&&ce(this.doAddFoldersToExistingWindow(we,q.map(Ee=>Ee.workspace.uri)))}const Ae=_.length+O.length+j.length;if(oe&&Ae===0){const me=oe.filesToOpenOrCreate[0]||oe.filesToDiff[0]||oe.filesToMerge[3],we=this.getWindows().filter(x=>oe&&(0,m.isEqualAuthority)(x.remoteAuthority,oe.remoteAuthority));let Ee;me?.fileUri&&!De&&((L.context===4||L.context===0||L.context===1)&&(Ee=await(0,G.findWindowOnFile)(we,me.fileUri,async x=>x.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(x.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(we))),Ee?(0,se.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?_.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,Ee,oe),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:oe,forceNewWindow:!0,remoteAuthority:oe.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const ke=(0,R.distinct)(O,me=>me.workspace.id);if(ke.length>0){const me=(0,R.coalesce)(ke.map(we=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],Ee=(0,m.isEqualAuthority)(oe?.remoteAuthority,we.remoteAuthority)?oe:void 0;ce(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}for(const we of ke){if(me.some(le=>le.openedWorkspace&&le.openedWorkspace.id===we.workspace.id))continue;const Ee=we.remoteAuthority,x=(0,m.isEqualAuthority)(oe?.remoteAuthority,Ee)?oe:void 0;ce(this.doOpenFolderOrWorkspace(L,we,ge,x),!!x),ge=!0}}const Le=(0,R.distinct)(_,me=>m.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Le.length>0){const me=(0,R.coalesce)(Le.map(we=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],Ee=(0,m.isEqualAuthority)(oe?.remoteAuthority,we.remoteAuthority)?oe:void 0;ce(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}for(const we of Le){if(me.some(le=>(0,se.isSingleFolderWorkspaceIdentifier)(le.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(le.openedWorkspace.uri,we.workspace.uri)))continue;const Ee=we.remoteAuthority,x=(0,m.isEqualAuthority)(oe?.remoteAuthority,Ee)?oe:void 0;ce(this.doOpenFolderOrWorkspace(L,we,ge,x),!!x),ge=!0}}const qe=(0,R.distinct)(j,me=>me.backupFolder);if(qe.length>0)for(const me of qe){const we=me.remoteAuthority,Ee=(0,m.isEqualAuthority)(oe?.remoteAuthority,we)?oe:void 0;ce(this.doOpenEmpty(L,!0,we,Ee,me),!!Ee),ge=!0}if(re.length===0||oe){oe&&!Y&&Y++;const me=oe?oe.remoteAuthority:L.remoteAuthority;for(let we=0;we<Y;we++)ce(this.doOpenEmpty(L,ge,me,oe),!!oe),ge=!0}return{windows:(0,R.distinct)(re),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),O.focus();const j={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,j),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const _={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,_),L}doOpenEmpty(L,O,_,j,Y){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:_,filesToOpen:j,forceNewWindow:O});let oe;return!O&&typeof L.contextWindowId=="number"&&(oe=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:_,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:j,windowToUse:oe,emptyWindowBackupInfo:Y,profile:L.profile})}doOpenFolderOrWorkspace(L,O,_,j,Y){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:j}),!_&&!Y&&typeof L.contextWindowId=="number"&&(Y=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:j,windowToUse:Y,profile:L.profile})}async getPathsToOpen(L){let O,_=!1,j=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=await this.doExtractPathsFromAPI(L),_=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=await this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),_=!0):(O=await this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),j=!0),!L.addMode&&_){const Y=O.filter(oe=>J(oe));if(Y.length>1){const oe=Y[0].remoteAuthority;if(Y.every(q=>(0,m.isEqualAuthority)(q.remoteAuthority,oe))){const q=await this.workspacesManagementMainService.createUntitledWorkspace(Y.map(re=>({uri:re.workspace.uri})));O.push({workspace:q,remoteAuthority:oe}),O=O.filter(re=>!J(re))}}}if(L.initialStartup&&!j&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const Y=await this.doGetPathsFromLastSession();O.unshift(...Y.filter(oe=>U(oe)||J(oe)||oe.backupPath))}return O}async doExtractPathsFromAPI(L){const O={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},_=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async j=>{const Y=await this.resolveOpenable(j,O);if(Y)return Y.label=j.label,Y;const oe=this.resourceFromOpenable(j),q={title:this.productService.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,g.localize)(0,null))],defaultId:0,message:oe.scheme===E.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:oe.scheme===E.Schemas.file?(0,g.localize)(3,null,(0,C.getPathLabel)(oe,{os:P.OS,tildify:this.environmentMainService})):(0,g.localize)(4,null,oe.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(q,(0,v.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(_)}async doExtractPathsFromCLI(L){const O=[],_={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},j=L["folder-uri"];if(j){const q=await Promise.all(j.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable({folderUri:ne},_)}));O.push(...(0,R.coalesce)(q))}const Y=L["file-uri"];if(Y){const q=await Promise.all(Y.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(re)?{workspaceUri:ne}:{fileUri:ne},_)}));O.push(...(0,R.coalesce)(q))}const oe=await Promise.all(L._.map(q=>_.remoteAuthority?this.doResolveRemotePath(q,_):this.doResolveFilePath(q,_)));return O.push(...(0,R.coalesce)(oe)),O}cliArgToUri(L){try{const O=d.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const _=await Promise.all(O.map(async j=>{if(j.workspace){const Y=await this.resolveOpenable({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});if(U(Y))return Y}else if(j.folderUri){const Y=await this.resolveOpenable({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});if(J(Y))return Y}else if(L!=="folders"&&j.backupPath)return{backupPath:j.backupPath,remoteAuthority:j.remoteAuthority}}));return(0,R.coalesce)(_)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,O=Object.create(null)){const _=this.resourceFromOpenable(L);return _.scheme===E.Schemas.file?((0,ae.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let _=this.resourceFromOpenable(L);const j=(0,N.getRemoteAuthority)(_)||O.remoteAuthority;if(_=(0,m.removeTrailingPathSeparator)((0,m.normalizePath)(_)),(0,ae.isFileToOpen)(L)){if(O.gotoLineMode){const{path:Y,line:oe,column:q}=(0,u.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:Y}),options:{selection:oe?{startLineNumber:oe,startColumn:q||1}:void 0},remoteAuthority:j}}return{fileUri:_,remoteAuthority:j}}else if((0,ae.isWorkspaceToOpen)(L))return{workspace:(0,he.getWorkspaceIdentifier)(_),remoteAuthority:j};return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:j}}resourceFromOpenable(L){return(0,ae.isWorkspaceToOpen)(L)?L.workspaceUri:(0,ae.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,O){let _,j;O.gotoLineMode&&({path:L,line:_,column:j}=(0,u.parseLineAndColumnAware)(L)),L=(0,u.sanitizeFilePath)((0,h.normalize)(L),(0,w.cwd)());try{const Y=await t.Promises.stat(L);if(Y.isFile()){if(!O.forceOpenWorkspaceAsFile){const oe=await this.workspacesManagementMainService.resolveLocalWorkspace(d.URI.file(L));if(oe)return oe.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:oe.id,configPath:oe.configPath},type:r.FileType.File,exists:!0,remoteAuthority:oe.remoteAuthority,transient:oe.transient}}return{fileUri:d.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:j||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(d.URI.file(L),Y),type:r.FileType.Directory,exists:!0};if(!P.isWindows&&L==="/dev/null")return{fileUri:d.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const oe=d.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([oe]),O.ignoreFileNotFound)return{fileUri:oe,type:r.FileType.File,exists:!1}}}doResolveRemotePath(L,O){const _=L.charCodeAt(0),j=O.remoteAuthority;let Y,oe;O.gotoLineMode&&({path:L,line:Y,column:oe}=(0,u.parseLineAndColumnAware)(L)),_!==47&&((0,u.isWindowsDriveLetter)(_)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,u.toSlashes)(L)),L=`/${L}`);const q=d.URI.from({scheme:E.Schemas.vscodeRemote,authority:j,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:q,options:{selection:Y?{startLineNumber:Y,startColumn:oe||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,he.getWorkspaceIdentifier)(q),remoteAuthority:j};if(O.gotoLineMode||h.posix.basename(L).indexOf(".")!==-1)return{fileUri:q,options:{selection:Y?{startLineNumber:Y,startColumn:oe||1}:void 0},remoteAuthority:j}}return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:j}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),_=O?.openFoldersInNewWindow||"default",j=O?.openFilesInNewWindow||"off";let Y=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(_==="on"||_==="off")&&(Y=_==="on");let oe=!1;return L.forceNewWindow||L.forceReuseWindow?oe=!!L.forceNewWindow&&!L.forceReuseWindow:(P.isMacintosh?L.context===1&&(oe=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(oe=!0),!L.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(oe=j==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:oe}}async openExtensionDevelopmentHostWindow(L,O){const _=(0,G.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(_)return this.lifecycleMainService.reload(_,O.cli),_.focus(),[_];let j=O.cli["folder-uri"]||[],Y=O.cli["file-uri"]||[],oe=O.cli._;if(!oe.length&&!j.length&&!Y.length&&!O.cli.extensionTestsPath){const ne=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=ne?.workspace??ne?.folderUri;ce&&(d.URI.isUri(ce)?ce.scheme===E.Schemas.file?oe=[ce.fsPath]:j=[ce.toString()]:ce.configPath.scheme===E.Schemas.file?oe=[(0,m.originalFSPath)(ce.configPath)]:Y=[ce.configPath.toString()])}let q=O.remoteAuthority;for(const ne of L)if(ne.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=d.URI.parse(ne),ge=(0,N.getRemoteAuthority)(ce);ge&&(q?(0,m.isEqualAuthority)(ge,q)||this.logService.error("more than one extension development path authority"):q=ge)}oe=oe.filter(ne=>{const ce=d.URI.file(ne);return(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,m.isEqualAuthority)((0,N.getRemoteAuthority)(ce),q)}),j=j.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,m.isEqualAuthority)((0,N.getRemoteAuthority)(ce),q):!1}),Y=Y.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,m.isEqualAuthority)((0,N.getRemoteAuthority)(ce),q):!1}),O.cli._=oe,O.cli["folder-uri"]=j,O.cli["file-uri"]=Y;const re={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!oe.length&&!j.length&&!Y.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:q,profile:O.profile};return this.open(re)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,h.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:I.default,isInitialStartup:L.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};let j;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(j=L.windowToUse||this.getLastActiveWindow(),j&&j.focus()),j){const Y=j.config;!_.extensionDevelopmentPath&&Y?.extensionDevelopmentPath&&(_.extensionDevelopmentPath=Y.extensionDevelopmentPath,_.extensionDevelopmentKind=Y.extensionDevelopmentKind,_["enable-proposed-api"]=Y["enable-proposed-api"],_.verbose=Y.verbose,_["inspect-extensions"]=Y["inspect-extensions"],_["inspect-brk-extensions"]=Y["inspect-brk-extensions"],_.debugId=Y.debugId,_.extensionEnvironment=Y.extensionEnvironment,_["extensions-dir"]=Y["extensions-dir"],_["disable-extensions"]=Y["disable-extensions"])}else{const Y=this.windowsStateHandler.getNewWindowState(_);(0,f.mark)("code/willCreateCodeWindow");const oe=j=this.instantiationService.createInstance(Q.CodeWindow,{state:Y,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(oe),ft.WINDOWS.push(oe),this._onDidOpenWindow.fire(oe),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,p.once)(oe.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(oe)),(0,p.once)(oe.onDidClose)(()=>this.onWindowClosed(oe)),(0,p.once)(oe.onDidDestroy)(()=>this._onDidDestroyWindow.fire(oe)),oe.onDidTriggerSystemContextMenu(({x:re,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:oe,x:re,y:ne}));const q=(0,v.assertIsDefined)(oe.win?.webContents);q.removeAllListeners("devtools-reload-page"),q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(oe)),this.lifecycleMainService.registerWindow(oe)}return _.windowId=j.id,j.isReady?this.lifecycleMainService.unload(j,4).then(Y=>{Y||this.doOpenInBrowserWindow(j,_,L)}):this.doOpenInBrowserWindow(j,_,L),j}doOpenInBrowserWindow(L,O,_){O.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,he.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ft.WINDOWS.indexOf(L);ft.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=S.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,m.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(_=>_.lastFocusTime));return L.find(_=>_.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,_){for(const j of this.getWindows())_&&_.indexOf(j.id)>=0||j.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ft.WINDOWS}getWindowCount(){return ft.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(_=>_.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=S.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([ee(2,a.ILogService),ee(3,X.IStateMainService),ee(4,A.IPolicyService),ee(5,n.IEnvironmentMainService),ee(6,F.IUserDataProfilesMainService),ee(7,l.ILifecycleMainService),ee(8,c.IBackupMainService),ee(9,i.IConfigurationService),ee(10,V.IWorkspacesHistoryMainService),ee(11,H.IWorkspacesManagementMainService),ee(12,s.IInstantiationService),ee(13,o.IDialogMainService),ee(14,r.IFileService),ee(15,M.IProductService),ee(16,T.IProtocolMainService),ee(17,W.IThemeMainService)],B),e.WindowsMainService=B}),define(te[272],ie([0,1,60,33,75,52]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(u,p,C,y){this.workspacesManagementMainService=u,this.windowsMainService=p,this.workspacesHistoryMainService=C,this.backupMainService=y,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(u,p){const C=this.windowsMainService.getWindowById(u);if(C)return this.workspacesManagementMainService.enterWorkspace(C,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(u,p,C){return this.workspacesManagementMainService.createUntitledWorkspace(p,C)}deleteUntitledWorkspace(u,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(u,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}getRecentlyOpened(u){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(u,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}removeRecentlyOpened(u,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}clearRecentlyOpened(u){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([ee(0,R.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,S.IBackupMainService)],D),e.WorkspacesMainService=D}),define(te[273],ie([0,1,15,41,25,18,44,17,30,49,43,35,2,13,9,4,12,7,29,81,131,46,145,102,248,148,60,264,19,69,181,84,119,56,105,179,27,59,113,193,213,194,250,106,195,196,14,206,86,68,5,85,265,226,260,22,6,208,270,65,20,63,256,87,38,253,91,114,32,232,234,73,48,239,240,266,241,267,116,243,244,245,246,251,33,271,252,28,92,75,272,52,249,37,212,42,259,222,55,72,89,254,261,262,8]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c,i,o,n,r,s,l,a,I,M,T,N,X,ae,Q,G,Z,se,he,V,H,W,A,F,U,J,B,$,L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae,ke,Le,qe,me,we,Ee,x,le,fe,Se,Ie,Te,Oe,Ne,Be,ze,Ke,Ue,Ge,K,ue,de,pe,ye,Re,_e,it,xe,je,et,nt,lt,gt,St,Bt,zt,$t,_t,qt,Ht,jt,Vt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends E.Disposable{constructor(be,Pe,Me,Ce,Fe,$e,Ze,tt,We,Ve,Qe){super(),this.mainProcessNodeIpcServer=be,this.userEnv=Pe,this.mainInstantiationService=Me,this.logService=Ce,this.environmentMainService=Fe,this.lifecycleMainService=$e,this.configurationService=Ze,this.stateMainService=tt,this.fileService=We,this.productService=Ve,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const be=We=>We?.startsWith(`${h.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((We,Ve,Qe,Je)=>be(Je.requestingUrl)?Qe(Pe.has(Ve)):Qe(!1)),S.session.defaultSession.setPermissionCheckHandler((We,Ve,Qe,Je)=>be(Je.requestingUrl)?Pe.has(Ve):!1);const Me=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Ce=We=>{for(let Ve=We;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Fe=We=>We.resourceType==="xhr"||Ce(We.frame),$e=We=>{const Ve=We.frame;if(!Ve||!this.windowsMainService)return!1;const Qe=S.BrowserWindow.getAllWindows();for(const Je of Qe)if(Ve.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ze=(We,Ve)=>{if(We.path!=="/index.html")return!0;const Qe=Ve.frame;if(!Qe||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&Qe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((We,Ve)=>{const Qe=m.URI.parse(We.url);return Qe.scheme===h.Schemas.vscodeWebview&&!Ze(Qe,We)?(this.logService.error("Blocked vscode-webview request",We.url),Ve({cancel:!0})):Qe.scheme===h.Schemas.vscodeFileResource&&!$e(We)?(this.logService.error("Blocked vscode-file request",We.url),Ve({cancel:!0})):Qe.path.endsWith(".svg")&&!Me.has(Qe.scheme)?Ve({cancel:!Fe(We)}):Ve({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((We,Ve)=>{const Qe=We.responseHeaders,Je=Qe["content-type"]||Qe["Content-Type"];if(Je&&Array.isArray(Je)){const ot=m.URI.parse(We.url);if(ot.path.endsWith(".svg")&&Me.has(ot.scheme))return Qe["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Qe});if(!ot.path.endsWith(h.Schemas.vscodeRemoteResource)&&Je.some(ct=>ct.toLowerCase().includes("image/svg")))return Ve({cancel:!Fe(We)})}return Ve({cancel:!1})});const tt=S.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,f.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(Me=>this.onUnexpectedError(Me)),process.on("uncaughtException",Me=>(0,b.onUnexpectedError)(Me)),process.on("unhandledRejection",Me=>(0,b.onUnexpectedError)(Me)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,g.registerContextMenuListener)(),S.app.on("accessibility-support-changed",(Me,Ce)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ce)}),S.app.on("activate",async(Me,Ce)=>{this.logService.trace("app#activate"),Ce||await this.windowsMainService?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Me,Ce)=>{Ce.on("will-navigate",Fe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ce.setWindowOpenHandler(({url:Fe})=>(this.nativeHostMainService?.openExternal(void 0,Fe),{action:"deny"}))});let be=[],Pe;S.app.on("open-file",(Me,Ce)=>{this.logService.trace("app#open-file: ",Ce),Me.preventDefault(),be.push((0,_e.hasWorkspaceFileExtension)(Ce)?{workspaceUri:m.URI.file(Ce)}:{fileUri:m.URI.file(Ce)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],Pe=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Me=>{const Ce=this.windowsMainService?.getWindowByWebContents(Me.sender);let Fe,$e;return Ce?.config?(Fe=Ce.config,$e={...process.env,...Ce.config.userEnv}):(Fe=this.environmentMainService.args,$e=process.env),this.resolveShellEnvironment(Fe,$e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Me,Ce,Fe)=>{const $e=this.validateNlsPath([Ce]);if(!$e||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile($e,R.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Me,...Ce)=>{const Fe=this.validateNlsPath(Ce);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Me=>Me.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Me=>Me.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Me=>Me.sender.reload())}validateNlsPath(be){let Pe;for(const Me of be)typeof Me=="string"&&(typeof Pe!="string"?Pe=Me:Pe=(0,f.join)(Pe,Me));if(!(typeof Pe!="string"||!(0,f.isAbsolute)(Pe)||!(0,u.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!P.isLinux)))return m.URI.file(Pe)}onUnexpectedError(be){if(be){const Pe={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;P.isWindows&&be&&S.app.setAppUserModelId(be);try{P.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.logService.error(We)}const Pe=new i.Server;this.lifecycleMainService.onWillShutdown(We=>{We.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Me=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Me}`);const{sharedProcess:Ce,sharedProcessReady:Fe,sharedProcessClient:$e}=this.setupSharedProcess(Me),Ze=await this.initServices(Me,Ce,Fe);this.setUpHandlers(Ze),Ze.invokeFunction(We=>this.initChannels(We,Pe,$e)),await Ze.invokeFunction(We=>this.openFirstWindow(We,Pe)),Ze.invokeFunction(We=>this.afterWindowOpen(We,Ce)),this._register(new It.RunOnceScheduler(()=>{this._register((0,It.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(be){this._register(be.createInstance(n.ProxyAuthHandler)),this._register(be.createInstance(Bt.DefaultExtensionsProfileInitHandler)),this._register(be.createInstance(jt.UserDataTransientProfilesHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(x.machineIdKey);return(!be||P.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,d.getMachineId)(),this.stateMainService.setItem(x.machineIdKey,be)),be}setupSharedProcess(be){const Pe=this._register(this.mainInstantiationService.createInstance(ke.SharedProcess,be,this.userEnv)),Me=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Fe=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Fe,"main")})(),Ce=(async()=>(await Pe.whenReady(),Me))();return{sharedProcess:Pe,sharedProcessReady:Ce,sharedProcessClient:Me}}async initServices(be,Pe,Me){const Ce=new _.ServiceCollection;switch(process.platform){case"win32":Ce.set(Ie.IUpdateService,new L.SyncDescriptor(ze.Win32UpdateService));break;case"linux":P.isLinuxSnap?Ce.set(Ie.IUpdateService,new L.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ce.set(Ie.IUpdateService,new L.SyncDescriptor(Ne.LinuxUpdateService));break;case"darwin":Ce.set(Ie.IUpdateService,new L.SyncDescriptor(Oe.DarwinUpdateService));break}Ce.set(pe.IWindowsMainService,new L.SyncDescriptor(ye.WindowsMainService,[be,this.userEnv],!1));const Fe=new X.DialogMainService(this.logService);Ce.set(X.IDialogMainService,Fe),Ce.set(oe.ILaunchMainService,new L.SyncDescriptor(oe.LaunchMainService,void 0,!1)),Ce.set(N.IDiagnosticsMainService,new L.SyncDescriptor(N.DiagnosticsMainService,void 0,!1)),Ce.set(T.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(Me.then(tt=>tt.getChannel("diagnostics"))))),Ce.set(j.IIssueMainService,new L.SyncDescriptor(j.IssueMainService,[this.userEnv])),Ce.set(ae.IEncryptionMainService,new L.SyncDescriptor(Q.EncryptionMainService,[be])),Ce.set(Y.IKeyboardLayoutMainService,new L.SyncDescriptor(Y.KeyboardLayoutMainService)),Ce.set(ge.INativeHostMainService,new L.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),Ce.set(I.ICredentialsMainService,new L.SyncDescriptor(nt.CredentialsNativeMainService)),Ce.set(ue.IWebviewManagerService,new L.SyncDescriptor(de.WebviewMainService)),Ce.set(ce.IMenubarMainService,new L.SyncDescriptor(ce.MenubarMainService)),Ce.set(he.IExtensionUrlTrustService,new L.SyncDescriptor(V.ExtensionUrlTrustService)),Ce.set(H.IExtensionHostStarter,new L.SyncDescriptor(W.ExtensionHostStarter)),Ce.set(we.IStorageMainService,new L.SyncDescriptor(we.StorageMainService)),Ce.set(we.IApplicationStorageMainService,new L.SyncDescriptor(we.ApplicationStorageMainService)),P.isWindows?Ce.set(A.IExternalTerminalMainService,new L.SyncDescriptor(F.WindowsExternalTerminalService)):P.isMacintosh?Ce.set(A.IExternalTerminalMainService,new L.SyncDescriptor(F.MacExternalTerminalService)):P.isLinux&&Ce.set(A.IExternalTerminalMainService,new L.SyncDescriptor(F.LinuxExternalTerminalService));const $e=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ce.set(s.IBackupMainService,$e);const Ze=new et.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,$e,Fe,this.productService);if(Ce.set(et.IWorkspacesManagementMainService,Ze),Ce.set(it.IWorkspacesService,new L.SyncDescriptor(je.WorkspacesMainService,void 0,!1)),Ce.set(xe.IWorkspacesHistoryMainService,new L.SyncDescriptor(xe.WorkspacesHistoryMainService,void 0,!1)),Ce.set(Ke.IURLService,new L.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,Se.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,Se.isInternalTelemetry)(this.productService,this.configurationService),We=(0,c.getDelayedChannel)(Me.then(ct=>ct.getChannel("telemetryAppender"))),Ve=new le.TelemetryAppenderClient(We),Qe=(0,Ee.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,be,tt,this.environmentMainService.installSourcePath),Je=(0,Se.getPiiPathsFromEnvironment)(this.environmentMainService),ot={appenders:[Ve],commonProperties:Qe,piiPaths:Je,sendErrorTelemetry:!0};Ce.set(x.ITelemetryService,new L.SyncDescriptor(fe.TelemetryService,[ot],!1))}else Ce.set(x.ITelemetryService,Se.NullTelemetryService);return Ce.set(_t.IExtensionsProfileScannerService,new L.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Ce.set(qt.IExtensionsScannerService,new L.SyncDescriptor(Ht.ExtensionsScannerService,void 0,!0)),await It.Promises.settled([$e.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ce)}initChannels(be,Pe,Me){const Ce=c.ProxyChannel.fromService(be.get(oe.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ce);const Fe=c.ProxyChannel.fromService(be.get(N.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Fe);const $e=new gt.PolicyChannel(be.get(lt.IPolicyService));Pe.registerChannel("policy",$e),Me.then(Ye=>Ye.registerChannel("policy",$e));const Ze=this.fileService.getProvider(h.Schemas.file);(0,w.assertType)(Ze instanceof $.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Me.then(Ye=>Ye.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const We=c.ProxyChannel.fromService(be.get(St.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",We),Me.then(Ye=>Ye.registerChannel("userDataProfiles",We));const Ve=new zt.RequestChannel(be.get($t.IRequestService));Me.then(Ye=>Ye.registerChannel("request",Ve));const Qe=new Te.UpdateChannel(be.get(Ie.IUpdateService));Pe.registerChannel("update",Qe);const Je=c.ProxyChannel.fromService(be.get(j.IIssueMainService));Pe.registerChannel("issue",Je);const ot=c.ProxyChannel.fromService(be.get(ae.IEncryptionMainService));Pe.registerChannel("encryption",ot);const ct=c.ProxyChannel.fromService(be.get(I.ICredentialsMainService));Pe.registerChannel("credentials",ct);const kt=c.ProxyChannel.fromService(be.get(Le.ISignService));Pe.registerChannel("sign",kt);const Xe=c.ProxyChannel.fromService(be.get(Y.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=be.get(ge.INativeHostMainService);const mt=c.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",mt),Me.then(Ye=>Ye.registerChannel("nativeHost",mt));const pt=c.ProxyChannel.fromService(be.get(it.IWorkspacesService));Pe.registerChannel("workspaces",pt);const yt=c.ProxyChannel.fromService(be.get(ce.IMenubarMainService));Pe.registerChannel("menubar",yt);const Mt=c.ProxyChannel.fromService(be.get(Ke.IURLService));Pe.registerChannel("url",Mt);const Dt=c.ProxyChannel.fromService(be.get(he.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Dt);const wt=c.ProxyChannel.fromService(be.get(ue.IWebviewManagerService));Pe.registerChannel("webview",wt);const ut=this._register(new me.StorageDatabaseChannel(this.logService,be.get(we.IStorageMainService)));Pe.registerChannel("storage",ut),Me.then(Ye=>Ye.registerChannel("storage",ut));const bt=this._register(new Vt.ProfileStorageChangesListenerChannel(be.get(we.IStorageMainService),be.get(St.IUserDataProfilesMainService),this.logService));Me.then(Ye=>Ye.registerChannel("profileStorageListener",bt));const vt=c.ProxyChannel.fromService(be.get(A.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const He=new ne.LogLevelChannel(be.get(re.ILogService));Pe.registerChannel("logLevel",He),Me.then(Ye=>Ye.registerChannel("logLevel",He));const st=new ne.LoggerChannel(be.get(re.ILoggerService));Pe.registerChannel("logger",st),Me.then(Ye=>Ye.registerChannel("logger",st));const ht=new M.ElectronExtensionHostDebugBroadcastChannel(be.get(pe.IWindowsMainService),be.get(St.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",ht);const at=c.ProxyChannel.fromService(be.get(H.IExtensionHostStarter));Pe.registerChannel(H.ipcExtensionHostStarterChannelName,at)}async openFirstWindow(be,Pe){const Me=this.windowsMainService=be.get(pe.IWindowsMainService),Ce=be.get(Ke.IURLService),Fe=be.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const $e=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(He=>{try{return{uri:m.URI.parse(He),url:He}}catch{return}}).filter(He=>{if(!He||this.shouldBlockURI(He.uri))return!1;const st=this.getWindowOpenableFromProtocolLink(He.uri);return st?($e.push(st),!1):!0}),tt=this,We=this.environmentMainService,Ve=this.productService,Qe=this.logService;Ce.registerHandler({async handleURL(He,st){if(Qe.trace("app#handleURL: ",He.toString(!0),st),He.scheme===Ve.urlProtocol&&He.path==="workspace"&&(He=He.with({authority:"file",path:m.URI.parse(He.query).path,query:""})),tt.shouldBlockURI(He))return!0;let ht=!1;const at=new URLSearchParams(He.query);at.get("windowId")==="_blank"&&(at.delete("windowId"),He=He.with({query:at.toString()}),ht=!0),ht||=P.isMacintosh&&Me.getWindowCount()===0;const Ye=at.get("continueOn");Ye!==null&&(We.continueOn=Ye??void 0,at.delete("continueOn"),He=He.with({query:at.toString()}));const Rt=tt.getWindowOpenableFromProtocolLink(He);if(Qe.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[Lt]=await Me.open({context:5,cli:{...We.args},urisToOpen:[Rt],forceNewWindow:ht,gotoLineMode:!0});return Lt.focus(),!0}if(ht){const[Lt]=await Me.open({context:5,cli:{...We.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ae.getRemoteAuthority)(He)});return await Lt.ready(),Ce.open(He,st)}return!1}});const Je=this._register(new Re.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),ot=new c.StaticRouter(He=>Je.getActiveClientId().then(st=>He===st)),ct=new Ue.URLHandlerRouter(ot),kt=Pe.getChannel("urlHandler",ct);Ce.registerHandler(new Ue.URLHandlerChannelClient(kt)),this._register(new K.ElectronURLListener(Ze,Ce,Me,this.environmentMainService,this.productService));const Xe=this.environmentMainService.args,mt=global.macOpenFiles,pt=(0,Z.isLaunchedFromCli)(process.env)?0:4,yt=Xe._.length,Mt=!!Xe["folder-uri"],Dt=!!Xe["file-uri"],wt=Xe["skip-add-to-recently-opened"]===!0,ut=Xe.wait&&Xe.waitMarkerFilePath?m.URI.file(Xe.waitMarkerFilePath):void 0,bt=Xe.remote||void 0;if($e.length>0)return Me.open({context:pt,cli:Xe,urisToOpen:$e,gotoLineMode:!0,initialStartup:!0});const vt=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);if(!yt&&!Mt&&!Dt){if(Xe["new-window"]||vt)return Me.open({context:pt,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:bt,profile:vt});if(mt.length)return Me.open({context:1,cli:Xe,urisToOpen:mt.map(He=>(0,_e.hasWorkspaceFileExtension)(He)?{workspaceUri:m.URI.file(He)}:{fileUri:m.URI.file(He)}),noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0})}return Me.open({context:pt,cli:Xe,forceNewWindow:Xe["new-window"]||!yt&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:wt,waitMarkerFileURI:ut,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:bt,profile:vt})}shouldBlockURI(be){return!!(be.authority===h.Schemas.file&&P.isWindows&&S.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,y.mnemonicButtonLabel)((0,r.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,r.localize)(1,null))],defaultId:0,cancelId:1,message:(0,r.localize)(2,null,(0,y.getPathLabel)(be,{os:P.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,r.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===h.Schemas.file){const Pe=m.URI.file(be.fsPath);return(0,_e.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(be.authority===h.Schemas.vscodeRemote){const Pe=be.path.indexOf(f.posix.sep,1);if(Pe!==-1){const Me=be.path.substring(1,Pe),Ce=be.path.substring(Pe),Fe=m.URI.from({scheme:h.Schemas.vscodeRemote,authority:Me,path:Ce,query:be.query,fragment:be.fragment});return(0,_e.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Fe}:/:[\d]+$/.test(Ce)?{fileUri:Fe}:{folderUri:Fe}}}}}afterWindowOpen(be,Pe){const Me=be.get(x.ITelemetryService),Ce=be.get(Ie.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(Me,Pe),this.installMutex(),S.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Fe,$e)=>{$e({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ce instanceof ze.Win32UpdateService||Ce instanceof Ne.LinuxUpdateService||Ce instanceof Oe.DarwinUpdateService)&&Ce.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const be=this.productService.win32MutexName;if(P.isWindows&&be)try{const Pe=await new Promise((Ce,Fe)=>{z(["windows-mutex"],Ce,Fe)}),Me=new Pe.Mutex(be);(0,p.once)(this.lifecycleMainService.onWillShutdown)(()=>Me.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(be,Pe){let Me=!1;(0,p.once)(this.lifecycleMainService.onWillShutdown)(()=>Me=!0),this._register(Pe.onDidError(({type:Ce,details:Fe})=>{let $e;switch(Ce){case 1:$e="SharedProcess: detected unresponsive window";break;case 2:$e=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:$e=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error($e)),be.publicLog2("sharedprocesserror",{type:Ce,reason:Fe?.reason,code:Fe?.exitCode,visible:Pe.isVisible(),shuttingdown:Me})}))}async resolveShellEnvironment(be,Pe,Me){try{return await(0,se.getResolvedShellEnv)(this.logService,be,Pe)}catch(Ce){const Fe=(0,D.toErrorMessage)(Ce);Me?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.logService.error(Fe)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Me=JSON.parse((0,C.stripComments)(Pe)),Fe=(0,Se.getTelemetryLevel)(this.configurationService)>=1;if(Me["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const $e=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);$e!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString($e))}}catch(be){this.logService.error(be)}}};Pt=ve([ee(2,O.IInstantiationService),ee(3,re.ILogService),ee(4,G.IEnvironmentMainService),ee(5,q.ILifecycleMainService),ee(6,a.IConfigurationService),ee(7,qe.IStateMainService),ee(8,J.IFileService),ee(9,De.IProductService),ee(10,St.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(te[274],ie([0,1,37,8,281,2]),function(z,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends S.AbstractPolicyService{constructor(u){super(),this.productName=u,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(u){await this.throttler.queue(()=>new Promise((p,C)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,u,y=>{for(const E in y){const h=y[E];h===void 0?this.policies.delete(E):this.policies.set(E,h)}this._onDidChange.fire(Object.keys(y)),p()})}catch(y){C(y)}}))}}e.NativePolicyService=D}),define(te[275],ie([0,1,224,8,18,17,2,12,19,36,113,6,223,282]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let f=class extends D.Disposable{constructor(w,m,v){super(),this.environmentService=m,this.logService=v,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,m){this.logService.trace("RequestService#request (node) - begin",w.url);const{proxyUrl:v,strictSSL:d}=this;let g;try{g=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const c={...process.env,...g},i=w.agent?w.agent:await(0,E.getProxyAgent)(w.url||"",c,{proxyUrl:v,strictSSL:d});w.agent=i,w.strictSSL=d,this.authorization&&(w.headers={...w.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(w,m);return this.logService.trace("RequestService#request (node) - success",w.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",w.url,o),o}}async getNodeRequest(w){return((0,S.parse)(w.url).protocol==="https:"?await new Promise((d,g)=>{z(["https"],d,g)}):await new Promise((d,g)=>{z(["http"],d,g)})).request}_request(w,m){return t.Promises.withAsyncBody(async(v,d)=>{const g=(0,S.parse)(w.url),c=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),i={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,b.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(i.auth=w.user+":"+w.password);const o=c(i,n=>{const r=(0,b.isNumber)(w.followRedirects)?w.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)this._request({...w,url:n.headers.location,followRedirects:r-1},m).then(v,d);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,h.createGunzip)())),v({res:n,stream:(0,k.streamToBufferReadableStream)(s)})}});o.on("error",d),w.timeout&&o.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&o.write(w.data),o.end(),m.onCancellationRequested(()=>{o.abort(),d(new R.CancellationError)})})}async resolveProxy(w){}};f=ve([ee(0,u.IConfigurationService),ee(1,p.INativeEnvironmentService),ee(2,y.ILogService)],f),e.RequestService=f}),define(te[276],ie([0,1,15,275]),function(z,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return S.net.request}class R extends t.RequestService{request(b,u){return super.request({...b||{},getRawRequest:k},u)}}e.RequestMainService=R}),define(te[283],ie([0,1,15,40,7,24,8,44,17,30,49,35,13,9,71,4,34,26,21,46,83,273,10,19,217,230,27,59,185,14,204,86,68,201,85,22,108,6,209,109,54,20,61,255,115,237,55,276,87,225,38,229,73,64,42,37,274,211,2,51,242,39,238]),function(z,e,S,t,k,R,D,b,u,p,C,y,E,h,f,P,w,m,v,d,g,c,i,o,n,r,s,l,a,I,M,T,N,X,ae,Q,G,Z,se,he,V,H,W,A,F,U,J,B,$,L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.startup()}catch(me){console.error(me.message),S.app.exit(1)}}async startup(){(0,u.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,we,Ee,x,le,fe,Se,Ie]=this.createServices();try{try{await this.initServices(Ee,Ie,x,le,Se)}catch(Te){throw this.handleStartupDataDirError(Ee,Se.nameLong,Te),Te}await me.invokeFunction(async Te=>{const Oe=Te.get(Z.ILogService),Ne=Te.get(Q.ILifecycleMainService),Be=Te.get(I.IFileService),ze=await this.claimInstance(Oe,Ee,Ne,me,Se,!0);return v.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(Ke=>{Oe.warn(`Error writing main lockfile: ${Ke.stack}`)}),fe.logger=new he.SpdLogLogger("main",(0,h.join)(Ee.logsPath,"main.log"),!0,!1,fe.getLevel()),(0,C.once)(Ne.onWillShutdown)(Ke=>{Be.dispose(),x.dispose(),Ke.join(v.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),me.createInstance(c.CodeApplication,ze,we).startup()})}catch(Te){me.invokeFunction(this.quit,Te)}}createServices(){const me=new ae.ServiceCollection,we=new ce.DisposableStore;process.once("exit",()=>we.dispose());const Ee={_serviceBrand:void 0,...V.default};me.set(H.IProductService,Ee);const x=new s.EnvironmentMainService(this.resolveArgs(),Ee),le=this.patchEnvironment(x);me.set(s.IEnvironmentMainService,x);const fe=new G.BufferLogService,Se=we.add(new Z.MultiplexLogService([new Z.ConsoleMainLogger((0,Z.getLogLevel)(x)),fe]));me.set(Z.ILogService,Se);const Ie=new M.FileService(Se);me.set(I.IFileService,Ie);const Te=new T.DiskFileSystemProvider(Se);Ie.registerProvider(E.Schemas.file,Te);const Oe=new De.UriIdentityService(Ie);me.set(ge.IUriIdentityService,Oe),me.set(Z.ILoggerService,new se.LoggerService(Se,Ie));const Ne=new _.StateMainService(x,Se,Ie);me.set(O.IStateMainService,Ne);const Be=new oe.UserDataProfilesMainService(Ne,Oe,x,Ie,Se);me.set(oe.IUserDataProfilesMainService,Be);const ze=P.isWindows&&Ee.win32RegValueName?we.add(new re.NativePolicyService(Ee.win32RegValueName)):x.policyFile?we.add(new ne.FilePolicyService(x.policyFile,Ie,Se)):new q.NullPolicyService;me.set(q.IPolicyService,ze);const Ke=new n.ConfigurationService(Be.defaultProfile.settingsResource,Ie,ze,Se);return me.set(o.IConfigurationService,Ke),me.set(Q.ILifecycleMainService,new N.SyncDescriptor(Q.LifecycleMainService,void 0,!1)),me.set(J.IRequestService,new N.SyncDescriptor(B.RequestMainService,void 0,!0)),me.set(Y.IThemeMainService,new N.SyncDescriptor(Y.ThemeMainService)),me.set($.ISignService,new N.SyncDescriptor(L.SignService,void 0,!1)),me.set(F.ITunnelService,new N.SyncDescriptor(U.TunnelService)),me.set(W.IProtocolMainService,new A.ProtocolMainService(x,Be,Se)),[new X.InstantiationService(me,!0),le,x,Ke,Ne,fe,Ee,Be]}patchEnvironment(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const x=process.env[Ee];typeof x=="string"&&(we[Ee]=x)}),Object.assign(process.env,we),we}async initServices(me,we,Ee,x,le){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsPath,we.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(fe=>fe?v.Promises.mkdir(fe,{recursive:!0}):void 0)),x.init(),Ee.initialize()]),we.setEnablement(le.quality!=="stable"||Ee.getValue(Ae.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(me,we,Ee,x,le,fe){let Se;try{(0,f.mark)("code/willStartMainServer"),Se=await(0,g.serve)(we.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),(0,C.once)(Ee.onWillShutdown)(()=>Se.dispose())}catch(Ie){if(Ie.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,le.nameLong,Ie),Ie;let Te;try{Te=await(0,g.connect)(we.mainIPCHandle,"main")}catch(ze){if(!fe||P.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,i.localize)(0,null,le.nameShort),(0,i.localize)(1,null),le.nameLong),ze;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(Ke){throw me.warn("Could not delete obsolete instance handle",Ke),Ke}return this.claimInstance(me,we,Ee,x,le,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw me.error(ze),Te.dispose(),new Error(ze)}let Oe;!we.args.wait&&!we.args.status&&(Oe=setTimeout(()=>{this.showStartupWarningDialog((0,i.localize)(2,null,le.nameShort),(0,i.localize)(3,null),le.nameLong)},1e4));const Ne=d.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Be=d.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return x.invokeFunction(async()=>{const ze=new r.DiagnosticsService(j.NullTelemetryService,le),Ke=await Be.getMainDiagnostics(),Ue=await Be.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ge=await ze.getDiagnostics(Ke,Ue);throw console.log(Ge),new u.ExpectedError});throw P.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,me),me.trace("Sending env to running instance..."),await Ne.start(we.args,process.env),Te.dispose(),Oe&&clearTimeout(Oe),new u.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw me.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new u.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(me,we,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const x=(0,R.coalesce)([me.userDataPath,me.extensionsPath,g.XDG_RUNTIME_DIR]).map(le=>(0,y.getPathLabel)(k.URI.file(le),{os:P.OS,tildify:me}));this.showStartupWarningDialog((0,i.localize)(4,null),(0,i.localize)(5,null,(0,b.toErrorMessage)(Ee),x.join(`
`)),we)}}showStartupWarningDialog(me,we,Ee){S.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,i.localize)(6,null))],message:me,detail:we,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(me,we){if(P.isWindows){const Ee=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((x,le)=>{z(["windows-foreground-love"],x,le)})).allowSetForegroundWindow(Ee)}catch(x){we.error(x)}}}quit(me,we){const Ee=me.get(Z.ILogService),x=me.get(Q.ILifecycleMainService);let le=0;we&&(we.isExpected?we.message&&Ee.trace(we.message):(le=1,we.stack?Ee.error(we.stack):Ee.error(`Startup error: ${we.toString()}`))),x.kill(le)}resolveArgs(){const me=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,a.createWaitMarkerFileSync)(me.verbose);we&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.doValidatePaths(me._,me.goto);me._=we}return me}doValidatePaths(me,we){const Ee=(0,w.cwd)(),x=me.map(Se=>{let Ie=String(Se),Te;we&&(Te=(0,p.parseLineAndColumnAware)(Ie),Ie=Te.path),Ie&&(Ie=this.preparePath(Ee,Ie));const Oe=(0,p.sanitizeFilePath)(Ie,Ee),Ne=(0,h.basename)(Oe);return Ne&&!(0,p.isValidBasename)(Ne)?null:we&&Te?(Te.path=Oe,this.toPath(Te)):Oe}),le=P.isWindows||P.isMacintosh,fe=(0,R.distinct)(x,Se=>Se&&le?Se.toLowerCase():Se||"");return(0,R.coalesce)(fe)}preparePath(me,we){return P.isWindows&&(we=(0,m.rtrim)(we,'"')),we=(0,m.trim)((0,m.trim)(we," "),"	"),P.isWindows&&(we=(0,h.resolve)(me,we),we=(0,m.rtrim)(we,".")),we}toPath(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bd1b7a384f8a5ab9fb5a6a0e8fea370e589f43a3/core/vs/code/electron-main/main.js.map
