/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/arrays","vs/base/browser/browser","vs/base/common/uri","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/map","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(Q){for(var t=[],y=0,i=Q.length;y<i;y++)t[y]=pe[Q[y]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function Ut(Q){if(Array.isArray(Q)){for(var t=0,y=Array(Q.length);t<Q.length;t++)y[t]=Q[t];return y}else return Array.from(Q)}var Vt=Object.hasOwnProperty,Lt=Object.setPrototypeOf,$t=Object.isFrozen,Kt=Object.getPrototypeOf,qt=Object.getOwnPropertyDescriptor,et=Object.freeze,ot=Object.seal,xt=Object.create,Nt=typeof Reflect<"u"&&Reflect,vt=Nt.apply,Et=Nt.construct;vt||(vt=function(t,y,i){return t.apply(y,i)}),et||(et=function(t){return t}),ot||(ot=function(t){return t}),Et||(Et=function(t,y){return new(Function.prototype.bind.apply(t,[null].concat(Ut(y))))});var jt=nt(Array.prototype.forEach),kt=nt(Array.prototype.pop),pt=nt(Array.prototype.push),ut=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Gt=nt(String.prototype.indexOf),Yt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Xt(TypeError);function nt(Q){return function(t){for(var y=arguments.length,i=Array(y>1?y-1:0),W=1;W<y;W++)i[W-1]=arguments[W];return vt(Q,t,i)}}function Xt(Q){return function(){for(var t=arguments.length,y=Array(t),i=0;i<t;i++)y[i]=arguments[i];return Et(Q,y)}}function Be(Q,t){Lt&&Lt(Q,null);for(var y=t.length;y--;){var i=t[y];if(typeof i=="string"){var W=ut(i);W!==i&&($t(t)||(t[y]=W),i=W)}Q[i]=!0}return Q}function ct(Q){var t=xt(null),y=void 0;for(y in Q)vt(Vt,Q,[y])&&(t[y]=Q[y]);return t}function Dt(Q,t){for(;Q!==null;){var y=qt(Q,t);if(y){if(y.get)return nt(y.get);if(typeof y.value=="function")return nt(y.value)}Q=Kt(Q)}function i(W){return console.warn("fallback value for",W),null}return i}var Mt=et(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ct=et(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),_t=et(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Zt=et(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),St=et(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),Qt=et(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=et(["#text"]),Bt=et(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),At=et(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ht=et(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=et(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),Jt=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ei=ot(/<%[\s\S]*|[\s\S]*%>/gm),ti=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ii=ot(/^aria-[\-\w]+$/),ni=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),si=ot(/^(?:\w+script|data):/i),ri=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),bt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Q){return typeof Q}:function(Q){return Q&&typeof Symbol=="function"&&Q.constructor===Symbol&&Q!==Symbol.prototype?"symbol":typeof Q};function rt(Q){if(Array.isArray(Q)){for(var t=0,y=Array(Q.length);t<Q.length;t++)y[t]=Q[t];return y}else return Array.from(Q)}var oi=function(){return typeof window>"u"?null:window},ai=function(t,y){if((typeof t>"u"?"undefined":bt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,W="data-tt-policy-suffix";y.currentScript&&y.currentScript.hasAttribute(W)&&(i=y.currentScript.getAttribute(W));var B="dompurify"+(i?"#"+i:"");try{return t.createPolicy(B,{createHTML:function(D){return D}})}catch{return console.warn("TrustedTypes policy "+B+" could not be created."),null}};function Wt(){var Q=arguments.length>0&&arguments[0]!==void 0?arguments[0]:oi(),t=function(re){return Wt(re)};if(t.version="2.3.1",t.removed=[],!Q||!Q.document||Q.document.nodeType!==9)return t.isSupported=!1,t;var y=Q.document,i=Q.document,W=Q.DocumentFragment,B=Q.HTMLTemplateElement,C=Q.Node,D=Q.Element,d=Q.NodeFilter,c=Q.NamedNodeMap,f=c===void 0?Q.NamedNodeMap||Q.MozNamedAttrMap:c,N=Q.Text,l=Q.Comment,n=Q.DOMParser,e=Q.trustedTypes,g=D.prototype,b=Dt(g,"cloneNode"),w=Dt(g,"nextSibling"),E=Dt(g,"childNodes"),a=Dt(g,"parentNode");if(typeof B=="function"){var u=i.createElement("template");u.content&&u.content.ownerDocument&&(i=u.content.ownerDocument)}var m=ai(e,y),S=m&&Z?m.createHTML(""):"",T=i,_=T.implementation,r=T.createNodeIterator,v=T.createDocumentFragment,o=T.getElementsByTagName,s=y.importNode,p={};try{p=ct(i).documentMode?i.documentMode:{}}catch{}var L={};t.isSupported=typeof a=="function"&&_&&typeof _.createHTMLDocument<"u"&&p!==9;var V=Jt,X=ei,J=ti,ge=ii,oe=si,me=ri,he=ni,ae=null,Se=Be({},[].concat(rt(Mt),rt(Ct),rt(_t),rt(St),rt(Ot))),te=null,De=Be({},[].concat(rt(Bt),rt(At),rt(Ht),rt(yt))),se=null,ie=null,ce=!0,ne=!0,F=!1,$=!1,j=!1,P=!1,h=!1,I=!1,U=!1,K=!0,Z=!1,k=!0,M=!0,z=!1,A={},R=null,O=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),H=null,q=Be({},["audio","video","img","source","image","track"]),ee=null,ue=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),de="http://www.w3.org/1998/Math/MathML",ye="http://www.w3.org/2000/svg",Ee="http://www.w3.org/1999/xhtml",Ne=Ee,Fe=!1,ve=null,Re=i.createElement("form"),Pe=function(re){ve&&ve===re||((!re||(typeof re>"u"?"undefined":bt(re))!=="object")&&(re={}),re=ct(re),ae="ALLOWED_TAGS"in re?Be({},re.ALLOWED_TAGS):Se,te="ALLOWED_ATTR"in re?Be({},re.ALLOWED_ATTR):De,ee="ADD_URI_SAFE_ATTR"in re?Be(ct(ue),re.ADD_URI_SAFE_ATTR):ue,H="ADD_DATA_URI_TAGS"in re?Be(ct(q),re.ADD_DATA_URI_TAGS):q,R="FORBID_CONTENTS"in re?Be({},re.FORBID_CONTENTS):O,se="FORBID_TAGS"in re?Be({},re.FORBID_TAGS):{},ie="FORBID_ATTR"in re?Be({},re.FORBID_ATTR):{},A="USE_PROFILES"in re?re.USE_PROFILES:!1,ce=re.ALLOW_ARIA_ATTR!==!1,ne=re.ALLOW_DATA_ATTR!==!1,F=re.ALLOW_UNKNOWN_PROTOCOLS||!1,$=re.SAFE_FOR_TEMPLATES||!1,j=re.WHOLE_DOCUMENT||!1,I=re.RETURN_DOM||!1,U=re.RETURN_DOM_FRAGMENT||!1,K=re.RETURN_DOM_IMPORT!==!1,Z=re.RETURN_TRUSTED_TYPE||!1,h=re.FORCE_BODY||!1,k=re.SANITIZE_DOM!==!1,M=re.KEEP_CONTENT!==!1,z=re.IN_PLACE||!1,he=re.ALLOWED_URI_REGEXP||he,Ne=re.NAMESPACE||Ee,$&&(ne=!1),U&&(I=!0),A&&(ae=Be({},[].concat(rt(Ot))),te=[],A.html===!0&&(Be(ae,Mt),Be(te,Bt)),A.svg===!0&&(Be(ae,Ct),Be(te,At),Be(te,yt)),A.svgFilters===!0&&(Be(ae,_t),Be(te,At),Be(te,yt)),A.mathMl===!0&&(Be(ae,St),Be(te,Ht),Be(te,yt))),re.ADD_TAGS&&(ae===Se&&(ae=ct(ae)),Be(ae,re.ADD_TAGS)),re.ADD_ATTR&&(te===De&&(te=ct(te)),Be(te,re.ADD_ATTR)),re.ADD_URI_SAFE_ATTR&&Be(ee,re.ADD_URI_SAFE_ATTR),re.FORBID_CONTENTS&&(R===O&&(R=ct(R)),Be(R,re.FORBID_CONTENTS)),M&&(ae["#text"]=!0),j&&Be(ae,["html","head","body"]),ae.table&&(Be(ae,["tbody"]),delete se.tbody),et&&et(re),ve=re)},Ke=Be({},["mi","mo","mn","ms","mtext"]),He=Be({},["foreignobject","desc","title","annotation-xml"]),Ue=Be({},Ct);Be(Ue,_t),Be(Ue,Zt);var Je=Be({},St);Be(Je,Qt);var it=function(re){var _e=a(re);(!_e||!_e.tagName)&&(_e={namespaceURI:Ee,tagName:"template"});var Le=ut(re.tagName),We=ut(_e.tagName);if(re.namespaceURI===ye)return _e.namespaceURI===Ee?Le==="svg":_e.namespaceURI===de?Le==="svg"&&(We==="annotation-xml"||Ke[We]):Boolean(Ue[Le]);if(re.namespaceURI===de)return _e.namespaceURI===Ee?Le==="math":_e.namespaceURI===ye?Le==="math"&&He[We]:Boolean(Je[Le]);if(re.namespaceURI===Ee){if(_e.namespaceURI===ye&&!He[We]||_e.namespaceURI===de&&!Ke[We])return!1;var je=Be({},["title","style","font","a","script"]);return!Je[Le]&&(je[Le]||!Ue[Le])}return!1},Oe=function(re){pt(t.removed,{element:re});try{re.parentNode.removeChild(re)}catch{try{re.outerHTML=S}catch{re.remove()}}},qe=function(re,_e){try{pt(t.removed,{attribute:_e.getAttributeNode(re),from:_e})}catch{pt(t.removed,{attribute:null,from:_e})}if(_e.removeAttribute(re),re==="is"&&!te[re])if(I||U)try{Oe(_e)}catch{}else try{_e.setAttribute(re,"")}catch{}},Ye=function(re){var _e=void 0,Le=void 0;if(h)re="<remove></remove>"+re;else{var We=Pt(re,/^[\r\n\t ]+/);Le=We&&We[0]}var je=m?m.createHTML(re):re;if(Ne===Ee)try{_e=new n().parseFromString(je,"text/html")}catch{}if(!_e||!_e.documentElement){_e=_.createDocument(Ne,"template",null);try{_e.documentElement.innerHTML=Fe?"":je}catch{}}var Xe=_e.body||_e.documentElement;return re&&Le&&Xe.insertBefore(i.createTextNode(Le),Xe.childNodes[0]||null),Ne===Ee?o.call(_e,j?"html":"body")[0]:j?_e.documentElement:Xe},x=function(re){return r.call(re.ownerDocument||re,re,d.SHOW_ELEMENT|d.SHOW_COMMENT|d.SHOW_TEXT,null,!1)},le=function(re){return re instanceof N||re instanceof l?!1:typeof re.nodeName!="string"||typeof re.textContent!="string"||typeof re.removeChild!="function"||!(re.attributes instanceof f)||typeof re.removeAttribute!="function"||typeof re.setAttribute!="function"||typeof re.namespaceURI!="string"||typeof re.insertBefore!="function"},we=function(re){return(typeof C>"u"?"undefined":bt(C))==="object"?re instanceof C:re&&(typeof re>"u"?"undefined":bt(re))==="object"&&typeof re.nodeType=="number"&&typeof re.nodeName=="string"},Ce=function(re,_e,Le){!L[re]||jt(L[re],function(We){We.call(t,_e,Le,ve)})},Ie=function(re){var _e=void 0;if(Ce("beforeSanitizeElements",re,null),le(re)||Pt(re.nodeName,/[\u0080-\uFFFF]/))return Oe(re),!0;var Le=ut(re.nodeName);if(Ce("uponSanitizeElement",re,{tagName:Le,allowedTags:ae}),!we(re.firstElementChild)&&(!we(re.content)||!we(re.content.firstElementChild))&&at(/<[/\w]/g,re.innerHTML)&&at(/<[/\w]/g,re.textContent)||Le==="select"&&at(/<template/i,re.innerHTML))return Oe(re),!0;if(!ae[Le]||se[Le]){if(M&&!R[Le]){var We=a(re)||re.parentNode,je=E(re)||re.childNodes;if(je&&We)for(var Xe=je.length,Ze=Xe-1;Ze>=0;--Ze)We.insertBefore(b(je[Ze],!0),w(re))}return Oe(re),!0}return re instanceof D&&!it(re)||(Le==="noscript"||Le==="noembed")&&at(/<\/no(script|embed)/i,re.innerHTML)?(Oe(re),!0):($&&re.nodeType===3&&(_e=re.textContent,_e=lt(_e,V," "),_e=lt(_e,X," "),re.textContent!==_e&&(pt(t.removed,{element:re.cloneNode()}),re.textContent=_e)),Ce("afterSanitizeElements",re,null),!1)},Me=function(re,_e,Le){if(k&&(_e==="id"||_e==="name")&&(Le in i||Le in Re))return!1;if(!(ne&&!ie[_e]&&at(J,_e))){if(!(ce&&at(ge,_e))){if(!te[_e]||ie[_e])return!1;if(!ee[_e]){if(!at(he,lt(Le,me,""))){if(!((_e==="src"||_e==="xlink:href"||_e==="href")&&re!=="script"&&Gt(Le,"data:")===0&&H[re])){if(!(F&&!at(oe,lt(Le,me,"")))){if(Le)return!1}}}}}}return!0},Ve=function(re){var _e=void 0,Le=void 0,We=void 0,je=void 0;Ce("beforeSanitizeAttributes",re,null);var Xe=re.attributes;if(!!Xe){var Ze={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:te};for(je=Xe.length;je--;){_e=Xe[je];var st=_e,ht=st.name,dt=st.namespaceURI;if(Le=Yt(_e.value),We=ut(ht),Ze.attrName=We,Ze.attrValue=Le,Ze.keepAttr=!0,Ze.forceKeepAttr=void 0,Ce("uponSanitizeAttribute",re,Ze),Le=Ze.attrValue,!Ze.forceKeepAttr&&(qe(ht,re),!!Ze.keepAttr)){if(at(/\/>/i,Le)){qe(ht,re);continue}$&&(Le=lt(Le,V," "),Le=lt(Le,X," "));var Tt=re.nodeName.toLowerCase();if(!!Me(Tt,We,Le))try{dt?re.setAttributeNS(dt,ht,Le):re.setAttribute(ht,Le),kt(t.removed)}catch{}}}Ce("afterSanitizeAttributes",re,null)}},tt=function ke(re){var _e=void 0,Le=x(re);for(Ce("beforeSanitizeShadowDOM",re,null);_e=Le.nextNode();)Ce("uponSanitizeShadowNode",_e,null),!Ie(_e)&&(_e.content instanceof W&&ke(_e.content),Ve(_e));Ce("afterSanitizeShadowDOM",re,null)};return t.sanitize=function(ke,re){var _e=void 0,Le=void 0,We=void 0,je=void 0,Xe=void 0;if(Fe=!ke,Fe&&(ke="<!-->"),typeof ke!="string"&&!we(ke)){if(typeof ke.toString!="function")throw Rt("toString is not a function");if(ke=ke.toString(),typeof ke!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(bt(Q.toStaticHTML)==="object"||typeof Q.toStaticHTML=="function"){if(typeof ke=="string")return Q.toStaticHTML(ke);if(we(ke))return Q.toStaticHTML(ke.outerHTML)}return ke}if(P||Pe(re),t.removed=[],typeof ke=="string"&&(z=!1),!z)if(ke instanceof C)_e=Ye("<!---->"),Le=_e.ownerDocument.importNode(ke,!0),Le.nodeType===1&&Le.nodeName==="BODY"||Le.nodeName==="HTML"?_e=Le:_e.appendChild(Le);else{if(!I&&!$&&!j&&ke.indexOf("<")===-1)return m&&Z?m.createHTML(ke):ke;if(_e=Ye(ke),!_e)return I?null:S}_e&&h&&Oe(_e.firstChild);for(var Ze=x(z?ke:_e);We=Ze.nextNode();)We.nodeType===3&&We===je||Ie(We)||(We.content instanceof W&&tt(We.content),Ve(We),je=We);if(je=null,z)return ke;if(I){if(U)for(Xe=v.call(_e.ownerDocument);_e.firstChild;)Xe.appendChild(_e.firstChild);else Xe=_e;return K&&(Xe=s.call(y,Xe,!0)),Xe}var st=j?_e.outerHTML:_e.innerHTML;return $&&(st=lt(st,V," "),st=lt(st,X," ")),m&&Z?m.createHTML(st):st},t.setConfig=function(ke){Pe(ke),P=!0},t.clearConfig=function(){ve=null,P=!1},t.isValidAttribute=function(ke,re,_e){ve||Pe({});var Le=ut(ke),We=ut(re);return Me(Le,We,_e)},t.addHook=function(ke,re){typeof re=="function"&&(L[ke]=L[ke]||[],pt(L[ke],re))},t.removeHook=function(ke){L[ke]&&kt(L[ke])},t.removeHooks=function(ke){L[ke]&&(L[ke]=[])},t.removeAllHooks=function(){L={}},t}var li=Wt();define("vs/base/browser/dompurify/dompurify",function(){return li}),define(pe[40],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class y{constructor(C){this.domNode=C,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(C){const D=i(C);this._maxWidth!==D&&(this._maxWidth=D,this.domNode.style.maxWidth=this._maxWidth)}setWidth(C){const D=i(C);this._width!==D&&(this._width=D,this.domNode.style.width=this._width)}setHeight(C){const D=i(C);this._height!==D&&(this._height=D,this.domNode.style.height=this._height)}setTop(C){const D=i(C);this._top!==D&&(this._top=D,this.domNode.style.top=this._top)}setLeft(C){const D=i(C);this._left!==D&&(this._left=D,this.domNode.style.left=this._left)}setBottom(C){const D=i(C);this._bottom!==D&&(this._bottom=D,this.domNode.style.bottom=this._bottom)}setRight(C){const D=i(C);this._right!==D&&(this._right=D,this.domNode.style.right=this._right)}setFontFamily(C){this._fontFamily!==C&&(this._fontFamily=C,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(C){this._fontWeight!==C&&(this._fontWeight=C,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(C){const D=i(C);this._fontSize!==D&&(this._fontSize=D,this.domNode.style.fontSize=this._fontSize)}setFontStyle(C){this._fontStyle!==C&&(this._fontStyle=C,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(C){this._fontFeatureSettings!==C&&(this._fontFeatureSettings=C,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setTextDecoration(C){this._textDecoration!==C&&(this._textDecoration=C,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(C){const D=i(C);this._lineHeight!==D&&(this._lineHeight=D,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(C){const D=i(C);this._letterSpacing!==D&&(this._letterSpacing=D,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(C){this._className!==C&&(this._className=C,this.domNode.className=this._className)}toggleClassName(C,D){this.domNode.classList.toggle(C,D),this._className=this.domNode.className}setDisplay(C){this._display!==C&&(this._display=C,this.domNode.style.display=this._display)}setPosition(C){this._position!==C&&(this._position=C,this.domNode.style.position=this._position)}setVisibility(C){this._visibility!==C&&(this._visibility=C,this.domNode.style.visibility=this._visibility)}setColor(C){this._color!==C&&(this._color=C,this.domNode.style.color=this._color)}setBackgroundColor(C){this._backgroundColor!==C&&(this._backgroundColor=C,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(C){this._layerHint!==C&&(this._layerHint=C,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(C){this._boxShadow!==C&&(this._boxShadow=C,this.domNode.style.boxShadow=C)}setContain(C){this._contain!==C&&(this._contain=C,this.domNode.style.contain=this._contain)}setAttribute(C,D){this.domNode.setAttribute(C,D)}removeAttribute(C){this.domNode.removeAttribute(C)}appendChild(C){this.domNode.appendChild(C.domNode)}removeChild(C){this.domNode.removeChild(C.domNode)}}t.FastDomNode=y;function i(B){return typeof B=="number"?`${B}px`:B}function W(B){return new y(B)}t.createFastDomNode=W}),define(pe[66],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let y=!1,i=null;function W(C){if(!C.parent||C.parent===C)return null;try{const D=C.location,d=C.parent.location;if(D.origin!=="null"&&d.origin!=="null"&&D.origin!==d.origin)return y=!0,null}catch{return y=!0,null}return C.parent}class B{static getSameOriginWindowChain(){if(!i){i=[];let D=window,d;do d=W(D),d?i.push({window:D,iframeElement:D.frameElement||null}):i.push({window:D,iframeElement:null}),D=d;while(D)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(D,d){if(!d||D===d)return{top:0,left:0};let c=0,f=0;const N=this.getSameOriginWindowChain();for(const l of N){if(c+=l.window.scrollY,f+=l.window.scrollX,l.window===d||!l.iframeElement)break;const n=l.iframeElement.getBoundingClientRect();c+=n.top,f+=n.left}return{top:c,left:f}}}t.IframeUtils=B}),define(pe[67],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var y;(function(B){B[B.Copy=0]="Copy",B[B.Move=1]="Move"})(y=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(C,D){super(`ListError [${C}] ${D}`)}}t.ListError=i;class W{constructor(){this.cache=new WeakMap}getHeight(C){return this.cache.get(C)??this.estimateHeight(C)}setDynamicHeight(C,D){D>0&&this.cache.set(C,D)}}t.CachedListVirtualDelegate=W}),define(pe[68],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class y{constructor(W){this.spliceables=W}splice(W,B,C){this.spliceables.forEach(D=>D.splice(W,B,C))}}t.CombinedSpliceable=y}),define(pe[41],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const y=20;class i{constructor(B,C,D,d,c,f){this._scrollbarSize=Math.round(C),this._oppositeScrollbarSize=Math.round(D),this._arrowSize=Math.round(B),this._visibleSize=d,this._scrollSize=c,this._scrollPosition=f,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new i(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(B){const C=Math.round(B);return this._visibleSize!==C?(this._visibleSize=C,this._refreshComputedValues(),!0):!1}setScrollSize(B){const C=Math.round(B);return this._scrollSize!==C?(this._scrollSize=C,this._refreshComputedValues(),!0):!1}setScrollPosition(B){const C=Math.round(B);return this._scrollPosition!==C?(this._scrollPosition=C,this._refreshComputedValues(),!0):!1}setScrollbarSize(B){this._scrollbarSize=Math.round(B)}setOppositeScrollbarSize(B){this._oppositeScrollbarSize=Math.round(B)}static _computeValues(B,C,D,d,c){const f=Math.max(0,D-B),N=Math.max(0,f-2*C),l=d>0&&d>D;if(!l)return{computedAvailableSize:Math.round(f),computedIsNeeded:l,computedSliderSize:Math.round(N),computedSliderRatio:0,computedSliderPosition:0};const n=Math.round(Math.max(y,Math.floor(D*N/d))),e=(N-n)/(d-D),g=c*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:l,computedSliderSize:Math.round(n),computedSliderRatio:e,computedSliderPosition:Math.round(g)}}_refreshComputedValues(){const B=i._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=B.computedAvailableSize,this._computedIsNeeded=B.computedIsNeeded,this._computedSliderSize=B.computedSliderSize,this._computedSliderRatio=B.computedSliderRatio,this._computedSliderPosition=B.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(B){if(!this._computedIsNeeded)return 0;const C=B-this._arrowSize-this._computedSliderSize/2;return Math.round(C/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(B){if(!this._computedIsNeeded)return 0;const C=B-this._arrowSize;let D=this._scrollPosition;return C<this._computedSliderPosition?D-=this._visibleSize:D+=this._visibleSize,D}getDesiredScrollPositionFromDelta(B){if(!this._computedIsNeeded)return 0;const C=this._computedSliderPosition+B;return Math.round(C/this._computedSliderRatio)}}t.ScrollbarState=i}),define(pe[23],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var y;(function(D){D[D.Hidden=0]="Hidden",D[D.Visible=1]="Visible",D[D.Recurse=2]="Recurse"})(y=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(D){D[D.Unknown=0]="Unknown",D[D.Twistie=1]="Twistie",D[D.Element=2]="Element",D[D.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var W;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(W=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(D=!1){return{accept:!0,bubble:0,autoExpand:D}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(D=!1){return{accept:!0,bubble:0,effect:0,autoExpand:D}}};class B extends Error{constructor(d,c){super(`TreeError [${d}] ${c}`)}}t.TreeError=B;class C{constructor(d){this.fn=d,this._map=new WeakMap}map(d){let c=this._map.get(d);return c||(c=this.fn(d),this._map.set(d,c)),c}}t.WeakMapper=C}),define(pe[12],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function y(C){return C?C.replace(/\$\((.*?)\)/g,(D,d)=>` ${d} `).trim():""}t.getCodiconAriaLabel=y;class i{constructor(D,d,c){this.id=D,this.definition=d,this.description=c,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}t.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function W(C,D){const d=["codicon","codicon-"+C];return D&&d.push("codicon-modifier-"+D),d}t.getClassNamesArray=W;var B;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function d(N){if(N instanceof i)return["codicon","codicon-"+N.id];const l=D.exec(N.id);if(!l)return d(i.error);const[,n,e]=l,g=["codicon","codicon-"+n];return e&&g.push("codicon-modifier-"+e.substr(1)),g}C.asClassNameArray=d;function c(N){return d(N).join(" ")}C.asClassName=c;function f(N){return"."+d(N).join(".")}C.asCSSSelector=f})(B=t.CSSIcon||(t.CSSIcon={}))}),define(pe[69],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function y(C,D){const d=Object.create(null);for(const c of C){const f=D(c);let N=d[f];N||(N=d[f]=[]),N.push(c)}return d}t.groupBy=y;function i(C,D){const d=[],c=[];for(const f of C)D.has(f)||d.push(f);for(const f of D)C.has(f)||c.push(f);return{removed:d,added:c}}t.diffSets=i;function W(C,D){const d=[],c=[];for(const[f,N]of C)D.has(f)||d.push(N);for(const[f,N]of D)C.has(f)||c.push(N);return{removed:d,added:c}}t.diffMaps=W;class B{constructor(){this.map=new Map}add(D,d){let c=this.map.get(D);c||(c=new Set,this.map.set(D,c)),c.add(d)}delete(D,d){const c=this.map.get(D);!c||(c.delete(d),c.size===0&&this.map.delete(D))}forEach(D,d){const c=this.map.get(D);!c||c.forEach(d)}}t.SetMap=B}),define(pe[24],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function y(D,d){const c=Math.pow(10,d);return Math.round(D*c)/c}class i{constructor(d,c,f,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=y(Math.max(Math.min(1,N),0),3)}static equals(d,c){return d.r===c.r&&d.g===c.g&&d.b===c.b&&d.a===c.a}}t.RGBA=i;class W{constructor(d,c,f,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=y(Math.max(Math.min(1,c),0),3),this.l=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,N),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.l===c.l&&d.a===c.a}static fromRGBA(d){const c=d.r/255,f=d.g/255,N=d.b/255,l=d.a,n=Math.max(c,f,N),e=Math.min(c,f,N);let g=0,b=0;const w=(e+n)/2,E=n-e;if(E>0){switch(b=Math.min(w<=.5?E/(2*w):E/(2-2*w),1),n){case c:g=(f-N)/E+(f<N?6:0);break;case f:g=(N-c)/E+2;break;case N:g=(c-f)/E+4;break}g*=60,g=Math.round(g)}return new W(g,b,w,l)}static _hue2rgb(d,c,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?d+(c-d)*6*f:f<1/2?c:f<2/3?d+(c-d)*(2/3-f)*6:d}static toRGBA(d){const c=d.h/360,{s:f,l:N,a:l}=d;let n,e,g;if(f===0)n=e=g=N;else{const b=N<.5?N*(1+f):N+f-N*f,w=2*N-b;n=W._hue2rgb(w,b,c+1/3),e=W._hue2rgb(w,b,c),g=W._hue2rgb(w,b,c-1/3)}return new i(Math.round(n*255),Math.round(e*255),Math.round(g*255),l)}}t.HSLA=W;class B{constructor(d,c,f,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=y(Math.max(Math.min(1,c),0),3),this.v=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,N),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.v===c.v&&d.a===c.a}static fromRGBA(d){const c=d.r/255,f=d.g/255,N=d.b/255,l=Math.max(c,f,N),n=Math.min(c,f,N),e=l-n,g=l===0?0:e/l;let b;return e===0?b=0:l===c?b=((f-N)/e%6+6)%6:l===f?b=(N-c)/e+2:b=(c-f)/e+4,new B(Math.round(b*60),g,l,d.a)}static toRGBA(d){const{h:c,s:f,v:N,a:l}=d,n=N*f,e=n*(1-Math.abs(c/60%2-1)),g=N-n;let[b,w,E]=[0,0,0];return c<60?(b=n,w=e):c<120?(b=e,w=n):c<180?(w=n,E=e):c<240?(w=e,E=n):c<300?(b=e,E=n):c<=360&&(b=n,E=e),b=Math.round((b+g)*255),w=Math.round((w+g)*255),E=Math.round((E+g)*255),new i(b,w,E,l)}}t.HSVA=B;class C{static fromHex(d){return C.Format.CSS.parseHex(d)||C.red}get hsla(){return this._hsla?this._hsla:W.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:B.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof i)this.rgba=d;else if(d instanceof W)this._hsla=d,this.rgba=W.toRGBA(d);else if(d instanceof B)this._hsva=d,this.rgba=B.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&i.equals(this.rgba,d.rgba)&&W.equals(this.hsla,d.hsla)&&B.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=C._relativeLuminanceForComponent(this.rgba.r),c=C._relativeLuminanceForComponent(this.rgba.g),f=C._relativeLuminanceForComponent(this.rgba.b),N=.2126*d+.7152*c+.0722*f;return y(N,4)}static _relativeLuminanceForComponent(d){const c=d/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(d){const c=this.getRelativeLuminance(),f=d.getRelativeLuminance();return c>f?(c+.05)/(f+.05):(f+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const c=this.getRelativeLuminance(),f=d.getRelativeLuminance();return c>f}isDarkerThan(d){const c=this.getRelativeLuminance(),f=d.getRelativeLuminance();return c<f}lighten(d){return new C(new W(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new C(new W(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:c,g:f,b:N,a:l}=this.rgba;return new C(new i(c,f,N,l*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const c=d.rgba,f=this.rgba.a,N=c.a,l=f+N*(1-f);if(l<1e-6)return C.transparent;const n=this.rgba.r*f/l+c.r*N*(1-f)/l,e=this.rgba.g*f/l+c.g*N*(1-f)/l,g=this.rgba.b*f/l+c.b*N*(1-f)/l;return new C(new i(n,e,g,l))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:c,g:f,b:N,a:l}=this.rgba;return new C(new i(d.rgba.r-l*(d.rgba.r-c),d.rgba.g-l*(d.rgba.g-f),d.rgba.b-l*(d.rgba.b-N),1))}flatten(...d){const c=d.reduceRight((f,N)=>C._flatten(N,f));return C._flatten(this,c)}static _flatten(d,c){const f=1-d.rgba.a;return new C(new i(f*c.rgba.r+d.rgba.a*d.rgba.r,f*c.rgba.g+d.rgba.a*d.rgba.g,f*c.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this._toString||(this._toString=C.Format.CSS.format(this)),this._toString}static getLighterColor(d,c,f){if(d.isLighterThan(c))return d;f=f||.5;const N=d.getRelativeLuminance(),l=c.getRelativeLuminance();return f=f*(l-N)/l,d.lighten(f)}static getDarkerColor(d,c,f){if(d.isDarkerThan(c))return d;f=f||.5;const N=d.getRelativeLuminance(),l=c.getRelativeLuminance();return f=f*(N-l)/N,d.darken(f)}}t.Color=C,C.white=new C(new i(255,255,255,1)),C.black=new C(new i(0,0,0,1)),C.red=new C(new i(255,0,0,1)),C.blue=new C(new i(0,0,255,1)),C.green=new C(new i(0,255,0,1)),C.cyan=new C(new i(0,255,255,1)),C.lightgrey=new C(new i(211,211,211,1)),C.transparent=new C(new i(0,0,0,0)),function(D){let d;(function(c){let f;(function(N){function l(S){return S.rgba.a===1?`rgb(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b})`:D.Format.CSS.formatRGBA(S)}N.formatRGB=l;function n(S){return`rgba(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b}, ${+S.rgba.a.toFixed(2)})`}N.formatRGBA=n;function e(S){return S.hsla.a===1?`hsl(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(S)}N.formatHSL=e;function g(S){return`hsla(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%, ${S.hsla.a.toFixed(2)})`}N.formatHSLA=g;function b(S){const T=S.toString(16);return T.length!==2?"0"+T:T}function w(S){return`#${b(S.rgba.r)}${b(S.rgba.g)}${b(S.rgba.b)}`}N.formatHex=w;function E(S,T=!1){return T&&S.rgba.a===1?D.Format.CSS.formatHex(S):`#${b(S.rgba.r)}${b(S.rgba.g)}${b(S.rgba.b)}${b(Math.round(S.rgba.a*255))}`}N.formatHexA=E;function a(S){return S.isOpaque()?D.Format.CSS.formatHex(S):D.Format.CSS.formatRGBA(S)}N.format=a;function u(S){const T=S.length;if(T===0||S.charCodeAt(0)!==35)return null;if(T===7){const _=16*m(S.charCodeAt(1))+m(S.charCodeAt(2)),r=16*m(S.charCodeAt(3))+m(S.charCodeAt(4)),v=16*m(S.charCodeAt(5))+m(S.charCodeAt(6));return new D(new i(_,r,v,1))}if(T===9){const _=16*m(S.charCodeAt(1))+m(S.charCodeAt(2)),r=16*m(S.charCodeAt(3))+m(S.charCodeAt(4)),v=16*m(S.charCodeAt(5))+m(S.charCodeAt(6)),o=16*m(S.charCodeAt(7))+m(S.charCodeAt(8));return new D(new i(_,r,v,o/255))}if(T===4){const _=m(S.charCodeAt(1)),r=m(S.charCodeAt(2)),v=m(S.charCodeAt(3));return new D(new i(16*_+_,16*r+r,16*v+v))}if(T===5){const _=m(S.charCodeAt(1)),r=m(S.charCodeAt(2)),v=m(S.charCodeAt(3)),o=m(S.charCodeAt(4));return new D(new i(16*_+_,16*r+r,16*v+v,(16*o+o)/255))}return null}N.parseHex=u;function m(S){switch(S){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=c.CSS||(c.CSS={}))})(d=D.Format||(D.Format={}))}(C=t.Color||(t.Color={}))}),define(pe[25],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function y(C){return(D,d,c)=>{let f=null,N=null;if(typeof c.value=="function"?(f="value",N=c.value):typeof c.get=="function"&&(f="get",N=c.get),!N)throw new Error("not supported");c[f]=C(N,d)}}t.createDecorator=y;function i(C,D,d){let c=null,f=null;if(typeof d.value=="function"?(c="value",f=d.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(c="get",f=d.get),!f)throw new Error("not supported");const N=`$memoize$${D}`;d[c]=function(...l){return this.hasOwnProperty(N)||Object.defineProperty(this,N,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,l)}),this[N]}}t.memoize=i;function W(C,D,d){return y((c,f)=>{const N=`$debounce$${f}`,l=`$debounce$result$${f}`;return function(...n){this[l]||(this[l]=d?d():void 0),clearTimeout(this[N]),D&&(this[l]=D(this[l],...n),n=[this[l]]),this[N]=setTimeout(()=>{c.apply(this,n),this[l]=d?d():void 0},C)}})}t.debounce=W;function B(C,D,d){return y((c,f)=>{const N=`$throttle$timer$${f}`,l=`$throttle$result$${f}`,n=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...g){if(this[l]||(this[l]=d?d():void 0),(this[n]===null||this[n]===void 0)&&(this[n]=-Number.MAX_VALUE),D&&(this[l]=D(this[l],...g)),this[e])return;const b=this[n]+C;b<=Date.now()?(this[n]=Date.now(),c.apply(this,[this[l]]),this[l]=d?d():void 0):(this[e]=!0,this[N]=setTimeout(()=>{this[e]=!1,this[n]=Date.now(),c.apply(this,[this[l]]),this[l]=d?d():void 0},b-Date.now()))}})}t.throttle=B}),define(pe[70],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class y{constructor(W,B,C,D){this.originalStart=W,this.originalLength=B,this.modifiedStart=C,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=y}),define(pe[9],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(S){setTimeout(()=>{throw S.stack?a.isErrorNoTelemetry(S)?new a(S.message+`

`+S.stack):new Error(S.message+`

`+S.stack):S},0)}}addListener(S){return this.listeners.push(S),()=>{this._removeListener(S)}}emit(S){this.listeners.forEach(T=>{T(S)})}_removeListener(S){this.listeners.splice(this.listeners.indexOf(S),1)}setUnexpectedErrorHandler(S){this.unexpectedErrorHandler=S}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(S){this.unexpectedErrorHandler(S),this.emit(S)}onUnexpectedExternalError(S){this.unexpectedErrorHandler(S)}}t.ErrorHandler=y,t.errorHandler=new y;function i(m){t.errorHandler.setUnexpectedErrorHandler(m)}t.setUnexpectedErrorHandler=i;function W(m){d(m)||t.errorHandler.onUnexpectedError(m)}t.onUnexpectedError=W;function B(m){d(m)||t.errorHandler.onUnexpectedExternalError(m)}t.onUnexpectedExternalError=B;function C(m){if(m instanceof Error){const{name:S,message:T}=m,_=m.stacktrace||m.stack;return{$isError:!0,name:S,message:T,stack:_,noTelemetry:a.isErrorNoTelemetry(m)}}return m}t.transformErrorForSerialization=C;const D="Canceled";function d(m){return m instanceof c?!0:m instanceof Error&&m.name===D&&m.message===D}t.isCancellationError=d;class c extends Error{constructor(){super(D),this.name=this.message}}t.CancellationError=c;function f(){const m=new Error(D);return m.name=m.message,m}t.canceled=f;function N(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}t.illegalArgument=N;function l(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}t.illegalState=l;function n(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=n;function e(m){const S=new Error(`${m} has been disposed`);return S.name="DISPOSED",S}t.disposed=e;function g(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}t.getErrorMessage=g;class b extends Error{constructor(S){super("NotImplemented"),S&&(this.message=S)}}t.NotImplementedError=b;class w extends Error{constructor(S){super("NotSupported"),S&&(this.message=S)}}t.NotSupportedError=w;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=E;class a extends Error{constructor(S){super(S),this.name="CodeExpectedError"}static fromError(S){if(S instanceof a)return S;const T=new a;return T.message=S.message,T.stack=S.stack,T}static isErrorNoTelemetry(S){return S.name==="CodeExpectedError"}}t.ErrorNoTelemetry=a;class u extends Error{constructor(S){super(S||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype);debugger}}t.BugIndicatingError=u}),define(pe[14],be([1,0,9]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(k,M=0){return k[k.length-(1+M)]}t.tail=i;function W(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}t.tail2=W;function B(k,M,z=(A,R)=>A===R){if(k===M)return!0;if(!k||!M||k.length!==M.length)return!1;for(let A=0,R=k.length;A<R;A++)if(!z(k[A],M[A]))return!1;return!0}t.equals=B;function C(k,M){const z=k.length-1;M<z&&(k[M]=k[z]),k.pop()}t.removeFastWithoutKeepingOrder=C;function D(k,M,z){return d(k.length,A=>z(k[A],M))}t.binarySearch=D;function d(k,M){let z=0,A=k-1;for(;z<=A;){const R=(z+A)/2|0,O=M(R);if(O<0)z=R+1;else if(O>0)A=R-1;else return R}return-(z+1)}t.binarySearch2=d;function c(k,M){let z=0,A=k.length;if(A===0)return 0;for(;z<A;){const R=Math.floor((z+A)/2);M(k[R])?A=R:z=R+1}return z}t.findFirstInSorted=c;function f(k,M,z){if(k=k|0,k>=M.length)throw new TypeError("invalid index");const A=M[Math.floor(M.length*Math.random())],R=[],O=[],H=[];for(const q of M){const ee=z(q,A);ee<0?R.push(q):ee>0?O.push(q):H.push(q)}return k<R.length?f(k,R,z):k<R.length+H.length?H[0]:f(k-(R.length+H.length),O,z)}t.quickSelect=f;function N(k,M){const z=[];let A;for(const R of k.slice(0).sort(M))!A||M(A[0],R)!==0?(A=[R],z.push(A)):A.push(R);return z}t.groupBy=N;function l(k,M,z){const A=[];function R(q,ee,ue){if(ee===0&&ue.length===0)return;const de=A[A.length-1];de&&de.start+de.deleteCount===q?(de.deleteCount+=ee,de.toInsert.push(...ue)):A.push({start:q,deleteCount:ee,toInsert:ue})}let O=0,H=0;for(;;){if(O===k.length){R(O,0,M.slice(H));break}if(H===M.length){R(O,k.length-O,[]);break}const q=k[O],ee=M[H],ue=z(q,ee);ue===0?(O+=1,H+=1):ue<0?(R(O,1,[]),O+=1):ue>0&&(R(O,0,[ee]),H+=1)}return A}t.sortedDiff=l;function n(k,M,z){const A=l(k,M,z),R=[],O=[];for(const H of A)R.push(...k.slice(H.start,H.start+H.deleteCount)),O.push(...H.toInsert);return{removed:R,added:O}}t.delta=n;function e(k,M,z){if(z===0)return[];const A=k.slice(0,z).sort(M);return b(k,M,A,z,k.length),A}t.top=e;function g(k,M,z,A,R){return z===0?Promise.resolve([]):new Promise((O,H)=>{(async()=>{const q=k.length,ee=k.slice(0,z).sort(M);for(let ue=z,de=Math.min(z+A,q);ue<q;ue=de,de=Math.min(de+A,q)){if(ue>z&&await new Promise(ye=>setTimeout(ye)),R&&R.isCancellationRequested)throw new y.CancellationError;b(k,M,ee,ue,de)}return ee})().then(O,H)})}t.topAsync=g;function b(k,M,z,A,R){for(const O=z.length;A<R;A++){const H=k[A];if(M(H,z[O-1])<0){z.pop();const q=c(z,ee=>M(H,ee)<0);z.splice(q,0,H)}}}function w(k){return k.filter(M=>!!M)}t.coalesce=w;function E(k){let M=0;for(let z=0;z<k.length;z++)k[z]&&(k[M]=k[z],M+=1);k.length=M}t.coalesceInPlace=E;function a(k,M,z){k.splice(z,0,k.splice(M,1)[0])}t.move=a;function u(k){return!Array.isArray(k)||k.length===0}t.isFalsyOrEmpty=u;function m(k){return Array.isArray(k)&&k.length>0}t.isNonEmptyArray=m;function S(k,M=z=>z){const z=new Set;return k.filter(A=>{const R=M(A);return z.has(R)?!1:(z.add(R),!0)})}t.distinct=S;function T(k){const M=new Set;return z=>{const A=k(z);return M.has(A)?!1:(M.add(A),!0)}}t.uniqueFilter=T;function _(k,M){const z=r(k,M);if(z!==-1)return k[z]}t.findLast=_;function r(k,M){for(let z=k.length-1;z>=0;z--){const A=k[z];if(M(A))return z}return-1}t.lastIndex=r;function v(k,M){return k.length>0?k[0]:M}t.firstOrDefault=v;function o(k,M){return k.length>0?k[k.length-1]:M}t.lastOrDefault=o;function s(k,M,z=(A,R)=>A===R){let A=0;for(let R=0,O=Math.min(k.length,M.length);R<O&&z(k[R],M[R]);R++)A++;return A}t.commonPrefixLength=s;function p(k){return[].concat(...k)}t.flatten=p;function L(k,M){let z=typeof M=="number"?k:0;typeof M=="number"?z=k:(z=0,M=k);const A=[];if(z<=M)for(let R=z;R<M;R++)A.push(R);else for(let R=z;R>M;R--)A.push(R);return A}t.range=L;function V(k,M,z){return k.reduce((A,R)=>(A[M(R)]=z?z(R):R,A),Object.create(null))}t.index=V;function X(k,M){return k.push(M),()=>J(k,M)}t.insert=X;function J(k,M){const z=k.indexOf(M);if(z>-1)return k.splice(z,1),M}t.remove=J;function ge(k,M,z){const A=k.slice(0,M),R=k.slice(M);return A.concat(z,R)}t.arrayInsert=ge;function oe(k,M){let z;if(typeof M=="number"){let A=M;z=()=>{const R=Math.sin(A++)*179426549;return R-Math.floor(R)}}else z=Math.random;for(let A=k.length-1;A>0;A-=1){const R=Math.floor(z()*(A+1)),O=k[A];k[A]=k[R],k[R]=O}}t.shuffle=oe;function me(k,M){const z=k.indexOf(M);z>-1&&(k.splice(z,1),k.unshift(M))}t.pushToStart=me;function he(k,M){const z=k.indexOf(M);z>-1&&(k.splice(z,1),k.push(M))}t.pushToEnd=he;function ae(k,M){for(const z of M)k.push(z)}t.pushMany=ae;function Se(k,M){return Array.isArray(k)?k.map(M):M(k)}t.mapArrayOrNot=Se;function te(k){return Array.isArray(k)?k:[k]}t.asArray=te;function De(k){return k[Math.floor(Math.random()*k.length)]}t.getRandomElement=De;function se(k,M){for(const z of k){const A=M(z);if(A!==void 0)return A}}t.mapFind=se;function ie(k,M,z){const A=ne(k,M),R=k.length,O=z.length;k.length=R+O;for(let H=R-1;H>=A;H--)k[H+O]=k[H];for(let H=0;H<O;H++)k[H+A]=z[H]}t.insertInto=ie;function ce(k,M,z,A){const R=ne(k,M),O=k.splice(R,z);return ie(k,R,A),O}t.splice=ce;function ne(k,M){return M<0?Math.max(M+k.length,0):Math.min(M,k.length)}var F;(function(k){function M(R){return R<0}k.isLessThan=M;function z(R){return R>0}k.isGreaterThan=z;function A(R){return R===0}k.isNeitherLessOrGreaterThan=A,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(F=t.CompareResult||(t.CompareResult={}));function $(k,M){return(z,A)=>M(k(z),k(A))}t.compareBy=$;function j(...k){return(M,z)=>{for(const A of k){const R=A(M,z);if(!F.isNeitherLessOrGreaterThan(R))return R}return F.neitherLessOrGreaterThan}}t.tieBreakComparators=j;const P=(k,M)=>k-M;t.numberComparator=P;function h(k,M){if(k.length===0)return;let z=k[0];for(let A=1;A<k.length;A++){const R=k[A];M(R,z)>0&&(z=R)}return z}t.findMaxBy=h;function I(k,M){if(k.length===0)return;let z=k[0];for(let A=1;A<k.length;A++){const R=k[A];M(R,z)>=0&&(z=R)}return z}t.findLastMaxBy=I;function U(k,M){return h(k,(z,A)=>-M(z,A))}t.findMinBy=U;class K{constructor(M){this.items=M,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(M){let z=this.firstIdx;for(;z<this.items.length&&M(this.items[z]);)z++;const A=z===this.firstIdx?null:this.items.slice(this.firstIdx,z);return this.firstIdx=z,A}takeFromEndWhile(M){let z=this.lastIdx;for(;z>=0&&M(this.items[z]);)z--;const A=z===this.lastIdx?null:this.items.slice(z+1,this.lastIdx+1);return this.lastIdx=z,A}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const M=this.items[this.firstIdx];return this.firstIdx++,M}removeLast(){const M=this.items[this.lastIdx];return this.lastIdx--,M}takeCount(M){const z=this.items.slice(this.firstIdx,this.firstIdx+M);return this.firstIdx+=M,z}}t.ArrayQueue=K;class Z{constructor(M){this.iterate=M}forEach(M){this.iterate(z=>(M(z),!0))}toArray(){const M=[];return this.iterate(z=>(M.push(z),!0)),M}filter(M){return new Z(z=>this.iterate(A=>M(A)?z(A):!0))}map(M){return new Z(z=>this.iterate(A=>z(M(A))))}some(M){let z=!1;return this.iterate(A=>(z=M(A),!z)),z}findFirst(M){let z;return this.iterate(A=>M(A)?(z=A,!1):!0),z}findLast(M){let z;return this.iterate(A=>(M(A)&&(z=A),!0)),z}findLastMaxBy(M){let z,A=!0;return this.iterate(R=>((A||F.isGreaterThan(M(R,z)))&&(A=!1,z=R),!0)),z}}t.CallbackIterable=Z,Z.empty=new Z(k=>{})}),define(pe[71],be([1,0,9]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function i(d,c){if(!d)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}t.ok=i;function W(d,c="Unreachable"){throw new Error(c)}t.assertNever=W;function B(d){if(!d)throw new y.BugIndicatingError("Assertion Failed")}t.assert=B;function C(d){if(!d()){debugger;d(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}t.assertFn=C;function D(d,c){let f=0;for(;f<d.length-1;){const N=d[f],l=d[f+1];if(!c(N,l))return!1;f++}return!0}t.checkAdjacentItems=D}),define(pe[42],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function y(i){const W=this;let B=!1,C;return function(){return B||(B=!0,C=i.apply(W,arguments)),C}}t.once=y}),define(pe[72],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class y{constructor(W){this._prefix=W,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=y,t.defaultGenerator=new y("id#")}),define(pe[26],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(i){function W(T){return T&&typeof T=="object"&&typeof T[Symbol.iterator]=="function"}i.is=W;const B=Object.freeze([]);function C(){return B}i.empty=C;function*D(T){yield T}i.single=D;function d(T){return T||B}i.from=d;function c(T){return!T||T[Symbol.iterator]().next().done===!0}i.isEmpty=c;function f(T){return T[Symbol.iterator]().next().value}i.first=f;function N(T,_){for(const r of T)if(_(r))return!0;return!1}i.some=N;function l(T,_){for(const r of T)if(_(r))return r}i.find=l;function*n(T,_){for(const r of T)_(r)&&(yield r)}i.filter=n;function*e(T,_){let r=0;for(const v of T)yield _(v,r++)}i.map=e;function*g(...T){for(const _ of T)for(const r of _)yield r}i.concat=g;function*b(T){for(const _ of T)for(const r of _)yield r}i.concatNested=b;function w(T,_,r){let v=r;for(const o of T)v=_(v,o);return v}i.reduce=w;function E(T,_){let r=0;for(const v of T)_(v,r++)}i.forEach=E;function*a(T,_,r=T.length){for(_<0&&(_+=T.length),r<0?r+=T.length:r>T.length&&(r=T.length);_<r;_++)yield T[_]}i.slice=a;function u(T,_=Number.POSITIVE_INFINITY){const r=[];if(_===0)return[r,T];const v=T[Symbol.iterator]();for(let o=0;o<_;o++){const s=v.next();if(s.done)return[r,i.empty()];r.push(s.value)}return[r,{[Symbol.iterator](){return v}}]}i.consume=u;function m(T){return u(T)[0]}i.collect=m;function S(T,_,r=(v,o)=>v===o){const v=T[Symbol.iterator](),o=_[Symbol.iterator]();for(;;){const s=v.next(),p=o.next();if(s.done!==p.done)return!1;if(s.done)return!0;if(!r(s.value,p.value))return!1}}i.equals=S})(y=t.Iterable||(t.Iterable={}))}),define(pe[43],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(y=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class W{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(g,b){this._keyCodeToStr[g]=b,this._strToKeyCode[b.toLowerCase()]=g}keyCodeToStr(g){return this._keyCodeToStr[g]}strToKeyCode(g){return this._strToKeyCode[g.toLowerCase()]||0}}const B=new W,C=new W,D=new W;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],c=Object.create(null),f=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>c[e]||0,toString:e=>d[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",g=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],b=[],w=[];for(const E of g){const[a,u,m,S,T,_,r,v,o,s]=E;if(w[m]||(w[m]=!0,d[m]=S,c[S]=m,f[S.toLowerCase()]=m,u&&(t.IMMUTABLE_CODE_TO_KEY_CODE[m]=T,T!==0&&T!==3&&T!==5&&T!==4&&T!==6&&T!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[T]=m))),!b[T]){if(b[T]=!0,!_)throw new Error(`String representation missing for key code ${T} around scan code ${S}`);B.define(T,_),C.define(T,o||_),D.define(T,s||o||_)}r&&(t.EVENT_KEY_CODE_MAP[r]=T),v&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[v]=T)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var N;(function(e){function g(m){return B.keyCodeToStr(m)}e.toString=g;function b(m){return B.strToKeyCode(m)}e.fromString=b;function w(m){return C.keyCodeToStr(m)}e.toUserSettingsUS=w;function E(m){return D.keyCodeToStr(m)}e.toUserSettingsGeneral=E;function a(m){return C.strToKeyCode(m)||D.strToKeyCode(m)}e.fromUserSettings=a;function u(m){if(m>=93&&m<=108)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return B.keyCodeToStr(m)}e.toElectronAccelerator=u})(N=t.KeyCodeUtils||(t.KeyCodeUtils={}));var l;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(l=t.KeyMod||(t.KeyMod={}));function n(e,g){const b=(g&65535)<<16>>>0;return(e|b)>>>0}t.KeyChord=n}),define(pe[73],be([1,0,9]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(N){N[N.CtrlCmd=2048]="CtrlCmd",N[N.Shift=1024]="Shift",N[N.Alt=512]="Alt",N[N.WinCtrl=256]="WinCtrl",N[N.KeyCode=255]="KeyCode"})(i||(i={}));function W(N,l){if(N===0)return null;const n=(N&65535)>>>0,e=(N&4294901760)>>>16;return e!==0?new D([B(n,l),B(e,l)]):new D([B(n,l)])}t.createKeybinding=W;function B(N,l){const n=!!(N&2048),e=!!(N&256),g=l===2?e:n,b=!!(N&1024),w=!!(N&512),E=l===2?n:e,a=N&255;return new C(g,b,w,E,a)}t.createSimpleKeybinding=B;class C{constructor(l,n,e,g,b){this.ctrlKey=l,this.shiftKey=n,this.altKey=e,this.metaKey=g,this.keyCode=b}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",g=this.metaKey?"1":"0";return`${l}${n}${e}${g}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new D([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=C;class D{constructor(l){if(l.length===0)throw(0,y.illegalArgument)("parts");this.parts=l}getHashCode(){let l="";for(let n=0,e=this.parts.length;n<e;n++)n!==0&&(l+=";"),l+=this.parts[n].getHashCode();return l}equals(l){if(l===null||this.parts.length!==l.parts.length)return!1;for(let n=0;n<this.parts.length;n++)if(!this.parts[n].equals(l.parts[n]))return!1;return!0}}t.ChordKeybinding=D;class d{constructor(l,n,e,g,b){this.ctrlKey=l,this.shiftKey=n,this.altKey=e,this.metaKey=g,this.scanCode=b}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.scanCode===l.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=d;class c{constructor(l,n,e,g,b,w){this.ctrlKey=l,this.shiftKey=n,this.altKey=e,this.metaKey=g,this.keyLabel=b,this.keyAriaLabel=w}}t.ResolvedKeybindingPart=c;class f{}t.ResolvedKeybinding=f}),define(pe[44],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class y{constructor(W){this.executor=W,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(W){this._error=W}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(W){return new y(()=>W(this.getValue()))}}t.Lazy=y}),define(pe[2],be([1,0,42,26]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const W=!1;let B=null;function C(o){B=o}if(t.setDisposableTracker=C,W){const o="__is_disposable_tracked__";C(new class{trackDisposable(s){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(p)},3e3)}setParent(s,p){if(s&&s!==E.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==E.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function D(o){return B?.trackDisposable(o),o}function d(o){B?.markAsDisposed(o)}function c(o,s){B?.setParent(o,s)}function f(o,s){if(!!B)for(const p of o)B.setParent(p,s)}function N(o){return B?.markAsSingleton(o),o}t.markAsSingleton=N;function l(o){return typeof o.dispose=="function"&&o.dispose.length===0}t.isDisposable=l;function n(o){if(i.Iterable.is(o)){const s=[];for(const p of o)if(p)try{p.dispose()}catch(L){s.push(L)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}t.dispose=n;function e(o){for(const s of o)l(s)&&s.dispose();return[]}t.disposeIfDisposable=e;function g(...o){const s=b(()=>n(o));return f(o,s),s}t.combinedDisposable=g;function b(o){const s=D({dispose:(0,y.once)(()=>{d(s),o()})});return s}t.toDisposable=b;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{n(this._toDispose)}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return c(s,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}t.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new w,D(this),c(this._store,this)}dispose(){d(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}t.Disposable=E,E.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&c(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&c(s,null),s}}t.MutableDisposable=a;class u{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=u;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(s){let p=s;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,d(this))},this}}t.SafeDisposable=m;class S{constructor(){this.references=new Map}acquire(s,...p){let L=this.references.get(s);L||(L={counter:0,object:this.createReferencedObject(s,...p)},this.references.set(s,L));const{object:V}=L,X=(0,y.once)(()=>{--L.counter===0&&(this.destroyReferencedObject(s,L.object),this.references.delete(s))});return L.counter++,{object:V,dispose:X}}}t.ReferenceCollection=S;class T{constructor(s){this.referenceCollection=s}async acquire(s,...p){const L=this.referenceCollection.acquire(s,...p);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(V){throw L.dispose(),V}}}t.AsyncReferenceCollection=T;class _{constructor(s){this.object=s}dispose(){}}t.ImmortalReference=_;function r(o){const s=new w;try{o(s)}finally{s.dispose()}}t.disposeOnReturn=r;class v{constructor(){this._store=new Map,this._isDisposed=!1,D(this)}dispose(){d(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{n(this._store.values())}finally{this._store.clear()}}has(s){return this._store.has(s)}get(s){return this._store.get(s)}set(s,p,L=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this._store.get(s)?.dispose(),this._store.set(s,p)}deleteAndDispose(s){this._store.get(s)?.dispose(),this._store.delete(s)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=v}),define(pe[74],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class y{constructor(B){this.element=B,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class i{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let B=this._first;for(;B!==y.Undefined;){const C=B.next;B.prev=y.Undefined,B.next=y.Undefined,B=C}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(B){return this._insert(B,!1)}push(B){return this._insert(B,!0)}_insert(B,C){const D=new y(B);if(this._first===y.Undefined)this._first=D,this._last=D;else if(C){const c=this._last;this._last=D,D.prev=c,c.next=D}else{const c=this._first;this._first=D,D.next=c,c.prev=D}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(D))}}shift(){if(this._first!==y.Undefined){const B=this._first.element;return this._remove(this._first),B}}pop(){if(this._last!==y.Undefined){const B=this._last.element;return this._remove(this._last),B}}_remove(B){if(B.prev!==y.Undefined&&B.next!==y.Undefined){const C=B.prev;C.next=B.next,B.next.prev=C}else B.prev===y.Undefined&&B.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):B.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):B.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let B=this._first;for(;B!==y.Undefined;)yield B.element,B=B.next}}t.LinkedList=i}),function(Q,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(pe[75],be([0]),t):(Q=typeof globalThis<"u"?globalThis:Q||self,t(Q.marked={}))}(this,function(Q){"use strict";function t(k,M){for(var z=0;z<M.length;z++){var A=M[z];A.enumerable=A.enumerable||!1,A.configurable=!0,"value"in A&&(A.writable=!0),Object.defineProperty(k,A.key,A)}}function y(k,M,z){return M&&t(k.prototype,M),z&&t(k,z),Object.defineProperty(k,"prototype",{writable:!1}),k}function i(k,M){if(!!k){if(typeof k=="string")return W(k,M);var z=Object.prototype.toString.call(k).slice(8,-1);if(z==="Object"&&k.constructor&&(z=k.constructor.name),z==="Map"||z==="Set")return Array.from(k);if(z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(z))return W(k,M)}}function W(k,M){(M==null||M>k.length)&&(M=k.length);for(var z=0,A=new Array(M);z<M;z++)A[z]=k[z];return A}function B(k,M){var z=typeof Symbol<"u"&&k[Symbol.iterator]||k["@@iterator"];if(z)return(z=z.call(k)).next.bind(z);if(Array.isArray(k)||(z=i(k))||M&&k&&typeof k.length=="number"){z&&(k=z);var A=0;return function(){return A>=k.length?{done:!0}:{done:!1,value:k[A++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Q.defaults=C();function D(k){Q.defaults=k}var d=/[&<>"']/,c=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,N=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},n=function(M){return l[M]};function e(k,M){if(M){if(d.test(k))return k.replace(c,n)}else if(f.test(k))return k.replace(N,n);return k}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(k){return k.replace(g,function(M,z){return z=z.toLowerCase(),z==="colon"?":":z.charAt(0)==="#"?z.charAt(1)==="x"?String.fromCharCode(parseInt(z.substring(2),16)):String.fromCharCode(+z.substring(1)):""})}var w=/(^|[^\[])\^/g;function E(k,M){k=typeof k=="string"?k:k.source,M=M||"";var z={replace:function(R,O){return O=O.source||O,O=O.replace(w,"$1"),k=k.replace(R,O),z},getRegex:function(){return new RegExp(k,M)}};return z}var a=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(k,M,z){if(k){var A;try{A=decodeURIComponent(b(z)).replace(a,"").toLowerCase()}catch{return null}if(A.indexOf("javascript:")===0||A.indexOf("vbscript:")===0||A.indexOf("data:")===0)return null}M&&!u.test(z)&&(z=v(M,z));try{z=encodeURI(z).replace(/%25/g,"%")}catch{return null}return z}var S={},T=/^[^:]+:\/*[^/]*$/,_=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(k,M){S[" "+k]||(T.test(k)?S[" "+k]=k+"/":S[" "+k]=L(k,"/",!0)),k=S[" "+k];var z=k.indexOf(":")===-1;return M.substring(0,2)==="//"?z?M:k.replace(_,"$1")+M:M.charAt(0)==="/"?z?M:k.replace(r,"$1")+M:k+M}var o={exec:function(){}};function s(k){for(var M=1,z,A;M<arguments.length;M++){z=arguments[M];for(A in z)Object.prototype.hasOwnProperty.call(z,A)&&(k[A]=z[A])}return k}function p(k,M){var z=k.replace(/\|/g,function(O,H,q){for(var ee=!1,ue=H;--ue>=0&&q[ue]==="\\";)ee=!ee;return ee?"|":" |"}),A=z.split(/ \|/),R=0;if(A[0].trim()||A.shift(),A.length>0&&!A[A.length-1].trim()&&A.pop(),A.length>M)A.splice(M);else for(;A.length<M;)A.push("");for(;R<A.length;R++)A[R]=A[R].trim().replace(/\\\|/g,"|");return A}function L(k,M,z){var A=k.length;if(A===0)return"";for(var R=0;R<A;){var O=k.charAt(A-R-1);if(O===M&&!z)R++;else if(O!==M&&z)R++;else break}return k.slice(0,A-R)}function V(k,M){if(k.indexOf(M[1])===-1)return-1;for(var z=k.length,A=0,R=0;R<z;R++)if(k[R]==="\\")R++;else if(k[R]===M[0])A++;else if(k[R]===M[1]&&(A--,A<0))return R;return-1}function X(k){k&&k.sanitize&&!k.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function J(k,M){if(M<1)return"";for(var z="";M>1;)M&1&&(z+=k),M>>=1,k+=k;return z+k}function ge(k,M,z,A){var R=M.href,O=M.title?e(M.title):null,H=k[1].replace(/\\([\[\]])/g,"$1");if(k[0].charAt(0)!=="!"){A.state.inLink=!0;var q={type:"link",raw:z,href:R,title:O,text:H,tokens:A.inlineTokens(H)};return A.state.inLink=!1,q}return{type:"image",raw:z,href:R,title:O,text:e(H)}}function oe(k,M){var z=k.match(/^(\s+)(?:```)/);if(z===null)return M;var A=z[1];return M.split(`
`).map(function(R){var O=R.match(/^\s+/);if(O===null)return R;var H=O[0];return H.length>=A.length?R.slice(A.length):R}).join(`
`)}var me=function(){function k(z){this.options=z||Q.defaults}var M=k.prototype;return M.space=function(A){var R=this.rules.block.newline.exec(A);if(R&&R[0].length>0)return{type:"space",raw:R[0]}},M.code=function(A){var R=this.rules.block.code.exec(A);if(R){var O=R[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:R[0],codeBlockStyle:"indented",text:this.options.pedantic?O:L(O,`
`)}}},M.fences=function(A){var R=this.rules.block.fences.exec(A);if(R){var O=R[0],H=oe(O,R[3]||"");return{type:"code",raw:O,lang:R[2]?R[2].trim():R[2],text:H}}},M.heading=function(A){var R=this.rules.block.heading.exec(A);if(R){var O=R[2].trim();if(/#$/.test(O)){var H=L(O,"#");(this.options.pedantic||!H||/ $/.test(H))&&(O=H.trim())}return{type:"heading",raw:R[0],depth:R[1].length,text:O,tokens:this.lexer.inline(O)}}},M.hr=function(A){var R=this.rules.block.hr.exec(A);if(R)return{type:"hr",raw:R[0]}},M.blockquote=function(A){var R=this.rules.block.blockquote.exec(A);if(R){var O=R[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:R[0],tokens:this.lexer.blockTokens(O,[]),text:O}}},M.list=function(A){var R=this.rules.block.list.exec(A);if(R){var O,H,q,ee,ue,de,ye,Ee,Ne,Fe,ve,Re,Pe=R[1].trim(),Ke=Pe.length>1,He={type:"list",raw:"",ordered:Ke,start:Ke?+Pe.slice(0,-1):"",loose:!1,items:[]};Pe=Ke?"\\d{1,9}\\"+Pe.slice(-1):"\\"+Pe,this.options.pedantic&&(Pe=Ke?Pe:"[*+-]");for(var Ue=new RegExp("^( {0,3}"+Pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");A&&(Re=!1,!(!(R=Ue.exec(A))||this.rules.block.hr.test(A)));){if(O=R[0],A=A.substring(O.length),Ee=R[2].split(`
`,1)[0],Ne=A.split(`
`,1)[0],this.options.pedantic?(ee=2,ve=Ee.trimLeft()):(ee=R[2].search(/[^ ]/),ee=ee>4?1:ee,ve=Ee.slice(ee),ee+=R[1].length),de=!1,!Ee&&/^ *$/.test(Ne)&&(O+=Ne+`
`,A=A.substring(Ne.length+1),Re=!0),!Re)for(var Je=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,ee-1)+"}#");A&&(Fe=A.split(`
`,1)[0],Ee=Fe,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(Ee)||qe.test(Ee)||Je.test(Ee)||it.test(A)));){if(Ee.search(/[^ ]/)>=ee||!Ee.trim())ve+=`
`+Ee.slice(ee);else if(!de)ve+=`
`+Ee;else break;!de&&!Ee.trim()&&(de=!0),O+=Fe+`
`,A=A.substring(Fe.length+1)}He.loose||(ye?He.loose=!0:/\n *\n *$/.test(O)&&(ye=!0)),this.options.gfm&&(H=/^\[[ xX]\] /.exec(ve),H&&(q=H[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:O,task:!!H,checked:q,loose:!1,text:ve}),He.raw+=O}He.items[He.items.length-1].raw=O.trimRight(),He.items[He.items.length-1].text=ve.trimRight(),He.raw=He.raw.trimRight();var Ye=He.items.length;for(ue=0;ue<Ye;ue++){this.lexer.state.top=!1,He.items[ue].tokens=this.lexer.blockTokens(He.items[ue].text,[]);var x=He.items[ue].tokens.filter(function(we){return we.type==="space"}),le=x.every(function(we){for(var Ce=we.raw.split(""),Ie=0,Me=B(Ce),Ve;!(Ve=Me()).done;){var tt=Ve.value;if(tt===`
`&&(Ie+=1),Ie>1)return!0}return!1});!He.loose&&x.length&&le&&(He.loose=!0,He.items[ue].loose=!0)}return He}},M.html=function(A){var R=this.rules.block.html.exec(A);if(R){var O={type:"html",raw:R[0],pre:!this.options.sanitizer&&(R[1]==="pre"||R[1]==="script"||R[1]==="style"),text:R[0]};if(this.options.sanitize){var H=this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]);O.type="paragraph",O.text=H,O.tokens=this.lexer.inline(H)}return O}},M.def=function(A){var R=this.rules.block.def.exec(A);if(R){R[3]&&(R[3]=R[3].substring(1,R[3].length-1));var O=R[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:O,raw:R[0],href:R[2],title:R[3]}}},M.table=function(A){var R=this.rules.block.table.exec(A);if(R){var O={type:"table",header:p(R[1]).map(function(ye){return{text:ye}}),align:R[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:R[3]&&R[3].trim()?R[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=R[0];var H=O.align.length,q,ee,ue,de;for(q=0;q<H;q++)/^ *-+: *$/.test(O.align[q])?O.align[q]="right":/^ *:-+: *$/.test(O.align[q])?O.align[q]="center":/^ *:-+ *$/.test(O.align[q])?O.align[q]="left":O.align[q]=null;for(H=O.rows.length,q=0;q<H;q++)O.rows[q]=p(O.rows[q],O.header.length).map(function(ye){return{text:ye}});for(H=O.header.length,ee=0;ee<H;ee++)O.header[ee].tokens=this.lexer.inline(O.header[ee].text);for(H=O.rows.length,ee=0;ee<H;ee++)for(de=O.rows[ee],ue=0;ue<de.length;ue++)de[ue].tokens=this.lexer.inline(de[ue].text);return O}}},M.lheading=function(A){var R=this.rules.block.lheading.exec(A);if(R)return{type:"heading",raw:R[0],depth:R[2].charAt(0)==="="?1:2,text:R[1],tokens:this.lexer.inline(R[1])}},M.paragraph=function(A){var R=this.rules.block.paragraph.exec(A);if(R){var O=R[1].charAt(R[1].length-1)===`
`?R[1].slice(0,-1):R[1];return{type:"paragraph",raw:R[0],text:O,tokens:this.lexer.inline(O)}}},M.text=function(A){var R=this.rules.block.text.exec(A);if(R)return{type:"text",raw:R[0],text:R[0],tokens:this.lexer.inline(R[0])}},M.escape=function(A){var R=this.rules.inline.escape.exec(A);if(R)return{type:"escape",raw:R[0],text:e(R[1])}},M.tag=function(A){var R=this.rules.inline.tag.exec(A);if(R)return!this.lexer.state.inLink&&/^<a /i.test(R[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(R[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(R[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(R[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:R[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]):R[0]}},M.link=function(A){var R=this.rules.inline.link.exec(A);if(R){var O=R[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var H=L(O.slice(0,-1),"\\");if((O.length-H.length)%2===0)return}else{var q=V(R[2],"()");if(q>-1){var ee=R[0].indexOf("!")===0?5:4,ue=ee+R[1].length+q;R[2]=R[2].substring(0,q),R[0]=R[0].substring(0,ue).trim(),R[3]=""}}var de=R[2],ye="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Ee&&(de=Ee[1],ye=Ee[3])}else ye=R[3]?R[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(O)?de=de.slice(1):de=de.slice(1,-1)),ge(R,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:ye&&ye.replace(this.rules.inline._escapes,"$1")},R[0],this.lexer)}},M.reflink=function(A,R){var O;if((O=this.rules.inline.reflink.exec(A))||(O=this.rules.inline.nolink.exec(A))){var H=(O[2]||O[1]).replace(/\s+/g," ");if(H=R[H.toLowerCase()],!H||!H.href){var q=O[0].charAt(0);return{type:"text",raw:q,text:q}}return ge(O,H,O[0],this.lexer)}},M.emStrong=function(A,R,O){O===void 0&&(O="");var H=this.rules.inline.emStrong.lDelim.exec(A);if(!!H&&!(H[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var q=H[1]||H[2]||"";if(!q||q&&(O===""||this.rules.inline.punctuation.exec(O))){var ee=H[0].length-1,ue,de,ye=ee,Ee=0,Ne=H[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,R=R.slice(-1*A.length+ee);(H=Ne.exec(R))!=null;)if(ue=H[1]||H[2]||H[3]||H[4]||H[5]||H[6],!!ue){if(de=ue.length,H[3]||H[4]){ye+=de;continue}else if((H[5]||H[6])&&ee%3&&!((ee+de)%3)){Ee+=de;continue}if(ye-=de,!(ye>0)){if(de=Math.min(de,de+ye+Ee),Math.min(ee,de)%2){var Fe=A.slice(1,ee+H.index+de);return{type:"em",raw:A.slice(0,ee+H.index+de+1),text:Fe,tokens:this.lexer.inlineTokens(Fe)}}var ve=A.slice(2,ee+H.index+de-1);return{type:"strong",raw:A.slice(0,ee+H.index+de+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},M.codespan=function(A){var R=this.rules.inline.code.exec(A);if(R){var O=R[2].replace(/\n/g," "),H=/[^ ]/.test(O),q=/^ /.test(O)&&/ $/.test(O);return H&&q&&(O=O.substring(1,O.length-1)),O=e(O,!0),{type:"codespan",raw:R[0],text:O}}},M.br=function(A){var R=this.rules.inline.br.exec(A);if(R)return{type:"br",raw:R[0]}},M.del=function(A){var R=this.rules.inline.del.exec(A);if(R)return{type:"del",raw:R[0],text:R[2],tokens:this.lexer.inlineTokens(R[2])}},M.autolink=function(A,R){var O=this.rules.inline.autolink.exec(A);if(O){var H,q;return O[2]==="@"?(H=e(this.options.mangle?R(O[1]):O[1]),q="mailto:"+H):(H=e(O[1]),q=H),{type:"link",raw:O[0],text:H,href:q,tokens:[{type:"text",raw:H,text:H}]}}},M.url=function(A,R){var O;if(O=this.rules.inline.url.exec(A)){var H,q;if(O[2]==="@")H=e(this.options.mangle?R(O[0]):O[0]),q="mailto:"+H;else{var ee;do ee=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(ee!==O[0]);H=e(O[0]),O[1]==="www."?q="http://"+H:q=H}return{type:"link",raw:O[0],text:H,href:q,tokens:[{type:"text",raw:H,text:H}]}}},M.inlineText=function(A,R){var O=this.rules.inline.text.exec(A);if(O){var H;return this.lexer.state.inRawBlock?H=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):e(O[0]):O[0]:H=e(this.options.smartypants?R(O[0]):O[0]),{type:"text",raw:O[0],text:H}}},k}(),he={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};he._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,he._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,he.def=E(he.def).replace("label",he._label).replace("title",he._title).getRegex(),he.bullet=/(?:[*+-]|\d{1,9}[.)])/,he.listItemStart=E(/^( *)(bull) */).replace("bull",he.bullet).getRegex(),he.list=E(he.list).replace(/bull/g,he.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+he.def.source+")").getRegex(),he._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",he._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,he.html=E(he.html,"i").replace("comment",he._comment).replace("tag",he._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),he.paragraph=E(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.blockquote=E(he.blockquote).replace("paragraph",he.paragraph).getRegex(),he.normal=s({},he),he.gfm=s({},he.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),he.gfm.table=E(he.gfm.table).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.gfm.paragraph=E(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",he.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.pedantic=s({},he.normal,{html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",he._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:E(he.normal._paragraph).replace("hr",he.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",he.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=E(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=E(he._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=E(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=E(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=E(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=E(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=E(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=E(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=E(ae.reflink).replace("label",ae._label).replace("ref",he._label).getRegex(),ae.nolink=E(ae.nolink).replace("ref",he._label).getRegex(),ae.reflinkSearch=E(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=s({},ae),ae.pedantic=s({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=s({},ae.normal,{escape:E(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=E(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=s({},ae.gfm,{br:E(ae.br).replace("{2,}","*").getRegex(),text:E(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Se(k){return k.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(k){var M="",z,A,R=k.length;for(z=0;z<R;z++)A=k.charCodeAt(z),Math.random()>.5&&(A="x"+A.toString(16)),M+="&#"+A+";";return M}var De=function(){function k(z){this.tokens=[],this.tokens.links=Object.create(null),this.options=z||Q.defaults,this.options.tokenizer=this.options.tokenizer||new me,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var A={block:he.normal,inline:ae.normal};this.options.pedantic?(A.block=he.pedantic,A.inline=ae.pedantic):this.options.gfm&&(A.block=he.gfm,this.options.breaks?A.inline=ae.breaks:A.inline=ae.gfm),this.tokenizer.rules=A}k.lex=function(A,R){var O=new k(R);return O.lex(A)},k.lexInline=function(A,R){var O=new k(R);return O.inlineTokens(A)};var M=k.prototype;return M.lex=function(A){A=A.replace(/\r\n|\r/g,`
`),this.blockTokens(A,this.tokens);for(var R;R=this.inlineQueue.shift();)this.inlineTokens(R.src,R.tokens);return this.tokens},M.blockTokens=function(A,R){var O=this;R===void 0&&(R=[]),this.options.pedantic?A=A.replace(/\t/g,"    ").replace(/^ +$/gm,""):A=A.replace(/^( *)(\t+)/gm,function(ye,Ee,Ne){return Ee+"    ".repeat(Ne.length)});for(var H,q,ee,ue;A;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ye){return(H=ye.call({lexer:O},A,R))?(A=A.substring(H.raw.length),R.push(H),!0):!1}))){if(H=this.tokenizer.space(A)){A=A.substring(H.raw.length),H.raw.length===1&&R.length>0?R[R.length-1].raw+=`
`:R.push(H);continue}if(H=this.tokenizer.code(A)){A=A.substring(H.raw.length),q=R[R.length-1],q&&(q.type==="paragraph"||q.type==="text")?(q.raw+=`
`+H.raw,q.text+=`
`+H.text,this.inlineQueue[this.inlineQueue.length-1].src=q.text):R.push(H);continue}if(H=this.tokenizer.fences(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.heading(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.hr(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.blockquote(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.list(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.html(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.def(A)){A=A.substring(H.raw.length),q=R[R.length-1],q&&(q.type==="paragraph"||q.type==="text")?(q.raw+=`
`+H.raw,q.text+=`
`+H.raw,this.inlineQueue[this.inlineQueue.length-1].src=q.text):this.tokens.links[H.tag]||(this.tokens.links[H.tag]={href:H.href,title:H.title});continue}if(H=this.tokenizer.table(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.lheading(A)){A=A.substring(H.raw.length),R.push(H);continue}if(ee=A,this.options.extensions&&this.options.extensions.startBlock&&function(){var ye=1/0,Ee=A.slice(1),Ne=void 0;O.options.extensions.startBlock.forEach(function(Fe){Ne=Fe.call({lexer:this},Ee),typeof Ne=="number"&&Ne>=0&&(ye=Math.min(ye,Ne))}),ye<1/0&&ye>=0&&(ee=A.substring(0,ye+1))}(),this.state.top&&(H=this.tokenizer.paragraph(ee))){q=R[R.length-1],ue&&q.type==="paragraph"?(q.raw+=`
`+H.raw,q.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=q.text):R.push(H),ue=ee.length!==A.length,A=A.substring(H.raw.length);continue}if(H=this.tokenizer.text(A)){A=A.substring(H.raw.length),q=R[R.length-1],q&&q.type==="text"?(q.raw+=`
`+H.raw,q.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=q.text):R.push(H);continue}if(A){var de="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,R},M.inline=function(A,R){return R===void 0&&(R=[]),this.inlineQueue.push({src:A,tokens:R}),R},M.inlineTokens=function(A,R){var O=this;R===void 0&&(R=[]);var H,q,ee,ue=A,de,ye,Ee;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(ue))!=null;)Ne.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(ue=ue.slice(0,de.index)+"["+J("a",de[0].length-2)+"]"+ue.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(ue))!=null;)ue=ue.slice(0,de.index)+"["+J("a",de[0].length-2)+"]"+ue.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(ue))!=null;)ue=ue.slice(0,de.index)+"++"+ue.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;A;)if(ye||(Ee=""),ye=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(H=ve.call({lexer:O},A,R))?(A=A.substring(H.raw.length),R.push(H),!0):!1}))){if(H=this.tokenizer.escape(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.tag(A)){A=A.substring(H.raw.length),q=R[R.length-1],q&&H.type==="text"&&q.type==="text"?(q.raw+=H.raw,q.text+=H.text):R.push(H);continue}if(H=this.tokenizer.link(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.reflink(A,this.tokens.links)){A=A.substring(H.raw.length),q=R[R.length-1],q&&H.type==="text"&&q.type==="text"?(q.raw+=H.raw,q.text+=H.text):R.push(H);continue}if(H=this.tokenizer.emStrong(A,ue,Ee)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.codespan(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.br(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.del(A)){A=A.substring(H.raw.length),R.push(H);continue}if(H=this.tokenizer.autolink(A,te)){A=A.substring(H.raw.length),R.push(H);continue}if(!this.state.inLink&&(H=this.tokenizer.url(A,te))){A=A.substring(H.raw.length),R.push(H);continue}if(ee=A,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Re=A.slice(1),Pe=void 0;O.options.extensions.startInline.forEach(function(Ke){Pe=Ke.call({lexer:this},Re),typeof Pe=="number"&&Pe>=0&&(ve=Math.min(ve,Pe))}),ve<1/0&&ve>=0&&(ee=A.substring(0,ve+1))}(),H=this.tokenizer.inlineText(ee,Se)){A=A.substring(H.raw.length),H.raw.slice(-1)!=="_"&&(Ee=H.raw.slice(-1)),ye=!0,q=R[R.length-1],q&&q.type==="text"?(q.raw+=H.raw,q.text+=H.text):R.push(H);continue}if(A){var Fe="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(Fe);break}else throw new Error(Fe)}}return R},y(k,null,[{key:"rules",get:function(){return{block:he,inline:ae}}}]),k}(),se=function(){function k(z){this.options=z||Q.defaults}var M=k.prototype;return M.code=function(A,R,O){var H=(R||"").match(/\S*/)[0];if(this.options.highlight){var q=this.options.highlight(A,H);q!=null&&q!==A&&(O=!0,A=q)}return A=A.replace(/\n$/,"")+`
`,H?'<pre><code class="'+this.options.langPrefix+e(H,!0)+'">'+(O?A:e(A,!0))+`</code></pre>
`:"<pre><code>"+(O?A:e(A,!0))+`</code></pre>
`},M.blockquote=function(A){return`<blockquote>
`+A+`</blockquote>
`},M.html=function(A){return A},M.heading=function(A,R,O,H){if(this.options.headerIds){var q=this.options.headerPrefix+H.slug(O);return"<h"+R+' id="'+q+'">'+A+"</h"+R+`>
`}return"<h"+R+">"+A+"</h"+R+`>
`},M.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},M.list=function(A,R,O){var H=R?"ol":"ul",q=R&&O!==1?' start="'+O+'"':"";return"<"+H+q+`>
`+A+"</"+H+`>
`},M.listitem=function(A){return"<li>"+A+`</li>
`},M.checkbox=function(A){return"<input "+(A?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},M.paragraph=function(A){return"<p>"+A+`</p>
`},M.table=function(A,R){return R&&(R="<tbody>"+R+"</tbody>"),`<table>
<thead>
`+A+`</thead>
`+R+`</table>
`},M.tablerow=function(A){return`<tr>
`+A+`</tr>
`},M.tablecell=function(A,R){var O=R.header?"th":"td",H=R.align?"<"+O+' align="'+R.align+'">':"<"+O+">";return H+A+("</"+O+`>
`)},M.strong=function(A){return"<strong>"+A+"</strong>"},M.em=function(A){return"<em>"+A+"</em>"},M.codespan=function(A){return"<code>"+A+"</code>"},M.br=function(){return this.options.xhtml?"<br/>":"<br>"},M.del=function(A){return"<del>"+A+"</del>"},M.link=function(A,R,O){if(A=m(this.options.sanitize,this.options.baseUrl,A),A===null)return O;var H='<a href="'+e(A)+'"';return R&&(H+=' title="'+R+'"'),H+=">"+O+"</a>",H},M.image=function(A,R,O){if(A=m(this.options.sanitize,this.options.baseUrl,A),A===null)return O;var H='<img src="'+A+'" alt="'+O+'"';return R&&(H+=' title="'+R+'"'),H+=this.options.xhtml?"/>":">",H},M.text=function(A){return A},k}(),ie=function(){function k(){}var M=k.prototype;return M.strong=function(A){return A},M.em=function(A){return A},M.codespan=function(A){return A},M.del=function(A){return A},M.html=function(A){return A},M.text=function(A){return A},M.link=function(A,R,O){return""+O},M.image=function(A,R,O){return""+O},M.br=function(){return""},k}(),ce=function(){function k(){this.seen={}}var M=k.prototype;return M.serialize=function(A){return A.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},M.getNextSafeSlug=function(A,R){var O=A,H=0;if(this.seen.hasOwnProperty(O)){H=this.seen[A];do H++,O=A+"-"+H;while(this.seen.hasOwnProperty(O))}return R||(this.seen[A]=H,this.seen[O]=0),O},M.slug=function(A,R){R===void 0&&(R={});var O=this.serialize(A);return this.getNextSafeSlug(O,R.dryrun)},k}(),ne=function(){function k(z){this.options=z||Q.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new ce}k.parse=function(A,R){var O=new k(R);return O.parse(A)},k.parseInline=function(A,R){var O=new k(R);return O.parseInline(A)};var M=k.prototype;return M.parse=function(A,R){R===void 0&&(R=!0);var O="",H,q,ee,ue,de,ye,Ee,Ne,Fe,ve,Re,Pe,Ke,He,Ue,Je,it,Oe,qe,Ye=A.length;for(H=0;H<Ye;H++){if(ve=A[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(qe=this.options.extensions.renderers[ve.type].call({parser:this},ve),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){O+=qe||"";continue}switch(ve.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,b(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ne="",Ee="",ue=ve.header.length,q=0;q<ue;q++)Ee+=this.renderer.tablecell(this.parseInline(ve.header[q].tokens),{header:!0,align:ve.align[q]});for(Ne+=this.renderer.tablerow(Ee),Fe="",ue=ve.rows.length,q=0;q<ue;q++){for(ye=ve.rows[q],Ee="",de=ye.length,ee=0;ee<de;ee++)Ee+=this.renderer.tablecell(this.parseInline(ye[ee].tokens),{header:!1,align:ve.align[ee]});Fe+=this.renderer.tablerow(Ee)}O+=this.renderer.table(Ne,Fe);continue}case"blockquote":{Fe=this.parse(ve.tokens),O+=this.renderer.blockquote(Fe);continue}case"list":{for(Re=ve.ordered,Pe=ve.start,Ke=ve.loose,ue=ve.items.length,Fe="",q=0;q<ue;q++)Ue=ve.items[q],Je=Ue.checked,it=Ue.task,He="",Ue.task&&(Oe=this.renderer.checkbox(Je),Ke?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=Oe+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=Oe+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:Oe}):He+=Oe),He+=this.parse(Ue.tokens,Ke),Fe+=this.renderer.listitem(He,it,Je);O+=this.renderer.list(Fe,Re,Pe);continue}case"html":{O+=this.renderer.html(ve.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Fe=ve.tokens?this.parseInline(ve.tokens):ve.text;H+1<Ye&&A[H+1].type==="text";)ve=A[++H],Fe+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);O+=R?this.renderer.paragraph(Fe):Fe;continue}default:{var x='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(x);return}else throw new Error(x)}}}return O},M.parseInline=function(A,R){R=R||this.renderer;var O="",H,q,ee,ue=A.length;for(H=0;H<ue;H++){if(q=A[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(ee=this.options.extensions.renderers[q.type].call({parser:this},q),ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(q.type))){O+=ee||"";continue}switch(q.type){case"escape":{O+=R.text(q.text);break}case"html":{O+=R.html(q.text);break}case"link":{O+=R.link(q.href,q.title,this.parseInline(q.tokens,R));break}case"image":{O+=R.image(q.href,q.title,q.text);break}case"strong":{O+=R.strong(this.parseInline(q.tokens,R));break}case"em":{O+=R.em(this.parseInline(q.tokens,R));break}case"codespan":{O+=R.codespan(q.text);break}case"br":{O+=R.br();break}case"del":{O+=R.del(this.parseInline(q.tokens,R));break}case"text":{O+=R.text(q.text);break}default:{var de='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return O},k}();function F(k,M,z){if(typeof k>"u"||k===null)throw new Error("marked(): input parameter is undefined or null");if(typeof k!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(k)+", string expected");if(typeof M=="function"&&(z=M,M=null),M=s({},F.defaults,M||{}),X(M),z){var A=M.highlight,R;try{R=De.lex(k,M)}catch(ue){return z(ue)}var O=function(de){var ye;if(!de)try{M.walkTokens&&F.walkTokens(R,M.walkTokens),ye=ne.parse(R,M)}catch(Ee){de=Ee}return M.highlight=A,de?z(de):z(null,ye)};if(!A||A.length<3||(delete M.highlight,!R.length))return O();var H=0;F.walkTokens(R,function(ue){ue.type==="code"&&(H++,setTimeout(function(){A(ue.text,ue.lang,function(de,ye){if(de)return O(de);ye!=null&&ye!==ue.text&&(ue.text=ye,ue.escaped=!0),H--,H===0&&O()})},0))}),H===0&&O();return}function q(ue){if(ue.message+=`
Please report this to https://github.com/markedjs/marked.`,M.silent)return"<p>An error occurred:</p><pre>"+e(ue.message+"",!0)+"</pre>";throw ue}try{var ee=De.lex(k,M);if(M.walkTokens){if(M.async)return Promise.all(F.walkTokens(ee,M.walkTokens)).then(function(){return ne.parse(ee,M)}).catch(q);F.walkTokens(ee,M.walkTokens)}return ne.parse(ee,M)}catch(ue){q(ue)}}F.options=F.setOptions=function(k){return s(F.defaults,k),D(F.defaults),F},F.getDefaults=C,F.defaults=Q.defaults,F.use=function(){for(var k=arguments.length,M=new Array(k),z=0;z<k;z++)M[z]=arguments[z];var A=s.apply(void 0,[{}].concat(M)),R=F.defaults.extensions||{renderers:{},childTokens:{}},O;M.forEach(function(H){if(H.extensions&&(O=!0,H.extensions.forEach(function(ee){if(!ee.name)throw new Error("extension name required");if(ee.renderer){var ue=R.renderers?R.renderers[ee.name]:null;ue?R.renderers[ee.name]=function(){for(var de=arguments.length,ye=new Array(de),Ee=0;Ee<de;Ee++)ye[Ee]=arguments[Ee];var Ne=ee.renderer.apply(this,ye);return Ne===!1&&(Ne=ue.apply(this,ye)),Ne}:R.renderers[ee.name]=ee.renderer}if(ee.tokenizer){if(!ee.level||ee.level!=="block"&&ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");R[ee.level]?R[ee.level].unshift(ee.tokenizer):R[ee.level]=[ee.tokenizer],ee.start&&(ee.level==="block"?R.startBlock?R.startBlock.push(ee.start):R.startBlock=[ee.start]:ee.level==="inline"&&(R.startInline?R.startInline.push(ee.start):R.startInline=[ee.start]))}ee.childTokens&&(R.childTokens[ee.name]=ee.childTokens)})),H.renderer&&function(){var ee=F.defaults.renderer||new se,ue=function(Ee){var Ne=ee[Ee];ee[Ee]=function(){for(var Fe=arguments.length,ve=new Array(Fe),Re=0;Re<Fe;Re++)ve[Re]=arguments[Re];var Pe=H.renderer[Ee].apply(ee,ve);return Pe===!1&&(Pe=Ne.apply(ee,ve)),Pe}};for(var de in H.renderer)ue(de);A.renderer=ee}(),H.tokenizer&&function(){var ee=F.defaults.tokenizer||new me,ue=function(Ee){var Ne=ee[Ee];ee[Ee]=function(){for(var Fe=arguments.length,ve=new Array(Fe),Re=0;Re<Fe;Re++)ve[Re]=arguments[Re];var Pe=H.tokenizer[Ee].apply(ee,ve);return Pe===!1&&(Pe=Ne.apply(ee,ve)),Pe}};for(var de in H.tokenizer)ue(de);A.tokenizer=ee}(),H.walkTokens){var q=F.defaults.walkTokens;A.walkTokens=function(ee){var ue=[];return ue.push(H.walkTokens.call(this,ee)),q&&(ue=ue.concat(q.call(this,ee))),ue}}O&&(A.extensions=R),F.setOptions(A)})},F.walkTokens=function(k,M){for(var z=[],A=function(){var q=O.value;switch(z=z.concat(M.call(F,q)),q.type){case"table":{for(var ee=B(q.header),ue;!(ue=ee()).done;){var de=ue.value;z=z.concat(F.walkTokens(de.tokens,M))}for(var ye=B(q.rows),Ee;!(Ee=ye()).done;)for(var Ne=Ee.value,Fe=B(Ne),ve;!(ve=Fe()).done;){var Re=ve.value;z=z.concat(F.walkTokens(Re.tokens,M))}break}case"list":{z=z.concat(F.walkTokens(q.items,M));break}default:F.defaults.extensions&&F.defaults.extensions.childTokens&&F.defaults.extensions.childTokens[q.type]?F.defaults.extensions.childTokens[q.type].forEach(function(Pe){z=z.concat(F.walkTokens(q[Pe],M))}):q.tokens&&(z=z.concat(F.walkTokens(q.tokens,M)))}},R=B(k),O;!(O=R()).done;)A();return z},F.parseInline=function(k,M){if(typeof k>"u"||k===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof k!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(k)+", string expected");M=s({},F.defaults,M||{}),X(M);try{var z=De.lexInline(k,M);return M.walkTokens&&F.walkTokens(z,M.walkTokens),ne.parseInline(z,M)}catch(A){if(A.message+=`
Please report this to https://github.com/markedjs/marked.`,M.silent)return"<p>An error occurred:</p><pre>"+e(A.message+"",!0)+"</pre>";throw A}},F.Parser=ne,F.parser=ne.parse,F.Renderer=se,F.TextRenderer=ie,F.Lexer=De,F.lexer=De.lex,F.Tokenizer=me,F.Slugger=ce,F.parse=F;var $=F.options,j=F.setOptions,P=F.use,h=F.walkTokens,I=F.parseInline,U=F,K=ne.parse,Z=De.lex;Q.Lexer=De,Q.Parser=ne,Q.Renderer=se,Q.Slugger=ce,Q.TextRenderer=ie,Q.Tokenizer=me,Q.getDefaults=C,Q.lexer=Z,Q.marked=F,Q.options=$,Q.parse=U,Q.parseInline=I,Q.parser=K,Q.setOptions=j,Q.use=P,Q.walkTokens=h,Object.defineProperty(Q,"__esModule",{value:!0})}),define(pe[76],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class y{constructor(W,B=0,C=W.length,D=B-1){this.items=W,this.start=B,this.end=C,this.index=D}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=y}),define(pe[77],be([1,0,76]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(C=[],D=10){this._initialize(C),this._limit=D,this._onChange()}getHistory(){return this._elements}add(C){this._history.delete(C),this._history.add(C),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}has(C){return this._history.has(C)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const C=this._elements;this._navigator=new y.ArrayNavigator(C,0,C.length,C.length)}_reduceToLimit(){const C=this._elements;C.length>this._limit&&this._initialize(C.slice(C.length-this._limit))}_currentPosition(){const C=this._navigator.current();return C?this._elements.indexOf(C):-1}_initialize(C){this._history=new Set;for(const D of C)this._history.add(D)}get _elements(){const C=[];return this._history.forEach(D=>C.push(D)),C}}t.HistoryNavigator=i;class W{constructor(C,D=10){if(this.capacity=D,C.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:C[0],previous:void 0,next:void 0};for(let d=1;d<C.length;d++)this.add(C[d])}add(C){const D={value:C,previous:this.tail,next:void 0};for(this.tail.next=D,this.tail=D,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(C){const D=this.tail.value;return this.tail.value=C,D}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(C){let D=this.head;for(;D;){if(D.value===C)return!0;D=D.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let C=this.head;for(;C;)yield C.value,C=C.next}}t.HistoryNavigator2=W}),define(pe[45],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function y(D,d,c){return Math.min(Math.max(D,d),c)}t.clamp=y;function i(D,d){return(d+D%d)%d}t.rot=i;class W{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=W;class B{constructor(){this._n=1,this._val=0}update(d){return this._val=this._val+(d-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=B;class C{constructor(d){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(d),this._values.fill(0,0,d)}update(d){const c=this._values[this._index];return this._values[this._index]=d,this._index=(this._index+1)%this._values.length,this._sum-=c,this._sum+=d,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=C}),define(pe[46],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(i){function W(d,c){if(d.start>=c.end||c.start>=d.end)return{start:0,end:0};const f=Math.max(d.start,c.start),N=Math.min(d.end,c.end);return N-f<=0?{start:0,end:0}:{start:f,end:N}}i.intersect=W;function B(d){return d.end-d.start<=0}i.isEmpty=B;function C(d,c){return!B(W(d,c))}i.intersects=C;function D(d,c){const f=[],N={start:d.start,end:Math.min(c.start,d.end)},l={start:Math.max(c.end,d.start),end:d.end};return B(N)||f.push(N),B(l)||f.push(l),f}i.relativeComplement=D})(y=t.Range||(t.Range={}))}),define(pe[78],be([1,0,46]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(d,c){const f=[];for(const N of c){if(d.start>=N.range.end)continue;if(d.end<N.range.start)break;const l=y.Range.intersect(d,N.range);y.Range.isEmpty(l)||f.push({range:l,size:N.size})}return f}t.groupIntersect=i;function W({start:d,end:c},f){return{start:d+f,end:c+f}}t.shift=W;function B(d){const c=[];let f=null;for(const N of d){const l=N.range.start,n=N.range.end,e=N.size;if(f&&e===f.size){f.range.end=n;continue}f={range:{start:l,end:n},size:e},c.push(f)}return c}t.consolidate=B;function C(...d){return B(d.reduce((c,f)=>c.concat(f),[]))}class D{constructor(){this.groups=[],this._size=0}splice(c,f,N=[]){const l=N.length-f,n=i({start:0,end:c},this.groups),e=i({start:c+f,end:Number.POSITIVE_INFINITY},this.groups).map(b=>({range:W(b.range,l),size:b.size})),g=N.map((b,w)=>({range:{start:c+w,end:c+w+1},size:b.size}));this.groups=C(n,g,e),this._size=this.groups.reduce((b,w)=>b+w.size*(w.range.end-w.range.start),0)}get count(){const c=this.groups.length;return c?this.groups[c-1].range.end:0}get size(){return this._size}indexAt(c){if(c<0)return-1;let f=0,N=0;for(const l of this.groups){const n=l.range.end-l.range.start,e=N+n*l.size;if(c<e)return f+Math.floor((c-N)/l.size);f+=n,N=e}return f}indexAfter(c){return Math.min(this.indexAt(c)+1,this.count)}positionAt(c){if(c<0)return-1;let f=0,N=0;for(const l of this.groups){const n=l.range.end-l.range.start,e=N+n;if(c<e)return f+(c-N)*l.size;f+=n*l.size,N=e}return-1}}t.RangeMap=D}),define(pe[79],be([1,0,9,2]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function W(u){const m=u;return m?typeof m.read=="function":!1}t.isReadable=W;function B(u){const m=u;return m?[m.on,m.pause,m.resume,m.destroy].every(S=>typeof S=="function"):!1}t.isReadableStream=B;function C(u){const m=u;return m?B(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}t.isReadableBufferedStream=C;function D(u,m){return new d(u,m)}t.newWriteableStream=D;class d{constructor(m,S){this.reducer=m,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m<"u"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(S=>S(m))}emitError(m){this.listeners.error.length===0?(0,y.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(S=>S(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,S){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(m,S){if(this.state.destroyed)return;let T;switch(m){case"data":T=this.listeners.data;break;case"end":T=this.listeners.end;break;case"error":T=this.listeners.error;break}if(T){const _=T.indexOf(S);_>=0&&T.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(T=>T())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(u,m){const S=[];let T;for(;(T=u.read())!==null;)S.push(T);return m(S)}t.consumeReadable=c;function f(u,m,S){const T=[];let _;for(;(_=u.read())!==null&&T.length<S;)T.push(_);return _===null&&T.length>0?m(T):{read:()=>{if(T.length>0)return T.shift();if(typeof _<"u"){const r=_;return _=void 0,r}return u.read()}}}t.peekReadable=f;function N(u,m){return new Promise((S,T)=>{const _=[];l(u,{onData:r=>{m&&_.push(r)},onError:r=>{m?T(r):S(void 0)},onEnd:()=>{S(m?m(_):void 0)}})})}t.consumeStream=N;function l(u,m){let S=!1;return u.on("error",T=>{S||m.onError(T)}),u.on("end",()=>{S||m.onEnd()}),u.on("data",T=>{S||m.onData(T)}),(0,i.toDisposable)(()=>S=!0)}t.listenStream=l;function n(u,m){return new Promise((S,T)=>{const _=new i.DisposableStore,r=[],v=p=>{if(r.push(p),r.length>m)return _.dispose(),u.pause(),S({stream:u,buffer:r,ended:!1})},o=p=>T(p),s=()=>S({stream:u,buffer:r,ended:!0});_.add((0,i.toDisposable)(()=>u.removeListener("error",o))),u.on("error",o),_.add((0,i.toDisposable)(()=>u.removeListener("end",s))),u.on("end",s),_.add((0,i.toDisposable)(()=>u.removeListener("data",v))),u.on("data",v)})}t.peekStream=n;function e(u,m){const S=D(m);return S.end(u),S}t.toStream=e;function g(){const u=D(()=>{throw new Error("not supported")});return u.end(),u}t.emptyStream=g;function b(u){let m=!1;return{read:()=>m?null:(m=!0,u)}}t.toReadable=b;function w(u,m,S){const T=D(S);return l(u,{onData:_=>T.write(m.data(_)),onError:_=>T.error(m.error?m.error(_):_),onEnd:()=>T.end()}),T}t.transform=w;function E(u,m,S){let T=!1;return{read:()=>{const _=m.read();return T?_:(T=!0,_!==null?S([u,_]):u)}}}t.prefixedReadable=E;function a(u,m,S){let T=!1;const _=D(S);return l(m,{onData:r=>T?_.write(r):(T=!0,_.write(S([u,r]))),onError:r=>_.error(r),onEnd:()=>{T||(T=!0,_.write(u)),_.end()}}),_}t.prefixedStream=a}),define(pe[31],be([1,0,79]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let W,B;class C{static alloc(p){return i?new C(Buffer.allocUnsafe(p)):new C(new Uint8Array(p))}static wrap(p){return i&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new C(p)}static fromString(p,L){return!(L?.dontUseNodeBuffer||!1)&&i?new C(Buffer.from(p)):(W||(W=new TextEncoder),new C(W.encode(p)))}static fromByteArray(p){const L=C.alloc(p.length);for(let V=0,X=p.length;V<X;V++)L.buffer[V]=p[V];return L}static concat(p,L){if(typeof L>"u"){L=0;for(let J=0,ge=p.length;J<ge;J++)L+=p[J].byteLength}const V=C.alloc(L);let X=0;for(let J=0,ge=p.length;J<ge;J++){const oe=p[J];V.set(oe,X),X+=oe.byteLength}return V}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=C.alloc(this.byteLength);return p.set(this),p}toString(){return i?this.buffer.toString():(B||(B=new TextDecoder),B.decode(this.buffer))}slice(p,L){return new C(this.buffer.subarray(p,L))}set(p,L){if(p instanceof C)this.buffer.set(p.buffer,L);else if(p instanceof Uint8Array)this.buffer.set(p,L);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),L);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return c(this.buffer,p)}writeUInt32BE(p,L){f(this.buffer,p,L)}readUInt32LE(p){return N(this.buffer,p)}writeUInt32LE(p,L){l(this.buffer,p,L)}readUInt8(p){return n(this.buffer,p)}writeUInt8(p,L){e(this.buffer,p,L)}}t.VSBuffer=C;function D(s,p){return s[p+0]<<0>>>0|s[p+1]<<8>>>0}t.readUInt16LE=D;function d(s,p,L){s[L+0]=p&255,p=p>>>8,s[L+1]=p&255}t.writeUInt16LE=d;function c(s,p){return s[p]*2**24+s[p+1]*2**16+s[p+2]*2**8+s[p+3]}t.readUInt32BE=c;function f(s,p,L){s[L+3]=p,p=p>>>8,s[L+2]=p,p=p>>>8,s[L+1]=p,p=p>>>8,s[L]=p}t.writeUInt32BE=f;function N(s,p){return s[p+0]<<0>>>0|s[p+1]<<8>>>0|s[p+2]<<16>>>0|s[p+3]<<24>>>0}t.readUInt32LE=N;function l(s,p,L){s[L+0]=p&255,p=p>>>8,s[L+1]=p&255,p=p>>>8,s[L+2]=p&255,p=p>>>8,s[L+3]=p&255}t.writeUInt32LE=l;function n(s,p){return s[p]}t.readUInt8=n;function e(s,p,L){s[L]=p}t.writeUInt8=e;function g(s){return y.consumeReadable(s,p=>C.concat(p))}t.readableToBuffer=g;function b(s){return y.toReadable(s)}t.bufferToReadable=b;function w(s){return y.consumeStream(s,p=>C.concat(p))}t.streamToBuffer=w;async function E(s){return s.ended?C.concat(s.buffer):C.concat([...s.buffer,await w(s.stream)])}t.bufferedStreamToBuffer=E;function a(s){return y.toStream(s,p=>C.concat(p))}t.bufferToStream=a;function u(s){return y.transform(s,{data:p=>typeof p=="string"?C.fromString(p):C.wrap(p)},p=>C.concat(p))}t.streamToBufferReadableStream=u;function m(s){return y.newWriteableStream(p=>C.concat(p),s)}t.newWriteableBufferStream=m;function S(s,p){return y.prefixedReadable(s,p,L=>C.concat(L))}t.prefixedBufferReadable=S;function T(s,p){return y.prefixedStream(s,p,L=>C.concat(L))}t.prefixedBufferStream=T;function _(s){let p=0,L=0,V=0;const X=new Uint8Array(Math.floor(s.length/4*3)),J=oe=>{switch(L){case 3:X[V++]=p|oe,L=0;break;case 2:X[V++]=p|oe>>>2,p=oe<<6,L=3;break;case 1:X[V++]=p|oe>>>4,p=oe<<4,L=2;break;default:p=oe<<2,L=1}};for(let oe=0;oe<s.length;oe++){const me=s.charCodeAt(oe);if(me>=65&&me<=90)J(me-65);else if(me>=97&&me<=122)J(me-97+26);else if(me>=48&&me<=57)J(me-48+52);else if(me===43||me===45)J(62);else if(me===47||me===95)J(63);else{if(me===61)break;throw new SyntaxError(`Unexpected base64 character ${s[oe]}`)}}const ge=V;for(;L>0;)J(0);return C.wrap(X).slice(0,ge)}t.decodeBase64=_;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:s},p=!0,L=!1){const V=L?v:r;let X="";const J=s.byteLength%3;let ge=0;for(;ge<s.byteLength-J;ge+=3){const oe=s[ge+0],me=s[ge+1],he=s[ge+2];X+=V[oe>>>2],X+=V[(oe<<4|me>>>4)&63],X+=V[(me<<2|he>>>6)&63],X+=V[he&63]}if(J===1){const oe=s[ge+0];X+=V[oe>>>2],X+=V[oe<<4&63],p&&(X+="==")}else if(J===2){const oe=s[ge+0],me=s[ge+1];X+=V[oe>>>2],X+=V[(oe<<4|me>>>4)&63],X+=V[me<<2&63],p&&(X+="=")}return X}t.encodeBase64=o}),define(pe[6],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function y(T){return typeof T=="string"}t.isString=y;function i(T){return Array.isArray(T)&&T.every(_=>y(_))}t.isStringArray=i;function W(T){return typeof T=="object"&&T!==null&&!Array.isArray(T)&&!(T instanceof RegExp)&&!(T instanceof Date)}t.isObject=W;function B(T){const _=Object.getPrototypeOf(Uint8Array);return typeof T=="object"&&T instanceof _}t.isTypedArray=B;function C(T){return typeof T=="number"&&!isNaN(T)}t.isNumber=C;function D(T){return!!T&&typeof T[Symbol.iterator]=="function"}t.isIterable=D;function d(T){return T===!0||T===!1}t.isBoolean=d;function c(T){return typeof T>"u"}t.isUndefined=c;function f(T){return!N(T)}t.isDefined=f;function N(T){return c(T)||T===null}t.isUndefinedOrNull=N;function l(T,_){if(!T)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}t.assertType=l;function n(T){if(N(T))throw new Error("Assertion Failed: argument is undefined or null");return T}t.assertIsDefined=n;function e(...T){const _=[];for(let r=0;r<T.length;r++){const v=T[r];if(N(v))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);_.push(v)}return _}t.assertAllDefined=e;const g=Object.prototype.hasOwnProperty;function b(T){if(!W(T))return!1;for(const _ in T)if(g.call(T,_))return!1;return!0}t.isEmptyObject=b;function w(T){return typeof T=="function"}t.isFunction=w;function E(...T){return T.length>0&&T.every(w)}t.areFunctions=E;function a(T,_){const r=Math.min(T.length,_.length);for(let v=0;v<r;v++)u(T[v],_[v])}t.validateConstraints=a;function u(T,_){if(y(_)){if(typeof T!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(T instanceof _)return}catch{}if(!N(T)&&T.constructor===_||_.length===1&&_.call(void 0,T)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=u;function m(T){return T===null?void 0:T}t.withNullAsUndefined=m;function S(T){return typeof T>"u"?null:T}t.withUndefinedAsNull=S}),define(pe[27],be([1,0,6]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const E=Array.isArray(w)?[]:{};return Object.keys(w).forEach(a=>{w[a]&&typeof w[a]=="object"?E[a]=i(w[a]):E[a]=w[a]}),E}t.deepClone=i;function W(w){if(!w||typeof w!="object")return w;const E=[w];for(;E.length>0;){const a=E.shift();Object.freeze(a);for(const u in a)if(B.call(a,u)){const m=a[u];typeof m=="object"&&!Object.isFrozen(m)&&!(0,y.isTypedArray)(m)&&E.push(m)}}return w}t.deepFreeze=W;const B=Object.prototype.hasOwnProperty;function C(w,E){return D(w,E,new Set)}t.cloneAndChange=C;function D(w,E,a){if((0,y.isUndefinedOrNull)(w))return w;const u=E(w);if(typeof u<"u")return u;if(Array.isArray(w)){const m=[];for(const S of w)m.push(D(S,E,a));return m}if((0,y.isObject)(w)){if(a.has(w))throw new Error("Cannot clone recursive data-structure");a.add(w);const m={};for(const S in w)B.call(w,S)&&(m[S]=D(w[S],E,a));return a.delete(w),m}return w}function d(w,E,a=!0){return(0,y.isObject)(w)?((0,y.isObject)(E)&&Object.keys(E).forEach(u=>{u in w?a&&((0,y.isObject)(w[u])&&(0,y.isObject)(E[u])?d(w[u],E[u],a):w[u]=E[u]):w[u]=E[u]}),w):E}t.mixin=d;function c(w,E){if(w===E)return!0;if(w==null||E===null||E===void 0||typeof w!=typeof E||typeof w!="object"||Array.isArray(w)!==Array.isArray(E))return!1;let a,u;if(Array.isArray(w)){if(w.length!==E.length)return!1;for(a=0;a<w.length;a++)if(!c(w[a],E[a]))return!1}else{const m=[];for(u in w)m.push(u);m.sort();const S=[];for(u in E)S.push(u);if(S.sort(),!c(m,S))return!1;for(a=0;a<m.length;a++)if(!c(w[m[a]],E[m[a]]))return!1}return!0}t.equals=c;function f(w){const E=new Set;return JSON.stringify(w,(a,u)=>{if((0,y.isObject)(u)||Array.isArray(u)){if(E.has(u))return"[Circular]";E.add(u)}return u})}t.safeStringify=f;function N(w,E){const a=Object.create(null);return!w||!E||Object.keys(E).forEach(m=>{const S=w[m],T=E[m];c(S,T)||(a[m]=T)}),a}t.distinct=N;function l(w,E){const a=E.toLowerCase(),u=Object.keys(w).find(m=>m.toLowerCase()===a);return u?w[u]:w[E]}t.getCaseInsensitive=l;function n(w,E){const a=Object.create(null);for(const[u,m]of Object.entries(w))E(u,m)&&(a[u]=m);return a}t.filter=n;function e(w){let E=[],a=Object.getPrototypeOf(w);for(;Object.prototype!==a;)E=E.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return E}t.getAllPropertyNames=e;function g(w){const E=[];for(const a of e(w))typeof w[a]=="function"&&E.push(a);return E}t.getAllMethodNames=g;function b(w,E){const a=m=>function(){const S=Array.prototype.slice.call(arguments,0);return E(m,S)},u={};for(const m of w)u[m]=a(m);return u}t.createProxyObject=b}),define(pe[80],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(pe[81],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class y{constructor(W,B){this.sender=W,this.onMessage=B}send(W){try{this.sender.send("vscode:message",W.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=y}),define(pe[47],be([7]),{}),define(pe[82],be([7]),{}),define(pe[83],be([7]),{}),define(pe[84],be([7]),{}),define(pe[85],be([1,0,12,83,84]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(W){let B=W.definition;for(;B instanceof y.Codicon;)B=B.definition;return`.codicon-${W.id}:before { content: '${B.fontCharacter}'; }`}t.formatRule=i}),define(pe[86],be([7]),{}),define(pe[87],be([7]),{}),define(pe[88],be([7]),{}),define(pe[89],be([7]),{}),define(pe[90],be([7]),{}),define(pe[91],be([7]),{}),define(pe[92],be([7]),{}),define(pe[93],be([7]),{}),define(pe[94],be([7]),{}),define(pe[95],be([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(pe[96],be([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInput",t)}),define(pe[97],be([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(pe[98],be([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(pe[99],be([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(pe[100],be([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(pe[101],be([13,10]),function(Q,t){return Q.create("vs/base/browser/ui/tree/abstractTree",t)}),define(pe[102],be([13,10]),function(Q,t){return Q.create("vs/base/common/actions",t)}),define(pe[103],be([13,10]),function(Q,t){return Q.create("vs/base/common/platform",t)}),define(pe[5],be([1,0,103]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let i=!1,W=!1,B=!1,C=!1,D=!1,d=!1,c=!1,f=!1,N=!1,l=!1,n,e=t.LANGUAGE_DEFAULT,g,b;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?w=t.globals.vscode.process:typeof process<"u"&&(w=process);const E=typeof w?.versions?.electron=="string",a=E&&w?.type==="renderer";if(typeof navigator=="object"&&!a)b=navigator.userAgent,i=b.indexOf("Windows")>=0,W=b.indexOf("Macintosh")>=0,f=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,B=b.indexOf("Linux")>=0,l=b?.indexOf("Mobi")>=0,d=!0,n=y.getConfiguredDefaultLocale(y.localize(0,null))||t.LANGUAGE_DEFAULT,e=n;else if(typeof w=="object"){i=w.platform==="win32",W=w.platform==="darwin",B=w.platform==="linux",C=B&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,c=E,N=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const s=w.env.VSCODE_NLS_CONFIG;if(s)try{const p=JSON.parse(s),L=p.availableLanguages["*"];n=p.locale,e=L||t.LANGUAGE_DEFAULT,g=p._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var u;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(u=t.Platform||(t.Platform={}));function m(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=m;let S=0;W?S=1:i?S=3:B&&(S=2),t.isWindows=i,t.isMacintosh=W,t.isLinux=B,t.isLinuxSnap=C,t.isNative=D,t.isElectron=c,t.isWeb=d,t.isWebWorker=d&&typeof t.globals.importScripts=="function",t.isIOS=f,t.isMobile=l,t.isCI=N,t.platform=S,t.userAgent=b,t.language=e;var T;(function(s){function p(){return t.language}s.value=p;function L(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}s.isDefaultVariant=L;function V(){return t.language==="en"}s.isDefault=V})(T=t.Language||(t.Language={})),t.locale=n,t.translationsConfigFile=g,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const s=[];t.globals.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let V=0,X=s.length;V<X;V++){const J=s[V];if(J.id===L.data.vscodeScheduleAsyncWork){s.splice(V,1),J.callback();return}}});let p=0;return L=>{const V=++p;s.push({id:V,callback:L}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return s=>setTimeout(s)})();var _;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(_=t.OperatingSystem||(t.OperatingSystem={})),t.OS=W||f?2:i?1:3;let r=!0,v=!1;function o(){if(!v){v=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,r=new Uint16Array(s.buffer)[0]===(2<<8)+1}return r}t.isLittleEndian=o,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(pe[104],be([1,0,5]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const W=y.globals.vscode.process;i={get platform(){return W.platform},get arch(){return W.arch},get env(){return W.env},cwd(){return W.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(pe[21],be([1,0,104]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,W=97,B=90,C=122,D=46,d=47,c=92,f=58,N=63;class l extends Error{constructor(u,m,S){let T;typeof m=="string"&&m.indexOf("not ")===0?(T="must not be",m=m.replace(/^not /,"")):T="must be";const _=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${_} ${T} of type ${m}`;r+=`. Received type ${typeof S}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function n(a,u){if(typeof a!="string")throw new l(u,"string",a)}function e(a){return a===d||a===c}function g(a){return a===d}function b(a){return a>=i&&a<=B||a>=W&&a<=C}function w(a,u,m,S){let T="",_=0,r=-1,v=0,o=0;for(let s=0;s<=a.length;++s){if(s<a.length)o=a.charCodeAt(s);else{if(S(o))break;o=d}if(S(o)){if(!(r===s-1||v===1))if(v===2){if(T.length<2||_!==2||T.charCodeAt(T.length-1)!==D||T.charCodeAt(T.length-2)!==D){if(T.length>2){const p=T.lastIndexOf(m);p===-1?(T="",_=0):(T=T.slice(0,p),_=T.length-1-T.lastIndexOf(m)),r=s,v=0;continue}else if(T.length!==0){T="",_=0,r=s,v=0;continue}}u&&(T+=T.length>0?`${m}..`:"..",_=2)}else T.length>0?T+=`${m}${a.slice(r+1,s)}`:T=a.slice(r+1,s),_=s-r-1;r=s,v=0}else o===D&&v!==-1?++v:v=-1}return T}function E(a,u){if(u===null||typeof u!="object")throw new l("pathObject","Object",u);const m=u.dir||u.root,S=u.base||`${u.name||""}${u.ext||""}`;return m?m===u.root?`${m}${S}`:`${m}${a}${S}`:S}t.win32={resolve(...a){let u="",m="",S=!1;for(let T=a.length-1;T>=-1;T--){let _;if(T>=0){if(_=a[T],n(_,"path"),_.length===0)continue}else u.length===0?_=y.cwd():(_=y.env[`=${u}`]||y.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==u.toLowerCase()&&_.charCodeAt(2)===c)&&(_=`${u}\\`));const r=_.length;let v=0,o="",s=!1;const p=_.charCodeAt(0);if(r===1)e(p)&&(v=1,s=!0);else if(e(p))if(s=!0,e(_.charCodeAt(1))){let L=2,V=L;for(;L<r&&!e(_.charCodeAt(L));)L++;if(L<r&&L!==V){const X=_.slice(V,L);for(V=L;L<r&&e(_.charCodeAt(L));)L++;if(L<r&&L!==V){for(V=L;L<r&&!e(_.charCodeAt(L));)L++;(L===r||L!==V)&&(o=`\\\\${X}\\${_.slice(V,L)}`,v=L)}}}else v=1;else b(p)&&_.charCodeAt(1)===f&&(o=_.slice(0,2),v=2,r>2&&e(_.charCodeAt(2))&&(s=!0,v=3));if(o.length>0)if(u.length>0){if(o.toLowerCase()!==u.toLowerCase())continue}else u=o;if(S){if(u.length>0)break}else if(m=`${_.slice(v)}\\${m}`,S=s,s&&u.length>0)break}return m=w(m,!S,"\\",e),S?`${u}\\${m}`:`${u}${m}`||"."},normalize(a){n(a,"path");const u=a.length;if(u===0)return".";let m=0,S,T=!1;const _=a.charCodeAt(0);if(u===1)return g(_)?"\\":a;if(e(_))if(T=!0,e(a.charCodeAt(1))){let v=2,o=v;for(;v<u&&!e(a.charCodeAt(v));)v++;if(v<u&&v!==o){const s=a.slice(o,v);for(o=v;v<u&&e(a.charCodeAt(v));)v++;if(v<u&&v!==o){for(o=v;v<u&&!e(a.charCodeAt(v));)v++;if(v===u)return`\\\\${s}\\${a.slice(o)}\\`;v!==o&&(S=`\\\\${s}\\${a.slice(o,v)}`,m=v)}}}else m=1;else b(_)&&a.charCodeAt(1)===f&&(S=a.slice(0,2),m=2,u>2&&e(a.charCodeAt(2))&&(T=!0,m=3));let r=m<u?w(a.slice(m),!T,"\\",e):"";return r.length===0&&!T&&(r="."),r.length>0&&e(a.charCodeAt(u-1))&&(r+="\\"),S===void 0?T?`\\${r}`:r:T?`${S}\\${r}`:`${S}${r}`},isAbsolute(a){n(a,"path");const u=a.length;if(u===0)return!1;const m=a.charCodeAt(0);return e(m)||u>2&&b(m)&&a.charCodeAt(1)===f&&e(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let u,m;for(let _=0;_<a.length;++_){const r=a[_];n(r,"path"),r.length>0&&(u===void 0?u=m=r:u+=`\\${r}`)}if(u===void 0)return".";let S=!0,T=0;if(typeof m=="string"&&e(m.charCodeAt(0))){++T;const _=m.length;_>1&&e(m.charCodeAt(1))&&(++T,_>2&&(e(m.charCodeAt(2))?++T:S=!1))}if(S){for(;T<u.length&&e(u.charCodeAt(T));)T++;T>=2&&(u=`\\${u.slice(T)}`)}return t.win32.normalize(u)},relative(a,u){if(n(a,"from"),n(u,"to"),a===u)return"";const m=t.win32.resolve(a),S=t.win32.resolve(u);if(m===S||(a=m.toLowerCase(),u=S.toLowerCase(),a===u))return"";let T=0;for(;T<a.length&&a.charCodeAt(T)===c;)T++;let _=a.length;for(;_-1>T&&a.charCodeAt(_-1)===c;)_--;const r=_-T;let v=0;for(;v<u.length&&u.charCodeAt(v)===c;)v++;let o=u.length;for(;o-1>v&&u.charCodeAt(o-1)===c;)o--;const s=o-v,p=r<s?r:s;let L=-1,V=0;for(;V<p;V++){const J=a.charCodeAt(T+V);if(J!==u.charCodeAt(v+V))break;J===c&&(L=V)}if(V!==p){if(L===-1)return S}else{if(s>p){if(u.charCodeAt(v+V)===c)return S.slice(v+V+1);if(V===2)return S.slice(v+V)}r>p&&(a.charCodeAt(T+V)===c?L=V:V===2&&(L=3)),L===-1&&(L=0)}let X="";for(V=T+L+1;V<=_;++V)(V===_||a.charCodeAt(V)===c)&&(X+=X.length===0?"..":"\\..");return v+=L,X.length>0?`${X}${S.slice(v,o)}`:(S.charCodeAt(v)===c&&++v,S.slice(v,o))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const u=t.win32.resolve(a);if(u.length<=2)return a;if(u.charCodeAt(0)===c){if(u.charCodeAt(1)===c){const m=u.charCodeAt(2);if(m!==N&&m!==D)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(b(u.charCodeAt(0))&&u.charCodeAt(1)===f&&u.charCodeAt(2)===c)return`\\\\?\\${u}`;return a},dirname(a){n(a,"path");const u=a.length;if(u===0)return".";let m=-1,S=0;const T=a.charCodeAt(0);if(u===1)return e(T)?a:".";if(e(T)){if(m=S=1,e(a.charCodeAt(1))){let v=2,o=v;for(;v<u&&!e(a.charCodeAt(v));)v++;if(v<u&&v!==o){for(o=v;v<u&&e(a.charCodeAt(v));)v++;if(v<u&&v!==o){for(o=v;v<u&&!e(a.charCodeAt(v));)v++;if(v===u)return a;v!==o&&(m=S=v+1)}}}}else b(T)&&a.charCodeAt(1)===f&&(m=u>2&&e(a.charCodeAt(2))?3:2,S=m);let _=-1,r=!0;for(let v=u-1;v>=S;--v)if(e(a.charCodeAt(v))){if(!r){_=v;break}}else r=!1;if(_===-1){if(m===-1)return".";_=m}return a.slice(0,_)},basename(a,u){u!==void 0&&n(u,"ext"),n(a,"path");let m=0,S=-1,T=!0,_;if(a.length>=2&&b(a.charCodeAt(0))&&a.charCodeAt(1)===f&&(m=2),u!==void 0&&u.length>0&&u.length<=a.length){if(u===a)return"";let r=u.length-1,v=-1;for(_=a.length-1;_>=m;--_){const o=a.charCodeAt(_);if(e(o)){if(!T){m=_+1;break}}else v===-1&&(T=!1,v=_+1),r>=0&&(o===u.charCodeAt(r)?--r===-1&&(S=_):(r=-1,S=v))}return m===S?S=v:S===-1&&(S=a.length),a.slice(m,S)}for(_=a.length-1;_>=m;--_)if(e(a.charCodeAt(_))){if(!T){m=_+1;break}}else S===-1&&(T=!1,S=_+1);return S===-1?"":a.slice(m,S)},extname(a){n(a,"path");let u=0,m=-1,S=0,T=-1,_=!0,r=0;a.length>=2&&a.charCodeAt(1)===f&&b(a.charCodeAt(0))&&(u=S=2);for(let v=a.length-1;v>=u;--v){const o=a.charCodeAt(v);if(e(o)){if(!_){S=v+1;break}continue}T===-1&&(_=!1,T=v+1),o===D?m===-1?m=v:r!==1&&(r=1):m!==-1&&(r=-1)}return m===-1||T===-1||r===0||r===1&&m===T-1&&m===S+1?"":a.slice(m,T)},format:E.bind(null,"\\"),parse(a){n(a,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return u;const m=a.length;let S=0,T=a.charCodeAt(0);if(m===1)return e(T)?(u.root=u.dir=a,u):(u.base=u.name=a,u);if(e(T)){if(S=1,e(a.charCodeAt(1))){let L=2,V=L;for(;L<m&&!e(a.charCodeAt(L));)L++;if(L<m&&L!==V){for(V=L;L<m&&e(a.charCodeAt(L));)L++;if(L<m&&L!==V){for(V=L;L<m&&!e(a.charCodeAt(L));)L++;L===m?S=L:L!==V&&(S=L+1)}}}}else if(b(T)&&a.charCodeAt(1)===f){if(m<=2)return u.root=u.dir=a,u;if(S=2,e(a.charCodeAt(2))){if(m===3)return u.root=u.dir=a,u;S=3}}S>0&&(u.root=a.slice(0,S));let _=-1,r=S,v=-1,o=!0,s=a.length-1,p=0;for(;s>=S;--s){if(T=a.charCodeAt(s),e(T)){if(!o){r=s+1;break}continue}v===-1&&(o=!1,v=s+1),T===D?_===-1?_=s:p!==1&&(p=1):_!==-1&&(p=-1)}return v!==-1&&(_===-1||p===0||p===1&&_===v-1&&_===r+1?u.base=u.name=a.slice(r,v):(u.name=a.slice(r,_),u.base=a.slice(r,v),u.ext=a.slice(_,v))),r>0&&r!==S?u.dir=a.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...a){let u="",m=!1;for(let S=a.length-1;S>=-1&&!m;S--){const T=S>=0?a[S]:y.cwd();n(T,"path"),T.length!==0&&(u=`${T}/${u}`,m=T.charCodeAt(0)===d)}return u=w(u,!m,"/",g),m?`/${u}`:u.length>0?u:"."},normalize(a){if(n(a,"path"),a.length===0)return".";const u=a.charCodeAt(0)===d,m=a.charCodeAt(a.length-1)===d;return a=w(a,!u,"/",g),a.length===0?u?"/":m?"./":".":(m&&(a+="/"),u?`/${a}`:a)},isAbsolute(a){return n(a,"path"),a.length>0&&a.charCodeAt(0)===d},join(...a){if(a.length===0)return".";let u;for(let m=0;m<a.length;++m){const S=a[m];n(S,"path"),S.length>0&&(u===void 0?u=S:u+=`/${S}`)}return u===void 0?".":t.posix.normalize(u)},relative(a,u){if(n(a,"from"),n(u,"to"),a===u||(a=t.posix.resolve(a),u=t.posix.resolve(u),a===u))return"";const m=1,S=a.length,T=S-m,_=1,r=u.length-_,v=T<r?T:r;let o=-1,s=0;for(;s<v;s++){const L=a.charCodeAt(m+s);if(L!==u.charCodeAt(_+s))break;L===d&&(o=s)}if(s===v)if(r>v){if(u.charCodeAt(_+s)===d)return u.slice(_+s+1);if(s===0)return u.slice(_+s)}else T>v&&(a.charCodeAt(m+s)===d?o=s:s===0&&(o=0));let p="";for(s=m+o+1;s<=S;++s)(s===S||a.charCodeAt(s)===d)&&(p+=p.length===0?"..":"/..");return`${p}${u.slice(_+o)}`},toNamespacedPath(a){return a},dirname(a){if(n(a,"path"),a.length===0)return".";const u=a.charCodeAt(0)===d;let m=-1,S=!0;for(let T=a.length-1;T>=1;--T)if(a.charCodeAt(T)===d){if(!S){m=T;break}}else S=!1;return m===-1?u?"/":".":u&&m===1?"//":a.slice(0,m)},basename(a,u){u!==void 0&&n(u,"ext"),n(a,"path");let m=0,S=-1,T=!0,_;if(u!==void 0&&u.length>0&&u.length<=a.length){if(u===a)return"";let r=u.length-1,v=-1;for(_=a.length-1;_>=0;--_){const o=a.charCodeAt(_);if(o===d){if(!T){m=_+1;break}}else v===-1&&(T=!1,v=_+1),r>=0&&(o===u.charCodeAt(r)?--r===-1&&(S=_):(r=-1,S=v))}return m===S?S=v:S===-1&&(S=a.length),a.slice(m,S)}for(_=a.length-1;_>=0;--_)if(a.charCodeAt(_)===d){if(!T){m=_+1;break}}else S===-1&&(T=!1,S=_+1);return S===-1?"":a.slice(m,S)},extname(a){n(a,"path");let u=-1,m=0,S=-1,T=!0,_=0;for(let r=a.length-1;r>=0;--r){const v=a.charCodeAt(r);if(v===d){if(!T){m=r+1;break}continue}S===-1&&(T=!1,S=r+1),v===D?u===-1?u=r:_!==1&&(_=1):u!==-1&&(_=-1)}return u===-1||S===-1||_===0||_===1&&u===S-1&&u===m+1?"":a.slice(u,S)},format:E.bind(null,"/"),parse(a){n(a,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return u;const m=a.charCodeAt(0)===d;let S;m?(u.root="/",S=1):S=0;let T=-1,_=0,r=-1,v=!0,o=a.length-1,s=0;for(;o>=S;--o){const p=a.charCodeAt(o);if(p===d){if(!v){_=o+1;break}continue}r===-1&&(v=!1,r=o+1),p===D?T===-1?T=o:s!==1&&(s=1):T!==-1&&(s=-1)}if(r!==-1){const p=_===0&&m?1:_;T===-1||s===0||s===1&&T===r-1&&T===_+1?u.base=u.name=a.slice(p,r):(u.name=a.slice(p,T),u.base=a.slice(p,r),u.ext=a.slice(T,r))}return _>0?u.dir=a.slice(0,_-1):m&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=y.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=y.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=y.platform==="win32"?t.win32.join:t.posix.join,t.resolve=y.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=y.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=y.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=y.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=y.platform==="win32"?t.win32.extname:t.posix.extname,t.format=y.platform==="win32"?t.win32.format:t.posix.format,t.parse=y.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=y.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=y.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=y.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(pe[105],be([1,0,21]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},W={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function B(f){const N=(0,y.extname)(f),l=i[N.toLowerCase()];return l!==void 0?l:C(f)}t.getMediaOrTextMime=B;function C(f){const N=(0,y.extname)(f);return W[N.toLowerCase()]}t.getMediaMime=C;function D(f){for(const N in W)if(W[N]===f)return N}t.getExtensionForMimeType=D;const d=/^(.+)\/(.+?)(;.+)?$/;function c(f,N){const l=d.exec(f);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:N?void 0:f}t.normalizeMimeType=c}),define(pe[106],be([1,0,5]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=y.globals.performance&&typeof y.globals.performance.now=="function";class W{static create(C=!0){return new W(C)}constructor(C){this._highResolution=i&&C,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?y.globals.performance.now():Date.now()}}t.StopWatch=W}),define(pe[3],be([1,0,9,42,2,74,106]),function(Q,t,y,i,W,B,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const D=!1,d=!1;var c;(function(o){o.None=()=>W.Disposable.None;function s(h){if(d){const{onListenerDidAdd:I}=h,U=e.create();let K=0;h.onListenerDidAdd=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),I?.()}}}function p(h){return(I,U=null,K)=>{let Z=!1,k;return k=h(M=>{if(!Z)return k?k.dispose():Z=!0,I.call(U,M)},null,K),Z&&k.dispose(),k}}o.once=p;function L(h,I,U){return me((K,Z=null,k)=>h(M=>K.call(Z,I(M)),null,k),U)}o.map=L;function V(h,I,U){return me((K,Z=null,k)=>h(M=>{I(M),K.call(Z,M)},null,k),U)}o.forEach=V;function X(h,I,U){return me((K,Z=null,k)=>h(M=>I(M)&&K.call(Z,M),null,k),U)}o.filter=X;function J(h){return h}o.signal=J;function ge(...h){return(I,U=null,K)=>(0,W.combinedDisposable)(...h.map(Z=>Z(k=>I.call(U,k),null,K)))}o.any=ge;function oe(h,I,U,K){let Z=U;return L(h,k=>(Z=I(Z,k),Z),K)}o.reduce=oe;function me(h,I){let U;const K={onFirstListenerAdd(){U=h(Z.fire,Z)},onLastListenerRemove(){U?.dispose()}};I||s(K);const Z=new b(K);return I?.add(Z),Z.event}function he(h,I,U=100,K=!1,Z,k){let M,z,A,R=0;const O={leakWarningThreshold:Z,onFirstListenerAdd(){M=h(q=>{R++,z=I(z,q),K&&!A&&(H.fire(z),z=void 0),clearTimeout(A),A=setTimeout(()=>{const ee=z;z=void 0,A=void 0,(!K||R>1)&&H.fire(ee),R=0},U)})},onLastListenerRemove(){M.dispose()}};k||s(O);const H=new b(O);return k?.add(H),H.event}o.debounce=he;function ae(h,I=(K,Z)=>K===Z,U){let K=!0,Z;return X(h,k=>{const M=K||!I(k,Z);return K=!1,Z=k,M},U)}o.latch=ae;function Se(h,I,U){return[o.filter(h,I,U),o.filter(h,K=>!I(K),U)]}o.split=Se;function te(h,I=!1,U=[]){let K=U.slice(),Z=h(z=>{K?K.push(z):M.fire(z)});const k=()=>{K?.forEach(z=>M.fire(z)),K=null},M=new b({onFirstListenerAdd(){Z||(Z=h(z=>M.fire(z)))},onFirstListenerDidAdd(){K&&(I?setTimeout(k):k())},onLastListenerRemove(){Z&&Z.dispose(),Z=null}});return M.event}o.buffer=te;class De{constructor(I){this.event=I,this.disposables=new W.DisposableStore}map(I){return new De(L(this.event,I,this.disposables))}forEach(I){return new De(V(this.event,I,this.disposables))}filter(I){return new De(X(this.event,I,this.disposables))}reduce(I,U){return new De(oe(this.event,I,U,this.disposables))}latch(){return new De(ae(this.event,void 0,this.disposables))}debounce(I,U=100,K=!1,Z){return new De(he(this.event,I,U,K,Z,this.disposables))}on(I,U,K){return this.event(I,U,K)}once(I,U,K){return p(this.event)(I,U,K)}dispose(){this.disposables.dispose()}}function se(h){return new De(h)}o.chain=se;function ie(h,I,U=K=>K){const K=(...z)=>M.fire(U(...z)),Z=()=>h.on(I,K),k=()=>h.removeListener(I,K),M=new b({onFirstListenerAdd:Z,onLastListenerRemove:k});return M.event}o.fromNodeEventEmitter=ie;function ce(h,I,U=K=>K){const K=(...z)=>M.fire(U(...z)),Z=()=>h.addEventListener(I,K),k=()=>h.removeEventListener(I,K),M=new b({onFirstListenerAdd:Z,onLastListenerRemove:k});return M.event}o.fromDOMEventEmitter=ce;function ne(h){return new Promise(I=>p(h)(I))}o.toPromise=ne;function F(h,I){return I(void 0),h(U=>I(U))}o.runAndSubscribe=F;function $(h,I){let U=null;function K(k){U?.dispose(),U=new W.DisposableStore,I(k,U)}K(void 0);const Z=h(k=>K(k));return(0,W.toDisposable)(()=>{Z.dispose(),U?.dispose()})}o.runAndSubscribeWithStore=$;class j{constructor(I,U){this.obs=I,this._counter=0,this._hasChanged=!1;const K={onFirstListenerAdd:()=>{I.addObserver(this)},onLastListenerRemove:()=>{I.removeObserver(this)}};U||s(K),this.emitter=new b(K),U&&U.add(this.emitter)}beginUpdate(I){this._counter++}handleChange(I,U){this._hasChanged=!0}endUpdate(I){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function P(h,I){return new j(h,I).emitter.event}o.fromObservable=P})(c=t.Event||(t.Event={}));class f{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${f._idPool++}`,f.all.add(this)}start(s){this._stopWatch=new C.StopWatch(!0),this.listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=f,f.all=new Set,f._idPool=0;let N=-1;function l(o){const s=N;return N=o,{dispose(){N=s}}}t.setGlobalLeakWarningThreshold=l;class n{constructor(s,p=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s,p){let L=N;if(typeof this.customThreshold=="number"&&(L=this.customThreshold),L<=0||p<L)return;this._stacks||(this._stacks=new Map);const V=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,V+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=L*.5;let X,J=0;for(const[ge,oe]of this._stacks)(!X||J<oe)&&(X=ge,J=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${J}):`),console.warn(X)}return()=>{const X=this._stacks.get(s.value)||0;this._stacks.set(s.value,X-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(s,p,L){this.callback=s,this.callbackThis=p,this.stack=L,this.subscription=new W.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class b{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=N>0?new n(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(D){const s=Array.from(this._listeners);queueMicrotask(()=>{for(const p of s)p.subscription.isset()&&(p.subscription.unset(),p.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(s,p,L)=>{this._listeners||(this._listeners=new B.LinkedList);const V=this._listeners.isEmpty();V&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let X,J;this._leakageMon&&this._listeners.size>=30&&(J=e.create(),X=this._leakageMon.check(J,this._listeners.size+1)),D&&(J=J??e.create());const ge=new g(s,p,J),oe=this._listeners.push(ge);V&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,p);const me=ge.subscription.set(()=>{X?.(),this._disposed||(oe(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return L instanceof W.DisposableStore?L.add(me):Array.isArray(L)&&L.push(me),me}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E);for(const p of this._listeners)this._deliveryQueue.push(this,p,s);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=b;class w{constructor(){this._queue=new B.LinkedList}get size(){return this._queue.size}push(s,p,L){this._queue.push(new a(s,p,L))}clear(s){const p=new B.LinkedList;for(const L of this._queue)L.emitter!==s&&p.push(L);this._queue=p}deliver(){for(;this._queue.size>0;){const s=this._queue.shift();try{s.listener.invoke(s.event)}catch(p){(0,y.onUnexpectedError)(p)}}}}t.EventDeliveryQueue=w;class E extends w{clear(s){this._queue.clear()}}class a{constructor(s,p,L){this.emitter=s,this.listener=p,this.event=L}}class u extends b{async fireAsync(s,p,L){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new B.LinkedList);for(const V of this._listeners)this._asyncDeliveryQueue.push([V,s]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[V,X]=this._asyncDeliveryQueue.shift(),J=[],ge={...X,token:p,waitUntil:oe=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");L&&(oe=L(oe,V.callback)),J.push(oe)}};try{V.invoke(ge)}catch(oe){(0,y.onUnexpectedError)(oe);continue}Object.freeze(J),await Promise.allSettled(J).then(oe=>{for(const me of oe)me.status==="rejected"&&(0,y.onUnexpectedError)(me.reason)})}}}}t.AsyncEmitter=u;class m extends b{constructor(s){super(s),this._isPaused=0,this._eventQueue=new B.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}t.PauseableEmitter=m;class S extends m{constructor(s){super(s),this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}t.DebounceEmitter=S;class T extends b{constructor(s){super(s),this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){!this.hasListeners()||(this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(p=>super.fire(p)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=T;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const p={event:s,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const L=()=>{this.hasListeners&&this.unhook(p);const V=this.events.indexOf(p);this.events.splice(V,1)};return(0,W.toDisposable)((0,i.once)(L))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(p=>this.emitter.fire(p))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=_;class r{constructor(){this.buffers=[]}wrapEvent(s){return(p,L,V)=>s(X=>{const J=this.buffers[this.buffers.length-1];J?J.push(()=>p.call(L,X)):p.call(L,X)},void 0,V)}bufferEvents(s){const p=[];this.buffers.push(p);const L=s();return this.buffers.pop(),p.forEach(V=>V()),L}}t.EventBufferer=r;class v{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=W.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=v}),define(pe[15],be([1,0,3,2]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class W{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new y.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(a,u){this._zoomLevel!==a&&(this._zoomLevel=a)}getZoomFactor(){return this._zoomFactor}setZoomFactor(a){this._zoomFactor=a}setFullscreen(a){this._fullscreen!==a&&(this._fullscreen=a,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}W.INSTANCE=new W;class B extends i.Disposable{constructor(){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(a){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),a&&this._onDidChange.fire()}}class C extends i.Disposable{get value(){return this._value}constructor(){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const a=this._register(new B);this._register(a.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}_getPixelRatio(){const a=document.createElement("canvas").getContext("2d"),u=window.devicePixelRatio||1,m=a.webkitBackingStorePixelRatio||a.mozBackingStorePixelRatio||a.msBackingStorePixelRatio||a.oBackingStorePixelRatio||a.backingStorePixelRatio||1;return u/m}}class D{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,i.markAsSingleton)(new C)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function d(E,a){typeof E=="string"&&(E=window.matchMedia(E)),E.addEventListener("change",a)}t.addMatchMediaChangeListener=d,t.PixelRatio=new D;function c(E,a){W.INSTANCE.setZoomLevel(E,a)}t.setZoomLevel=c;function f(){return W.INSTANCE.getZoomLevel()}t.getZoomLevel=f;function N(){return W.INSTANCE.getZoomFactor()}t.getZoomFactor=N;function l(E){W.INSTANCE.setZoomFactor(E)}t.setZoomFactor=l;function n(E){W.INSTANCE.setFullscreen(E)}t.setFullscreen=n;function e(){return W.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=W.INSTANCE.onDidChangeFullscreen;const g=navigator.userAgent;t.isFirefox=g.indexOf("Firefox")>=0,t.isWebKit=g.indexOf("AppleWebKit")>=0,t.isChrome=g.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&g.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=g.indexOf("Electron/")>=0,t.isAndroid=g.indexOf("Android")>=0;let b=!1;if(window.matchMedia){const E=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),a=window.matchMedia("(display-mode: fullscreen)");b=E.matches,d(E,({matches:u})=>{b&&a.matches||(b=u)})}function w(){return b}t.isStandalone=w}),define(pe[107],be([1,0,15,5]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var W;(function(B){B[B.Always=0]="Always",B[B.FullScreen=1]="FullScreen",B[B.None=2]="None"})(W=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||y.isStandalone()?0:navigator.keyboard||y.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(pe[18],be([1,0,3]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{get event(){return this.emitter.event}constructor(B,C,D){const d=c=>this.emitter.fire(c);this.emitter=new y.Emitter({onFirstListenerAdd:()=>B.addEventListener(C,d,D),onLastListenerRemove:()=>B.removeEventListener(C,d,D)})}dispose(){this.emitter.dispose()}}t.DomEmitter=i}),define(pe[19],be([1,0,15,43,73,5]),function(Q,t,y,i,W,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function C(e){if(e.charCode){const b=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(b)}const g=e.keyCode;if(g===3)return 7;if(y.isFirefox){if(g===59)return 80;if(g===107)return 81;if(g===109)return 83;if(B.isMacintosh&&g===224)return 57}else if(y.isWebKit){if(g===91)return 57;if(B.isMacintosh&&g===93)return 57;if(!B.isMacintosh&&g===92)return 57}return i.EVENT_KEY_CODE_MAP[g]||0}const D=B.isMacintosh?256:2048,d=512,c=1024,f=B.isMacintosh?2048:256;function N(e){const g=[];return e.ctrlKey&&g.push("ctrl"),e.shiftKey&&g.push("shift"),e.altKey&&g.push("alt"),e.metaKey&&g.push("meta"),`modifiers: [${g.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=N;function l(e){const g=[];return e.ctrlKey&&g.push("ctrl"),e.shiftKey&&g.push("shift"),e.altKey&&g.push("alt"),e.metaKey&&g.push("meta"),`modifiers: [${g.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=l;class n{constructor(g){this._standardKeyboardEventBrand=!0;const b=g;this.browserEvent=b,this.target=b.target,this.ctrlKey=b.ctrlKey,this.shiftKey=b.shiftKey,this.altKey=b.altKey,this.metaKey=b.metaKey,this.keyCode=C(b),this.code=b.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this._asRuntimeKeybinding}equals(g){return this._asKeybinding===g}_computeKeybinding(){let g=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(g=this.keyCode);let b=0;return this.ctrlKey&&(b|=D),this.altKey&&(b|=d),this.shiftKey&&(b|=c),this.metaKey&&(b|=f),b|=g,b}_computeRuntimeKeybinding(){let g=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(g=this.keyCode),new W.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,g)}}t.StandardKeyboardEvent=n}),define(pe[20],be([1,0,15,66,5]),function(Q,t,y,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class B{constructor(c){this.timestamp=Date.now(),this.browserEvent=c,this.leftButton=c.button===0,this.middleButton=c.button===1,this.rightButton=c.button===2,this.buttons=c.buttons,this.target=c.target,this.detail=c.detail||1,c.type==="dblclick"&&(this.detail=2),this.ctrlKey=c.ctrlKey,this.shiftKey=c.shiftKey,this.altKey=c.altKey,this.metaKey=c.metaKey,typeof c.pageX=="number"?(this.posx=c.pageX,this.posy=c.pageY):(this.posx=c.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=c.clientY+document.body.scrollTop+document.documentElement.scrollTop);const f=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,c.view);this.posx-=f.left,this.posy-=f.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=B;class C extends B{constructor(c){super(c),this.dataTransfer=c.dataTransfer}}t.DragMouseEvent=C;class D{constructor(c,f=0,N=0){if(this.browserEvent=c||null,this.target=c?c.target||c.targetNode||c.srcElement:null,this.deltaY=N,this.deltaX=f,c){const l=c,n=c;if(typeof l.wheelDeltaY<"u")this.deltaY=l.wheelDeltaY/120;else if(typeof n.VERTICAL_AXIS<"u"&&n.axis===n.VERTICAL_AXIS)this.deltaY=-n.detail/3;else if(c.type==="wheel"){const e=c;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!W.isMacintosh?this.deltaY=-c.deltaY/3:this.deltaY=-c.deltaY:this.deltaY=-c.deltaY/40}if(typeof l.wheelDeltaX<"u")y.isSafari&&W.isWindows?this.deltaX=-(l.wheelDeltaX/120):this.deltaX=l.wheelDeltaX/120;else if(typeof n.HORIZONTAL_AXIS<"u"&&n.axis===n.HORIZONTAL_AXIS)this.deltaX=-c.detail/3;else if(c.type==="wheel"){const e=c;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!W.isMacintosh?this.deltaX=-c.deltaX/3:this.deltaX=-c.deltaX:this.deltaX=-c.deltaX/40}this.deltaY===0&&this.deltaX===0&&c.wheelDelta&&(this.deltaY=c.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=D}),define(pe[32],be([1,0,3,2,102]),function(Q,t,y,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class B extends i.Disposable{constructor(l,n="",e="",g=!0,b){super(),this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=l,this._label=n,this._cssClass=e,this._enabled=g,this._actionCallback=b}get id(){return this._id}get label(){return this._label}set label(l){this._setLabel(l)}_setLabel(l){this._label!==l&&(this._label=l,this._onDidChange.fire({label:l}))}get tooltip(){return this._tooltip||""}set tooltip(l){this._setTooltip(l)}_setTooltip(l){this._tooltip!==l&&(this._tooltip=l,this._onDidChange.fire({tooltip:l}))}get class(){return this._cssClass}set class(l){this._setClass(l)}_setClass(l){this._cssClass!==l&&(this._cssClass=l,this._onDidChange.fire({class:l}))}get enabled(){return this._enabled}set enabled(l){this._setEnabled(l)}_setEnabled(l){this._enabled!==l&&(this._enabled=l,this._onDidChange.fire({enabled:l}))}get checked(){return this._checked}set checked(l){this._setChecked(l)}_setChecked(l){this._checked!==l&&(this._checked=l,this._onDidChange.fire({checked:l}))}async run(l,n){this._actionCallback&&await this._actionCallback(l)}}t.Action=B;class C extends i.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new y.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new y.Emitter),this.onDidRun=this._onDidRun.event}async run(l,n){if(!l.enabled)return;this._onWillRun.fire({action:l});let e;try{await this.runAction(l,n)}catch(g){e=g}this._onDidRun.fire({action:l,error:e})}async runAction(l,n){await l.run(n)}}t.ActionRunner=C;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let n=[];for(const e of l)e.length&&(n.length?n=[...n,new D,...e]:n=e);return n}async run(){}}t.Separator=D,D.ID="vs.actions.separator";class d{get actions(){return this._actions}constructor(l,n,e,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=n,this.class=g,this._actions=e}async run(){}}t.SubmenuAction=d;class c extends B{constructor(){super(c.ID,W.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=c,c.ID="vs.actions.empty";function f(N){return{id:N.id,label:N.label,class:void 0,enabled:N.enabled??!0,checked:N.checked??!1,run:async()=>N.run(),tooltip:N.label}}t.toAction=f}),define(pe[28],be([1,0,3]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(D,d){const c=setTimeout(D.bind(d),0);return{dispose(){clearTimeout(c)}}});var W;(function(D){function d(c){return c===D.None||c===D.Cancelled||c instanceof B?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}D.isCancellationToken=d,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(W=t.CancellationToken||(t.CancellationToken={}));class B{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new B),this._token}cancel(){this._token?this._token instanceof B&&this._token.cancel():this._token=W.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof B&&this._token.dispose():this._token=W.None}}t.CancellationTokenSource=C}),define(pe[108],be([1,0,28]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(D){this.task=D,this.result=null}get(){if(this.result)return this.result;const D=new y.CancellationTokenSource,d=this.task(D.token);return this.result={promise:d,dispose:()=>{this.result=null,D.cancel(),D.dispose()}},this.result}}t.Cache=i;class W{constructor(D){this.fn=D,this.lastCache=void 0,this.lastArgKey=void 0}get(D){const d=JSON.stringify(D);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.fn(D)),this.lastCache}}t.LRUCachedFunction=W;class B{get cachedValues(){return this._map}constructor(D){this.fn=D,this._map=new Map}get(D){if(this._map.has(D))return this._map.get(D);const d=this.fn(D);return this._map.set(D,d),d}}t.CachedFunction=B}),define(pe[48],be([1,0,3,2]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var W;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(W=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class B{constructor(e,g,b,w,E,a,u){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(g=g|0,b=b|0,w=w|0,E=E|0,a=a|0,u=u|0),this.rawScrollLeft=w,this.rawScrollTop=u,g<0&&(g=0),w+g>b&&(w=b-g),w<0&&(w=0),E<0&&(E=0),u+E>a&&(u=a-E),u<0&&(u=0),this.width=g,this.scrollWidth=b,this.scrollLeft=w,this.height=E,this.scrollHeight=a,this.scrollTop=u}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,g){return new B(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,g?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,g?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new B(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,g){const b=this.width!==e.width,w=this.scrollWidth!==e.scrollWidth,E=this.scrollLeft!==e.scrollLeft,a=this.height!==e.height,u=this.scrollHeight!==e.scrollHeight,m=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:g,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:b,scrollWidthChanged:w,scrollLeftChanged:E,heightChanged:a,scrollHeightChanged:u,scrollTopChanged:m}}}t.ScrollState=B;class C extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new y.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new B(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,g){const b=this._state.withScrollDimensions(e,g);this._setState(b,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const g=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(g,!1)}setScrollPositionSmooth(e,g){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const b=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===b.scrollLeft&&this._smoothScrolling.to.scrollTop===b.scrollTop)return;let w;g?w=new f(this._smoothScrolling.from,b,this._smoothScrolling.startTime,this._smoothScrolling.duration):w=this._smoothScrolling.combine(this._state,b,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=w}else{const b=this._state.withScrollPosition(e);this._smoothScrolling=f.start(this._state,b,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),g=this._state.withScrollPosition(e);if(this._setState(g,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,g){const b=this._state;b.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(b,g)))}}t.Scrollable=C;class D{constructor(e,g,b){this.scrollLeft=e,this.scrollTop=g,this.isDone=b}}t.SmoothScrollingUpdate=D;function d(n,e){const g=e-n;return function(b){return n+g*l(b)}}function c(n,e,g){return function(b){return b<g?n(b/g):e((b-g)/(1-g))}}class f{constructor(e,g,b,w){this.from=e,this.to=g,this.duration=w,this.startTime=b,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,g,b){if(Math.abs(e-g)>2.5*b){let E,a;return e<g?(E=e+.75*b,a=g-.75*b):(E=e-.75*b,a=g+.75*b),c(d(e,E),d(a,g),.33)}return d(e,g)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const g=(e-this.startTime)/this.duration;if(g<1){const b=this.scrollLeft(g),w=this.scrollTop(g);return new D(b,w,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,g,b){return f.start(e,g,b)}static start(e,g,b){b=b+10;const w=Date.now()-10;return new f(e,g,w,b)}}t.SmoothScrollingOperation=f;function N(n){return Math.pow(n,3)}function l(n){return 1-N(1-n)}}),define(pe[11],be([1,0,108,44]),function(Q,t,y,i){"use strict";var W;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function B(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.isFalsyOrWhitespace=B;const C=/{(\d+)}/g;function D(x,...le){return le.length===0?x:x.replace(C,function(we,Ce){const Ie=parseInt(Ce,10);return isNaN(Ie)||Ie<0||Ie>=le.length?we:le[Ie]})}t.format=D;const d=/{([^}]+)}/g;function c(x,le){return x.replace(d,(we,Ce)=>le[Ce]??we)}t.format2=c;function f(x){return x.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.escape=f;function N(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=N;function l(x,le){let we=0;const Ce=le.charCodeAt(0);for(let Ie=x.length-1;Ie>=0;Ie--)x.charCodeAt(Ie)===Ce&&we++;return we}t.count=l;function n(x,le,we="\u2026"){return x.length<=le?x:`${x.substr(0,le)}${we}`}t.truncate=n;function e(x,le=" "){const we=g(x,le);return b(we,le)}t.trim=e;function g(x,le){if(!x||!le)return x;const we=le.length;if(we===0||x.length===0)return x;let Ce=0;for(;x.indexOf(le,Ce)===Ce;)Ce=Ce+we;return x.substring(Ce)}t.ltrim=g;function b(x,le){if(!x||!le)return x;const we=le.length,Ce=x.length;if(we===0||Ce===0)return x;let Ie=Ce,Me=-1;for(;Me=x.lastIndexOf(le,Ie-1),!(Me===-1||Me+we!==Ie);){if(Me===0)return"";Ie=Me}return x.substring(0,Ie)}t.rtrim=b;function w(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=w;function E(x){return x.replace(/\*/g,"")}t.stripWildcards=E;function a(x,le,we={}){if(!x)throw new Error("Cannot create regex from empty string");le||(x=N(x)),we.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ce="";return we.global&&(Ce+="g"),we.matchCase||(Ce+="i"),we.multiline&&(Ce+="m"),we.unicode&&(Ce+="u"),new RegExp(x,Ce)}t.createRegExp=a;function u(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.regExpLeadsToEndlessLoop=u;function m(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=m;function S(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}t.regExpFlags=S;function T(x){return x.split(/\r\n|\r|\n/)}t.splitLines=T;function _(x){for(let le=0,we=x.length;le<we;le++){const Ce=x.charCodeAt(le);if(Ce!==32&&Ce!==9)return le}return-1}t.firstNonWhitespaceIndex=_;function r(x,le=0,we=x.length){for(let Ce=le;Ce<we;Ce++){const Ie=x.charCodeAt(Ce);if(Ie!==32&&Ie!==9)return x.substring(le,Ce)}return x.substring(le,we)}t.getLeadingWhitespace=r;function v(x,le=x.length-1){for(let we=le;we>=0;we--){const Ce=x.charCodeAt(we);if(Ce!==32&&Ce!==9)return we}return-1}t.lastNonWhitespaceIndex=v;function o(x,le,we){const Ce=[];let Ie=0;for(const Me of x.matchAll(le)){if(Ce.push(x.slice(Ie,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Ie=Me.index+Me[0].length,Ce.push(we(Me[0],...Me.slice(1),Me.index,x,Me.groups))}return Ce.push(x.slice(Ie)),Promise.all(Ce).then(Me=>Me.join(""))}t.replaceAsync=o;function s(x,le){return x<le?-1:x>le?1:0}t.compare=s;function p(x,le,we=0,Ce=x.length,Ie=0,Me=le.length){for(;we<Ce&&Ie<Me;we++,Ie++){const ke=x.charCodeAt(we),re=le.charCodeAt(Ie);if(ke<re)return-1;if(ke>re)return 1}const Ve=Ce-we,tt=Me-Ie;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstring=p;function L(x,le){return V(x,le,0,x.length,0,le.length)}t.compareIgnoreCase=L;function V(x,le,we=0,Ce=x.length,Ie=0,Me=le.length){for(;we<Ce&&Ie<Me;we++,Ie++){let ke=x.charCodeAt(we),re=le.charCodeAt(Ie);if(ke===re)continue;if(ke>=128||re>=128)return p(x.toLowerCase(),le.toLowerCase(),we,Ce,Ie,Me);J(ke)&&(ke-=32),J(re)&&(re-=32);const _e=ke-re;if(_e!==0)return _e}const Ve=Ce-we,tt=Me-Ie;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstringIgnoreCase=V;function X(x){return x>=48&&x<=57}t.isAsciiDigit=X;function J(x){return x>=97&&x<=122}t.isLowerAsciiLetter=J;function ge(x){return x>=65&&x<=90}t.isUpperAsciiLetter=ge;function oe(x,le){return x.length===le.length&&V(x,le)===0}t.equalsIgnoreCase=oe;function me(x,le){const we=le.length;return le.length>x.length?!1:V(x,le,0,we)===0}t.startsWithIgnoreCase=me;function he(x,le){const we=Math.min(x.length,le.length);let Ce;for(Ce=0;Ce<we;Ce++)if(x.charCodeAt(Ce)!==le.charCodeAt(Ce))return Ce;return we}t.commonPrefixLength=he;function ae(x,le){const we=Math.min(x.length,le.length);let Ce;const Ie=x.length-1,Me=le.length-1;for(Ce=0;Ce<we;Ce++)if(x.charCodeAt(Ie-Ce)!==le.charCodeAt(Me-Ce))return Ce;return we}t.commonSuffixLength=ae;function Se(x){return 55296<=x&&x<=56319}t.isHighSurrogate=Se;function te(x){return 56320<=x&&x<=57343}t.isLowSurrogate=te;function De(x,le){return(x-55296<<10)+(le-56320)+65536}t.computeCodePoint=De;function se(x,le,we){const Ce=x.charCodeAt(we);if(Se(Ce)&&we+1<le){const Ie=x.charCodeAt(we+1);if(te(Ie))return De(Ce,Ie)}return Ce}t.getNextCodePoint=se;function ie(x,le){const we=x.charCodeAt(le-1);if(te(we)&&le>1){const Ce=x.charCodeAt(le-2);if(Se(Ce))return De(Ce,we)}return we}class ce{get offset(){return this._offset}constructor(le,we=0){this._str=le,this._len=le.length,this._offset=we}setOffset(le){this._offset=le}prevCodePoint(){const le=ie(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=se(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}t.CodePointIterator=ce;class ne{get offset(){return this._iterator.offset}constructor(le,we=0){this._iterator=new ce(le,we)}nextGraphemeLength(){const le=Ke.getInstance(),we=this._iterator,Ce=we.offset;let Ie=le.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Me=we.offset,Ve=le.getGraphemeBreakType(we.nextCodePoint());if(Re(Ie,Ve)){we.setOffset(Me);break}Ie=Ve}return we.offset-Ce}prevGraphemeLength(){const le=Ke.getInstance(),we=this._iterator,Ce=we.offset;let Ie=le.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Me=we.offset,Ve=le.getGraphemeBreakType(we.prevCodePoint());if(Re(Ve,Ie)){we.setOffset(Me);break}Ie=Ve}return Ce-we.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ne;function F(x,le){return new ne(x,le).nextGraphemeLength()}t.nextCharLength=F;function $(x,le){return new ne(x,le).prevGraphemeLength()}t.prevCharLength=$;function j(x,le){le>0&&te(x.charCodeAt(le))&&le--;const we=le+F(x,le);return[we-$(x,we),we]}t.getCharContainingOffset=j;function P(x){const le=new ne(x);let we=0;for(;!le.eol();)we++,le.nextGraphemeLength();return we}t.charCount=P;let h;function I(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(x){return h||(h=I()),h.test(x)}t.containsRTL=U;const K=/^[\t\n\r\x20-\x7E]*$/;function Z(x){return K.test(x)}t.isBasicASCII=Z,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function k(x){return t.UNUSUAL_LINE_TERMINATORS.test(x)}t.containsUnusualLineTerminators=k;function M(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.isFullWidthCharacter=M;function z(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.isEmojiImprecise=z;function A(x,le){if(x.length<le)return x;const we=/\b/g;let Ce=0;for(;we.test(x)&&!(x.length-we.lastIndex<le);)Ce=we.lastIndex,we.lastIndex+=1;return x.substring(Ce).replace(/^\s/,"")}t.lcut=A;const R=/\x1B\x5B[12]?K/g,O=/\x1b\[\d+m/g,H=/\x1b\[0?m/g;function q(x){return x&&(x=x.replace(R,""),x=x.replace(O,""),x=x.replace(H,"")),x}t.removeAnsiEscapeCodes=q,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ee(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ee;function ue(x){return ee(x)?x.substr(1):x}t.stripUTF8BOM=ue;function de(x,le){if(!x||!le||x.length<le.length)return!1;const we=le.length,Ce=x.toLowerCase();let Ie=0,Me=-1;for(;Ie<we;){const Ve=Ce.indexOf(le[Ie],Me+1);if(Ve<0)return!1;Me=Ve,Ie++}return!0}t.fuzzyContains=de;function ye(x,le=!1){return x?(le&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.containsUppercaseCharacter=ye;function Ee(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.uppercaseFirstLetter=Ee;function Ne(x,le=1){if(le===0)return"";let we=-1;do we=x.indexOf(`
`,we+1),le--;while(le>0&&we>=0);return we===-1?x:(x[we-1]==="\r"&&we--,x.substr(0,we))}t.getNLines=Ne;function Fe(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.singleLetterHash=Fe;function ve(x){return Ke.getInstance().getGraphemeBreakType(x)}t.getGraphemeBreakType=ve;function Re(x,le){return x===0?le!==5&&le!==7:x===2&&le===3?!1:x===4||x===2||x===3||le===4||le===2||le===3?!0:!(x===8&&(le===8||le===9||le===11||le===12)||(x===11||x===9)&&(le===9||le===10)||(x===12||x===10)&&le===10||le===5||le===13||le===7||x===1||x===13&&le===14||x===6&&le===6)}var Pe;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Ke{static getInstance(){return Ke._INSTANCE||(Ke._INSTANCE=new Ke),Ke._INSTANCE}constructor(){this._data=He()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const we=this._data,Ce=we.length/3;let Ie=1;for(;Ie<=Ce;)if(le<we[3*Ie])Ie=2*Ie;else if(le>we[3*Ie+1])Ie=2*Ie+1;else return we[3*Ie+2];return 0}}Ke._INSTANCE=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(x,le){if(x===0)return 0;const we=Je(x,le);if(we!==void 0)return we;const Ce=new ce(le,x);return Ce.prevCodePoint(),Ce.offset}t.getLeftDeleteOffset=Ue;function Je(x,le){const we=new ce(le,x);let Ce=we.prevCodePoint();for(;it(Ce)||Ce===65039||Ce===8419;){if(we.offset===0)return;Ce=we.prevCodePoint()}if(!z(Ce))return;let Ie=we.offset;return Ie>0&&we.prevCodePoint()===8205&&(Ie=we.offset),Ie}function it(x){return 127995<=x&&x<=127999}var Oe;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),t.noBreakWhitespace="\xA0";class qe{static getInstance(le){return qe.cache.get(Array.from(le))}static getLocales(){return qe._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=qe,W=qe,qe.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.cache=new y.LRUCachedFunction(x=>{function le(re){const _e=new Map;for(let Le=0;Le<re.length;Le+=2)_e.set(re[Le],re[Le+1]);return _e}function we(re,_e){const Le=new Map(re);for(const[We,je]of _e)Le.set(We,je);return Le}function Ce(re,_e){if(!re)return _e;const Le=new Map;for(const[We,je]of re)_e.has(We)&&Le.set(We,je);return Le}const Ie=W.ambiguousCharacterData.getValue();let Me=x.filter(re=>!re.startsWith("_")&&re in Ie);Me.length===0&&(Me=["_default"]);let Ve;for(const re of Me){const _e=le(Ie[re]);Ve=Ce(Ve,_e)}const tt=le(Ie._common),ke=we(tt,Ve);return new qe(ke)}),qe._locales=new i.Lazy(()=>Object.keys(qe.ambiguousCharacterData.getValue()).filter(x=>!x.startsWith("_")));class Ye{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ye.getRawData())),this._data}static isInvisibleCharacter(le){return Ye.getData().has(le)}static get codePoints(){return Ye.getData()}}t.InvisibleCharacters=Ye,Ye._data=void 0}),define(pe[109],be([1,0,21,5,11,6]),function(Q,t,y,i,W,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function C(v){return v===47||v===92}t.isPathSeparator=C;function D(v){return v.replace(/[\\/]/g,y.posix.sep)}t.toSlashes=D;function d(v){return v.indexOf("/")===-1&&(v=D(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.toPosixPath=d;function c(v,o=y.posix.sep){if(!v)return"";const s=v.length,p=v.charCodeAt(0);if(C(p)){if(C(v.charCodeAt(1))&&!C(v.charCodeAt(2))){let V=3;const X=V;for(;V<s&&!C(v.charCodeAt(V));V++);if(X!==V&&!C(v.charCodeAt(V+1))){for(V+=1;V<s;V++)if(C(v.charCodeAt(V)))return v.slice(0,V+1).replace(/[\\/]/g,o)}}return o}else if(w(p)&&v.charCodeAt(1)===58)return C(v.charCodeAt(2))?v.slice(0,2)+o:v.slice(0,2);let L=v.indexOf("://");if(L!==-1){for(L+=3;L<s;L++)if(C(v.charCodeAt(L)))return v.slice(0,L+1)}return""}t.getRoot=c;function f(v){if(!i.isWindows||!v||v.length<5)return!1;let o=v.charCodeAt(0);if(o!==92||(o=v.charCodeAt(1),o!==92))return!1;let s=2;const p=s;for(;s<v.length&&(o=v.charCodeAt(s),o!==92);s++);return!(p===s||(o=v.charCodeAt(s+1),isNaN(o)||o===92))}t.isUNC=f;const N=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,n=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,o=i.isWindows){const s=o?N:l;return!(!v||v.length===0||/^\s+$/.test(v)||(s.lastIndex=0,s.test(v))||o&&n.test(v)||v==="."||v===".."||o&&v[v.length-1]==="."||o&&v.length!==v.trim().length||v.length>255)}t.isValidBasename=e;function g(v,o,s){const p=v===o;return!s||p?p:!v||!o?!1:(0,W.equalsIgnoreCase)(v,o)}t.isEqual=g;function b(v,o,s,p=y.sep){if(v===o)return!0;if(!v||!o||o.length>v.length)return!1;if(s){if(!(0,W.startsWithIgnoreCase)(v,o))return!1;if(o.length===v.length)return!0;let V=o.length;return o.charAt(o.length-1)===p&&V--,v.charAt(V)===p}return o.charAt(o.length-1)!==p&&(o+=p),v.indexOf(o)===0}t.isEqualOrParent=b;function w(v){return v>=65&&v<=90||v>=97&&v<=122}t.isWindowsDriveLetter=w;function E(v,o){return i.isWindows&&v.endsWith(":")&&(v+=y.sep),(0,y.isAbsolute)(v)||(v=(0,y.join)(o,v)),v=(0,y.normalize)(v),i.isWindows?(v=(0,W.rtrim)(v,y.sep),v.endsWith(":")&&(v+=y.sep)):(v=(0,W.rtrim)(v,y.sep),v||(v=y.sep)),v}t.sanitizeFilePath=E;function a(v){const o=(0,y.normalize)(v);return i.isWindows?v.length>3?!1:u(o)&&(v.length===2||o.charCodeAt(2)===92):o===y.posix.sep}t.isRootOrDriveLetter=a;function u(v,o=i.isWindows){return o?w(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.hasDriveLetter=u;function m(v){return u(v)?v[0]:void 0}t.getDriveLetter=m;function S(v,o,s){return o.length>v.length?-1:v===o?0:(s&&(v=v.toLowerCase(),o=o.toLowerCase()),v.indexOf(o))}t.indexOfPath=S;function T(v){const o=v.split(":");let s,p,L;for(const V of o){const X=Number(V);(0,B.isNumber)(X)?p===void 0?p=X:L===void 0&&(L=X):s=s?[s,V].join(":"):V}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:p!==void 0?p:void 0,column:L!==void 0?L:p!==void 0?1:void 0}}t.parseLineAndColumnAware=T;const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(v,o,s=8){let p="";for(let V=0;V<s;V++)p+=_.charAt(Math.floor(Math.random()*_.length));let L;return o?L=`${o}-${p}`:L=p,v?(0,y.join)(v,L):L}t.randomPath=r}),define(pe[110],be([1,0,11]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(w){return W(w,0)}t.hash=i;function W(w,E){switch(typeof w){case"object":return w===null?B(349,E):Array.isArray(w)?d(w,E):c(w,E);case"string":return D(w,E);case"boolean":return C(w,E);case"number":return B(w,E);case"undefined":return B(937,E);default:return B(617,E)}}t.doHash=W;function B(w,E){return(E<<5)-E+w|0}t.numberHash=B;function C(w,E){return B(w?433:863,E)}function D(w,E){E=B(149417,E);for(let a=0,u=w.length;a<u;a++)E=B(w.charCodeAt(a),E);return E}t.stringHash=D;function d(w,E){return E=B(104579,E),w.reduce((a,u)=>W(u,a),E)}function c(w,E){return E=B(181387,E),Object.keys(w).sort().reduce((a,u)=>(a=D(u,a),W(w[u],a)),E)}class f{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=W(E,this._value),this._value}}t.Hasher=f;var N;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function l(w,E,a=32){const u=a-E,m=~((1<<u)-1);return(w<<E|(m&w)>>>u)>>>0}function n(w,E=0,a=w.byteLength,u=0){for(let m=0;m<a;m++)w[E+m]=u}function e(w,E,a="0"){for(;w.length<E;)w=a+w;return w}function g(w,E=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(a=>a.toString(16).padStart(2,"0")).join(""):e((w>>>0).toString(16),E/4)}t.toHexString=g;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const a=E.length;if(a===0)return;const u=this._buff;let m=this._buffLen,S=this._leftoverHighSurrogate,T,_;for(S!==0?(T=S,_=-1,S=0):(T=E.charCodeAt(0),_=0);;){let r=T;if(y.isHighSurrogate(T))if(_+1<a){const v=E.charCodeAt(_+1);y.isLowSurrogate(v)?(_++,r=y.computeCodePoint(T,v)):r=65533}else{S=T;break}else y.isLowSurrogate(T)&&(r=65533);if(m=this._push(u,m,r),_++,_<a)T=E.charCodeAt(_);else break}this._buffLen=m,this._leftoverHighSurrogate=S}_push(E,a,u){return u<128?E[a++]=u:u<2048?(E[a++]=192|(u&1984)>>>6,E[a++]=128|(u&63)>>>0):u<65536?(E[a++]=224|(u&61440)>>>12,E[a++]=128|(u&4032)>>>6,E[a++]=128|(u&63)>>>0):(E[a++]=240|(u&1835008)>>>18,E[a++]=128|(u&258048)>>>12,E[a++]=128|(u&4032)>>>6,E[a++]=128|(u&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,n(this._buff,this._buffLen),this._buffLen>56&&(this._step(),n(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=b._bigBlock32,a=this._buffDV;for(let s=0;s<64;s+=4)E.setUint32(s,a.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)E.setUint32(s,l(E.getUint32(s-12,!1)^E.getUint32(s-32,!1)^E.getUint32(s-56,!1)^E.getUint32(s-64,!1),1),!1);let u=this._h0,m=this._h1,S=this._h2,T=this._h3,_=this._h4,r,v,o;for(let s=0;s<80;s++)s<20?(r=m&S|~m&T,v=1518500249):s<40?(r=m^S^T,v=1859775393):s<60?(r=m&S|m&T|S&T,v=2400959708):(r=m^S^T,v=3395469782),o=l(u,5)+r+_+v+E.getUint32(s*4,!1)&4294967295,_=T,T=S,S=l(m,30),m=u,u=o;this._h0=this._h0+u&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+T&4294967295,this._h4=this._h4+_&4294967295}}t.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(pe[111],be([1,0,70,110]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class W{constructor(l){this.source=l}getElements(){const l=this.source,n=new Int32Array(l.length);for(let e=0,g=l.length;e<g;e++)n[e]=l.charCodeAt(e);return n}}t.StringDiffSequence=W;function B(N,l,n){return new f(new W(N),new W(l)).ComputeDiff(n).changes}t.stringDiff=B;class C{static Assert(l,n){if(!l)throw new Error(n)}}t.Debug=C;class D{static Copy(l,n,e,g,b){for(let w=0;w<b;w++)e[g+w]=l[n+w]}static Copy2(l,n,e,g,b){for(let w=0;w<b;w++)e[g+w]=l[n+w]}}t.MyArray=D;var d;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new y.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(l,n){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,n),this.m_originalCount++}AddModifiedElement(l,n){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,n),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class f{constructor(l,n,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=l,this._modifiedSequence=n;const[g,b,w]=f._getElements(l),[E,a,u]=f._getElements(n);this._hasStrings=w&&u,this._originalStringElements=g,this._originalElementsOrHash=b,this._modifiedStringElements=E,this._modifiedElementsOrHash=a,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(l){return l.length>0&&typeof l[0]=="string"}static _getElements(l){const n=l.getElements();if(f._isStringArray(n)){const e=new Int32Array(n.length);for(let g=0,b=n.length;g<b;g++)e[g]=(0,i.stringHash)(n[g],0);return[n,e,!0]}return n instanceof Int32Array?[[],n,!1]:[[],new Int32Array(n),!1]}ElementsAreEqual(l,n){return this._originalElementsOrHash[l]!==this._modifiedElementsOrHash[n]?!1:this._hasStrings?this._originalStringElements[l]===this._modifiedStringElements[n]:!0}ElementsAreStrictEqual(l,n){if(!this.ElementsAreEqual(l,n))return!1;const e=f._getStrictElement(this._originalSequence,l),g=f._getStrictElement(this._modifiedSequence,n);return e===g}static _getStrictElement(l,n){return typeof l.getStrictElement=="function"?l.getStrictElement(n):null}OriginalElementsAreEqual(l,n){return this._originalElementsOrHash[l]!==this._originalElementsOrHash[n]?!1:this._hasStrings?this._originalStringElements[l]===this._originalStringElements[n]:!0}ModifiedElementsAreEqual(l,n){return this._modifiedElementsOrHash[l]!==this._modifiedElementsOrHash[n]?!1:this._hasStrings?this._modifiedStringElements[l]===this._modifiedStringElements[n]:!0}ComputeDiff(l){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,l)}_ComputeDiff(l,n,e,g,b){const w=[!1];let E=this.ComputeDiffRecursive(l,n,e,g,w);return b&&(E=this.PrettifyChanges(E)),{quitEarly:w[0],changes:E}}ComputeDiffRecursive(l,n,e,g,b){for(b[0]=!1;l<=n&&e<=g&&this.ElementsAreEqual(l,e);)l++,e++;for(;n>=l&&g>=e&&this.ElementsAreEqual(n,g);)n--,g--;if(l>n||e>g){let S;return e<=g?(C.Assert(l===n+1,"originalStart should only be one more than originalEnd"),S=[new y.DiffChange(l,0,e,g-e+1)]):l<=n?(C.Assert(e===g+1,"modifiedStart should only be one more than modifiedEnd"),S=[new y.DiffChange(l,n-l+1,e,0)]):(C.Assert(l===n+1,"originalStart should only be one more than originalEnd"),C.Assert(e===g+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const w=[0],E=[0],a=this.ComputeRecursionPoint(l,n,e,g,w,E,b),u=w[0],m=E[0];if(a!==null)return a;if(!b[0]){const S=this.ComputeDiffRecursive(l,u,e,m,b);let T=[];return b[0]?T=[new y.DiffChange(u+1,n-(u+1)+1,m+1,g-(m+1)+1)]:T=this.ComputeDiffRecursive(u+1,n,m+1,g,b),this.ConcatenateChanges(S,T)}return[new y.DiffChange(l,n-l+1,e,g-e+1)]}WALKTRACE(l,n,e,g,b,w,E,a,u,m,S,T,_,r,v,o,s,p){let L=null,V=null,X=new c,J=n,ge=e,oe=_[0]-o[0]-g,me=-1073741824,he=this.m_forwardHistory.length-1;do{const ae=oe+l;ae===J||ae<ge&&u[ae-1]<u[ae+1]?(S=u[ae+1],r=S-oe-g,S<me&&X.MarkNextChange(),me=S,X.AddModifiedElement(S+1,r),oe=ae+1-l):(S=u[ae-1]+1,r=S-oe-g,S<me&&X.MarkNextChange(),me=S-1,X.AddOriginalElement(S,r+1),oe=ae-1-l),he>=0&&(u=this.m_forwardHistory[he],l=u[0],J=1,ge=u.length-1)}while(--he>=-1);if(L=X.getReverseChanges(),p[0]){let ae=_[0]+1,Se=o[0]+1;if(L!==null&&L.length>0){const te=L[L.length-1];ae=Math.max(ae,te.getOriginalEnd()),Se=Math.max(Se,te.getModifiedEnd())}V=[new y.DiffChange(ae,T-ae+1,Se,v-Se+1)]}else{X=new c,J=w,ge=E,oe=_[0]-o[0]-a,me=1073741824,he=s?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const ae=oe+b;ae===J||ae<ge&&m[ae-1]>=m[ae+1]?(S=m[ae+1]-1,r=S-oe-a,S>me&&X.MarkNextChange(),me=S+1,X.AddOriginalElement(S+1,r+1),oe=ae+1-b):(S=m[ae-1],r=S-oe-a,S>me&&X.MarkNextChange(),me=S,X.AddModifiedElement(S+1,r+1),oe=ae-1-b),he>=0&&(m=this.m_reverseHistory[he],b=m[0],J=1,ge=m.length-1)}while(--he>=-1);V=X.getChanges()}return this.ConcatenateChanges(L,V)}ComputeRecursionPoint(l,n,e,g,b,w,E){let a=0,u=0,m=0,S=0,T=0,_=0;l--,e--,b[0]=0,w[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const r=n-l+(g-e),v=r+1,o=new Int32Array(v),s=new Int32Array(v),p=g-e,L=n-l,V=l-e,X=n-g,ge=(L-p)%2===0;o[p]=l,s[L]=n,E[0]=!1;for(let oe=1;oe<=r/2+1;oe++){let me=0,he=0;m=this.ClipDiagonalBound(p-oe,oe,p,v),S=this.ClipDiagonalBound(p+oe,oe,p,v);for(let Se=m;Se<=S;Se+=2){Se===m||Se<S&&o[Se-1]<o[Se+1]?a=o[Se+1]:a=o[Se-1]+1,u=a-(Se-p)-V;const te=a;for(;a<n&&u<g&&this.ElementsAreEqual(a+1,u+1);)a++,u++;if(o[Se]=a,a+u>me+he&&(me=a,he=u),!ge&&Math.abs(Se-L)<=oe-1&&a>=s[Se])return b[0]=a,w[0]=u,te<=s[Se]&&1447>0&&oe<=1447+1?this.WALKTRACE(p,m,S,V,L,T,_,X,o,s,a,n,b,u,g,w,ge,E):null}const ae=(me-l+(he-e)-oe)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(me,ae))return E[0]=!0,b[0]=me,w[0]=he,ae>0&&1447>0&&oe<=1447+1?this.WALKTRACE(p,m,S,V,L,T,_,X,o,s,a,n,b,u,g,w,ge,E):(l++,e++,[new y.DiffChange(l,n-l+1,e,g-e+1)]);T=this.ClipDiagonalBound(L-oe,oe,L,v),_=this.ClipDiagonalBound(L+oe,oe,L,v);for(let Se=T;Se<=_;Se+=2){Se===T||Se<_&&s[Se-1]>=s[Se+1]?a=s[Se+1]-1:a=s[Se-1],u=a-(Se-L)-X;const te=a;for(;a>l&&u>e&&this.ElementsAreEqual(a,u);)a--,u--;if(s[Se]=a,ge&&Math.abs(Se-p)<=oe&&a<=o[Se])return b[0]=a,w[0]=u,te>=o[Se]&&1447>0&&oe<=1447+1?this.WALKTRACE(p,m,S,V,L,T,_,X,o,s,a,n,b,u,g,w,ge,E):null}if(oe<=1447){let Se=new Int32Array(S-m+2);Se[0]=p-m+1,D.Copy2(o,m,Se,1,S-m+1),this.m_forwardHistory.push(Se),Se=new Int32Array(_-T+2),Se[0]=L-T+1,D.Copy2(s,T,Se,1,_-T+1),this.m_reverseHistory.push(Se)}}return this.WALKTRACE(p,m,S,V,L,T,_,X,o,s,a,n,b,u,g,w,ge,E)}PrettifyChanges(l){for(let n=0;n<l.length;n++){const e=l[n],g=n<l.length-1?l[n+1].originalStart:this._originalElementsOrHash.length,b=n<l.length-1?l[n+1].modifiedStart:this._modifiedElementsOrHash.length,w=e.originalLength>0,E=e.modifiedLength>0;for(;e.originalStart+e.originalLength<g&&e.modifiedStart+e.modifiedLength<b&&(!w||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!E||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const u=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!u)break;e.originalStart++,e.modifiedStart++}const a=[null];if(n<l.length-1&&this.ChangesOverlap(l[n],l[n+1],a)){l[n]=a[0],l.splice(n+1,1),n--;continue}}for(let n=l.length-1;n>=0;n--){const e=l[n];let g=0,b=0;if(n>0){const S=l[n-1];g=S.originalStart+S.originalLength,b=S.modifiedStart+S.modifiedLength}const w=e.originalLength>0,E=e.modifiedLength>0;let a=0,u=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let S=1;;S++){const T=e.originalStart-S,_=e.modifiedStart-S;if(T<g||_<b||w&&!this.OriginalElementsAreEqual(T,T+e.originalLength)||E&&!this.ModifiedElementsAreEqual(_,_+e.modifiedLength))break;const v=(T===g&&_===b?5:0)+this._boundaryScore(T,e.originalLength,_,e.modifiedLength);v>u&&(u=v,a=S)}e.originalStart-=a,e.modifiedStart-=a;const m=[null];if(n>0&&this.ChangesOverlap(l[n-1],l[n],m)){l[n-1]=m[0],l.splice(n,1),n++;continue}}if(this._hasStrings)for(let n=1,e=l.length;n<e;n++){const g=l[n-1],b=l[n],w=b.originalStart-g.originalStart-g.originalLength,E=g.originalStart,a=b.originalStart+b.originalLength,u=a-E,m=g.modifiedStart,S=b.modifiedStart+b.modifiedLength,T=S-m;if(w<5&&u<20&&T<20){const _=this._findBetterContiguousSequence(E,u,m,T,w);if(_){const[r,v]=_;(r!==g.originalStart+g.originalLength||v!==g.modifiedStart+g.modifiedLength)&&(g.originalLength=r-g.originalStart,g.modifiedLength=v-g.modifiedStart,b.originalStart=r+w,b.modifiedStart=v+w,b.originalLength=a-b.originalStart,b.modifiedLength=S-b.modifiedStart)}}}return l}_findBetterContiguousSequence(l,n,e,g,b){if(n<b||g<b)return null;const w=l+n-b+1,E=e+g-b+1;let a=0,u=0,m=0;for(let S=l;S<w;S++)for(let T=e;T<E;T++){const _=this._contiguousSequenceScore(S,T,b);_>0&&_>a&&(a=_,u=S,m=T)}return a>0?[u,m]:null}_contiguousSequenceScore(l,n,e){let g=0;for(let b=0;b<e;b++){if(!this.ElementsAreEqual(l+b,n+b))return 0;g+=this._originalStringElements[l+b].length}return g}_OriginalIsBoundary(l){return l<=0||l>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[l])}_OriginalRegionIsBoundary(l,n){if(this._OriginalIsBoundary(l)||this._OriginalIsBoundary(l-1))return!0;if(n>0){const e=l+n;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(l){return l<=0||l>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[l])}_ModifiedRegionIsBoundary(l,n){if(this._ModifiedIsBoundary(l)||this._ModifiedIsBoundary(l-1))return!0;if(n>0){const e=l+n;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(l,n,e,g){const b=this._OriginalRegionIsBoundary(l,n)?1:0,w=this._ModifiedRegionIsBoundary(e,g)?1:0;return b+w}ConcatenateChanges(l,n){const e=[];if(l.length===0||n.length===0)return n.length>0?n:l;if(this.ChangesOverlap(l[l.length-1],n[0],e)){const g=new Array(l.length+n.length-1);return D.Copy(l,0,g,0,l.length-1),g[l.length-1]=e[0],D.Copy(n,1,g,l.length,n.length-1),g}else{const g=new Array(l.length+n.length);return D.Copy(l,0,g,0,l.length),D.Copy(n,0,g,l.length,n.length),g}}ChangesOverlap(l,n,e){if(C.Assert(l.originalStart<=n.originalStart,"Left change is not less than or equal to right change"),C.Assert(l.modifiedStart<=n.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=n.originalStart||l.modifiedStart+l.modifiedLength>=n.modifiedStart){const g=l.originalStart;let b=l.originalLength;const w=l.modifiedStart;let E=l.modifiedLength;return l.originalStart+l.originalLength>=n.originalStart&&(b=n.originalStart+n.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=n.modifiedStart&&(E=n.modifiedStart+n.modifiedLength-l.modifiedStart),e[0]=new y.DiffChange(g,b,w,E),!0}else return e[0]=null,!1}ClipDiagonalBound(l,n,e,g){if(l>=0&&l<g)return l;const b=e,w=g-e-1,E=n%2===0;if(l<0){const a=b%2===0;return E===a?0:1}else{const a=w%2===0;return E===a?g-1:g-2}}}t.LcsDiff=f}),define(pe[49],be([1,0,14,11]),function(Q,t,y,i){"use strict";var W,B,C;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0;function D(_,r,v){let o=_.get(r);return o===void 0&&(o=v,_.set(r,o)),o}t.getOrSet=D;function d(_){const r=[];return _.forEach((v,o)=>{r.push(`${o} => ${v}`)}),`Map(${_.size}) {${r.join(", ")}}`}t.mapToString=d;function c(_){const r=[];return _.forEach(v=>{r.push(v)}),`Set(${_.size}) {${r.join(", ")}}`}t.setToString=c;class f{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const v=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return v-o}value(){return this._value[this._pos]}}t.StringIterator=f;class N{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=N;class l{constructor(r=!0,v=!0){this._splitOnBackslash=r,this._caseSensitive=v}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let v=r.length-1;v>=0;v--,this._valueLen--){const o=this._value.charCodeAt(v);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const v=this._value.charCodeAt(this._to);if(v===47||this._splitOnBackslash&&v===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=l;var n;(function(_){_[_.Scheme=1]="Scheme",_[_.Authority=2]="Authority",_[_.Path=3]="Path",_[_.Query=4]="Query",_[_.Fragment=5]="Fragment"})(n||(n={}));class e{constructor(r,v){this._ignorePathCasing=r,this._ignoreQueryAndFragment=v,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,i.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=e;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(_){_[_.Left=-1]="Left",_[_.Mid=0]="Mid",_[_.Right=1]="Right"})(b||(b={}));class w{static forUris(r=()=>!1,v=()=>!1){return new w(new e(r,v))}static forPaths(r=!1){return new w(new l(void 0,!r))}static forStrings(){return new w(new f)}static forConfigKeys(){return new w(new N)}constructor(r){this._iter=r}clear(){this._root=void 0}fill(r,v){if(v){const o=v.slice(0);(0,y.shuffle)(o);for(const s of o)this.set(s,r)}else{const o=r.slice(0);(0,y.shuffle)(o);for(const s of o)this.set(s[0],s[1])}}set(r,v){const o=this._iter.reset(r);let s;this._root||(this._root=new g,this._root.segment=o.value());const p=[];for(s=this._root;;){const V=o.cmp(s.segment);if(V>0)s.left||(s.left=new g,s.left.segment=o.value()),p.push([-1,s]),s=s.left;else if(V<0)s.right||(s.right=new g,s.right.segment=o.value()),p.push([1,s]),s=s.right;else if(o.hasNext())o.next(),s.mid||(s.mid=new g,s.mid.segment=o.value()),p.push([0,s]),s=s.mid;else break}const L=s.value;s.value=v,s.key=r;for(let V=p.length-1;V>=0;V--){const X=p[V][1];X.updateHeight();const J=X.balanceFactor();if(J<-1||J>1){const ge=p[V][0],oe=p[V+1][0];if(ge===1&&oe===1)p[V][1]=X.rotateLeft();else if(ge===-1&&oe===-1)p[V][1]=X.rotateRight();else if(ge===1&&oe===-1)X.right=p[V+1][1]=p[V+1][1].rotateRight(),p[V][1]=X.rotateLeft();else if(ge===-1&&oe===1)X.left=p[V+1][1]=p[V+1][1].rotateLeft(),p[V][1]=X.rotateRight();else throw new Error;if(V>0)switch(p[V-1][0]){case-1:p[V-1][1].left=p[V][1];break;case 1:p[V-1][1].right=p[V][1];break;case 0:p[V-1][1].mid=p[V][1];break}else this._root=p[0][1]}}return L}get(r){return this._getNode(r)?.value}_getNode(r){const v=this._iter.reset(r);let o=this._root;for(;o;){const s=v.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(v.hasNext())v.next(),o=o.mid;else break}return o}has(r){const v=this._getNode(r);return!(v?.value===void 0&&v?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,v){const o=this._iter.reset(r),s=[];let p=this._root;for(;p;){const L=o.cmp(p.segment);if(L>0)s.push([-1,p]),p=p.left;else if(L<0)s.push([1,p]),p=p.right;else if(o.hasNext())o.next(),s.push([0,p]),p=p.mid;else break}if(!!p){if(v?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const L=this._min(p.right);if(L.key){const{key:V,value:X,segment:J}=L;this._delete(L.key,!1),p.key=V,p.value=X,p.segment=J}}else{const L=p.left??p.right;if(s.length>0){const[V,X]=s[s.length-1];switch(V){case-1:X.left=L;break;case 0:X.mid=L;break;case 1:X.right=L;break}}else this._root=L}for(let L=s.length-1;L>=0;L--){const V=s[L][1];V.updateHeight();const X=V.balanceFactor();if(X>1?(V.right.balanceFactor()>=0||(V.right=V.right.rotateRight()),s[L][1]=V.rotateLeft()):X<-1&&(V.left.balanceFactor()<=0||(V.left=V.left.rotateLeft()),s[L][1]=V.rotateRight()),L>0)switch(s[L-1][0]){case-1:s[L-1][1].left=s[L][1];break;case 1:s[L-1][1].right=s[L][1];break;case 0:s[L-1][1].mid=s[L][1];break}else this._root=s[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const v=this._iter.reset(r);let o=this._root,s;for(;o;){const p=v.cmp(o.segment);if(p>0)o=o.left;else if(p<0)o=o.right;else if(v.hasNext())v.next(),s=o.value||s,o=o.mid;else break}return o&&o.value||s}findSuperstr(r){const v=this._iter.reset(r);let o=this._root;for(;o;){const s=v.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(v.hasNext())v.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[v,o]of this)r(o,v)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const v=[];return this._dfsEntries(r,v),v[Symbol.iterator]()}_dfsEntries(r,v){!r||(r.left&&this._dfsEntries(r.left,v),r.value&&v.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,v),r.right&&this._dfsEntries(r.right,v))}_isBalanced(){const r=v=>{if(!v)return!0;const o=v.balanceFactor();return o<-1||o>1?!1:r(v.left)&&r(v.right)};return r(this._root)}}t.TernarySearchTree=w;class E{constructor(r,v){this.uri=r,this.value=v}}class a{constructor(r,v){this[W]="ResourceMap",r instanceof a?(this.map=new Map(r.map),this.toKey=v??a.defaultToKey):(this.map=new Map,this.toKey=r??a.defaultToKey)}set(r,v){return this.map.set(this.toKey(r),new E(r,v)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,v){typeof v<"u"&&(r=r.bind(v));for(const[o,s]of this.map)r(s.value,s.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(W=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}t.ResourceMap=a,a.defaultToKey=_=>_.toString();class u{constructor(r,v){this[B]="ResourceSet",!r||typeof r=="function"?this._map=new a(r):(this._map=new a(v),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,v){this._map.forEach((o,s)=>r.call(v,s,s,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=u;var m;(function(_){_[_.None=0]="None",_[_.AsOld=1]="AsOld",_[_.AsNew=2]="AsNew"})(m=t.Touch||(t.Touch={}));class S{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,v=0){const o=this._map.get(r);if(!!o)return v!==0&&this.touch(o,v),o.value}set(r,v,o=0){let s=this._map.get(r);if(s)s.value=v,o!==0&&this.touch(s,o);else{switch(s={key:r,value:v,next:void 0,previous:void 0},o){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(r,s),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const v=this._map.get(r);if(!!v)return this._map.delete(r),this.removeItem(v),this._size--,v.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,v){const o=this._state;let s=this._head;for(;s;){if(v?r.bind(v)(s.value,s.key,this):r(s.value,s.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const r=this,v=this._state;let o=this._head;const s={[Symbol.iterator](){return s},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.key,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return s}values(){const r=this,v=this._state;let o=this._head;const s={[Symbol.iterator](){return s},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.value,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return s}entries(){const r=this,v=this._state;let o=this._head;const s={[Symbol.iterator](){return s},next(){if(r._state!==v)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:[o.key,o.value],done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return s}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let v=this._head,o=this.size;for(;v&&o>r;)this._map.delete(v.key),v=v.next,o--;this._head=v,this._size=o,v&&(v.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const v=r.next,o=r.previous;if(!v||!o)throw new Error("Invalid list");v.previous=o,o.next=v}r.next=void 0,r.previous=void 0,this._state++}touch(r,v){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(r===this._head)return;const o=r.next,s=r.previous;r===this._tail?(s.next=void 0,this._tail=s):(o.previous=s,s.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(v===2){if(r===this._tail)return;const o=r.next,s=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=s,s.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((v,o)=>{r.push([o,v])}),r}fromJSON(r){this.clear();for(const[v,o]of r)this.set(v,o)}}t.LinkedMap=S;class T extends S{constructor(r,v=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,v),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,v=2){return super.get(r,v)}peek(r){return super.get(r,0)}set(r,v){return super.set(r,v,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=T}),define(pe[33],be([1,0,49,11]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function W(...O){return function(H,q){for(let ee=0,ue=O.length;ee<ue;ee++){const de=O[ee](H,q);if(de)return de}return null}}t.or=W,t.matchesStrictPrefix=B.bind(void 0,!1),t.matchesPrefix=B.bind(void 0,!0);function B(O,H,q){if(!q||q.length<H.length)return null;let ee;return O?ee=i.startsWithIgnoreCase(q,H):ee=q.indexOf(H)===0,ee?H.length>0?[{start:0,end:H.length}]:[]:null}function C(O,H){const q=H.toLowerCase().indexOf(O.toLowerCase());return q===-1?null:[{start:q,end:q+O.length}]}t.matchesContiguousSubString=C;function D(O,H){return d(O.toLowerCase(),H.toLowerCase(),0,0)}t.matchesSubString=D;function d(O,H,q,ee){if(q===O.length)return[];if(ee===H.length)return null;if(O[q]===H[ee]){let ue=null;return(ue=d(O,H,q+1,ee+1))?w({start:ee,end:ee+1},ue):null}return d(O,H,q,ee+1)}function c(O){return 97<=O&&O<=122}function f(O){return 65<=O&&O<=90}t.isUpper=f;function N(O){return 48<=O&&O<=57}function l(O){return O===32||O===9||O===10||O===13}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(O=>n.add(O.charCodeAt(0)));function e(O){return l(O)||n.has(O)}function g(O,H){return O===H||e(O)&&e(H)}function b(O){return c(O)||f(O)||N(O)}function w(O,H){return H.length===0?H=[O]:O.end===H[0].start?H[0].start=O.start:H.unshift(O),H}function E(O,H){for(let q=H;q<O.length;q++){const ee=O.charCodeAt(q);if(f(ee)||N(ee)||q>0&&!b(O.charCodeAt(q-1)))return q}return O.length}function a(O,H,q,ee){if(q===O.length)return[];if(ee===H.length)return null;if(O[q]!==H[ee].toLowerCase())return null;{let ue=null,de=ee+1;for(ue=a(O,H,q+1,ee+1);!ue&&(de=E(H,de))<H.length;)ue=a(O,H,q+1,de),de++;return ue===null?null:w({start:ee,end:ee+1},ue)}}function u(O){let H=0,q=0,ee=0,ue=0,de=0;for(let ve=0;ve<O.length;ve++)de=O.charCodeAt(ve),f(de)&&H++,c(de)&&q++,b(de)&&ee++,N(de)&&ue++;const ye=H/O.length,Ee=q/O.length,Ne=ee/O.length,Fe=ue/O.length;return{upperPercent:ye,lowerPercent:Ee,alphaPercent:Ne,numericPercent:Fe}}function m(O){const{upperPercent:H,lowerPercent:q}=O;return q===0&&H>.6}function S(O){const{upperPercent:H,lowerPercent:q,alphaPercent:ee,numericPercent:ue}=O;return q>.2&&H<.8&&ee>.6&&ue<.2}function T(O){let H=0,q=0,ee=0,ue=0;for(let de=0;de<O.length;de++)ee=O.charCodeAt(de),f(ee)&&H++,c(ee)&&q++,l(ee)&&ue++;return(H===0||q===0)&&ue===0?O.length<=30:H<=5}function _(O,H){if(!H||(H=H.trim(),H.length===0)||!T(O)||H.length>60)return null;const q=u(H);if(!S(q)){if(!m(q))return null;H=H.toLowerCase()}let ee=null,ue=0;for(O=O.toLowerCase();ue<H.length&&(ee=a(O,H,0,ue))===null;)ue=E(H,ue+1);return ee}t.matchesCamelCase=_;function r(O,H,q=!1){if(!H||H.length===0)return null;let ee=null,ue=0;for(O=O.toLowerCase(),H=H.toLowerCase();ue<H.length&&(ee=v(O,H,0,ue,q))===null;)ue=o(H,ue+1);return ee}t.matchesWords=r;function v(O,H,q,ee,ue){if(q===O.length)return[];if(ee===H.length)return null;if(g(O.charCodeAt(q),H.charCodeAt(ee))){let de=null,ye=ee+1;if(de=v(O,H,q+1,ee+1,ue),!ue)for(;!de&&(ye=o(H,ye))<H.length;)de=v(O,H,q+1,ye,ue),ye++;return de?O.charCodeAt(q)!==H.charCodeAt(ee)?de:w({start:ee,end:ee+1},de):null}else return null}function o(O,H){for(let q=H;q<O.length;q++)if(e(O.charCodeAt(q))||q>0&&e(O.charCodeAt(q-1)))return q;return O.length}const s=W(t.matchesPrefix,_,C),p=W(t.matchesPrefix,_,D),L=new y.LRUCache(1e4);function V(O,H,q=!1){if(typeof O!="string"||typeof H!="string")return null;let ee=L.get(O);ee||(ee=new RegExp(i.convertSimple2RegExpPattern(O),"i"),L.set(O,ee));const ue=ee.exec(H);return ue?[{start:ue.index,end:ue.index+ue[0].length}]:q?p(O,H):s(O,H)}t.matchesFuzzy=V;function X(O,H){const q=K(O,O.toLowerCase(),0,H,H.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?ge(q):null}t.matchesFuzzy2=X;function J(O,H,q,ee,ue,de){const ye=Math.min(13,O.length);for(;q<ye;q++){const Ee=K(O,H,q,ee,ue,de,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ee)return Ee}return[0,de]}t.anyScore=J;function ge(O){if(typeof O>"u")return[];const H=[],q=O[1];for(let ee=O.length-1;ee>1;ee--){const ue=O[ee]+q,de=H[H.length-1];de&&de.end===ue?de.end=ue+1:H.push({start:ue,end:ue+1})}return H}t.createMatches=ge;const oe=128;function me(){const O=[],H=[];for(let q=0;q<=oe;q++)H[q]=0;for(let q=0;q<=oe;q++)O.push(H.slice(0));return O}function he(O){const H=[];for(let q=0;q<=O;q++)H[q]=0;return H}const ae=he(2*oe),Se=he(2*oe),te=me(),De=me(),se=me(),ie=!1;function ce(O,H,q,ee,ue){function de(Ee,Ne,Fe=" "){for(;Ee.length<Ne;)Ee=Fe+Ee;return Ee}let ye=` |   |${ee.split("").map(Ee=>de(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=q;Ee++)Ee===0?ye+=" |":ye+=`${H[Ee-1]}|`,ye+=O[Ee].slice(0,ue+1).map(Ne=>de(Ne.toString(),3)).join("|")+`
`;return ye}function ne(O,H,q,ee){O=O.substr(H),q=q.substr(ee),console.log(ce(De,O,O.length,q,q.length)),console.log(ce(se,O,O.length,q,q.length)),console.log(ce(te,O,O.length,q,q.length))}function F(O,H){if(H<0||H>=O.length)return!1;const q=O.codePointAt(H);switch(q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(q)}}function $(O,H){if(H<0||H>=O.length)return!1;switch(O.charCodeAt(H)){case 32:case 9:return!0;default:return!1}}function j(O,H,q){return H[O]!==q[O]}function P(O,H,q,ee,ue,de,ye=!1){for(;H<q&&ue<de;)O[H]===ee[ue]&&(ye&&(ae[H]=ue),H+=1),ue+=1;return H===q}t.isPatternInWord=P;var h;(function(O){O[O.Diag=1]="Diag",O[O.Left=2]="Left",O[O.LeftLeft=3]="LeftLeft"})(h||(h={}));var I;(function(O){O.Default=[-100,0];function H(q){return!q||q.length===2&&q[0]===-100&&q[1]===0}O.isDefault=H})(I=t.FuzzyScore||(t.FuzzyScore={}));class U{constructor(H,q){this.firstMatchCanBeWeak=H,this.boostFullMatch=q}}t.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function K(O,H,q,ee,ue,de,ye=U.default){const Ee=O.length>oe?oe:O.length,Ne=ee.length>oe?oe:ee.length;if(q>=Ee||de>=Ne||Ee-q>Ne-de||!P(H,q,Ee,ue,de,Ne,!0))return;Z(Ee,Ne,q,de,H,ue);let Fe=1,ve=1,Re=q,Pe=de;const Ke=[!1];for(Fe=1,Re=q;Re<Ee;Fe++,Re++){const Oe=ae[Re],qe=Se[Re],Ye=Re+1<Ee?Se[Re+1]:Ne;for(ve=Oe-de+1,Pe=Oe;Pe<Ye;ve++,Pe++){let x=Number.MIN_SAFE_INTEGER,le=!1;Pe<=qe&&(x=k(O,H,Re,q,ee,ue,Pe,Ne,de,te[Fe-1][ve-1]===0,Ke));let we=0;x!==Number.MAX_SAFE_INTEGER&&(le=!0,we=x+De[Fe-1][ve-1]);const Ce=Pe>Oe,Ie=Ce?De[Fe][ve-1]+(te[Fe][ve-1]>0?-5:0):0,Me=Pe>Oe+1&&te[Fe][ve-1]>0,Ve=Me?De[Fe][ve-2]+(te[Fe][ve-2]>0?-5:0):0;if(Me&&(!Ce||Ve>=Ie)&&(!le||Ve>=we))De[Fe][ve]=Ve,se[Fe][ve]=3,te[Fe][ve]=0;else if(Ce&&(!le||Ie>=we))De[Fe][ve]=Ie,se[Fe][ve]=2,te[Fe][ve]=0;else if(le)De[Fe][ve]=we,se[Fe][ve]=1,te[Fe][ve]=te[Fe-1][ve-1]+1;else throw new Error("not possible")}}if(ie&&ne(O,q,ee,de),!Ke[0]&&!ye.firstMatchCanBeWeak)return;Fe--,ve--;const He=[De[Fe][ve],de];let Ue=0,Je=0;for(;Fe>=1;){let Oe=ve;do{const qe=se[Fe][Oe];if(qe===3)Oe=Oe-2;else if(qe===2)Oe=Oe-1;else break}while(Oe>=1);Ue>1&&H[q+Fe-1]===ue[de+ve-1]&&!j(Oe+de-1,ee,ue)&&Ue+1>te[Fe][Oe]&&(Oe=ve),Oe===ve?Ue++:Ue=1,Je||(Je=Oe),Fe--,ve=Oe-1,He.push(ve)}Ne===Ee&&ye.boostFullMatch&&(He[0]+=2);const it=Je-Ee;return He[0]-=it,He}t.fuzzyScore=K;function Z(O,H,q,ee,ue,de){let ye=O-1,Ee=H-1;for(;ye>=q&&Ee>=ee;)ue[ye]===de[Ee]&&(Se[ye]=Ee,ye--),Ee--}function k(O,H,q,ee,ue,de,ye,Ee,Ne,Fe,ve){if(H[q]!==de[ye])return Number.MIN_SAFE_INTEGER;let Re=1,Pe=!1;return ye===q-ee?Re=O[q]===ue[ye]?7:5:j(ye,ue,de)&&(ye===0||!j(ye-1,ue,de))?(Re=O[q]===ue[ye]?7:5,Pe=!0):F(de,ye)&&(ye===0||!F(de,ye-1))?Re=5:(F(de,ye-1)||$(de,ye-1))&&(Re=5,Pe=!0),Re>1&&q===ee&&(ve[0]=!0),Pe||(Pe=j(ye,ue,de)||F(de,ye-1)||$(de,ye-1)),q===ee?ye>Ne&&(Re-=Pe?3:5):Fe?Re+=Pe?2:0:Re+=Pe?0:1,ye+1===Ee&&(Re-=Pe?3:5),Re}function M(O,H,q,ee,ue,de,ye){return A(O,H,q,ee,ue,de,!0,ye)}t.fuzzyScoreGracefulAggressive=M;function z(O,H,q,ee,ue,de,ye){return A(O,H,q,ee,ue,de,!1,ye)}t.fuzzyScoreGraceful=z;function A(O,H,q,ee,ue,de,ye,Ee){let Ne=K(O,H,q,ee,ue,de,Ee);if(Ne&&!ye)return Ne;if(O.length>=3){const Fe=Math.min(7,O.length-1);for(let ve=q+1;ve<Fe;ve++){const Re=R(O,ve);if(Re){const Pe=K(Re,Re.toLowerCase(),q,ee,ue,de,Ee);Pe&&(Pe[0]-=3,(!Ne||Pe[0]>Ne[0])&&(Ne=Pe))}}}return Ne}function R(O,H){if(H+1>=O.length)return;const q=O[H],ee=O[H+1];if(q!==ee)return O.slice(0,H)+ee+q+O.slice(H+2)}}),define(pe[34],be([1,0,12,33,11]),function(Q,t,y,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=t.iconStartMarker=void 0,t.iconStartMarker="$(";const B=new RegExp(`\\$\\(${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(y.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${B.source}`,"g");function d(b){return b.replace(D,(w,E)=>E?w:`\\${w}`)}t.escapeIcons=d;const c=new RegExp(`\\\\${B.source}`,"g");function f(b){return b.replace(c,w=>`\\${w}`)}t.markdownEscapeEscapedIcons=f;const N=new RegExp(`(\\s)?(\\\\)?${B.source}(\\s)?`,"g");function l(b){return b.indexOf(t.iconStartMarker)===-1?b:b.replace(N,(w,E,a,u)=>a?w:E||u||"")}t.stripIcons=l;function n(b){const w=b.indexOf(t.iconStartMarker);return w===-1?{text:b}:e(b,w)}t.parseLabelWithIcons=n;function e(b,w){const E=[];let a="";function u(s){if(s){a+=s;for(const p of s)E.push(T)}}let m=-1,S="",T=0,_,r,v=w;const o=b.length;for(u(b.substr(0,w));v<o;)_=b[v],r=b[v+1],_===t.iconStartMarker[0]&&r===t.iconStartMarker[1]?(m=v,u(S),S=t.iconStartMarker,v++):_===")"&&m!==-1?(T+=v-m+1,m=-1,S=""):m!==-1?C.test(_)?S+=_:(u(S),m=-1,S=""):u(_),v++;return u(S),{text:a,iconOffsets:E}}function g(b,w,E=!1){const{text:a,iconOffsets:u}=w;if(!u||u.length===0)return(0,i.matchesFuzzy)(b,a,E);const m=(0,W.ltrim)(a," "),S=a.length-m.length,T=(0,i.matchesFuzzy)(b,m,E);if(T)for(const _ of T){const r=u[_.start+S]+S;_.start+=r,_.end+=r}return T}t.matchesFuzzyIconAware=g}),define(pe[16],be([1,0,21,5]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const W=/^\w[\w\d+.-]*$/,B=/^\//,C=/^\/\//;function D(_,r){if(!_.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!W.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!B.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(_,r){return!_&&!r?"file":_}function c(_,r){switch(_){case"https":case"http":case"file":r?r[0]!==N&&(r=N+r):r=N;break}return r}const f="",N="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class n{static isUri(r){return r instanceof n?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,v,o,s,p,L=!1){typeof r=="object"?(this.scheme=r.scheme||f,this.authority=r.authority||f,this.path=r.path||f,this.query=r.query||f,this.fragment=r.fragment||f):(this.scheme=d(r,L),this.authority=v||f,this.path=c(this.scheme,o||f),this.query=s||f,this.fragment=p||f,D(this,L))}get fsPath(){return a(this,!1)}with(r){if(!r)return this;let{scheme:v,authority:o,path:s,query:p,fragment:L}=r;return v===void 0?v=this.scheme:v===null&&(v=f),o===void 0?o=this.authority:o===null&&(o=f),s===void 0?s=this.path:s===null&&(s=f),p===void 0?p=this.query:p===null&&(p=f),L===void 0?L=this.fragment:L===null&&(L=f),v===this.scheme&&o===this.authority&&s===this.path&&p===this.query&&L===this.fragment?this:new g(v,o,s,p,L)}static parse(r,v=!1){const o=l.exec(r);return o?new g(o[2]||f,T(o[4]||f),T(o[5]||f),T(o[7]||f),T(o[9]||f),v):new g(f,f,f,f,f)}static file(r){let v=f;if(i.isWindows&&(r=r.replace(/\\/g,N)),r[0]===N&&r[1]===N){const o=r.indexOf(N,2);o===-1?(v=r.substring(2),r=N):(v=r.substring(2,o),r=r.substring(o)||N)}return new g("file",v,r,f,f)}static from(r){const v=new g(r.scheme,r.authority,r.path,r.query,r.fragment);return D(v,!0),v}static joinPath(r,...v){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return i.isWindows&&r.scheme==="file"?o=n.file(y.win32.join(a(r,!0),...v)).path:o=y.posix.join(r.path,...v),r.with({path:o})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof n)return r;{const v=new g(r);return v._formatted=r.external,v._fsPath=r._sep===e?r.fsPath:null,v}}else return r}}t.URI=n;const e=i.isWindows?1:void 0;class g extends n{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=e),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(_,r){let v,o=-1;for(let s=0;s<_.length;s++){const p=_.charCodeAt(s);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||r&&p===47)o!==-1&&(v+=encodeURIComponent(_.substring(o,s)),o=-1),v!==void 0&&(v+=_.charAt(s));else{v===void 0&&(v=_.substr(0,s));const L=b[p];L!==void 0?(o!==-1&&(v+=encodeURIComponent(_.substring(o,s)),o=-1),v+=L):o===-1&&(o=s)}}return o!==-1&&(v+=encodeURIComponent(_.substring(o))),v!==void 0?v:_}function E(_){let r;for(let v=0;v<_.length;v++){const o=_.charCodeAt(v);o===35||o===63?(r===void 0&&(r=_.substr(0,v)),r+=b[o]):r!==void 0&&(r+=_[v])}return r!==void 0?r:_}function a(_,r){let v;return _.authority&&_.path.length>1&&_.scheme==="file"?v=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===47&&(_.path.charCodeAt(1)>=65&&_.path.charCodeAt(1)<=90||_.path.charCodeAt(1)>=97&&_.path.charCodeAt(1)<=122)&&_.path.charCodeAt(2)===58?r?v=_.path.substr(1):v=_.path[1].toLowerCase()+_.path.substr(2):v=_.path,i.isWindows&&(v=v.replace(/\//g,"\\")),v}t.uriToFsPath=a;function u(_,r){const v=r?E:w;let o="",{scheme:s,authority:p,path:L,query:V,fragment:X}=_;if(s&&(o+=s,o+=":"),(p||s==="file")&&(o+=N,o+=N),p){let J=p.indexOf("@");if(J!==-1){const ge=p.substr(0,J);p=p.substr(J+1),J=ge.indexOf(":"),J===-1?o+=v(ge,!1):(o+=v(ge.substr(0,J),!1),o+=":",o+=v(ge.substr(J+1),!1)),o+="@"}p=p.toLowerCase(),J=p.indexOf(":"),J===-1?o+=v(p,!1):(o+=v(p.substr(0,J),!1),o+=p.substr(J))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const J=L.charCodeAt(1);J>=65&&J<=90&&(L=`/${String.fromCharCode(J+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const J=L.charCodeAt(0);J>=65&&J<=90&&(L=`${String.fromCharCode(J+32)}:${L.substr(2)}`)}o+=v(L,!0)}return V&&(o+="?",o+=v(V,!1)),X&&(o+="#",o+=r?X:w(X,!1)),o}function m(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+m(_.substr(3)):_}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function T(_){return _.match(S)?_.replace(S,r=>m(r)):_}}),define(pe[50],be([1,0,31,11,16]),function(Q,t,y,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function B(c){return JSON.stringify(c,D)}t.stringify=B;function C(c){let f=JSON.parse(c);return f=d(f),f}t.parse=C;function D(c,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:(0,i.regExpFlags)(f)}:f}function d(c,f=0){if(!c||f>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return W.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 14:return new Date(c.source)}if(c instanceof y.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let N=0;N<c.length;++N)c[N]=d(c[N],f+1);else for(const N in c)Object.hasOwnProperty.call(c,N)&&(c[N]=d(c[N],f+1))}return c}t.revive=d}),define(pe[35],be([1,0,5,16]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var W;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebook="vscode-notebook",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(W=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class B{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${W.vscodeRemoteResource}`}setPreferredWebSchema(c){this._preferredWebSchema=c}setDelegate(c){this._delegate=c}setServerRootPath(c){this._remoteResourcesPath=`${c}/${W.vscodeRemoteResource}`}set(c,f,N){this._hosts[c]=f,this._ports[c]=N}setConnectionToken(c,f){this._connectionTokens[c]=f}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(c){if(this._delegate)return this._delegate(c);const f=c.authority;let N=this._hosts[f];N&&N.indexOf(":")!==-1&&N.indexOf("[")===-1&&(N=`[${N}]`);const l=this._ports[f],n=this._connectionTokens[f];let e=`path=${encodeURIComponent(c.path)}`;return typeof n=="string"&&(e+=`&${t.connectionTokenQueryName}=${encodeURIComponent(n)}`),i.URI.from({scheme:y.isWeb?this._preferredWebSchema:W.vscodeRemoteResource,authority:`${N}:${l}`,path:this._remoteResourcesPath,query:e})}}t.RemoteAuthorities=new B;class C{asBrowserUri(c,f){const N=this.toUri(c,f);return N.scheme===W.vscodeRemote?t.RemoteAuthorities.rewrite(N):N.scheme===W.file&&(y.isNative||y.isWebWorker&&y.globals.origin===`${W.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?N.with({scheme:W.vscodeFileResource,authority:N.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):N}asFileUri(c,f){const N=this.toUri(c,f);return N.scheme===W.vscodeFileResource?N.with({scheme:W.file,authority:N.authority!==C.FALLBACK_AUTHORITY?N.authority:null,query:null,fragment:null}):N}toUri(c,f){return i.URI.isUri(c)?c:i.URI.parse(f.toUrl(c))}}C.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new C;var D;(function(d){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(c.get("3"));const f="vscode-coi";function N(n){let e;typeof n=="string"?e=new URL(n).searchParams:n instanceof URL?e=n.searchParams:i.URI.isUri(n)&&(e=new URL(n.toString(!0)).searchParams);const g=e?.get(f);if(!!g)return c.get(g)}d.getHeadersFromQuery=N;function l(n,e,g){if(!globalThis.crossOriginIsolated)return;const b=e&&g?"3":g?"2":"1";n instanceof URLSearchParams?n.set(f,b):n[f]=b}d.addSearchParam=l})(D=t.COI||(t.COI={}))}),define(pe[36],be([1,0,109,35,21,5,11,16]),function(Q,t,y,i,W,B,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function d(n){return(0,D.uriToFsPath)(n,!0)}t.originalFSPath=d;class c{constructor(e){this._ignorePathCasing=e}compare(e,g,b=!1){return e===g?0:(0,C.compare)(this.getComparisonKey(e,b),this.getComparisonKey(g,b))}isEqual(e,g,b=!1){return e===g?!0:!e||!g?!1:this.getComparisonKey(e,b)===this.getComparisonKey(g,b)}getComparisonKey(e,g=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,g,b=!1){if(e.scheme===g.scheme){if(e.scheme===i.Schemas.file)return y.isEqualOrParent(d(e),d(g),this._ignorePathCasing(e))&&e.query===g.query&&(b||e.fragment===g.fragment);if((0,t.isEqualAuthority)(e.authority,g.authority))return y.isEqualOrParent(e.path,g.path,this._ignorePathCasing(e),"/")&&e.query===g.query&&(b||e.fragment===g.fragment)}return!1}joinPath(e,...g){return D.URI.joinPath(e,...g)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return W.posix.basename(e.path)}extname(e){return W.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let g;return e.scheme===i.Schemas.file?g=D.URI.file(W.dirname(d(e))).path:(g=W.posix.dirname(e.path),e.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),g="/")),e.with({path:g})}normalizePath(e){if(!e.path.length)return e;let g;return e.scheme===i.Schemas.file?g=D.URI.file(W.normalize(d(e))).path:g=W.posix.normalize(e.path),e.with({path:g})}relativePath(e,g){if(e.scheme!==g.scheme||!(0,t.isEqualAuthority)(e.authority,g.authority))return;if(e.scheme===i.Schemas.file){const E=W.relative(d(e),d(g));return B.isWindows?y.toSlashes(E):E}let b=e.path||"/";const w=g.path||"/";if(this._ignorePathCasing(e)){let E=0;for(const a=Math.min(b.length,w.length);E<a&&!(b.charCodeAt(E)!==w.charCodeAt(E)&&b.charAt(E).toLowerCase()!==w.charAt(E).toLowerCase());E++);b=w.substr(0,E)+b.substr(E)}return W.posix.relative(b,w)}resolvePath(e,g){if(e.scheme===i.Schemas.file){const b=D.URI.file(W.resolve(d(e),g));return e.with({authority:b.authority,path:b.path})}return g=y.toPosixPath(g),e.with({path:W.posix.resolve(e.path,g)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,g){return e===g||e!==void 0&&g!==void 0&&(0,C.equalsIgnoreCase)(e,g)}hasTrailingPathSeparator(e,g=W.sep){if(e.scheme===i.Schemas.file){const b=d(e);return b.length>y.getRoot(b).length&&b[b.length-1]===g}else{const b=e.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,g=W.sep){return(0,t.hasTrailingPathSeparator)(e,g)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,g=W.sep){let b=!1;if(e.scheme===i.Schemas.file){const w=d(e);b=w!==void 0&&w.length===y.getRoot(w).length&&w[w.length-1]===g}else{g="/";const w=e.path;b=w.length===1&&w.charCodeAt(w.length-1)===47}return!b&&!(0,t.hasTrailingPathSeparator)(e,g)?e.with({path:e.path+"/"}):e}}t.ExtUri=c,t.extUri=new c(()=>!1),t.extUriBiasedIgnorePathCase=new c(n=>n.scheme===i.Schemas.file?!B.isLinux:!0),t.extUriIgnorePathCase=new c(n=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function f(n,e){const g=[];for(let b=0;b<n.length;b++){const w=e(n[b]);n.some((E,a)=>a===b?!1:(0,t.isEqualOrParent)(w,e(E)))||g.push(n[b])}return g}t.distinctParents=f;var N;(function(n){n.META_DATA_LABEL="label",n.META_DATA_DESCRIPTION="description",n.META_DATA_SIZE="size",n.META_DATA_MIME="mime";function e(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(a=>{const[u,m]=a.split(":");u&&m&&b.set(u,m)});const E=g.path.substring(0,g.path.indexOf(";"));return E&&b.set(n.META_DATA_MIME,E),b}n.parseMetaData=e})(N=t.DataUri||(t.DataUri={}));function l(n,e,g){if(e){let b=n.path;return b&&b[0]!==W.posix.sep&&(b=W.posix.sep+b),n.with({scheme:g,authority:e,path:b})}return n.with({scheme:g})}t.toLocalResource=l}),define(pe[8],be([1,0,28,9,3,2,36,5]),function(Q,t,y,i,W,B,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function d(j){return!!j&&typeof j.then=="function"}t.isThenable=d;function c(j){const P=new y.CancellationTokenSource,h=j(P.token),I=new Promise((U,K)=>{const Z=P.token.onCancellationRequested(()=>{Z.dispose(),P.dispose(),K(new i.CancellationError)});Promise.resolve(h).then(k=>{Z.dispose(),P.dispose(),U(k)},k=>{Z.dispose(),P.dispose(),K(k)})});return new class{cancel(){P.cancel()}then(U,K){return I.then(U,K)}catch(U){return this.then(void 0,U)}finally(U){return I.finally(U)}}}t.createCancelablePromise=c;function f(j,P,h){return new Promise((I,U)=>{const K=P.onCancellationRequested(()=>{K.dispose(),I(h)});j.then(I,U).finally(()=>K.dispose())})}t.raceCancellation=f;function N(j,P){return new Promise((h,I)=>{const U=P.onCancellationRequested(()=>{U.dispose(),I(new i.CancellationError)});j.then(h,I).finally(()=>U.dispose())})}t.raceCancellationError=N;async function l(j){let P=-1;const h=j.map((U,K)=>U.then(Z=>(P=K,Z))),I=await Promise.race(h);return j.forEach((U,K)=>{K!==P&&U.cancel()}),I}t.raceCancellablePromises=l;function n(j,P,h){let I;const U=setTimeout(()=>{I?.(void 0),h?.()},P);return Promise.race([j.finally(()=>clearTimeout(U)),new Promise(K=>I=K)])}t.raceTimeout=n;function e(j){return new Promise((P,h)=>{const I=j();d(I)?I.then(P,h):P(I)})}t.asPromise=e;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(P){if(this.activePromise){if(this.queuedPromiseFactory=P,!this.queuedPromise){const h=()=>{this.queuedPromise=null;const I=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,I};this.queuedPromise=new Promise(I=>{this.activePromise.then(h,h).then(I)})}return new Promise((h,I)=>{this.queuedPromise.then(h,I)})}return this.activePromise=P(),new Promise((h,I)=>{this.activePromise.then(U=>{this.activePromise=null,h(U)},U=>{this.activePromise=null,I(U)})})}}t.Throttler=g;class b{constructor(){this.current=Promise.resolve(null)}queue(P){return this.current=this.current.then(()=>P(),()=>P())}}t.Sequencer=b;class w{constructor(){this.promiseMap=new Map}queue(P,h){const U=(this.promiseMap.get(P)??Promise.resolve()).catch(()=>{}).then(h).finally(()=>{this.promiseMap.get(P)===U&&this.promiseMap.delete(P)});return this.promiseMap.set(P,U),U}}t.SequencerByKey=w;const E=(j,P)=>{let h=!0;const I=setTimeout(()=>{h=!1,P()},j);return{isTriggered:()=>h,dispose:()=>{clearTimeout(I),h=!1}}},a=j=>{let P=!0;return queueMicrotask(()=>{P&&(P=!1,j())}),{isTriggered:()=>P,dispose:()=>{P=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(P){this.defaultDelay=P,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(P,h=this.defaultDelay){this.task=P,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,K)=>{this.doResolve=U,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const I=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=h===t.MicrotaskDelay?a(I):E(h,I),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=u;class m{constructor(P){this.delayer=new u(P),this.throttler=new g}trigger(P,h){return this.delayer.trigger(()=>this.throttler.queue(P),h)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=m;class S{constructor(){this._isOpen=!1,this._promise=new Promise((P,h)=>{this._completePromise=P})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=S;class T extends S{constructor(P){super(),this._timeout=setTimeout(()=>this.open(),P)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=T;function _(j,P){return P?new Promise((h,I)=>{const U=setTimeout(()=>{K.dispose(),h()},j),K=P.onCancellationRequested(()=>{clearTimeout(U),K.dispose(),I(new i.CancellationError)})}):c(h=>_(j,h))}t.timeout=_;function r(j,P=0){const h=setTimeout(j,P);return(0,B.toDisposable)(()=>clearTimeout(h))}t.disposableTimeout=r;function v(j){const P=[];let h=0;const I=j.length;function U(){return h<I?j[h++]():null}function K(Z){Z!=null&&P.push(Z);const k=U();return k?k.then(K):Promise.resolve(P)}return Promise.resolve(null).then(K)}t.sequence=v;function o(j,P=I=>!!I,h=null){let I=0;const U=j.length,K=()=>{if(I>=U)return Promise.resolve(h);const Z=j[I++];return Promise.resolve(Z()).then(M=>P(M)?Promise.resolve(M):K())};return K()}t.first=o;function s(j,P=I=>!!I,h=null){if(j.length===0)return Promise.resolve(h);let I=j.length;const U=()=>{I=-1;for(const K of j)K.cancel?.()};return new Promise((K,Z)=>{for(const k of j)k.then(M=>{--I>=0&&P(M)?(U(),K(M)):I===0&&K(h)}).catch(M=>{--I>=0&&(U(),Z(M))})})}t.firstParallel=s;class p{constructor(P){this._size=0,this.maxDegreeOfParalellism=P,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new W.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(P){return this._size++,new Promise((h,I)=>{this.outstandingPromises.push({factory:P,c:h,e:I}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const P=this.outstandingPromises.shift();this.runningPromises++;const h=P.factory();h.then(P.c,P.e),h.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=p;class L extends p{constructor(){super(1)}}t.Queue=L;class V{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const P=new se;return this.drainers.add(P),P.p}isDrained(){for(const[,P]of this.queues)if(P.size>0)return!1;return!0}queueFor(P,h=C.extUri){const I=h.getComparisonKey(P);let U=this.queues.get(I);return U||(U=new L,W.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(I),this.onDidQueueDrain()}),this.queues.set(I,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const P of this.drainers)P.complete();this.drainers.clear()}dispose(){for(const[,P]of this.queues)P.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=V;class X{constructor(P,h){this._token=-1,typeof P=="function"&&typeof h=="number"&&this.setIfNotSet(P,h)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(P,h){this.cancel(),this._token=setTimeout(()=>{this._token=-1,P()},h)}setIfNotSet(P,h){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,P()},h))}}t.TimeoutTimer=X;class J{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(P,h){this.cancel(),this._token=setInterval(()=>{P()},h)}}t.IntervalTimer=J;class ge{constructor(P,h){this.timeoutToken=-1,this.runner=P,this.timeout=h,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(P=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,P)}get delay(){return this.timeout}set delay(P){this.timeout=P}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=ge;class oe{constructor(P,h){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.runner=P,this.timeout=h,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(P=this.timeout){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(P/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=oe;class me extends ge{constructor(P,h){super(P,h),this.units=[]}work(P){this.units.push(P),this.isScheduled()||this.schedule()}doRun(){const P=this.units;this.units=[],this.runner?.(P)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=me;class he extends B.Disposable{constructor(P,h){super(),this.options=P,this.handler=h,this.pendingWork=[],this.throttler=this._register(new B.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(P){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+P.length>this.options.maxBufferedWork)return!1}else if(this.pending+P.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...P),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ge(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=he,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=j=>{(0,D.setTimeout0)(()=>{if(P)return;const h=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,h-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:t.runWhenIdle=(j,P)=>{const h=requestIdleCallback(j,typeof P=="number"?{timeout:P}:void 0);let I=!1;return{dispose(){I||(I=!0,cancelIdleCallback(h))}}}}();class ae{constructor(P){this._didRun=!1,this._executor=()=>{try{this._value=P()}catch(h){this._error=h}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=ae;async function Se(j,P,h){let I;for(let U=0;U<h;U++)try{return await j()}catch(K){I=K,await _(P)}throw I}t.retry=Se;class te{hasPending(P){return this._pending?typeof P=="number"?this._pending.taskId===P:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(P,h,I){return this._pending={taskId:P,cancel:()=>I?.(),promise:h},h.then(()=>this.donePending(P),()=>this.donePending(P)),h}donePending(P){this._pending&&P===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const P=this._next;this._next=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}setNext(P){if(this._next)this._next.run=P;else{let h,I;const U=new Promise((K,Z)=>{h=K,I=Z});this._next={run:P,promise:U,promiseResolve:h,promiseReject:I}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}t.TaskSequentializer=te;class De{constructor(P,h=()=>Date.now()){this.interval=P,this.nowFn=h,this.lastIncrementTime=0,this.value=0}increment(){const P=this.nowFn();return P-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=P,this.value=0),this.value++,this.value}}t.IntervalCounter=De;class se{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((P,h)=>{this.completeCallback=P,this.errorCallback=h})}complete(P){return new Promise(h=>{this.completeCallback(P),this.resolved=!0,h()})}error(P){return new Promise(h=>{this.errorCallback(P),this.rejected=!0,h()})}cancel(){new Promise(P=>{this.errorCallback(new i.CancellationError),this.rejected=!0,P()})}}t.DeferredPromise=se;var ie;(function(j){async function P(I){let U;const K=await Promise.all(I.map(Z=>Z.then(k=>k,k=>{U||(U=k)})));if(typeof U<"u")throw U;return K}j.settled=P;function h(I){return new Promise(async(U,K)=>{try{await I(U,K)}catch(Z){K(Z)}})}j.withAsyncBody=h})(ie=t.Promises||(t.Promises={}));var ce;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(ce||(ce={}));class ne{static fromArray(P){return new ne(h=>{h.emitMany(P)})}static fromPromise(P){return new ne(async h=>{h.emitMany(await P)})}static fromPromises(P){return new ne(async h=>{await Promise.all(P.map(async I=>h.emitOne(await I)))})}static merge(P){return new ne(async h=>{await Promise.all(P.map(async I=>{for await(const U of I)h.emitOne(U)}))})}constructor(P){this._state=0,this._results=[],this._error=null,this._onStateChanged=new W.Emitter,queueMicrotask(async()=>{const h={emitOne:I=>this.emitOne(I),emitMany:I=>this.emitMany(I),reject:I=>this.reject(I)};try{await Promise.resolve(P(h)),this.resolve()}catch(I){this.reject(I)}finally{h.emitOne=void 0,h.emitMany=void 0,h.reject=void 0}})}[Symbol.asyncIterator](){let P=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(P<this._results.length)return{done:!1,value:this._results[P++]};if(this._state===1)return{done:!0,value:void 0};await W.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(P,h){return new ne(async I=>{for await(const U of P)I.emitOne(h(U))})}map(P){return ne.map(this,P)}static filter(P,h){return new ne(async I=>{for await(const U of P)h(U)&&I.emitOne(U)})}filter(P){return ne.filter(this,P)}static coalesce(P){return ne.filter(P,h=>!!h)}coalesce(){return ne.coalesce(this)}static async toPromise(P){const h=[];for await(const I of P)h.push(I);return h}toPromise(){return ne.toPromise(this)}emitOne(P){this._state===0&&(this._results.push(P),this._onStateChanged.fire())}emitMany(P){this._state===0&&(this._results=this._results.concat(P),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(P){this._state===0&&(this._state=2,this._error=P,this._onStateChanged.fire())}}t.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class F extends ne{constructor(P,h){super(h),this._source=P}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=F;function $(j){const P=new y.CancellationTokenSource,h=j(P.token);return new F(P,async I=>{const U=P.token.onCancellationRequested(()=>{U.dispose(),P.dispose(),I.reject(new i.CancellationError)});try{for await(const K of h){if(P.token.isCancellationRequested)return;I.emitOne(K)}U.dispose(),P.dispose()}catch(K){U.dispose(),P.dispose(),I.reject(K)}})}t.createCancelableAsyncIterable=$}),define(pe[4],be([1,0,15,107,19,20,8,9,3,112,2,35,5,6,16]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.computeClippingRect=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function g(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.clearNode=g;function b(Y){return Y?.isConnected??!1}t.isInDOM=b;class w{constructor(G,fe,Ae,Te){this._node=G,this._type=fe,this._handler=Ae,this._options=Te||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){!this._handler||(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function E(Y,G,fe,Ae){return new w(Y,G,fe,Ae)}t.addDisposableListener=E;function a(Y){return function(G){return Y(new B.StandardMouseEvent(G))}}function u(Y){return function(G){return Y(new W.StandardKeyboardEvent(G))}}const m=function(G,fe,Ae,Te){let $e=Ae;return fe==="click"||fe==="mousedown"?$e=a(Ae):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&($e=u(Ae)),E(G,fe,$e,Te)};t.addStandardDisposableListener=m;const S=function(G,fe,Ae){const Te=a(fe);return _(G,Te,Ae)};t.addStandardDisposableGenericMouseDownListener=S;const T=function(G,fe,Ae){const Te=a(fe);return v(G,Te,Ae)};t.addStandardDisposableGenericMouseUpListener=T;function _(Y,G,fe){return E(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,G,fe)}t.addDisposableGenericMouseDownListener=_;function r(Y,G,fe){return E(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,G,fe)}t.addDisposableGenericMouseMoveListener=r;function v(Y,G,fe){return E(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,G,fe)}t.addDisposableGenericMouseUpListener=v;class o{constructor(G,fe=0){this._runner=G,this.priority=fe,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(G){(0,D.onUnexpectedError)(G)}}static sort(G,fe){return fe.priority-G.priority}}(function(){let Y=[],G=null,fe=!1,Ae=!1;const Te=()=>{for(fe=!1,G=Y,Y=[],Ae=!0;G.length>0;)G.sort(o.sort),G.shift().execute();Ae=!1};t.scheduleAtNextAnimationFrame=($e,ze=0)=>{const Ge=new o($e,ze);return Y.push(Ge),fe||(fe=!0,requestAnimationFrame(Te)),Ge},t.runAtThisOrScheduleAtNextAnimationFrame=($e,ze)=>{if(Ae){const Ge=new o($e,ze);return G.push(Ge),Ge}else return(0,t.scheduleAtNextAnimationFrame)($e,ze)}})();function s(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,1e4)}t.measure=s;function p(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,-1e4)}t.modify=p;const L=8,V=function(Y,G){return G};class X extends f.Disposable{constructor(G,fe,Ae,Te=V,$e=L){super();let ze=null,Ge=0;const Qe=this._register(new C.TimeoutTimer),gt=()=>{Ge=new Date().getTime(),Ae(ze),ze=null};this._register(E(G,fe,It=>{ze=Te(ze,It);const mt=new Date().getTime()-Ge;mt>=$e?(Qe.cancel(),gt()):Qe.setIfNotSet(gt,$e-mt)}))}}function J(Y,G,fe,Ae,Te){return new X(Y,G,fe,Ae,Te)}t.addDisposableThrottledListener=J;function ge(Y){return document.defaultView.getComputedStyle(Y,null)}t.getComputedStyle=ge;function oe(Y){if(Y!==document.body)return new he(Y.clientWidth,Y.clientHeight);if(l.isIOS&&window.visualViewport)return new he(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new he(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new he(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new he(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=oe;class me{static convertToPixels(G,fe){return parseFloat(fe)||0}static getDimension(G,fe,Ae){const Te=ge(G),$e=Te?Te.getPropertyValue(fe):"0";return me.convertToPixels(G,$e)}static getBorderLeftWidth(G){return me.getDimension(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return me.getDimension(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return me.getDimension(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return me.getDimension(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return me.getDimension(G,"padding-left","paddingLeft")}static getPaddingRight(G){return me.getDimension(G,"padding-right","paddingRight")}static getPaddingTop(G){return me.getDimension(G,"padding-top","paddingTop")}static getPaddingBottom(G){return me.getDimension(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return me.getDimension(G,"margin-left","marginLeft")}static getMarginTop(G){return me.getDimension(G,"margin-top","marginTop")}static getMarginRight(G){return me.getDimension(G,"margin-right","marginRight")}static getMarginBottom(G){return me.getDimension(G,"margin-bottom","marginBottom")}}class he{constructor(G,fe){this.width=G,this.height=fe}with(G=this.width,fe=this.height){return G!==this.width||fe!==this.height?new he(G,fe):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof he?G:new he(G.width,G.height)}static equals(G,fe){return G===fe?!0:!G||!fe?!1:G.width===fe.width&&G.height===fe.height}}t.Dimension=he,he.None=new he(0,0);function ae(Y){let G=Y.offsetParent,fe=Y.offsetTop,Ae=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==document.body&&Y!==document.documentElement;){fe-=Y.scrollTop;const Te=z(Y)?null:ge(Y);Te&&(Ae-=Te.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===G&&(Ae+=me.getBorderLeftWidth(Y),fe+=me.getBorderTopWidth(Y),fe+=Y.offsetTop,Ae+=Y.offsetLeft,G=Y.offsetParent)}return{left:Ae,top:fe}}t.getTopLeftOffset=ae;function Se(Y,G,fe){typeof G=="number"&&(Y.style.width=`${G}px`),typeof fe=="number"&&(Y.style.height=`${fe}px`)}t.size=Se;function te(Y,G,fe,Ae,Te,$e="absolute"){typeof G=="number"&&(Y.style.top=`${G}px`),typeof fe=="number"&&(Y.style.right=`${fe}px`),typeof Ae=="number"&&(Y.style.bottom=`${Ae}px`),typeof Te=="number"&&(Y.style.left=`${Te}px`),Y.style.position=$e}t.position=te;function De(Y){const G=Y.getBoundingClientRect();return{left:G.left+window.scrollX,top:G.top+window.scrollY,width:G.width,height:G.height}}t.getDomNodePagePosition=De;function se(Y){let G=Y,fe=1;do{const Ae=ge(G).zoom;Ae!=null&&Ae!=="1"&&(fe*=Ae),G=G.parentElement}while(G!==null&&G!==document.documentElement);return fe}t.getDomNodeZoomLevel=se;function ie(Y){const G=me.getMarginLeft(Y)+me.getMarginRight(Y);return Y.offsetWidth+G}t.getTotalWidth=ie;function ce(Y){const G=me.getBorderLeftWidth(Y)+me.getBorderRightWidth(Y),fe=me.getPaddingLeft(Y)+me.getPaddingRight(Y);return Y.offsetWidth-G-fe}t.getContentWidth=ce;function ne(Y){const G=me.getMarginLeft(Y)+me.getMarginRight(Y);return Y.scrollWidth+G}t.getTotalScrollWidth=ne;function F(Y){const G=me.getBorderTopWidth(Y)+me.getBorderBottomWidth(Y),fe=me.getPaddingTop(Y)+me.getPaddingBottom(Y);return Y.offsetHeight-G-fe}t.getContentHeight=F;function $(Y){const G=me.getMarginTop(Y)+me.getMarginBottom(Y);return Y.offsetHeight+G}t.getTotalHeight=$;function j(Y,G){if(Y===null)return 0;const fe=ae(Y),Ae=ae(G);return fe.left-Ae.left}function P(Y,G){const fe=G.map(Te=>Math.max(ne(Te),ie(Te))+j(Te,Y)||0);return Math.max(...fe)}t.getLargestChildWidth=P;function h(Y,G){for(;Y;){if(Y===G)return!0;Y=Y.parentNode}return!1}t.isAncestor=h;const I="parentFlowToElementId";function U(Y,G){Y.dataset[I]=G.id}t.setParentFlowTo=U;function K(Y){const G=Y.dataset[I];return typeof G=="string"?document.getElementById(G):null}function Z(Y,G){let fe=Y;for(;fe;){if(fe===G)return!0;if(fe instanceof HTMLElement){const Ae=K(fe);if(Ae){fe=Ae;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=Z;function k(Y,G,fe){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(G))return Y;if(fe){if(typeof fe=="string"){if(Y.classList.contains(fe))return null}else if(Y===fe)return null}Y=Y.parentNode}return null}t.findParentWithClass=k;function M(Y,G,fe){return!!k(Y,G,fe)}t.hasParentWithClass=M;function z(Y){return Y&&!!Y.host&&!!Y.mode}t.isShadowRoot=z;function A(Y){return!!R(Y)}t.isInShadowDOM=A;function R(Y){for(;Y.parentNode;){if(Y===document.body)return null;Y=Y.parentNode}return z(Y)?Y:null}t.getShadowRoot=R;function O(){let Y=document.activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.getActiveElement=O;function H(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("style");return G.type="text/css",G.media="screen",Y.appendChild(G),G}t.createStyleSheet=H;function q(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return Y.appendChild(G),G}t.createMetaElement=q;let ee=null;function ue(){return ee||(ee=H()),ee}function de(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function ye(Y,G,fe=ue()){!fe||!G||fe.sheet.insertRule(Y+"{"+G+"}",0)}t.createCSSRule=ye;function Ee(Y,G=ue()){if(!G)return;const fe=de(G),Ae=[];for(let Te=0;Te<fe.length;Te++)fe[Te].selectorText.indexOf(Y)!==-1&&Ae.push(Te);for(let Te=Ae.length-1;Te>=0;Te--)G.sheet.deleteRule(Ae[Te])}t.removeCSSRulesContainingSelector=Ee;function Ne(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.isHTMLElement=Ne,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:y.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:(Y,G)=>(Y.preventDefault(),G&&Y.stopPropagation(),Y)};function Fe(Y){const G=[];for(let fe=0;Y&&Y.nodeType===Y.ELEMENT_NODE;fe++)G[fe]=Y.scrollTop,Y=Y.parentNode;return G}t.saveParentsScrollTop=Fe;function ve(Y,G){for(let fe=0;Y&&Y.nodeType===Y.ELEMENT_NODE;fe++)Y.scrollTop!==G[fe]&&(Y.scrollTop=G[fe]),Y=Y.parentNode}t.restoreParentsScrollTop=ve;class Re extends f.Disposable{static hasFocusWithin(G){const fe=R(G),Ae=fe?fe.activeElement:document.activeElement;return h(Ae,G)}constructor(G){super(),this._onDidFocus=this._register(new d.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new d.Emitter),this.onDidBlur=this._onDidBlur.event;let fe=Re.hasFocusWithin(G),Ae=!1;const Te=()=>{Ae=!1,fe||(fe=!0,this._onDidFocus.fire())},$e=()=>{fe&&(Ae=!0,window.setTimeout(()=>{Ae&&(Ae=!1,fe=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{Re.hasFocusWithin(G)!==fe&&(fe?$e():Te())},this._register(E(G,t.EventType.FOCUS,Te,!0)),this._register(E(G,t.EventType.BLUR,$e,!0)),this._register(E(G,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(E(G,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}refreshState(){this._refreshStateHandler()}}function Pe(Y){return new Re(Y)}t.trackFocus=Pe;function Ke(Y,G){return Y.after(G),G}t.after=Ke;function He(Y,...G){if(Y.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.append=He;function Ue(Y,G){return Y.insertBefore(G,Y.firstChild),G}t.prepend=Ue;function Je(Y,...G){Y.innerText="",He(Y,...G)}t.reset=Je;const it=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Oe;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(Oe=t.Namespace||(t.Namespace={}));function qe(Y,G,fe,...Ae){const Te=it.exec(G);if(!Te)throw new Error("Bad use of emmet");fe={...fe||{}};const $e=Te[1]||"div";let ze;return Y!==Oe.HTML?ze=document.createElementNS(Y,$e):ze=document.createElement($e),Te[3]&&(ze.id=Te[3]),Te[4]&&(ze.className=Te[4].replace(/\./g," ").trim()),Object.keys(fe).forEach(Ge=>{const Qe=fe[Ge];typeof Qe>"u"||(/^on\w+$/.test(Ge)?ze[Ge]=Qe:Ge==="selected"?Qe&&ze.setAttribute(Ge,"true"):ze.setAttribute(Ge,Qe))}),ze.append(...Ae),ze}function Ye(Y,G,...fe){return qe(Oe.HTML,Y,G,...fe)}t.$=Ye,Ye.SVG=function(Y,G,...fe){return qe(Oe.SVG,Y,G,...fe)};function x(Y,G){const fe=[];return Y.forEach((Ae,Te)=>{Te>0&&(G instanceof Node?fe.push(G.cloneNode()):fe.push(document.createTextNode(G))),fe.push(Ae)}),fe}t.join=x;function le(...Y){for(const G of Y)G.style.display="",G.removeAttribute("aria-hidden")}t.show=le;function we(...Y){for(const G of Y)G.style.display="none",G.setAttribute("aria-hidden","true")}t.hide=we;function Ce(Y,G){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(G))return Y;Y=Y.parentNode}return null}function Ie(Y){!Y||!Y.hasAttribute("tabIndex")||(document.activeElement===Y&&Ce(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Ie;function Me(Y){return G=>{G.preventDefault(),G.stopPropagation(),Y(G)}}t.finalHandler=Me;function Ve(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.domContentLoaded=Ve;function tt(Y){const G=window.devicePixelRatio*Y;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.computeScreenAwareSize=tt;function ke(Y){window.open(Y,"_blank","noopener")}t.windowOpenNoOpener=ke;const re=780,_e=640;function Le(Y){const G=Math.floor(window.screenLeft+window.innerWidth/2-re/2),fe=Math.floor(window.screenTop+window.innerHeight/2-_e/2);window.open(Y,"_blank",`width=${re},height=${_e},top=${fe},left=${G}`)}t.windowOpenPopup=Le;function We(Y,G=!0){const fe=window.open();return fe?(G&&(fe.opener=null),fe.location.href=Y,!0):!1}t.windowOpenWithSuccess=We;function je(Y){const G=()=>{Y(),fe=(0,t.scheduleAtNextAnimationFrame)(G)};let fe=(0,t.scheduleAtNextAnimationFrame)(G);return(0,f.toDisposable)(()=>fe.dispose())}t.animate=je,N.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Xe(Y){return Y?`url('${N.FileAccess.asBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Xe;function Ze(Y){return`'${Y.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=Ze;function st(Y,G){let fe;if(e.URI.isUri(Y))fe=Y.toString(!0);else{const Te=new Blob([Y]);fe=URL.createObjectURL(Te),setTimeout(()=>URL.revokeObjectURL(fe))}const Ae=document.createElement("a");document.body.appendChild(Ae),Ae.download=G,Ae.href=fe,Ae.click(),setTimeout(()=>document.body.removeChild(Ae))}t.triggerDownload=st;function ht(){return new Promise(Y=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,d.Event.once(d.Event.fromDOMEventEmitter(G,"input"))(()=>{Y((0,n.withNullAsUndefined)(G.files))}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.triggerUpload=ht;var dt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(dt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function Tt(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(l.isMacintosh||l.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.detectFullscreen=Tt;function Ft(Y,G=!1){const fe=document.createElement("a");return c.addHook("afterSanitizeAttributes",Ae=>{for(const Te of["href","src"])if(Ae.hasAttribute(Te)){const $e=Ae.getAttribute(Te);if(Te==="href"&&$e.startsWith("#"))continue;if(fe.href=$e,!Y.includes(fe.protocol.replace(/:$/,""))){if(G&&Te==="src"&&fe.href.startsWith("data:"))continue;Ae.removeAttribute(Te)}}}),(0,f.toDisposable)(()=>{c.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Ft;const ui=[N.Schemas.http,N.Schemas.https,N.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);function ci(Y,G){const fe={ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1},Ae=Ft(ui);try{const Te=c.sanitize(G,{...fe,RETURN_TRUSTED_TYPE:!0});Y.innerHTML=Te}finally{Ae.dispose()}}t.safeInnerHtml=ci;function hi(Y){const G=new Uint16Array(Y.length);for(let Te=0;Te<G.length;Te++)G[Te]=Y.charCodeAt(Te);let fe="";const Ae=new Uint8Array(G.buffer);for(let Te=0;Te<Ae.length;Te++)fe+=String.fromCharCode(Ae[Te]);return fe}function di(Y){return btoa(hi(Y))}t.multibyteAwareBtoa=di;class ft extends d.Emitter{constructor(){super(),this._subscriptions=new f.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(E(window,"keydown",G=>{if(G.defaultPrevented)return;const fe=new W.StandardKeyboardEvent(G);if(!(fe.keyCode===6&&G.repeat)){if(G.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(G.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(G.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(G.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(fe.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=G,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(E(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!G.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!G.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!G.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=G,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(E(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(E(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(E(document.body,"mousemove",G=>{G.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(E(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function fi(Y){const G=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.getCookieValue=fi;class gi extends f.Disposable{constructor(G,fe){super(),this.element=G,this.callbacks=fe,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(E(this.element,t.EventType.DRAG_ENTER,G=>{this.counter++,this.dragStartTime=G.timeStamp,this.callbacks.onDragEnter(G)})),this._register(E(this.element,t.EventType.DRAG_OVER,G=>{G.preventDefault(),this.callbacks.onDragOver?.(G,G.timeStamp-this.dragStartTime)})),this._register(E(this.element,t.EventType.DRAG_LEAVE,G=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(G))})),this._register(E(this.element,t.EventType.DRAG_END,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(G)})),this._register(E(this.element,t.EventType.DROP,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(G)}))}}t.DragAndDropObserver=gi;function mi(Y,G){const fe=Y instanceof HTMLElement?Y.getBoundingClientRect():Y,Ae=G.getBoundingClientRect(),Te=Math.max(Ae.top-fe.top,0),$e=Math.max(fe.width-(fe.right-Ae.right),0),ze=Math.max(fe.height-(fe.bottom-Ae.bottom),0),Ge=Math.max(Ae.left-fe.left,0);return{top:Te,right:$e,bottom:ze,left:Ge}}t.computeClippingRect=mi;const pi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function bi(Y,...G){let fe,Ae;Array.isArray(G[0])?(fe={},Ae=G[0]):(fe=G[0]||{},Ae=G[1]);const Te=pi.exec(Y);if(!Te||!Te.groups)throw new Error("Bad use of h");const $e=Te.groups.tag||"div",ze=document.createElement($e);Te.groups.id&&(ze.id=Te.groups.id),Te.groups.class&&(ze.className=Te.groups.class.replace(/\./g," ").trim());const Ge={};if(Te.groups.name&&(Ge[Te.groups.name]=ze),Ae)for(const Qe of Ae)Qe instanceof HTMLElement?ze.appendChild(Qe):typeof Qe=="string"?ze.append(Qe):(Object.assign(Ge,Qe),ze.appendChild(Qe.root));for(const[Qe,gt]of Object.entries(fe))if(Qe==="style")for(const[It,mt]of Object.entries(gt))ze.style.setProperty(zt(It),typeof mt=="number"?mt+"px":""+mt);else Qe==="tabIndex"?ze.tabIndex=gt:ze.setAttribute(zt(Qe),gt.toString());return Ge.root=ze,Ge}t.h=bi;function zt(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(pe[51],be([1,0,4,2,105]),function(Q,t,y,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class B extends i.Disposable{constructor(d,c){super(),this._register((0,y.addDisposableListener)(d,"dragover",f=>{f.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{c(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this._register((0,y.addDisposableListener)(d,f,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=B,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:W.Mimes.text};function C(D,d,c){const f=document.createElement("div");f.className=c,f.textContent=d,D.dataTransfer&&(document.body.appendChild(f),D.dataTransfer.setDragImage(f,-10,-10),setTimeout(()=>document.body.removeChild(f),0))}t.applyDragImage=C}),define(pe[52],be([1,0,4]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(l,n={}){const e=B(n);return e.textContent=l,e}t.renderText=i;function W(l,n={}){const e=B(n);return d(e,c(l,!!n.renderCodeSegments),n.actionHandler,n.renderCodeSegments),e}t.renderFormattedText=W;function B(l){const n=l.inline?"span":"div",e=document.createElement(n);return l.className&&(e.className=l.className),e}t.createElement=B;class C{constructor(n){this.source=n,this.index=0}eos(){return this.index>=this.source.length}next(){const n=this.peek();return this.advance(),n}peek(){return this.source[this.index]}advance(){this.index++}}var D;(function(l){l[l.Invalid=0]="Invalid",l[l.Root=1]="Root",l[l.Text=2]="Text",l[l.Bold=3]="Bold",l[l.Italics=4]="Italics",l[l.Action=5]="Action",l[l.ActionClose=6]="ActionClose",l[l.Code=7]="Code",l[l.NewLine=8]="NewLine"})(D||(D={}));function d(l,n,e,g){let b;if(n.type===2)b=document.createTextNode(n.content||"");else if(n.type===3)b=document.createElement("b");else if(n.type===4)b=document.createElement("i");else if(n.type===7&&g)b=document.createElement("code");else if(n.type===5&&e){const w=document.createElement("a");e.disposables.add(y.addStandardDisposableListener(w,"click",E=>{e.callback(String(n.index),E)})),b=w}else n.type===8?b=document.createElement("br"):n.type===1&&(b=l);b&&l!==b&&l.appendChild(b),b&&Array.isArray(n.children)&&n.children.forEach(w=>{d(b,w,e,g)})}function c(l,n){const e={type:1,children:[]};let g=0,b=e;const w=[],E=new C(l);for(;!E.eos();){let a=E.next();const u=a==="\\"&&N(E.peek(),n)!==0;if(u&&(a=E.next()),!u&&f(a,n)&&a===E.peek()){E.advance(),b.type===2&&(b=w.pop());const m=N(a,n);if(b.type===m||b.type===5&&m===6)b=w.pop();else{const S={type:m,children:[]};m===5&&(S.index=g,g++),b.children.push(S),w.push(b),b=S}}else if(a===`
`)b.type===2&&(b=w.pop()),b.children.push({type:8});else if(b.type!==2){const m={type:2,content:a};b.children.push(m),w.push(b),b=m}else b.content+=a}return b.type===2&&(b=w.pop()),w.length,e}function f(l,n){return N(l,n)!==0}function N(l,n){switch(l){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return n?7:0;default:return 0}}}),define(pe[53],be([1,0,4,2]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class W{constructor(){this._hooks=new i.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(C,D){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const d=this._onStopCallback;this._onStopCallback=null,C&&d&&d(D)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(C,D,d,c,f){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=c,this._onStopCallback=f;let N=C;try{C.setPointerCapture(D),this._hooks.add((0,i.toDisposable)(()=>{try{C.releasePointerCapture(D)}catch{}}))}catch{N=window}this._hooks.add(y.addDisposableListener(N,y.EventType.POINTER_MOVE,l=>{if(l.buttons!==d){this.stopMonitoring(!0);return}l.preventDefault(),this._pointerMoveCallback(l)})),this._hooks.add(y.addDisposableListener(N,y.EventType.POINTER_UP,l=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=W});var xe=this&&this.__decorate||function(Q,t,y,i){var W=arguments.length,B=W<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,y):i,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")B=Reflect.decorate(Q,t,y,i);else for(var D=Q.length-1;D>=0;D--)(C=Q[D])&&(B=(W<3?C(B):W>3?C(t,y,B):C(t,y))||B);return W>3&&B&&Object.defineProperty(t,y,B),B};define(pe[22],be([1,0,4,14,25,2]),function(Q,t,y,i,W,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var C;(function(d){d.Tap="-monaco-gesturetap",d.Change="-monaco-gesturechange",d.Start="-monaco-gesturestart",d.End="-monaco-gesturesend",d.Contextmenu="-monaco-gesturecontextmenu"})(C=t.EventType||(t.EventType={}));class D extends B.Disposable{constructor(){super(),this.dispatched=!1,this.activeTouches={},this.handle=null,this.targets=[],this.ignoreTargets=[],this._lastSetTapCountTime=0,this._register(y.addDisposableListener(document,"touchstart",c=>this.onTouchStart(c),{passive:!1})),this._register(y.addDisposableListener(document,"touchend",c=>this.onTouchEnd(c))),this._register(y.addDisposableListener(document,"touchmove",c=>this.onTouchMove(c),{passive:!1}))}static addTarget(c){return D.isTouchDevice()?(D.INSTANCE||(D.INSTANCE=new D),D.INSTANCE.targets.push(c),{dispose:()=>{D.INSTANCE.targets=D.INSTANCE.targets.filter(f=>f!==c)}}):B.Disposable.None}static ignoreTarget(c){return D.isTouchDevice()?(D.INSTANCE||(D.INSTANCE=new D),D.INSTANCE.ignoreTargets.push(c),{dispose:()=>{D.INSTANCE.ignoreTargets=D.INSTANCE.ignoreTargets.filter(f=>f!==c)}}):B.Disposable.None}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(c){const f=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let N=0,l=c.targetTouches.length;N<l;N++){const n=c.targetTouches.item(N);this.activeTouches[n.identifier]={id:n.identifier,initialTarget:n.target,initialTimeStamp:f,initialPageX:n.pageX,initialPageY:n.pageY,rollingTimestamps:[f],rollingPageX:[n.pageX],rollingPageY:[n.pageY]};const e=this.newGestureEvent(C.Start,n.target);e.pageX=n.pageX,e.pageY=n.pageY,this.dispatchEvent(e)}this.dispatched&&(c.preventDefault(),c.stopPropagation(),this.dispatched=!1)}onTouchEnd(c){const f=Date.now(),N=Object.keys(this.activeTouches).length;for(let l=0,n=c.changedTouches.length;l<n;l++){const e=c.changedTouches.item(l);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("move of an UNKNOWN touch",e);continue}const g=this.activeTouches[e.identifier],b=Date.now()-g.initialTimeStamp;if(b<D.HOLD_DELAY&&Math.abs(g.initialPageX-i.tail(g.rollingPageX))<30&&Math.abs(g.initialPageY-i.tail(g.rollingPageY))<30){const w=this.newGestureEvent(C.Tap,g.initialTarget);w.pageX=i.tail(g.rollingPageX),w.pageY=i.tail(g.rollingPageY),this.dispatchEvent(w)}else if(b>=D.HOLD_DELAY&&Math.abs(g.initialPageX-i.tail(g.rollingPageX))<30&&Math.abs(g.initialPageY-i.tail(g.rollingPageY))<30){const w=this.newGestureEvent(C.Contextmenu,g.initialTarget);w.pageX=i.tail(g.rollingPageX),w.pageY=i.tail(g.rollingPageY),this.dispatchEvent(w)}else if(N===1){const w=i.tail(g.rollingPageX),E=i.tail(g.rollingPageY),a=i.tail(g.rollingTimestamps)-g.rollingTimestamps[0],u=w-g.rollingPageX[0],m=E-g.rollingPageY[0],S=this.targets.filter(T=>g.initialTarget instanceof Node&&T.contains(g.initialTarget));this.inertia(S,f,Math.abs(u)/a,u>0?1:-1,w,Math.abs(m)/a,m>0?1:-1,E)}this.dispatchEvent(this.newGestureEvent(C.End,g.initialTarget)),delete this.activeTouches[e.identifier]}this.dispatched&&(c.preventDefault(),c.stopPropagation(),this.dispatched=!1)}newGestureEvent(c,f){const N=document.createEvent("CustomEvent");return N.initEvent(c,!1,!0),N.initialTarget=f,N.tapCount=0,N}dispatchEvent(c){if(c.type===C.Tap){const f=new Date().getTime();let N=0;f-this._lastSetTapCountTime>D.CLEAR_TAP_COUNT_TIME?N=1:N=2,this._lastSetTapCountTime=f,c.tapCount=N}else(c.type===C.Change||c.type===C.Contextmenu)&&(this._lastSetTapCountTime=0);for(let f=0;f<this.ignoreTargets.length;f++)if(c.initialTarget instanceof Node&&this.ignoreTargets[f].contains(c.initialTarget))return;this.targets.forEach(f=>{c.initialTarget instanceof Node&&f.contains(c.initialTarget)&&(f.dispatchEvent(c),this.dispatched=!0)})}inertia(c,f,N,l,n,e,g,b){this.handle=y.scheduleAtNextAnimationFrame(()=>{const w=Date.now(),E=w-f;let a=0,u=0,m=!0;N+=D.SCROLL_FRICTION*E,e+=D.SCROLL_FRICTION*E,N>0&&(m=!1,a=l*N*E),e>0&&(m=!1,u=g*e*E);const S=this.newGestureEvent(C.Change);S.translationX=a,S.translationY=u,c.forEach(T=>T.dispatchEvent(S)),m||this.inertia(c,w,N,l,n+a,e,g,b+u)})}onTouchMove(c){const f=Date.now();for(let N=0,l=c.changedTouches.length;N<l;N++){const n=c.changedTouches.item(N);if(!this.activeTouches.hasOwnProperty(String(n.identifier))){console.warn("end of an UNKNOWN touch",n);continue}const e=this.activeTouches[n.identifier],g=this.newGestureEvent(C.Change,e.initialTarget);g.translationX=n.pageX-i.tail(e.rollingPageX),g.translationY=n.pageY-i.tail(e.rollingPageY),g.pageX=n.pageX,g.pageY=n.pageY,this.dispatchEvent(g),e.rollingPageX.length>3&&(e.rollingPageX.shift(),e.rollingPageY.shift(),e.rollingTimestamps.shift()),e.rollingPageX.push(n.pageX),e.rollingPageY.push(n.pageY),e.rollingTimestamps.push(f)}this.dispatched&&(c.preventDefault(),c.stopPropagation(),this.dispatched=!1)}}D.SCROLL_FRICTION=-.005,D.HOLD_DELAY=700,D.CLEAR_TAP_COUNT_TIME=400,xe([W.memoize],D,"isTouchDevice",null),t.Gesture=D}),define(pe[54],be([1,0,4,5,82]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const W=2e4;let B,C,D,d,c;function f(e){B=document.createElement("div"),B.className="monaco-aria-container";const g=()=>{const w=document.createElement("div");return w.className="monaco-alert",w.setAttribute("role","alert"),w.setAttribute("aria-atomic","true"),B.appendChild(w),w};C=g(),D=g();const b=()=>{const w=document.createElement("div");return w.className="monaco-status",w.setAttribute("role","complementary"),w.setAttribute("aria-live","polite"),w.setAttribute("aria-atomic","true"),B.appendChild(w),w};d=b(),c=b(),e.appendChild(B)}t.setARIAContainer=f;function N(e){!B||(C.textContent!==e?(y.clearNode(D),n(C,e)):(y.clearNode(C),n(D,e)))}t.alert=N;function l(e){!B||(i.isMacintosh?N(e):d.textContent!==e?(y.clearNode(c),n(d,e)):(y.clearNode(d),n(c,e)))}t.status=l;function n(e,g){y.clearNode(e),g.length>W&&(g=g.substr(0,W)),e.textContent=g,e.style.visibility="hidden",e.style.visibility="visible"}}),define(pe[113],be([1,0,4,12]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const W=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function B(D){const d=new Array;let c,f=0,N=0;for(;(c=W.exec(D))!==null;){N=c.index||0,f<N&&d.push(D.substring(f,N)),f=(c.index||0)+c[0].length;const[,l,n]=c;d.push(l?`$(${n})`:C({id:n}))}return f<D.length&&d.push(D.substring(f)),d}t.renderLabelWithIcons=B;function C(D){const d=y.$("span");return d.classList.add(...i.CSSIcon.asClassNameArray(D)),d}t.renderIcon=C}),define(pe[114],be([1,0,4]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(B){try{B.parentElement?.removeChild(B)}catch{}}class W{constructor(C){this.renderers=C,this.cache=new Map}alloc(C){let D=this.getTemplateCache(C).pop();if(!D){const d=(0,y.$)(".monaco-list-row"),f=this.getRenderer(C).renderTemplate(d);D={domNode:d,templateId:C,templateData:f}}return D}release(C){!C||this.releaseRow(C)}releaseRow(C){const{domNode:D,templateId:d}=C;D&&(D.classList.remove("scrolling"),i(D)),this.getTemplateCache(d).push(C)}getTemplateCache(C){let D=this.cache.get(C);return D||(D=[],this.cache.set(C,D)),D}dispose(){this.cache.forEach((C,D)=>{for(const d of C)this.getRenderer(D).disposeTemplate(d.templateData),d.templateData=null}),this.cache.clear()}getRenderer(C){const D=this.renderers.get(C);if(!D)throw new Error(`No renderer found for ${C}`);return D}}t.RowCache=W}),define(pe[115],be([1,0,8,2]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class W extends i.Disposable{constructor(C,D,d){super(),this._visibility=C,this._visibleClassName=D,this._invisibleClassName=d,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new y.TimeoutTimer)}setVisibility(C){this._visibility!==C&&(this._visibility=C,this._updateShouldBeVisible())}setShouldBeVisible(C){this._rawShouldBeVisible=C,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const C=this._applyVisibilitySetting();this._shouldBeVisible!==C&&(this._shouldBeVisible=C,this.ensureVisibility())}setIsNeeded(C){this._isNeeded!==C&&(this._isNeeded=C,this.ensureVisibility())}setDomNode(C){this._domNode=C,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(C){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(C?" fade":"")))}}t.ScrollbarVisibilityController=W}),define(pe[116],be([1,0,4,22,14,3,2,5]),function(Q,t,y,i,W,B,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class d extends C.Disposable{constructor(f,N,l,n){super(),this.selected=0,this.selectBoxOptions=n||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new B.Emitter),this.styles=l,this.registerListeners(),this.setOptions(f,N)}registerListeners(){this._register(i.Gesture.addTarget(this.selectElement)),[i.EventType.Tap].forEach(f=>{this._register(y.addDisposableListener(this.selectElement,f,N=>{this.selectElement.focus()}))}),this._register(y.addStandardDisposableListener(this.selectElement,"click",f=>{y.EventHelper.stop(f,!0)})),this._register(y.addStandardDisposableListener(this.selectElement,"change",f=>{this.selectElement.title=f.target.value,this._onDidSelect.fire({index:f.target.selectedIndex,selected:f.target.value})})),this._register(y.addStandardDisposableListener(this.selectElement,"keydown",f=>{let N=!1;D.isMacintosh?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(N=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(N=!0),N&&f.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(f,N){(!this.options||!W.equals(this.options,f))&&(this.options=f,this.selectElement.options.length=0,this.options.forEach((l,n)=>{this.selectElement.add(this.createOption(l.text,n,l.isDisabled))})),N!==void 0&&this.select(N)}select(f){this.options.length===0?this.selected=0:f>=0&&f<this.options.length?this.selected=f:f>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(f){this.selectBoxOptions.ariaLabel=f,this.selectElement.setAttribute("aria-label",f)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(f){this.selectElement.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(f){this.styles=f,this.applyStyles()}applyStyles(){if(this.selectElement){const f=this.styles.selectBackground?this.styles.selectBackground.toString():"",N=this.styles.selectForeground?this.styles.selectForeground.toString():"",l=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=f,this.selectElement.style.color=N,this.selectElement.style.borderColor=l}}createOption(f,N,l){const n=document.createElement("option");return n.value=f,n.text=f,n.disabled=!!l,n}}t.SelectBoxNative=d}),define(pe[55],be([1,0,23,14,8,111,3,26]),function(Q,t,y,i,W,B,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function d(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.isFilterResult=d;function c(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.getVisibleState=c;function f(l){return typeof l.collapsible=="boolean"}class N{constructor(n,e,g,b={}){this.user=n,this.list=e,this.rootRef=[],this.eventBufferer=new C.EventBufferer,this._onDidChangeCollapseState=new C.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new C.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new C.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new W.Delayer(W.MicrotaskDelay),this.collapseByDefault=typeof b.collapseByDefault>"u"?!1:b.collapseByDefault,this.filter=b.filter,this.autoExpandSingleChildren=typeof b.autoExpandSingleChildren>"u"?!1:b.autoExpandSingleChildren,this.root={parent:void 0,element:g,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(n,e,g=D.Iterable.empty(),b={}){if(n.length===0)throw new y.TreeError(this.user,"Invalid tree location");b.diffIdentityProvider?this.spliceSmart(b.diffIdentityProvider,n,e,g,b):this.spliceSimple(n,e,g,b)}spliceSmart(n,e,g,b=D.Iterable.empty(),w,E=w.diffDepth??0){const{parentNode:a}=this.getParentNodeWithListIndex(e);if(!a.lastDiffIds)return this.spliceSimple(e,g,b,w);const u=[...b],m=e[e.length-1],S=new B.LcsDiff({getElements:()=>a.lastDiffIds},{getElements:()=>[...a.children.slice(0,m),...u,...a.children.slice(m+g)].map(o=>n.getId(o.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return a.lastDiffIds=void 0,this.spliceSimple(e,g,u,w);const T=e.slice(0,-1),_=(o,s,p)=>{if(E>0)for(let L=0;L<p;L++)o--,s--,this.spliceSmart(n,[...T,o,0],Number.MAX_SAFE_INTEGER,u[s].children,w,E-1)};let r=Math.min(a.children.length,m+g),v=u.length;for(const o of S.changes.sort((s,p)=>p.originalStart-s.originalStart))_(r,v,r-(o.originalStart+o.originalLength)),r=o.originalStart,v=o.modifiedStart-m,this.spliceSimple([...T,r],o.originalLength,D.Iterable.slice(u,v,v+o.modifiedLength),w);_(r,v,r)}spliceSimple(n,e,g=D.Iterable.empty(),{onDidCreateNode:b,onDidDeleteNode:w,diffIdentityProvider:E}){const{parentNode:a,listIndex:u,revealed:m,visible:S}=this.getParentNodeWithListIndex(n),T=[],_=D.Iterable.map(g,oe=>this.createTreeNode(oe,a,a.visible?1:0,m,T,b)),r=n[n.length-1],v=a.children.length>0;let o=0;for(let oe=r;oe>=0&&oe<a.children.length;oe--){const me=a.children[oe];if(me.visible){o=me.visibleChildIndex;break}}const s=[];let p=0,L=0;for(const oe of _)s.push(oe),L+=oe.renderNodeCount,oe.visible&&(oe.visibleChildIndex=o+p++);const V=(0,i.splice)(a.children,r,e,s);E?a.lastDiffIds?(0,i.splice)(a.lastDiffIds,r,e,s.map(oe=>E.getId(oe.element).toString())):a.lastDiffIds=a.children.map(oe=>E.getId(oe.element).toString()):a.lastDiffIds=void 0;let X=0;for(const oe of V)oe.visible&&X++;if(X!==0)for(let oe=r+s.length;oe<a.children.length;oe++){const me=a.children[oe];me.visible&&(me.visibleChildIndex-=X)}if(a.visibleChildrenCount+=p-X,m&&S){const oe=V.reduce((me,he)=>me+(he.visible?he.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(a,L-oe),this.list.splice(u,oe,T)}if(V.length>0&&w){const oe=me=>{w(me),me.children.forEach(oe)};V.forEach(oe)}this._onDidSplice.fire({insertedNodes:s,deletedNodes:V});const J=a.children.length>0;v!==J&&this.setCollapsible(n.slice(0,-1),J);let ge=a;for(;ge;){if(ge.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}ge=ge.parent}}rerender(n){if(n.length===0)throw new y.TreeError(this.user,"Invalid tree location");const{node:e,listIndex:g,revealed:b}=this.getTreeNodeWithListIndex(n);e.visible&&b&&this.list.splice(g,1,[e])}updateElementHeight(n,e){if(n.length===0)throw new y.TreeError(this.user,"Invalid tree location");const{listIndex:g}=this.getTreeNodeWithListIndex(n);this.list.updateElementHeight(g,e)}has(n){return this.hasTreeNode(n)}getListIndex(n){const{listIndex:e,visible:g,revealed:b}=this.getTreeNodeWithListIndex(n);return g&&b?e:-1}getListRenderCount(n){return this.getTreeNode(n).renderNodeCount}isCollapsible(n){return this.getTreeNode(n).collapsible}setCollapsible(n,e){const g=this.getTreeNode(n);typeof e>"u"&&(e=!g.collapsible);const b={collapsible:e};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(n,b))}isCollapsed(n){return this.getTreeNode(n).collapsed}setCollapsed(n,e,g){const b=this.getTreeNode(n);typeof e>"u"&&(e=!b.collapsed);const w={collapsed:e,recursive:g||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(n,w))}_setCollapseState(n,e){const{node:g,listIndex:b,revealed:w}=this.getTreeNodeWithListIndex(n),E=this._setListNodeCollapseState(g,b,w,e);if(g!==this.root&&this.autoExpandSingleChildren&&E&&!f(e)&&g.collapsible&&!g.collapsed&&!e.recursive){let a=-1;for(let u=0;u<g.children.length;u++)if(g.children[u].visible)if(a>-1){a=-1;break}else a=u;a>-1&&this._setCollapseState([...n,a],e)}return E}_setListNodeCollapseState(n,e,g,b){const w=this._setNodeCollapseState(n,b,!1);if(!g||!n.visible||!w)return w;const E=n.renderNodeCount,a=this.updateNodeAfterCollapseChange(n),u=E-(e===-1?0:1);return this.list.splice(e+1,u,a.slice(1)),w}_setNodeCollapseState(n,e,g){let b;if(n===this.root?b=!1:(f(e)?(b=n.collapsible!==e.collapsible,n.collapsible=e.collapsible):n.collapsible?(b=n.collapsed!==e.collapsed,n.collapsed=e.collapsed):b=!1,b&&this._onDidChangeCollapseState.fire({node:n,deep:g})),!f(e)&&e.recursive)for(const w of n.children)b=this._setNodeCollapseState(w,e,!0)||b;return b}expandTo(n){this.eventBufferer.bufferEvents(()=>{let e=this.getTreeNode(n);for(;e.parent;)e=e.parent,n=n.slice(0,n.length-1),e.collapsed&&this._setCollapseState(n,{collapsed:!1,recursive:!1})})}refilter(){const n=this.root.renderNodeCount,e=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,n,e),this.refilterDelayer.cancel()}createTreeNode(n,e,g,b,w,E){const a={parent:e,element:n.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof n.collapsible=="boolean"?n.collapsible:typeof n.collapsed<"u",collapsed:typeof n.collapsed>"u"?this.collapseByDefault:n.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},u=this._filterNode(a,g);a.visibility=u,b&&w.push(a);const m=n.children||D.Iterable.empty(),S=b&&u!==0&&!a.collapsed,T=D.Iterable.map(m,v=>this.createTreeNode(v,a,u,S,w,E));let _=0,r=1;for(const v of T)a.children.push(v),r+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=_++);return a.collapsible=a.collapsible||a.children.length>0,a.visibleChildrenCount=_,a.visible=u===2?_>0:u===1,a.visible?a.collapsed||(a.renderNodeCount=r):(a.renderNodeCount=0,b&&w.pop()),E?.(a),a}updateNodeAfterCollapseChange(n){const e=n.renderNodeCount,g=[];return this._updateNodeAfterCollapseChange(n,g),this._updateAncestorsRenderNodeCount(n.parent,g.length-e),g}_updateNodeAfterCollapseChange(n,e){if(n.visible===!1)return 0;if(e.push(n),n.renderNodeCount=1,!n.collapsed)for(const g of n.children)n.renderNodeCount+=this._updateNodeAfterCollapseChange(g,e);return this._onDidChangeRenderNodeCount.fire(n),n.renderNodeCount}updateNodeAfterFilterChange(n){const e=n.renderNodeCount,g=[];return this._updateNodeAfterFilterChange(n,n.visible?1:0,g),this._updateAncestorsRenderNodeCount(n.parent,g.length-e),g}_updateNodeAfterFilterChange(n,e,g,b=!0){let w;if(n!==this.root){if(w=this._filterNode(n,e),w===0)return n.visible=!1,n.renderNodeCount=0,!1;b&&g.push(n)}const E=g.length;n.renderNodeCount=n===this.root?0:1;let a=!1;if(!n.collapsed||w!==0){let u=0;for(const m of n.children)a=this._updateNodeAfterFilterChange(m,w,g,b&&!n.collapsed)||a,m.visible&&(m.visibleChildIndex=u++);n.visibleChildrenCount=u}else n.visibleChildrenCount=0;return n!==this.root&&(n.visible=w===2?a:w===1,n.visibility=w),n.visible?n.collapsed||(n.renderNodeCount+=g.length-E):(n.renderNodeCount=0,b&&g.pop()),this._onDidChangeRenderNodeCount.fire(n),n.visible}_updateAncestorsRenderNodeCount(n,e){if(e!==0)for(;n;)n.renderNodeCount+=e,this._onDidChangeRenderNodeCount.fire(n),n=n.parent}_filterNode(n,e){const g=this.filter?this.filter.filter(n.element,e):1;return typeof g=="boolean"?(n.filterData=void 0,g?1:0):d(g)?(n.filterData=g.data,c(g.visibility)):(n.filterData=void 0,c(g))}hasTreeNode(n,e=this.root){if(!n||n.length===0)return!0;const[g,...b]=n;return g<0||g>e.children.length?!1:this.hasTreeNode(b,e.children[g])}getTreeNode(n,e=this.root){if(!n||n.length===0)return e;const[g,...b]=n;if(g<0||g>e.children.length)throw new y.TreeError(this.user,"Invalid tree location");return this.getTreeNode(b,e.children[g])}getTreeNodeWithListIndex(n){if(n.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:g,revealed:b,visible:w}=this.getParentNodeWithListIndex(n),E=n[n.length-1];if(E<0||E>e.children.length)throw new y.TreeError(this.user,"Invalid tree location");const a=e.children[E];return{node:a,listIndex:g,revealed:b,visible:w&&a.visible}}getParentNodeWithListIndex(n,e=this.root,g=0,b=!0,w=!0){const[E,...a]=n;if(E<0||E>e.children.length)throw new y.TreeError(this.user,"Invalid tree location");for(let u=0;u<E;u++)g+=e.children[u].renderNodeCount;return b=b&&!e.collapsed,w=w&&e.visible,a.length===0?{parentNode:e,listIndex:g,revealed:b,visible:w}:this.getParentNodeWithListIndex(a,e.children[E],g+1,b,w)}getNode(n=[]){return this.getTreeNode(n)}getNodeLocation(n){const e=[];let g=n;for(;g.parent;)e.push(g.parent.children.indexOf(g)),g=g.parent;return e.reverse()}getParentNodeLocation(n){if(n.length!==0)return n.length===1?[]:(0,i.tail2)(n)[0]}getFirstElementChild(n){const e=this.getTreeNode(n);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(n=[]){const e=this.getTreeNode(n);if(e.children.length!==0)return this._getLastElementAncestor(e)}_getLastElementAncestor(n){return n.children.length===0?n.element:this._getLastElementAncestor(n.children[n.children.length-1])}}t.IndexTreeModel=N}),define(pe[117],be([1,0,55,23,26]),function(Q,t,y,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class B{get size(){return this.nodes.size}constructor(D,d,c={}){this.user=D,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new y.IndexTreeModel(D,d,null,c),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,c.sorter&&(this.sorter={compare(f,N){return c.sorter.compare(f.element,N.element)}}),this.identityProvider=c.identityProvider}setChildren(D,d=W.Iterable.empty(),c={}){const f=this.getElementLocation(D);this._setChildren(f,this.preserveCollapseState(d),c)}_setChildren(D,d=W.Iterable.empty(),c){const f=new Set,N=new Set,l=e=>{if(e.element===null)return;const g=e;if(f.add(g.element),this.nodes.set(g.element,g),this.identityProvider){const b=this.identityProvider.getId(g.element).toString();N.add(b),this.nodesByIdentity.set(b,g)}c.onDidCreateNode?.(g)},n=e=>{if(e.element===null)return;const g=e;if(f.has(g.element)||this.nodes.delete(g.element),this.identityProvider){const b=this.identityProvider.getId(g.element).toString();N.has(b)||this.nodesByIdentity.delete(b)}c.onDidDeleteNode?.(g)};this.model.splice([...D,0],Number.MAX_VALUE,d,{...c,onDidCreateNode:l,onDidDeleteNode:n})}preserveCollapseState(D=W.Iterable.empty()){return this.sorter&&(D=[...D].sort(this.sorter.compare.bind(this.sorter))),W.Iterable.map(D,d=>{let c=this.nodes.get(d.element);if(!c&&this.identityProvider){const l=this.identityProvider.getId(d.element).toString();c=this.nodesByIdentity.get(l)}if(!c)return{...d,children:this.preserveCollapseState(d.children)};const f=typeof d.collapsible=="boolean"?d.collapsible:c.collapsible,N=typeof d.collapsed<"u"?d.collapsed:c.collapsed;return{...d,collapsible:f,collapsed:N,children:this.preserveCollapseState(d.children)}})}rerender(D){const d=this.getElementLocation(D);this.model.rerender(d)}updateElementHeight(D,d){const c=this.getElementLocation(D);this.model.updateElementHeight(c,d)}resort(D=null,d=!0){if(!this.sorter)return;const c=this.getElementLocation(D),f=this.model.getNode(c);this._setChildren(c,this.resortChildren(f,d),{})}resortChildren(D,d,c=!0){let f=[...D.children];return(d||c)&&(f=f.sort(this.sorter.compare.bind(this.sorter))),W.Iterable.map(f,N=>({element:N.element,collapsible:N.collapsible,collapsed:N.collapsed,children:this.resortChildren(N,d,!1)}))}getFirstElementChild(D=null){const d=this.getElementLocation(D);return this.model.getFirstElementChild(d)}getLastElementAncestor(D=null){const d=this.getElementLocation(D);return this.model.getLastElementAncestor(d)}has(D){return this.nodes.has(D)}getListIndex(D){const d=this.getElementLocation(D);return this.model.getListIndex(d)}getListRenderCount(D){const d=this.getElementLocation(D);return this.model.getListRenderCount(d)}isCollapsible(D){const d=this.getElementLocation(D);return this.model.isCollapsible(d)}setCollapsible(D,d){const c=this.getElementLocation(D);return this.model.setCollapsible(c,d)}isCollapsed(D){const d=this.getElementLocation(D);return this.model.isCollapsed(d)}setCollapsed(D,d,c){const f=this.getElementLocation(D);return this.model.setCollapsed(f,d,c)}expandTo(D){const d=this.getElementLocation(D);this.model.expandTo(d)}refilter(){this.model.refilter()}getNode(D=null){if(D===null)return this.model.getNode(this.model.rootRef);const d=this.nodes.get(D);if(!d)throw new i.TreeError(this.user,`Tree element not found: ${D}`);return d}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new i.TreeError(this.user,"Invalid getParentNodeLocation call");const d=this.nodes.get(D);if(!d)throw new i.TreeError(this.user,`Tree element not found: ${D}`);const c=this.model.getNodeLocation(d),f=this.model.getParentNodeLocation(c);return this.model.getNode(f).element}getElementLocation(D){if(D===null)return[];const d=this.nodes.get(D);if(!d)throw new i.TreeError(this.user,`Tree element not found: ${D}`);return this.model.getNodeLocation(d)}}t.ObjectTreeModel=B}),define(pe[17],be([1,0,4,19,20,22,2]),function(Q,t,y,i,W,B,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class D extends C.Disposable{onclick(c,f){this._register(y.addDisposableListener(c,y.EventType.CLICK,N=>f(new W.StandardMouseEvent(N))))}onmousedown(c,f){this._register(y.addDisposableListener(c,y.EventType.MOUSE_DOWN,N=>f(new W.StandardMouseEvent(N))))}onmouseover(c,f){this._register(y.addDisposableListener(c,y.EventType.MOUSE_OVER,N=>f(new W.StandardMouseEvent(N))))}onmouseleave(c,f){this._register(y.addDisposableListener(c,y.EventType.MOUSE_LEAVE,N=>f(new W.StandardMouseEvent(N))))}onkeydown(c,f){this._register(y.addDisposableListener(c,y.EventType.KEY_DOWN,N=>f(new i.StandardKeyboardEvent(N))))}onkeyup(c,f){this._register(y.addDisposableListener(c,y.EventType.KEY_UP,N=>f(new i.StandardKeyboardEvent(N))))}oninput(c,f){this._register(y.addDisposableListener(c,y.EventType.INPUT,f))}onblur(c,f){this._register(y.addDisposableListener(c,y.EventType.BLUR,f))}onfocus(c,f){this._register(y.addDisposableListener(c,y.EventType.FOCUS,f))}onchange(c,f){this._register(y.addDisposableListener(c,y.EventType.CHANGE,f))}ignoreGesture(c){B.Gesture.ignoreTarget(c)}}t.Widget=D}),define(pe[37],be([1,0,53,17,8,4]),function(Q,t,y,i,W,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class C extends i.Widget{constructor(d){super(),this._onActivate=d.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=d.bgWidth+"px",this.bgDomNode.style.height=d.bgHeight+"px",typeof d.top<"u"&&(this.bgDomNode.style.top="0px"),typeof d.left<"u"&&(this.bgDomNode.style.left="0px"),typeof d.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof d.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=d.className,this.domNode.classList.add(...d.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof d.top<"u"&&(this.domNode.style.top=d.top+"px"),typeof d.left<"u"&&(this.domNode.style.left=d.left+"px"),typeof d.bottom<"u"&&(this.domNode.style.bottom=d.bottom+"px"),typeof d.right<"u"&&(this.domNode.style.right=d.right+"px"),this._pointerMoveMonitor=this._register(new y.GlobalPointerMoveMonitor),this._register(B.addStandardDisposableListener(this.bgDomNode,B.EventType.POINTER_DOWN,c=>this._arrowPointerDown(c))),this._register(B.addStandardDisposableListener(this.domNode,B.EventType.POINTER_DOWN,c=>this._arrowPointerDown(c))),this._pointerdownRepeatTimer=this._register(new W.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new W.TimeoutTimer)}_arrowPointerDown(d){if(!d.target||!(d.target instanceof Element))return;const c=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(c,200),this._pointerMoveMonitor.startMonitoring(d.target,d.pointerId,d.buttons,f=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),d.preventDefault()}}t.ScrollbarArrow=C}),define(pe[56],be([1,0,4,40,53,37,115,17,5]),function(Q,t,y,i,W,B,C,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const c=140;class f extends D.Widget{constructor(l){super(),this._lazyRender=l.lazyRender,this._host=l.host,this._scrollable=l.scrollable,this._scrollByPage=l.scrollByPage,this._scrollbarState=l.scrollbarState,this._visibilityController=this._register(new C.ScrollbarVisibilityController(l.visibility,"visible scrollbar "+l.extraScrollbarClassName,"invisible scrollbar "+l.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new W.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(y.addDisposableListener(this.domNode.domNode,y.EventType.POINTER_DOWN,n=>this._domNodePointerDown(n)))}_createArrow(l){const n=this._register(new B.ScrollbarArrow(l));this.domNode.domNode.appendChild(n.bgDomNode),this.domNode.domNode.appendChild(n.domNode)}_createSlider(l,n,e,g){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(l),this.slider.setLeft(n),typeof e=="number"&&this.slider.setWidth(e),typeof g=="number"&&this.slider.setHeight(g),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(y.addDisposableListener(this.slider.domNode,y.EventType.POINTER_DOWN,b=>{b.button===0&&(b.preventDefault(),this._sliderPointerDown(b))})),this.onclick(this.slider.domNode,b=>{b.leftButton&&b.stopPropagation()})}_onElementSize(l){return this._scrollbarState.setVisibleSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(l){return this._scrollbarState.setScrollSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(l){return this._scrollbarState.setScrollPosition(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(l){l.target===this.domNode.domNode&&this._onPointerDown(l)}delegatePointerDown(l){const n=this.domNode.domNode.getClientRects()[0].top,e=n+this._scrollbarState.getSliderPosition(),g=n+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),b=this._sliderPointerPosition(l);e<=b&&b<=g?l.button===0&&(l.preventDefault(),this._sliderPointerDown(l)):this._onPointerDown(l)}_onPointerDown(l){let n,e;if(l.target===this.domNode.domNode&&typeof l.offsetX=="number"&&typeof l.offsetY=="number")n=l.offsetX,e=l.offsetY;else{const b=y.getDomNodePagePosition(this.domNode.domNode);n=l.pageX-b.left,e=l.pageY-b.top}const g=this._pointerDownRelativePosition(n,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(g):this._scrollbarState.getDesiredScrollPositionFromOffset(g)),l.button===0&&(l.preventDefault(),this._sliderPointerDown(l))}_sliderPointerDown(l){if(!l.target||!(l.target instanceof Element))return;const n=this._sliderPointerPosition(l),e=this._sliderOrthogonalPointerPosition(l),g=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(l.target,l.pointerId,l.buttons,b=>{const w=this._sliderOrthogonalPointerPosition(b),E=Math.abs(w-e);if(d.isWindows&&E>c){this._setDesiredScrollPositionNow(g.getScrollPosition());return}const u=this._sliderPointerPosition(b)-n;this._setDesiredScrollPositionNow(g.getDesiredScrollPositionFromDelta(u))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(l){const n={};this.writeScrollPosition(n,l),this._scrollable.setScrollPositionNow(n)}updateScrollbarSize(l){this._updateScrollbarSize(l),this._scrollbarState.setScrollbarSize(l),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=f}),define(pe[118],be([1,0,20,56,37,41,12]),function(Q,t,y,i,W,B,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class D extends i.AbstractScrollbar{constructor(c,f,N){const l=c.getScrollDimensions(),n=c.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:N,scrollbarState:new B.ScrollbarState(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,l.width,l.scrollWidth,n.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:c,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-W.ARROW_IMG_SIZE)/2,g=(f.horizontalScrollbarSize-W.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonLeft,top:g,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonRight,top:g,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}_updateSlider(c,f){this.slider.setWidth(c),this.slider.setLeft(f)}_renderDomNode(c,f){this.domNode.setWidth(c),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(c){return this._shouldRender=this._onElementScrollSize(c.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(c.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(c.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(c,f){return c}_sliderPointerPosition(c){return c.pageX}_sliderOrthogonalPointerPosition(c){return c.pageY}_updateScrollbarSize(c){this.slider.setHeight(c)}writeScrollPosition(c,f){c.scrollLeft=f}updateOptions(c){this.updateScrollbarSize(c.horizontal===2?0:c.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(c.vertical===2?0:c.verticalScrollbarSize),this._visibilityController.setVisibility(c.horizontal),this._scrollByPage=c.scrollByPage}}t.HorizontalScrollbar=D}),define(pe[119],be([1,0,20,56,37,41,12]),function(Q,t,y,i,W,B,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class D extends i.AbstractScrollbar{constructor(c,f,N){const l=c.getScrollDimensions(),n=c.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:N,scrollbarState:new B.ScrollbarState(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,l.height,l.scrollHeight,n.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:c,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-W.ARROW_IMG_SIZE)/2,g=(f.verticalScrollbarSize-W.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonUp,top:e,left:g,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonDown,top:void 0,left:g,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this._host.onMouseWheel(new y.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}_updateSlider(c,f){this.slider.setHeight(c),this.slider.setTop(f)}_renderDomNode(c,f){this.domNode.setWidth(f),this.domNode.setHeight(c),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(c){return this._shouldRender=this._onElementScrollSize(c.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(c.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(c.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(c,f){return f}_sliderPointerPosition(c){return c.pageY}_sliderOrthogonalPointerPosition(c){return c.pageX}_updateScrollbarSize(c){this.slider.setWidth(c)}writeScrollPosition(c,f){c.scrollTop=f}updateOptions(c){this.updateScrollbarSize(c.vertical===2?0:c.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(c.vertical),this._scrollByPage=c.scrollByPage}}t.VerticalScrollbar=D}),define(pe[57],be([1,0,15,4,40,20,118,119,17,8,3,2,5,48,89]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,g=50,b=!0;class w{constructor(r,v,o){this.timestamp=r,this.deltaX=v,this.deltaY=o,this.score=0}}class E{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let r=1,v=0,o=1,s=this._rear;do{const p=s===this._front?r:Math.pow(2,-o);if(r-=p,v+=this._memory[s].score*p,s===this._front)break;s=(this._capacity+s-1)%this._capacity,o++}while(!0);return v<=.5}accept(r,v,o){const s=new w(r,v,o);s.score=this._computeScore(s),this._front===-1&&this._rear===-1?(this._memory[0]=s,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=s)}_computeScore(r){if(Math.abs(r.deltaX)>0&&Math.abs(r.deltaY)>0)return 1;let v=.5;const o=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(r.deltaX)||!this._isAlmostInt(r.deltaY))&&(v+=.25),Math.min(Math.max(v,0),1)}_isAlmostInt(r){return Math.abs(Math.round(r)-r)<.01}}t.MouseWheelClassifier=E,E.INSTANCE=new E;class a extends d.Widget{get options(){return this._options}constructor(r,v,o){super(),this._onScroll=this._register(new f.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new f.Emitter),this.onWillScroll=this._onWillScroll.event,r.style.overflow="hidden",this._options=T(v),this._scrollable=o,this._register(this._scrollable.onScroll(p=>{this._onWillScroll.fire(p),this._onDidScroll(p),this._onScroll.fire(p)}));const s={onMouseWheel:p=>this._onMouseWheel(p),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new D.VerticalScrollbar(this._scrollable,this._options,s)),this._horizontalScrollbar=this._register(new C.HorizontalScrollbar(this._scrollable,this._options,s)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(r),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,W.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,W.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,W.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,p=>this._onMouseOver(p)),this.onmouseleave(this._listenOnDomNode,p=>this._onMouseLeave(p)),this._hideTimeout=this._register(new c.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,N.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(r){this._verticalScrollbar.delegatePointerDown(r)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(r){this._scrollable.setScrollDimensions(r,!1)}updateClassName(r){this._options.className=r,l.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(r){typeof r.handleMouseWheel<"u"&&(this._options.handleMouseWheel=r.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof r.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=r.mouseWheelScrollSensitivity),typeof r.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=r.fastScrollSensitivity),typeof r.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=r.scrollPredominantAxis),typeof r.horizontal<"u"&&(this._options.horizontal=r.horizontal),typeof r.vertical<"u"&&(this._options.vertical=r.vertical),typeof r.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=r.horizontalScrollbarSize),typeof r.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=r.verticalScrollbarSize),typeof r.scrollByPage<"u"&&(this._options.scrollByPage=r.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(r){this._revealOnScroll=r}delegateScrollFromMouseWheelEvent(r){this._onMouseWheel(new B.StandardWheelEvent(r))}_setListeningToMouseWheel(r){if(this._mouseWheelToDispose.length>0!==r&&(this._mouseWheelToDispose=(0,N.dispose)(this._mouseWheelToDispose),r)){const o=s=>{this._onMouseWheel(new B.StandardWheelEvent(s))};this._mouseWheelToDispose.push(i.addDisposableListener(this._listenOnDomNode,i.EventType.MOUSE_WHEEL,o,{passive:!1}))}}_onMouseWheel(r){const v=E.INSTANCE;if(b){const p=window.devicePixelRatio/(0,y.getZoomFactor)();l.isWindows||l.isLinux?v.accept(Date.now(),r.deltaX/p,r.deltaY/p):v.accept(Date.now(),r.deltaX,r.deltaY)}let o=!1;if(r.deltaY||r.deltaX){let p=r.deltaY*this._options.mouseWheelScrollSensitivity,L=r.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(p)>=Math.abs(L)?L=0:p=0),this._options.flipAxes&&([p,L]=[L,p]);const V=!l.isMacintosh&&r.browserEvent&&r.browserEvent.shiftKey;(this._options.scrollYToX||V)&&!L&&(L=p,p=0),r.browserEvent&&r.browserEvent.altKey&&(L=L*this._options.fastScrollSensitivity,p=p*this._options.fastScrollSensitivity);const X=this._scrollable.getFutureScrollPosition();let J={};if(p){const ge=g*p,oe=X.scrollTop-(ge<0?Math.floor(ge):Math.ceil(ge));this._verticalScrollbar.writeScrollPosition(J,oe)}if(L){const ge=g*L,oe=X.scrollLeft-(ge<0?Math.floor(ge):Math.ceil(ge));this._horizontalScrollbar.writeScrollPosition(J,oe)}J=this._scrollable.validateScrollPosition(J),(X.scrollLeft!==J.scrollLeft||X.scrollTop!==J.scrollTop)&&(b&&this._options.mouseWheelSmoothScroll&&v.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(J):this._scrollable.setScrollPositionNow(J),o=!0)}let s=o;!s&&this._options.alwaysConsumeMouseWheel&&(s=!0),!s&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(s=!0),s&&(r.preventDefault(),r.stopPropagation())}_onDidScroll(r){this._shouldRender=this._horizontalScrollbar.onDidScroll(r)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(r)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const r=this._scrollable.getCurrentScrollPosition(),v=r.scrollTop>0,o=r.scrollLeft>0,s=o?" left":"",p=v?" top":"",L=o||v?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${s}`),this._topShadowDomNode.setClassName(`shadow${p}`),this._topLeftShadowDomNode.setClassName(`shadow${L}${p}${s}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(r){this._mouseIsOver=!1,this._hide()}_onMouseOver(r){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=a;class u extends a{constructor(r,v){v=v||{},v.mouseWheelSmoothScroll=!1;const o=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:s=>i.scheduleAtNextAnimationFrame(s)});super(r,v,o),this._register(o)}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=u;class m extends a{constructor(r,v,o){super(r,v,o)}setScrollPosition(r){r.reuseAnimation?this._scrollable.setScrollPositionSmooth(r,r.reuseAnimation):this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=m;class S extends a{constructor(r,v){v=v||{},v.mouseWheelSmoothScroll=!1;const o=new n.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:s=>i.scheduleAtNextAnimationFrame(s)});super(r,v,o),this._register(o),this._element=r,this.onScroll(s=>{s.scrollTopChanged&&(this._element.scrollTop=s.scrollTop),s.scrollLeftChanged&&(this._element.scrollLeft=s.scrollLeft)}),this.scanDomNode()}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=S;function T(_){const r={lazyRender:typeof _.lazyRender<"u"?_.lazyRender:!1,className:typeof _.className<"u"?_.className:"",useShadows:typeof _.useShadows<"u"?_.useShadows:!0,handleMouseWheel:typeof _.handleMouseWheel<"u"?_.handleMouseWheel:!0,flipAxes:typeof _.flipAxes<"u"?_.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof _.consumeMouseWheelIfScrollbarIsNeeded<"u"?_.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof _.alwaysConsumeMouseWheel<"u"?_.alwaysConsumeMouseWheel:!1,scrollYToX:typeof _.scrollYToX<"u"?_.scrollYToX:!1,mouseWheelScrollSensitivity:typeof _.mouseWheelScrollSensitivity<"u"?_.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof _.fastScrollSensitivity<"u"?_.fastScrollSensitivity:5,scrollPredominantAxis:typeof _.scrollPredominantAxis<"u"?_.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof _.mouseWheelSmoothScroll<"u"?_.mouseWheelSmoothScroll:!0,arrowSize:typeof _.arrowSize<"u"?_.arrowSize:11,listenOnDomNode:typeof _.listenOnDomNode<"u"?_.listenOnDomNode:null,horizontal:typeof _.horizontal<"u"?_.horizontal:1,horizontalScrollbarSize:typeof _.horizontalScrollbarSize<"u"?_.horizontalScrollbarSize:10,horizontalSliderSize:typeof _.horizontalSliderSize<"u"?_.horizontalSliderSize:0,horizontalHasArrows:typeof _.horizontalHasArrows<"u"?_.horizontalHasArrows:!1,vertical:typeof _.vertical<"u"?_.vertical:1,verticalScrollbarSize:typeof _.verticalScrollbarSize<"u"?_.verticalScrollbarSize:10,verticalHasArrows:typeof _.verticalHasArrows<"u"?_.verticalHasArrows:!1,verticalSliderSize:typeof _.verticalSliderSize<"u"?_.verticalSliderSize:0,scrollByPage:typeof _.scrollByPage<"u"?_.scrollByPage:!1};return r.horizontalSliderSize=typeof _.horizontalSliderSize<"u"?_.horizontalSliderSize:r.horizontalScrollbarSize,r.verticalSliderSize=typeof _.verticalSliderSize<"u"?_.verticalSliderSize:r.verticalScrollbarSize,l.isMacintosh&&(r.className+=" mac"),r}}),define(pe[58],be([1,0,15,51,4,18,22,57,14,8,25,3,2,46,48,78,114,9]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l,n,e,g,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const E={CurrentDragAndDropData:void 0},a={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(v){return[v]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class u{get context(){return this._context}set context(o){this._context=o}constructor(o){this.elements=o}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=u;class m{constructor(o){this.elements=o}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=m;class S{constructor(){this.types=[],this.files=[]}update(o){if(o.types&&this.types.splice(0,this.types.length,...o.types),o.files){this.files.splice(0,this.files.length);for(let s=0;s<o.files.length;s++){const p=o.files.item(s);p&&(p.size||p.type)&&this.files.push(p)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=S;function T(v,o){return Array.isArray(v)&&Array.isArray(o)?(0,d.equals)(v,o):v===o}class _{constructor(o){o?.getSetSize?this.getSetSize=o.getSetSize.bind(o):this.getSetSize=(s,p,L)=>L,o?.getPosInSet?this.getPosInSet=o.getPosInSet.bind(o):this.getPosInSet=(s,p)=>p+1,o?.getRole?this.getRole=o.getRole.bind(o):this.getRole=s=>"listitem",o?.isChecked?this.isChecked=o.isChecked.bind(o):this.isChecked=s=>{}}}class r{get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(o){if(o!==this._horizontalScrolling){if(o&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=o,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const s of this.items)this.measureItemWidth(s);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,W.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(o,s,p,L=a){if(this.virtualDelegate=s,this.domId=`list_id_${++r.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new c.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=l.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=l.Disposable.None,this.onDragLeaveTimeout=l.Disposable.None,this.disposables=new l.DisposableStore,this._onDidChangeContentHeight=new N.Emitter,this.onDidChangeContentHeight=N.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,L.horizontalScrolling&&L.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new g.RangeMap;for(const X of p)this.renderers.set(X.templateId,X);this.cache=this.disposables.add(new b.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof L.mouseSupport=="boolean"?L.mouseSupport:!0),this._horizontalScrolling=L.horizontalScrolling??a.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof L.additionalScrollHeight>"u"?0:L.additionalScrollHeight,this.accessibilityProvider=new _(L.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(L.transformOptimization??a.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)"),this.disposables.add(C.Gesture.addTarget(this.rowsContainer)),this.scrollable=new e.Scrollable({forceIntegerValues:!0,smoothScrollDuration:L.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:X=>(0,W.scheduleAtNextAnimationFrame)(X)}),this.scrollableElement=this.disposables.add(new D.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:L.alwaysConsumeMouseWheel??a.alwaysConsumeMouseWheel,horizontal:1,vertical:L.verticalScrollMode??a.verticalScrollMode,useShadows:L.useShadows??a.useShadows,mouseWheelScrollSensitivity:L.mouseWheelScrollSensitivity,fastScrollSensitivity:L.fastScrollSensitivity},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),o.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,W.addDisposableListener)(this.rowsContainer,C.EventType.Change,X=>this.onTouchChange(X))),this.disposables.add((0,W.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",X=>X.target.scrollTop=0)),this.disposables.add((0,W.addDisposableListener)(this.domNode,"dragover",X=>this.onDragOver(this.toDragEvent(X)))),this.disposables.add((0,W.addDisposableListener)(this.domNode,"drop",X=>this.onDrop(this.toDragEvent(X)))),this.disposables.add((0,W.addDisposableListener)(this.domNode,"dragleave",X=>this.onDragLeave(this.toDragEvent(X)))),this.disposables.add((0,W.addDisposableListener)(this.domNode,"dragend",X=>this.onDragEnd(X))),this.setRowLineHeight=L.setRowLineHeight??a.setRowLineHeight,this.setRowHeight=L.setRowHeight??a.setRowHeight,this.supportDynamicHeights=L.supportDynamicHeights??a.supportDynamicHeights,this.dnd=L.dnd??a.dnd,this.layout()}updateOptions(o){o.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=o.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),o.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(o.smoothScrolling?125:0),o.horizontalScrolling!==void 0&&(this.horizontalScrolling=o.horizontalScrolling),o.mouseWheelScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({mouseWheelScrollSensitivity:o.mouseWheelScrollSensitivity}),o.fastScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({fastScrollSensitivity:o.fastScrollSensitivity})}delegateScrollFromMouseWheelEvent(o){this.scrollableElement.delegateScrollFromMouseWheelEvent(o)}delegateVerticalScrollbarPointerDown(o){this.scrollableElement.delegateVerticalScrollbarPointerDown(o)}updateElementHeight(o,s,p){if(o<0||o>=this.items.length)return;const L=this.items[o].size;if(typeof s>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[o].lastDynamicHeightWidth=void 0,s=L+this.probeDynamicHeight(o)}if(L===s)return;const V=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let X=0;o<V.start||p!==null&&p>o&&p<=V.end?X=s-L:X=0,this.rangeMap.splice(o,1,[{size:s}]),this.items[o].size=s,this.render(V,Math.max(0,this.lastRenderTop+X),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(o,s,p=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(o,s,p)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(o,s,p=[]){const L=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),V={start:o,end:o+s},X=n.Range.intersect(L,V),J=new Map;for(let j=X.end-1;j>=X.start;j--){const P=this.items[j];if(P.dragStartDisposable.dispose(),P.checkedDisposable.dispose(),P.row){let h=J.get(P.templateId);h||(h=[],J.set(P.templateId,h));const I=this.renderers.get(P.templateId);I&&I.disposeElement&&I.disposeElement(P.element,j,P.row.templateData,P.size),h.push(P.row)}P.row=null}const ge={start:o+s,end:this.items.length},oe=n.Range.intersect(ge,L),me=n.Range.relativeComplement(ge,L),he=p.map(j=>({id:String(this.itemId++),element:j,templateId:this.virtualDelegate.getTemplateId(j),size:this.virtualDelegate.getHeight(j),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(j),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:l.Disposable.None,checkedDisposable:l.Disposable.None}));let ae;o===0&&s>=this.items.length?(this.rangeMap=new g.RangeMap,this.rangeMap.splice(0,0,he),ae=this.items,this.items=he):(this.rangeMap.splice(o,s,he),ae=this.items.splice(o,s,...he));const Se=p.length-s,te=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),De=(0,g.shift)(oe,Se),se=n.Range.intersect(te,De);for(let j=se.start;j<se.end;j++)this.updateItemInDOM(this.items[j],j);const ie=n.Range.relativeComplement(De,te);for(const j of ie)for(let P=j.start;P<j.end;P++)this.removeItemFromDOM(P);const ce=me.map(j=>(0,g.shift)(j,Se)),F=[{start:o,end:o+p.length},...ce].map(j=>n.Range.intersect(te,j)),$=this.getNextToLastElement(F);for(const j of F)for(let P=j.start;P<j.end;P++){const h=this.items[P],U=J.get(h.templateId)?.pop();this.insertItemInDOM(P,$,U)}for(const j of J.values())for(const P of j)this.cache.release(P);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),ae.map(j=>j.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,W.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let o=0;for(const s of this.items)typeof s.width<"u"&&(o=Math.max(o,s.width));this.scrollWidth=o,this.scrollableElement.setScrollDimensions({scrollWidth:o===0?0:o+10})}updateWidth(o){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const s=this.items[o];this.measureItemWidth(s),typeof s.width<"u"&&s.width>this.scrollWidth&&(this.scrollWidth=s.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const o of this.items)o.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const o=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),s=this.rangeMap.positionAt(o.start),p=this.rangeMap.positionAt(o.start+1);return p!==-1&&(p-s)/2+s<this.scrollTop?o.start+1:o.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(o){return this.items[o].element}indexOf(o){return this.items.findIndex(s=>s.element===o)}domElement(o){const s=this.items[o].row;return s&&s.domNode}elementHeight(o){return this.items[o].size}elementTop(o){return this.rangeMap.positionAt(o)}indexAt(o){return this.rangeMap.indexAt(o)}indexAfter(o){return this.rangeMap.indexAfter(o)}layout(o,s){const p={height:typeof o=="number"?o:(0,W.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,p.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(p),typeof s<"u"&&(this.renderWidth=s,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof s=="number"?s:(0,W.getContentWidth)(this.domNode)})}render(o,s,p,L,V,X=!1){const J=this.getRenderRange(s,p),ge=n.Range.relativeComplement(J,o),oe=n.Range.relativeComplement(o,J),me=this.getNextToLastElement(ge);if(X){const he=n.Range.intersect(o,J);for(let ae=he.start;ae<he.end;ae++)this.updateItemInDOM(this.items[ae],ae)}for(const he of ge)for(let ae=he.start;ae<he.end;ae++)this.insertItemInDOM(ae,me);for(const he of oe)for(let ae=he.start;ae<he.end;ae++)this.removeItemFromDOM(ae);L!==void 0&&(this.rowsContainer.style.left=`-${L}px`),this.rowsContainer.style.top=`-${s}px`,this.horizontalScrolling&&V!==void 0&&(this.rowsContainer.style.width=`${Math.max(V,this.renderWidth)}px`),this.lastRenderTop=s,this.lastRenderHeight=p}insertItemInDOM(o,s,p){const L=this.items[o];L.row||(L.row=p??this.cache.alloc(L.templateId));const V=this.accessibilityProvider.getRole(L.element)||"listitem";L.row.domNode.setAttribute("role",V);const X=this.accessibilityProvider.isChecked(L.element);if(typeof X=="boolean")L.row.domNode.setAttribute("aria-checked",String(!!X));else if(X){const oe=me=>L.row.domNode.setAttribute("aria-checked",String(!!me));oe(X.value),L.checkedDisposable=X.onDidChange(oe)}L.row.domNode.parentElement||(s?this.rowsContainer.insertBefore(L.row.domNode,s):this.rowsContainer.appendChild(L.row.domNode)),this.updateItemInDOM(L,o);const J=this.renderers.get(L.templateId);if(!J)throw new Error(`No renderer found for template id ${L.templateId}`);J?.renderElement(L.element,o,L.row.templateData,L.size);const ge=this.dnd.getDragURI(L.element);L.dragStartDisposable.dispose(),L.row.domNode.draggable=!!ge,ge&&(L.dragStartDisposable=(0,W.addDisposableListener)(L.row.domNode,"dragstart",oe=>this.onDragStart(L.element,ge,oe))),this.horizontalScrolling&&(this.measureItemWidth(L),this.eventuallyUpdateScrollWidth())}measureItemWidth(o){if(!o.row||!o.row.domNode)return;o.row.domNode.style.width=y.isFirefox?"-moz-fit-content":"fit-content",o.width=(0,W.getContentWidth)(o.row.domNode);const s=window.getComputedStyle(o.row.domNode);s.paddingLeft&&(o.width+=parseFloat(s.paddingLeft)),s.paddingRight&&(o.width+=parseFloat(s.paddingRight)),o.row.domNode.style.width=""}updateItemInDOM(o,s){o.row.domNode.style.top=`${this.elementTop(s)}px`,this.setRowHeight&&(o.row.domNode.style.height=`${o.size}px`),this.setRowLineHeight&&(o.row.domNode.style.lineHeight=`${o.size}px`),o.row.domNode.setAttribute("data-index",`${s}`),o.row.domNode.setAttribute("data-last-element",s===this.length-1?"true":"false"),o.row.domNode.setAttribute("data-parity",s%2===0?"even":"odd"),o.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(o.element,s,this.length))),o.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(o.element,s))),o.row.domNode.setAttribute("id",this.getElementDomId(s)),o.row.domNode.classList.toggle("drop-target",o.dropTarget)}removeItemFromDOM(o){const s=this.items[o];if(s.dragStartDisposable.dispose(),s.checkedDisposable.dispose(),s.row){const p=this.renderers.get(s.templateId);p&&p.disposeElement&&p.disposeElement(s.element,o,s.row.templateData,s.size),this.cache.release(s.row),s.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(o,s){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:o,reuseAnimation:s})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(o){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:o})}get scrollTop(){return this.getScrollTop()}set scrollTop(o){this.setScrollTop(o)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"click")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseDblClick(){return N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"dblclick")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseMiddleClick(){return N.Event.filter(N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"auxclick")).event,o=>this.toMouseEvent(o),this.disposables),o=>o.browserEvent.button===1,this.disposables)}get onMouseUp(){return N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mouseup")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseDown(){return N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mousedown")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseOver(){return N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mouseover")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseMove(){return N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mousemove")).event,o=>this.toMouseEvent(o),this.disposables)}get onMouseOut(){return N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"mouseout")).event,o=>this.toMouseEvent(o),this.disposables)}get onContextMenu(){return N.Event.any(N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"contextmenu")).event,o=>this.toMouseEvent(o),this.disposables),N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,C.EventType.Contextmenu)).event,o=>this.toGestureEvent(o),this.disposables))}get onTouchStart(){return N.Event.map(this.disposables.add(new B.DomEmitter(this.domNode,"touchstart")).event,o=>this.toTouchEvent(o),this.disposables)}get onTap(){return N.Event.map(this.disposables.add(new B.DomEmitter(this.rowsContainer,C.EventType.Tap)).event,o=>this.toGestureEvent(o),this.disposables)}toMouseEvent(o){const s=this.getItemIndexFromEventTarget(o.target||null),p=typeof s>"u"?void 0:this.items[s],L=p&&p.element;return{browserEvent:o,index:s,element:L}}toTouchEvent(o){const s=this.getItemIndexFromEventTarget(o.target||null),p=typeof s>"u"?void 0:this.items[s],L=p&&p.element;return{browserEvent:o,index:s,element:L}}toGestureEvent(o){const s=this.getItemIndexFromEventTarget(o.initialTarget||null),p=typeof s>"u"?void 0:this.items[s],L=p&&p.element;return{browserEvent:o,index:s,element:L}}toDragEvent(o){const s=this.getItemIndexFromEventTarget(o.target||null),p=typeof s>"u"?void 0:this.items[s],L=p&&p.element;return{browserEvent:o,index:s,element:L}}onScroll(o){try{const s=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(s,o.scrollTop,o.height,o.scrollLeft,o.scrollWidth),this.supportDynamicHeights&&this._rerender(o.scrollTop,o.height,o.inSmoothScrolling)}catch(s){throw console.error("Got bad scroll event:",o),s}}onTouchChange(o){o.preventDefault(),o.stopPropagation(),this.scrollTop-=o.translationY}onDragStart(o,s,p){if(!p.dataTransfer)return;const L=this.dnd.getDragElements(o);if(p.dataTransfer.effectAllowed="copyMove",p.dataTransfer.setData(i.DataTransfers.TEXT,s),p.dataTransfer.setDragImage){let V;this.dnd.getDragLabel&&(V=this.dnd.getDragLabel(L,p)),typeof V>"u"&&(V=String(L.length));const X=(0,W.$)(".monaco-drag-image");X.textContent=V,document.body.appendChild(X),p.dataTransfer.setDragImage(X,-10,-10),setTimeout(()=>document.body.removeChild(X),0)}this.domNode.classList.add("dragging"),this.currentDragData=new u(L),E.CurrentDragAndDropData=new m(L),this.dnd.onDragStart?.(this.currentDragData,p)}onDragOver(o){if(o.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),E.CurrentDragAndDropData&&E.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(o.browserEvent),!o.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(E.CurrentDragAndDropData)this.currentDragData=E.CurrentDragAndDropData;else{if(!o.browserEvent.dataTransfer.types)return!1;this.currentDragData=new S}const s=this.dnd.onDragOver(this.currentDragData,o.element,o.index,o.browserEvent);if(this.canDrop=typeof s=="boolean"?s:s.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;o.browserEvent.dataTransfer.dropEffect=typeof s!="boolean"&&s.effect===0?"copy":"move";let p;if(typeof s!="boolean"&&s.feedback?p=s.feedback:typeof o.index>"u"?p=[-1]:p=[o.index],p=(0,d.distinct)(p).filter(L=>L>=-1&&L<this.length).sort((L,V)=>L-V),p=p[0]===-1?[-1]:p,T(this.currentDragFeedback,p))return!0;if(this.currentDragFeedback=p,this.currentDragFeedbackDisposable.dispose(),p[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,l.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const L of p){const V=this.items[L];V.dropTarget=!0,V.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,l.toDisposable)(()=>{for(const L of p){const V=this.items[L];V.dropTarget=!1,V.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(o){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,c.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,o.element,o.index,o.browserEvent)}onDrop(o){if(!this.canDrop)return;const s=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,E.CurrentDragAndDropData=void 0,!(!s||!o.browserEvent.dataTransfer)&&(o.browserEvent.preventDefault(),s.update(o.browserEvent.dataTransfer),this.dnd.drop(s,o.element,o.index,o.browserEvent))}onDragEnd(o){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,E.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(o)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=l.Disposable.None}setupDragAndDropScrollTopAnimation(o){if(!this.dragOverAnimationDisposable){const s=(0,W.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,W.animate)(this.animateDragAndDropScrollTop.bind(this,s))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,c.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=o.pageY}animateDragAndDropScrollTop(o){if(this.dragOverMouseY===void 0)return;const s=this.dragOverMouseY-o,p=this.renderHeight-35;s<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(s-35))):s>p&&(this.scrollTop+=Math.min(14,Math.floor(.3*(s-p))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(o){const s=this.scrollableElement.getDomNode();let p=o;for(;p instanceof HTMLElement&&p!==this.rowsContainer&&s.contains(p);){const L=p.getAttribute("data-index");if(L){const V=Number(L);if(!isNaN(V))return V}p=p.parentElement}}getRenderRange(o,s){return{start:this.rangeMap.indexAt(o),end:this.rangeMap.indexAfter(o+s-1)}}_rerender(o,s,p){const L=this.getRenderRange(o,s);let V,X;o===this.elementTop(L.start)?(V=L.start,X=0):L.end-L.start>1&&(V=L.start+1,X=this.elementTop(V)-o);let J=0;for(;;){const ge=this.getRenderRange(o,s);let oe=!1;for(let me=ge.start;me<ge.end;me++){const he=this.probeDynamicHeight(me);he!==0&&this.rangeMap.splice(me,1,[this.items[me]]),J+=he,oe=oe||he!==0}if(!oe){J!==0&&this.eventuallyUpdateScrollDimensions();const me=n.Range.relativeComplement(L,ge);for(const ae of me)for(let Se=ae.start;Se<ae.end;Se++)this.items[Se].row&&this.removeItemFromDOM(Se);const he=n.Range.relativeComplement(ge,L);for(const ae of he)for(let Se=ae.start;Se<ae.end;Se++){const te=Se+1,De=te<this.items.length?this.items[te].row:null,se=De?De.domNode:null;this.insertItemInDOM(Se,se)}for(let ae=ge.start;ae<ge.end;ae++)this.items[ae].row&&this.updateItemInDOM(this.items[ae],ae);if(typeof V=="number"){const ae=this.scrollable.getFutureScrollPosition().scrollTop-o,Se=this.elementTop(V)-X+ae;this.setScrollTop(Se,p)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(o){const s=this.items[o];if(this.virtualDelegate.getDynamicHeight){const X=this.virtualDelegate.getDynamicHeight(s.element);if(X!==null){const J=s.size;return s.size=X,s.lastDynamicHeightWidth=this.renderWidth,X-J}}if(!s.hasDynamicHeight||s.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(s.element))return 0;const p=s.size;if(s.row)return s.row.domNode.style.height="",s.size=s.row.domNode.offsetHeight,s.lastDynamicHeightWidth=this.renderWidth,s.size-p;const L=this.cache.alloc(s.templateId);L.domNode.style.height="",this.rowsContainer.appendChild(L.domNode);const V=this.renderers.get(s.templateId);if(!V)throw new w.BugIndicatingError("Missing renderer for templateId: "+s.templateId);return V.renderElement(s.element,o,L.templateData,void 0),s.size=L.domNode.offsetHeight,V.disposeElement?.(s.element,o,L.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(s.element,s.size),s.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(L.domNode),this.cache.release(L),s.size-p}getNextToLastElement(o){const s=o[o.length-1];if(!s)return null;const p=this.items[s.end];return!p||!p.row?null:p.row.domNode}getElementDomId(o){return`${this.domId}_${o}`}dispose(){if(this.items){for(const o of this.items)if(o.row){const s=this.renderers.get(o.row.templateId);s&&(s.disposeElement?.(o.element,-1,o.row.templateData,void 0),s.disposeTemplate(o.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,l.dispose)(this.disposables)}}r.InstanceCount=0,xe([f.memoize],r.prototype,"onMouseClick",null),xe([f.memoize],r.prototype,"onMouseDblClick",null),xe([f.memoize],r.prototype,"onMouseMiddleClick",null),xe([f.memoize],r.prototype,"onMouseUp",null),xe([f.memoize],r.prototype,"onMouseDown",null),xe([f.memoize],r.prototype,"onMouseOver",null),xe([f.memoize],r.prototype,"onMouseMove",null),xe([f.memoize],r.prototype,"onMouseOut",null),xe([f.memoize],r.prototype,"onContextMenu",null),xe([f.memoize],r.prototype,"onTouchStart",null),xe([f.memoize],r.prototype,"onTap",null),t.ListView=r}),define(pe[59],be([1,0,4,18,19,22,54,68,14,8,24,25,3,33,2,45,27,5,6,67,58,88]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l,n,e,g,b,w,E,a,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class m{constructor(h){this.trait=h,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(h){return h}renderElement(h,I,U){const K=this.renderedElements.findIndex(Z=>Z.templateData===U);if(K>=0){const Z=this.renderedElements[K];this.trait.unrender(U),Z.index=I}else{const Z={index:I,templateData:U};this.renderedElements.push(Z)}this.trait.renderIndex(I,U)}splice(h,I,U){const K=[];for(const Z of this.renderedElements)Z.index<h?K.push(Z):Z.index>=h+I&&K.push({index:Z.index+U-I,templateData:Z.templateData});this.renderedElements=K}renderIndexes(h){for(const{index:I,templateData:U}of this.renderedElements)h.indexOf(I)>-1&&this.trait.renderIndex(I,U)}disposeTemplate(h){const I=this.renderedElements.findIndex(U=>U.templateData===h);I<0||this.renderedElements.splice(I,1)}}class S{get name(){return this._trait}get renderer(){return new m(this)}constructor(h){this._trait=h,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new l.Emitter,this.onChange=this._onChange.event}splice(h,I,U){I=Math.max(0,Math.min(I,this.length-h));const K=U.length-I,Z=h+I,k=[...this.sortedIndexes.filter(z=>z<h),...U.map((z,A)=>z?A+h:-1).filter(z=>z!==-1),...this.sortedIndexes.filter(z=>z>=Z).map(z=>z+K)],M=this.length+K;if(this.sortedIndexes.length>0&&k.length===0&&M>0){const z=this.sortedIndexes.find(A=>A>=h)??M-1;k.push(Math.min(z,M-1))}this.renderer.splice(h,I,U.length),this._set(k,k),this.length=M}renderIndex(h,I){I.classList.toggle(this._trait,this.contains(h))}unrender(h){h.classList.remove(this._trait)}set(h,I){return this._set(h,[...h].sort(ce),I)}_set(h,I,U){const K=this.indexes,Z=this.sortedIndexes;this.indexes=h,this.sortedIndexes=I;const k=se(Z,h);return this.renderer.renderIndexes(k),this._onChange.fire({indexes:h,browserEvent:U}),K}get(){return this.indexes}contains(h){return(0,d.binarySearch)(this.sortedIndexes,h,ce)>=0}dispose(){(0,e.dispose)(this._onChange)}}xe([N.memoize],S.prototype,"renderer",null);class T extends S{constructor(h){super("selected"),this.setAriaSelected=h}renderIndex(h,I){super.renderIndex(h,I),this.setAriaSelected&&(this.contains(h)?I.setAttribute("aria-selected","true"):I.setAttribute("aria-selected","false"))}}class _{constructor(h,I,U){this.trait=h,this.view=I,this.identityProvider=U}splice(h,I,U){if(!this.identityProvider)return this.trait.splice(h,I,U.map(()=>!1));const K=this.trait.get().map(k=>this.identityProvider.getId(this.view.element(k)).toString()),Z=U.map(k=>K.indexOf(this.identityProvider.getId(k).toString())>-1);this.trait.splice(h,I,Z)}}function r(P){return P.tagName==="INPUT"||P.tagName==="TEXTAREA"}t.isInputElement=r;function v(P){return P.classList.contains("monaco-editor")?!0:P.classList.contains("monaco-list")||!P.parentElement?!1:v(P.parentElement)}t.isMonacoEditor=v;function o(P){return P.tagName==="A"&&P.classList.contains("monaco-button")||P.tagName==="DIV"&&P.classList.contains("monaco-button-dropdown")?!0:P.classList.contains("monaco-list")||!P.parentElement?!1:o(P.parentElement)}t.isButton=o;class s{get onKeyDown(){return this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event).filter(h=>!r(h.target)).map(h=>new W.StandardKeyboardEvent(h)))}constructor(h,I,U){this.list=h,this.view=I,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(K=>K.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===9).on(this.onEscape,this,this.disposables),U.multipleSelectionSupport!==!1&&this.onKeyDown.filter(K=>(w.isMacintosh?K.metaKey:K.ctrlKey)&&K.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),h.multipleSelectionSupport&&this.onKeyDown.filter(I=>(w.isMacintosh?I.metaKey:I.ctrlKey)&&I.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection(this.list.getFocus(),h.browserEvent)}onUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPrevious(1,!1,h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNext(1,!1,h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPreviousPage(h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNextPage(h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onCtrlA(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection((0,d.range)(this.list.length),h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(h){this.list.getSelection().length&&(h.preventDefault(),h.stopPropagation(),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}xe([N.memoize],s.prototype,"onKeyDown",null);var p;(function(P){P[P.Automatic=0]="Automatic",P[P.Trigger=1]="Trigger"})(p=t.TypeNavigationMode||(t.TypeNavigationMode={}));var L;(function(P){P[P.Idle=0]="Idle",P[P.Typing=1]="Typing"})(L||(L={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(P){return P.ctrlKey||P.metaKey||P.altKey?!1:P.keyCode>=31&&P.keyCode<=56||P.keyCode>=21&&P.keyCode<=30||P.keyCode>=93&&P.keyCode<=102||P.keyCode>=80&&P.keyCode<=90}};class V{constructor(h,I,U,K,Z){this.list=h,this.view=I,this.keyboardNavigationLabelProvider=U,this.keyboardNavigationEventFilter=K,this.delegate=Z,this.enabled=!1,this.state=L.Idle,this.mode=p.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(h.options)}updateOptions(h){h.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=h.typeNavigationMode??p.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let h=!1;const I=this.enabledDisposables.add(l.Event.chain(this.enabledDisposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).filter(Z=>!r(Z.target)).filter(()=>this.mode===p.Automatic||this.triggered).map(Z=>new W.StandardKeyboardEvent(Z)).filter(Z=>h||this.keyboardNavigationEventFilter(Z)).filter(Z=>this.delegate.mightProducePrintableCharacter(Z)).forEach(Z=>y.EventHelper.stop(Z,!0)).map(Z=>Z.browserEvent.key).event,U=l.Event.debounce(I,()=>null,800,void 0,void 0,this.enabledDisposables);l.Event.reduce(l.Event.any(I,U),(Z,k)=>k===null?null:(Z||"")+k,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),U(this.onClear,this,this.enabledDisposables),I(()=>h=!0,void 0,this.enabledDisposables),U(()=>h=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const h=this.list.getFocus();if(h.length>0&&h[0]===this.previouslyFocused){const I=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(h[0]));I&&(0,C.alert)(I)}this.previouslyFocused=-1}onInput(h){if(!h){this.state=L.Idle,this.triggered=!1;return}const I=this.list.getFocus(),U=I.length>0?I[0]:0,K=this.state===L.Idle?1:0;this.state=L.Typing;for(let Z=0;Z<this.list.length;Z++){const k=(U+Z+K)%this.list.length,M=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(k)),z=M&&M.toString();if(typeof z>"u"||(0,n.matchesPrefix)(h,z)){this.previouslyFocused=U,this.list.setFocus([k]),this.list.reveal(k);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class X{constructor(h,I){this.list=h,this.view=I,this.disposables=new e.DisposableStore,this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(I.domNode,"keydown")).event)).filter(K=>!r(K.target)).map(K=>new W.StandardKeyboardEvent(K)).filter(K=>K.keyCode===2&&!K.ctrlKey&&!K.metaKey&&!K.shiftKey&&!K.altKey).on(this.onTab,this,this.disposables)}onTab(h){if(h.target!==this.view.domNode)return;const I=this.list.getFocus();if(I.length===0)return;const U=this.view.domElement(I[0]);if(!U)return;const K=U.querySelector("[tabIndex]");if(!K||!(K instanceof HTMLElement)||K.tabIndex===-1)return;const Z=window.getComputedStyle(K);Z.visibility==="hidden"||Z.display==="none"||(h.preventDefault(),h.stopPropagation(),K.focus())}dispose(){this.disposables.dispose()}}function J(P){return w.isMacintosh?P.browserEvent.metaKey:P.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=J;function ge(P){return P.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ge;function oe(P){return P instanceof MouseEvent&&P.button===2}const me={isSelectionSingleChangeEvent:J,isSelectionRangeChangeEvent:ge};class he{constructor(h){this.list=h,this.disposables=new e.DisposableStore,this._onPointer=new l.Emitter,this.onPointer=this._onPointer.event,h.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||me),this.mouseSupport=typeof h.options.mouseSupport>"u"||!!h.options.mouseSupport,this.mouseSupport&&(h.onMouseDown(this.onMouseDown,this,this.disposables),h.onContextMenu(this.onContextMenu,this,this.disposables),h.onMouseDblClick(this.onDoubleClick,this,this.disposables),h.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(B.Gesture.addTarget(h.getHTMLElement()))),l.Event.any(h.onMouseClick,h.onMouseMiddleClick,h.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,h.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||me))}isSelectionSingleChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(h):!1}isSelectionRangeChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(h):!1}isSelectionChangeEvent(h){return this.isSelectionSingleChangeEvent(h)||this.isSelectionRangeChangeEvent(h)}onMouseDown(h){v(h.browserEvent.target)||document.activeElement!==h.browserEvent.target&&this.list.domFocus()}onContextMenu(h){if(v(h.browserEvent.target))return;const I=typeof h.index>"u"?[]:[h.index];this.list.setFocus(I,h.browserEvent)}onViewPointer(h){if(!this.mouseSupport||r(h.browserEvent.target)||v(h.browserEvent.target))return;const I=h.index;if(typeof I>"u"){this.list.setFocus([],h.browserEvent),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(h))return this.changeSelection(h);if(this.isSelectionChangeEvent(h))return this.changeSelection(h);this.list.setFocus([I],h.browserEvent),this.list.setAnchor(I),oe(h.browserEvent)||this.list.setSelection([I],h.browserEvent),this._onPointer.fire(h)}onDoubleClick(h){if(r(h.browserEvent.target)||v(h.browserEvent.target)||this.isSelectionChangeEvent(h))return;const I=this.list.getFocus();this.list.setSelection(I,h.browserEvent)}changeSelection(h){const I=h.index;let U=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(h)){typeof U>"u"&&(U=this.list.getFocus()[0]??I,this.list.setAnchor(U));const K=Math.min(U,I),Z=Math.max(U,I),k=(0,d.range)(K,Z+1),M=this.list.getSelection(),z=De(se(M,[U]),U);if(z.length===0)return;const A=se(k,ie(M,z));this.list.setSelection(A,h.browserEvent),this.list.setFocus([I],h.browserEvent)}else if(this.isSelectionSingleChangeEvent(h)){const K=this.list.getSelection(),Z=K.filter(k=>k!==I);this.list.setFocus([I]),this.list.setAnchor(I),K.length===Z.length?this.list.setSelection([...Z,I],h.browserEvent):this.list.setSelection(Z,h.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=he;class ae{constructor(h,I){this.styleElement=h,this.selectorSuffix=I}style(h){const I=this.selectorSuffix&&`.${this.selectorSuffix}`,U=[];h.listBackground&&(h.listBackground.isOpaque()?U.push(`.monaco-list${I} .monaco-list-rows { background: ${h.listBackground}; }`):w.isMacintosh||console.warn(`List with id '${this.selectorSuffix}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),h.listFocusBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.focused { background-color: ${h.listFocusBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.focused:hover { background-color: ${h.listFocusBackground}; }`)),h.listFocusForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.focused { color: ${h.listFocusForeground}; }`),h.listActiveSelectionBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.selected { background-color: ${h.listActiveSelectionBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.selected:hover { background-color: ${h.listActiveSelectionBackground}; }`)),h.listActiveSelectionForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { color: ${h.listActiveSelectionForeground}; }`),h.listActiveSelectionIconForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected .codicon { color: ${h.listActiveSelectionIconForeground}; }`),h.listFocusAndSelectionOutline&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { outline-color: ${h.listFocusAndSelectionOutline} !important; }`),h.listFocusAndSelectionBackground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { background-color: ${h.listFocusAndSelectionBackground}; }
			`),h.listFocusAndSelectionForeground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { color: ${h.listFocusAndSelectionForeground}; }
			`),h.listInactiveFocusForeground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { color:  ${h.listInactiveFocusForeground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { color:  ${h.listInactiveFocusForeground}; }`)),h.listInactiveSelectionIconForeground&&U.push(`.monaco-list${I} .monaco-list-row.focused .codicon { color:  ${h.listInactiveSelectionIconForeground}; }`),h.listInactiveFocusBackground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { background-color:  ${h.listInactiveFocusBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { background-color:  ${h.listInactiveFocusBackground}; }`)),h.listInactiveSelectionBackground&&(U.push(`.monaco-list${I} .monaco-list-row.selected { background-color:  ${h.listInactiveSelectionBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.selected:hover { background-color:  ${h.listInactiveSelectionBackground}; }`)),h.listInactiveSelectionForeground&&U.push(`.monaco-list${I} .monaco-list-row.selected { color: ${h.listInactiveSelectionForeground}; }`),h.listHoverBackground&&U.push(`.monaco-list${I}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${h.listHoverBackground}; }`),h.listHoverForeground&&U.push(`.monaco-list${I}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${h.listHoverForeground}; }`),h.listSelectionOutline&&U.push(`.monaco-list${I} .monaco-list-row.selected { outline: 1px dotted ${h.listSelectionOutline}; outline-offset: -1px; }`),h.listFocusOutline&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${I}.last-focused .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
			`),h.listInactiveFocusOutline&&U.push(`.monaco-list${I} .monaco-list-row.focused { outline: 1px dotted ${h.listInactiveFocusOutline}; outline-offset: -1px; }`),h.listHoverOutline&&U.push(`.monaco-list${I} .monaco-list-row:hover { outline: 1px dashed ${h.listHoverOutline}; outline-offset: -1px; }`),h.listDropBackground&&U.push(`
				.monaco-list${I}.drop-target,
				.monaco-list${I} .monaco-list-rows.drop-target,
				.monaco-list${I} .monaco-list-row.drop-target { background-color: ${h.listDropBackground} !important; color: inherit !important; }
			`),h.tableColumnsBorder&&U.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${h.tableColumnsBorder};
			}`),h.tableOddRowsBackgroundColor&&U.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${h.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=U.join(`
`)}}t.DefaultStyleController=ae;const Se={listFocusBackground:f.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:f.Color.fromHex("#0E639C"),listActiveSelectionForeground:f.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:f.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:f.Color.fromHex("#094771"),listFocusAndSelectionForeground:f.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:f.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listHoverBackground:f.Color.fromHex("#2A2D2E"),listDropBackground:f.Color.fromHex("#383B3D"),treeIndentGuidesStroke:f.Color.fromHex("#a9a9a9"),tableColumnsBorder:f.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:f.Color.fromHex("#cccccc").transparent(.04)},te={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function De(P,h){const I=P.indexOf(h);if(I===-1)return[];const U=[];let K=I-1;for(;K>=0&&P[K]===h-(I-K);)U.push(P[K--]);for(U.reverse(),K=I;K<P.length&&P[K]===h+(K-I);)U.push(P[K++]);return U}function se(P,h){const I=[];let U=0,K=0;for(;U<P.length||K<h.length;)if(U>=P.length)I.push(h[K++]);else if(K>=h.length)I.push(P[U++]);else if(P[U]===h[K]){I.push(P[U]),U++,K++;continue}else P[U]<h[K]?I.push(P[U++]):I.push(h[K++]);return I}function ie(P,h){const I=[];let U=0,K=0;for(;U<P.length||K<h.length;)if(U>=P.length)I.push(h[K++]);else if(K>=h.length)I.push(P[U++]);else if(P[U]===h[K]){U++,K++;continue}else P[U]<h[K]?I.push(P[U++]):K++;return I}const ce=(P,h)=>P-h;class ne{constructor(h,I){this._templateId=h,this.renderers=I}get templateId(){return this._templateId}renderTemplate(h){return this.renderers.map(I=>I.renderTemplate(h))}renderElement(h,I,U,K){let Z=0;for(const k of this.renderers)k.renderElement(h,I,U[Z++],K)}disposeElement(h,I,U,K){let Z=0;for(const k of this.renderers)k.disposeElement?.(h,I,U[Z],K),Z+=1}disposeTemplate(h){let I=0;for(const U of this.renderers)U.disposeTemplate(h[I++])}}class F{constructor(h){this.accessibilityProvider=h,this.templateId="a18n"}renderTemplate(h){return h}renderElement(h,I,U){const K=this.accessibilityProvider.getAriaLabel(h);K?U.setAttribute("aria-label",K):U.removeAttribute("aria-label");const Z=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(h);typeof Z=="number"?U.setAttribute("aria-level",`${Z}`):U.removeAttribute("aria-level")}disposeTemplate(h){}}class ${constructor(h,I){this.list=h,this.dnd=I}getDragElements(h){const I=this.list.getSelectedElements();return I.indexOf(h)>-1?I:[h]}getDragURI(h){return this.dnd.getDragURI(h)}getDragLabel(h,I){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(h,I)}onDragStart(h,I){this.dnd.onDragStart?.(h,I)}onDragOver(h,I,U,K){return this.dnd.onDragOver(h,I,U,K)}onDragLeave(h,I,U,K){this.dnd.onDragLeave?.(h,I,U,K)}onDragEnd(h){this.dnd.onDragEnd?.(h)}drop(h,I,U,K){this.dnd.drop(h,I,U,K)}}class j{get onDidChangeFocus(){return l.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),h=>this.toListEvent(h),this.disposables)}get onDidChangeSelection(){return l.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),h=>this.toListEvent(h),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let h=!1;const I=this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).map(Z=>new W.StandardKeyboardEvent(Z)).filter(Z=>h=Z.keyCode===58||Z.shiftKey&&Z.keyCode===68).map(Z=>y.EventHelper.stop(Z,!0)).filter(()=>!1).event,U=this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>h=!1).map(Z=>new W.StandardKeyboardEvent(Z)).filter(Z=>Z.keyCode===58||Z.shiftKey&&Z.keyCode===68).map(Z=>y.EventHelper.stop(Z,!0)).map(({browserEvent:Z})=>{const k=this.getFocus(),M=k.length?k[0]:void 0,z=typeof M<"u"?this.view.element(M):void 0,A=typeof M<"u"?this.view.domElement(M):this.view.domNode;return{index:M,element:z,anchor:A,browserEvent:Z}}).event,K=this.disposables.add(l.Event.chain(this.view.onContextMenu)).filter(Z=>!h).map(({element:Z,index:k,browserEvent:M})=>({element:Z,index:k,anchor:{x:M.pageX+1,y:M.pageY},browserEvent:M})).event;return l.Event.any(I,U,K)}get onKeyDown(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return l.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return l.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(h,I,U,K,Z=te){this.user=h,this._options=Z,this.focus=new S("focused"),this.anchor=new S("anchor"),this.eventBufferer=new l.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event;const k=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new T(k!=="listbox"),(0,b.mixin)(Z,Se,!1);const M=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=Z.accessibilityProvider,this.accessibilityProvider&&(M.push(new F(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),K=K.map(A=>new ne(A.templateId,[...M,A]));const z={...Z,dnd:Z.dnd&&new $(this,Z.dnd)};if(this.view=new u.ListView(I,U,K,z),this.view.domNode.setAttribute("role",k),Z.styleController)this.styleController=Z.styleController(this.view.domId);else{const A=(0,y.createStyleSheet)(this.view.domNode);this.styleController=new ae(A,this.view.domId)}if(this.spliceable=new D.CombinedSpliceable([new _(this.focus,this.view,Z.identityProvider),new _(this.selection,this.view,Z.identityProvider),new _(this.anchor,this.view,Z.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new X(this,this.view)),(typeof Z.keyboardSupport!="boolean"||Z.keyboardSupport)&&(this.keyboardController=new s(this,this.view,Z),this.disposables.add(this.keyboardController)),Z.keyboardNavigationLabelProvider){const A=Z.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new V(this,this.view,Z.keyboardNavigationLabelProvider,Z.keyboardNavigationEventFilter??(()=>!0),A),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(Z),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createMouseController(h){return new he(this)}updateOptions(h={}){this._options={...this._options,...h},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(h),this.keyboardController?.updateOptions(h),this.view.updateOptions(h)}get options(){return this._options}splice(h,I,U=[]){if(h<0||h>this.view.length)throw new a.ListError(this.user,`Invalid start index: ${h}`);if(I<0)throw new a.ListError(this.user,`Invalid delete count: ${I}`);I===0&&U.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(h,I,U))}updateWidth(h){this.view.updateWidth(h)}updateElementHeight(h,I){this.view.updateElementHeight(h,I,null)}rerender(){this.view.rerender()}element(h){return this.view.element(h)}indexOf(h){return this.view.indexOf(h)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(h){this.view.setScrollTop(h)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(h){this.view.setScrollLeft(h)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(h){this._ariaLabel=h,this.view.domNode.setAttribute("aria-label",h)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(h,I){this.view.layout(h,I)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(h,I){for(const U of h)if(U<0||U>=this.length)throw new a.ListError(this.user,`Invalid index ${U}`);this.selection.set(h,I)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(h=>this.view.element(h))}setAnchor(h){if(typeof h>"u"){this.anchor.set([]);return}if(h<0||h>=this.length)throw new a.ListError(this.user,`Invalid index ${h}`);this.anchor.set([h])}getAnchor(){return(0,d.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const h=this.getAnchor();return typeof h>"u"?void 0:this.element(h)}setFocus(h,I){for(const U of h)if(U<0||U>=this.length)throw new a.ListError(this.user,`Invalid index ${U}`);this.focus.set(h,I)}focusNext(h=1,I=!1,U,K){if(this.length===0)return;const Z=this.focus.get(),k=this.findNextIndex(Z.length>0?Z[0]+h:0,I,K);k>-1&&this.setFocus([k],U)}focusPrevious(h=1,I=!1,U,K){if(this.length===0)return;const Z=this.focus.get(),k=this.findPreviousIndex(Z.length>0?Z[0]-h:0,I,K);k>-1&&this.setFocus([k],U)}async focusNextPage(h,I){let U=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);U=U===0?0:U-1;const K=this.getFocus()[0];if(K!==U&&(K===void 0||U>K)){const Z=this.findPreviousIndex(U,!1,I);Z>-1&&K!==Z?this.setFocus([Z],h):this.setFocus([U],h)}else{const Z=this.view.getScrollTop();let k=Z+this.view.renderHeight;U>K&&(k-=this.view.elementHeight(U)),this.view.setScrollTop(k),this.view.getScrollTop()!==Z&&(this.setFocus([]),await(0,c.timeout)(0),await this.focusNextPage(h,I))}}async focusPreviousPage(h,I){let U;const K=this.view.getScrollTop();K===0?U=this.view.indexAt(K):U=this.view.indexAfter(K-1);const Z=this.getFocus()[0];if(Z!==U&&(Z===void 0||Z>=U)){const k=this.findNextIndex(U,!1,I);k>-1&&Z!==k?this.setFocus([k],h):this.setFocus([U],h)}else{const k=K;this.view.setScrollTop(K-this.view.renderHeight),this.view.getScrollTop()!==k&&(this.setFocus([]),await(0,c.timeout)(0),await this.focusPreviousPage(h,I))}}focusLast(h,I){if(this.length===0)return;const U=this.findPreviousIndex(this.length-1,!1,I);U>-1&&this.setFocus([U],h)}focusFirst(h,I){this.focusNth(0,h,I)}focusNth(h,I,U){if(this.length===0)return;const K=this.findNextIndex(h,!1,U);K>-1&&this.setFocus([K],I)}findNextIndex(h,I=!1,U){for(let K=0;K<this.length;K++){if(h>=this.length&&!I)return-1;if(h=h%this.length,!U||U(this.element(h)))return h;h++}return-1}findPreviousIndex(h,I=!1,U){for(let K=0;K<this.length;K++){if(h<0&&!I)return-1;if(h=(this.length+h%this.length)%this.length,!U||U(this.element(h)))return h;h--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(h=>this.view.element(h))}reveal(h,I){if(h<0||h>=this.length)throw new a.ListError(this.user,`Invalid index ${h}`);const U=this.view.getScrollTop(),K=this.view.elementTop(h),Z=this.view.elementHeight(h);if((0,E.isNumber)(I)){const k=Z-this.view.renderHeight;this.view.setScrollTop(k*(0,g.clamp)(I,0,1)+K)}else{const k=K+Z,M=U+this.view.renderHeight;K<U&&k>=M||(K<U||k>=M&&Z>=this.view.renderHeight?this.view.setScrollTop(K):k>=M&&this.view.setScrollTop(k-this.view.renderHeight))}}getRelativeTop(h){if(h<0||h>=this.length)throw new a.ListError(this.user,`Invalid index ${h}`);const I=this.view.getScrollTop(),U=this.view.elementTop(h),K=this.view.elementHeight(h);if(U<I||U+K>I+this.view.renderHeight)return null;const Z=K-this.view.renderHeight;return Math.abs((I-U)/Z)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(h){return this.view.getElementDomId(h)}style(h){this.styleController.style(h)}toListEvent({indexes:h,browserEvent:I}){return{indexes:h,elements:h.map(U=>this.view.element(U)),browserEvent:I}}_onFocusChange(){const h=this.focus.get();this.view.domNode.classList.toggle("element-focused",h.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const h=this.focus.get();if(h.length>0){let I;this.accessibilityProvider?.getActiveDescendantId&&(I=this.accessibilityProvider.getActiveDescendantId(this.view.element(h[0]))),this.view.domNode.setAttribute("aria-activedescendant",I||this.view.getElementDomId(h[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const h=this.selection.get();this.view.domNode.classList.toggle("selection-none",h.length===0),this.view.domNode.classList.toggle("selection-single",h.length===1),this.view.domNode.classList.toggle("selection-multiple",h.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}xe([N.memoize],j.prototype,"onDidChangeFocus",null),xe([N.memoize],j.prototype,"onDidChangeSelection",null),xe([N.memoize],j.prototype,"onContextMenu",null),xe([N.memoize],j.prototype,"onKeyDown",null),xe([N.memoize],j.prototype,"onKeyUp",null),xe([N.memoize],j.prototype,"onKeyPress",null),xe([N.memoize],j.prototype,"onDidFocus",null),xe([N.memoize],j.prototype,"onDidBlur",null),t.List=j}),define(pe[60],be([1,0,9,34,36,11,16]),function(Q,t,y,i,W,B,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var D;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(D=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class d{constructor(w="",E=!1){if(this.value=w,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=E.isTrusted??void 0,this.supportThemeIcons=E.supportThemeIcons??!1,this.supportHtml=E.supportHtml??!1)}appendText(w,E=0){return this.value+=l(this.supportThemeIcons?(0,i.escapeIcons)(w):w).replace(/([ \t]+)/g,(a,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(w){return this.value+=w,this}appendCodeblock(w,E){return this.value+="\n```",this.value+=w,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}appendLink(w,E,a){return this.value+="[",this.value+=this._escape(E,"]"),this.value+="](",this.value+=this._escape(String(w),")"),a&&(this.value+=` "${this._escape(this._escape(a,'"'),")")}"`),this.value+=")",this}_escape(w,E){const a=new RegExp((0,B.escapeRegExpCharacters)(E),"g");return w.replace(a,(u,m)=>w.charAt(m-1)!=="\\"?`\\${u}`:u)}}t.MarkdownString=d;function c(b){return f(b)?!b.value:Array.isArray(b)?b.every(c):!0}t.isEmptyMarkdownString=c;function f(b){return b instanceof d?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}t.isMarkdownString=f;function N(b,w){return b===w?!0:!b||!w?!1:b.value===w.value&&b.isTrusted===w.isTrusted&&b.supportThemeIcons===w.supportThemeIcons&&b.supportHtml===w.supportHtml&&(b.baseUri===w.baseUri||!!b.baseUri&&!!w.baseUri&&(0,W.isEqual)(C.URI.from(b.baseUri),C.URI.from(w.baseUri)))}t.markdownStringEqual=N;function l(b){return b.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=l;function n(b){return b.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=n;function e(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function g(b){const w=[],E=b.split("|").map(u=>u.trim());b=E[0];const a=E[1];if(a){const u=/height=(\d+)/.exec(a),m=/width=(\d+)/.exec(a),S=u?u[1]:"",T=m?m[1]:"",_=isFinite(parseInt(T)),r=isFinite(parseInt(S));_&&w.push(`width="${T}"`),r&&w.push(`height="${S}"`)}return{href:b,dimensions:w}}t.parseHrefAndDimensions=g}),define(pe[120],be([1,0,4,112,18,52,20,113,9,3,60,34,72,44,2,75,50,35,27,36,11,16]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l,n,e,g,b,w,E,a,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const S=Object.freeze({image:(X,J,ge)=>{let oe=[],me=[];return X&&({href:X,dimensions:oe}=(0,f.parseHrefAndDimensions)(X),me.push(`src="${(0,f.escapeDoubleQuotes)(X)}"`)),ge&&me.push(`alt="${(0,f.escapeDoubleQuotes)(ge)}"`),J&&me.push(`title="${(0,f.escapeDoubleQuotes)(J)}"`),oe.length&&(me=me.concat(oe)),"<img "+me.join(" ")+">"},paragraph:X=>`<p>${X}</p>`,link:(X,J,ge)=>typeof X!="string"?"":(X===ge&&(ge=(0,f.removeMarkdownEscapes)(ge)),J=typeof J=="string"?(0,f.escapeDoubleQuotes)((0,f.removeMarkdownEscapes)(J)):"",X=(0,f.removeMarkdownEscapes)(X),X=X.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${X}" title="${J||X}">${ge}</a>`)});function T(X,J={},ge={}){const oe=new e.DisposableStore;let me=!1;const he=(0,B.createElement)(J),ae=function(F){let $;try{$=(0,b.parse)(decodeURIComponent(F))}catch{}return $?($=(0,E.cloneAndChange)($,j=>{if(X.uris&&X.uris[j])return m.URI.revive(X.uris[j])}),encodeURIComponent(JSON.stringify($))):F},Se=function(F,$){const j=X.uris&&X.uris[F];let P=m.URI.revive(j);return $?F.startsWith(w.Schemas.data+":")?F:(P||(P=m.URI.parse(F)),w.FileAccess.asBrowserUri(P).toString(!0)):!P||m.URI.parse(F).toString()===P.toString()?F:(P.query&&(P=P.with({query:ae(P.query)})),P.toString())},te=new g.marked.Renderer;te.image=S.image,te.link=S.link,te.paragraph=S.paragraph;const De=[];if(J.codeBlockRenderer&&(te.code=(F,$)=>{const j=l.defaultGenerator.nextId(),P=J.codeBlockRenderer(_($),F);return De.push(P.then(h=>[j,h])),`<div class="code" data-code="${j}">${(0,u.escape)(F)}</div>`}),J.actionHandler){const F=J.actionHandler.disposables.add(new W.DomEmitter(he,"click")),$=J.actionHandler.disposables.add(new W.DomEmitter(he,"auxclick"));J.actionHandler.disposables.add(c.Event.any(F.event,$.event)(j=>{const P=new C.StandardMouseEvent(j);if(!P.leftButton&&!P.middleButton)return;let h=P.target;if(!(h.tagName!=="A"&&(h=h.parentElement,!h||h.tagName!=="A")))try{let I=h.dataset.href;I&&(X.baseUri&&(I=r(m.URI.from(X.baseUri),I)),J.actionHandler.callback(I,P))}catch(I){(0,d.onUnexpectedError)(I)}finally{P.preventDefault()}}))}X.supportHtml||(ge.sanitizer=F=>(X.isTrusted?F.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?F:"",ge.sanitize=!0,ge.silent=!0),ge.renderer=te;let se=X.value??"";se.length>1e5&&(se=`${se.substr(0,1e5)}\u2026`),X.supportThemeIcons&&(se=(0,N.markdownEscapeEscapedIcons)(se));let ie=g.marked.parse(se,ge);X.supportThemeIcons&&(ie=(0,D.renderLabelWithIcons)(ie).map($=>typeof $=="string"?$:$.outerHTML).join(""));const ne=new DOMParser().parseFromString(v(X,ie),"text/html");if(ne.body.querySelectorAll("img").forEach(F=>{const $=F.getAttribute("src");if($){let j=$;try{X.baseUri&&(j=r(m.URI.from(X.baseUri),j))}catch{}F.src=Se(j,!0)}}),ne.body.querySelectorAll("a").forEach(F=>{const $=F.getAttribute("href");if(F.setAttribute("href",""),!$||/^data:|javascript:/i.test($)||/^command:/i.test($)&&!X.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test($))F.replaceWith(...F.childNodes);else{let j=Se($,!1);X.baseUri&&(j=r(m.URI.from(X.baseUri),$)),F.dataset.href=j}}),he.innerHTML=v(X,ne.body.innerHTML),De.length>0&&Promise.all(De).then(F=>{if(me)return;const $=new Map(F),j=he.querySelectorAll("div[data-code]");for(const P of j){const h=$.get(P.dataset.code??"");h&&y.reset(P,h)}J.asyncRenderCallback?.()}),J.asyncRenderCallback)for(const F of he.getElementsByTagName("img")){const $=oe.add(y.addDisposableListener(F,"load",()=>{$.dispose(),J.asyncRenderCallback()}))}return{element:he,dispose:()=>{me=!0,oe.dispose()}}}t.renderMarkdown=T;function _(X){if(!X)return"";const J=X.split(/[\s+|:|,|\{|\?]/,1);return J.length?J[0]:X}function r(X,J){return/^\w[\w\d+.-]*:/.test(J)?J:X.path.endsWith("/")?(0,a.resolvePath)(X,J).toString():(0,a.resolvePath)((0,a.dirname)(X),J).toString()}function v(X,J){const{config:ge,allowedSchemes:oe}=o(X);i.addHook("uponSanitizeAttribute",(he,ae)=>{if(ae.attrName==="style"||ae.attrName==="class"){if(he.tagName==="SPAN"){if(ae.attrName==="style"){ae.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(ae.attrValue);return}else if(ae.attrName==="class"){ae.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(ae.attrValue);return}}ae.keepAttr=!1;return}});const me=y.hookDomPurifyHrefAndSrcSanitizer(oe);try{return i.sanitize(J,{...ge,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),me.dispose()}}t.allowedMarkdownAttr=["align","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width"];function o(X){const J=[w.Schemas.http,w.Schemas.https,w.Schemas.mailto,w.Schemas.data,w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemote,w.Schemas.vscodeRemoteResource];return X.isTrusted&&J.push(w.Schemas.command),{config:{ALLOWED_TAGS:[...y.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:J}}function s(X){return typeof X=="string"?X:p(X)}t.renderStringAsPlaintext=s;function p(X){let J=X.value??"";J.length>1e5&&(J=`${J.substr(0,1e5)}\u2026`);const ge=g.marked.parse(J,{renderer:V.getValue()}).replace(/&(#\d+|[a-zA-Z]+);/g,oe=>L.get(oe)??oe);return v({isTrusted:!1},ge).toString()}t.renderMarkdownAsPlaintext=p;const L=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),V=new n.Lazy(()=>{const X=new g.marked.Renderer;return X.code=J=>J,X.blockquote=J=>J,X.html=J=>"",X.heading=(J,ge,oe)=>J+`
`,X.hr=()=>"",X.list=(J,ge)=>J,X.listitem=J=>J+`
`,X.paragraph=J=>J+`
`,X.table=(J,ge)=>J+ge+`
`,X.tablerow=J=>J,X.tablecell=(J,ge)=>J+" ",X.strong=J=>J,X.em=J=>J,X.codespan=J=>J,X.br=()=>`
`,X.del=J=>J,X.image=(J,ge,oe)=>"",X.text=J=>J,X.link=(J,ge,oe)=>oe,X})}),define(pe[121],be([1,0,4,8,28,60,34,2,6,98]),function(Q,t,y,i,W,B,C,D,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function f(n,e){(0,d.isString)(e)?n.title=(0,C.stripIcons)(e):e?.markdownNotSupportedFallback?n.title=e.markdownNotSupportedFallback:n.removeAttribute("title")}t.setupNativeHover=f;class N{constructor(e,g,b){this.hoverDelegate=e,this.target=g,this.fadeInAnimation=b}async update(e,g,b){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let w;if(e===void 0||(0,d.isString)(e)||e instanceof HTMLElement)w=e;else if(!(0,d.isFunction)(e.markdown))w=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,c.localize)(0,null),g),this._cancellationTokenSource=new W.CancellationTokenSource;const E=this._cancellationTokenSource.token;if(w=await e.markdown(E),w===void 0&&(w=e.markdownNotSupportedFallback),this.isDisposed||E.isCancellationRequested)return}this.show(w,g,b)}show(e,g,b){const w=this._hoverWidget;if(this.hasContent(e)){const E={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!w,...b};this._hoverWidget=this.hoverDelegate.showHover(E,g)}w?.dispose()}hasContent(e){return e?(0,B.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function l(n,e,g,b){let w,E;const a=(_,r)=>{_&&(E?.dispose(),E=void 0),r&&(w?.dispose(),w=void 0),n.onDidHideHover?.()},u=(_,r,v)=>new i.TimeoutTimer(async()=>{(!E||E.isDisposed)&&(E=new N(n,v||e,_>0),await E.update(g,r,b))},_),m=()=>{if(w)return;const _=new D.DisposableStore,r=s=>a(!1,s.fromElement===e);_.add(y.addDisposableListener(e,y.EventType.MOUSE_LEAVE,r,!0));const v=()=>a(!0,!0);_.add(y.addDisposableListener(e,y.EventType.MOUSE_DOWN,v,!0));const o={targetElements:[e],dispose:()=>{}};if(n.placement===void 0||n.placement==="mouse"){const s=p=>{o.x=p.x+10,p.target instanceof HTMLElement&&p.target.classList.contains("action-label")&&a(!0,!0)};_.add(y.addDisposableListener(e,y.EventType.MOUSE_MOVE,s,!0))}_.add(u(n.delay,!1,o)),w=_},S=y.addDisposableListener(e,y.EventType.MOUSE_OVER,m,!0);return{show:_=>{a(!1,!0),u(0,_)},hide:()=>{a(!0,!0)},update:async(_,r)=>{g=_,await E?.update(g,void 0,r)},dispose:()=>{S.dispose(),a(!0,!0)}}}t.setupCustomHover=l}),define(pe[122],be([1,0,4,18,19,120,59,14,3,43,2,5,100,91]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const n=y.$,e="selectOption.entry.template";class g{get templateId(){return e}renderTemplate(E){const a=Object.create(null);return a.root=E,a.text=y.append(E,n(".option-text")),a.detail=y.append(E,n(".option-detail")),a.decoratorRight=y.append(E,n(".option-decorator-right")),a}renderElement(E,a,u){const m=u,S=E.text,T=E.detail,_=E.decoratorRight,r=E.isDisabled;m.text.textContent=S,m.detail.textContent=T||"",m.decoratorRight.innerText=_||"",r?m.root.classList.add("option-disabled"):m.root.classList.remove("option-disabled")}disposeTemplate(E){}}class b extends f.Disposable{constructor(E,a,u,m,S){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.selectBoxOptions=S||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=b.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new d.Emitter,this._register(this._onDidSelect),this.styles=m,this.registerListeners(),this.constructSelectDropDown(u),this.selected=a||0,E&&this.setOptions(E,a)}getHeight(){return 18}getTemplateId(){return e}constructSelectDropDown(E){this.contextViewProvider=E,this.selectDropDownContainer=y.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=y.append(this.selectDropDownContainer,n(".select-box-details-pane"));const a=y.append(this.selectDropDownContainer,n(".select-box-dropdown-container-width-control")),u=y.append(a,n(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",y.append(u,this.widthControlElement),this._dropDownPosition=0,this.styleElement=y.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(y.addDisposableListener(this.selectDropDownContainer,y.EventType.DRAG_START,m=>{y.EventHelper.stop(m,!0)}))}registerListeners(){this._register(y.addStandardDisposableListener(this.selectElement,"change",a=>{this.selected=a.target.selectedIndex,this._onDidSelect.fire({index:a.target.selectedIndex,selected:a.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(y.addDisposableListener(this.selectElement,y.EventType.CLICK,a=>{y.EventHelper.stop(a),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(y.addDisposableListener(this.selectElement,y.EventType.MOUSE_DOWN,a=>{y.EventHelper.stop(a)}));let E;this._register(y.addDisposableListener(this.selectElement,"touchstart",a=>{E=this._isVisible})),this._register(y.addDisposableListener(this.selectElement,"touchend",a=>{y.EventHelper.stop(a),E?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(y.addDisposableListener(this.selectElement,y.EventType.KEY_DOWN,a=>{const u=new W.StandardKeyboardEvent(a);let m=!1;N.isMacintosh?(u.keyCode===18||u.keyCode===16||u.keyCode===10||u.keyCode===3)&&(m=!0):(u.keyCode===18&&u.altKey||u.keyCode===16&&u.altKey||u.keyCode===10||u.keyCode===3)&&(m=!0),m&&(this.showSelectDropDown(),y.EventHelper.stop(a,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(E,a){D.equals(this.options,E)||(this.options=E,this.selectElement.options.length=0,this._hasDetails=!1,this.options.forEach((u,m)=>{this.selectElement.add(this.createOption(u.text,m,u.isDisabled)),typeof u.description=="string"&&(this._hasDetails=!0)})),a!==void 0&&(this.select(a),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(E){E>=0&&E<this.options.length?this.selected=E:E>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(E){this.selectBoxOptions.ariaLabel=E,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(E){this.selectElement.tabIndex=E?0:-1}render(E){this.container=E,E.classList.add("select-container"),E.appendChild(this.selectElement),this.applyStyles()}style(E){const a=[];this.styles=E,this.styles.listFocusBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&!this.styles.selectBorder.equals(this.styles.selectBackground)?(a.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=a.join(`
`),this.applyStyles()}applyStyles(){if(this.selectElement){const E=this.styles.selectBackground?this.styles.selectBackground.toString():"",a=this.styles.selectForeground?this.styles.selectForeground.toString():"",u=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=E,this.selectElement.style.color=a,this.selectElement.style.borderColor=u}this.selectList&&this.styleList()}styleList(){if(this.selectList){const E=this.styles.selectBackground?this.styles.selectBackground.toString():"";this.selectList.style({});const a=this.styles.selectListBackground?this.styles.selectListBackground.toString():E;this.selectDropDownListContainer.style.backgroundColor=a,this.selectionDetailsPane.style.backgroundColor=a;const u=this.styles.focusBorder?this.styles.focusBorder.toString():"";this.selectDropDownContainer.style.outlineColor=u,this.selectDropDownContainer.style.outlineOffset="-1px"}}createOption(E,a,u){const m=document.createElement("option");return m.value=E,m.text=E,m.disabled=!!u,m}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:E=>this.renderSelectDropDown(E,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:E=>this.renderSelectDropDown(E),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(E){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),E&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(E,a){return E.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(a),{dispose:()=>{try{E.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let E=0;return this.options.forEach((a,u)=>{this.updateDetail(u),this.selectionDetailsPane.offsetHeight>E&&(E=this.selectionDetailsPane.offsetHeight)}),E}layoutSelectDropDown(E){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const a=y.getDomNodePagePosition(this.selectElement),u=getComputedStyle(this.selectElement),m=parseFloat(u.getPropertyValue("--dropdown-padding-top"))+parseFloat(u.getPropertyValue("--dropdown-padding-bottom")),S=window.innerHeight-a.top-a.height-(this.selectBoxOptions.minBottomMargin||0),T=a.top-b.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,_=this.selectElement.offsetWidth,r=this.setWidthControlElement(this.widthControlElement),v=Math.max(r,Math.round(_)).toString()+"px";this.selectDropDownContainer.style.width=v,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let o=this.selectList.contentHeight;const s=this._hasDetails?this.measureMaxDetailsHeight():0,p=o+m+s,L=Math.floor((S-m-s)/this.getHeight()),V=Math.floor((T-m-s)/this.getHeight());if(E)return a.top+a.height>window.innerHeight-22||a.top<b.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||L<1&&V<1?!1:(L<b.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&V>L&&this.options.length>L?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(a.top+a.height>window.innerHeight-22||a.top<b.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&L<1||this._dropDownPosition===1&&V<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&L+V<1)return this.hideSelectDropDown(!0),!1;p>S&&(o=L*this.getHeight())}else p>T&&(o=V*this.getHeight());return this.selectList.layout(o),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=o+m+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=o+m+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=v,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(E){let a=0;if(E){let u=0,m=0;this.options.forEach((S,T)=>{const _=S.detail?S.detail.length:0,r=S.decoratorRight?S.decoratorRight.length:0,v=S.text.length+_+r;v>m&&(u=T,m=v)}),E.textContent=this.options[u].text+(this.options[u].decoratorRight?this.options[u].decoratorRight+" ":""),a=y.getTotalWidth(E)}return a}createSelectList(E){if(this.selectList)return;this.selectDropDownListContainer=y.append(E,n(".select-box-dropdown-list-container")),this.listRenderer=new g,this.selectList=new C.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:m=>{let S=m.text;return m.detail&&(S+=`. ${m.detail}`),m.decoratorRight&&(S+=`. ${m.decoratorRight}`),m.description&&(S+=`. ${m.description}`),S},getWidgetAriaLabel:()=>(0,l.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const a=this._register(new i.DomEmitter(this.selectDropDownListContainer,"keydown")),u=d.Event.chain(a.event).filter(()=>this.selectList.length>0).map(m=>new W.StandardKeyboardEvent(m));this._register(u.filter(m=>m.keyCode===3).on(m=>this.onEnter(m),this)),this._register(u.filter(m=>m.keyCode===2).on(m=>this.onEnter(m),this)),this._register(u.filter(m=>m.keyCode===9).on(m=>this.onEscape(m),this)),this._register(u.filter(m=>m.keyCode===16).on(m=>this.onUpArrow(m),this)),this._register(u.filter(m=>m.keyCode===18).on(m=>this.onDownArrow(m),this)),this._register(u.filter(m=>m.keyCode===12).on(this.onPageDown,this)),this._register(u.filter(m=>m.keyCode===11).on(this.onPageUp,this)),this._register(u.filter(m=>m.keyCode===14).on(this.onHome,this)),this._register(u.filter(m=>m.keyCode===13).on(this.onEnd,this)),this._register(u.filter(m=>m.keyCode>=21&&m.keyCode<=56||m.keyCode>=80&&m.keyCode<=108).on(this.onCharacter,this)),this._register(y.addDisposableListener(this.selectList.getHTMLElement(),y.EventType.POINTER_UP,m=>this.onPointerUp(m))),this._register(this.selectList.onMouseOver(m=>typeof m.index<"u"&&this.selectList.setFocus([m.index]))),this._register(this.selectList.onDidChangeFocus(m=>this.onListFocus(m))),this._register(y.addDisposableListener(this.selectDropDownContainer,y.EventType.FOCUS_OUT,m=>{!this._isVisible||y.isAncestor(m.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(E){if(!this.selectList.length)return;y.EventHelper.stop(E);const a=E.target;if(!a||a.classList.contains("slider"))return;const u=a.closest(".monaco-list-row");if(!u)return;const m=Number(u.getAttribute("data-index")),S=u.classList.contains("option-disabled");m>=0&&m<this.options.length&&!S&&(this.selected=m,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(E,a){const u=S=>{for(let T=0;T<S.childNodes.length;T++){const _=S.childNodes.item(T);(_.tagName&&_.tagName.toLowerCase())==="img"?S.removeChild(_):u(_)}},m=(0,B.renderMarkdown)({value:E,supportThemeIcons:!0},{actionHandler:a});return m.element.classList.add("select-box-description-markdown"),u(m.element),m.element}onListFocus(E){!this._isVisible||!this._hasDetails||this.updateDetail(E.indexes[0])}updateDetail(E){this.selectionDetailsPane.innerText="";const a=this.options[E],u=a?.description??"",m=a?.descriptionIsMarkdown??!1;if(u){if(m){const S=a.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(u,S))}else this.selectionDetailsPane.innerText=u;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(E){y.EventHelper.stop(E),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(E){y.EventHelper.stop(E),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(E){if(this.selected<this.options.length-1){y.EventHelper.stop(E,!0);const a=this.options[this.selected+1].isDisabled;if(a&&this.options.length>this.selected+2)this.selected+=2;else{if(a)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(E){this.selected>0&&(y.EventHelper.stop(E,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(E){y.EventHelper.stop(E),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(E){y.EventHelper.stop(E),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(E){y.EventHelper.stop(E),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(E){y.EventHelper.stop(E),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(E){const a=c.KeyCodeUtils.toString(E.keyCode);let u=-1;for(let m=0;m<this.options.length-1;m++)if(u=(m+this.selected+1)%this.options.length,this.options[u].text.charAt(0).toUpperCase()===a&&!this.options[u].isDisabled){this.select(u),this.selectList.setFocus([u]),this.selectList.reveal(this.selectList.getFocus()[0]),y.EventHelper.stop(E);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=b,b.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,b.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,b.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(pe[123],be([1,0,122,116,17,24,27,5,90]),function(Q,t,y,i,W,B,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:B.Color.fromHex("#3C3C3C"),selectForeground:B.Color.fromHex("#F0F0F0"),selectBorder:B.Color.fromHex("#3C3C3C")};class d extends W.Widget{constructor(f,N,l,n=(0,C.deepClone)(t.defaultStyles),e){super(),D.isMacintosh&&!e?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(f,N,n,e):this.selectBoxDelegate=new y.SelectBoxList(f,N,l,n,e),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(f,N){this.selectBoxDelegate.setOptions(f,N)}select(f){this.selectBoxDelegate.select(f)}setAriaLabel(f){this.selectBoxDelegate.setAriaLabel(f)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(f){this.selectBoxDelegate.setFocusable(f)}render(f){this.selectBoxDelegate.render(f)}style(f){this.selectBoxDelegate.style(f)}applyStyles(){this.selectBoxDelegate.applyStyles()}}t.SelectBox=d}),define(pe[61],be([1,0,15,51,4,22,121,123,32,2,5,6,95,47]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class n extends c.Disposable{get action(){return this._action}constructor(w,E,a={}){super(),this.options=a,this._context=w||this,this._action=E,E instanceof d.Action&&this._register(E.onDidChange(u=>{!this.element||this.handleActionChangeEvent(u)}))}handleActionChangeEvent(w){w.enabled!==void 0&&this.updateEnabled(),w.checked!==void 0&&this.updateChecked(),w.class!==void 0&&this.updateClass(),w.label!==void 0&&(this.updateLabel(),this.updateTooltip()),w.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new d.ActionRunner)),this._actionRunner}set actionRunner(w){this._actionRunner=w}isEnabled(){return this._action.enabled}setActionContext(w){this._context=w}render(w){const E=this.element=w;this._register(B.Gesture.addTarget(w));const a=this.options&&this.options.draggable;a&&(w.draggable=!0,y.isFirefox&&this._register((0,W.addDisposableListener)(w,W.EventType.DRAG_START,u=>u.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this._register((0,W.addDisposableListener)(E,B.EventType.Tap,u=>this.onClick(u,!0))),this._register((0,W.addDisposableListener)(E,W.EventType.MOUSE_DOWN,u=>{a||W.EventHelper.stop(u,!0),this._action.enabled&&u.button===0&&E.classList.add("active")})),f.isMacintosh&&this._register((0,W.addDisposableListener)(E,W.EventType.CONTEXT_MENU,u=>{u.button===0&&u.ctrlKey===!0&&this.onClick(u)})),this._register((0,W.addDisposableListener)(E,W.EventType.CLICK,u=>{W.EventHelper.stop(u,!0),this.options&&this.options.isMenu||this.onClick(u)})),this._register((0,W.addDisposableListener)(E,W.EventType.DBLCLICK,u=>{W.EventHelper.stop(u,!0)})),[W.EventType.MOUSE_UP,W.EventType.MOUSE_OUT].forEach(u=>{this._register((0,W.addDisposableListener)(E,u,m=>{W.EventHelper.stop(m),E.classList.remove("active")}))})}onClick(w,E=!1){W.EventHelper.stop(w,!0);const a=N.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?w:{preserveFocus:E}:this._context;this.actionRunner.run(this._action,a)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(w){this.element&&(this.element.tabIndex=w?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const w=this.getTooltip()??"";this.updateAriaLabel(),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(w):(this.customHover=(0,C.setupCustomHover)(this.options.hoverDelegate,this.element,w),this._store.add(this.customHover))):this.element.title=w}updateAriaLabel(){if(this.element){const w=this.getTooltip()??"";this.element.setAttribute("aria-label",w)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=n;class e extends n{constructor(w,E,a={}){super(w,E,a),this.options=a,this.options.icon=a.icon!==void 0?a.icon:!1,this.options.label=a.label!==void 0?a.label:!0,this.cssClass=""}render(w){super.render(w),this.element&&(this.label=(0,W.append)(this.element,(0,W.$)("a.action-label"))),this.label&&(this._action.id===d.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,W.append)(this.element,(0,W.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(w){this.label&&(this.label.tabIndex=w?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let w=null;return this.action.tooltip?w=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(w=this.action.label,this.options.keybinding&&(w=l.localize(0,null,w,this.options.keybinding))),w??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const w=this.getTooltip()??"";this.label.setAttribute("aria-label",w)}}updateChecked(){this.label&&(this.action.checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class g extends n{constructor(w,E,a,u,m,S){super(w,E),this.selectBox=new D.SelectBox(a,u,m,void 0,S),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(w,E){this.selectBox.setOptions(w,E)}select(w){this.selectBox.select(w)}registerListeners(){this._register(this.selectBox.onDidSelect(w=>this.runAction(w.selected,w.index)))}runAction(w,E){this.actionRunner.run(this._action,this.getActionContext(w,E))}getActionContext(w,E){return w}setFocusable(w){this.selectBox.setFocusable(w)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(w){this.selectBox.render(w)}}t.SelectActionViewItem=g}),define(pe[62],be([1,0,4,19,61,32,3,2,6,47]),function(Q,t,y,i,W,B,C,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var c;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(c=t.ActionsOrientation||(t.ActionsOrientation={}));class f extends D.Disposable{constructor(n,e={}){super(),this._actionRunnerDisposables=this._register(new D.DisposableStore),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new C.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new C.Emitter({onFirstListenerAdd:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new C.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new C.Emitter),this.onWillRun=this._onWillRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new B.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(w=>this._onDidRun.fire(w))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(w=>this._onWillRun.fire(w))),this.viewItems=[],this.viewItemDisposables=new Map,this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let g,b;switch(this._orientation){case 0:g=[15],b=[17];break;case 1:g=[16],b=[18],this.domNode.className+=" vertical";break}this._register(y.addDisposableListener(this.domNode,y.EventType.KEY_DOWN,w=>{const E=new i.StandardKeyboardEvent(w);let a=!0;const u=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;g&&(E.equals(g[0])||E.equals(g[1]))?a=this.focusPrevious():b&&(E.equals(b[0])||E.equals(b[1]))?a=this.focusNext():E.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():E.equals(14)?a=this.focusFirst():E.equals(13)?a=this.focusLast():E.equals(2)&&u instanceof W.BaseActionViewItem&&u.trapsArrowNavigation?a=this.focusNext():this.isTriggerKeyEvent(E)?this._triggerKeys.keyDown?this.doTrigger(E):this.triggerKeyDown=!0:a=!1,a&&(E.preventDefault(),E.stopPropagation())})),this._register(y.addDisposableListener(this.domNode,y.EventType.KEY_UP,w=>{const E=new i.StandardKeyboardEvent(w);this.isTriggerKeyEvent(E)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(E)),E.preventDefault(),E.stopPropagation()):(E.equals(2)||E.equals(1026))&&this.updateFocusedItem()})),this.focusTracker=this._register(y.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(y.getActiveElement()===this.domNode||!y.isAncestor(y.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),n.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(n){n?this.actionsList.setAttribute("aria-label",n):this.actionsList.removeAttribute("aria-label")}setFocusable(n){if(this.focusable=n,this.focusable){const e=this.viewItems.find(g=>g instanceof W.BaseActionViewItem&&g.isEnabled());e instanceof W.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof W.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(n){let e=!1;return this._triggerKeys.keys.forEach(g=>{e=e||n.equals(g)}),e}updateFocusedItem(){for(let n=0;n<this.actionsList.children.length;n++){const e=this.actionsList.children[n];if(y.isAncestor(y.getActiveElement(),e)){this.focusedItem=n;break}}}get context(){return this._context}set context(n){this._context=n,this.viewItems.forEach(e=>e.setActionContext(n))}get actionRunner(){return this._actionRunner}set actionRunner(n){this._actionRunner=n,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(e=>this._onDidRun.fire(e))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(e=>this._onWillRun.fire(e))),this.viewItems.forEach(e=>e.actionRunner=n)}getContainer(){return this.domNode}hasAction(n){return this.viewItems.findIndex(e=>e.action.id===n.id)!==-1}getAction(n){if(typeof n=="number")return this.viewItems[n]?.action;if(n instanceof HTMLElement){for(;n.parentElement!==this.actionsList;){if(!n.parentElement)return;n=n.parentElement}for(let e=0;e<this.actionsList.childNodes.length;e++)if(this.actionsList.childNodes[e]===n)return this.viewItems[e].action}}push(n,e={}){const g=Array.isArray(n)?n:[n];let b=d.isNumber(e.index)?e.index:null;g.forEach(w=>{const E=document.createElement("li");E.className="action-item",E.setAttribute("role","presentation");let a;this.options.actionViewItemProvider&&(a=this.options.actionViewItemProvider(w)),a||(a=new W.ActionViewItem(this.context,w,{hoverDelegate:this.options.hoverDelegate,...e})),this.options.allowContextMenu||this.viewItemDisposables.set(a,y.addDisposableListener(E,y.EventType.CONTEXT_MENU,u=>{y.EventHelper.stop(u,!0)})),a.actionRunner=this._actionRunner,a.setActionContext(this.context),a.render(E),this.focusable&&a instanceof W.BaseActionViewItem&&this.viewItems.length===0&&a.setFocusable(!0),b===null||b<0||b>=this.actionsList.children.length?(this.actionsList.appendChild(E),this.viewItems.push(a)):(this.actionsList.insertBefore(E,this.actionsList.children[b]),this.viewItems.splice(b,0,a),b++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(n){if(n>=0&&n<this.actionsList.children.length){const e=this.actionsList.children.item(n);if(e)return e.clientWidth}return 0}getHeight(n){if(n>=0&&n<this.actionsList.children.length){const e=this.actionsList.children.item(n);if(e)return e.clientHeight}return 0}pull(n){n>=0&&n<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[n]),this.viewItemDisposables.get(this.viewItems[n])?.dispose(),this.viewItemDisposables.delete(this.viewItems[n]),(0,D.dispose)(this.viewItems.splice(n,1)),this.refreshRole())}clear(){(0,D.dispose)(this.viewItems),(0,D.dispose)(this.viewItemDisposables.values()),this.viewItemDisposables.clear(),this.viewItems=[],y.clearNode(this.actionsList),this.refreshRole()}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(n){let e=!1,g;if(n===void 0?e=!0:typeof n=="number"?g=n:typeof n=="boolean"&&(e=n),e&&typeof this.focusedItem>"u"){const b=this.viewItems.findIndex(w=>w.isEnabled());this.focusedItem=b===-1?void 0:b,this.updateFocus(void 0,void 0,!0)}else g!==void 0&&(this.focusedItem=g),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(n){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let g;do{if(!n&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,g=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!g.isEnabled()||g.action.id===B.Separator.ID));return this.updateFocus(),!0}focusPrevious(n){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let g;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!n&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}g=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!g.isEnabled()||g.action.id===B.Separator.ID));return this.updateFocus(!0),!0}updateFocus(n,e,g=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const b=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(b){let w=!0;d.isFunction(b.focus)||(w=!1),this.options.focusOnlyEnabledItems&&d.isFunction(b.isEnabled)&&!b.isEnabled()&&(w=!1),b.action.id===B.Separator.ID&&(w=!1),w?(g||this.previouslyFocusedItem!==this.focusedItem)&&(b.focus(n),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(n){if(typeof this.focusedItem>"u")return;const e=this.viewItems[this.focusedItem];if(e instanceof W.BaseActionViewItem){const g=e._context===null||e._context===void 0?n:e._context;this.run(e._action,g)}}async run(n,e){await this._actionRunner.run(n,e)}dispose(){(0,D.dispose)(this.viewItems),this.viewItems=[],this.getContainer().remove(),super.dispose()}}t.ActionBar=f;function N(l){if(!l.length)return l;let n=-1;for(let g=0;g<l.length;g++)if(l[g].id!==B.Separator.ID){n=g;break}if(n===-1)return[];l=l.slice(n);for(let g=l.length-1;g>=0&&l[g].id===B.Separator.ID;g--)l.splice(g,1);let e=!1;for(let g=l.length-1;g>=0;g--){const b=l[g].id===B.Separator.ID;b&&!e?l.splice(g,1):b?b&&(e=!1):e=!0}return l}t.prepareActions=N}),define(pe[124],be([1,0,4,18,52,62,54,57,17,24,3,77,27,99,87]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=y.$;var g;(function(a){a[a.INFO=1]="INFO",a[a.WARNING=2]="WARNING",a[a.ERROR=3]="ERROR"})(g=t.MessageType||(t.MessageType={}));const b={inputBackground:c.Color.fromHex("#3C3C3C"),inputForeground:c.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:c.Color.fromHex("#55AAFF"),inputValidationInfoBackground:c.Color.fromHex("#063B49"),inputValidationWarningBorder:c.Color.fromHex("#B89500"),inputValidationWarningBackground:c.Color.fromHex("#352A05"),inputValidationErrorBorder:c.Color.fromHex("#BE1100"),inputValidationErrorBackground:c.Color.fromHex("#5A1D1D")};class w extends d.Widget{constructor(u,m,S){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new f.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=m,this.options=S||Object.create(null),(0,l.mixin)(this.options,b,!1),this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.inputBackground=this.options.inputBackground,this.inputForeground=this.options.inputForeground,this.inputBorder=this.options.inputBorder,this.inputValidationInfoBorder=this.options.inputValidationInfoBorder,this.inputValidationInfoBackground=this.options.inputValidationInfoBackground,this.inputValidationInfoForeground=this.options.inputValidationInfoForeground,this.inputValidationWarningBorder=this.options.inputValidationWarningBorder,this.inputValidationWarningBackground=this.options.inputValidationWarningBackground,this.inputValidationWarningForeground=this.options.inputValidationWarningForeground,this.inputValidationErrorBorder=this.options.inputValidationErrorBorder,this.inputValidationErrorBackground=this.options.inputValidationErrorBackground,this.inputValidationErrorForeground=this.options.inputValidationErrorForeground,this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=y.append(u,e(".monaco-inputbox.idle"));const T=this.options.flexibleHeight?"textarea":"input",_=y.append(this.element,e(".ibwrapper"));if(this.input=y.append(_,e(T+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=y.append(_,e("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new D.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),y.append(u,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(o=>this.input.scrollTop=o.scrollTop));const r=this._register(new i.DomEmitter(document,"selectionchange")),v=f.Event.filter(r.event,()=>document.getSelection()?.anchorNode===_);this._register(v(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this.ignoreGesture(this.input),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new B.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(u){this.placeholder=u,this.input.setAttribute("placeholder",u)}setTooltip(u){this.tooltip=u,this.input.title=u}setAriaLabel(u){this.ariaLabel=u,u?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(u){this.input.value!==u&&(this.input.value=u,this.onValueChange())}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:y.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(u=null){this.input.select(),u&&(this.input.setSelectionRange(u.start,u.end),u.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(u){u?this.enable():this.disable()}get width(){return y.getTotalWidth(this.input)}set width(u){if(this.options.flexibleHeight&&this.options.flexibleWidth){let m=0;if(this.mirror){const S=parseFloat(this.mirror.style.paddingLeft||"")||0,T=parseFloat(this.mirror.style.paddingRight||"")||0;m=S+T}this.input.style.width=u-m+"px"}else this.input.style.width=u+"px";this.mirror&&(this.mirror.style.width=u+"px")}set paddingRight(u){this.input.style.width=`calc(100% - ${u}px)`,this.mirror&&(this.mirror.style.paddingRight=u+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const u=this.cachedContentHeight,m=this.cachedHeight,S=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:u,height:m}),this.scrollableElement.setScrollPosition({scrollTop:S})}showMessage(u,m){this.message=u,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(u.type));const S=this.stylesForType(this.message.type);this.element.style.border=S.border?`1px solid ${S.border}`:"",this.message.content&&(this.hasFocus()||m)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let u=null;return this.validation&&(u=this.validation(this.value),u?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(u)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),u?.type}stylesForType(u){switch(u){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}}classForType(u){switch(u){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let u;const m=()=>u.style.width=y.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:T=>{if(!this.message)return null;u=y.append(T,e(".monaco-inputbox-container")),m();const _={inline:!0,className:"monaco-inputbox-message"},r=this.message.formatContent?(0,W.renderFormattedText)(this.message.content,_):(0,W.renderText)(this.message.content,_);r.classList.add(this.classForType(this.message.type));const v=this.stylesForType(this.message.type);return r.style.backgroundColor=v.background?v.background.toString():"",r.style.color=v.foreground?v.foreground.toString():"",r.style.border=v.border?`1px solid ${v.border}`:"",y.append(u,r),null},onHide:()=>{this.state="closed"},layout:m});let S;this.message.type===3?S=n.localize(0,null,this.message.content):this.message.type===2?S=n.localize(1,null,this.message.content):S=n.localize(2,null,this.message.content),C.alert(S),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const u=this.value,S=u.charCodeAt(u.length-1)===10?" ":"";(u+S).replace(/\u000c/g,"")?this.mirror.textContent=u+S:this.mirror.innerText="\xA0",this.layout()}style(u){this.inputBackground=u.inputBackground,this.inputForeground=u.inputForeground,this.inputBorder=u.inputBorder,this.inputValidationInfoBackground=u.inputValidationInfoBackground,this.inputValidationInfoForeground=u.inputValidationInfoForeground,this.inputValidationInfoBorder=u.inputValidationInfoBorder,this.inputValidationWarningBackground=u.inputValidationWarningBackground,this.inputValidationWarningForeground=u.inputValidationWarningForeground,this.inputValidationWarningBorder=u.inputValidationWarningBorder,this.inputValidationErrorBackground=u.inputValidationErrorBackground,this.inputValidationErrorForeground=u.inputValidationErrorForeground,this.inputValidationErrorBorder=u.inputValidationErrorBorder,this.applyStyles()}applyStyles(){const u=this.inputBackground?this.inputBackground.toString():"",m=this.inputForeground?this.inputForeground.toString():"",S=this.inputBorder?this.inputBorder.toString():"";this.element.style.backgroundColor=u,this.element.style.color=m,this.input.style.backgroundColor="inherit",this.input.style.color=m,this.element.style.borderWidth=S?"1px":"",this.element.style.borderStyle=S?"solid":"",this.element.style.borderColor=S}layout(){if(!this.mirror)return;const u=this.cachedContentHeight;this.cachedContentHeight=y.getTotalHeight(this.mirror),u!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(u){const m=this.inputElement,S=m.selectionStart,T=m.selectionEnd,_=m.value;S!==null&&T!==null&&(this.value=_.substr(0,S)+u+_.substr(T),m.setSelectionRange(S+1,S+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=w;class E extends w{constructor(u,m,S){const T=n.localize(3,null),_=` or \u21C5 ${T}`,r=` (\u21C5 ${T})`;super(u,m,S),this._onDidFocus=this._register(new f.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new f.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new N.HistoryNavigator(S.history,100);const v=()=>{if(S.showHistoryHint&&S.showHistoryHint()&&!this.placeholder.endsWith(_)&&!this.placeholder.endsWith(r)&&this.history.getHistory().length){const o=this.placeholder.endsWith(")")?_:r,s=this.placeholder+o;S.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=s:this.setPlaceHolder(s)}};this.observer=new MutationObserver((o,s)=>{o.forEach(p=>{p.target.textContent||v()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>v()),this.onblur(this.input,()=>{const o=s=>{if(this.placeholder.endsWith(s)){const p=this.placeholder.slice(0,this.placeholder.length-s.length);return S.showPlaceholderOnFocus?this.placeholder=p:this.setPlaceHolder(p),!0}else return!1};o(r)||o(_)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}showNextValue(){this.history.has(this.value)||this.addToHistory();let u=this.getNextValue();u&&(u=u===this.value?this.getNextValue():u),u&&(this.value=u,C.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let u=this.getPreviousValue();u&&(u=u===this.value?this.getPreviousValue():u),u&&(this.value=u,C.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let u=this.history.current();return u||(u=this.history.last(),this.history.next()),u}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=E}),define(pe[63],be([1,0,61,17,12,24,3,92]),function(Q,t,y,i,W,B,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const D={inputActiveOptionBorder:B.Color.fromHex("#007ACC00"),inputActiveOptionForeground:B.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:B.Color.fromHex("#0E639C50")};class d extends y.BaseActionViewItem{constructor(l,n,e){super(l,n,e),this.toggle=this._register(new c({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(l){this.element=l,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(l){this.toggle.domNode.tabIndex=l?0:-1}}t.ToggleActionViewItem=d;class c extends i.Widget{constructor(l){super(),this._onChange=this._register(new C.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new C.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts={...D,...l},this._checked=this._opts.isChecked;const n=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,n.push(...W.CSSIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&n.push(...this._opts.actionClassName.split(" ")),this._checked&&n.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...n),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,e=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),e.preventDefault())}),this.ignoreGesture(this.domNode),this.onkeydown(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),e.preventDefault(),e.stopPropagation();return}this._onKeyDown.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(l){this._checked=l,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(l){this._icon&&this.domNode.classList.remove(...W.CSSIcon.asClassNameArray(this._icon)),this._icon=l,this._icon&&this.domNode.classList.add(...W.CSSIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}style(l){l.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=l.inputActiveOptionBorder),l.inputActiveOptionForeground&&(this._opts.inputActiveOptionForeground=l.inputActiveOptionForeground),l.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=l.inputActiveOptionBackground),this.applyStyles()}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground?this._opts.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(l){this.domNode.title=l,this.domNode.setAttribute("aria-label",l)}}t.Toggle=c;class f extends i.Widget{constructor(l,n){super(),this.title=l,this.isChecked=n,this.checkbox=new c({title:this.title,isChecked:this.isChecked,icon:W.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.checkbox.domNode,this.styles={},this.checkbox.onChange(()=>{this.applyStyles()})}get checked(){return this.checkbox.checked}set checked(l){this.checkbox.checked=l,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(l){this.styles=l,this.applyStyles()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground?this.styles.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.styles.checkboxBackground?this.styles.checkboxBackground.toString():"",this.domNode.style.borderColor=this.styles.checkboxBorder?this.styles.checkboxBorder.toString():""}}t.Checkbox=f}),define(pe[125],be([1,0,63,12,97]),function(Q,t,y,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const B=W.localize(0,null),C=W.localize(1,null),D=W.localize(2,null);class d extends y.Toggle{constructor(l){super({icon:i.Codicon.caseSensitive,title:B+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.CaseSensitiveToggle=d;class c extends y.Toggle{constructor(l){super({icon:i.Codicon.wholeWord,title:C+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.WholeWordsToggle=c;class f extends y.Toggle{constructor(l){super({icon:i.Codicon.regex,title:D+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.RegexToggle=f}),define(pe[126],be([1,0,4,125,124,17,3,96,2,86]),function(Q,t,y,i,W,B,C,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const c=D.localize(0,null);class f extends B.Widget{constructor(l,n,e){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=new d.DisposableStore,this.additionalToggles=[],this._onDidOptionChange=this._register(new C.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new C.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new C.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new C.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new C.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new C.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new C.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||c,this.showCommonFindToggles=!!e.showCommonFindToggles,this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionForeground=e.inputActiveOptionForeground,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground;const g=e.appendCaseSensitiveLabel||"",b=e.appendWholeWordsLabel||"",w=e.appendRegexLabel||"",E=e.history||[],a=!!e.flexibleHeight,u=!!e.flexibleWidth,m=e.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new W.HistoryInputBox(this.domNode,n,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:E,showHistoryHint:e.showHistoryHint,flexibleHeight:a,flexibleWidth:u,flexibleMaxHeight:m})),this.regex=this._register(new i.RegexToggle({appendTitle:w,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.regex.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(T=>{this._onRegexKeyDown.fire(T)})),this.wholeWords=this._register(new i.WholeWordsToggle({appendTitle:b,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.wholeWords.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new i.CaseSensitiveToggle({appendTitle:g,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.caseSensitive.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(T=>{this._onCaseSensitiveKeyDown.fire(T)}));const S=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,T=>{if(T.equals(15)||T.equals(17)||T.equals(9)){const _=S.indexOf(document.activeElement);if(_>=0){let r=-1;T.equals(17)?r=(_+1)%S.length:T.equals(15)&&(_===0?r=S.length-1:r=_-1),T.equals(9)?(S[_].blur(),this.inputBox.focus()):r>=0&&S[r].focus(),y.EventHelper.stop(T,!0)}}}),this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"block":"none",this.controls.appendChild(this.caseSensitive.domNode),this.controls.appendChild(this.wholeWords.domNode),this.controls.appendChild(this.regex.domNode),this.showCommonFindToggles||(this.caseSensitive.domNode.style.display="none",this.wholeWords.domNode.style.display="none",this.regex.domNode.style.display="none"),this.setAdditionalToggles(e?.additionalToggles),this.domNode.appendChild(this.controls),l?.appendChild(this.domNode),this._register(y.addDisposableListener(this.inputBox.inputElement,"compositionstart",T=>{this.imeSessionInProgress=!0})),this._register(y.addDisposableListener(this.inputBox.inputElement,"compositionend",T=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,T=>this._onKeyDown.fire(T)),this.onkeyup(this.inputBox.inputElement,T=>this._onKeyUp.fire(T)),this.oninput(this.inputBox.inputElement,T=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,T=>this._onMouseDown.fire(T))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable();for(const l of this.additionalToggles)l.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable();for(const l of this.additionalToggles)l.disable()}setFocusInputOnOptionClick(l){this.fixFocusOnOptionClickEnabled=l}setEnabled(l){l?this.enable():this.disable()}setAdditionalToggles(l){for(const n of this.additionalToggles)n.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.dispose(),this.additionalTogglesDisposables=new d.DisposableStore;for(const n of l??[])this.additionalTogglesDisposables.add(n),this.controls.appendChild(n.domNode),this.additionalTogglesDisposables.add(n.onChange(e=>{this._onDidOptionChange.fire(e),!e&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(n);this.additionalToggles.length>0&&(this.controls.style.display="block"),this.inputBox.paddingRight=(this.showCommonFindToggles?this.caseSensitive.width()+this.wholeWords.width()+this.regex.width():0)+this.additionalToggles.reduce((n,e)=>n+e.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(l){this.inputBox.value!==l&&(this.inputBox.value=l)}onSearchSubmit(){this.inputBox.addToHistory()}style(l){this.inputActiveOptionBorder=l.inputActiveOptionBorder,this.inputActiveOptionForeground=l.inputActiveOptionForeground,this.inputActiveOptionBackground=l.inputActiveOptionBackground,this.inputBackground=l.inputBackground,this.inputForeground=l.inputForeground,this.inputBorder=l.inputBorder,this.inputValidationInfoBackground=l.inputValidationInfoBackground,this.inputValidationInfoForeground=l.inputValidationInfoForeground,this.inputValidationInfoBorder=l.inputValidationInfoBorder,this.inputValidationWarningBackground=l.inputValidationWarningBackground,this.inputValidationWarningForeground=l.inputValidationWarningForeground,this.inputValidationWarningBorder=l.inputValidationWarningBorder,this.inputValidationErrorBackground=l.inputValidationErrorBackground,this.inputValidationErrorForeground=l.inputValidationErrorForeground,this.inputValidationErrorBorder=l.inputValidationErrorBorder,this.applyStyles()}applyStyles(){if(this.domNode){const l={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(l),this.wholeWords.style(l),this.caseSensitive.style(l);for(const e of this.additionalToggles)e.style(l);const n={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(n)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive.checked}setCaseSensitive(l){this.caseSensitive.checked=l}getWholeWords(){return this.wholeWords.checked}setWholeWords(l){this.wholeWords.checked=l}getRegex(){return this.regex.checked}setRegex(l){this.regex.checked=l,this.validate()}focusOnCaseSensitive(){this.caseSensitive.focus()}focusOnRegex(){this.regex.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(l){this.inputBox.showMessage(l)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=f,f.OPTION_CHANGE="optionChange"}),define(pe[127],be([1,0,4,18,19,62,126,58,59,63,55,23,32,14,8,12,69,3,33,2,45,6,101,93]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l,n,e,g,b,w,E,a,u,m,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class T extends D.ElementsDragAndDropData{set context(F){this.data.context=F}get context(){return this.data.context}constructor(F){super(F.elements.map($=>$.element)),this.data=F}}function _(ne){return ne instanceof D.ElementsDragAndDropData?new T(ne):ne}class r{constructor(F,$){this.modelProvider=F,this.dnd=$,this.autoExpandDisposable=a.Disposable.None}getDragURI(F){return this.dnd.getDragURI(F.element)}getDragLabel(F,$){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(F.map(j=>j.element),$)}onDragStart(F,$){this.dnd.onDragStart?.(_(F),$)}onDragOver(F,$,j,P,h=!0){const I=this.dnd.onDragOver(_(F),$&&$.element,j,P),U=this.autoExpandNode!==$;if(U&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=$),typeof $>"u")return I;if(U&&typeof I!="boolean"&&I.autoExpand&&(this.autoExpandDisposable=(0,e.disposableTimeout)(()=>{const z=this.modelProvider(),A=z.getNodeLocation($);z.isCollapsed(A)&&z.setCollapsed(A,!1),this.autoExpandNode=void 0},500)),typeof I=="boolean"||!I.accept||typeof I.bubble>"u"||I.feedback){if(!h){const z=typeof I=="boolean"?I:I.accept,A=typeof I=="boolean"?void 0:I.effect;return{accept:z,effect:A,feedback:[j]}}return I}if(I.bubble===1){const z=this.modelProvider(),A=z.getNodeLocation($),R=z.getParentNodeLocation(A),O=z.getNode(R),H=R&&z.getListIndex(R);return this.onDragOver(F,O,H,P,!1)}const K=this.modelProvider(),Z=K.getNodeLocation($),k=K.getListIndex(Z),M=K.getListRenderCount(Z);return{...I,feedback:(0,n.range)(k,k+M)}}drop(F,$,j,P){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(_(F),$&&$.element,j,P)}onDragEnd(F){this.dnd.onDragEnd?.(F)}}function v(ne,F){return F&&{...F,identityProvider:F.identityProvider&&{getId($){return F.identityProvider.getId($.element)}},dnd:F.dnd&&new r(ne,F.dnd),multipleSelectionController:F.multipleSelectionController&&{isSelectionSingleChangeEvent($){return F.multipleSelectionController.isSelectionSingleChangeEvent({...$,element:$.element})},isSelectionRangeChangeEvent($){return F.multipleSelectionController.isSelectionRangeChangeEvent({...$,element:$.element})}},accessibilityProvider:F.accessibilityProvider&&{...F.accessibilityProvider,getSetSize($){const j=ne(),P=j.getNodeLocation($),h=j.getParentNodeLocation(P);return j.getNode(h).visibleChildrenCount},getPosInSet($){return $.visibleChildIndex+1},isChecked:F.accessibilityProvider&&F.accessibilityProvider.isChecked?$=>F.accessibilityProvider.isChecked($.element):void 0,getRole:F.accessibilityProvider&&F.accessibilityProvider.getRole?$=>F.accessibilityProvider.getRole($.element):()=>"treeitem",getAriaLabel($){return F.accessibilityProvider.getAriaLabel($.element)},getWidgetAriaLabel(){return F.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:F.accessibilityProvider&&F.accessibilityProvider.getWidgetRole?()=>F.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:F.accessibilityProvider&&F.accessibilityProvider.getAriaLevel?$=>F.accessibilityProvider.getAriaLevel($.element):$=>$.depth,getActiveDescendantId:F.accessibilityProvider.getActiveDescendantId&&($=>F.accessibilityProvider.getActiveDescendantId($.element))},keyboardNavigationLabelProvider:F.keyboardNavigationLabelProvider&&{...F.keyboardNavigationLabelProvider,getKeyboardNavigationLabel($){return F.keyboardNavigationLabelProvider.getKeyboardNavigationLabel($.element)}}}}class o{constructor(F){this.delegate=F}getHeight(F){return this.delegate.getHeight(F.element)}getTemplateId(F){return this.delegate.getTemplateId(F.element)}hasDynamicHeight(F){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(F.element)}setDynamicHeight(F,$){this.delegate.setDynamicHeight?.(F.element,$)}}t.ComposedTreeDelegate=o;class s{static lift(F){return F instanceof s?F:new s(F)}static empty(F=0){return new s({focus:[],selection:[],expanded:Object.create(null),scrollTop:F})}constructor(F){if(this.focus=new Set(F.focus),this.selection=new Set(F.selection),F.expanded instanceof Array){this.expanded=Object.create(null);for(const $ of F.expanded)this.expanded[$]=1}else this.expanded=F.expanded;this.expanded=F.expanded,this.scrollTop=F.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=s;var p;(function(ne){ne.None="none",ne.OnHover="onHover",ne.Always="always"})(p=t.RenderIndentGuides||(t.RenderIndentGuides={}));class L{get elements(){return this._elements}constructor(F,$=[]){this._elements=$,this.disposables=new a.DisposableStore,this.onDidChange=w.Event.forEach(F,j=>this._elements=j,this.disposables)}dispose(){this.disposables.dispose()}}class V{constructor(F,$,j,P,h,I={}){this.renderer=F,this.modelProvider=$,this.activeNodes=P,this.renderedIndentGuides=h,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=V.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=a.Disposable.None,this.disposables=new a.DisposableStore,this.templateId=F.templateId,this.updateOptions(I),w.Event.map(j,U=>U.node)(this.onDidChangeNodeTwistieState,this,this.disposables),F.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(F={}){if(typeof F.indent<"u"){const $=(0,u.clamp)(F.indent,0,40);if($!==this.indent){this.indent=$;for(const[j,P]of this.renderedNodes)this.renderTreeElement(j,P)}}if(typeof F.renderIndentGuides<"u"){const $=F.renderIndentGuides!==p.None;if($!==this.shouldRenderIndentGuides&&(this.shouldRenderIndentGuides=$,this.indentGuidesDisposable.dispose(),$)){const j=new a.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,j),this.indentGuidesDisposable=j,this._onDidChangeActiveNodes(this.activeNodes.elements)}}typeof F.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=F.hideTwistiesOfChildlessElements)}renderTemplate(F){const $=(0,y.append)(F,(0,y.$)(".monaco-tl-row")),j=(0,y.append)($,(0,y.$)(".monaco-tl-indent")),P=(0,y.append)($,(0,y.$)(".monaco-tl-twistie")),h=(0,y.append)($,(0,y.$)(".monaco-tl-contents")),I=this.renderer.renderTemplate(h);return{container:F,indent:j,twistie:P,indentGuidesDisposable:a.Disposable.None,templateData:I}}renderElement(F,$,j,P){this.renderedNodes.set(F,j),this.renderedElements.set(F.element,F),this.renderTreeElement(F,j),this.renderer.renderElement(F,$,j.templateData,P)}disposeElement(F,$,j,P){j.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(F,$,j.templateData,P),typeof P=="number"&&(this.renderedNodes.delete(F),this.renderedElements.delete(F.element))}disposeTemplate(F){this.renderer.disposeTemplate(F.templateData)}onDidChangeTwistieState(F){const $=this.renderedElements.get(F);!$||this.onDidChangeNodeTwistieState($)}onDidChangeNodeTwistieState(F){const $=this.renderedNodes.get(F);!$||(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(F,$))}renderTreeElement(F,$){const j=V.DefaultIndent+(F.depth-1)*this.indent;$.twistie.style.paddingLeft=`${j}px`,$.indent.style.width=`${j+this.indent-16}px`,F.collapsible?$.container.setAttribute("aria-expanded",String(!F.collapsed)):$.container.removeAttribute("aria-expanded"),$.twistie.classList.remove(...g.Codicon.treeItemExpanded.classNamesArray);let P=!1;if(this.renderer.renderTwistie&&(P=this.renderer.renderTwistie(F.element,$.twistie)),F.collapsible&&(!this.hideTwistiesOfChildlessElements||F.visibleChildrenCount>0)?(P||$.twistie.classList.add(...g.Codicon.treeItemExpanded.classNamesArray),$.twistie.classList.add("collapsible"),$.twistie.classList.toggle("collapsed",F.collapsed)):$.twistie.classList.remove("collapsible","collapsed"),(0,y.clearNode)($.indent),$.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const h=new a.DisposableStore,I=this.modelProvider();for(;;){const U=I.getNodeLocation(F),K=I.getParentNodeLocation(U);if(!K)break;const Z=I.getNode(K),k=(0,y.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(Z)&&k.classList.add("active"),$.indent.childElementCount===0?$.indent.appendChild(k):$.indent.insertBefore(k,$.indent.firstElementChild),this.renderedIndentGuides.add(Z,k),h.add((0,a.toDisposable)(()=>this.renderedIndentGuides.delete(Z,k))),F=Z}$.indentGuidesDisposable=h}_onDidChangeActiveNodes(F){if(!this.shouldRenderIndentGuides)return;const $=new Set,j=this.modelProvider();F.forEach(P=>{const h=j.getNodeLocation(P);try{const I=j.getParentNodeLocation(h);P.collapsible&&P.children.length>0&&!P.collapsed?$.add(P):I&&$.add(j.getNode(I))}catch{}}),this.activeIndentNodes.forEach(P=>{$.has(P)||this.renderedIndentGuides.forEach(P,h=>h.classList.remove("active"))}),$.forEach(P=>{this.activeIndentNodes.has(P)||this.renderedIndentGuides.forEach(P,h=>h.classList.add("active"))}),this.activeIndentNodes=$}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,a.dispose)(this.disposables)}}V.DefaultIndent=8;class X{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(F){this._pattern=F,this._lowercasePattern=F.toLowerCase()}constructor(F,$,j){this.tree=F,this.keyboardNavigationLabelProvider=$,this._filter=j,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new a.DisposableStore,F.onWillRefilter(this.reset,this,this.disposables)}filter(F,$){let j=1;if(this._filter){const I=this._filter.filter(F,$);if(typeof I=="boolean"?j=I?1:0:(0,f.isFilterResult)(I)?j=(0,f.getVisibleState)(I.visibility):j=I,j===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:E.FuzzyScore.Default,visibility:j};const P=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(F),h=Array.isArray(P)?P:[P];for(const I of h){const U=I&&I.toString();if(typeof U>"u")return{data:E.FuzzyScore.Default,visibility:j};const K=(0,E.fuzzyScore)(this._pattern,this._lowercasePattern,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(K)return this._matchCount++,h.length===1?{data:K,visibility:j}:{data:{label:U,score:K},visibility:j}}return this.tree.findMode===ge.Filter?2:{data:E.FuzzyScore.Default,visibility:j}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,a.dispose)(this.disposables)}}class J extends c.Toggle{constructor(F){super({icon:g.Codicon.listFilter,title:(0,S.localize)(0,null),isChecked:F?.isChecked??!1,inputActiveOptionBorder:F?.inputActiveOptionBorder,inputActiveOptionForeground:F?.inputActiveOptionForeground,inputActiveOptionBackground:F?.inputActiveOptionBackground})}}t.ModeToggle=J;var ge;(function(ne){ne[ne.Highlight=0]="Highlight",ne[ne.Filter=1]="Filter"})(ge=t.TreeFindMode||(t.TreeFindMode={}));class oe extends a.Disposable{set mode(F){this.modeToggle.checked=F===ge.Filter,this.findInput.inputBox.setPlaceHolder(F===ge.Filter?(0,S.localize)(1,null):(0,S.localize)(2,null))}get value(){return this.findInput.inputBox.value}set value(F){this.findInput.inputBox.value=F}constructor(F,$,j,P,h){super(),this.tree=$,this.elements=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new w.Emitter,this.onDidDisable=this._onDidDisable.event,F.appendChild(this.elements.root),this._register((0,a.toDisposable)(()=>F.removeChild(this.elements.root))),this.modeToggle=this._register(new J({...h,isChecked:P===ge.Filter})),this.onDidChangeMode=w.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?ge.Filter:ge.Highlight,this._store),this.findInput=this._register(new C.FindInput(this.elements.findInput,j,{label:(0,S.localize)(3,null),additionalToggles:[this.modeToggle],showCommonFindToggles:!1})),this.actionbar=this._register(new B.ActionBar(this.elements.actionbar)),this.mode=P;const I=this._register(new i.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),U=this._register(w.Event.chain(I.event)).map(M=>new W.StandardKeyboardEvent(M)).event;this._register(U(M=>{switch(M.keyCode){case 18:M.preventDefault(),M.stopPropagation(),this.tree.domFocus();return}}));const K=this._register(new l.Action("close",(0,S.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(K,{icon:!0,label:!1});const Z=this._register(new i.DomEmitter(this.elements.grab,"mousedown"));this._register(Z.event(M=>{const z=new a.DisposableStore,A=z.add(new i.DomEmitter(window,"mousemove")),R=z.add(new i.DomEmitter(window,"mouseup")),O=this.right,H=M.pageX,q=this.top,ee=M.pageY;this.elements.grab.classList.add("grabbing");const ue=this.elements.root.style.transition;this.elements.root.style.transition="unset";const de=ye=>{const Ee=ye.pageX-H;this.right=O-Ee;const Ne=ye.pageY-ee;this.top=q+Ne,this.layout()};z.add(A.event(de)),z.add(R.event(ye=>{de(ye),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=ue,z.dispose()}))}));const k=this._register(w.Event.chain(this._register(new i.DomEmitter(this.elements.grab,"keydown")).event)).map(M=>new W.StandardKeyboardEvent(M)).event;this._register(k(M=>{let z,A;if(M.keyCode===15?z=Number.POSITIVE_INFINITY:M.keyCode===17?z=0:M.keyCode===10&&(z=this.right===0?Number.POSITIVE_INFINITY:0),M.keyCode===16?A=0:M.keyCode===18&&(A=Number.POSITIVE_INFINITY),z!==void 0&&(M.preventDefault(),M.stopPropagation(),this.right=z,this.layout()),A!==void 0){M.preventDefault(),M.stopPropagation(),this.top=A;const R=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=R},0)}})),this.onDidChangeValue=this.findInput.onDidChange,this.style(h??{})}style(F){this.findInput.style(F),F.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=F.listFilterWidgetBackground.toString()),F.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${F.listFilterWidgetShadow}`)}focus(){this.findInput.focus()}select(){this.findInput.select()}layout(F=this.width){this.width=F,this.right=(0,u.clamp)(this.right,0,Math.max(0,F-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,u.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(F){this.findInput.showMessage(F)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class me{get pattern(){return this._pattern}get mode(){return this._mode}set mode(F){F!==this._mode&&(this._mode=F,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(F))}constructor(F,$,j,P,h){this.tree=F,this.view=j,this.filter=P,this.contextViewProvider=h,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new w.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangePattern=new w.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new w.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new a.DisposableStore,this.disposables=new a.DisposableStore,this._mode=F.options.defaultFindMode??ge.Highlight,$.onDidSplice(this.onDidSpliceModel,this,this.disposables)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.mode=this.tree.options.defaultFindMode??ge.Highlight,this.widget=new oe(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.styles),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(F=>this.mode=F,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new a.DisposableStore,this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(F){this._pattern=F,this._onDidChangePattern.fire(F),this.filter.pattern=F,this.tree.refilter(),F&&this.tree.focusNext(0,!0,void 0,j=>!E.FuzzyScore.isDefault(j.filterData));const $=this.tree.getFocus();if($.length>0){const j=$[0];this.tree.getRelativeTop(j)===null&&this.tree.reveal(j,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const F=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&F?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:2,content:(0,S.localize)(5,null)}):this.widget?.showMessage({type:2}):this.widget?.clearMessage()}shouldAllowFocus(F){return!this.widget||!this.pattern||this._mode===ge.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!E.FuzzyScore.isDefault(F.filterData)}style(F){this.styles=F,this.widget?.style(F)}layout(F){this.width=F,this.widget?.layout(F)}dispose(){this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function he(ne){let F=N.TreeMouseEventTarget.Unknown;return(0,y.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?F=N.TreeMouseEventTarget.Twistie:(0,y.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?F=N.TreeMouseEventTarget.Element:(0,y.hasParentWithClass)(ne.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(F=N.TreeMouseEventTarget.Filter),{browserEvent:ne.browserEvent,element:ne.element?ne.element.element:null,target:F}}function ae(ne){return{element:ne.element?ne.element.element:null,browserEvent:ne.browserEvent,anchor:ne.anchor}}function Se(ne,F){F(ne),ne.children.forEach($=>Se($,F))}class te{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(F,$){this.getFirstViewElementWithTrait=F,this.identityProvider=$,this.nodes=[],this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event}set(F,$){!$?.__forceEvent&&(0,n.equals)(this.nodes,F)||this._set(F,!1,$)}_set(F,$,j){if(this.nodes=[...F],this.elements=void 0,this._nodeSet=void 0,!$){const P=this;this._onDidChange.fire({get elements(){return P.get()},browserEvent:j})}}get(){return this.elements||(this.elements=this.nodes.map(F=>F.element)),[...this.elements]}getNodes(){return this.nodes}has(F){return this.nodeSet.has(F)}onDidModelSplice({insertedNodes:F,deletedNodes:$}){if(!this.identityProvider){const K=this.createNodeSet(),Z=k=>K.delete(k);$.forEach(k=>Se(k,Z)),this.set([...K.values()]);return}const j=new Set,P=K=>j.add(this.identityProvider.getId(K.element).toString());$.forEach(K=>Se(K,P));const h=new Map,I=K=>h.set(this.identityProvider.getId(K.element).toString(),K);F.forEach(K=>Se(K,I));const U=[];for(const K of this.nodes){const Z=this.identityProvider.getId(K.element).toString();if(!j.has(Z))U.push(K);else{const M=h.get(Z);M&&U.push(M)}}if(this.nodes.length>0&&U.length===0){const K=this.getFirstViewElementWithTrait();K&&U.push(K)}this._set(U,!0)}createNodeSet(){const F=new Set;for(const $ of this.nodes)F.add($);return F}}class De extends d.MouseController{constructor(F,$){super(F),this.tree=$}onViewPointer(F){if((0,d.isButton)(F.browserEvent.target)||(0,d.isInputElement)(F.browserEvent.target)||(0,d.isMonacoEditor)(F.browserEvent.target))return;const $=F.element;if(!$)return super.onViewPointer(F);if(this.isSelectionRangeChangeEvent(F)||this.isSelectionSingleChangeEvent(F))return super.onViewPointer(F);const j=F.browserEvent.target,P=j.classList.contains("monaco-tl-twistie")||j.classList.contains("monaco-icon-label")&&j.classList.contains("folder-icon")&&F.browserEvent.offsetX<16;let h=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?h=this.tree.expandOnlyOnTwistieClick($.element):h=!!this.tree.expandOnlyOnTwistieClick,h&&!P&&F.browserEvent.detail!==2)return super.onViewPointer(F);if(!this.tree.expandOnDoubleClick&&F.browserEvent.detail===2)return super.onViewPointer(F);if($.collapsible){const I=this.tree.model,U=I.getNodeLocation($),K=F.browserEvent.altKey;if(this.tree.setFocus([U]),I.setCollapsed(U,void 0,K),h&&P)return}super.onViewPointer(F)}onDoubleClick(F){F.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(F)}}class se extends d.List{constructor(F,$,j,P,h,I,U,K){super(F,$,j,P,K),this.focusTrait=h,this.selectionTrait=I,this.anchorTrait=U}createMouseController(F){return new De(this,F.tree)}splice(F,$,j=[]){if(super.splice(F,$,j),j.length===0)return;const P=[],h=[];let I;j.forEach((U,K)=>{this.focusTrait.has(U)&&P.push(F+K),this.selectionTrait.has(U)&&h.push(F+K),this.anchorTrait.has(U)&&(I=F+K)}),P.length>0&&super.setFocus((0,n.distinct)([...super.getFocus(),...P])),h.length>0&&super.setSelection((0,n.distinct)([...super.getSelection(),...h])),typeof I=="number"&&super.setAnchor(I)}setFocus(F,$,j=!1){super.setFocus(F,$),j||this.focusTrait.set(F.map(P=>this.element(P)),$)}setSelection(F,$,j=!1){super.setSelection(F,$),j||this.selectionTrait.set(F.map(P=>this.element(P)),$)}setAnchor(F,$=!1){super.setAnchor(F),$||(typeof F>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(F)]))}}class ie{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return w.Event.map(this.view.onMouseClick,he)}get onMouseDblClick(){return w.Event.filter(w.Event.map(this.view.onMouseDblClick,he),F=>F.target!==N.TreeMouseEventTarget.Filter)}get onContextMenu(){return w.Event.map(this.view.onContextMenu,ae)}get onTap(){return w.Event.map(this.view.onTap,he)}get onPointer(){return w.Event.map(this.view.onPointer,he)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return w.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??ge.Highlight}set findMode(F){this.findController&&(this.findController.mode=F)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:w.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(F,$,j,P,h={}){this._user=F,this._options=h,this.eventBufferer=new w.EventBufferer,this.onDidChangeFindOpenState=w.Event.None,this.disposables=new a.DisposableStore,this._onWillRefilter=new w.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new w.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const I=new o(j),U=new w.Relay,K=new w.Relay,Z=this.disposables.add(new L(K.event)),k=new b.SetMap;this.renderers=P.map(A=>new V(A,()=>this.model,U.event,Z,k,h));for(const A of this.renderers)this.disposables.add(A);let M;h.keyboardNavigationLabelProvider&&(M=new X(this,h.keyboardNavigationLabelProvider,h.filter),h={...h,filter:M},this.disposables.add(M)),this.focus=new te(()=>this.view.getFocusedElements()[0],h.identityProvider),this.selection=new te(()=>this.view.getSelectedElements()[0],h.identityProvider),this.anchor=new te(()=>this.view.getAnchorElement(),h.identityProvider),this.view=new se(F,$,I,this.renderers,this.focus,this.selection,this.anchor,{...v(()=>this.model,h),tree:this}),this.model=this.createModel(F,this.view,h),U.input=this.model.onDidChangeCollapseState;const z=w.Event.forEach(this.model.onDidSplice,A=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(A),this.selection.onDidModelSplice(A)})},this.disposables);if(z(()=>null,null,this.disposables),K.input=w.Event.chain(w.Event.any(z,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const A=new Set;for(const R of this.focus.getNodes())A.add(R);for(const R of this.selection.getNodes())A.add(R);return[...A.values()]}).event,h.keyboardSupport!==!1){const A=w.Event.chain(this.view.onKeyDown).filter(R=>!(0,d.isInputElement)(R.target)).map(R=>new W.StandardKeyboardEvent(R));A.filter(R=>R.keyCode===15).on(this.onLeftArrow,this,this.disposables),A.filter(R=>R.keyCode===17).on(this.onRightArrow,this,this.disposables),A.filter(R=>R.keyCode===10).on(this.onSpace,this,this.disposables)}(h.findWidgetEnabled??!0)&&h.keyboardNavigationLabelProvider&&h.contextViewProvider?(this.findController=new me(this,this.model,this.view,M,h.contextViewProvider),this.focusNavigationFilter=A=>this.findController.shouldAllowFocus(A),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode):this.onDidChangeFindMode=w.Event.None,this.styleElement=(0,y.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===p.Always)}updateOptions(F={}){this._options={...this._options,...F};for(const $ of this.renderers)$.updateOptions(F);this.view.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===p.Always)}get options(){return this._options}updateWidth(F){const $=this.model.getListIndex(F);$!==-1&&this.view.updateWidth($)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(F){this.view.scrollTop=F}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(F){this.view.scrollLeft=F}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const F=this.view.firstVisibleIndex;return F<0||F>=this.view.length?void 0:this.view.element(F).element}get lastVisibleElement(){const F=this.view.lastVisibleIndex;return this.view.element(F).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(F){this.view.ariaLabel=F}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(F,$){this.view.layout(F,$),(0,m.isNumber)($)&&this.findController?.layout($)}style(F){const $=`.${this.view.domId}`,j=[];F.treeIndentGuidesStroke&&(j.push(`.monaco-list${$}:hover .monaco-tl-indent > .indent-guide, .monaco-list${$}.always .monaco-tl-indent > .indent-guide  { border-color: ${F.treeIndentGuidesStroke.transparent(.4)}; }`),j.push(`.monaco-list${$} .monaco-tl-indent > .indent-guide.active { border-color: ${F.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=j.join(`
`),this.findController?.style(F),this.view.style(F)}getParentElement(F){const $=this.model.getParentNodeLocation(F);return this.model.getNode($).element}getFirstElementChild(F){return this.model.getFirstElementChild(F)}getNode(F){return this.model.getNode(F)}collapse(F,$=!1){return this.model.setCollapsed(F,!0,$)}expand(F,$=!1){return this.model.setCollapsed(F,!1,$)}toggleCollapsed(F,$=!1){return this.model.setCollapsed(F,void 0,$)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(F){return this.model.isCollapsible(F)}setCollapsible(F,$){return this.model.setCollapsible(F,$)}isCollapsed(F){return this.model.isCollapsed(F)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(F){if(typeof F>"u")return this.view.setAnchor(void 0);const $=this.model.getNode(F);this.anchor.set([$]);const j=this.model.getListIndex(F);j>-1&&this.view.setAnchor(j,!0)}getAnchor(){return(0,n.firstOrDefault)(this.anchor.get(),void 0)}setSelection(F,$){const j=F.map(h=>this.model.getNode(h));this.selection.set(j,$);const P=F.map(h=>this.model.getListIndex(h)).filter(h=>h>-1);this.view.setSelection(P,$,!0)}getSelection(){return this.selection.get()}setFocus(F,$){const j=F.map(h=>this.model.getNode(h));this.focus.set(j,$);const P=F.map(h=>this.model.getListIndex(h)).filter(h=>h>-1);this.view.setFocus(P,$,!0)}focusNext(F=1,$=!1,j,P=this.focusNavigationFilter){this.view.focusNext(F,$,j,P)}focusPrevious(F=1,$=!1,j,P=this.focusNavigationFilter){this.view.focusPrevious(F,$,j,P)}focusNextPage(F,$=this.focusNavigationFilter){return this.view.focusNextPage(F,$)}focusPreviousPage(F,$=this.focusNavigationFilter){return this.view.focusPreviousPage(F,$)}focusLast(F,$=this.focusNavigationFilter){this.view.focusLast(F,$)}focusFirst(F,$=this.focusNavigationFilter){this.view.focusFirst(F,$)}getFocus(){return this.focus.get()}reveal(F,$){this.model.expandTo(F);const j=this.model.getListIndex(F);j!==-1&&this.view.reveal(j,$)}getRelativeTop(F){const $=this.model.getListIndex(F);return $===-1?null:this.view.getRelativeTop($)}getViewState(F=this.options.identityProvider){if(!F)throw new N.TreeError(this._user,"Can't get tree view state without an identity provider");const $=I=>F.getId(I).toString(),j=s.empty(this.scrollTop);for(const I of this.getFocus())j.focus.add($(I));for(const I of this.getSelection())j.selection.add($(I));const P=this.model.getNode(),h=[P];for(;h.length>0;){const I=h.shift();I!==P&&I.collapsible&&(j.expanded[$(I.element)]=I.collapsed?0:1),h.push(...I.children)}return j}onLeftArrow(F){F.preventDefault(),F.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const j=$[0],P=this.model.getNodeLocation(j);if(!this.model.setCollapsed(P,!0)){const I=this.model.getParentNodeLocation(P);if(!I)return;const U=this.model.getListIndex(I);this.view.reveal(U),this.view.setFocus([U])}}onRightArrow(F){F.preventDefault(),F.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const j=$[0],P=this.model.getNodeLocation(j);if(!this.model.setCollapsed(P,!1)){if(!j.children.some(K=>K.visible))return;const[I]=this.view.getFocus(),U=I+1;this.view.reveal(U),this.view.setFocus([U])}}onSpace(F){F.preventDefault(),F.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const j=$[0],P=this.model.getNodeLocation(j),h=F.browserEvent.altKey;this.model.setCollapsed(P,void 0,h)}navigate(F){return new ce(this.view,this.model,F)}dispose(){(0,a.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=ie;class ce{constructor(F,$,j){this.view=F,this.model=$,j?this.index=this.model.getListIndex(j):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(pe[128],be([1,0,127,117,23,26]),function(Q,t,y,i,W,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class C extends y.AbstractTree{constructor(d,c,f,N,l,n={}){super(d,c,f,N,n),this.user=d,this.dataSource=l,this.nodesByIdentity=new Map,this.identityProvider=n.identityProvider}getInput(){return this.input}setInput(d,c){if(c&&!this.identityProvider)throw new W.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=d,!d){this.nodesByIdentity.clear(),this.model.setChildren(null,B.Iterable.empty());return}if(!c){this._refresh(d);return}const f=[],N=[],l=e=>{const g=this.identityProvider.getId(e).toString();return!c.expanded[g]},n=e=>{const g=this.identityProvider.getId(e.element).toString();c.focus.has(g)&&f.push(e.element),c.selection.has(g)&&N.push(e.element)};this._refresh(d,l,n),this.setFocus(f),this.setSelection(N),c&&typeof c.scrollTop=="number"&&(this.scrollTop=c.scrollTop)}updateChildren(d=this.input){if(typeof this.input>"u")throw new W.TreeError(this.user,"Tree input not set");let c;this.identityProvider&&(c=f=>{const N=this.identityProvider.getId(f).toString(),l=this.nodesByIdentity.get(N);if(!!l)return l.collapsed}),this._refresh(d,c)}resort(d=this.input,c=!0){this.model.resort(d===this.input?null:d,c)}refresh(d){if(d===void 0){this.view.rerender();return}this.model.rerender(d)}_refresh(d,c,f){let N;if(this.identityProvider){const l=new Set,n=f;f=e=>{const g=this.identityProvider.getId(e.element).toString();l.add(g),this.nodesByIdentity.set(g,e),n?.(e)},N=e=>{const g=this.identityProvider.getId(e.element).toString();l.has(g)||this.nodesByIdentity.delete(g)}}this.model.setChildren(d===this.input?null:d,this.iterate(d,c).elements,{onDidCreateNode:f,onDidDeleteNode:N})}iterate(d,c){const f=[...this.dataSource.getChildren(d)];return{elements:B.Iterable.map(f,l=>{const{elements:n,size:e}=this.iterate(l,c),g=this.dataSource.hasChildren?this.dataSource.hasChildren(l):void 0,b=e===0?void 0:c&&c(l);return{element:l,children:n,collapsible:g,collapsed:b}}),size:f.length}}createModel(d,c,f){return new i.ObjectTreeModel(d,c,f)}}t.DataTree=C}),define(pe[38],be([1,0,14,8,31,28,25,9,3,2,50,11,6]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var n;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(n=t.RequestType||(t.RequestType={}));function e(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(g=t.ResponseType||(t.ResponseType={}));function b(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(w||(w={}));class E{constructor(ie){this.buffer=ie,this.pos=0}read(ie){const ce=this.buffer.slice(this.pos,this.pos+ie);return this.pos+=ce.byteLength,ce}}class a{constructor(){this.buffers=[]}get buffer(){return W.VSBuffer.concat(this.buffers)}write(ie){this.buffers.push(ie)}}var u;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object"})(u||(u={}));function m(se){const ie=W.VSBuffer.alloc(4);return ie.writeUInt32BE(se,0),ie}function S(se){return se.read(4).readUInt32BE(0)}function T(se){const ie=W.VSBuffer.alloc(1);return ie.writeUInt8(se,0),ie}const _={Undefined:T(u.Undefined),String:T(u.String),Buffer:T(u.Buffer),VSBuffer:T(u.VSBuffer),Array:T(u.Array),Object:T(u.Object)},r=typeof Buffer<"u";function v(se,ie){if(typeof ie>"u")se.write(_.Undefined);else if(typeof ie=="string"){const ce=W.VSBuffer.fromString(ie);se.write(_.String),se.write(m(ce.byteLength)),se.write(ce)}else if(r&&Buffer.isBuffer(ie)){const ce=W.VSBuffer.wrap(ie);se.write(_.Buffer),se.write(m(ce.byteLength)),se.write(ce)}else if(ie instanceof W.VSBuffer)se.write(_.VSBuffer),se.write(m(ie.byteLength)),se.write(ie);else if(Array.isArray(ie)){se.write(_.Array),se.write(m(ie.length));for(const ce of ie)v(se,ce)}else{const ce=W.VSBuffer.fromString(JSON.stringify(ie));se.write(_.Object),se.write(m(ce.byteLength)),se.write(ce)}}function o(se){switch(se.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return se.read(S(se)).toString();case u.Buffer:return se.read(S(se)).buffer;case u.VSBuffer:return se.read(S(se));case u.Array:{const ce=S(se),ne=[];for(let F=0;F<ce;F++)ne.push(o(se));return ne}case u.Object:return JSON.parse(se.read(S(se)).toString())}}class s{constructor(ie,ce,ne=null,F=1e3){this.protocol=ie,this.ctx=ce,this.logger=ne,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(ie,ce){this.channels.set(ie,ce),setTimeout(()=>this.flushPendingRequests(ie),0)}sendResponse(ie){switch(ie.type){case 200:{const ce=this.send([ie.type]);this.logger?.logOutgoing(ce,0,1,b(ie.type));return}case 201:case 202:case 204:case 203:{const ce=this.send([ie.type,ie.id],ie.data);this.logger?.logOutgoing(ce,ie.id,1,b(ie.type),ie.data);return}}}send(ie,ce=void 0){const ne=new a;return v(ne,ie),v(ne,ce),this.sendBuffer(ne.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onRawMessage(ie){const ce=new E(ie),ne=o(ce),F=o(ce),$=ne[0];switch($){case 100:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e($)}: ${ne[2]}.${ne[3]}`,F),this.onPromise({type:$,id:ne[1],channelName:ne[2],name:ne[3],arg:F});case 102:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e($)}: ${ne[2]}.${ne[3]}`,F),this.onEventListen({type:$,id:ne[1],channelName:ne[2],name:ne[3],arg:F});case 101:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e($)}`),this.disposeActiveRequest({type:$,id:ne[1]});case 103:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e($)}`),this.disposeActiveRequest({type:$,id:ne[1]})}}onPromise(ie){const ce=this.channels.get(ie.channelName);if(!ce){this.collectPendingRequest(ie);return}const ne=new B.CancellationTokenSource;let F;try{F=ce.call(this.ctx,ie.name,ie.arg,ne.token)}catch(P){F=Promise.reject(P)}const $=ie.id;F.then(P=>{this.sendResponse({id:$,data:P,type:201}),this.activeRequests.delete(ie.id)},P=>{P instanceof Error?this.sendResponse({id:$,data:{message:P.message,name:P.name,stack:P.stack?P.stack.split?P.stack.split(`
`):P.stack:void 0},type:202}):this.sendResponse({id:$,data:P,type:203}),this.activeRequests.delete(ie.id)});const j=(0,c.toDisposable)(()=>ne.cancel());this.activeRequests.set(ie.id,j)}onEventListen(ie){const ce=this.channels.get(ie.channelName);if(!ce){this.collectPendingRequest(ie);return}const ne=ie.id,$=ce.listen(this.ctx,ie.name,ie.arg)(j=>this.sendResponse({id:ne,data:j,type:204}));this.activeRequests.set(ie.id,$)}disposeActiveRequest(ie){const ce=this.activeRequests.get(ie.id);ce&&(ce.dispose(),this.activeRequests.delete(ie.id))}collectPendingRequest(ie){let ce=this.pendingRequests.get(ie.channelName);ce||(ce=[],this.pendingRequests.set(ie.channelName,ce));const ne=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.sendResponse({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ce.push({request:ie,timeoutTimer:ne})}flushPendingRequests(ie){const ce=this.pendingRequests.get(ie);if(ce){for(const ne of ce)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.onPromise(ne.request);break;case 102:this.onEventListen(ne.request);break}this.pendingRequests.delete(ie)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=s;var p;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(p=t.RequestInitiator||(t.RequestInitiator={}));class L{constructor(ie,ce=null){this.protocol=ie,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=ce}getChannel(ie){const ce=this;return{call(ne,F,$){return ce.isDisposed?Promise.reject(new D.CancellationError):ce.requestPromise(ie,ne,F,$)},listen(ne,F){return ce.isDisposed?d.Event.None:ce.requestEvent(ie,ne,F)}}}requestPromise(ie,ce,ne,F=B.CancellationToken.None){const $=this.lastRequestId++,P={id:$,type:100,channelName:ie,name:ce,arg:ne};if(F.isCancellationRequested)return Promise.reject(new D.CancellationError);let h;return new Promise((U,K)=>{if(F.isCancellationRequested)return K(new D.CancellationError);const Z=()=>{const A=R=>{switch(R.type){case 201:this.handlers.delete($),U(R.data);break;case 202:{this.handlers.delete($);const O=new Error(R.data.message);O.stack=R.data.stack,O.name=R.data.name,K(O);break}case 203:this.handlers.delete($),K(R.data);break}};this.handlers.set($,A),this.sendRequest(P)};let k=null;this.state===w.Idle?Z():(k=(0,i.createCancelablePromise)(A=>this.whenInitialized()),k.then(()=>{k=null,Z()}));const M=()=>{k?(k.cancel(),k=null):this.sendRequest({id:$,type:101}),K(new D.CancellationError)},z=F.onCancellationRequested(M);h=(0,c.combinedDisposable)((0,c.toDisposable)(M),z),this.activeRequests.add(h)}).finally(()=>{this.activeRequests.delete(h)})}requestEvent(ie,ce,ne){const F=this.lastRequestId++,j={id:F,type:102,channelName:ie,name:ce,arg:ne};let P=null;const h=new d.Emitter({onFirstListenerAdd:()=>{P=(0,i.createCancelablePromise)(U=>this.whenInitialized()),P.then(()=>{P=null,this.activeRequests.add(h),this.sendRequest(j)})},onLastListenerRemove:()=>{P?(P.cancel(),P=null):(this.activeRequests.delete(h),this.sendRequest({id:F,type:103}))}}),I=U=>h.fire(U.data);return this.handlers.set(F,I),h.event}sendRequest(ie){switch(ie.type){case 100:case 102:{const ce=this.send([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.logger?.logOutgoing(ce,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const ce=this.send([ie.type,ie.id]);this.logger?.logOutgoing(ce,ie.id,0,e(ie.type));return}}}send(ie,ce=void 0){const ne=new a;return v(ne,ie),v(ne,ce),this.sendBuffer(ne.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onBuffer(ie){const ce=new E(ie),ne=o(ce),F=o(ce),$=ne[0];switch($){case 200:return this.logger?.logIncoming(ie.byteLength,0,0,b($)),this.onResponse({type:ne[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(ie.byteLength,ne[1],0,b($),F),this.onResponse({type:ne[0],id:ne[1],data:F})}}onResponse(ie){if(ie.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}this.handlers.get(ie.id)?.(ie)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}xe([C.memoize],L.prototype,"onDidInitializePromise",null),t.ChannelClient=L;class V{get connections(){const ie=[];return this._connections.forEach(ce=>ie.push(ce)),ie}constructor(ie){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,ie(({protocol:ce,onDidClientDisconnect:ne})=>{d.Event.once(ce.onMessage)($=>{const j=new E($),P=o(j),h=new s(ce,P),I=new L(ce);this.channels.forEach((K,Z)=>h.registerChannel(Z,K));const U={channelServer:h,channelClient:I,ctx:P};this._connections.add(U),this._onDidAddConnection.fire(U),ne(()=>{h.dispose(),I.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}getChannel(ie,ce){const ne=this;return{call(F,$,j){let P;if((0,l.isFunction)(ce)){const I=(0,y.getRandomElement)(ne.connections.filter(ce));P=I?Promise.resolve(I):d.Event.toPromise(d.Event.filter(ne.onDidAddConnection,ce))}else P=ce.routeCall(ne,F,$);const h=P.then(I=>I.channelClient.getChannel(ie));return J(h).call(F,$,j)},listen(F,$){if((0,l.isFunction)(ce))return ne.getMulticastEvent(ie,ce,F,$);const j=ce.routeEvent(ne,F,$).then(P=>P.channelClient.getChannel(ie));return J(j).listen(F,$)}}}getMulticastEvent(ie,ce,ne,F){const $=this;let j=new c.DisposableStore;const P=new d.Emitter({onFirstListenerAdd:()=>{j=new c.DisposableStore;const h=new d.EventMultiplexer,I=new Map,U=Z=>{const M=Z.channelClient.getChannel(ie).listen(ne,F),z=h.add(M);I.set(Z,z)},K=Z=>{const k=I.get(Z);!k||(k.dispose(),I.delete(Z))};$.connections.filter(ce).forEach(U),d.Event.filter($.onDidAddConnection,ce)(U,void 0,j),$.onDidRemoveConnection(K,void 0,j),h.event(P.fire,P,j),j.add(h)},onLastListenerRemove:()=>{j.dispose()}});return P.event}registerChannel(ie,ce){this.channels.set(ie,ce),this._connections.forEach(ne=>{ne.channelServer.registerChannel(ie,ce)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=V;class X{constructor(ie,ce,ne=null){const F=new a;v(F,ce),ie.send(F.buffer),this.channelClient=new L(ie,ne),this.channelServer=new s(ie,ce,ne)}getChannel(ie){return this.channelClient.getChannel(ie)}registerChannel(ie,ce){this.channelServer.registerChannel(ie,ce)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=X;function J(se){return{call(ie,ce,ne){return se.then(F=>F.call(ie,ce,ne))},listen(ie,ce){const ne=new d.Relay;return se.then(F=>ne.input=F.listen(ie,ce)),ne.event}}}t.getDelayedChannel=J;function ge(se){let ie=!1;return{call(ce,ne,F){return ie?se.call(ce,ne,F):(0,i.timeout)(0).then(()=>ie=!0).then(()=>se.call(ce,ne,F))},listen(ce,ne){if(ie)return se.listen(ce,ne);const F=new d.Relay;return(0,i.timeout)(0).then(()=>ie=!0).then(()=>F.input=se.listen(ce,ne)),F.event}}}t.getNextTickChannel=ge;class oe{constructor(ie){this.fn=ie}routeCall(ie){return this.route(ie)}routeEvent(ie){return this.route(ie)}async route(ie){for(const ce of ie.connections)if(await Promise.resolve(this.fn(ce.ctx)))return Promise.resolve(ce);return await d.Event.toPromise(ie.onDidAddConnection),await this.route(ie)}}t.StaticRouter=oe;var me;(function(se){function ie($,j){const P=$,h=j&&j.disableMarshalling,I=new Map;for(const U in P)ne(U)&&I.set(U,d.Event.buffer(P[U],!0));return new class{listen(U,K,Z){const k=I.get(K);if(k)return k;if(F(K)){const M=P[K];if(typeof M=="function")return M.call(P,Z)}throw new Error(`Event not found: ${K}`)}call(U,K,Z){const k=P[K];if(typeof k=="function"){if(!h&&Array.isArray(Z))for(let M=0;M<Z.length;M++)Z[M]=(0,f.revive)(Z[M]);return k.apply(P,Z)}throw new Error(`Method not found: ${K}`)}}}se.fromService=ie;function ce($,j){const P=j&&j.disableMarshalling;return new Proxy({},{get(h,I){if(typeof I=="string")return j?.properties?.has(I)?j.properties.get(I):F(I)?function(U){return $.listen(I,U)}:ne(I)?$.listen(I):async function(...U){let K;j&&!(0,l.isUndefinedOrNull)(j.context)?K=[j.context,...U]:K=U;const Z=await $.call(I,K);return P?Z:(0,f.revive)(Z)};throw new Error(`Property not found: ${String(I)}`)}})}se.toService=ce;function ne($){return $[0]==="o"&&$[1]==="n"&&N.isUpperAsciiLetter($.charCodeAt(2))}function F($){return/^onDynamic/.test($)&&N.isUpperAsciiLetter($.charCodeAt(9))}})(me=t.ProxyChannel||(t.ProxyChannel={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const ie=se.toString();if(ie!=="[object Object]")return ie}return se}function Se(se){return Array.isArray(se)?se.map(ae):ae(se)}function te(se,ie,ce,ne,F,$,j){j=Se(j);const P=he[F],h=P[ne%P.length];let I=[`%c[${se}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test($)?(I=I.concat(j),I.push(")")):I.push(j),console.log.apply(console,I)}t.logWithColors=te;class De{constructor(ie,ce){this._outgoingPrefix=ie,this._incomingPrefix=ce,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(ie,ce,ne,F,$){this._totalOutgoing+=ie,te(this._outgoingPrefix,this._totalOutgoing,ie,ce,ne,F,$)}logIncoming(ie,ce,ne,F,$){this._totalIncoming+=ie,te(this._incomingPrefix,this._totalIncoming,ie,ce,ne,F,$)}}t.IPCLogger=De}),define(pe[29],be([1,0,5]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=y.globals.vscode.ipcRenderer,t.ipcMessagePort=y.globals.vscode.ipcMessagePort,t.webFrame=y.globals.vscode.webFrame,t.process=y.globals.vscode.process,t.context=y.globals.vscode.context}),define(pe[129],be([1,0,80,29]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let W=0;function B(D,d,c){const f=[],N=W++,l=`vscode:onContextMenu${N}`,n=(e,g,b)=>{f[g].click?.(b)};i.ipcRenderer.once(l,n),i.ipcRenderer.once(y.CONTEXT_MENU_CLOSE_CHANNEL,(e,g)=>{g===N&&(i.ipcRenderer.removeListener(l,n),c?.())}),i.ipcRenderer.send(y.CONTEXT_MENU_CHANNEL,N,D.map(e=>C(e,f)),l,d)}t.popup=B;function C(D,d){const c={id:d.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return d.push(D),Array.isArray(D.submenu)&&(c.submenu=D.submenu.map(f=>C(f,d))),c}}),define(pe[130],be([1,0,31,3,38,81,29]),function(Q,t,y,i,W,B,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class D extends W.IPCClient{static createProtocol(){const c=i.Event.fromNodeEventEmitter(C.ipcRenderer,"vscode:message",(f,N)=>y.VSBuffer.wrap(N));return C.ipcRenderer.send("vscode:hello"),new B.Protocol(C.ipcRenderer,c)}constructor(c){const f=D.createProtocol();super(f,c),this.protocol=f}dispose(){this.protocol.disconnect()}}t.Client=D}),define(pe[131],be([13,10]),function(Q,t){return Q.create("vs/platform/files/common/files",t)}),define(pe[132],be([13,10]),function(Q,t){return Q.create("vs/platform/theme/common/iconRegistry",t)}),define(pe[64],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class y{constructor(W,B=[],C=!1){this.ctor=W,this.staticArguments=B,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=y}),define(pe[133],be([1,0,64]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const i=[];var W;(function(D){D[D.Eager=0]="Eager",D[D.Delayed=1]="Delayed"})(W=t.InstantiationType||(t.InstantiationType={}));function B(D,d,c){d instanceof y.SyncDescriptor||(d=new y.SyncDescriptor(d,[],Boolean(c))),i.push([D,d])}t.registerSingleton=B;function C(){return i}t.getSingletonServiceDescriptors=C}),define(pe[30],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var y;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(d){return d[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(y=t._util||(t._util={})),t.IInstantiationService=W("instantiationService");function i(C,D,d){D[y.DI_TARGET]===D?D[y.DI_DEPENDENCIES].push({id:C,index:d}):(D[y.DI_DEPENDENCIES]=[{id:C,index:d}],D[y.DI_TARGET]=D)}function W(C){if(y.serviceIds.has(C))return y.serviceIds.get(C);const D=function(d,c,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(D,d,f)};return D.toString=()=>C,y.serviceIds.set(C,D),D}t.createDecorator=W;function B(C){return C}t.refineServiceDecorator=B}),define(pe[134],be([1,0,30]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,y.createDecorator)(t.ID);function i(B){return!!B.hostName&&!!B.errorMessage}t.isRemoteDiagnosticError=i;class W{async getPerformanceInfo(C,D){return{}}async getSystemInfo(C,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,D){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}t.NullDiagnosticsService=W}),define(pe[135],be([1,0,49,21,11,6,16,131,30]),function(Q,t,y,i,W,B,C,D,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,d.createDecorator)("fileService");function c(te){return te.create===!0}t.isFileOpenForWriteOptions=c;var f;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(f=t.FileType||(t.FileType={}));var N;(function(te){te[te.Readonly=1]="Readonly"})(N=t.FilePermission||(t.FilePermission={}));var l;(function(te){te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileClone=32768]="FileClone"})(l=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function n(te){return!!(te.capabilities&2)}t.hasReadWriteCapability=n;function e(te){return!!(te.capabilities&8)}t.hasFileFolderCopyCapability=e;function g(te){return!!(te.capabilities&32768)}t.hasFileCloneCapability=g;function b(te){return!!(te.capabilities&4)}t.hasOpenReadWriteCloseCapability=b;function w(te){return!!(te.capabilities&16)}t.hasFileReadStreamCapability=w;function E(te){return n(te)?!!(te.capabilities&16384):!1}t.hasFileAtomicReadCapability=E;var a;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(a=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class u extends Error{constructor(De,se){super(De),this.code=se}}t.FileSystemProviderError=u;function m(te,De){const se=new u(te.toString(),De);return T(se,De),se}t.createFileSystemProviderError=m;function S(te){return te||m((0,D.localize)(0,null),a.Unknown)}t.ensureFileSystemProviderError=S;function T(te,De){return te.name=De?`${De} (FileSystemError)`:"FileSystemError",te}t.markAsFileSystemProviderError=T;function _(te){if(!te)return a.Unknown;if(te instanceof u)return te.code;const De=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!De)return a.Unknown;switch(De[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}t.toFileSystemProviderErrorCode=_;function r(te){if(te instanceof V)return te.fileOperationResult;switch(_(te)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=r;var v;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(v=t.FileOperation||(t.FileOperation={}));class o{constructor(De,se,ie){this.resource=De,this.operation=se,this.target=ie}isOperation(De){return this.operation===De}}t.FileOperationEvent=o;var s;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(s=t.FileChangeType||(t.FileChangeType={}));class p{constructor(De,se){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=De;const ie=new Map;for(const ce of De){const ne=ie.get(ce.type);switch(ne?ne.push([ce.resource,ce]):ie.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,ne]of ie)switch(ce){case 1:this.added=y.TernarySearchTree.forUris(()=>se),this.added.fill(ne);break;case 0:this.updated=y.TernarySearchTree.forUris(()=>se),this.updated.fill(ne);break;case 2:this.deleted=y.TernarySearchTree.forUris(()=>se),this.deleted.fill(ne);break}}contains(De,...se){return this.doContains(De,{includeChildren:!1},...se)}affects(De,...se){return this.doContains(De,{includeChildren:!0},...se)}doContains(De,se,...ie){if(!De)return!1;const ce=ie.length>0;return!!((!ce||ie.includes(1))&&(this.added?.get(De)||se.includeChildren&&this.added?.findSuperstr(De))||(!ce||ie.includes(0))&&(this.updated?.get(De)||se.includeChildren&&this.updated?.findSuperstr(De))||(!ce||ie.includes(2))&&(this.deleted?.findSubstr(De)||se.includeChildren&&this.deleted?.findSuperstr(De)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=p;function L(te,De,se){return!te||!De||te===De||De.length>te.length?!1:(De.charAt(De.length-1)!==i.sep&&(De+=i.sep),se?(0,W.startsWithIgnoreCase)(te,De):te.indexOf(De)===0)}t.isParent=L;class V extends Error{constructor(De,se,ie){super(De),this.fileOperationResult=se,this.options=ie}}t.FileOperationError=V;class X extends V{constructor(De,se,ie){super(De,2,ie),this.stat=se}}t.NotModifiedSinceFileOperationError=X;var J;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",te[te.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(J=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var ge;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function oe(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}t.etag=oe;async function me(te,De){if(!De.hasProvider(C.URI.from({scheme:te.scheme})))return new Promise(se=>{const ie=De.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===te.scheme&&ce.added&&(ie.dispose(),se())})})}t.whenProviderRegistered=me,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class he{static formatSize(De){return(0,B.isNumber)(De)||(De=0),De<he.KB?(0,D.localize)(1,null,De.toFixed(0)):De<he.MB?(0,D.localize)(2,null,(De/he.KB).toFixed(2)):De<he.GB?(0,D.localize)(3,null,(De/he.MB).toFixed(2)):De<he.TB?(0,D.localize)(4,null,(De/he.GB).toFixed(2)):(0,D.localize)(5,null,(De/he.TB).toFixed(2))}}t.ByteSize=he,he.KB=1024,he.MB=he.KB*he.KB,he.GB=he.MB*he.KB,he.TB=he.GB*he.KB;var ae;(function(te){te[te.IA32=0]="IA32",te[te.OTHER=1]="OTHER"})(ae=t.Arch||(t.Arch={}));function Se(te){return{maxFileSize:te===0?300*he.MB:16*he.GB,maxHeapSize:te===0?700*he.MB:2*700*he.MB}}t.getPlatformLimits=Se}),define(pe[136],be([1,0,2,130]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class W extends y.Disposable{constructor(C){super(),this.mainProcessConnection=this._register(new i.Client(`window:${C}`))}getChannel(C){return this.mainProcessConnection.getChannel(C)}registerChannel(C,D){this.mainProcessConnection.registerChannel(C,D)}}t.ElectronIPCMainProcessService=W});var wt=this&&this.__param||function(Q,t){return function(y,i){t(y,i,Q)}};define(pe[137],be([1,0,38,64,133,30]),function(Q,t,y,i,W,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class C{constructor(n,e,g,b){const w=g.getChannel(n);return D(e)?b.createInstance(new i.SyncDescriptor(e.channelClientCtor,[w])):y.ProxyChannel.toService(w,e?.proxyOptions)}}function D(l){return!!l?.channelClientCtor}t.IMainProcessService=(0,B.createDecorator)("mainProcessService");let d=class extends C{constructor(n,e,g,b){super(n,e,g,b)}};d=xe([wt(2,t.IMainProcessService),wt(3,B.IInstantiationService)],d);function c(l,n,e){(0,W.registerSingleton)(l,new i.SyncDescriptor(d,[n,e],!0))}t.registerMainProcessRemoteService=c,t.ISharedProcessService=(0,B.createDecorator)("sharedProcessService");let f=class extends C{constructor(n,e,g,b){super(n,e,g,b)}};f=xe([wt(2,t.ISharedProcessService),wt(3,B.IInstantiationService)],f);function N(l,n,e){(0,W.registerSingleton)(l,new i.SyncDescriptor(f,[n,e],!0))}t.registerSharedProcessRemoteService=N}),define(pe[138],be([1,0,38,137]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let W=class{constructor(C,D){return this.windowId=C,y.ProxyChannel.toService(D.getChannel("nativeHost"),{context:C,properties:(()=>{const d=new Map;return d.set("windowId",C),d})()})}};W=xe([wt(1,i.IMainProcessService)],W),t.NativeHostService=W}),define(pe[39],be([1,0,71,6]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class W{constructor(){this.data=new Map}add(C,D){y.ok(i.isString(C)),y.ok(i.isObject(D)),y.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,D)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}t.Registry=new W}),define(pe[139],be([1,0,3,39]),function(Q,t,y,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function W(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class B{constructor(){this._onDidChangeSchema=new y.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,c){this.schemasById[W(d)]=c,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new B;i.Registry.add(t.Extensions.JSONContribution,C)}),define(pe[140],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var y;(function(B){B.DARK="dark",B.LIGHT="light",B.HIGH_CONTRAST_DARK="hcDark",B.HIGH_CONTRAST_LIGHT="hcLight"})(y=t.ColorScheme||(t.ColorScheme={}));function i(B){return B===y.HIGH_CONTRAST_DARK||B===y.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function W(B){return B===y.DARK||B===y.HIGH_CONTRAST_DARK}t.isDark=W}),define(pe[65],be([1,0,12,3,2,30,39,140]),function(Q,t,y,i,W,B,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,B.createDecorator)("themeService");var d;(function(b){function w(E){return E&&typeof E=="object"&&typeof E.id=="string"}b.isThemeColor=w})(d=t.ThemeColor||(t.ThemeColor={}));function c(b){return{id:b}}t.themeColorFromId=c;var f;(function(b){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||d.isThemeColor(r.color))}b.isThemeIcon=w;const E=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const v=E.exec(r);if(!v)return;const[,o]=v;return{id:o}}b.fromString=a;function u(r){return{id:r}}b.fromId=u;function m(r,v){let o=r.id;const s=o.lastIndexOf("~");return s!==-1&&(o=o.substring(0,s)),v&&(o=`${o}~${v}`),{id:o}}b.modify=m;function S(r){const v=r.id.lastIndexOf("~");if(v!==-1)return r.id.substring(v+1)}b.getModifier=S;function T(r,v){return r.id===v.id&&r.color?.id===v.color?.id}b.isEqual=T;function _(r,v){return{id:r.id,color:v?c(v):void 0}}b.asThemeIcon=_,b.asClassNameArray=y.CSSIcon.asClassNameArray,b.asClassName=y.CSSIcon.asClassName,b.asCSSSelector=y.CSSIcon.asCSSSelector})(f=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=y.Codicon.file,t.FolderThemeIcon=y.Codicon.folder;function N(b){switch(b){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case D.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=N,t.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,W.toDisposable)(()=>{const E=this.themingParticipants.indexOf(w);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const n=new l;C.Registry.add(t.Extensions.ThemingContribution,n);function e(b){return n.onColorThemeChange(b)}t.registerThemingParticipant=e;class g extends W.Disposable{constructor(w){super(),this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,E){let a=this.theme.getColor(w);return a&&E&&(a=E(a,this.theme)),a?a.toString():null}}t.Themable=g}),define(pe[141],be([1,0,8,12,3,6,16,132,139,39,65]),function(Q,t,y,i,W,B,C,D,d,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var N;(function(u){function m(S,T){let _=S.defaults;for(;f.ThemeIcon.isThemeIcon(_);){const r=e.getIcon(_.id);if(!r)return;_=r.defaults}return _}u.getDefinition=m})(N=t.IconContribution||(t.IconContribution={}));var l;(function(u){function m(T){return{weight:T.weight,style:T.style,src:T.src.map(_=>({format:_.format,location:_.location.toString()}))}}u.toJSONObject=m;function S(T){const _=r=>(0,B.isString)(r)?r:void 0;if(T&&Array.isArray(T.src)&&T.src.every(r=>(0,B.isString)(r.format)&&(0,B.isString)(r.location)))return{weight:_(T.weight),style:_(T.style),src:T.src.map(r=>({format:r.format,location:C.URI.parse(r.location)}))}}u.fromJSONObject=S})(l=t.IconFontDefinition||(t.IconFontDefinition={}));class n{constructor(){this._onDidChange=new W.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,S,T,_){const r=this.iconsById[m];if(r){if(T&&!r.description){r.description=T,this.iconSchema.properties[m].markdownDescription=`${T} $(${m})`;const s=this.iconReferenceSchema.enum.indexOf(m);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=T),this._onDidChange.fire()}return r}const v={id:m,description:T,defaults:S,deprecationMessage:_};this.iconsById[m]=v;const o={$ref:"#/definitions/icons"};return _&&(o.deprecationMessage=_),T&&(o.markdownDescription=`${T}: $(${m})`),this.iconSchema.properties[m]=o,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(T||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const S=this.iconReferenceSchema.enum.indexOf(m);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,S){const T=this.iconFontsById[m];return T||(this.iconFontsById[m]=S,this._onDidChange.fire(),S)}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(r,v)=>r.id.localeCompare(v.id),S=r=>{for(;f.ThemeIcon.isThemeIcon(r.defaults);)r=this.iconsById[r.defaults.id];return`codicon codicon-${r?r.id:""}`},T=[];T.push("| preview     | identifier                        | default codicon ID                | description"),T.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const _=Object.keys(this.iconsById).map(r=>this.iconsById[r]);for(const r of _.filter(v=>!!v.description).sort(m))T.push(`|<i class="${S(r)}"></i>|${r.id}|${f.ThemeIcon.isThemeIcon(r.defaults)?r.defaults.id:r.id}|${r.description||""}|`);T.push("| preview     | identifier                        "),T.push("| ----------- | --------------------------------- |");for(const r of _.filter(v=>!f.ThemeIcon.isThemeIcon(v.defaults)).sort(m))T.push(`|<i class="${S(r)}"></i>|${r.id}|`);return T.join(`
`)}}const e=new n;c.Registry.add(t.Extensions.IconContribution,e);function g(u,m,S,T){return e.registerIcon(u,m,S,T)}t.registerIcon=g;function b(){return e}t.getIconRegistry=b;function w(){for(const u of i.Codicon.getAll())e.registerIcon(u.id,u.definition,u.description)}w(),t.iconsSchemaId="vscode://schemas/icons";const E=c.Registry.as(d.Extensions.JSONContribution);E.registerSchema(t.iconsSchemaId,e.getIconSchema());const a=new y.RunOnceScheduler(()=>E.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{a.isScheduled()||a.schedule()}),t.widgetClose=g("widget-close",i.Codicon.close,(0,D.localize)(2,null)),t.gotoPreviousLocation=g("goto-previous-location",i.Codicon.arrowUp,(0,D.localize)(3,null)),t.gotoNextLocation=g("goto-next-location",i.Codicon.arrowDown,(0,D.localize)(4,null)),t.syncing=f.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=f.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(pe[142],be([1,0,4,3,141,65]),function(Q,t,y,i,W,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function C(d){const c=new i.Emitter,f=(0,W.getIconRegistry)();return f.onDidChange(()=>c.fire()),d?.onDidProductIconThemeChange(()=>c.fire()),{onDidChange:c.event,getCSS(){const N=d?d.getProductIconTheme():new D,l={},n=g=>{const b=N.getIcon(g);if(!b)return;const w=b.font;return w?(l[w.id]=w.definition,`.codicon-${g.id}:before { content: '${b.fontCharacter}'; font-family: ${(0,y.asCSSPropertyValue)(w.id)}; }`):`.codicon-${g.id}:before { content: '${b.fontCharacter}'; }`},e=[];for(const g of f.getIcons()){const b=n(g);b&&e.push(b)}for(const g in l){const b=l[g],w=b.weight?`font-weight: ${b.weight};`:"",E=b.style?`font-style: ${b.style};`:"",a=b.src.map(u=>`${(0,y.asCSSUrl)(u.location)} format('${u.format}')`).join(", ");e.push(`@font-face { src: ${a}; font-family: ${(0,y.asCSSPropertyValue)(g)};${w}${E} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=C;class D{getIcon(c){const f=(0,W.getIconRegistry)();let N=c.defaults;for(;B.ThemeIcon.isThemeIcon(N);){const l=f.getIcon(N.id);if(!l)return;N=l.defaults}return N}}t.UnthemedProductIconTheme=D}),define(pe[143],be([1,0,5]),function(Q,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(f){return!!f.workspaceUri}t.isWorkspaceToOpen=i;function W(f){return!!f.folderUri}t.isFolderToOpen=W;function B(f){return!!f.fileUri}t.isFileToOpen=B;function C(f){const N=D(f),l=f.getValue("window.menuBarVisibility");return l==="default"||N==="native"&&l==="compact"||y.isMacintosh&&y.isNative?"classic":l}t.getMenuBarVisibility=C;function D(f){if(y.isWeb)return"custom";const N=f.getValue("window");if(N){if(y.isMacintosh&&N.nativeTabs===!0||y.isMacintosh&&N.nativeFullScreen===!1)return"native";const e=N.titleBarStyle;if(e==="native"||e==="custom")return e}return y.isLinux?"native":"custom"}t.getTitleBarStyle=D;function d(f){if(!y.isWindows||y.isWeb||D(f)==="native")return!1;const N=f.getValue("window.experimental.windowControlsOverlay.enabled");return typeof N=="boolean"?N:!1}t.useWindowControlsOverlay=d;function c(f=0){return Math.pow(1.2,f)}t.zoomLevelToZoomFactor=c}),define(pe[144],be([1,0,15,29,143]),function(Q,t,y,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function B(d){i.webFrame.setZoomLevel(d),(0,y.setZoomFactor)((0,W.zoomLevelToZoomFactor)(d)),(0,y.setZoomLevel)(d,!1)}t.applyZoom=B;function C(){B((0,y.getZoomLevel)()+1)}t.zoomIn=C;function D(){B((0,y.getZoomLevel)()-1)}t.zoomOut=D}),define(pe[145],be([1,0,10,4,128,8,129,29,134,135,136,138,142,144,94,85]),function(Q,t,y,i,W,B,C,D,d,c,f,N,l,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,g=/\s--(inspect|debug)-port=(\d+)/;class b{getHeight(p){return 22}getTemplateId(p){return _(p)?"process":S(p)?"machine":(0,d.isRemoteDiagnosticError)(p)?"error":T(p)?"header":""}}class w{hasChildren(p){return(0,d.isRemoteDiagnosticError)(p)?!1:_(p)?!!p.children?.length:!0}getChildren(p){return _(p)?p.children?p.children:[]:(0,d.isRemoteDiagnosticError)(p)?[]:T(p)?p.processRoots.length>1?p.processRoots:[p.processRoots[0].rootProcess]:S(p)?[p.rootProcess]:[p.processes]}}class E{constructor(){this.templateId="header"}renderTemplate(p){const L=Object.create(null),V=(0,i.append)(p,(0,i.$)(".row"));return L.name=(0,i.append)(V,(0,i.$)(".nameLabel")),L.CPU=(0,i.append)(V,(0,i.$)(".cpu")),L.memory=(0,i.append)(V,(0,i.$)(".memory")),L.PID=(0,i.append)(V,(0,i.$)(".pid")),L}renderElement(p,L,V,X){V.name.textContent=(0,y.localize)(0,null),V.CPU.textContent=(0,y.localize)(1,null),V.PID.textContent=(0,y.localize)(2,null),V.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(p){}}class a{constructor(){this.templateId="machine"}renderTemplate(p){const L=Object.create(null),V=(0,i.append)(p,(0,i.$)(".row"));return L.name=(0,i.append)(V,(0,i.$)(".nameLabel")),L}renderElement(p,L,V,X){V.name.textContent=p.element.name}disposeTemplate(p){}}class u{constructor(){this.templateId="error"}renderTemplate(p){const L=Object.create(null),V=(0,i.append)(p,(0,i.$)(".row"));return L.name=(0,i.append)(V,(0,i.$)(".nameLabel")),L}renderElement(p,L,V,X){V.name.textContent=p.element.errorMessage}disposeTemplate(p){}}class m{constructor(p,L,V){this.platform=p,this.totalMem=L,this.mapPidToWindowTitle=V,this.templateId="process"}renderTemplate(p){const L=Object.create(null),V=(0,i.append)(p,(0,i.$)(".row"));return L.name=(0,i.append)(V,(0,i.$)(".nameLabel")),L.CPU=(0,i.append)(V,(0,i.$)(".cpu")),L.memory=(0,i.append)(V,(0,i.$)(".memory")),L.PID=(0,i.append)(V,(0,i.$)(".pid")),L}renderElement(p,L,V,X){const{element:J}=p;let ge=J.name;ge==="window"&&(ge=this.mapPidToWindowTitle.get(J.pid)!==void 0?`${ge} (${this.mapPidToWindowTitle.get(J.pid)})`:ge);const oe=J.pid.toFixed(0);V.name.textContent=ge,V.name.title=J.cmd,V.CPU.textContent=J.load.toFixed(0),V.PID.textContent=oe,V.PID.parentElement.id=`pid-${oe}`;const me=this.platform==="win32"?J.mem:this.totalMem*(J.mem/100);V.memory.textContent=(me/c.ByteSize.MB).toFixed(0)}disposeTemplate(p){}}function S(s){return!!s.name&&!!s.rootProcess}function T(s){return!!s.processRoots}function _(s){return!!s.pid}class r{constructor(p,L){this.data=L,this.mapPidToWindowTitle=new Map;const V=new f.ElectronIPCMainProcessService(p);this.nativeHostService=new N.NativeHostService(p,V),this.applyStyles(L.styles),this.setEventHandlers(L),D.ipcRenderer.on("vscode:windowsInfoResponse",(X,J)=>{this.mapPidToWindowTitle=new Map,J.forEach(ge=>this.mapPidToWindowTitle.set(ge.pid,ge.title))}),D.ipcRenderer.on("vscode:listProcessesResponse",async(X,J)=>{J.forEach((ge,oe)=>{_(ge.rootProcess)&&(ge.rootProcess.name=oe===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:J}}),this.tree.layout(window.innerHeight,window.innerWidth)):await this.createProcessTree(J),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),D.ipcRenderer.send("vscode:windowsInfoRequest"),D.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(p){document.onkeydown=L=>{const V=p.platform==="darwin"?L.metaKey:L.ctrlKey;V&&L.keyCode===87&&(L.stopPropagation(),L.preventDefault(),D.ipcRenderer.send("vscode:closeProcessExplorer")),V&&L.keyCode===187&&(0,n.zoomIn)(),V&&L.keyCode===189&&(0,n.zoomOut)()}}async createProcessTree(p){const L=document.getElementById("process-list");if(!L)return;const{totalmem:V}=await this.nativeHostService.getOSStatistics(),X=[new m(this.data.platform,V,this.mapPidToWindowTitle),new E,new a,new u];this.tree=new W.DataTree("processExplorer",L,new b,X,new w,{identityProvider:{getId:J=>_(J)?J.pid.toString():(0,d.isRemoteDiagnosticError)(J)?J.hostName:T(J)?"processes":S(J)?J.name:"header"}}),this.tree.setInput({processes:{processRoots:p}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onContextMenu(J=>{_(J.element)&&this.showContextMenu(J.element,!0)}),L.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{L.style.height=`${window.innerHeight}px`,this.tree?.layout(window.innerHeight,window.innerWidth)})}isDebuggable(p){const L=e.exec(p);return L&&L.length>=2||p.indexOf("node ")>=0||p.indexOf("node.exe")>=0}attachTo(p){const L={type:"node",request:"attach",name:`process ${p.pid}`};let V=e.exec(p.cmd);V&&V.length>=2?(V.length===4&&V[3]&&(L.port=parseInt(V[3])),L.protocol=V[1]==="debug"?"legacy":"inspector"):L.processId=String(p.pid),V=g.exec(p.cmd),V&&V.length===3&&(L.port=parseInt(V[2])),D.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[L]})}applyStyles(p){const L=(0,i.createStyleSheet)(),V=[];p.listFocusBackground&&(V.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${p.listFocusBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${p.listFocusBackground}; }`)),p.listFocusForeground&&V.push(`.monaco-list:focus .monaco-list-row.focused { color: ${p.listFocusForeground}; }`),p.listActiveSelectionBackground&&(V.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${p.listActiveSelectionBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${p.listActiveSelectionBackground}; }`)),p.listActiveSelectionForeground&&V.push(`.monaco-list:focus .monaco-list-row.selected { color: ${p.listActiveSelectionForeground}; }`),p.listHoverBackground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${p.listHoverBackground}; }`),p.listHoverForeground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${p.listHoverForeground}; }`),p.listFocusOutline&&V.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${p.listFocusOutline}; outline-offset: -1px; }`),p.listHoverOutline&&V.push(`.monaco-list-row:hover { outline: 1px dashed ${p.listHoverOutline}; outline-offset: -1px; }`),p.scrollbarShadowColor&&V.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${p.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${p.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${p.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),p.scrollbarSliderBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${p.scrollbarSliderBackgroundColor};
				}
			`),p.scrollbarSliderHoverBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${p.scrollbarSliderHoverBackgroundColor};
				}
			`),p.scrollbarSliderActiveBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${p.scrollbarSliderActiveBackgroundColor};
				}
			`),L.textContent=V.join(`
`),p.color&&(document.body.style.color=p.color)}showContextMenu(p,L){const V=[],X=Number(p.pid);L&&(V.push({label:(0,y.localize)(4,null),click:()=>{this.nativeHostService.killProcess(X,"SIGTERM")}}),V.push({label:(0,y.localize)(5,null),click:()=>{this.nativeHostService.killProcess(X,"SIGKILL")}}),V.push({type:"separator"})),V.push({label:(0,y.localize)(6,null),click:()=>{const J=this.tree?.getSelection()?.map(oe=>{if(!(!oe||!("pid"in oe)))return oe.pid}).filter(oe=>!!oe);J?.includes(X)||(J.length=0,J.push(X));const ge=J?.map(oe=>document.getElementById(`pid-${oe}`)).filter(oe=>!!oe);if(ge){const oe=ge.map(me=>me.innerText).filter(me=>!!me);this.nativeHostService.writeClipboardText(oe.join(`
`))}}}),V.push({label:(0,y.localize)(7,null),click:()=>{const J=document.getElementById("process-list");J&&this.nativeHostService.writeClipboardText(J.innerText)}}),p&&L&&this.isDebuggable(p.cmd)&&(V.push({type:"separator"}),V.push({label:(0,y.localize)(8,null),click:()=>{this.attachTo(p)}})),(0,C.popup)(V)}requestProcessList(p){setTimeout(()=>{const L=Date.now(),V=p+L-this.lastRequestTime;this.lastRequestTime=L,V>1e3?(D.ipcRenderer.send("vscode:windowsInfoRequest"),D.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(V)},200)}}function v(){const s=(0,i.createStyleSheet)();s.id="codiconStyles";const p=(0,l.getIconsStyleSheet)(void 0);function L(){s.textContent=p.getCSS()}const V=new B.RunOnceScheduler(L,0);p.onDidChange(()=>V.schedule()),V.schedule()}function o(s){const p=s.data.platform==="win32"?"windows":s.data.platform==="linux"?"linux":"mac";document.body.classList.add(p),v(),(0,n.applyZoom)(s.data.zoomLevel),new r(s.windowId,s.data)}t.startup=o})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bd1b7a384f8a5ab9fb5a6a0e8fea370e589f43a3/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
