/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(B){for(var i=[],D=0,C=B.length;D<C;D++)i[D]=Q[B[D]];return i};define(Q[49],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function D(L){return(m,l,f)=>{let I=null,w=null;if(typeof f.value=="function"?(I="value",w=f.value):typeof f.get=="function"&&(I="get",w=f.get),!w)throw new Error("not supported");f[I]=L(w,l)}}i.createDecorator=D;function C(L,m,l){let f=null,I=null;if(typeof l.value=="function"?(f="value",I=l.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(f="get",I=l.get),!I)throw new Error("not supported");const w=`$memoize$${m}`;l[f]=function(...d){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[w]}}i.memoize=C;function P(L,m,l){return D((f,I)=>{const w=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...S){this[d]||(this[d]=l?l():void 0),clearTimeout(this[w]),m&&(this[d]=m(this[d],...S),S=[this[d]]),this[w]=setTimeout(()=>{f.apply(this,S),this[d]=l?l():void 0},L)}})}i.debounce=P;function k(L,m,l){return D((f,I)=>{const w=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,S=`$throttle$lastRun$${I}`,g=`$throttle$pending$${I}`;return function(...y){if(this[d]||(this[d]=l?l():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),m&&(this[d]=m(this[d],...y)),this[g])return;const v=this[S]+L;v<=Date.now()?(this[S]=Date.now(),f.apply(this,[this[d]]),this[d]=l?l():void 0):(this[g]=!0,this[w]=setTimeout(()=>{this[g]=!1,this[S]=Date.now(),f.apply(this,[this[d]]),this[d]=l?l():void 0},v-Date.now()))}})}i.throttle=k}),define(Q[68],Z([0,1,11]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.checkAdjacentItems=i.assertFn=i.assert=i.assertNever=i.ok=void 0;function C(l,f){if(!l)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}i.ok=C;function P(l,f="Unreachable"){throw new Error(f)}i.assertNever=P;function k(l){if(!l)throw new D.BugIndicatingError("Assertion Failed")}i.assert=k;function L(l){if(!l()){debugger;l(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}i.assertFn=L;function m(l,f){let I=0;for(;I<l.length-1;){const w=l[I],d=l[I+1];if(!f(w,d))return!1;I++}return!0}i.checkAdjacentItems=m}),define(Q[50],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var D;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(D=i.ScanError||(i.ScanError={}));var C;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(C=i.SyntaxKind||(i.SyntaxKind={}));var P;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(P=i.ParseErrorCode||(i.ParseErrorCode={}));var k;(function(e){e.DEFAULT={allowTrailingComma:!0}})(k=i.ParseOptions||(i.ParseOptions={}));function L(e,r=!1){let t=0;const n=e.length;let o="",p=0,E=16,b=0;function R(se){let fe=0,le=0;for(;fe<se;){const ie=e.charCodeAt(t);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;t++,fe++}return fe<se&&(le=-1),le}function j(se){t=se,o="",p=0,E=16,b=0}function _(){const se=t;if(e.charCodeAt(t)===48)t++;else for(t++;t<e.length&&f(e.charCodeAt(t));)t++;if(t<e.length&&e.charCodeAt(t)===46)if(t++,t<e.length&&f(e.charCodeAt(t)))for(t++;t<e.length&&f(e.charCodeAt(t));)t++;else return b=3,e.substring(se,t);let fe=t;if(t<e.length&&(e.charCodeAt(t)===69||e.charCodeAt(t)===101))if(t++,(t<e.length&&e.charCodeAt(t)===43||e.charCodeAt(t)===45)&&t++,t<e.length&&f(e.charCodeAt(t))){for(t++;t<e.length&&f(e.charCodeAt(t));)t++;fe=t}else b=3;return e.substring(se,fe)}function J(){let se="",fe=t;for(;;){if(t>=n){se+=e.substring(fe,t),b=2;break}const le=e.charCodeAt(t);if(le===34){se+=e.substring(fe,t),t++;break}if(le===92){if(se+=e.substring(fe,t),t++,t>=n){b=2;break}switch(e.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const V=R(4);V>=0?se+=String.fromCharCode(V):b=4;break}default:b=5}fe=t;continue}if(le>=0&&le<=31)if(l(le)){se+=e.substring(fe,t),b=2;break}else b=6;t++}return se}function H(){if(o="",b=0,p=t,t>=n)return p=n,E=17;let se=e.charCodeAt(t);if(m(se)){do t++,o+=String.fromCharCode(se),se=e.charCodeAt(t);while(m(se));return E=15}if(l(se))return t++,o+=String.fromCharCode(se),se===13&&e.charCodeAt(t)===10&&(t++,o+=`
`),E=14;switch(se){case 123:return t++,E=1;case 125:return t++,E=2;case 91:return t++,E=3;case 93:return t++,E=4;case 58:return t++,E=6;case 44:return t++,E=5;case 34:return t++,o=J(),E=10;case 47:{const fe=t-1;if(e.charCodeAt(t+1)===47){for(t+=2;t<n&&!l(e.charCodeAt(t));)t++;return o=e.substring(fe,t),E=12}if(e.charCodeAt(t+1)===42){t+=2;const le=n-1;let ie=!1;for(;t<le;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2,ie=!0;break}t++}return ie||(t++,b=1),o=e.substring(fe,t),E=13}return o+=String.fromCharCode(se),t++,E=16}case 45:if(o+=String.fromCharCode(se),t++,t===n||!f(e.charCodeAt(t)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),E=11;default:for(;t<n&&ne(se);)t++,se=e.charCodeAt(t);if(p!==t){switch(o=e.substring(p,t),o){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return o+=String.fromCharCode(se),t++,E=16}}function ne(se){if(m(se)||l(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let se;do se=H();while(se>=12&&se<=15);return se}return{setPosition:j,getPosition:()=>t,scan:r?re:H,getToken:()=>E,getTokenValue:()=>o,getTokenOffset:()=>p,getTokenLength:()=>t-p,getTokenError:()=>b}}i.createScanner=L;function m(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var I;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(I||(I={}));function w(e,r){const t=[],n=new Object;let o;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function b(R,j,_,J){p.value=R,p.offset=j,p.length=_,p.type=J,p.colonOffset=void 0,o=p}try{h(e,{onObjectBegin:(R,j)=>{if(r<=R)throw n;o=void 0,E=r>R,t.push("")},onObjectProperty:(R,j,_)=>{if(r<j||(b(R,j,_,"property"),t[t.length-1]=R,r<=j+_))throw n},onObjectEnd:(R,j)=>{if(r<=R)throw n;o=void 0,t.pop()},onArrayBegin:(R,j)=>{if(r<=R)throw n;o=void 0,t.push(0)},onArrayEnd:(R,j)=>{if(r<=R)throw n;o=void 0,t.pop()},onLiteralValue:(R,j,_)=>{if(r<j||(b(R,j,_,s(R)),r<=j+_))throw n},onSeparator:(R,j,_)=>{if(r<=j)throw n;if(R===":"&&o&&o.type==="property")o.colonOffset=j,E=!1,o=void 0;else if(R===","){const J=t[t.length-1];typeof J=="number"?t[t.length-1]=J+1:(E=!0,t[t.length-1]=""),o=void 0}}})}catch(R){if(R!==n)throw R}return{path:t,previousNode:o,isAtPropertyKey:E,matches:R=>{let j=0;for(let _=0;j<R.length&&_<t.length;_++)if(R[j]===t[_]||R[j]==="*")j++;else if(R[j]!=="**")return!1;return j===R.length}}}i.getLocation=w;function d(e,r=[],t=k.DEFAULT){let n=null,o=[];const p=[];function E(R){Array.isArray(o)?o.push(R):n!==null&&(o[n]=R)}return h(e,{onObjectBegin:()=>{const R={};E(R),p.push(o),o=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{o=p.pop()},onArrayBegin:()=>{const R=[];E(R),p.push(o),o=R,n=null},onArrayEnd:()=>{o=p.pop()},onLiteralValue:E,onError:(R,j,_)=>{r.push({error:R,offset:j,length:_})}},t),o[0]}i.parse=d;function S(e,r=[],t=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){n.type==="property"&&(n.length=R-n.offset,n=n.parent)}function p(R){return n.children.push(R),R}h(e,{onObjectBegin:R=>{n=p({type:"object",offset:R,length:-1,parent:n,children:[]})},onObjectProperty:(R,j,_)=>{n=p({type:"property",offset:j,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:R,offset:j,length:_,parent:n})},onObjectEnd:(R,j)=>{n.length=R+j-n.offset,n=n.parent,o(R+j)},onArrayBegin:(R,j)=>{n=p({type:"array",offset:R,length:-1,parent:n,children:[]})},onArrayEnd:(R,j)=>{n.length=R+j-n.offset,n=n.parent,o(R+j)},onLiteralValue:(R,j,_)=>{p({type:s(R),offset:j,length:_,parent:n,value:R}),o(j+_)},onSeparator:(R,j,_)=>{n.type==="property"&&(R===":"?n.colonOffset=j:R===","&&o(j))},onError:(R,j,_)=>{r.push({error:R,offset:j,length:_})}},t);const b=n.children[0];return b&&delete b.parent,b}i.parseTree=S;function g(e,r){if(!e)return;let t=e;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const p of t.children)if(Array.isArray(p.children)&&p.children[0].value===n){t=p.children[1],o=!0;break}if(!o)return}else{const o=n;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}i.findNodeAtLocation=g;function y(e){if(!e.parent||!e.parent.children)return[];const r=y(e.parent);if(e.parent.type==="property"){const t=e.parent.children[0].value;r.push(t)}else if(e.parent.type==="array"){const t=e.parent.children.indexOf(e);t!==-1&&r.push(t)}return r}i.getNodePath=y;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":{const r=Object.create(null);for(const t of e.children){const n=t.children[1];n&&(r[t.children[0].value]=v(n))}return r}case"null":case"string":case"number":case"boolean":return e.value;default:return}}i.getNodeValue=v;function a(e,r,t=!1){return r>=e.offset&&r<e.offset+e.length||t&&r===e.offset+e.length}i.contains=a;function c(e,r,t=!1){if(a(e,r,t)){const n=e.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const p=c(n[o],r,t);if(p)return p}return e}}i.findNodeAtOffset=c;function h(e,r,t=k.DEFAULT){const n=L(e,!1);function o(A){return A?()=>A(n.getTokenOffset(),n.getTokenLength()):()=>!0}function p(A){return A?U=>A(U,n.getTokenOffset(),n.getTokenLength()):()=>!0}const E=o(r.onObjectBegin),b=p(r.onObjectProperty),R=o(r.onObjectEnd),j=o(r.onArrayBegin),_=o(r.onArrayEnd),J=p(r.onLiteralValue),H=p(r.onSeparator),ne=o(r.onComment),re=p(r.onError),se=t&&t.disallowComments,fe=t&&t.allowTrailingComma;function le(){for(;;){const A=n.scan();switch(n.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:se||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(A){case 12:case 13:se?ie(10):ne();break;case 16:ie(1);break;case 15:case 14:break;default:return A}}}function ie(A,U=[],T=[]){if(re(A),U.length+T.length>0){let O=n.getToken();for(;O!==17;){if(U.indexOf(O)!==-1){le();break}else if(T.indexOf(O)!==-1)break;O=le()}}}function V(A){const U=n.getTokenValue();return A?J(U):b(U),le(),!0}function N(){switch(n.getToken()){case 11:{let A=0;try{A=JSON.parse(n.getTokenValue()),typeof A!="number"&&(ie(2),A=0)}catch{ie(2)}J(A);break}case 7:J(null);break;case 8:J(!0);break;case 9:J(!1);break;default:return!1}return le(),!0}function F(){return n.getToken()!==10?(ie(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(H(":"),le(),Y()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function z(){E(),le();let A=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(A||ie(4,[],[]),H(","),le(),n.getToken()===2&&fe)break}else A&&ie(6,[],[]);F()||ie(4,[],[2,5]),A=!0}return R(),n.getToken()!==2?ie(7,[2],[]):le(),!0}function $(){j(),le();let A=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(A||ie(4,[],[]),H(","),le(),n.getToken()===4&&fe)break}else A&&ie(6,[],[]);Y()||ie(4,[],[4,5]),A=!0}return _(),n.getToken()!==4?ie(8,[4],[]):le(),!0}function Y(){switch(n.getToken()){case 3:return $();case 1:return z();case 10:return V(!0);default:return N()}}return le(),n.getToken()===17?t.allowEmptyContent?!0:(ie(4,[],[]),!1):Y()?(n.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}i.visit=h;function u(e,r){const t=L(e),n=[];let o,p=0,E;do switch(E=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:p!==E&&n.push(e.substring(p,E)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),p=t.getPosition();break}while(o!==17);return n.join("")}i.stripComments=u;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function B(P){const k=[];typeof P=="number"&&k.push("code/timeOrigin",P);function L(l){k.push(l,Date.now())}function m(){const l=[];for(let f=0;f<k.length;f+=2)l.push({name:k[f],startTime:k[f+1]});return l}return{mark:L,getMarks:m}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(P+L.startTime)});return k}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function D(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=i()),P.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=D(C))}(),function(B,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var D=i();for(var C in D)(typeof exports=="object"?exports:B)[C]=D[C]}}(typeof self<"u"?self:this,function(){return function(B){var i={};function D(C){if(i[C])return i[C].exports;var P=i[C]={i:C,l:!1,exports:{}};return B[C].call(P.exports,P,P.exports,D),P.l=!0,P.exports}return D.m=B,D.c=i,D.d=function(C,P,k){D.o(C,P)||Object.defineProperty(C,P,{enumerable:!0,get:k})},D.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},D.t=function(C,P){if(1&P&&(C=D(C)),8&P||4&P&&typeof C=="object"&&C&&C.__esModule)return C;var k=Object.create(null);if(D.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:C}),2&P&&typeof C!="string")for(var L in C)D.d(k,L,function(m){return C[m]}.bind(null,L));return k},D.n=function(C){var P=C&&C.__esModule?function(){return C.default}:function(){return C};return D.d(P,"a",P),P},D.o=function(C,P){return Object.prototype.hasOwnProperty.call(C,P)},D.p="",D(D.s=0)}([function(B,i,D){(function(C){var P;i=B.exports=T,P=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,m=i.re=[],l=i.src=[],f=0,I=f++;l[I]="0|[1-9]\\d*";var w=f++;l[w]="[0-9]+";var d=f++;l[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=f++;l[S]="("+l[I]+")\\.("+l[I]+")\\.("+l[I]+")";var g=f++;l[g]="("+l[w]+")\\.("+l[w]+")\\.("+l[w]+")";var y=f++;l[y]="(?:"+l[I]+"|"+l[d]+")";var v=f++;l[v]="(?:"+l[w]+"|"+l[d]+")";var a=f++;l[a]="(?:-("+l[y]+"(?:\\."+l[y]+")*))";var c=f++;l[c]="(?:-?("+l[v]+"(?:\\."+l[v]+")*))";var h=f++;l[h]="[0-9A-Za-z-]+";var u=f++;l[u]="(?:\\+("+l[h]+"(?:\\."+l[h]+")*))";var s=f++,e="v?"+l[S]+l[a]+"?"+l[u]+"?";l[s]="^"+e+"$";var r="[v=\\s]*"+l[g]+l[c]+"?"+l[u]+"?",t=f++;l[t]="^"+r+"$";var n=f++;l[n]="((?:<|>)?=?)";var o=f++;l[o]=l[w]+"|x|X|\\*";var p=f++;l[p]=l[I]+"|x|X|\\*";var E=f++;l[E]="[v=\\s]*("+l[p]+")(?:\\.("+l[p]+")(?:\\.("+l[p]+")(?:"+l[a]+")?"+l[u]+"?)?)?";var b=f++;l[b]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[c]+")?"+l[u]+"?)?)?";var R=f++;l[R]="^"+l[n]+"\\s*"+l[E]+"$";var j=f++;l[j]="^"+l[n]+"\\s*"+l[b]+"$";var _=f++;l[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var J=f++;l[J]="(?:~>?)";var H=f++;l[H]="(\\s*)"+l[J]+"\\s+",m[H]=new RegExp(l[H],"g");var ne=f++;l[ne]="^"+l[J]+l[E]+"$";var re=f++;l[re]="^"+l[J]+l[b]+"$";var se=f++;l[se]="(?:\\^)";var fe=f++;l[fe]="(\\s*)"+l[se]+"\\s+",m[fe]=new RegExp(l[fe],"g");var le=f++;l[le]="^"+l[se]+l[E]+"$";var ie=f++;l[ie]="^"+l[se]+l[b]+"$";var V=f++;l[V]="^"+l[n]+"\\s*("+r+")$|^$";var N=f++;l[N]="^"+l[n]+"\\s*("+e+")$|^$";var F=f++;l[F]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[E]+")",m[F]=new RegExp(l[F],"g");var z=f++;l[z]="^\\s*("+l[E]+")\\s+-\\s+("+l[E]+")\\s*$";var $=f++;l[$]="^\\s*("+l[b]+")\\s+-\\s+("+l[b]+")\\s*$";var Y=f++;l[Y]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)P(A,l[A]),m[A]||(m[A]=new RegExp(l[A]));function U(x,G){if(x instanceof T)return x;if(typeof x!="string"||x.length>k||!(G?m[t]:m[s]).test(x))return null;try{return new T(x,G)}catch{return null}}function T(x,G){if(x instanceof T){if(x.loose===G)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof T))return new T(x,G);P("SemVer",x,G),this.loose=G;var X=x.trim().match(G?m[t]:m[s]);if(!X)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<L)return me}return ue}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}i.parse=U,i.valid=function(x,G){var X=U(x,G);return X?X.version:null},i.clean=function(x,G){var X=U(x.trim().replace(/^[=v]+/,""),G);return X?X.version:null},i.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(x){return P("SemVer.compare",this.version,this.loose,x),x instanceof T||(x=new T(x,this.loose)),this.compareMain(x)||this.comparePre(x)},T.prototype.compareMain=function(x){return x instanceof T||(x=new T(x,this.loose)),M(this.major,x.major)||M(this.minor,x.minor)||M(this.patch,x.patch)},T.prototype.comparePre=function(x){if(x instanceof T||(x=new T(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var G=0;do{var X=this.prerelease[G],ue=x.prerelease[G];if(P("prerelease compare",G,X,ue),X===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(X===void 0)return-1;if(X!==ue)return M(X,ue)}while(++G)},T.prototype.inc=function(x,G){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},i.inc=function(x,G,X,ue){typeof X=="string"&&(ue=X,X=void 0);try{return new T(x,X).inc(G,ue).version}catch{return null}},i.diff=function(x,G){if(ae(x,G))return null;var X=U(x),ue=U(G);if(X.prerelease.length||ue.prerelease.length){for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==ue[me])return me},i.compareIdentifiers=M;var O=/^[0-9]+$/;function M(x,G){var X=O.test(x),ue=O.test(G);return X&&ue&&(x=+x,G=+G),X&&!ue?-1:ue&&!X?1:x<G?-1:x>G?1:0}function W(x,G,X){return new T(x,X).compare(new T(G,X))}function q(x,G,X){return W(x,G,X)>0}function K(x,G,X){return W(x,G,X)<0}function ae(x,G,X){return W(x,G,X)===0}function ce(x,G,X){return W(x,G,X)!==0}function pe(x,G,X){return W(x,G,X)>=0}function Se(x,G,X){return W(x,G,X)<=0}function te(x,G,X,ue){var me;switch(G){case"===":typeof x=="object"&&(x=x.version),typeof X=="object"&&(X=X.version),me=x===X;break;case"!==":typeof x=="object"&&(x=x.version),typeof X=="object"&&(X=X.version),me=x!==X;break;case"":case"=":case"==":me=ae(x,X,ue);break;case"!=":me=ce(x,X,ue);break;case">":me=q(x,X,ue);break;case">=":me=pe(x,X,ue);break;case"<":me=K(x,X,ue);break;case"<=":me=Se(x,X,ue);break;default:throw new TypeError("Invalid operator: "+G)}return me}function oe(x,G){if(x instanceof oe){if(x.loose===G)return x;x=x.value}if(!(this instanceof oe))return new oe(x,G);P("comparator",x,G),this.loose=G,this.parse(x),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}i.rcompareIdentifiers=function(x,G){return M(G,x)},i.major=function(x,G){return new T(x,G).major},i.minor=function(x,G){return new T(x,G).minor},i.patch=function(x,G){return new T(x,G).patch},i.compare=W,i.compareLoose=function(x,G){return W(x,G,!0)},i.rcompare=function(x,G,X){return W(G,x,X)},i.sort=function(x,G){return x.sort(function(X,ue){return i.compare(X,ue,G)})},i.rsort=function(x,G){return x.sort(function(X,ue){return i.rcompare(X,ue,G)})},i.gt=q,i.lt=K,i.eq=ae,i.neq=ce,i.gte=pe,i.lte=Se,i.cmp=te,i.Comparator=oe;var de={};function he(x,G){if(x instanceof he)return x.loose===G?x:new he(x.raw,G);if(x instanceof oe)return new he(x.value,G);if(!(this instanceof he))return new he(x,G);if(this.loose=G,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function ve(x){return!x||x.toLowerCase()==="x"||x==="*"}function ke(x,G,X,ue,me,De,we,Le,be,Ce,Me,Re,Te){return((G=ve(X)?"":ve(ue)?">="+X+".0.0":ve(me)?">="+X+"."+ue+".0":">="+G)+" "+(Le=ve(be)?"":ve(Ce)?"<"+(+be+1)+".0.0":ve(Me)?"<"+be+"."+(+Ce+1)+".0":Re?"<="+be+"."+Ce+"."+Me+"-"+Re:"<="+Le)).trim()}function Fe(x,G){for(var X=0;X<x.length;X++)if(!x[X].test(G))return!1;if(G.prerelease.length){for(X=0;X<x.length;X++)if(P(x[X].semver),x[X].semver!==de&&x[X].semver.prerelease.length>0){var ue=x[X].semver;if(ue.major===G.major&&ue.minor===G.minor&&ue.patch===G.patch)return!0}return!1}return!0}function Ue(x,G,X){try{G=new he(G,X)}catch{return!1}return G.test(x)}function xe(x,G,X,ue){var me,De,we,Le,be;switch(x=new T(x,ue),G=new he(G,ue),X){case">":me=q,De=Se,we=K,Le=">",be=">=";break;case"<":me=K,De=pe,we=q,Le="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,G,ue))return!1;for(var Ce=0;Ce<G.set.length;++Ce){var Me=G.set[Ce],Re=null,Te=null;if(Me.forEach(function(Ae){Ae.semver===de&&(Ae=new oe(">=0.0.0")),Re=Re||Ae,Te=Te||Ae,me(Ae.semver,Re.semver,ue)?Re=Ae:we(Ae.semver,Te.semver,ue)&&(Te=Ae)}),Re.operator===Le||Re.operator===be||(!Te.operator||Te.operator===Le)&&De(x,Te.semver)||Te.operator===be&&we(x,Te.semver))return!1}return!0}oe.prototype.parse=function(x){var G=this.loose?m[V]:m[N],X=x.match(G);if(!X)throw new TypeError("Invalid comparator: "+x);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new T(X[2],this.loose):this.semver=de},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(x){return P("Comparator.test",x,this.loose),this.semver===de||(typeof x=="string"&&(x=new T(x,this.loose)),te(x,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(x,G){if(!(x instanceof oe))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new he(x.value,G),Ue(this.value,X,G);if(x.operator==="")return X=new he(this.value,G),Ue(x.semver,X,G);var ue=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=te(this.semver,"<",x.semver,G)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),be=te(this.semver,">",x.semver,G)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ue||me||De&&we||Le||be},i.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(x){var G=this.loose;x=x.trim(),P("range",x,G);var X=G?m[$]:m[z];x=x.replace(X,ke),P("hyphen replace",x),x=x.replace(m[F],"$1$2$3"),P("comparator trim",x,m[F]),x=(x=(x=x.replace(m[H],"$1~")).replace(m[fe],"$1^")).split(/\s+/).join(" ");var ue=G?m[V]:m[N],me=x.split(" ").map(function(De){return function(we,Le){return P("comp",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Te){P("caret",Re,Te);var Ae=Te?m[ie]:m[le];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Oe;return P("caret",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?Oe="":ve(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?Oe=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(P("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(P("no pr"),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),P("caret return",Oe),Oe})}(Me,Ce)}).join(" ")}(we,Le),P("caret",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Te){var Ae=Te?m[re]:m[ne];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Oe;return P("tilde",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?Oe="":ve(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?Oe=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(P("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):Oe=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",P("tilde return",Oe),Oe})}(Me,Ce)}).join(" ")}(we,Le),P("tildes",we),we=function(be,Ce){return P("replaceXRanges",be,Ce),be.split(/\s+/).map(function(Me){return function(Re,Te){Re=Re.trim();var Ae=Te?m[j]:m[R];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie,Oe){P("xRange",Re,Ne,ye,Ee,Pe,Ie,Oe);var Ve=ve(Ee),ze=Ve||ve(Pe),je=ze||ve(Ie);return ye==="="&&je&&(ye=""),Ve?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&je?(ze&&(Pe=0),je&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":je&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),P("xRange return",Ne),Ne})}(Me,Ce)}).join(" ")}(we,Le),P("xrange",we),we=function(be,Ce){return P("replaceStars",be,Ce),be.trim().replace(m[Y],"")}(we,Le),P("stars",we),we}(De,G)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(ue)})),me=me.map(function(De){return new oe(De,G)})},he.prototype.intersects=function(x,G){if(!(x instanceof he))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(ue){return x.set.some(function(me){return me.every(function(De){return ue.intersects(De,G)})})})})},i.toComparators=function(x,G){return new he(x,G).set.map(function(X){return X.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},he.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new T(x,this.loose));for(var G=0;G<this.set.length;G++)if(Fe(this.set[G],x))return!0;return!1},i.satisfies=Ue,i.maxSatisfying=function(x,G,X){var ue=null,me=null;try{var De=new he(G,X)}catch{return null}return x.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==-1||(me=new T(ue=we,X)))}),ue},i.minSatisfying=function(x,G,X){var ue=null,me=null;try{var De=new he(G,X)}catch{return null}return x.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==1||(me=new T(ue=we,X)))}),ue},i.validRange=function(x,G){try{return new he(x,G).range||"*"}catch{return null}},i.ltr=function(x,G,X){return xe(x,G,"<",X)},i.gtr=function(x,G,X){return xe(x,G,">",X)},i.outside=xe,i.prerelease=function(x,G){var X=U(x,G);return X&&X.prerelease.length?X.prerelease:null},i.intersects=function(x,G,X){return x=new he(x,X),G=new he(G,X),x.intersects(G)},i.coerce=function(x){if(x instanceof T)return x;if(typeof x!="string")return null;var G=x.match(m[_]);return G==null?null:U((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,D(1))},function(B,i){var D,C,P=B.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function m(v){if(D===setTimeout)return setTimeout(v,0);if((D===k||!D)&&setTimeout)return D=setTimeout,setTimeout(v,0);try{return D(v,0)}catch{try{return D.call(null,v,0)}catch{return D.call(this,v,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:k}catch{D=k}try{C=typeof clearTimeout=="function"?clearTimeout:L}catch{C=L}})();var l,f=[],I=!1,w=-1;function d(){I&&l&&(I=!1,l.length?f=l.concat(f):w=-1,f.length&&S())}function S(){if(!I){var v=m(d);I=!0;for(var a=f.length;a;){for(l=f,f=[];++w<a;)l&&l[w].run();w=-1,a=f.length}l=null,I=!1,function(c){if(C===clearTimeout)return clearTimeout(c);if((C===L||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(c);try{C(c)}catch{try{return C.call(null,c)}catch{return C.call(this,c)}}}(v)}}function g(v,a){this.fun=v,this.array=a}function y(){}P.nextTick=function(v){var a=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)a[c-1]=arguments[c];f.push(new g(v,a)),f.length!==1||I||m(S)},g.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=y,P.addListener=y,P.once=y,P.off=y,P.removeListener=y,P.removeAllListeners=y,P.emit=y,P.prependListener=y,P.prependOnceListener=y,P.listeners=function(v){return[]},P.binding=function(v){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(v){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[69],Z([0,1]),function(B,i){"use strict";var D;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class C{constructor(m,l,f){this.level=m,this.key=l,this.value=f,this.forward=[]}}const P=void 0;class k{constructor(m,l=2**16){this.comparator=m,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new C(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new C(this._maxLevel,P,P)}has(m){return Boolean(k._search(this,m,this.comparator))}get(m){return k._search(this,m,this.comparator)?.value}set(m,l){return k._insert(this,m,l,this.comparator)&&(this._size+=1),this}delete(m){const l=k._delete(this,m,this.comparator);return l&&(this._size-=1),l}forEach(m,l){let f=this._header.forward[0];for(;f;)m.call(l,f.value,f.key,this),f=f.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let m=this._header.forward[0];for(;m;)yield[m.key,m.value],m=m.forward[0]}*keys(){let m=this._header.forward[0];for(;m;)yield m.key,m=m.forward[0]}*values(){let m=this._header.forward[0];for(;m;)yield m.value,m=m.forward[0]}toString(){let m="[SkipList]:",l=this._header.forward[0];for(;l;)m+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return m}static _search(m,l,f){let I=m._header;for(let w=m._level-1;w>=0;w--)for(;I.forward[w]&&f(I.forward[w].key,l)<0;)I=I.forward[w];if(I=I.forward[0],I&&f(I.key,l)===0)return I}static _insert(m,l,f,I){const w=[];let d=m._header;for(let S=m._level-1;S>=0;S--){for(;d.forward[S]&&I(d.forward[S].key,l)<0;)d=d.forward[S];w[S]=d}if(d=d.forward[0],d&&I(d.key,l)===0)return d.value=f,!1;{const S=k._randomLevel(m);if(S>m._level){for(let g=m._level;g<S;g++)w[g]=m._header;m._level=S}d=new C(S,l,f);for(let g=0;g<S;g++)d.forward[g]=w[g].forward[g],w[g].forward[g]=d;return!0}}static _randomLevel(m,l=.5){let f=1;for(;Math.random()<l&&f<m._maxLevel;)f+=1;return f}static _delete(m,l,f){const I=[];let w=m._header;for(let d=m._level-1;d>=0;d--){for(;w.forward[d]&&f(w.forward[d].key,l)<0;)w=w.forward[d];I[d]=w}if(w=w.forward[0],!w||f(w.key,l)!==0)return!1;for(let d=0;d<m._level&&I[d].forward[d]===w;d++)I[d].forward[d]=w.forward[d];for(;m._level>0&&m._header.forward[m._level-1]===P;)m._level-=1;return!0}}i.SkipList=k}),define(Q[43],Z([0,1,11,2]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function P(u){const s=u;return s?typeof s.read=="function":!1}i.isReadable=P;function k(u){const s=u;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}i.isReadableStream=k;function L(u){const s=u;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=L;function m(u,s){return new l(u,s)}i.newWriteableStream=m;class l{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,D.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const t=r.indexOf(e);t>=0&&r.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(u,s){const e=[];let r;for(;(r=u.read())!==null;)e.push(r);return s(e)}i.consumeReadable=f;function I(u,s,e){const r=[];let t;for(;(t=u.read())!==null&&r.length<e;)r.push(t);return t===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return u.read()}}}i.peekReadable=I;function w(u,s){return new Promise((e,r)=>{const t=[];d(u,{onData:n=>{s&&t.push(n)},onError:n=>{s?r(n):e(void 0)},onEnd:()=>{e(s?s(t):void 0)}})})}i.consumeStream=w;function d(u,s){let e=!1;return u.on("error",r=>{e||s.onError(r)}),u.on("end",()=>{e||s.onEnd()}),u.on("data",r=>{e||s.onData(r)}),(0,C.toDisposable)(()=>e=!0)}i.listenStream=d;function S(u,s){return new Promise((e,r)=>{const t=new C.DisposableStore,n=[],o=b=>{if(n.push(b),n.length>s)return t.dispose(),u.pause(),e({stream:u,buffer:n,ended:!1})},p=b=>r(b),E=()=>e({stream:u,buffer:n,ended:!0});t.add((0,C.toDisposable)(()=>u.removeListener("error",p))),u.on("error",p),t.add((0,C.toDisposable)(()=>u.removeListener("end",E))),u.on("end",E),t.add((0,C.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}i.peekStream=S;function g(u,s){const e=m(s);return e.end(u),e}i.toStream=g;function y(){const u=m(()=>{throw new Error("not supported")});return u.end(),u}i.emptyStream=y;function v(u){let s=!1;return{read:()=>s?null:(s=!0,u)}}i.toReadable=v;function a(u,s,e){const r=m(e);return d(u,{onData:t=>r.write(s.data(t)),onError:t=>r.error(s.error?s.error(t):t),onEnd:()=>r.end()}),r}i.transform=a;function c(u,s,e){let r=!1;return{read:()=>{const t=s.read();return r?t:(r=!0,t!==null?e([u,t]):u)}}}i.prefixedReadable=c;function h(u,s,e){let r=!1;const t=m(e);return d(s,{onData:n=>r?t.write(n):(r=!0,t.write(e([u,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(u)),t.end()}}),t}i.prefixedStream=h}),define(Q[15],Z([0,1,43]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const C=typeof Buffer<"u";let P,k;class L{static alloc(b){return C?new L(Buffer.allocUnsafe(b)):new L(new Uint8Array(b))}static wrap(b){return C&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new L(b)}static fromString(b,R){return!(R?.dontUseNodeBuffer||!1)&&C?new L(Buffer.from(b)):(P||(P=new TextEncoder),new L(P.encode(b)))}static fromByteArray(b){const R=L.alloc(b.length);for(let j=0,_=b.length;j<_;j++)R.buffer[j]=b[j];return R}static concat(b,R){if(typeof R>"u"){R=0;for(let J=0,H=b.length;J<H;J++)R+=b[J].byteLength}const j=L.alloc(R);let _=0;for(let J=0,H=b.length;J<H;J++){const ne=b[J];j.set(ne,_),_+=ne.byteLength}return j}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=L.alloc(this.byteLength);return b.set(this),b}toString(){return C?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(b,R){return new L(this.buffer.subarray(b,R))}set(b,R){if(b instanceof L)this.buffer.set(b.buffer,R);else if(b instanceof Uint8Array)this.buffer.set(b,R);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),R);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return f(this.buffer,b)}writeUInt32BE(b,R){I(this.buffer,b,R)}readUInt32LE(b){return w(this.buffer,b)}writeUInt32LE(b,R){d(this.buffer,b,R)}readUInt8(b){return S(this.buffer,b)}writeUInt8(b,R){g(this.buffer,b,R)}}i.VSBuffer=L;function m(E,b){return E[b+0]<<0>>>0|E[b+1]<<8>>>0}i.readUInt16LE=m;function l(E,b,R){E[R+0]=b&255,b=b>>>8,E[R+1]=b&255}i.writeUInt16LE=l;function f(E,b){return E[b]*2**24+E[b+1]*2**16+E[b+2]*2**8+E[b+3]}i.readUInt32BE=f;function I(E,b,R){E[R+3]=b,b=b>>>8,E[R+2]=b,b=b>>>8,E[R+1]=b,b=b>>>8,E[R]=b}i.writeUInt32BE=I;function w(E,b){return E[b+0]<<0>>>0|E[b+1]<<8>>>0|E[b+2]<<16>>>0|E[b+3]<<24>>>0}i.readUInt32LE=w;function d(E,b,R){E[R+0]=b&255,b=b>>>8,E[R+1]=b&255,b=b>>>8,E[R+2]=b&255,b=b>>>8,E[R+3]=b&255}i.writeUInt32LE=d;function S(E,b){return E[b]}i.readUInt8=S;function g(E,b,R){E[R]=b}i.writeUInt8=g;function y(E){return D.consumeReadable(E,b=>L.concat(b))}i.readableToBuffer=y;function v(E){return D.toReadable(E)}i.bufferToReadable=v;function a(E){return D.consumeStream(E,b=>L.concat(b))}i.streamToBuffer=a;async function c(E){return E.ended?L.concat(E.buffer):L.concat([...E.buffer,await a(E.stream)])}i.bufferedStreamToBuffer=c;function h(E){return D.toStream(E,b=>L.concat(b))}i.bufferToStream=h;function u(E){return D.transform(E,{data:b=>typeof b=="string"?L.fromString(b):L.wrap(b)},b=>L.concat(b))}i.streamToBufferReadableStream=u;function s(E){return D.newWriteableStream(b=>L.concat(b),E)}i.newWriteableBufferStream=s;function e(E,b){return D.prefixedReadable(E,b,R=>L.concat(R))}i.prefixedBufferReadable=e;function r(E,b){return D.prefixedStream(E,b,R=>L.concat(R))}i.prefixedBufferStream=r;function t(E){let b=0,R=0,j=0;const _=new Uint8Array(Math.floor(E.length/4*3)),J=ne=>{switch(R){case 3:_[j++]=b|ne,R=0;break;case 2:_[j++]=b|ne>>>2,b=ne<<6,R=3;break;case 1:_[j++]=b|ne>>>4,b=ne<<4,R=2;break;default:b=ne<<2,R=1}};for(let ne=0;ne<E.length;ne++){const re=E.charCodeAt(ne);if(re>=65&&re<=90)J(re-65);else if(re>=97&&re<=122)J(re-97+26);else if(re>=48&&re<=57)J(re-48+52);else if(re===43||re===45)J(62);else if(re===47||re===95)J(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ne]}`)}}const H=j;for(;R>0;)J(0);return L.wrap(_).slice(0,H)}i.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:E},b=!0,R=!1){const j=R?o:n;let _="";const J=E.byteLength%3;let H=0;for(;H<E.byteLength-J;H+=3){const ne=E[H+0],re=E[H+1],se=E[H+2];_+=j[ne>>>2],_+=j[(ne<<4|re>>>4)&63],_+=j[(re<<2|se>>>6)&63],_+=j[se&63]}if(J===1){const ne=E[H+0];_+=j[ne>>>2],_+=j[ne<<4&63],b&&(_+="==")}else if(J===2){const ne=E[H+0],re=E[H+1];_+=j[ne>>>2],_+=j[(ne<<4|re>>>4)&63],_+=j[re<<2&63],b&&(_+="=")}return _}i.encodeBase64=p}),define(Q[26],Z([0,1,5]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createProxyObject=i.getAllMethodNames=i.getAllPropertyNames=i.filter=i.getCaseInsensitive=i.distinct=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function C(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const c=Array.isArray(a)?[]:{};return Object.keys(a).forEach(h=>{a[h]&&typeof a[h]=="object"?c[h]=C(a[h]):c[h]=a[h]}),c}i.deepClone=C;function P(a){if(!a||typeof a!="object")return a;const c=[a];for(;c.length>0;){const h=c.shift();Object.freeze(h);for(const u in h)if(k.call(h,u)){const s=h[u];typeof s=="object"&&!Object.isFrozen(s)&&!(0,D.isTypedArray)(s)&&c.push(s)}}return a}i.deepFreeze=P;const k=Object.prototype.hasOwnProperty;function L(a,c){return m(a,c,new Set)}i.cloneAndChange=L;function m(a,c,h){if((0,D.isUndefinedOrNull)(a))return a;const u=c(a);if(typeof u<"u")return u;if(Array.isArray(a)){const s=[];for(const e of a)s.push(m(e,c,h));return s}if((0,D.isObject)(a)){if(h.has(a))throw new Error("Cannot clone recursive data-structure");h.add(a);const s={};for(const e in a)k.call(a,e)&&(s[e]=m(a[e],c,h));return h.delete(a),s}return a}function l(a,c,h=!0){return(0,D.isObject)(a)?((0,D.isObject)(c)&&Object.keys(c).forEach(u=>{u in a?h&&((0,D.isObject)(a[u])&&(0,D.isObject)(c[u])?l(a[u],c[u],h):a[u]=c[u]):a[u]=c[u]}),a):c}i.mixin=l;function f(a,c){if(a===c)return!0;if(a==null||c===null||c===void 0||typeof a!=typeof c||typeof a!="object"||Array.isArray(a)!==Array.isArray(c))return!1;let h,u;if(Array.isArray(a)){if(a.length!==c.length)return!1;for(h=0;h<a.length;h++)if(!f(a[h],c[h]))return!1}else{const s=[];for(u in a)s.push(u);s.sort();const e=[];for(u in c)e.push(u);if(e.sort(),!f(s,e))return!1;for(h=0;h<s.length;h++)if(!f(a[s[h]],c[s[h]]))return!1}return!0}i.equals=f;function I(a){const c=new Set;return JSON.stringify(a,(h,u)=>{if((0,D.isObject)(u)||Array.isArray(u)){if(c.has(u))return"[Circular]";c.add(u)}return u})}i.safeStringify=I;function w(a,c){const h=Object.create(null);return!a||!c||Object.keys(c).forEach(s=>{const e=a[s],r=c[s];f(e,r)||(h[s]=r)}),h}i.distinct=w;function d(a,c){const h=c.toLowerCase(),u=Object.keys(a).find(s=>s.toLowerCase()===h);return u?a[u]:a[c]}i.getCaseInsensitive=d;function S(a,c){const h=Object.create(null);for(const[u,s]of Object.entries(a))c(u,s)&&(h[u]=s);return h}i.filter=S;function g(a){let c=[],h=Object.getPrototypeOf(a);for(;Object.prototype!==h;)c=c.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return c}i.getAllPropertyNames=g;function y(a){const c=[];for(const h of g(a))typeof a[h]=="function"&&c.push(h);return c}i.getAllMethodNames=y;function v(a,c){const h=s=>function(){const e=Array.prototype.slice.call(arguments,0);return c(s,e)},u={};for(const s of a)u[s]=h(s);return u}i.createProxyObject=v}),define(Q[30],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(P){return D.test(P)}i.isUUID=C,i.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(m){for(let l=0;l<m.length;l++)m[l]=Math.floor(Math.random()*256);return m};const k=new Uint8Array(16),L=[];for(let m=0;m<256;m++)L.push(m.toString(16).padStart(2,"0"));return function(){P(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let l=0,f="";return f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+="-",f+=L[k[l++]],f+=L[k[l++]],f+="-",f+=L[k[l++]],f+=L[k[l++]],f+="-",f+=L[k[l++]],f+=L[k[l++]],f+="-",f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f+=L[k[l++]],f}}()}),define(Q[70],Z([6,7]),function(B,i){return B.create("vs/base/common/date",i)}),define(Q[71],Z([0,1,70]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const C=60,P=C*60,k=P*24,L=k*7,m=k*30,l=k*365;function f(w,d,S){typeof w!="number"&&(w=w.getTime());const g=Math.round((new Date().getTime()-w)/1e3);if(g<-30)return(0,D.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(g<30)return(0,D.localize)(1,null);let y;return g<C?(y=g,d?y===1?S?(0,D.localize)(2,null,y):(0,D.localize)(3,null,y):S?(0,D.localize)(4,null,y):(0,D.localize)(5,null,y):y===1?S?(0,D.localize)(6,null,y):(0,D.localize)(7,null,y):S?(0,D.localize)(8,null,y):(0,D.localize)(9,null,y)):g<P?(y=Math.floor(g/C),d?y===1?S?(0,D.localize)(10,null,y):(0,D.localize)(11,null,y):S?(0,D.localize)(12,null,y):(0,D.localize)(13,null,y):y===1?S?(0,D.localize)(14,null,y):(0,D.localize)(15,null,y):S?(0,D.localize)(16,null,y):(0,D.localize)(17,null,y)):g<k?(y=Math.floor(g/P),d?y===1?S?(0,D.localize)(18,null,y):(0,D.localize)(19,null,y):S?(0,D.localize)(20,null,y):(0,D.localize)(21,null,y):y===1?S?(0,D.localize)(22,null,y):(0,D.localize)(23,null,y):S?(0,D.localize)(24,null,y):(0,D.localize)(25,null,y)):g<L?(y=Math.floor(g/k),d?y===1?(0,D.localize)(26,null,y):(0,D.localize)(27,null,y):y===1?(0,D.localize)(28,null,y):(0,D.localize)(29,null,y)):g<m?(y=Math.floor(g/L),d?y===1?S?(0,D.localize)(30,null,y):(0,D.localize)(31,null,y):S?(0,D.localize)(32,null,y):(0,D.localize)(33,null,y):y===1?S?(0,D.localize)(34,null,y):(0,D.localize)(35,null,y):S?(0,D.localize)(36,null,y):(0,D.localize)(37,null,y)):g<l?(y=Math.floor(g/m),d?y===1?S?(0,D.localize)(38,null,y):(0,D.localize)(39,null,y):S?(0,D.localize)(40,null,y):(0,D.localize)(41,null,y):y===1?S?(0,D.localize)(42,null,y):(0,D.localize)(43,null,y):S?(0,D.localize)(44,null,y):(0,D.localize)(45,null,y)):(y=Math.floor(g/l),d?y===1?S?(0,D.localize)(46,null,y):(0,D.localize)(47,null,y):S?(0,D.localize)(48,null,y):(0,D.localize)(49,null,y):y===1?S?(0,D.localize)(50,null,y):(0,D.localize)(51,null,y):S?(0,D.localize)(52,null,y):(0,D.localize)(53,null,y))}i.fromNow=f;function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=I}),define(Q[72],Z([6,7]),function(B,i){return B.create("vs/base/common/errorMessage",i)}),define(Q[31],Z([0,1,19,5,72]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function k(w,d){return d&&(w.stack||w.stacktrace)?P.localize(0,null,m(w),L(w.stack)||L(w.stacktrace)):m(w)}function L(w){return Array.isArray(w)?w.join(`
`):w}function m(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?P.localize(1,null,w.message):w.message||P.localize(2,null)}function l(w=null,d=!1){if(!w)return P.localize(3,null);if(Array.isArray(w)){const S=D.coalesce(w),g=l(S[0],d);return S.length>1?P.localize(4,null,g,S.length):g}if(C.isString(w))return w;if(w.detail){const S=w.detail;if(S.error)return k(S.error,d);if(S.exception)return k(S.exception,d)}return w.stack?k(w,d):w.message?w.message:P.localize(5,null)}i.toErrorMessage=l;function f(w){const d=w;return d instanceof Error&&Array.isArray(d.actions)}i.isErrorWithActions=f;function I(w,d){let S;return typeof w=="string"?S=new Error(w):S=w,S.actions=d,S}i.createErrorWithActions=I}),define(Q[73],Z([6,7]),function(B,i){return B.create("vs/base/common/jsonErrorMessages",i)}),define(Q[74],Z([0,1,73]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function C(P){switch(P){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}i.getParseErrorMessage=C}),define(Q[51],Z([0,1,13]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var C;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(C=i.Source||(i.Source={}));var P;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(P=i.TerminateResponseCode||(i.TerminateResponseCode={}));function k(m,...l){const f=l.reduce((d,S)=>(d[S]=!0,d),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(m).filter(d=>!f[d]).forEach(d=>{for(let S=0;S<I.length;S++)if(d.search(I[S])!==-1){delete m[d];break}})}i.sanitizeProcessEnvironment=k;function L(m){!m||(delete m.DEBUG,D.isMacintosh&&delete m.DYLD_LIBRARY_PATH,D.isLinux&&delete m.LD_PRELOAD)}i.removeDangerousEnvVariables=L}),define(Q[52],Z([0,1,4,2]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const P=L=>({onDidChange:D.Event.None,value:L});i.staticObservableValue=P;class k extends C.Disposable{get value(){return this._value}set value(m){m!==this._value&&(this._value=m,this.changeEmitter.fire(m))}constructor(m){super(),this._value=m,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}i.MutableObservableValue=k}),define(Q[53],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function C(a){return P(a,0)}i.hash=C;function P(a,c){switch(typeof a){case"object":return a===null?k(349,c):Array.isArray(a)?l(a,c):f(a,c);case"string":return m(a,c);case"boolean":return L(a,c);case"number":return k(a,c);case"undefined":return k(937,c);default:return k(617,c)}}i.doHash=P;function k(a,c){return(c<<5)-c+a|0}i.numberHash=k;function L(a,c){return k(a?433:863,c)}function m(a,c){c=k(149417,c);for(let h=0,u=a.length;h<u;h++)c=k(a.charCodeAt(h),c);return c}i.stringHash=m;function l(a,c){return c=k(104579,c),a.reduce((h,u)=>P(u,h),c)}function f(a,c){return c=k(181387,c),Object.keys(a).sort().reduce((h,u)=>(h=m(u,h),P(a[u],h)),c)}class I{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=P(c,this._value),this._value}}i.Hasher=I;var w;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function d(a,c,h=32){const u=h-c,s=~((1<<u)-1);return(a<<c|(s&a)>>>u)>>>0}function S(a,c=0,h=a.byteLength,u=0){for(let s=0;s<h;s++)a[c+s]=u}function g(a,c,h="0"){for(;a.length<c;)a=h+a;return a}function y(a,c=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(h=>h.toString(16).padStart(2,"0")).join(""):g((a>>>0).toString(16),c/4)}i.toHexString=y;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const h=c.length;if(h===0)return;const u=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,r,t;for(e!==0?(r=e,t=-1,e=0):(r=c.charCodeAt(0),t=0);;){let n=r;if(D.isHighSurrogate(r))if(t+1<h){const o=c.charCodeAt(t+1);D.isLowSurrogate(o)?(t++,n=D.computeCodePoint(r,o)):n=65533}else{e=r;break}else D.isLowSurrogate(r)&&(n=65533);if(s=this._push(u,s,n),t++,t<h)r=c.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(c,h,u){return u<128?c[h++]=u:u<2048?(c[h++]=192|(u&1984)>>>6,c[h++]=128|(u&63)>>>0):u<65536?(c[h++]=224|(u&61440)>>>12,c[h++]=128|(u&4032)>>>6,c[h++]=128|(u&63)>>>0):(c[h++]=240|(u&1835008)>>>18,c[h++]=128|(u&258048)>>>12,c[h++]=128|(u&4032)>>>6,c[h++]=128|(u&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=v._bigBlock32,h=this._buffDV;for(let E=0;E<64;E+=4)c.setUint32(E,h.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)c.setUint32(E,d(c.getUint32(E-12,!1)^c.getUint32(E-32,!1)^c.getUint32(E-56,!1)^c.getUint32(E-64,!1),1),!1);let u=this._h0,s=this._h1,e=this._h2,r=this._h3,t=this._h4,n,o,p;for(let E=0;E<80;E++)E<20?(n=s&e|~s&r,o=1518500249):E<40?(n=s^e^r,o=1859775393):E<60?(n=s&e|s&r|e&r,o=2400959708):(n=s^e^r,o=3395469782),p=d(u,5)+n+t+o+c.getUint32(E*4,!1)&4294967295,t=r,r=e,e=d(s,30),s=u,u=p;this._h0=this._h0+u&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+t&4294967295}}i.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var C;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(C||(C={})),function(P){const k="error",L="warning",m="warn",l="info",f="ignore";function I(d){return d?D.equalsIgnoreCase(k,d)?P.Error:D.equalsIgnoreCase(L,d)||D.equalsIgnoreCase(m,d)?P.Warning:D.equalsIgnoreCase(l,d)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function w(d){switch(d){case P.Error:return k;case P.Warning:return L;case P.Info:return l;default:return f}}P.toString=w}(C||(C={})),i.default=C}),define(Q[75],Z([0,1,10]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function C(f){const I=f;return I&&typeof I.type=="string"&&typeof I.severity=="string"}i.isRemoteConsoleLog=C;function P(f){const I=[];let w;try{const d=JSON.parse(f.arguments),S=d[d.length-1];S&&S.__$stack&&(d.pop(),w=S.__$stack),I.push(...d)}catch{I.push("Unable to log remote console arguments",f.arguments)}return{args:I,stack:w}}i.parse=P;function k(f){if(typeof f!="string")return k(P(f).stack);const I=f;if(I){const w=L(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}i.getFirstFrame=k;function L(f){if(!f)return f;const I=f.indexOf(`
`);return I===-1?f:f.substring(0,I)}function m(f,I){const{args:w,stack:d}=P(f),S=typeof w[0]=="string"&&w.length===1;let g=L(d);g&&(g=`(${g.trim()})`);let y=[];if(typeof w[0]=="string"?g&&S?y=[`%c[${I}] %c${w[0]} %c${g}`,l("blue"),l(""),l("grey")]:y=[`%c[${I}] %c${w[0]}`,l("blue"),l(""),...w.slice(1)]:y=[`%c[${I}]%`,l("blue"),...w],g&&!S&&y.push(g),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,y)}i.log=m;function l(f){return`color: ${f}`}}),define(Q[44],Z([0,1,15,27,10]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function k(f){return JSON.stringify(f,m)}i.stringify=k;function L(f){let I=JSON.parse(f);return I=l(I),I}i.parse=L;function m(f,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,C.regExpFlags)(I)}:I}function l(f,I=0){if(!f||I>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return P.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 14:return new Date(f.source)}if(f instanceof D.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let w=0;w<f.length;++w)f[w]=l(f[w],I+1);else for(const w in f)Object.hasOwnProperty.call(f,w)&&(f[w]=l(f[w],I+1))}return f}i.revive=l}),define(Q[76],Z([0,1,38,14,20]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,m=/^Microsoft.PowerShellPreview_.*/;var l;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(l||(l={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class w{constructor(s,e,r){this.exePath=s,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:u=!1}={}){return u?f===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:u=!1,findPreview:s=!1}={}){const e=d({useAlternateBitness:u});if(!e)return null;const r=C.join(e,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const E of await P.Promises.readdir(r)){let b=-1;if(s){const j=E.indexOf("-");if(j<0)continue;const _=E.substring(0,j);if(!k.test(_)||E.substring(j+1)!=="preview")continue;b=parseInt(_,10)}else{if(!k.test(E))continue;b=parseInt(E,10)}if(b<=t)continue;const R=C.join(r,E,"pwsh.exe");!await P.SymlinkSupport.existsFile(R)||(n=R,t=b)}if(!n)return null;const o=e.includes("x86")?" (x86)":"",p=s?" Preview":"";return new w(n,`PowerShell${p}${o}`,!0)}async function g({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const s=C.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=u?{pwshMsixDirRegex:m,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await P.Promises.readdir(s))if(e.test(t)){const n=C.join(s,t,"pwsh.exe");return new w(n,r)}return null}function y(){const u=C.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(u,".NET Core PowerShell Global Tool")}function v(){const u=C.join(process.env.windir,f===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(u,"Windows PowerShell",!0)}async function*a(){let u=await S();u&&(yield u),u=await S({useAlternateBitness:!0}),u&&(yield u),u=await g(),u&&(yield u),u=y(),u&&(yield u),u=await S({findPreview:!0}),u&&(yield u),u=await g({findPreview:!0}),u&&(yield u),u=await S({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=v(),u&&(yield u)}async function*c(){for await(const u of a())await u.exists()&&(yield u)}i.enumeratePowerShellInstallations=c;async function h(){for await(const u of c())return u;return null}i.getFirstAvailablePowerShellInstallation=h}),define(Q[55],Z([0,1,14,13,32,51,5,20]),function(B,i,D,C,P,k,L,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function l(w=P.env){return w.comspec||"cmd.exe"}i.getWindowsShell=l;function f(w){let d=[],S=!1;const g=function(y){if(S){d.push(y);return}(!w.send(y,a=>{if(a&&console.error(a),S=!1,d.length>0){const c=d.slice(0);d=[],c.forEach(h=>g(h))}})||C.isWindows)&&(S=!0)};return{send:g}}i.createQueuedSender=f;var I;(function(w){async function d(S,g,y){if(D.isAbsolute(S))return S;if(g===void 0&&(g=P.cwd()),D.dirname(S)!=="."||(y===void 0&&L.isString(P.env.PATH)&&(y=P.env.PATH.split(D.delimiter)),y===void 0||y.length===0))return D.join(g,S);async function a(c){if(await m.Promises.exists(c)){let h;try{h=await m.Promises.stat(c)}catch(u){u.message.startsWith("EACCES")&&(h=await m.Promises.lstat(c))}return h?!h.isDirectory():!1}return!1}for(const c of y){let h;if(D.isAbsolute(c)?h=D.join(c,S):h=D.join(g,c,S),await a(h))return h;let u=h+".com";if(await a(u)||(u=h+".exe",await a(u)))return u}return D.join(g,S)}w.findExecutable=d})(I=i.win32||(i.win32={}))}),define(Q[77],Z([0,1,38,13,76,55]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function L(S,g){return S===1?C.isWindows?w():k.getWindowsShell(g):f(S,g)}i.getSystemShell=L;function m(S,g){return S===1?C.isWindows?d(g):k.getWindowsShell(g):f(S,g)}i.getSystemShellSync=m;let l=null;function f(S,g){if(C.isLinux&&S===2||C.isMacintosh&&S===3)return"/bin/bash";if(!l){let y;if(C.isWindows)y="/bin/bash";else{if(y=g.SHELL,!y)try{y=(0,D.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}l=y}return l}let I=null;async function w(){return I||(I=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),I}function d(S){if(I)return I;const g=C.isWindows&&parseFloat((0,D.release)())>=10,y=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${S.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?v:k.getWindowsShell(S)}});var ge=this&&this.__decorate||function(B,i,D,C){var P=arguments.length,k=P<3?i:C===null?C=Object.getOwnPropertyDescriptor(i,D):C,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(B,i,D,C);else for(var m=B.length-1;m>=0;m--)(L=B[m])&&(k=(P<3?L(k):P>3?L(i,D,k):L(i,D))||k);return P>3&&k&&Object.defineProperty(i,D,k),k};define(Q[56],Z([0,1,19,3,15,24,49,11,4,2,44,27,5]),function(B,i,D,C,P,k,L,m,l,f,I,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var S;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(S=i.RequestType||(i.RequestType={}));function g(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(y=i.ResponseType||(i.ResponseType={}));function v(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(a||(a={}));class c{constructor(F){this.buffer=F,this.pos=0}read(F){const z=this.buffer.slice(this.pos,this.pos+F);return this.pos+=z.byteLength,z}}class h{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var u;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(u||(u={}));function s(N){const F=P.VSBuffer.alloc(4);return F.writeUInt32BE(N,0),F}function e(N){return N.read(4).readUInt32BE(0)}function r(N){const F=P.VSBuffer.alloc(1);return F.writeUInt8(N,0),F}const t={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object)},n=typeof Buffer<"u";function o(N,F){if(typeof F>"u")N.write(t.Undefined);else if(typeof F=="string"){const z=P.VSBuffer.fromString(F);N.write(t.String),N.write(s(z.byteLength)),N.write(z)}else if(n&&Buffer.isBuffer(F)){const z=P.VSBuffer.wrap(F);N.write(t.Buffer),N.write(s(z.byteLength)),N.write(z)}else if(F instanceof P.VSBuffer)N.write(t.VSBuffer),N.write(s(F.byteLength)),N.write(F);else if(Array.isArray(F)){N.write(t.Array),N.write(s(F.length));for(const z of F)o(N,z)}else{const z=P.VSBuffer.fromString(JSON.stringify(F));N.write(t.Object),N.write(s(z.byteLength)),N.write(z)}}function p(N){switch(N.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return N.read(e(N)).toString();case u.Buffer:return N.read(e(N)).buffer;case u.VSBuffer:return N.read(e(N));case u.Array:{const z=e(N),$=[];for(let Y=0;Y<z;Y++)$.push(p(N));return $}case u.Object:return JSON.parse(N.read(e(N)).toString())}}class E{constructor(F,z,$=null,Y=1e3){this.protocol=F,this.ctx=z,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(F,z){this.channels.set(F,z),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const z=this.send([F.type]);this.logger?.logOutgoing(z,0,1,v(F.type));return}case 201:case 202:case 204:case 203:{const z=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(z,F.id,1,v(F.type),F.data);return}}}send(F,z=void 0){const $=new h;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const z=new c(F),$=p(z),Y=p(z),A=$[0];switch(A){case 100:return this.logger?.logIncoming(F.byteLength,$[1],1,`${g(A)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger?.logIncoming(F.byteLength,$[1],1,`${g(A)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger?.logIncoming(F.byteLength,$[1],1,`${g(A)}`),this.disposeActiveRequest({type:A,id:$[1]});case 103:return this.logger?.logIncoming(F.byteLength,$[1],1,`${g(A)}`),this.disposeActiveRequest({type:A,id:$[1]})}}onPromise(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=new k.CancellationTokenSource;let Y;try{Y=z.call(this.ctx,F.name,F.arg,$.token)}catch(T){Y=Promise.reject(T)}const A=F.id;Y.then(T=>{this.sendResponse({id:A,data:T,type:201}),this.activeRequests.delete(F.id)},T=>{T instanceof Error?this.sendResponse({id:A,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.sendResponse({id:A,data:T,type:203}),this.activeRequests.delete(F.id)});const U=(0,f.toDisposable)(()=>$.cancel());this.activeRequests.set(F.id,U)}onEventListen(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=F.id,A=z.listen(this.ctx,F.name,F.arg)(U=>this.sendResponse({id:$,data:U,type:204}));this.activeRequests.set(F.id,A)}disposeActiveRequest(F){const z=this.activeRequests.get(F.id);z&&(z.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let z=this.pendingRequests.get(F.channelName);z||(z=[],this.pendingRequests.set(F.channelName,z));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const z=this.pendingRequests.get(F);if(z){for(const $ of z)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=E;var b;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(b=i.RequestInitiator||(i.RequestInitiator={}));class R{constructor(F,z=null){this.protocol=F,this.isDisposed=!1,this.state=a.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=z}getChannel(F){const z=this;return{call($,Y,A){return z.isDisposed?Promise.reject(new m.CancellationError):z.requestPromise(F,$,Y,A)},listen($,Y){return z.isDisposed?l.Event.None:z.requestEvent(F,$,Y)}}}requestPromise(F,z,$,Y=k.CancellationToken.None){const A=this.lastRequestId++,T={id:A,type:100,channelName:F,name:z,arg:$};if(Y.isCancellationRequested)return Promise.reject(new m.CancellationError);let O;return new Promise((W,q)=>{if(Y.isCancellationRequested)return q(new m.CancellationError);const K=()=>{const Se=te=>{switch(te.type){case 201:this.handlers.delete(A),W(te.data);break;case 202:{this.handlers.delete(A);const oe=new Error(te.data.message);oe.stack=te.data.stack,oe.name=te.data.name,q(oe);break}case 203:this.handlers.delete(A),q(te.data);break}};this.handlers.set(A,Se),this.sendRequest(T)};let ae=null;this.state===a.Idle?K():(ae=(0,C.createCancelablePromise)(Se=>this.whenInitialized()),ae.then(()=>{ae=null,K()}));const ce=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:A,type:101}),q(new m.CancellationError)},pe=Y.onCancellationRequested(ce);O=(0,f.combinedDisposable)((0,f.toDisposable)(ce),pe),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(F,z,$){const Y=this.lastRequestId++,U={id:Y,type:102,channelName:F,name:z,arg:$};let T=null;const O=new l.Emitter({onFirstListenerAdd:()=>{T=(0,C.createCancelablePromise)(W=>this.whenInitialized()),T.then(()=>{T=null,this.activeRequests.add(O),this.sendRequest(U)})},onLastListenerRemove:()=>{T?(T.cancel(),T=null):(this.activeRequests.delete(O),this.sendRequest({id:Y,type:103}))}}),M=W=>O.fire(W.data);return this.handlers.set(Y,M),O.event}sendRequest(F){switch(F.type){case 100:case 102:{const z=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(z,F.id,0,`${g(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const z=this.send([F.type,F.id]);this.logger?.logOutgoing(z,F.id,0,g(F.type));return}}}send(F,z=void 0){const $=new h;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const z=new c(F),$=p(z),Y=p(z),A=$[0];switch(A){case 200:return this.logger?.logIncoming(F.byteLength,0,0,v(A)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,$[1],0,v(A),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(F){if(F.type===200){this.state=a.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([L.memoize],R.prototype,"onDidInitializePromise",null),i.ChannelClient=R;class j{get connections(){const F=[];return this._connections.forEach(z=>F.push(z)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:z,onDidClientDisconnect:$})=>{l.Event.once(z.onMessage)(A=>{const U=new c(A),T=p(U),O=new E(z,T),M=new R(z);this.channels.forEach((q,K)=>O.registerChannel(K,q));const W={channelServer:O,channelClient:M,ctx:T};this._connections.add(W),this._onDidAddConnection.fire(W),$(()=>{O.dispose(),M.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}getChannel(F,z){const $=this;return{call(Y,A,U){let T;if((0,d.isFunction)(z)){const M=(0,D.getRandomElement)($.connections.filter(z));T=M?Promise.resolve(M):l.Event.toPromise(l.Event.filter($.onDidAddConnection,z))}else T=z.routeCall($,Y,A);const O=T.then(M=>M.channelClient.getChannel(F));return J(O).call(Y,A,U)},listen(Y,A){if((0,d.isFunction)(z))return $.getMulticastEvent(F,z,Y,A);const U=z.routeEvent($,Y,A).then(T=>T.channelClient.getChannel(F));return J(U).listen(Y,A)}}}getMulticastEvent(F,z,$,Y){const A=this;let U=new f.DisposableStore;const T=new l.Emitter({onFirstListenerAdd:()=>{U=new f.DisposableStore;const O=new l.EventMultiplexer,M=new Map,W=K=>{const ce=K.channelClient.getChannel(F).listen($,Y),pe=O.add(ce);M.set(K,pe)},q=K=>{const ae=M.get(K);!ae||(ae.dispose(),M.delete(K))};A.connections.filter(z).forEach(W),l.Event.filter(A.onDidAddConnection,z)(W,void 0,U),A.onDidRemoveConnection(q,void 0,U),O.event(T.fire,T,U),U.add(O)},onLastListenerRemove:()=>{U.dispose()}});return T.event}registerChannel(F,z){this.channels.set(F,z),this._connections.forEach($=>{$.channelServer.registerChannel(F,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=j;class _{constructor(F,z,$=null){const Y=new h;o(Y,z),F.send(Y.buffer),this.channelClient=new R(F,$),this.channelServer=new E(F,z,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,z){this.channelServer.registerChannel(F,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=_;function J(N){return{call(F,z,$){return N.then(Y=>Y.call(F,z,$))},listen(F,z){const $=new l.Relay;return N.then(Y=>$.input=Y.listen(F,z)),$.event}}}i.getDelayedChannel=J;function H(N){let F=!1;return{call(z,$,Y){return F?N.call(z,$,Y):(0,C.timeout)(0).then(()=>F=!0).then(()=>N.call(z,$,Y))},listen(z,$){if(F)return N.listen(z,$);const Y=new l.Relay;return(0,C.timeout)(0).then(()=>F=!0).then(()=>Y.input=N.listen(z,$)),Y.event}}}i.getNextTickChannel=H;class ne{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const z of F.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await l.Event.toPromise(F.onDidAddConnection),await this.route(F)}}i.StaticRouter=ne;var re;(function(N){function F(A,U){const T=A,O=U&&U.disableMarshalling,M=new Map;for(const W in T)$(W)&&M.set(W,l.Event.buffer(T[W],!0));return new class{listen(W,q,K){const ae=M.get(q);if(ae)return ae;if(Y(q)){const ce=T[q];if(typeof ce=="function")return ce.call(T,K)}throw new Error(`Event not found: ${q}`)}call(W,q,K){const ae=T[q];if(typeof ae=="function"){if(!O&&Array.isArray(K))for(let ce=0;ce<K.length;ce++)K[ce]=(0,I.revive)(K[ce]);return ae.apply(T,K)}throw new Error(`Method not found: ${q}`)}}}N.fromService=F;function z(A,U){const T=U&&U.disableMarshalling;return new Proxy({},{get(O,M){if(typeof M=="string")return U?.properties?.has(M)?U.properties.get(M):Y(M)?function(W){return A.listen(M,W)}:$(M)?A.listen(M):async function(...W){let q;U&&!(0,d.isUndefinedOrNull)(U.context)?q=[U.context,...W]:q=W;const K=await A.call(M,q);return T?K:(0,I.revive)(K)};throw new Error(`Property not found: ${String(M)}`)}})}N.toService=z;function $(A){return A[0]==="o"&&A[1]==="n"&&w.isUpperAsciiLetter(A.charCodeAt(2))}function Y(A){return/^onDynamic/.test(A)&&w.isUpperAsciiLetter(A.charCodeAt(9))}})(re=i.ProxyChannel||(i.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const F=N.toString();if(F!=="[object Object]")return F}return N}function le(N){return Array.isArray(N)?N.map(fe):fe(N)}function ie(N,F,z,$,Y,A,U){U=le(U);const T=se[Y],O=T[$%T.length];let M=[`%c[${N}]%c[${String(F).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String($).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(A)?(M=M.concat(U),M.push(")")):M.push(U),console.log.apply(console,M)}i.logWithColors=ie;class V{constructor(F,z){this._outgoingPrefix=F,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,z,$,Y,A){this._totalOutgoing+=F,ie(this._outgoingPrefix,this._totalOutgoing,F,z,$,Y,A)}logIncoming(F,z,$,Y,A){this._totalIncoming+=F,ie(this._incomingPrefix,this._totalIncoming,F,z,$,Y,A)}}i.IPCLogger=V}),define(Q[78],Z([0,1,57,3,15,24,75,11,4,2,26,55,51,56]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class g extends S.ChannelServer{constructor(a){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",c=>P.VSBuffer.wrap(Buffer.from(c,"base64")))},a),process.once("disconnect",()=>this.dispose())}}i.Server=g;class y{constructor(a,c){this.modulePath=a,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new C.Delayer(h),this.child=null,this._client=null}getChannel(a){const c=this;return{call(h,u,s){return c.requestPromise(a,h,u,s)},listen(h,u){return c.requestEvent(a,h,u)}}}requestPromise(a,c,h,u=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(a),e=(0,C.createCancelablePromise)(n=>s.call(c,h,n)),r=u.onCancellationRequested(()=>e.cancel()),t=(0,f.toDisposable)(()=>e.cancel());return this.activeRequests.add(t),e.finally(()=>{r.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(a,c,h){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let u;const s=new l.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(a).listen(c,h)(s.fire,s),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const a=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,d.removeDangerousEnvVariables)(c.env),this.child=(0,D.fork)(this.modulePath,a,c);const h=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,L.isRemoteConsoleLog)(o)){(0,L.log)(o,`IPC Library: ${this.options.serverName}`);return}h.fire(P.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),r=h.event,t={send:e,onMessage:r};this._client=new S.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,p)=>{process.removeListener("exit",n),this.activeRequests.forEach(E=>(0,f.dispose)(E)),this.activeRequests.clear(),o!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+p),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:p})})}return this._client}getCachedChannel(a){let c=this.channels.get(a);return c||(c=this.client.getChannel(a),this.channels.set(a,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=y}),define(Q[79],Z([0,1,3,4,2,5]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var L;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=i.StorageHint||(i.StorageHint={}));function m(w){const d=w;return d?.changed instanceof Map||d?.deleted instanceof Set}i.isStorageItemsChangeEvent=m;var l;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(l=i.StorageState||(i.StorageState={}));class f extends P.Disposable{constructor(d,S=Object.create(null)){super(),this.database=d,this.options=S,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((S,g)=>this.accept(g,S)),d.deleted?.forEach(S=>this.accept(S,void 0))}accept(d,S){if(this.state===l.Closed)return;let g=!1;(0,k.isUndefinedOrNull)(S)?g=this.cache.delete(d):this.cache.get(d)!==S&&(this.cache.set(d,S),g=!0),g&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,S){const g=this.cache.get(d);return(0,k.isUndefinedOrNull)(g)?S:g}getBoolean(d,S){const g=this.get(d);return(0,k.isUndefinedOrNull)(g)?S:g==="true"}getNumber(d,S){const g=this.get(d);return(0,k.isUndefinedOrNull)(g)?S:parseInt(g,10)}async set(d,S){if(this.state===l.Closed)return;if((0,k.isUndefinedOrNull)(S))return this.delete(d);const g=String(S);if(this.cache.get(d)!==g)return this.cache.set(d,g),this.pendingInserts.set(d,g),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===l.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert?.forEach((S,g)=>this.items.set(g,S)),d.delete?.forEach(S=>this.items.delete(S))}async close(){}}i.InMemoryStorageDatabase=I}),define(Q[80],Z([6,7]),function(B,i){return B.create("vs/base/node/zip",i)}),define(Q[81],Z([6,7]),function(B,i){return B.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Q[82],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Q[83],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Q[84],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagementCLI",i)}),define(Q[85],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionNls",i)}),define(Q[86],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(Q[87],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Q[88],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Q[89],Z([6,7]),function(B,i){return B.create("vs/platform/extensions/common/extensionValidator",i)}),define(Q[90],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/fileService",i)}),define(Q[91],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/io",i)}),define(Q[92],Z([6,7]),function(B,i){return B.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Q[93],Z([6,7]),function(B,i){return B.create("vs/platform/languagePacks/common/languagePacks",i)}),define(Q[94],Z([6,7]),function(B,i){return B.create("vs/platform/request/common/request",i)}),define(Q[95],Z([6,7]),function(B,i){return B.create("vs/platform/shell/node/shellEnv",i)}),define(Q[96],Z([6,7]),function(B,i){return B.create("vs/platform/telemetry/common/telemetryService",i)}),define(Q[97],Z([6,7]),function(B,i){return B.create("vs/platform/userDataProfile/common/userDataProfile",i)}),define(Q[98],Z([6,7]),function(B,i){return B.create("vs/platform/workspace/common/workspace",i)}),define(Q[99],Z([0,1,71,49,17,14,32,18,10]),function(B,i,D,C,P,k,L,m,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class f{get appRoot(){return(0,k.dirname)(P.FileAccess.asFileUri("",B).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,m.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,m.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return l.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,m.joinPath)(l.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,m.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,m.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,m.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=L.env.VSCODE_PORTABLE;return y?l.URI.file((0,k.join)(y,"argv.json")):(0,m.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,k.resolve)(y):(0,k.normalize)((0,k.join)(P.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,k.resolve)(y):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,k.resolve)(y);const v=L.env.VSCODE_EXTENSIONS;if(v)return v;const a=L.env.VSCODE_PORTABLE;return a?(0,k.join)(a,"extensions"):(0,m.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(v=>/^[^:/?#]+?:\/\//.test(v)?l.URI.parse(v):l.URI.file((0,k.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?l.URI.parse(y):l.URI.file((0,k.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,m.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return l.URI.file((0,k.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=L.env.VSCODE_PORTABLE;return y?l.URI.file((0,k.join)(y,"policy.json")):(0,m.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(y){this.args.continueOn=y}get args(){return this._args}constructor(y,v,a){this._args=y,this.paths=v,this.productService=a,this.editSessionId=this.args.editSessionId}}ge([C.memoize],f.prototype,"appRoot",null),ge([C.memoize],f.prototype,"userHome",null),ge([C.memoize],f.prototype,"userDataPath",null),ge([C.memoize],f.prototype,"appSettingsHome",null),ge([C.memoize],f.prototype,"tmpDir",null),ge([C.memoize],f.prototype,"cacheHome",null),ge([C.memoize],f.prototype,"stateResource",null),ge([C.memoize],f.prototype,"userRoamingDataHome",null),ge([C.memoize],f.prototype,"userDataSyncHome",null),ge([C.memoize],f.prototype,"userDataSyncLogResource",null),ge([C.memoize],f.prototype,"editSessionsLogResource",null),ge([C.memoize],f.prototype,"sync",null),ge([C.memoize],f.prototype,"machineSettingsResource",null),ge([C.memoize],f.prototype,"workspaceStorageHome",null),ge([C.memoize],f.prototype,"localHistoryHome",null),ge([C.memoize],f.prototype,"keyboardLayoutResource",null),ge([C.memoize],f.prototype,"argvResource",null),ge([C.memoize],f.prototype,"isExtensionDevelopment",null),ge([C.memoize],f.prototype,"untitledWorkspacesHome",null),ge([C.memoize],f.prototype,"installSourcePath",null),ge([C.memoize],f.prototype,"builtinExtensionsPath",null),ge([C.memoize],f.prototype,"extensionsPath",null),ge([C.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ge([C.memoize],f.prototype,"extensionDevelopmentKind",null),ge([C.memoize],f.prototype,"extensionTestsLocationURI",null),ge([C.memoize],f.prototype,"debugExtensionHost",null),ge([C.memoize],f.prototype,"serviceMachineIdResource",null),ge([C.memoize],f.prototype,"telemetryLogResource",null),ge([C.memoize],f.prototype,"disableWorkspaceTrust",null),ge([C.memoize],f.prototype,"policyFile",null),i.AbstractNativeEnvironmentService=f;function I(g,y){return S(g["inspect-extensions"],g["inspect-brk-extensions"],5870,y,g.debugId,g.extensionEnvironment)}i.parseExtensionHostPort=I;function w(g,y){return S(g["inspect-search"],g["inspect-brk-search"],5876,y,g.extensionEnvironment)}i.parseSearchPort=w;function d(g,y){return S(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,y,g.extensionEnvironment)}i.parsePtyHostPort=d;function S(g,y,v,a,c,h){const s=Number(y||g)||(a?null:v),e=s?Boolean(!!y):!1;let r;if(h)try{r=JSON.parse(h)}catch{}return{port:s,break:e,debugId:c,env:r}}}),function(){"use strict";function B(i,D,C){function P(L,m){const l=k(L,m),f=[l];return i.isAbsolute(l)||f.unshift(C),i.resolve(...f)}function k(L,m){process.env.VSCODE_DEV&&(m="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return i.join(f,m);const I=L["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=i.join(w,"AppData","Roaming")}break;case"darwin":f=i.join(D.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||i.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(f,m)}return{getUserDataPath:P}}if(typeof define=="function")define(Q[100],Z([149,38,32]),function(i,D,C){return B(i,D,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("path"),D=require("os");module.exports=B(i,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[101],Z([0,1,38,99,100]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class k extends C.AbstractNativeEnvironmentService{constructor(m,l){super(m,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,P.getUserDataPath)(m,l.nameShort)},l)}}i.NativeEnvironmentService=k}),define(Q[102],Z([0,1,5,85]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;function P(L,m,l){try{k(L,m,l)}catch{}return L}i.localizeManifest=P;function k(L,m,l){const f=(I,w,d)=>{const S=I[w];if((0,D.isString)(S)){const g=S,y=g.length;if(y>1&&g[0]==="%"&&g[y-1]==="%"){const v=g.substr(1,y-2);let a=m[v];a===void 0&&l&&(a=l[v]);const c=typeof a=="string"?a:a.message;if(c!==void 0){const h=l?.[v],u=typeof h=="string"?h:h?.message;if(d&&(w==="title"||w==="category")&&u&&u!==c){const s={value:c,original:u};I[w]=s}else I[w]=c}else console.warn(`[${L.name}]: ${(0,C.localize)(0,null,v)}`)}}else if((0,D.isObject)(S))for(const g in S)S.hasOwnProperty(g)&&(g==="commands"?f(S,g,!0):f(S,g,d));else if(Array.isArray(S))for(let g=0;g<S.length;g++)f(S,g,d)};for(const I in L)L.hasOwnProperty(I)&&f(L,I)}}),define(Q[45],Z([0,1,18,54,89,39]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function l(a){return a=a.trim(),a==="*"||L.test(a)}i.isValidVersionStr=l;function f(a){if(!l(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=a.match(L);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}i.parseVersion=f;function I(a){if(!a)return null;const c=a.majorBase,h=a.majorMustEqual,u=a.minorBase;let s=a.minorMustEqual;const e=a.patchBase;let r=a.patchMustEqual;a.hasCaret&&(c===0||(s=!1),r=!1);let t=0;if(a.preRelease){const n=m.exec(a.preRelease);if(n){const[,o,p,E]=n;t=Date.UTC(Number(o),Number(p)-1,Number(E))}}return{majorBase:c,majorMustEqual:h,minorBase:u,minorMustEqual:s,patchBase:e,patchMustEqual:r,isMinimum:a.hasGreaterEquals,notBefore:t}}i.normalizeVersion=I;function w(a,c,h){let u;typeof a=="string"?u=I(f(a)):u=a;let s;c instanceof Date?s=c.getTime():typeof c=="string"&&(s=new Date(c).getTime());let e;if(typeof h=="string"?e=I(f(h)):e=h,!u||!e)return!1;const r=u.majorBase,t=u.minorBase,n=u.patchBase;let o=e.majorBase,p=e.minorBase,E=e.patchBase;const b=e.notBefore;let R=e.majorMustEqual,j=e.minorMustEqual,_=e.patchMustEqual;return e.isMinimum?r>o?!0:r<o?!1:t>p?!0:t<p||s&&s<b?!1:n>=E:(r===1&&o===0&&(!R||!j||!_)&&(o=1,p=0,E=0,R=!0,j=!1,_=!1),r<o?!1:r>o?!R:t<p?!1:t>p?!j:n<E?!1:n>E?!_:!(s&&s<b))}i.isValidVersion=w;function d(a,c,h,u,s){const e=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return e.push([C.default.Error,P.localize(0,null)]),e;if(typeof u.name!="string")return e.push([C.default.Error,P.localize(1,null,"name")]),e;if(typeof u.version!="string")return e.push([C.default.Error,P.localize(2,null,"version")]),e;if(!u.engines)return e.push([C.default.Error,P.localize(3,null,"engines")]),e;if(typeof u.engines.vscode!="string")return e.push([C.default.Error,P.localize(4,null,"engines.vscode")]),e;if(typeof u.extensionDependencies<"u"&&!v(u.extensionDependencies))return e.push([C.default.Error,P.localize(5,null,"extensionDependencies")]),e;if(typeof u.activationEvents<"u"){if(!v(u.activationEvents))return e.push([C.default.Error,P.localize(6,null,"activationEvents")]),e;if(typeof u.main>"u"&&typeof u.browser>"u")return e.push([C.default.Error,P.localize(7,null,"activationEvents","main")]),e}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&e.push([C.default.Warning,P.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return e.push([C.default.Error,P.localize(9,null,"main")]),e;{const n=(0,D.joinPath)(h,u.main);(0,D.isEqualOrParent)(n,h)||e.push([C.default.Warning,P.localize(10,null,n.path,h.path)])}if(typeof u.activationEvents>"u")return e.push([C.default.Error,P.localize(11,null,"activationEvents","main")]),e}if(typeof u.browser<"u"){if(typeof u.browser!="string")return e.push([C.default.Error,P.localize(12,null,"browser")]),e;{const n=(0,D.joinPath)(h,u.browser);(0,D.isEqualOrParent)(n,h)||e.push([C.default.Warning,P.localize(13,null,n.path,h.path)])}if(typeof u.activationEvents>"u")return e.push([C.default.Error,P.localize(14,null,"activationEvents","browser")]),e}if(!k.valid(u.version))return e.push([C.default.Error,P.localize(15,null)]),e;const r=[];if(!S(a,c,u,s,r))for(const n of r)e.push([C.default.Error,n]);return e}i.validateExtensionManifest=d;function S(a,c,h,u,s){return u||typeof h.main>"u"&&typeof h.browser>"u"?!0:y(a,c,h.engines.vscode,s)}i.isValidExtensionVersion=S;function g(a,c,h){return a==="*"||y(c,h,a)}i.isEngineValid=g;function y(a,c,h,u=[]){const s=I(f(h));if(!s)return u.push(P.localize(16,null,h)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return u.push(P.localize(17,null,h)),!1}else if(!s.majorMustEqual)return u.push(P.localize(18,null,h)),!1;return w(a,c,s)?!0:(u.push(P.localize(19,null,a,h)),!1)}function v(a){if(!Array.isArray(a))return!1;for(let c=0,h=a.length;c<h;c++)if(typeof a[c]!="string")return!1;return!0}}),define(Q[103],Z([0,1,15,30]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function P(k,L,m){let l=m&&m.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const I=(await L.readFile(k.serviceMachineIdResource)).value.toString();l=(0,C.isUUID)(I)?I:null}catch{l=null}if(!l){l=(0,C.generateUuid)();try{await L.writeFile(k.serviceMachineIdResource,D.VSBuffer.fromString(l))}catch{}}return m?.store("storage.serviceMachineId",l,-1,1),l}i.getServiceMachineId=P}),define(Q[46],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class D{constructor(P,k=[],L=!1){this.ctor=P,this.staticArguments=k,this.supportsDelayedInstantiation=L}}i.SyncDescriptor=D}),define(Q[104],Z([0,1,46]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=i.InstantiationType=void 0;const C=[];var P;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(P=i.InstantiationType||(i.InstantiationType={}));function k(m,l,f){l instanceof D.SyncDescriptor||(l=new D.SyncDescriptor(l,[],Boolean(f))),C.push([m,l])}i.registerSingleton=k;function L(){return C}i.getSingletonServiceDescriptors=L}),define(Q[105],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class D{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}i.Node=D;class C{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const L of this._nodes.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const m=this.lookupOrInsertNode(k),l=this.lookupOrInsertNode(L);m.outgoing.set(l.key,l),l.incoming.set(m.key,m)}removeNode(k){const L=this._hashFn(k);this._nodes.delete(L);for(const m of this._nodes.values())m.outgoing.delete(L),m.incoming.delete(L)}lookupOrInsertNode(k){const L=this._hashFn(k);let m=this._nodes.get(L);return m||(m=new D(L,k),this._nodes.set(L,m)),m}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[L,m]of this._nodes)k.push(`${L}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this._nodes){const m=new Set([k]),l=this._findCycle(L,m);if(l)return l}}_findCycle(k,L){for(const[m,l]of k.outgoing){if(L.has(m))return[...L,m].join(" -> ");L.add(m);const f=this._findCycle(l,L);if(f)return f;L.delete(m)}}}i.Graph=C}),define(Q[21],Z([0,1,5,10,8]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,P.createDecorator)("configurationService");function k(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof C.URI)}i.isConfigurationOverrides=k;function L(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof C.URI)}i.isConfigurationUpdateOverrides=L;var m;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(m=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}i.ConfigurationTargetToString=l;function f(a,c){const h=Object.create(null);for(const u in a)I(h,u,a[u],c);return h}i.toValuesTree=f;function I(a,c,h,u){const s=c.split("."),e=s.pop();let r=a;for(let t=0;t<s.length;t++){const n=s[t];let o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${c} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[e]=h}catch{u(`Ignoring ${c} as ${s.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${c} as ${s.join(".")} is ${JSON.stringify(r)}`)}i.addToValueTree=I;function w(a,c){const h=c.split(".");d(a,h)}i.removeFromValueTree=w;function d(a,c){const h=c.shift();if(c.length===0){delete a[h];return}if(Object.keys(a).indexOf(h)!==-1){const u=a[h];typeof u=="object"&&!Array.isArray(u)&&(d(u,c),Object.keys(u).length===0&&delete a[h])}}function S(a,c,h){function u(r,t){let n=r;for(const o of t){if(typeof n!="object"||n===null)return;n=n[o]}return n}const s=c.split("."),e=u(a,s);return typeof e>"u"?h:e}i.getConfigurationValue=S;function g(a,c,h){Object.keys(c).forEach(u=>{u!=="__proto__"&&(u in a?D.isObject(a[u])&&D.isObject(c[u])?g(a[u],c[u],h):h&&(a[u]=c[u]):a[u]=c[u])})}i.merge=g;function y(a,c,h){const u=a.inspect(c),s=a.inspect(h);return typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:u.defaultValue}i.getMigratedSettingValue=y;function v(a){return a.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=v}),define(Q[58],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Q[16],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,D.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,D.refineServiceDecorator)(i.IEnvironmentService)}),define(Q[22],Z([0,1,83,8]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function P(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=P;function k(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=k;function L(a,c){switch(a){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=L;function m(a,c){return c==="web"&&!a.includes("web")}i.isNotWebExtensionInWebTargetPlatform=m;function l(a,c,h){return m(c,h)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===h?!0:f(h).includes(a)}i.isTargetPlatformCompatible=l;function f(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=f;function I(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}i.isIExtensionIdentifier=I;var w;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(w=i.SortBy||(i.SortBy={}));var d;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(d=i.SortOrder||(i.SortOrder={}));var S;(function(a){a.Install="install",a.Uninstall="uninstall"})(S=i.StatisticType||(i.StatisticType={}));var g;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(g=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var y;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(y=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class v extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}i.ExtensionManagementError=v,i.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,D.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.PreferencesLabel=(0,D.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"}}),define(Q[59],Z([0,1,15,11,91,12]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function L(I,w,d,S,g,y){let v;try{await m(I,w,d,S,g,y)}catch(a){v=a}finally{v&&g.errorTransformer&&(v=g.errorTransformer(v)),typeof v<"u"&&d.error(v),d.end()}}i.readFileIntoStream=L;async function m(I,w,d,S,g,y){l(y);const v=await I.open(w,{create:!1});try{l(y);let a=0,c=0,h=g&&typeof g.length=="number"?g.length:void 0,u=D.VSBuffer.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),s=g&&typeof g.position=="number"?g.position:0,e=0;do c=await I.read(v,s,u.buffer,e,u.byteLength-e),s+=c,e+=c,a+=c,typeof h=="number"&&(h-=c),e===u.byteLength&&(await d.write(S(u)),u=D.VSBuffer.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),e=0);while(c>0&&(typeof h!="number"||h>0)&&l(y)&&f(a,g));if(e>0){let r=e;typeof h=="number"&&(r=Math.min(e,h)),d.write(S(u.slice(0,r)))}}catch(a){throw(0,k.ensureFileSystemProviderError)(a)}finally{await I.close(v)}}function l(I){if(I.isCancellationRequested)throw(0,C.canceled)();return!0}function f(I,w){if(w?.limits){if(typeof w.limits.memory=="number"&&I>w.limits.memory)throw(0,k.createFileSystemProviderError)((0,P.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&I>w.limits.size)throw(0,k.createFileSystemProviderError)((0,P.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],Z([0,1,4,150,2,13,151]),function(B,i,D,C,P,k,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class m extends P.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(f){const I=this.normalizeRequests(f),w=I.filter(S=>{const g=this.watchers.get(S.path);return g?!(0,C.patternsEquals)(g.request.excludes,S.excludes)||!(0,C.patternsEquals)(g.request.includes,S.includes):!0}),d=Array.from(this.watchers.values()).filter(({request:S})=>!I.find(g=>g.path===S.path&&(0,C.patternsEquals)(g.excludes,S.excludes)&&(0,C.patternsEquals)(g.includes,S.includes))).map(({request:S})=>S.path);w.length&&this.trace(`Request to start watching: ${w.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),d.length&&this.trace(`Request to stop watching: ${d.join(",")}`);for(const S of d)this.stopWatching(S);for(const S of w)this.startWatching(S)}startWatching(f){const I=new L.NodeJSFileWatcherLibrary(f,d=>this._onDidChangeFile.fire(d),d=>this._onDidLogMessage.fire(d),this.verboseLogging),w={request:f,instance:I};this.watchers.set(f.path,w)}async stop(){for(const[f]of this.watchers)this.stopWatching(f);this.watchers.clear()}stopWatching(f){const I=this.watchers.get(f);I&&(this.watchers.delete(f),I.instance.dispose())}normalizeRequests(f){const I=new Map;for(const w of f){const d=k.isLinux?w.path:w.path.toLowerCase();I.set(d,w)}return Array.from(I.values())}async setVerboseLogging(f){this.verboseLogging=f;for(const[,I]of this.watchers)I.instance.setVerboseLogging(f)}trace(f){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(f)})}toMessage(f,I){return I?`[File Watcher (node.js)] ${f} (path: ${I.request.path})`:`[File Watcher (node.js)] ${f}`}}i.NodeJSWatcher=m}),define(Q[107],Z([0,1,60,106]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class P extends D.AbstractNonRecursiveWatcherClient{constructor(L,m,l){super(L,m,l),this.init()}createWatcher(){return new C.NodeJSWatcher}}i.NodeJSWatcherClient=P}),define(Q[108],Z([0,1,17,56,78,60]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class L extends k.AbstractUniversalWatcherClient{constructor(l,f,I){super(l,f,I),this.init()}createWatcher(l){const f=l.add(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(f.onDidProcessExit(({code:I,signal:w})=>this.onError(`terminated by itself with code ${I}, signal: ${w}`))),C.ProxyChannel.toService((0,C.getNextTickChannel)(f.getChannel("watcher")))}}i.UniversalWatcherClient=L}),define(Q[61],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class D{constructor(...P){this._entries=new Map;for(const[k,L]of P)this.set(k,L)}set(P,k){const L=this._entries.get(P);return this._entries.set(P,k),L}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}i.ServiceCollection=D}),define(Q[109],Z([0,1,3,11,2,46,105,8,61,152]),function(B,i,D,C,P,k,L,m,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const I=!1;class w extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class d{constructor(v=new l.ServiceCollection,a=!1,c,h=I){this._services=v,this._strict=a,this._parent=c,this._enableTracing=h,this._activeInstantiations=new Set,this._services.set(m.IInstantiationService,this),this._globalGraph=h?c?._globalGraph??new L.Graph(u=>u):void 0}createChild(v){return new d(v,this._strict,this,this._enableTracing)}invokeFunction(v,...a){const c=g.traceInvocation(this._enableTracing,v);let h=!1;try{return v({get:s=>{if(h)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const e=this._getOrCreateServiceInstance(s,c);if(!e)throw new Error(`[invokeFunction] unknown service '${s}'`);return e}},...a)}finally{h=!0,c.stop()}}createInstance(v,...a){let c,h;return v instanceof k.SyncDescriptor?(c=g.traceCreation(this._enableTracing,v.ctor),h=this._createInstance(v.ctor,v.staticArguments.concat(a),c)):(c=g.traceCreation(this._enableTracing,v),h=this._createInstance(v,a,c)),c.stop(),h}_createInstance(v,a=[],c){const h=m._util.getServiceDependencies(v).sort((e,r)=>e.index-r.index),u=[];for(const e of h){const r=this._getOrCreateServiceInstance(e.id,c);r||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${e.id}.`,!1),u.push(r)}const s=h.length>0?h[0].index:a.length;if(a.length!==s){console.trace(`[createInstance] First service dependency of ${v.name} at position ${s+1} conflicts with ${a.length} static arguments`);const e=s-a.length;e>0?a=a.concat(new Array(e)):a=a.slice(0,s)}return Reflect.construct(v,a.concat(u))}_setServiceInstance(v,a){if(this._services.get(v)instanceof k.SyncDescriptor)this._services.set(v,a);else if(this._parent)this._parent._setServiceInstance(v,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const a=this._services.get(v);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):a}_getOrCreateServiceInstance(v,a){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(v));const c=this._getServiceInstanceOrDescriptor(v);return c instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,c,a.branch(v,!0)):(a.branch(v,!1),c)}_safeCreateAndCacheServiceInstance(v,a,c){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,a,c)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,a,c){const h=new L.Graph(e=>e.id.toString());let u=0;const s=[{id:v,desc:a,_trace:c}];for(;s.length;){const e=s.pop();if(h.lookupOrInsertNode(e),u++>1e3)throw new w(h);for(const r of m._util.getServiceDependencies(e.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(r.id);if(t||this._throwIfStrict(`[createInstance] ${v} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(e.id),String(r.id)),t instanceof k.SyncDescriptor){const n={id:r.id,desc:t,_trace:e._trace.branch(r.id,!0)};h.insertEdge(e,n),s.push(n)}}}for(;;){const e=h.roots();if(e.length===0){if(!h.isEmpty())throw new w(h);break}for(const{data:r}of e){if(this._getServiceInstanceOrDescriptor(r.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,n)}h.removeNode(r)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,a,c=[],h,u){if(this._services.get(v)instanceof k.SyncDescriptor)return this._createServiceInstance(v,a,c,h,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,a,c,h,u);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(v,a,c=[],h,u){if(h){const s=new d(void 0,this._strict,this,this._enableTracing);s._globalGraphImplicitDependency=String(v);const e=new Map,r=new D.IdleValue(()=>{const t=s._createInstance(a,c,u);for(const[n,o]of e){const p=t[n];if(typeof p=="function")for(const E of o)p.apply(t,E)}return e.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let E=e.get(n);return E||(E=new f.LinkedList,e.set(n,E)),(R,j,_)=>{const J=E.push([R,j,_]);return(0,P.toDisposable)(J)}}if(n in t)return t[n];const o=r.value;let p=o[n];return typeof p!="function"||(p=p.bind(o),t[n]=p),p},set(t,n,o){return r.value[n]=o,!0}})}else return this._createInstance(a,c,u)}_throwIfStrict(v,a){if(a&&console.warn(v),this._strict)throw new Error(v)}}i.InstantiationService=d;var S;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(S||(S={}));class g{static traceInvocation(v,a){return v?new g(1,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(v,a){return v?new g(0,a.name):g._None}constructor(v,a){this.type=v,this.name=a,this._start=Date.now(),this._dep=[]}branch(v,a){const c=new g(2,v.toString());return this._dep.push([v,a,c]),c}stop(){const v=Date.now()-this._start;g._totals+=v;let a=!1;function c(u,s){const e=[],r=new Array(u+1).join("	");for(const[t,n,o]of s._dep)if(n&&o){a=!0,e.push(`${r}CREATES -> ${t}`);const p=c(u+1,o);p&&e.push(p)}else e.push(`${r}uses -> ${t}`);return e.join(`
`)}const h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(v>2||a)&&g.all.add(h.join(`
`))}}i.Trace=g,g.all=new Set,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0});var ee=this&&this.__param||function(B,i){return function(D,C){i(D,C,B)}};define(Q[62],Z([0,1,24,2,13,93,22,8]),function(B,i,D,C,P,k,L,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LanguagePackBaseService=i.ILanguagePackService=void 0,i.ILanguagePackService=(0,m.createDecorator)("languagePackService");let l=class extends C.Disposable{constructor(I){super(),this.extensionGalleryService=I}async getAvailableLanguages(){const I=new D.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const S=w.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(y=>y.startsWith("lp-"))).map(g=>{const y=g.properties.localizedLanguages?.[0],v=this.getLocale(g);return{...this.createQuickPickItem(v,y,g),extensionId:g.identifier.id,galleryExtension:g}});return S.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),S}getLocale(I){return I.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(I,w,d){const S=w??I;let g;if(S!==I&&(g=`(${I})`),I.toLowerCase()===P.language.toLowerCase()&&(g??="",g+=(0,k.localize)(0,null)),d?.installCount){g??="";const y=d.installCount;let v;y>1e6?v=`${Math.floor(y/1e5)/10}M`:y>1e3?v=`${Math.floor(y/1e3)}K`:v=String(y),g+=` $(cloud-download) ${v}`}return{id:I,label:S,description:g}}};l=ge([ee(0,L.IExtensionGalleryService)],l),i.LanguagePackBaseService=l}),define(Q[9],Z([0,1,31,4,2,13,8]),function(B,i,D,C,P,k,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,L.createDecorator)("logService"),i.ILoggerService=(0,L.createDecorator)("loggerService");function m(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function f(r,t,n){switch(t){case l.Trace:r.trace(n);break;case l.Debug:r.debug(n);break;case l.Info:r.info(n);break;case l.Warning:r.warn(n);break;case l.Error:r.error(n);break;case l.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=f;function I(r){let t="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(n>0?" ":"")+o}return t}i.format=I;class w extends P.Disposable{constructor(){super(...arguments),this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=w;class d extends w{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,I([t,...n]))}debug(t,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,I([t,...n]))}info(t,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,I([t,...n]))}warn(t,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,I([t,...n]))}error(t,...n){if(this.checkLogLevel(l.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(l.Error,I(o))}else this.log(l.Error,I([t,...n]))}critical(t,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,I([t,...n]))}flush(){}}i.AbstractMessageLogger=d;class S extends w{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!k.isWindows}trace(t,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,t,...n):console.log(`[main ${m()}]`,t,...n))}debug(t,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,t,...n):console.log(`[main ${m()}]`,t,...n))}info(t,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,t,...n):console.log(`[main ${m()}]`,t,...n))}warn(t,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,t,...n):console.warn(`[main ${m()}]`,t,...n))}error(t,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,t,...n):console.error(`[main ${m()}]`,t,...n))}critical(t,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`\x1B[90m[main ${m()}]\x1B[0m`,t,...n):console.error(`[main ${m()}]`,t,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=S;class g extends w{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}i.ConsoleLogger=g;class y extends w{constructor(t,n=i.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=y;class v extends w{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const o of this.logServices)o.trace(t,...n)}debug(t,...n){for(const o of this.logServices)o.debug(t,...n)}info(t,...n){for(const o of this.logServices)o.info(t,...n)}warn(t,...n){for(const o of this.logServices)o.warn(t,...n)}error(t,...n){for(const o of this.logServices)o.error(t,...n)}critical(t,...n){for(const o of this.logServices)o.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}i.MultiplexLogService=v;class a extends P.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}i.LogService=a;class c extends P.Disposable{constructor(t,n){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(p=>p.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,n){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,n?.always?l.Trace:this.logLevel,n),this.loggers.set(t.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=c;class h{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(t){}getLevel(){return l.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}i.NullLogService=h;function u(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const t=s(r.logLevel.toLowerCase());if(t!==void 0)return t}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=u;function s(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=s;function e(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=e}),define(Q[110],Z([0,1,19,3,11,4,2,14,60,9]),function(B,i,D,C,P,k,L,m,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class I extends L.Disposable{constructor(d,S){super(),this.logService=d,this.options=S,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new C.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new C.ThrottledDelayer(0))}watch(d,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,S):this.watchNonRecursive(d,S)}watchUniversal(d,S){const g={path:this.toFilePath(d),excludes:S.excludes,includes:S.includes,recursive:S.recursive},y=(0,D.insert)(this.universalPathsToWatch,g);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,P.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,l.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const S of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const S of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(S)&&d.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,S){const g={path:this.toFilePath(d),excludes:S.excludes,includes:S.includes,recursive:!1},y=(0,D.insert)(this.nonRecursivePathsToWatch,g);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,P.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,l.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,m.normalize)(d.fsPath)}}i.AbstractDiskFileSystemProvider=I}),define(Q[111],Z([0,1,19,3,15,24,4,53,63,2,36,17,112,18,43,90,12,59,9]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g,y,v,a,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let h=class extends f.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new C.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${s}`);const r=new f.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),r.add(e.onDidChangeFile(t=>this._onDidFilesChange.fire(new v.FileChangesEvent(t,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&r.add(e.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),r.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,f.dispose)(r)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(r){e.push(r)}}),!this.provider.has(s)&&await C.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const r=this.provider.get(s.scheme);return!!(r&&r.capabilities&e)}listCapabilities(){return l.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,S.isAbsolutePath)(s))throw new v.FileOperationError((0,y.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const r=new Error;throw r.name="ENOPRO",r.message=(0,y.localize)(1,null,s.toString()),r}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,v.hasOpenReadWriteCloseCapability)(e)||(0,v.hasReadWriteCapability)(e)||(0,v.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,v.hasOpenReadWriteCloseCapability)(e)||(0,v.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(r){throw(0,v.toFileSystemProviderErrorCode)(r)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,y.localize)(2,null,this.resourceForError(s)),1):(0,v.ensureFileSystemProviderError)(r)}}async doResolveFile(s,e){const r=await this.withProvider(s),t=this.isPathCaseSensitive(r),n=e?.resolveTo,o=e?.resolveSingleChildDescendants,p=e?.resolveMetadata,E=await r.stat(s);let b;return this.toFileStat(r,s,E,void 0,!!p,(R,j)=>(b||(b=I.TernarySearchTree.forUris(()=>!t),b.set(s,!0),n&&b.fill(!0,n)),b.get(R.resource)||b.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&o?j===1:!1))}async toFileStat(s,e,r,t,n,o){const{providerExtUri:p}=this.getExtUri(s),E={resource:e,name:p.basename(e),isFile:(r.type&v.FileType.File)!==0,isDirectory:(r.type&v.FileType.Directory)!==0,isSymbolicLink:(r.type&v.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&v.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,v.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(E.isDirectory&&o(E,t)){try{const b=await s.readdir(e),R=await C.Promises.settled(b.map(async([j,_])=>{try{const J=p.joinPath(e,j),H=n?await s.stat(J):{type:_};return await this.toFileStat(s,J,H,b.length,n,o)}catch(J){return this.logService.trace(J),null}}));E.children=(0,D.coalesce)(R)}catch(b){this.logService.trace(b),E.children=[]}return E}return E}async resolveAll(s){return C.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),r=await e.stat(s);return this.toFileStat(e,s,r,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(r){return r}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new v.FileOperationError((0,y.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=P.VSBuffer.fromString(""),r){await this.doValidateCreateFile(s,r);const t=await this.writeFile(s,e);return this._onDidRunOperation.fire(new v.FileOperationEvent(s,0,t)),t}async writeFile(s,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(t);try{await this.validateWriteFile(t,s,r)||await this.mkdirp(t,n.dirname(s));let p;if((0,v.hasReadWriteCapability)(t)&&!(e instanceof P.VSBuffer))if((0,g.isReadableStream)(e)){const E=await(0,g.peekStream)(e,3);E.ended?p=P.VSBuffer.concat(E.buffer):p=E}else p=(0,g.peekReadable)(e,E=>P.VSBuffer.concat(E),3);else p=e;!(0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)&&p instanceof P.VSBuffer?await this.doWriteUnbuffered(t,s,r,p):await this.doWriteBuffered(t,s,r,p instanceof P.VSBuffer?(0,P.bufferToReadable)(p):p),this._onDidRunOperation.fire(new v.FileOperationEvent(s,4))}catch(o){throw new v.FileOperationError((0,y.localize)(4,null,this.resourceForError(s),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),r)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,r){if(!!r?.unlock&&!(s.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(e)));let n;try{n=await s.stat(e)}catch{return}if((n.type&v.FileType.Directory)!==0)throw new v.FileOperationError((0,y.localize)(6,null,this.resourceForError(e)),0,r);if(this.throwIfFileIsReadonly(e,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==v.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,v.etag)({mtime:r.mtime,size:n.size}))throw new v.FileOperationError((0,y.localize)(7,null),3,r);return n}async readFile(s,e,r){const t=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(t,s,e,r):this.doReadFile(t,s,e,r)}async doReadFileAtomic(s,e,r,t){return new Promise((n,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const p=await this.doReadFile(s,e,r,t);n(p)}catch(p){o(p)}})})}async doReadFile(s,e,r,t){const n=await this.doReadFileStream(s,e,{...r,preferUnbuffered:!0},t);return{...n,value:await(0,P.streamToBuffer)(n.value)}}async readFileStream(s,e,r){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,e,r)}async doReadFileStream(s,e,r,t){const n=new k.CancellationTokenSource(t),o=this.validateReadFile(e,r).then(E=>E,E=>{throw n.cancel(),E});let p;try{return typeof r?.etag=="string"&&r.etag!==v.ETAG_DISABLED&&await o,r?.atomic&&(0,v.hasFileAtomicReadCapability)(s)||!((0,v.hasOpenReadWriteCloseCapability)(s)||(0,v.hasFileReadStreamCapability)(s))||(0,v.hasReadWriteCapability)(s)&&r?.preferUnbuffered?p=this.readFileUnbuffered(s,e,r):(0,v.hasFileReadStreamCapability)(s)?p=this.readFileStreamed(s,e,n.token,r):p=this.readFileBuffered(s,e,n.token,r),{...await o,value:p}}catch(E){p&&await(0,g.consumeStream)(p);const b=(0,y.localize)(8,null,this.resourceForError(e),(0,v.ensureFileSystemProviderError)(E).toString());throw E instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(b,E.stat,r):new v.FileOperationError(b,(0,v.toFileOperationResult)(E),r)}}readFileStreamed(s,e,r,t=Object.create(null)){const n=s.readFileStream(e,t,r);return(0,g.transform)(n,{data:o=>o instanceof P.VSBuffer?o:P.VSBuffer.wrap(o),error:o=>new v.FileOperationError((0,y.localize)(9,null,this.resourceForError(e),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),t)},o=>P.VSBuffer.concat(o))}readFileBuffered(s,e,r,t=Object.create(null)){const n=(0,P.newWriteableBufferStream)();return(0,a.readFileIntoStream)(s,e,n,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new v.FileOperationError((0,y.localize)(10,null,this.resourceForError(e),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),t)},r),n}readFileUnbuffered(s,e,r){const t=(0,g.newWriteableStream)(n=>P.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,v.hasFileAtomicReadCapability)(s)?n=await s.readFile(e,{atomic:!0}):n=await s.readFile(e),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(e,n.byteLength,r),t.end(P.VSBuffer.wrap(n))}catch(n){t.error(n),t.end()}})(),t}async validateReadFile(s,e){const r=await this.resolve(s,{resolveMetadata:!0});if(r.isDirectory)throw new v.FileOperationError((0,y.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==v.ETAG_DISABLED&&e.etag===r.etag)throw new v.NotModifiedSinceFileOperationError((0,y.localize)(12,null),r,e);return this.validateReadFileLimits(s,r.size,e),r}validateReadFileLimits(s,e,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&e>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&e>r.limits.size&&(t=7),typeof t=="number")throw new v.FileOperationError((0,y.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,e,r){return this.doCanMoveCopy(s,e,"move",r)}async canCopy(s,e,r){return this.doCanMoveCopy(s,e,"copy",r)}async doCanMoveCopy(s,e,r,t){if(s.toString()!==e.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(n,s,o,e,r,t)}catch(n){return n}return!0}async move(s,e,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,n,e,"move",!!r),p=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,o==="move"?2:3,p)),p}async copy(s,e,r){const t=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,n,e,"copy",!!r),p=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,o==="copy"?3:2,p)),p}async doMoveCopy(s,e,r,t,n,o){if(e.toString()===t.toString())return n;const{exists:p,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(s,e,r,t,n,o);if(p&&!E&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),n==="copy"){if(s===r&&(0,v.hasFileFolderCopyCapability)(s))await s.copy(e,t,{overwrite:o});else{const b=await this.resolve(e);b.isDirectory?await this.doCopyFolder(s,b,r,t):await this.doCopyFile(s,e,r,t)}return n}else return s===r?(await s.rename(e,t,{overwrite:o}),n):(await this.doMoveCopy(s,e,r,t,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,r,t){if((0,v.hasOpenReadWriteCloseCapability)(s)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(s,e,r,t);if((0,v.hasOpenReadWriteCloseCapability)(s)&&(0,v.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(s,e,r,t);if((0,v.hasReadWriteCapability)(s)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(s,e,r,t);if((0,v.hasReadWriteCapability)(s)&&(0,v.hasReadWriteCapability)(r))return this.doPipeUnbuffered(s,e,r,t)}async doCopyFolder(s,e,r,t){await r.mkdir(t),Array.isArray(e.children)&&await C.Promises.settled(e.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(t,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),r,o):this.doCopyFile(s,n.resource,r,o)}))}async doValidateMoveCopy(s,e,r,t,n,o){let p=!1;if(s===r){const{providerExtUri:b,isPathCaseSensitive:R}=this.getExtUri(s);if(R||(p=b.isEqual(e,t)),p&&n==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(e),this.resourceForError(t)));if(!p&&b.isEqualOrParent(t,e))throw new Error((0,y.localize)(15,null,this.resourceForError(e),this.resourceForError(t)))}const E=await this.exists(t);if(E&&!p){if(!o)throw new v.FileOperationError((0,y.localize)(16,null,this.resourceForError(e),this.resourceForError(t)),4);if(s===r){const{providerExtUri:b}=this.getExtUri(s);if(b.isEqualOrParent(e,t))throw new Error((0,y.localize)(17,null,this.resourceForError(e),this.resourceForError(t)))}}return{exists:E,isSameResourceWithDifferentPathCase:p}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,0,r)),r}async mkdirp(s,e){const r=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(e,t.dirname(e));)try{if(((await s.stat(e)).type&v.FileType.Directory)===0)throw new Error((0,y.localize)(18,null,this.resourceForError(e)));break}catch(n){if((0,v.toFileSystemProviderErrorCode)(n)!==v.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(t.basename(e)),e=t.dirname(e)}for(let n=r.length-1;n>=0;n--){e=t.joinPath(e,r[n]);try{await s.mkdir(e)}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(r){return r}return!0}async doValidateDelete(s,e){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(r.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch{}if(n)this.throwIfFileIsReadonly(s,n);else throw new v.FileOperationError((0,y.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const p=await this.resolve(s);if(p.isDirectory&&Array.isArray(p.children)&&p.children.length>0)throw new Error((0,y.localize)(21,null,this.resourceForError(s)))}return r}async del(s,e){const r=await this.doValidateDelete(s,e),t=!!e?.useTrash,n=!!e?.recursive;await r.delete(s,{recursive:n,useTrash:t}),this._onDidRunOperation.fire(new v.FileOperationEvent(s,1))}async cloneFile(s,e){const r=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(r===t&&this.getExtUri(r).providerExtUri.isEqual(s,e))return;if(r===t&&(0,v.hasFileCloneCapability)(r))return r.cloneFile(s,e);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(e));const n=this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri);return r===t&&(0,v.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(s,e,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,s,t,e))}watch(s,e={recursive:!1,excludes:[]}){const r=new f.DisposableStore;let t=!1,n=()=>{t=!0};return r.add((0,f.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(s,e);t?(0,f.dispose)(o):n=()=>(0,f.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(s,e){const r=await this.withProvider(s),t=(0,m.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(s),e]);let n=this.activeWatchers.get(t);return n||(n={count:0,disposable:r.watch(s,e)},this.activeWatchers.set(t,n)),n.count+=1,(0,f.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,f.dispose)(n.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,f.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(e,{create:!0,unlock:r?.unlock??!1});try{(0,g.isReadableStream)(t)||(0,g.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,n,t):await this.doWriteReadableBufferedQueued(s,n,t)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,e,r){let t=0,n;if((0,g.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=P.VSBuffer.concat(r.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,t,0),t+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,p)=>{(0,g.listenStream)(n,{onData:async E=>{n.pause();try{await this.doWriteBuffer(s,e,E,E.byteLength,t,0)}catch(b){return p(b)}t+=E.byteLength,setTimeout(()=>n.resume())},onError:E=>p(E),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,r){let t=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(s,e,n,n.byteLength,t,0),t+=n.byteLength}async doWriteBuffer(s,e,r,t,n,o){let p=0;for(;p<t;)p+=await s.write(e,n+p,r.buffer,o+p,t-p)}async doWriteUnbuffered(s,e,r,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,r,t))}async doWriteUnbufferedQueued(s,e,r,t){let n;t instanceof P.VSBuffer?n=t:(0,g.isReadableStream)(t)?n=await(0,P.streamToBuffer)(t):(0,g.isReadableBufferedStream)(t)?n=await(0,P.bufferedStreamToBuffer)(t):n=(0,P.readableToBuffer)(t),await s.writeFile(e,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,r,t))}async doPipeBufferedQueued(s,e,r,t){let n,o;try{n=await s.open(e,{create:!1}),o=await r.open(t,{create:!0,unlock:!1});const p=P.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,b=0,R=0;do R=await s.read(n,E,p.buffer,b,p.byteLength-b),await this.doWriteBuffer(r,o,p,R,E,b),E+=R,b+=R,b===p.byteLength&&(b=0);while(R>0)}catch(p){throw(0,v.ensureFileSystemProviderError)(p)}finally{await C.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,r,t))}async doPipeUnbufferedQueued(s,e,r,t){return r.writeFile(t,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,r,t))}async doPipeUnbufferedToBufferedQueued(s,e,r,t){const n=await r.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(r,n,P.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(s,e,r,t){const n=await(0,P.streamToBuffer)(this.readFileBuffered(s,e,k.CancellationToken.None));await this.doWriteUnbuffered(r,t,void 0,n)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new v.FileOperationError((0,y.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,y.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===w.Schemas.file?s.fsPath:s.toString(!0)}};h=ge([ee(0,c.ILogService)],h),i.FileService=h}),define(Q[113],Z([0,1,114,153,3,36,15,4,154,2,14,13,18,43,20,92,12,59,110,31,108,107]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g,y,v,a,c,h,u,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,C.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,h.toErrorMessage)(r)}`)}})();class e extends c.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=m.Event.None,this.resourceLocks=new k.ResourceMap(o=>d.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:o}=await g.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await g.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async p=>{try{let E;p.isSymbolicLink()?E=(await this.stat((0,d.joinPath)(t,p.name))).type:E=this.toType(p),o.push([p.name,E])}catch(E){this.logService.trace(E)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let o;return n?.dangling?o=v.FileType.Unknown:t.isFile()?o=v.FileType.File:t.isDirectory()?o=v.FileType.Directory:o=v.FileType.Unknown,n&&(o|=v.FileType.SymbolicLink),o}async createResourceLock(t){const n=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const p=new P.Barrier;return this.resourceLocks.set(t,p),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,f.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===p&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),p.open()})}async readFile(t,n){let o;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const p=this.toFilePath(t);return await g.Promises.readFile(p)}catch(p){throw this.toFileSystemProviderError(p)}finally{o?.dispose()}}traceLock(t){e.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,n,o){const p=(0,S.newWriteableStream)(E=>L.VSBuffer.concat(E.map(b=>L.VSBuffer.wrap(b))).buffer);return(0,a.readFileIntoStream)(this,t,p,E=>E.buffer,{...n,bufferSize:256*1024},o),p}async writeFile(t,n,o){let p;try{const E=this.toFilePath(t);if(!o.create||!o.overwrite){if(await g.Promises.exists(E)){if(!o.overwrite)throw(0,v.createFileSystemProviderError)((0,y.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,v.createFileSystemProviderError)((0,y.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(p,0,n,0,n.byteLength)}catch(E){throw await this.toFileSystemProviderWriteError(t,E)}finally{typeof p=="number"&&await this.close(p)}}static configureFlushOnWrite(t){e.canFlush=t}async open(t,n){const o=this.toFilePath(t);let p;(0,v.isFileOpenForWriteOptions)(n)&&(p=await this.createResourceLock(t));let E;try{if((0,v.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:R}=await g.SymlinkSupport.stat(o);R.mode&128||await g.Promises.chmod(o,R.mode|128)}catch(R){this.logService.trace(R)}let b;if((0,v.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await g.Promises.truncate(o,0),b="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}b||(b="w")}else b="r";E=await g.Promises.open(o,b)}catch(b){throw p?.dispose(),(0,v.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,b):this.toFileSystemProviderError(b)}if(this.mapHandleToPos.set(E,0),(0,v.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(E,t),p){const b=this.mapHandleToLock.get(E);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${o})`),this.mapHandleToLock.set(E,p),b&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${o})`),b.dispose())}return E}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&e.canFlush)try{await g.Promises.fdatasync(t)}catch(o){e.configureFlushOnWrite(!1),this.logService.error(o)}return await g.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,o,p,E){const b=this.normalizePos(t,n);let R=null;try{R=(await g.Promises.read(t,o,p,E,b)).bytesRead}catch(j){throw this.toFileSystemProviderError(j)}finally{this.updatePos(t,b,R)}return R}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,o){const p=this.mapHandleToPos.get(t);typeof p=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,p+o):this.mapHandleToPos.delete(t)))}async write(t,n,o,p,E){return(0,P.retry)(()=>this.doWrite(t,n,o,p,E),100,3)}async doWrite(t,n,o,p,E){const b=this.normalizePos(t,n);let R=null;try{R=(await g.Promises.write(t,o,p,E,b)).bytesWritten}catch(j){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),j)}finally{this.updatePos(t,b,R)}return R}async mkdir(t){try{await g.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const o=this.toFilePath(t);n.recursive?await g.Promises.rm(o,g.RimRafMode.MOVE):await g.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,n,o){const p=this.toFilePath(t),E=this.toFilePath(n);if(p!==E)try{await this.validateTargetDeleted(t,n,"move",o.overwrite),await g.Promises.move(p,E)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,y.localize)(2,null,(0,I.basename)(p),(0,I.basename)((0,I.dirname)(E)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(t,n,o){const p=this.toFilePath(t),E=this.toFilePath(n);if(p!==E)try{await this.validateTargetDeleted(t,n,"copy",o.overwrite),await g.Promises.copy(p,E,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,y.localize)(3,null,(0,I.basename)(p),(0,I.basename)((0,I.dirname)(E)),b.toString()))),this.toFileSystemProviderError(b)}}async validateTargetDeleted(t,n,o,p){const E=this.toFilePath(t),b=this.toFilePath(n);let R=!1;if(!!(this.capabilities&1024)||(R=(0,l.isEqual)(E,b,!0)),R&&o==="copy")throw(0,v.createFileSystemProviderError)((0,y.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!R&&await g.Promises.exists(b)){if(!p)throw(0,v.createFileSystemProviderError)((0,y.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,o){const p=this.toFilePath(t),E=this.toFilePath(n),b=!!(this.capabilities&1024);if((0,l.isEqual)(p,E,!b))return;const R=new f.DisposableStore;try{const[j,_]=await Promise.all([this.createResourceLock(t),this.createResourceLock(n)]);R.add(j),R.add(_),o&&await g.Promises.mkdir((0,I.dirname)(E),{recursive:!0}),await g.Promises.copyFile(p,E)}catch(j){if(j.code==="ENOENT"&&!o)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(j)}finally{R.dispose()}}createUniversalWatcher(t,n,o){return new u.UniversalWatcherClient(p=>t(p),p=>n(p),o)}createNonRecursiveWatcher(t,n,o){return new s.NodeJSWatcherClient(p=>t(p),p=>n(p),o)}toFileSystemProviderError(t){if(t instanceof v.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=v.FileSystemProviderErrorCode.NoPermissions;break;default:n=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let o=this.toFileSystemProviderError(n);if(t&&o.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await g.SymlinkSupport.stat(this.toFilePath(t));p.mode&128||(o=(0,v.createFileSystemProviderError)(n,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return o}}i.DiskFileSystemProvider=e,e.TRACE_LOG_RESOURCE_LOCKS=!1,e.canFlush=!0}),define(Q[115],Z([0,1,12,9]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function P(m,l,f,I,w){try{const d=await new Promise((g,y)=>{B(["spdlog"],g,y)});d.setFlushOn(C.LogLevel.Trace);const S=await d.createAsyncRotatingLogger(m,l,f,I);return w&&S.clearFormatters(),S}catch(d){console.error(d)}return null}function k(m,l,f){switch(l){case C.LogLevel.Trace:m.trace(f);break;case C.LogLevel.Debug:m.debug(f);break;case C.LogLevel.Info:m.info(f);break;case C.LogLevel.Warning:m.warn(f);break;case C.LogLevel.Error:m.error(f);break;case C.LogLevel.Critical:m.critical(f);break;default:throw new Error("Invalid log level")}}class L extends C.AbstractMessageLogger{constructor(l,f,I,w,d){super(),this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(l,f,I,w),this._register(this.onDidChangeLogLevel(S=>{this._logger?.setLevel(S)}))}async _createSpdLogLogger(l,f,I,w){const d=I?6:1,S=30/d*D.ByteSize.MB,g=await P(l,f,S,d,w);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:y,message:v}of this.buffer)k(this._logger,y,v);this.buffer=[]}}log(l,f){this._logger?k(this._logger,l,f):this.getLevel()<=l&&this.buffer.push({level:l,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=L}),define(Q[37],Z([0,1,4,63,2,8]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NullPolicyService=i.AbstractPolicyService=i.IPolicyService=void 0,i.IPolicyService=(0,k.createDecorator)("policy");class L extends P.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(f){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...f,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(f),C.Iterable.reduce(this.policies.entries(),(w,[d,S])=>({...w,[d]:S}),{})}getPolicyValue(f){return this.policies.get(f)}serialize(){return C.Iterable.reduce(Object.entries(this.policyDefinitions),(f,[I,w])=>({...f,[I]:{definition:w,value:this.policies.get(I)}}),{})}}i.AbstractPolicyService=L;class m{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}i.NullPolicyService=m}),define(Q[116],Z([0,1,3,4,63,5,12,9,37]),function(B,i,D,C,P,k,L,m,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FilePolicyService=void 0;function f(w,d){const S=[];for(const g of P.Iterable.concat(w.keys(),d.keys()))w.get(g)!==d.get(g)&&S.push(g);return S}let I=class extends l.AbstractPolicyService{constructor(d,S,g){super(),this.file=d,this.fileService=S,this.logService=g,this.throttledDelayer=this._register(new D.ThrottledDelayer(500));const y=C.Event.filter(S.onDidFilesChange,v=>v.affects(d));this._register(S.watch(d)),this._register(y(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(d){await this.refresh()}async read(){const d=new Map;try{const S=await this.fileService.readFile(this.file),g=JSON.parse(S.value.toString());if(!(0,k.isObject)(g))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(g))this.policyDefinitions[y]&&d.set(y,g[y])}catch(S){S.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",S)}return d}async refresh(){const d=await this.read(),S=f(this.policies,d);this.policies=d,S.length>0&&this._onDidChange.fire(S)}};I=ge([ee(1,L.IFileService),ee(2,m.ILogService)],I),i.FilePolicyService=I}),define(Q[28],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,D.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Q[33],Z([0,1,68,5]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class P{constructor(){this.data=new Map}add(L,m){D.ok(C.isString(L)),D.ok(C.isObject(m)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,m)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}i.Registry=new P}),define(Q[117],Z([0,1,4,33]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function P(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class k{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,f){this.schemasById[P(l)]=f,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new k;C.Registry.add(i.Extensions.JSONContribution,L)}),define(Q[40],Z([0,1,19,4,5,81,21,117,33]),function(B,i,D,C,P,k,L,m,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var f;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(f=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var I;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=l.Registry.as(m.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,r=!0){this.registerConfigurations([e],r)}registerConfigurations(e,r=!0){const t=this.doRegisterConfigurations(e,r);w.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(e){const r=this.doDeregisterConfigurations(e);w.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:e,remove:r}){const t=[];t.push(...this.doDeregisterConfigurations(r)),t.push(...this.doRegisterConfigurations(e,!1)),w.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(e){const r=[],t=[];for(const{overrides:n,source:o}of e)for(const p in n)if(r.push(p),i.OVERRIDE_PROPERTY_REGEX.test(p)){const E=this.configurationDefaultsOverrides.get(p),b=E?.valuesSources??new Map;if(o)for(const J of Object.keys(n[p]))b.set(J,o);const R={...E?.value||{},...n[p]};this.configurationDefaultsOverrides.set(p,{source:o,value:R,valuesSources:b});const j=(0,L.getLanguageTagSettingPlainKey)(p),_={type:"object",default:R,description:k.localize(1,null,j),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:P.isString(o)?void 0:o,defaultValueSource:o};t.push(...y(p)),this.configurationProperties[p]=_,this.defaultLanguageConfigurationOverridesNode.properties[p]=_}else{this.configurationDefaultsOverrides.set(p,{value:n[p],source:o});const E=this.configurationProperties[p];E&&(this.updatePropertyDefaultValue(p,E),this.updateSchema(p,E))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const r=[];for(const{overrides:t,source:n}of e)for(const o in t){const p=this.configurationDefaultsOverrides.get(o),E=P.isString(n)?n:n?.id,b=P.isString(p?.source)?p?.source:p?.source?.id;if(E===b)if(r.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const R=this.configurationProperties[o];R&&(this.updatePropertyDefaultValue(o,R),this.updateSchema(o,R))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const r of e)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,r){const t=[];return e.forEach(n=>{t.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),t}doDeregisterConfigurations(e){const r=[],t=n=>{if(n.properties)for(const o in n.properties){r.push(o);const p=this.configurationProperties[o];p?.policy?.name&&this.policyConfigurations.delete(p.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>t(o))};for(const n of e){t(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(e,r=!0,t,n,o=3){o=P.isUndefinedOrNull(e.scope)?o:e.scope;const p=[],E=e.properties;if(E)for(const R in E){const j=E[R];if(r&&h(R,j)){delete E[R];continue}if(j.source=t,j.defaultDefaultValue=E[R].default,this.updatePropertyDefaultValue(R,j),i.OVERRIDE_PROPERTY_REGEX.test(R)?j.scope=void 0:(j.scope=P.isUndefinedOrNull(j.scope)?o:j.scope,j.restricted=P.isUndefinedOrNull(j.restricted)?!!n?.includes(R):j.restricted),E[R].hasOwnProperty("included")&&!E[R].included){this.excludedConfigurationProperties[R]=E[R],delete E[R];continue}else this.configurationProperties[R]=E[R],E[R].policy?.name&&this.policyConfigurations.set(E[R].policy.name,R);!E[R].deprecationMessage&&E[R].markdownDeprecationMessage&&(E[R].deprecationMessage=E[R].markdownDeprecationMessage),p.push(R)}const b=e.allOf;if(b)for(const R of b)p.push(...this.validateAndRegisterProperties(R,r,t,n,o));return p}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const r=t=>{const n=t.properties;if(n)for(const p in n)this.updateSchema(p,n[p]);t.allOf?.forEach(r)};r(e)}updateSchema(e,r){switch(i.allSettings.properties[e]=r,r.scope){case 1:i.applicationSettings.properties[e]=r;break;case 2:i.machineSettings.properties[e]=r;break;case 6:i.machineOverridableSettings.properties[e]=r;break;case 3:i.windowSettings.properties[e]=r;break;case 4:i.resourceSettings.properties[e]=r;break;case 5:i.resourceSettings.properties[e]=r,this.resourceLanguageSettingsSchema.properties[e]=r;break}}removeFromSchema(e,r){switch(delete i.allSettings.properties[e],r.scope){case 1:delete i.applicationSettings.properties[e];break;case 2:delete i.machineSettings.properties[e];break;case 6:delete i.machineOverridableSettings.properties[e];break;case 3:delete i.windowSettings.properties[e];break;case 4:case 5:delete i.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const r=`[${e}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,t),i.allSettings.properties[r]=t,i.applicationSettings.properties[r]=t,i.machineSettings.properties[r]=t,i.machineOverridableSettings.properties[r]=t,i.windowSettings.properties[r]=t,i.resourceSettings.properties[r]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,r){const t=this.configurationDefaultsOverrides.get(e);let n=t?.value,o=t?.source;P.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),P.isUndefined(n)&&(n=a(r.type)),r.default=n,r.defaultValueSource=o}}const S="\\[([^\\]]+)\\]",g=new RegExp(S,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function y(s){const e=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let r=g.exec(s);for(;r?.length;){const t=r[1].trim();t&&e.push(t),r=g.exec(s)}}return(0,D.distinct)(e)}i.overrideIdentifiersFromKey=y;function v(s){return s.reduce((e,r)=>`${e}[${r}]`,"")}i.keyFromOverrideIdentifiers=v;function a(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=a;const c=new d;l.Registry.add(i.Extensions.Configuration,c);function h(s,e){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?k.localize(7,null,s):c.getConfigurationProperties()[s]!==void 0?k.localize(8,null,s):e.policy?.name&&c.getPolicyConfigurations().get(e.policy?.name)!==void 0?k.localize(9,null,s,e.policy?.name,c.getPolicyConfigurations().get(e.policy?.name)):null:k.localize(6,null)}i.validateProperty=h;function u(){const s=[],e=c.getConfigurationProperties();for(const r of Object.keys(e))s.push([r,e[r].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=u}),define(Q[64],Z([0,1,19,4,50,2,36,26,5,10,21,40,33]),function(B,i,D,C,P,k,L,m,l,f,I,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.ConfigurationModel=void 0;class S{constructor(e={},r=[],t=[],n){this._contents=e,this._keys=r,this._overrides=t,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const e=this.raw.map(r=>{if(r instanceof S)return r;const t=new g("");return t.parseRaw(r),t.configurationModel});this._rawConfiguration=e.reduce((r,t)=>t===r?t:r.merge(t),e[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(e){return e?(0,I.getConfigurationValue)(this.contents,e):this.contents}inspect(e,r){const t=this.rawConfiguration.getValue(e),n=r?this.rawConfiguration.getOverrideValue(e,r):void 0,o=r?this.rawConfiguration.override(r).getValue(e):t;return{value:t,override:n,merged:o}}getOverrideValue(e,r){const t=this.getContentsForOverrideIdentifer(r);return t?e?(0,I.getConfigurationValue)(t,e):t:void 0}getKeysForOverrideIdentifier(e){const r=[];for(const t of this.overrides)t.identifiers.includes(e)&&r.push(...t.keys);return D.distinct(r)}getAllOverrideIdentifiers(){const e=[];for(const r of this.overrides)e.push(...r.identifiers);return D.distinct(e)}override(e){let r=this.overrideConfigurations.get(e);return r||(r=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,r)),r}merge(...e){const r=m.deepClone(this.contents),t=m.deepClone(this.overrides),n=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const p of e)if(o.push(...p.raw?.length?p.raw:[p]),!p.isEmpty()){this.mergeContents(r,p.contents);for(const E of p.overrides){const[b]=t.filter(R=>D.equals(R.identifiers,E.identifiers));b?(this.mergeContents(b.contents,E.contents),b.keys.push(...E.keys),b.keys=D.distinct(b.keys)):t.push(m.deepClone(E))}for(const E of p.keys)n.indexOf(E)===-1&&n.push(E)}return new S(r,n,t,o.every(p=>p instanceof S)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new S(m.deepClone(this.contents),[...this.keys],m.deepClone(this.overrides))}createOverrideConfigurationModel(e){const r=this.getContentsForOverrideIdentifer(e);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const t={};for(const n of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let o=this.contents[n];const p=r[n];p&&(typeof o=="object"&&typeof p=="object"?(o=m.deepClone(o),this.mergeContents(o,p)):o=p),t[n]=o}return new S(t,this.keys,this.overrides)}mergeContents(e,r){for(const t of Object.keys(r)){if(t in e&&l.isObject(e[t])&&l.isObject(r[t])){this.mergeContents(e[t],r[t]);continue}e[t]=m.deepClone(r[t])}}checkAndFreeze(e){return this.frozen&&!Object.isFrozen(e)?m.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let r=null,t=null;const n=o=>{o&&(t?this.mergeContents(t,o):t=m.deepClone(o))};for(const o of this.overrides)D.equals(o.identifiers,[e])?r=o.contents:o.identifiers.includes(e)&&n(o.contents);return n(r),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,r){this.addKey(e),(0,I.addToValueTree)(this.contents,e,r,t=>{throw new Error(t)})}removeValue(e){this.removeKey(e)&&(0,I.removeFromValueTree)(this.contents,e)}addKey(e){let r=this.keys.length;for(let t=0;t<r;t++)e.indexOf(this.keys[t])===0&&(r=t);this.keys.splice(r,1,e)}removeKey(e){const r=this.keys.indexOf(e);return r!==-1?(this.keys.splice(r,1),!0):!1}}i.ConfigurationModel=S;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,r){if(!l.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t,r)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,r){this._raw=e;const{contents:t,keys:n,overrides:o,restricted:p,hasExcludedProperties:E}=this.doParseRaw(e,r);this._configurationModel=new S(t,n,o,E?[e]:void 0),this._restrictedConfigurations=p||[]}doParseContent(e){let r={},t=null,n=[];const o=[],p=[];function E(R){Array.isArray(n)?n.push(R):t!==null&&(n[t]=R)}const b={onObjectBegin:()=>{const R={};E(R),o.push(n),n=R,t=null},onObjectProperty:R=>{t=R},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const R=[];E(R),o.push(n),n=R,t=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:E,onError:(R,j,_)=>{p.push({error:R,offset:j,length:_})}};if(e)try{P.visit(e,b),r=n[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return r}doParseRaw(e,r){const t=d.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,t,!0,r);e=n.raw;const o=(0,I.toValuesTree)(e,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),p=Object.keys(e),E=this.toOverrides(e,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:o,keys:p,overrides:E,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(e,r,t,n){let o=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[],hasExcludedProperties:o};const p={},E=[];for(const b in e)if(w.OVERRIDE_PROPERTY_REGEX.test(b)&&t){const R=this.filter(e[b],r,!1,n);p[b]=R.raw,o=o||R.hasExcludedProperties,E.push(...R.restricted)}else{const R=r[b],j=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&E.push(b),(j===void 0||n.scopes===void 0||n.scopes.includes(j))&&!(n.skipRestricted&&R?.restricted)?p[b]=e[b]:o=!0}return{raw:p,restricted:E,hasExcludedProperties:o}}toOverrides(e,r){const t=[];for(const n of Object.keys(e))if(w.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const p in e[n])o[p]=e[n][p];t.push({identifiers:(0,w.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,I.toValuesTree)(o,r)})}return t}}i.ConfigurationModelParser=g;class y extends k.Disposable{constructor(e,r,t,n){super(),this.userSettingsResource=e,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=y;class v{constructor(e,r,t,n,o=new S,p=new S,E=new L.ResourceMap,b=new S,R=new L.ResourceMap,j=!0){this._defaultConfiguration=e,this._policyConfiguration=r,this._applicationConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=p,this._folderConfigurations=E,this._memoryConfiguration=b,this._memoryConfigurationByResource=R,this._freeze=j,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,r,t){return this.getConsolidatedConfigurationModel(e,r,t).getValue(e)}updateValue(e,r,t={}){let n;t.resource?(n=this._memoryConfigurationByResource.get(t.resource),n||(n=new S,this._memoryConfigurationByResource.set(t.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(e):n.setValue(e,r),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,r,t){const n=this.getConsolidatedConfigurationModel(e,r,t),o=this.getFolderConfigurationModelForResource(r.resource,t),p=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,E=this._defaultConfiguration.inspect(e,r.overrideIdentifier),b=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(e),R=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(e),j=this.userConfiguration.freeze().inspect(e,r.overrideIdentifier),_=this.localUserConfiguration.freeze().inspect(e,r.overrideIdentifier),J=this.remoteUserConfiguration.freeze().inspect(e,r.overrideIdentifier),H=t?this._workspaceConfiguration.freeze().inspect(e,r.overrideIdentifier):void 0,ne=o?o.freeze().inspect(e,r.overrideIdentifier):void 0,re=p.inspect(e,r.overrideIdentifier),se=n.getValue(e),fe=D.distinct(n.overrides.map(le=>le.identifiers).flat()).filter(le=>n.getOverrideValue(e,le)!==void 0);return{defaultValue:E?E.merged:void 0,policyValue:b?b.merged:void 0,applicationValue:R?R.merged:void 0,userValue:j?j.merged:void 0,userLocalValue:_?_.merged:void 0,userRemoteValue:J?J.merged:void 0,workspaceValue:H?H.merged:void 0,workspaceFolderValue:ne?ne.merged:void 0,memoryValue:re?re.merged:void 0,value:se,default:E.value!==void 0||E.override!==void 0?{value:E.value,override:E.override}:void 0,policy:b?.value!==void 0?{value:b.value}:void 0,application:R?.value!==void 0||R?.override!==void 0?{value:R.value,override:R.override}:void 0,user:j.value!==void 0||j.override!==void 0?{value:j.value,override:j.override}:void 0,userLocal:_.value!==void 0||_.override!==void 0?{value:_.value,override:_.override}:void 0,userRemote:J.value!==void 0||J.override!==void 0?{value:J.value,override:J.override}:void 0,workspace:H?.value!==void 0||H?.override!==void 0?{value:H.value,override:H.override}:void 0,workspaceFolder:ne?.value!==void 0||ne?.override!==void 0?{value:ne.value,override:ne.override}:void 0,memory:re.value!==void 0||re.override!==void 0?{value:re.value,override:re.override}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(e){const r=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(e){this._policyConfiguration=e}updateApplicationConfiguration(e){this._applicationConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,r){this._folderConfigurations.set(e,r),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,r){const t=[];if(!r){const{added:n,updated:o,removed:p}=h(this._defaultConfiguration,e);r=[...n,...o,...p]}for(const n of r)for(const o of(0,w.overrideIdentifiersFromKey)(n)){const p=this._defaultConfiguration.getKeysForOverrideIdentifier(o),E=e.getKeysForOverrideIdentifier(o),b=[...E.filter(R=>p.indexOf(R)===-1),...p.filter(R=>E.indexOf(R)===-1),...p.filter(R=>!m.equals(this._defaultConfiguration.override(o).getValue(R),e.override(o).getValue(R)))];t.push([o,b])}return this.updateDefaultConfiguration(e),{keys:r,overrides:t}}compareAndUpdatePolicyConfiguration(e){const{added:r,updated:t,removed:n}=h(this._policyConfiguration,e),o=[...r,...t,...n];return o.length&&this.updatePolicyConfiguration(e),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=h(this.applicationConfiguration,e),p=[...r,...t,...n];return p.length&&this.updateApplicationConfiguration(e),{keys:p,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=h(this.localUserConfiguration,e),p=[...r,...t,...n];return p.length&&this.updateLocalUserConfiguration(e),{keys:p,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=h(this.remoteUserConfiguration,e),p=[...r,...t,...n];return p.length&&this.updateRemoteUserConfiguration(e),{keys:p,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:r,updated:t,removed:n,overrides:o}=h(this.workspaceConfiguration,e),p=[...r,...t,...n];return p.length&&this.updateWorkspaceConfiguration(e),{keys:p,overrides:o}}compareAndUpdateFolderConfiguration(e,r){const t=this.folderConfigurations.get(e),{added:n,updated:o,removed:p,overrides:E}=h(t,r),b=[...n,...o,...p];return(b.length||!t)&&this.updateFolderConfiguration(e,r),{keys:b,overrides:E}}compareAndDeleteFolderConfiguration(e){const r=this.folderConfigurations.get(e);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:t,updated:n,removed:o,overrides:p}=h(r,void 0);return{keys:[...t,...n,...o],overrides:p}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(e,r,t){let n=this.getConsolidatedConfigurationModelForResource(r,t);return r.overrideIdentifier&&(n=n.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(e)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:e},r){let t=this.getWorkspaceConsolidatedConfiguration();if(r&&e){const n=r.getFolder(e);n&&(t=this.getFolderConsolidatedConfiguration(n.uri)||t);const o=this._memoryConfigurationByResource.get(e);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let r=this._foldersConsolidatedConfigurations.get(e);if(!r){const t=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(r=t.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(e,r)):r=t}return r}getFolderConfigurationModelForResource(e,r){if(r&&e){const t=r.getFolder(e);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,r)=>{const{contents:t,overrides:n,keys:o}=this._folderConfigurations.get(r);return e.push([r,{contents:t,overrides:n,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>e.add(r)),this.userConfiguration.freeze().keys.forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>r.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>r.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(e).forEach(n=>r.add(n))),[...r.values()]}static parse(e){const r=this.parseConfigurationModel(e.defaults),t=this.parseConfigurationModel(e.policy),n=this.parseConfigurationModel(e.application),o=this.parseConfigurationModel(e.user),p=this.parseConfigurationModel(e.workspace),E=e.folders.reduce((b,R)=>(b.set(f.URI.revive(R[0]),this.parseConfigurationModel(R[1])),b),new L.ResourceMap);return new v(r,t,n,o,new S,p,E,new S,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new S(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=v;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,r=new Map;for(const n of s)n.keys.forEach(o=>e.add(o)),n.overrides.forEach(([o,p])=>{const E=(0,L.getOrSet)(r,o,new Set);p.forEach(b=>E.add(b))});const t=[];return r.forEach((n,o)=>t.push([o,[...n.values()]])),{keys:[...e.values()],overrides:t}}i.mergeChanges=a;class c{constructor(e,r,t,n){this.change=e,this.previous=r,this.currentConfiguraiton=t,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(E=>o.add(E)),e.overrides.forEach(([,E])=>E.forEach(b=>o.add(b))),this.affectedKeys=[...o.values()];const p=new S;this.affectedKeys.forEach(E=>p.setValue(E,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(r){const t=this.previousConfiguration?this.previousConfiguration.getValue(e,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,r,this.currentWorkspace);return!m.equals(t,n)}return!0}return!1}doesAffectedKeysTreeContains(e,r){let t=(0,I.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof t=="object"&&(n=Object.keys(t)[0]);){if(e=e[n],!e)return!1;t=t[n]}return!0}}i.ConfigurationChangeEvent=c;function h(s,e){const{added:r,removed:t,updated:n}=u(e,s),o=[],p=s?.getAllOverrideIdentifiers()||[],E=e?.getAllOverrideIdentifiers()||[];if(e){const b=E.filter(R=>!p.includes(R));for(const R of b)o.push([R,e.getKeysForOverrideIdentifier(R)])}if(s){const b=p.filter(R=>!E.includes(R));for(const R of b)o.push([R,s.getKeysForOverrideIdentifier(R)])}if(e&&s){for(const b of p)if(E.includes(b)){const R=u({contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)},{contents:e.getOverrideValue(void 0,b)||{},keys:e.getKeysForOverrideIdentifier(b)});o.push([b,[...R.added,...R.removed,...R.updated]])}}return{added:r,removed:t,updated:n,overrides:o}}function u(s,e){const r=s?e?s.keys.filter(o=>e.keys.indexOf(o)===-1):[...s.keys]:[],t=e?s?e.keys.filter(o=>s.keys.indexOf(o)===-1):[...e.keys]:[],n=[];if(s&&e){for(const o of e.keys)if(s.keys.indexOf(o)!==-1){const p=(0,I.getConfigurationValue)(e.contents,o),E=(0,I.getConfigurationValue)(s.contents,o);m.equals(p,E)||n.push(o)}}return{added:r,removed:t,updated:n}}}),define(Q[118],Z([0,1,19,4,2,26,5,21,64,40,9,37,33]),function(B,i,D,C,P,k,L,m,l,f,I,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PolicyConfiguration=i.NullPolicyConfiguration=i.DefaultConfigurationModel=i.DefaultConfiguration=void 0;class S extends P.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new g(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(d.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:h})=>this.onDidUpdateConfiguration(c,h))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(c,h){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:c})}getConfigurationDefaultOverrides(){return{}}}i.DefaultConfiguration=S;class g extends l.ConfigurationModel{constructor(c={}){const h=d.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(h),s=Object.create(null),e=[];for(const r in h){const t=c[r],n=t!==void 0?t:h[r].default;(0,m.addToValueTree)(s,r,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(s))f.OVERRIDE_PROPERTY_REGEX.test(r)&&e.push({identifiers:(0,f.overrideIdentifiersFromKey)(r),keys:Object.keys(s[r]),contents:(0,m.toValuesTree)(s[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,u,e)}}i.DefaultConfigurationModel=g;class y{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new l.ConfigurationModel}async initialize(){return this.configurationModel}}i.NullPolicyConfiguration=y;let v=class extends P.Disposable{get configurationModel(){return this._configurationModel}constructor(c,h,u){super(),this.defaultConfiguration=c,this.policyService=h,this.logService=u,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new l.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(c=>this.onDidChangePolicies(c))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:c})=>this.update(await this.registerPolicyDefinitions(c),!0))),this._configurationModel}async registerPolicyDefinitions(c){const h={},u=[],s=d.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const e of c){const r=s[e];if(!r){u.push(e);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}u.push(e),h[r.policy.name]={type:r.type}}}return(0,L.isEmptyObject)(h)||await this.policyService.registerPolicyDefinitions(h),u}onDidChangePolicies(c){const h=d.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),u=(0,D.coalesce)(c.map(s=>h.get(s)));this.update(u,!0)}update(c,h){const u=d.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),s=[],e=this._configurationModel.isEmpty();for(const r of c){const t=u[r]?.policy?.name;if(t){const n=this.policyService.getPolicyValue(t);(e?n!==void 0:!(0,k.equals)(this._configurationModel.getValue(r),n))&&s.push([r,n])}else this._configurationModel.getValue(r)!==void 0&&s.push([r,void 0])}if(s.length){const r=this._configurationModel;this._configurationModel=new l.ConfigurationModel;for(const t of r.keys)this._configurationModel.setValue(t,r.getValue(t));for(const[t,n]of s)n===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,n);h&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};v=ge([ee(1,w.IPolicyService),ee(2,I.ILogService)],v),i.PolicyConfiguration=v}),define(Q[119],Z([0,1,3,4,2,18,21,64,118,37]),function(B,i,D,C,P,k,L,m,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class I extends P.Disposable{constructor(d,S,g,y){super(),this.settingsResource=d,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new l.DefaultConfiguration),this.policyConfiguration=g instanceof f.NullPolicyService?new l.NullPolicyConfiguration:this._register(new l.PolicyConfiguration(this.defaultConfiguration,g,y)),this.userConfiguration=this._register(new m.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,S)),this.configuration=new m.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new m.ConfigurationModel,new m.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:v,properties:a})=>this.onDidDefaultConfigurationChange(v,a))),this._register(this.policyConfiguration.onDidChangeConfiguration(v=>this.onDidPolicyConfigurationChange(v))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[d,S,g]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new m.Configuration(d,S,new m.ConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(d,S){const g=typeof d=="string"?d:void 0,y=(0,L.isConfigurationOverrides)(d)?d:(0,L.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(g,y,void 0)}updateValue(d,S,g,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const S=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(g,S,2)}onDidDefaultConfigurationChange(d,S){const g=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(d,S);this.trigger(y,g,7)}onDidPolicyConfigurationChange(d){const S=this.configuration.toData(),g=this.configuration.compareAndUpdatePolicyConfiguration(d);this.trigger(g,S,7)}trigger(d,S,g){const y=new m.ConfigurationChangeEvent(d,{data:S},this.configuration);y.source=g,y.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(d){switch(d){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=I}),define(Q[120],Z([0,1,17]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parseAuthorityWithOptionalPort=i.parseAuthorityWithPort=i.getRemoteServerRootPath=i.getRemoteName=i.getRemoteAuthority=void 0;function C(f){return f.scheme===D.Schemas.vscodeRemote?f.authority:void 0}i.getRemoteAuthority=C;function P(f){if(!f)return;const I=f.indexOf("+");return I<0?f:f.substr(0,I)}i.getRemoteName=P;function k(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}i.getRemoteServerRootPath=k;function L(f){const{host:I,port:w}=l(f);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:w}}i.parseAuthorityWithPort=L;function m(f,I){let{host:w,port:d}=l(f);return typeof d>"u"&&(d=I),{host:w,port:d}}i.parseAuthorityWithOptionalPort=m;function l(f){const I=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const w=f.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const d=f.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:f,port:void 0}}}),define(Q[34],Z([0,1,27,8,120]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.isApplicationScopedExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}i.getWorkspaceSupportTypeMessage=k;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}i.isIExtensionIdentifier=L,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var m;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(m=i.ExtensionType||(i.ExtensionType={}));var l;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(l=i.TargetPlatform||(i.TargetPlatform={}));class f{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,v){if(typeof y>"u"||y===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof y=="string"||typeof v=="string"){const a=typeof y=="string"?y:y.value,c=typeof v=="string"?v:v.value;return D.equalsIgnoreCase(a,c)}return y._lower===v._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}i.ExtensionIdentifier=f;function I(g){return w(g)}i.isApplicationScopedExtension=I;function w(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}i.isLanguagePackExtension=w;function d(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=d;function S(g,y){if(y){const v=`onResolveRemoteAuthority:${(0,P.getRemoteName)(y)}`;return g.activationEvents?.indexOf(v)!==-1}return!1}i.isResolverExtension=S,i.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,27,22,34,13,10,11,32]),function(B,i,D,C,P,k,L,m,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function f(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,D.compareIgnoreCase)(r.id,t.id)===0}i.areSameExtensions=f;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(t){const n=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,n,o)}static parse(t){const n=I.exec(t);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?f(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}i.ExtensionKey=w;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(r){const t=d.exec(r);return t&&t[1]?[y(t[1]),t[2]]:[y(r),void 0]}i.getIdAndVersion=S;function g(r,t){return`${r}.${t}`}i.getExtensionId=g;function y(r){return r.toLocaleLowerCase()}i.adoptToGalleryExtensionId=y;function v(r,t){return y(g(r,t))}i.getGalleryExtensionId=v;function a(r,t){const n=[],o=p=>{for(const E of n)if(E.some(b=>f(t(b),t(p))))return E;return null};for(const p of r){const E=o(p);E?E.push(p):n.push([p])}return n}i.groupByExtension=a;function c(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=c;function h(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}i.getGalleryExtensionTelemetryData=h,i.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function u(r,t){const n=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const p=o.shift();if(p&&n.every(E=>!f(E.identifier,{id:p}))){const E=r.filter(b=>f(b.identifier,{id:p}));E.length===1&&(n.push(E[0]),o.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}i.getExtensionDependencies=u;async function s(r,t){if(!k.isLinux)return!1;let n;try{n=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){t.debug("Error while getting the os-release file.",(0,m.getErrorMessage)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=s;async function e(r,t){const n=await s(r,t),o=(0,C.getTargetPlatform)(n?"alpine":k.platform,l.arch);return t.debug("ComputeTargetPlatform:",o),o}i.computeTargetPlatform=e}),define(Q[121],Z([0,1,24,11,17,18,39,10,84,22,23,34]),function(B,i,D,C,P,k,L,m,l,f,I,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLI=void 0;const d=v=>(0,l.localize)(0,null,v),S=(0,l.localize)(1,null,"ms-dotnettools.csharp");function g(v,a){return a?`${v.publisher}.${v.name}@${v.version}`:`${v.publisher}.${v.name}`}let y=class{constructor(a,c){this.extensionManagementService=a,this.extensionGalleryService=c}get location(){}async listExtensions(a,c,h,u=console){let s=await this.extensionManagementService.getInstalled(1,h);const e=w.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(c&&c!==""){if(e.indexOf(c.toLowerCase())<0){u.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){u.log("Possible Categories: "),e.forEach(t=>{u.log(t)});return}this.location&&u.log((0,l.localize)(2,null,this.location)),s=s.sort((t,n)=>t.identifier.id.localeCompare(n.identifier.id));let r;for(const t of s)r!==t.identifier.id&&(r=t.identifier.id,u.log(g(t.manifest,a)))}async installExtensions(a,c,h,u,s=console){const e=[],r=[];a.length&&s.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1,h.profileLocation),n=(b,R)=>{const j=t.find(_=>(0,I.areSameExtensions)(_.identifier,{id:b}));if(j){if(!u&&(!R||R==="prerelease"&&j.preRelease))return s.log((0,l.localize)(5,null,b,j.manifest.version,b)),!1;if(R&&j.manifest.version===R)return s.log((0,l.localize)(6,null,`${b}@${R}`)),!1}return!0},o=(b,R,j)=>{E.push({id:b,version:R!=="prerelease"?R:void 0,installOptions:{...h,isBuiltin:j,installPreReleaseVersion:R==="prerelease"||h.installPreReleaseVersion}})},p=[],E=[];for(const b of a)if(b instanceof m.URI)p.push(b);else{const[R,j]=(0,I.getIdAndVersion)(b);n(R,j)&&o(R,j,!1)}for(const b of c){const[R,j]=(0,I.getIdAndVersion)(b);n(R,j)&&o(R,j,!0)}if(p.length&&await Promise.all(p.map(async b=>{try{const R=await this.installVSIX(b,{...h,isBuiltin:!1},u,s);R&&r.push(R)}catch(R){s.error(R.message||R.stack||R),e.push(b.toString())}})),E.length){const b=await this.getGalleryExtensions(E);await Promise.all(E.map(async R=>{const j=b.get(R.id.toLowerCase());if(j)try{const _=await this.installFromGallery(R,j,t,u,s);_&&r.push(_)}catch(_){s.error(_.message||_.stack||_),e.push(R.id)}else s.error(`${d(R.version?`${R.id}@${R.version}`:R.id)}
${S}`),e.push(R.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(a,c,h,u){const s=await this.extensionManagementService.getManifest(a);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,h,c.profileLocation,u))try{return await this.extensionManagementService.install(a,c),u.log((0,l.localize)(8,null,(0,k.basename)(a))),s}catch(r){if((0,C.isCancellationError)(r))return u.log((0,l.localize)(9,null,(0,k.basename)(a))),null;throw r}return null}async getGalleryExtensions(a){const c=new Map,h=a.some(s=>s.installOptions.installPreReleaseVersion),u=await this.extensionGalleryService.getExtensions(a.map(s=>({...s,preRelease:h})),D.CancellationToken.None);for(const s of u)c.set(s.identifier.id.toLowerCase(),s);return c}async installFromGallery({id:a,version:c,installOptions:h},u,s,e,r){const t=await this.extensionGalleryService.getManifest(u,D.CancellationToken.None);if(t&&!this.validateExtensionKind(t,r))return null;const n=s.find(o=>(0,I.areSameExtensions)(o.identifier,u.identifier));if(n){if(u.version===n.manifest.version)return r.log((0,l.localize)(10,null,c?`${a}@${c}`:a)),null;r.log((0,l.localize)(11,null,a,u.version))}try{h.isBuiltin?r.log(c?(0,l.localize)(12,null,a,c):(0,l.localize)(13,null,a)):r.log(c?(0,l.localize)(14,null,a,c):(0,l.localize)(15,null,a));const o=await this.extensionManagementService.installFromGallery(u,{...h,installGivenVersion:!!c});return r.log((0,l.localize)(16,null,a,o.manifest.version)),t}catch(o){if((0,C.isCancellationError)(o))return r.log((0,l.localize)(17,null,a)),null;throw o}}validateExtensionKind(a,c){return!0}async validateVSIX(a,c,h,u){const s={id:(0,I.getGalleryExtensionId)(a.publisher,a.name)},r=(await this.extensionManagementService.getInstalled(1,h)).find(t=>(0,I.areSameExtensions)(s,t.identifier)&&(0,L.gt)(t.manifest.version,a.version));return r&&!c?(u.log((0,l.localize)(18,null,r.identifier.id,r.manifest.version,a.version)),!1):this.validateExtensionKind(a,u)}async uninstallExtensions(a,c,h,u=console){const s=async r=>{if(r instanceof m.URI){const t=await this.extensionManagementService.getManifest(r);return g(t)}return r},e=[];for(const r of a){const t=await s(r),o=(await this.extensionManagementService.getInstalled(void 0,h)).filter(p=>(0,I.areSameExtensions)(p.identifier,{id:t}));if(!o.length)throw new Error(`${this.notInstalled(t)}
${S}`);if(o.some(p=>p.type===0)){u.log((0,l.localize)(19,null,t));return}if(!c&&o.some(p=>p.isBuiltin)){u.log((0,l.localize)(20,null,t));return}u.log((0,l.localize)(21,null,t));for(const p of o)await this.extensionManagementService.uninstall(p,{profileLocation:h}),e.push(p);this.location?u.log((0,l.localize)(22,null,t,this.location)):u.log((0,l.localize)(23,null,t))}}async locateExtension(a,c=console){const h=await this.extensionManagementService.getInstalled();a.forEach(u=>{h.forEach(s=>{if(s.identifier.id===u&&s.location.scheme===P.Schemas.file){c.log(s.location.fsPath);return}})})}notInstalled(a){return this.location?(0,l.localize)(24,null,a,this.location):(0,l.localize)(25,null,a)}};y=ge([ee(0,f.IExtensionManagementService),ee(1,f.IExtensionGalleryService)],y),i.ExtensionManagementCLI=y}),define(Q[41],Z([0,1,3,15,2,36,10,23,12,8,9]),function(B,i,D,C,P,k,L,m,l,f,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsProfileScannerService=i.IExtensionsProfileScannerService=void 0,i.IExtensionsProfileScannerService=(0,f.createDecorator)("IExtensionsProfileScannerService");let w=class extends P.Disposable{constructor(S,g){super(),this.fileService=S,this.logService=g,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(S){return this.withProfileExtensions(S)}addExtensionsToProfile(S,g){return this.withProfileExtensions(g,y=>(y=y.filter(v=>S.some(([a])=>!(0,m.areSameExtensions)(v.identifier,a.identifier))),y.push(...S.map(([v,a])=>({identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:a}))),y))}removeExtensionFromProfile(S,g){return this.withProfileExtensions(g,y=>y.filter(v=>!(0,m.areSameExtensions)(v.identifier,S)))}async withProfileExtensions(S,g){return this.getResourceAccessQueue(S).queue(async()=>{let y=[];try{const v=await this.fileService.readFile(S),a=JSON.parse(v.value.toString());for(const c of a){if(!c.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",c);continue}if(!c.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",c);continue}if(!c.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",c);continue}y.push({identifier:c.identifier,location:L.URI.revive(c.location),version:c.version,metadata:c.metadata})}}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}if(g){y=g(y);const v=y.map(a=>({identifier:a.identifier,version:a.version,location:a.location.toJSON(),metadata:a.metadata}));await this.fileService.writeFile(S,C.VSBuffer.fromString(JSON.stringify(v)))}return y})}getResourceAccessQueue(S){let g=this.resourcesAccessQueueMap.get(S);return g||(g=new D.Queue,this.resourcesAccessQueueMap.set(S,g)),g}};w=ge([ee(0,l.IFileService),ee(1,I.ILogService)],w),i.ExtensionsProfileScannerService=w}),define(Q[122],Z([0,1,3,11,2,13,18,39,10,30,20,16,22,23,12,9]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let v=class extends P.Disposable{constructor(c,h,u,s){super(),this.fileService=h,this.extensionGalleryService=u,this.logService=s,this.extensionsDownloadDir=l.URI.file(c.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(c,h){await this.cleanUpPromise;const u=this.getName(c),s=(0,L.joinPath)(this.extensionsDownloadDir,u);if(!await this.fileService.exists(s)){const e=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(c,e,h);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(e)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",c.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,e.path),r}}return s}async delete(c){await this.cleanUpPromise,await this.fileService.del(c)}async rename(c,h,u){try{await I.Promises.rename(c.fsPath,h.fsPath)}catch(s){if(k.isWindows&&s&&s.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${c} to ${h} with 'EPERM' error. Trying again...`),this.rename(c,h,u);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const c=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(c.children){const h=[],u=[];for(const r of c.children){const t=S.ExtensionKey.parse(r.name);t&&u.push([t,r])}const s=(0,S.groupByExtension)(u,([r])=>r),e=[];for(const r of s)r.sort((t,n)=>m.rcompare(t[0].version,n[0].version)),h.push(...r.slice(1).map(t=>t[1].resource)),e.push(r[0][1]);e.sort((r,t)=>r.mtime-t.mtime),h.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(h.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(c){this.logService.error(c)}}getName(c){return this.cache?S.ExtensionKey.create(c).toString().toLowerCase():(0,f.generateUuid)()}};v=ge([ee(0,w.INativeEnvironmentService),ee(1,g.IFileService),ee(2,d.IExtensionGalleryService),ee(3,y.ILogService)],v),i.ExtensionsDownloader=v}),define(Q[123],Z([0,1,2,14,20,34]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(l,f){super(),this.environmentService=l,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(f.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(l){l.some(f=>!!f.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=L}),define(Q[124],Z([0,1,155,19,3,2,17,14,20,16,22,23,9,62]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeLanguagePackService=void 0;let g=class extends S.LanguagePackBaseService{constructor(c,h,u,s){super(u),this.extensionManagementService=c,this.logService=s,this.cache=this._register(new y(h,s)),this.extensionManagementService.registerParticipant({postInstall:async e=>this.postInstallExtension(e),postUninstall:async e=>this.postUninstallExtension(e)})}async getInstalledLanguages(){const c=await this.cache.getLanguagePacks(),h=Object.keys(c).map(u=>{const s=c[u];return{...this.createQuickPickItem(u,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return h.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),h.sort((u,s)=>u.label.localeCompare(s.label)),h}async postInstallExtension(c){c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",c.identifier.id),await this.update())}async postUninstallExtension(c){const h=await this.cache.getLanguagePacks();Object.keys(h).some(u=>h[u]&&h[u].extensions.some(s=>(0,w.areSameExtensions)(s.extensionIdentifier,c.identifier)))&&(this.logService.info("Removing language packs from the extension",c.identifier.id),await this.update())}async update(){const[c,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),u=await this.cache.update(h);return!(0,C.equals)(Object.keys(c),Object.keys(u))}};g=ge([ee(0,I.IExtensionManagementService),ee(1,f.INativeEnvironmentService),ee(2,I.IExtensionGalleryService),ee(3,d.ILogService)],g),i.NativeLanguagePackService=g;let y=class extends k.Disposable{constructor(c,h){super(),this.logService=h,this.languagePacks={},this.languagePacksFilePath=(0,m.join)(c.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(c){return this.withLanguagePacks(h=>{Object.keys(h).forEach(u=>delete h[u]),this.createLanguagePacksFromExtensions(h,...c)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(c,...h){for(const u of h)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(c,u);Object.keys(c).forEach(u=>this.updateHash(c[u]))}createLanguagePacksFromExtension(c,h){const u=h.identifier,s=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const e of s)if(h.location.scheme===L.Schemas.file&&v(e)){let r=c[e.languageId];r||(r={hash:"",extensions:[],translations:{},label:e.localizedLanguageName??e.languageName},c[e.languageId]=r);const t=r.extensions.filter(n=>(0,w.areSameExtensions)(n.extensionIdentifier,u))[0];t?t.version=h.manifest.version:r.extensions.push({extensionIdentifier:u,version:h.manifest.version});for(const n of e.translations)r.translations[n.id]=(0,m.join)(h.location.fsPath,n.path)}}updateHash(c){if(c){const h=(0,D.createHash)("md5");for(const u of c.extensions)h.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);c.hash=h.digest("hex")}}withLanguagePacks(c=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(h=c(u),u)).then(u=>{for(const e of Object.keys(u))u[e]||delete u[e];this.languagePacks=u,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),l.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>h,u=>this.logService.error(u))})}};y=ge([ee(0,f.INativeEnvironmentService),ee(1,d.ILogService)],y);function v(a){if(typeof a.languageId!="string"||!Array.isArray(a.translations)||a.translations.length===0)return!1;for(const c of a.translations)if(typeof c.id!="string"||typeof c.path!="string")return!1;return!(a.languageName&&typeof a.languageName!="string"||a.localizedLanguageName&&typeof a.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,15,94,40,8,33]),function(B,i,D,C,P,k,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,k.createDecorator)("requestService");function m(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}i.isSuccess=m;function l(y){return y.res.statusCode===204}async function f(y){return l(y)?null:(await(0,D.streamToBuffer)(y.stream)).toString()}i.asText=f;async function I(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);return f(y)}i.asTextOrError=I;async function w(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);if(l(y))return null;const a=(await(0,D.streamToBuffer)(y.stream)).toString();try{return JSON.parse(a)}catch(c){throw c.message+=`:
`+a,c}}i.asJson=w;function d(y){g(y)}i.updateProxyConfigurationsScope=d;let S;function g(y){const v=L.Registry.as(P.Extensions.Configuration),a=S;S={id:"http",order:15,title:(0,C.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(4,null),(0,C.localize)(5,null),(0,C.localize)(6,null),(0,C.localize)(7,null)],default:"override",description:(0,C.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[S],remove:a?[a]:[]})}g(2)}),define(Q[125],Z([0,1,24,17,12,47]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let L=class{constructor(l,f){this.requestService=l,this.fileService=f}async download(l,f,I=D.CancellationToken.None){if(l.scheme===C.Schemas.file||l.scheme===C.Schemas.vscodeRemote){await this.fileService.copy(l,f);return}const w={type:"GET",url:l.toString(!0)},d=await this.requestService.request(w,I);if(d.res.statusCode===200)await this.fileService.writeFile(f,d.stream);else{const S=await(0,k.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${S}`)}}};L=ge([ee(0,k.IRequestService),ee(1,P.IFileService)],L),i.DownloadService=L}),define(Q[126],Z([0,1,127,5]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function P(L,m){return L.protocol==="http:"?m.HTTP_PROXY||m.http_proxy||null:L.protocol==="https:"&&(m.HTTPS_PROXY||m.https_proxy||m.HTTP_PROXY||m.http_proxy)||null}async function k(L,m,l={}){const f=(0,D.parse)(L),I=l.proxyUrl||P(f,m);if(!I)return null;const w=(0,D.parse)(I);if(!/^https?:$/.test(w.protocol||""))return null;const d={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,C.isBoolean)(l.strictSSL)?l.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((S,g)=>{B(["http-proxy-agent"],S,g)}))(d):new(await new Promise((S,g)=>{B(["https-proxy-agent"],S,g)}))(d)}i.getProxyAgent=k}),define(Q[128],Z([0,1,57,14,95,24,31,11,13,30,77,156,3]),function(B,i,D,C,P,k,L,m,l,f,I,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const S=1e4;let g;async function y(a,c,h){return c["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(h)&&!c["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(h)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=d.Promises.withAsyncBody(async(u,s)=>{const e=new k.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),s(new Error((0,P.localize)(0,null)))},S);try{u(await v(a,e.token))}catch(t){!(0,m.isCancellationError)(t)&&!e.token.isCancellationRequested?s(new Error((0,P.localize)(1,null,(0,L.toErrorMessage)(t)))):u({})}finally{clearTimeout(r),e.dispose()}})),g)}i.getResolvedShellEnv=y;async function v(a,c){const h=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",h);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",u);const s=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",r);const t=await(0,I.getSystemShell)(l.OS,r);return a.trace("getUnixShellEnvironment#shell",t),new Promise((n,o)=>{if(c.isCancellationRequested)return o((0,m.canceled)());const p=(0,C.basename)(t);let E,b;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(p)?(E=`& '${process.execPath}' ${R} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,b=["-Login","-Command"]):(E=`'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,p==="tcsh"?b=["-ic"]:b=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),E);const j=(0,D.spawn)(t,[...b,E],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});c.onCancellationRequested(()=>(j.kill(),o((0,m.canceled)()))),j.on("error",H=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(H)),o(H)});const _=[];j.stdout.on("data",H=>_.push(H));const J=[];j.stderr.on("data",H=>J.push(H)),j.on("close",(H,ne)=>{const re=Buffer.concat(_).toString("utf8");a.trace("getUnixShellEnvironment#raw",re);const se=Buffer.concat(J).toString("utf8");if(se.trim()&&a.trace("getUnixShellEnvironment#stderr",se),H||ne)return o(new Error((0,P.localize)(2,null,H,ne)));const fe=e.exec(re),le=fe?fe[1]:"{}";try{const ie=JSON.parse(le);h?ie.ELECTRON_RUN_AS_NODE=h:delete ie.ELECTRON_RUN_AS_NODE,u?ie.ELECTRON_NO_ATTACH_CONSOLE=u:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",ie),n(ie)}catch(ie){a.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(ie)),o(ie)}})})}}),define(Q[65],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IStateService=void 0,i.IStateService=(0,D.createDecorator)("stateService")}),define(Q[129],Z([0,1,3,15,5,16,12,9]),function(B,i,D,C,P,k,L,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StateService=i.FileStorage=void 0;class l{constructor(w,d,S){this.storagePath=w,this.logService=d,this.fileService=S,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new D.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,d){const S=this.storage[w];return(0,P.isUndefinedOrNull)(S)?d:S}setItem(w,d){this.setItems([{key:w,data:d}])}setItems(w){let d=!1;for(const{key:S,data:g}of w)this.storage[S]!==g&&((0,P.isUndefinedOrNull)(g)?(0,P.isUndefined)(this.storage[S])||(this.storage[S]=void 0,d=!0):(this.storage[S]=g,d=!0));d&&this.save()}removeItem(w){(0,P.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,C.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}i.FileStorage=l;let f=class{constructor(w,d,S){this.fileStorage=new l(w.stateResource,d,S)}async init(){await this.fileStorage.init()}getItem(w,d){return this.fileStorage.getItem(w,d)}};f=ge([ee(0,k.IEnvironmentService),ee(1,m.ILogService),ee(2,L.IFileService)],f),i.StateService=f}),define(Q[66],Z([0,1,13,32,10,30]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function L(f){if(D.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function m(f,I,w,d,S,g,y,v,a,c){const h=Object.create(null);h["common.machineId"]=y,h.sessionID=(0,k.generateUuid)()+Date.now(),h.commitHash=S,h.version=g,h["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,D.PlatformToString)(D.platform),h["common.nodePlatform"]=C.platform,h["common.nodeArch"]=d,h["common.product"]=c||"desktop",v&&(h["common.msftInternal"]=v);let u=0;const s=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.isLinuxSnap&&(h["common.snap"]="true");const e=L(w);e&&(h["common.platformDetail"]=e);try{const r=await f.readFile(P.URI.file(a));h["common.source"]=r.value.toString().slice(0,30)}catch{}return h}i.resolveCommonProperties=m;function l(f){const I=C.env.USERDNSDOMAIN;if(!I)return!1;const w=I.toLowerCase();return f.some(d=>w===d)}i.verifyMicrosoftInternalDomain=l}),define(Q[35],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,D.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(C=i.TelemetryLevel||(i.TelemetryLevel={}));var P;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(P=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,5,21,66,35]),function(B,i,D,C,P,k,L,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.isInternalTelemetry=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class l{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,C.staticObservableValue)(0)}publicLog(e,r){return Promise.resolve(void 0)}publicLog2(e,r){return this.publicLog(e,r)}publicLogError(e,r){return Promise.resolve(void 0)}publicLogError2(e,r){return this.publicLogError(e,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=l,i.NullTelemetryService=new l;class f{async publicLog(e,r,t){}async publicLogError(e,r,t){}}i.NullEndpointTelemetryService=f,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(s,e){return e.onDidChangeConfiguration(r=>{r.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(r.source),configurationKeys:a(r.sourceConfig)})})}i.configurationTelemetry=I;function w(s,e){return!(e.disableTelemetry||!s.enableTelemetry||e.extensionTestsLocationURI)}i.supportsTelemetry=w;function d(s){const e=s.getValue(m.TELEMETRY_SETTING_ID),r=s.getValue("telemetry.enableCrashReporter");if(s.getValue(m.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(e??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=d;function S(s){const e={},r={},t={};v(s,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const o=t[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),e[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(e[n]=o)}return{properties:e,measurements:r}}i.validateTelemetryData=S;const g=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function y(s){if(!s)return"none";for(const e of g)if(s.startsWith(`${e}+`))return e;return"other"}i.cleanRemoteAuthority=y;function v(s,e,r=0,t){if(!!s)for(const n of Object.getOwnPropertyNames(s)){const o=s[n],p=t?t+n:n;Array.isArray(o)?e[p]=(0,D.safeStringify)(o):o instanceof Date?e[p]=o.toISOString():(0,P.isObject)(o)?r<2?v(o,e,r+1,p+"."):e[p]=(0,D.safeStringify)(o):e[p]=o}}function a(s){if(!s)return[];const e=[];return c(e,"",s),e}function c(s,e,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(t=>c(s,e?`${e}.${t}`:t,r[t])):s.push(e)}function h(s,e){const r=s.msftInternalDomains||[],t=e.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(r)||t}i.isInternalTelemetry=h;function u(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}i.getPiiPathsFromEnvironment=u}),define(Q[130],Z([0,1,103,42]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function P(k,L,m,l,f,I,w){const d={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${L.nameShort})`};if((0,C.supportsTelemetry)(L,m)&&(0,C.getTelemetryLevel)(l)===3){const S=await(0,D.getServiceMachineId)(m,f,I),{sessionId:g}=await w.getTelemetryInfo();d["X-Market-User-Id"]=S,d["VSCode-SessionId"]=g}return d}i.resolveMarketplaceHeaders=P}),define(Q[131],Z([0,1,11,26,42]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(l,f,I){const w=await new Promise((v,a)=>{B(["@microsoft/1ds-core-js"],v,a)}),d=await new Promise((v,a)=>{B(["@microsoft/1ds-post-js"],v,a)}),S=new w.AppInsightsCore,g=new d.PostChannel,y={instrumentationKey:l,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(I){y.extensionConfig={};const v={alwaysUseXhrOverride:!0,httpXHROverride:I};y.extensionConfig[g.identifier]=v}return S.initialize(y,[]),S.addTelemetryInitializer(v=>{f&&(v.ext=v.ext??{},v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),S}class m{constructor(f,I,w,d,S){this._isInternalTelemetry=f,this._eventPrefix=I,this._defaultData=w,this._xhrOverride=S,this.endPointUrl=k,this._defaultData||(this._defaultData={}),typeof d=="function"?this._aiCoreOrKey=d():this._aiCoreOrKey=d,this._asyncAiCore=null}_withAIClient(f){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){f(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=L(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{f(I)},I=>{(0,D.onUnexpectedError)(I),console.error(I)})}}log(f,I){if(!this._aiCoreOrKey)return;I=(0,C.mixin)(I,this._defaultData),I=(0,P.validateTelemetryData)(I);const w=this._eventPrefix+"/"+f;try{this._withAIClient(d=>{d.pluginVersionString=I?.properties.version??"Unknown",d.track({name:w,baseData:{name:w,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(f=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,f(void 0)})})}):Promise.resolve(void 0)}}i.AbstractOneDataSystemAppender=m}),define(Q[132],Z([0,1,2,26,52,13,27,96,21,40,133,28,33,35,42]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let y=class{constructor(c,h,u){this._configurationService=h,this._productService=u,this._experimentProperties={},this.telemetryLevel=new P.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=c.appenders,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(c,h){this._experimentProperties[c]=h}_updateTelemetryLevel(){let c=(0,g.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const u=h.usage?3:h.error?2:0;c=Math.min(c,u)}this.telemetryLevel.value=c}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const c=await this._commonProperties,h=c.sessionID,u=c["common.machineId"],s=c["common.firstSessionDate"],e=c["common.msftInternal"];return{sessionId:h,machineId:u,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(c,h,u,s){return this.telemetryLevel.value<h?Promise.resolve(void 0):this._commonProperties.then(e=>{u=(0,C.mixin)(u,e),u=(0,C.mixin)(u,this._experimentProperties),u=(0,C.cloneAndChange)(u,r=>{if(typeof r=="string")return this._cleanupInfo(r,s)}),this._appenders.forEach(r=>r.log(c,u))},e=>{console.error(e)})}publicLog(c,h,u){return this._log(c,3,h,u)}publicLog2(c,h,u){return this.publicLog(c,h,u)}publicLogError(c,h){return this._sendErrorTelemetry?this._log(c,2,h,!0):Promise.resolve(void 0)}publicLogError2(c,h){return this.publicLogError(c,h)}_anonymizeFilePaths(c){let h=c;const u=[];for(const t of this._cleanupPatterns)for(;;){const n=t.exec(c);if(!n)break;u.push([n.index,t.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,e=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(h="";;){const t=e.exec(c);if(!t)break;!s.test(t[0])&&u.every(([n,o])=>t.index<n||t.index>=o)&&(h+=c.substring(r,t.index)+"<REDACTED: user-file-path>",r=e.lastIndex)}return r<c.length&&(h+=c.substr(r)),h}_removePropertiesWithPossibleUserInfo(c){if(!c)return c;const h=c.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of u)if(s.regex.test(h))return`<REDACTED: ${s.label}>`;return c}_cleanupInfo(c,h){let u=c;h&&(u=this._anonymizeFilePaths(u));for(const s of this._cleanupPatterns)u=u.replace(s,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ge([ee(1,l.IConfigurationService),ee(2,w.IProductService)],y),i.TelemetryService=y;function v(){const a=(0,m.localize)(0,null,I.default.nameLong),c=I.default.privacyStatementUrl?(0,m.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,m.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=k.isWeb?"":(0,m.localize)(3,null),u=(0,m.localize)(4,null),s=(0,m.localize)(5,null),e=(0,m.localize)(6,null),r=(0,m.localize)(7,null),t=`
|       | ${u} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,m.localize)(8,null);return`
${a} ${c} ${h}

&nbsp;

${r}
${t}

&nbsp;

${n}
`}d.Registry.as(f.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,m.localize)(9,null),properties:{[S.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,m.localize)(10,null),(0,m.localize)(11,null),(0,m.localize)(12,null),(0,m.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),d.Registry.as(f.Extensions.Configuration).registerConfiguration({id:S.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,m.localize)(14,null),properties:{[S.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,m.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,m.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,m.localize)(17,null,`\`#${S.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[134],Z([0,1,157,131]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OneDataSystemAppender=void 0;class P extends C.AbstractOneDataSystemAppender{constructor(L,m,l,f){const I={sendPOST:(w,d)=>{const S={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const g=D.request(w.urlString,S,y=>{y.on("data",function(v){d(y.statusCode??200,y.headers,v.toString())}),y.on("error",function(v){d(0,{})})});g.write(w.data),g.end()}catch{d(0,{})}}};super(L,m,l,f,I)}}i.OneDataSystemAppender=P}),define(Q[135],Z([0,1,14,20]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function P(k,L){const m=Object.create(null),l=(I,w)=>{const d=JSON.parse(I);m[w]=d};if(L){const I=[],w=await C.Promises.readdir(L);for(const S of w)try{(await C.Promises.stat((0,D.join)(L,S))).isDirectory()&&I.push(S)}catch{}const d=[];for(const S of I)(await C.Promises.readdir((0,D.join)(L,S))).filter(y=>y==="telemetry.json").length===1&&d.push(S);for(const S of d){const g=(await C.Promises.readFile((0,D.join)(L,S,"telemetry.json"))).toString();l(g,S)}}let f=(await C.Promises.readFile((0,D.join)(k,"telemetry-core.json"))).toString();return l(f,"vscode-core"),f=(await C.Promises.readFile((0,D.join)(k,"telemetry-extensions.json"))).toString(),l(f,"vscode-extensions"),JSON.stringify(m,null,4)}i.buildTelemetryMessage=P}),define(Q[29],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Q[136],Z([0,1,4,2,10,16,23,12,9,29]),function(B,i,D,C,P,k,L,m,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let I=class extends C.Disposable{constructor(d,S,g,y,v){super(),this.extensionsManagementService=d,this.logService=y,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(c=>{this.installedExtensions=c.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(c=>this.onInstallExtension(c))),this._register(d.onDidInstallExtensions(c=>this.onDidInstallExtensions(c))),this._register(d.onDidUninstallExtension(c=>this.onDidUninstallExtension(c)));const a=P.URI.file(g.extensionsPath);this._register(S.watch(a)),this._register(D.Event.filter(S.onDidFilesChange,c=>c.rawChanges.some(h=>this.doesChangeAffects(h,a)))(()=>this.onDidChange()))}doesChangeAffects(d,S){return d.type!==1&&d.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),S)?!1:this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(d.resource).startsWith(".")}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const S of d)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(S=>!(0,L.areSameExtensions)(S,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,L.areSameExtensions)(S,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(),S=d.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,L.areSameExtensions)(v,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),g=this.installedExtensions.filter(y=>this.installingExtensions.some(v=>(0,L.areSameExtensions)(v,y))?!1:d.every(v=>!(0,L.areSameExtensions)(v.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=d.map(y=>y.identifier),(S.length||g.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:g})}}};I=ge([ee(1,m.IFileService),ee(2,k.INativeEnvironmentService),ee(3,l.ILogService),ee(4,f.IUriIdentityService)],I),i.ExtensionsWatcher=I}),define(Q[137],Z([0,1,29,104,12,18,69,4,2]),function(B,i,D,C,P,k,L,m,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class f{constructor(d){this.uri=d,this.time=f._clock++}touch(){return this.time=f._clock++,this}}f._clock=0;let I=class{constructor(d){this._fileService=d,this._dispooables=new l.DisposableStore,this._limit=2**16;const S=new Map,g=y=>{let v=S.get(y.scheme);return v===void 0&&(v=d.hasProvider(y)&&!this._fileService.hasCapability(y,1024),S.set(y.scheme,v)),v};this._dispooables.add(m.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{S.delete(y.scheme)})),this.extUri=new k.ExtUri(g),this._canonicalUris=new L.SkipList((y,v)=>this.extUri.compare(y,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,k.normalizePath)(d));const S=this._canonicalUris.get(d);return S?S.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new f(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((g,y)=>g[1].touch<y[1].touch?1:g[1].touch>y[1].touch?-1:0);f._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let g=0;g<S;g++)this._canonicalUris.set(d[g][0],d[g][1].touch())}};I=ge([ee(0,P.IFileService)],I),i.UriIdentityService=I,(0,C.registerSingleton)(D.IUriIdentityService,I,1)}),define(Q[138],Z([0,1,98,14,36,18,10,8,17]),function(B,i,D,C,P,k,L,m,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.hasWorkspaceFileExtension=i.isSavedWorkspace=i.isTemporaryWorkspace=i.isUntitledWorkspace=i.UNTITLED_WORKSPACE_NAME=i.WORKSPACE_FILTER=i.WORKSPACE_SUFFIX=i.WORKSPACE_EXTENSION=i.toWorkspaceFolder=i.WorkspaceFolder=i.Workspace=i.isWorkspaceFolder=i.isWorkspace=i.WorkbenchState=i.reviveIdentifier=i.isWorkspaceIdentifier=i.toWorkspaceIdentifier=i.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=i.isSingleFolderWorkspaceIdentifier=i.IWorkspaceContextService=void 0,i.IWorkspaceContextService=(0,m.createDecorator)("contextService");function f(r){const t=r;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}i.isSingleFolderWorkspaceIdentifier=f,i.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(r,t){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,C.basename)(r)}:t?i.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=r;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}i.toWorkspaceIdentifier=I;function w(r){const t=r;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}i.isWorkspaceIdentifier=w;function d(r){const t=r;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:L.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}i.reviveIdentifier=d;var S;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(S=i.WorkbenchState||(i.WorkbenchState={}));function g(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}i.isWorkspace=g;function y(r){const t=r;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}i.isWorkspaceFolder=y;class v{constructor(t,n,o,p,E){this._id=t,this._transient=o,this._configuration=p,this._ignorePathCasing=E,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}i.Workspace=v;class a{constructor(t,n){this.raw=n,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,k.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}i.WorkspaceFolder=a;function c(r){return new a({uri:r,index:0,name:(0,k.basenameOrAuthority)(r)},{uri:r.toString()})}i.toWorkspaceFolder=c,i.WORKSPACE_EXTENSION="code-workspace",i.WORKSPACE_SUFFIX=`.${i.WORKSPACE_EXTENSION}`,i.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[i.WORKSPACE_EXTENSION]}],i.UNTITLED_WORKSPACE_NAME="workspace.json";function h(r,t){return k.extUriBiasedIgnorePathCase.isEqualOrParent(r,t.untitledWorkspacesHome)}i.isUntitledWorkspace=h;function u(r){let t;return L.URI.isUri(r)?t=r:t=r.configuration,t?.scheme===l.Schemas.tmp}i.isTemporaryWorkspace=u;function s(r,t){return!h(r,t)&&!u(r)}i.isSavedWorkspace=s;function e(r){return(typeof r=="string"?(0,C.extname)(r):(0,k.extname)(r))===i.WORKSPACE_SUFFIX}i.hasWorkspaceFileExtension=e}),define(Q[25],Z([0,1,53,4,2,18,5,10,97,16,12,8,9,138,36,29,3,30,27]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g,y,v,a,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryUserDataProfilesService=i.UserDataProfilesService=i.toUserDataProfile=i.EXTENSIONS_RESOURCE_NAME=i.reviveProfile=i.IUserDataProfilesService=i.PROFILES_ENABLEMENT_CONFIG=i.isUserDataProfile=void 0;function h(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&m.URI.isUri(n.location)&&m.URI.isUri(n.globalStorageHome)&&m.URI.isUri(n.settingsResource)&&m.URI.isUri(n.keybindingsResource)&&m.URI.isUri(n.tasksResource)&&m.URI.isUri(n.snippetsHome)&&((0,L.isUndefined)(n.extensionsResource)||m.URI.isUri(n.extensionsResource)))}i.isUserDataProfile=h,i.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",i.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function u(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:m.URI.revive(t.location).with({scheme:n}),globalStorageHome:m.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:m.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:m.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:m.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:m.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:m.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}i.reviveProfile=u,i.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(t,n,o,p){return{id:t,name:n,location:o,isDefault:!1,shortName:p?.shortName,globalStorageHome:(0,k.joinPath)(o,"globalStorage"),settingsResource:(0,k.joinPath)(o,"settings.json"),keybindingsResource:(0,k.joinPath)(o,"keybindings.json"),tasksResource:(0,k.joinPath)(o,"tasks.json"),snippetsHome:(0,k.joinPath)(o,"snippets"),extensionsResource:(0,k.joinPath)(o,i.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:p?.useDefaultFlags,isTransient:p?.transient}}i.toUserDataProfile=s;let e=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,p,E){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=p,this.logService=E,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new C.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new C.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new C.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new C.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new g.ResourceMap},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(b=>s((0,k.basename)(b.location),b.name,b.location,{shortName:b.shortName,useDefaultFlags:b.useDefaultFlags})):[];let o;const p=new g.ResourceMap,E=s((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,l.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...E,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?E.extensionsResource:void 0}),n.length){const b=this.getStoredProfileAssociations();if(b.workspaces)for(const[R,j]of Object.entries(b.workspaces)){const _=m.URI.parse(R),J=m.URI.parse(j),H=n.find(ne=>this.uriIdentityService.extUri.isEqual(ne.location,J));H&&p.set(_,H)}if(b.emptyWindow){const R=m.URI.parse(b.emptyWindow);o=n.find(j=>this.uriIdentityService.extUri.isEqual(j.location,R))}}this._profilesObject={profiles:n,workspaces:p,emptyWindow:o}}return this._profilesObject}async createTransientProfile(n){const o="Temp",p=new RegExp(`${(0,c.escapeRegExpCharacters)(o)}\\s(\\d+)`);let E=0;for(const R of this.profiles){const j=p.exec(R.name),_=j?parseInt(j[1]):0;E=_>E?_:E}const b=`${o} ${E+1}`;return this.createProfile((0,D.hash)((0,a.generateUuid)()).toString(16),b,{transient:!0},n)}async createNamedProfile(n,o,p){return this.createProfile((0,D.hash)((0,a.generateUuid)()).toString(16),n,o,p)}async createProfile(n,o,p,E){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const b=await this.doCreateProfile(n,o,p);return E&&await this.setProfileForWorkspace(E,b),b}async doCreateProfile(n,o,p){let E=this.profileCreationPromises.get(o);return E||(E=(async()=>{try{const b=this.profiles.find(_=>_.name===o||_.id===n);if(b)return b;const R=s(n,o,(0,k.joinPath)(this.profilesHome,n),p);await this.fileService.createFolder(R.location);const j=[];return this._onWillCreateProfile.fire({profile:R,join(_){j.push(_)}}),await v.Promises.settled(j),this.updateProfiles([R],[],[]),R}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,E)),E}async updateProfile(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);let p=this.profiles.find(E=>E.id===n.id);if(!p)throw new Error(`Profile '${n.name}' does not exist`);return p=s(p.id,o.name??p.name,p.location,{shortName:o.shortName??p.shortName,transient:o.transient??p.isTransient,useDefaultFlags:o.useDefaultFlags??p.useDefaultFlags}),this.updateProfiles([],[],[p]),p}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(E=>E.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const p=[];this._onWillRemoveProfile.fire({profile:o,join(E){p.push(E)}});try{await Promise.allSettled(p)}catch(E){this.logService.error(E)}o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const E of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(E)?.id&&this.profilesObject.workspaces.delete(E);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(E){this.logService.error(E)}}getOrSetProfileForWorkspace(n,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let p=this.getProfileForWorkspace(n);return p||(p=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,p)),p}async setProfileForWorkspace(n,o){this.setProfileForWorkspaceSync(n,o)}setProfileForWorkspaceSync(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const p=this.profiles.find(E=>E.id===o.id);if(!p)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,p)}unsetWorkspace(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(p=>!this.uriIdentityService.extUri.isEqual(p.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return m.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,S.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,S.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,p){const E=[...this.profiles,...n],b=[];this.transientProfilesObject.profiles=[];for(let R of E)R.isDefault||o.some(j=>R.id===j.id)||(R=p.find(j=>R.id===j.id)??R,R.isTransient?this.transientProfilesObject.profiles.push(R):b.push({location:R.location,name:R.name,shortName:R.shortName,useDefaultFlags:R.useDefaultFlags}));this.saveStoredProfiles(b),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,p)}triggerProfilesChanges(n,o,p){this._onDidChangeProfiles.fire({added:n,removed:o,updated:p,all:this.profiles})}updateWorkspaceAssociation(n,o,p){p=o?.isTransient?!0:p,p||this.updateWorkspaceAssociation(n,void 0,!0);const E=this.getWorkspace(n),b=p?this.transientProfilesObject:this.profilesObject;m.URI.isUri(E)?(b.workspaces.delete(E),o&&b.workspaces.set(E,o)):b.emptyWindow=o,p||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[p,E]of this.profilesObject.workspaces.entries())n[p.toString()]=E.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};e.PROFILES_KEY="userDataProfiles",e.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e=ge([ee(0,f.IEnvironmentService),ee(1,I.IFileService),ee(2,y.IUriIdentityService),ee(3,d.ILogService)],e),i.UserDataProfilesService=e;class r extends e{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}i.InMemoryUserDataProfilesService=r}),define(Q[139],Z([0,1,19,3,24,11,4,2,13,10,82,22,23,34,9,28,35,25]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g,y,v,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let c=class extends m.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,n,o,p,E){super(),this.galleryService=t,this.telemetryService=n,this.logService=o,this.productService=p,this.userDataProfilesService=E,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this.participants=[],this._register((0,m.toDisposable)(()=>{this.installingExtensions.forEach(({task:b})=>b.cancel()),this.uninstallingExtensions.forEach(b=>b.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(I.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,n)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),u(o)}}async uninstall(t,n={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,n)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const n=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:n,compatible:!0},P.CancellationToken.None);if(!o)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,n,o){const p=J=>`${d.ExtensionKey.create(J).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!f.URI.isUri(n)){const J=this.installingExtensions.get(p(n));if(J){this.logService.info("Extensions is already requested to install",n.identifier.id);const{local:H}=await J.task.waitUntilTaskIsFinished();return H}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const E=[],b=[],R=[],j=this.createInstallExtensionTask(t,n,o);f.URI.isUri(n)||this.installingExtensions.set(p(n),{task:j,waitingTasks:[]}),this._onInstallExtension.fire({identifier:j.identifier,source:n,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",j.identifier.id),E.push({task:j,manifest:t});let _=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",j.identifier.id);else try{const H=await this.getAllDepsAndPackExtensions(j.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ne=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:re,manifest:se}of H){_=_||!!se.extensionDependencies?.some(ie=>(0,d.areSameExtensions)({id:ie},j.identifier));const fe=p(re),le=this.installingExtensions.get(fe);if(le){if(this.canWaitForTask(j,le.task)){this.logService.info("Waiting for already requested installing extension",re.identifier.id,j.identifier.id),le.waitingTasks.push(j);const ie=le.task.identifier;b.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,V=>V.some(N=>(0,d.areSameExtensions)(N.identifier,ie)))).then(V=>{if(!V.find(F=>(0,d.areSameExtensions)(F.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!ne.some(({identifier:ie})=>(0,d.areSameExtensions)(ie,re.identifier))){const ie=this.createInstallExtensionTask(se,re,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(fe,{task:ie,waitingTasks:[j]}),this._onInstallExtension.fire({identifier:ie.identifier,source:re,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",ie.identifier.id,j.identifier.id),E.push({task:ie,manifest:se})}}}catch(H){if(f.URI.isUri(j.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",j.identifier.id,H.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",j.identifier.id,H.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",j.identifier.id),H}const J=E.reduce((H,{task:ne,manifest:re})=>(H.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:re}),H),new Map);for(;J.size;){let H;const ne=[...J.values()].filter(({manifest:re})=>!re.extensionDependencies?.some(se=>J.has(se.toLowerCase())));ne.length?H=J.size===1?ne:ne.filter(({task:re})=>!(re===j&&!_)):(this.logService.info("Found extensions with circular dependencies",ne.map(({task:re})=>re.identifier.id)),H=[...J.values()]),await this.joinAllSettled(H.map(async({task:re})=>{const se=new Date().getTime();try{const{local:fe}=await re.run();if(await this.joinAllSettled(this.participants.map(le=>le.postInstall(fe,re.source,o,P.CancellationToken.None))),!f.URI.isUri(re.source)){const le=re.operation===3,ie=le?void 0:(new Date().getTime()-re.source.lastUpdated)/1e3;if(s(this.telemetryService,le?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(re.source),duration:new Date().getTime()-se,durationSinceUpdate:ie}),l.isWeb&&re.operation!==3)try{await this.galleryService.reportStatistic(fe.manifest.publisher,fe.manifest.name,fe.manifest.version,"install")}catch{}}R.push({local:fe,identifier:re.identifier,operation:re.operation,source:re.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:fe.isApplicationScoped})}catch(fe){throw f.URI.isUri(re.source)||s(this.telemetryService,re.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(re.source),duration:new Date().getTime()-se,error:fe}),this.logService.error("Error while installing the extension:",re.identifier.id),fe}finally{J.delete(re.identifier.id.toLowerCase())}}))}return b.length&&await this.joinAllSettled(b),R.forEach(({identifier:H})=>this.logService.info("Extension installed successfully:",H.id)),this._onDidInstallExtensions.fire(R),R.filter(({identifier:H})=>(0,d.areSameExtensions)(H,j.identifier))[0].local}catch(J){if(E.forEach(({task:H})=>H.cancel()),R.length)try{const H=await Promise.allSettled(R.map(({local:ne})=>this.createUninstallExtensionTask(ne,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ne=0;ne<H.length;ne++){const re=H[ne],{identifier:se}=R[ne];re.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",se.id):this.logService.warn("Rollback: Error while uninstalling extension",se.id,(0,k.getErrorMessage)(re.reason))}}catch(H){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(H),R.map(({identifier:ne})=>ne.id))}throw this._onDidInstallExtensions.fire(E.map(({task:H})=>({identifier:H.identifier,operation:2,source:H.source,context:o.context,profileLocation:o.profileLocation}))),J}finally{for(const[J,{task:H,waitingTasks:ne}]of this.installingExtensions.entries()){const re=ne.indexOf(j);re!==-1&&ne.splice(re,1),ne.length===0&&(H===j||re!==-1)&&this.installingExtensions.delete(J)}}}canWaitForTask(t,n){for(const[,{task:o,waitingTasks:p}]of this.installingExtensions.entries())if(o===t&&(p.includes(n)||p.some(E=>this.canWaitForTask(E,n)))||o===n&&p[0]&&!this.canWaitForTask(t,p[0]))return!1;return!0}async joinAllSettled(t){const n=[],o=[],p=await Promise.allSettled(t);for(const E of p)E.status==="fulfilled"?n.push(E.value):o.push(E.reason);if(o.length)throw h(o);return n}async getAllDepsAndPackExtensions(t,n,o,p,E){if(!this.galleryService.isEnabled())return[];const b=await this.getInstalled(void 0,E),R=[t],j=[],_=async(J,H)=>{const ne=H.extensionDependencies||[],re=[...ne];if(H.extensionPack){const se=o?b.find(fe=>(0,d.areSameExtensions)(fe.identifier,J)):void 0;for(const fe of H.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(le=>(0,d.areSameExtensions)({id:le},{id:fe}))||re.every(le=>!(0,d.areSameExtensions)({id:le},{id:fe}))&&re.push(fe)}if(re.length){const se=[...R,...j.map(le=>le.gallery.identifier)],fe=re.filter(le=>se.every(ie=>!(0,d.areSameExtensions)(ie,{id:le})));if(fe.length){const le=await this.galleryService.getExtensions(fe.map(ie=>({id:ie,preRelease:p})),P.CancellationToken.None);for(const ie of le){if(se.find(F=>(0,d.areSameExtensions)(F,ie.identifier)))continue;const V=ne.some(F=>(0,d.areSameExtensions)({id:F},ie.identifier));let N;try{N=await this.checkAndGetCompatibleVersion(ie,!1,p)}catch(F){if(F instanceof w.ExtensionManagementError&&F.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!V){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw F}j.push({gallery:N.extension,manifest:N.manifest}),await _(N.extension.identifier,N.manifest)}}}};return await _(t,n),j}async checkAndGetCompatibleVersion(t,n,o){if((await this.getExtensionsControlManifest()).malicious.some(R=>(0,d.areSameExtensions)(t.identifier,R)))throw new w.ExtensionManagementError(I.localize(3,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const R=await this.getTargetPlatform();throw new w.ExtensionManagementError(I.localize(4,null,t.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(R)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const E=await this.getCompatibleVersion(t,n,o);if(E){if(o&&!n&&t.hasPreReleaseVersion&&!E.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(I.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],P.CancellationToken.None))[0]?new w.ExtensionManagementError(I.localize(6,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(I.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",E.identifier.id);const b=await this.galleryService.getManifest(E,P.CancellationToken.None);if(b===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(b.version!==E.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:b}}async getCompatibleVersion(t,n,o){const p=await this.getTargetPlatform();let E=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(E=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:p,compatible:!0},P.CancellationToken.None))[0]||null),!E&&await this.galleryService.isExtensionCompatible(t,o,p)&&(E=t),E||(n?E=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:p,compatible:!0},P.CancellationToken.None))[0]||null:E=await this.galleryService.getCompatibleExtension(t,o,p)),E}async uninstallExtension(t,n){const o=_=>`${_.id.toLowerCase()}${n.versionOnly?`-${t.manifest.version}`:""}${n.profileLocation?`@${n.profileLocation.toString()}`:""}`,p=this.uninstallingExtensions.get(o(t.identifier));if(p)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),p.waitUntilTaskIsFinished();const E=(_,J)=>{const H=this.createUninstallExtensionTask(_,J);return this.uninstallingExtensions.set(o(H.extension.identifier),H),n.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped}),H},b=(_,J)=>{J?n.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString(),J.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,J.message):n.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(_),error:J}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:J?.code,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped})},R=[],j=[];try{R.push(E(t,n));const _=await this.getInstalled(1,n.profileLocation);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const J=this.getAllPackExtensionsToUninstall(t,_);for(const H of J)this.uninstallingExtensions.has(o(H.identifier))?this.logService.info("Extensions is already requested to uninstall",H.identifier.id):R.push(E(H,n))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(R.map(J=>J.extension),_,t),await this.joinAllSettled(R.map(async J=>{try{if(await J.run(),await this.joinAllSettled(this.participants.map(H=>H.postUninstall(J.extension,n,P.CancellationToken.None))),J.extension.identifier.uuid)try{await this.galleryService.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}b(J.extension)}catch(H){const ne=H instanceof w.ExtensionManagementError?H:new w.ExtensionManagementError((0,k.getErrorMessage)(H),w.ExtensionManagementErrorCode.Internal);throw b(J.extension,ne),ne}finally{j.push(J)}}))}catch(_){const J=_ instanceof w.ExtensionManagementError?_:new w.ExtensionManagementError((0,k.getErrorMessage)(_),w.ExtensionManagementErrorCode.Internal);for(const H of R){try{H.cancel()}catch{}j.includes(H)||b(H.extension,J)}throw J}finally{for(const _ of R)this.uninstallingExtensions.delete(o(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(t,n,o){for(const p of t){const E=this.getDependents(p,n);if(E.length){const b=E.filter(R=>!t.some(j=>(0,d.areSameExtensions)(j.identifier,R.identifier)));if(b.length)throw new Error(this.getDependentsErrorMessage(p,b,o))}}}getDependentsErrorMessage(t,n,o){return o===t?n.length===1?I.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(9,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(10,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?I.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(t,n,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const p=t.manifest.extensionPack?t.manifest.extensionPack:[];if(p.length){const E=n.filter(R=>!R.isBuiltin&&p.some(j=>(0,d.areSameExtensions)({id:j},R.identifier))),b=[];for(const R of E)b.push(...this.getAllPackExtensionsToUninstall(R,n,o));return[...E,...b]}return[]}getDependents(t,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(p=>(0,d.areSameExtensions)({id:p},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,n,o){return o.profileLocation&&(0,S.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,n,o)}createUninstallExtensionTask(t,n){return n.profileLocation&&t.isApplicationScoped&&(n={...n,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,n)}};c=ge([ee(0,w.IExtensionGalleryService),ee(1,v.ITelemetryService),ee(2,g.ILogService),ee(3,y.IProductService),ee(4,a.IUserDataProfilesService)],c),i.AbstractExtensionManagementService=c;function h(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((n,o)=>new Error(`${n.message}${n.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}i.joinErrors=h;function u(r){if(r instanceof w.ExtensionManagementError)return r;const t=new w.ExtensionManagementError(r.message,w.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function s(r,t,{extensionData:n,duration:o,error:p,durationSinceUpdate:E}){const b=p?p instanceof w.ExtensionManagementError?p.code:w.ExtensionManagementErrorCode.Internal:void 0;r.publicLog(t,{...n,success:!p,duration:o,errorcode:b,durationSinceUpdate:E})}i.reportTelemetry=s;class e{constructor(){this.barrier=new C.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(t=>new Promise((n,o)=>{const p=t.onCancellationRequested(()=>{p.dispose(),o(new k.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=e}),define(Q[48],Z([0,1,19,3,26,15,11,50,74,2,17,14,13,18,39,54,5,10,86,16,23,34,45,12,8,9,28,4,44,41,25,29,102]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g,y,v,a,c,h,u,s,e,r,t,n,o,p,E,b,R,j,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var J;(function(ie){function V(N,F){if(N===F)return!0;const z=Object.keys(N),$=new Set;for(const Y of Object.keys(F))$.add(Y);if(z.length!==$.size)return!1;for(const Y of z){if(N[Y]!==F[Y])return!1;$.delete(Y)}return $.size===0}ie.equals=V})(J=i.Translations||(i.Translations={})),i.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let H=class extends f.Disposable{constructor(V,N,F,z,$,Y,A,U,T,O,M){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=N,this.extensionsControlLocation=F,this.cacheLocation=z,this.userDataProfilesService=$,this.extensionsProfileScannerService=Y,this.fileService=A,this.logService=U,this.environmentService=T,this.productService=O,this.instantiationService=M,this._onDidChangeCache=this._register(new p.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,S.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,S.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,S.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,N,F){const[z,$]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(N)]),Y=F?await this.scanExtensionsUnderDevelopment(V,[...z,...$]):[];return this.dedupExtensions(z,$,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const N=[];N.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),N.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[F,z]=await Promise.all(N);return this.applyScanOptions([...F,...z],0,V,!1)}async scanUserExtensions(V){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(V.profileLocation??this.userExtensionsLocation,!!V.profileLocation,1,!V.includeUninstalled,V.language);let z=await(V.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return z=await this.applyScanOptions(z,1,V,!0),this.logService.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(V,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===I.Schemas.file).map(async z=>{const $=await this.createExtensionScannerInput(z,!1,1,!0,V.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(A=>(A.type=N.find(U=>(0,u.areSameExtensions)(U.identifier,A.identifier))?.type??A.type,this.extensionsScanner.validate(A,$)))}))).flat();return this.applyScanOptions(F,"development",V,!0)}return[]}async scanExistingExtension(V,N,F){const z=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanExtension(z);return!$||!F.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(V,N,F){const z=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions($,N,F,!0)}async scanMetadata(V){const N=(0,S.joinPath)(V,"package.json"),F=(await this.fileService.readFile(N)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(V,N){const F=(0,S.joinPath)(V,"package.json"),z=(await this.fileService.readFile(F)).value.toString(),$=JSON.parse(z);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,$.__metadata={...$.__metadata,...N},await this.fileService.writeFile((0,S.joinPath)(V,"package.json"),k.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(V,N,F,z){return F.includeAllVersions||(V=this.dedupExtensions(N===0?V:void 0,N===1?V:void 0,N==="development"?V:void 0,await this.getTargetPlatform(),z)),F.includeInvalid||(V=V.filter($=>$.isValid)),V.sort(($,Y)=>{const A=w.basename($.location.fsPath),U=w.basename(Y.location.fsPath);return A<U?-1:A>U?1:0})}dedupExtensions(V,N,F,z,$){const Y=(U,T,O)=>{if(U.isValid&&!T.isValid)return!1;if(U.isValid===T.isValid){if($&&g.gt(U.manifest.version,T.manifest.version))return this.logService.debug(`Skipping extension ${T.location.path} with lower version ${T.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(g.eq(U.manifest.version,T.manifest.version)){if(U.type===0)return this.logService.debug(`Skipping extension ${T.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===z)return this.logService.debug(`Skipping extension ${T.location.path} from different target platform ${T.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${U.location.path} with ${T.location.path}.`):this.logService.debug(`Overwriting user extension ${U.location.path} with ${T.location.path}.`),!0},A=new Map;return V?.forEach(U=>{const T=s.ExtensionIdentifier.toKey(U.identifier.id),O=A.get(T);(!O||Y(O,U,!1))&&A.set(T,U)}),N?.forEach(U=>{const T=s.ExtensionIdentifier.toKey(U.identifier.id),O=A.get(T);if(!O&&V&&U.type===0){this.logService.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!O||Y(O,U,!1))&&A.set(T,U)}),F?.forEach(U=>{const T=s.ExtensionIdentifier.toKey(U.identifier.id),O=A.get(T);(!O||Y(O,U,!0))&&A.set(T,U),A.set(T,U)}),[...A.values()]}async scanDefaultSystemExtensions(V,N){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),$=await(V&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(V,N){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=N?await this.getBuiltInExtensionControl():{},$=[],Y=a.URI.file(w.normalize(w.join(I.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions")));for(const U of F){const T=z[U.name]||"marketplace";switch(T){case"disabled":break;case"marketplace":$.push((0,S.joinPath)(Y,U.name));break;default:$.push(a.URI.file(T));break}}const A=await Promise.all($.map(async U=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(U,!1,0,!0,V))));return this.logService.trace("Scanned dev system extensions:",A.length),(0,D.coalesce)(A)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,N,F,z,$,Y=!0){const A=await this.getTranslations($??d.language),U=await this.getMtime(V),T=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=T?await this.getMtime(T):void 0;return new ne(V,U,T,O,N,F,z,Y,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,A)}async getMtime(V){try{const N=await this.fileService.stat(V);if(typeof N.mtime=="number")return N.mtime}catch{}}};H=ge([ee(4,R.IUserDataProfilesService),ee(5,b.IExtensionsProfileScannerService),ee(6,r.IFileService),ee(7,n.ILogService),ee(8,h.IEnvironmentService),ee(9,o.IProductService),ee(10,t.IInstantiationService)],H),i.AbstractExtensionsScannerService=H;class ne{constructor(V,N,F,z,$,Y,A,U,T,O,M,W,q,K){this.location=V,this.mtime=N,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=z,this.profile=$,this.type=Y,this.excludeObsolete=A,this.validate=U,this.productVersion=T,this.productDate=O,this.productCommit=M,this.devMode=W,this.language=q,this.translations=K}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,N){return(0,S.isEqual)(V.location,N.location)&&V.mtime===N.mtime&&(0,S.isEqual)(V.applicationExtensionslocation,N.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&V.profile===N.profile&&V.type===N.type&&V.excludeObsolete===N.excludeObsolete&&V.validate===N.validate&&V.productVersion===N.productVersion&&V.productDate===N.productDate&&V.productCommit===N.productCommit&&V.devMode===N.devMode&&V.language===N.language&&J.equals(V.translations,N.translations)}}let re=class extends f.Disposable{constructor(V,N,F,z,$){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=N,this.uriIdentityService=F,this.fileService=z,this.logService=$}async scanExtensions(V){const N=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let F={};if(V.excludeObsolete&&V.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(z)}catch{}return(0,v.isEmptyObject)(F)?N:N.filter(z=>!F[u.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(V){const N=await this.fileService.resolve(V.location);if(!N.children?.length)return[];const F=await Promise.all(N.children.map(async z=>{if(!z.isDirectory||V.type===1&&(0,S.basename)(z.resource).indexOf(".")===0)return null;const $=new ne(z.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension($)}));return(0,D.coalesce)(F).sort((z,$)=>z.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(V){let N=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){N=N.filter(z=>!z.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,V);N.push(...F)}return N}async scanExtensionsFromProfileResource(V,N,F){const z=await this.extensionsProfileScannerService.scanProfileExtensions(V);if(!z.length)return[];const $=await Promise.all(z.map(async Y=>{if(N(Y)){const A=new ne(Y.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(A,Y.metadata)}return null}));return(0,D.coalesce)($)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,S.joinPath)(V.location,"package.json"))){const N=await this.scanExtension(V);return N?[N]:[]}else return await this.scanExtensions(V)}catch(N){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,L.getErrorMessage)(N)),[]}}async scanExtension(V,N){try{let F=await this.scanExtensionManifest(V.location);if(F){F.publisher||(F.publisher=s.UNDEFINED_PUBLISHER),N=N??F.__metadata,delete F.__metadata;const z=(0,u.getGalleryExtensionId)(F.publisher,F.name),$=N?.id?{id:z,uuid:N.id}:{id:z},Y=N?.isSystem?0:V.type,A=Y===0||!!N?.isBuiltin;F=await this.translateManifest(V.location,F,ne.createNlsConfiguration(V));const U={type:Y,identifier:$,manifest:F,location:V.location,isBuiltin:A,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return V.validate?this.validate(U,V):U}}catch(F){V.type!==0&&this.logService.error(F)}return null}validate(V,N){let F=!0;const z=(0,e.validateExtensionManifest)(N.productVersion,N.productDate,N.location,V.manifest,V.isBuiltin);for(const[$,Y]of z)$===y.default.Error&&(F=!1,this.logService.error(this.formatMessage(N.location,Y)));return V.isValid=F,V.validations=z,V}async scanExtensionManifest(V){const N=(0,S.joinPath)(V,"package.json");let F;try{F=(await this.fileService.readFile(N)).value.toString()}catch($){return(0,r.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(V,(0,c.localize)(0,null,N.path,$.message))),null}let z;try{z=JSON.parse(F)}catch{const Y=[];(0,m.parse)(F,Y);for(const A of Y)this.logService.error(this.formatMessage(V,(0,c.localize)(1,null,N.path,A.offset,A.length,(0,l.getParseErrorMessage)(A.error))));return null}return(0,m.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(V,(0,c.localize)(2,null,N.path))),null):z}async translateManifest(V,N,F){const z=await this.getLocalizedMessages(V,N,F);if(z)try{const $=[],Y=await this.resolveOriginalMessageBundle(z.default,$);if($.length>0)return $.forEach(U=>{this.logService.error(this.formatMessage(V,(0,c.localize)(3,null,z.default?.path,(0,l.getParseErrorMessage)(U.error))))}),N;if((0,m.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(V,(0,c.localize)(4,null,z.default?.path))),N;const A=z.values||Object.create(null);return(0,_.localizeManifest)(N,A,Y)}catch{}return N}async getLocalizedMessages(V,N,F){const z=(0,S.joinPath)(V,"package.nls.json"),$=(T,O)=>{O.forEach(M=>{this.logService.error(this.formatMessage(V,(0,c.localize)(5,null,T?.path,(0,l.getParseErrorMessage)(M.error))))})},Y=T=>{this.logService.error(this.formatMessage(V,(0,c.localize)(6,null,T?.path)))},A=`${N.publisher}.${N.name}`,U=F.translations[A];if(U)try{const T=a.URI.file(U),O=(await this.fileService.readFile(T)).value.toString(),M=[],W=(0,m.parse)(O,M);return M.length>0?($(T,M),{values:void 0,default:z}):(0,m.getNodeType)(W)!=="object"?(Y(T),{values:void 0,default:z}):{values:W.contents?W.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let O;try{O=await this.findMessageBundles(V,F)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const M=(await this.fileService.readFile(O.localized)).value.toString(),W=[],q=(0,m.parse)(M,W);return W.length>0?($(O.localized,W),{values:void 0,default:O.original}):(0,m.getNodeType)(q)!=="object"?(Y(O.localized),{values:void 0,default:O.original}):{values:q,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(V,N){if(V)try{const F=(await this.fileService.readFile(V)).value.toString();return(0,m.parse)(F,N)}catch{}}findMessageBundles(V,N){return new Promise((F,z)=>{const $=Y=>{const A=(0,S.joinPath)(V,`package.nls.${Y}.json`);this.fileService.exists(A).then(U=>{U&&F({localized:A,original:(0,S.joinPath)(V,"package.nls.json")});const T=Y.lastIndexOf("-");T===-1?F({localized:(0,S.joinPath)(V,"package.nls.json"),original:null}):(Y=Y.substring(0,T),$(Y))})};if(N.devMode||N.pseudo||!N.language)return F({localized:(0,S.joinPath)(V,"package.nls.json"),original:null});$(N.language)})}formatMessage(V,N){return`[${V.path}]: ${N}`}};re=ge([ee(1,b.IExtensionsProfileScannerService),ee(2,j.IUriIdentityService),ee(3,r.IFileService),ee(4,n.ILogService)],re);let se=class extends re{constructor(V,N,F,z,$,Y){super(N,F,z,$,Y),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new C.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new p.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const N=await this.readExtensionCache();if(this.input=V,N&&N.input&&ne.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(z=>(z.location=a.URI.revive(z.location),z));const F=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:F}),F}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),N=JSON.parse(V.value.toString());return{result:N.result,input:(0,E.revive)(N.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,k.VSBuffer.fromString(JSON.stringify(V)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const N=V.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!P.equals(F,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}};se=ge([ee(2,b.IExtensionsProfileScannerService),ee(3,j.IUriIdentityService),ee(4,r.IFileService),ee(5,n.ILogService)],se);function fe(ie,V){const N=(0,u.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:N,identifier:new s.ExtensionIdentifier(N),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:V,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}i.toExtensionDescription=fe;class le extends H{constructor(V,N,F,z,$,Y,A,U,T,O,M){super(V,N,(0,S.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,S.joinPath)(z,s.MANIFEST_CACHE_FOLDER),$,Y,A,U,T,O,M),this.translationsPromise=(async()=>{if(d.translationsConfigFile)try{const W=await this.fileService.readFile(a.URI.file(d.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}i.NativeExtensionsScannerService=le}),define(Q[140],Z([0,1,57,3,31,4,2,17,14,20,9,25]),function(B,i,D,C,P,k,L,m,l,f,I,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let d=class extends L.Disposable{constructor(g,y){super(),this.userDataProfilesService=g,this.logService=y,this.processesLimiter=new C.Limiter(5)}async postUninstall(g){const y=this.parseScript(g,"uninstall");return y&&(this.logService.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,g).then(()=>this.logService.info(g.identifier.id,g.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(g.identifier.id,g.manifest.version,`Failed to run post uninstall script: ${v}`)))),f.Promises.rm(this.getExtensionStoragePath(g)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(g,y){const v=`vscode:${y}`;if(g.location.scheme===m.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[v]=="string"){const a=g.manifest.scripts[v].split(" ");return a.length<2||a[0]!=="node"||!a[1]?(this.logService.warn(g.identifier.id,g.manifest.version,`${v} should be a node script`),null):{script:(0,l.join)(g.location.fsPath,a[1]),args:a.slice(2)||[]}}return null}runLifecycleHook(g,y,v,a,c){return new Promise((h,u)=>{const s=this.start(g,y,v,c);let e;const r=t=>{e&&(clearTimeout(e),e=null),t?u(t):h(void 0)};s.on("error",t=>{r((0,P.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,n)=>{r(t?`post-${y} process exited with code ${t}`:void 0)}),a&&(e=setTimeout(()=>{e=null,s.kill(),u("timed out")},5e3))})}start(g,y,v,a){const c={silent:!0,execArgv:void 0},h=(0,D.fork)(g,[`--type=extension-post-${y}`,...v],c);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const u=k.Event.fromNodeEventEmitter(h.stdout,"data"),s=k.Event.fromNodeEventEmitter(h.stderr,"data");u(t=>this.logService.info(a.identifier.id,a.manifest.version,`post-${y}`,t)),s(t=>this.logService.error(a.identifier.id,a.manifest.version,`post-${y}`,t));const e=k.Event.any(k.Event.map(u,t=>({data:`%c${t}`,format:[""]})),k.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(e,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(a.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),h}getExtensionStoragePath(g){return(0,l.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};d=ge([ee(0,w.IUserDataProfilesService),ee(1,I.ILogService)],d),i.ExtensionsLifecycle=d}),define(Q[141],Z([0,1,10,16,41,48,12,8,9,28,25]),function(B,i,D,C,P,k,L,m,l,f,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let w=class extends k.NativeExtensionsScannerService{constructor(S,g,y,v,a,c,h){super(D.URI.file(a.builtinExtensionsPath),D.URI.file(a.extensionsPath),a.userHome,D.URI.file(a.userDataPath),S,g,y,v,a,c,h)}};w=ge([ee(0,I.IUserDataProfilesService),ee(1,P.IExtensionsProfileScannerService),ee(2,L.IFileService),ee(3,l.ILogService),ee(4,C.INativeEnvironmentService),ee(5,f.IProductService),ee(6,m.IInstantiationService)],w),i.ExtensionsScannerService=w}),define(Q[142],Z([0,1,3,4,2,112,5,79,8,25]),function(B,i,D,C,P,k,L,m,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.isProfileUsingDefaultStorage=i.AbstractStorageService=i.loadKeyTargets=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.TARGET_KEY=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker",i.TARGET_KEY="__$__targetStorageMarker",i.IStorageService=(0,l.createDecorator)("storageService");var I;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(I=i.WillSaveStateReason||(i.WillSaveStateReason={}));var w;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(w=i.StorageScope||(i.StorageScope={}));var d;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(d=i.StorageTarget||(i.StorageTarget={}));function S(c){const h=c.get(i.TARGET_KEY);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}i.loadKeyTargets=S;class g extends P.Disposable{constructor(h={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super(),this.options=h,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(h,u){if(u===i.TARGET_KEY){switch(h){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:h})}else this._onDidChangeValue.fire({scope:h,key:u,target:this.getKeyTargets(h)[u]})}emitWillSaveState(h){this._onWillSaveState.fire({reason:h})}get(h,u,s){return this.getStorage(u)?.get(h,s)}getBoolean(h,u,s){return this.getStorage(u)?.getBoolean(h,s)}getNumber(h,u,s){return this.getStorage(u)?.getNumber(h,s)}store(h,u,s,e){if((0,L.isUndefinedOrNull)(u)){this.remove(h,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(h,s,e),this.getStorage(s)?.set(h,u)})}remove(h,u){this.withPausedEmitters(()=>{this.updateKeyTarget(h,u,void 0),this.getStorage(u)?.delete(h)})}withPausedEmitters(h){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{h()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(h,u){const s=[],e=this.getKeyTargets(h);for(const r of Object.keys(e))e[r]===u&&s.push(r);return s}updateKeyTarget(h,u,s){const e=this.getKeyTargets(u);typeof s=="number"?e[h]!==s&&(e[h]=s,this.getStorage(u)?.set(i.TARGET_KEY,JSON.stringify(e))):typeof e[h]=="number"&&(delete e[h],this.getStorage(u)?.set(i.TARGET_KEY,JSON.stringify(e)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(h){switch(h){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(h){const u=this.getStorage(h);return u?S(u):Object.create(null)}isNew(h){return this.getBoolean(i.IS_NEW_KEY,h)===!0}async flush(h=I.NONE){this._onWillSaveState.fire({reason:h});const u=this.getStorage(-1),s=this.getStorage(0),e=this.getStorage(1);switch(h){case I.NONE:await D.Promises.settled([u?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([u?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return a(h,u,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(h,u){return this.emitWillSaveState(I.NONE),(0,f.isUserDataProfile)(h)?this.switchToProfile(h,u):this.switchToWorkspace(h,u)}canSwitchProfile(h,u){return!(h.id===u.id||y(u)&&y(h))}switchData(h,u,s,e){this.withPausedEmitters(()=>{if(e)for(const[r,t]of h)u.set(r,t);else{const r=new Set;for(const[t,n]of h)r.add(t),u.get(t)!==n&&this.emitDidChangeValue(s,t);for(const[t]of u.items)r.has(t)||this.emitDidChangeValue(s,t)}})}}i.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;function y(c){return c.isDefault||!!c.useDefaultFlags?.uiState}i.isProfileUsingDefaultStorage=y;class v extends g{constructor(){super(),this.applicationStorage=this._register(new m.Storage(new m.InMemoryStorageDatabase)),this.profileStorage=this._register(new m.Storage(new m.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new m.Storage(new m.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(h=>this.emitDidChangeValue(1,h))),this._register(this.profileStorage.onDidChangeStorage(h=>this.emitDidChangeValue(0,h))),this._register(this.applicationStorage.onDidChangeStorage(h=>this.emitDidChangeValue(-1,h)))}getStorage(h){switch(h){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(h){return!1}}i.InMemoryStorageService=v;async function a(c,h,u,s,e,r){const t=J=>{try{return JSON.parse(J)}catch{return J}},n=new Map,o=new Map;c.forEach((J,H)=>{n.set(H,J),o.set(H,t(J))});const p=new Map,E=new Map;h.forEach((J,H)=>{p.set(H,J),E.set(H,t(J))});const b=new Map,R=new Map;u.forEach((J,H)=>{b.set(H,J),R.set(H,t(J))}),console.group(s!==e?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const j=[];if(n.forEach((J,H)=>{j.push({key:H,value:J})}),console.table(j),console.groupEnd(),console.log(o),s!==e){console.group(`Storage: Profile (path: ${e}, profile specific)`);const J=[];p.forEach((H,ne)=>{J.push({key:ne,value:H})}),console.table(J),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${r})`);const _=[];b.forEach((J,H)=>{_.push({key:H,value:J})}),console.table(_),console.groupEnd(),console.log(R)}i.logStorage=a}),define(Q[143],Z([0,1,19,24,11,13,32,5,10,21,16,22,23,45,12,9,28,47,130,142,35]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g,y,v,a,c,h,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const s=k.isWeb?"web":(0,w.getTargetPlatform)(k.platform,L.arch);var e;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function r(...T){return String(T.reduce((O,M)=>O|M,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class b{constructor(O=E){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(O,M=this.state.pageSize){return new b({...this.state,pageNumber:O,pageSize:M})}withFilter(O,...M){const W=[...this.state.criteria,...M.length?M.map(q=>({filterType:O,value:q})):[{filterType:O}]];return new b({...this.state,criteria:W})}withSortBy(O){return new b({...this.state,sortBy:O})}withSortOrder(O){return new b({...this.state,sortOrder:O})}withFlags(...O){return new b({...this.state,flags:O.reduce((M,W)=>M|W,0)})}withAssetTypes(...O){return new b({...this.state,assetTypes:O})}withSource(O){return new b({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:M,pageSize:W,sortBy:q,sortOrder:K,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:O,pageNumber:M,pageSize:W,sortBy:q,sortOrder:K}],assetTypes:ce,flags:ae}}get searchText(){const O=this.state.criteria.filter(M=>M.filterType===t.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function R(T,O){const M=(T||[]).filter(W=>W.statisticName===O)[0];return M?M.value:0}function j(T){const O="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(W=>W.assetType.indexOf(O)===0).reduce((W,q)=>{const K=H(T,q.assetType);return K&&W.push([q.assetType.substring(O.length),K]),W},[])}function _(T){if(T.properties){const O=T.properties.filter(q=>q.key===n.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=O.filter(q=>M.test(q.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return H(T,n.Repository)}function J(T){return{uri:`${T.fallbackAssetUri}/${n.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${n.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function H(T,O){return T.files.filter(W=>W.assetType===O)[0]?{uri:`${T.assetUri}/${O}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${O}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function ne(T,O){const M=T.properties?T.properties.filter(q=>q.key===O):[],W=M.length>0&&M[0].value;return W?W.split(",").map(q=>(0,d.adoptToGalleryExtensionId)(q)):[]}function re(T){const O=T.properties?T.properties.filter(M=>M.key===o.Engine):[];return O.length>0&&O[0].value||""}function se(T){const O=T.properties?T.properties.filter(M=>M.key===o.PreRelease):[];return O.length>0&&O[0].value==="true"}function fe(T){const O=T.properties?T.properties.filter(W=>W.key===o.LocalizedLanguages):[],M=O.length>0&&O[0].value||"";return M?M.split(","):[]}function le(T){return T.properties?.find(O=>O.key===o.SponsorLink)?.value}function ie(T){return T.indexOf("preview")!==-1}function V(T){return T.targetPlatform?(0,w.toTargetPlatform)(T.targetPlatform):"undefined"}function N(T){const O=(0,D.distinct)(T.versions.map(V)),M=!!T.tags?.includes(w.WEB_EXTENSION_TAG),W=O.indexOf("web");return M?W===-1&&O.push("web"):W!==-1&&O.splice(W,1),O}function F(T,O){const M=(0,w.getFallbackTargetPlarforms)(O);for(let W=0;W<T.length;W++){const q=T[W];if(q.version===T[W-1]?.version){let K=W;const ae=V(q);if(ae===O)for(;K>0&&T[K-1].version===q.version;)K--;else if(M.includes(ae))for(;K>0&&T[K-1].version===q.version&&V(T[K-1])!==O;)K--;K!==W&&(T.splice(W,1),T.splice(K,0,q))}}return T}i.sortExtensionVersions=F;function z(T,O,M){T.telemetryData={index:O,querySource:M}}function $(T,O,M){const W=T.versions[0],q={manifest:H(O,n.Manifest),readme:H(O,n.Details),changelog:H(O,n.Changelog),license:H(O,n.License),repository:_(O),download:J(O),icon:H(O,n.Icon),coreTranslations:j(O)};return{identifier:{id:(0,d.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:O.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(W),description:T.shortDescription||"",installCount:R(T.statistics,"install"),rating:R(T.statistics,"averagerating"),ratingCount:R(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:M,assets:q,properties:{dependencies:ne(O,o.Dependency),extensionPack:ne(O,o.ExtensionPack),engine:re(O),localizedLanguages:fe(O),targetPlatform:V(O),isPreReleaseVersion:se(O)},hasPreReleaseVersion:se(W),hasReleaseVersion:!0,preview:ie(T.flags)}}let Y=class{constructor(O,M,W,q,K,ae,ce,pe){this.requestService=M,this.logService=W,this.environmentService=q,this.telemetryService=K,this.fileService=ae,this.productService=ce,this.configurationService=pe;const Se=ce.extensionsGallery;this.extensionsGalleryUrl=Se?.serviceUrl,this.extensionsGallerySearchUrl=Se?.searchUrl,this.extensionsControlUrl=Se?.controlUrl,this.commonHeadersPromise=(0,c.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,M,W){const q=C.CancellationToken.isCancellationToken(M)?{}:M,K=C.CancellationToken.isCancellationToken(M)?M:W,ae=[],ce=[],pe=[],Se=[];let te=!0;for(const he of O){he.uuid?ce.push(he.uuid):ae.push(he.id);const ve=!!(he.version||he.preRelease);pe.push({id:he.id,uuid:he.uuid,includePreRelease:ve}),he.version&&Se.push({id:he.id,uuid:he.uuid,version:he.version}),te=te&&!!he.hasPreRelease&&!ve}if(!ce.length&&!ae.length)return[];let oe=new b().withPage(1,O.length);ce.length&&(oe=oe.withFilter(t.ExtensionId,...ce)),ae.length&&(oe=oe.withFilter(t.ExtensionName,...ae)),(q.queryAllVersions||te)&&(oe=oe.withFlags(oe.flags,e.IncludeVersions)),q.source&&(oe=oe.withSource(q.source));const{extensions:de}=await this.queryGalleryExtensions(oe,{targetPlatform:q.targetPlatform??s,includePreRelease:pe,versions:Se,compatible:!!q.compatible},K);return q.source&&de.forEach((he,ve)=>z(he,ve,q.source)),de}async getCompatibleExtension(O,M,W){if((0,w.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(O,M,W))return O;const q=new b().withFlags(e.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,O.identifier.uuid),{extensions:K}=await this.queryGalleryExtensions(q,{targetPlatform:W,compatible:!0,includePreRelease:M},C.CancellationToken.None);return K[0]||null}async isExtensionCompatible(O,M,W){if(!(0,w.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,W)||!M&&O.properties.isPreReleaseVersion)return!1;let q=O.properties.engine;if(!q){const K=await this.getManifest(O,C.CancellationToken.None);if(!K)throw new Error("Manifest was not found");q=K.engines.vscode}return(0,S.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion(O,M,W,q,K){if(!(0,w.isTargetPlatformCompatible)(V(O),q,K)||M!=="any"&&se(O)!==(M==="prerelease"))return!1;if(W)try{const ae=await this.getEngine(O);if(!(0,S.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}catch(ae){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,P.getErrorMessage)(ae)),!1}return!0}async query(O,M){let W=O.text||"";const q=O.pageSize??50;let K=new b().withPage(1,q);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,de)=>(K=K.withFilter(t.Category,de||oe),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,de)=>(K=K.withFilter(t.Tag,de||oe),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(t.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),K=K.withFilter(t.SearchText,W)),K=K.withSortBy(0)):O.ids?K=K.withFilter(t.ExtensionId,...O.ids):O.names?K=K.withFilter(t.ExtensionName,...O.names):K=K.withSortBy(4),typeof O.sortBy=="number"&&(K=K.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(K=K.withSortOrder(O.sortOrder)),O.source&&(K=K.withSource(O.source));const ae=async(te,oe)=>{const{extensions:de,total:he}=await this.queryGalleryExtensions(te,{targetPlatform:s,compatible:!1,includePreRelease:!!O.includePreRelease},oe);return de.forEach((ve,ke)=>z(ve,(te.pageNumber-1)*te.pageSize+ke,O.source)),{extensions:de,total:he}},{extensions:ce,total:pe}=await ae(K,M),Se=async(te,oe)=>{if(oe.isCancellationRequested)throw new P.CancellationError;const{extensions:de}=await ae(K.withPage(te+1),oe);return de};return{firstPage:ce,total:pe,pageSize:K.pageSize,getPage:Se}}async queryGalleryExtensions(O,M,W){const q=O.flags;!!(O.flags&e.IncludeLatestVersionOnly)&&!!(O.flags&e.IncludeVersions)&&(O=O.withFlags(O.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(O.flags&e.IncludeLatestVersionOnly)&&!(O.flags&e.IncludeVersions)&&(O=O.withFlags(O.flags,e.IncludeLatestVersionOnly)),M.versions?.length&&(O=O.withFlags(O.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),O=O.withFlags(O.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:K,total:ae}=await this.queryRawGalleryExtensions(O,W);if(!(O.flags&e.IncludeLatestVersionOnly)){const te=[];for(const oe of K){const de=await this.toGalleryExtensionWithCriteria(oe,M);de&&te.push(de)}return{extensions:te,total:ae}}const pe=[],Se=new Map;for(let te=0;te<K.length;te++){const oe=K[te],de={id:(0,d.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),uuid:oe.extensionId},he=(0,m.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ke=>(0,d.areSameExtensions)(ke,de))?.includePreRelease;if(M.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(N(oe),M.targetPlatform))continue;const ve=await this.toGalleryExtensionWithCriteria(oe,M);!ve||ve.properties.isPreReleaseVersion&&(!he||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==M.targetPlatform&&ve.hasPreReleaseVersion?Se.set(oe.extensionId,te):pe.push([te,ve])}if(Se.size){const te=new Date().getTime(),oe=new b().withFlags(q&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,Se.size).withFilter(t.ExtensionId,...Se.keys()),{extensions:de}=await this.queryGalleryExtensions(oe,M,W);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-te,count:Se.size});for(const he of de){const ve=Se.get(he.identifier.uuid);pe.push([ve,he])}}return{extensions:pe.sort((te,oe)=>te[0]-oe[0]).map(([,te])=>te),total:ae}}async toGalleryExtensionWithCriteria(O,M){const W={id:(0,d.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},q=M.versions?.find(pe=>(0,d.areSameExtensions)(pe,W))?.version,K=(0,m.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(pe=>(0,d.areSameExtensions)(pe,W))?.includePreRelease,ae=N(O),ce=F(O.versions,M.targetPlatform);if(M.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ae,M.targetPlatform))return null;for(let pe=0;pe<ce.length;pe++){const Se=ce[pe];if(!(q&&Se.version!==q)){if(await this.isValidVersion(Se,K?"any":"release",M.compatible,ae,M.targetPlatform))return $(O,Se,ae);if(q&&Se.version===q)return null}}return q||M.compatible?null:$(O,O.versions[0],ae)}async queryRawGalleryExtensions(O,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,e.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(e.Unpublished));const W=await this.commonHeadersPromise,q=JSON.stringify(O.raw),K={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},ae=new Date().getTime();let ce,pe,Se=0;try{if(ce=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&O.criteria.some(oe=>oe.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:q,headers:K},M),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:Se};const te=await(0,a.asJson)(ce);if(te){const oe=te.results[0],de=oe.extensions,he=oe.resultMetadata&&oe.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return Se=he&&he.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:Se}}return{galleryExtensions:[],total:Se}}catch(te){throw pe=te,te}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-ae,success:!!ce&&(0,a.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:pe?(0,P.isCancellationError)(pe)?"canceled":(0,P.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(O,M,W,q){if(!this.isEnabled())return;const K=k.isWeb?this.api(`/itemName/${O}.${M}/version/${W}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${M}/${W}/stats?statType=${q}`),ae=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:K,headers:pe},C.CancellationToken.None)}catch{}}async download(O,M,W){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const q=(0,d.getGalleryExtensionTelemetryData)(O),K=new Date().getTime(),ae=te=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:te}),ce=W===2?"install":W===3?"update":"",pe=ce?{uri:`${O.assets.download.uri}${l.URI.parse(O.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${O.assets.download.fallbackUri}${l.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:O.assets.download,Se=await this.getAsset(pe);await this.fileService.writeFile(M,Se.stream),ae(new Date().getTime()-K)}async getReadme(O,M){if(O.assets.readme){const W=await this.getAsset(O.assets.readme,{},M);return await(0,a.asTextOrError)(W)||""}return""}async getManifest(O,M){if(O.assets.manifest){const W=await this.getAsset(O.assets.manifest,{},M),q=await(0,a.asTextOrError)(W);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(O,M){const W=H(O,n.Manifest);if(!W)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},K=await this.getAsset(W,{headers:q});return await(0,a.asJson)(K)}async getCoreTranslation(O,M){const W=O.assets.coreTranslations.filter(q=>q[0]===M.toUpperCase())[0];if(W){const q=await this.getAsset(W[1]),K=await(0,a.asTextOrError)(q);return K?JSON.parse(K):null}return null}async getChangelog(O,M){if(O.assets.changelog){const W=await this.getAsset(O.assets.changelog,{},M);return await(0,a.asTextOrError)(W)||""}return""}async getAllCompatibleVersions(O,M,W){let q=new b().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?q=q.withFilter(t.ExtensionId,O.identifier.uuid):q=q.withFilter(t.ExtensionName,O.identifier.id);const{galleryExtensions:K}=await this.queryRawGalleryExtensions(q,C.CancellationToken.None);if(!K.length)return[];const ae=N(K[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(ae,W))return[];const ce=[];await Promise.all(K[0].versions.map(async te=>{try{await this.isValidVersion(te,M?"any":"release",!0,ae,W)&&ce.push(te)}catch{}}));const pe=[],Se=new Set;for(const te of F(ce,W))Se.has(te.version)||(Se.add(te.version),pe.push({version:te.version,date:te.lastUpdated,isPreReleaseVersion:se(te)}));return pe}async getAsset(O,M={},W=C.CancellationToken.None){const q=await this.commonHeadersPromise,K={type:"GET"},ae={...q,...M.headers||{}};M={...M,...K,headers:ae};const ce=O.uri,pe=O.fallbackUri,Se={...M,url:ce};try{const te=await this.requestService.request(Se,W);if(te.res.statusCode===200)return te;const oe=await(0,a.asTextOrError)(te);throw new Error(`Expected 200, got back ${te.res.statusCode} instead.

${oe}`)}catch(te){if((0,P.isCancellationError)(te))throw te;const oe=(0,P.getErrorMessage)(te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:oe});const de={...M,url:pe};return this.requestService.request(de,W)}}async getEngine(O){let M=re(O);if(!M){const W=await this.getManifestFromRawExtensionVersion(O,C.CancellationToken.None);if(!W)throw new Error("Manifest was not found");M=W.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},C.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,a.asJson)(O),W=[],q={};if(M){for(const K of M.malicious)W.push({id:K});if(M.migrateToPreRelease)for(const[K,ae]of Object.entries(M.migrateToPreRelease))(!ae.engine||(0,S.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(q[K.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[K,ae]of Object.entries(M.deprecated))ae&&(q[K.toLowerCase()]=(0,m.isBoolean)(ae)?{}:ae)}return{malicious:W,deprecated:q}}};Y=ge([ee(1,a.IRequestService),ee(2,y.ILogService),ee(3,I.IEnvironmentService),ee(4,u.ITelemetryService),ee(5,g.IFileService),ee(6,v.IProductService),ee(7,f.IConfigurationService)],Y);let A=class extends Y{constructor(O,M,W,q,K,ae,ce,pe){super(O,M,W,q,K,ae,ce,pe)}};A=ge([ee(0,h.IStorageService),ee(1,a.IRequestService),ee(2,y.ILogService),ee(3,I.IEnvironmentService),ee(4,u.ITelemetryService),ee(5,g.IFileService),ee(6,v.IProductService),ee(7,f.IConfigurationService)],A),i.ExtensionGalleryService=A;let U=class extends Y{constructor(O,M,W,q,K,ae,ce){super(void 0,O,M,W,q,K,ae,ce)}};U=ge([ee(0,a.IRequestService),ee(1,y.ILogService),ee(2,I.IEnvironmentService),ee(3,u.ITelemetryService),ee(4,g.IFileService),ee(5,v.IProductService),ee(6,f.IConfigurationService)],U),i.ExtensionGalleryServiceWithNoStorageService=U}),define(Q[144],Z([0,1,44,16,12,9,65,29,25]),function(B,i,D,C,P,k,L,m,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=void 0;let f=class We extends l.UserDataProfilesService{constructor(w,d,S,g,y){super(S,g,d,y),this.stateService=w}getStoredProfiles(){return(0,D.revive)(this.stateService.getItem(We.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,D.revive)(this.stateService.getItem(We.PROFILE_ASSOCIATIONS_KEY,{}))}};f=ge([ee(0,L.IStateService),ee(1,m.IUriIdentityService),ee(2,C.IEnvironmentService),ee(3,P.IFileService),ee(4,k.ILogService)],f),i.UserDataProfilesService=f}),define(Q[145],Z([0,1,37,3,158,2]),function(B,i,D,C,P,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativePolicyService=void 0;class L extends D.AbstractPolicyService{constructor(l){super(),this.productName=l,this.throttler=new C.Throttler,this.watcher=this._register(new k.MutableDisposable)}async initializePolicies(l){await this.throttler.queue(()=>new Promise((f,I)=>{try{this.watcher.value=(0,P.createWatcher)(this.productName,l,w=>{for(const d in w){const S=w[d];S===void 0?this.policies.delete(d):this.policies.set(d,S)}this._onDidChange.fire(Object.keys(w)),f()})}catch(w){I(w)}}))}}i.NativePolicyService=L}),define(Q[67],Z([0,1,114,3,14,5,20,80,159,160]),function(B,i,D,C,P,k,L,m,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class I extends Error{constructor(e,r){let t=r.message;switch(e){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=e,this.cause=r}}i.ExtractError=I;function w(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,t)=>r+t,e&61440)}function d(s){if(s instanceof I)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new I(e,s)}function S(s,e,r,t,n,o){const p=P.dirname(e),E=P.join(t,p);if(!E.startsWith(t))return Promise.reject(new Error(m.localize(0,null,e)));const b=P.join(t,e);let R;return o.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(L.Promises.mkdir(E,{recursive:!0})).then(()=>new Promise((j,_)=>{if(!o.isCancellationRequested)try{R=(0,D.createWriteStream)(b,{mode:r}),R.once("close",()=>j()),R.once("error",_),s.once("error",_),s.pipe(R)}catch(J){_(J)}}))}function g(s,e,r,t){let n=(0,C.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((p,E)=>{const b=new C.Sequencer,R=j=>{j.isCancellationRequested||(o++,s.readEntry())};s.once("error",E),s.once("close",()=>n.then(()=>{t.isCancellationRequested||s.entryCount===o?p():E(new I("Incomplete",new Error(m.localize(1,null,o,s.entryCount))))},E)),s.readEntry(),s.on("entry",j=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(j.fileName)){R(t);return}const _=j.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(_)){const ne=P.join(e,_);n=(0,C.createCancelablePromise)(re=>L.Promises.mkdir(ne,{recursive:!0}).then(()=>R(re)).then(void 0,E));return}const J=v(s,j),H=w(j);n=(0,C.createCancelablePromise)(ne=>b.queue(()=>J.then(re=>S(re,_,H,e,r,ne).then(()=>R(ne)))).then(null,E))})})}function y(s,e=!1){return new Promise((r,t)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(n,o)=>{n?t(d(n)):r((0,k.assertIsDefined)(o))})})}function v(s,e){return new Promise((r,t)=>{s.openReadStream(e,(n,o)=>{n?t(d(n)):r((0,k.assertIsDefined)(o))})})}function a(s,e){return new Promise((r,t)=>{const n=new f.ZipFile;e.forEach(p=>{p.contents?n.addBuffer(typeof p.contents=="string"?Buffer.from(p.contents,"utf8"):p.contents,p.path):p.localPath&&n.addFile(p.localPath,p.path)}),n.end();const o=(0,D.createWriteStream)(s);n.outputStream.pipe(o),n.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>r(s))})}i.zip=a;function c(s,e,r={},t){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=y(s,!0);return r.overwrite&&(o=o.then(p=>L.Promises.rm(e).then(()=>p))),o.then(p=>g(p,e,{sourcePathRegex:n},t))}i.extract=c;function h(s,e){return y(s).then(r=>new Promise((t,n)=>{r.on("entry",o=>{o.fileName===e&&v(r,o).then(p=>t(p),p=>n(p))}),r.once("close",()=>n(new Error(m.localize(2,null,e))))}))}function u(s,e){return h(s,e).then(r=>new Promise((t,n)=>{const o=[];r.once("error",n),r.on("data",p=>o.push(p)),r.on("end",()=>t(Buffer.concat(o)))}))}i.buffer=u}),define(Q[146],Z([0,1,67,88]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function P(k){return(0,D.buffer)(k,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,C.localize)(0,null))}})}i.getManifest=P}),define(Q[147],Z([0,1,3,31,11,2,17,14,13,18,39,5,10,30,20,67,87,58,16,139,22,23,41,48,122,140,146,123,136,34,45,12,8,9,28,35,29,25]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g,y,v,a,c,h,u,s,e,r,t,n,o,p,E,b,R,j,_,J,H,ne,re,se){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=i.INativeServerExtensionManagementService=void 0,i.INativeServerExtensionManagementService=(0,_.refineServiceDecorator)(u.IExtensionManagementService);let fe=class extends h.AbstractExtensionManagementService{constructor(A,U,T,O,M,W,q,K,ae,ce,pe,Se){super(A,U,T,ce,Se),this.extensionsScannerService=M,this.extensionsProfileScannerService=W,this.downloadService=q,this.fileService=ae,this.installGalleryExtensionsTasks=new Map;const te=this._register(K.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(le,de=>te.postUninstall(de))),this.manifestCache=this._register(new p.ExtensionsManifestCache(O,this)),this.extensionsDownloader=this._register(K.createInstance(t.ExtensionsDownloader));const oe=this._register(new E.ExtensionsWatcher(this,ae,O,T,pe));this._register(oe.onDidChangeExtensionsByAnotherSource(({added:de,removed:he})=>{de.length&&this._onDidInstallExtensions.fire(de.map(ve=>({identifier:ve.identifier,operation:1,local:ve}))),he.forEach(ve=>this._onDidUninstallExtension.fire({identifier:ve}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(A){this.logService.trace("ExtensionManagementService#zip",A.identifier.id);const U=await this.collectFiles(A),T=await(0,y.zip)((0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,S.generateUuid)()).fsPath,U);return d.URI.file(T)}async unzip(A){return this.logService.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:U,cleanup:T}=await this.downloadVsix(A),O=m.resolve(U.fsPath);try{return await(0,o.getManifest)(O)}finally{await T()}}getInstalled(A,U){return this.extensionsScanner.scanExtensions(A??null,U)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(A,U={}){this.logService.trace("ExtensionManagementService#install",A.toString());const{location:T,cleanup:O}=await this.downloadVsix(A);try{const M=await(0,o.getManifest)(m.resolve(T.fsPath));if(M.engines&&M.engines.vscode&&!(0,R.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,(0,s.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return await this.installExtension(M,T,U)}finally{await O()}}getMetadata(A){return this.extensionsScannerService.scanMetadata(A.location)}async updateMetadata(A,U){this.logService.trace("ExtensionManagementService#updateMetadata",A.identifier.id);const T={...U};return U.isPreReleaseVersion&&(T.preRelease=!0),A=await this.extensionsScanner.updateMetadata(A,T),this.manifestCache.invalidate(),A}async updateExtensionScope(A,U){return this.logService.trace("ExtensionManagementService#updateExtensionScope",A.identifier.id),A=await this.extensionsScanner.updateMetadata(A,{isMachineScoped:U}),this.manifestCache.invalidate(),A}removeUninstalledExtensions(A){return this.extensionsScanner.cleanUp(A)}async downloadVsix(A){if(A.scheme===L.Schemas.file)return{location:A,async cleanup(){}};this.logService.trace("Downloading extension from",A.toString());const U=(0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,S.generateUuid)());return await this.downloadService.download(A,U),this.logService.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.fileService.del(U)}catch(O){this.logService.error(O)}}}}doCreateInstallExtensionTask(A,U,T){let O;if(d.URI.isUri(U))O=new N(A,U,T,this.galleryService,this.extensionsScanner,this.logService);else{const M=s.ExtensionKey.create(U).toString();O=this.installGalleryExtensionsTasks.get(M),O||(this.installGalleryExtensionsTasks.set(M,O=new V(A,U,T,this.extensionsDownloader,this.extensionsScanner,this.logService)),O.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(M)))}return T.profileLocation?new F(O,T.profileLocation,this.extensionsProfileScannerService):O}doCreateUninstallExtensionTask(A,U){return U.profileLocation?new $(A,U.profileLocation,this.extensionsProfileScannerService):new z(A,U,this.extensionsScanner)}async collectFiles(A){const U=async O=>{let M=await g.Promises.readdir(O);M=M.map(K=>m.join(O,K));const W=await Promise.all(M.map(K=>g.Promises.stat(K)));let q=Promise.resolve([]);return W.forEach((K,ae)=>{const ce=M[ae];K.isFile()&&(q=q.then(pe=>[...pe,ce])),K.isDirectory()&&(q=q.then(pe=>U(ce).then(Se=>[...pe,...Se])))}),q};return(await U(A.location.fsPath)).map(O=>({path:`extension/${m.relative(A.location.fsPath,O)}`,localPath:O}))}};fe=ge([ee(0,u.IExtensionGalleryService),ee(1,ne.ITelemetryService),ee(2,J.ILogService),ee(3,c.INativeEnvironmentService),ee(4,r.IExtensionsScannerService),ee(5,e.IExtensionsProfileScannerService),ee(6,a.IDownloadService),ee(7,_.IInstantiationService),ee(8,j.IFileService),ee(9,H.IProductService),ee(10,re.IUriIdentityService),ee(11,se.IUserDataProfilesService)],fe),i.ExtensionManagementService=fe;let le=class extends k.Disposable{constructor(A,U,T,O){super(),this.beforeRemovingExtension=A,this.fileService=U,this.extensionsScannerService=T,this.logService=O,this.uninstalledPath=(0,f.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(A){await this.removeUninstalledExtensions(),A&&await this.removeOutdatedExtensions()}async scanExtensions(A,U){const T={includeInvalid:!0,profileLocation:U};let O=[];return A===null||A===0?O.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},T,!1)):A===1&&O.push(...await this.extensionsScannerService.scanUserExtensions(T)),O=A!==null?O.filter(M=>M.type===A):O,Promise.all(O.map(M=>this.toLocalExtension(M)))}async scanUserExtensions(A){const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(U.map(T=>this.toLocalExtension(T)))}async extractUserExtension(A,U,T,O){const M=A.toString(),W=m.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,S.generateUuid)()}`),q=m.join(this.extensionsScannerService.userExtensionsLocation.fsPath,M);try{await g.Promises.rm(q)}catch{throw new u.ExtensionManagementError(v.localize(1,null,q,A.id),u.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(A,U,W,O),await this.extensionsScannerService.updateMetadata(d.URI.file(W),T);try{await this.rename(A,W,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(K){try{await g.Promises.rm(W)}catch{}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(K)}. Deleted from extracted location`,W),K}return this.scanLocalExtension(d.URI.file(q),1)}async updateMetadata(A,U){return await this.extensionsScannerService.updateMetadata(A.location,U),this.scanLocalExtension(A.location,A.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const U=A.map(T=>s.ExtensionKey.create(T));await this.withUninstalledExtensions(T=>{U.forEach(O=>T[O.toString()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(O=>delete O[A.toString()]);const T=(await this.scanUserExtensions(!0)).find(O=>s.ExtensionKey.create(O).equals(A))||null;return T?this.updateMetadata(T,{installedTimestamp:Date.now()}):null}async removeExtension(A,U){this.logService.trace(`Deleting ${U} extension from disk`,A.identifier.id,A.location.fsPath),await g.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[s.ExtensionKey.create(A).toString()])}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await g.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(U)try{T=JSON.parse(U)}catch{}return A&&(A(T),Object.keys(T).length?await g.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await g.Promises.rm(this.uninstalledPath)),T})}async extractAtLocation(A,U,T,O){this.logService.trace(`Started extracting the extension from ${U} to ${T}`);try{await g.Promises.rm(T)}catch(M){throw new u.ExtensionManagementError(this.joinErrors(M).message,u.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(U,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,A.id)}catch(M){try{await g.Promises.rm(T)}catch{}let W=u.ExtensionManagementErrorCode.Extract;throw M instanceof y.ExtractError&&(M.type==="CorruptZip"?W=u.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(W=u.ExtensionManagementErrorCode.IncompleteZip)),new u.ExtensionManagementError(M.message,W)}}async rename(A,U,T,O){try{await g.Promises.rename(U,T)}catch(M){if(l.isWindows&&M&&M.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${U} to ${T} with 'EPERM' error. Trying again...`,A.id),this.rename(A,U,T,O);throw new u.ExtensionManagementError(M.message||v.localize(2,null,U,T),M.code||u.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(A,U){const T=await this.extensionsScannerService.scanExistingExtension(A,U,{includeInvalid:!0});if(T)return this.toLocalExtension(T);throw new Error(v.localize(3,null,A.path))}async toLocalExtension(A){const U=await this.fileService.resolve(A.location);let T,O;return U.children&&(T=U.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,O=U.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:T,changelogUrl:O,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated}}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const W of U)A[s.ExtensionKey.create(W).toString()]||T.add(W.identifier.id.toLowerCase());const O=(0,s.groupByExtension)(U,W=>W.identifier);await D.Promises.settled(O.map(async W=>{const q=W.sort((K,ae)=>I.rcompare(K.manifest.version,ae.manifest.version))[0];T.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}));const M=U.filter(W=>A[s.ExtensionKey.create(W).toString()]);await D.Promises.settled(M.map(W=>this.removeUninstalledExtension(W)))}async removeOutdatedExtensions(){const A=await this.extensionsScannerService.scanSystemExtensions({}),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=[],O=await this.extensionsScannerService.getTargetPlatform(),M=(0,s.groupByExtension)(U,W=>W.identifier);for(const W of M)if(W.length>1&&T.push(...W.sort((q,K)=>{const ae=I.rcompare(q.manifest.version,K.manifest.version);return ae!==0?ae:q.targetPlatform===O?-1:1}).slice(1)),W[0].type===0){const q=A.find(K=>(0,s.areSameExtensions)(K.identifier,W[0].identifier));(!q||I.gte(q.manifest.version,W[0].manifest.version))&&T.push(W[0])}await D.Promises.settled(T.map(W=>this.removeExtension(W,"outdated")))}joinErrors(A){const U=Array.isArray(A)?A:[A];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}};le=ge([ee(1,j.IFileService),ee(2,r.IExtensionsScannerService),ee(3,J.ILogService)],le);class ie extends h.AbstractExtensionTask{get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(A,U,T,O,M){super(),this.identifier=A,this.source=U,this.options=T,this.extensionsScanner=O,this.logService=M,this._operation=2}async installExtension(A,U){try{const T=await this.unsetUninstalledAndGetLocal(A.key);if(T)return this.extensionsScanner.updateMetadata(T,A.metadata)}catch{throw l.isMacintosh?new u.ExtensionManagementError(v.localize(4,null),u.ExtensionManagementErrorCode.Internal):new u.ExtensionManagementError(v.localize(5,null),u.ExtensionManagementErrorCode.Internal)}return this.extract(A,U)}async unsetUninstalledAndGetLocal(A){if(!await this.isUninstalled(A))return null;this.logService.trace("Removing the extension from uninstalled list:",A.id);const T=await this.extensionsScanner.setInstalled(A);return this.logService.info("Removed the extension from uninstalled list:",A.id),T}async isUninstalled(A){return!!(await this.extensionsScanner.getUninstalledExtensions())[A.toString()]}async extract({zipPath:A,key:U,metadata:T},O){const M=await this.extensionsScanner.extractUserExtension(U,A,T,O);return this.logService.info("Extracting completed.",U.id),M}}class V extends ie{constructor(A,U,T,O,M,W){super(U.identifier,U,T,M,W),this.manifest=A,this.gallery=U,this.extensionsDownloader=O}async doRun(A){const T=(await this.extensionsScanner.scanExtensions(null,void 0)).find(W=>(0,s.areSameExtensions)(W.identifier,this.gallery.identifier));T&&(this._operation=3);const O={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,b.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:T?.preRelease)};if(T?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(T,O),metadata:O};const M=await this.downloadExtension(this.gallery,this._operation);try{const W=await this.installExtension({zipPath:M,key:s.ExtensionKey.create(this.gallery),metadata:O},A);return T&&!this.options.profileLocation&&(T.targetPlatform!==W.targetPlatform||I.neq(T.manifest.version,W.manifest.version))&&await this.extensionsScanner.setUninstalled(T),{local:W,metadata:O}}catch(W){throw await this.deleteDownloadedVSIX(M),W}}async deleteDownloadedVSIX(A){try{await this.extensionsDownloader.delete(d.URI.file(A))}catch(U){this.logService.warn("Error while deleting the downloaded vsix",A.toString(),(0,P.getErrorMessage)(U))}}async downloadExtension(A,U){let T;try{this.logService.trace("Started downloading extension:",A.identifier.id),T=(await this.extensionsDownloader.downloadExtension(A,U)).fsPath,this.logService.info("Downloaded extension:",A.identifier.id,T)}catch(O){throw new u.ExtensionManagementError((0,h.joinErrors)(O).message,u.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(T),T}catch(O){throw await this.deleteDownloadedVSIX(T),new u.ExtensionManagementError((0,h.joinErrors)(O).message,u.ExtensionManagementErrorCode.Invalid)}}}class N extends ie{constructor(A,U,T,O,M,W){super({id:(0,s.getGalleryExtensionId)(A.publisher,A.name)},U,T,M,W),this.manifest=A,this.location=U,this.galleryService=O}async doRun(A){const U=new s.ExtensionKey(this.identifier,this.manifest.version),O=(await this.extensionsScanner.scanExtensions(1,void 0)).find(q=>(0,s.areSameExtensions)(this.identifier,q.identifier)),M=await this.getMetadata(this.identifier.id,this.manifest.version,A);if(M.isApplicationScoped=(0,b.isApplicationScopedExtension)(this.manifest),M.isMachineScoped=this.options.isMachineScoped||O?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||O?.isBuiltin,M.installedTimestamp=Date.now(),O)if(this._operation=3,U.equals(new s.ExtensionKey(O.identifier,O.manifest.version)))try{await this.extensionsScanner.removeExtension(O,"existing")}catch{throw new Error(v.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(O.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(O);else{const q=await this.unsetUninstalledAndGetLocal(U);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:m.resolve(this.location.fsPath),key:U,metadata:M},A),metadata:M}}async getMetadata(A,U,T){try{let[O]=await this.galleryService.getExtensions([{id:A,version:U}],T);if(O||([O]=await this.galleryService.getExtensions([{id:A}],T)),O)return{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(A,U,T){this.task=A,this.profileLocation=U,this.extensionsProfileScannerService=T,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const A=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[A.local,A.metadata]],this.profileLocation),A}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class z extends h.AbstractExtensionTask{constructor(A,U,T){super(),this.extension=A,this.options=U,this.extensionsScanner=T}async doRun(A){const U=[],T=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const O=s.ExtensionKey.create(this.extension);U.push(...T.filter(M=>O.equals(s.ExtensionKey.create(M))))}else U.push(...T.filter(O=>(0,s.areSameExtensions)(O.identifier,this.extension.identifier)));if(!U.length)throw new Error(v.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...U),this.options.remove)for(const O of U)try{A.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(O)}catch(M){throw new Error(v.localize(9,null,(0,C.toErrorMessage)(M)))}}}class $ extends h.AbstractExtensionTask{constructor(A,U,T){super(),this.extension=A,this.profileLocation=U,this.extensionsProfileScannerService=T}async doRun(A){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[148],Z([0,1,127,3,15,11,2,5,21,16,128,9,126,161]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let g=class extends L.Disposable{constructor(v,a,c){super(),this.environmentService=a,this.logService=c,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,a){this.logService.trace("RequestService#request (node) - begin",v.url);const{proxyUrl:c,strictSSL:h}=this;let u;try{u=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const s={...process.env,...u},e=v.agent?v.agent:await(0,d.getProxyAgent)(v.url||"",s,{proxyUrl:c,strictSSL:h});v.agent=e,v.strictSSL=h,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(v,a);return this.logService.trace("RequestService#request (node) - success",v.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",v.url,r),r}}async getNodeRequest(v){return((0,D.parse)(v.url).protocol==="https:"?await new Promise((h,u)=>{B(["https"],h,u)}):await new Promise((h,u)=>{B(["http"],h,u)})).request}_request(v,a){return C.Promises.withAsyncBody(async(c,h)=>{const u=(0,D.parse)(v.url),s=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),e={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,m.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(e.auth=v.user+":"+v.password);const r=s(e,t=>{const n=(0,m.isNumber)(v.followRedirects)?v.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)this._request({...v,url:t.headers.location,followRedirects:n-1},a).then(c,h);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,S.createGunzip)())),c({res:t,stream:(0,P.streamToBufferReadableStream)(o)})}});r.on("error",h),v.timeout&&r.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&r.write(v.data),r.end(),a.onCancellationRequested(()=>{r.abort(),h(new k.CancellationError)})})}async resolveProxy(v){}};g=ge([ee(0,l.IConfigurationService),ee(1,f.INativeEnvironmentService),ee(2,w.ILogService)],g),i.RequestService=g}),define(Q[162],Z([0,1,38,3,15,31,11,2,17,14,13,32,10,20,21,119,58,125,16,101,143,22,121,41,48,147,141,12,111,113,46,109,61,62,124,9,115,116,37,145,133,28,47,148,65,129,66,35,132,42,134,135,29,137,25,144]),function(B,i,D,C,P,k,L,m,l,f,I,w,d,S,g,y,v,a,c,h,u,s,e,r,t,n,o,p,E,b,R,j,_,J,H,ne,re,se,fe,le,ie,V,N,F,z,$,Y,A,U,T,O,M,W,q,K,ae){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class ce extends m.Disposable{constructor(te){super(),this.argv=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[te,oe]=await this.initServices();return te.invokeFunction(async de=>{const he=de.get(ne.ILogService),ve=de.get(p.IFileService),ke=de.get(c.INativeEnvironmentService),Fe=de.get(K.IUserDataProfilesService);he.info("CLI main",this.argv),this.registerErrorHandler(he),await this.doRun(ke,ve,Fe,te),await Promise.all(oe.map(Ue=>{(0,C.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const te=new _.ServiceCollection,oe={_serviceBrand:void 0,...ie.default};te.set(V.IProductService,oe);const de=new h.NativeEnvironmentService(this.argv,oe);te.set(c.INativeEnvironmentService,de),await Promise.all([de.appSettingsHome.fsPath,de.extensionsPath].map(we=>we?S.Promises.mkdir(we,{recursive:!0}):void 0));const he=(0,ne.getLogLevel)(de),ve=[];ve.push(new re.SpdLogLogger("cli",(0,f.join)(de.logsPath,"cli.log"),!0,!1,he)),he===ne.LogLevel.Trace&&ve.push(new ne.ConsoleLogger(he));const ke=this._register(new ne.MultiplexLogService(ve));te.set(ne.ILogService,ke);const Fe=this._register(new E.FileService(ke));te.set(p.IFileService,Fe);const Ue=this._register(new b.DiskFileSystemProvider(ke));Fe.registerProvider(l.Schemas.file,Ue);const xe=new $.StateService(de,ke,Fe);te.set(z.IStateService,xe);const x=new q.UriIdentityService(Fe);te.set(W.IUriIdentityService,x);const G=new ae.UserDataProfilesService(xe,x,de,Fe,ke);te.set(K.IUserDataProfilesService,G);const X=I.isWindows&&oe.win32RegValueName?this._register(new le.NativePolicyService(oe.win32RegValueName)):de.policyFile?this._register(new se.FilePolicyService(de.policyFile,Fe,ke)):new fe.NullPolicyService;te.set(fe.IPolicyService,X);const ue=this._register(new y.ConfigurationService(G.defaultProfile.settingsResource,Fe,X,ke));te.set(g.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),G.setEnablement(oe.quality!=="stable"||ue.getValue(K.PROFILES_ENABLEMENT_CONFIG)),te.set(W.IUriIdentityService,new q.UriIdentityService(Fe)),te.set(N.IRequestService,new R.SyncDescriptor(F.RequestService,void 0,!0)),te.set(v.IDownloadService,new R.SyncDescriptor(a.DownloadService,void 0,!0)),te.set(r.IExtensionsProfileScannerService,new R.SyncDescriptor(r.ExtensionsProfileScannerService,void 0,!0)),te.set(t.IExtensionsScannerService,new R.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),te.set(n.INativeServerExtensionManagementService,new R.SyncDescriptor(n.ExtensionManagementService,void 0,!0)),te.set(s.IExtensionGalleryService,new R.SyncDescriptor(u.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),te.set(J.ILanguagePackService,new R.SyncDescriptor(H.NativeLanguagePackService,void 0,!1));const me=[],De=(0,T.isInternalTelemetry)(oe,ue);if((0,T.supportsTelemetry)(oe,de)){oe.aiConfig&&oe.aiConfig.ariaKey&&me.push(new O.OneDataSystemAppender(De,"monacoworkbench",null,oe.aiConfig.ariaKey));const{installSourcePath:we}=de,Le={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const Ce=await S.Promises.readFile(de.stateResource.fsPath);be=JSON.parse(Ce.toString())[A.machineIdKey]}catch(Ce){Ce.code!=="ENOENT"&&ke.error(Ce)}return(0,Y.resolveCommonProperties)(Fe,(0,D.release)(),(0,D.hostname)(),process.arch,oe.commit,oe.version,be,De,we)})(),piiPaths:(0,T.getPiiPathsFromEnvironment)(de)};te.set(A.ITelemetryService,new R.SyncDescriptor(U.TelemetryService,[Le],!1))}else te.set(A.ITelemetryService,T.NullTelemetryService);return[new j.InstantiationService(te),me]}registerErrorHandler(te){(0,L.setUnexpectedErrorHandler)(oe=>{const de=(0,k.toErrorMessage)(oe,!0);!de||te.error(`[uncaught exception in CLI]: ${de}`)}),process.on("uncaughtException",oe=>(0,L.onUnexpectedError)(oe)),process.on("unhandledRejection",oe=>(0,L.onUnexpectedError)(oe))}async doRun(te,oe,de,he){const ve=te.args.profile?de.profiles.find(ke=>ke.name===te.args.profile)?.extensionsResource:de.defaultProfile.extensionsResource;if(this.argv["install-source"])return this.setInstallSource(te,oe,this.argv["install-source"]);if(this.argv["list-extensions"])return he.createInstance(e.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,ve);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ke={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:ve};return he.createInstance(e.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],ke,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return he.createInstance(e.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,ve);if(this.argv["locate-extension"])return he.createInstance(e.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}asExtensionIdOrVSIX(te){return te.map(oe=>/\.vsix$/i.test(oe)?d.URI.file((0,f.isAbsolute)(oe)?oe:(0,f.join)((0,w.cwd)(),oe)):oe)}async setInstallSource(te,oe,de){await oe.writeFile(d.URI.file(te.installSourcePath),P.VSBuffer.fromString(de.slice(0,30)))}}async function pe(Se){const te=new ce(Se);try{await te.run()}finally{te.dispose()}}i.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bd1b7a384f8a5ab9fb5a6a0e8fea370e589f43a3/core/vs/code/node/cliProcessMain.js.map
