/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(ie){for(var e=[],r=0,C=ie.length;r<C;r++)e[r]=Ce[ie[r]];return e};define(Ce[73],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function r(y,A){const E=Object.create(null);for(const P of y){const O=A(P);let b=E[O];b||(b=E[O]=[]),b.push(P)}return E}e.groupBy=r;function C(y,A){const E=[],P=[];for(const O of y)A.has(O)||E.push(O);for(const O of A)y.has(O)||P.push(O);return{removed:E,added:P}}e.diffSets=C;function S(y,A){const E=[],P=[];for(const[O,b]of y)A.has(O)||E.push(b);for(const[O,b]of A)y.has(O)||P.push(b);return{removed:E,added:P}}e.diffMaps=S;class M{constructor(){this.map=new Map}add(A,E){let P=this.map.get(A);P||(P=new Set,this.map.set(A,P)),P.add(E)}delete(A,E){const P=this.map.get(A);!P||(P.delete(E),P.size===0&&this.map.delete(A))}forEach(A,E){const P=this.map.get(A);!P||P.forEach(E)}}e.SetMap=M}),define(Ce[55],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(y){return(A,E,P)=>{let O=null,b=null;if(typeof P.value=="function"?(O="value",b=P.value):typeof P.get=="function"&&(O="get",b=P.get),!b)throw new Error("not supported");P[O]=y(b,E)}}e.createDecorator=r;function C(y,A,E){let P=null,O=null;if(typeof E.value=="function"?(P="value",O=E.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(P="get",O=E.get),!O)throw new Error("not supported");const b=`$memoize$${A}`;E[P]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[b]}}e.memoize=C;function S(y,A,E){return r((P,O)=>{const b=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...k){this[m]||(this[m]=E?E():void 0),clearTimeout(this[b]),A&&(this[m]=A(this[m],...k),k=[this[m]]),this[b]=setTimeout(()=>{P.apply(this,k),this[m]=E?E():void 0},y)}})}e.debounce=S;function M(y,A,E){return r((P,O)=>{const b=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,k=`$throttle$lastRun$${O}`,p=`$throttle$pending$${O}`;return function(...l){if(this[m]||(this[m]=E?E():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...l)),this[p])return;const u=this[k]+y;u<=Date.now()?(this[k]=Date.now(),P.apply(this,[this[m]]),this[m]=E?E():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[k]=Date.now(),P.apply(this,[this[m]]),this[m]=E?E():void 0},u-Date.now()))}})}e.throttle=M}),define(Ce[74],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ce[106],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function y(t,c=!1){let i=0;const n=t.length;let o="",f=0,s=16,h=0;function v(L){let R=0,K=0;for(;R<L;){const W=t.charCodeAt(i);if(W>=48&&W<=57)K=K*16+W-48;else if(W>=65&&W<=70)K=K*16+W-65+10;else if(W>=97&&W<=102)K=K*16+W-97+10;else break;i++,R++}return R<L&&(K=-1),K}function T(L){i=L,o="",f=0,s=16,h=0}function N(){const L=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&P(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&P(t.charCodeAt(i)))for(i++;i<t.length&&P(t.charCodeAt(i));)i++;else return h=3,t.substring(L,i);let R=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&P(t.charCodeAt(i))){for(i++;i<t.length&&P(t.charCodeAt(i));)i++;R=i}else h=3;return t.substring(L,R)}function V(){let L="",R=i;for(;;){if(i>=n){L+=t.substring(R,i),h=2;break}const K=t.charCodeAt(i);if(K===34){L+=t.substring(R,i),i++;break}if(K===92){if(L+=t.substring(R,i),i++,i>=n){h=2;break}switch(t.charCodeAt(i++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const $=v(4);$>=0?L+=String.fromCharCode($):h=4;break}default:h=5}R=i;continue}if(K>=0&&K<=31)if(E(K)){L+=t.substring(R,i),h=2;break}else h=6;i++}return L}function U(){if(o="",h=0,f=i,i>=n)return f=n,s=17;let L=t.charCodeAt(i);if(A(L)){do i++,o+=String.fromCharCode(L),L=t.charCodeAt(i);while(A(L));return s=15}if(E(L))return i++,o+=String.fromCharCode(L),L===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),s=14;switch(L){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,o=V(),s=10;case 47:{const R=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!E(t.charCodeAt(i));)i++;return o=t.substring(R,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const K=n-1;let W=!1;for(;i<K;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,h=1),o=t.substring(R,i),s=13}return o+=String.fromCharCode(L),i++,s=16}case 45:if(o+=String.fromCharCode(L),i++,i===n||!P(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=N(),s=11;default:for(;i<n&&D(L);)i++,L=t.charCodeAt(i);if(f!==i){switch(o=t.substring(f,i),o){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return o+=String.fromCharCode(L),i++,s=16}}function D(L){if(A(L)||E(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let L;do L=U();while(L>=12&&L<=15);return L}return{setPosition:T,getPosition:()=>i,scan:c?x:U,getToken:()=>s,getTokenValue:()=>o,getTokenOffset:()=>f,getTokenLength:()=>i-f,getTokenError:()=>h}}e.createScanner=y;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function b(t,c){const i=[],n=new Object;let o;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function h(v,T,N,V){f.value=v,f.offset=T,f.length=N,f.type=V,f.colonOffset=void 0,o=f}try{_(t,{onObjectBegin:(v,T)=>{if(c<=v)throw n;o=void 0,s=c>v,i.push("")},onObjectProperty:(v,T,N)=>{if(c<T||(h(v,T,N,"property"),i[i.length-1]=v,c<=T+N))throw n},onObjectEnd:(v,T)=>{if(c<=v)throw n;o=void 0,i.pop()},onArrayBegin:(v,T)=>{if(c<=v)throw n;o=void 0,i.push(0)},onArrayEnd:(v,T)=>{if(c<=v)throw n;o=void 0,i.pop()},onLiteralValue:(v,T,N)=>{if(c<T||(h(v,T,N,w(v)),c<=T+N))throw n},onSeparator:(v,T,N)=>{if(c<=T)throw n;if(v===":"&&o&&o.type==="property")o.colonOffset=T,s=!1,o=void 0;else if(v===","){const V=i[i.length-1];typeof V=="number"?i[i.length-1]=V+1:(s=!0,i[i.length-1]=""),o=void 0}}})}catch(v){if(v!==n)throw v}return{path:i,previousNode:o,isAtPropertyKey:s,matches:v=>{let T=0;for(let N=0;T<v.length&&N<i.length;N++)if(v[T]===i[N]||v[T]==="*")T++;else if(v[T]!=="**")return!1;return T===v.length}}}e.getLocation=b;function m(t,c=[],i=M.DEFAULT){let n=null,o=[];const f=[];function s(v){Array.isArray(o)?o.push(v):n!==null&&(o[n]=v)}return _(t,{onObjectBegin:()=>{const v={};s(v),f.push(o),o=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{const v=[];s(v),f.push(o),o=v,n=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:s,onError:(v,T,N)=>{c.push({error:v,offset:T,length:N})}},i),o[0]}e.parse=m;function k(t,c=[],i=M.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){n.type==="property"&&(n.length=v-n.offset,n=n.parent)}function f(v){return n.children.push(v),v}_(t,{onObjectBegin:v=>{n=f({type:"object",offset:v,length:-1,parent:n,children:[]})},onObjectProperty:(v,T,N)=>{n=f({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:v,offset:T,length:N,parent:n})},onObjectEnd:(v,T)=>{n.length=v+T-n.offset,n=n.parent,o(v+T)},onArrayBegin:(v,T)=>{n=f({type:"array",offset:v,length:-1,parent:n,children:[]})},onArrayEnd:(v,T)=>{n.length=v+T-n.offset,n=n.parent,o(v+T)},onLiteralValue:(v,T,N)=>{f({type:w(v),offset:T,length:N,parent:n,value:v}),o(T+N)},onSeparator:(v,T,N)=>{n.type==="property"&&(v===":"?n.colonOffset=T:v===","&&o(T))},onError:(v,T,N)=>{c.push({error:v,offset:T,length:N})}},i);const h=n.children[0];return h&&delete h.parent,h}e.parseTree=k;function p(t,c){if(!t)return;let i=t;for(const n of c)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const f of i.children)if(Array.isArray(f.children)&&f.children[0].value===n){i=f.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=p;function l(t){if(!t.parent||!t.parent.children)return[];const c=l(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;c.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&c.push(i)}return c}e.getNodePath=l;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const c=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(c[i.children[0].value]=u(n))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function d(t,c,i=!1){return c>=t.offset&&c<t.offset+t.length||i&&c===t.offset+t.length}e.contains=d;function g(t,c,i=!1){if(d(t,c,i)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=c;o++){const f=g(n[o],c,i);if(f)return f}return t}}e.findNodeAtOffset=g;function _(t,c,i=M.DEFAULT){const n=y(t,!1);function o(ce){return ce?()=>ce(n.getTokenOffset(),n.getTokenLength()):()=>!0}function f(ce){return ce?me=>ce(me,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=o(c.onObjectBegin),h=f(c.onObjectProperty),v=o(c.onObjectEnd),T=o(c.onArrayBegin),N=o(c.onArrayEnd),V=f(c.onLiteralValue),U=f(c.onSeparator),D=o(c.onComment),x=f(c.onError),L=i&&i.disallowComments,R=i&&i.allowTrailingComma;function K(){for(;;){const ce=n.scan();switch(n.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:L||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ce){case 12:case 13:L?W(10):D();break;case 16:W(1);break;case 15:case 14:break;default:return ce}}}function W(ce,me=[],ee=[]){if(x(ce),me.length+ee.length>0){let be=n.getToken();for(;be!==17;){if(me.indexOf(be)!==-1){K();break}else if(ee.indexOf(be)!==-1)break;be=K()}}}function $(ce){const me=n.getTokenValue();return ce?V(me):h(me),K(),!0}function G(){switch(n.getToken()){case 11:{let ce=0;try{ce=JSON.parse(n.getTokenValue()),typeof ce!="number"&&(W(2),ce=0)}catch{W(2)}V(ce);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return K(),!0}function re(){return n.getToken()!==10?(W(3,[],[2,5]),!1):($(!1),n.getToken()===6?(U(":"),K(),Ee()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function ge(){s(),K();let ce=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ce||W(4,[],[]),U(","),K(),n.getToken()===2&&R)break}else ce&&W(6,[],[]);re()||W(4,[],[2,5]),ce=!0}return v(),n.getToken()!==2?W(7,[2],[]):K(),!0}function oe(){T(),K();let ce=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ce||W(4,[],[]),U(","),K(),n.getToken()===4&&R)break}else ce&&W(6,[],[]);Ee()||W(4,[],[4,5]),ce=!0}return N(),n.getToken()!==4?W(8,[4],[]):K(),!0}function Ee(){switch(n.getToken()){case 3:return oe();case 1:return ge();case 10:return $(!0);default:return G()}}return K(),n.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):Ee()?(n.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=_;function a(t,c){const i=y(t),n=[];let o,f=0,s;do switch(s=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:f!==s&&n.push(t.substring(f,s)),c!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,c)),f=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=a;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[107],Ie([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(ke,ye){for(var De=0;De<ye.length;De++){var ae=ye[De];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(ke,ae.key,ae)}}function r(ke,ye,De){return ye&&e(ke.prototype,ye),De&&e(ke,De),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function C(ke,ye){if(!!ke){if(typeof ke=="string")return S(ke,ye);var De=Object.prototype.toString.call(ke).slice(8,-1);if(De==="Object"&&ke.constructor&&(De=ke.constructor.name),De==="Map"||De==="Set")return Array.from(ke);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return S(ke,ye)}}function S(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var De=0,ae=new Array(ye);De<ye;De++)ae[De]=ke[De];return ae}function M(ke,ye){var De=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(De)return(De=De.call(ke)).next.bind(De);if(Array.isArray(ke)||(De=C(ke))||ye&&ke&&typeof ke.length=="number"){De&&(ke=De);var ae=0;return function(){return ae>=ke.length?{done:!0}:{done:!1,value:ke[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=y();function A(ke){ie.defaults=ke}var E=/[&<>"']/,P=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ye){return m[ye]};function p(ke,ye){if(ye){if(E.test(ke))return ke.replace(P,k)}else if(O.test(ke))return ke.replace(b,k);return ke}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ke){return ke.replace(l,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var d=/(^|[^\[])\^/g;function g(ke,ye){ke=typeof ke=="string"?ke:ke.source,ye=ye||"";var De={replace:function(ue,Z){return Z=Z.source||Z,Z=Z.replace(d,"$1"),ke=ke.replace(ue,Z),De},getRegex:function(){return new RegExp(ke,ye)}};return De}var _=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(ke,ye,De){if(ke){var ae;try{ae=decodeURIComponent(u(De)).replace(_,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!a.test(De)&&(De=o(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var t={},c=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(ke,ye){t[" "+ke]||(c.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=v(ke,"/",!0)),ke=t[" "+ke];var De=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:ke.replace(i,"$1")+ye:ye.charAt(0)==="/"?De?ye:ke.replace(n,"$1")+ye:ke+ye}var f={exec:function(){}};function s(ke){for(var ye=1,De,ae;ye<arguments.length;ye++){De=arguments[ye];for(ae in De)Object.prototype.hasOwnProperty.call(De,ae)&&(ke[ae]=De[ae])}return ke}function h(ke,ye){var De=ke.replace(/\|/g,function(Z,J,I){for(var B=!1,H=J;--H>=0&&I[H]==="\\";)B=!B;return B?"|":" |"}),ae=De.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function v(ke,ye,De){var ae=ke.length;if(ae===0)return"";for(var ue=0;ue<ae;){var Z=ke.charAt(ae-ue-1);if(Z===ye&&!De)ue++;else if(Z!==ye&&De)ue++;else break}return ke.slice(0,ae-ue)}function T(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var De=ke.length,ae=0,ue=0;ue<De;ue++)if(ke[ue]==="\\")ue++;else if(ke[ue]===ye[0])ae++;else if(ke[ue]===ye[1]&&(ae--,ae<0))return ue;return-1}function N(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(ke,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=ke),ye>>=1,ke+=ke;return De+ke}function U(ke,ye,De,ae){var ue=ye.href,Z=ye.title?p(ye.title):null,J=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){ae.state.inLink=!0;var I={type:"link",raw:De,href:ue,title:Z,text:J,tokens:ae.inlineTokens(J)};return ae.state.inLink=!1,I}return{type:"image",raw:De,href:ue,title:Z,text:p(J)}}function D(ke,ye){var De=ke.match(/^(\s+)(?:```)/);if(De===null)return ye;var ae=De[1];return ye.split(`
`).map(function(ue){var Z=ue.match(/^\s+/);if(Z===null)return ue;var J=Z[0];return J.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var x=function(){function ke(De){this.options=De||ie.defaults}var ye=ke.prototype;return ye.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},ye.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var Z=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:v(Z,`
`)}}},ye.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var Z=ue[0],J=D(Z,ue[3]||"");return{type:"code",raw:Z,lang:ue[2]?ue[2].trim():ue[2],text:J}}},ye.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var Z=ue[2].trim();if(/#$/.test(Z)){var J=v(Z,"#");(this.options.pedantic||!J||/ $/.test(J))&&(Z=J.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:Z,tokens:this.lexer.inline(Z)}}},ye.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var Z=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},ye.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var Z,J,I,B,H,j,se,le,Y,ve,pe,Me,xe=ue[1].trim(),Ye=xe.length>1,Ge={type:"list",raw:"",ordered:Ye,start:Ye?+xe.slice(0,-1):"",loose:!1,items:[]};xe=Ye?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=Ye?xe:"[*+-]");for(var Te=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Me=!1,!(!(ue=Te.exec(ae))||this.rules.block.hr.test(ae)));){if(Z=ue[0],ae=ae.substring(Z.length),le=ue[2].split(`
`,1)[0],Y=ae.split(`
`,1)[0],this.options.pedantic?(B=2,pe=le.trimLeft()):(B=ue[2].search(/[^ ]/),B=B>4?1:B,pe=le.slice(B),B+=ue[1].length),j=!1,!le&&/^ *$/.test(Y)&&(Z+=Y+`
`,ae=ae.substring(Y.length+1),Me=!0),!Me)for(var rt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),X=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Q=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:```|~~~)"),he=new RegExp("^ {0,"+Math.min(3,B-1)+"}#");ae&&(ve=ae.split(`
`,1)[0],le=ve,this.options.pedantic&&(le=le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Q.test(le)||he.test(le)||rt.test(le)||X.test(ae)));){if(le.search(/[^ ]/)>=B||!le.trim())pe+=`
`+le.slice(B);else if(!j)pe+=`
`+le;else break;!j&&!le.trim()&&(j=!0),Z+=ve+`
`,ae=ae.substring(ve.length+1)}Ge.loose||(se?Ge.loose=!0:/\n *\n *$/.test(Z)&&(se=!0)),this.options.gfm&&(J=/^\[[ xX]\] /.exec(pe),J&&(I=J[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:Z,task:!!J,checked:I,loose:!1,text:pe}),Ge.raw+=Z}Ge.items[Ge.items.length-1].raw=Z.trimRight(),Ge.items[Ge.items.length-1].text=pe.trimRight(),Ge.raw=Ge.raw.trimRight();var Ue=Ge.items.length;for(H=0;H<Ue;H++){this.lexer.state.top=!1,Ge.items[H].tokens=this.lexer.blockTokens(Ge.items[H].text,[]);var je=Ge.items[H].tokens.filter(function(Ke){return Ke.type==="space"}),Ze=je.every(function(Ke){for(var Ve=Ke.raw.split(""),it=0,st=M(Ve),dt;!(dt=st()).done;){var _t=dt.value;if(_t===`
`&&(it+=1),it>1)return!0}return!1});!Ge.loose&&je.length&&Ze&&(Ge.loose=!0,Ge.items[H].loose=!0)}return Ge}},ye.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var Z={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var J=this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]);Z.type="paragraph",Z.text=J,Z.tokens=this.lexer.inline(J)}return Z}},ye.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Z=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var Z={type:"table",header:h(ue[1]).map(function(se){return{text:se}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=ue[0];var J=Z.align.length,I,B,H,j;for(I=0;I<J;I++)/^ *-+: *$/.test(Z.align[I])?Z.align[I]="right":/^ *:-+: *$/.test(Z.align[I])?Z.align[I]="center":/^ *:-+ *$/.test(Z.align[I])?Z.align[I]="left":Z.align[I]=null;for(J=Z.rows.length,I=0;I<J;I++)Z.rows[I]=h(Z.rows[I],Z.header.length).map(function(se){return{text:se}});for(J=Z.header.length,B=0;B<J;B++)Z.header[B].tokens=this.lexer.inline(Z.header[B].text);for(J=Z.rows.length,B=0;B<J;B++)for(j=Z.rows[B],H=0;H<j.length;H++)j[H].tokens=this.lexer.inline(j[H].text);return Z}}},ye.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},ye.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var Z=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:Z,tokens:this.lexer.inline(Z)}}},ye.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},ye.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:p(ue[1])}},ye.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]):ue[0]}},ye.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var Z=ue[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var J=v(Z.slice(0,-1),"\\");if((Z.length-J.length)%2===0)return}else{var I=T(ue[2],"()");if(I>-1){var B=ue[0].indexOf("!")===0?5:4,H=B+ue[1].length+I;ue[2]=ue[2].substring(0,I),ue[0]=ue[0].substring(0,H).trim(),ue[3]=""}}var j=ue[2],se="";if(this.options.pedantic){var le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);le&&(j=le[1],se=le[3])}else se=ue[3]?ue[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(Z)?j=j.slice(1):j=j.slice(1,-1)),U(ue,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(ae,ue){var Z;if((Z=this.rules.inline.reflink.exec(ae))||(Z=this.rules.inline.nolink.exec(ae))){var J=(Z[2]||Z[1]).replace(/\s+/g," ");if(J=ue[J.toLowerCase()],!J||!J.href){var I=Z[0].charAt(0);return{type:"text",raw:I,text:I}}return U(Z,J,Z[0],this.lexer)}},ye.emStrong=function(ae,ue,Z){Z===void 0&&(Z="");var J=this.rules.inline.emStrong.lDelim.exec(ae);if(!!J&&!(J[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=J[1]||J[2]||"";if(!I||I&&(Z===""||this.rules.inline.punctuation.exec(Z))){var B=J[0].length-1,H,j,se=B,le=0,Y=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,ue=ue.slice(-1*ae.length+B);(J=Y.exec(ue))!=null;)if(H=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!H){if(j=H.length,J[3]||J[4]){se+=j;continue}else if((J[5]||J[6])&&B%3&&!((B+j)%3)){le+=j;continue}if(se-=j,!(se>0)){if(j=Math.min(j,j+se+le),Math.min(B,j)%2){var ve=ae.slice(1,B+J.index+j);return{type:"em",raw:ae.slice(0,B+J.index+j+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var pe=ae.slice(2,B+J.index+j-1);return{type:"strong",raw:ae.slice(0,B+J.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}}}}},ye.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var Z=ue[2].replace(/\n/g," "),J=/[^ ]/.test(Z),I=/^ /.test(Z)&&/ $/.test(Z);return J&&I&&(Z=Z.substring(1,Z.length-1)),Z=p(Z,!0),{type:"codespan",raw:ue[0],text:Z}}},ye.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},ye.autolink=function(ae,ue){var Z=this.rules.inline.autolink.exec(ae);if(Z){var J,I;return Z[2]==="@"?(J=p(this.options.mangle?ue(Z[1]):Z[1]),I="mailto:"+J):(J=p(Z[1]),I=J),{type:"link",raw:Z[0],text:J,href:I,tokens:[{type:"text",raw:J,text:J}]}}},ye.url=function(ae,ue){var Z;if(Z=this.rules.inline.url.exec(ae)){var J,I;if(Z[2]==="@")J=p(this.options.mangle?ue(Z[0]):Z[0]),I="mailto:"+J;else{var B;do B=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(B!==Z[0]);J=p(Z[0]),Z[1]==="www."?I="http://"+J:I=J}return{type:"link",raw:Z[0],text:J,href:I,tokens:[{type:"text",raw:J,text:J}]}}},ye.inlineText=function(ae,ue){var Z=this.rules.inline.text.exec(ae);if(Z){var J;return this.lexer.state.inRawBlock?J=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):p(Z[0]):Z[0]:J=p(this.options.smartypants?ue(Z[0]):Z[0]),{type:"text",raw:Z[0],text:J}}},ke}(),L={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};L._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,L._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,L.def=g(L.def).replace("label",L._label).replace("title",L._title).getRegex(),L.bullet=/(?:[*+-]|\d{1,9}[.)])/,L.listItemStart=g(/^( *)(bull) */).replace("bull",L.bullet).getRegex(),L.list=g(L.list).replace(/bull/g,L.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+L.def.source+")").getRegex(),L._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",L._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,L.html=g(L.html,"i").replace("comment",L._comment).replace("tag",L._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L.paragraph=g(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.blockquote=g(L.blockquote).replace("paragraph",L.paragraph).getRegex(),L.normal=s({},L),L.gfm=s({},L.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),L.gfm.table=g(L.gfm.table).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.gfm.paragraph=g(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",L.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.pedantic=s({},L.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",L._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:g(L.normal._paragraph).replace("hr",L.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",L.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=g(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=g(L._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=g(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=g(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=g(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=g(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=g(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=g(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=g(R.reflink).replace("label",R._label).replace("ref",L._label).getRegex(),R.nolink=g(R.nolink).replace("ref",L._label).getRegex(),R.reflinkSearch=g(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=s({},R),R.pedantic=s({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=s({},R.normal,{escape:g(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=g(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=s({},R.gfm,{br:g(R.br).replace("{2,}","*").getRegex(),text:g(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ke){var ye="",De,ae,ue=ke.length;for(De=0;De<ue;De++)ae=ke.charCodeAt(De),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var $=function(){function ke(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ie.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:L.normal,inline:R.normal};this.options.pedantic?(ae.block=L.pedantic,ae.inline=R.pedantic):this.options.gfm&&(ae.block=L.gfm,this.options.breaks?ae.inline=R.breaks:ae.inline=R.gfm),this.tokenizer.rules=ae}ke.lex=function(ae,ue){var Z=new ke(ue);return Z.lex(ae)},ke.lexInline=function(ae,ue){var Z=new ke(ue);return Z.inlineTokens(ae)};var ye=ke.prototype;return ye.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(ae,ue){var Z=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,le,Y){return le+"    ".repeat(Y.length)});for(var J,I,B,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(J=se.call({lexer:Z},ae,ue))?(ae=ae.substring(J.raw.length),ue.push(J),!0):!1}))){if(J=this.tokenizer.space(ae)){ae=ae.substring(J.raw.length),J.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(J);continue}if(J=this.tokenizer.code(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):ue.push(J);continue}if(J=this.tokenizer.fences(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.heading(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.hr(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.blockquote(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.list(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.html(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.def(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+J.raw,I.text+=`
`+J.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.lheading(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,le=ae.slice(1),Y=void 0;Z.options.extensions.startBlock.forEach(function(ve){Y=ve.call({lexer:this},le),typeof Y=="number"&&Y>=0&&(se=Math.min(se,Y))}),se<1/0&&se>=0&&(B=ae.substring(0,se+1))}(),this.state.top&&(J=this.tokenizer.paragraph(B))){I=ue[ue.length-1],H&&I.type==="paragraph"?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ue.push(J),H=B.length!==ae.length,ae=ae.substring(J.raw.length);continue}if(J=this.tokenizer.text(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&I.type==="text"?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ue.push(J);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,ue},ye.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},ye.inlineTokens=function(ae,ue){var Z=this;ue===void 0&&(ue=[]);var J,I,B,H=ae,j,se,le;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)Y.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,j.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(le=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(J=pe.call({lexer:Z},ae,ue))?(ae=ae.substring(J.raw.length),ue.push(J),!0):!1}))){if(J=this.tokenizer.escape(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.tag(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&J.type==="text"&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ue.push(J);continue}if(J=this.tokenizer.link(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&J.type==="text"&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ue.push(J);continue}if(J=this.tokenizer.emStrong(ae,H,le)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.codespan(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.br(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.del(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.autolink(ae,W)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(!this.state.inLink&&(J=this.tokenizer.url(ae,W))){ae=ae.substring(J.raw.length),ue.push(J);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Me=ae.slice(1),xe=void 0;Z.options.extensions.startInline.forEach(function(Ye){xe=Ye.call({lexer:this},Me),typeof xe=="number"&&xe>=0&&(pe=Math.min(pe,xe))}),pe<1/0&&pe>=0&&(B=ae.substring(0,pe+1))}(),J=this.tokenizer.inlineText(B,K)){ae=ae.substring(J.raw.length),J.raw.slice(-1)!=="_"&&(le=J.raw.slice(-1)),se=!0,I=ue[ue.length-1],I&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ue.push(J);continue}if(ae){var ve="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ue},r(ke,null,[{key:"rules",get:function(){return{block:L,inline:R}}}]),ke}(),G=function(){function ke(De){this.options=De||ie.defaults}var ye=ke.prototype;return ye.code=function(ae,ue,Z){var J=(ue||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(ae,J);I!=null&&I!==ae&&(Z=!0,ae=I)}return ae=ae.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+p(J,!0)+'">'+(Z?ae:p(ae,!0))+`</code></pre>
`:"<pre><code>"+(Z?ae:p(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,ue,Z,J){if(this.options.headerIds){var I=this.options.headerPrefix+J.slug(Z);return"<h"+ue+' id="'+I+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,ue,Z){var J=ue?"ol":"ul",I=ue&&Z!==1?' start="'+Z+'"':"";return"<"+J+I+`>
`+ae+"</"+J+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,ue){var Z=ue.header?"th":"td",J=ue.align?"<"+Z+' align="'+ue.align+'">':"<"+Z+">";return J+ae+("</"+Z+`>
`)},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,ue,Z){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var J='<a href="'+p(ae)+'"';return ue&&(J+=' title="'+ue+'"'),J+=">"+Z+"</a>",J},ye.image=function(ae,ue,Z){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var J='<img src="'+ae+'" alt="'+Z+'"';return ue&&(J+=' title="'+ue+'"'),J+=this.options.xhtml?"/>":">",J},ye.text=function(ae){return ae},ke}(),re=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,ue,Z){return""+Z},ye.image=function(ae,ue,Z){return""+Z},ye.br=function(){return""},ke}(),ge=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,ue){var Z=ae,J=0;if(this.seen.hasOwnProperty(Z)){J=this.seen[ae];do J++,Z=ae+"-"+J;while(this.seen.hasOwnProperty(Z))}return ue||(this.seen[ae]=J,this.seen[Z]=0),Z},ye.slug=function(ae,ue){ue===void 0&&(ue={});var Z=this.serialize(ae);return this.getNextSafeSlug(Z,ue.dryrun)},ke}(),oe=function(){function ke(De){this.options=De||ie.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new ge}ke.parse=function(ae,ue){var Z=new ke(ue);return Z.parse(ae)},ke.parseInline=function(ae,ue){var Z=new ke(ue);return Z.parseInline(ae)};var ye=ke.prototype;return ye.parse=function(ae,ue){ue===void 0&&(ue=!0);var Z="",J,I,B,H,j,se,le,Y,ve,pe,Me,xe,Ye,Ge,Te,rt,X,Q,he,Ue=ae.length;for(J=0;J<Ue;J++){if(pe=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(he=this.options.extensions.renderers[pe.type].call({parser:this},pe),he!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){Z+=he||"";continue}switch(pe.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,u(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(Y="",le="",H=pe.header.length,I=0;I<H;I++)le+=this.renderer.tablecell(this.parseInline(pe.header[I].tokens),{header:!0,align:pe.align[I]});for(Y+=this.renderer.tablerow(le),ve="",H=pe.rows.length,I=0;I<H;I++){for(se=pe.rows[I],le="",j=se.length,B=0;B<j;B++)le+=this.renderer.tablecell(this.parseInline(se[B].tokens),{header:!1,align:pe.align[B]});ve+=this.renderer.tablerow(le)}Z+=this.renderer.table(Y,ve);continue}case"blockquote":{ve=this.parse(pe.tokens),Z+=this.renderer.blockquote(ve);continue}case"list":{for(Me=pe.ordered,xe=pe.start,Ye=pe.loose,H=pe.items.length,ve="",I=0;I<H;I++)Te=pe.items[I],rt=Te.checked,X=Te.task,Ge="",Te.task&&(Q=this.renderer.checkbox(rt),Ye?Te.tokens.length>0&&Te.tokens[0].type==="paragraph"?(Te.tokens[0].text=Q+" "+Te.tokens[0].text,Te.tokens[0].tokens&&Te.tokens[0].tokens.length>0&&Te.tokens[0].tokens[0].type==="text"&&(Te.tokens[0].tokens[0].text=Q+" "+Te.tokens[0].tokens[0].text)):Te.tokens.unshift({type:"text",text:Q}):Ge+=Q),Ge+=this.parse(Te.tokens,Ye),ve+=this.renderer.listitem(Ge,X,rt);Z+=this.renderer.list(ve,Me,xe);continue}case"html":{Z+=this.renderer.html(pe.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(ve=pe.tokens?this.parseInline(pe.tokens):pe.text;J+1<Ue&&ae[J+1].type==="text";)pe=ae[++J],ve+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);Z+=ue?this.renderer.paragraph(ve):ve;continue}default:{var je='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return Z},ye.parseInline=function(ae,ue){ue=ue||this.renderer;var Z="",J,I,B,H=ae.length;for(J=0;J<H;J++){if(I=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(B=this.options.extensions.renderers[I.type].call({parser:this},I),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){Z+=B||"";continue}switch(I.type){case"escape":{Z+=ue.text(I.text);break}case"html":{Z+=ue.html(I.text);break}case"link":{Z+=ue.link(I.href,I.title,this.parseInline(I.tokens,ue));break}case"image":{Z+=ue.image(I.href,I.title,I.text);break}case"strong":{Z+=ue.strong(this.parseInline(I.tokens,ue));break}case"em":{Z+=ue.em(this.parseInline(I.tokens,ue));break}case"codespan":{Z+=ue.codespan(I.text);break}case"br":{Z+=ue.br();break}case"del":{Z+=ue.del(this.parseInline(I.tokens,ue));break}case"text":{Z+=ue.text(I.text);break}default:{var j='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return Z},ke}();function Ee(ke,ye,De){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=s({},Ee.defaults,ye||{}),N(ye),De){var ae=ye.highlight,ue;try{ue=$.lex(ke,ye)}catch(H){return De(H)}var Z=function(j){var se;if(!j)try{ye.walkTokens&&Ee.walkTokens(ue,ye.walkTokens),se=oe.parse(ue,ye)}catch(le){j=le}return ye.highlight=ae,j?De(j):De(null,se)};if(!ae||ae.length<3||(delete ye.highlight,!ue.length))return Z();var J=0;Ee.walkTokens(ue,function(H){H.type==="code"&&(J++,setTimeout(function(){ae(H.text,H.lang,function(j,se){if(j)return Z(j);se!=null&&se!==H.text&&(H.text=se,H.escaped=!0),J--,J===0&&Z()})},0))}),J===0&&Z();return}function I(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+p(H.message+"",!0)+"</pre>";throw H}try{var B=$.lex(ke,ye);if(ye.walkTokens){if(ye.async)return Promise.all(Ee.walkTokens(B,ye.walkTokens)).then(function(){return oe.parse(B,ye)}).catch(I);Ee.walkTokens(B,ye.walkTokens)}return oe.parse(B,ye)}catch(H){I(H)}}Ee.options=Ee.setOptions=function(ke){return s(Ee.defaults,ke),A(Ee.defaults),Ee},Ee.getDefaults=y,Ee.defaults=ie.defaults,Ee.use=function(){for(var ke=arguments.length,ye=new Array(ke),De=0;De<ke;De++)ye[De]=arguments[De];var ae=s.apply(void 0,[{}].concat(ye)),ue=Ee.defaults.extensions||{renderers:{},childTokens:{}},Z;ye.forEach(function(J){if(J.extensions&&(Z=!0,J.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var H=ue.renderers?ue.renderers[B.name]:null;H?ue.renderers[B.name]=function(){for(var j=arguments.length,se=new Array(j),le=0;le<j;le++)se[le]=arguments[le];var Y=B.renderer.apply(this,se);return Y===!1&&(Y=H.apply(this,se)),Y}:ue.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[B.level]?ue[B.level].unshift(B.tokenizer):ue[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ue.startBlock?ue.startBlock.push(B.start):ue.startBlock=[B.start]:B.level==="inline"&&(ue.startInline?ue.startInline.push(B.start):ue.startInline=[B.start]))}B.childTokens&&(ue.childTokens[B.name]=B.childTokens)})),J.renderer&&function(){var B=Ee.defaults.renderer||new G,H=function(le){var Y=B[le];B[le]=function(){for(var ve=arguments.length,pe=new Array(ve),Me=0;Me<ve;Me++)pe[Me]=arguments[Me];var xe=J.renderer[le].apply(B,pe);return xe===!1&&(xe=Y.apply(B,pe)),xe}};for(var j in J.renderer)H(j);ae.renderer=B}(),J.tokenizer&&function(){var B=Ee.defaults.tokenizer||new x,H=function(le){var Y=B[le];B[le]=function(){for(var ve=arguments.length,pe=new Array(ve),Me=0;Me<ve;Me++)pe[Me]=arguments[Me];var xe=J.tokenizer[le].apply(B,pe);return xe===!1&&(xe=Y.apply(B,pe)),xe}};for(var j in J.tokenizer)H(j);ae.tokenizer=B}(),J.walkTokens){var I=Ee.defaults.walkTokens;ae.walkTokens=function(B){var H=[];return H.push(J.walkTokens.call(this,B)),I&&(H=H.concat(I.call(this,B))),H}}Z&&(ae.extensions=ue),Ee.setOptions(ae)})},Ee.walkTokens=function(ke,ye){for(var De=[],ae=function(){var I=Z.value;switch(De=De.concat(ye.call(Ee,I)),I.type){case"table":{for(var B=M(I.header),H;!(H=B()).done;){var j=H.value;De=De.concat(Ee.walkTokens(j.tokens,ye))}for(var se=M(I.rows),le;!(le=se()).done;)for(var Y=le.value,ve=M(Y),pe;!(pe=ve()).done;){var Me=pe.value;De=De.concat(Ee.walkTokens(Me.tokens,ye))}break}case"list":{De=De.concat(Ee.walkTokens(I.items,ye));break}default:Ee.defaults.extensions&&Ee.defaults.extensions.childTokens&&Ee.defaults.extensions.childTokens[I.type]?Ee.defaults.extensions.childTokens[I.type].forEach(function(xe){De=De.concat(Ee.walkTokens(I[xe],ye))}):I.tokens&&(De=De.concat(Ee.walkTokens(I.tokens,ye)))}},ue=M(ke),Z;!(Z=ue()).done;)ae();return De},Ee.parseInline=function(ke,ye){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=s({},Ee.defaults,ye||{}),N(ye);try{var De=$.lexInline(ke,ye);return ye.walkTokens&&Ee.walkTokens(De,ye.walkTokens),oe.parseInline(De,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+p(ae.message+"",!0)+"</pre>";throw ae}},Ee.Parser=oe,Ee.parser=oe.parse,Ee.Renderer=G,Ee.TextRenderer=re,Ee.Lexer=$,Ee.lexer=$.lex,Ee.Tokenizer=x,Ee.Slugger=ge,Ee.parse=Ee;var ce=Ee.options,me=Ee.setOptions,ee=Ee.use,be=Ee.walkTokens,_e=Ee.parseInline,Fe=Ee,Be=oe.parse,Xe=$.lex;ie.Lexer=$,ie.Parser=oe,ie.Renderer=G,ie.Slugger=ge,ie.TextRenderer=re,ie.Tokenizer=x,ie.getDefaults=y,ie.lexer=Xe,ie.marked=Ee,ie.options=ce,ie.parse=Fe,ie.parseInline=_e,ie.parser=Be,ie.setOptions=me,ie.use=ee,ie.walkTokens=be,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Ce[108],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(A,E,P){return Math.min(Math.max(A,E),P)}e.clamp=r;function C(A,E){return(E+A%E)%E}e.rot=C;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class M{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class y{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const P=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function ie(S){const M=[];typeof S=="number"&&M.push("code/timeOrigin",S);function y(E){M.push(E,Date.now())}function A(){const E=[];for(let P=0;P<M.length;P+=2)E.push({name:M[P],startTime:M[P+1]});return E}return{mark:y,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const y of performance.getEntriesByType("mark"))M.push({name:y.name,startTime:Math.round(S+y.startTime)});return M}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function r(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=r(C))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var C in r)(typeof exports=="object"?exports:ie)[C]=r[C]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function r(C){if(e[C])return e[C].exports;var S=e[C]={i:C,l:!1,exports:{}};return ie[C].call(S.exports,S,S.exports,r),S.l=!0,S.exports}return r.m=ie,r.c=e,r.d=function(C,S,M){r.o(C,S)||Object.defineProperty(C,S,{enumerable:!0,get:M})},r.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},r.t=function(C,S){if(1&S&&(C=r(C)),8&S||4&S&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(r.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&S&&typeof C!="string")for(var y in C)r.d(M,y,function(A){return C[A]}.bind(null,y));return M},r.n=function(C){var S=C&&C.__esModule?function(){return C.default}:function(){return C};return r.d(S,"a",S),S},r.o=function(C,S){return Object.prototype.hasOwnProperty.call(C,S)},r.p="",r(r.s=0)}([function(ie,e,r){(function(C){var S;e=ie.exports=ee,S=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],E=e.src=[],P=0,O=P++;E[O]="0|[1-9]\\d*";var b=P++;E[b]="[0-9]+";var m=P++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=P++;E[k]="("+E[O]+")\\.("+E[O]+")\\.("+E[O]+")";var p=P++;E[p]="("+E[b]+")\\.("+E[b]+")\\.("+E[b]+")";var l=P++;E[l]="(?:"+E[O]+"|"+E[m]+")";var u=P++;E[u]="(?:"+E[b]+"|"+E[m]+")";var d=P++;E[d]="(?:-("+E[l]+"(?:\\."+E[l]+")*))";var g=P++;E[g]="(?:-?("+E[u]+"(?:\\."+E[u]+")*))";var _=P++;E[_]="[0-9A-Za-z-]+";var a=P++;E[a]="(?:\\+("+E[_]+"(?:\\."+E[_]+")*))";var w=P++,t="v?"+E[k]+E[d]+"?"+E[a]+"?";E[w]="^"+t+"$";var c="[v=\\s]*"+E[p]+E[g]+"?"+E[a]+"?",i=P++;E[i]="^"+c+"$";var n=P++;E[n]="((?:<|>)?=?)";var o=P++;E[o]=E[b]+"|x|X|\\*";var f=P++;E[f]=E[O]+"|x|X|\\*";var s=P++;E[s]="[v=\\s]*("+E[f]+")(?:\\.("+E[f]+")(?:\\.("+E[f]+")(?:"+E[d]+")?"+E[a]+"?)?)?";var h=P++;E[h]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[g]+")?"+E[a]+"?)?)?";var v=P++;E[v]="^"+E[n]+"\\s*"+E[s]+"$";var T=P++;E[T]="^"+E[n]+"\\s*"+E[h]+"$";var N=P++;E[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=P++;E[V]="(?:~>?)";var U=P++;E[U]="(\\s*)"+E[V]+"\\s+",A[U]=new RegExp(E[U],"g");var D=P++;E[D]="^"+E[V]+E[s]+"$";var x=P++;E[x]="^"+E[V]+E[h]+"$";var L=P++;E[L]="(?:\\^)";var R=P++;E[R]="(\\s*)"+E[L]+"\\s+",A[R]=new RegExp(E[R],"g");var K=P++;E[K]="^"+E[L]+E[s]+"$";var W=P++;E[W]="^"+E[L]+E[h]+"$";var $=P++;E[$]="^"+E[n]+"\\s*("+c+")$|^$";var G=P++;E[G]="^"+E[n]+"\\s*("+t+")$|^$";var re=P++;E[re]="(\\s*)"+E[n]+"\\s*("+c+"|"+E[s]+")",A[re]=new RegExp(E[re],"g");var ge=P++;E[ge]="^\\s*("+E[s]+")\\s+-\\s+("+E[s]+")\\s*$";var oe=P++;E[oe]="^\\s*("+E[h]+")\\s+-\\s+("+E[h]+")\\s*$";var Ee=P++;E[Ee]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)S(ce,E[ce]),A[ce]||(A[ce]=new RegExp(E[ce]));function me(Y,ve){if(Y instanceof ee)return Y;if(typeof Y!="string"||Y.length>M||!(ve?A[i]:A[w]).test(Y))return null;try{return new ee(Y,ve)}catch{return null}}function ee(Y,ve){if(Y instanceof ee){if(Y.loose===ve)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ee))return new ee(Y,ve);S("SemVer",Y,ve),this.loose=ve;var pe=Y.trim().match(ve?A[i]:A[w]);if(!pe)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var xe=+Me;if(xe>=0&&xe<y)return xe}return Me}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=me,e.valid=function(Y,ve){var pe=me(Y,ve);return pe?pe.version:null},e.clean=function(Y,ve){var pe=me(Y.trim().replace(/^[=v]+/,""),ve);return pe?pe.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(Y){return S("SemVer.compare",this.version,this.loose,Y),Y instanceof ee||(Y=new ee(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},ee.prototype.compareMain=function(Y){return Y instanceof ee||(Y=new ee(Y,this.loose)),_e(this.major,Y.major)||_e(this.minor,Y.minor)||_e(this.patch,Y.patch)},ee.prototype.comparePre=function(Y){if(Y instanceof ee||(Y=new ee(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ve=0;do{var pe=this.prerelease[ve],Me=Y.prerelease[ve];if(S("prerelease compare",ve,pe,Me),pe===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(pe===void 0)return-1;if(pe!==Me)return _e(pe,Me)}while(++ve)},ee.prototype.inc=function(Y,ve){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ve,pe,Me){typeof pe=="string"&&(Me=pe,pe=void 0);try{return new ee(Y,pe).inc(ve,Me).version}catch{return null}},e.diff=function(Y,ve){if(ke(Y,ve))return null;var pe=me(Y),Me=me(ve);if(pe.prerelease.length||Me.prerelease.length){for(var xe in pe)if((xe==="major"||xe==="minor"||xe==="patch")&&pe[xe]!==Me[xe])return"pre"+xe;return"prerelease"}for(var xe in pe)if((xe==="major"||xe==="minor"||xe==="patch")&&pe[xe]!==Me[xe])return xe},e.compareIdentifiers=_e;var be=/^[0-9]+$/;function _e(Y,ve){var pe=be.test(Y),Me=be.test(ve);return pe&&Me&&(Y=+Y,ve=+ve),pe&&!Me?-1:Me&&!pe?1:Y<ve?-1:Y>ve?1:0}function Fe(Y,ve,pe){return new ee(Y,pe).compare(new ee(ve,pe))}function Be(Y,ve,pe){return Fe(Y,ve,pe)>0}function Xe(Y,ve,pe){return Fe(Y,ve,pe)<0}function ke(Y,ve,pe){return Fe(Y,ve,pe)===0}function ye(Y,ve,pe){return Fe(Y,ve,pe)!==0}function De(Y,ve,pe){return Fe(Y,ve,pe)>=0}function ae(Y,ve,pe){return Fe(Y,ve,pe)<=0}function ue(Y,ve,pe,Me){var xe;switch(ve){case"===":typeof Y=="object"&&(Y=Y.version),typeof pe=="object"&&(pe=pe.version),xe=Y===pe;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof pe=="object"&&(pe=pe.version),xe=Y!==pe;break;case"":case"=":case"==":xe=ke(Y,pe,Me);break;case"!=":xe=ye(Y,pe,Me);break;case">":xe=Be(Y,pe,Me);break;case">=":xe=De(Y,pe,Me);break;case"<":xe=Xe(Y,pe,Me);break;case"<=":xe=ae(Y,pe,Me);break;default:throw new TypeError("Invalid operator: "+ve)}return xe}function Z(Y,ve){if(Y instanceof Z){if(Y.loose===ve)return Y;Y=Y.value}if(!(this instanceof Z))return new Z(Y,ve);S("comparator",Y,ve),this.loose=ve,this.parse(Y),this.semver===J?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(Y,ve){return _e(ve,Y)},e.major=function(Y,ve){return new ee(Y,ve).major},e.minor=function(Y,ve){return new ee(Y,ve).minor},e.patch=function(Y,ve){return new ee(Y,ve).patch},e.compare=Fe,e.compareLoose=function(Y,ve){return Fe(Y,ve,!0)},e.rcompare=function(Y,ve,pe){return Fe(ve,Y,pe)},e.sort=function(Y,ve){return Y.sort(function(pe,Me){return e.compare(pe,Me,ve)})},e.rsort=function(Y,ve){return Y.sort(function(pe,Me){return e.rcompare(pe,Me,ve)})},e.gt=Be,e.lt=Xe,e.eq=ke,e.neq=ye,e.gte=De,e.lte=ae,e.cmp=ue,e.Comparator=Z;var J={};function I(Y,ve){if(Y instanceof I)return Y.loose===ve?Y:new I(Y.raw,ve);if(Y instanceof Z)return new I(Y.value,ve);if(!(this instanceof I))return new I(Y,ve);if(this.loose=ve,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function B(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function H(Y,ve,pe,Me,xe,Ye,Ge,Te,rt,X,Q,he,Ue){return((ve=B(pe)?"":B(Me)?">="+pe+".0.0":B(xe)?">="+pe+"."+Me+".0":">="+ve)+" "+(Te=B(rt)?"":B(X)?"<"+(+rt+1)+".0.0":B(Q)?"<"+rt+"."+(+X+1)+".0":he?"<="+rt+"."+X+"."+Q+"-"+he:"<="+Te)).trim()}function j(Y,ve){for(var pe=0;pe<Y.length;pe++)if(!Y[pe].test(ve))return!1;if(ve.prerelease.length){for(pe=0;pe<Y.length;pe++)if(S(Y[pe].semver),Y[pe].semver!==J&&Y[pe].semver.prerelease.length>0){var Me=Y[pe].semver;if(Me.major===ve.major&&Me.minor===ve.minor&&Me.patch===ve.patch)return!0}return!1}return!0}function se(Y,ve,pe){try{ve=new I(ve,pe)}catch{return!1}return ve.test(Y)}function le(Y,ve,pe,Me){var xe,Ye,Ge,Te,rt;switch(Y=new ee(Y,Me),ve=new I(ve,Me),pe){case">":xe=Be,Ye=ae,Ge=Xe,Te=">",rt=">=";break;case"<":xe=Xe,Ye=De,Ge=Be,Te="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Y,ve,Me))return!1;for(var X=0;X<ve.set.length;++X){var Q=ve.set[X],he=null,Ue=null;if(Q.forEach(function(je){je.semver===J&&(je=new Z(">=0.0.0")),he=he||je,Ue=Ue||je,xe(je.semver,he.semver,Me)?he=je:Ge(je.semver,Ue.semver,Me)&&(Ue=je)}),he.operator===Te||he.operator===rt||(!Ue.operator||Ue.operator===Te)&&Ye(Y,Ue.semver)||Ue.operator===rt&&Ge(Y,Ue.semver))return!1}return!0}Z.prototype.parse=function(Y){var ve=this.loose?A[$]:A[G],pe=Y.match(ve);if(!pe)throw new TypeError("Invalid comparator: "+Y);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new ee(pe[2],this.loose):this.semver=J},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(Y){return S("Comparator.test",Y,this.loose),this.semver===J||(typeof Y=="string"&&(Y=new ee(Y,this.loose)),ue(Y,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(Y,ve){if(!(Y instanceof Z))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new I(Y.value,ve),se(this.value,pe,ve);if(Y.operator==="")return pe=new I(this.value,ve),se(Y.semver,pe,ve);var Me=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ye=this.semver.version===Y.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Te=ue(this.semver,"<",Y.semver,ve)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),rt=ue(this.semver,">",Y.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Me||xe||Ye&&Ge||Te||rt},e.Range=I,I.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},I.prototype.toString=function(){return this.range},I.prototype.parseRange=function(Y){var ve=this.loose;Y=Y.trim(),S("range",Y,ve);var pe=ve?A[oe]:A[ge];Y=Y.replace(pe,H),S("hyphen replace",Y),Y=Y.replace(A[re],"$1$2$3"),S("comparator trim",Y,A[re]),Y=(Y=(Y=Y.replace(A[U],"$1~")).replace(A[R],"$1^")).split(/\s+/).join(" ");var Me=ve?A[$]:A[G],xe=Y.split(" ").map(function(Ye){return function(Ge,Te){return S("comp",Ge),Ge=function(rt,X){return rt.trim().split(/\s+/).map(function(Q){return function(he,Ue){S("caret",he,Ue);var je=Ue?A[W]:A[K];return he.replace(je,function(Ze,Ke,Ve,it,st){var dt;return S("caret",he,Ze,Ke,Ve,it,st),B(Ke)?dt="":B(Ve)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?dt=Ke==="0"?">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+".0 <"+(+Ke+1)+".0.0":st?(S("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+st+" <"+(+Ke+1)+".0.0"):(S("no pr"),dt=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+" <"+(+Ke+1)+".0.0"),S("caret return",dt),dt})}(Q,X)}).join(" ")}(Ge,Te),S("caret",Ge),Ge=function(rt,X){return rt.trim().split(/\s+/).map(function(Q){return function(he,Ue){var je=Ue?A[x]:A[D];return he.replace(je,function(Ze,Ke,Ve,it,st){var dt;return S("tilde",he,Ze,Ke,Ve,it,st),B(Ke)?dt="":B(Ve)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?dt=">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":st?(S("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0"):dt=">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0",S("tilde return",dt),dt})}(Q,X)}).join(" ")}(Ge,Te),S("tildes",Ge),Ge=function(rt,X){return S("replaceXRanges",rt,X),rt.split(/\s+/).map(function(Q){return function(he,Ue){he=he.trim();var je=Ue?A[T]:A[v];return he.replace(je,function(Ze,Ke,Ve,it,st,dt){S("xRange",he,Ze,Ke,Ve,it,st,dt);var _t=B(Ve),tt=_t||B(it),ut=tt||B(st);return Ke==="="&&ut&&(Ke=""),_t?Ze=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&ut?(tt&&(it=0),ut&&(st=0),Ke===">"?(Ke=">=",tt?(Ve=+Ve+1,it=0,st=0):ut&&(it=+it+1,st=0)):Ke==="<="&&(Ke="<",tt?Ve=+Ve+1:it=+it+1),Ze=Ke+Ve+"."+it+"."+st):tt?Ze=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":ut&&(Ze=">="+Ve+"."+it+".0 <"+Ve+"."+(+it+1)+".0"),S("xRange return",Ze),Ze})}(Q,X)}).join(" ")}(Ge,Te),S("xrange",Ge),Ge=function(rt,X){return S("replaceStars",rt,X),rt.trim().replace(A[Ee],"")}(Ge,Te),S("stars",Ge),Ge}(Ye,ve)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(Ye){return!!Ye.match(Me)})),xe=xe.map(function(Ye){return new Z(Ye,ve)})},I.prototype.intersects=function(Y,ve){if(!(Y instanceof I))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Me){return Y.set.some(function(xe){return xe.every(function(Ye){return Me.intersects(Ye,ve)})})})})},e.toComparators=function(Y,ve){return new I(Y,ve).set.map(function(pe){return pe.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},I.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new ee(Y,this.loose));for(var ve=0;ve<this.set.length;ve++)if(j(this.set[ve],Y))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Y,ve,pe){var Me=null,xe=null;try{var Ye=new I(ve,pe)}catch{return null}return Y.forEach(function(Ge){Ye.test(Ge)&&(Me&&xe.compare(Ge)!==-1||(xe=new ee(Me=Ge,pe)))}),Me},e.minSatisfying=function(Y,ve,pe){var Me=null,xe=null;try{var Ye=new I(ve,pe)}catch{return null}return Y.forEach(function(Ge){Ye.test(Ge)&&(Me&&xe.compare(Ge)!==1||(xe=new ee(Me=Ge,pe)))}),Me},e.validRange=function(Y,ve){try{return new I(Y,ve).range||"*"}catch{return null}},e.ltr=function(Y,ve,pe){return le(Y,ve,"<",pe)},e.gtr=function(Y,ve,pe){return le(Y,ve,">",pe)},e.outside=le,e.prerelease=function(Y,ve){var pe=me(Y,ve);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(Y,ve,pe){return Y=new I(Y,pe),ve=new I(ve,pe),Y.intersects(ve)},e.coerce=function(Y){if(Y instanceof ee)return Y;if(typeof Y!="string")return null;var ve=Y.match(A[N]);return ve==null?null:me((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,r(1))},function(ie,e){var r,C,S=ie.exports={};function M(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function A(u){if(r===setTimeout)return setTimeout(u,0);if((r===M||!r)&&setTimeout)return r=setTimeout,setTimeout(u,0);try{return r(u,0)}catch{try{return r.call(null,u,0)}catch{return r.call(this,u,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:M}catch{r=M}try{C=typeof clearTimeout=="function"?clearTimeout:y}catch{C=y}})();var E,P=[],O=!1,b=-1;function m(){O&&E&&(O=!1,E.length?P=E.concat(P):b=-1,P.length&&k())}function k(){if(!O){var u=A(m);O=!0;for(var d=P.length;d;){for(E=P,P=[];++b<d;)E&&E[b].run();b=-1,d=P.length}E=null,O=!1,function(g){if(C===clearTimeout)return clearTimeout(g);if((C===y||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(g);try{C(g)}catch{try{return C.call(null,g)}catch{return C.call(this,g)}}}(u)}}function p(u,d){this.fun=u,this.array=d}function l(){}S.nextTick=function(u){var d=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)d[g-1]=arguments[g];P.push(new p(u,d)),P.length!==1||O||A(k)},p.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=l,S.addListener=l,S.once=l,S.off=l,S.removeListener=l,S.removeAllListeners=l,S.emit=l,S.prependListener=l,S.prependOnceListener=l,S.listeners=function(u){return[]},S.binding=function(u){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(u){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ce[109],Ie([1,0,12,7]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(a){const w=a;return w?typeof w.read=="function":!1}e.isReadable=S;function M(a){const w=a;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=M;function y(a){const w=a;return w?M(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(a,w){return new E(a,w)}e.newWriteableStream=A;class E{constructor(w,t){this.reducer=w,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(t=>t(w))}emitError(w){this.listeners.error.length===0?(0,r.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(t=>t(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,t){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(w,t){if(this.state.destroyed)return;let c;switch(w){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const i=c.indexOf(t);i>=0&&c.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(a,w){const t=[];let c;for(;(c=a.read())!==null;)t.push(c);return w(t)}e.consumeReadable=P;function O(a,w,t){const c=[];let i;for(;(i=a.read())!==null&&c.length<t;)c.push(i);return i===null&&c.length>0?w(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return a.read()}}}e.peekReadable=O;function b(a,w){return new Promise((t,c)=>{const i=[];m(a,{onData:n=>{w&&i.push(n)},onError:n=>{w?c(n):t(void 0)},onEnd:()=>{t(w?w(i):void 0)}})})}e.consumeStream=b;function m(a,w){let t=!1;return a.on("error",c=>{t||w.onError(c)}),a.on("end",()=>{t||w.onEnd()}),a.on("data",c=>{t||w.onData(c)}),(0,C.toDisposable)(()=>t=!0)}e.listenStream=m;function k(a,w){return new Promise((t,c)=>{const i=new C.DisposableStore,n=[],o=h=>{if(n.push(h),n.length>w)return i.dispose(),a.pause(),t({stream:a,buffer:n,ended:!1})},f=h=>c(h),s=()=>t({stream:a,buffer:n,ended:!0});i.add((0,C.toDisposable)(()=>a.removeListener("error",f))),a.on("error",f),i.add((0,C.toDisposable)(()=>a.removeListener("end",s))),a.on("end",s),i.add((0,C.toDisposable)(()=>a.removeListener("data",o))),a.on("data",o)})}e.peekStream=k;function p(a,w){const t=A(w);return t.end(a),t}e.toStream=p;function l(){const a=A(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=l;function u(a){let w=!1;return{read:()=>w?null:(w=!0,a)}}e.toReadable=u;function d(a,w,t){const c=A(t);return m(a,{onData:i=>c.write(w.data(i)),onError:i=>c.error(w.error?w.error(i):i),onEnd:()=>c.end()}),c}e.transform=d;function g(a,w,t){let c=!1;return{read:()=>{const i=w.read();return c?i:(c=!0,i!==null?t([a,i]):a)}}}e.prefixedReadable=g;function _(a,w,t){let c=!1;const i=A(t);return m(w,{onData:n=>c?i.write(n):(c=!0,i.write(t([a,n]))),onError:n=>i.error(n),onEnd:()=>{c||(c=!0,i.write(a)),i.end()}}),i}e.prefixedStream=_}),define(Ce[23],Ie([1,0,109]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let S,M;class y{static alloc(h){return C?new y(Buffer.allocUnsafe(h)):new y(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new y(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&C?new y(Buffer.from(h)):(S||(S=new TextEncoder),new y(S.encode(h)))}static fromByteArray(h){const v=y.alloc(h.length);for(let T=0,N=h.length;T<N;T++)v.buffer[T]=h[T];return v}static concat(h,v){if(typeof v>"u"){v=0;for(let V=0,U=h.length;V<U;V++)v+=h[V].byteLength}const T=y.alloc(v);let N=0;for(let V=0,U=h.length;V<U;V++){const D=h[V];T.set(D,N),N+=D.byteLength}return T}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=y.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(h,v){return new y(this.buffer.subarray(h,v))}set(h,v){if(h instanceof y)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return P(this.buffer,h)}writeUInt32BE(h,v){O(this.buffer,h,v)}readUInt32LE(h){return b(this.buffer,h)}writeUInt32LE(h,v){m(this.buffer,h,v)}readUInt8(h){return k(this.buffer,h)}writeUInt8(h,v){p(this.buffer,h,v)}}e.VSBuffer=y;function A(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0}e.readUInt16LE=A;function E(s,h,v){s[v+0]=h&255,h=h>>>8,s[v+1]=h&255}e.writeUInt16LE=E;function P(s,h){return s[h]*2**24+s[h+1]*2**16+s[h+2]*2**8+s[h+3]}e.readUInt32BE=P;function O(s,h,v){s[v+3]=h,h=h>>>8,s[v+2]=h,h=h>>>8,s[v+1]=h,h=h>>>8,s[v]=h}e.writeUInt32BE=O;function b(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0|s[h+2]<<16>>>0|s[h+3]<<24>>>0}e.readUInt32LE=b;function m(s,h,v){s[v+0]=h&255,h=h>>>8,s[v+1]=h&255,h=h>>>8,s[v+2]=h&255,h=h>>>8,s[v+3]=h&255}e.writeUInt32LE=m;function k(s,h){return s[h]}e.readUInt8=k;function p(s,h,v){s[v]=h}e.writeUInt8=p;function l(s){return r.consumeReadable(s,h=>y.concat(h))}e.readableToBuffer=l;function u(s){return r.toReadable(s)}e.bufferToReadable=u;function d(s){return r.consumeStream(s,h=>y.concat(h))}e.streamToBuffer=d;async function g(s){return s.ended?y.concat(s.buffer):y.concat([...s.buffer,await d(s.stream)])}e.bufferedStreamToBuffer=g;function _(s){return r.toStream(s,h=>y.concat(h))}e.bufferToStream=_;function a(s){return r.transform(s,{data:h=>typeof h=="string"?y.fromString(h):y.wrap(h)},h=>y.concat(h))}e.streamToBufferReadableStream=a;function w(s){return r.newWriteableStream(h=>y.concat(h),s)}e.newWriteableBufferStream=w;function t(s,h){return r.prefixedReadable(s,h,v=>y.concat(v))}e.prefixedBufferReadable=t;function c(s,h){return r.prefixedStream(s,h,v=>y.concat(v))}e.prefixedBufferStream=c;function i(s){let h=0,v=0,T=0;const N=new Uint8Array(Math.floor(s.length/4*3)),V=D=>{switch(v){case 3:N[T++]=h|D,v=0;break;case 2:N[T++]=h|D>>>2,h=D<<6,v=3;break;case 1:N[T++]=h|D>>>4,h=D<<4,v=2;break;default:h=D<<2,v=1}};for(let D=0;D<s.length;D++){const x=s.charCodeAt(D);if(x>=65&&x<=90)V(x-65);else if(x>=97&&x<=122)V(x-97+26);else if(x>=48&&x<=57)V(x-48+52);else if(x===43||x===45)V(62);else if(x===47||x===95)V(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${s[D]}`)}}const U=T;for(;v>0;)V(0);return y.wrap(N).slice(0,U)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:s},h=!0,v=!1){const T=v?o:n;let N="";const V=s.byteLength%3;let U=0;for(;U<s.byteLength-V;U+=3){const D=s[U+0],x=s[U+1],L=s[U+2];N+=T[D>>>2],N+=T[(D<<4|x>>>4)&63],N+=T[(x<<2|L>>>6)&63],N+=T[L&63]}if(V===1){const D=s[U+0];N+=T[D>>>2],N+=T[D<<4&63],h&&(N+="==")}else if(V===2){const D=s[U+0],x=s[U+1];N+=T[D>>>2],N+=T[(D<<4|x>>>4)&63],N+=T[x<<2&63],h&&(N+="=")}return N}e.encodeBase64=f}),define(Ce[43],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(S){return r.test(S)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(A){for(let E=0;E<A.length;E++)A[E]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),y=[];for(let A=0;A<256;A++)y.push(A.toString(16).padStart(2,"0"));return function(){S(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,P="";return P+=y[M[E++]],P+=y[M[E++]],P+=y[M[E++]],P+=y[M[E++]],P+="-",P+=y[M[E++]],P+=y[M[E++]],P+="-",P+=y[M[E++]],P+=y[M[E++]],P+="-",P+=y[M[E++]],P+=y[M[E++]],P+="-",P+=y[M[E++]],P+=y[M[E++]],P+=y[M[E++]],P+=y[M[E++]],P+=y[M[E++]],P+=y[M[E++]],P}}()}),define(Ce[110],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[111],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class C{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let E=0,P=A.notIn.length;E<P;E++)switch(A.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,E){if(A.getTokenCount()===0)return!0;const P=A.findTokenIndexAtOffset(E-2),O=A.getStandardTokenType(P);return this.isOK(O)}_findNeutralCharacterInRange(A,E){for(let P=A;P<=E;P++){const O=String.fromCharCode(P);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=C;class S{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of A)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=S;function M(y,A,E){y.has(A)?y.get(A).push(E):y.set(A,[E])}}),define(Ce[112],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Ce[113],Ie([1,0,112]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,S=C*60,M=S*24,y=M*7,A=M*30,E=M*365;function P(b,m,k){typeof b!="number"&&(b=b.getTime());const p=Math.round((new Date().getTime()-b)/1e3);if(p<-30)return(0,r.localize)(0,null,P(new Date().getTime()+p*1e3,!1));if(p<30)return(0,r.localize)(1,null);let l;return p<C?(l=p,m?l===1?k?(0,r.localize)(2,null,l):(0,r.localize)(3,null,l):k?(0,r.localize)(4,null,l):(0,r.localize)(5,null,l):l===1?k?(0,r.localize)(6,null,l):(0,r.localize)(7,null,l):k?(0,r.localize)(8,null,l):(0,r.localize)(9,null,l)):p<S?(l=Math.floor(p/C),m?l===1?k?(0,r.localize)(10,null,l):(0,r.localize)(11,null,l):k?(0,r.localize)(12,null,l):(0,r.localize)(13,null,l):l===1?k?(0,r.localize)(14,null,l):(0,r.localize)(15,null,l):k?(0,r.localize)(16,null,l):(0,r.localize)(17,null,l)):p<M?(l=Math.floor(p/S),m?l===1?k?(0,r.localize)(18,null,l):(0,r.localize)(19,null,l):k?(0,r.localize)(20,null,l):(0,r.localize)(21,null,l):l===1?k?(0,r.localize)(22,null,l):(0,r.localize)(23,null,l):k?(0,r.localize)(24,null,l):(0,r.localize)(25,null,l)):p<y?(l=Math.floor(p/M),m?l===1?(0,r.localize)(26,null,l):(0,r.localize)(27,null,l):l===1?(0,r.localize)(28,null,l):(0,r.localize)(29,null,l)):p<A?(l=Math.floor(p/y),m?l===1?k?(0,r.localize)(30,null,l):(0,r.localize)(31,null,l):k?(0,r.localize)(32,null,l):(0,r.localize)(33,null,l):l===1?k?(0,r.localize)(34,null,l):(0,r.localize)(35,null,l):k?(0,r.localize)(36,null,l):(0,r.localize)(37,null,l)):p<E?(l=Math.floor(p/A),m?l===1?k?(0,r.localize)(38,null,l):(0,r.localize)(39,null,l):k?(0,r.localize)(40,null,l):(0,r.localize)(41,null,l):l===1?k?(0,r.localize)(42,null,l):(0,r.localize)(43,null,l):k?(0,r.localize)(44,null,l):(0,r.localize)(45,null,l)):(l=Math.floor(p/E),m?l===1?k?(0,r.localize)(46,null,l):(0,r.localize)(47,null,l):k?(0,r.localize)(48,null,l):(0,r.localize)(49,null,l):l===1?k?(0,r.localize)(50,null,l):(0,r.localize)(51,null,l):k?(0,r.localize)(52,null,l):(0,r.localize)(53,null,l))}e.fromNow=P;function O(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ce[114],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Ce[44],Ie([1,0,18,10,114]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(b,m){return m&&(b.stack||b.stacktrace)?S.localize(0,null,A(b),y(b.stack)||y(b.stacktrace)):A(b)}function y(b){return Array.isArray(b)?b.join(`
`):b}function A(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?S.localize(1,null,b.message):b.message||S.localize(2,null)}function E(b=null,m=!1){if(!b)return S.localize(3,null);if(Array.isArray(b)){const k=r.coalesce(b),p=E(k[0],m);return k.length>1?S.localize(4,null,p,k.length):p}if(C.isString(b))return b;if(b.detail){const k=b.detail;if(k.error)return M(k.error,m);if(k.exception)return M(k.exception,m)}return b.stack?M(b,m):b.message?b.message:S.localize(5,null)}e.toErrorMessage=E;function P(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=P;function O(b,m){let k;return typeof b=="string"?k=new Error(b):k=b,k.actions=m,k}e.createErrorWithActions=O}),define(Ce[75],Ie([1,0,19]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const b=(0,r.extname)(O),m=C[b.toLowerCase()];return m!==void 0?m:y(O)}e.getMediaOrTextMime=M;function y(O){const b=(0,r.extname)(O);return S[b.toLowerCase()]}e.getMediaMime=y;function A(O){for(const b in S)if(S[b]===O)return b}e.getExtensionForMimeType=A;const E=/^(.+)\/(.+?)(;.+)?$/;function P(O,b){const m=E.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:b?void 0:O}e.normalizeMimeType=P}),define(Ce[38],Ie([1,0,19,21,9,10]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(o){return o===47||o===92}e.isPathSeparator=y;function A(o){return o.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=A;function E(o){return o.indexOf("/")===-1&&(o=A(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=E;function P(o,f=r.posix.sep){if(!o)return"";const s=o.length,h=o.charCodeAt(0);if(y(h)){if(y(o.charCodeAt(1))&&!y(o.charCodeAt(2))){let T=3;const N=T;for(;T<s&&!y(o.charCodeAt(T));T++);if(N!==T&&!y(o.charCodeAt(T+1))){for(T+=1;T<s;T++)if(y(o.charCodeAt(T)))return o.slice(0,T+1).replace(/[\\/]/g,f)}}return f}else if(d(h)&&o.charCodeAt(1)===58)return y(o.charCodeAt(2))?o.slice(0,2)+f:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<s;v++)if(y(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.getRoot=P;function O(o){if(!C.isWindows||!o||o.length<5)return!1;let f=o.charCodeAt(0);if(f!==92||(f=o.charCodeAt(1),f!==92))return!1;let s=2;const h=s;for(;s<o.length&&(f=o.charCodeAt(s),f!==92);s++);return!(h===s||(f=o.charCodeAt(s+1),isNaN(f)||f===92))}e.isUNC=O;const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(o,f=C.isWindows){const s=f?b:m;return!(!o||o.length===0||/^\s+$/.test(o)||(s.lastIndex=0,s.test(o))||f&&k.test(o)||o==="."||o===".."||f&&o[o.length-1]==="."||f&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=p;function l(o,f,s){const h=o===f;return!s||h?h:!o||!f?!1:(0,S.equalsIgnoreCase)(o,f)}e.isEqual=l;function u(o,f,s,h=r.sep){if(o===f)return!0;if(!o||!f||f.length>o.length)return!1;if(s){if(!(0,S.startsWithIgnoreCase)(o,f))return!1;if(f.length===o.length)return!0;let T=f.length;return f.charAt(f.length-1)===h&&T--,o.charAt(T)===h}return f.charAt(f.length-1)!==h&&(f+=h),o.indexOf(f)===0}e.isEqualOrParent=u;function d(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=d;function g(o,f){return C.isWindows&&o.endsWith(":")&&(o+=r.sep),(0,r.isAbsolute)(o)||(o=(0,r.join)(f,o)),o=(0,r.normalize)(o),C.isWindows?(o=(0,S.rtrim)(o,r.sep),o.endsWith(":")&&(o+=r.sep)):(o=(0,S.rtrim)(o,r.sep),o||(o=r.sep)),o}e.sanitizeFilePath=g;function _(o){const f=(0,r.normalize)(o);return C.isWindows?o.length>3?!1:a(f)&&(o.length===2||f.charCodeAt(2)===92):f===r.posix.sep}e.isRootOrDriveLetter=_;function a(o,f=C.isWindows){return f?d(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function w(o){return a(o)?o[0]:void 0}e.getDriveLetter=w;function t(o,f,s){return f.length>o.length?-1:o===f?0:(s&&(o=o.toLowerCase(),f=f.toLowerCase()),o.indexOf(f))}e.indexOfPath=t;function c(o){const f=o.split(":");let s,h,v;for(const T of f){const N=Number(T);(0,M.isNumber)(N)?h===void 0?h=N:v===void 0&&(v=N):s=s?[s,T].join(":"):T}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,f,s=8){let h="";for(let T=0;T<s;T++)h+=i.charAt(Math.floor(Math.random()*i.length));let v;return f?v=`${f}-${h}`:v=h,o?(0,r.join)(o,v):v}e.randomPath=n}),define(Ce[24],Ie([1,0,18,9]),function(ie,e,r,C){"use strict";var S,M,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(i,n,o){let f=i.get(n);return f===void 0&&(f=o,i.set(n,f)),f}e.getOrSet=A;function E(i){const n=[];return i.forEach((o,f)=>{n.push(`${f} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=E;function P(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=P;class O{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),f=this._value.charCodeAt(this._pos);return o-f}value(){return this._value[this._pos]}}e.StringIterator=O;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,C.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class m{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const f=this._value.charCodeAt(o);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,C.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var k;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(k||(k={}));class p{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,C.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(u||(u={}));class d{static forUris(n=()=>!1,o=()=>!1){return new d(new p(n,o))}static forPaths(n=!1){return new d(new m(void 0,!n))}static forStrings(){return new d(new O)}static forConfigKeys(){return new d(new b)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,o){if(o){const f=o.slice(0);(0,r.shuffle)(f);for(const s of f)this.set(s,n)}else{const f=n.slice(0);(0,r.shuffle)(f);for(const s of f)this.set(s[0],s[1])}}set(n,o){const f=this._iter.reset(n);let s;this._root||(this._root=new l,this._root.segment=f.value());const h=[];for(s=this._root;;){const T=f.cmp(s.segment);if(T>0)s.left||(s.left=new l,s.left.segment=f.value()),h.push([-1,s]),s=s.left;else if(T<0)s.right||(s.right=new l,s.right.segment=f.value()),h.push([1,s]),s=s.right;else if(f.hasNext())f.next(),s.mid||(s.mid=new l,s.mid.segment=f.value()),h.push([0,s]),s=s.mid;else break}const v=s.value;s.value=o,s.key=n;for(let T=h.length-1;T>=0;T--){const N=h[T][1];N.updateHeight();const V=N.balanceFactor();if(V<-1||V>1){const U=h[T][0],D=h[T+1][0];if(U===1&&D===1)h[T][1]=N.rotateLeft();else if(U===-1&&D===-1)h[T][1]=N.rotateRight();else if(U===1&&D===-1)N.right=h[T+1][1]=h[T+1][1].rotateRight(),h[T][1]=N.rotateLeft();else if(U===-1&&D===1)N.left=h[T+1][1]=h[T+1][1].rotateLeft(),h[T][1]=N.rotateRight();else throw new Error;if(T>0)switch(h[T-1][0]){case-1:h[T-1][1].left=h[T][1];break;case 1:h[T-1][1].right=h[T][1];break;case 0:h[T-1][1].mid=h[T][1];break}else this._root=h[0][1]}}return v}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let f=this._root;for(;f;){const s=o.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(o.hasNext())o.next(),f=f.mid;else break}return f}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const f=this._iter.reset(n),s=[];let h=this._root;for(;h;){const v=f.cmp(h.segment);if(v>0)s.push([-1,h]),h=h.left;else if(v<0)s.push([1,h]),h=h.right;else if(f.hasNext())f.next(),s.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this._min(h.right);if(v.key){const{key:T,value:N,segment:V}=v;this._delete(v.key,!1),h.key=T,h.value=N,h.segment=V}}else{const v=h.left??h.right;if(s.length>0){const[T,N]=s[s.length-1];switch(T){case-1:N.left=v;break;case 0:N.mid=v;break;case 1:N.right=v;break}}else this._root=v}for(let v=s.length-1;v>=0;v--){const T=s[v][1];T.updateHeight();const N=T.balanceFactor();if(N>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),s[v][1]=T.rotateLeft()):N<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),s[v][1]=T.rotateRight()),v>0)switch(s[v-1][0]){case-1:s[v-1][1].left=s[v][1];break;case 1:s[v-1][1].right=s[v][1];break;case 0:s[v-1][1].mid=s[v][1];break}else this._root=s[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let f=this._root,s;for(;f;){const h=o.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(o.hasNext())o.next(),s=f.value||s,f=f.mid;else break}return f&&f.value||s}findSuperstr(n){const o=this._iter.reset(n);let f=this._root;for(;f;){const s=o.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(o.hasNext())o.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(n){for(const[o,f]of this)n(f,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const f=o.balanceFactor();return f<-1||f>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=d;class g{constructor(n,o){this.uri=n,this.value=o}}class _{constructor(n,o){this[S]="ResourceMap",n instanceof _?(this.map=new Map(n.map),this.toKey=o??_.defaultToKey):(this.map=new Map,this.toKey=n??_.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new g(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[f,s]of this.map)n(s.value,s.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=_,_.defaultToKey=i=>i.toString();class a{constructor(n,o){this[M]="ResourceSet",!n||typeof n=="function"?this._map=new _(n):(this._map=new _(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((f,s)=>n.call(o,s,s,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=a;var w;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class t{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const f=this._map.get(n);if(!!f)return o!==0&&this.touch(f,o),f.value}set(n,o,f=0){let s=this._map.get(n);if(s)s.value=o,f!==0&&this.touch(s,f);else{switch(s={key:n,value:o,next:void 0,previous:void 0},f){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const f=this._state;let s=this._head;for(;s;){if(o?n.bind(o)(s.value,s.key,this):n(s.value,s.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,o=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:f.key,done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return s}values(){const n=this,o=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:f.value,done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return s}entries(){const n=this,o=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:[f.key,f.value],done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return s}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,f=this.size;for(;o&&f>n;)this._map.delete(o.key),o=o.next,f--;this._head=o,this._size=f,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,f=n.previous;if(!o||!f)throw new Error("Invalid list");o.previous=f,f.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const f=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(f.previous=s,s.next=f),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const f=n.next,s=n.previous;n===this._head?(f.previous=void 0,this._head=f):(f.previous=s,s.next=f),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,f)=>{n.push([f,o])}),n}fromJSON(n){this.clear();for(const[o,f]of n)this.set(o,f)}}e.LinkedMap=t;class c extends t{constructor(n,o=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(Ce[115],Ie([1,0,24,9]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...Z){return function(J,I){for(let B=0,H=Z.length;B<H;B++){const j=Z[B](J,I);if(j)return j}return null}}e.or=S,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Z,J,I){if(!I||I.length<J.length)return null;let B;return Z?B=C.startsWithIgnoreCase(I,J):B=I.indexOf(J)===0,B?J.length>0?[{start:0,end:J.length}]:[]:null}function y(Z,J){const I=J.toLowerCase().indexOf(Z.toLowerCase());return I===-1?null:[{start:I,end:I+Z.length}]}e.matchesContiguousSubString=y;function A(Z,J){return E(Z.toLowerCase(),J.toLowerCase(),0,0)}e.matchesSubString=A;function E(Z,J,I,B){if(I===Z.length)return[];if(B===J.length)return null;if(Z[I]===J[B]){let H=null;return(H=E(Z,J,I+1,B+1))?d({start:B,end:B+1},H):null}return E(Z,J,I,B+1)}function P(Z){return 97<=Z&&Z<=122}function O(Z){return 65<=Z&&Z<=90}e.isUpper=O;function b(Z){return 48<=Z&&Z<=57}function m(Z){return Z===32||Z===9||Z===10||Z===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>k.add(Z.charCodeAt(0)));function p(Z){return m(Z)||k.has(Z)}function l(Z,J){return Z===J||p(Z)&&p(J)}function u(Z){return P(Z)||O(Z)||b(Z)}function d(Z,J){return J.length===0?J=[Z]:Z.end===J[0].start?J[0].start=Z.start:J.unshift(Z),J}function g(Z,J){for(let I=J;I<Z.length;I++){const B=Z.charCodeAt(I);if(O(B)||b(B)||I>0&&!u(Z.charCodeAt(I-1)))return I}return Z.length}function _(Z,J,I,B){if(I===Z.length)return[];if(B===J.length)return null;if(Z[I]!==J[B].toLowerCase())return null;{let H=null,j=B+1;for(H=_(Z,J,I+1,B+1);!H&&(j=g(J,j))<J.length;)H=_(Z,J,I+1,j),j++;return H===null?null:d({start:B,end:B+1},H)}}function a(Z){let J=0,I=0,B=0,H=0,j=0;for(let pe=0;pe<Z.length;pe++)j=Z.charCodeAt(pe),O(j)&&J++,P(j)&&I++,u(j)&&B++,b(j)&&H++;const se=J/Z.length,le=I/Z.length,Y=B/Z.length,ve=H/Z.length;return{upperPercent:se,lowerPercent:le,alphaPercent:Y,numericPercent:ve}}function w(Z){const{upperPercent:J,lowerPercent:I}=Z;return I===0&&J>.6}function t(Z){const{upperPercent:J,lowerPercent:I,alphaPercent:B,numericPercent:H}=Z;return I>.2&&J<.8&&B>.6&&H<.2}function c(Z){let J=0,I=0,B=0,H=0;for(let j=0;j<Z.length;j++)B=Z.charCodeAt(j),O(B)&&J++,P(B)&&I++,m(B)&&H++;return(J===0||I===0)&&H===0?Z.length<=30:J<=5}function i(Z,J){if(!J||(J=J.trim(),J.length===0)||!c(Z)||J.length>60)return null;const I=a(J);if(!t(I)){if(!w(I))return null;J=J.toLowerCase()}let B=null,H=0;for(Z=Z.toLowerCase();H<J.length&&(B=_(Z,J,0,H))===null;)H=g(J,H+1);return B}e.matchesCamelCase=i;function n(Z,J,I=!1){if(!J||J.length===0)return null;let B=null,H=0;for(Z=Z.toLowerCase(),J=J.toLowerCase();H<J.length&&(B=o(Z,J,0,H,I))===null;)H=f(J,H+1);return B}e.matchesWords=n;function o(Z,J,I,B,H){if(I===Z.length)return[];if(B===J.length)return null;if(l(Z.charCodeAt(I),J.charCodeAt(B))){let j=null,se=B+1;if(j=o(Z,J,I+1,B+1,H),!H)for(;!j&&(se=f(J,se))<J.length;)j=o(Z,J,I+1,se,H),se++;return j?Z.charCodeAt(I)!==J.charCodeAt(B)?j:d({start:B,end:B+1},j):null}else return null}function f(Z,J){for(let I=J;I<Z.length;I++)if(p(Z.charCodeAt(I))||I>0&&p(Z.charCodeAt(I-1)))return I;return Z.length}const s=S(e.matchesPrefix,i,y),h=S(e.matchesPrefix,i,A),v=new r.LRUCache(1e4);function T(Z,J,I=!1){if(typeof Z!="string"||typeof J!="string")return null;let B=v.get(Z);B||(B=new RegExp(C.convertSimple2RegExpPattern(Z),"i"),v.set(Z,B));const H=B.exec(J);return H?[{start:H.index,end:H.index+H[0].length}]:I?h(Z,J):s(Z,J)}e.matchesFuzzy=T;function N(Z,J){const I=Be(Z,Z.toLowerCase(),0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return I?U(I):null}e.matchesFuzzy2=N;function V(Z,J,I,B,H,j){const se=Math.min(13,Z.length);for(;I<se;I++){const le=Be(Z,J,I,B,H,j,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(le)return le}return[0,j]}e.anyScore=V;function U(Z){if(typeof Z>"u")return[];const J=[],I=Z[1];for(let B=Z.length-1;B>1;B--){const H=Z[B]+I,j=J[J.length-1];j&&j.end===H?j.end=H+1:J.push({start:H,end:H+1})}return J}e.createMatches=U;const D=128;function x(){const Z=[],J=[];for(let I=0;I<=D;I++)J[I]=0;for(let I=0;I<=D;I++)Z.push(J.slice(0));return Z}function L(Z){const J=[];for(let I=0;I<=Z;I++)J[I]=0;return J}const R=L(2*D),K=L(2*D),W=x(),$=x(),G=x(),re=!1;function ge(Z,J,I,B,H){function j(le,Y,ve=" "){for(;le.length<Y;)le=ve+le;return le}let se=` |   |${B.split("").map(le=>j(le,3)).join("|")}
`;for(let le=0;le<=I;le++)le===0?se+=" |":se+=`${J[le-1]}|`,se+=Z[le].slice(0,H+1).map(Y=>j(Y.toString(),3)).join("|")+`
`;return se}function oe(Z,J,I,B){Z=Z.substr(J),I=I.substr(B),console.log(ge($,Z,Z.length,I,I.length)),console.log(ge(G,Z,Z.length,I,I.length)),console.log(ge(W,Z,Z.length,I,I.length))}function Ee(Z,J){if(J<0||J>=Z.length)return!1;const I=Z.codePointAt(J);switch(I){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(I)}}function ce(Z,J){if(J<0||J>=Z.length)return!1;switch(Z.charCodeAt(J)){case 32:case 9:return!0;default:return!1}}function me(Z,J,I){return J[Z]!==I[Z]}function ee(Z,J,I,B,H,j,se=!1){for(;J<I&&H<j;)Z[J]===B[H]&&(se&&(R[J]=H),J+=1),H+=1;return J===I}e.isPatternInWord=ee;var be;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(be||(be={}));var _e;(function(Z){Z.Default=[-100,0];function J(I){return!I||I.length===2&&I[0]===-100&&I[1]===0}Z.isDefault=J})(_e=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(J,I){this.firstMatchCanBeWeak=J,this.boostFullMatch=I}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(Z,J,I,B,H,j,se=Fe.default){const le=Z.length>D?D:Z.length,Y=B.length>D?D:B.length;if(I>=le||j>=Y||le-I>Y-j||!ee(J,I,le,H,j,Y,!0))return;Xe(le,Y,I,j,J,H);let ve=1,pe=1,Me=I,xe=j;const Ye=[!1];for(ve=1,Me=I;Me<le;ve++,Me++){const Q=R[Me],he=K[Me],Ue=Me+1<le?K[Me+1]:Y;for(pe=Q-j+1,xe=Q;xe<Ue;pe++,xe++){let je=Number.MIN_SAFE_INTEGER,Ze=!1;xe<=he&&(je=ke(Z,J,Me,I,B,H,xe,Y,j,W[ve-1][pe-1]===0,Ye));let Ke=0;je!==Number.MAX_SAFE_INTEGER&&(Ze=!0,Ke=je+$[ve-1][pe-1]);const Ve=xe>Q,it=Ve?$[ve][pe-1]+(W[ve][pe-1]>0?-5:0):0,st=xe>Q+1&&W[ve][pe-1]>0,dt=st?$[ve][pe-2]+(W[ve][pe-2]>0?-5:0):0;if(st&&(!Ve||dt>=it)&&(!Ze||dt>=Ke))$[ve][pe]=dt,G[ve][pe]=3,W[ve][pe]=0;else if(Ve&&(!Ze||it>=Ke))$[ve][pe]=it,G[ve][pe]=2,W[ve][pe]=0;else if(Ze)$[ve][pe]=Ke,G[ve][pe]=1,W[ve][pe]=W[ve-1][pe-1]+1;else throw new Error("not possible")}}if(re&&oe(Z,I,B,j),!Ye[0]&&!se.firstMatchCanBeWeak)return;ve--,pe--;const Ge=[$[ve][pe],j];let Te=0,rt=0;for(;ve>=1;){let Q=pe;do{const he=G[ve][Q];if(he===3)Q=Q-2;else if(he===2)Q=Q-1;else break}while(Q>=1);Te>1&&J[I+ve-1]===H[j+pe-1]&&!me(Q+j-1,B,H)&&Te+1>W[ve][Q]&&(Q=pe),Q===pe?Te++:Te=1,rt||(rt=Q),ve--,pe=Q-1,Ge.push(pe)}Y===le&&se.boostFullMatch&&(Ge[0]+=2);const X=rt-le;return Ge[0]-=X,Ge}e.fuzzyScore=Be;function Xe(Z,J,I,B,H,j){let se=Z-1,le=J-1;for(;se>=I&&le>=B;)H[se]===j[le]&&(K[se]=le,se--),le--}function ke(Z,J,I,B,H,j,se,le,Y,ve,pe){if(J[I]!==j[se])return Number.MIN_SAFE_INTEGER;let Me=1,xe=!1;return se===I-B?Me=Z[I]===H[se]?7:5:me(se,H,j)&&(se===0||!me(se-1,H,j))?(Me=Z[I]===H[se]?7:5,xe=!0):Ee(j,se)&&(se===0||!Ee(j,se-1))?Me=5:(Ee(j,se-1)||ce(j,se-1))&&(Me=5,xe=!0),Me>1&&I===B&&(pe[0]=!0),xe||(xe=me(se,H,j)||Ee(j,se-1)||ce(j,se-1)),I===B?se>Y&&(Me-=xe?3:5):ve?Me+=xe?2:0:Me+=xe?0:1,se+1===le&&(Me-=xe?3:5),Me}function ye(Z,J,I,B,H,j,se){return ae(Z,J,I,B,H,j,!0,se)}e.fuzzyScoreGracefulAggressive=ye;function De(Z,J,I,B,H,j,se){return ae(Z,J,I,B,H,j,!1,se)}e.fuzzyScoreGraceful=De;function ae(Z,J,I,B,H,j,se,le){let Y=Be(Z,J,I,B,H,j,le);if(Y&&!se)return Y;if(Z.length>=3){const ve=Math.min(7,Z.length-1);for(let pe=I+1;pe<ve;pe++){const Me=ue(Z,pe);if(Me){const xe=Be(Me,Me.toLowerCase(),I,B,H,j,le);xe&&(xe[0]-=3,(!Y||xe[0]>Y[0])&&(Y=xe))}}}return Y}function ue(Z,J){if(J+1>=Z.length)return;const I=Z[J],B=Z[J+1];if(I!==B)return Z.slice(0,J)+B+I+Z.slice(J+2)}}),define(Ce[116],Ie([1,0,117,115,9]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const M=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(r.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${M.source}`,"g");function E(u){return u.replace(A,(d,g)=>g?d:`\\${d}`)}e.escapeIcons=E;const P=new RegExp(`\\\\${M.source}`,"g");function O(u){return u.replace(P,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=O;const b=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(b,(d,g,_,a)=>_?d:g||a||"")}e.stripIcons=m;function k(u){const d=u.indexOf(e.iconStartMarker);return d===-1?{text:u}:p(u,d)}e.parseLabelWithIcons=k;function p(u,d){const g=[];let _="";function a(s){if(s){_+=s;for(const h of s)g.push(c)}}let w=-1,t="",c=0,i,n,o=d;const f=u.length;for(a(u.substr(0,d));o<f;)i=u[o],n=u[o+1],i===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(w=o,a(t),t=e.iconStartMarker,o++):i===")"&&w!==-1?(c+=o-w+1,w=-1,t=""):w!==-1?y.test(i)?t+=i:(a(t),w=-1,t=""):a(i),o++;return a(t),{text:_,iconOffsets:g}}function l(u,d,g=!1){const{text:_,iconOffsets:a}=d;if(!a||a.length===0)return(0,C.matchesFuzzy)(u,_,g);const w=(0,S.ltrim)(_," "),t=_.length-w.length,c=(0,C.matchesFuzzy)(u,w,g);if(c)for(const i of c){const n=a[i.start+t]+t;i.start+=n,i.end+=n}return c}e.matchesFuzzyIconAware=l}),define(Ce[29],Ie([1,0,9]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(C||(C={})),function(S){const M="error",y="warning",A="warn",E="info",P="ignore";function O(m){return m?r.equalsIgnoreCase(M,m)?S.Error:r.equalsIgnoreCase(y,m)||r.equalsIgnoreCase(A,m)?S.Warning:r.equalsIgnoreCase(E,m)?S.Info:S.Ignore:S.Ignore}S.fromValue=O;function b(m){switch(m){case S.Error:return M;case S.Warning:return y;case S.Info:return E;default:return P}}S.toString=b}(C||(C={})),e.default=C}),define(Ce[76],Ie([1,0,23,9,2]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(P){return JSON.stringify(P,A)}e.stringify=M;function y(P){let O=JSON.parse(P);return O=E(O),O}e.parse=y;function A(P,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function E(P,O=0){if(!P||O>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return S.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof r.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let b=0;b<P.length;++b)P[b]=E(P[b],O+1);else for(const b in P)Object.hasOwnProperty.call(P,b)&&(P[b]=E(P[b],O+1))}return P}e.revive=E}),define(Ce[13],Ie([1,0,21,2]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var S;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(S=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${S.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${S.vscodeRemoteResource}`}set(P,O,b){this._hosts[P]=O,this._ports[P]=b}setConnectionToken(P,O){this._connectionTokens[P]=O}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const O=P.authority;let b=this._hosts[O];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const m=this._ports[O],k=this._connectionTokens[O];let p=`path=${encodeURIComponent(P.path)}`;return typeof k=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(k)}`),C.URI.from({scheme:r.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${b}:${m}`,path:this._remoteResourcesPath,query:p})}}e.RemoteAuthorities=new M;class y{asBrowserUri(P,O){const b=this.toUri(P,O);return b.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===S.file&&(r.isNative||r.isWebWorker&&r.globals.origin===`${S.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?b.with({scheme:S.vscodeFileResource,authority:b.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(P,O){const b=this.toUri(P,O);return b.scheme===S.vscodeFileResource?b.with({scheme:S.file,authority:b.authority!==y.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(P,O){return C.URI.isUri(P)?P:C.URI.parse(O.toUrl(P))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y;var A;(function(E){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(P.get("3"));const O="vscode-coi";function b(k){let p;typeof k=="string"?p=new URL(k).searchParams:k instanceof URL?p=k.searchParams:C.URI.isUri(k)&&(p=new URL(k.toString(!0)).searchParams);const l=p?.get(O);if(!!l)return P.get(l)}E.getHeadersFromQuery=b;function m(k,p,l){if(!globalThis.crossOriginIsolated)return;const u=p&&l?"3":l?"2":"1";k instanceof URLSearchParams?k.set(O,u):k[O]=u}E.addSearchParam=m})(A=e.COI||(e.COI={}))}),define(Ce[22],Ie([1,0,38,13,19,21,9,2]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(k){return(0,A.uriToFsPath)(k,!0)}e.originalFSPath=E;class P{constructor(p){this._ignorePathCasing=p}compare(p,l,u=!1){return p===l?0:(0,y.compare)(this.getComparisonKey(p,u),this.getComparisonKey(l,u))}isEqual(p,l,u=!1){return p===l?!0:!p||!l?!1:this.getComparisonKey(p,u)===this.getComparisonKey(l,u)}getComparisonKey(p,l=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,l,u=!1){if(p.scheme===l.scheme){if(p.scheme===C.Schemas.file)return r.isEqualOrParent(E(p),E(l),this._ignorePathCasing(p))&&p.query===l.query&&(u||p.fragment===l.fragment);if((0,e.isEqualAuthority)(p.authority,l.authority))return r.isEqualOrParent(p.path,l.path,this._ignorePathCasing(p),"/")&&p.query===l.query&&(u||p.fragment===l.fragment)}return!1}joinPath(p,...l){return A.URI.joinPath(p,...l)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return S.posix.basename(p.path)}extname(p){return S.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let l;return p.scheme===C.Schemas.file?l=A.URI.file(S.dirname(E(p))).path:(l=S.posix.dirname(p.path),p.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),l="/")),p.with({path:l})}normalizePath(p){if(!p.path.length)return p;let l;return p.scheme===C.Schemas.file?l=A.URI.file(S.normalize(E(p))).path:l=S.posix.normalize(p.path),p.with({path:l})}relativePath(p,l){if(p.scheme!==l.scheme||!(0,e.isEqualAuthority)(p.authority,l.authority))return;if(p.scheme===C.Schemas.file){const g=S.relative(E(p),E(l));return M.isWindows?r.toSlashes(g):g}let u=p.path||"/";const d=l.path||"/";if(this._ignorePathCasing(p)){let g=0;for(const _=Math.min(u.length,d.length);g<_&&!(u.charCodeAt(g)!==d.charCodeAt(g)&&u.charAt(g).toLowerCase()!==d.charAt(g).toLowerCase());g++);u=d.substr(0,g)+u.substr(g)}return S.posix.relative(u,d)}resolvePath(p,l){if(p.scheme===C.Schemas.file){const u=A.URI.file(S.resolve(E(p),l));return p.with({authority:u.authority,path:u.path})}return l=r.toPosixPath(l),p.with({path:S.posix.resolve(p.path,l)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,l){return p===l||p!==void 0&&l!==void 0&&(0,y.equalsIgnoreCase)(p,l)}hasTrailingPathSeparator(p,l=S.sep){if(p.scheme===C.Schemas.file){const u=E(p);return u.length>r.getRoot(u).length&&u[u.length-1]===l}else{const u=p.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,l=S.sep){return(0,e.hasTrailingPathSeparator)(p,l)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,l=S.sep){let u=!1;if(p.scheme===C.Schemas.file){const d=E(p);u=d!==void 0&&d.length===r.getRoot(d).length&&d[d.length-1]===l}else{l="/";const d=p.path;u=d.length===1&&d.charCodeAt(d.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(p,l)?p.with({path:p.path+"/"}):p}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(k=>k.scheme===C.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new P(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(k,p){const l=[];for(let u=0;u<k.length;u++){const d=p(k[u]);k.some((g,_)=>_===u?!1:(0,e.isEqualOrParent)(d,p(g)))||l.push(k[u])}return l}e.distinctParents=O;var b;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function p(l){const u=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(_=>{const[a,w]=_.split(":");a&&w&&u.set(a,w)});const g=l.path.substring(0,l.path.indexOf(";"));return g&&u.set(k.META_DATA_MIME,g),u}k.parseMetaData=p})(b=e.DataUri||(e.DataUri={}));function m(k,p,l){if(p){let u=k.path;return u&&u[0]!==S.posix.sep&&(u=S.posix.sep+u),k.with({scheme:l,authority:p,path:u})}return k.with({scheme:l})}e.toLocalResource=m}),define(Ce[15],Ie([1,0,20,12,5,7,22,21]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(me){return!!me&&typeof me.then=="function"}e.isThenable=E;function P(me){const ee=new r.CancellationTokenSource,be=me(ee.token),_e=new Promise((Fe,Be)=>{const Xe=ee.token.onCancellationRequested(()=>{Xe.dispose(),ee.dispose(),Be(new C.CancellationError)});Promise.resolve(be).then(ke=>{Xe.dispose(),ee.dispose(),Fe(ke)},ke=>{Xe.dispose(),ee.dispose(),Be(ke)})});return new class{cancel(){ee.cancel()}then(Fe,Be){return _e.then(Fe,Be)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return _e.finally(Fe)}}}e.createCancelablePromise=P;function O(me,ee,be){return new Promise((_e,Fe)=>{const Be=ee.onCancellationRequested(()=>{Be.dispose(),_e(be)});me.then(_e,Fe).finally(()=>Be.dispose())})}e.raceCancellation=O;function b(me,ee){return new Promise((be,_e)=>{const Fe=ee.onCancellationRequested(()=>{Fe.dispose(),_e(new C.CancellationError)});me.then(be,_e).finally(()=>Fe.dispose())})}e.raceCancellationError=b;async function m(me){let ee=-1;const be=me.map((Fe,Be)=>Fe.then(Xe=>(ee=Be,Xe))),_e=await Promise.race(be);return me.forEach((Fe,Be)=>{Be!==ee&&Fe.cancel()}),_e}e.raceCancellablePromises=m;function k(me,ee,be){let _e;const Fe=setTimeout(()=>{_e?.(void 0),be?.()},ee);return Promise.race([me.finally(()=>clearTimeout(Fe)),new Promise(Be=>_e=Be)])}e.raceTimeout=k;function p(me){return new Promise((ee,be)=>{const _e=me();E(_e)?_e.then(ee,be):ee(_e)})}e.asPromise=p;class l{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const be=()=>{this.queuedPromise=null;const _e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_e};this.queuedPromise=new Promise(_e=>{this.activePromise.then(be,be).then(_e)})}return new Promise((be,_e)=>{this.queuedPromise.then(be,_e)})}return this.activePromise=ee(),new Promise((be,_e)=>{this.activePromise.then(Fe=>{this.activePromise=null,be(Fe)},Fe=>{this.activePromise=null,_e(Fe)})})}}e.Throttler=l;class u{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=u;class d{constructor(){this.promiseMap=new Map}queue(ee,be){const Fe=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(be).finally(()=>{this.promiseMap.get(ee)===Fe&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,Fe),Fe}}e.SequencerByKey=d;const g=(me,ee)=>{let be=!0;const _e=setTimeout(()=>{be=!1,ee()},me);return{isTriggered:()=>be,dispose:()=>{clearTimeout(_e),be=!1}}},_=me=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,me())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,be=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,Be)=>{this.doResolve=Fe,this.doReject=Be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const _e=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=be===e.MicrotaskDelay?_(_e):g(be,_e),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new C.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class w{constructor(ee){this.delayer=new a(ee),this.throttler=new l}trigger(ee,be){return this.delayer.trigger(()=>this.throttler.queue(ee),be)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class t{constructor(){this._isOpen=!1,this._promise=new Promise((ee,be)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class c extends t{constructor(ee){super(),this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function i(me,ee){return ee?new Promise((be,_e)=>{const Fe=setTimeout(()=>{Be.dispose(),be()},me),Be=ee.onCancellationRequested(()=>{clearTimeout(Fe),Be.dispose(),_e(new C.CancellationError)})}):P(be=>i(me,be))}e.timeout=i;function n(me,ee=0){const be=setTimeout(me,ee);return(0,M.toDisposable)(()=>clearTimeout(be))}e.disposableTimeout=n;function o(me){const ee=[];let be=0;const _e=me.length;function Fe(){return be<_e?me[be++]():null}function Be(Xe){Xe!=null&&ee.push(Xe);const ke=Fe();return ke?ke.then(Be):Promise.resolve(ee)}return Promise.resolve(null).then(Be)}e.sequence=o;function f(me,ee=_e=>!!_e,be=null){let _e=0;const Fe=me.length,Be=()=>{if(_e>=Fe)return Promise.resolve(be);const Xe=me[_e++];return Promise.resolve(Xe()).then(ye=>ee(ye)?Promise.resolve(ye):Be())};return Be()}e.first=f;function s(me,ee=_e=>!!_e,be=null){if(me.length===0)return Promise.resolve(be);let _e=me.length;const Fe=()=>{_e=-1;for(const Be of me)Be.cancel?.()};return new Promise((Be,Xe)=>{for(const ke of me)ke.then(ye=>{--_e>=0&&ee(ye)?(Fe(),Be(ye)):_e===0&&Be(be)}).catch(ye=>{--_e>=0&&(Fe(),Xe(ye))})})}e.firstParallel=s;class h{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((be,_e)=>{this.outstandingPromises.push({factory:ee,c:be,e:_e}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const be=ee.factory();be.then(ee.c,ee.e),be.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class v extends h{constructor(){super(1)}}e.Queue=v;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ee=new G;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,be=y.extUri){const _e=be.getComparisonKey(ee);let Fe=this.queues.get(_e);return Fe||(Fe=new v,S.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(_e),this.onDidQueueDrain()}),this.queues.set(_e,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class N{constructor(ee,be){this._token=-1,typeof ee=="function"&&typeof be=="number"&&this.setIfNotSet(ee,be)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,be){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},be)}setIfNotSet(ee,be){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},be))}}e.TimeoutTimer=N;class V{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,be){this.cancel(),this._token=setInterval(()=>{ee()},be)}}e.IntervalTimer=V;class U{constructor(ee,be){this.timeoutToken=-1,this.runner=ee,this.timeout=be,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class D{constructor(ee,be){be%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${be}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=be,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=D;class x extends U{constructor(ee,be){super(ee,be),this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class L extends M.Disposable{constructor(ee,be){super(),this.options=ee,this.handler=be,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ee),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=me=>{(0,A.setTimeout0)(()=>{if(ee)return;const be=Date.now()+15;me(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,be-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(me,ee)=>{const be=requestIdleCallback(me,typeof ee=="number"?{timeout:ee}:void 0);let _e=!1;return{dispose(){_e||(_e=!0,cancelIdleCallback(be))}}}}();class R{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(be){this._error=be}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function K(me,ee,be){let _e;for(let Fe=0;Fe<be;Fe++)try{return await me()}catch(Be){_e=Be,await i(ee)}throw _e}e.retry=K;class W{hasPending(ee){return this._pending?typeof ee=="number"?this._pending.taskId===ee:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(ee,be,_e){return this._pending={taskId:ee,cancel:()=>_e?.(),promise:be},be.then(()=>this.donePending(ee),()=>this.donePending(ee)),be}donePending(ee){this._pending&&ee===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ee=this._next;this._next=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this._next)this._next.run=ee;else{let be,_e;const Fe=new Promise((Be,Xe)=>{be=Be,_e=Xe});this._next={run:ee,promise:Fe,promiseResolve:be,promiseReject:_e}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class ${constructor(ee,be=()=>Date.now()){this.interval=ee,this.nowFn=be,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class G{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ee,be)=>{this.completeCallback=ee,this.errorCallback=be})}complete(ee){return new Promise(be=>{this.completeCallback(ee),this.resolved=!0,be()})}error(ee){return new Promise(be=>{this.errorCallback(ee),this.rejected=!0,be()})}cancel(){new Promise(ee=>{this.errorCallback(new C.CancellationError),this.rejected=!0,ee()})}}e.DeferredPromise=G;var re;(function(me){async function ee(_e){let Fe;const Be=await Promise.all(_e.map(Xe=>Xe.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe<"u")throw Fe;return Be}me.settled=ee;function be(_e){return new Promise(async(Fe,Be)=>{try{await _e(Fe,Be)}catch(Xe){Be(Xe)}})}me.withAsyncBody=be})(re=e.Promises||(e.Promises={}));var ge;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(ge||(ge={}));class oe{static fromArray(ee){return new oe(be=>{be.emitMany(ee)})}static fromPromise(ee){return new oe(async be=>{be.emitMany(await ee)})}static fromPromises(ee){return new oe(async be=>{await Promise.all(ee.map(async _e=>be.emitOne(await _e)))})}static merge(ee){return new oe(async be=>{await Promise.all(ee.map(async _e=>{for await(const Fe of _e)be.emitOne(Fe)}))})}constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const be={emitOne:_e=>this.emitOne(_e),emitMany:_e=>this.emitMany(_e),reject:_e=>this.reject(_e)};try{await Promise.resolve(ee(be)),this.resolve()}catch(_e){this.reject(_e)}finally{be.emitOne=void 0,be.emitMany=void 0,be.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,be){return new oe(async _e=>{for await(const Fe of ee)_e.emitOne(be(Fe))})}map(ee){return oe.map(this,ee)}static filter(ee,be){return new oe(async _e=>{for await(const Fe of ee)be(Fe)&&_e.emitOne(Fe)})}filter(ee){return oe.filter(this,ee)}static coalesce(ee){return oe.filter(ee,be=>!!be)}coalesce(){return oe.coalesce(this)}static async toPromise(ee){const be=[];for await(const _e of ee)be.push(_e);return be}toPromise(){return oe.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class Ee extends oe{constructor(ee,be){super(be),this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Ee;function ce(me){const ee=new r.CancellationTokenSource,be=me(ee.token);return new Ee(ee,async _e=>{const Fe=ee.token.onCancellationRequested(()=>{Fe.dispose(),ee.dispose(),_e.reject(new C.CancellationError)});try{for await(const Be of be){if(ee.token.isCancellationRequested)return;_e.emitOne(Be)}Fe.dispose(),ee.dispose()}catch(Be){Fe.dispose(),ee.dispose(),_e.reject(Be)}})}e.createCancelableAsyncIterable=ce}),define(Ce[118],Ie([1,0,15,19]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new r.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),M=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(v,T,N=!1){const V=v||"",U=T||"",D=S.value.collator.compare(V,U);return S.value.collatorIsNumeric&&D===0&&V!==U?V<U?-1:1:D}e.compareFileNames=A;function E(v,T){const N=M.value.collator;return v=v||"",T=T||"",w(N,v,T)}e.compareFileNamesDefault=E;function P(v,T){const N=M.value.collator;return v=v||"",T=T||"",n(v,T)||w(N,v,T)}e.compareFileNamesUpper=P;function O(v,T){const N=M.value.collator;return v=v||"",T=T||"",i(v,T)||w(N,v,T)}e.compareFileNamesLower=O;function b(v,T){return v=v||"",T=T||"",v===T?0:v<T?-1:1}e.compareFileNamesUnicode=b;function m(v,T,N=!1){N||(v=v&&v.toLowerCase(),T=T&&T.toLowerCase());const[V,U]=_(v),[D,x]=_(T);return V!==D?V<D?-1:1:U===x?0:U<x?-1:1}e.noIntlCompareFileNames=m;function k(v,T){const[N,V]=_(v),[U,D]=_(T);let x=S.value.collator.compare(V,D);if(x===0){if(S.value.collatorIsNumeric&&V!==D)return V<D?-1:1;if(x=S.value.collator.compare(N,U),S.value.collatorIsNumeric&&x===0&&N!==U)return N<U?-1:1}return x}e.compareFileExtensions=k;function p(v,T){v=v||"",T=T||"";const N=a(v),V=a(T),U=M.value.collator,D=y.value.collator;return w(D,N,V)||w(U,v,T)}e.compareFileExtensionsDefault=p;function l(v,T){v=v||"",T=T||"";const N=a(v),V=a(T),U=M.value.collator,D=y.value.collator;return w(D,N,V)||n(v,T)||w(U,v,T)}e.compareFileExtensionsUpper=l;function u(v,T){v=v||"",T=T||"";const N=a(v),V=a(T),U=M.value.collator,D=y.value.collator;return w(D,N,V)||i(v,T)||w(U,v,T)}e.compareFileExtensionsLower=u;function d(v,T){v=v||"",T=T||"";const N=a(v).toLowerCase(),V=a(T).toLowerCase();return N!==V?N<V?-1:1:v!==T?v<T?-1:1:0}e.compareFileExtensionsUnicode=d;const g=/^(.*?)(\.([^.]*))?$/;function _(v,T=!1){const N=v?g.exec(v):[];let V=[N&&N[1]||"",N&&N[3]||""];return T&&(!V[0]&&V[1]||V[0]&&V[0].charAt(0)===".")&&(V=[V[0]+"."+V[1],""]),V}function a(v){const T=v?g.exec(v):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function w(v,T,N){const V=v.compare(T,N);return V!==0?V:T.length!==N.length?T.length<N.length?-1:1:0}function t(v){const T=v.charAt(0);return T.toLocaleUpperCase()!==T}function c(v){const T=v.charAt(0);return T.toLocaleLowerCase()!==T}function i(v,T){return t(v)&&c(T)?-1:c(v)&&t(T)?1:0}function n(v,T){return c(v)&&t(T)?-1:t(v)&&c(T)?1:0}function o(v,T,N=!1){return N||(v=v&&v.toLowerCase(),T=T&&T.toLowerCase()),v===T?0:v<T?-1:1}function f(v,T,N=!1){const V=v.split(C.sep),U=T.split(C.sep),D=V.length-1,x=U.length-1;let L,R;for(let K=0;;K++){if(L=D===K,R=x===K,L&&R)return A(V[K],U[K],N);if(L)return-1;if(R)return 1;const W=o(V[K],U[K],N);if(W!==0)return W}}e.comparePaths=f;function s(v,T,N){const V=v.toLowerCase(),U=T.toLowerCase(),D=h(v,T,N);if(D)return D;const x=V.endsWith(N),L=U.endsWith(N);if(x!==L)return x?-1:1;const R=A(V,U);return R!==0?R:V.localeCompare(U)}e.compareAnything=s;function h(v,T,N){const V=v.toLowerCase(),U=T.toLowerCase(),D=V.startsWith(N),x=U.startsWith(N);if(D!==x)return D?-1:1;if(D&&x){if(V.length<U.length)return-1;if(V.length>U.length)return 1}return 0}e.compareByPrefix=h}),define(Ce[34],Ie([1,0,18,15,38,24,19,21,9]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",b="[^/\\\\]",m=/\//g;function k(G,re){switch(G){case 0:return"";case 1:return`${b}*?`;default:return`(?:${O}|${b}+${O}${re?`|${O}${b}+`:""})*?`}}function p(G,re){if(!G)return[];const ge=[];let oe=!1,Ee=!1,ce="";for(const me of G){switch(me){case re:if(!oe&&!Ee){ge.push(ce),ce="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":Ee=!0;break;case"]":Ee=!1;break}ce+=me}return ce&&ge.push(ce),ge}e.splitGlobAware=p;function l(G){if(!G)return"";let re="";const ge=p(G,e.GLOB_SPLIT);if(ge.every(oe=>oe===e.GLOBSTAR))re=".*";else{let oe=!1;ge.forEach((Ee,ce)=>{if(Ee===e.GLOBSTAR){if(oe)return;re+=k(2,ce===ge.length-1)}else{let me=!1,ee="",be=!1,_e="";for(const Fe of Ee){if(Fe!=="}"&&me){ee+=Fe;continue}if(be&&(Fe!=="]"||!_e)){let Be;Fe==="-"?Be=Fe:(Fe==="^"||Fe==="!")&&!_e?Be="^":Fe===e.GLOB_SPLIT?Be="":Be=(0,E.escapeRegExpCharacters)(Fe),_e+=Be;continue}switch(Fe){case"{":me=!0;continue;case"[":be=!0;continue;case"}":{re+=`(?:${p(ee,",").map(ke=>l(ke)).join("|")})`,me=!1,ee="";break}case"]":{re+="["+_e+"]",be=!1,_e="";break}case"?":re+=b;continue;case"*":re+=k(1);continue;default:re+=(0,E.escapeRegExpCharacters)(Fe)}}ce<ge.length-1&&(ge[ce+1]!==e.GLOBSTAR||ce+2<ge.length)&&(re+=O)}oe=Ee===e.GLOBSTAR})}return re}const u=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,_=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),c=function(){return!1},i=function(){return null};function n(G,re){if(!G)return i;let ge;typeof G!="string"?ge=G.pattern:ge=G,ge=ge.trim();const oe=`${ge}_${!!re.trimForExclusions}`;let Ee=t.get(oe);if(Ee)return o(Ee,G);let ce;return u.test(ge)?Ee=s(ge.substr(4),ge):(ce=d.exec(f(ge,re)))?Ee=h(ce[1],ge):(re.trimForExclusions?_:g).test(ge)?Ee=v(ge,re):(ce=a.exec(f(ge,re)))?Ee=T(ce[1].substr(1),ge,!0):(ce=w.exec(f(ge,re)))?Ee=T(ce[1],ge,!1):Ee=N(ge),t.set(oe,Ee),o(Ee,G)}function o(G,re){if(typeof re=="string")return G;const ge=function(oe,Ee){return(0,S.isEqualOrParent)(oe,re.base,!A.isLinux)?G(oe.substr(re.base.length+1),Ee):null};return ge.allBasenames=G.allBasenames,ge.allPaths=G.allPaths,ge.basenames=G.basenames,ge.patterns=G.patterns,ge}function f(G,re){return re.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function s(G,re){return function(ge,oe){return typeof ge=="string"&&ge.endsWith(G)?re:null}}function h(G,re){const ge=`/${G}`,oe=`\\${G}`,Ee=function(me,ee){return typeof me!="string"?null:ee?ee===G?re:null:me===G||me.endsWith(ge)||me.endsWith(oe)?re:null},ce=[G];return Ee.basenames=ce,Ee.patterns=[re],Ee.allBasenames=ce,Ee}function v(G,re){const ge=W(G.slice(1,-1).split(",").map(ee=>n(ee,re)).filter(ee=>ee!==i),G),oe=ge.length;if(!oe)return i;if(oe===1)return ge[0];const Ee=function(ee,be){for(let _e=0,Fe=ge.length;_e<Fe;_e++)if(ge[_e](ee,be))return G;return null},ce=ge.find(ee=>!!ee.allBasenames);ce&&(Ee.allBasenames=ce.allBasenames);const me=ge.reduce((ee,be)=>be.allPaths?ee.concat(be.allPaths):ee,[]);return me.length&&(Ee.allPaths=me),Ee}function T(G,re,ge){const oe=y.sep===y.posix.sep,Ee=oe?G:G.replace(m,y.sep),ce=y.sep+Ee,me=y.posix.sep+G;let ee;return ge?ee=function(be,_e){return typeof be=="string"&&(be===Ee||be.endsWith(ce)||!oe&&(be===G||be.endsWith(me)))?re:null}:ee=function(be,_e){return typeof be=="string"&&(be===Ee||!oe&&be===G)?re:null},ee.allPaths=[(ge?"*/":"./")+G],ee}function N(G){try{const re=new RegExp(`^${l(G)}$`);return function(ge){return re.lastIndex=0,typeof ge=="string"&&re.test(ge)?G:null}}catch{return i}}function V(G,re,ge){return!G||typeof re!="string"?!1:U(G)(re,void 0,ge)}e.match=V;function U(G,re={}){if(!G)return c;if(typeof G=="string"||D(G)){const ge=n(G,re);if(ge===i)return c;const oe=function(Ee,ce){return!!ge(Ee,ce)};return ge.allBasenames&&(oe.allBasenames=ge.allBasenames),ge.allPaths&&(oe.allPaths=ge.allPaths),oe}return R(G,re)}e.parse=U;function D(G){const re=G;return re?typeof re.base=="string"&&typeof re.pattern=="string":!1}e.isRelativePattern=D;function x(G){return G.allBasenames||[]}e.getBasenameTerms=x;function L(G){return G.allPaths||[]}e.getPathTerms=L;function R(G,re){const ge=W(Object.getOwnPropertyNames(G).map(ee=>K(ee,G[ee],re)).filter(ee=>ee!==i)),oe=ge.length;if(!oe)return i;if(!ge.some(ee=>!!ee.requiresSiblings)){if(oe===1)return ge[0];const ee=function(Fe,Be){let Xe;for(let ke=0,ye=ge.length;ke<ye;ke++){const De=ge[ke](Fe,Be);if(typeof De=="string")return De;(0,C.isThenable)(De)&&(Xe||(Xe=[]),Xe.push(De))}return Xe?(async()=>{for(const ke of Xe){const ye=await ke;if(typeof ye=="string")return ye}return null})():null},be=ge.find(Fe=>!!Fe.allBasenames);be&&(ee.allBasenames=be.allBasenames);const _e=ge.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return _e.length&&(ee.allPaths=_e),ee}const Ee=function(ee,be,_e){let Fe,Be;for(let Xe=0,ke=ge.length;Xe<ke;Xe++){const ye=ge[Xe];ye.requiresSiblings&&_e&&(be||(be=(0,y.basename)(ee)),Fe||(Fe=be.substr(0,be.length-(0,y.extname)(ee).length)));const De=ye(ee,be,Fe,_e);if(typeof De=="string")return De;(0,C.isThenable)(De)&&(Be||(Be=[]),Be.push(De))}return Be?(async()=>{for(const Xe of Be){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},ce=ge.find(ee=>!!ee.allBasenames);ce&&(Ee.allBasenames=ce.allBasenames);const me=ge.reduce((ee,be)=>be.allPaths?ee.concat(be.allPaths):ee,[]);return me.length&&(Ee.allPaths=me),Ee}function K(G,re,ge){if(re===!1)return i;const oe=n(G,ge);if(oe===i)return i;if(typeof re=="boolean")return oe;if(re){const Ee=re.when;if(typeof Ee=="string"){const ce=(me,ee,be,_e)=>{if(!_e||!oe(me,ee))return null;const Fe=Ee.replace("$(basename)",be),Be=_e(Fe);return(0,C.isThenable)(Be)?Be.then(Xe=>Xe?G:null):Be?G:null};return ce.requiresSiblings=!0,ce}}return oe}function W(G,re){const ge=G.filter(ee=>!!ee.basenames);if(ge.length<2)return G;const oe=ge.reduce((ee,be)=>{const _e=be.basenames;return _e?ee.concat(_e):ee},[]);let Ee;if(re){Ee=[];for(let ee=0,be=oe.length;ee<be;ee++)Ee.push(re)}else Ee=ge.reduce((ee,be)=>{const _e=be.patterns;return _e?ee.concat(_e):ee},[]);const ce=function(ee,be){if(typeof ee!="string")return null;if(!be){let Fe;for(Fe=ee.length;Fe>0;Fe--){const Be=ee.charCodeAt(Fe-1);if(Be===47||Be===92)break}be=ee.substr(Fe)}const _e=oe.indexOf(be);return _e!==-1?Ee[_e]:null};ce.basenames=oe,ce.patterns=Ee,ce.allBasenames=oe;const me=G.filter(ee=>!ee.basenames);return me.push(ce),me}function $(G,re){return(0,r.equals)(G,re,(ge,oe)=>typeof ge=="string"&&typeof oe=="string"?ge===oe:typeof ge!="string"&&typeof oe!="string"?ge.base===oe.base&&ge.pattern===oe.pattern:!1)}e.patternsEquals=$}),define(Ce[77],Ie([1,0,12,116,22,9,2]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(d="",g=!1){if(this.value=d,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(d,g=0){return this.value+=m(this.supportThemeIcons?(0,C.escapeIcons)(d):d).replace(/([ \t]+)/g,(_,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,g){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(d,g,_){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(d),")"),_&&(this.value+=` "${this._escape(this._escape(_,'"'),")")}"`),this.value+=")",this}_escape(d,g){const _=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return d.replace(_,(a,w)=>d.charAt(w-1)!=="\\"?`\\${a}`:a)}}e.MarkdownString=E;function P(u){return O(u)?!u.value:Array.isArray(u)?u.every(P):!0}e.isEmptyMarkdownString=P;function O(u){return u instanceof E?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function b(u,d){return u===d?!0:!u||!d?!1:u.value===d.value&&u.isTrusted===d.isTrusted&&u.supportThemeIcons===d.supportThemeIcons&&u.supportHtml===d.supportHtml&&(u.baseUri===d.baseUri||!!u.baseUri&&!!d.baseUri&&(0,S.isEqual)(y.URI.from(u.baseUri),y.URI.from(d.baseUri)))}e.markdownStringEqual=b;function m(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function k(u){return u.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function p(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=p;function l(u){const d=[],g=u.split("|").map(a=>a.trim());u=g[0];const _=g[1];if(_){const a=/height=(\d+)/.exec(_),w=/width=(\d+)/.exec(_),t=a?a[1]:"",c=w?w[1]:"",i=isFinite(parseInt(c)),n=isFinite(parseInt(t));i&&d.push(`width="${c}"`),n&&d.push(`height="${t}"`)}return{href:u,dimensions:d}}e.parseHrefAndDimensions=l}),define(Ce[78],Ie([1,0,18,38,19,21,22,9]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(i,n){const{os:o,tildify:f,relative:s}=n;if(s){const T=P(i,s,o);if(typeof T=="string")return T}let h=i.fsPath;if(o===1&&!M.isWindows?h=h.replace(/\//g,"\\"):o!==1&&M.isWindows&&(h=h.replace(/\\/g,"/")),o!==1&&f?.userHome){const T=f.userHome.fsPath;let N;i.scheme!==f.userHome.scheme&&i.path.startsWith(S.posix.sep)?N=f.userHome.with({path:i.path}).fsPath:N=i.fsPath,h=m(N,T,o)}return(o===1?S.win32:S.posix).normalize(O(h,o===1))}e.getPathLabel=E;function P(i,n,o){const f=o===1?S.win32:S.posix,s=o===3?y.extUri:y.extUriIgnorePathCase,h=n.getWorkspace(),v=(0,r.firstOrDefault)(h.folders);if(!v)return;i.scheme!==v.uri.scheme&&i.path.startsWith(S.posix.sep)&&(i=v.uri.with({path:i.path}));const T=n.getWorkspaceFolder(i);if(!T)return;let N;if(s.isEqual(T.uri,i)?N="":N=s.relativePath(T.uri,i)??"",N&&(N=f.normalize(N)),h.folders.length>1&&!n.noPrefix){const V=T.name?T.name:s.basenameOrAuthority(T.uri);N=N?`${V} \u2022 ${N}`:V}return N}function O(i,n=M.isWindows){return(0,C.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=O;let b=Object.create(null);function m(i,n,o=M.OS){if(o===1||!i||!n)return i;let f=b.original===n?b.normalized:void 0;f||(f=n,M.isWindows&&(f=(0,C.toSlashes)(f)),f=`${(0,A.rtrim)(f,S.posix.sep)}${S.posix.sep}`,b={original:n,normalized:f});let s=i;return M.isWindows&&(s=(0,C.toSlashes)(s)),(o===3?s.startsWith(f):(0,A.startsWithIgnoreCase)(s,f))?`~/${s.substr(f.length)}`:i}e.tildify=m;function k(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=k;const p="\u2026",l="\\\\",u="~";function d(i,n=S.sep){const o=new Array(i.length);let f=!1;for(let s=0;s<i.length;s++){const h=i[s];if(h===""){o[s]=`.${n}`;continue}if(!h){o[s]=h;continue}f=!0;let v="",T=h;T.indexOf(l)===0?(v=T.substr(0,T.indexOf(l)+l.length),T=T.substr(T.indexOf(l)+l.length)):T.indexOf(n)===0?(v=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(u)===0&&(v=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length));const N=T.split(n);for(let V=1;f&&V<=N.length;V++)for(let U=N.length-V;f&&U>=0;U--){f=!1;let D=N.slice(U,U+V).join(n);for(let x=0;!f&&x<i.length;x++)if(x!==s&&i[x]&&i[x].indexOf(D)>-1){const L=U+V===N.length,R=U>0&&i[x].indexOf(n)>-1?n+D:D,K=i[x].endsWith(R);f=!L||K}if(!f){let x="";(N[0].endsWith(":")||v!=="")&&(U===1&&(U=0,V++,D=N[0]+n+D),U>0&&(x=N[0]+n),x=v+x),U>0&&(x=x+p+n),x=x+D,U+V<N.length&&(x=x+n+p),o[s]=x}}f&&(o[s]=h)}return o}e.shorten=d;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function _(i,n=Object.create(null)){const o=[];let f=!1,s="";for(const h of i)if(h==="$"||f&&h==="{")s&&o.push({value:s,type:g.TEXT}),s="",f=!0;else if(h==="}"&&f){const v=n[s];if(typeof v=="string")v.length&&o.push({value:v,type:g.VARIABLE});else if(v){const T=o[o.length-1];(!T||T.type!==g.SEPARATOR)&&o.push({value:v.label,type:g.SEPARATOR})}s="",f=!1}else s+=h;return s&&!f&&o.push({value:s,type:g.TEXT}),o.filter((h,v)=>{if(h.type===g.SEPARATOR){const T=o[v-1],N=o[v+1];return[T,N].every(V=>V&&(V.type===g.VARIABLE||V.type===g.TEXT)&&V.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=_;function a(i,n){return M.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function w(i,n){return M.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function c(i){const n=i.indexOf("/")!==-1?S.posix:S.win32,o=n.basename(i),f=n.dirname(i);return o.length?{name:o,parentPath:f}:{name:f,parentPath:""}}e.splitName=c}),define(Ce[119],Ie([1,0,2]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(O){return O.toJSON()}class S{constructor(b){this._uriTransformer=b}transformIncoming(b){const m=this._uriTransformer.transformIncoming(b);return m===b?b:C(r.URI.from(m))}transformOutgoing(b){const m=this._uriTransformer.transformOutgoing(b);return m===b?b:C(r.URI.from(m))}transformOutgoingURI(b){const m=this._uriTransformer.transformOutgoing(b);return m===b?b:r.URI.from(m)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function M(O,b,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof r.URI)return b.transformOutgoing(O);for(const k in O)if(Object.hasOwnProperty.call(O,k)){const p=M(O[k],b,m+1);p!==null&&(O[k]=p)}}return null}function y(O,b){const m=M(O,b,0);return m===null?O:m}e.transformOutgoingURIs=y;function A(O,b,m,k){if(!O||k>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?r.URI.revive(b.transformIncoming(O)):b.transformIncoming(O);for(const p in O)if(Object.hasOwnProperty.call(O,p)){const l=A(O[p],b,m,k+1);l!==null&&(O[p]=l)}}return null}function E(O,b){const m=A(O,b,!1,0);return m===null?O:m}e.transformIncomingURIs=E;function P(O,b){const m=A(O,b,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=P}),define(Ce[120],Ie([1,0,34,19]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(M,y,A,E,P,O){if(Array.isArray(M)){let b=0;for(const m of M){const k=S(m,y,A,E,P,O);if(k===10)return k;k>b&&(b=k)}return b}else{if(typeof M=="string")return E?M==="*"?5:M===A?10:0:0;if(M){const{language:b,pattern:m,scheme:k,hasAccessToAllModels:p,notebookType:l}=M;if(!E&&!p)return 0;l&&P&&(y=P);let u=0;if(k)if(k===y.scheme)u=10;else if(k==="*")u=5;else return 0;if(b)if(b===A)u=10;else if(b==="*")u=Math.max(u,5);else return 0;if(l)if(l===O)u=10;else if(l==="*"&&O!==void 0)u=Math.max(u,5);else return 0;if(m){let d;if(typeof m=="string"?d=m:d={...m,base:(0,C.normalize)(m.base)},d===y.fsPath||(0,r.match)(d,y.fsPath))u=10;else return 0}return u}else return 0}}e.score=S}),define(Ce[79],Ie([1,0,23,21]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(S||(S={}));function M(b){for(let m=0,k=b.length;m<k;m+=4){const p=b[m+0],l=b[m+1],u=b[m+2],d=b[m+3];b[m+0]=d,b[m+1]=u,b[m+2]=l,b[m+3]=p}}function y(b){const m=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return C.isLittleEndian()||M(m),r.VSBuffer.wrap(m)}function A(b){const m=b.buffer;if(C.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const k=new Uint8Array(m.byteLength);return k.set(m),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function E(b){const m=new Uint32Array(P(b));let k=0;if(m[k++]=b.id,b.type==="full")m[k++]=1,m[k++]=b.data.length,m.set(b.data,k),k+=b.data.length;else{m[k++]=2,m[k++]=b.deltas.length;for(const p of b.deltas)m[k++]=p.start,m[k++]=p.deleteCount,p.data?(m[k++]=p.data.length,m.set(p.data,k),k+=p.data.length):m[k++]=0}return y(m)}e.encodeSemanticTokensDto=E;function P(b){let m=0;if(m+=1+1,b.type==="full")m+=1+b.data.length;else{m+=1,m+=(1+1+1)*b.deltas.length;for(const k of b.deltas)k.data&&(m+=k.data.length)}return m}function O(b){const m=A(b);let k=0;const p=m[k++];if(m[k++]===1){const g=m[k++],_=m.subarray(k,k+g);return k+=g,{id:p,type:"full",data:_}}const u=m[k++],d=[];for(let g=0;g<u;g++){const _=m[k++],a=m[k++],w=m[k++];let t;w>0&&(t=m.subarray(k,k+w),k+=w),d[g]={start:_,deleteCount:a,data:t}}return{id:p,type:"delta",deltas:d}}e.decodeSemanticTokensDto=O}),define(Ce[121],Ie([16,17]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Ce[122],Ie([1,0,121,21,123,18,25,110]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=P;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class b{constructor(Q,he,Ue,je){this.id=Q,this.name=he,this.defaultValue=Ue,this.schema=je}applyUpdate(Q,he){return k(Q,he)}compute(Q,he,Ue){return Ue}}class m{constructor(Q,he){this.newValue=Q,this.didChange=he}}e.ApplyUpdateResult=m;function k(X,Q){if(typeof X!="object"||typeof Q!="object"||!X||!Q)return new m(Q,X!==Q);if(Array.isArray(X)||Array.isArray(Q)){const Ue=Array.isArray(X)&&Array.isArray(Q)&&M.equals(X,Q);return new m(Q,!Ue)}let he=!1;for(const Ue in Q)if(Q.hasOwnProperty(Ue)){const je=k(X[Ue],Q[Ue]);je.didChange&&(X[Ue]=je.newValue,he=!0)}return new m(X,he)}class p{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,he){return k(Q,he)}validate(Q){return this.defaultValue}}class l{constructor(Q,he,Ue,je){this.id=Q,this.name=he,this.defaultValue=Ue,this.schema=je}applyUpdate(Q,he){return k(Q,he)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,he,Ue){return Ue}}function u(X,Q){return typeof X>"u"?Q:X==="false"?!1:Boolean(X)}e.boolean=u;class d extends l{constructor(Q,he,Ue,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Ue),super(Q,he,Ue,je)}validate(Q){return u(Q,this.defaultValue)}}function g(X,Q,he,Ue){if(typeof X>"u")return Q;let je=parseInt(X,10);return isNaN(je)?Q:(je=Math.max(he,je),je=Math.min(Ue,je),je|0)}e.clampedInt=g;class _ extends l{static clampedInt(Q,he,Ue,je){return g(Q,he,Ue,je)}constructor(Q,he,Ue,je,Ze,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ue,Ke.minimum=je,Ke.maximum=Ze),super(Q,he,Ue,Ke),this.minimum=je,this.maximum=Ze}validate(Q){return _.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class a extends l{static clamp(Q,he,Ue){return Q<he?he:Q>Ue?Ue:Q}static float(Q,he){if(typeof Q=="number")return Q;if(typeof Q>"u")return he;const Ue=parseFloat(Q);return isNaN(Ue)?he:Ue}constructor(Q,he,Ue,je,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ue),super(Q,he,Ue,Ze),this.validationFn=je}validate(Q){return this.validationFn(a.float(Q,this.defaultValue))}}class w extends l{static string(Q,he){return typeof Q!="string"?he:Q}constructor(Q,he,Ue,je=void 0){typeof je<"u"&&(je.type="string",je.default=Ue),super(Q,he,Ue,je)}validate(Q){return w.string(Q,this.defaultValue)}}function t(X,Q,he){return typeof X!="string"||he.indexOf(X)===-1?Q:X}e.stringSet=t;class c extends l{constructor(Q,he,Ue,je,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=je,Ze.default=Ue),super(Q,he,Ue,Ze),this._allowedValues=je}validate(Q){return t(Q,this.defaultValue,this._allowedValues)}}class i extends b{constructor(Q,he,Ue,je,Ze,Ke,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=Ze,Ve.default=je),super(Q,he,Ue,Ve),this._allowedValues=Ze,this._convert=Ke}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function n(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,he,Ue){return Ue===0?Q.accessibilitySupport:Ue}}class f extends b{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertSpace:u(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function T(X){switch(X){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=T;function N(X){switch(X){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class V extends p{constructor(){super(130)}compute(Q,he,Ue){const je=["monaco-editor"];return he.get(34)&&je.push(he.get(34)),Q.extraEditorClassName&&je.push(Q.extraEditorClassName),he.get(67)==="default"?je.push("mouse-default"):he.get(67)==="copy"&&je.push("mouse-copy"),he.get(101)&&je.push("showUnused"),he.get(128)&&je.push("showDeprecated"),je.join(" ")}}class U extends d{constructor(){super(33,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,he,Ue){return Ue&&Q.emptySelectionClipboard}}class D extends b{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{cursorMoveOnType:u(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":t(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":t(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(he.loop,this.defaultValue.loop)}}}class x extends b{constructor(){super(46,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?x.OFF:Q==="true"?x.ON:Q:Boolean(Q)?x.ON:x.OFF}}e.EditorFontLigatures=x,x.OFF='"liga" off, "calt" off',x.ON='"liga" on, "calt" on';class L extends p{constructor(){super(45)}compute(Q,he,Ue){return Q.fontInfo}}class R extends l{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Q){const he=a.float(Q,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(he,6,100)}compute(Q,he,Ue){return Q.fontInfo.fontSize}}class K extends b{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(_.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class W extends b{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ue,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ue,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ue,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ue,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ue,description:r.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{multiple:t(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??t(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??t(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??t(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??t(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??t(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends b{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),delay:_.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:u(he.sticky,this.defaultValue.sticky),above:u(he.above,this.defaultValue.above)}}}var G;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class re extends p{constructor(){super(133)}compute(Q,he,Ue){return re.computeLayout(he,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const he=Q.height/Q.lineHeight,Ue=Q.scrollBeyondLastLine?he-1:0,je=(Q.viewLineCount+Ue)/(Q.pixelRatio*Q.height),Ze=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Ue,desiredRatio:je,minimapLineCount:Ze}}static _computeMinimapLayout(Q,he){const Ue=Q.outerWidth,je=Q.outerHeight,Ze=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Ke=he.stableMinimapLayoutInput,Ve=Ke&&Q.outerHeight===Ke.outerHeight&&Q.lineHeight===Ke.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ke.pixelRatio&&Q.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Q.minimap.enabled===Ke.minimap.enabled&&Q.minimap.side===Ke.minimap.side&&Q.minimap.size===Ke.minimap.size&&Q.minimap.showSlider===Ke.minimap.showSlider&&Q.minimap.renderCharacters===Ke.minimap.renderCharacters&&Q.minimap.maxColumn===Ke.minimap.maxColumn&&Q.minimap.scale===Ke.minimap.scale&&Q.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Q.isViewportWrapping===Ke.isViewportWrapping,it=Q.lineHeight,st=Q.typicalHalfwidthCharacterWidth,dt=Q.scrollBeyondLastLine,_t=Q.minimap.renderCharacters;let tt=Ze>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const ut=Q.minimap.maxColumn,Ot=Q.minimap.size,Ht=Q.minimap.side,At=Q.verticalScrollbarWidth,ft=Q.viewLineCount,Ct=Q.remainingWidth,Lt=Q.isViewportWrapping,xt=_t?2:3;let qe=Math.floor(Ze*je);const Ft=qe/Ze;let It=!1,Nt=!1,gt=xt*tt,Se=tt/Ze,Pe=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:et,extraLinesBeyondLastLine:lt,desiredRatio:mt,minimapLineCount:yt}=re.computeContainedMinimapLineCount({viewLineCount:ft,scrollBeyondLastLine:dt,height:je,lineHeight:it,pixelRatio:Ze});if(ft/yt>1)It=!0,Nt=!0,tt=1,gt=1,Se=tt/Ze;else{let wt=!1,kt=tt+1;if(Ot==="fit"){const bt=Math.ceil((ft+lt)*gt);Lt&&Ve&&Ct<=he.stableFitRemainingWidth?(wt=!0,kt=he.stableFitMaxMinimapScale):wt=bt>qe}if(Ot==="fill"||wt){It=!0;const bt=tt;gt=Math.min(it*Ze,Math.max(1,Math.floor(1/mt))),Lt&&Ve&&Ct<=he.stableFitRemainingWidth&&(kt=he.stableFitMaxMinimapScale),tt=Math.min(kt,Math.max(1,Math.floor(gt/xt))),tt>bt&&(Pe=Math.min(2,tt/bt)),Se=tt/Ze/Pe,qe=Math.ceil(Math.max(et,ft+lt)*gt),Lt?(he.stableMinimapLayoutInput=Q,he.stableFitRemainingWidth=Ct,he.stableFitMaxMinimapScale=tt):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const fe=Math.floor(ut*Se),q=Math.min(fe,Math.max(0,Math.floor((Ct-At-2)*Se/(st+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(Ze*q);const Le=Ae/Ze;Ae=Math.floor(Ae*Pe);const nt=_t?1:2,We=Ht==="left"?0:Ue-q-At;return{renderMinimap:nt,minimapLeft:We,minimapWidth:q,minimapHeightIsEditorHeight:It,minimapIsSampling:Nt,minimapScale:tt,minimapLineHeight:gt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Ft}}static computeLayout(Q,he){const Ue=he.outerWidth|0,je=he.outerHeight|0,Ze=he.lineHeight|0,Ke=he.lineNumbersDigitCount|0,Ve=he.typicalHalfwidthCharacterWidth,it=he.maxDigitWidth,st=he.pixelRatio,dt=he.viewLineCount,_t=Q.get(125),tt=_t==="inherit"?Q.get(124):_t,ut=tt==="inherit"?Q.get(120):tt,Ot=Q.get(123),Ht=Q.get(2),At=he.isDominatedByLongLines,ft=Q.get(51),Ct=Q.get(61).renderType!==0,Lt=Q.get(62),xt=Q.get(95),qe=Q.get(66),Ft=Q.get(93),It=Ft.verticalScrollbarSize,Nt=Ft.verticalHasArrows,gt=Ft.arrowSize,Se=Ft.horizontalScrollbarSize,Pe=Q.get(59),fe=Q.get(38),q=Q.get(100)!=="never";let Ae;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const vt=parseFloat(Pe.substr(0,Pe.length-2));Ae=_.clampedInt(vt*Ve,0,0,1e3)}else Ae=_.clampedInt(Pe,0,0,1e3);fe&&q&&(Ae+=16);let Le=0;if(Ct){const vt=Math.max(Ke,Lt);Le=Math.round(vt*it)}let nt=0;ft&&(nt=Ze);let We=0,et=We+nt,lt=et+Le,mt=lt+Ae;const yt=Ue-nt-Le-Ae;let Et=!1,wt=!1,kt=-1;Ht!==2&&(tt==="inherit"&&At?(Et=!0,wt=!0):ut==="on"||ut==="bounded"?wt=!0:ut==="wordWrapColumn"&&(kt=Ot));const bt=re._computeMinimapLayout({outerWidth:Ue,outerHeight:je,lineHeight:Ze,typicalHalfwidthCharacterWidth:Ve,pixelRatio:st,scrollBeyondLastLine:xt,minimap:qe,verticalScrollbarWidth:It,viewLineCount:dt,remainingWidth:yt,isViewportWrapping:wt},he.memory||new O);bt.renderMinimap!==0&&bt.minimapLeft===0&&(We+=bt.minimapWidth,et+=bt.minimapWidth,lt+=bt.minimapWidth,mt+=bt.minimapWidth);const Dt=yt-bt.minimapWidth,ti=Math.max(1,Math.floor((Dt-It-2)/Ve)),Xt=Nt?gt:0;return wt&&(kt=Math.max(1,ti),ut==="bounded"&&(kt=Math.min(kt,Ot))),{width:Ue,height:je,glyphMarginLeft:We,glyphMarginWidth:nt,lineNumbersLeft:et,lineNumbersWidth:Le,decorationsLeft:lt,decorationsWidth:Ae,contentLeft:mt,contentWidth:Dt,minimap:bt,viewportColumn:ti,isWordWrapMinified:Et,isViewportWrapping:wt,wrappingColumn:kt,verticalScrollbarWidth:It,horizontalScrollbarHeight:Se,overviewRuler:{top:Xt,width:It,height:je-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=re;class ge extends b{constructor(){const Q={enabled:!0};super(58,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class oe extends b{constructor(){const Q={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:r.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:r.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),maxLineCount:_.clampedInt(he.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Ee extends b{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:r.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[r.localize(47,null),r.localize(48,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(49,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:r.localize(53,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:t(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:_.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(he.fontFamily,this.defaultValue.fontFamily),padding:u(he.padding,this.defaultValue.padding)}}}class ce extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>a.clamp(Q,0,150),{markdownDescription:r.localize(54,null)})}compute(Q,he,Ue){return Q.fontInfo.lineHeight}}class me extends b{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:r.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(57,null),r.localize(58,null),r.localize(59,null)],default:Q.size,description:r.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(62,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),autohide:u(he.autohide,this.defaultValue.autohide),size:t(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(he.side,this.defaultValue.side,["right","left"]),showSlider:t(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(he.renderCharacters,this.defaultValue.renderCharacters),scale:_.clampedInt(he.scale,1,1,3),maxColumn:_.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(X){return X==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class be extends b{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(67,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{top:_.clampedInt(he.top,0,0,1e3),bottom:_.clampedInt(he.bottom,0,0,1e3)}}}class _e extends b{constructor(){const Q={enabled:!0,cycle:!1};super(77,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(69,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),cycle:u(he.cycle,this.defaultValue.cycle)}}}class Fe extends p{constructor(){super(131)}compute(Q,he,Ue){return Q.pixelRatio}}class Be extends b{constructor(){const Q={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[r.localize(70,null),r.localize(71,null),r.localize(72,null)]}];super(80,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:Q.strings,description:r.localize(73,null)},comments:{anyOf:he,default:Q.comments,description:r.localize(74,null)},other:{anyOf:he,default:Q.other,description:r.localize(75,null)}},default:Q,markdownDescription:r.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const st=Q?"on":"off";return{comments:st,strings:st,other:st}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:he,comments:Ue,strings:je}=Q,Ze=["on","inline","off"];let Ke,Ve,it;return typeof he=="boolean"?Ke=he?"on":"off":Ke=t(he,this.defaultValue.other,Ze),typeof Ue=="boolean"?Ve=Ue?"on":"off":Ve=t(Ue,this.defaultValue.comments,Ze),typeof je=="boolean"?it=je?"on":"off":it=t(je,this.defaultValue.strings,Ze),{other:Ke,comments:Ve,strings:it}}}var Xe;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Xe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ke extends b{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(77,null),r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"on",description:r.localize(81,null)})}validate(Q){let he=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(he=4,Ue=Q):Q==="interval"?he=3:Q==="relative"?he=2:Q==="on"?he=1:he=0),{renderType:he,renderFn:Ue}}}function ye(X){const Q=X.get(88);return Q==="editable"?X.get(82):Q!=="on"}e.filterValidationDecorations=ye;class De extends b{constructor(){const Q=[],he={type:"number",description:r.localize(82,null)};super(92,"rulers",Q,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:r.localize(83,null),format:"color-hex"}}}]},default:Q,description:r.localize(84,null)})}validate(Q){if(Array.isArray(Q)){const he=[];for(const Ue of Q)if(typeof Ue=="number")he.push({column:_.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const je=Ue;he.push({column:_.clampedInt(je.column,0,0,1e4),color:je.color})}return he.sort((Ue,je)=>Ue.column-je.column),he}return this.defaultValue}}function ae(X,Q){if(typeof X!="string")return Q;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends b{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(85,null),r.localize(86,null),r.localize(87,null)],default:"auto",description:r.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(89,null),r.localize(90,null),r.localize(91,null)],default:"auto",description:r.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(95,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q,Ue=_.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=_.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:_.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(he.vertical,this.defaultValue.vertical),horizontal:ae(he.horizontal,this.defaultValue.horizontal),useShadows:u(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:_.clampedInt(he.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:je,verticalSliderSize:_.clampedInt(he.verticalSliderSize,je,0,1e3),scrollByPage:u(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends b{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(102,null)}})}applyUpdate(Q,he){let Ue=!1;he.allowedCharacters&&Q&&(y.equals(Q.allowedCharacters,he.allowedCharacters)||(Q={...Q,allowedCharacters:he.allowedCharacters},Ue=!0)),he.allowedLocales&&Q&&(y.equals(Q.allowedLocales,he.allowedLocales)||(Q={...Q,allowedLocales:he.allowedLocales},Ue=!0));const je=super.applyUpdate(Q,he);return Ue?new m(je.newValue,!0):je}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{nonBasicASCII:H(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,he){if(typeof Q!="object"||!Q)return he;const Ue={};for(const[je,Ze]of Object.entries(Q))Ze===!0&&(Ue[je]=!0);return Ue}}class J extends b{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(103,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),mode:t(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class I extends b{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:r.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:r.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends b{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(106,null),r.localize(107,null),r.localize(108,null)],default:Q.bracketPairs,description:r.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(110,null),r.localize(111,null),r.localize(112,null)],default:Q.bracketPairsHorizontal,description:r.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[r.localize(116,null),r.localize(117,null),r.localize(118,null)],default:Q.highlightActiveIndentation,description:r.localize(119,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{bracketPairs:H(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(X,Q,he){const Ue=he.indexOf(X);return Ue===-1?Q:he[Ue]}class j extends b{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(120,null),r.localize(121,null)],default:Q.insertMode,description:r.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(162,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertMode:t(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(he.showIcons,this.defaultValue.showIcons),showStatusBar:u(he.showStatusBar,this.defaultValue.showStatusBar),preview:u(he.preview,this.defaultValue.preview),previewMode:t(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(he.showMethods,this.defaultValue.showMethods),showFunctions:u(he.showFunctions,this.defaultValue.showFunctions),showConstructors:u(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(he.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(he.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(he.showFields,this.defaultValue.showFields),showVariables:u(he.showVariables,this.defaultValue.showVariables),showClasses:u(he.showClasses,this.defaultValue.showClasses),showStructs:u(he.showStructs,this.defaultValue.showStructs),showInterfaces:u(he.showInterfaces,this.defaultValue.showInterfaces),showModules:u(he.showModules,this.defaultValue.showModules),showProperties:u(he.showProperties,this.defaultValue.showProperties),showEvents:u(he.showEvents,this.defaultValue.showEvents),showOperators:u(he.showOperators,this.defaultValue.showOperators),showUnits:u(he.showUnits,this.defaultValue.showUnits),showValues:u(he.showValues,this.defaultValue.showValues),showConstants:u(he.showConstants,this.defaultValue.showConstants),showEnums:u(he.showEnums,this.defaultValue.showEnums),showEnumMembers:u(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(he.showKeywords,this.defaultValue.showKeywords),showWords:u(he.showWords,this.defaultValue.showWords),showColors:u(he.showColors,this.defaultValue.showColors),showFiles:u(he.showFiles,this.defaultValue.showFiles),showReferences:u(he.showReferences,this.defaultValue.showReferences),showFolders:u(he.showFolders,this.defaultValue.showFolders),showTypeParameters:u(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(he.showSnippets,this.defaultValue.showSnippets),showUsers:u(he.showUsers,this.defaultValue.showUsers),showIssues:u(he.showIssues,this.defaultValue.showIssues)}}}class se extends b{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(163,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class le extends p{constructor(){super(132)}compute(Q,he,Ue){return he.get(82)?!0:Q.tabFocusMode}}var Y;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Y=e.WrappingIndent||(e.WrappingIndent={}));function ve(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends p{constructor(){super(134)}compute(Q,he,Ue){const je=he.get(133);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class Me extends b{constructor(){const Q={enabled:!0};super(32,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:r.localize(164,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}const xe="Consolas, 'Courier New', monospace",Ye="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?Ye:C.isLinux?Ge:xe,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(X){return e.editorOptionsRegistry[X.id]=X,X}var rt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(165,null)})),acceptSuggestionOnEnter:Te(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(166,null),""],markdownDescription:r.localize(167,null)})),accessibilitySupport:Te(new o),accessibilityPageSize:Te(new _(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(168,null)})),ariaLabel:Te(new w(4,"ariaLabel",r.localize(169,null))),autoClosingBrackets:Te(new c(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),autoClosingDelete:Te(new c(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(173,null),""],description:r.localize(174,null)})),autoClosingOvertype:Te(new c(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(175,null),""],description:r.localize(176,null)})),autoClosingQuotes:Te(new c(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(177,null),r.localize(178,null),""],description:r.localize(179,null)})),autoIndent:Te(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[r.localize(180,null),r.localize(181,null),r.localize(182,null),r.localize(183,null),r.localize(184,null)],description:r.localize(185,null)})),automaticLayout:Te(new d(10,"automaticLayout",!1)),autoSurround:Te(new c(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(186,null),r.localize(187,null),r.localize(188,null),""],description:r.localize(189,null)})),bracketPairColorization:Te(new I),bracketPairGuides:Te(new B),stickyTabStops:Te(new d(106,"stickyTabStops",!1,{description:r.localize(190,null)})),codeLens:Te(new d(14,"codeLens",!0,{description:r.localize(191,null)})),codeLensFontFamily:Te(new w(15,"codeLensFontFamily","",{description:r.localize(192,null)})),codeLensFontSize:Te(new _(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(193,null)})),colorDecorators:Te(new d(17,"colorDecorators",!0,{description:r.localize(194,null)})),columnSelection:Te(new d(18,"columnSelection",!1,{description:r.localize(195,null)})),comments:Te(new f),contextmenu:Te(new d(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new d(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(196,null)})),cursorBlinking:Te(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:r.localize(197,null)})),cursorSmoothCaretAnimation:Te(new d(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(198,null)})),cursorStyle:Te(new i(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:r.localize(199,null)})),cursorSurroundingLines:Te(new _(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(200,null)})),cursorSurroundingLinesStyle:Te(new c(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(201,null),r.localize(202,null)],description:r.localize(203,null)})),cursorWidth:Te(new _(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(204,null)})),disableLayerHinting:Te(new d(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new d(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new d(30,"domReadOnly",!1)),dragAndDrop:Te(new d(31,"dragAndDrop",!0,{description:r.localize(205,null)})),emptySelectionClipboard:Te(new U),dropIntoEditor:Te(new Me),stickyScroll:Te(new oe),extraEditorClassName:Te(new w(34,"extraEditorClassName","")),fastScrollSensitivity:Te(new a(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:r.localize(206,null)})),find:Te(new D),fixedOverflowWidgets:Te(new d(37,"fixedOverflowWidgets",!1)),folding:Te(new d(38,"folding",!0,{description:r.localize(207,null)})),foldingStrategy:Te(new c(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(208,null),r.localize(209,null)],description:r.localize(210,null)})),foldingHighlight:Te(new d(40,"foldingHighlight",!0,{description:r.localize(211,null)})),foldingImportsByDefault:Te(new d(41,"foldingImportsByDefault",!1,{description:r.localize(212,null)})),foldingMaximumRegions:Te(new _(42,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(213,null)})),unfoldOnClickAfterEndOfLine:Te(new d(43,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(214,null)})),fontFamily:Te(new w(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(215,null)})),fontInfo:Te(new L),fontLigatures2:Te(new x),fontSize:Te(new R),fontWeight:Te(new K),formatOnPaste:Te(new d(49,"formatOnPaste",!1,{description:r.localize(216,null)})),formatOnType:Te(new d(50,"formatOnType",!1,{description:r.localize(217,null)})),glyphMargin:Te(new d(51,"glyphMargin",!0,{description:r.localize(218,null)})),gotoLocation:Te(new W),hideCursorInOverviewRuler:Te(new d(53,"hideCursorInOverviewRuler",!1,{description:r.localize(219,null)})),hover:Te(new $),inDiffEditor:Te(new d(55,"inDiffEditor",!1)),letterSpacing:Te(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>a.clamp(X,-5,20),{description:r.localize(220,null)})),lightbulb:Te(new ge),lineDecorationsWidth:Te(new l(59,"lineDecorationsWidth",10)),lineHeight:Te(new ce),lineNumbers:Te(new ke),lineNumbersMinChars:Te(new _(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new d(63,"linkedEditing",!1,{description:r.localize(221,null)})),links:Te(new d(64,"links",!0,{description:r.localize(222,null)})),matchBrackets:Te(new c(65,"matchBrackets","always",["always","near","never"],{description:r.localize(223,null)})),minimap:Te(new me),mouseStyle:Te(new c(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new a(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:r.localize(224,null)})),mouseWheelZoom:Te(new d(69,"mouseWheelZoom",!1,{markdownDescription:r.localize(225,null)})),multiCursorMergeOverlapping:Te(new d(70,"multiCursorMergeOverlapping",!0,{description:r.localize(226,null)})),multiCursorModifier:Te(new i(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[r.localize(227,null),r.localize(228,null)],markdownDescription:r.localize(229,null)})),multiCursorPaste:Te(new c(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(230,null),r.localize(231,null)],markdownDescription:r.localize(232,null)})),occurrencesHighlight:Te(new d(73,"occurrencesHighlight",!0,{description:r.localize(233,null)})),overviewRulerBorder:Te(new d(74,"overviewRulerBorder",!0,{description:r.localize(234,null)})),overviewRulerLanes:Te(new _(75,"overviewRulerLanes",3,0,3)),padding:Te(new be),parameterHints:Te(new _e),peekWidgetDefaultFocus:Te(new c(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(235,null),r.localize(236,null)],description:r.localize(237,null)})),definitionLinkOpensInPeek:Te(new d(79,"definitionLinkOpensInPeek",!1,{description:r.localize(238,null)})),quickSuggestions:Te(new Be),quickSuggestionsDelay:Te(new _(81,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(239,null)})),readOnly:Te(new d(82,"readOnly",!1)),renameOnType:Te(new d(83,"renameOnType",!1,{description:r.localize(240,null),markdownDeprecationMessage:r.localize(241,null)})),renderControlCharacters:Te(new d(84,"renderControlCharacters",!0,{description:r.localize(242,null),restricted:!0})),renderFinalNewline:Te(new d(85,"renderFinalNewline",!0,{description:r.localize(243,null)})),renderLineHighlight:Te(new c(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(244,null)],description:r.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Te(new d(87,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(246,null)})),renderValidationDecorations:Te(new c(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new c(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(247,null),r.localize(248,null),r.localize(249,null),""],description:r.localize(250,null)})),revealHorizontalRightPadding:Te(new _(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Te(new d(91,"roundedSelection",!0,{description:r.localize(251,null)})),rulers:Te(new De),scrollbar:Te(new ue),scrollBeyondLastColumn:Te(new _(94,"scrollBeyondLastColumn",4,0,1073741824,{description:r.localize(252,null)})),scrollBeyondLastLine:Te(new d(95,"scrollBeyondLastLine",!0,{description:r.localize(253,null)})),scrollPredominantAxis:Te(new d(96,"scrollPredominantAxis",!0,{description:r.localize(254,null)})),selectionClipboard:Te(new d(97,"selectionClipboard",!0,{description:r.localize(255,null),included:C.isLinux})),selectionHighlight:Te(new d(98,"selectionHighlight",!0,{description:r.localize(256,null)})),selectOnLineNumbers:Te(new d(99,"selectOnLineNumbers",!0)),showFoldingControls:Te(new c(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[r.localize(257,null),r.localize(258,null),r.localize(259,null)],description:r.localize(260,null)})),showUnused:Te(new d(101,"showUnused",!0,{description:r.localize(261,null)})),showDeprecated:Te(new d(128,"showDeprecated",!0,{description:r.localize(262,null)})),inlayHints:Te(new Ee),snippetSuggestions:Te(new c(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(263,null),r.localize(264,null),r.localize(265,null),r.localize(266,null)],description:r.localize(267,null)})),smartSelect:Te(new se),smoothScrolling:Te(new d(104,"smoothScrolling",!1,{description:r.localize(268,null)})),stopRenderingLineAfter:Te(new _(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new j),inlineSuggest:Te(new J),suggestFontSize:Te(new _(109,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Te(new _(110,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Te(new d(111,"suggestOnTriggerCharacters",!0,{description:r.localize(271,null)})),suggestSelection:Te(new c(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(272,null),r.localize(273,null),r.localize(274,null)],description:r.localize(275,null)})),tabCompletion:Te(new c(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(276,null),r.localize(277,null),r.localize(278,null)],description:r.localize(279,null)})),tabIndex:Te(new _(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new Z),unusualLineTerminators:Te(new c(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(280,null),r.localize(281,null),r.localize(282,null)],description:r.localize(283,null)})),useShadowDOM:Te(new d(117,"useShadowDOM",!0)),useTabStops:Te(new d(118,"useTabStops",!0,{description:r.localize(284,null)})),wordSeparators:Te(new w(119,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:r.localize(285,null)})),wordWrap:Te(new c(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(286,null),r.localize(287,null),r.localize(288,null),r.localize(289,null)],description:r.localize(290,null)})),wordWrapBreakAfterCharacters:Te(new w(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new w(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new _(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(291,null)})),wordWrapOverride1:Te(new c(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new c(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new i(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[r.localize(292,null),r.localize(293,null),r.localize(294,null),r.localize(295,null)],description:r.localize(296,null)})),wrappingStrategy:Te(new c(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(297,null),r.localize(298,null)],description:r.localize(299,null)})),editorClassName:Te(new V),pixelRatio:Te(new Fe),tabFocusMode:Te(new le),layoutInfo:Te(new re),wrappingInfo:Te(new pe)}}),define(Ce[124],Ie([16,17]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[125],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[126],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[127],Ie([16,17]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Ce[128],Ie([16,17]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Ce[129],Ie([16,17]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Ce[130],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[131],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[132],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[133],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[134],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[135],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[136],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[137],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Ce[138],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[139],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[140],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[141],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[142],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[143],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[144],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[145],Ie([1,0,22,29,126,241]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||y.test(d)}e.isValidVersionStr=E;function P(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=d.match(y);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=P;function O(d){if(!d)return null;const g=d.majorBase,_=d.majorMustEqual,a=d.minorBase;let w=d.minorMustEqual;const t=d.patchBase;let c=d.patchMustEqual;d.hasCaret&&(g===0||(w=!1),c=!1);let i=0;if(d.preRelease){const n=A.exec(d.preRelease);if(n){const[,o,f,s]=n;i=Date.UTC(Number(o),Number(f)-1,Number(s))}}return{majorBase:g,majorMustEqual:_,minorBase:a,minorMustEqual:w,patchBase:t,patchMustEqual:c,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=O;function b(d,g,_){let a;typeof d=="string"?a=O(P(d)):a=d;let w;g instanceof Date?w=g.getTime():typeof g=="string"&&(w=new Date(g).getTime());let t;if(typeof _=="string"?t=O(P(_)):t=_,!a||!t)return!1;const c=a.majorBase,i=a.minorBase,n=a.patchBase;let o=t.majorBase,f=t.minorBase,s=t.patchBase;const h=t.notBefore;let v=t.majorMustEqual,T=t.minorMustEqual,N=t.patchMustEqual;return t.isMinimum?c>o?!0:c<o?!1:i>f?!0:i<f||w&&w<h?!1:n>=s:(c===1&&o===0&&(!v||!T||!N)&&(o=1,f=0,s=0,v=!0,T=!1,N=!1),c<o?!1:c>o?!v:i<f?!1:i>f?!T:n<s?!1:n>s?!N:!(w&&w<h))}e.isValidVersion=b;function m(d,g,_,a,w){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([C.default.Error,S.localize(0,null)]),t;if(typeof a.name!="string")return t.push([C.default.Error,S.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([C.default.Error,S.localize(2,null,"version")]),t;if(!a.engines)return t.push([C.default.Error,S.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([C.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!u(a.extensionDependencies))return t.push([C.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!u(a.activationEvents))return t.push([C.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([C.default.Error,S.localize(7,null,"activationEvents","main")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([C.default.Warning,S.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([C.default.Error,S.localize(9,null,"main")]),t;{const n=(0,r.joinPath)(_,a.main);(0,r.isEqualOrParent)(n,_)||t.push([C.default.Warning,S.localize(10,null,n.path,_.path)])}if(typeof a.activationEvents>"u")return t.push([C.default.Error,S.localize(11,null,"activationEvents","main")]),t}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([C.default.Error,S.localize(12,null,"browser")]),t;{const n=(0,r.joinPath)(_,a.browser);(0,r.isEqualOrParent)(n,_)||t.push([C.default.Warning,S.localize(13,null,n.path,_.path)])}if(typeof a.activationEvents>"u")return t.push([C.default.Error,S.localize(14,null,"activationEvents","browser")]),t}if(!M.valid(a.version))return t.push([C.default.Error,S.localize(15,null)]),t;const c=[];if(!k(d,g,a,w,c))for(const n of c)t.push([C.default.Error,n]);return t}e.validateExtensionManifest=m;function k(d,g,_,a,w){return a||typeof _.main>"u"&&typeof _.browser>"u"?!0:l(d,g,_.engines.vscode,w)}e.isValidExtensionVersion=k;function p(d,g,_){return d==="*"||l(g,_,d)}e.isEngineValid=p;function l(d,g,_,a=[]){const w=O(P(_));if(!w)return a.push(S.localize(16,null,_)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return a.push(S.localize(17,null,_)),!1}else if(!w.majorMustEqual)return a.push(S.localize(18,null,_)),!1;return b(d,g,w)?!0:(a.push(S.localize(19,null,d,_)),!1)}function u(d){if(!Array.isArray(d))return!1;for(let g=0,_=d.length;g<_;g++)if(typeof d[g]!="string")return!1;return!0}}),define(Ce[80],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(S,M=[],y=!1){this.ctor=S,this.staticArguments=M,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=r}),define(Ce[56],Ie([1,0,80]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var S;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(S=e.InstantiationType||(e.InstantiationType={}));function M(A,E,P){E instanceof r.SyncDescriptor||(E=new r.SyncDescriptor(E,[],Boolean(P))),C.push([A,E])}e.registerSingleton=M;function y(){return C}e.getSingletonServiceDescriptors=y}),define(Ce[146],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(M,y){this.key=M,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class C{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const y of this._nodes.values())y.outgoing.size===0&&M.push(y);return M}insertEdge(M,y){const A=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(y);A.outgoing.set(E.key,E),E.incoming.set(A.key,A)}removeNode(M){const y=this._hashFn(M);this._nodes.delete(y);for(const A of this._nodes.values())A.outgoing.delete(y),A.incoming.delete(y)}lookupOrInsertNode(M){const y=this._hashFn(M);let A=this._nodes.get(y);return A||(A=new r(y,M),this._nodes.set(y,A)),A}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[y,A]of this._nodes)M.push(`${y}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,y]of this._nodes){const A=new Set([M]),E=this._findCycle(y,A);if(E)return E}}_findCycle(M,y){for(const[A,E]of M.outgoing){if(y.has(A))return[...y,A].join(" -> ");y.add(A);const P=this._findCycle(E,y);if(P)return P;y.delete(A)}}}e.Graph=C}),define(Ce[3],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function A(E){return E[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=A})(r=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function C(y,A,E){A[r.DI_TARGET]===A?A[r.DI_DEPENDENCIES].push({id:y,index:E}):(A[r.DI_DEPENDENCIES]=[{id:y,index:E}],A[r.DI_TARGET]=A)}function S(y){if(r.serviceIds.has(y))return r.serviceIds.get(y);const A=function(E,P,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(A,E,O)};return A.toString=()=>y,r.serviceIds.set(y,A),A}e.createDecorator=S;function M(y){return y}e.refineServiceDecorator=M}),define(Ce[57],Ie([1,0,10,2,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function M(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof C.URI)}e.isConfigurationOverrides=M;function y(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=y;var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function P(d,g){const _=Object.create(null);for(const a in d)O(_,a,d[a],g);return _}e.toValuesTree=P;function O(d,g,_,a){const w=g.split("."),t=w.pop();let c=d;for(let i=0;i<w.length;i++){const n=w[i];let o=c[n];switch(typeof o){case"undefined":o=c[n]=Object.create(null);break;case"object":break;default:a(`Ignoring ${g} as ${w.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}c=o}if(typeof c=="object"&&c!==null)try{c[t]=_}catch{a(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(c)}`)}else a(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=O;function b(d,g){const _=g.split(".");m(d,_)}e.removeFromValueTree=b;function m(d,g){const _=g.shift();if(g.length===0){delete d[_];return}if(Object.keys(d).indexOf(_)!==-1){const a=d[_];typeof a=="object"&&!Array.isArray(a)&&(m(a,g),Object.keys(a).length===0&&delete d[_])}}function k(d,g,_){function a(c,i){let n=c;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const w=g.split("."),t=a(d,w);return typeof t>"u"?_:t}e.getConfigurationValue=k;function p(d,g,_){Object.keys(g).forEach(a=>{a!=="__proto__"&&(a in d?r.isObject(d[a])&&r.isObject(g[a])?p(d[a],g[a],_):_&&(d[a]=g[a]):d[a]=g[a])})}e.merge=p;function l(d,g,_){const a=d.inspect(g),w=d.inspect(_);return typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:a.defaultValue}e.getMigratedSettingValue=l;function u(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=u}),define(Ce[39],Ie([1,0,21,9,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",r.isMacintosh),M.set("isLinux",r.isLinux),M.set("isWindows",r.isWindows),M.set("isWeb",r.isWeb),M.set("isMacNative",r.isMacintosh&&!r.isWeb),M.set("isEdge",r.isEdge),M.set("isFirefox",r.isFirefox),M.set("isChrome",r.isChrome),M.set("isSafari",r.isSafari);const y=Object.prototype.hasOwnProperty;var A;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return b.INSTANCE}static true(){return m.INSTANCE}static has(D){return k.create(D)}static equals(D,x){return p.create(D,x)}static notEquals(D,x){return d.create(D,x)}static regex(D,x){return i.create(D,x)}static in(D,x){return l.create(D,x)}static notIn(D,x){return u.create(D,x)}static not(D){return g.create(D)}static and(...D){return f.create(D,null)}static or(...D){return s.create(D,null,!0)}static greater(D,x){return a.create(D,x)}static greaterEquals(D,x){return w.create(D,x)}static smaller(D,x){return t.create(D,x)}static smallerEquals(D,x){return c.create(D,x)}static deserialize(D,x=!1){if(!!D)return this._deserializeOrExpression(D,x)}static _deserializeOrExpression(D,x){const L=D.split("||");return s.create(L.map(R=>this._deserializeAndExpression(R,x)),null,!0)}static _deserializeAndExpression(D,x){const L=D.split("&&");return f.create(L.map(R=>this._deserializeOne(R,x)),null)}static _deserializeOne(D,x){if(D=D.trim(),D.indexOf("!=")>=0){const L=D.split("!=");return d.create(L[0].trim(),this._deserializeValue(L[1],x))}if(D.indexOf("==")>=0){const L=D.split("==");return p.create(L[0].trim(),this._deserializeValue(L[1],x))}if(D.indexOf("=~")>=0){const L=D.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],x))}if(D.indexOf(" not in ")>=0){const L=D.split(" not in ");return u.create(L[0].trim(),this._deserializeValue(L[1],x))}if(D.indexOf(" in ")>=0){const L=D.split(" in ");return l.create(L[0].trim(),this._deserializeValue(L[1],x))}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const L=D.split(">=");return w.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const L=D.split(">");return a.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const L=D.split("<=");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const L=D.split("<");return t.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(D)?g.create(D.substr(1).trim()):k.create(D)}static _deserializeValue(D,x){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;const L=/^'([^']*)'$/.exec(D);return L?L[1].trim():D}static _deserializeRegexValue(D,x){if((0,C.isFalsyOrWhitespace)(D)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const L=D.indexOf("/"),R=D.lastIndexOf("/");if(L===R||L<0){if(x)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}const K=D.slice(L+1,R),W=D[R+1]==="i"?"i":"";try{return new RegExp(K,W)}catch($){if(x)throw new Error(`bad regexp-value '${D}', parse error: ${$}`);return console.warn(`bad regexp-value '${D}', parse error: ${$}`),null}}}e.ContextKeyExpr=E;function P(U,D){const x=U?U.substituteConstants():void 0,L=D?D.substituteConstants():void 0;return!x&&!L?!0:!x||!L?!1:x.equals(L)}e.expressionsAreEqualWithConstantSubstitution=P;function O(U,D){return U.cmp(D)}class b{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class k{static create(D,x=null){const L=M.get(D);return typeof L=="boolean"?L?m.INSTANCE:b.INSTANCE:new k(D,x)}constructor(D,x){this.key=D,this.negated=x,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:v(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=M.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:b.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class p{static create(D,x,L=null){if(typeof x=="boolean")return x?k.create(D,L):g.create(D,L);const R=M.get(D);return typeof R=="boolean"?x===(R?"true":"false")?m.INSTANCE:b.INSTANCE:new p(D,x,L)}constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=M.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?m.INSTANCE:b.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class l{static create(D,x){return new l(D,x)}constructor(D,x){this.key=D,this.valueKey=x,this.type=10,this.negated=null}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.valueKey),L=D.getValue(this.key);return Array.isArray(x)?x.includes(L):typeof L=="string"&&typeof x=="object"&&x!==null?y.call(x,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=u.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=l;class u{static create(D,x){return new u(D,x)}constructor(D,x){this.key=D,this.valueKey=x,this.type=11,this._negated=l.create(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:this._negated.cmp(D._negated)}equals(D){return D.type===this.type?this._negated.equals(D._negated):!1}substituteConstants(){return this}evaluate(D){return!this._negated.evaluate(D)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(D){return D.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=u;class d{static create(D,x,L=null){if(typeof x=="boolean")return x?g.create(D,L):k.create(D,L);const R=M.get(D);return typeof R=="boolean"?x===(R?"true":"false")?b.INSTANCE:m.INSTANCE:new d(D,x,L)}constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=M.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?b.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class g{static create(D,x=null){const L=M.get(D);return typeof L=="boolean"?L?b.INSTANCE:m.INSTANCE:new g(D,x)}constructor(D,x){this.key=D,this.negated=x,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:v(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=M.get(this.key);return typeof D=="boolean"?D?b.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function _(U,D){if(typeof U=="string"){const x=parseFloat(U);isNaN(x)||(U=x)}return typeof U=="string"||typeof U=="number"?D(U):b.INSTANCE}class a{static create(D,x,L=null){return _(x,R=>new a(D,R,L))}constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class w{static create(D,x,L=null){return _(x,R=>new w(D,R,L))}constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=w;class t{static create(D,x,L=null){return _(x,R=>new t(D,R,L))}constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class c{static create(D,x,L=null){return _(x,R=>new c(D,R,L))}constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class i{static create(D,x){return new i(D,x)}constructor(D,x){this.key=D,this.regexp=x,this.type=7,this.negated=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const x=this.regexp?this.regexp.source:"",L=D.regexp?D.regexp.source:"";return x<L?-1:x>L?1:0}equals(D){if(D.type===this.type){const x=this.regexp?this.regexp.source:"",L=D.regexp?D.regexp.source:"";return this.key===D.key&&x===L}return!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{static create(D){return new n(D)}constructor(D){this._actual=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(U){let D=null;for(let x=0,L=U.length;x<L;x++){const R=U[x].substituteConstants();if(U[x]!==R&&D===null){D=[];for(let K=0;K<x;K++)D[K]=U[K]}D!==null&&(D[x]=R)}return D===null?U:D}class f{static create(D,x){return f._normalizeArr(D,x)}constructor(D,x){this.expr=D,this.negated=x,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,L=this.expr.length;x<L;x++){const R=O(this.expr[x],D.expr[x]);if(R!==0)return R}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:f.create(D,this.negated)}evaluate(D){for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].evaluate(D))return!1;return!0}static _normalizeArr(D,x){const L=[];let R=!1;for(const K of D)if(!!K){if(K.type===1){R=!0;continue}if(K.type===0)return b.INSTANCE;if(K.type===6){L.push(...K.expr);continue}L.push(K)}if(L.length===0&&R)return m.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(O);for(let K=1;K<L.length;K++)L[K-1].equals(L[K])&&(L.splice(K,1),K--);if(L.length===1)return L[0];for(;L.length>1;){const K=L[L.length-1];if(K.type!==9)break;L.pop();const W=L.pop(),$=L.length===0,G=s.create(K.expr.map(re=>f.create([re,W],null)),null,$);G&&(L.push(G),L.sort(O))}return L.length===1?L[0]:new f(L,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const x of this.expr)D.push(...x.keys());return D}map(D){return new f(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(const x of this.expr)D.push(x.negate());this.negated=s.create(D,this,!0)}return this.negated}}class s{static create(D,x,L){return s._normalizeArr(D,x,L)}constructor(D,x){this.expr=D,this.negated=x,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,L=this.expr.length;x<L;x++){const R=O(this.expr[x],D.expr[x]);if(R!==0)return R}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:s.create(D,this.negated,!1)}evaluate(D){for(let x=0,L=this.expr.length;x<L;x++)if(this.expr[x].evaluate(D))return!0;return!1}static _normalizeArr(D,x,L){let R=[],K=!1;if(D){for(let W=0,$=D.length;W<$;W++){const G=D[W];if(!!G){if(G.type===0){K=!0;continue}if(G.type===1)return m.INSTANCE;if(G.type===9){R=R.concat(G.expr);continue}R.push(G)}}if(R.length===0&&K)return b.INSTANCE;R.sort(O)}if(R.length!==0){if(R.length===1)return R[0];for(let W=1;W<R.length;W++)R[W-1].equals(R[W])&&(R.splice(W,1),W--);if(R.length===1)return R[0];if(L){for(let W=0;W<R.length;W++)for(let $=W+1;$<R.length;$++)N(R[W],R[$])&&(R.splice($,1),$--);if(R.length===1)return R[0]}return new s(R,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const x of this.expr)D.push(...x.keys());return D}map(D){return new s(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(const x of this.expr)D.push(x.negate());for(;D.length>1;){const x=D.shift(),L=D.shift(),R=[];for(const W of V(x))for(const $ of V(L))R.push(f.create([W,$],null));const K=D.length===0;D.unshift(s.create(R,null,K))}this.negated=D[0]}return this.negated}}class h extends k{static all(){return h._info.values()}constructor(D,x,L){super(D,null),this._defaultValue=x,typeof L=="object"?h._info.push({...L,key:D}):L!==!0&&h._info.push({key:D,description:L,type:x!=null?typeof x:void 0})}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return p.create(this.key,D)}notEqualsTo(D){return d.create(this.key,D)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(U,D){return U<D?-1:U>D?1:0}function T(U,D,x,L){return U<x?-1:U>x?1:D<L?-1:D>L?1:0}function N(U,D){if(D.type===6&&U.type!==9&&U.type!==6){for(const R of D.expr)if(U.equals(R))return!0}const x=U.negate(),L=V(x).concat(V(D));L.sort(O);for(let R=0;R<L.length;R++){const W=L[R].negate();for(let $=R+1;$<L.length;$++){const G=L[$];if(W.equals(G))return!0}}return!1}e.implies=N;function V(U){return U.type===9?U.expr:[U]}}),define(Ce[147],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[81],Ie([1,0,125,3]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function M(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function y(d,g){switch(d){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function A(d,g){return g==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function E(d,g,_){return A(g,_)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===_?!0:P(_).includes(d)}e.isTargetPlatformCompatible=E;function P(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function O(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=O;var b;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var m;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var k;(function(d){d.Install="install",d.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var p;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var l;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(l=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(g,_){super(g),this.code=_,this.name=_}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[35],Ie([1,0,24,19,9,10,2,127,3]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var O;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var b;(function(W){W[W.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var m;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function k(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=k;function p(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=p;function l(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=l;function u(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function d(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=d;function g(W){return k(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var _;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor($,G){super($),this.code=G}}e.FileSystemProviderError=a;function w(W,$){const G=new a(W.toString(),$);return c(G,$),G}e.createFileSystemProviderError=w;function t(W){return W||w((0,A.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=t;function c(W,$){return W.name=$?`${$} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=c;function i(W){if(!W)return _.Unknown;if(W instanceof a)return W.code;const $=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!$)return _.Unknown;switch($[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=i;function n(W){if(W instanceof T)return W.fileOperationResult;switch(i(W)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var o;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class f{constructor($,G,re){this.resource=$,this.operation=G,this.target=re}isOperation($){return this.operation===$}}e.FileOperationEvent=f;var s;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class h{constructor($,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const re=new Map;for(const ge of $){const oe=re.get(ge.type);switch(oe?oe.push([ge.resource,ge]):re.set(ge.type,[[ge.resource,ge]]),ge.type){case 1:this.rawAdded.push(ge.resource);break;case 0:this.rawUpdated.push(ge.resource);break;case 2:this.rawDeleted.push(ge.resource);break}}for(const[ge,oe]of re)switch(ge){case 1:this.added=r.TernarySearchTree.forUris(()=>G),this.added.fill(oe);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>G),this.updated.fill(oe);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>G),this.deleted.fill(oe);break}}contains($,...G){return this.doContains($,{includeChildren:!1},...G)}affects($,...G){return this.doContains($,{includeChildren:!0},...G)}doContains($,G,...re){if(!$)return!1;const ge=re.length>0;return!!((!ge||re.includes(1))&&(this.added?.get($)||G.includeChildren&&this.added?.findSuperstr($))||(!ge||re.includes(0))&&(this.updated?.get($)||G.includeChildren&&this.updated?.findSuperstr($))||(!ge||re.includes(2))&&(this.deleted?.findSubstr($)||G.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function v(W,$,G){return!W||!$||W===$||$.length>W.length?!1:($.charAt($.length-1)!==C.sep&&($+=C.sep),G?(0,S.startsWithIgnoreCase)(W,$):W.indexOf($)===0)}e.isParent=v;class T extends Error{constructor($,G,re){super($),this.fileOperationResult=G,this.options=re}}e.FileOperationError=T;class N extends T{constructor($,G,re){super($,2,re),this.stat=G}}e.NotModifiedSinceFileOperationError=N;var V;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=D;async function x(W,$){if(!$.hasProvider(y.URI.from({scheme:W.scheme})))return new Promise(G=>{const re=$.onDidChangeFileSystemProviderRegistrations(ge=>{ge.scheme===W.scheme&&ge.added&&(re.dispose(),G())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize($){return(0,M.isNumber)($)||($=0),$<L.KB?(0,A.localize)(1,null,$.toFixed(0)):$<L.MB?(0,A.localize)(2,null,($/L.KB).toFixed(2)):$<L.GB?(0,A.localize)(3,null,($/L.MB).toFixed(2)):$<L.TB?(0,A.localize)(4,null,($/L.GB).toFixed(2)):(0,A.localize)(5,null,($/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var R;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(R=e.Arch||(e.Arch={}));function K(W){return{maxFileSize:W===0?300*L.MB:16*L.GB,maxHeapSize:W===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=K}),define(Ce[58],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...S){this._entries=new Map;for(const[M,y]of S)this.set(M,y)}set(S,M){const y=this._entries.get(S);return this._entries.set(S,M),y}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=r}),define(Ce[148],Ie([1,0,15,12,7,80,146,3,58,149]),function(ie,e,r,C,S,M,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class b extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class m{constructor(u=new E.ServiceCollection,d=!1,g,_=O){this._services=u,this._strict=d,this._parent=g,this._enableTracing=_,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=_?g?._globalGraph??new y.Graph(a=>a):void 0}createChild(u){return new m(u,this._strict,this,this._enableTracing)}invokeFunction(u,...d){const g=p.traceInvocation(this._enableTracing,u);let _=!1;try{return u({get:w=>{if(_)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(w,g);if(!t)throw new Error(`[invokeFunction] unknown service '${w}'`);return t}},...d)}finally{_=!0,g.stop()}}createInstance(u,...d){let g,_;return u instanceof M.SyncDescriptor?(g=p.traceCreation(this._enableTracing,u.ctor),_=this._createInstance(u.ctor,u.staticArguments.concat(d),g)):(g=p.traceCreation(this._enableTracing,u),_=this._createInstance(u,d,g)),g.stop(),_}_createInstance(u,d=[],g){const _=A._util.getServiceDependencies(u).sort((t,c)=>t.index-c.index),a=[];for(const t of _){const c=this._getOrCreateServiceInstance(t.id,g);c||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(c)}const w=_.length>0?_[0].index:d.length;if(d.length!==w){console.trace(`[createInstance] First service dependency of ${u.name} at position ${w+1} conflicts with ${d.length} static arguments`);const t=w-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,w)}return Reflect.construct(u,d.concat(a))}_setServiceInstance(u,d){if(this._services.get(u)instanceof M.SyncDescriptor)this._services.set(u,d);else if(this._parent)this._parent._setServiceInstance(u,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const d=this._services.get(u);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):d}_getOrCreateServiceInstance(u,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(u));const g=this._getServiceInstanceOrDescriptor(u);return g instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,g,d.branch(u,!0)):(d.branch(u,!1),g)}_safeCreateAndCacheServiceInstance(u,d,g){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,d,g)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,d,g){const _=new y.Graph(t=>t.id.toString());let a=0;const w=[{id:u,desc:d,_trace:g}];for(;w.length;){const t=w.pop();if(_.lookupOrInsertNode(t),a++>1e3)throw new b(_);for(const c of A._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(c.id);if(i||this._throwIfStrict(`[createInstance] ${u} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),i instanceof M.SyncDescriptor){const n={id:c.id,desc:i,_trace:t._trace.branch(c.id,!0)};_.insertEdge(t,n),w.push(n)}}}for(;;){const t=_.roots();if(t.length===0){if(!_.isEmpty())throw new b(_);break}for(const{data:c}of t){if(this._getServiceInstanceOrDescriptor(c.id)instanceof M.SyncDescriptor){const n=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,n)}_.removeNode(c)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,d,g=[],_,a){if(this._services.get(u)instanceof M.SyncDescriptor)return this._createServiceInstance(u,d,g,_,a);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,d,g,_,a);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(u,d,g=[],_,a){if(_){const w=new m(void 0,this._strict,this,this._enableTracing);w._globalGraphImplicitDependency=String(u);const t=new Map,c=new r.IdleValue(()=>{const i=w._createInstance(d,g,a);for(const[n,o]of t){const f=i[n];if(typeof f=="function")for(const s of o)f.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!c.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let s=t.get(n);return s||(s=new P.LinkedList,t.set(n,s)),(v,T,N)=>{const V=s.push([v,T,N]);return(0,S.toDisposable)(V)}}if(n in i)return i[n];const o=c.value;let f=o[n];return typeof f!="function"||(f=f.bind(o),i[n]=f),f},set(i,n,o){return c.value[n]=o,!0}})}else return this._createInstance(d,g,a)}_throwIfStrict(u,d){if(d&&console.warn(u),this._strict)throw new Error(u)}}e.InstantiationService=m;var k;(function(l){l[l.Creation=0]="Creation",l[l.Invocation=1]="Invocation",l[l.Branch=2]="Branch"})(k||(k={}));class p{static traceInvocation(u,d){return u?new p(1,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(u,d){return u?new p(0,d.name):p._None}constructor(u,d){this.type=u,this.name=d,this._start=Date.now(),this._dep=[]}branch(u,d){const g=new p(2,u.toString());return this._dep.push([u,d,g]),g}stop(){const u=Date.now()-this._start;p._totals+=u;let d=!1;function g(a,w){const t=[],c=new Array(a+1).join("	");for(const[i,n,o]of w._dep)if(n&&o){d=!0,t.push(`${c}CREATES -> ${i}`);const f=g(a+1,o);f&&t.push(f)}else t.push(`${c}uses -> ${i}`);return t.join(`
`)}const _=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(u>2||d)&&p.all.add(_.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(Ce[14],Ie([1,0,44,5,7,21,3]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function A(){return new Date().toISOString()}var E;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function P(c,i,n){switch(i){case E.Trace:c.trace(n);break;case E.Debug:c.debug(n);break;case E.Info:c.info(n);break;case E.Warning:c.warn(n);break;case E.Error:c.error(n);break;case E.Critical:c.critical(n);break;default:throw new Error("Invalid log level")}}e.log=P;function O(c){let i="";for(let n=0;n<c.length;n++){let o=c[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}e.format=O;class b extends S.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class m extends b{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(E.Trace)&&this.log(E.Trace,O([i,...n]))}debug(i,...n){this.checkLogLevel(E.Debug)&&this.log(E.Debug,O([i,...n]))}info(i,...n){this.checkLogLevel(E.Info)&&this.log(E.Info,O([i,...n]))}warn(i,...n){this.checkLogLevel(E.Warning)&&this.log(E.Warning,O([i,...n]))}error(i,...n){if(this.checkLogLevel(E.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(E.Error,O(o))}else this.log(E.Error,O([i,...n]))}critical(i,...n){this.checkLogLevel(E.Critical)&&this.log(E.Critical,O([i,...n]))}flush(){}}e.AbstractMessageLogger=m;class k extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!M.isWindows}trace(i,...n){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}debug(i,...n){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}info(i,...n){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}warn(i,...n){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${A()}]\x1B[0m`,i,...n):console.warn(`[main ${A()}]`,i,...n))}error(i,...n){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}critical(i,...n){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class p extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...n){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=p;class l extends b{constructor(i,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,r.toErrorMessage)(i,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=l;class u extends b{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=u;class d extends S.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=d;class g extends S.Disposable{constructor(i,n){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(f=>f.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?E.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class _{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(i){}getLevel(){return E.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=_;function a(c){if(c.verbose)return E.Trace;if(typeof c.logLevel=="string"){const i=w(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function w(c){switch(c){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=w;function t(c){switch(c){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=t}),define(Ce[82],Ie([1,0,29,128,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var y;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function P(p,l){return l-p}E.compare=P;const O=Object.create(null);O[E.Error]=(0,C.localize)(0,null),O[E.Warning]=(0,C.localize)(1,null),O[E.Info]=(0,C.localize)(2,null);function b(p){return O[p]||""}E.toString=b;function m(p){switch(p){case r.default.Error:return E.Error;case r.default.Warning:return E.Warning;case r.default.Info:return E.Info;case r.default.Ignore:return E.Hint}}E.fromSeverity=m;function k(p){switch(p){case E.Error:return r.default.Error;case E.Warning:return r.default.Warning;case E.Info:return r.default.Info;case E.Hint:return r.default.Ignore}}E.toSeverity=k}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(E){const P="";function O(m){return b(m,!0)}E.makeKey=O;function b(m,k){const p=[P];return m.source?p.push(m.source.replace("\xA6","\\\xA6")):p.push(P),m.code?typeof m.code=="string"?p.push(m.code.replace("\xA6","\\\xA6")):p.push(m.code.value.replace("\xA6","\\\xA6")):p.push(P),m.severity!==void 0&&m.severity!==null?p.push(y.toString(m.severity)):p.push(P),m.message&&k?p.push(m.message.replace("\xA6","\\\xA6")):p.push(P),m.startLineNumber!==void 0&&m.startLineNumber!==null?p.push(m.startLineNumber.toString()):p.push(P),m.startColumn!==void 0&&m.startColumn!==null?p.push(m.startColumn.toString()):p.push(P),m.endLineNumber!==void 0&&m.endLineNumber!==null?p.push(m.endLineNumber.toString()):p.push(P),m.endColumn!==void 0&&m.endColumn!==null?p.push(m.endColumn.toString()):p.push(P),p.push(P),p.join("\xA6")}E.makeKeyOptionalMessage=b})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Ce[150],Ie([1,0,5,29,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,S.createDecorator)("notificationService");var M;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new E,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class E{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=E}),define(Ce[83],Ie([1,0,7,9,2,3]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,M.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function y(O,b){return S.URI.isUri(O)?(0,C.equalsIgnoreCase)(O.scheme,b):(0,C.startsWithIgnoreCase)(O,b+":")}e.matchesScheme=y;function A(O,...b){return b.some(m=>y(O,m))}e.matchesSomeScheme=A;function E(O,b){return O.with({fragment:`${b.startLineNumber},${b.startColumn}${b.endLineNumber?`-${b.endLineNumber}${b.endColumn?`,${b.endColumn}`:""}`:""}`})}e.withSelection=E;function P(O){let b;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return m&&(b={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},O=O.with({fragment:""})),{selection:b,uri:O}}e.extractSelection=P}),define(Ce[151],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(ie,e,r,C){var S=arguments.length,M=S<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,r):C,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ie,e,r,C);else for(var A=ie.length-1;A>=0;A--)(y=ie[A])&&(M=(S<3?y(M):S>3?y(e,r,M):y(e,r))||M);return S>3&&M&&Object.defineProperty(e,r,M),M},$e=this&&this.__param||function(ie,e){return function(r,C){e(r,C,ie)}};define(Ce[152],Ie([1,0,15,20,7,3]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var y;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(b){this.callback=b}report(b){this._value=b,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let E=class extends S.Disposable{constructor(b,m){super(),this.deferred=new r.DeferredPromise,m.withProgress(b,k=>(this.reporter=k,this.lastStep&&k.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};E=ze([$e(1,e.IProgressService)],E),e.UnmanagedProgress=E;class P extends S.Disposable{constructor(b){super(),this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(b){this.stop();const m=++this.currentOperationId,k=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>k.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:k.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ce[30],Ie([1,0,45,10]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(y,A){r.ok(C.isString(y)),r.ok(C.isObject(A)),r.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,A)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new S}),define(Ce[84],Ie([1,0,5,30]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,P){this.schemasById[S(E)]=P,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new M;C.Registry.add(e.Extensions.JSONContribution,y)}),define(Ce[85],Ie([1,0,18,5,10,124,57,84,30]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=E.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const i=this.doRegisterConfigurations(t,c);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const c=this.doDeregisterConfigurations(t);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:t,remove:c}){const i=[];i.push(...this.doDeregisterConfigurations(c)),i.push(...this.doRegisterConfigurations(t,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(i)})}registerDefaultConfigurations(t){const c=[],i=[];for(const{overrides:n,source:o}of t)for(const f in n)if(c.push(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const s=this.configurationDefaultsOverrides.get(f),h=s?.valuesSources??new Map;if(o)for(const V of Object.keys(n[f]))h.set(V,o);const v={...s?.value||{},...n[f]};this.configurationDefaultsOverrides.set(f,{source:o,value:v,valuesSources:h});const T=(0,y.getLanguageTagSettingPlainKey)(f),N={type:"object",default:v,description:M.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:S.isString(o)?void 0:o,defaultValueSource:o};i.push(...l(f)),this.configurationProperties[f]=N,this.defaultLanguageConfigurationOverridesNode.properties[f]=N}else{this.configurationDefaultsOverrides.set(f,{value:n[f],source:o});const s=this.configurationProperties[f];s&&(this.updatePropertyDefaultValue(f,s),this.updateSchema(f,s))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const c=[];for(const{overrides:i,source:n}of t)for(const o in i){const f=this.configurationDefaultsOverrides.get(o),s=S.isString(n)?n:n?.id,h=S.isString(f?.source)?f?.source:f?.source?.id;if(s===h)if(c.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const v=this.configurationProperties[o];v&&(this.updatePropertyDefaultValue(o,v),this.updateSchema(o,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const c of t)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,c){const i=[];return t.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,c,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(t){const c=[],i=n=>{if(n.properties)for(const o in n.properties){c.push(o);const f=this.configurationProperties[o];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of t){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return c}validateAndRegisterProperties(t,c=!0,i,n,o=3){o=S.isUndefinedOrNull(t.scope)?o:t.scope;const f=[],s=t.properties;if(s)for(const v in s){const T=s[v];if(c&&_(v,T)){delete s[v];continue}if(T.source=i,T.defaultDefaultValue=s[v].default,this.updatePropertyDefaultValue(v,T),e.OVERRIDE_PROPERTY_REGEX.test(v)?T.scope=void 0:(T.scope=S.isUndefinedOrNull(T.scope)?o:T.scope,T.restricted=S.isUndefinedOrNull(T.restricted)?!!n?.includes(v):T.restricted),s[v].hasOwnProperty("included")&&!s[v].included){this.excludedConfigurationProperties[v]=s[v],delete s[v];continue}else this.configurationProperties[v]=s[v],s[v].policy?.name&&this.policyConfigurations.set(s[v].policy.name,v);!s[v].deprecationMessage&&s[v].markdownDeprecationMessage&&(s[v].deprecationMessage=s[v].markdownDeprecationMessage),f.push(v)}const h=t.allOf;if(h)for(const v of h)f.push(...this.validateAndRegisterProperties(v,c,i,n,o));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const c=i=>{const n=i.properties;if(n)for(const f in n)this.updateSchema(f,n[f]);i.allOf?.forEach(c)};c(t)}updateSchema(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.resourceLanguageSettingsSchema.properties[t]=c;break}}removeFromSchema(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const c=`[${t}]`,i={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,c){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,o=i?.source;S.isUndefined(n)&&(n=c.defaultDefaultValue,o=void 0),S.isUndefined(n)&&(n=d(c.type)),c.default=n,c.defaultValueSource=o}}const k="\\[([^\\]]+)\\]",p=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(w){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let c=p.exec(w);for(;c?.length;){const i=c[1].trim();i&&t.push(i),c=p.exec(w)}}return(0,r.distinct)(t)}e.overrideIdentifiersFromKey=l;function u(w){return w.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=u;function d(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new m;E.Registry.add(e.Extensions.Configuration,g);function _(w,t){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?M.localize(7,null,w):g.getConfigurationProperties()[w]!==void 0?M.localize(8,null,w):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,w,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.validateProperty=_;function a(){const w=[],t=g.getConfigurationProperties();for(const c of Object.keys(t))w.push([c,t[c].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=a}),define(Ce[153],Ie([1,0,18,5,106,7,24,25,10,2,57,85,30]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class k{constructor(t={},c=[],i=[],n){this._contents=t,this._keys=c,this._overrides=i,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(c=>{if(c instanceof k)return c;const i=new p("");return i.parseRaw(c),i.configurationModel});this._rawConfiguration=t.reduce((c,i)=>i===c?i:c.merge(i),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(t){return t?(0,O.getConfigurationValue)(this.contents,t):this.contents}inspect(t,c){const i=this.rawConfiguration.getValue(t),n=c?this.rawConfiguration.getOverrideValue(t,c):void 0,o=c?this.rawConfiguration.override(c).getValue(t):i;return{value:i,override:n,merged:o}}getOverrideValue(t,c){const i=this.getContentsForOverrideIdentifer(c);return i?t?(0,O.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){const c=[];for(const i of this.overrides)i.identifiers.includes(t)&&c.push(...i.keys);return r.distinct(c)}getAllOverrideIdentifiers(){const t=[];for(const c of this.overrides)t.push(...c.identifiers);return r.distinct(t)}override(t){let c=this.overrideConfigurations.get(t);return c||(c=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,c)),c}merge(...t){const c=A.deepClone(this.contents),i=A.deepClone(this.overrides),n=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const f of t)if(o.push(...f.raw?.length?f.raw:[f]),!f.isEmpty()){this.mergeContents(c,f.contents);for(const s of f.overrides){const[h]=i.filter(v=>r.equals(v.identifiers,s.identifiers));h?(this.mergeContents(h.contents,s.contents),h.keys.push(...s.keys),h.keys=r.distinct(h.keys)):i.push(A.deepClone(s))}for(const s of f.keys)n.indexOf(s)===-1&&n.push(s)}return new k(c,n,i,o.every(f=>f instanceof k)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new k(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(t){const c=this.getContentsForOverrideIdentifer(t);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const i={};for(const n of r.distinct([...Object.keys(this.contents),...Object.keys(c)])){let o=this.contents[n];const f=c[n];f&&(typeof o=="object"&&typeof f=="object"?(o=A.deepClone(o),this.mergeContents(o,f)):o=f),i[n]=o}return new k(i,this.keys,this.overrides)}mergeContents(t,c){for(const i of Object.keys(c)){if(i in t&&E.isObject(t[i])&&E.isObject(c[i])){this.mergeContents(t[i],c[i]);continue}t[i]=A.deepClone(c[i])}}checkAndFreeze(t){return this.frozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let c=null,i=null;const n=o=>{o&&(i?this.mergeContents(i,o):i=A.deepClone(o))};for(const o of this.overrides)r.equals(o.identifiers,[t])?c=o.contents:o.identifiers.includes(t)&&n(o.contents);return n(c),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,c){this.addKey(t),(0,O.addToValueTree)(this.contents,t,c,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,O.removeFromValueTree)(this.contents,t)}addKey(t){let c=this.keys.length;for(let i=0;i<c;i++)t.indexOf(this.keys[i])===0&&(c=i);this.keys.splice(c,1,t)}removeKey(t){const c=this.keys.indexOf(t);return c!==-1?(this.keys.splice(c,1),!0):!1}}e.ConfigurationModel=k;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new k}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,c){if(!E.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,c)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,c){this._raw=t;const{contents:i,keys:n,overrides:o,restricted:f,hasExcludedProperties:s}=this.doParseRaw(t,c);this._configurationModel=new k(i,n,o,s?[t]:void 0),this._restrictedConfigurations=f||[]}doParseContent(t){let c={},i=null,n=[];const o=[],f=[];function s(v){Array.isArray(n)?n.push(v):i!==null&&(n[i]=v)}const h={onObjectBegin:()=>{const v={};s(v),o.push(n),n=v,i=null},onObjectProperty:v=>{i=v},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const v=[];s(v),o.push(n),n=v,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:s,onError:(v,T,N)=>{f.push({error:v,offset:T,length:N})}};if(t)try{S.visit(t,h),c=n[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return c}doParseRaw(t,c){const i=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,i,!0,c);t=n.raw;const o=(0,O.toValuesTree)(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),f=Object.keys(t),s=this.toOverrides(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:o,keys:f,overrides:s,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(t,c,i,n){let o=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:o};const f={},s=[];for(const h in t)if(b.OVERRIDE_PROPERTY_REGEX.test(h)&&i){const v=this.filter(t[h],c,!1,n);f[h]=v.raw,o=o||v.hasExcludedProperties,s.push(...v.restricted)}else{const v=c[h],T=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&s.push(h),(T===void 0||n.scopes===void 0||n.scopes.includes(T))&&!(n.skipRestricted&&v?.restricted)?f[h]=t[h]:o=!0}return{raw:f,restricted:s,hasExcludedProperties:o}}toOverrides(t,c){const i=[];for(const n of Object.keys(t))if(b.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const f in t[n])o[f]=t[n][f];i.push({identifiers:(0,b.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,O.toValuesTree)(o,c)})}return i}}e.ConfigurationModelParser=p;class l extends M.Disposable{constructor(t,c,i,n){super(),this.userSettingsResource=t,this.scopes=c,this.fileService=n,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&i.isEqual(o.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new k}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=l;class u{constructor(t,c,i,n,o=new k,f=new k,s=new y.ResourceMap,h=new k,v=new y.ResourceMap,T=!0){this._defaultConfiguration=t,this._policyConfiguration=c,this._applicationConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=f,this._folderConfigurations=s,this._memoryConfiguration=h,this._memoryConfigurationByResource=v,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(t,c,i){return this.getConsolidatedConfigurationModel(t,c,i).getValue(t)}updateValue(t,c,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new k,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,c===void 0?n.removeValue(t):n.setValue(t,c),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,c,i){const n=this.getConsolidatedConfigurationModel(t,c,i),o=this.getFolderConfigurationModelForResource(c.resource,i),f=c.resource?this._memoryConfigurationByResource.get(c.resource)||this._memoryConfiguration:this._memoryConfiguration,s=this._defaultConfiguration.inspect(t,c.overrideIdentifier),h=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(t),v=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(t),T=this.userConfiguration.freeze().inspect(t,c.overrideIdentifier),N=this.localUserConfiguration.freeze().inspect(t,c.overrideIdentifier),V=this.remoteUserConfiguration.freeze().inspect(t,c.overrideIdentifier),U=i?this._workspaceConfiguration.freeze().inspect(t,c.overrideIdentifier):void 0,D=o?o.freeze().inspect(t,c.overrideIdentifier):void 0,x=f.inspect(t,c.overrideIdentifier),L=n.getValue(t),R=r.distinct(n.overrides.map(K=>K.identifiers).flat()).filter(K=>n.getOverrideValue(t,K)!==void 0);return{defaultValue:s?s.merged:void 0,policyValue:h?h.merged:void 0,applicationValue:v?v.merged:void 0,userValue:T?T.merged:void 0,userLocalValue:N?N.merged:void 0,userRemoteValue:V?V.merged:void 0,workspaceValue:U?U.merged:void 0,workspaceFolderValue:D?D.merged:void 0,memoryValue:x?x.merged:void 0,value:L,default:s.value!==void 0||s.override!==void 0?{value:s.value,override:s.override}:void 0,policy:h?.value!==void 0?{value:h.value}:void 0,application:v?.value!==void 0||v?.override!==void 0?{value:v.value,override:v.override}:void 0,user:T.value!==void 0||T.override!==void 0?{value:T.value,override:T.override}:void 0,userLocal:N.value!==void 0||N.override!==void 0?{value:N.value,override:N.override}:void 0,userRemote:V.value!==void 0||V.override!==void 0?{value:V.value,override:V.override}:void 0,workspace:U?.value!==void 0||U?.override!==void 0?{value:U.value,override:U.override}:void 0,workspaceFolder:D?.value!==void 0||D?.override!==void 0?{value:D.value,override:D.override}:void 0,memory:x.value!==void 0||x.override!==void 0?{value:x.value,override:x.override}:void 0,overrideIdentifiers:R.length?R:void 0}}keys(t){const c=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:c?c.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,c){this._folderConfigurations.set(t,c),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,c){const i=[];if(!c){const{added:n,updated:o,removed:f}=_(this._defaultConfiguration,t);c=[...n,...o,...f]}for(const n of c)for(const o of(0,b.overrideIdentifiersFromKey)(n)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(o),s=t.getKeysForOverrideIdentifier(o),h=[...s.filter(v=>f.indexOf(v)===-1),...f.filter(v=>s.indexOf(v)===-1),...f.filter(v=>!A.equals(this._defaultConfiguration.override(o).getValue(v),t.override(o).getValue(v)))];i.push([o,h])}return this.updateDefaultConfiguration(t),{keys:c,overrides:i}}compareAndUpdatePolicyConfiguration(t){const{added:c,updated:i,removed:n}=_(this._policyConfiguration,t),o=[...c,...i,...n];return o.length&&this.updatePolicyConfiguration(t),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:c,updated:i,removed:n,overrides:o}=_(this.applicationConfiguration,t),f=[...c,...i,...n];return f.length&&this.updateApplicationConfiguration(t),{keys:f,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:c,updated:i,removed:n,overrides:o}=_(this.localUserConfiguration,t),f=[...c,...i,...n];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:c,updated:i,removed:n,overrides:o}=_(this.remoteUserConfiguration,t),f=[...c,...i,...n];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:c,updated:i,removed:n,overrides:o}=_(this.workspaceConfiguration,t),f=[...c,...i,...n];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:o}}compareAndUpdateFolderConfiguration(t,c){const i=this.folderConfigurations.get(t),{added:n,updated:o,removed:f,overrides:s}=_(i,c),h=[...n,...o,...f];return(h.length||!i)&&this.updateFolderConfiguration(t,c),{keys:h,overrides:s}}compareAndDeleteFolderConfiguration(t){const c=this.folderConfigurations.get(t);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:n,removed:o,overrides:f}=_(c,void 0);return{keys:[...i,...n,...o],overrides:f}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,c,i){let n=this.getConsolidatedConfigurationModelForResource(c,i);return c.overrideIdentifier&&(n=n.override(c.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:t},c){let i=this.getWorkspaceConsolidatedConfiguration();if(c&&t){const n=c.getFolder(t);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const o=this._memoryConfigurationByResource.get(t);o&&(i=i.merge(o))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let c=this._foldersConsolidatedConfigurations.get(t);if(!c){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(c=i.merge(n),this._freeze&&(c=c.freeze()),this._foldersConsolidatedConfigurations.set(t,c)):c=i}return c}getFolderConfigurationModelForResource(t,c){if(c&&t){const i=c.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,c)=>{const{contents:i,overrides:n,keys:o}=this._folderConfigurations.get(c);return t.push([c,{contents:i,overrides:n,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(c=>t.add(c)),this.userConfiguration.freeze().keys.forEach(c=>t.add(c)),this._workspaceConfiguration.freeze().keys.forEach(c=>t.add(c)),this._folderConfigurations.forEach(c=>c.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>t.add(c)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>t.add(c)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>t.add(c)),this._folderConfigurations.forEach(c=>c.freeze().getAllOverrideIdentifiers().forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const c=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>c.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>c.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>c.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(n=>c.add(n))),[...c.values()]}static parse(t){const c=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.policy),n=this.parseConfigurationModel(t.application),o=this.parseConfigurationModel(t.user),f=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((h,v)=>(h.set(P.URI.revive(v[0]),this.parseConfigurationModel(v[1])),h),new y.ResourceMap);return new u(c,i,n,o,new k,f,s,new k,new y.ResourceMap,!1)}static parseConfigurationModel(t){return new k(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=u;function d(...w){if(w.length===0)return{keys:[],overrides:[]};if(w.length===1)return w[0];const t=new Set,c=new Map;for(const n of w)n.keys.forEach(o=>t.add(o)),n.overrides.forEach(([o,f])=>{const s=(0,y.getOrSet)(c,o,new Set);f.forEach(h=>s.add(h))});const i=[];return c.forEach((n,o)=>i.push([o,[...n.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=d;class g{constructor(t,c,i,n){this.change=t,this.previous=c,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(s=>o.add(s)),t.overrides.forEach(([,s])=>s.forEach(h=>o.add(h))),this.affectedKeys=[...o.values()];const f=new k;this.affectedKeys.forEach(s=>f.setValue(s,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,c){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(c){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,c,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,c,this.currentWorkspace);return!A.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(t,c){let i=(0,O.toValuesTree)({[c]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(t=t[n],!t)return!1;i=i[n]}return!0}}e.ConfigurationChangeEvent=g;function _(w,t){const{added:c,removed:i,updated:n}=a(t,w),o=[],f=w?.getAllOverrideIdentifiers()||[],s=t?.getAllOverrideIdentifiers()||[];if(t){const h=s.filter(v=>!f.includes(v));for(const v of h)o.push([v,t.getKeysForOverrideIdentifier(v)])}if(w){const h=f.filter(v=>!s.includes(v));for(const v of h)o.push([v,w.getKeysForOverrideIdentifier(v)])}if(t&&w){for(const h of f)if(s.includes(h)){const v=a({contents:w.getOverrideValue(void 0,h)||{},keys:w.getKeysForOverrideIdentifier(h)},{contents:t.getOverrideValue(void 0,h)||{},keys:t.getKeysForOverrideIdentifier(h)});o.push([h,[...v.added,...v.removed,...v.updated]])}}return{added:c,removed:i,updated:n,overrides:o}}function a(w,t){const c=w?t?w.keys.filter(o=>t.keys.indexOf(o)===-1):[...w.keys]:[],i=t?w?t.keys.filter(o=>w.keys.indexOf(o)===-1):[...t.keys]:[],n=[];if(w&&t){for(const o of t.keys)if(w.keys.indexOf(o)!==-1){const f=(0,O.getConfigurationValue)(t.contents,o),s=(0,O.getConfigurationValue)(w.contents,o);A.equals(f,s)||n.push(o)}}return{added:c,removed:i,updated:n}}}),define(Ce[86],Ie([1,0,12,3]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var S;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends r.ErrorNoTelemetry{static isTemporarilyNotAvailable(A){return A instanceof M&&A._code===S.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof M&&A._code===S.NoResolverFound}static isHandled(A){return A instanceof M&&A.isHandled}constructor(A,E=S.Unknown,P){super(A),this._message=A,this._code=E,this._detail=P,this.isHandled=E===S.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(Ce[87],Ie([1,0,13]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(P){return P.scheme===r.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=C;function S(P){if(!P)return;const O=P.indexOf("+");return O<0?P:P.substr(0,O)}e.getRemoteName=S;function M(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=M;function y(P){const{host:O,port:b}=E(P);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:b}}e.parseAuthorityWithPort=y;function A(P,O){let{host:b,port:m}=E(P);return typeof m>"u"&&(m=O),{host:b,port:m}}e.parseAuthorityWithOptionalPort=A;function E(P){const O=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const b=P.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const m=P.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:P,port:void 0}}}),define(Ce[26],Ie([1,0,9,3,87]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=M;function y(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var E;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,u){if(typeof l>"u"||l===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof l=="string"||typeof u=="string"){const d=typeof l=="string"?l:l.value,g=typeof u=="string"?u:u.value;return r.equalsIgnoreCase(d,g)}return l._lower===u._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.ExtensionIdentifier=P;function O(p){return b(p)}e.isApplicationScopedExtension=O;function b(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function m(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function k(p,l){if(l){const u=`onResolveRemoteAuthority:${(0,S.getRemoteName)(l)}`;return p.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[154],Ie([1,0,9,81,26,21,2,12,59]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(c,i){return c.uuid&&i.uuid?c.uuid===i.uuid:c.id===i.id?!0:(0,r.compareIgnoreCase)(c.id,i.id)===0}e.areSameExtensions=P;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,n,o)}static parse(i){const n=O.exec(i);return n&&n[1]&&n[2]?new b({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(c){const i=m.exec(c);return i&&i[1]?[l(i[1]),i[2]]:[l(c),void 0]}e.getIdAndVersion=k;function p(c,i){return`${c}.${i}`}e.getExtensionId=p;function l(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=l;function u(c,i){return l(p(c,i))}e.getGalleryExtensionId=u;function d(c,i){const n=[],o=f=>{for(const s of n)if(s.some(h=>P(i(h),i(f))))return s;return null};for(const f of c){const s=o(f);s?s.push(f):n.push([f])}return n}e.groupByExtension=d;function g(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function _(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function a(c,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const f=o.shift();if(f&&n.every(s=>!P(s.identifier,{id:f}))){const s=c.filter(h=>P(h.identifier,{id:f}));s.length===1&&(n.push(s[0]),o.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=a;async function w(c,i){if(!M.isLinux)return!1;let n;try{n=(await c.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await c.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){i.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(f))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function t(c,i){const n=await w(c,i),o=(0,C.getTargetPlatform)(n?"alpine":M.platform,E.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=t}),define(Ce[155],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,M,y=5){const A=M(E=>{const P=typeof E=="string"?E:E.data;let O=this._terminalBufferMap.get(S);if(O){O.data.push(P);return}const b=setTimeout(()=>this.flushBuffer(S),y);O={data:[P],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(S),A.dispose()}},this._terminalBufferMap.set(S,O)});return A}stopBuffering(S){this._terminalBufferMap.get(S)?.dispose()}flushBuffer(S){const M=this._terminalBufferMap.get(S);M&&(this._terminalBufferMap.delete(S),this._callback(S,M.data.join("")))}}e.TerminalDataBufferer=r}),define(Ce[156],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var r;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(r=e.ColorScheme||(e.ColorScheme={}));function C(M){return M===r.HIGH_CONTRAST_DARK||M===r.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function S(M){return M===r.DARK||M===r.HIGH_CONTRAST_DARK}e.isDark=S}),define(Ce[60],Ie([1,0,117,5,7,3,30,156]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var E;(function(u){function d(g){return g&&typeof g=="object"&&typeof g.id=="string"}u.isThemeColor=d})(E=e.ThemeColor||(e.ThemeColor={}));function P(u){return{id:u}}e.themeColorFromId=P;var O;(function(u){function d(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||E.isThemeColor(n.color))}u.isThemeIcon=d;const g=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function _(n){const o=g.exec(n);if(!o)return;const[,f]=o;return{id:f}}u.fromString=_;function a(n){return{id:n}}u.fromId=a;function w(n,o){let f=n.id;const s=f.lastIndexOf("~");return s!==-1&&(f=f.substring(0,s)),o&&(f=`${f}~${o}`),{id:f}}u.modify=w;function t(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}u.getModifier=t;function c(n,o){return n.id===o.id&&n.color?.id===o.color?.id}u.isEqual=c;function i(n,o){return{id:n.id,color:o?P(o):void 0}}u.asThemeIcon=i,u.asClassNameArray=r.CSSIcon.asClassNameArray,u.asClassName=r.CSSIcon.asClassName,u.asCSSSelector=r.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function b(u){switch(u){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new C.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,S.toDisposable)(()=>{const g=this.themingParticipants.indexOf(d);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const k=new m;y.Registry.add(e.Extensions.ThemingContribution,k);function p(u){return k.onColorThemeChange(u)}e.registerThemingParticipant=p;class l extends S.Disposable{constructor(d){super(),this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,g){let _=this.theme.getColor(d);return _&&g&&(_=g(_,this.theme)),_?_.toString():null}}e.Themable=l}),define(Ce[157],Ie([1,0,5,21,3,14]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var y;(function(l){l.Http="http",l.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=b;function m(l,u){return u?u!==1&&l<1024:!C.isWindows&&l<1024}e.isPortPrivileged=m;class k{constructor(u,d,g){this.remoteAddress=u,this.localAddress=d,this._dispose=g,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=k;let p=class{constructor(u){this.logService=u,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(const g of d){const _=Array.from(g.values());for(const a of _){const w=await a.value;w&&u.push(w)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(g=>g?.dispose());u.clear()}this._tunnels.clear()}setEnvironmentTunnel(u,d,g,_,a){this.addTunnelToMap(u,d,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:d,localAddress:g,privacy:_,protocol:a,dispose:()=>Promise.resolve()}))}openTunnel(u,d,g,_,a=!1,w,t){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${_}.`),!u)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.retainOrCreateTunnel(u,d,g,_,a,w,t);return c?c.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==d||i.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const g=d.get(u.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,g))}}}}async tryDisposeTunnel(u,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const _=g.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),_}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const g=this._tunnels.get(u);if(g&&g.has(d)){const _=g.get(d);_.refcount=0,await this.tryDisposeTunnel(u,d,_)}}addTunnelToMap(u,d,g){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:g})}async removeEmptyTunnelFromMap(u,d){const g=this._tunnels.get(u);g&&(await g.get(d)||g.delete(d),g.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,d){const g=[u];O(u)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):b(u)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const _=g.map(a=>this._tunnels.get(a));for(const a of _){const w=a?.get(d);if(w)return w}}canTunnel(u){return!!P(u)}doIsPortPrivileged(u,d,g,_){if(d)return!1;if(g){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(_);if(a?.length===4){const w=parseInt(a[1]),t=parseInt(a[2]);if(w>10||w===10&&t>=14)return!1}}return u<1024}createWithProvider(u,d,g,_,a,w,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${_}.`);const c=g;this._factoryInProgress.add(c);const i=_===void 0?g:_,n={elevationRequired:a?this.isPortPrivileged(i):!1},o={remoteAddress:{host:d,port:g},localAddressPort:_,privacy:w,public:w?w!==A.Private:void 0,protocol:t},f=u.forwardPort(o,n);return f?(this.addTunnelToMap(d,g,f),f.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(c)})):this._factoryInProgress.delete(c),f}};p=ze([$e(0,M.ILogService)],p),e.AbstractTunnelService=p}),define(Ce[158],Ie([1,0,13]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(E){return E.scheme!==r.Schemas.file&&E.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=C;function S(E){if(E.folders.length)return E.folders.every(P=>C(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&C(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=S;function M(E){return S(E)?.scheme}e.getVirtualWorkspaceScheme=M;function y(E){return S(E)?.authority}e.getVirtualWorkspaceAuthority=y;function A(E){return S(E)!==void 0}e.isVirtualWorkspace=A}),define(Ce[46],Ie([1,0,129,19,24,22,2,3,13]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function P(c){const i=c;return typeof i?.id=="string"&&y.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(c,i){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,C.basename)(c)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=c;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=O;function b(c){const i=c;return typeof i?.id=="string"&&y.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function m(c){const i=c;if(i?.uri)return{id:i.id,uri:y.URI.revive(i.uri)};const n=c;if(n?.configPath)return{id:n.id,configPath:y.URI.revive(n.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=m;var k;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function p(c){const i=c;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=p;function l(c){const i=c;return!!(i&&typeof i=="object"&&y.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=l;class u{constructor(i,n,o,f,s){this._id=i,this._transient=o,this._configuration=f,this._ignorePathCasing=s,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class d{constructor(i,n){this.raw=n,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,M.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function g(c){return new d({uri:c,index:0,name:(0,M.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(c,i){return M.extUriBiasedIgnorePathCase.isEqualOrParent(c,i.untitledWorkspacesHome)}e.isUntitledWorkspace=_;function a(c){let i;return y.URI.isUri(c)?i=c:i=c.configuration,i?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=a;function w(c,i){return!_(c,i)&&!a(c)}e.isSavedWorkspace=w;function t(c){return(typeof c=="string"?(0,C.extname)(c):(0,M.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Ce[61],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const M=this._idPool++;return this._data.set(M,S),this.logDebugInfo(),M}get(S,M){return this._data.has(S)?this._data.get(S)[M]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(Ce[36],Ie([1,0,13,22,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new C.ExtUri(A=>{const E=this._providerInfo.get(A.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(A,E){E===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,E)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ce[159],Ie([1,0,15]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(y,A,E){this._deferredPromises=new Map,this._id=y,this._shared=A,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of P.values())O.complete()}catch(O){for(const b of P.values())b.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,A){let E=this._value[y];return typeof E>"u"&&(E=A),E}update(y,A){this._value[y]=A;const E=this._deferredPromises.get(y);if(E!==void 0)return E.p;const P=new r.DeferredPromise;return this._deferredPromises.set(y,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=C;class S extends C{setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}constructor(y,A){super(y.identifier.value,!0,A),this._extension=y}}e.ExtensionGlobalMemento=S}),define(Ce[160],Ie([1,0,5,2]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new r.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,A,E,P){const b=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(y)).acceptModelChanged(A.value,E,P);this._onDidChangeNotebookDocument.fire(b)}$acceptDirtyStateChanged(y,A){this._notebooksAndEditors.getNotebookDocument(C.URI.revive(y)).acceptDirty(A)}$acceptModelSaved(y){const A=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(y));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(Ce[11],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class C{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[161],Ie([1,0,26,5]),function(ie,e,r,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,E){S.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(A.identifier),Je(this,S,E,"f"),Oe(this,S,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(A){return Oe(this,S,"f").get(this._id,A)}store(A,E){return Oe(this,S,"f").store(this._id,A,E)}delete(A){return Oe(this,S,"f").delete(this._id,A)}}e.ExtensionSecrets=M,S=new WeakMap}),define(Ce[88],Ie([1,0,3,5]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new C.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new C.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(y,A){this._level=y,this._productConfig=A||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(y){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=y,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ce[62],Ie([1,0,3,157,5,11]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(E){function P(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:b.protocol}}E.fromApiTunnel=P;function O(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==C.TunnelPrivacyId.ConstantPrivate&&b.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}E.fromServiceTunnel=O})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let A=class{constructor(P){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,O){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,O){return{dispose:()=>{}}}async $providePortAttributes(P,O,b,m,k){return[]}async $forwardPort(P,O){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=ze([$e(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ce[47],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class C{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=C}),define(Ce[162],Ie([1,0,23]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(E){let P=this.buffers.indexOf(E);return P<0&&(P=this.buffers.length,this.buffers.push(E)),P}}function S(A,E){if(E.serializeBuffersForPostMessage){const P=new C,O=(k,p)=>{if(p instanceof ArrayBuffer){const l=P.add(p);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(p)){const l=M(p);if(l){const u=P.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:u,view:{type:l,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},b=JSON.stringify(A,O),m=P.buffers.map(k=>{const p=new Uint8Array(k);return r.VSBuffer.wrap(p)});return{message:b,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=S;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(A,E){const P=E.map(m=>{const k=new ArrayBuffer(m.byteLength);return new Uint8Array(k).set(m.buffer),k}),O=E.length?(m,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const p=k,{index:l}=p,u=P[l];if(p.view)switch(p.view.type){case 1:return new Int8Array(u,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return k}:void 0;return{message:JSON.parse(A,O),arrayBuffers:P}}e.deserializeWebviewMessage=y}),define(Ce[89],Ie([1,0,137,10,2,7,3,30,35,13]),function(ie,e,r,C,S,M,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var O;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(O=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var b;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(b=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(G){const re=G;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}e.isEditorPaneWithSelection=m;function k(G,re,ge){for(const oe of ge.visibleEditorPanes)if(oe.group.id===re&&G.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=k;function p(G){if(o(G))return!1;const re=G;return S.URI.isUri(re?.resource)}e.isResourceEditorInput=p;function l(G){if(o(G))return!1;const re=G;return re?.original!==void 0&&re.modified!==void 0}e.isResourceDiffEditorInput=l;function u(G){if(o(G)||l(G))return!1;const re=G;return re?.primary!==void 0&&re.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function d(G){if(o(G))return!1;const re=G;return re?re.resource===void 0||re.resource.scheme===P.Schemas.untitled||re.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;const g=/Untitled-\d+/;function _(G){return G.scheme===P.Schemas.untitled&&G.path.length>1&&!g.test(G.path)}e.isUntitledWithAssociatedResource=_;function a(G){if(o(G))return!1;const re=G;return S.URI.isUri(re?.base?.resource)&&S.URI.isUri(re?.input1?.resource)&&S.URI.isUri(re?.input2?.resource)&&S.URI.isUri(re?.result?.resource)}e.isResourceMergeEditorInput=a;var w;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var t;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(t=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource(re,ge){let oe=this.mapIdToSaveSource.get(re);return oe||(oe={source:re,label:ge},this.mapIdToSaveSource.set(re,oe)),oe.source}getSourceLabel(re){return this.mapIdToSaveSource.get(re)?.label??re}}e.SaveSourceRegistry=new c;var i;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(i=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends M.Disposable{}e.AbstractEditorInput=n;function o(G){return G instanceof n}e.isEditorInput=o;function f(G){const re=G;return S.URI.isUri(re?.preferredResource)}function s(G){const re=G;return o(re?.primary)&&o(re?.secondary)}e.isSideBySideEditorInput=s;function h(G){const re=G;return o(re?.modified)&&o(re?.original)}e.isDiffEditorInput=h;function v(G){return o(G?.editor)}e.isEditorInputWithOptions=v;function T(G){const re=G;return v(G)&&re?.group!==void 0}e.isEditorInputWithOptionsAndGroup=T;function N(G){const re=G;return typeof re?.groupId=="number"&&o(re.editor)}e.isEditorIdentifier=N;var V;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(V=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var D;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(D=e.SideBySideEditor||(e.SideBySideEditor={}));class x{getOriginalUri(re,ge){if(!re)return;if(a(re))return e.EditorResourceAccessor.getOriginalUri(re.result,ge);if(ge?.supportSideBySide){const{primary:Ee,secondary:ce}=this.getSideEditors(re);if(Ee&&ce){if(ge?.supportSideBySide===D.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:ge.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===D.ANY)return this.getOriginalUri(Ee,{filterByScheme:ge.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:ge.filterByScheme});re=ge.supportSideBySide===D.PRIMARY?Ee:ce}}if(l(re)||u(re)||a(re))return;const oe=f(re)?re.preferredResource:re.resource;return!oe||!ge||!ge.filterByScheme?oe:this.filterUri(oe,ge.filterByScheme)}getSideEditors(re){return s(re)||u(re)?{primary:re.primary,secondary:re.secondary}:h(re)||l(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,ge){if(!re)return;if(a(re))return e.EditorResourceAccessor.getCanonicalUri(re.result,ge);if(ge?.supportSideBySide){const{primary:Ee,secondary:ce}=this.getSideEditors(re);if(Ee&&ce){if(ge?.supportSideBySide===D.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:ge.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===D.ANY)return this.getCanonicalUri(Ee,{filterByScheme:ge.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:ge.filterByScheme});re=ge.supportSideBySide===D.PRIMARY?Ee:ce}}if(l(re)||u(re)||a(re))return;const oe=re.resource;return!oe||!ge||!ge.filterByScheme?oe:this.filterUri(oe,ge.filterByScheme)}filterUri(re,ge){if(Array.isArray(ge)){if(ge.some(oe=>re.scheme===oe))return re}else if(ge===re.scheme)return re}}e.EditorResourceAccessor=new x;var L;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(re){const ge=this.instantiationService=re.get(y.IInstantiationService);for(const[oe,Ee]of this.editorSerializerConstructors)this.createEditorSerializer(oe,Ee,ge);this.editorSerializerConstructors.clear()}createEditorSerializer(re,ge,oe){const Ee=oe.createInstance(ge);this.editorSerializerInstances.set(re,Ee)}registerFileEditorFactory(re){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=re}getFileEditorFactory(){return(0,C.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(re,ge){if(this.editorSerializerConstructors.has(re)||this.editorSerializerInstances.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.instantiationService?this.createEditorSerializer(re,ge,this.instantiationService):this.editorSerializerConstructors.set(re,ge),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(re),this.editorSerializerInstances.delete(re)})}getEditorSerializer(re){return this.editorSerializerInstances.get(typeof re=="string"?re:re.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new R);async function K(G,re){return!G||!G.length?[]:await Promise.all(G.map(async ge=>{const oe=S.URI.revive(ge.fileUri);if(!oe||!await re.canHandleResource(oe))return;let ce=ge.exists,me=ge.type;if(typeof ce!="boolean"||typeof me!="number")try{me=(await re.stat(oe)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ce=!0}catch{ce=!1}if(!ce&&ge.openOnlyIfExists||me===E.FileType.Directory)return;const ee={...ge.options,pinned:!0};return ce?{resource:oe,options:ee}:{resource:oe,options:ee,forceUntitled:!0}}))}e.pathsToEditors=K;var W;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}));function $(G){const re=G;if(!re)return!1;const ge=re;if(ge.modified)return $(ge.modified);const oe=re;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=$}),define(Ce[63],Ie([1,0,13,2]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(A,E){return A.scheme===r.Schemas.http||A.scheme===r.Schemas.https?A:(E&&E.authority&&E.isRemote&&A.scheme===r.Schemas.file&&(A=C.URI.from({scheme:r.Schemas.vscodeRemote,authority:E.authority,path:A.path})),C.URI.from({scheme:r.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=S;function M(A){return A.replace(/./g,E=>{const P=E.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?E:"-"+P.toString(16).padStart(4,"0")})}function y(A){return A.replace(/-([0-9a-f]{4})/g,(E,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=y}),define(Ce[163],Ie([1,0,5,7,63]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,E,P){this._proxy=A,this._editors=E,this._remoteInfo=P,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const O=E.getVisibleTextEditors();for(const b of this._insets.values())O.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,E,P,O,b){let m;for(const _ of this._editors.getVisibleTextEditors(!0))if(_.value===A){m=_;break}if(!m)throw new Error("not a visible editor");const k=this,p=this._handlePool++,l=new r.Emitter,u=new r.Emitter,d=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(_){return(0,S.asWebviewUri)(_,k._remoteInfo)}get cspSource(){return S.webviewGenericCspSource}set options(_){this._options=_,k._proxy.$setOptions(p,_)}get options(){return this._options}set html(_){this._html=_,k._proxy.$setHtml(p,_)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(_){return k._proxy.$postMessage(p,_)}},g=new class{constructor(){this.editor=A,this.line=E,this.height=P,this.webview=d,this.onDidDispose=u.event}dispose(){k._insets.has(p)&&(k._insets.delete(p),k._proxy.$disposeEditorInset(p),u.fire(),u.dispose(),l.dispose())}};return this._proxy.$createEditorInset(p,m.id,m.value.document.uri,E+1,P,O||{},b.identifier,b.extensionLocation),this._insets.set(p,{editor:A,inset:g,onDidReceiveMessage:l}),g}$onDidDispose(A){const E=this._insets.get(A);E&&E.inset.dispose()}$onDidReceiveMessage(A,E){this._insets.get(A)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=M}),define(Ce[164],Ie([1,0,5,15,138]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,E,P,O){const b={command:A};if(E&&Object.keys(E).length>0&&(b.arguments=E),this.internalSend("request",b),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const k=this.pendingRequests.get(b.seq);if(k){this.pendingRequests.delete(b.seq);const p={type:"response",seq:0,request_seq:b.seq,success:!1,command:A,message:(0,S.localize)(0,null,O,A)};k(p)}},O)}return P&&this.pendingRequests.set(b.seq,P),b.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,E){return A.type!=="event"||E.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,C.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const E=A,P=this.pendingRequests.get(E.request_seq);P&&(this.pendingRequests.delete(E.request_seq),P(E));break}}}}internalSend(A,E){E.type=A,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((E,P)=>A.set(P,E)),await(0,C.timeout)(500),A.forEach((E,P)=>{E({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(Ce[165],Ie([1,0,139,39,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new C.RawContextKey("breakpointAccessType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(50,null)});const M=m=>r.localize(51,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(52,null)};var y;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(y=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var E;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,S.createDecorator)(e.DEBUG_SERVICE_ID);var b;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(b=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[166],Ie([1,0,9,2,19,25,13]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function E(i,n,o){return i.replace(A,function(f,s){return n&&s.length>0&&s[0]!=="_"?f:o&&o.hasOwnProperty(s)?o[s]:f})}e.formatPII=E;function P(i){const n={};for(const o of Object.keys(i))o.startsWith("!")||(n[o]=i[o]);return n}e.filterExceptionsFromTelemetry=P;function O(i){return i.configuration.request==="attach"&&!b(i)&&(!i.parentSession||O(i.parentSession))}e.isSessionAttach=O;function b(i){let n=i.configuration.type;if(!!n)return n==="vslsShare"&&(n=i.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(n,"extensionhost")||(0,r.equalsIgnoreCase)(n,"pwa-extensionhost")?i:i.parentSession?b(i.parentSession):void 0}e.getExtensionHostDebugSession=b;function m(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=m;function k(i,n,o){let f,s=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=h.exec(i);){const T=v.index+1,N=T+v[0].length;if(T<=n&&N>=o){f=v[0],s=T;break}}if(f){const T=/\w+/g;let N=null;for(;(N=T.exec(f))&&!(N.index+1+s+N[0].length>=o););N&&(f=f.substring(0,T.lastIndex))}return f?{start:s,end:s+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=k;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(i){return!!(i&&i.match(p))}e.isUri=l;function u(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(l(i.path))return C.URI.parse(i.path);if((0,S.isAbsolute)(i.path))return C.URI.file(i.path)}return i.path}function d(i){if(typeof i.path=="object"){const n=C.URI.revive(i.path);if(n)return n.scheme===y.Schemas.file?n.fsPath:n.toString()}return i.path}function g(i,n){const o=n?u:d,f=(0,M.deepClone)(i);return a(f,(s,h)=>{s&&h&&(h.path=o(h))}),f}e.convertToDAPaths=g;function _(i,n){const o=n?u:d,f=(0,M.deepClone)(i);return a(f,(s,h)=>{!s&&h&&(h.path=o(h))}),f}e.convertToVSCPaths=_;function a(i,n){switch(i.type){case"event":{const o=i;switch(o.event){case"output":n(!1,o.body.source);break;case"loadedSource":n(!1,o.body.source);break;case"breakpoint":n(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=i;switch(o.command){case"setBreakpoints":n(!0,o.arguments.source);break;case"breakpointLocations":n(!0,o.arguments.source);break;case"source":n(!0,o.arguments.source);break;case"gotoTargets":n(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(f=>n(!1,f));break;default:break}break}case"response":{const o=i;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(f=>n(!1,f.source));break;case"loadedSources":o.body.sources.forEach(f=>n(!1,f));break;case"scopes":o.body.scopes.forEach(f=>n(!1,f.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(f=>n(!1,f.source));break;case"setBreakpoints":o.body.breakpoints.forEach(f=>n(!1,f.source));break;case"disassemble":o.body?.instructions.forEach(s=>n(!1,s.location));break;default:break}break}}}function w(i){return i.filter(n=>!n.presentation?.hidden).sort((n,o)=>n.presentation?o.presentation?n.presentation.group?o.presentation.group?n.presentation.group!==o.presentation.group?n.presentation.group.localeCompare(o.presentation.group):t(n.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(n.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=w;function t(i,n){return typeof i!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:i-n}async function c(i,n){const o=i.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(o!=="none"&&(await n.saveAll(),o==="allEditorsInActiveGroup")){const f=n.activeEditorPane;f&&f.input.resource?.scheme===y.Schemas.untitled&&await n.save({editor:f.input,groupId:f.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=c}),define(Ce[64],Ie([1,0,23,34,167,75,13,19,21,39]),function(ie,e,r,C,S,M,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var O;(function(s){s[s.Markup=1]="Markup",s[s.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var b;(function(s){s[s.Running=1]="Running",s[s.Idle=2]="Idle"})(b=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(s){s[s.Unconfirmed=1]="Unconfirmed",s[s.Pending=2]="Pending",s[s.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(s){s[s.WithHardKernelDependency=0]="WithHardKernelDependency",s[s.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",s[s.Pure=2]="Pure",s[s.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(s){s.Always="always",s.Never="never",s.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(s){s[s.ModelChange=1]="ModelChange",s[s.Move=2]="Move",s[s.ChangeCellLanguage=5]="ChangeCellLanguage",s[s.Initialize=6]="Initialize",s[s.ChangeCellMetadata=7]="ChangeCellMetadata",s[s.Output=8]="Output",s[s.OutputItem=9]="OutputItem",s[s.ChangeCellContent=10]="ChangeCellContent",s[s.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",s[s.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",s[s.ChangeCellMime=13]="ChangeCellMime",s[s.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(s){s[s.Handle=0]="Handle",s[s.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(s){s[s.Replace=1]="Replace",s[s.Output=2]="Output",s[s.Metadata=3]="Metadata",s[s.CellLanguage=4]="CellLanguage",s[s.DocumentMetadata=5]="DocumentMetadata",s[s.Move=6]="Move",s[s.OutputItems=7]="OutputItems",s[s.PartialMetadata=8]="PartialMetadata",s[s.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var g;(function(s){s.scheme=y.Schemas.vscodeNotebookCell;const h=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${h.join("")}]+`),T=7;function N(R,K){const W=K.toString(T),G=`${W.length<h.length?h[W.length-1]:"z"}${W}s${(0,r.encodeBase64)(r.VSBuffer.fromString(R.scheme),!0,!0)}`;return R.with({scheme:s.scheme,fragment:G})}s.generate=N;function V(R){if(R.scheme!==s.scheme)return;const K=R.fragment.indexOf("s");if(K<0)return;const W=parseInt(R.fragment.substring(0,K).replace(v,""),T),$=(0,r.decodeBase64)(R.fragment.substring(K+1)).toString();if(!isNaN(W))return{handle:W,notebook:R.with({scheme:$,fragment:null})}}s.parse=V;function U(R,K){return R.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${R.scheme!==y.Schemas.file?R.scheme:""}`})}s.generateCellOutputUri=U;function D(R){if(R.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!K)return;const W=K[1]&&K[1]!==""?K[1]:void 0,$=K[2];return{outputId:W,notebook:R.with({scheme:$||y.Schemas.file,fragment:null})}}s.parseCellOutputUri=D;function x(R,K,W){return s.generate(R,K).with({scheme:W})}s.generateCellPropertyUri=x;function L(R,K){if(R.scheme===K)return s.parse(R.with({scheme:s.scheme}))}s.parseCellPropertyUri=L})(g=e.CellUri||(e.CellUri={}));const _=s=>E.isWindows?s.replace(/\//g,"\\"):s;class a{constructor(h=[],v=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=v,this.order=[...new Set(h)].map(T=>({pattern:T,matches:C.parse(_(T))}))}sort(h){const v=new Map(S.Iterable.map(h,N=>[N,_(N)]));let T=[];for(const{matches:N}of this.order)for(const[V,U]of v)if(N(U)){T.push(V),v.delete(V);break}return v.size&&(T=T.concat([...v.keys()].sort((N,V)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(V)))),T}prioritize(h,v){const T=this.findIndex(h);if(T===-1){this.order.unshift({pattern:h,matches:C.parse(_(h))});return}const N=new Set(v.map(U=>this.findIndex(U,T)));N.delete(-1);const V=Array.from(N).sort();this.order.splice(T+1,0,...V.map(U=>this.order[U]));for(let U=V.length-1;U>=0;U--)this.order.splice(V[U],1)}toArray(){return this.order.map(h=>h.pattern)}findIndex(h,v=this.order.length){const T=_(h);for(let N=0;N<v;N++)if(this.order[N].matches(T))return N;return-1}}e.MimeTypeDisplayOrder=a;function w(s,h,v,T=(N,V)=>N===V){const N=[];function V(x,L,R){if(L===0&&R.length===0)return;const K=N[N.length-1];K&&K.start+K.deleteCount===x?(K.deleteCount+=L,K.toInsert.push(...R)):N.push({start:x,deleteCount:L,toInsert:R})}let U=0,D=0;for(;;){if(U===s.length){V(U,0,h.slice(D));break}if(D===h.length){V(U,s.length-U,[]);break}const x=s[U],L=h[D];if(T(x,L)){U+=1,D+=1;continue}v(L)?(V(U,1,[]),U+=1):(V(U,0,[L]),D+=1)}return N}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(s){s.default="default",s.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(s){const h=s;return!!((typeof h.include=="string"||C.isRelativePattern(h.include))&&(typeof h.exclude=="string"||C.isRelativePattern(h.exclude)))}e.isDocumentExcludePattern=c;function i(s,h,v){if(Array.isArray(s.viewType)&&s.viewType.indexOf(h)>=0||s.viewType===h)return!0;if(s.filenamePattern){const T=c(s.filenamePattern)?s.filenamePattern.include:s.filenamePattern,N=c(s.filenamePattern)?s.filenamePattern.exclude:void 0;if(C.match(T,(0,A.basename)(v.fsPath).toLowerCase()))return!(N&&C.match(N,(0,A.basename)(v.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var n;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(h){return`${o._prefix}${h}`}static parse(h){if(h.startsWith(o._prefix))return h.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/";function f(s){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(s)}e.isTextStreamMime=f}),define(Ce[168],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ce[169],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=r;function C(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=C;function S(y){return Array.from(y.entries()).map(A=>[A[0],r(A[1].map)])}e.serializeEnvironmentVariableCollections=S;function M(y){return new Map(y.map(A=>[A[0],{map:C(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ce[40],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(M){M.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class S{static fromExtHostTestItem(y,A,E=y.parent){if(y._isRoot)return new S([A]);const P=[y.id];for(let O=E;O&&O.id!==A;O=O.parent)P.push(O.id);return P.push(A),new S(P.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const A=y.indexOf("\0");return A===-1?y:y.slice(0,A)}static fromString(y){return new S(y.split("\0"))}static join(y,A){return new S([...y.path,A])}static joinToString(y,A){return y.toString()+"\0"+A}static parentId(y){const A=y.lastIndexOf("\0");return A===-1?void 0:y.slice(0,A)}static compare(y,A){return y===A?0:A.startsWith(y+"\0")?2:y.startsWith(A+"\0")?3:1}constructor(y,A=y.length){if(this.path=y,this.viewEnd=A,y.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new S(this.path,y)}*idsToRoot(){for(let y=this.viewEnd;y>0;y--)yield new S(this.path,y)}compare(y){if(typeof y=="string")return S.compare(this.toString(),y);for(let A=0;A<y.viewEnd&&A<this.viewEnd;A++)if(y.path[A]!==this.path[A])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=S}),define(Ce[48],Ie([1,0,2,49,40]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var y;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(y=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(s){s.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),s.deserialize=h=>({range:C.Range.lift(h.range),uri:r.URI.revive(h.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var E;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(E=e.TestMessageType||(e.TestMessageType={}));var P;(function(s){s.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.serialize(h.location)}),s.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.deserialize(h.location)})})(P=e.ITestErrorMessage||(e.ITestErrorMessage={}));const O=(s,h)=>`${h?"s":"e"}${s}`;e.getMarkId=O;var b;(function(s){s.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.serialize(h.location)}),s.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.deserialize(h.location)})})(b=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(s){s.serialize=h=>h.type===0?P.serialize(h):b.serialize(h),s.deserialize=h=>h.type===0?P.deserialize(h):b.deserialize(h)})(m=e.ITestMessage||(e.ITestMessage={}));var k;(function(s){s.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),s.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(m.serialize)}),s.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(m.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",l=(s,h)=>s+p+h;e.namespaceTestTag=l;const u=s=>{const h=s.indexOf(p);return{ctrlId:s.slice(0,h),tagId:s.slice(h+1)}};e.denamespaceTestTag=u;var d;(function(s){s.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),s.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?r.URI.revive(h.uri):void 0,range:h.range?C.Range.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(d=e.ITestItem||(e.ITestItem={}));var g;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));var _;(function(s){s.serialize=h=>({expand:h.expand,item:d.serialize(h.item)}),s.deserialize=h=>({controllerId:S.TestId.root(h.item.extId),expand:h.expand,item:d.deserialize(h.item)})})(_=e.InternalTestItem||(e.InternalTestItem={}));var a;(function(s){s.serialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.uri!==void 0&&(v.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(v.range=h.item.range?.toJSON()),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}},s.deserialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.range!==void 0&&(v.range=h.item.range?C.Range.lift(h.item.range):null),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}}})(a=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(s,h)=>{h.expand!==void 0&&(s.expand=h.expand),h.item!==void 0&&(s.item=s.item?Object.assign(s.item,h.item):h.item)};e.applyTestItemUpdate=w;var t;(function(s){s.serializeWithoutMessages=h=>({..._.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(k.serializeWithoutMessages),retired:h.retired}),s.serialize=h=>({..._.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(k.serialize),retired:h.retired}),s.deserialize=h=>({..._.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(k.deserialize),retired:!0})})(t=e.TestResultItem||(e.TestResultItem={}));var c;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(c=e.DetailType||(e.DetailType={}));var i;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var n;(function(s){s.deserialize=h=>h.op===0?{op:h.op,item:_.deserialize(h.item)}:h.op===1?{op:h.op,item:a.deserialize(h.item)}:h.op===2?{op:h.op,uri:r.URI.revive(h.uri),docv:h.docv}:h,s.serialize=h=>h.op===0?{op:h.op,item:_.serialize(h.item)}:h.op===1?{op:h.op,item:a.serialize(h.item)}:h})(n=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(h){}update(h){}remove(h,v){}complete(){}}e.IncrementalChangeCollector=o;class f{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(h){const v=this.createChangeCollector();for(const T of h)switch(T.op){case 0:{const N=_.deserialize(T.item),V=S.TestId.parentId(N.item.extId)?.toString();if(V){if(this.items.has(V)){const U=this.items.get(V);U.children.add(N.item.extId);const D=this.createItem(N,U);this.items.set(N.item.extId,D),v.add(D)}}else{const U=this.createItem(N);this.roots.add(U),this.items.set(N.item.extId,U),v.add(U)}N.expand===2&&this.busyControllerCount++;break}case 1:{const N=a.deserialize(T.item),V=this.items.get(N.extId);if(!V)break;N.expand!==void 0&&(V.expand===2&&this.busyControllerCount--,N.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(V,N),v.update(V);break}case 3:{const N=this.items.get(T.itemId);if(!N)break;const V=S.TestId.parentId(N.item.extId)?.toString();V?this.items.get(V).children.delete(N.item.extId):this.roots.delete(N);const U=[[T.itemId]];for(;U.length;)for(const D of U.pop()){const x=this.items.get(D);x&&(U.push(x.children),this.items.delete(D),v.remove(x,x!==N),x.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(T.itemId);break;case 4:this.updatePendingRoots(T.amount);break;case 6:this._tags.set(T.tag.id,T.tag);break;case 7:this._tags.delete(T.id);break}v.complete()}retireTest(h){}updatePendingRoots(h){this.pendingRootCount+=h}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=f}),define(Ce[65],Ie([1,0,15,5,7,45,48,40]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(d,g)=>d===g,O={range:(d,g)=>d===g?!0:!d||!g?!1:d.equalsRange(g),busy:P,label:P,description:P,error:P,tags:(d,g)=>!(d.length!==g.length||d.some(_=>!g.includes(_)))},b=(d,g)=>{let _;for(const[a,w]of Object.entries(O))w(d[a],g[a])||(_?_[a]=g[a]:_={[a]:g[a]});return _};class m extends S.Disposable{get root(){return this.options.root}constructor(g){super(),this.options=g,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const _ of this.tree.values())this.updateExpandability(_)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){switch(g.op){case 2:{for(const _ of this.diff)if(_.op===2&&_.uri===g.uri){_.docv=g.docv;return}break}case 1:{const _=this.diff[this.diff.length-1];if(_){if(_.op===1&&_.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(_.item,g.item);return}if(_.op===0&&_.item.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(_.item,g.item);return}}break}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,_){const a=this.tree.get(g);if(!!a){if((a.expandLevels===void 0||_>a.expandLevels)&&(a.expandLevels=_),a.expand===1){const w=this.resolveChildren(a);return w.isOpen()?this.expandChildren(a,_-1):w.wait().then(()=>this.expandChildren(a,_-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,_-1)):this.expandChildren(a,_-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,_){switch(_.op){case 3:this.removeItem(A.TestId.joinToString(g.fullId,_.id));break;case 0:this.upsertItem(_.item,g);break;case 5:for(const a of _.ops)this.onTestItemEvent(g,a);break;case 1:this.diffTagRefs(_.new,_.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:_.update}});break;case 6:this.documentSynced(g.actual.uri);break;default:(0,M.assertNever)(_)}}documentSynced(g){g&&this.pushDiff({op:2,uri:g,docv:this.options.getDocumentVersion(g)})}upsertItem(g,_){const a=A.TestId.fromExtHostTestItem(g,this.root.id,_?.actual),w=this.options.getApiFor(g);w.parent&&w.parent!==_?.actual&&this.options.getChildren(w.parent).delete(g.id);let t=this.tree.get(a.toString());if(!t){t={fullId:a,actual:g,expandLevels:_?.expandLevels?_.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(t.fullId.toString(),t),this.setItemParent(g,_),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:t.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,t,_);return}if(t.actual===g){this.connectItem(g,t,_);return}const c=this.options.getChildren(t.actual),i=t.actual,n=b(this.options.toITestItem(i),this.options.toITestItem(g));this.options.getApiFor(i).listener=void 0,t.actual=g,t.expand=0,n&&(n.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,i.tags,a.toString()),delete n.tags),this.onTestItemEvent(t,{op:4,update:n})),this.connectItemAndChildren(g,t,_);for(const[o,f]of c)this.options.getChildren(g).get(f.id)||this.removeItem(A.TestId.joinToString(a,f.id));this.documentSynced(t.actual.uri)}diffTagRefs(g,_,a){const w=new Set(_.map(t=>t.id));for(const t of g)w.delete(t.id)||this.incrementTagRefs(t);this.pushDiff({op:1,item:{extId:a,item:{tags:g.map(t=>(0,y.namespaceTestTag)(this.options.controllerId,t.id))}}}),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const _=this.tags.get(g.id);_?_.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const _=this.tags.get(g);_&&!--_.refCount&&(this.tags.delete(g),this.pushDiff({op:7,id:(0,y.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,_){this.options.getApiFor(g).parent=_&&_.actual!==this.root?_.actual:void 0}connectItem(g,_,a){this.setItemParent(g,a);const w=this.options.getApiFor(g);w.parent=a?.actual,w.listener=t=>this.onTestItemEvent(_,t),this.updateExpandability(_)}connectItemAndChildren(g,_,a){this.connectItem(g,_,a);for(const[w,t]of this.options.getChildren(g))this.upsertItem(t,_)}updateExpandability(g){let _;this._resolveHandler?g.resolveBarrier?_=g.resolveBarrier.isOpen()?3:2:_=g.actual.canResolveChildren?1:0:_=0,_!==g.expand&&(g.expand=_,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:_}}),_===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,_){if(_<0)return;const a=[];for(const[w,t]of this.options.getChildren(g.actual)){const c=this.expand(A.TestId.joinToString(g.fullId,t.id),_);(0,r.isThenable)(c)&&a.push(c)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const t=new r.Barrier;return t.open(),t}g.expand=2,this.pushExpandStateUpdate(g);const _=g.resolveBarrier=new r.Barrier,a=t=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,t)};let w;try{w=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(t){a(t)}return(0,r.isThenable)(w)?w.catch(a).then(()=>{_.open(),this.updateExpandability(g)}):(_.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const _=this.tree.get(g);if(!_)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const a=[_];for(;a.length;){const w=a.pop();if(!!w){this.options.getApiFor(w.actual).listener=void 0;for(const t of w.actual.tags)this.decrementTagRefs(t.id);this.tree.delete(w.fullId.toString());for(const[t,c]of this.options.getChildren(w.actual))a.push(this.tree.get(A.TestId.joinToString(w.fullId,c.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=m;class k extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=k;class p extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class l extends Error{constructor(g,_,a){super(`TestItem with ID "${g}" is from controller "${_}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=l;const u=(d,g,_)=>{let a=new Map;return{get size(){return a.size},forEach(w,t){for(const c of a.values())w.call(t,c,this)},[Symbol.iterator](){return a.entries()},replace(w){const t=new Map,c=new Set(a.keys()),i={op:5,ops:[]};for(const n of w){if(!(n instanceof _))throw new p(n.id);const o=g(n).controllerId;if(o!==d.controllerId)throw new l(n.id,o,d.controllerId);if(t.has(n.id))throw new k(n.id);t.set(n.id,n),c.delete(n.id),i.ops.push({op:0,item:n})}for(const n of c.keys())i.ops.push({op:3,id:n});d.listener?.(i),a=t},add(w){if(!(w instanceof _))throw new p(w.id);a.set(w.id,w),d.listener?.({op:0,item:w})},delete(w){a.delete(w)&&d.listener?.({op:3,id:w})},get(w){return a.get(w)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=u}),define(Ce[90],Ie([1,0,65]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,S=(y,A)=>{const E={controllerId:A};return C.set(y,E),E};e.createPrivateApiFor=S;const M=y=>{const A=C.get(y);if(!A)throw new r.InvalidTestItemError(y?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ce[170],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var C;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class S extends Error{constructor(y,A){super(A),this.variable=y}}e.VariableError=S}),define(Ce[171],Ie([1,0,19,59,10,25,21,78,142,170,9]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class b{constructor(k,p,l,u){this._contributedVariables=new Map,this._context=k,this._labelService=p,this._userHomePromise=l,u&&(this._envVariablesPromise=u.then(d=>this.prepareEnv(d)))}prepareEnv(k){if(y.isWindows){const p=Object.create(null);return Object.keys(k).forEach(l=>{p[l.toLowerCase()]=k[l]}),p}return k}resolveWithEnvironment(k,p,l){return this.recursiveResolve({env:this.prepareEnv(k),userHome:void 0},p?p.uri:void 0,l)}async resolveAsync(k,p){const l={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(l,k?k.uri:void 0,p)}async resolveAnyBase(k,p,l,u){const d=M.deepClone(p);y.isWindows&&d.windows?Object.keys(d.windows).forEach(_=>d[_]=d.windows[_]):y.isMacintosh&&d.osx?Object.keys(d.osx).forEach(_=>d[_]=d.osx[_]):y.isLinux&&d.linux&&Object.keys(d.linux).forEach(_=>d[_]=d.linux[_]),delete d.windows,delete d.osx,delete d.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,k?k.uri:void 0,d,l,u)}async resolveAnyAsync(k,p,l){return this.resolveAnyBase(k,p,l)}async resolveAnyMap(k,p,l){const u=new Map;return{newConfig:await this.resolveAnyBase(k,p,l,u),resolvedVariables:u}}resolveWithInteractionReplace(k,p,l,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,p,l,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,p){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,p)}async recursiveResolve(k,p,l,u,d){if(S.isString(l))return this.resolveString(k,p,l,u,d);if(Array.isArray(l))return Promise.all(l.map(g=>this.recursiveResolve(k,p,g,u,d)));if(S.isObject(l)){const g=Object.create(null),_=await Promise.all(Object.keys(l).map(async a=>[await this.resolveString(k,p,a,u,d),await this.recursiveResolve(k,p,l[a],u,d)]));for(const[a,w]of _)g[a]=w;return g}return l}resolveString(k,p,l,u,d){return(0,O.replaceAsync)(l,b.VARIABLE_REGEXP,async(g,_)=>{if(_.includes(b.VARIABLE_LHS))return g;let a=await this.evaluateSingleVariable(k,g,_,p,u);return d?.set(_,a),a!==g&&S.isString(a)&&a.match(b.VARIABLE_REGEXP)&&(a=await this.resolveString(k,p,a,u,d)),a})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}async evaluateSingleVariable(k,p,l,u,d){let g;const _=l.split(":");_.length>1&&(l=_[0],g=_[1]);const a=c=>{const i=this._context.getFilePath();if(i)return i;throw new P.VariableError(c,(0,E.localize)(0,null,p))},w=c=>{const i=a(c);if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new P.VariableError(c,(0,E.localize)(1,null,p,r.basename(i)))},t=c=>{if(g){const i=this._context.getFolderUri(g);if(i)return i;throw new P.VariableError(c,(0,E.localize)(2,null,p,g))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new P.VariableError(c,(0,E.localize)(3,null,p)):new P.VariableError(c,(0,E.localize)(4,null,p))};switch(l){case"env":if(g){if(k.env){const c=k.env[y.isWindows?g.toLowerCase():g];if(S.isString(c))return c}return""}throw new P.VariableError(P.VariableKind.Env,(0,E.localize)(5,null,p));case"config":if(g){const c=this._context.getConfigurationValue(u,g);if(S.isUndefinedOrNull(c))throw new P.VariableError(P.VariableKind.Config,(0,E.localize)(6,null,p,g));if(S.isObject(c))throw new P.VariableError(P.VariableKind.Config,(0,E.localize)(7,null,p,g));return c}throw new P.VariableError(P.VariableKind.Config,(0,E.localize)(8,null,p));case"command":return this.resolveFromMap(P.VariableKind.Command,p,g,d,"command");case"input":return this.resolveFromMap(P.VariableKind.Input,p,g,d,"input");case"extensionInstallFolder":if(g){const c=await this._context.getExtension(g);if(!c)throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,p,g));return this.fsPath(c.extensionLocation)}throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,p));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.WorkspaceFolder)));case"cwd":return u||g?(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(t(P.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(k.userHome)return k.userHome;throw new P.VariableError(P.VariableKind.UserHome,(0,E.localize)(11,null,p))}case"lineNumber":{const c=this._context.getLineNumber();if(c)return c;throw new P.VariableError(P.VariableKind.LineNumber,(0,E.localize)(12,null,p))}case"selectedText":{const c=this._context.getSelectedText();if(c)return c;throw new P.VariableError(P.VariableKind.SelectedText,(0,E.localize)(13,null,p))}case"file":return a(P.VariableKind.File);case"fileWorkspaceFolder":return w(P.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||g?r.relative(this.fsPath(t(P.VariableKind.RelativeFile)),a(P.VariableKind.RelativeFile)):a(P.VariableKind.RelativeFile);case"relativeFileDirname":{const c=r.dirname(a(P.VariableKind.RelativeFileDirname));if(u||g){const i=r.relative(this.fsPath(t(P.VariableKind.RelativeFileDirname)),c);return i.length===0?".":i}return c}case"fileDirname":return r.dirname(a(P.VariableKind.FileDirname));case"fileExtname":return r.extname(a(P.VariableKind.FileExtname));case"fileBasename":return r.basename(a(P.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=r.basename(a(P.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-r.extname(c).length)}case"fileDirnameBasename":return r.basename(r.dirname(a(P.VariableKind.FileDirnameBasename)));case"execPath":{const c=this._context.getExecPath();return c||p}case"execInstallFolder":{const c=this._context.getAppRoot();return c||p}case"pathSeparator":return r.sep;default:try{const c=g?`${l}:${g}`:l;return this.resolveFromMap(P.VariableKind.Unknown,p,c,d,void 0)}catch{return p}}}}resolveFromMap(k,p,l,u,d){if(l&&u){const g=d===void 0?u[l]:u[d+":"+l];if(typeof g=="string")return g;throw new P.VariableError(k,(0,E.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=b,b.VARIABLE_LHS="${",b.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[91],Ie([1,0,3,89]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var S;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var M;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var A;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const l=p;return(0,C.isEditorInput)(l?.editor)&&(0,C.isEditorInput)(l?.replacement)}e.isEditorReplacement=P;var O;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function m(p){const l=p;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.isEditorGroup=m;function k(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(Ce[172],Ie([1,0,3,91]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(M){const y=M;return typeof M=="number"||(0,C.isEditorGroup)(y)}e.isPreferredGroup=S}),define(Ce[173],Ie([1,0,3,147]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(C.IEnvironmentService)}),define(Ce[174],Ie([1,0,26,5,19]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(b){this.removedDueToLooping=b}}e.DeltaExtensionsResult=M;class y{constructor(b){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=b,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const b of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(b.identifier))){console.error("Extension `"+b.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(b.identifier),b),this._extensionsArr.push(b),Array.isArray(b.activationEvents))for(let m of b.activationEvents)m==="onUri"&&(m=`onUri:${r.ExtensionIdentifier.toKey(b.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(b)}}set(b){this._extensionDescriptions=b,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(b,m){this._extensionDescriptions=P(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(b);const k=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,k.map(p=>p.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(k)}static _findLoopingExtensions(b){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,g){this.addNode(d),this.addNode(g),this._arcs.has(d)?this._arcs.get(d).push(g):this._arcs.set(d,[g])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,g){const _=m.getArcs(d);for(let a=0;a<_.length;a++)if(!g.has(_[a]))return!1;return!0}getNodes(){return this._nodesArr}},k=new Map;for(const d of b){const g=r.ExtensionIdentifier.toKey(d.identifier);if(k.set(g,d),d.extensionDependencies)for(const _ of d.extensionDependencies){const a=r.ExtensionIdentifier.toKey(_);m.addArc(g,a)}}const p=new Set;m.getNodes().filter(d=>m.getArcs(d).length===0).forEach(d=>p.add(d));const l=m.getNodes().filter(d=>!p.has(d));let u;do{u=!1;for(let d=0;d<l.length;d++){const g=l[d];m.hasOnlyGoodArcs(g,p)&&(l.splice(d,1),d--,p.add(g),u=!0)}}while(u);return l.map(d=>k.get(d))}containsActivationEvent(b){return this._activationMap.has(b)}containsExtension(b){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(b))}getExtensionDescriptionsForActivationEvent(b){const m=this._activationMap.get(b);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(b){const m=this._extensionsMap.get(r.ExtensionIdentifier.toKey(b));return m||void 0}getExtensionDescriptionByUUID(b){for(const m of this._extensionsArr)if(m.uuid===b)return m}getExtensionDescriptionByIdOrUUID(b,m){return this.getExtensionDescription(b)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=y;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function E(O,b){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,k=b.isBuiltin?0:b.isUnderDevelopment?2:1;if(m!==k)return m-k;const p=S.posix.basename(O.extensionLocation.path),l=S.posix.basename(b.extensionLocation.path);return p<l?-1:p>l?1:0}function P(O,b){const m=new Set;return b.forEach(k=>m.add(r.ExtensionIdentifier.toKey(k))),O.filter(k=>!m.has(r.ExtensionIdentifier.toKey(k.identifier)))}}),define(Ce[92],Ie([1,0,23]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var S;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function y(P){const O=r.VSBuffer.alloc(1);switch(P){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=y;function A(P,O){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var E;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[28],Ie([1,0,5,2,3,26,154]),function(ie,e,r,C,S,M,y){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class E{constructor(f){this.affinity=f,this.kind=1}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class P{constructor(){this.kind=2,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class O{constructor(){this.kind=3,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class b{constructor(f){this.dependency=f}}e.MissingExtensionDependency=b;var m;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=k;class p{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(f,s){const h=[],v=[],T=[],N=[],V=d(this._allExtensions),U=d(f),D=(K,W)=>K.extensionLocation.toString()===W.extensionLocation.toString()||K.isBuiltin===W.isBuiltin||K.isUserBuiltin===W.isUserBuiltin||K.isUnderDevelopment===W.isUnderDevelopment;for(const K of this._allExtensions){const W=U.get(M.ExtensionIdentifier.toKey(K.identifier));if(!W){h.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}if(!D(K,W)){h.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of f){const W=V.get(M.ExtensionIdentifier.toKey(K.identifier));if(!W){v.push(K);continue}if(!D(W,K)){h.push(W.identifier),V.delete(M.ExtensionIdentifier.toKey(W.identifier));continue}}const x=u(this._myExtensions),L=u(s);for(const K of this._myExtensions)L.has(M.ExtensionIdentifier.toKey(K))||T.push(K);for(const K of s)x.has(M.ExtensionIdentifier.toKey(K))||N.push(K);const R={toRemove:h,toAdd:v,myToRemove:T,myToAdd:N};return this.delta(R),R}delta(f){const{toRemove:s,toAdd:h,myToRemove:v,myToAdd:T}=f,N=u(s),V=u(v);for(let U=0;U<this._allExtensions.length;U++)N.has(M.ExtensionIdentifier.toKey(this._allExtensions[U].identifier))&&(this._allExtensions.splice(U,1),U--);for(let U=0;U<this._myExtensions.length;U++)V.has(M.ExtensionIdentifier.toKey(this._myExtensions[U]))&&(this._myExtensions.splice(U,1),U--);for(const U of h)this._allExtensions.push(U);for(const U of T)this._myExtensions.push(U)}containsExtension(f){for(const s of this._myExtensions)if(M.ExtensionIdentifier.equals(s,f))return!0;return!1}}e.ExtensionHostExtensions=p;class l{constructor(f){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,f)for(const s of f)this.add(s)}get size(){return this._map.size}add(f){return this._map.set(this._toKey(f),f),this}clear(){this._map.clear()}delete(f){return this._map.delete(this._toKey(f))}has(f){return this._map.has(this._toKey(f))}forEach(f,s){this._map.forEach(h=>f.call(s,h,h,this))}*entries(){for(const[f,s]of this._map)yield[s,s]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=l;function u(o){const f=new Set;for(const s of o)f.add(M.ExtensionIdentifier.toKey(s));return f}e.extensionIdentifiersArrayToSet=u;function d(o){const f=new Map;for(const s of o)f.set(M.ExtensionIdentifier.toKey(s.identifier),s);return f}function g(o,f){return o.enabledApiProposals?o.enabledApiProposals.includes(f):!1}e.isProposedApiEnabled=g;function _(o,f){if(!g(o,f))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=_;class a{constructor(f,s,h,v){this.codeLoadingTime=f,this.activateCallTime=s,this.activateResolvedTime=h,this.activationReason=v}}e.ActivationTimes=a;class w{constructor(f,s){this.description=f,this.value=s}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function c(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=c;function i(o,f){return{identifier:new M.ExtensionIdentifier((0,y.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!f,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=i;class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.extensions=[]}activateByEvent(f){return Promise.resolve(void 0)}activationEventIsDone(f){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f,s){return Promise.resolve(0)}getInspectPorts(f,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,s){return Promise.resolve()}}e.NullExtensionService=n}),define(Ce[175],Ie([1,0,12,26,28,14,15]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(u,d,g,_){this.startup=u,this.codeLoadingTime=d,this.activateCallTime=g,this.activateResolvedTime=_}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class E{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,d){return u===-1||d===-1?-1:d-u}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class P{constructor(u,d,g,_,a,w){this.activationFailed=u,this.activationFailedError=d,this.activationTimes=g,this.module=_,this.exports=a,this.subscriptions=w}}e.ActivatedExtension=P;class O extends P{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class b extends P{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class m extends P{constructor(u){super(!0,u,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let k=class{constructor(u,d,g,_,a){this._logService=a,this._registry=u,this._resolvedExtensionsSet=new Set,d.forEach(w=>this._resolvedExtensionsSet.add(C.ExtensionIdentifier.toKey(w))),this._externalExtensionsMap=new Map,g.forEach(w=>this._externalExtensionsMap.set(C.ExtensionIdentifier.toKey(w),w)),this._host=_,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[u,d]of this._operations)d.dispose()}isActivated(u){const d=this._operations.get(C.ExtensionIdentifier.toKey(u));return Boolean(d&&d.value)}getActivatedExtension(u){const d=this._operations.get(C.ExtensionIdentifier.toKey(u));if(!d||!d.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return d.value}async activateByEvent(u,d){if(this._alreadyActivatedEvents[u])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(u);await this._activateExtensions(g.map(_=>({id:_.identifier,reason:{startup:d,extensionId:_.identifier,activationEvent:u}}))),this._alreadyActivatedEvents[u]=!0}activateById(u,d){const g=this._registry.getExtensionDescription(u);if(!g)throw new Error(`Extension '${u}' is not known`);return this._activateExtensions([{id:g.identifier,reason:d}])}async _activateExtensions(u){const d=u.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(d.map(g=>g.wait()))}_handleActivationRequest(u){if(this._operations.has(C.ExtensionIdentifier.toKey(u.id)))return this._operations.get(C.ExtensionIdentifier.toKey(u.id));if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(u.id)))return this._createAndSaveOperation(u,null,[],null);const d=this._registry.getExtensionDescription(u.id);if(!d){const a=new Error(`Cannot activate unknown extension '${u.id.value}'`),w=this._createAndSaveOperation(u,null,[],new m(a));return this._host.onExtensionActivationError(u.id,a,new S.MissingExtensionDependency(u.id.value)),w}const g=[],_=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const a of _){if(this._resolvedExtensionsSet.has(C.ExtensionIdentifier.toKey(a)))continue;const w=this._operations.get(C.ExtensionIdentifier.toKey(a));if(w){g.push(w);continue}if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(a))){g.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(C.ExtensionIdentifier.toKey(a)),reason:u.reason}));continue}const t=this._registry.getExtensionDescription(a);if(t){if(!t.main&&!t.browser)continue;g.push(this._handleActivationRequest({id:t.identifier,reason:u.reason}));continue}const c=d.displayName||d.identifier.value,i=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${a}'`),n=this._createAndSaveOperation(u,d.displayName,[],new m(i));return this._host.onExtensionActivationError(d.identifier,i,new S.MissingExtensionDependency(a)),n}return this._createAndSaveOperation(u,d.displayName,g,null)}_createAndSaveOperation(u,d,g,_){const a=new p(u.id,d,u.reason,g,_,this._host,this._logService);return this._operations.set(C.ExtensionIdentifier.toKey(u.id),a),a}};k=ze([$e(4,M.ILogService)],k),e.ExtensionsActivator=k;let p=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(u,d,g,_,a,w,t){this._id=u,this._displayName=d,this._reason=g,this._deps=_,this._value=a,this._host=w,this._logService=t,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let u=0;u<this._deps.length;u++){const d=this._deps[u];if(d.value&&!d.value.activationFailed){this._deps.splice(u,1),u--;continue}if(d.value&&d.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);g.detail=d.value.activationFailedError,this._value=new m(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(u=>u.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(u){const d=new Error;if(u&&u.name&&(d.name=u.name),u&&u.message?d.message=`Activating extension '${this._id.value}' failed: ${u.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${u}.`,u&&u.stack&&(d.stack=u.stack),this._value=new m(d),this._isDisposed&&r.isCancellationError(u))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(u)}}};p=ze([$e(6,M.ILogService)],p)}),define(Ce[176],Ie([1,0,14,27,28]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends r.LogService{constructor(A,E){super(A.createLogger(E.logFile,{name:S.ExtensionHostLogFileName}))}};M=ze([$e(0,r.ILoggerService),$e(1,C.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[6],Ie([1,0,18,12,77,24,75,9,10,2,43,35,86,64,28]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p){"use strict";var l,u,d,g,_,a,w,t,c,i,n,o,f,s,h,v,T,N,V,U,D,x,L;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(z){return Object.assign(z,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(z,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[te,...we]=arguments;return Reflect.construct(z,we,te.constructor)}}})}let K=a=class{static from(...F){let te=F;return new a(function(){if(te){for(const we of te)we&&typeof we.dispose=="function"&&we.dispose();te=void 0}})}constructor(F){l.set(this,void 0),Je(this,l,F,"f")}dispose(){typeof Oe(this,l,"f")=="function"&&(Oe(this,l,"f").call(this),Je(this,l,void 0,"f"))}};l=new WeakMap,K=a=ze([R],K),e.Disposable=K;let W=w=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let we=1;we<F.length;we++){const He=F[we];He.isBefore(te)&&(te=He)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let we=1;we<F.length;we++){const He=F[we];He.isAfter(te)&&(te=He)}return te}static isPosition(F){if(!F)return!1;if(F instanceof w)return!0;const{line:te,character:we}=F;return typeof te=="number"&&typeof we=="number"}static of(F){if(F instanceof w)return F;if(this.isPosition(F))return new w(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(F,te){if(F<0)throw(0,C.illegalArgument)("line must be non-negative");if(te<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=F,this._character=te}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,te=0){if(F===null||te===null)throw(0,C.illegalArgument)();let we;return typeof F>"u"?we=0:typeof F=="number"?we=F:(we=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),we===0&&te===0?this:new w(this.line+we,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,C.illegalArgument)();let we;return typeof F>"u"?we=this.line:typeof F=="number"?we=F:(we=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),we===this.line&&te===this.character?this:new w(we,te)}toJSON(){return{line:this.line,character:this.character}}};W=w=ze([R],W),e.Position=W;let $=t=class{static isRange(F){return F instanceof t?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof t)return F;if(this.isRange(F))return new t(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(F,te,we,He){let Qe,ct;if(typeof F=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(F,te),ct=new W(we,He)):W.isPosition(F)&&W.isPosition(te)&&(Qe=W.of(F),ct=W.of(te)),!Qe||!ct)throw new Error("Invalid arguments");Qe.isBefore(ct)?(this._start=Qe,this._end=ct):(this._start=ct,this._end=Qe)}contains(F){return t.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const te=W.Max(F.start,this._start),we=W.Min(F.end,this._end);if(!te.isAfter(we))return new t(te,we)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=W.Min(F.start,this._start),we=W.Max(F.end,this.end);return new t(te,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,te=this.end){if(F===null||te===null)throw(0,C.illegalArgument)();let we;return F?W.isPosition(F)?we=F:(we=F.start||this.start,te=F.end||this.end):we=this.start,we.isEqual(this._start)&&te.isEqual(this.end)?this:new t(we,te)}toJSON(){return[this.start,this.end]}};$=t=ze([R],$),e.Range=$;let G=c=class extends ${static isSelection(F){return F instanceof c?!0:F?$.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(F,te,we,He){let Qe,ct;if(typeof F=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(F,te),ct=new W(we,He)):W.isPosition(F)&&W.isPosition(te)&&(Qe=W.of(F),ct=W.of(te)),!Qe||!ct)throw new Error("Invalid arguments");super(Qe,ct),this._anchor=Qe,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=c=ze([R],G),e.Selection=G;class re{constructor(F,te,we){if(typeof F!="string"||F.length===0)throw(0,C.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,C.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(te),this.connectionToken=we}}e.ResolvedAuthority=re;class ge extends Error{static NotAvailable(F,te){return new ge(F,m.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ge(F,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(F),this._message=F,this._code=te,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ge.prototype)}}e.RemoteAuthorityResolverError=ge;var oe;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(oe=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(Ee=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ce=i=class{static isTextEdit(F){return F instanceof i?!0:F?$.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new $(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new $(new W(0,0),new W(0,0)),"");return te.newEol=F,te}get range(){return this._range}set range(F){if(F&&!$.isRange(F))throw(0,C.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,C.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,C.illegalArgument)("newEol");this._newEol=F}constructor(F,te){this._range=F,this._newText=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ce=i=ze([R],ce),e.TextEdit=ce;let me=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?Vt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new n(F,te)}static insertCells(F,te){return new n(new Vt(F,F),te)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,te){const we=new n(new Vt(F,F),[]);return we.newCellMetadata=te,we}static updateNotebookMetadata(F){const te=new n(new Vt(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};me=n=ze([R],me),e.NotebookEdit=me;class ee{static isSnippetTextEdit(F){return F instanceof ee?!0:F?$.isRange(F.range)&&Fe.isSnippetString(F.snippet):!1}static replace(F,te){return new ee(F,te)}static insert(F,te){return ee.replace(new $(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.SnippetTextEdit=ee;var be;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(be=e.FileEditType||(e.FileEditType={}));let _e=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,te,we,He){this._edits.push({_type:1,from:F,to:te,options:we,metadata:He})}createFile(F,te,we){this._edits.push({_type:1,from:void 0,to:F,options:te,metadata:we})}deleteFile(F,te,we){this._edits.push({_type:1,from:F,to:void 0,options:te,metadata:we})}replaceNotebookMetadata(F,te,we){this._edits.push({_type:3,metadata:we,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(F,te,we,He){const Qe=te.start,ct=te.end;(Qe!==ct||we.length>0)&&this._edits.push({_type:5,uri:F,index:Qe,count:ct-Qe,cells:we,metadata:He})}replaceNotebookCellMetadata(F,te,we,He){this._edits.push({_type:3,metadata:He,uri:F,edit:{editType:8,index:te,metadata:we}})}replace(F,te,we,He){this._edits.push({_type:2,uri:F,edit:new ce(te,we),metadata:He})}insert(F,te,we,He){this.replace(F,new $(te,te),we,He)}delete(F,te,we){this.replace(F,te,"",we)}has(F){return this._edits.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const we of te){if(!we)continue;let He,Qe;Array.isArray(we)?(He=we[0],Qe=we[1]):He=we,me.isNotebookCellEdit(He)?He.newCellMetadata?this.replaceNotebookCellMetadata(F,He.range.start,He.newCellMetadata,Qe):He.newNotebookMetadata?this.replaceNotebookMetadata(F,He.newNotebookMetadata,Qe):this.replaceNotebookCells(F,He.range,He.newCells,Qe):ee.isSnippetTextEdit(He)?this._edits.push({_type:6,uri:F,range:He.range,edit:He.snippet,metadata:Qe}):this._edits.push({_type:2,uri:F,edit:He,metadata:Qe})}else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===F.toString()&&(this._edits[we]=void 0);break}}(0,r.coalesceInPlace)(this._edits)}}get(F){const te=[];for(const we of this._edits)we._type===2&&we.uri.toString()===F.toString()&&te.push(we.edit);return te}entries(){const F=new M.ResourceMap;for(const te of this._edits)if(te._type===2){let we=F.get(te.uri);we||(we=[te.uri,[]],F.set(te.uri,we)),we[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};_e=ze([R],_e),e.WorkspaceEdit=_e;let Fe=o=class{static isSnippetString(F){return F instanceof o?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this._tabstop=1,this.value=F||""}appendText(F){return this.value+=o._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this._tabstop++){if(typeof F=="function"){const we=new o;we._tabstop=this._tabstop,F(we),this._tabstop=we._tabstop,F=we.value}else F=o._escape(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this._tabstop++){const we=F.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const we=new o;we._tabstop=this._tabstop,te(we),this._tabstop=we._tabstop,te=we.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};Fe=o=ze([R],Fe),e.SnippetString=Fe;var Be;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Be=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=f=class{static isLocation(F){return F instanceof f?!0:F?$.isRange(F.range)&&P.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if($.isRange(te))this.range=$.of(te);else if(W.isPosition(te))this.range=new $(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=f=ze([R],ke),e.Location=ke;let ye=class{static is(F){return F?typeof F.message=="string"&&F.location&&$.isRange(F.location.range)&&P.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};ye=ze([R],ye),e.DiagnosticRelatedInformation=ye;let De=class{constructor(F,te,we=Xe.Error){if(!$.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=we}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,r.equals)(F.tags,te.tags)&&(0,r.equals)(F.relatedInformation,te.relatedInformation,ye.isEqual)}};De=ze([R],De),e.Diagnostic=De;let ae=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};ae=ze([R],ae),e.Hover=ae;var ue;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Z=class{constructor(F,te=ue.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:ue[this.kind]}}};Z=ze([R],Z),e.DocumentHighlight=Z;var J;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(J=e.SymbolKind||(e.SymbolKind={}));var I;(function(z){z[z.Deprecated=1]="Deprecated"})(I=e.SymbolTag||(e.SymbolTag={}));let B=s=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,we,He,Qe){this.name=F,this.kind=te,this.containerName=Qe,typeof we=="string"&&(this.containerName=we),He instanceof ke?this.location=He:we instanceof $&&(this.location=new ke(He,we)),s.validate(this)}toJSON(){return{name:this.name,kind:J[this.kind],location:this.location,containerName:this.containerName}}};B=s=ze([R],B),e.SymbolInformation=B;let H=h=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(h.validate)}constructor(F,te,we,He,Qe){this.name=F,this.detail=te,this.kind=we,this.range=He,this.selectionRange=Qe,this.children=[],h.validate(this)}};H=h=ze([R],H),e.DocumentSymbol=H;var j;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(j=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(F,te){this.title=F,this.kind=te}};se=ze([R],se),e.CodeAction=se;let le=v=class{constructor(F){this.value=F}append(F){return new v(this.value?this.value+v.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+v.sep)}};le.sep=".",le=v=ze([R],le),e.CodeActionKind=le,le.Empty=new le(""),le.QuickFix=le.Empty.append("quickfix"),le.Refactor=le.Empty.append("refactor"),le.RefactorExtract=le.Refactor.append("extract"),le.RefactorInline=le.Refactor.append("inline"),le.RefactorMove=le.Refactor.append("move"),le.RefactorRewrite=le.Refactor.append("rewrite"),le.Source=le.Empty.append("source"),le.SourceOrganizeImports=le.Source.append("organizeImports"),le.SourceFixAll=le.Source.append("fixAll");let Y=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=ze([R],Y),e.SelectionRange=Y;class ve{constructor(F,te,we,He,Qe,ct){this.kind=F,this.name=te,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=ct}}e.CallHierarchyItem=ve;class pe{constructor(F,te){this.fromRanges=te,this.from=F}}e.CallHierarchyIncomingCall=pe;class Me{constructor(F,te){this.fromRanges=te,this.to=F}}e.CallHierarchyOutgoingCall=Me;var xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ye=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};Ye=ze([R],Ye),e.CodeLens=Ye;let Ge=T=class{static isMarkdownString(F){return F instanceof T?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){u.set(this,void 0),Je(this,u,new S.MarkdownString(F,{supportThemeIcons:te}),"f")}get value(){return Oe(this,u,"f").value}set value(F){Oe(this,u,"f").value=F}get isTrusted(){return Oe(this,u,"f").isTrusted}set isTrusted(F){Oe(this,u,"f").isTrusted=F}get supportThemeIcons(){return Oe(this,u,"f").supportThemeIcons}set supportThemeIcons(F){Oe(this,u,"f").supportThemeIcons=F}get supportHtml(){return Oe(this,u,"f").supportHtml}set supportHtml(F){Oe(this,u,"f").supportHtml=F}get baseUri(){return Oe(this,u,"f").baseUri}set baseUri(F){Oe(this,u,"f").baseUri=F}appendText(F){return Oe(this,u,"f").appendText(F),this}appendMarkdown(F){return Oe(this,u,"f").appendMarkdown(F),this}appendCodeblock(F,te){return Oe(this,u,"f").appendCodeblock(te??"",F),this}};u=new WeakMap,Ge=T=ze([R],Ge),e.MarkdownString=Ge;let Te=class{constructor(F,te){this.label=F,this.documentation=te}};Te=ze([R],Te),e.ParameterInformation=Te;let rt=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};rt=ze([R],rt),e.SignatureInformation=rt;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=ze([R],X),e.SignatureHelp=X;var Q;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var he;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(he=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(F){this.value=F}};Ue=ze([R],Ue),e.InlayHintLabelPart=Ue;let je=class{constructor(F,te,we){this.position=F,this.label=te,this.kind=we}};je=ze([R],je),e.InlayHint=je;var Ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Ve;(function(z){z[z.Deprecated=1]="Deprecated"})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));let it=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};it=ze([R],it),e.CompletionItem=it;let st=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};st=ze([R],st),e.CompletionList=st;let dt=class{constructor(F,te,we){this.insertText=F,this.range=te,this.command=we}};dt=ze([R],dt),e.InlineSuggestion=dt;let _t=class{constructor(F){this.commands=void 0,this.items=F}};_t=ze([R],_t),e.InlineSuggestionList=_t;let tt=class{constructor(F,te,we){this.insertText=F,this.range=te,this.command=we}};tt=ze([R],tt),e.InlineSuggestionNew=tt;let ut=class{constructor(F,te){this.items=F,this.commands=te}};ut=ze([R],ut),e.InlineSuggestionsNew=ut;var Ot;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Ot=e.ViewColumn||(e.ViewColumn={}));var Ht;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ht=e.StatusBarAlignment||(e.StatusBarAlignment={}));var At;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(At=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ct;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ct=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Lt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var xt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(xt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var qe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function F(te){switch(te){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=F}(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(F,te){if(te&&!P.URI.isUri(te))throw(0,C.illegalArgument)("target");if(!$.isRange(F)||F.isEmpty)throw(0,C.illegalArgument)("range");this.range=F,this.target=te}};Ft=ze([R],Ft),e.DocumentLink=Ft;let It=class{constructor(F,te,we,He){this.red=F,this.green=te,this.blue=we,this.alpha=He}};It=ze([R],It),e.Color=It;let Nt=class{constructor(F,te){if(te&&!(te instanceof It))throw(0,C.illegalArgument)("color");if(!$.isRange(F)||F.isEmpty)throw(0,C.illegalArgument)("range");this.range=F,this.color=te}};Nt=ze([R],Nt),e.ColorInformation=Nt;let gt=class{constructor(F){if(!F||typeof F!="string")throw(0,C.illegalArgument)("label");this.label=F}};gt=ze([R],gt),e.ColorPresentation=gt;var Se;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var Pe;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Pe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var fe;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(fe=e.TerminalExitReason||(e.TerminalExitReason={}));class q{constructor(F,te,we){if(this.startIndex=F,this.length=te,this.tooltip=we,typeof F!="number"||F<0)throw(0,C.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,C.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=q;var Ae;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Le{constructor(F){if(this.options=F,typeof F!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Le;var nt;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var We;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(We=e.TaskPanelKind||(e.TaskPanelKind={}));let et=N=class{static from(F){switch(F){case"clean":return N.Clean;case"build":return N.Build;case"rebuild":return N.Rebuild;case"test":return N.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,C.illegalArgument)("name");this._id=F}get id(){return this._id}};et.Clean=new N("clean","Clean"),et.Build=new N("build","Build"),et.Rebuild=new N("rebuild","Rebuild"),et.Test=new N("test","Test"),et=N=ze([R],et),e.TaskGroup=et;function lt(z){let F="";for(let te=0;te<z.length;te++)F+=z[te].replace(/,/g,",,")+",";return F}let mt=class{constructor(F,te,we){if(typeof F!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=F,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=we):this._options=te)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,C.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(const te of this._args)F.push(te);return lt(F)}};mt=ze([R],mt),e.ProcessExecution=mt;let yt=class{constructor(F,te,we){if(this._args=[],Array.isArray(te)){if(!F)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,C.illegalArgument)("command");this._command=F,this._args=te,this._options=we}else{if(typeof F!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=F,this._options=te}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,C.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const te of this._args)F.push(typeof te=="string"?te:te.value);return lt(F)}};yt=ze([R],yt),e.ShellExecution=yt;var Et;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Et=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class kt{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=kt;let bt=V=class{constructor(F,te,we,He,Qe,ct){this.__deprecated=!1,this._definition=this.definition=F;let ht;typeof te=="string"?(this._name=this.name=te,this._source=this.source=we,this.execution=He,ht=Qe,this.__deprecated=!0):te===wt.Global||te===wt.Workspace?(this.target=te,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=ct):(this.target=te,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=ct),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof mt?this._definition={type:V.ProcessType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:V.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:V.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:V.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const te=this._definition.type;(V.EmptyType===te||V.ProcessType===te||V.ShellType===te||V.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=V=ze([R],bt),e.Task=bt;var Dt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Dt=e.ProgressLocation||(e.ProgressLocation={}));var ti;(function(z){function F(te){const we=te;return(0,E.isNumber)(we.value)?we.tooltip&&!(0,E.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=F})(ti=e.ViewBadge||(e.ViewBadge={}));let Xt=U=class{static isTreeItem(F,te){if(F instanceof U)return!0;const we=F;if(we.label!==void 0&&!(0,E.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,E.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,E.isString)(we.iconPath)&&!P.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,E.isString)(we.iconPath.id))){const He=we.iconPath;if(!He||!(0,E.isString)(He.light)&&!P.URI.isUri(He.light)&&!(0,E.isString)(He.dark)&&!P.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,E.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!P.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,E.isString)(we.tooltip)&&!(we.tooltip instanceof Ge))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<vt.None&&we.collapsibleState>vt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,E.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(te,"treeItemCheckbox");const He=(0,E.isNumber)(we.checkboxState)?we.checkboxState:(0,E.isObject)(we.checkboxState)&&(0,E.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Qe=!(0,E.isNumber)(we.checkboxState)&&(0,E.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(He===void 0||He!==ii.Checked&&He!==ii.Unchecked||Qe!==void 0&&!(0,E.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(F,te=vt.None){this.collapsibleState=te,P.URI.isUri(F)?this.resourceUri=F:this.label=F}};Xt=U=ze([R],Xt),e.TreeItem=Xt;var vt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(vt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ii;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(ii=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ni=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F,te){this.value=F,this.id=te??(0,O.generateUuid)()}};ni=ze([R],ni),e.DataTransferItem=ni;let ri=class{constructor(F){d.set(this,new Map);for(const[te,we]of F??[]){const He=Oe(this,d,"f").get(te);He?He.push(we):Oe(this,d,"f").set(te,[we])}}get(F){return Oe(this,d,"f").get(F)?.[0]}set(F,te){Oe(this,d,"f").set(F,[te])}forEach(F,te){for(const[we,He]of Oe(this,d,"f"))for(const Qe of He)F.call(te,Qe,we,this)}*[(d=new WeakMap,Symbol.iterator)](){for(const[F,te]of Oe(this,d,"f"))for(const we of te)yield[F,we]}};ri=ze([R],ri),e.DataTransfer=ri;let pi=class{constructor(F){this.insertText=F}};pi=ze([R],pi),e.DocumentDropEdit=pi;let Tt=class{constructor(F){this.insertText=F}};Tt=ze([R],Tt),e.DocumentPasteEdit=Tt;let zt=class{constructor(F,te){this.id=F,this.color=te}};zt=ze([R],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let vi=class{constructor(F){this.id=F}};vi=ze([R],vi),e.ThemeColor=vi;var si;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(si=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Qt=class{get base(){return this._base}set base(F){this._base=F,this._baseUri=P.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!P.URI.isUri(F)&&!P.URI.isUri(F.uri)))throw(0,C.illegalArgument)("base");if(typeof te!="string")throw(0,C.illegalArgument)("pattern");typeof F=="string"?this.baseUri=P.URI.file(F):P.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Qt=ze([R],Qt),e.RelativePattern=Qt;let at=class{constructor(F,te,we,He){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};at=ze([R],at),e.Breakpoint=at;let Ei=class extends at{constructor(F,te,we,He,Qe){if(super(te,we,He,Qe),F===null)throw(0,C.illegalArgument)("location");this.location=F}};Ei=ze([R],Ei),e.SourceBreakpoint=Ei;let $t=class extends at{constructor(F,te,we,He,Qe){super(te,we,He,Qe),this.functionName=F}};$t=ze([R],$t),e.FunctionBreakpoint=$t;let qt=class extends at{constructor(F,te,we,He,Qe,ct,ht){if(super(He,Qe,ct,ht),!te)throw(0,C.illegalArgument)("dataId");this.label=F,this.dataId=te,this.canPersist=we}};qt=ze([R],qt),e.DataBreakpoint=qt;let oi=class{constructor(F,te,we){this.command=F,this.args=te||[],this.options=we}};oi=ze([R],oi),e.DebugAdapterExecutable=oi;let bi=class{constructor(F,te){this.port=F,this.host=te}};bi=ze([R],bi),e.DebugAdapterServer=bi;let ai=class{constructor(F){this.path=F}};ai=ze([R],ai),e.DebugAdapterNamedPipeServer=ai;let wi=class{constructor(F){this.implementation=F}};wi=ze([R],wi),e.DebugAdapterInlineImplementation=wi;let ci=class{constructor(F,te){this.range=F,this.expression=te}};ci=ze([R],ci),e.EvaluatableExpression=ci;var li;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(li=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Ni;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ni=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Yt=class{constructor(F,te){this.range=F,this.text=te}};Yt=ze([R],Yt),e.InlineValueText=Yt;let Jt=class{constructor(F,te,we=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=we}};Jt=ze([R],Jt),e.InlineValueVariableLookup=Jt;let Si=class{constructor(F,te){this.range=F,this.expression=te}};Si=ze([R],Si),e.InlineValueEvaluatableExpression=Si;let _i=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};_i=ze([R],_i),e.InlineValueContext=_i;var Zt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Zt=e.FileChangeType||(e.FileChangeType={}));let yi=D=class extends Error{static FileExists(F){return new D(F,b.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(F){return new D(F,b.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(F){return new D(F,b.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(F){return new D(F,b.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(F){return new D(F,b.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(F){return new D(F,b.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}constructor(F,te=b.FileSystemProviderErrorCode.Unknown,we){super(P.URI.isUri(F)?F.toString(!0):F),this.code=we?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};yi=D=ze([R],yi),e.FileSystemError=yi;let Di=class{constructor(F,te,we){this.start=F,this.end=te,this.kind=we}};Di=ze([R],Di),e.FoldingRange=Di;var Mi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Mi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Li;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Li=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ci;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ci=e.CommentMode||(e.CommentMode={}));var Pi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Pi=e.CommentThreadState||(e.CommentThreadState={}));class Ai{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.SemanticTokensLegend=Ai;function Ne(z){return typeof z>"u"||(0,E.isStringArray)(z)}class Ut{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let te=0,we=F.tokenTypes.length;te<we;te++)this._tokenTypeStrToInt.set(F.tokenTypes[te],te);for(let te=0,we=F.tokenModifiers.length;te<we;te++)this._tokenModifierStrToInt.set(F.tokenModifiers[te],te)}}push(F,te,we,He,Qe){if(typeof F=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(F,te,we,He,Qe);if($.isRange(F)&&typeof te=="string"&&Ne(we))return this._push(F,te,we);throw(0,C.illegalArgument)()}_push(F,te,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const He=F.start.line,Qe=F.start.character,ct=F.end.character-F.start.character,ht=this._tokenTypeStrToInt.get(te);let Rt=0;if(we)for(const Bt of we){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Bt);Rt|=1<<Wt>>>0}this._pushEncoded(He,Qe,ct,ht,Rt)}_pushEncoded(F,te,we,He,Qe){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Rt=this._data.length/5|0;let Bt=0,Wt=0;for(let jt=0;jt<Rt;jt++){let Kt=this._data[5*jt],ki=this._data[5*jt+1];Kt===0?(Kt=Bt,ki+=Wt):Kt+=Bt,this._data[5*jt]=Kt,this._data[5*jt+1]=ki,Bt=Kt,Wt=ki}}let ct=F,ht=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Qe,this._prevLine=F,this._prevChar=te}static _sortAndDeltaEncode(F){const te=[],we=F.length/5|0;for(let ht=0;ht<we;ht++)te[ht]=ht;te.sort((ht,Rt)=>{const Bt=F[5*ht],Wt=F[5*Rt];if(Bt===Wt){const jt=F[5*ht+1],Kt=F[5*Rt+1];return jt-Kt}return Bt-Wt});const He=new Uint32Array(F.length);let Qe=0,ct=0;for(let ht=0;ht<we;ht++){const Rt=5*te[ht],Bt=F[Rt+0],Wt=F[Rt+1],jt=F[Rt+2],Kt=F[Rt+3],ki=F[Rt+4],Zi=Bt-Qe,Cn=Zi===0?Wt-ct:Wt,Ti=5*ht;He[Ti+0]=Zi,He[Ti+1]=Cn,He[Ti+2]=jt,He[Ti+3]=Kt,He[Ti+4]=ki,Qe=Bt,ct=Wt}return He}build(F){return this._dataIsSortedAndDeltaEncoded?new ui(new Uint32Array(this._data),F):new ui(Ut._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Ut;class ui{constructor(F,te){this.resultId=te,this.data=F}}e.SemanticTokens=ui;class pt{constructor(F,te,we){this.start=F,this.deleteCount=te,this.data=we}}e.SemanticTokensEdit=pt;class Ui{constructor(F,te){this.resultId=te,this.edits=F}}e.SemanticTokensEdits=Ui;var Bi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Bi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ei=class{constructor(){}};ei.Back={iconPath:new zt("arrow-left")},ei=ze([R],ei),e.QuickInputButtons=ei;var xi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(xi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var di;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(di=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(zi=e.ExtensionKind||(e.ExtensionKind={}));class $i{static validate(F){if(F.badge){let te=(0,A.nextCharLength)(F.badge,0);if(te<F.badge.length&&(te+=(0,A.nextCharLength)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,we){this.badge=F,this.tooltip=te,this.color=we}}e.FileDecoration=$i;let Ii=class{constructor(F){this.kind=F}};Ii=ze([R],Ii),e.ColorTheme=Ii;var Ri;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ri=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(F){return F instanceof Vt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(F,te){if(F<0)throw(0,C.illegalArgument)("start must be positive");if(te<0)throw(0,C.illegalArgument)("end must be positive");F<=te?(this._start=F,this._end=te):(this._start=te,this._end=F)}with(F){let te=this._start,we=this._end;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(we=F.end),te===this._start&&we===this._end?this:new Vt(te,we)}}e.NotebookRange=Vt;class hi{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>hi.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,we,He,Qe,ct,ht){this.kind=F,this.value=te,this.languageId=we,this.mime=He,this.outputs=Qe??[],this.metadata=ct,this.executionSummary=ht,hi.validate(this)}}e.NotebookCellData=hi;class Wi{constructor(F){this.cells=F}}e.NotebookData=Wi;class Mt{static isNotebookCellOutputItem(F){return F instanceof Mt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return Mt.json(te,"application/vnd.code.notebook.error")}static stdout(F){return Mt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Mt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new Mt(F,te)}static text(F,te=y.Mimes.text){const we=Oe(Mt,g,"f",_).encode(String(F));return new Mt(we,te)}static json(F,te="text/x-json"){const we=JSON.stringify(F,void 0,"	");return Mt.text(we,te)}constructor(F,te){this.data=F,this.mime=te;const we=(0,y.normalizeMimeType)(te,!0);if(!we)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=Mt,g=Mt,_={value:new TextEncoder};class fi{static isNotebookCellOutput(F){return F instanceof fi?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const we=new Set,He=new Set;for(let Qe=0;Qe<F.length;Qe++){const ct=F[Qe],ht=(0,y.normalizeMimeType)(ct.mime);if(!we.has(ht)||(0,k.isTextStreamMime)(ht)){we.add(ht);continue}He.add(Qe),te&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return He.size===0?F:F.filter((Qe,ct)=>!He.has(ct))}constructor(F,te,we){this.items=fi.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=we):(this.id=(0,O.generateUuid)(),this.metadata=te??we)}}e.NotebookCellOutput=fi;var Hi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Hi=e.NotebookCellKind||(e.NotebookCellKind={}));var ne;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(ne=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var de;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(de=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Re;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Re=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ot{constructor(F,te){this.text=F,this.alignment=te}}e.NotebookCellStatusBarItem=ot;var St;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(St=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Pt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Pt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rn{constructor(F,te=[]){this.uri=F,this.provides=(0,r.asArray)(te)}}e.NotebookRendererScript=rn;let Vi=class{constructor(F,te){this.label=F,this.timestamp=te}};Vi=ze([R],Vi),e.TimelineItem=Vi;var sn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class cn{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.LinkedEditingRanges=cn;class ln{constructor(F,te){this._port=F,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ln;var un;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(un=e.TestResultState||(e.TestResultState={}));var dn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ji=class{constructor(F=void 0,te=void 0,we=void 0){this.include=F,this.exclude=te,this.profile=we}};ji=ze([R],ji),e.TestRunRequest=ji;let qi=x=class{static diff(F,te,we){const He=new x(F);return He.expectedOutput=te,He.actualOutput=we,He}constructor(F){this.message=F}};qi=x=ze([R],qi),e.TestMessage=qi;let Ki=class{constructor(F){this.id=F}};Ki=ze([R],Ki),e.TestTag=Ki;let mi=class{constructor(F,te){this.covered=F,this.total=te}};mi=ze([R],mi),e.CoveredCount=mi;let Gi=L=class{static fromDetails(F,te){const we=new mi(0,0),He=new mi(0,0),Qe=new mi(0,0);for(const ht of te)if("branches"in ht){we.total+=1,we.covered+=ht.executionCount>0?1:0;for(const Rt of ht.branches)He.total+=1,He.covered+=Rt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ht.executionCount>0?1:0;const ct=new L(F,we,He.total>0?He:void 0,Qe.total>0?Qe:void 0);return ct.detailedCoverage=te,ct}constructor(F,te,we,He){this.uri=F,this.statementCoverage=te,this.branchCoverage=we,this.functionCoverage=He}};Gi=L=ze([R],Gi),e.FileCoverage=Gi;let Xi=class{constructor(F,te,we=[]){this.executionCount=F,this.location=te,this.branches=we}};Xi=ze([R],Xi),e.StatementCoverage=Xi;let Qi=class{constructor(F,te){this.executionCount=F,this.location=te}};Qi=ze([R],Qi),e.BranchCoverage=Qi;let Yi=class{constructor(F,te){this.executionCount=F,this.location=te}};Yi=ze([R],Yi),e.FunctionCoverage=Yi;var hn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(F,te,we,He,Qe,ct){this.kind=F,this.name=te,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=ct}}e.TypeHierarchyItem=gn;class pn{constructor(F){this.uri=F}}e.TextTabInput=pn;class vn{constructor(F,te){this.original=F,this.modified=te}}e.TextDiffTabInput=vn;class En{constructor(F,te,we,He){this.base=F,this.input1=te,this.input2=we,this.result=He}}e.TextMergeTabInput=En;class bn{constructor(F,te){this.uri=F,this.viewType=te}}e.CustomEditorTabInput=bn;class wn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=wn;class Sn{constructor(F,te){this.uri=F,this.notebookType=te}}e.NotebookEditorTabInput=Sn;class _n{constructor(F,te,we){this.original=F,this.modified=te,this.notebookType=we}}e.NotebookDiffEditorTabInput=_n;class yn{constructor(){}}e.TerminalEditorTabInput=yn;class Dn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.InteractiveWindowInput=Dn}),define(Ce[93],Ie([1,0,45,13,9,242,123,6,18]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function O(p,l){l?P.set(p,l):P.delete(p)}e.setWordDefinitionFor=O;function b(p){return P.get(p)}e.getWordDefinitionFor=b;class m extends M.MirrorTextModel{constructor(l,u,d,g,_,a,w,t){super(u,d,g,_),this._proxy=l,this._languageId=a,this._isDirty=w,this.notebook=t,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,E.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===C.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},save(){return l._save()},getText(u){return u?l._getTextInRange(u):l.getText()},get eol(){return l._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(u){return l._lineAt(u)},offsetAt(u){return l._offsetAt(u)},positionAt(u){return l._positionAt(u)},validateRange(u){return l._validateRange(u)},validatePosition(u){return l._validatePosition(u)},getWordRangeAtPosition(u,d){return l._getWordRangeAtPosition(u,d)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,r.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,r.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const u=this._validateRange(l);if(u.isEmpty)return"";if(u.isSingleLine)return this._lines[u.start.line].substring(u.start.character,u.end.character);const d=this._eol,g=u.start.line,_=u.end.line,a=[];a.push(this._lines[g].substring(u.start.character));for(let w=g+1;w<_;w++)a.push(this._lines[w]);return a.push(this._lines[_].substring(0,u.end.character)),a.join(d)}_lineAt(l){let u;if(l instanceof A.Position?u=l.line:typeof l=="number"&&(u=l),typeof u!="number"||u<0||u>=this._lines.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new k(u,this._lines[u],u===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(l),d=this._lines[u.index].length;return new A.Position(u.index,Math.min(u.remainder,d))}_validateRange(l){if(!(l instanceof A.Range))throw new Error("Invalid argument");const u=this._validatePosition(l.start),d=this._validatePosition(l.end);return u===l.start&&d===l.end?l:new A.Range(u.line,u.character,d.line,d.character)}_validatePosition(l){if(!(l instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:u,character:d}=l,g=!1;if(u<0)u=0,d=0,g=!0;else if(u>=this._lines.length)u=this._lines.length-1,d=this._lines[u].length,g=!0;else{const _=this._lines[u].length;d<0?(d=0,g=!0):d>_&&(d=_,g=!0)}return g?new A.Position(u,d):l}_getWordRangeAtPosition(l,u){const d=this._validatePosition(l);if(!u)u=b(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const g=(0,y.getWordAtText)(d.character+1,(0,y.ensureValidWordDefinition)(u),this._lines[d.line],0);if(g)return new A.Range(d.line,g.startColumn-1,d.line,g.endColumn-1)}}e.ExtHostDocumentData=m;class k{constructor(l,u,d){this._line=l,this._text=u,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=k}),define(Ce[177],Ie([1,0,6,11,5]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let E;switch(A){case"light":E=r.ColorThemeKind.Light;break;case"hcDark":E=r.ColorThemeKind.HighContrast;break;case"hcLight":E=r.ColorThemeKind.HighContrastLight;break;default:E=r.ColorThemeKind.Dark}this._actual=new r.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=ze([$e(0,C.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ce[8],Ie([1,0,18,23,77,24,107,76,25,10,2,49,66,82,90,89,64,40,48,172,6,178]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var t;(function(Se){function Pe(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:nt,positionColumn:We}=q,et=new a.Position(Ae-1,Le-1),lt=new a.Position(nt-1,We-1);return new a.Selection(et,lt)}Se.to=Pe;function fe(q){const{anchor:Ae,active:Le}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=fe})(t=e.Selection||(e.Selection={}));var c;(function(Se){function Pe(q){if(!q)return;const{start:Ae,end:Le}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=Pe;function fe(q){if(!q)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:nt,endColumn:We}=q;return new a.Range(Ae-1,Le-1,nt-1,We-1)}Se.to=fe})(c=e.Range||(e.Range={}));var i;(function(Se){function Pe(fe){switch(fe){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Se.to=Pe})(i=e.TokenType||(e.TokenType={}));var n;(function(Se){function Pe(q){return new a.Position(q.lineNumber-1,q.column-1)}Se.to=Pe;function fe(q){return{lineNumber:q.line+1,column:q.character+1}}Se.from=fe})(n=e.Position||(e.Position={}));var o;(function(Se){function Pe(Ae,Le){return(0,r.coalesce)((0,r.asArray)(Ae).map(nt=>fe(nt,Le)))}Se.from=Pe;function fe(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:q(Ae.scheme,Le),pattern:he.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function q(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(o=e.DocumentSelector||(e.DocumentSelector={}));var f;(function(Se){function Pe(q){switch(q){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Se.from=Pe;function fe(q){switch(q){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Se.to=fe})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(Se){function Pe(q){let Ae;return q.code&&((0,P.isString)(q.code)||(0,P.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...c.from(q.range),message:q.message,source:q.source,code:Ae,severity:v.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(h.from),tags:Array.isArray(q.tags)?(0,r.coalesce)(q.tags.map(f.from)):void 0}}Se.from=Pe;function fe(q){const Ae=new a.Diagnostic(c.to(q),q.message,v.to(q.severity));return Ae.source=q.source,Ae.code=(0,P.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(h.to),Ae.tags=q.tags&&(0,r.coalesce)(q.tags.map(f.to)),Ae}Se.to=fe})(s=e.Diagnostic||(e.Diagnostic={}));var h;(function(Se){function Pe(q){return{...c.from(q.location.range),message:q.message,resource:q.location.uri}}Se.from=Pe;function fe(q){return new a.DiagnosticRelatedInformation(new a.Location(q.resource,c.to(q)),q.message)}Se.to=fe})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var v;(function(Se){function Pe(q){switch(q){case a.DiagnosticSeverity.Error:return k.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return k.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return k.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return k.MarkerSeverity.Hint}return k.MarkerSeverity.Error}Se.from=Pe;function fe(q){switch(q){case k.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case k.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case k.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case k.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Se.to=fe})(v=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var T;(function(Se){function Pe(q){return typeof q=="number"&&q>=a.ViewColumn.One?q-1:q===a.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}Se.from=Pe;function fe(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=fe})(T=e.ViewColumn||(e.ViewColumn={}));function N(Se){return typeof Se.range<"u"}function V(Se){return Se.length===0?!0:!!N(Se[0])}e.isDecorationOptionsArr=V;var U;(function(Se){function Pe(We){return We.map(Se.from)}Se.fromMany=Pe;function fe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function q(We){let et;if(fe(We)){const{language:Et,value:wt}=We;et={value:"```"+Et+`
`+wt+"\n```\n"}}else a.MarkdownString.isMarkdownString(We)?et={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?et={value:We}:et={value:""};const lt=Object.create(null);et.uris=lt;const mt=Et=>{try{let wt=O.URI.parse(Et,!0);wt=wt.with({query:Ae(wt.query,lt)}),lt[Et]=wt}catch{}return""},yt=new y.marked.Renderer;return yt.link=mt,yt.image=Et=>typeof Et=="string"?mt(S.parseHrefAndDimensions(Et).href):"",(0,y.marked)(et.value,{renderer:yt}),et}Se.from=q;function Ae(We,et){if(!We)return We;let lt;try{lt=(0,A.parse)(We)}catch{}if(!lt)return We;let mt=!1;return lt=(0,E.cloneAndChange)(lt,yt=>{if(O.URI.isUri(yt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[Et]=yt,mt=!0,Et}else return}),mt?JSON.stringify(lt):We}function Le(We){const et=new a.MarkdownString(We.value,We.supportThemeIcons);return et.isTrusted=We.isTrusted,et.supportHtml=We.supportHtml,et.baseUri=We.baseUri?O.URI.from(We.baseUri):void 0,et}Se.to=Le;function nt(We){if(!!We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=nt})(U=e.MarkdownString||(e.MarkdownString={}));function D(Se){return V(Se)?Se.map(Pe=>({range:c.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?U.fromMany(Pe.hoverMessage):Pe.hoverMessage?U.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):Se.map(Pe=>({range:c.from(Pe)}))}e.fromRangeOrRangeWithMessage=D;function x(Se){return typeof Se>"u"?Se:typeof Se=="string"?O.URI.file(Se):Se}e.pathOrURIToURI=x;var L;(function(Se){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?x(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Se.from=Pe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(Se){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?x(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?L.from(fe.before):void 0,after:fe.after?L.from(fe.after):void 0}}Se.from=Pe})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(Se){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Pe})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(Se){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?K.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?R.from(fe.light):void 0,dark:fe.dark?R.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?x(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?L.from(fe.before):void 0,after:fe.after?L.from(fe.after):void 0}}Se.from=Pe})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Se){function Pe(q){return{text:q.newText,eol:q.newEol&&Ge.from(q.newEol),range:c.from(q.range)}}Se.from=Pe;function fe(q){const Ae=new a.TextEdit(c.to(q.range),q.text);return Ae.newEol=typeof q.eol>"u"?void 0:Ge.to(q.eol),Ae}Se.to=fe})($=e.TextEdit||(e.TextEdit={}));var G;(function(Se){function Pe(q,Ae){const Le={edits:[]};if(q instanceof a.WorkspaceEdit){const nt=new M.ResourceSet;for(const We of q._allEntries())We._type===1&&O.URI.isUri(We.to)&&We.from===void 0&&nt.add(We.to);for(const We of q._allEntries())We._type===1?Le.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Le.edits.push({resource:We.uri,textEdit:$.from(We.edit),versionId:nt.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Le.edits.push({resource:We.uri,textEdit:{range:c.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:nt.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Le.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Le.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(st.from)}})}return Le}Se.from=Pe;function fe(q){const Ae=new a.WorkspaceEdit;for(const Le of q.edits)Le.textEdit?Ae.replace(O.URI.revive(Le.resource),c.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(O.URI.revive(Le.oldResource),O.URI.revive(Le.newResource),Le.options);return Ae}Se.to=fe})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var re;(function(Se){const Pe=Object.create(null);Pe[a.SymbolKind.File]=0,Pe[a.SymbolKind.Module]=1,Pe[a.SymbolKind.Namespace]=2,Pe[a.SymbolKind.Package]=3,Pe[a.SymbolKind.Class]=4,Pe[a.SymbolKind.Method]=5,Pe[a.SymbolKind.Property]=6,Pe[a.SymbolKind.Field]=7,Pe[a.SymbolKind.Constructor]=8,Pe[a.SymbolKind.Enum]=9,Pe[a.SymbolKind.Interface]=10,Pe[a.SymbolKind.Function]=11,Pe[a.SymbolKind.Variable]=12,Pe[a.SymbolKind.Constant]=13,Pe[a.SymbolKind.String]=14,Pe[a.SymbolKind.Number]=15,Pe[a.SymbolKind.Boolean]=16,Pe[a.SymbolKind.Array]=17,Pe[a.SymbolKind.Object]=18,Pe[a.SymbolKind.Key]=19,Pe[a.SymbolKind.Null]=20,Pe[a.SymbolKind.EnumMember]=21,Pe[a.SymbolKind.Struct]=22,Pe[a.SymbolKind.Event]=23,Pe[a.SymbolKind.Operator]=24,Pe[a.SymbolKind.TypeParameter]=25;function fe(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}Se.from=fe;function q(Ae){for(const Le in Pe)if(Pe[Le]===Ae)return Number(Le);return a.SymbolKind.Property}Se.to=q})(re=e.SymbolKind||(e.SymbolKind={}));var ge;(function(Se){function Pe(q){switch(q){case a.SymbolTag.Deprecated:return 1}}Se.from=Pe;function fe(q){switch(q){case 1:return a.SymbolTag.Deprecated}}Se.to=fe})(ge=e.SymbolTag||(e.SymbolTag={}));var oe;(function(Se){function Pe(q){return{name:q.name,kind:re.from(q.kind),tags:q.tags&&q.tags.map(ge.from),containerName:q.containerName,location:be.from(q.location)}}Se.from=Pe;function fe(q){const Ae=new a.SymbolInformation(q.name,re.to(q.kind),q.containerName,be.to(q.location));return Ae.tags=q.tags&&q.tags.map(ge.to),Ae}Se.to=fe})(oe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Ee;(function(Se){function Pe(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:c.from(q.range),selectionRange:c.from(q.selectionRange),kind:re.from(q.kind),tags:q.tags?.map(ge.from)??[]};return q.children&&(Ae.children=q.children.map(Pe)),Ae}Se.from=Pe;function fe(q){const Ae=new a.DocumentSymbol(q.name,q.detail,re.to(q.kind),c.to(q.range),c.to(q.selectionRange));return(0,r.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(ge.to)),q.children&&(Ae.children=q.children.map(fe)),Ae}Se.to=fe})(Ee=e.DocumentSymbol||(e.DocumentSymbol={}));var ce;(function(Se){function Pe(q){const Ae=new a.CallHierarchyItem(re.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),c.to(q.range),c.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=Pe;function fe(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:q.name,detail:q.detail,kind:re.from(q.kind),uri:q.uri,range:c.from(q.range),selectionRange:c.from(q.selectionRange),tags:q.tags?.map(ge.from)}}Se.from=fe})(ce=e.CallHierarchyItem||(e.CallHierarchyItem={}));var me;(function(Se){function Pe(fe){return new a.CallHierarchyIncomingCall(ce.to(fe.from),fe.fromRanges.map(q=>c.to(q)))}Se.to=Pe})(me=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ee;(function(Se){function Pe(fe){return new a.CallHierarchyOutgoingCall(ce.to(fe.to),fe.fromRanges.map(q=>c.to(q)))}Se.to=Pe})(ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var be;(function(Se){function Pe(q){return{range:q.range&&c.from(q.range),uri:q.uri}}Se.from=Pe;function fe(q){return new a.Location(O.URI.revive(q.uri),c.to(q.range))}Se.to=fe})(be=e.location||(e.location={}));var _e;(function(Se){function Pe(q){const Ae=q,Le=q;return{originSelectionRange:Ae.originSelectionRange?c.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:c.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?c.from(Ae.targetSelectionRange):void 0}}Se.from=Pe;function fe(q){return{targetUri:O.URI.revive(q.uri),targetRange:c.to(q.range),targetSelectionRange:q.targetSelectionRange?c.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?c.to(q.originSelectionRange):void 0}}Se.to=fe})(_e=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Se){function Pe(q){return{range:c.from(q.range),contents:U.fromMany(q.contents)}}Se.from=Pe;function fe(q){return new a.Hover(q.contents.map(U.to),c.to(q.range))}Se.to=fe})(Fe=e.Hover||(e.Hover={}));var Be;(function(Se){function Pe(q){return{range:c.from(q.range),expression:q.expression}}Se.from=Pe;function fe(q){return new a.EvaluatableExpression(c.to(q.range),q.expression)}Se.to=fe})(Be=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(Se){function Pe(q){if(q instanceof a.InlineValueText)return{type:"text",range:c.from(q.range),text:q.text};if(q instanceof a.InlineValueVariableLookup)return{type:"variable",range:c.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Pe;function fe(q){switch(q.type){case"text":return{range:c.to(q.range),text:q.text};case"variable":return{range:c.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:c.to(q.range),expression:q.expression}}}Se.to=fe})(Xe=e.InlineValue||(e.InlineValue={}));var ke;(function(Se){function Pe(q){return{frameId:q.frameId,stoppedLocation:c.from(q.stoppedLocation)}}Se.from=Pe;function fe(q){return new a.InlineValueContext(q.frameId,c.to(q.stoppedLocation))}Se.to=fe})(ke=e.InlineValueContext||(e.InlineValueContext={}));var ye;(function(Se){function Pe(q){return{range:c.from(q.range),kind:q.kind}}Se.from=Pe;function fe(q){return new a.DocumentHighlight(c.to(q.range),q.kind)}Se.to=fe})(ye=e.DocumentHighlight||(e.DocumentHighlight={}));var De;(function(Se){function Pe(fe){switch(fe){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Se.to=Pe})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Se){function Pe(fe){return{triggerKind:De.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Se.to=Pe})(ae=e.CompletionContext||(e.CompletionContext={}));var ue;(function(Se){function Pe(q){switch(q){case a.CompletionItemTag.Deprecated:return 1}}Se.from=Pe;function fe(q){switch(q){case 1:return a.CompletionItemTag.Deprecated}}Se.to=fe})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var Z;(function(Se){const Pe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function fe(Le){return Pe.get(Le)??9}Se.from=fe;const q=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Ae(Le){return q.get(Le)??a.CompletionItemKind.Property}Se.to=Ae})(Z=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(Se){function Pe(fe,q){const Ae=new a.CompletionItem(fe.label);return Ae.insertText=fe.insertText,Ae.kind=Z.to(fe.kind),Ae.tags=fe.tags?.map(ue.to),Ae.detail=fe.detail,Ae.documentation=S.isMarkdownString(fe.documentation)?U.to(fe.documentation):fe.documentation,Ae.sortText=fe.sortText,Ae.filterText=fe.filterText,Ae.preselect=fe.preselect,Ae.commitCharacters=fe.commitCharacters,b.Range.isIRange(fe.range)?Ae.range=c.to(fe.range):typeof fe.range=="object"&&(Ae.range={inserting:c.to(fe.range.insert),replacing:c.to(fe.range.replace)}),Ae.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ae.insertText=new a.SnippetString(fe.insertText):(Ae.insertText=fe.insertText,Ae.textEdit=Ae.range instanceof a.Range?new a.TextEdit(Ae.range,Ae.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ae.additionalTextEdits=fe.additionalTextEdits.map(Le=>$.to(Le))),Ae.command=q&&fe.command?q.fromInternal(fe.command):void 0,Ae}Se.to=Pe})(J=e.CompletionItem||(e.CompletionItem={}));var I;(function(Se){function Pe(q){if(typeof q.label!="string"&&!Array.isArray(q.label))throw new TypeError("Invalid label");return{label:q.label,documentation:U.fromStrict(q.documentation)}}Se.from=Pe;function fe(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?U.to(q.documentation):q.documentation}}Se.to=fe})(I=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(Se){function Pe(q){return{label:q.label,documentation:U.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(I.from):[],activeParameter:q.activeParameter}}Se.from=Pe;function fe(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?U.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(I.to):[],activeParameter:q.activeParameter}}Se.to=fe})(B=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(Se){function Pe(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.from):[]}}Se.from=Pe;function fe(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.to):[]}}Se.to=fe})(H=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(Se){function Pe(fe,q){const Ae=new a.InlayHint(n.to(q.position),typeof q.label=="string"?q.label:q.label.map(se.to.bind(void 0,fe)),q.kind&&le.to(q.kind));return Ae.textEdits=q.textEdits&&q.textEdits.map($.to),Ae.tooltip=S.isMarkdownString(q.tooltip)?U.to(q.tooltip):q.tooltip,Ae.paddingLeft=q.paddingLeft,Ae.paddingRight=q.paddingRight,Ae}Se.to=Pe})(j=e.InlayHint||(e.InlayHint={}));var se;(function(Se){function Pe(fe,q){const Ae=new a.InlayHintLabelPart(q.label);return Ae.tooltip=S.isMarkdownString(q.tooltip)?U.to(q.tooltip):q.tooltip,m.Command.is(q.command)&&(Ae.command=fe.fromInternal(q.command)),q.location&&(Ae.location=be.to(q.location)),Ae}Se.to=Pe})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var le;(function(Se){function Pe(q){return q}Se.from=Pe;function fe(q){return q}Se.to=fe})(le=e.InlayHintKind||(e.InlayHintKind={}));var Y;(function(Se){function Pe(q){return{range:c.from(q.range),url:q.target,tooltip:q.tooltip}}Se.from=Pe;function fe(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?O.URI.parse(q.url,!0):O.URI.revive(q.url)}catch{}return new a.DocumentLink(c.to(q.range),Ae)}Se.to=fe})(Y=e.DocumentLink||(e.DocumentLink={}));var ve;(function(Se){function Pe(q){const Ae=new a.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=$.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Le=>$.to(Le))),Ae}Se.to=Pe;function fe(q){return{label:q.label,textEdit:q.textEdit?$.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>$.from(Ae)):void 0}}Se.from=fe})(ve=e.ColorPresentation||(e.ColorPresentation={}));var pe;(function(Se){function Pe(q){return new a.Color(q[0],q[1],q[2],q[3])}Se.to=Pe;function fe(q){return[q.red,q.green,q.blue,q.alpha]}Se.from=fe})(pe=e.Color||(e.Color={}));var Me;(function(Se){function Pe(q){return{range:c.from(q.range)}}Se.from=Pe;function fe(q){return new a.SelectionRange(c.to(q.range))}Se.to=fe})(Me=e.SelectionRange||(e.SelectionRange={}));var xe;(function(Se){function Pe(fe){switch(fe){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Se.to=Pe})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ye;(function(Se){function Pe(q){switch(q){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Pe;function fe(q){switch(q){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Se.to=fe})(Ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(Se){function Pe(q){if(q===a.EndOfLine.CRLF)return 1;if(q===a.EndOfLine.LF)return 0}Se.from=Pe;function fe(q){if(q===1)return a.EndOfLine.CRLF;if(q===0)return a.EndOfLine.LF}Se.to=fe})(Ge=e.EndOfLine||(e.EndOfLine={}));var Te;(function(Se){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Pe})(Te=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(Se){function Pe(fe){const q={start:fe.start+1,end:fe.end+1};return fe.kind&&(q.kind=X.from(fe.kind)),q}Se.from=Pe})(rt=e.FoldingRange||(e.FoldingRange={}));var X;(function(Se){function Pe(fe){if(fe)switch(fe){case a.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Se.from=Pe})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(Se){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?c.from(fe.selection):void 0,override:typeof fe.override=="boolean"?l.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Pe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(Se){function Pe(Le){return Le instanceof a.RelativePattern?Le.toJSON():typeof Le=="string"?Le:fe(Le)||q(Le)?new a.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=Pe;function fe(Le){const nt=Le;return nt?O.URI.isUri(nt.baseUri)&&typeof nt.pattern=="string":!1}function q(Le){const nt=Le;return nt?typeof nt.base=="string"&&typeof nt.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new a.RelativePattern(O.URI.revive(Le.baseUri),Le.pattern)}Se.to=Ae})(he=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(Se){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const q=fe;return{language:q.language,scheme:q.scheme,pattern:he.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}Se.from=Pe})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var je;(function(Se){function Pe(q){return{start:q.start,end:q.end}}Se.from=Pe;function fe(q){return new a.NotebookRange(q.start,q.end)}Se.to=fe})(je=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(Se){function Pe(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Se.to=Pe;function fe(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}Se.from=fe})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(Se){function Pe(fe){if(fe===u.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(fe===u.NotebookCellExecutionState.Pending)return;if(fe===u.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Se.to=Pe})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(Se){function Pe(q){switch(q){case a.NotebookCellKind.Markup:return u.CellKind.Markup;case a.NotebookCellKind.Code:default:return u.CellKind.Code}}Se.from=Pe;function fe(q){switch(q){case u.CellKind.Markup:return a.NotebookCellKind.Markup;case u.CellKind.Code:default:return a.NotebookCellKind.Code}}Se.to=fe})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(Se){function Pe(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(const Le of q.cells)a.NotebookCellData.validate(Le),Ae.cells.push(st.from(Le));return Ae}Se.from=Pe;function fe(q){const Ae=new a.NotebookData(q.cells.map(st.to));return(0,P.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}Se.to=fe})(it=e.NotebookData||(e.NotebookData={}));var st;(function(Se){function Pe(q){return{cellKind:Ve.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:Ze.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(_t.from):[]}}Se.from=Pe;function fe(q){return new a.NotebookCellData(Ve.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(_t.to):void 0,q.metadata,q.internalMetadata?Ze.to(q.internalMetadata):void 0)}Se.to=fe})(st=e.NotebookCellData||(e.NotebookCellData={}));var dt;(function(Se){function Pe(q){return{mime:q.mime,valueBytes:C.VSBuffer.wrap(q.data)}}Se.from=Pe;function fe(q){return new a.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}Se.to=fe})(dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var _t;(function(Se){function Pe(q){return{outputId:q.id,items:q.items.map(dt.from),metadata:q.metadata}}Se.from=Pe;function fe(q){const Ae=q.items.map(dt.to);return new a.NotebookCellOutput(Ae,q.outputId,q.metadata)}Se.to=fe})(_t=e.NotebookCellOutput||(e.NotebookCellOutput={}));var tt;(function(Se){function Pe(Ae){return q(Ae)?{include:(0,P.withNullAsUndefined)(he.from(Ae.include)),exclude:(0,P.withNullAsUndefined)(he.from(Ae.exclude))}:(0,P.withNullAsUndefined)(he.from(Ae))}Se.from=Pe;function fe(Ae){return q(Ae)?{include:he.to(Ae.include),exclude:he.to(Ae.exclude)}:he.to(Ae)}Se.to=fe;function q(Ae){const Le=Ae;return Le?!(0,P.isUndefinedOrNull)(Le.include)&&!(0,P.isUndefinedOrNull)(Le.exclude):!1}})(tt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ut;(function(Se){function Pe(fe,q,Ae){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,Ae),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Se.from=Pe})(ut=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ot;(function(Se){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Se.from=Pe})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ht;(function(Se){function Pe(q){return{uri:q.uri,provides:q.provides}}Se.from=Pe;function fe(q){return new a.NotebookRendererScript(O.URI.revive(q.uri),q.provides)}Se.to=fe})(Ht=e.NotebookRendererScript||(e.NotebookRendererScript={}));var At;(function(Se){function Pe(q){return{message:U.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:c.from(q.location.range),uri:q.location.uri}}}Se.from=Pe;function fe(q){const Ae=new a.TestMessage(typeof q.message=="string"?q.message:U.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?be.to(q.location):void 0,Ae}Se.to=fe})(At=e.TestMessage||(e.TestMessage={}));var ft;(function(Se){Se.namespace=g.namespaceTestTag,Se.denamespace=g.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Ct;(function(Se){function Pe(q){const Ae=(0,p.getPrivateApiFor)(q).controllerId;return{extId:d.TestId.fromExtHostTestItem(q,Ae).toString(),label:q.label,uri:O.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(Le=>ft.namespace(Ae,Le.id)),range:b.Range.lift(c.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&U.fromStrict(q.error)||null}}Se.from=Pe;function fe(q){return{parent:void 0,error:void 0,id:d.TestId.fromString(q.extId).localId,label:q.label,uri:O.URI.revive(q.uri),tags:(q.tags||[]).map(Ae=>{const{tagId:Le}=ft.denamespace(Ae);return new a.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}Se.toPlain=fe})(Ct=e.TestItem||(e.TestItem={})),function(Se){function Pe(q){return{id:q.id}}Se.from=Pe;function fe(q){return new a.TestTag(q.id)}Se.to=fe}(ft=e.TestTag||(e.TestTag={}));var Lt;(function(Se){const Pe=(q,Ae)=>{const Le=[];for(const[We,et]of Ae)d.TestId.compare(et.item.extId,We)===2&&(Ae.delete(We),Le.push(et));const nt={...Ct.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(et=>et.type===0).map(At.to)})),children:Le.map(We=>Pe(We,Ae))};for(const We of nt.children)We.parent=nt;return nt};function fe(q){const Ae=[],Le=new Map;for(const nt of q.items){Le.set(nt.item.extId,nt);const We=d.TestId.root(nt.item.extId);q.request.targets.some(et=>et.controllerId===We&&et.testIds.includes(nt.item.extId))&&Ae.push(nt)}return{completedAt:q.completedAt,results:Ae.map(nt=>Pe(nt,Le))}}Se.to=fe})(Lt=e.TestResults||(e.TestResults={}));var xt;(function(Se){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function fe(Le){return"line"in Le?n.from(Le):c.from(Le)}function q(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(nt=>({count:nt.executionCount,location:nt.location&&fe(nt.location)})):void 0}:{type:0,count:Le.executionCount,location:fe(Le.location)}}Se.fromDetailed=q;function Ae(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(q)}}Se.fromFile=Ae})(xt=e.TestCoverage||(e.TestCoverage={}));var qe;(function(Se){function Pe(fe){switch(fe){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Se.to=Pe})(qe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(Se){function Pe(q){const Ae=new a.TypeHierarchyItem(re.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),c.to(q.range),c.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=Pe;function fe(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:re.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:c.from(q.range),selectionRange:c.from(q.selectionRange),tags:q.tags?.map(ge.from)}}Se.from=fe})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var It;(function(Se){function Pe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}Se.from=Pe})(It=e.ViewBadge||(e.ViewBadge={}));var Nt;(function(Se){function Pe(fe,q){const Ae=fe.fileData;return Ae?new class extends a.DataTransferItem{asFile(){return{name:Ae.name,uri:O.URI.revive(Ae.uri),data:(0,w.once)(()=>q())}}}("",fe.id):new a.DataTransferItem(fe.asString)}Se.toDataTransferItem=Pe})(Nt=e.DataTransferItem||(e.DataTransferItem={}));var gt;(function(Se){function Pe(q,Ae){const Le=q.items.map(([nt,We])=>[nt,Nt.toDataTransferItem(We,()=>Ae(We.id))]);return new a.DataTransfer(Le)}Se.toDataTransfer=Pe;async function fe(q){const Ae={items:[]},Le=[];return q.forEach((nt,We)=>{Le.push((async()=>{const et=await nt.asString(),lt=nt.asFile();Ae.items.push([We,{id:nt.id,asString:et,fileData:lt?{name:lt.name,uri:lt.uri}:void 0}])})())}),await Promise.all(Le),Ae}Se.toDataTransferDTO=fe})(gt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[179],Ie([1,0,2,12,6,8,149]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(P,O,b,m={timeout:1500,errors:3}){this._logService=P,this._documents=O,this._mainThreadBulkEdits=b,this._thresholds=m,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(O,b,m)=>{const p={dispose:this._callbacks.push([O,b,P])};return Array.isArray(m)&&m.push(p),p}}async $participateInSave(P,O){const b=r.URI.revive(P);let m=!1;const k=setTimeout(()=>m=!0,this._thresholds.timeout),p=[];try{for(const l of[...this._callbacks]){if(m)break;const u=this._documents.getDocument(b),d=await this._deliverEventAsyncAndBlameBadListeners(l,{document:u,reason:M.TextDocumentSaveReason.to(O)});p.push(d)}}finally{clearTimeout(k)}return p}_deliverEventAsyncAndBlameBadListeners([P,O,b],m){const k=this._badListeners.get(P);return typeof k=="number"&&k>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,P,O,m).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const l=this._badListeners.get(P);this._badListeners.set(P,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,O,b,m){const k=[],p=Date.now(),{document:l,reason:u}=m,{version:d}=l,g=Object.freeze({document:l,reason:u,waitUntil(_){if(Object.isFrozen(k))throw(0,C.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(_))}});try{O.apply(b,[g])}catch(_){return Promise.reject(_)}return Object.freeze(k),new Promise((_,a)=>{const w=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(k).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(w),_(t)}).catch(t=>{clearTimeout(w),a(t)})}).then(_=>{const a={edits:[]};for(const w of _)if(Array.isArray(w)&&w.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:c,range:i}of w)a.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:i&&M.Range.from(i),text:t,eol:c&&M.EndOfLine.from(c)}});if(a.edits.length!==0)return d===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ce[180],Ie([1,0,13,2,8,6,64]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(b,m,k,p){this.start=b,this.deletedCount=m,this.deletedItems=k,this.items=p}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(b,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:b}}constructor(b,m,k){this.notebook=b,this._extHostDocument=m,this._cellData=k,this.handle=k.handle,this.uri=C.URI.revive(k.uri),this.cellKind=k.cellKind,this._outputs=k.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=k.internalMetadata??{},this._metadata=Object.freeze(k.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return b._mime},set mime(p){b._mime=p},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}};this._apiCell=Object.freeze(k)}return this._apiCell}setOutputs(b){this._outputs=b.map(S.NotebookCellOutput.to)}setOutputItems(b,m,k){const p=k.map(S.NotebookCellOutputItem.to),l=this._outputs.find(u=>u.id===b);l&&(m||(l.items.length=0),l.items.push(...p))}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=E;class P{constructor(b,m,k,p,l){this._proxy=b,this._textDocumentsAndEditors=m,this._textDocuments=k,this.uri=p,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=l.viewType,this._metadata=Object.freeze(l.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,l.cells]],!0,void 0),this._versionId=l.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this,m={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===r.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(k){return k=b._validateIndex(k),b._cells[k].apiCell},getCells(k){return(k?b._getCells(k):b._cells).map(l=>l.apiCell)},save(){return b._save()}};this._notebook=Object.freeze(m)}return this._notebook}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,m,k){this._versionId=b.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:k});const p={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},l=[];for(const d of b.rawEvents)d.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1,p.contentChanges):d.kind===y.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx,p.contentChanges):d.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(d.index,d.outputs),l.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems),l.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(d.index,d.language),l.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document})):d.kind===y.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document}):d.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(d.index,d.metadata),l.push({cell:this._cells[d.index].apiCell,metadata:this._cells[d.index].apiCell.metadata})):d.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(d.index,d.internalMetadata),l.push({cell:this._cells[d.index].apiCell,executionSummary:this._cells[d.index].apiCell.executionSummary}));const u=new Map;for(let d=0;d<l.length;d++){const g=l[d],_=u.get(g.cell);if(_===void 0){const a=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});u.set(g.cell,a-1)}else p.cellChanges[_]={...p.cellChanges[_],...g}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let m=b.start|0,k=b.end|0;return m<0&&(m=0),k>this._cells.length&&(k=this._cells.length),b.with({start:m,end:k})}_getCells(b){b=this._validateRange(b);const m=[];for(let k=b.start;k<b.end;k++)m.push(this._cells[k]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,m,k){if(this._disposed)return;const p=[],l=[],u=[];if(b.reverse().forEach(d=>{const _=d[2].map(t=>{const c=new E(this,this._textDocumentsAndEditors,t);return m||l.push(E.asModelAddData(this.apiNotebook,t)),c}),a=new A(d[0],d[1],[],_),w=this._cells.splice(d[0],d[1],..._);for(const t of w)u.push(t.uri),a.deletedItems.push(t.apiCell);p.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:u}),k)for(const d of p)k.push(d.asApiEvent())}_moveCell(b,m,k){const p=this._cells.splice(b,1);this._cells.splice(m,0,...p);const l=[new A(b,1,p.map(u=>u.apiCell),[]),new A(m,0,[],p)];for(const u of l)k.push(u.asApiEvent())}_setCellOutputs(b,m){this._cells[b].setOutputs(m)}_setCellOutputItems(b,m,k,p){this._cells[b].setOutputItems(m,k,p)}_changeCellLanguage(b,m){const k=this._cells[b];k.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(k.uri,m)}_changeCellMime(b,m){const k=this._cells[b];k.apiCell.mime=m}_changeCellMetadata(b,m){this._cells[b].setMetadata(m)}_changeCellInternalMetadata(b,m){this._cells[b].setInternalMetadata(m)}getCellFromApiCell(b){return this._cells.find(m=>m.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(m=>m.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Ce[94],Ie([1,0,12,8,6]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,E,P,O,b,m){this.id=A,this._proxy=E,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=b,this._visibleRanges=O,this._viewColumn=m}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(E){this.selections=[E]},get selections(){return A._selections},set selections(E){if(!Array.isArray(E)||!E.every(S.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");A._selections=E,A._trySetSelections(E)},get visibleRanges(){return A._visibleRanges},revealRange(E,P){A._proxy.$tryRevealRange(A.id,C.NotebookRange.from(E),P??S.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(C.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ce[181],Ie([1,0,5,14,8]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,E){this._logService=A,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,E);const P=this._notebooksAndEditors.getEditorById(A);E.visibleRanges&&P._acceptVisibleRanges(E.visibleRanges.ranges.map(S.NotebookRange.to)),E.selections&&P._acceptSelections(E.selections.selections.map(S.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const E in A)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(S.ViewColumn.to(A[E]))}};M=ze([$e(0,C.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ce[182],Ie([1,0,8,152,132,20,55,12]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,k,p){const l=this._handles++,{title:u,location:d,cancellable:g}=k,_={label:(0,S.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(l,{location:r.ProgressLocation.from(d),title:u,source:_,cancellable:g},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(l,p,!!g)}_withProgress(m,k,p){let l;p&&(l=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,l));const u=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),l?.dispose()};let d;try{d=k(new O(this._proxy,m),p&&l?l.token:M.CancellationToken.None)}catch(g){throw u(m),g}return d.then(g=>u(m),g=>u(m)),d}$acceptProgressCanceled(m){const k=this._mapHandleToCancellationSource.get(m);k&&(k.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=E;function P(b,m){return b.message=m.message,typeof m.increment=="number"&&(typeof b.increment=="number"?b.increment+=m.increment:b.increment=m.increment),b}class O extends C.Progress{constructor(m,k){super(p=>this.throttledReport(p)),this._proxy=m,this._handle=k}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}ze([(0,y.throttle)(100,(b,m)=>P(b,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ce[95],Ie([1,0,49,90,40,65,48,8,2]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(_,a,w,t)=>{let c=a;return{enumerable:!0,configurable:!1,get(){return c},set(i){if(!w(c,i)){const n=c;c=i,_.listener?.(t(i,n))}}}},O=(_,a)=>_===a,b={range:(_,a)=>_===a?!0:!_||!a?!1:_.isEqual(a),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(_,a)=>!(_.length!==a.length||_.some(w=>!a.find(t=>w.id===t.id)))},m=_=>a=>({op:4,update:_(a)}),k=(_,a)=>({range:(()=>{let w;const t=m(c=>({range:r.Range.lift(A.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return w},set(c){_.listener?.({op:6}),b.range(w,c)||(w=c,_.listener?.(t(c)))}}})(),label:P(_,a,b.label,m(w=>({label:w}))),description:P(_,void 0,b.description,m(w=>({description:w}))),sortText:P(_,void 0,b.sortText,m(w=>({sortText:w}))),canResolveChildren:P(_,!1,b.canResolveChildren,w=>({op:2,state:w})),busy:P(_,!1,b.busy,m(w=>({busy:w}))),error:P(_,void 0,b.error,m(w=>({error:A.MarkdownString.fromStrict(w)||null}))),tags:P(_,[],b.tags,(w,t)=>({op:1,new:w.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),p=_=>{const a=S.TestId.fromString(_.extId),w=new u(a.controllerId,a.localId,_.label,E.URI.revive(_.uri)||void 0);return w.range=A.Range.to(_.range||void 0),w.description=_.description||void 0,w.sortText=_.sortText||void 0,w.tags=_.tags.map(t=>A.TestTag.to({id:(0,y.denamespaceTestTag)(t).tagId})),w},l=_=>{let a;for(const w of _.tests){const t=p(w.item);(0,C.getPrivateApiFor)(t).parent=a,a=t}return a};e.toItemFromContext=l;class u{constructor(a,w,t,c){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const i=(0,C.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof d?void 0:i.parent}},children:{value:(0,M.createTestItemChildren)(i,C.getPrivateApiFor,u),enumerable:!0,writable:!1},...k(i,t)})}}e.TestItemImpl=u;class d extends u{constructor(a,w){super(a,a,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class g extends M.TestItemCollection{constructor(a,w,t){super({controllerId:a,getDocumentVersion:c=>c&&t.getDocument(c)?.version,getApiFor:C.getPrivateApiFor,getChildren:c=>c.children,root:new d(a,w),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(Ce[96],Ie([1,0,45,12,74,8,6]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(m,k,p){const l=A._Keys.nextId();m.$registerTextEditorDecorationType(k.identifier,l,M.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:l,dispose(){m.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=A,A._Keys=new S.IdGenerator("TextEditorDecorationType");class E{constructor(m,k){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=k.undoStopBefore,this._undoStopAfter=k.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,k){this._throwIfFinalized();let p=null;if(m instanceof y.Position)p=new y.Range(m,m);else if(m instanceof y.Range)p=m;else throw new Error("Unrecognized location");this._pushEdit(p,k,!1)}insert(m,k){this._throwIfFinalized(),this._pushEdit(new y.Range(m,m),k,!0)}delete(m){this._throwIfFinalized();let k=null;if(m instanceof y.Range)k=m;else throw new Error("Unrecognized location");this._pushEdit(k,null,!0)}_pushEdit(m,k,p){const l=this._document.validateRange(m);this._collectedEdits.push({range:l,text:k,forceMoveMarkers:p})}setEndOfLine(m){if(this._throwIfFinalized(),m!==y.EndOfLine.LF&&m!==y.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=E;class P{constructor(m,k,p,l){this._proxy=m,this._id=k,this._accept(p),this._logService=l;const u=this;this.value={get tabSize(){return u._tabSize},set tabSize(d){u._setTabSize(d)},get insertSpaces(){return u._insertSpaces},set insertSpaces(d){u._setInsertSpaces(d)},get cursorStyle(){return u._cursorStyle},set cursorStyle(d){u._setCursorStyle(d)},get lineNumbers(){return u._lineNumbers},set lineNumbers(d){u._setLineNumbers(d)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const k=Math.floor(m);return k>0?k:null}if(typeof m=="string"){const k=parseInt(m,10);return isNaN(k)?null:k>0?k:null}return null}_setTabSize(m){const k=this._validateTabSize(m);if(k!==null){if(typeof k=="number"){if(this._tabSize===k)return;this._tabSize=k}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:k}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const k=this._validateInsertSpaces(m);if(typeof k=="boolean"){if(this._insertSpaces===k)return;this._insertSpaces=k}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:k}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const k={};let p=!1;if(typeof m.tabSize<"u"){const l=this._validateTabSize(m.tabSize);l==="auto"?(p=!0,k.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,p=!0,k.tabSize=l)}if(typeof m.insertSpaces<"u"){const l=this._validateInsertSpaces(m.insertSpaces);l==="auto"?(p=!0,k.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,p=!0,k.insertSpaces=l)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,p=!0,k.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,p=!0,k.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,k))}_warnOnError(m,k){k.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=P;class O{constructor(m,k,p,l,u,d,g,_){this.id=m,this._proxy=k,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._options=new P(this._proxy,this.id,d,p),this._visibleRanges=g,this._viewColumn=_;const a=this;this.value=Object.freeze({get document(){return l.getValue()},set document(w){throw(0,C.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(w){if(!(w instanceof y.Selection))throw(0,C.illegalArgument)("selection");a._selections=[w],a._trySetSelection()},get selections(){return a._selections},set selections(w){if(!Array.isArray(w)||w.some(t=>!(t instanceof y.Selection)))throw(0,C.illegalArgument)("selections");a._selections=w,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(w){throw(0,C.readonly)("visibleRanges")},get options(){return a._options.value},set options(w){a._disposed||a._options.assign(w)},get viewColumn(){return a._viewColumn},set viewColumn(w){throw(0,C.readonly)("viewColumn")},edit(w,t={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new E(l.getValue(),t);return w(c),a._applyEdit(c)},insertSnippet(w,t,c={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=a._selections.map(n=>M.Range.from(n));else if(t instanceof y.Position){const{lineNumber:n,column:o}=M.Position.from(t);i=[{startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o}]}else if(t instanceof y.Range)i=[M.Range.from(t)];else{i=[];for(const n of t)if(n instanceof y.Range)i.push(M.Range.from(n));else{const{lineNumber:o,column:f}=M.Position.from(n);i.push({startLineNumber:o,startColumn:f,endLineNumber:o,endColumn:f})}}return k.$tryInsertSnippet(m,l.getValue().version,w.value,i,c)},setDecorations(w,t){const c=t.length===0;c&&!a._hasDecorationsForKey.has(w.key)||(c?a._hasDecorationsForKey.delete(w.key):a._hasDecorationsForKey.add(w.key),a._runOnProxy(()=>{if(M.isDecorationOptionsArr(t))return k.$trySetDecorations(m,w.key,M.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let n=0,o=t.length;n<o;n++){const f=t[n];i[4*n]=f.start.line+1,i[4*n+1]=f.start.character+1,i[4*n+2]=f.end.line+1,i[4*n+3]=f.end.character+1}return k.$trySetDecorationsFast(m,w.key,i)}}))},revealRange(w,t){a._runOnProxy(()=>k.$tryRevealRange(m,M.Range.from(w),t||y.TextEditorRevealType.Default))},show(w){k.$tryShowEditor(m,M.ViewColumn.from(w))},hide(){k.$tryHideEditor(m)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,r.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,r.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,r.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,r.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const k=m.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const p=k.edits.map(u=>u.range);p.sort((u,d)=>u.end.line===d.end.line?u.end.character===d.end.character?u.start.line===d.start.line?u.start.character-d.start.character:u.start.line-d.start.line:u.end.character-d.end.character:u.end.line-d.end.line);for(let u=0,d=p.length-1;u<d;u++){const g=p[u].end;if(p[u+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=k.edits.map(u=>({range:M.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,l,{setEndOfLine:typeof k.setEndOfLine=="number"?M.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this._logService.warn(k),null))}}e.ExtHostTextEditor=O}),define(Ce[183],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",localization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.localization.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[184],Ie([1,0,143,12,29,81,84,30,26,183,151]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const b=A.Registry.as(y.Extensions.JSONContribution);class m{constructor(a,w,t){this._messageHandler=a,this._extension=w,this._extensionPointId=t}_msg(a,w){this._messageHandler({type:a,message:w,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(S.default.Error,a)}warn(a){this._msg(S.default.Warning,a)}info(a){this._msg(S.default.Info,a)}}e.ExtensionMessageCollector=m;class k{static _toSet(a){const w=new Set;for(let t=0,c=a.length;t<c;t++)w.add(E.ExtensionIdentifier.toKey(a[t].description.identifier));return w}static compute(a,w){if(!a||!a.length)return new k(w,[]);if(!w||!w.length)return new k([],a);const t=this._toSet(a),c=this._toSet(w),i=w.filter(o=>!t.has(E.ExtensionIdentifier.toKey(o.description.identifier))),n=a.filter(o=>!c.has(E.ExtensionIdentifier.toKey(o.description.identifier)));return new k(i,n)}constructor(a,w){this.added=a,this.removed=w}}e.ExtensionPointUserDelta=k;class p{constructor(a,w){this.name=a,this.defaultExtensionKind=w,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=k.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,C.onUnexpectedError)(a)}}}e.ExtensionPoint=p;const l={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:r.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:r.localize(31,null)},{label:"onUri",body:"onUri",description:r.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(36,null)},{label:"onRenderer",description:r.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(39,null)},{label:"*",description:r.localize(40,null),body:"*"}]}},badges:{type:"array",description:r.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(42,null)},href:{type:"string",description:r.localize(43,null)},description:{type:"string",description:r.localize(44,null)}}}},markdown:{type:"string",description:r.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(49,null),type:"array",items:l,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(50,null)},{body:["workspace"],description:r.localize(51,null)},{body:["ui","workspace"],description:r.localize(52,null)},{body:["workspace","ui"],description:r.localize(53,null)},{body:[],description:r.localize(54,null)}]},capabilities:{description:r.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(58,null),r.localize(59,null),r.localize(60,null)]},description:{type:"string",markdownDescription:r.localize(61,null)}}},untrustedWorkspaces:{description:r.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(64,null),r.localize(65,null),r.localize(66,null)]},restrictedConfigurations:{description:r.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(68,null)}}}}},sponsor:{description:r.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(71,null),type:"string"},"vscode:uninstall":{description:r.localize(72,null),type:"string"}}},icon:{type:"string",description:r.localize(73,null)},l10n:{type:"string",description:r.localize(74,null)}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const w=new p(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,w),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,b.registerSchema(u,e.schema),w}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const g={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(g.ExtensionsRegistry,new d),e.ExtensionsRegistry=A.Registry.as(g.ExtensionsRegistry),b.registerSchema(u,e.schema),b.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(Ce[185],Ie([1,0,140,10,25,184,39,5]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var P;(function(m){function k(p,l,u){if(!p)return;const d=C.isString(p.type)?p.type:void 0;if(!d||d.length===0){u.error(r.localize(3,null));return}const g=[];if(Array.isArray(p.required))for(const _ of p.required)C.isString(_)&&g.push(_);return{extensionId:l.value,taskType:d,required:g,properties:p.properties?S.deepClone(p.properties):{},when:p.when?y.ContextKeyExpr.deserialize(p.when):void 0}}m.from=k})(P||(P={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:r.localize(4,null),type:"array",items:E}});class b{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((k,p)=>{O.setHandler((l,u)=>{this._schema=void 0;try{for(const d of u.removed){const g=d.value;for(const _ of g)this.taskTypes&&_.type&&this.taskTypes[_.type]&&delete this.taskTypes[_.type]}for(const d of u.added){const g=d.value;for(const _ of g){const a=P.from(_,d.description.identifier,d.collector);a&&(this.taskTypes[a.taskType]=a)}}(u.removed.length>0||u.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}k(void 0)})})}onReady(){return this.readyPromise}get(k){return this.taskTypes[k]}all(){return Object.keys(this.taskTypes).map(k=>this.taskTypes[k])}getJsonSchema(){if(this._schema===void 0){const k=[];for(const p of this.all()){const l={type:"object",additionalProperties:!1};p.required.length>0&&(l.required=p.required.slice(0)),p.properties!==void 0?l.properties=S.deepClone(p.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[p.taskType]},k.push(l)}this._schema={oneOf:k}}return this._schema}}e.TaskDefinitionRegistryImpl=b,e.TaskDefinitionRegistry=new b}),define(Ce[186],Ie([1,0,141,10,22,25,39,185]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY={value:r.localize(1,null),original:"Tasks"};var E;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function K(W){if(!W)return R.Strong;switch(W.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=K}(E=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var O;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=K}(O=e.RevealKind||(e.RevealKind={}));var b;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(b=e.RevealProblemKind||(e.RevealProblemKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=K}(b=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(R){function K(W){switch(W.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=K}(m=e.PanelKind||(e.PanelKind={}));var k;(function(R){R.defaults={echo:!0,reveal:O.Always,revealProblems:b.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var p;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(p=e.RuntimeType||(e.RuntimeType={})),function(R){function K($){switch($.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=K;function W($){switch($){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=W}(p=e.RuntimeType||(e.RuntimeType={}));var l;(function(R){function K(W){return C.isString(W)?W:W.value}R.value=K})(l=e.CommandString||(e.CommandString={}));var u;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function K($){return $===R.Clean._id||$===R.Build._id||$===R.Rebuild._id||$===R.Test._id}R.is=K;function W($){if($!==void 0)return C.isString($)?K($)?{_id:$,isDefault:!1}:void 0:$}R.from=W})(u=e.TaskGroup||(e.TaskGroup={}));var d;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var g;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function K(W){switch(W){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=K})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var _;(function(R){R.parallel="parallel",R.sequence="sequence"})(_=e.DependsOrder||(e.DependsOrder={}));var a;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(a=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class t{constructor(K,W,$,G,re,ge){this._label="",this._id=K,W&&(this._label=W),$&&(this.type=$),this.runOptions=G,this.configurationProperties=re,this._source=ge}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,W=!1){if(K===void 0)return!1;if(C.isString(K))return K===this._label||K===this.configurationProperties.identifier||W&&K===this._id;const $=this.getDefinition(!0);return $!==void 0&&$._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class c extends t{constructor(K,W,$,G,re,ge,oe,Ee){super(K,$,void 0,oe,Ee,W),this.command={},this._source=W,this.hasDefinedMatchers=ge,re&&(this.command=re)}clone(){return new c(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case p.Shell:W="shell";break;case p.Process:W="process";break;case p.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(K){return K instanceof c}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(W+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify($)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new c(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=c;class i extends t{constructor(K,W,$,G,re,ge,oe){super(K,$,G,ge,oe,W),this._source=W,this.configures=re}static is(K){return K instanceof i}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(W+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify($)}}e.ConfiguringTask=i;class n extends t{constructor(K,W,$,G,re,ge,oe,Ee,ce){super(K,$,G,Ee,ce,W),this.defines=re,this.hasDefinedMatchers=oe,this.command=ge,this.icon=ce.icon,this.hide=ce.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof n}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new n(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=n;class o extends t{constructor(K,W,$,G,re,ge){super(K,$,G,re,ge,W),this._source=W}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new o(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=o;var f;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(f=e.ExecutionEngine||(e.ExecutionEngine={})),function(R){R._default=R.Terminal}(f=e.ExecutionEngine||(e.ExecutionEngine={}));var s;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(s=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(K){this._order=new Map;for(let W=0;W<K.length;W++)this._order.set(K[W].uri.toString(),W)}compare(K,W){const $=K.getWorkspaceFolder(),G=W.getWorkspaceFolder();if($&&G){let re=this._order.get($.uri.toString());re=re===void 0?0:re+1;let ge=this._order.get(G.uri.toString());return ge=ge===void 0?0:ge+1,re===ge?K._label.localeCompare(W._label):re-ge}else return!$&&G?-1:$&&!G?1:0}}e.TaskSorter=h;var v;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var T;(function(R){R.SingleRun="singleRun",R.Background="background"})(T=e.TaskRunType||(e.TaskRunType={}));var N;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(N=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(R){function K(W,$,G,re,ge){if($){const oe={kind:W,taskId:$._id,taskName:$.configurationProperties.name,runType:$.configurationProperties.isBackground?"background":"singleRun",group:$.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:$};return W==="start"?(oe.terminalId=G,oe.resolvedVariables=re):W==="processStarted"?oe.processId=G:W==="processEnded"&&(oe.exitCode=G),Object.freeze(oe)}else return Object.freeze({kind:"changed"})}R.create=K})(V=e.TaskEvent||(e.TaskEvent={}));var U;(function(R){function K($){const G=Object.keys($).sort();let re="";for(const ge of G){let oe=$[ge];oe instanceof Object?oe=K(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),re+=ge+","+oe+","}return re}function W($){const re={_key:K($),type:$.taskType};return Object.assign(re,$),re}R.create=W})(U=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var D;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection"})(D=e.TaskSettingId||(e.TaskSettingId={}));var x;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(x=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var L;(function(R){function K(W,$){const G=A.TaskDefinitionRegistry.get(W.type);if(G===void 0){const Ee=M.deepClone(W);return delete Ee._key,U.create(Ee)}const re=Object.create(null);re.type=G.taskType;const ge=new Set;G.required.forEach(Ee=>ge.add(Ee));const oe=G.properties;for(const Ee of Object.keys(oe)){const ce=W[Ee];if(ce!=null)re[Ee]=ce;else if(ge.has(Ee)){const me=oe[Ee];if(me.default!==void 0)re[Ee]=M.deepClone(me.default);else switch(me.type){case"boolean":re[Ee]=!1;break;case"number":case"integer":re[Ee]=0;break;case"string":re[Ee]="";break;default:$.error(r.localize(2,null,JSON.stringify(W,void 0,0),Ee));return}}}return U.create(re)}R.createTaskIdentifier=K})(L=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[187],Ie([1,0,12]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,r.onUnexpectedError)(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=C;class S extends C{constructor(){super(),this._hasErr=!0,this._err=new r.CancellationError}}e.CanceledLazyPromise=S}),define(Ce[41],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const C=[];function S(A){const E=new r(A);return C[E.nid]=E,E}e.createProxyIdentifier=S;function M(A){return C[A].sid}e.getStringIdentifierForProxy=M;class y{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=y}),define(Ce[4],Ie([1,0,41]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput"})(S=e.TabInputKind||(e.TabInputKind={}));var M;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var y;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(u){return u._id=b._n++,u}}e.IdObject=b,b._n=0;var m;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var k;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(k=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,r.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,r.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,r.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[67],Ie([1,0,3,14,4,11]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(E,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(S.MainContext.MainThreadTelemetry)}report(E,P,O){const b=this.getUsageKey(E,P);this._reportedUsages.has(b)||(this._reportedUsages.add(b),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:E}))}getUsageKey(E,P){return`${E}-${P.identifier.value}`}};y=ze([$e(0,M.IExtHostRpcService),$e(1,C.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(A,E,P){}})}),define(Ce[188],Ie([1,0,5,4,6,26]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,P,O,b={}){const m=M.ExtensionIdentifier.toKey(E.identifier),k=this._inFlightRequests.get(m)||[],p=[...O].sort().join(" ");let l=k.find(u=>u.providerId===P&&u.scopes===p);if(l)return l.result;{const u=this._getSession(E,m,P,O,b);l={providerId:P,scopes:p,result:u},k.push(l),this._inFlightRequests.set(m,k);try{await u}finally{const d=k.findIndex(g=>g.providerId===P&&g.scopes===p);d>-1&&(k.splice(d),this._inFlightRequests.set(m,k))}return u}}async _getSession(E,P,O,b,m={}){await this._proxy.$ensureProvider(O);const k=E.displayName||E.name;return this._proxy.$getSession(O,b,P,k,m)}async removeSession(E,P){const O=this._authenticationProviders.get(E);return O?O.provider.removeSession(P):this._proxy.$removeSession(E,P)}registerAuthenticationProvider(E,P,O,b){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:P,provider:O,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(k=>k.id===E)||this._providers.push({id:E,label:P});const m=O.onDidChangeSessions(k=>{this._proxy.$sendDidChangeSessions(E,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,P,b?.supportsMultipleAccounts??!1),new S.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(E);const k=this._providers.findIndex(p=>p.id===E);k>-1&&this._providers.splice(k),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,P){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,P){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,P){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,P){return this._onDidChangeSessions.fire({provider:{id:E,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(Ce[189],Ie([1,0,4,11,8]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,E){this._proxy=A.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:P=>E.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,E,P){const O=S.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(O,void 0,P?.isRefactoring??!1)}};M=ze([$e(0,C.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Ce[190],Ie([1,0,4]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(M){const y=M.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(A){return y.$writeText(A)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[37],Ie([1,0,10,6,8,25,4,18,14,76,49,243,2,7,3,11,95,23,41,44]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_){"use strict";var a,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let t=class{constructor(s,h){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,w.set(this,void 0),Je(this,a,s.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=h,Je(this,w,s.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new c(this,v=>{const T=this._apiCommands.get(v);return T?.result===n.Void?T:void 0},h),this._argumentProcessors=[{processArgument(v){return(0,P.revive)(v)}},{processArgument(v){return(0,M.cloneAndChange)(v,function(T){if(O.Range.isIRange(T))return S.Range.to(T);if(b.Position.isIPosition(T))return S.Position.to(T);if(O.Range.isIRange(T.range)&&m.URI.isUri(T.uri))return S.location.to(T);if(T instanceof d.VSBuffer)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const h=this.registerCommand(!1,s.id,async(...v)=>{const T=s.args.map((V,U)=>{if(!V.validate(v[U]))throw new Error(`Invalid argument '${V.name}' when running '${s.id}', received: ${v[U]}`);return V.convert(v[U])}),N=await this.executeCommand(s.internalId,...T);return s.result.convert(N,v,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new C.Disposable(()=>{h.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,h,v,T,N,V){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:v,thisArg:T,description:N,extension:V}),s&&Oe(this,a,"f").$registerCommand(h),new C.Disposable(()=>{this._commands.delete(h)&&s&&Oe(this,a,"f").$unregisterCommand(h)})}executeCommand(s,...h){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,h,!0)}async _doExecuteCommand(s,h,v){if(this._commands.has(s))return Oe(this,a,"f").$fireCommandActivationEvent(s),this._executeContributedCommand(s,h,!1);{let T=!1;const N=(0,M.cloneAndChange)(h,function(V){if(V instanceof C.Position)return S.Position.from(V);if(V instanceof C.Range)return S.Range.from(V);if(V instanceof C.Location)return S.location.from(V);if(C.NotebookRange.isNotebookRange(V))return S.NotebookRange.from(V);if(V instanceof ArrayBuffer)return T=!0,d.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return T=!0,d.VSBuffer.wrap(V);if(V instanceof d.VSBuffer)return T=!0,V;if(!Array.isArray(V))return V});try{const V=await Oe(this,a,"f").$executeCommand(s,T?new g.SerializableObjectWithBuffers(N):N,v);return(0,P.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this._doExecuteCommand(s,h,!1);throw V}}}async _executeContributedCommand(s,h,v){const T=this._commands.get(s);if(!T)throw new Error("Unknown command");this._reportTelemetry(T,s);const{callback:N,thisArg:V,description:U}=T;if(U)for(let D=0;D<U.args.length;D++)try{(0,r.validateConstraint)(h[D],U.args[D].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${U.args[D].name}' - ${U.args[D].description}`)}try{return await N.apply(V,h)}catch(D){if(s===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...h);x&&(s=x.command)}throw this._logService.error(D,s,T.extension?.identifier),v?new class extends Error{constructor(){super((0,_.toErrorMessage)(D)),this.id=s,this.source=T.extension?.displayName??T.extension?.name}}:D}}_reportTelemetry(s,h){!s.extension||s.extension.isBuiltin||Oe(this,w,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:h})}$executeContributedCommand(s,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(h=h.map(v=>this._argumentProcessors.reduce((T,N)=>N.processArgument(T),v)),this._executeContributedCommand(s,h,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),Oe(this,a,"f").$getCommands().then(h=>(s&&(h=h.filter(v=>v[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[h,v]of this._commands){const{description:T}=v;T&&(s[h]=T)}return Promise.resolve(s)}};a=new WeakMap,w=new WeakMap,t=ze([$e(0,l.IExtHostRpcService),$e(1,E.ILogService)],t),e.ExtHostCommands=t,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class c{constructor(s,h,v){this._commands=s,this._lookupApiCommand=h,this._logService=v,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,h){if(!s)return;const v={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return v;const T=this._lookupApiCommand(s.command);if(T)v.id=T.internalId,v.arguments=T.args.map((N,V)=>N.convert(s.arguments&&s.arguments[V]));else if((0,A.isNonEmptyArray)(s.arguments)){const N=++this._cachIdPool;this._cache.set(N,s),h.add((0,k.toDisposable)(()=>{this._cache.delete(N),this._logService.trace("CommandsConverter#DISPOSE",N)})),v.$ident=N,v.id=this.delegatingCommandId,v.arguments=[N],this._logService.trace("CommandsConverter#CREATE",s.command,N)}return v}fromInternal(s){return typeof s.$ident=="number"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const h=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=c;class i{constructor(s,h,v,T){this.name=s,this.description=h,this.validate=v,this.convert=T}optional(){return new i(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,h){return new i(s??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",f=>m.URI.isUri(f),f=>f),i.Position=new i("position","A position in a text document",f=>C.Position.isPosition(f),S.Position.from),i.Range=new i("range","A range in a text document",f=>C.Range.isRange(f),S.Range.from),i.Selection=new i("selection","A selection in a text document",f=>C.Selection.isSelection(f),S.Selection.from),i.Number=new i("number","",f=>typeof f=="number",f=>f),i.String=new i("string","",f=>typeof f=="string",f=>f),i.CallHierarchyItem=new i("item","A call hierarchy item",f=>f instanceof C.CallHierarchyItem,S.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",f=>f instanceof C.TypeHierarchyItem,S.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",f=>f instanceof u.TestItemImpl,S.TestItem.from);class n{constructor(s,h){this.description=s,this.convert=h}}e.ApiCommandResult=n,n.Void=new n("no result",f=>f);class o{constructor(s,h,v,T,N){this.id=s,this.internalId=h,this.description=v,this.args=T,this.result=N}}e.ApiCommand=o}),define(Ce[191],Ie([1,0,2,8,6,66,37,18,79,83,13]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",k(C.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,u)=>{if((0,A.isFalsyOrEmpty)(l))return;class d extends S.SymbolInformation{static to(_){const a=new d(_.name,C.SymbolKind.to(_.kind),_.containerName||"",new S.Location(u[0],C.Range.to(_.range)));return a.detail=_.detail,a.range=a.location.range,a.selectionRange=C.Range.to(_.selectionRange),a.children=_.children?_.children.map(d.to):[],a}}return l.map(d.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(C.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(C.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(C.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",k(C.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",k(C.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(u=>S.Position.isPosition(u)),l=>l.map(C.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(u=>{let d;for(const g of u.reverse())d=new S.SelectionRange(C.Range.to(g),d);return d}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(C.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(C.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(C.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(C.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:C.Range.to(l.range),placeholder:l.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return C.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(C.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new S.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const u=(0,E.decodeSemanticTokensDto)(l);if(u.type==="full")return new S.SemanticTokens(u.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new S.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const u=(0,E.decodeSemanticTokensDto)(l);if(u.type==="full")return new S.SemanticTokens(u.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,u,d)=>{if(!l)return new S.CompletionList([]);const g=l.suggestions.map(_=>C.CompletionItem.to(_,d));return new S.CompletionList(g,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return C.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,u,d)=>k(g=>new S.CodeLens(C.Range.to(g.range),g.command&&d.fromInternal(g.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>S.Range.isRange(l),l=>S.Selection.isSelection(l)?C.Selection.from(l):C.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,u,d)=>k(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(g.command)}else{const _=new S.CodeAction(g.title,g.kind?new S.CodeActionKind(g.kind):void 0);return g.edit&&(_.edit=C.WorkspaceEdit.to(g.edit)),g.command&&(_.command=d.fromInternal(g.command)),_.isPreferred=g.isPreferred,_}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(u=>new S.ColorInformation(C.Range.to(u.range),C.Color.to(u.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof S.Color,C.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:C.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(C.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,u,d)=>l.map(C.InlayHint.to.bind(void 0,d)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",k(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(u=>C.NotebookExclusiveDocumentPattern.to(u))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(C.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",l=>r.URI.isUri(l)||typeof l=="string"&&(0,P.matchesSomeScheme)(l,O.Schemas.http,O.Schemas.https),l=>l),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[C.ViewColumn.from(l),void 0]:[C.ViewColumn.from(l.viewColumn),C.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[C.ViewColumn.from(l),void 0]:[C.ViewColumn.from(l.viewColumn),C.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[C.ViewColumn.from(l.viewColumn),C.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(C.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(C.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(C.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class m{static register(u){b.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=m;function k(l){return u=>{if(Array.isArray(u))return u.map(l)}}function p(l){if(!Array.isArray(l))return;const u=[];for(const d of l)M.isLocationLink(d)?u.push(C.DefinitionLink.to(d)):u.push(C.location.to(d));return u}}),define(Ce[192],Ie([1,0,15,55,5,7,2,66,26,8,6,28,4]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function k(p,l,u){const d=p.getProxy(m.MainContext.MainThreadComments);class g{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const s=this._commentControllers.get(f.handle);return s?s.value:f}else if(f&&f.$mid===7){const s=this._commentControllers.get(f.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.commentThreadHandle);return h?h.value:f}else if(f&&f.$mid===8){const s=this._commentControllers.get(f.thread.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.thread.commentThreadHandle);return h?{thread:h.value,text:f.text}:f}else if(f&&f.$mid===9){const s=this._commentControllers.get(f.thread.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const v=f.commentUniqueId,T=h.getCommentByUniqueId(v);return T||f}else if(f&&f.$mid===10){const s=this._commentControllers.get(f.thread.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const v=f.text,T=f.commentUniqueId,N=h.getCommentByUniqueId(T);return N?(typeof N.body=="string"?N.body=v:N.body.value=v,N):f}return f}})}createCommentController(f,s,h){const v=g.handlePool++,T=new a(f,v,s,h);this._commentControllers.set(T.handle,T);const N=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(f.identifier))||[];return N.push(T),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(f.identifier),N),T.value}$createCommentThreadTemplate(f,s,h){const v=this._commentControllers.get(f);!v||v.$createCommentThreadTemplate(s,h)}async $updateCommentThreadTemplate(f,s,h){const v=this._commentControllers.get(f);!v||v.$updateCommentThreadTemplate(s,h)}$deleteCommentThread(f,s){this._commentControllers.get(f)?.$deleteCommentThread(s)}$provideCommentingRanges(f,s,h){const v=this._commentControllers.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const T=u.getDocument(y.URI.revive(s));return(0,r.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(T,h)).then(N=>N?N.map(V=>P.Range.from(V)):void 0)}$toggleReaction(f,s,h,v,T){const N=this._commentControllers.get(f);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const V=N.getCommentThread(s);if(V){const U=V.getCommentByUniqueId(v.uniqueIdInThread);if(N!==void 0&&U&&N.reactionHandler)return N.reactionHandler(U,c(T))}return Promise.resolve(void 0)})}dispose(){}}g.handlePool=0;class _{set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(f){(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,s,h,v,T,N,V,U){this._commentControllerHandle=s,this._id=h,this._uri=v,this._range=T,this._comments=N,this.extensionDescription=V,this._isTemplate=U,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),d.$createCommentThread(s,this.handle,this._id,this._uri,P.Range.from(this._range),V.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(s,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(x){D.range=x},get comments(){return D.comments},set comments(x){D.comments=x},get collapsibleState(){return D.collapsibleState},set collapsibleState(x){D.collapsibleState=x},get canReply(){return D.canReply},set canReply(x){D.canReply=x},get contextValue(){return D.contextValue},set contextValue(x){D.contextValue=x},get label(){return D.label},set label(x){D.label=x},get state(){return D.state},set state(x){D.state=x},dispose:()=>{D.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const f=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),s={};f("range")&&(s.range=P.Range.from(this._range)),f("label")&&(s.label=this.label),f("contextValue")&&(s.contextValue=this.contextValue??null),f("comments")&&(s.comments=this._comments.map(h=>w(this,h,this._commentsMap))),f("collapsibleState")&&(s.collapseState=i(this._collapseState)),f("canReply")&&(s.canReply=this.canReply),f("state")&&(s.state=n(this._state)),f("isTemplate")&&(s.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(f){for(const s of this._commentsMap){const h=s[0],v=s[1];if(f===v)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}_._handlePool=0,ze([(0,C.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,s,h,v){this._extension=f,this._handle=s,this._id=h,this._label=v,this._threads=new Map,d.$registerCommentController(this.handle,h,v);const T=this;this.value=Object.freeze({id:T.id,label:T.label,get options(){return T.options},set options(N){T.options=N},get commentingRangeProvider(){return T.commentingRangeProvider},set commentingRangeProvider(N){T.commentingRangeProvider=N},get reactionHandler(){return T.reactionHandler},set reactionHandler(N){T.reactionHandler=N},createCommentThread(N,V,U){return T.createCommentThread(N,V,U).value},dispose:()=>{T.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(f,s,h,v){if(typeof f=="string"){const T=new _(this.id,this.handle,f,s,h,v,this._extension,!1);return this._threads.set(T.handle,T),T}else{const T=new _(this.id,this.handle,void 0,f,s,h,this._extension,!1);return this._threads.set(T.handle,T),T}}$createCommentThreadTemplate(f,s){const h=new _(this.id,this.handle,void 0,y.URI.revive(f),P.Range.to(s),[],this._extension,!0);return h.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(f,s){const h=this._threads.get(f);h&&(h.range=P.Range.to(s))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function w(o,f,s){let h=s.get(f);h||(h=++o.commentHandle,s.set(f,h));const v=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:h,body:typeof f.body=="string"?f.body:P.MarkdownString.from(f.body),userName:f.author.name,userIconPath:v,label:f.label,commentReactions:f.reactions?f.reactions.map(T=>t(T)):void 0,timestamp:f.timestamp?.toJSON()}}function t(o){return{label:o.label,iconPath:o.iconPath?P.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function c(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?y.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function i(o){if(o!==void 0)switch(o){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function n(o){if(o!==void 0)switch(o){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new g}e.createExtHostComments=k}),define(Ce[193],Ie([1,0,25,4,27,11]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(O,b){this._mainThreadConsole=O.getProxy(C.MainContext.MainThreadConsole),this._includeStack=b.consoleForward.includeStack,this._logNative=b.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,b){const m=this,k=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m._handleConsoleCall(O,b,k,arguments)}})}_handleConsoleCall(O,b,m,k){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:b,arguments:E(k,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,m,k)}};y=ze([$e(0,M.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const A=1e5;function E(P,O){const b=[];if(P.length)for(let m=0;m<P.length;m++){let k=P[m];if(typeof k>"u")k="undefined";else if(k instanceof Error){const p=k;p.stack?k=p.stack:k=p.toString()}b.push(k)}if(O){const m=new Error().stack;m&&b.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,r.safeStringify)(b);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ce[97],Ie([1,0,2,4,6,3,11,14,18,9,19]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class Oi{constructor(k,p){this._logService=p,this._provider=new Map,this._proxy=k.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(k,p){const l=Oi._handlePool++;this._provider.set(l,{provider:k,extensionId:p}),this._proxy.$registerDecorationProvider(l,p.value);const u=k.onDidChangeFileDecorations&&k.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(l,null);return}const g=(0,E.asArray)(d);if(g.length<=Oi._maxEventSize){this._proxy.$onDidChange(l,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,g.length);const _=g.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),a=(0,E.groupBy)(_,(t,c)=>t.rank-c.rank||(0,P.compare)(t.uri.path,c.uri.path)),w=[];e:for(const t of a){let c;for(const i of t){const n=(0,O.dirname)(i.uri.path);if(c!==n&&(c=n,w.push(i.uri)>=Oi._maxEventSize))break e}}this._proxy.$onDidChange(l,w)});return new S.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(k,p,l){if(!this._provider.has(k))return Object.create(null);const u=Object.create(null),{provider:d,extensionId:g}=this._provider.get(k);return await Promise.all(p.map(async _=>{try{const{uri:a,id:w}=_,t=await Promise.resolve(d.provideFileDecoration(r.URI.revive(a),l));if(!t)return;try{S.FileDecoration.validate(t),u[w]=[t.propagate,t.tooltip,t.badge,t.color]}catch(c){this._logService.warn(`INVALID decoration from extension '${g.value}': ${c}`)}}catch(a){this._logService.error(a)}})),u}};b._handlePool=0,b._maxEventSize=250,b=ze([$e(0,y.IExtHostRpcService),$e(1,A.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[194],Ie([1,0,130,82,2,4,6,8,5,14,24,36]),function(ie,e,r,C,S,M,y,A,E,P,O,b){"use strict";var m,k,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class l{constructor(g,_,a,w,t,c){this._name=g,this._owner=_,this._maxDiagnosticsPerFile=a,m.set(this,void 0),k.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,Je(this,p,new O.ResourceMap(i=>w.getComparisonKey(i)),"f"),Je(this,m,t,"f"),Je(this,k,c,"f")}dispose(){this._isDisposed||(Oe(this,k,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,_){if(!g){this.clear();return}this._checkDisposed();let a=[];if(S.URI.isUri(g)){if(!_){this.delete(g);return}Oe(this,p,"f").set(g,_.slice()),a=[g]}else if(Array.isArray(g)){a=[];let t;g=[...g].sort(l._compareIndexedTuplesByUri);for(const c of g){const[i,n]=c;if((!t||i.toString()!==t.toString())&&(t&&Oe(this,p,"f").get(t).length===0&&Oe(this,p,"f").delete(t),t=i,a.push(i),Oe(this,p,"f").set(i,[])),n)Oe(this,p,"f").get(i)?.push(...n);else{const o=Oe(this,p,"f").get(i);o&&(o.length=0)}}}if(Oe(this,k,"f").fire(a),!Oe(this,m,"f"))return;const w=[];for(const t of a){let c=[];const i=Oe(this,p,"f").get(t);if(i)if(i.length>this._maxDiagnosticsPerFile){c=[];const n=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const f of i)if(f.severity===n[o]&&c.push(A.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;c.push({severity:C.MarkerSeverity.Info,message:(0,r.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=i.map(n=>A.Diagnostic.from(n));w.push([t,c])}Oe(this,m,"f").$changeMany(this._owner,w)}delete(g){this._checkDisposed(),Oe(this,k,"f").fire([g]),Oe(this,p,"f").delete(g),Oe(this,m,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Oe(this,k,"f").fire([...Oe(this,p,"f").keys()]),Oe(this,p,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(g,_){this._checkDisposed();for(const[a,w]of this)g.call(_,a,w,this)}*[(m=new WeakMap,k=new WeakMap,p=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Oe(this,p,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const _=Oe(this,p,"f").get(g);return Array.isArray(_)?Object.freeze(_.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Oe(this,p,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,_){return g[0].toString()<_[0].toString()?-1:g[0].toString()>_[0].toString()?1:0}}e.DiagnosticCollection=l;let u=class gi{static _mapper(g){const _=new O.ResourceMap;for(const a of g)_.set(a,a);return{uris:Object.freeze(Array.from(_.values()))}}constructor(g,_,a){this._logService=_,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,gi._mapper),this._proxy=g.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,_){const{_collections:a,_proxy:w,_onDidChangeDiagnostics:t,_logService:c,_fileSystemInfoService:i}=this,n=new class{$changeMany(s,h){w.$changeMany(s,h),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,s,h.length===0?"CLEARING":h)}$clear(s){w.$clear(s),c.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,s)}dispose(){w.dispose()}};let o;if(!_)_="_generated_diagnostic_collection_name_#"+gi._idPool++,o=_;else if(!a.has(_))o=_;else{this._logService.warn(`DiagnosticCollection with name '${_}' does already exist.`);do o=_+gi._idPool++;while(a.has(o))}return new class extends l{constructor(){super(_,o,gi._maxDiagnosticsPerFile,i.extUri,n,t),a.set(o,this)}dispose(){super.dispose(),a.delete(o)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const _=new Map,a=[];for(const w of this._collections.values())w.forEach((t,c)=>{let i=_.get(t.toString());typeof i>"u"&&(i=a.length,_.set(t.toString(),i),a.push([t,[]])),a[i][1]=a[i][1].concat(...c)});return a}}_getDiagnostics(g){let _=[];for(const a of this._collections.values())a.has(g)&&(_=_.concat(a.get(g)));return _}$acceptMarkersChange(g){if(!this._mirrorCollection){const _="_generated_mirror",a=new l(_,_,gi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(_,a),this._mirrorCollection=a}for(const[_,a]of g)this._mirrorCollection.set(S.URI.revive(_),a.map(A.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=ze([$e(1,P.ILogService),$e(2,b.IExtHostFileSystemInfo)],u),e.ExtHostDiagnostics=u}),define(Ce[195],Ie([1,0,2,4]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(y){this._proxy=y.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(A=>A?A.map(E=>r.URI.revive(E)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(A=>A?r.URI.revive(A):void 0)}}e.ExtHostDialogs=S}),define(Ce[196],Ie([1,0,12,2,6,4,13,20,9]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(b,m,k){this._documentsAndEditors=m,this._logService=k,this._documentContentProviders=new Map,this._proxy=b.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,m){if(Object.keys(y.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const k=P._handlePool++;this._documentContentProviders.set(k,m),this._proxy.$registerTextContentProvider(k,b);let p;return typeof m.onDidChange=="function"&&(p=m.onDidChange(l=>{if(l.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(k,l).then(u=>{if(!u&&typeof u!="string")return;const d=this._documentsAndEditors.getDocument(l);if(!d)return;const g=(0,E.splitLines)(u);if(!d.equalLines(g))return this._proxy.$onVirtualDocumentChange(l,u)},r.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(k)&&this._proxy.$unregisterTextContentProvider(k),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(b,m){const k=this._documentContentProviders.get(b);return k?Promise.resolve(k.provideTextDocumentContent(C.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ce[197],Ie([1,0,5,7,2,4,93,8,10,25,6]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(k,p){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=k.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const u of l)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const u of l)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(k){if(!k)return;const p=this._documentsAndEditors.getDocument(k);if(p)return p}getDocument(k){const p=this.getDocumentData(k);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return p.document}ensureDocumentData(k){const p=this._documentsAndEditors.getDocument(k);if(p)return Promise.resolve(p);let l=this._documentLoader.get(k.toString());return l||(l=this._proxy.$tryOpenDocument(k).then(u=>{this._documentLoader.delete(k.toString());const d=S.URI.revive(u);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(d))},u=>(this._documentLoader.delete(k.toString()),Promise.reject(u))),this._documentLoader.set(k.toString(),l)),l}createDocumentData(k){return this._proxy.$tryCreateDocument(k).then(p=>S.URI.revive(p))}$acceptModelLanguageChanged(k,p){const l=S.URI.revive(k),u=this._documentsAndEditors.getDocument(l);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(p),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(k){const p=S.URI.revive(k),l=this._documentsAndEditors.getDocument(p);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(k,p){const l=S.URI.revive(k),u=this._documentsAndEditors.getDocument(l);if(!u)throw new Error("unknown document");u._acceptIsDirty(p),this._onDidChangeDocument.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,p,l){const u=S.URI.revive(k),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");d._acceptIsDirty(l),d.onEvents(p);let g;p.isUndoing?g=O.TextDocumentChangeReason.Undo:p.isRedoing&&(g=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:d.document,contentChanges:p.changes.map(_=>({range:A.Range.to(_.range),rangeOffset:_.rangeOffset,rangeLength:_.rangeLength,text:_.text})),reason:g}))}setWordDefinitionFor(k,p){(0,y.setWordDefinitionFor)(k,p)}}e.ExtHostDocuments=b}),define(Ce[50],Ie([1,0,45,5,7,2,3,4,93,11,96,8,14,24,13,167,198]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(a,w){this._extHostRpc=a,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new k.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const w=[],t=[],c=[];if(a.removedDocuments)for(const i of a.removedDocuments){const n=M.URI.revive(i),o=this._documents.get(n);o?.unref()&&(this._documents.delete(n),w.push(o.value))}if(a.addedDocuments)for(const i of a.addedDocuments){const n=M.URI.revive(i.uri);let o=this._documents.get(n);if(o&&n.scheme!==p.Schemas.vscodeNotebookCell&&n.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);o||(o=new d(new E.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),n,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(n,o),t.push(o.value)),o.ref()}if(a.removedEditors)for(const i of a.removedEditors){const n=this._editors.get(i);this._editors.delete(i),n&&c.push(n)}if(a.addedEditors)for(const i of a.addedEditors){const n=M.URI.revive(i.documentUri);r.ok(this._documents.has(n),`document '${n}' does not exist`),r.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const o=this._documents.get(n).value,f=new O.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new u.Lazy(()=>o.document),i.selections.map(b.Selection.to),i.options,i.visibleRanges.map(s=>b.Range.to(s)),typeof i.editorPosition=="number"?b.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,f)}a.newActiveEditor!==void 0&&(r.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,S.dispose)(w),(0,S.dispose)(c),a.removedDocuments&&this._onDidRemoveDocuments.fire(w),a.addedDocuments&&this._onDidAddDocuments.fire(t),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const w=this._editors.get(this._activeEditorId);return a?w:w?.value}allEditors(){return[...this._editors.values()]}};g=ze([$e(0,P.IExtHostRpcService),$e(1,m.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[51],Ie([1,0,8,4,2,5,3,6,11,10,73]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class b{constructor(u,d,g){this._activeTabIdGetter=g,this._parentGroup=d,this.acceptDtoUpdate(u)}get apiObject(){if(!this._apiObject){const u=this,d={get isActive(){return u._dto.id===u._activeTabIdGetter()},get label(){return u._dto.label},get input(){return u._input},get isDirty(){return u._dto.isDirty},get isPinned(){return u._dto.isPinned},get isPreview(){return u._dto.isPreview},get group(){return u._parentGroup.apiObject}};this._apiObject=Object.freeze(d)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(u){this._dto=u,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(S.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(S.URI.revive(this._dto.input.base),S.URI.revive(this._dto.input.input1),S.URI.revive(this._dto.input.input2),S.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(S.URI.revive(this._dto.input.uri),S.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(u,d){this._tabs=[],this._activeTabId="",this._dto=u,this._activeGroupIdGetter=d;for(const g of u.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new b(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const u=this,d={get isActive(){return u._dto.groupId===u._activeGroupIdGetter()},get viewColumn(){return r.ViewColumn.to(u._dto.viewColumn)},get activeTab(){return u._tabs.find(g=>g.tabId===u._activeTabId)?.apiObject},get tabs(){return Object.freeze(u._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(d)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(u){this._dto=u}acceptTabOperation(u){if(u.kind===0){const g=new b(u.tabDto,this,()=>this.activeTabId());return this._tabs.splice(u.index,0,g),u.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(u.kind===1){const g=this._tabs.splice(u.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(u.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this._tabs.splice(u.index,0,g),g}const d=this._tabs.find(g=>g.tabId===u.tabDto.id);if(!d)throw new Error("INVALID tab");return u.tabDto.isActive?this._activeTabId=u.tabDto.id:this._activeTabId===u.tabDto.id&&!u.tabDto.isActive&&(this._activeTabId=""),d.acceptDtoUpdate(u.tabDto),d}activeTabId(){return this._activeTabId}}let k=class{constructor(u){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=u.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const u=this,d={onDidChangeTabGroups:u._onDidChangeTabGroups.event,onDidChangeTabs:u._onDidChangeTabs.event,get all(){return Object.freeze(u._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=u._activeGroupId;return(0,P.assertIsDefined)(u._extHostTabGroups.find(a=>a.groupId===g)?.apiObject)},close:async(g,_)=>{const a=Array.isArray(g)?g:[g];return a.length?p(a[0])?this._closeGroups(a,_):this._closeTabs(a,_):!0}};this._apiObject=Object.freeze(d)}return this._apiObject}$acceptEditorTabModel(u){const d=new Set(this._extHostTabGroups.map(i=>i.groupId)),g=new Set(u.map(i=>i.groupId)),_=(0,O.diffSets)(d,g),a=this._extHostTabGroups.filter(i=>_.removed.includes(i.groupId)).map(i=>i.apiObject),w=[],t=[];this._extHostTabGroups=u.map(i=>{const n=new m(i,()=>this._activeGroupId);return _.added.includes(n.groupId)?w.push(n.apiObject):t.push(n.apiObject),n});const c=(0,P.assertIsDefined)(u.find(i=>i.isActive===!0)?.groupId);c!==void 0&&this._activeGroupId!==c&&(this._activeGroupId=c),this._onDidChangeTabGroups.fire(Object.freeze({opened:w,closed:a,changed:t}))}$acceptTabGroupUpdate(u){const d=this._extHostTabGroups.find(g=>g.groupId===u.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(u),u.isActive&&(this._activeGroupId=u.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const d=this._extHostTabGroups.find(_=>_.groupId===u.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const g=d.acceptTabOperation(u);switch(u.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(u){for(const d of this._extHostTabGroups)for(const g of d.tabs)if(g.apiObject===u)return g}_findExtHostTabGroupFromApi(u){return this._extHostTabGroups.find(d=>d.apiObject===u)}async _closeTabs(u,d){const g=[];for(const _ of u){const a=this._findExtHostTabFromApi(_);if(!a)throw new Error("Tab close: Invalid tab not found!");g.push(a.tabId)}return this._proxy.$closeTab(g,d)}async _closeGroups(u,d){const g=[];for(const _ of u){const a=this._findExtHostTabGroupFromApi(_);if(!a)throw new Error("Group close: Invalid group not found!");g.push(a.groupId)}return this._proxy.$closeGroup(g,d)}};k=ze([$e(0,E.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function p(l){return l.tabs!==void 0}}),define(Ce[199],Ie([1,0,2,4,7,6,8,244,9,23,28]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const l=this._schemes.indexOf(p);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),l=[];let u,d,g=14,_=14;for(const a of p){let w=u?(0,E.commonPrefixLength)(u,a):0;for(w===0?d=1:d=_;w<a.length;w++)w+1===a.length?(g=_,_=9):_+=1,l.push([d,a.toUpperCase().charCodeAt(w),_]),l.push([d,a.toLowerCase().charCodeAt(w),_]),d=_;u=a,_=g}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new A.StateMachine(l)}}provideDocumentLinks(p){this._initStateMachine();const l=[],u=A.LinkComputer.computeLinks({getLineContent(d){return p.lineAt(d-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const d of u){const g=y.DocumentLink.to(d);g.target&&l.push(g)}return l}}class m{constructor(p,l){this._extHostLanguageFeatures=l,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,l,u,d={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(g,u);let _=2;d.isCaseSensitive&&(_+=1024),d.isReadonly&&(_+=2048),typeof u.copy=="function"&&(_+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,O.checkProposedApiEnabled)(p,"fsChunks"),_+=4),this._proxy.$registerFileSystemProvider(g,l,_).catch(w=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${l}`),console.error(w)});const a=u.onDidChangeFile(w=>{const t=[];for(const c of w){const{uri:i,type:n}=c;if(i.scheme!==l)continue;let o;switch(n){case M.FileChangeType.Changed:o=0;break;case M.FileChangeType.Created:o=1;break;case M.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:o})}this._proxy.$onFileSystemChange(g,t)});return(0,S.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(p){const{type:l,ctime:u,mtime:d,size:g,permissions:_}=p;return{type:l,ctime:u,mtime:d,size:g,permissions:_}}$stat(p,l){return Promise.resolve(this._getFsProvider(p).stat(r.URI.revive(l))).then(u=>m._asIStat(u))}$readdir(p,l){return Promise.resolve(this._getFsProvider(p).readDirectory(r.URI.revive(l)))}$readFile(p,l){return Promise.resolve(this._getFsProvider(p).readFile(r.URI.revive(l))).then(u=>P.VSBuffer.wrap(u))}$writeFile(p,l,u,d){return Promise.resolve(this._getFsProvider(p).writeFile(r.URI.revive(l),u.buffer,d))}$delete(p,l,u){return Promise.resolve(this._getFsProvider(p).delete(r.URI.revive(l),u))}$rename(p,l,u,d){return Promise.resolve(this._getFsProvider(p).rename(r.URI.revive(l),r.URI.revive(u),d))}$copy(p,l,u,d){const g=this._getFsProvider(p);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(r.URI.revive(l),r.URI.revive(u),d))}$mkdir(p,l){return Promise.resolve(this._getFsProvider(p).createDirectory(r.URI.revive(l)))}$watch(p,l,u,d){const g=this._getFsProvider(p).watch(r.URI.revive(u),d);this._watches.set(l,g)}$unwatch(p,l){const u=this._watches.get(l);u&&(u.dispose(),this._watches.delete(l))}$open(p,l,u){const d=this._getFsProvider(p);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(r.URI.revive(l),u))}$close(p,l){const u=this._getFsProvider(p);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(l))}$read(p,l,u,d){const g=this._getFsProvider(p);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const _=P.VSBuffer.alloc(d);return Promise.resolve(g.read(l,u,_.buffer,0,d)).then(a=>_.slice(0,a))}$write(p,l,u,d){const g=this._getFsProvider(p);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(l,u,d.buffer,0,d.byteLength))}_getFsProvider(p){const l=this._fsProvider.get(p);if(!l){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return l}}e.ExtHostFileSystem=m}),define(Ce[52],Ie([1,0,4,35,6,23,3,11,36,7]),function(ie,e,r,C,S,M,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Gt{constructor(m,k){this._fileSystemProvider=new Map,this._proxy=m.getProxy(r.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(l){try{const u=p._fileSystemProvider.get(l.scheme);if(!u)return await p._proxy.$stat(l);await p._proxy.$ensureActivation(l.scheme);const d=await u.stat(l);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(u){Gt._handleError(u)}},async readDirectory(l){try{const u=p._fileSystemProvider.get(l.scheme);return u?(await p._proxy.$ensureActivation(l.scheme),(await u.readDirectory(l)).slice()):await p._proxy.$readdir(l)}catch(u){return Gt._handleError(u)}},async createDirectory(l){try{return await p._proxy.$mkdir(l)}catch(u){return Gt._handleError(u)}},async readFile(l){try{const u=p._fileSystemProvider.get(l.scheme);return u?(await p._proxy.$ensureActivation(l.scheme),(await u.readFile(l)).slice()):(await p._proxy.$readFile(l)).buffer}catch(u){return Gt._handleError(u)}},async writeFile(l,u){try{return await p._proxy.$writeFile(l,M.VSBuffer.wrap(u))}catch(d){return Gt._handleError(d)}},async delete(l,u){try{const d=p._fileSystemProvider.get(l.scheme);return d?(await p._proxy.$ensureActivation(l.scheme),await d.delete(l,{recursive:!1,...u})):await p._proxy.$delete(l,{recursive:!1,useTrash:!1,...u})}catch(d){return Gt._handleError(d)}},async rename(l,u,d){try{return await p._proxy.$rename(l,u,{overwrite:!1,...d})}catch(g){return Gt._handleError(g)}},async copy(l,u,d){try{return await p._proxy.$copy(l,u,{overwrite:!1,...d})}catch(g){return Gt._handleError(g)}},isWritableFileSystem(l){const u=k.getCapabilities(l);if(typeof u=="number")return!(u&2048)}})}static _handleError(m){if(m instanceof S.FileSystemError)throw m;if(!(m instanceof Error))throw new S.FileSystemError(String(m));if(m.name==="ENOPRO")throw S.FileSystemError.Unavailable(m.message);switch(m.name){case C.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(m.message);case C.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(m.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(m.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(m.message);case C.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(m.message);case C.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(m.message);default:throw new S.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,k){return this._fileSystemProvider.set(m,k),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(m))}};O=ze([$e(0,A.IExtHostRpcService),$e(1,E.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[200],Ie([1,0,5,34,2,4,8,6]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(b,m,k,p,l,u,d,g){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const _=this.ensureWatching(b,k,l);this._config=0,u&&(this._config+=1),d&&(this._config+=2),g&&(this._config+=4);const a=(0,C.parse)(l),w=typeof l=="string",t=p(c=>{if(!u)for(const i of c.created){const n=S.URI.revive(i);a(n.fsPath)&&(!w||m.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!d)for(const i of c.changed){const n=S.URI.revive(i);a(n.fsPath)&&(!w||m.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!g)for(const i of c.deleted){const n=S.URI.revive(i);a(n.fsPath)&&(!w||m.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=A.Disposable.from(_,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(b,m,k){const p=A.Disposable.from();if(typeof k=="string")return p;const l=b.getProxy(M.MainContext.MainThreadFileSystem);let u=!1;(k.pattern.includes(C.GLOBSTAR)||k.pattern.includes(C.GLOB_SPLIT))&&(u=!0);const d=Math.random();return l.$watch(m.identifier.value,d,k.baseUri,{recursive:u,excludes:[]}),A.Disposable.from({dispose:()=>l.$unwatch(d)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(b,m,k){this._mainContext=b,this._logService=m,this._extHostDocumentsAndEditors=k,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,m,k,p,l,u){return new E(this._mainContext,b,m,this._onFileSystemEvent.event,y.GlobPattern.from(k),p,l,u)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,m){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(k=>({oldUri:S.URI.revive(k.source),newUri:S.URI.revive(k.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(k=>S.URI.revive(k.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(k=>S.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,m){return(k,p,l)=>{const u=function(g){k.call(p,g)};return u.extension=b,m.event(u,void 0,l)}}async $onWillRunFileOperation(b,m,k,p){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(l=>({oldUri:S.URI.revive(l.source),newUri:S.URI.revive(l.target)}))},k,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(l=>S.URI.revive(l.target))},k,p);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(l=>S.URI.revive(l.target))},k,p)}}async _fireWillEvent(b,m,k,p){const l=new Set,u=[];if(await b.fireAsync(m,p,async(g,_)=>{const a=Date.now(),w=await Promise.resolve(g);w instanceof A.WorkspaceEdit&&(u.push([_.extension,w]),l.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-a>k&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),p.isCancellationRequested||u.length===0)return;const d={edits:[]};for(const[,g]of u){const{edits:_}=y.WorkspaceEdit.from(g,{getTextDocumentVersion:a=>this._extHostDocumentsAndEditors.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(_)}return{edit:d,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=P}),define(Ce[201],Ie([1,0,2,37]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(y,A,E,P,O){this._extHostNotebooks=A,this._textDocumentsAndEditors=E,this._commands=P;const b=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new C.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new C.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new C.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new C.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const k=this._extHostNotebooks.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri),notebookEditor:k.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(b)}$willAddInteractiveDocument(y,A,E,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:E,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=S}),define(Ce[202],Ie([1,0,7,4]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(y){this._handlePool=0,this._proxy=y.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,y),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=S}),define(Ce[203],Ie([1,0,2,25,8,6,66,4,9,49,18,10,245,20,7,79,74,61,204,12,15,28]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class t{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentSymbols(I,B){const H=this._documents.getDocument(I),j=await this._provider.provideDocumentSymbols(H,B);if(!(0,O.isFalsyOrEmpty)(j))return j[0]instanceof M.DocumentSymbol?j.map(S.DocumentSymbol.from):t._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(I){I=I.slice(0).sort((j,se)=>{let le=j.location.range.start.compareTo(se.location.range.start);return le===0&&(le=se.location.range.end.compareTo(j.location.range.end)),le});const B=[],H=[];for(const j of I){const se={name:j.name||"!!MISSING: name!!",kind:S.SymbolKind.from(j.kind),tags:j.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:S.Range.from(j.location.range),selectionRange:S.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(se),B.push(se);break}const le=H[H.length-1];if(P.Range.containsRange(le.range,se.range)&&!P.Range.equalsRange(le.range,se.range)){le.children?.push(se),H.push(se);break}H.pop()}}return B}}class c{constructor(I,B,H){this._documents=I,this._commands=B,this._provider=H,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(I,B){const H=this._documents.getDocument(I),j=await this._provider.provideCodeLenses(H,B);if(!j||B.isCancellationRequested)return;const se=this._cache.add(j),le=new p.DisposableStore;this._disposables.set(se,le);const Y={cacheId:se,lenses:[]};for(let ve=0;ve<j.length;ve++)Y.lenses.push({cacheId:[se,ve],range:S.Range.from(j[ve].range),command:this._commands.toInternal(j[ve].command,le)});return Y}async resolveCodeLens(I,B){const H=I.cacheId&&this._cache.get(...I.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,B),j||(j=H),B.isCancellationRequested)return;const se=I.cacheId&&this._disposables.get(I.cacheId[0]);if(!!se)return I.command=this._commands.toInternal(j.command??c._badCmd,se),I}releaseCodeLenses(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(J){return Array.isArray(J)?J.map(S.DefinitionLink.from):J?[S.DefinitionLink.from(J)]:[]}class n{constructor(I,B){this._documents=I,this._provider=B}async provideDefinition(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideDefinition(j,se,H);return i(le)}}class o{constructor(I,B){this._documents=I,this._provider=B}async provideDeclaration(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideDeclaration(j,se,H);return i(le)}}class f{constructor(I,B){this._documents=I,this._provider=B}async provideImplementation(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideImplementation(j,se,H);return i(le)}}class s{constructor(I,B){this._documents=I,this._provider=B}async provideTypeDefinition(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideTypeDefinition(j,se,H);return i(le)}}class h{constructor(I,B){this._documents=I,this._provider=B}async provideHover(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideHover(j,se,H);if(!(!le||(0,O.isFalsyOrEmpty)(le.contents)))return le.range||(le.range=j.getWordRangeAtPosition(se)),le.range||(le.range=new M.Range(se,se)),S.Hover.from(le)}}class v{constructor(I,B){this._documents=I,this._provider=B}async provideEvaluatableExpression(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideEvaluatableExpression(j,se,H);if(le)return S.EvaluatableExpression.from(le)}}class T{constructor(I,B){this._documents=I,this._provider=B}async provideInlineValues(I,B,H,j){const se=this._documents.getDocument(I),le=await this._provider.provideInlineValues(se,S.Range.to(B),S.InlineValueContext.to(H),j);if(Array.isArray(le))return le.map(Y=>S.InlineValue.from(Y))}}class N{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentHighlights(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideDocumentHighlights(j,se,H);if(Array.isArray(le))return le.map(S.DocumentHighlight.from)}}class V{constructor(I,B){this._documents=I,this._provider=B}async provideLinkedEditingRanges(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideLinkedEditingRanges(j,se,H);if(le&&Array.isArray(le.ranges))return{ranges:(0,O.coalesce)(le.ranges.map(S.Range.from)),wordPattern:le.wordPattern}}}class U{constructor(I,B){this._documents=I,this._provider=B}async provideReferences(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=await this._provider.provideReferences(se,le,H,j);if(Array.isArray(Y))return Y.map(S.location.from)}}class D{constructor(I,B,H,j,se,le,Y){this._documents=I,this._commands=B,this._diagnostics=H,this._provider=j,this._logService=se,this._extension=le,this._apiDeprecation=Y,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(I,B,H,j){const se=this._documents.getDocument(I),le=m.Selection.isISelection(B)?S.Selection.to(B):S.Range.to(B),Y=[];for(const Ge of this._diagnostics.getDiagnostics(I))if(le.intersection(Ge.range)&&Y.push(Ge)>D._maxCodeActionsPerFile)break;const ve={diagnostics:Y,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:S.CodeActionTriggerKind.to(H.trigger)},pe=await this._provider.provideCodeActions(se,le,ve,j);if(!(0,O.isNonEmptyArray)(pe)||j.isCancellationRequested)return;const Me=this._cache.add(pe),xe=new p.DisposableStore;this._disposables.set(Me,xe);const Ye=[];for(let Ge=0;Ge<pe.length;Ge++){const Te=pe[Ge];!Te||(D._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ye.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,xe)})):(ve.only&&(Te.kind?ve.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ye.push({cacheId:[Me,Ge],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,xe),diagnostics:Te.diagnostics&&Te.diagnostics.map(S.Diagnostic.from),edit:Te.edit&&S.WorkspaceEdit.from(Te.edit,void 0),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,disabled:Te.disabled?.reason})))}return{cacheId:Me,actions:Ye}}async resolveCodeAction(I,B){const[H,j]=I,se=this._cache.get(H,j);if(!se||D._isCommand(se)||!this._provider.resolveCodeAction)return;const le=await this._provider.resolveCodeAction(se,B)??se;return le?.edit?S.WorkspaceEdit.from(le.edit,void 0):void 0}releaseCodeActions(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}static _isCommand(I){return typeof I.command=="string"&&typeof I.title=="string"}}D._maxCodeActionsPerFile=1e3;class x{constructor(I,B,H,j){this._proxy=I,this._documents=B,this._provider=H,this._handle=j}async prepareDocumentPaste(I,B,H,j){if(!this._provider.prepareDocumentPaste)return;const se=this._documents.getDocument(I),le=B.map(ve=>S.Range.to(ve)),Y=S.DataTransfer.toDataTransfer(H,()=>{throw new _.NotImplementedError});return await this._provider.prepareDocumentPaste(se,le,Y,j),S.DataTransfer.toDataTransferDTO(Y)}async providePasteEdits(I,B,H,j,se){const le=this._documents.getDocument(B),Y=H.map(Me=>S.Range.to(Me)),ve=S.DataTransfer.toDataTransfer(j,async Me=>(await this._proxy.$resolvePasteFileData(this._handle,I,Me)).buffer),pe=await this._provider.provideDocumentPasteEdits(le,Y,ve,se);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?S.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class L{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentFormattingEdits(I,B,H){const j=this._documents.getDocument(I),se=await this._provider.provideDocumentFormattingEdits(j,B,H);if(Array.isArray(se))return se.map(S.TextEdit.from)}}class R{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentRangeFormattingEdits(I,B,H,j){const se=this._documents.getDocument(I),le=S.Range.to(B),Y=await this._provider.provideDocumentRangeFormattingEdits(se,le,H,j);if(Array.isArray(Y))return Y.map(S.TextEdit.from)}}class K{constructor(I,B){this._documents=I,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,B,H,j,se){const le=this._documents.getDocument(I),Y=S.Position.to(B),ve=await this._provider.provideOnTypeFormattingEdits(le,Y,H,j,se);if(Array.isArray(ve))return ve.map(S.TextEdit.from)}}class W{constructor(I,B){this._provider=I,this._logService=B,this._cache=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,B){const H=await this._provider.provideWorkspaceSymbols(I,B);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const j=this._cache.add(H),se={cacheId:j,symbols:[]};for(let le=0;le<H.length;le++){const Y=H[le];if(!Y||!Y.name){this._logService.warn("INVALID SymbolInformation",Y);continue}se.symbols.push({...S.WorkspaceSymbol.from(Y),cacheId:[j,le]})}return se}async resolveWorkspaceSymbol(I,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this._cache.get(...I.cacheId);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,B);return j&&(0,C.mixin)(I,S.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(I){this._cache.delete(I)}}class ${static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,B,H){this._documents=I,this._provider=B,this._logService=H}async provideRenameEdits(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B);try{const Y=await this._provider.provideRenameEdits(se,le,H,j);return Y?S.WorkspaceEdit.from(Y):void 0}catch(Y){const ve=$._asMessage(Y);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(Y)}}async resolveRenameLocation(I,B,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(I),se=S.Position.to(B);try{const le=await this._provider.prepareRename(j,se,H);let Y,ve;if(M.Range.isRange(le)?(Y=le,ve=j.getText(le)):(0,b.isObject)(le)&&(Y=le.range,ve=le.placeholder),!Y||!ve)return;if(Y.start.line>se.line||Y.end.line<se.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(Y),text:ve}}catch(le){const Y=$._asMessage(le);return Y?{rejectReason:Y,range:void 0,text:void 0}:Promise.reject(le)}}static _asMessage(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class G{constructor(I,B){this.resultId=I,this.tokens=B}}class re{constructor(I,B){this._documents=I,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(I,B,H){const j=this._documents.getDocument(I),se=B!==0?this._previousResults.get(B):null;let le=typeof se?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,se.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return se&&this._previousResults.delete(B),le?(le=re._fixProvidedSemanticTokens(le),this._send(re._convertToEdits(se,le),le)):null}async releaseDocumentSemanticColoring(I){this._previousResults.delete(I)}static _fixProvidedSemanticTokens(I){return re._isSemanticTokens(I)?re._isCorrectSemanticTokens(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):re._isSemanticTokensEdits(I)?re._isCorrectSemanticTokensEdits(I)?I:new M.SemanticTokensEdits(I.edits.map(B=>new M.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),I.resultId):I}static _isSemanticTokens(I){return I&&!!I.data}static _isCorrectSemanticTokens(I){return I.data instanceof Uint32Array}static _isSemanticTokensEdits(I){return I&&Array.isArray(I.edits)}static _isCorrectSemanticTokensEdits(I){for(const B of I.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(I,B){if(!re._isSemanticTokens(B)||!I||!I.tokens)return B;const H=I.tokens,j=H.length,se=B.data,le=se.length;let Y=0;const ve=Math.min(j,le);for(;Y<ve&&H[Y]===se[Y];)Y++;if(Y===j&&Y===le)return new M.SemanticTokensEdits([],B.resultId);let pe=0;const Me=ve-Y;for(;pe<Me&&H[j-pe-1]===se[le-pe-1];)pe++;return new M.SemanticTokensEdits([{start:Y,deleteCount:j-Y-pe,data:se.subarray(Y,le-pe)}],B.resultId)}_send(I,B){if(re._isSemanticTokens(I)){const H=this._nextResultId++;return this._previousResults.set(H,new G(I.resultId,I.data)),(0,l.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(re._isSemanticTokensEdits(I)){const H=this._nextResultId++;return re._isSemanticTokens(B)?this._previousResults.set(H,new G(B.resultId,B.data)):this._previousResults.set(H,new G(I.resultId)),(0,l.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=re;class ge{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentRangeSemanticTokens(I,B,H){const j=this._documents.getDocument(I),se=await this._provider.provideDocumentRangeSemanticTokens(j,S.Range.to(B),H);return se?this._send(se):null}_send(I){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}e.DocumentRangeSemanticTokensAdapter=ge;class oe{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,B,H,j,se){this._documents=I,this._commands=B,this._provider=H,this._apiDeprecation=j,this._extension=se,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=se.getWordRangeAtPosition(le)||new M.Range(le,le),ve=Y.with({end:le}),pe=new g.StopWatch(!0),Me=await this._provider.provideCompletionItems(se,le,j,S.CompletionContext.to(H));if(!Me||j.isCancellationRequested)return;const xe=Array.isArray(Me)?new M.CompletionList(Me):Me,Ye=oe.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ge=new p.DisposableStore;this._disposables.set(Ye,Ge);const Te=[],rt={x:Ye,b:Te,a:{replace:S.Range.from(Y),insert:S.Range.from(ve)},c:xe.isIncomplete||void 0,d:pe.elapsed()};for(let X=0;X<xe.items.length;X++){const Q=xe.items[X],he=this._convertCompletionItem(Q,[Ye,X],ve,Y);Te.push(he)}return rt}async resolveCompletionItem(I,B){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...I);if(!H)return;const j=await this._provider.resolveCompletionItem(H,B);if(!!j)return this._convertCompletionItem(j,I)}releaseCompletionItems(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_convertCompletionItem(I,B,H,j){const se=this._disposables.get(B[0]);if(!se)throw Error("DisposableStore is missing...");const le={x:B,a:I.label,b:I.kind!==void 0?S.CompletionItemKind.from(I.kind):void 0,n:I.tags&&I.tags.map(S.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:S.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters,l:I.additionalTextEdits&&I.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(I.command,se)};I.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),le.h=I.textEdit.newText):typeof I.insertText=="string"?le.h=I.insertText:I.insertText instanceof M.SnippetString&&(le.h=I.insertText.value,le.i|=4);let Y;return I.textEdit?Y=I.textEdit.range:I.range&&(Y=I.range),M.Range.isRange(Y)?le.j=S.Range.from(Y):Y&&(!H?.isEqual(Y.inserting)||!j?.isEqual(Y.replacing))&&(le.j={insert:S.Range.from(Y.inserting),replace:S.Range.from(Y.replacing)}),le}}class Ee{async provideInlineCompletions(I,B,H,j){}disposeCompletions(I){}handleDidShowCompletionItem(I,B){}}class ce extends Ee{constructor(I,B,H,j){super(),this._extension=I,this._documents=B,this._provider=H,this._commands=j,this._references=new ee,this._isAdditionsProposedApiEnabled=(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=await this._provider.provideInlineCompletionItems(se,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:S.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const ve=Array.isArray(Y)?Y:Y.items,pe=this._isAdditionsProposedApiEnabled?Array.isArray(Y)?[]:Y.commands||[]:[];let Me;return{pid:this._references.createReferenceId({dispose(){Me?.dispose()},items:ve}),items:ve.map((Ye,Ge)=>{let Te;Ye.command&&(Me||(Me=new p.DisposableStore),Te=this._commands.toInternal(Ye.command,Me));const rt=Ye.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Ye.filterText,range:Ye.range?S.Range.from(Ye.range):void 0,command:Te,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:pe.map(Ye=>(Me||(Me=new p.DisposableStore),this._commands.toInternal(Ye,Me)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const H=this._references.get(I)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class me extends Ee{constructor(I,B,H,j){super(),this.extension=I,this._documents=B,this._provider=H,this._commands=j,this._references=new ee,this.isAdditionProposedApiEnabled=(0,w.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=await this._provider.provideInlineCompletionItems(se,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:S.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const ve=Array.isArray(Y)?Y:Y.items,pe=Array.isArray(Y)?[]:Y.commands||[];let Me;return{pid:this._references.createReferenceId({dispose(){Me?.dispose()},items:ve}),items:ve.map((Ye,Ge)=>{let Te;Ye.command&&(Me||(Me=new p.DisposableStore),Te=this._commands.toInternal(Ye.command,Me));const rt=Ye.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Ye.filterText,range:Ye.range?S.Range.from(Ye.range):void 0,command:Te,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:pe.map(Ye=>(Me||(Me=new p.DisposableStore),this._commands.toInternal(Ye,Me)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const H=this._references.get(I)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class ee{constructor(){this._references=new Map,this._idPool=1}createReferenceId(I){const B=this._idPool++;return this._references.set(B,I),B}disposeReferenceId(I){const B=this._references.get(I);return this._references.delete(I),B}get(I){return this._references.get(I)}}class be{constructor(I,B){this._documents=I,this._provider=B,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=this.reviveContext(H),ve=await this._provider.provideSignatureHelp(se,le,j,Y);if(ve){const pe=this._cache.add([ve]);return{...S.SignatureHelp.from(ve),id:pe}}}reviveContext(I){let B;if(I.activeSignatureHelp){const H=S.SignatureHelp.to(I.activeSignatureHelp),j=this._cache.get(I.activeSignatureHelp.id,0);j?(B=j,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...I,activeSignatureHelp:B}}releaseSignatureHelp(I){this._cache.delete(I)}}class _e{constructor(I,B,H,j,se){this._documents=I,this._commands=B,this._provider=H,this._logService=j,this._extension=se,this._cache=new d.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(I,B,H){const j=this._documents.getDocument(I),se=S.Range.to(B),le=await this._provider.provideInlayHints(j,se,H);if(!Array.isArray(le)||le.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(H.isCancellationRequested)return;const Y=this._cache.add(le);this._disposables.set(Y,new p.DisposableStore);const ve={hints:[],cacheId:Y};for(let pe=0;pe<le.length;pe++)this._isValidInlayHint(le[pe],se)&&ve.hints.push(this._convertInlayHint(le[pe],[Y,pe]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),ve}async resolveInlayHint(I,B){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...I);if(!H)return;const j=await this._provider.resolveInlayHint(H,B);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,I)}releaseHints(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_isValidInlayHint(I,B){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(B&&!B.contains(I.position))}_convertInlayHint(I,B){const H=this._disposables.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:B,tooltip:S.MarkdownString.fromStrict(I.tooltip),position:S.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(S.TextEdit.from),kind:I.kind&&S.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?j.label=I.label:j.label=I.label.map(se=>{const le={label:se.value};return le.tooltip=S.MarkdownString.fromStrict(se.tooltip),M.Location.isLocation(se.location)&&(le.location=S.location.from(se.location)),se.command&&(le.command=this._commands.toInternal(se.command,H)),le}),j}}class Fe{constructor(I,B){this._documents=I,this._provider=B,this._cache=new d.Cache("DocumentLink")}async provideLinks(I,B){const H=this._documents.getDocument(I),j=await this._provider.provideDocumentLinks(H,B);if(!(!Array.isArray(j)||j.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(S.DocumentLink.from)};{const se=this._cache.add(j),le={links:[],cacheId:se};for(let Y=0;Y<j.length;Y++){if(!Fe._validateLink(j[Y]))continue;const ve=S.DocumentLink.from(j[Y]);ve.cacheId=[se,Y],le.links.push(ve)}return le}}}static _validateLink(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,B){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...I);if(!H)return;const j=await this._provider.resolveDocumentLink(H,B);if(!(!j||!Fe._validateLink(j)))return S.DocumentLink.from(j)}releaseLinks(I){this._cache.delete(I)}}class Be{constructor(I,B){this._documents=I,this._provider=B}async provideColors(I,B){const H=this._documents.getDocument(I),j=await this._provider.provideDocumentColors(H,B);return Array.isArray(j)?j.map(le=>({color:S.Color.from(le.color),range:S.Range.from(le.range)})):[]}async provideColorPresentations(I,B,H){const j=this._documents.getDocument(I),se=S.Range.to(B.range),le=S.Color.to(B.color),Y=await this._provider.provideColorPresentations(le,{document:j,range:se},H);if(!!Array.isArray(Y))return Y.map(S.ColorPresentation.from)}}class Xe{constructor(I,B){this._documents=I,this._provider=B}async provideFoldingRanges(I,B,H){const j=this._documents.getDocument(I),se=await this._provider.provideFoldingRanges(j,B,H);if(!!Array.isArray(se))return se.map(S.FoldingRange.from)}}class ke{constructor(I,B,H){this._documents=I,this._provider=B,this._logService=H}async provideSelectionRanges(I,B,H){const j=this._documents.getDocument(I),se=B.map(S.Position.to),le=await this._provider.provideSelectionRanges(j,se,H);if(!(0,O.isNonEmptyArray)(le))return[];if(le.length!==se.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Y=[];for(let ve=0;ve<se.length;ve++){const pe=[];Y.push(pe);let Me=se[ve],xe=le[ve];for(;;){if(!xe.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(pe.push(S.SelectionRange.from(xe)),!xe.parent)break;Me=xe.range,xe=xe.parent}}return Y}}class ye{constructor(I,B){this._documents=I,this._provider=B,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.prepareCallHierarchy(j,se,H);if(!le)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(le)?le.map(ve=>this._cacheAndConvertItem(Y,ve)):[this._cacheAndConvertItem(Y,le)]}async provideCallsTo(I,B,H){const j=this._itemFromCache(I,B);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(!!se)return se.map(le=>({from:this._cacheAndConvertItem(I,le.from),fromRanges:le.fromRanges.map(Y=>S.Range.from(Y))}))}async provideCallsFrom(I,B,H){const j=this._itemFromCache(I,B);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(!!se)return se.map(le=>({to:this._cacheAndConvertItem(I,le.to),fromRanges:le.fromRanges.map(Y=>S.Range.from(Y))}))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,B){const H=this._cache.get(I),j=S.CallHierarchyItem.from(B,I,H.size.toString(36));return H.set(j._itemId,B),j}_itemFromCache(I,B){return this._cache.get(I)?.get(B)}}class De{constructor(I,B){this._documents=I,this._provider=B,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.prepareTypeHierarchy(j,se,H);if(!le)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(le)?le.map(ve=>this._cacheAndConvertItem(Y,ve)):[this._cacheAndConvertItem(Y,le)]}async provideSupertypes(I,B,H){const j=this._itemFromCache(I,B);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySupertypes(j,H);if(!!se)return se.map(le=>this._cacheAndConvertItem(I,le))}async provideSubtypes(I,B,H){const j=this._itemFromCache(I,B);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySubtypes(j,H);if(!!se)return se.map(le=>this._cacheAndConvertItem(I,le))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,B){const H=this._cache.get(I),j=S.TypeHierarchyItem.from(B,I,H.size.toString(36));return H.set(j._itemId,B),j}_itemFromCache(I,B){return this._cache.get(I)?.get(B)}}class ae{constructor(I,B,H,j){this._proxy=I,this._documents=B,this._provider=H,this._handle=j}async provideDocumentOnDropEdits(I,B,H,j,se){const le=this._documents.getDocument(B),Y=S.Position.to(H),ve=S.DataTransfer.toDataTransfer(j,async Me=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,I,Me)).buffer),pe=await this._provider.provideDocumentDropEdits(le,Y,ve,se);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?S.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class ue{constructor(I,B){this.adapter=I,this.extension=B}}class Z{constructor(I,B,H,j,se,le,Y){this._adapter=new Map,this._uriTransformer=B,this._proxy=I.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=j,this._diagnostics=se,this._logService=le,this._apiDeprecation=Y}_transformDocumentSelector(I){return S.DocumentSelector.from(I,this._uriTransformer)}_createDisposable(I){return new M.Disposable(()=>{this._adapter.delete(I),this._proxy.$unregister(I)})}_nextHandle(){return Z._handlePool++}async _withAdapter(I,B,H,j,se,le=!1){const Y=this._adapter.get(I);if(!Y||!(Y.adapter instanceof B))return j;const ve=Date.now();le||this._logService.trace(`[${Y.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const pe=H(Y.adapter,Y.extension);return Promise.resolve(pe).catch(Me=>{(0,_.isCancellationError)(Me)||(this._logService.error(`[${Y.extension.identifier.value}] provider FAILED`),this._logService.error(Me))}).finally(()=>{le||this._logService.trace(`[${Y.extension.identifier.value}] provider DONE after ${Date.now()-ve}ms`)}),k.CancellationToken.isCancellationToken(se)?(0,a.raceCancellationError)(pe,se):pe}_addNewAdapter(I,B){const H=this._nextHandle();return this._adapter.set(H,new ue(I,B)),H}static _extLabel(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,B,H,j){const se=this._addNewAdapter(new t(this._documents,H),I),le=j&&j.label||Z._extLabel(I);return this._proxy.$registerDocumentSymbolProvider(se,this._transformDocumentSelector(B),le),this._createDisposable(se)}$provideDocumentSymbols(I,B,H){return this._withAdapter(I,t,j=>j.provideDocumentSymbols(r.URI.revive(B),H),void 0,H)}registerCodeLensProvider(I,B,H){const j=this._nextHandle(),se=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new c(this._documents,this._commands.converter,H),I)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(B),se);let le=this._createDisposable(j);if(se!==void 0){const Y=H.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(se));le=M.Disposable.from(le,Y)}return le}$provideCodeLenses(I,B,H){return this._withAdapter(I,c,j=>j.provideCodeLenses(r.URI.revive(B),H),void 0,H)}$resolveCodeLens(I,B,H){return this._withAdapter(I,c,j=>j.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(I,B){this._withAdapter(I,c,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(I,B,H){const j=this._addNewAdapter(new n(this._documents,H),I);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDefinition(I,B,H,j){return this._withAdapter(I,n,se=>se.provideDefinition(r.URI.revive(B),H,j),[],j)}registerDeclarationProvider(I,B,H){const j=this._addNewAdapter(new o(this._documents,H),I);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDeclaration(I,B,H,j){return this._withAdapter(I,o,se=>se.provideDeclaration(r.URI.revive(B),H,j),[],j)}registerImplementationProvider(I,B,H){const j=this._addNewAdapter(new f(this._documents,H),I);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideImplementation(I,B,H,j){return this._withAdapter(I,f,se=>se.provideImplementation(r.URI.revive(B),H,j),[],j)}registerTypeDefinitionProvider(I,B,H){const j=this._addNewAdapter(new s(this._documents,H),I);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideTypeDefinition(I,B,H,j){return this._withAdapter(I,s,se=>se.provideTypeDefinition(r.URI.revive(B),H,j),[],j)}registerHoverProvider(I,B,H,j){const se=this._addNewAdapter(new h(this._documents,H),I);return this._proxy.$registerHoverProvider(se,this._transformDocumentSelector(B)),this._createDisposable(se)}$provideHover(I,B,H,j){return this._withAdapter(I,h,se=>se.provideHover(r.URI.revive(B),H,j),void 0,j)}registerEvaluatableExpressionProvider(I,B,H,j){const se=this._addNewAdapter(new v(this._documents,H),I);return this._proxy.$registerEvaluatableExpressionProvider(se,this._transformDocumentSelector(B)),this._createDisposable(se)}$provideEvaluatableExpression(I,B,H,j){return this._withAdapter(I,v,se=>se.provideEvaluatableExpression(r.URI.revive(B),H,j),void 0,j)}registerInlineValuesProvider(I,B,H,j){const se=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,le=this._addNewAdapter(new T(this._documents,H),I);this._proxy.$registerInlineValuesProvider(le,this._transformDocumentSelector(B),se);let Y=this._createDisposable(le);if(se!==void 0){const ve=H.onDidChangeInlineValues(pe=>this._proxy.$emitInlineValuesEvent(se));Y=M.Disposable.from(Y,ve)}return Y}$provideInlineValues(I,B,H,j,se){return this._withAdapter(I,T,le=>le.provideInlineValues(r.URI.revive(B),H,j,se),void 0,se)}registerDocumentHighlightProvider(I,B,H){const j=this._addNewAdapter(new N(this._documents,H),I);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentHighlights(I,B,H,j){return this._withAdapter(I,N,se=>se.provideDocumentHighlights(r.URI.revive(B),H,j),void 0,j)}registerLinkedEditingRangeProvider(I,B,H){const j=this._addNewAdapter(new V(this._documents,H),I);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideLinkedEditingRanges(I,B,H,j){return this._withAdapter(I,V,async se=>{const le=await se.provideLinkedEditingRanges(r.URI.revive(B),H,j);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?Z._serializeRegExp(le.wordPattern):void 0}},void 0,j)}registerReferenceProvider(I,B,H){const j=this._addNewAdapter(new U(this._documents,H),I);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideReferences(I,B,H,j,se){return this._withAdapter(I,U,le=>le.provideReferences(r.URI.revive(B),H,j,se),void 0,se)}registerCodeActionProvider(I,B,H,j){const se=new p.DisposableStore,le=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,H,this._logService,I,this._apiDeprecation),I);return this._proxy.$registerQuickFixSupport(le,this._transformDocumentSelector(B),{providedKinds:j?.providedCodeActionKinds?.map(Y=>Y.value),documentation:j?.documentation?.map(Y=>({kind:Y.kind.value,command:this._commands.converter.toInternal(Y.command,se)}))},Z._extLabel(I),Boolean(H.resolveCodeAction)),se.add(this._createDisposable(le)),se}$provideCodeActions(I,B,H,j,se){return this._withAdapter(I,D,le=>le.provideCodeActions(r.URI.revive(B),H,j,se),void 0,se)}$resolveCodeAction(I,B,H){return this._withAdapter(I,D,j=>j.resolveCodeAction(B,H),void 0,void 0)}$releaseCodeActions(I,B){this._withAdapter(I,D,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(I,B,H){const j=this._addNewAdapter(new L(this._documents,H),I);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(B),I.identifier,I.displayName||I.name),this._createDisposable(j)}$provideDocumentFormattingEdits(I,B,H,j){return this._withAdapter(I,L,se=>se.provideDocumentFormattingEdits(r.URI.revive(B),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(I,B,H){const j=this._addNewAdapter(new R(this._documents,H),I);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(B),I.identifier,I.displayName||I.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(I,B,H,j,se){return this._withAdapter(I,R,le=>le.provideDocumentRangeFormattingEdits(r.URI.revive(B),H,j,se),void 0,se)}registerOnTypeFormattingEditProvider(I,B,H,j){const se=this._addNewAdapter(new K(this._documents,H),I);return this._proxy.$registerOnTypeFormattingSupport(se,this._transformDocumentSelector(B),j,I.identifier),this._createDisposable(se)}$provideOnTypeFormattingEdits(I,B,H,j,se,le){return this._withAdapter(I,K,Y=>Y.provideOnTypeFormattingEdits(r.URI.revive(B),H,j,se,le),void 0,le)}registerWorkspaceSymbolProvider(I,B){const H=this._addNewAdapter(new W(B,this._logService),I);return this._proxy.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(I,B,H){return this._withAdapter(I,W,j=>j.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,B,H){return this._withAdapter(I,W,j=>j.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(I,B){this._withAdapter(I,W,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(I,B,H){const j=this._addNewAdapter(new $(this._documents,H,this._logService),I);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(B),$.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(I,B,H,j,se){return this._withAdapter(I,$,le=>le.provideRenameEdits(r.URI.revive(B),H,j,se),void 0,se)}$resolveRenameLocation(I,B,H,j){return this._withAdapter(I,$,se=>se.resolveRenameLocation(r.URI.revive(B),H,j),void 0,j)}registerDocumentSemanticTokensProvider(I,B,H,j){const se=this._addNewAdapter(new re(this._documents,H),I),le=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(se,this._transformDocumentSelector(B),j,le);let Y=this._createDisposable(se);if(le){const ve=H.onDidChangeSemanticTokens(pe=>this._proxy.$emitDocumentSemanticTokensEvent(le));Y=M.Disposable.from(Y,ve)}return Y}$provideDocumentSemanticTokens(I,B,H,j){return this._withAdapter(I,re,se=>se.provideDocumentSemanticTokens(r.URI.revive(B),H,j),null,j)}$releaseDocumentSemanticTokens(I,B){this._withAdapter(I,re,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,B,H,j){const se=this._addNewAdapter(new ge(this._documents,H),I);return this._proxy.$registerDocumentRangeSemanticTokensProvider(se,this._transformDocumentSelector(B),j),this._createDisposable(se)}$provideDocumentRangeSemanticTokens(I,B,H,j){return this._withAdapter(I,ge,se=>se.provideDocumentRangeSemanticTokens(r.URI.revive(B),H,j),null,j)}registerCompletionItemProvider(I,B,H,j){const se=this._addNewAdapter(new oe(this._documents,this._commands.converter,H,this._apiDeprecation,I),I);return this._proxy.$registerCompletionsProvider(se,this._transformDocumentSelector(B),j,oe.supportsResolving(H),`${I.identifier.value}(${j.join("")})`),this._createDisposable(se)}$provideCompletionItems(I,B,H,j,se){return this._withAdapter(I,oe,le=>le.provideCompletionItems(r.URI.revive(B),H,j,se),void 0,se)}$resolveCompletionItem(I,B,H){return this._withAdapter(I,oe,j=>j.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(I,B){this._withAdapter(I,oe,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(I,B,H){const j=new ce(I,this._documents,H,this._commands.converter),se=this._addNewAdapter(j,I);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(B),j.supportsHandleDidShowCompletionItem),this._createDisposable(se)}registerInlineCompletionsProviderNew(I,B,H){const j=this._addNewAdapter(new me(I,this._documents,H,this._commands.converter),I);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(B),!0),this._createDisposable(j)}$provideInlineCompletions(I,B,H,j,se){return this._withAdapter(I,Ee,le=>le.provideInlineCompletions(r.URI.revive(B),H,j,se),void 0,se)}$handleInlineCompletionDidShow(I,B,H){this._withAdapter(I,Ee,async j=>{j.handleDidShowCompletionItem(B,H)},void 0,void 0)}$freeInlineCompletionsList(I,B){this._withAdapter(I,Ee,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(I,B,H,j){const se=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,le=this._addNewAdapter(new be(this._documents,H),I);return this._proxy.$registerSignatureHelpProvider(le,this._transformDocumentSelector(B),se),this._createDisposable(le)}$provideSignatureHelp(I,B,H,j,se){return this._withAdapter(I,be,le=>le.provideSignatureHelp(r.URI.revive(B),H,j,se),void 0,se)}$releaseSignatureHelp(I,B){this._withAdapter(I,be,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(I,B,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new _e(this._documents,this._commands.converter,H,this._logService,I),I);this._proxy.$registerInlayHintsProvider(se,this._transformDocumentSelector(B),typeof H.resolveInlayHint=="function",j,Z._extLabel(I));let le=this._createDisposable(se);if(j!==void 0){const Y=H.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(j));le=M.Disposable.from(le,Y)}return le}$provideInlayHints(I,B,H,j){return this._withAdapter(I,_e,se=>se.provideInlayHints(r.URI.revive(B),H,j),void 0,j)}$resolveInlayHint(I,B,H){return this._withAdapter(I,_e,j=>j.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(I,B){this._withAdapter(I,_e,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(I,B,H){const j=this._addNewAdapter(new Fe(this._documents,H),I);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(B),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(I,B,H){return this._withAdapter(I,Fe,j=>j.provideLinks(r.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(I,B,H){return this._withAdapter(I,Fe,j=>j.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(I,B){this._withAdapter(I,Fe,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(I,B,H){const j=this._addNewAdapter(new Be(this._documents,H),I);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentColors(I,B,H){return this._withAdapter(I,Be,j=>j.provideColors(r.URI.revive(B),H),[],H)}$provideColorPresentations(I,B,H,j){return this._withAdapter(I,Be,se=>se.provideColorPresentations(r.URI.revive(B),H,j),void 0,j)}registerFoldingRangeProvider(I,B,H){const j=this._nextHandle(),se=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new Xe(this._documents,H),I)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(B),se);let le=this._createDisposable(j);if(se!==void 0){const Y=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(se));le=M.Disposable.from(le,Y)}return le}$provideFoldingRanges(I,B,H,j){return this._withAdapter(I,Xe,se=>se.provideFoldingRanges(r.URI.revive(B),H,j),void 0,j)}registerSelectionRangeProvider(I,B,H){const j=this._addNewAdapter(new ke(this._documents,H,this._logService),I);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideSelectionRanges(I,B,H,j){return this._withAdapter(I,ke,se=>se.provideSelectionRanges(r.URI.revive(B),H,j),[],j)}registerCallHierarchyProvider(I,B,H){const j=this._addNewAdapter(new ye(this._documents,H),I);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareCallHierarchy(I,B,H,j){return this._withAdapter(I,ye,se=>Promise.resolve(se.prepareSession(r.URI.revive(B),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(I,B,H,j){return this._withAdapter(I,ye,se=>se.provideCallsTo(B,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(I,B,H,j){return this._withAdapter(I,ye,se=>se.provideCallsFrom(B,H,j),void 0,j)}$releaseCallHierarchy(I,B){this._withAdapter(I,ye,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(I,B,H){const j=this._addNewAdapter(new De(this._documents,H),I);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareTypeHierarchy(I,B,H,j){return this._withAdapter(I,De,se=>Promise.resolve(se.prepareSession(r.URI.revive(B),H,j)),void 0,j)}$provideTypeHierarchySupertypes(I,B,H,j){return this._withAdapter(I,De,se=>se.provideSupertypes(B,H,j),void 0,j)}$provideTypeHierarchySubtypes(I,B,H,j){return this._withAdapter(I,De,se=>se.provideSubtypes(B,H,j),void 0,j)}$releaseTypeHierarchy(I,B){this._withAdapter(I,De,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(I,B,H){const j=this._nextHandle();return this._adapter.set(j,new ue(new ae(this._proxy,this._documents,H,j),I)),this._proxy.$registerDocumentOnDropEditProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentOnDropEdits(I,B,H,j,se,le){return this._withAdapter(I,ae,Y=>Promise.resolve(Y.provideDocumentOnDropEdits(B,r.URI.revive(H),j,se,le)),void 0,void 0)}registerDocumentPasteEditProvider(I,B,H,j){const se=this._nextHandle();return this._adapter.set(se,new ue(new x(this._proxy,this._documents,H,se),I)),this._proxy.$registerPasteEditProvider(se,this._transformDocumentSelector(B),!!H.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(se)}$prepareDocumentPaste(I,B,H,j,se){return this._withAdapter(I,x,le=>le.prepareDocumentPaste(r.URI.revive(B),H,j,se),void 0,se)}$providePasteEdits(I,B,H,j,se,le){return this._withAdapter(I,x,Y=>Y.providePasteEdits(B,r.URI.revive(H),j,se,le),void 0,le)}static _serializeRegExp(I){return{pattern:I.source,flags:(0,E.regExpFlags)(I)}}static _serializeIndentationRule(I){return{decreaseIndentPattern:Z._serializeRegExp(I.decreaseIndentPattern),increaseIndentPattern:Z._serializeRegExp(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?Z._serializeRegExp(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?Z._serializeRegExp(I.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(I){return{beforeText:Z._serializeRegExp(I.beforeText),afterText:I.afterText?Z._serializeRegExp(I.afterText):void 0,previousLineText:I.previousLineText?Z._serializeRegExp(I.previousLineText):void 0,action:I.action}}static _serializeOnEnterRules(I){return I.map(Z._serializeOnEnterRule)}setLanguageConfiguration(I,B,H){const{wordPattern:j}=H;if(j&&(0,E.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(B,j):this._documents.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const se=this._nextHandle(),le={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Z._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Z._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Z._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(se,B,le),this._createDisposable(se)}$setWordDefinitions(I){for(const B of I)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=Z,Z._handlePool=0}),define(Ce[205],Ie([1,0,4,8,6,29,15,7]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(O,b,m,k){this._documents=b,this._commands=m,this._uriTransformer=k,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,b){await this._proxy.$changeLanguage(O,b);const m=this._documents.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,b){const m=O.version,k=C.Position.from(b),p=await this._proxy.$tokensAtPosition(O.uri,k),l={type:S.StandardTokenType.Other,range:O.getWordRangeAtPosition(b)??new S.Range(b.line,b.character,b.line,b.character)};if(!p)return l;const u={range:C.Range.to(p.range),type:C.TokenType.to(p.type)};return!u.range.contains(b)||m!==O.version?l:u}createLanguageStatusItem(O,b,m){const k=this._handlePool++,p=this._proxy,l=this._ids,u=`${O.identifier.value}/${b}`;if(l.has(u))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);l.add(u);const d={selector:m,id:b,name:O.displayName??O.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const _=new A.DisposableStore,a=()=>{g?.dispose(),g=(0,y.disposableTimeout)(()=>{_.clear(),this._proxy.$setLanguageStatus(k,{id:u,name:d.name??O.displayName??O.name,source:O.displayName??O.name,selector:C.DocumentSelector.from(d.selector,this._uriTransformer),label:d.text,detail:d.detail??"",severity:d.severity===S.LanguageStatusSeverity.Error?M.default.Error:d.severity===S.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:d.command&&this._commands.toInternal(d.command,_),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},w={dispose(){_.dispose(),g?.dispose(),p.$removeLanguageStatus(k),l.delete(u)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,a()},get selector(){return d.selector},set selector(t){d.selector=t,a()},get text(){return d.text},set text(t){d.text=t,a()},get detail(){return d.detail},set detail(t){d.detail=t,a()},get severity(){return d.severity},set severity(t){d.severity=t,a()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,a()},get command(){return d.command},set command(t){d.command=t,a()},get busy(){return d.busy},set busy(t){d.busy=t,a()}};return a(),w}}e.ExtHostLanguages=E}),define(Ce[68],Ie([1,0,21,9,2,3,14,4,27,11]),function(ie,e,r,C,S,M,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(m,k,p){this.logService=p,this.bundleCache=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=m.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===r.LANGUAGE_DEFAULT}getMessage(m,k){const{message:p,args:l,comment:u}=k;if(this.isDefaultLanguage)return(0,C.format2)(p,l??{});let d=p;u&&u.length>0&&(d+=`/${u.join()}`);const g=this.bundleCache.get(m)?.contents[d];return g||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,C.format2)(g??d,l??{})}getBundle(m){return this.bundleCache.get(m)?.contents}getBundleUri(m){return this.bundleCache.get(m)?.uri}async initializeLocalizedMessages(m){if(this.isDefaultLanguage||!m.l10n||this.bundleCache.has(m.identifier.value))return;let k;const p=this.getBundleLocation(m);if(!p){this.logService.error(`No bundle location found for extension ${m.identifier.value}`);return}const l=S.URI.joinPath(p,`bundle.l10n.${this.currentLanguage}.json`);try{const u=await this._proxy.$fetchBundleContents(l);k=JSON.parse(u)}catch(u){this.logService.error(`Failed to load translations for ${m.identifier.value} from ${l}: ${u.message}`);return}k&&this.bundleCache.set(m.identifier.value,{contents:k,uri:l})}getBundleLocation(m){return m.l10n?S.URI.joinPath(m.extensionLocation,m.l10n):void 0}};O=ze([$e(0,E.IExtHostInitDataService),$e(1,P.IExtHostRpcService),$e(2,y.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ce[206],Ie([1,0,14,4,27,11,5]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends r.AbstractLoggerService{constructor(O,b){const m=new y.Emitter;super(b.logLevel,m.event),this._proxy=O.getProxy(C.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,b,m){return new E(this._proxy,O,b,m)}};A=ze([$e(0,M.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class E extends r.AbstractMessageLogger{constructor(O,b,m,k){super(k?.always),this.proxy=O,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(b,k).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,b){const m=[[O,b]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(O){this.proxy.$log(this.file,O)}}}),define(Ce[207],Ie([1,0,4,14,28]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let y=class{constructor(E,P){this._logService=P,this._proxy=E.getProxy(r.MainContext.MainThreadMessageService)}showMessage(E,P,O,b,m){const k={source:{identifier:E.identifier,label:E.displayName||E.name}};let p;typeof b=="string"||M(b)?p=[b,...m]:(k.modal=b?.modal,k.useCustom=b?.useCustom,k.detail=b?.detail,p=m),k.useCustom&&(0,S.checkProposedApiEnabled)(E,"resolvers");const l=[];for(let u=0;u<p.length;u++){const d=p[u];if(typeof d=="string")l.push({title:d,handle:u,isCloseAffordance:!1});else if(typeof d=="object"){const{title:g,isCloseAffordance:_}=d;l.push({title:g,isCloseAffordance:!!_,handle:u})}else this._logService.warn("Invalid message item:",d)}return this._proxy.$showMessage(P,O,k,l).then(u=>{if(typeof u=="number")return p[u]})}};y=ze([$e(1,C.ILogService)],y),e.ExtHostMessageService=y}),define(Ce[208],Ie([1,0,23,5,7,24,9,10,2,61,4,37,8,6,41,180,94]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(_=>_.apiEditor)}constructor(_,a,w,t){this._textDocumentsAndEditors=w,this._textDocuments=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=_.getProxy(O.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=_.getProxy(O.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=_.getProxy(O.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===12){const i=c.notebookEditor?.notebookUri,n=c.cell.handle,f=this._documents.get(i)?.getCell(n);if(f)return f.apiCell}return c}}),d._registerApiCommands(a)}getEditorById(_){const a=this._editors.get(_);if(!a)throw new Error(`unknown text editor: ${_}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(_){for(const[a,w]of this._editors)if(w.apiEditor===_)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(_,a){const w=this._documents.get(_);if(!w&&!a)throw new Error(`NO notebook document for '${_}'`);return w}_getProviderData(_){const a=this._notebookContentProviders.get(_);if(!a)throw new Error(`NO provider for '${_}'`);return a}registerNotebookContentProvider(_,a,w,t,c){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);return this._notebookContentProviders.set(a,{extension:_,provider:w}),this._notebookProxy.$registerNotebookProvider({id:_.identifier,location:_.extensionLocation},a,m.NotebookDocumentContentOptions.from(t),d._convertNotebookRegistrationData(_,c)),new k.Disposable(()=>{this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(_,a){if(!a)return;const w=a.filenamePattern.map(t=>m.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(a.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:_.identifier,providerDisplayName:_.displayName||_.name,displayName:a.displayName,filenamePattern:w,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(_,a,w){const t=d._notebookStatusBarItemProviderHandlePool++,c=typeof w.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,c,a);let i;return c!==void 0&&(i=w.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(c))),new k.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,c),i?.dispose()})}async createNotebookDocument(_){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:_.viewType,content:_.content&&m.NotebookData.from(_.content)});return E.URI.revive(a)}async openNotebookDocument(_){const a=this._documents.get(_);if(a)return a.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenNotebook(_),t=this._documents.get(E.URI.revive(w));return(0,A.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(_,a){E.URI.isUri(_)&&(_=await this.openNotebookDocument(_));let w;typeof a=="object"?w={position:m.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(m.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:w={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(_.uri,_.notebookType,w),c=t&&this._editors.get(t)?.apiEditor;if(c)return c;throw t?new Error(`Could NOT open editor for "${_.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${_.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(_,a,w,t){const c=this._notebookStatusBarItemProviders.get(_),i=E.URI.revive(a),n=this._documents.get(i);if(!n||!c)return;const o=n.getCellFromIndex(w);if(!o)return;const f=await c.provideCellStatusBarItems(o.apiCell,t);if(!f)return;const s=new S.DisposableStore,h=this._statusBarCache.add([s]),T=(Array.isArray(f)?f:[f]).map(N=>m.NotebookStatusBarItem.from(N,this._commandsConverter,s));return{cacheId:h,items:T}}$releaseNotebookCellStatusBarItems(_){this._statusBarCache.delete(_)}registerNotebookSerializer(_,a,w,t,c){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,w),this._notebookProxy.$registerNotebookSerializer(i,{id:_.identifier,location:_.extensionLocation},a,m.NotebookDocumentContentOptions.from(t),d._convertNotebookRegistrationData(_,c)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(_,a,w){const t=this._notebookSerializer.get(_);if(!t)throw new Error("NO serializer found");const c=await t.deserializeNotebook(a.buffer,w);return new p.SerializableObjectWithBuffers(m.NotebookData.from(c))}async $notebookToData(_,a,w){const t=this._notebookSerializer.get(_);if(!t)throw new Error("NO serializer found");const c=await t.serializeNotebook(m.NotebookData.to(a.value),w);return r.VSBuffer.wrap(c)}async $openNotebook(_,a,w,t,c){const{provider:i}=this._getProviderData(_),n=await i.openNotebook(E.URI.revive(a),{backupId:w,untitledDocumentData:t?.buffer},c);return new p.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(m.NotebookCellData.from)})}_createExtHostEditor(_,a,w){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const t=new u.ExtHostNotebookEditor(a,this._notebookEditorsProxy,_,w.visibleRanges.map(m.NotebookRange.to),w.selections.map(m.NotebookRange.to),typeof w.viewColumn=="number"?m.ViewColumn.to(w.viewColumn):void 0);this._editors.set(a,t)}$acceptDocumentAndEditorsDelta(_){if(_.value.removedDocuments)for(const w of _.value.removedDocuments){const t=E.URI.revive(w),c=this._documents.get(t);c&&(c.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:c.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(c.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===t.toString()&&this._editors.delete(i.id)}if(_.value.addedDocuments){const w=[];for(const t of _.value.addedDocuments){const c=E.URI.revive(t.uri);if(this._documents.has(c))throw new Error(`adding EXISTING notebook ${c} `);const i=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,c,t);w.push(...t.cells.map(n=>l.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(c)?.dispose(),this._documents.set(c,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(_.value.addedEditors)for(const w of _.value.addedEditors){if(this._editors.has(w.id))return;const t=E.URI.revive(w.documentUri),c=this._documents.get(t);c&&this._createExtHostEditor(c,w.id,w)}const a=[];if(_.value.removedEditors)for(const w of _.value.removedEditors){const t=this._editors.get(w);t&&(this._editors.delete(w),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),a.push(t))}if(_.value.visibleEditors){this._visibleNotebookEditors=_.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const w=new Set;this._visibleNotebookEditors.forEach(t=>w.add(t.id));for(const t of this._editors.values()){const c=w.has(t.id);t._acceptVisibility(c)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}_.value.newActiveEditor===null?this._activeNotebookEditor=void 0:_.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(_.value.newActiveEditor)),_.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(_){const a=b.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[a,new b.ApiCommandArgument("data","Bytes to convert to data",c=>c instanceof Uint8Array,c=>r.VSBuffer.wrap(c))],new b.ApiCommandResult("Notebook Data",c=>m.NotebookData.to(c.value))),t=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[a,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",c=>!0,c=>new p.SerializableObjectWithBuffers(m.NotebookData.from(c)))],new b.ApiCommandResult("Bytes",c=>c.buffer));_.registerApiCommand(w),_.registerApiCommand(t)}}e.ExtHostNotebookController=d,d._notebookStatusBarItemProviderHandlePool=0}),define(Ce[209],Ie([1,0,18,15,20,5,7,24,2,26,14,4,37,8,6,63,168,28,41]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let _=class{constructor(n,o,f,s,h){this._initData=o,this._extHostNotebook=f,this._commands=s,this._logService=h,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(b.MainContext.MainThreadNotebookKernels);const v=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const N=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:N}}else if(T&&"notebookEditor"in T){const N=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:N}}return T})],m.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(n,o,f,s,h,v){for(const oe of this._kernelData.values())if(oe.controller.id===o&&P.ExtensionIdentifier.equals(n.identifier,oe.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const T=this._handlePool++,N=this;this._logService.trace(`NotebookController[${T}], CREATED by ${n.identifier.value}, ${o}`);const V=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${n.identifier}'`);let U=!1;const D=new y.DisposableStore,x=new M.Emitter,L=new M.Emitter,R={id:c(n.identifier,o),notebookType:f,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:s||n.identifier.value,preloads:v?v.map(k.NotebookRendererScript.from):[]};let K=h??V,W;this._proxy.$addKernel(T,R).catch(oe=>{console.log(oe),U=!0});let $=0;const G=()=>{if(U)return;const oe=++$;Promise.resolve().then(()=>{oe===$&&this._proxy.$updateKernel(T,R)})},re=new A.ResourceMap,ge={get id(){return o},get notebookType(){return R.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return R.label},set label(oe){R.label=oe??n.displayName??n.name,G()},get detail(){return R.detail??""},set detail(oe){R.detail=oe,G()},get description(){return R.description??""},set description(oe){R.description=oe,G()},get kind(){return(0,d.checkProposedApiEnabled)(n,"notebookControllerKind"),R.kind??""},set kind(oe){(0,d.checkProposedApiEnabled)(n,"notebookControllerKind"),R.kind=oe,G()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(oe){R.supportedLanguages=oe,G()},get supportsExecutionOrder(){return R.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){R.supportsExecutionOrder=oe,G()},get rendererScripts(){return R.preloads?R.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(oe){K=oe??V},get interruptHandler(){return W},set interruptHandler(oe){W=oe,R.supportsInterrupt=Boolean(oe),G()},createNotebookCellExecution(oe){if(U)throw new Error("notebook controller is DISPOSED");if(!re.has(oe.notebook.uri))throw N._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Ee=>Ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return N._createNotebookCellExecution(oe,c(n.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${T}], DISPOSED`),U=!0,this._kernelData.delete(T),D.dispose(),x.dispose(),L.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(oe,Ee){Ee===p.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(n,"notebookControllerAffinityHidden"),N._proxy.$updateNotebookPriority(T,oe.uri,Ee)},onDidReceiveMessage:L.event,postMessage(oe,Ee){return(0,d.checkProposedApiEnabled)(n,"notebookMessaging"),N._proxy.$postMessage(T,Ee&&N._extHostNotebook.getIdByEditor(Ee),oe)},asWebviewUri(oe){return(0,d.checkProposedApiEnabled)(n,"notebookMessaging"),(0,l.asWebviewUri)(oe,N._initData.remote)}};return this._kernelData.set(T,{extensionId:n.identifier,controller:ge,onDidReceiveMessage:L,onDidChangeSelection:x,associatedNotebooks:re}),ge}getIdByController(n){for(const[o,f]of this._kernelData)if(f.controller===n)return c(f.extensionId,n.id);return null}$acceptNotebookAssociation(n,o,f){const s=this._kernelData.get(n);if(s){const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(o));f?s.associatedNotebooks.set(h.uri,!0):s.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,h.uri.toString(),f),s.onDidChangeSelection.fire({selected:f,notebook:h.apiNotebook})}}async $executeCells(n,o,f){const s=this._kernelData.get(n);if(!s)return;const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(o)),v=[];for(const T of f){const N=h.getCell(T);N&&v.push(N.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,h.uri.toString(),v.length),await s.controller.executeHandler.call(s.controller,v,h.apiNotebook,s.controller)}catch(T){this._logService.error(`NotebookController[${n}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(n,o,f){const s=this._kernelData.get(n);if(!s)return;const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(o));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,h.apiNotebook);else for(const v of f){const T=h.getCell(v);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,o,f){const s=this._kernelData.get(n);if(!s)return;const h=this._extHostNotebook.getEditorById(o);s.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:f}))}$cellExecutionChanged(n,o,f){const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(n)).getCell(o);if(h){const v=f?k.NotebookCellExecutionState.to(f):p.NotebookCellExecutionState.Idle;v!==void 0&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:v})}}_createNotebookCellExecution(n,o){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const h=new w(o,s,this._proxy);this._activeExecutions.set(s.uri,h);const v=h.onDidChangeState(()=>{h.state===a.Resolved&&(h.dispose(),v.dispose(),this._activeExecutions.delete(s.uri))});return h.asApiObject()}};_=ze([$e(4,O.ILogService)],_),e.ExtHostNotebookKernels=_;var a;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(a||(a={}));class w extends y.Disposable{get state(){return this._state}constructor(n,o,f){super(),this._cell=o,this._proxy=f,this._handle=w.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new S.CancellationTokenSource),this._collector=new t(10,s=>this.update(s)),this._executionOrder=o.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const o=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(o))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let o=this._cell;if(n&&(o=this._cell.notebook.getCellFromApiCell(n)),!o)throw new Error("INVALID cell");return o.handle}validateAndConvertOutputs(n){return n.map(o=>{const f=p.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return f===o.items?k.NotebookCellOutput.from(o):k.NotebookCellOutput.from({items:f,id:o.id,metadata:o.metadata})})}async updateOutputs(n,o,f){const s=this.cellIndexToHandle(o),h=this.validateAndConvertOutputs((0,r.asArray)(n));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,cellHandle:s,append:f,outputs:h})}async updateOutputItems(n,o,f){return n=p.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(n),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:n.map(k.NotebookCellOutputItem.from),outputId:o.id,append:f})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(f){n._executionOrder=f,n.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(f){if(n._state===a.Resolved||n._state===a.Started)throw new Error("Cannot call start again");n._state=a.Started,n._onDidChangeState.fire(),n.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,s){if(n._state===a.Resolved)throw new Error("Cannot call resolve twice");n._state=a.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new g.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:f}))},clearOutput(f){return n.verifyStateForOutput(),n.updateOutputs([],f,!1)},appendOutput(f,s){return n.verifyStateForOutput(),n.updateOutputs(f,s,!0)},replaceOutput(f,s){return n.verifyStateForOutput(),n.updateOutputs(f,s,!1)},appendOutputItems(f,s){return n.verifyStateForOutput(),n.updateOutputItems(f,s,!0)},replaceOutputItems(f,s){return n.verifyStateForOutput(),n.updateOutputItems(f,s,!1)}})}}w.HANDLE=0;class t{constructor(n,o){this.delay=n,this.callback=o,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new C.DeferredPromise,this.startedTimer=Date.now(),(0,C.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const o=this.batch;return this.batch=[],this.callback(o).finally(()=>n.complete())}}function c(i,n){return`${i.value}/${n}`}e.createKernelId=c}),define(Ce[210],Ie([1,0,5,4,94]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,E,P){const O=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(E)?.fire({editor:O.apiEditor,message:P})}createRendererMessaging(A,E){if(!A.contributes?.notebookRenderer?.some(O=>O.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(O,b,m)=>this.getOrCreateEmitterFor(E).event(O,b,m),postMessage:(O,b)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,b]=[b,O]);const m=b&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(b);return this.proxy.$postMessage(m?.id,E,O)}}}getOrCreateEmitterFor(A){let E=this._rendererMessageEmitters.get(A);return E||(E=new r.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,E),E)}}e.ExtHostNotebookRenderers=M}),define(Ce[211],Ie([1,0,20,5,7,4,2,6,12,18,29,60]),function(ie,e,r,C,S,M,y,A,E,P,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(k,p,l){const u=k.getProxy(M.MainContext.MainThreadQuickOpen);class d{constructor(o,f){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=f}showQuickPick(o,f,s=r.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(o),v=++this._instances,T=u.$show(v,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},s),N={},V=T.then(()=>N);return Promise.race([V,h]).then(U=>{if(U!==N)return h.then(D=>{const x=[];for(let L=0;L<D.length;L++){const R=D[L];typeof R=="string"?x.push({label:R,handle:L}):R.kind===A.QuickPickItemKind.Separator?x.push({type:"separator",label:R.label}):x.push({label:R.label,description:R.description,detail:R.detail,picked:R.picked,alwaysShow:R.alwaysShow,handle:L})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=L=>{f.onDidSelectItem(D[L])}),u.$setItems(v,x),T.then(L=>{if(typeof L=="number")return D[L];if(Array.isArray(L))return L.map(R=>D[R])})})}).then(void 0,U=>{if(!(0,E.isCancellationError)(U))return u.$setError(v,U),Promise.reject(U)})}$onItemSelected(o){this._onDidSelectItem?.(o)}showInput(o,f=r.CancellationToken.None){return this._validateInput=o?.validateInput,u.$input(o,typeof this._validateInput=="function",f).then(void 0,s=>{if(!(0,E.isCancellationError)(s))return Promise.reject(s)})}async $validateInput(o){if(!this._validateInput)return;const f=await this._validateInput(o);if(!f||typeof f=="string")return f;let s;switch(f.severity){case A.InputBoxValidationSeverity.Info:s=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:s=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:s=O.default.Error;break;default:s=f.message?O.default.Error:O.default.Ignore;break}return{content:f.message,severity:s}}async showWorkspaceFolderPick(o,f=r.CancellationToken.None){const s=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!s)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(v=>v.uri.toString()===s.uri.toString())}createQuickPick(o){const f=new c(o,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(o){const f=new i(o,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(o,f){this._sessions.get(o)?._fireDidChangeValue(f)}$onDidAccept(o){this._sessions.get(o)?._fireDidAccept()}$onDidChangeActive(o,f){const s=this._sessions.get(o);s instanceof c&&s._fireDidChangeActive(f)}$onDidChangeSelection(o,f){const s=this._sessions.get(o);s instanceof c&&s._fireDidChangeSelection(f)}$onDidTriggerButton(o,f){this._sessions.get(o)?._fireDidTriggerButton(f)}$onDidTriggerItemButton(o,f,s){const h=this._sessions.get(o);h instanceof c&&h._fireDidTriggerItemButton(f,s)}$onDidHide(o){this._sessions.get(o)?._fireDidHide()}}class g{constructor(o,f){this._extensionId=o,this._onDidDispose=f,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((f,s)=>{const h=f===A.QuickInputButtons.Back?-1:s;this._handlesToButtons.set(h,f)}),this.update({buttons:o.map((f,s)=>({...t(f),tooltip:f.tooltip,handle:f===A.QuickInputButtons.Back?-1:s}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const f=this._handlesToButtons.get(o);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),u.$dispose(this._id))}update(o){if(!this._disposed){for(const f of Object.keys(o)){const s=o[f];this._pendingUpdate[f]=s===void 0?null:s}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){u.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function _(n){if(n instanceof A.ThemeIcon)return{id:n.id};const o=w(n),f=a(n);return{dark:typeof o=="string"?y.URI.file(o):o,light:typeof f=="string"?y.URI.file(f):f}}function a(n){return typeof n=="object"&&"light"in n?n.light:n}function w(n){return typeof n=="object"&&"dark"in n?n.dark:n}function t(n){const o=_(n.iconPath);let f,s;return"id"in o?s=b.ThemeIcon.asClassName(o):f=o,{iconPath:f,iconClass:s}}class c extends g{constructor(o,f){super(o.identifier,f),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((s,h)=>{this._handlesToItems.set(h,s),this._itemsToHandles.set(s,h)});const f=[];for(let s=0;s<o.length;s++){const h=o[s];h.kind===A.QuickPickItemKind.Separator?f.push({type:"separator",label:h.label}):f.push({handle:s,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((v,T)=>({...t(v),tooltip:v.tooltip,handle:T}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(o){const f=(0,P.coalesce)(o.map(s=>this._handlesToItems.get(s)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(o){const f=(0,P.coalesce)(o.map(s=>this._handlesToItems.get(s)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(o,f){const s=this._handlesToItems.get(o);if(!s||!s.buttons||!s.buttons.length)return;const h=s.buttons[f];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:s})}}class i extends g{constructor(o,f){super(o.identifier,f),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,o?typeof o=="string"?this.update({validationMessage:o,severity:O.default.Error}):this.update({validationMessage:o.message,severity:o.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new d(p,l)}e.createExtHostQuickOpen=m});var Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r};define(Ce[212],Ie([1,0,2,5,55,7,15,4,18,118,14,26,60,8,28]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p){"use strict";var l,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(h){if(h)return typeof h.iconPath=="string"?r.URI.file(h.iconPath):r.URI.isUri(h.iconPath)||m.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function g(h,v){if(!h.iconPath&&!v.iconPath)return 0;if(h.iconPath){if(!v.iconPath)return 1}else return-1;const T=typeof h.iconPath=="string"?h.iconPath:r.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,N=typeof v.iconPath=="string"?v.iconPath:r.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,P.comparePaths)(T,N)}function _(h,v){let T=0;if(h.strikeThrough!==v.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==v.faded)return h.faded?1:-1;if(h.tooltip!==v.tooltip)return(h.tooltip||"").localeCompare(v.tooltip||"");if(T=g(h,v),T!==0)return T;if(h.light&&v.light)T=g(h.light,v.light);else{if(h.light)return 1;if(v.light)return-1}if(T!==0)return T;if(h.dark&&v.dark)T=g(h.dark,v.dark);else{if(h.dark)return 1;if(v.dark)return-1}return T}function a(h,v){if(h.command!==v.command)return h.command<v.command?-1:1;if(h.title!==v.title)return h.title<v.title?-1:1;if(h.tooltip!==v.tooltip){if(h.tooltip!==void 0&&v.tooltip!==void 0)return h.tooltip<v.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(h.arguments===v.arguments)return 0;if(h.arguments)if(v.arguments){if(h.arguments.length!==v.arguments.length)return h.arguments.length-v.arguments.length}else return 1;else return-1;for(let T=0;T<h.arguments.length;T++){const N=h.arguments[T],V=v.arguments[T];if(N!==V)return N<V?-1:1}return 0}function w(h,v){let T=(0,P.comparePaths)(h.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(T!==0)return T;if(h.command&&v.command)T=a(h.command,v.command);else{if(h.command)return 1;if(v.command)return-1}if(T!==0)return T;if(h.decorations&&v.decorations)T=_(h.decorations,v.decorations);else{if(h.decorations)return 1;if(v.decorations)return-1}return T}function t(h,v){for(let T=0;T<h.length;T++)if(h[T]!==v[T])return!1;return!0}function c(h,v){return h.command===v.command&&h.title===v.title&&h.tooltip===v.tooltip&&(h.arguments&&v.arguments?t(h.arguments,v.arguments):h.arguments===v.arguments)}function i(h,v){return(0,E.equals)(h,v,c)}class n{get value(){return this._value}set value(v){v=v??"",Oe(this,l,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Oe(this,l,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Oe(this,l,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get enabled(){return this._enabled}set enabled(v){v=!!v,this._enabled!==v&&(this._enabled=v,Oe(this,l,"f").$setInputBoxEnablement(this._sourceControlHandle,v))}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Oe(this,l,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}constructor(v,T,N){this._extension=v,this._sourceControlHandle=N,l.set(this,void 0),this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,l,T,"f")}showValidationMessage(v,T){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,l,"f").$showValidationMessage(this._sourceControlHandle,v,T)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=n,l=new WeakMap;class o{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}constructor(v,T,N,V,U){this._proxy=v,this._commands=T,this._sourceControlHandle=N,this._id=V,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,T){const N=this._resourceStatesCommandsMap.get(v);return N?(0,y.asPromise)(()=>this._commands.executeCommand(N.command,...N.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(w),N=(0,E.sortedDiff)(this._resourceSnapshot,v,w).map(D=>{const x=D.toInsert.map(L=>{const R=this._resourceHandlePool++;this._resourceStatesMap.set(R,L);const K=L.resourceUri;let W;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const be=new M.DisposableStore;W=this._commands.converter.toInternal(L.command,be),this._resourceStatesDisposablesMap.set(R,be)}else this._resourceStatesCommandsMap.set(R,L.command);const $=d(L.decorations),G=L.decorations&&d(L.decorations.light)||$,re=L.decorations&&d(L.decorations.dark)||$,ge=[G,re],oe=L.decorations&&L.decorations.tooltip||"",Ee=L.decorations&&!!L.decorations.strikeThrough,ce=L.decorations&&!!L.decorations.faded,me=L.contextValue||"";return{rawResource:[R,K,ge,oe,Ee,ce,me,W],handle:R}});return{start:D.start,deleteCount:D.deleteCount,toInsert:x}}),V=N.map(({start:D,deleteCount:x,toInsert:L})=>[D,x,L.map(R=>R.rawResource)]),U=N.reverse();for(const{start:D,deleteCount:x,toInsert:L}of U){const R=L.map(W=>W.handle),K=this._handlesSnapshot.splice(D,x,...R);for(const W of K)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=v,V}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class f{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Oe(this,u,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Oe(this,u,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Oe(this,u,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=v;const T=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Oe(this,u,"f").$updateSourceControl(this.handle,{acceptInputCommand:T})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=v;const T=v!==void 0?{command:this._commands.converter.toInternal(v.command,this._actionButtonDisposables.value),secondaryCommands:v.secondaryCommands?.map(N=>N.map(V=>this._commands.converter.toInternal(V,this._actionButtonDisposables.value))),description:v.description,enabled:v.enabled}:void 0;Oe(this,u,"f").$updateSourceControl(this.handle,{actionButton:T??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&i(this._statusBarCommands,v))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=v;const T=(v||[]).map(N=>this._commands.converter.toInternal(N,this._statusBarDisposables.value));Oe(this,u,"f").$updateSourceControl(this.handle,{statusBarCommands:T})}get selected(){return this._selected}constructor(v,T,N,V,U,D){this._extension=v,this._commands=N,this._id=V,this._label=U,this._rootUri=D,u.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=f._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,u,T,"f"),this._inputBox=new n(v,Oe(this,u,"f"),this.handle),Oe(this,u,"f").$registerSourceControl(this.handle,V,U,D)}createResourceGroup(v,T){const N=new o(Oe(this,u,"f"),this._commands,this.handle,v,T),V=C.Event.once(N.onDidDispose)(()=>this.createdResourceGroups.delete(N));return this.createdResourceGroups.set(N,V),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const v=[],T=[];for(const[N,V]of this.createdResourceGroups){V.dispose();const U=N.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(N),this.eventuallyUpdateResourceStates()});C.Event.once(N.onDidDispose)(()=>{this.updatedResourceGroups.delete(N),U.dispose(),this._groups.delete(N.handle),Oe(this,u,"f").$unregisterGroup(this.handle,N.handle)}),v.push([N.handle,N.id,N.label,N.features]);const D=N._takeResourceStateSnapshot();D.length>0&&T.push([N.handle,D]),this._groups.set(N.handle,N)}Oe(this,u,"f").$registerGroups(this.handle,v,T),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(T=>{const N=T._takeResourceStateSnapshot();N.length!==0&&v.push([T.handle,N])}),v.length>0&&Oe(this,u,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Oe(this,u,"f").$unregisterSourceControl(this.handle)}}u=new WeakMap,f._handlePool=0,ze([(0,S.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let s=class en{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(v,T,N){this._commands=T,this.logService=N,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=v.getProxy(A.MainContext.MainThreadSCM),this._telemetry=v.getProxy(A.MainContext.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const U=this._sourceControls.get(V.sourceControlHandle);if(!U)return V;const D=U.getResourceGroup(V.groupHandle);return D?D.getResourceState(V.handle):V}else if(V&&V.$mid===4){const U=this._sourceControls.get(V.sourceControlHandle);return U?U.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const U=this._sourceControls.get(V.handle);return U||V}return V}})}createSourceControl(v,T,N,V){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,T,N,V),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const U=en._handlePool++,D=new f(v,this._proxy,this._commands,T,N,V);this._sourceControls.set(U,D);const x=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier))||[];return x.push(D),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(v.identifier),x),D}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const T=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier)),N=T&&T[T.length-1];return N&&N.inputBox}$provideOriginalResource(v,T,N){const V=r.URI.revive(T);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,V.toString());const U=this._sourceControls.get(v);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(V,N)).then(D=>D||null)}$onInputBoxValueChange(v,T){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const N=this._sourceControls.get(v);return N&&N.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(v,T,N,V){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,T,N);const U=this._sourceControls.get(v);if(!U)return Promise.resolve(void 0);const D=U.getResourceGroup(T);return D?D.$executeResourceCommand(N,V):Promise.resolve(void 0)}$validateInput(v,T,N){this.logService.trace("ExtHostSCM#$validateInput",v);const V=this._sourceControls.get(v);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>V.inputBox.validateInput(T,N)).then(U=>{if(!U)return Promise.resolve(void 0);const D=k.MarkdownString.fromStrict(U.message);return D?Promise.resolve([D,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};s._handlePool=0,s=ze([$e(2,O.ILogService)],s),e.ExtHostSCM=s}),define(Ce[69],Ie([1,0,4,5,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,E){return this._proxy.$getPassword(A,E)}store(A,E,P){return this._proxy.$setPassword(A,E,P)}delete(A,E){return this._proxy.$deletePassword(A,E)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[213],Ie([1,0,6,4,133,7,8,10]),function(ie,e,r,C,S,M,y,A){"use strict";var E,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(p,l,u,d,g=r.StatusBarAlignment.Left,_){E.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Je(this,E,p,"f"),Je(this,P,l,"f"),this._entryId=O.ID_GEN++,this._extension=u,this._id=d,this._alignment=g,this._priority=this.validatePriority(_)}validatePriority(p){if(!!(0,A.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!O.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Oe(this,P,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Oe(this,P,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let l;this._name?l=this._name:l=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const d=y.MarkdownString.fromStrict(this._tooltip);Oe(this,E,"f").$setEntry(this._entryId,p,l,this._text,d,this._command?.internal,u,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,E=new WeakMap,P=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const l={message:p};return this._messages.unshift(l),this._update(),new r.Disposable(()=>{const u=this._messages.indexOf(l);u>=0&&(this._messages.splice(u,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(p,l){this._proxy=p.getProxy(C.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new b(this)}createStatusBarEntry(p,l,u,d){return new O(this._proxy,this._commands,p,l,u,d)}setStatusBarMessage(p,l){const u=this._statusMessage.setMessage(p);let d;return typeof l=="number"?d=setTimeout(()=>u.dispose(),l):typeof l<"u"&&l.then(()=>u.dispose(),()=>u.dispose()),new r.Disposable(()=>{u.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=m}),define(Ce[70],Ie([1,0,4,5,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A){this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,E){this._proxy.$registerExtensionStorageKeysToSync(A,E)}initializeExtensionStorage(A,E,P){return this._proxy.$initializeExtensionStorage(A,E).then(O=>O||P)}setValue(A,E,P){return this._proxy.$setValue(A,E,P)}$acceptValue(A,E,P){this._onDidChangeStorage.fire({shared:A,key:E,value:P})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Ce[71],Ie([1,0,3,27,14,52,2]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let A=class{constructor(P,O,b){this._logService=O,this._extHostFileSystem=b,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(P){return y.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,O=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(P){if(this._value)return y.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return y.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=ze([$e(0,C.IExtHostInitDataService),$e(1,S.ILogService),$e(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ce[98],Ie([1,0,3,4,11]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,r.createDecorator)("IExtHostTelemetryLogService");let M=class{constructor(A){this._telemetryShape=A.getProxy(C.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(A,E,P){this._telemetryShape.$logTelemetryToOutputChannel(`${A.identifier.value}/${E}`,P)}};M=ze([$e(0,S.IExtHostRpcService)],M),e.ExtHostTelemetryLogService=M}),define(Ce[53],Ie([1,0,5,4,3,2,11,7,6,134,12,169,20,43,155,60,10,15,8]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class _{constructor(s,h,v,T){this._proxy=s,this._id=h,this._creationOptions=v,this._name=T,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(V=>this._pidPromiseComplete=V);const N=this;this.value={get name(){return N._name||""},get processId(){return N._pidPromise},get creationOptions(){return N._creationOptions},get exitStatus(){return N._exitStatus},get state(){return N._state},sendText(V,U=!0){N._checkDisposed(),N._proxy.$sendText(N._id,V,U)},show(V){N._checkDisposed(),N._proxy.$show(N._id,V)},hide(){N._checkDisposed(),N._proxy.$hide(N._id)},dispose(){N._disposed||(N._disposed=!0,N._proxy.$dispose(N._id))},get dimensions(){if(!(N._cols===void 0||N._rows===void 0))return{columns:N._cols,rows:N._rows}}}}async create(s,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:(0,u.withNullAsUndefined)(s.shellPath),shellArgs:(0,u.withNullAsUndefined)(s.shellArgs),cwd:(0,u.withNullAsUndefined)(s.cwd),env:(0,u.withNullAsUndefined)(s.env),icon:(0,u.withNullAsUndefined)(n(s.iconPath)),color:l.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,u.withNullAsUndefined)(s.message),strictEnv:(0,u.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,u.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,u.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,u.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(s.location,h?.resolvedExtHostIdentifier),isTransient:(0,u.withNullAsUndefined)(s.isTransient)})}async createExtensionTerminal(s,h,v,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:l.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(s,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(s,h){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in s?{viewColumn:g.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitStatus(s,h){this._exitStatus=Object.freeze({code:s,reason:h})}setDimensions(s,h){return s===this._cols&&h===this._rows||s===0||h===0?!1:(this._cols=s,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=_;class a{get onProcessReady(){return this._onProcessReady.event}constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput?.(s)}resize(s,h){this._pty.setDimensions?.({columns:s,rows:h})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(s||void 0),s&&this._pty.setDimensions?.(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let w=1,t=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(s,h){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new r.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=h.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[v,T]of this._terminalProcesses)T.shutdown(!0)}})}getDefaultShell(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(s,h){const v=new _(this._proxy,(0,k.generateUuid)(),s,s.name),T=new a(s.pty);return v.createExtensionTerminal(s.location,this._serializeParentTerminal(s,h).resolvedExtHostIdentifier,n(s.iconPath),o(s.color)).then(N=>{const V=this._setupExtHostProcessListeners(N,T);this._terminalProcessDisposables[N]=V}),this._terminals.push(v),v.value}_serializeParentTerminal(s,h){if(h=h||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const v=s.location.parentTerminal;if(v){const T=this._terminals.find(N=>N.value===v);T&&(h.resolvedExtHostIdentifier=T._id)}}else s.location&&typeof s.location!="object"?h.location=s.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(s,h){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const T=new a(h),N=this._setupExtHostProcessListeners(s,T);this._terminalProcessDisposables[s]=N}async $acceptActiveTerminalChanged(s){const h=this._activeTerminal;if(s===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(s);v&&(this._activeTerminal=v,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,h){const v=this._getTerminalById(s);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:h})}async $acceptTerminalDimensions(s,h,v){const T=this._getTerminalById(s);T&&T.setDimensions(h,v)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptTerminalMaximumDimensions(s,h,v){this._terminalProcesses.get(s)?.resize(h,v)}async $acceptTerminalTitleChange(s,h){const v=this._getTerminalById(s);v&&(v.name=h)}async $acceptTerminalClosed(s,h,v){const T=this._getTerminalObjectIndexById(this._terminals,s);if(T!==null){const N=this._terminals.splice(T,1)[0];N.setExitStatus(h,v),this._onDidCloseTerminal.fire(N.value)}}$acceptTerminalOpened(s,h,v,T){if(h){const U=this._getTerminalObjectIndexById(this._terminals,h);if(U!==null){this._terminals[U]._id=s,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const N={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:M.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},V=new _(this._proxy,s,N,v);this._terminals.push(V),this._onDidOpenTerminal.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(s,h){this._getTerminalById(s)?._setProcessId(h)}async $startExtensionTerminal(s,h){const v=this._getTerminalById(s);if(!v)return{message:(0,P.localize)(0,null,s)};v.isOpen||await new Promise(N=>{const V=this.onDidOpenTerminal(async U=>{U===v.value&&(V.dispose(),N())})});const T=this._terminalProcesses.get(s);T?T.startSendingEvents(h):this._extensionTerminalAwaitingStart[s]={initialDimensions:h}}_setupExtHostProcessListeners(s,h){const v=new A.DisposableStore;v.add(h.onProcessReady(N=>this._proxy.$sendProcessReady(s,N.pid,N.cwd))),v.add(h.onDidChangeProperty(N=>this._proxy.$sendProcessProperty(s,N))),this._bufferer.startBuffering(s,h.onProcessData),v.add(h.onProcessExit(N=>this._onProcessExit(s,N))),this._terminalProcesses.set(s,h);const T=this._extensionTerminalAwaitingStart[s];return T&&h instanceof a&&(h.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),v}$acceptProcessAckDataEvent(s,h){this._terminalProcesses.get(s)?.acknowledgeDataEvent(h)}$acceptProcessInput(s,h){this._terminalProcesses.get(s)?.input(h)}$acceptTerminalInteraction(s){const h=this._getTerminalById(s);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(s,h,v){try{this._terminalProcesses.get(s)?.resize(h,v)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(s,h){this._terminalProcesses.get(s)?.shutdown(h)}$acceptProcessRequestInitialCwd(s){this._terminalProcesses.get(s)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(s,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(s){this._terminalProcesses.get(s)?.getCwd().then(h=>this._proxy.$sendProcessProperty(s,{type:"cwd",value:h}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,h,v){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,v),this._proxy.$registerProfileProvider(h,s.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(s,h){const v=new m.CancellationTokenSource().token;let T=await this._profileProviders.get(s)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,h);return}this.createTerminalFromOptions(T.options,h)}}async $provideLinks(s,h){const v=this._getTerminalById(s);if(!v)return[];this._terminalLinkCache.delete(s),this._terminalLinkCancellationSource.get(s)?.dispose(!0);const N=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,N);const V=[],U={terminal:v.value,line:h},D=[];for(const R of this._linkProviders)D.push(d.Promises.withAsyncBody(async K=>{N.token.onCancellationRequested(()=>K({provider:R,links:[]}));const W=await R.provideTerminalLinks(U,N.token)||[];N.token.isCancellationRequested||K({provider:R,links:W})}));const x=await Promise.all(D);if(N.token.isCancellationRequested)return[];const L=new Map;for(const R of x)R&&R.links.length>0&&V.push(...R.links.map(K=>{const W={id:w++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return L.set(W.id,{provider:R.provider,link:K}),W}));return this._terminalLinkCache.set(s,L),V}$activateLink(s,h){const v=this._terminalLinkCache.get(s)?.get(h);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(s,h){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const v=this._terminalProcessDisposables[s];v&&(v.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,h)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,h){const v=this._getTerminalObjectIndexById(s,h);return v!==null?s[v]:null}_getTerminalObjectIndexById(s,h){let v=null;return s.some((T,N)=>T._id===h?(v=N,!0):!1),v}getEnvironmentVariableCollection(s){let h=this._environmentVariableCollections.get(s.identifier.value);return h||(h=new c,this._setEnvironmentVariableCollection(s.identifier.value,h)),h}_syncEnvironmentVariableCollection(s,h){const v=(0,b.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(s,h.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(s){s.forEach(h=>{const v=h[0],T=new c(h[1]);this._setEnvironmentVariableCollection(v,T)})}$acceptDefaultProfile(s,h){const v=this._defaultProfile;this._defaultProfile=s,this._defaultAutomationProfile=h,v?.path!==s.path&&this._onDidChangeShell.fire(s.path)}_setEnvironmentVariableCollection(s,h){this._environmentVariableCollections.set(s,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,h)})}};t=ze([$e(1,y.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class c{get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(s)}get size(){return this.map.size}replace(s,h){this._setIfDiffers(s,{value:h,type:E.EnvironmentVariableMutatorType.Replace})}append(s,h){this._setIfDiffers(s,{value:h,type:E.EnvironmentVariableMutatorType.Append})}prepend(s,h){this._setIfDiffers(s,{value:h,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,h){const v=this.map.get(s);(!v||v.value!==h.value||v.type!==h.type)&&(this.map.set(s,h),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,h){this.map.forEach((v,T)=>s.call(h,T,v,this))}[Symbol.iterator](){return this.map.entries()}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let i=class extends t{constructor(s){super(!1,s)}createTerminal(s,h,v){throw new O.NotSupportedError}createTerminalFromOptions(s,h){throw new O.NotSupportedError}};i=ze([$e(0,y.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function n(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function o(f){return l.ThemeColor.isThemeColor(f)?f:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r};define(Ce[214],Ie([1,0,18,23,20,5,178,215,7,25,10,43,4,11,95,8,6,40,65,48]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_){"use strict";var a,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(U,D,x){this.editors=x,this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(m.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new i(this.proxy),D.registerArgumentProcessor({processArgument:L=>{if(L?.$mid!==13)return L;const R=L,K=R.tests[R.tests.length-1].item.extId;return this.controllers.get(d.TestId.root(K))?.collection.tree.get(K)?.actual??(0,p.toItemFromContext)(L)}})}createTestController(U,D,x){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const L=new E.DisposableStore,R=L.add(new p.ExtHostTestItemCollection(U,D,this.editors));R.root.label=D;const K=new Map,W=this.proxy,$={items:R.root.children,get label(){return D},set label(re){D=re,R.root.label=re,W.$updateController(U,{label:D})},get refreshHandler(){return x},set refreshHandler(re){x=re,W.$updateController(U,{canRefresh:!!re})},get id(){return U},createRunProfile:(re,ge,oe,Ee,ce)=>{let me=(0,A.hash)(re);for(;K.has(me);)me++;return new T(this.proxy,K,U,me,re,ge,oe,Ee,ce)},createTestItem(re,ge,oe){return new p.TestItemImpl(U,re,ge,oe)},createTestRun:(re,ge,oe=!0)=>this.runTracker.createTestRun(U,R,re,ge,oe),set resolveHandler(re){R.resolveHandler=re},get resolveHandler(){return R.resolveHandler},dispose:()=>{L.dispose()}};W.$registerTestController(U,D,!!x),L.add((0,E.toDisposable)(()=>W.$unregisterTestController(U)));const G={controller:$,collection:R,profiles:K};return this.controllers.set(U,G),L.add((0,E.toDisposable)(()=>this.controllers.delete(U))),L.add(R.onDidGenerateDiff(re=>W.$publishDiff(U,re.map(_.TestsDiffOp.serialize)))),$}createTestObserver(){return this.observer.checkout()}async runTests(U,D=S.CancellationToken.None){const x=n(U);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.controllers.get(x.controllerId);if(!L)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(R=>d.TestId.fromExtHostTestItem(R,L.collection.root.id).toString())??[L.collection.root.id],profileGroup:N[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:U.exclude?.map(R=>R.id)},D)}$syncTests(){for(const{collection:U}of this.controllers.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,D,x){return(0,r.mapFind)(this.runTracker.trackers,R=>R.id===U?R.getCoverage(D):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(U,D,x,L){return(0,r.mapFind)(this.runTracker.trackers,K=>K.id===U?K.getCoverage(D):void 0)?.resolveFileCoverage(x,L)??Promise.resolve([])}$configureRunProfile(U,D){this.controllers.get(U)?.profiles.get(D)?.configureHandler?.()}async $refreshTests(U,D){await this.controllers.get(U)?.controller.refreshHandler?.(D)}$publishTestResults(U){this.results=Object.freeze(U.map(D=>(0,P.deepFreeze)(l.TestResults.to(D))).concat(this.results).sort((D,x)=>x.completedAt-D.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,D){const x=this.controllers.get(d.TestId.fromString(U).controllerId)?.collection;x&&(await x.expand(U,D<0?1/0:D),x.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(_.TestsDiffOp.deserialize))}async $runControllerTests(U,D){return Promise.all(U.map(x=>this.runControllerTestRequest(x,D)))}async runControllerTestRequest(U,D){const x=this.controllers.get(U.controllerId);if(!x)return{};const{collection:L,profiles:R}=x,K=R.get(U.profileId);if(!K)return{};const W=U.testIds.map(ge=>L.tree.get(ge)).filter(O.isDefined),$=U.excludeExtIds.map(ge=>x.collection.tree.get(ge)).filter(O.isDefined).filter(ge=>W.some(oe=>oe.fullId.compare(ge.fullId)===2));if(!W.length)return{};const G=new u.TestRunRequest(W.some(ge=>ge.actual instanceof p.TestItemRootImpl)?void 0:W.map(ge=>ge.actual),$.map(ge=>ge.actual),K),re=this.runTracker.prepareForMainThreadTestRun(G,o.fromInternal(U,x.collection),D);try{return await K.runHandler(G,D),{}}catch(ge){return{error:String(ge)}}finally{re.isRunning&&!D.isCancellationRequested&&await M.Event.toPromise(re.onEnd),re.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};t=ze([$e(0,k.IExtHostRpcService)],t),e.ExtHostTesting=t;class c extends E.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,D,x){super(),this.dto=U,this.proxy=D,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:L}of this.tasks.values())L.end()}))}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const D=this.dto.id,x=this.dto.controllerId,L=(0,b.generateUuid)(),R=new f(this.proxy,D,L),K=re=>(ge,...oe)=>{if($){console.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ge)||(this.ensureTestIsKnown(ge),re(ge,...oe))},W=(re,ge)=>{const oe=ge instanceof Array?ge.map(l.TestMessage.from):[l.TestMessage.from(ge)];if(re.uri&&re.range){const Ee={range:l.Range.from(re.range),uri:re.uri};for(const ce of oe)ce.location=ce.location||Ee}this.proxy.$appendTestMessagesInRun(D,L,d.TestId.fromExtHostTestItem(re,x).toString(),oe)};let $=!1;const G={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return R.coverageProvider},set coverageProvider(re){R.coverageProvider=re},enqueued:K(re=>{this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(re,x).toString(),1)}),skipped:K(re=>{this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(re,x).toString(),5)}),started:K(re=>{this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(re,x).toString(),2)}),errored:K((re,ge,oe)=>{W(re,ge),this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(re,x).toString(),6,oe)}),failed:K((re,ge,oe)=>{W(re,ge),this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(re,x).toString(),4,oe)}),passed:K((re,ge)=>{this.proxy.$updateTestStateInRun(D,L,d.TestId.fromExtHostTestItem(re,this.dto.controllerId).toString(),3,ge)}),appendOutput:(re,ge,oe)=>{$||(oe&&(this.dto.isIncluded(oe)?this.ensureTestIsKnown(oe):oe=void 0),this.proxy.$appendOutputToRun(D,L,C.VSBuffer.fromString(re),ge&&l.location.from(ge),oe&&d.TestId.fromExtHostTestItem(oe,x).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(D,L),this.tasks.delete(L),this.isRunning||this.dispose())}};return this.tasks.set(L,{run:G,coverage:R}),this.proxy.$startedTestRunTask(D,{id:L,name:U,running:!0}),G}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(U){if(!(U instanceof p.TestItemImpl))throw new g.InvalidTestItemError(U.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const D=[],x=this.dto.colllection.root;for(;;){const L=l.TestItem.from(U);if(D.unshift(L),this.sharedTestIds.has(L.extId)||(this.sharedTestIds.add(L.extId),U===x))break;U=U.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,D)}}class i{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,D,x){return this.getTracker(U,D,x)}cancelRunById(U){for(const D of this.tracked.values())if(D.id===U){D.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,D,x,L,R){const K=this.tracked.get(x);if(K)return K.createRun(L);const W=o.fromPublic(U,D,x,R),$=n(x);this.proxy.$startedExtensionTestRun({controllerId:U,profile:$&&{group:N[$.kind],id:$.profileId},exclude:x.exclude?.map(re=>d.TestId.fromExtHostTestItem(re,D.root.id).toString())??[],id:W.id,include:x.include?.map(re=>d.TestId.fromExtHostTestItem(re,D.root.id).toString())??[D.root.id],persist:R});const G=this.getTracker(x,W);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),G.createRun(L)}getTracker(U,D,x){const L=new c(D,this.proxy,x);return this.tracked.set(U,L),L.onEnd(()=>this.tracked.delete(U)),L}}e.TestRunCoordinator=i;const n=V=>{if(!!V.profile){if(!(V.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class o{static fromPublic(U,D,x,L){return new o(U,(0,b.generateUuid)(),x.include?.map(R=>d.TestId.fromExtHostTestItem(R,U).toString())??[U],x.exclude?.map(R=>d.TestId.fromExtHostTestItem(R,U).toString())??[],L,D)}static fromInternal(U,D){return new o(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,D)}constructor(U,D,x,L,R,K){this.controllerId=U,this.id=D,this.isPersisted=R,this.colllection=K,this.includePrefix=x.map(W=>W+"\0"),this.excludePrefix=L.map(W=>W+"\0")}isIncluded(U){const D=d.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(D===x||D.startsWith(x))return!1;for(const x of this.includePrefix)if(D===x||D.startsWith(x))return!0;return!1}}e.TestRunDto=o;class f{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,D,x){this.proxy=U,this.runId=D,this.taskId=x}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(D){throw this.fileCoverage=void 0,D}}async resolveFileCoverage(U,D){const x=await this.fileCoverage;let L=x?.[U];return!this._coverageProvider||!x||!L?[]:(L.detailedCoverage||(L=x[U]=await this._coverageProvider.resolveFileCoverage?.(L,D)??L),L.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class s extends _.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){super(),this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,l.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const D=d.TestId.parentId(U.item.extId);if(D&&this.alreadyRemoved.has(D.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:D,removed:x}=this;return{get added(){return[...U].map(L=>L.revived)},get updated(){return[...D].map(L=>L.revived)},get removed(){return[...x].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,D){return{...U,revived:l.TestItem.toPlain(U.item),depth:D?D.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}e.MirroredTestCollection=h;class v{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(D=>D.revived)},dispose:(0,y.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class T{get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?l.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,D,x,L,R,K,W,$=!1,G=void 0){this.controllerId=x,this.profileId=L,this._label=R,this.kind=K,this.runHandler=W,this._isDefault=$,this._tag=G,a.set(this,void 0),w.set(this,void 0),Je(this,a,U,"f"),Je(this,w,D,"f"),D.set(L,this);const re=N[K];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,a,"f").$publishTestRunProfile({profileId:L,controllerId:x,tag:G?l.TestTag.namespace(this.controllerId,G.id):null,label:R,group:re,isDefault:$,hasConfigurationHandler:!1})}dispose(){Oe(this,w,"f")?.delete(this.profileId)&&(Je(this,w,void 0,"f"),Oe(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=T,a=new WeakMap,w=new WeakMap;const N={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Ce[216],Ie([1,0,18,5,4,96,8,6]),function(ie,e,r,C,S,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(O,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new C.Emitter,this._onDidChangeTextEditorOptions=new C.Emitter,this._onDidChangeTextEditorVisibleRanges=new C.Emitter,this._onDidChangeTextEditorViewColumn=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const b=this._extHostDocumentsAndEditors.allEditors();return O?b:b.map(m=>m.value)}async showTextDocument(O,b,m){let k;typeof b=="number"?k={position:y.ViewColumn.from(b),preserveFocus:m}:typeof b=="object"?k={position:y.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?y.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:k={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(O.uri,k),l=p&&this._extHostDocumentsAndEditors.getEditor(p);if(l)return l.value;throw p?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,b){return new M.TextEditorDecorationType(this._proxy,O,b).value}$acceptEditorPropertiesChanged(O,b){const m=this._extHostDocumentsAndEditors.getEditor(O);if(!m)throw new Error("unknown text editor");if(b.options&&m._acceptOptions(b.options),b.selections){const k=b.selections.selections.map(y.Selection.to);m._acceptSelections(k)}if(b.visibleRanges){const k=r.coalesce(b.visibleRanges.map(y.Range.to));m._acceptVisibleRanges(k)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...b.options,lineNumbers:y.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const k=A.TextEditorSelectionChangeKind.fromValue(b.selections.source),p=b.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:p,kind:k})}if(b.visibleRanges){const k=r.coalesce(b.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:k})}}$acceptEditorPositionData(O){for(const b in O){const m=this._extHostDocumentsAndEditors.getEditor(b);if(!m)throw new Error("Unknown text editor");const k=y.ViewColumn.to(O[b]);m.value.viewColumn!==k&&(m._acceptViewColumn(k),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:k}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=E}),define(Ce[217],Ie([1,0,2,3,4,7,6,8,10]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class P{constructor(m,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===11){const l=p.uri===void 0?void 0:r.URI.revive(p.uri);return this._itemsBySourceAndUriMap.get(p.source)?.get(O(l))?.get(p.handle)}return p}})}async $getTimeline(m,k,p,l){return this._providers.get(m)?.provideTimeline(r.URI.revive(k),p,l)}registerTimelineProvider(m,k,p,l){const u=new M.DisposableStore,d=this.convertTimelineItem(k.id,l,u).bind(this);let g;k.onDidChange&&(g=k.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:k.id}),this));const _=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:m,onDidChange:void 0,async provideTimeline(a,w,t){w?.resetCache&&(u.clear(),_.get(k.id)?.clear());const c=await k.provideTimeline(a,w,t);if(c==null)return;const i=d(a,w);return{...c,source:k.id,items:c.items.map(i)}},dispose(){for(const a of _.values())a.get(k.id)?.clear();g?.dispose(),u.dispose()}})}convertTimelineItem(m,k,p){return(l,u)=>{let d;if(u?.cacheResults){let g=this._itemsBySourceAndUriMap.get(m);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(m,g));const _=O(l);d=g.get(_),d===void 0&&(d=new Map,g.set(_,d))}return g=>{const{iconPath:_,...a}=g,w=`${m}|${g.id??g.timestamp}`;d?.set(w,g);let t,c,i;g.iconPath&&(_ instanceof y.ThemeIcon?i={id:_.id,color:_.color}:r.URI.isUri(_)?(t=_,c=_):{light:t,dark:c}=_);let n;return y.MarkdownString.isMarkdownString(a.tooltip)?n=A.MarkdownString.from(a.tooltip):(0,E.isString)(a.tooltip)?n=a.tooltip:y.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=A.MarkdownString.from(a.detail)):(0,E.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=a.detail),{...a,id:a.id??void 0,handle:w,source:m,command:g.command?k.toInternal(g.command,p):void 0,icon:t,iconDark:c,themeIcon:i,tooltip:n,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,M.toDisposable)(()=>{for(const p of this._itemsBySourceAndUriMap.values())p.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=P;function O(b){return b?.toString()}}),define(Ce[218],Ie([1,0,7,13,2,4]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(E){this._openers=new Map,this._proxy=E.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,P,O,b){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const m=b.schemes.find(k=>!y.supportedSchemes.has(k));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,O),this._proxy.$registerUriOpener(P,b.schemes,E,b.label),(0,r.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(E,P,O){const b=this._openers.get(E);if(!b)throw new Error(`Unknown opener with id: ${E}`);const m=S.URI.revive(P);return b.canOpenExternalUri(m,O)}async $openUri(E,P,O){const b=this._openers.get(E);if(!b)throw new Error(`Unknown opener id: '${E}'`);return b.openExternalUri(S.URI.revive(P.resolvedUri),{sourceUri:S.URI.revive(P.sourceUri)},O)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(Ce[219],Ie([1,0,4,2,7,12,26]),function(ie,e,r,C,S,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(P,O){if(this.handles.has(y.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const b=A.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(P)),this.handlers.set(b,O),this._proxy.$registerUriHandler(b,P),(0,S.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(P)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(P,O){const b=this.handlers.get(P);if(!b)return Promise.resolve(void 0);try{b.handleUri(C.URI.revive(O))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(P){return C.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=A,A.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[54],Ie([1,0,5,13,2,145,162,63,4]),function(ie,e,r,C,S,M,y,A,E){"use strict";var P,O,b,m,k,p,l,u,d,g,_,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(h,v,T,N,V,U,D){P.set(this,void 0),O.set(this,void 0),b.set(this,void 0),m.set(this,void 0),k.set(this,void 0),p.set(this,void 0),l.set(this,""),u.set(this,void 0),d.set(this,!1),g.set(this,!1),_.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new r.Emitter),this._onDidDispose=Oe(this,a,"f").event,Je(this,P,h,"f"),Je(this,O,v,"f"),Je(this,u,T,"f"),Je(this,m,N,"f"),Je(this,k,V,"f"),Je(this,p,U,"f"),Je(this,_,t(U),"f"),Je(this,b,D,"f")}dispose(){Je(this,d,!0,"f"),Oe(this,a,"f").fire(),Oe(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return Je(this,g,!0,"f"),(0,A.asWebviewUri)(h,Oe(this,m,"f"))}get cspSource(){const h=Oe(this,p,"f").extensionLocation;if(h.scheme===C.Schemas.https||h.scheme===C.Schemas.http){let v=h.toString();return v.endsWith("/")||(v+="/"),v+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,l,"f")}set html(h){this.assertNotDisposed(),Oe(this,l,"f")!==h&&(Je(this,l,h,"f"),!Oe(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(Je(this,g,!0,"f"),Oe(this,b,"f").report("Webview vscode-resource: uris",Oe(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,O,"f").$setHtml(Oe(this,P,"f"),h))}get options(){return this.assertNotDisposed(),Oe(this,u,"f")}set options(h){this.assertNotDisposed(),Oe(this,O,"f").$setOptions(Oe(this,P,"f"),n(Oe(this,p,"f"),Oe(this,k,"f"),h)),Je(this,u,h,"f")}async postMessage(h){if(Oe(this,d,"f"))return!1;const v=(0,y.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Oe(this,_,"f")});return Oe(this,O,"f").$postMessage(Oe(this,P,"f"),v.message,...v.buffers)}assertNotDisposed(){if(Oe(this,d,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,P=new WeakMap,O=new WeakMap,b=new WeakMap,m=new WeakMap,k=new WeakMap,p=new WeakMap,l=new WeakMap,u=new WeakMap,d=new WeakMap,g=new WeakMap,_=new WeakMap,a=new WeakMap;function t(s){try{const h=(0,M.normalizeVersion)((0,M.parseVersion)(s.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=t;class c{constructor(h,v,T,N,V){this.remoteInfo=v,this.workspace=T,this._logService=N,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=h.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(h,v,T){const N=this.getWebview(h);if(N){const{message:V}=(0,y.deserializeWebviewMessage)(v,T.value);N._onMessageEmitter.fire(V)}}$onMissingCsp(h,v){this._logService.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,v,T){const N=new w(h,this._webviewProxy,o(v),this.remoteInfo,this.workspace,T,this._deprecationService);return this._webviews.set(h,N),N._onDidDispose(()=>{this._webviews.delete(h)}),N}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=c;function i(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=i;function n(s,h,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||f(s,h)}}e.serializeWebviewOptions=n;function o(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(h=>S.URI.from(h))}}e.reviveOptions=o;function f(s,h){return[...(h?.getWorkspaceFolders()||[]).map(v=>v.uri),s.extensionLocation]}}),define(Ce[220],Ie([1,0,20,215,7,13,22,2,8,54,61,4,6]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(t,c){this.document=t,this._storagePath=c,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,c){await this.getEdit(t).undo(),c||this.disposeBackup()}async redo(t,c){await this.getEdit(t).redo(),c||this.disposeBackup()}disposeEdits(t){for(const c of t)this._edits.delete(c)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=a(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const c=this._edits.get(t,0);if(!c)throw new Error("No edit found");return c}}class p{constructor(){this._documents=new Map}get(t,c){return this._documents.get(this.key(t,c))}add(t,c,i){const n=this.key(t,c.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${c.uri}`);const o=new k(c,i);return this._documents.set(n,o),o}delete(t,c){const i=this.key(t,c.uri);this._documents.delete(i)}key(t,c){return`${t}@@@${c}`}}var l;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(l||(l={}));class u{constructor(){this._providers=new Map}addTextProvider(t,c,i){return this.add(0,t,c,i)}addCustomProvider(t,c,i){return this.add(1,t,c,i)}get(t){return this._providers.get(t)}add(t,c,i,n){if(this._providers.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this._providers.set(c,{type:t,extension:i,provider:n}),new m.Disposable(()=>this._providers.delete(c))}}class d{constructor(t,c,i,n,o){this._extHostDocuments=c,this._extensionStoragePaths=i,this._extHostWebview=n,this._extHostWebviewPanels=o,this._editorProviders=new u,this._documents=new p,this._proxy=t.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,c,i,n){const o=new S.DisposableStore;return g(i)?(o.add(this._editorProviders.addTextProvider(c,t,i)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),c,n.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(c,t,i)),this.supportEditing(i)&&o.add(i.onDidChangeCustomDocument(f=>{const s=this.getCustomDocumentEntry(c,f.document.uri);if(_(f)){const h=s.addEdit(f);this._proxy.$onDidEdit(f.document.uri,c,h,f.label)}else this._proxy.$onContentChange(f.document.uri,c)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),c,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),m.Disposable.from(o,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(c)}))}async $createCustomDocument(t,c,i,n,o){const f=this._editorProviders.get(c);if(!f)throw new Error(`No provider found for '${c}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${c}'`);const s=A.URI.revive(t),h=await f.provider.openCustomDocument(s,{backupId:i,untitledDocumentData:n?.buffer},o);let v;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(v=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(c,h,v),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,c){const i=this._editorProviders.get(c);if(!i)throw new Error(`No provider found for '${c}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${c}'`);const n=A.URI.revive(t),{document:o}=this.getCustomDocumentEntry(c,n);this._documents.delete(c,o),o.dispose()}async $resolveWebviewEditor(t,c,i,n,o,f){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);const h=E.ViewColumn.to(o),v=this._extHostWebview.createNewWebview(c,n.webviewOptions,s.extension),T=this._extHostWebviewPanels.createNewWebviewPanel(c,i,n.title,h,n.panelOptions,v,!0),N=A.URI.revive(t);switch(s.type){case 1:{const{document:V}=this.getCustomDocumentEntry(i,N);return s.provider.resolveCustomEditor(V,T,f)}case 0:{const V=this._extHostDocuments.getDocument(N);return s.provider.resolveCustomTextEditor(V,T,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,c,i){this.getCustomDocumentEntry(c,t).disposeEdits(i)}async $onMoveCustomEditor(t,c,i){const n=this._editorProviders.get(i);if(!n)throw new Error(`No provider found for '${i}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const f=A.URI.revive(c),s=this._extHostDocuments.getDocument(f);await n.provider.moveCustomTextEditor(s,o,r.CancellationToken.None)}async $undo(t,c,i,n){return this.getCustomDocumentEntry(c,t).undo(i,n)}async $redo(t,c,i,n){return this.getCustomDocumentEntry(c,t).redo(i,n)}async $revert(t,c,i){const n=this.getCustomDocumentEntry(c,t);await this.getCustomEditorProvider(c).revertCustomDocument(n.document,i),n.disposeBackup()}async $onSave(t,c,i){const n=this.getCustomDocumentEntry(c,t);await this.getCustomEditorProvider(c).saveCustomDocument(n.document,i),n.disposeBackup()}async $onSaveAs(t,c,i,n){const o=this.getCustomDocumentEntry(c,t);return this.getCustomEditorProvider(c).saveCustomDocumentAs(o.document,A.URI.revive(i),n)}async $backup(t,c,i){const n=this.getCustomDocumentEntry(c,t),f=await this.getCustomEditorProvider(c).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},i);return n.updateBackup(f),f.id}getCustomDocumentEntry(t,c){const i=this._documents.get(t,A.URI.revive(c));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const i=this._editorProviders.get(t)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=d;function g(w){return typeof w.resolveCustomTextEditor=="function"}function _(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function a(w){const t=w.scheme===M.Schemas.file||w.scheme===M.Schemas.untitled?w.fsPath:w.toString();return(0,C.hash)(t)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[221],Ie([1,0,5,7,2,43,8,54,4,6]),function(ie,e,r,C,S,M,y,A,E,P){"use strict";var O,b,m,k,p,l,u,d,g,_,a,w,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class c extends C.Disposable{constructor(f,s,h,v){super(),O.set(this,void 0),b.set(this,void 0),m.set(this,void 0),k.set(this,void 0),p.set(this,void 0),l.set(this,void 0),u.set(this,void 0),d.set(this,void 0),g.set(this,!0),_.set(this,void 0),a.set(this,!1),w.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,w,"f").event,t.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,O,f,"f"),Je(this,b,s,"f"),Je(this,k,h,"f"),Je(this,m,v.viewType,"f"),Je(this,p,v.panelOptions,"f"),Je(this,d,v.viewColumn,"f"),Je(this,l,v.title,"f"),Je(this,_,v.active,"f")}dispose(){Oe(this,a,"f")||(Je(this,a,!0,"f"),Oe(this,w,"f").fire(),Oe(this,b,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,k,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,k,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,l,"f")}set title(f){this.assertNotDisposed(),Oe(this,l,"f")!==f&&(Je(this,l,f,"f"),Oe(this,b,"f").$setTitle(Oe(this,O,"f"),f))}get iconPath(){return this.assertNotDisposed(),Oe(this,u,"f")}set iconPath(f){this.assertNotDisposed(),Oe(this,u,"f")!==f&&(Je(this,u,f,"f"),Oe(this,b,"f").$setIconPath(Oe(this,O,"f"),S.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Oe(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,d,"f")=="number"&&Oe(this,d,"f")<0))return Oe(this,d,"f")}get active(){return this.assertNotDisposed(),Oe(this,_,"f")}get visible(){return this.assertNotDisposed(),Oe(this,g,"f")}_updateViewState(f){Oe(this,a,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Je(this,_,f.active,"f"),Je(this,g,f.visible,"f"),Je(this,d,f.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(f,s){this.assertNotDisposed(),Oe(this,b,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof f>"u"?void 0:y.ViewColumn.from(f),preserveFocus:!!s})}assertNotDisposed(){if(Oe(this,a,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,b=new WeakMap,m=new WeakMap,k=new WeakMap,p=new WeakMap,l=new WeakMap,u=new WeakMap,d=new WeakMap,g=new WeakMap,_=new WeakMap,a=new WeakMap,w=new WeakMap,t=new WeakMap;class i{static newHandle(){return(0,M.generateUuid)()}constructor(f,s,h){this.webviews=s,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(E.MainContext.MainThreadWebviewPanels)}createWebviewPanel(f,s,h,v,T={}){const N=typeof v=="object"?v.viewColumn:v,V={viewColumn:y.ViewColumn.from(N),preserveFocus:typeof v=="object"&&!!v.preserveFocus},U=(0,A.shouldSerializeBuffersForPostMessage)(f),D=i.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(f),D,s,{title:h,panelOptions:n(T),webviewOptions:(0,A.serializeWebviewOptions)(f,this.workspace,T),serializeBuffersForPostMessage:U},V);const x=this.webviews.createNewWebview(D,T,f);return this.createNewWebviewPanel(D,s,h,N,T,x,!0)}$onDidChangeWebviewPanelViewStates(f){const s=Object.keys(f);s.sort((h,v)=>{const T=f[h],N=f[v];return T.active?1:N.active?-1:+T.visible-+N.visible});for(const h of s){const v=this.getWebviewPanel(h);if(!v)continue;const T=f[h];v._updateViewState({active:T.active,visible:T.visible,viewColumn:y.ViewColumn.to(T.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,s,h){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:h,extension:f}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(f)}),new P.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(f,s,h,v){const T=this._serializers.get(s);if(!T)throw new Error(`No serializer found for '${s}'`);const{serializer:N,extension:V}=T,U=this.webviews.createNewWebview(f,h.webviewOptions,V),D=this.createNewWebviewPanel(f,s,h.title,v,h.panelOptions,U,h.active);await N.deserializeWebviewPanel(D,h.state)}createNewWebviewPanel(f,s,h,v,T,N,V){const U=new c(f,this._proxy,N,{viewType:s,title:h,viewColumn:v,panelOptions:T,active:V});return this._webviewPanels.set(f,U),U}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=i;function n(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[222],Ie([1,0,5,7,54,8,4,6]),function(ie,e,r,C,S,M,y,A){"use strict";var E,P,O,b,m,k,p,l,u,d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends C.Disposable{constructor(t,c,i,n,o,f,s){super(),E.set(this,void 0),P.set(this,void 0),O.set(this,void 0),b.set(this,void 0),m.set(this,!1),k.set(this,void 0),p.set(this,void 0),l.set(this,void 0),u.set(this,void 0),d.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Oe(this,d,"f").event,g.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,g,"f").event,Je(this,O,i,"f"),Je(this,p,n,"f"),Je(this,E,t,"f"),Je(this,P,c,"f"),Je(this,b,o,"f"),Je(this,k,s,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,g,"f").fire(),Oe(this,b,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,p,"f")}set title(t){this.assertNotDisposed(),Oe(this,p,"f")!==t&&(Je(this,p,t,"f"),Oe(this,P,"f").$setWebviewViewTitle(Oe(this,E,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,l,"f")}set description(t){this.assertNotDisposed(),Oe(this,l,"f")!==t&&(Je(this,l,t,"f"),Oe(this,P,"f").$setWebviewViewDescription(Oe(this,E,"f"),t))}get visible(){return Oe(this,k,"f")}get webview(){return Oe(this,b,"f")}get viewType(){return Oe(this,O,"f")}_setVisible(t){t===Oe(this,k,"f")||Oe(this,m,"f")||(Je(this,k,t,"f"),Oe(this,d,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,u,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,u,"f")?.value&&t?.tooltip===Oe(this,u,"f")?.tooltip)&&(Je(this,u,M.ViewBadge.from(t),"f"),Oe(this,P,"f").$setWebviewViewBadge(Oe(this,E,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,P,"f").$show(Oe(this,E,"f"),!!t)}assertNotDisposed(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,P=new WeakMap,O=new WeakMap,b=new WeakMap,m=new WeakMap,k=new WeakMap,p=new WeakMap,l=new WeakMap,u=new WeakMap,d=new WeakMap,g=new WeakMap;class a{constructor(t,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,c,i,n){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:i,extension:t}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(t),c,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(t,c,i,n,o){const f=this._viewProviders.get(c);if(!f)throw new Error(`No view provider found for '${c}'`);const{provider:s,extension:h}=f,v=this._extHostWebview.createNewWebview(t,{},h),T=new _(t,this._proxy,c,i,v,h,!0);this._webviewViews.set(t,T),await s.resolveWebviewView(T,{state:n},o)}async $onDidChangeWebviewViewVisibility(t,c){this.getWebviewView(t)._setVisible(c)}async $disposeWebviewView(t){const c=this.getWebviewView(t);this._webviewViews.delete(t),c.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const c=this._webviewViews.get(t);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=a}),define(Ce[99],Ie([1,0,5,4,2,13,9,3,11]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class tn{get state(){return this._state}constructor(b){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=tn.InitialState,this._proxy=b.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,m){let k;if(typeof b=="string"){k=b;try{b=S.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,y.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,k,m)}async asExternalUri(b,m){if((0,y.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this._proxy.$asExternalUri(b,m);return S.URI.from(k)}};P.InitialState={focused:!0},P=ze([$e(0,E.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ce[223],Ie([1,0,193,27,11]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends r.AbstractExtHostConsoleForwarder{constructor(A,E){super(A,E)}_nativeConsoleLogMessage(A,E,P){E.apply(console,P)}};M=ze([$e(0,S.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ce[224],Ie([1,0,15,23,20,12,5,7,119,187,41]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(T,N){try{return JSON.stringify(T,N)}catch{return"null"}}const k="$$ref$$",p={[k]:-1};class l{constructor(N,V){this.jsonString=N,this.referencedBuffers=V}}function u(T,N=null,V=!1){const U=[];return{jsonString:(V?m:JSON.stringify)(T,(x,L)=>{if(typeof L>"u")return p;if(typeof L=="object"){if(L instanceof C.VSBuffer){const R=U.push(L)-1;return{[k]:R}}if(N)return N(x,L)}return L}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=u;function d(T,N,V){return JSON.parse(T,(U,D)=>{if(D){const x=D[k];if(typeof x=="number")return N[x];if(V&&D.$mid===1)return V.transformIncoming(D)}return D})}e.parseJsonAndRestoreBufferRefs=d;function g(T,N){return JSON.stringify(T,N)}function _(T){return T?(N,V)=>V&&V.$mid===1?T.transformOutgoing(V):V:null}var a;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(T){T[T.Responsive=0]="Responsive",T[T.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},c=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class n extends A.Disposable{constructor(N,V=null,U=null){super(),this[b]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=N,this._logger=V,this._uriTransformer=U,this._uriReplacer=_(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,x=O.ProxyIdentifier.count;D<x;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(N=>{this._pendingRPCReplies[N].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(N){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(N){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(N){this._responsiveState!==N&&(this._responsiveState=N,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(N){return this._uriTransformer?(0,E.transformIncomingURIs)(N,this._uriTransformer):N}getProxy(N){const{nid:V,sid:U}=N;return this._proxies[V]||(this._proxies[V]=this._createProxy(V,U)),this._proxies[V]}_createProxy(N,V){const U={get:(D,x)=>(typeof x=="string"&&!D[x]&&x.charCodeAt(0)===36&&(D[x]=(...L)=>this._remoteCall(N,x,L)),x===i?V:D[x])};return new Proxy(Object.create(null),U)}set(N,V){return this._locals[N.nid]=V,V}assertRegistered(N){for(let V=0,U=N.length;V<U;V++){const D=N[V];if(!this._locals[D.nid])throw new Error(`Missing proxy instance ${D.sid}`)}}_receiveOneMessage(N){if(this._isDisposed)return;const V=N.byteLength,U=o.read(N,0),D=U.readUInt8(),x=U.readUInt32();switch(D){case 1:case 2:{let{rpcId:L,method:R,args:K}=s.deserializeRequestJSONArgs(U);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,x,L,R,K,D===2);break}case 3:case 4:{let{rpcId:L,method:R,args:K}=s.deserializeRequestMixedArgs(U);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,x,L,R,K,D===4);break}case 5:{this._logger?.logIncoming(V,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(V,x);break}case 7:{this._receiveReply(V,x,void 0);break}case 9:{let L=s.deserializeReplyOKJSON(U);this._uriTransformer&&(L=(0,E.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(V,x,L);break}case 10:{const L=s.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(V,x,L);break}case 8:{const L=s.deserializeReplyOKVSBuffer(U);this._receiveReply(V,x,L);break}case 11:{let L=s.deserializeReplyErrError(U);this._uriTransformer&&(L=(0,E.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(V,x,L);break}case 12:{this._receiveReplyErr(V,x,void 0);break}default:console.error("received unexpected message"),console.error(N)}}_receiveRequest(N,V,U,D,x,L){this._logger?.logIncoming(N,V,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(U)}.${D}(`,x);const R=String(V);let K,W;if(L){const G=new S.CancellationTokenSource;x.push(G.token),K=this._invokeHandler(U,D,x),W=()=>G.cancel()}else K=this._invokeHandler(U,D,x),W=t;this._cancelInvokedHandlers[R]=W;const $=s.serializeAcknowledged(V);this._logger?.logOutgoing($.byteLength,V,1,"ack"),this._protocol.send($),K.then(G=>{delete this._cancelInvokedHandlers[R];const re=s.serializeReplyOK(V,G,this._uriReplacer);this._logger?.logOutgoing(re.byteLength,V,1,"reply:",G),this._protocol.send(re)},G=>{delete this._cancelInvokedHandlers[R];const re=s.serializeReplyErr(V,G);this._logger?.logOutgoing(re.byteLength,V,1,"replyErr:",G),this._protocol.send(re)})}_receiveCancel(N,V){this._logger?.logIncoming(N,V,1,"receiveCancel");const U=String(V);this._cancelInvokedHandlers[U]?.()}_receiveReply(N,V,U){this._logger?.logIncoming(N,V,0,"receiveReply:",U);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const x=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],x.resolveOk(U)}_receiveReplyErr(N,V,U){this._logger?.logIncoming(N,V,0,"receiveReplyErr:",U);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const x=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let L;U&&(U.$isError?(L=new Error,L.name=U.name,L.message=U.message,L.stack=U.stack):L=U),x.resolveErr(L)}_invokeHandler(N,V,U){try{return Promise.resolve(this._doInvokeHandler(N,V,U))}catch(D){return Promise.reject(D)}}_doInvokeHandler(N,V,U){const D=this._locals[N];if(!D)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(N));const x=D[V];if(typeof x!="function")throw new Error("Unknown method "+V+" on actor "+(0,O.getStringIdentifierForProxy)(N));return x.apply(D,U)}_remoteCall(N,V,U){if(this._isDisposed)return new P.CanceledLazyPromise;let D=null;if(U.length>0&&S.CancellationToken.isCancellationToken(U[U.length-1])&&(D=U.pop()),D&&D.isCancellationRequested)return Promise.reject(M.canceled());const x=s.serializeRequestArguments(U,this._uriReplacer),L=++this._lastMessageId,R=String(L),K=new P.LazyPromise;D&&D.onCancellationRequested(()=>{const $=s.serializeCancel(L);this._logger?.logOutgoing($.byteLength,L,0,"cancel"),this._protocol.send(s.serializeCancel(L))}),this._pendingRPCReplies[R]=K,this._onWillSendRequest(L);const W=s.serializeRequest(L,N,V,x,!!D);return this._logger?.logOutgoing(W.byteLength,L,0,`request: ${(0,O.getStringIdentifierForProxy)(N)}.${V}(`,U),this._protocol.send(W),K}}e.RPCProtocol=n,b=c,n.UNRESPONSIVE_TIME=3*1e3;class o{static alloc(N,V,U){const D=new o(C.VSBuffer.alloc(U+1+4),0);return D.writeUInt8(N),D.writeUInt32(V),D}static read(N,V){return new o(N,V)}get buffer(){return this._buff}constructor(N,V){this._buff=N,this._offset=V}static sizeUInt8(){return 1}writeUInt8(N){this._buff.writeUInt8(N,this._offset),this._offset+=1}readUInt8(){const N=this._buff.readUInt8(this._offset);return this._offset+=1,N}writeUInt32(N){this._buff.writeUInt32BE(N,this._offset),this._offset+=4}readUInt32(){const N=this._buff.readUInt32BE(this._offset);return this._offset+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this._buff.writeUInt8(N.byteLength,this._offset),this._offset+=1,this._buff.set(N,this._offset),this._offset+=N.byteLength}readShortString(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,U}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readLongString(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,U}writeBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readVSBuffer(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+N);return this._offset+=N,V}static sizeMixedArray(N){let V=0;V+=1;for(let U=0,D=N.length;U<D;U++){const x=N[U];switch(V+=1,x.type){case 1:V+=this.sizeLongString(x.value);break;case 2:V+=this.sizeVSBuffer(x.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(x.value);for(let L=0;L<x.buffers.length;++L)V+=this.sizeVSBuffer(x.buffers[L]);break;case 4:break}}return V}writeMixedArray(N){this._buff.writeUInt8(N.length,this._offset),this._offset+=1;for(let V=0,U=N.length;V<U;V++){const D=N[V];switch(D.type){case 1:this.writeUInt8(1),this.writeLongString(D.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D.value);break;case 3:this.writeUInt8(3),this.writeUInt32(D.buffers.length),this.writeLongString(D.value);for(let x=0;x<D.buffers.length;++x)this.writeBuffer(D.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const V=new Array(N);for(let U=0;U<N;U++)switch(this.readUInt8()){case 1:V[U]=this.readLongString();break;case 2:V[U]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),L=this.readLongString(),R=[];for(let K=0;K<x;++K)R.push(this.readVSBuffer());V[U]=new O.SerializableObjectWithBuffers(d(L,R,null));break}case 4:V[U]=void 0;break}return V}}o.sizeUInt32=4;var f;(function(T){T[T.Simple=0]="Simple",T[T.Mixed=1]="Mixed"})(f||(f={}));class s{static _useMixedArgSerialization(N){for(let V=0,U=N.length;V<U;V++)if(N[V]instanceof C.VSBuffer||N[V]instanceof O.SerializableObjectWithBuffers||typeof N[V]>"u")return!0;return!1}static serializeRequestArguments(N,V){if(this._useMixedArgSerialization(N)){const U=[];for(let D=0,x=N.length;D<x;D++){const L=N[D];if(L instanceof C.VSBuffer)U[D]={type:2,value:L};else if(typeof L>"u")U[D]={type:4};else if(L instanceof O.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:K}=u(L.value,V);U[D]={type:3,value:C.VSBuffer.fromString(R),buffers:K}}else U[D]={type:1,value:C.VSBuffer.fromString(g(L,V))}}return{type:1,args:U}}return{type:0,args:g(N,V)}}static serializeRequest(N,V,U,D,x){switch(D.type){case 0:return this._requestJSONArgs(N,V,U,D.args,x);case 1:return this._requestMixedArgs(N,V,U,D.args,x)}}static _requestJSONArgs(N,V,U,D,x){const L=C.VSBuffer.fromString(U),R=C.VSBuffer.fromString(D);let K=0;K+=o.sizeUInt8(),K+=o.sizeShortString(L),K+=o.sizeLongString(R);const W=o.alloc(x?2:1,N,K);return W.writeUInt8(V),W.writeShortString(L),W.writeLongString(R),W.buffer}static deserializeRequestJSONArgs(N){const V=N.readUInt8(),U=N.readShortString(),D=N.readLongString();return{rpcId:V,method:U,args:JSON.parse(D)}}static _requestMixedArgs(N,V,U,D,x){const L=C.VSBuffer.fromString(U);let R=0;R+=o.sizeUInt8(),R+=o.sizeShortString(L),R+=o.sizeMixedArray(D);const K=o.alloc(x?4:3,N,R);return K.writeUInt8(V),K.writeShortString(L),K.writeMixedArray(D),K.buffer}static deserializeRequestMixedArgs(N){const V=N.readUInt8(),U=N.readShortString(),D=N.readMixedArray(),x=new Array(D.length);for(let L=0,R=D.length;L<R;L++){const K=D[L];typeof K=="string"?x[L]=JSON.parse(K):x[L]=K}return{rpcId:V,method:U,args:x}}static serializeAcknowledged(N){return o.alloc(5,N,0).buffer}static serializeCancel(N){return o.alloc(6,N,0).buffer}static serializeReplyOK(N,V,U){if(typeof V>"u")return this._serializeReplyOKEmpty(N);if(V instanceof C.VSBuffer)return this._serializeReplyOKVSBuffer(N,V);if(V instanceof O.SerializableObjectWithBuffers){const{jsonString:D,referencedBuffers:x}=u(V.value,U,!0);return this._serializeReplyOKJSONWithBuffers(N,D,x)}else return this._serializeReplyOKJSON(N,m(V,U))}static _serializeReplyOKEmpty(N){return o.alloc(7,N,0).buffer}static _serializeReplyOKVSBuffer(N,V){let U=0;U+=o.sizeVSBuffer(V);const D=o.alloc(8,N,U);return D.writeVSBuffer(V),D.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static _serializeReplyOKJSON(N,V){const U=C.VSBuffer.fromString(V);let D=0;D+=o.sizeLongString(U);const x=o.alloc(9,N,D);return x.writeLongString(U),x.buffer}static _serializeReplyOKJSONWithBuffers(N,V,U){const D=C.VSBuffer.fromString(V);let x=0;x+=o.sizeUInt32,x+=o.sizeLongString(D);for(const R of U)x+=o.sizeVSBuffer(R);const L=o.alloc(10,N,x);L.writeUInt32(U.length),L.writeLongString(D);for(const R of U)L.writeBuffer(R);return L.buffer}static deserializeReplyOKJSON(N){const V=N.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(N,V){const U=N.readUInt32(),D=N.readLongString(),x=[];for(let L=0;L<U;++L)x.push(N.readVSBuffer());return new O.SerializableObjectWithBuffers(d(D,x,V))}static serializeReplyErr(N,V){const U=V?m(M.transformErrorForSerialization(V),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(N);const D=C.VSBuffer.fromString(U);let x=0;x+=o.sizeLongString(D);const L=o.alloc(11,N,x);return L.writeLongString(D),L.buffer}static deserializeReplyErrError(N){const V=N.readLongString();return JSON.parse(V)}static _serializeReplyErrEmpty(N){return o.alloc(12,N,0).buffer}}var h;(function(T){T[T.RequestJSONArgs=1]="RequestJSONArgs",T[T.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",T[T.RequestMixedArgs=3]="RequestMixedArgs",T[T.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",T[T.Acknowledged=5]="Acknowledged",T[T.Cancel=6]="Cancel",T[T.ReplyOKEmpty=7]="ReplyOKEmpty",T[T.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",T[T.ReplyOKJSON=9]="ReplyOKJSON",T[T.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",T[T.ReplyErrError=11]="ReplyErrError",T[T.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var v;(function(T){T[T.String=1]="String",T[T.VSBuffer=2]="VSBuffer",T[T.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",T[T.Undefined=4]="Undefined"})(v||(v={}))}),define(Ce[225],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(M){const y=A=>{self.removeEventListener("message",y);const E=A.data;Object.defineProperties(self,{postMessage:{value(P,O){E.postMessage(P,O)}},onmessage:{get(){return E.onmessage},set(P){E.onmessage=P}}}),E.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",y)}.toString();class C extends EventTarget{constructor(M,y,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${r})('${y}'))`,P=new Blob([E],{type:"application/javascript"}),O=URL.createObjectURL(P),b=new MessageChannel,m=O,k={type:"_newWorker",id:m,port:b.port2,url:O,options:A};M(k,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(p){b.port1.onmessage=p}},onmessageerror:{get(){return b.port1.onmessageerror},set(p){b.port1.onmessageerror=p}}}),b.port1.addEventListener("messageerror",p=>{const l=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(l)}),b.port1.addEventListener("message",p=>{const l=new MessageEvent("message",{data:p.data});this.dispatchEvent(l)}),b.port1.start()}}e.NestedWorker=C}),define(Ce[226],Ie([1,0,5,30,39,3,35,12,15]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new r.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new r.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(p){this.channels.has(p.id)||(this.channels.set(p.id,p),this._onDidRegisterChannel.fire(p.id))}getChannels(){const p=[];return this.channels.forEach(l=>p.push(l)),p}getChannel(p){return this.channels.get(p)}removeChannel(p){this.channels.delete(p),this._onDidRemoveChannel.fire(p)}}C.Registry.add(e.Extensions.OutputChannels,new O);function b(k,p,l,u,d){return(0,E.createCancelablePromise)(async g=>{await(0,y.whenProviderRegistered)(l,u);const _=C.Registry.as(e.Extensions.OutputChannels);try{await m(l,1,u,d,g),_.registerChannel({id:k,label:p,file:l,log:!0})}catch(a){(0,A.isCancellationError)(a)||d.error("Error while registering log channel",l.toString(),(0,A.getErrorMessage)(a))}})}e.registerLogChannel=b;async function m(k,p,l,u,d){if(!await l.exists(k)){if(d.isCancellationRequested)throw new A.CancellationError;if(p>10)throw new Error("Timed out while waiting for file to be created");u.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",k.toString()),await(0,E.timeout)(1e3,d),await m(k,p+1,l,u,d)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new S.RawContextKey("activeOutputChannel","")}),define(Ce[100],Ie([1,0,4,3,11,14,226,52,27,36,113,23,10,35]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class p extends M.AbstractMessageLogger{get disposed(){return this._disposed}constructor(g,_,a,w,t){super(),this.id=g,this.name=_,this.logger=a,this.proxy=w,this.extension=t,this.offset=0,this._disposed=!1,this.visible=!1,this._register(a.onDidChangeLogLevel(c=>this.setLevel(c)))}appendLine(g){this.append(g+`
`)}append(g){this.info(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Clear,g)}replace(g){const _=this.offset;this.info(g),this.proxy.$update(this.id,y.OutputChannelUpdateMode.Replace,_),this.visible&&this.logger.flush()}show(g,_){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:_))}hide(){this.proxy.$close(this.id)}log(g,_){this.offset+=b.VSBuffer.fromString(_).byteLength,(0,M.log)(this.logger,g,_)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class l extends p{appendLine(g){this.append(g)}}let u=class{constructor(g,_,a,w,t){this.initData=_,this.extHostFileSystem=a,this.extHostFileSystemInfo=w,this.loggerService=t,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(_.logsLocation,`output_logging_${(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[_,a]of this.channels)a.visible=_===this.visibleChannelId}createOutputChannel(g,_,a){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const w=typeof _=="object"&&_.log,t=(0,m.isString)(_)?_:void 0;if((0,m.isString)(t)&&!t.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=w?this.doCreateLogOutputChannel(g,a):this.doCreateOutputChannel(g,t,a);return c.then(i=>{this.channels.set(i.id,i),i.visible=i.id===this.visibleChannelId}),w?this.createExtHostLogOutputChannel(g,c):this.createExtHostOutputChannel(g,c)}async doCreateOutputChannel(g,_,a){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const w=await this.outputDirectoryPromise,t=this.extHostFileSystemInfo.extUri.joinPath(w,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.loggerService.createLogger(t,{always:!0,donotRotate:!0,donotUseFormatters:!0}),i=await this.proxy.$register(g,t,!1,_,a.identifier.value);return new p(i,g,c,this.proxy,a)}async doCreateLogOutputChannel(g,_){const a=await this.createExtensionLogDirectory(_),w=this.extHostFileSystemInfo.extUri.joinPath(a,`${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.loggerService.createLogger(w,{name:g}),c=await this.proxy.$register(g,w,!0,void 0,_.identifier.value);return new l(c,g,t,this.proxy,_)}createExtensionLogDirectory(g){let _=this.extensionLogDirectoryPromise.get(g.identifier.value);if(!_){const a=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,g.identifier.value);this.extensionLogDirectoryPromise.set(g.identifier.value,_=(async()=>{try{await this.extHostFileSystem.value.createDirectory(a)}catch(w){if((0,k.toFileSystemProviderErrorCode)(w)!==k.FileSystemProviderErrorCode.FileExists)throw w}return a})())}return _}createExtHostOutputChannel(g,_){let a=!1;const w=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return g},append(t){w(),_.then(c=>c.append(t))},appendLine(t){w(),_.then(c=>c.appendLine(t))},clear(){w(),_.then(t=>t.clear())},replace(t){w(),_.then(c=>c.replace(t))},show(t,c){w(),_.then(i=>i.show(t,c))},hide(){w(),_.then(t=>t.hide())},dispose(){a=!0,_.then(t=>t.dispose())}}}createExtHostLogOutputChannel(g,_){let a=!1;const w=()=>{if(a)throw new Error("Channel has been closed")};return{...this.createExtHostOutputChannel(g,_),trace(t,...c){w(),_.then(i=>i.trace(t,...c))},debug(t,...c){w(),_.then(i=>i.debug(t,...c))},info(t,...c){w(),_.then(i=>i.info(t,...c))},warn(t,...c){w(),_.then(i=>i.warn(t,...c))},error(t,...c){w(),_.then(i=>i.error(t,...c))},dispose(){a=!0,_.then(t=>t.dispose())}}}};u=ze([$e(0,S.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,A.IExtHostConsumerFileSystem),$e(3,P.IExtHostFileSystemInfo),$e(4,M.ILoggerService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ce[227],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ce[228],Ie([1,0,38,13,19,21,22,2,3,158,46,173,227]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let k=class nn{constructor(l,u,d,g){this.localUserHome=l,this.remoteAgentService=u,this.environmentService=d,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=_?.userHome??l})()}hasValidBasename(l,u,d){return typeof u=="string"||typeof u>"u"?this.resolveOS.then(g=>this.doHasValidBasename(l,g,u)):this.doHasValidBasename(l,u,d)}doHasValidBasename(l,u,d){return l.scheme===C.Schemas.file||l.scheme===C.Schemas.vscodeRemote?(0,r.isValidBasename)(d??(0,y.basename)(l),u===1):!0}get defaultUriScheme(){return nn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(l,u){if(l.remoteAuthority)return C.Schemas.vscodeRemote;const d=(0,P.getVirtualWorkspaceScheme)(u.getWorkspace());if(d)return d;const g=u.getWorkspace().folders[0];if(g)return g.uri.scheme;const _=u.getWorkspace().configuration;return _?_.scheme:C.Schemas.file}userHome(l){return l?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(l=>l===1?S.win32:S.posix)}async fileURI(l){let u="";if(await this.resolveOS===1&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const g=l.indexOf("/",2);g===-1?(u=l.substring(2),l="/"):(u=l.substring(2,g),l=l.substring(g)||"/")}return A.URI.from({scheme:C.Schemas.file,authority:u,path:l,query:"",fragment:""})}};k=ze([$e(1,m.IRemoteAgentService),$e(2,b.IWorkbenchEnvironmentService),$e(3,O.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(Ce[101],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(y,A){this.line=y,this.character=A}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,A){return new r(0,0)}with(y){return new r(0,0)}}e.Position=r;class C{constructor(y,A,E,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(y,A),this.end=new r(E,P)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new C(0,0,0,0)}with(y){return new C(0,0,0,0)}}e.Range=C;var S;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[42],Ie([1,0,18,34,25,38,9,3,19,12,101,15]),function(ie,e,r,C,S,M,y,A,E,P,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",k=" characters skipped \u27EB",p=(m.length+k.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var l;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function d(oe){return!!oe.preview}e.resultIsMatch=d;function g(oe){return!!oe.resource}e.isFileMatch=g;function _(oe){return!!oe.message}e.isProgressMessage=_;var a;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(Ee){this.resource=Ee,this.results=[]}}e.FileMatch=w;class t{constructor(Ee,ce,me){this.ranges=ce;const ee=Array.isArray(ce)?ce:[ce];if(me&&me.matchLines===1&&c(ee)){Ee=(0,y.getNLines)(Ee,me.matchLines);let be="",_e=0,Fe=0;const Be=Math.floor(me.charsPerLine/5),Xe=[];for(const ke of ee){const ye=Math.max(ke.startColumn-Be,0),De=ke.startColumn+me.charsPerLine;if(ye>Fe+Be+p){const ae=m+(ye-Fe)+k;be+=ae+Ee.slice(ye,De),_e+=ye-(Fe+ae.length)}else be+=Ee.slice(Fe,De);Xe.push(new n(0,ke.startColumn-_e,ke.endColumn-_e)),Fe=De}this.preview={text:be,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const be=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:Ee,matches:(0,r.mapArrayOrNot)(ce,_e=>new i(_e.startLineNumber-be,_e.startColumn,_e.endLineNumber-be,_e.endColumn))}}}}e.TextSearchMatch=t;function c(oe){const Ee=oe[0].startLineNumber;for(const ce of oe)if(ce.startLineNumber!==Ee||ce.endLineNumber!==Ee)return!1;return!0}class i{constructor(Ee,ce,me,ee){this.startLineNumber=Ee,this.startColumn=ce,this.endLineNumber=me,this.endColumn=ee}}e.SearchRange=i;class n extends i{constructor(Ee,ce,me){super(Ee,ce,Ee,me)}}e.OneLineRange=n;var o;(function(oe){oe.List="list",oe.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var f;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function s(oe,Ee=!0){const ce=oe&&oe.files&&oe.files.exclude,me=Ee&&oe&&oe.search&&oe.search.exclude;if(!ce&&!me)return;if(!ce||!me)return ce||me;let ee=Object.create(null);return ee=S.mixin(ee,S.deepClone(ce)),ee=S.mixin(ee,S.deepClone(me),!0),ee}e.getExcludes=s;function h(oe,Ee){return oe.excludePattern&&C.match(oe.excludePattern,Ee)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&C.match(oe.includePattern,Ee)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ce=>{const me=ce.folder.fsPath;if(M.isEqualOrParent(Ee,me)){const ee=E.relative(me,Ee);return!ce.includePattern||!!C.match(ce.includePattern,ee)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var v;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(Ee,ce){super(Ee),this.code=ce}}e.SearchError=T;function N(oe){const Ee=oe.message;if((0,P.isCancellationError)(oe))return new T(Ee,v.canceled);try{const ce=JSON.parse(Ee);return new T(ce.message,ce.code)}catch{return new T(Ee,v.other)}}e.deserializeSearchError=N;function V(oe){const Ee={message:oe.message,code:oe.code};return new Error(JSON.stringify(Ee))}e.serializeSearchError=V;function U(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=U;function D(oe){return oe.type==="success"}e.isSerializedSearchSuccess=D;function x(oe){return!!oe.path}e.isSerializedFileMatch=x;function L(oe,Ee){const ce=oe.searchPath?oe.searchPath:oe.relativePath;return(0,y.fuzzyContains)(ce,Ee)}e.isFilePatternMatch=L;class R{constructor(Ee){this.path=Ee,this.results=[]}addMatch(Ee){this.results.push(Ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=R;function K(oe,Ee){const ce={...oe||{},...Ee||{}};return Object.keys(ce).filter(me=>{const ee=ce[me];return typeof ee=="boolean"&&ee})}e.resolvePatternsForProvider=K;class W{constructor(Ee,ce){this._parsedIncludeExpression=null,this._excludeExpression={...Ee.excludePattern||{},...ce.excludePattern||{}},this._parsedExcludeExpression=C.parse(this._excludeExpression);let me=Ee.includePattern;ce.includePattern&&(me?me={...me,...ce.includePattern}:me=ce.includePattern),me&&(this._parsedIncludeExpression=C.parse(me))}matchesExcludesSync(Ee,ce,me){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Ee,ce,me))}includedInQuerySync(Ee,ce,me){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Ee,ce,me)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Ee,ce,me))}includedInQuery(Ee,ce,me){const ee=this._parsedExcludeExpression(Ee,ce,me),be=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Ee,ce,me):!0;return(0,b.isThenable)(ee)?ee.then(_e=>_e?!1:be()):be()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=W;function $(oe){for(const Ee in oe)if(typeof oe[Ee]!="boolean")return!0;return!1}function G(oe){if(!oe)return;let Ee;return ce=>(Ee||(Ee=(oe()||Promise.resolve([])).then(me=>me?ge(me):{})),Ee.then(me=>!!me[ce]))}e.hasSiblingPromiseFn=G;function re(oe){if(!oe)return;let Ee;return ce=>{if(!Ee){const me=oe();Ee=me?ge(me):{}}return!!Ee[ce]}}e.hasSiblingFn=re;function ge(oe){const Ee={};for(const ce of oe)Ee[ce]=!0;return Ee}}),define(Ce[31],Ie([1,0,18,15,20,5,7,24,13,108,22,9,10,2,136,3,14,150,46,36,27,11,8,6,47,42,4]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_,a,w,t,c,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function f(D,x,L){return new O.ExtUri(R=>T(R,L)).isEqual(D,x)}function s(D,x,L){return f(D.uri,x.uri,L)?0:(0,b.compare)(D.uri.toString(),x.uri.toString())}function h(D,x,L){return D.index!==x.index?D.index<x.index?-1:1:f(D.uri,x.uri,L)?(0,b.compare)(D.name,x.name):(0,b.compare)(D.uri.toString(),x.uri.toString())}function v(D,x,L,R){const K=D.slice(0).sort(($,G)=>L($,G,R)),W=x.slice(0).sort(($,G)=>L($,G,R));return(0,r.delta)(K,W,($,G)=>L($,G,R))}function T(D,x){const L=x.getCapabilities(D.scheme);return!(L&&L&1024)}class N extends g.Workspace{static toExtHostWorkspace(x,L,R,K){if(!x)return{workspace:null,added:[],removed:[]};const{id:W,name:$,folders:G,configuration:re,transient:ge,isUntitled:oe}=x,Ee=[],ce=L;L?G.forEach((_e,Fe)=>{const Be=k.URI.revive(_e.uri),Xe=N._findFolder(R||L,Be,K);Xe?(Xe.name=_e.name,Xe.index=_e.index,Ee.push(Xe)):Ee.push({uri:Be,name:_e.name,index:Fe})}):Ee.push(...G.map(({uri:_e,name:Fe,index:Be})=>({uri:k.URI.revive(_e),name:Fe,index:Be}))),Ee.sort((_e,Fe)=>_e.index<Fe.index?-1:1);const me=new N(W,$,Ee,!!ge,re?k.URI.revive(re):null,!!oe,_e=>T(_e,K)),{added:ee,removed:be}=v(ce?ce.workspaceFolders:[],me.workspaceFolders,s,K);return{workspace:me,added:ee,removed:be}}static _findFolder(x,L,R){for(let K=0;K<x.folders.length;K++){const W=x.workspaceFolders[K];if(f(W.uri,L,R))return W}}constructor(x,L,R,K,W,$,G){super(x,R.map(re=>new g.WorkspaceFolder(re)),K,W,G),this._name=L,this._isUntitled=$,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(G),R.forEach(re=>{this._workspaceFolders.push(re),this._structure.set(re.uri,re)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,L){return L&&this._structure.get(x)&&(x=(0,O.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let V=class{constructor(x,L,R,K,W){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=K,this._extHostFileSystemInfo=R,this._uriTransformerService=W,this._requestIdProvider=new P.Counter,this._barrier=new C.Barrier,this._proxy=x.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(o.MainContext.MainThreadMessageService);const $=L.workspace;this._confirmedWorkspace=$?new N($.id,$.name,[],!!$.transient,$.configuration?k.URI.revive($.configuration):null,!!$.isUntitled,G=>T(G,R)):void 0}$initializeWorkspace(x,L){this._trusted=L,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?k.URI.from({scheme:E.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,L,R,...K){const W=[];if(Array.isArray(K)&&K.forEach(oe=>{k.URI.isUri(oe.uri)&&!W.some(Ee=>f(Ee.uri,oe.uri,this._extHostFileSystemInfo))&&W.push({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri)})}),this._unconfirmedWorkspace||[L,R].some(oe=>typeof oe!="number"||oe<0)||R===0&&W.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+R>$.length)return!1;const G=$.slice(0);G.splice(L,R,...W.map(oe=>({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<G.length;oe++){const Ee=G[oe];if(G.some((ce,me)=>me!==oe&&f(Ee.uri,ce.uri,this._extHostFileSystemInfo)))return!1}G.forEach((oe,Ee)=>oe.index=Ee);const{added:re,removed:ge}=v($,G,h,this._extHostFileSystemInfo);if(re.length===0&&ge.length===0)return!1;if(this._proxy){const oe=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(oe,L,R,W).then(void 0,Ee=>{this._unconfirmedWorkspace=void 0;const ce={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(d.Severity.Error,(0,p.localize)(0,null,oe,Ee.toString()),ce,[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(x,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,L)}async getWorkspaceFolder2(x,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,L)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,L){let R,K="";if(typeof x=="string"?(R=k.URI.file(x),K=x):typeof x<"u"&&(R=x,K=x.fsPath),!R)return K;const W=this.getWorkspaceFolder(R,!0);if(!W)return K;typeof L>"u"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let $=(0,O.relativePath)(W.uri,R);return L&&W.name&&($=`${W.name}/${$}`),$}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=N.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:L,added:R,removed:K}=N.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:K}))}findFiles(x,L,R,K,W=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let $;if(L===null?$=!1:L&&(typeof L=="string"?$=L:$=L.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:re}=U(t.GlobPattern.from(x));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(G),(0,m.withUndefinedAsNull)(re),(0,m.withUndefinedAsNull)($),(0,m.withUndefinedAsNull)(R),W).then(ge=>Array.isArray(ge)?ge.map(oe=>k.URI.revive(oe)):[])}async findTextInFiles(x,L,R,K,W=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),G=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:re,folder:ge}=U(t.GlobPattern.from(L.include)),oe=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,Ee={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:G,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:re,excludePattern:oe},ce=!1;if(this._activeSearchCallbacks[$]=me=>{if(ce)return;const ee=k.URI.revive(me.resource);me.results.forEach(be=>{(0,n.resultIsMatch)(be)?R({uri:ee,preview:{text:be.preview.text,matches:(0,r.mapArrayOrNot)(be.preview.matches,_e=>new c.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))},ranges:(0,r.mapArrayOrNot)(be.ranges,_e=>new c.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))}):R({uri:ee,text:be.text,lineNumber:be.lineNumber})})},W.isCancellationRequested)return{};try{const me=await this._proxy.$startTextSearch(x,(0,m.withUndefinedAsNull)(ge),Ee,$,W);return delete this._activeSearchCallbacks[$],me||{}}catch(me){throw delete this._activeSearchCallbacks[$],me}}$handleTextSearchResult(x,L){this._activeSearchCallbacks[L]?.(x)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,L){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,L);const R=this._uriTransformerService.transformOutgoingScheme(x),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,R),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(x,L){this._logService.info("Getting edit session identifier for workspaceFolder",x);const R=await this.resolveWorkspaceFolder(k.URI.revive(x));if(!R){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const K=this._editSessionIdentityProviders.get(R.uri.scheme);if(this._logService.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!K),!K)return;const W=await K.provideEditSessionIdentity(R,L);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}};V=ze([$e(0,w.IExtHostRpcService),$e(1,a.IExtHostInitDataService),$e(2,_.IExtHostFileSystemInfo),$e(3,u.ILogService),$e(4,i.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function U(D){let x,L;return D&&(typeof D=="string"?x=D:(x=D.pattern,L=k.URI.revive(D.baseUri))),{includePattern:x,folder:L}}}),define(Ce[32],Ie([1,0,25,5,31,4,6,153,85,10,15,3,11,14,2]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(c,i){if(i){const n=i.split(".");let o=c;for(let f=0;o&&f<n.length;f++)o=o[n[f]];return o}}function u(c){return c instanceof p.URI}function d(c){return c&&c.uri instanceof p.URI&&c.languageId&&typeof c.languageId=="string"}function g(c){return c&&!c.uri&&c.languageId&&typeof c.languageId=="string"}function _(c){return c&&c.uri instanceof p.URI&&(!c.name||typeof c.name=="string")&&(!c.index||typeof c.index=="number")}function a(c){if(u(c))return{resource:c};if(d(c))return{resource:c.uri,overrideIdentifier:c.languageId};if(g(c))return{overrideIdentifier:c.languageId};if(_(c))return{resource:c.uri};if(c===null)return{resource:null}}let w=class{constructor(i,n,o){this._proxy=i.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=o,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,n){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(i,n))}};w=ze([$e(0,m.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,k.ILogService)],w),e.ExtHostConfiguration=w;class t{constructor(i,n,o,f){this._onDidChangeConfiguration=new C.Emitter,this._proxy=i,this._logService=f,this._extHostWorkspace=n,this._configuration=A.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,n){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,o))}getConfiguration(i,n,o){const f=a(n)||{},s=this._toReadonlyValue(i?l(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,f,o?.identifier);function h(T){if(T==null)return null;if(typeof T=="boolean")return T?2:5;switch(T){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(T){return typeof l(s,T)<"u"},get:(T,N)=>{this._validateConfigurationAccess(i?`${i}.${T}`:T,f,o?.identifier);let V=l(s,T);if(typeof V>"u")V=N;else{let U;const D=(x,L)=>{let R;const K=()=>{U=U||(0,r.deepClone)(s),R=R||l(U,L)};return(0,P.isObject)(x)?new Proxy(x,{get:(W,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return K(),()=>R;if(U)return R=R||l(U,L),R[$];const G=W[$];return typeof $=="string"?D(G,`${L}.${$}`):G},set:(W,$,G)=>(K(),R&&(R[$]=G),!0),deleteProperty:(W,$)=>(K(),R&&delete R[$],!0),defineProperty:(W,$,G)=>(K(),R&&Object.defineProperty(R,$,G),!0)}):x};V=D(V,T)}return V},update:(T,N,V,U)=>{T=i?`${i}.${T}`:T;const D=h(V);return N!==void 0?this._proxy.$updateConfigurationOption(D,T,N,f,U):this._proxy.$removeConfigurationOption(D,T,f,U)},inspect:T=>{T=i?`${i}.${T}`:T;const N=(0,r.deepClone)(this._configuration.inspect(T,f,this._extHostWorkspace.workspace));if(N)return{key:T,defaultValue:N.policy?.value??N.default?.value,globalValue:N.user?.value??N.application?.value,workspaceValue:N.workspace?.value,workspaceFolderValue:N.workspaceFolder?.value,defaultLanguageValue:N.default?.override,globalLanguageValue:N.user?.override??N.application?.override,workspaceLanguageValue:N.workspace?.override,workspaceFolderLanguageValue:N.workspaceFolder?.override,languageIds:N.overrideIdentifiers}}};return typeof s=="object"&&(0,r.mixin)(v,s,!1),Object.freeze(v)}_toReadonlyValue(i){const n=o=>(0,P.isObject)(o)?new Proxy(o,{get:(f,s)=>n(f[s]),set:(f,s,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(f,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(f,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return n(i)}_validateConfigurationAccess(i,n,o){const f=E.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),s=o?`[${o.value}] `:"";if(f===4){typeof n?.resource>"u"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){n?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,n){const o=new A.ConfigurationChangeEvent(i,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,s)=>o.affectsConfiguration(f,a(s))})}_toMap(i){return i.reduce((n,o)=>(n.set(o[0],o[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[102],Ie([1,0,2,15,5,4,6,31,50,32,20,53,11,27,3,13,21,14,67,186,12]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_,a){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var c;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(c=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(L){function R($){if($){const G=$;return G&&!!G.process}else return!1}L.is=R;function K($){if($==null)return;const G={process:$.process,args:$.args};return $.options&&(G.options=i.from($.options)),G}L.from=K;function W($){if($!=null)return new y.ProcessExecution($.process,$.args,$.options)}L.to=W})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(L){function R($){if($){const G=$;return G&&(!!G.commandLine||!!G.command)}else return!1}L.is=R;function K($){if($==null)return;const G={};return $.commandLine!==void 0?G.commandLine=$.commandLine:(G.command=$.command,G.args=$.args),$.options&&(G.options=o.from($.options)),G}L.from=K;function W($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new y.ShellExecution($.commandLine,$.options):new y.ShellExecution($.command,$.args?$.args:[],$.options)}L.to=W})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(L){function R($){if($){const G=$;return G&&G.customExecution==="customExecution"}else return!1}L.is=R;function K($){return{customExecution:"customExecution"}}L.from=K;function W($,G){return G.get($)}L.to=W})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(L){function R(K,W){let $;return K.scope!==void 0&&typeof K.scope!="number"?$=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===y.TaskScope.Workspace&&W&&W.workspaceFile?$=W.workspaceFile:$=_.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:$}}L.from=R})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(L){function R(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}L.from=R})(v=e.TaskGroupDTO||(e.TaskGroupDTO={}));var T;(function(L){function R($,G){if($==null)return[];const re=[];for(const ge of $){const oe=K(ge,G);oe&&re.push(oe)}return re}L.fromMany=R;function K($,G){if($==null)return;let re;$.execution instanceof y.ProcessExecution?re=n.from($.execution):$.execution instanceof y.ShellExecution?re=f.from($.execution):$.execution&&$.execution instanceof y.CustomExecution&&(re=s.from($.execution));const ge=t.from($.definition);let oe;return $.scope?typeof $.scope=="number"?oe=$.scope:oe=$.scope.uri:oe=y.TaskScope.Workspace,!ge||!oe?void 0:{_id:$._id,definition:ge,name:$.name,source:{extensionId:G.identifier.value,label:$.source,scope:oe},execution:re,isBackground:$.isBackground,group:v.from($.group),presentationOptions:c.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}L.from=K;async function W($,G,re){if($==null)return;let ge;n.is($.execution)?ge=n.to($.execution):f.is($.execution)?ge=f.to($.execution):s.is($.execution)&&(ge=s.to($._id,re));const oe=t.to($.definition);let Ee;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?Ee=$.source.scope:Ee=await G.resolveWorkspaceFolder(r.URI.revive($.source.scope)):Ee=y.TaskScope.Workspace),!oe||!Ee)return;const ce=new y.Task(oe,Ee,$.name,$.source.label,ge,$.problemMatchers);return $.isBackground!==void 0&&(ce.isBackground=$.isBackground),$.group!==void 0&&(ce.group=y.TaskGroup.from($.group._id),ce.group&&$.group.isDefault&&(ce.group=new y.TaskGroup(ce.group.id,ce.group.label),$.group.isDefault===!0&&(ce.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ce.presentationOptions=c.to($.presentationOptions)),$._id&&(ce._id=$._id),$.detail&&(ce.detail=$.detail),ce}L.to=W})(T=e.TaskDTO||(e.TaskDTO={}));var N;(function(L){function R(W){return W}L.from=R;function K(W){if(!!W)return Object.assign(Object.create(null),W)}L.to=K})(N=e.TaskFilterDTO||(e.TaskFilterDTO={}));class V{constructor(R,K,W){this._id=K,this._task=W,w.set(this,void 0),Je(this,w,R,"f")}get task(){return this._task}terminate(){Oe(this,w,"f").terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}w=new WeakMap;var U;(function(L){function R(K){return{id:K._id,task:void 0}}L.from=R})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let D=class{constructor(R,K,W,$,G,re,ge,oe){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=R.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=$,this._configurationService=G,this._terminalService=re,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ge,this._deprecationService=oe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(R,K,W){if(!W)return new y.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:K,provider:W,extension:R}),this._proxy.$registerTaskProvider($,K),new y.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(R,K){this._proxy.$registerTaskSystem(R,K)}fetchTasks(R){return this._proxy.$fetchTasks(N.from(R)).then(async K=>{const W=[];for(const $ of K){const G=await T.to($,this._workspaceProvider,this._providedCustomExecutions2);G&&W.push(G)}return W})}get taskExecutions(){const R=[];return this._taskExecutions.forEach(K=>R.push(K)),R}terminateTask(R){if(!(R instanceof V))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(R._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(R,K,W){const $=this._providedCustomExecutions2.get(R.id);$&&(this._activeCustomExecutions2.set(R.id,$),this._terminalService.attachPtyToTerminal(K,await $.callback(W))),this._lastStartedTask=R.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(R)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(R){const K=await this.getTaskExecution(R);this._taskExecutionPromises.delete(R.id),this._taskExecutions.delete(R.id),this.customExecutionComplete(R),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessStarted.fire({execution:K,processId:R.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:R.exitCode})}$provideTasks(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));const $=[],G=(0,C.asPromise)(()=>W.provider.provideTasks(O.CancellationToken.None)).then(re=>this.provideTasksInternal(K,$,W,re));return new Promise(re=>{G.then(ge=>{Promise.all($).then(()=>{re(ge)})})})}async $resolveTask(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));if(K.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${W.type}].`);const $=await T.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const G=await W.provider.resolveTask($,O.CancellationToken.None);if(!G)return;this.checkDeprecation(G,W);const re=T.from(G,W.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(re.execution)&&await this.addCustomExecution(re,G,!0),await this.resolveTaskInternal(re)}nextHandle(){return this._handleCounter++}async addCustomExecution(R,K,W){const $=await this._proxy.$createTaskId(R);!W&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,K.execution)),this._providedCustomExecutions2.set($,K.execution)}async getTaskExecution(R,K){if(typeof R=="string"){const G=this._taskExecutionPromises.get(R);if(!G)throw new a.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return G}const W=this._taskExecutionPromises.get(R.id);if(W)return W;const $=new Promise((G,re)=>{function ge(oe,Ee,ce){ce?G(new V(oe,Ee.id,ce)):re("Unexpected: Task does not exist.")}K?ge(this,R,K):T.to(R.task,this._workspaceProvider,this._providedCustomExecutions2).then(oe=>ge(this,R,oe))});return this._taskExecutionPromises.set(R.id,$),$.then(G=>(this._taskExecutions.set(R.id,G),G),G=>Promise.reject(G))}checkDeprecation(R,K){R._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(R){this._activeCustomExecutions2.get(R.id)&&this._activeCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.has(R.id)&&this._lastStartedTask!==R.id&&(this._providedCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.delete(R.id));const W=this._notProvidedCustomExecutions.values();let $=W.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=W.next()}};D=ze([$e(0,m.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,d.ILogService),$e(7,g.IExtHostApiDeprecationService)],D),e.ExtHostTaskBase=D;let x=class extends D{constructor(R,K,W,$,G,re,ge,oe){super(R,K,W,$,G,re,ge,oe),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(0)})}async executeTask(R,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const W=T.from(K,R);if(W===void 0)throw new Error("Task is not valid");if(s.is(W.execution))await this.addCustomExecution(W,K,!1);else throw new a.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),K);return this._proxy.$executeTask(W).catch(G=>{throw new Error(G)}),$}provideTasksInternal(R,K,W,$){const G=[];if($)for(const re of $){this.checkDeprecation(re,W),(!re.definition||!R[re.definition.type])&&this._logService.warn(`The task [${re.source}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`);const ge=T.from(re,W.extension);ge&&s.is(ge.execution)?(G.push(ge),K.push(this.addCustomExecution(ge,re,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:W.extension}}async resolveTaskInternal(R){if(s.is(R.execution))return R;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(R,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,K,W){}};x=ze([$e(0,m.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,d.ILogService),$e(7,g.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Ce[229],Ie([1,0,19,20,44,34,22,204,42]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(m,k,p){this.config=m,this.provider=k,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&M.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const k=this.config.folderQueries||[];return new Promise((p,l)=>{const u=d=>{this.resultCount++,m(d)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const g=d.toString(),_=r.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,_)||this.matchFile(u,{base:d,basename:_})}),Promise.all(k.map(d=>this.searchInFolder(d,u))).then(d=>{p({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{l(new Error((0,S.toErrorMessage)(d)))})})}async searchInFolder(m,k){const p=new C.CancellationTokenSource,l=this.getSearchOptionsForFolder(m),u=this.initDirectoryTree(),d=new E.QueryGlobTester(this.config,m),g=!d.hasSiblingExcludeClauses();let _;try{this.activeCancellationTokens.add(p),_=A.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,p.token),w=_.elapsed(),t=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(c=>{const i=r.posix.relative(m.folder.path,c.path);if(g){const n=r.basename(c.path);this.matchFile(k,{base:m.folder,relativePath:i,basename:n});return}this.addDirectoryEntries(u,m.folder,i,k)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,d,k),{providerTime:w,postProcessTime:t.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(m){const k=(0,E.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),p=(0,E.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:p,includes:k,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},k,p,l){if(p===this.filePattern){const d=r.basename(this.filePattern);this.matchFile(l,{base:k,relativePath:this.filePattern,basename:d})}function u(d){const g=r.basename(d),_=r.dirname(d);let a=m[_];a||(a=m[_]=[],u(_)),a.push({base:k,relativePath:d,basename:g})}u(p)}matchDirectoryTree({rootEntries:m,pathToEntries:k},p,l){const u=this,d=this.filePattern;function g(_){const a=(0,E.hasSiblingFn)(()=>_.map(w=>w.basename));for(let w=0,t=_.length;w<t;w++){const c=_[w],{relativePath:i,basename:n}=c;if(p.matchesExcludesSync(i,n,d!==n?a:void 0))continue;const o=k[i];if(o)g(o);else{if(i===d)continue;u.matchFile(l,c)}if(u.isLimitHit)break}}g(m)}matchFile(m,k){(!this.includePattern||k.relativePath&&this.includePattern(k.relativePath,k.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(k))}}class O{constructor(){this.sessions=new Map}fileSearch(m,k,p,l){const u=this.getSessionTokenSource(m.cacheKey),d=new P(m,k,u&&u.token);let g=0;const _=a=>{g+=a.length,p(a.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(d,O.BATCH_SIZE,_,l).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:a.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new C.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:y.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,k,p,l){l.onCancellationRequested(()=>{m.cancel()});const u=g=>{g&&(d.push(g),k>0&&d.length>=k&&(p(d),d=[]))};let d=[];return m.search(u).then(g=>(d.length&&p(d),g),g=>(d.length&&p(d),Promise.reject(g)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(Ce[230],Ie([1,0,18,73,34,78,24,13,19,22,9,10,2,246,144,57,14,46,91,228,42]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(v,T,N,V,U){this.configurationService=v,this.workspaceContextService=T,this.editorGroupsService=N,this.logService=V,this.pathService=U}text(v,T,N={}){v=this.getContentPattern(v,N);const V=this.configurationService.getValue(),U=T&&T.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(T?.map(d.toWorkspaceFolder),N),type:2,contentPattern:v,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:V.search.usePCRE2||U||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}getContentPattern(v,T){const N=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const V={...v,wordSeparators:N.editor.wordSeparators};return this.isCaseSensitive(v,T)&&(V.isCaseSensitive=!0),this.isMultiline(v)&&(V.isMultiline=!0),V}file(v,T={}){return{...this.commonQuery(v,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(v,T){return v?(v=Array.isArray(v)?v.map(o):o(v),T?this.parseSearchPaths(v):{pattern:c(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],T={}){const N=this.handleIncludeExclude(T.includePattern,T.expandPatterns),V=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),U=v.length>1,D=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(R=>this.getFolderQueryForSearchPath(R,T,V)):v.map(R=>this.getFolderQueryForRoot(R,T,V,U))).filter(R=>!!R),x={_reason:T._reason,folderQueries:D,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:V.pattern,includePattern:N.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const R=r.coalesce(r.flatten(this.editorGroupsService.groups.map($=>$.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(R));const K=R.filter($=>(0,a.pathIncludedInQuery)(x,$.fsPath)),W=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...x,...W}}const L=T.extraFileResources&&T.extraFileResources.filter(R=>(0,a.pathIncludedInQuery)(x,R.fsPath));return x.extraFileResources=L&&L.length?L:void 0,x}commonQueryFromFileList(v){const T=[],N=new y.ResourceMap,V={};let U=!1;return v.forEach(D=>{if(D.scheme===A.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(D)){const L=this.workspaceContextService.getWorkspaceFolder(D)?.uri??D.with({path:E.dirname(D.fsPath)});let R=N.get(L);R||(U=!0,R={folder:L,includePattern:{}},T.push(R),N.set(L,R));const K=E.relative(L.fsPath,D.fsPath);(0,b.assertIsDefined)(R.includePattern)[K.replace(/\\/g,"/")]=!0}else D.fsPath&&(U=!0,V[D.fsPath]=!0)}),{folderQueries:T,includePattern:V,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(v,T){if(T.isSmartCase){if(v.isRegExp){if(O.containsUppercaseCharacter(v.pattern,!0))return!0}else if(O.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,k.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const T=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),V=(Array.isArray(v)?v:i(v)).map(W=>{const $=this.pathService.resolvedUserHome;return $?(0,M.untildify)(W,$.scheme===A.Schemas.file?$.fsPath:$.path):W}),U=C.groupBy(V,W=>T(W)?"searchPaths":"exprSegments"),D=(U.exprSegments||[]).map(W=>O.rtrim(W,"/")).map(W=>O.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),n(W))),x={},L=this.expandSearchPathPatterns(U.searchPaths||[]);L&&L.length&&(x.searchPaths=L);const R=r.flatten(D),K=c(...R);return K&&(x.pattern=K),x}getExcludesForFolder(v,T){return T.disregardExcludeSettings?void 0:(0,a.getExcludes)(v,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const T=r.flatten(v.map(V=>{let{pathPortion:U,globPortion:D}=t(V);D&&(D=f(D));const x=this.expandOneSearchPath(U);return r.flatten(x.map(L=>this.resolveOneSearchPathPattern(L,D)))})),N=new Map;return T.forEach(V=>{const U=V.searchPath.toString(),D=N.get(U);D?V.pattern&&(D.pattern=D.pattern||{},D.pattern[V.pattern]=!0):N.set(U,{searchPath:V.searchPath,pattern:V.pattern?c(V.pattern):void 0})}),Array.from(N.values())}expandOneSearchPath(v){if(E.isAbsolute(v)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==A.Schemas.file?[{searchPath:T[0].uri.with({path:v})}]:[{searchPath:m.URI.file(E.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=o(v),v.startsWith("../")||v===".."){const V=E.posix.resolve(T.path,v);return[{searchPath:T.with({path:V})}]}const N=f(v);return[{searchPath:T,pattern:N}]}else{if(v==="./"||v===".\\")return[];{const T=v.replace(/^\.[\/\\]/,""),V=this.workspaceContextService.getWorkspace().folders.map(U=>{const D=T.match(new RegExp(`^${O.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return D?{match:D,folder:U}:null}).filter(b.isDefined);if(V.length)return V.map(U=>{const D=U.match[1];return{searchPath:U.folder.uri,pattern:D&&f(D)}});{const U=v.match(/\.[\/\\](.+)[\/\\]?/),D=U?U[1]:v,x=p.localize(0,null,D);throw new Error(x)}}}}resolveOneSearchPathPattern(v,T){const N=v.pattern&&T?`${v.pattern}/${T}`:v.pattern||T,V=[{searchPath:v.searchPath,pattern:N}];return N&&!N.endsWith("**")&&V.push({searchPath:v.searchPath,pattern:N+"/**"}),V}getFolderQueryForSearchPath(v,T,N){const V=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(v.searchPath),T,N,!1);return V?{...V,includePattern:v.pattern}:null}getFolderQueryForRoot(v,T,N,V){let U;const D=m.URI.isUri(v)?v:v.uri;if(N.searchPaths){const W=N.searchPaths.filter($=>(0,P.isEqual)($.searchPath,D))[0];if(W&&!W.pattern)return null;W&&(U=W.pattern)}const x=this.configurationService.getValue({resource:D}),R={...this.getExcludesForFolder(x,T)||{},...U||{}},K=m.URI.isUri(v)?(0,P.basename)(v):v.name;return{folder:D,folderName:V?K:void 0,excludePattern:Object.keys(R).length>0?R:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!x.search.followSymlinks}}};w=ze([$e(0,l.IConfigurationService),$e(1,d.IWorkspaceContextService),$e(2,g.IEditorGroupsService),$e(3,u.ILogService),$e(4,_.IPathService)],w),e.QueryBuilder=w;function t(h){const v=h.match(/[\*\{\}\(\)\[\]\?]/);if(v){const T=v.index,N=h.substr(0,T).match(/[/|\\][^/\\]*$/);if(N){let V=h.substr(0,N.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:h.substr((N.index||0)+1)}}}return{pathPortion:h}}function c(...h){return h.length?h.reduce((v,T)=>(v[T]=!0,v),Object.create(null)):void 0}function i(h){return S.splitGlobAware(h,",").map(v=>v.trim()).filter(v=>!!v.length)}function n(h){return[`**/${h}/**`,`**/${h}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function o(h){return h.replace(/\\/g,"/")}function f(h){return o(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(h,v){h=r.distinct(h,V=>V.toString());const T=[],N=v.getWorkspace();return h&&h.forEach(V=>{let U;if(v.getWorkbenchState()===2)U=(0,P.relativePath)(N.folders[0].uri,V),U&&U!=="."&&(U="./"+U);else{const D=v.getWorkspaceFolder(V);if(D){const x=D.name;if(N.folders.filter(R=>R.name===x).length===1){const R=(0,P.relativePath)(D.uri,V);R===""?U=`./${D.name}`:U=`./${D.name}/${R}`}else U=V.fsPath}}U&&T.push(U)}),T}e.resolveResourcesForSearchIncludes=s}),define(Ce[231],Ie([1,0,22,2,20,12,3,230,42,46]),function(ie,e,r,C,S,M,y,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function b(l,u){const d=u.activationEvents;if(!d)return Promise.resolve(void 0);const g=[],_=[];for(const n of d)if(/^workspaceContains:/.test(n)){const o=n.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||l.forceUsingSearch?_.push(o):g.push(o)}if(g.length===0&&_.length===0)return Promise.resolve(void 0);let a;const w=new Promise((n,o)=>{a=n}),t=n=>a({activationEvent:n}),c=Promise.all(g.map(n=>m(l,n,t))).then(()=>{}),i=k(l,u.identifier,_,t);return Promise.all([c,i]).then(()=>{a(void 0)}),w}e.checkActivateWorkspaceContainsExtension=b;async function m(l,u,d){for(const g of l.folders)if(await l.exists(r.joinPath(C.URI.revive(g),u))){d(`workspaceContains:${u}`);return}}async function k(l,u,d,g){if(d.length===0)return Promise.resolve(void 0);const _=new S.CancellationTokenSource,a=l.checkExists(l.folders,d,_.token),w=setTimeout(async()=>{_.cancel(),l.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},O);let t=!1;try{t=await a}catch(c){M.isCancellationError(c)||M.onUnexpectedError(c)}_.dispose(),clearTimeout(w),t&&g(`workspaceContains:${d.join(",")}`)}function p(l,u,d,g){const _=l.get(y.IInstantiationService),a=l.get(E.ISearchService),t=_.createInstance(A.QueryBuilder).file(u.map(c=>(0,P.toWorkspaceFolder)(C.URI.revive(c))),{_reason:"checkExists",includePattern:d,exists:!0});return a.fileSearch(t,g).then(c=>!!c.limitHit,c=>M.isCancellationError(c)?!1:Promise.reject(c))}e.checkGlobFileExists=p});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[33],Ie([1,0,131,19,72,22,15,7,24,2,14,4,32,175,70,31,28,174,12,26,23,159,6,86,3,27,71,11,58,62,53,5,231,69,161,13,68]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_,a,w,t,c,i,n,o,f,s,h,v,T,N,V,U,D,x){"use strict";var L,R,K;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let W=class Fi extends A.Disposable{constructor(ce,me,ee,be,_e,Fe,Be,Xe,ke,ye,De){super(),this._onDidChangeRemoteConnectionData=this._register(new T.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=me,this._extHostContext=ee,this._initData=Be,this._extHostWorkspace=be,this._extHostConfiguration=_e,this._logService=Fe,this._extHostTunnelService=ke,this._extHostTerminalService=ye,this._extHostLocalizationService=De,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new d.ExtensionDescriptionRegistry(this._initData.allExtensions);const ae=(0,u.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new d.ExtensionDescriptionRegistry(re(this._globalRegistry,ae)),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new V.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=ce.createChild(new s.ServiceCollection([p.IExtHostStorage,this._storage],[V.IExtHostSecretState,this._secretState]));let ue=[],Z=[];this._initData.remote.isRemote&&(ue=this._initData.allExtensions.filter(I=>!I.main&&!I.browser).map(I=>I.identifier),Z=this._initData.allExtensions.filter(I=>!ae.has(_.ExtensionIdentifier.toKey(I.identifier.value))).filter(I=>(I.main||I.browser)&&I.api==="none").map(I=>I.identifier));const J=(0,u.extensionIdentifiersArrayToSet)(Z);this._activator=this._register(new k.ExtensionsActivator(this._myRegistry,ue,Z,{onExtensionActivationError:(I,B,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(I,g.transformErrorForSerialization(B),H)},actualActivateExtension:async(I,B)=>{if(J.has(_.ExtensionIdentifier.toKey(I)))return await this._mainThreadExtensionsProxy.$activateExtension(I,B),new k.HostExtension;const H=this._myRegistry.getExtensionDescription(I);return this._activateExtension(H,B)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ce){g.onUnexpectedError(ce)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ce=[];try{ce=this._myRegistry.getAllExtensionDescriptions().map(_e=>_e.identifier).filter(_e=>this.isActivated(_e)).map(_e=>this._deactivate(_e))}catch{}await Promise.all(ce)}terminate(ce,me=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ce}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(be=>{this._logService.error(be)}),this._extHostContext.dispose();const ee=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),ee]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${me}`):this._logService.info(`Extension host exiting with code ${me}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(me)})}isActivated(ce){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ce):!1}async getExtension(ce){const me=await this._mainThreadExtensionsProxy.$getExtension(ce);let ee;if(me?.browserNlsBundleUris){ee={};for(const be of Object.keys(me.browserNlsBundleUris))ee[be]=P.URI.revive(me.browserNlsBundleUris[be])}return me&&{...me,identifier:new _.ExtensionIdentifier(me.identifier.value),extensionLocation:P.URI.revive(me.extensionLocation),browserNlsBundleUris:ee}}_activateByEvent(ce,me){return this._activator.activateByEvent(ce,me)}_activateById(ce,me){return this._activator.activateById(ce,me)}activateByIdWithErrors(ce,me){return this._activateById(ce,me).then(()=>{const ee=this._activator.getActivatedExtension(ce);if(ee.activationFailed)return Promise.reject(ee.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ce=>this._myRegistry)}getExtensionExports(ce){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ce).exports:null}async _realPathExtensionUri(ce){if(ce.scheme!==D.Schemas.file)return ce;const me=await this._hostUtils.realpath(ce.fsPath);return P.URI.file(me)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ce=>new oe(ce))),this._extensionPathIndex}async _createExtensionPathIndex(ce){const me=E.TernarySearchTree.forUris(ee=>M.extUriBiasedIgnorePathCase.ignorePathCasing(ee));return await Promise.all(ce.map(async ee=>{if(this._getEntryPoint(ee)){const be=await this._realPathExtensionUri(ee.extensionLocation);me.set(be,ee)}})),me}_deactivate(ce){let me=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ce))return me;const ee=this._activator.getActivatedExtension(ce);if(!ee)return me;try{typeof ee.module.deactivate=="function"&&(me=Promise.resolve(ee.module.deactivate()).then(void 0,be=>(this._logService.error(be),Promise.resolve(void 0))))}catch(be){this._logService.error(`An error occurred when deactivating the extension '${ce.value}':`),this._logService.error(be)}try{(0,A.dispose)(ee.subscriptions)}catch(be){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ce.value}':`),this._logService.error(be)}return me}async _activateExtension(ce,me){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ce.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ce.identifier),this._doActivateExtension(ce,me).then(ee=>{const be=ee.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ce.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,me),this._logExtensionActivationTimes(ce,me,"success",be),ee},ee=>{throw this._logExtensionActivationTimes(ce,me,"failure"),ee})}_logExtensionActivationTimes(ce,me,ee,be){const _e=$(ce,me);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{..._e,...be||{},outcome:ee})}_doActivateExtension(ce,me){const ee=$(ce,me);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ee);const be=this._getEntryPoint(ce);if(!be)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ce.identifier.value}, startup: ${me.startup}, activationEvent: '${me.activationEvent}'${ce.identifier.value!==me.extensionId.value?`, root cause: ${me.extensionId.value}`:""}`),this._logService.flush();const _e=new k.ExtensionActivationTimesBuilder(me.startup);return Promise.all([this._loadCommonJSModule(ce,(0,M.joinPath)(ce.extensionLocation,be),_e),this._loadExtensionContext(ce)]).then(Fe=>(S.mark(`code/extHost/willActivateExtension/${ce.identifier.value}`),Fi._callActivate(this._logService,ce.identifier,Fe[0],Fe[1],_e))).then(Fe=>(S.mark(`code/extHost/didActivateExtension/${ce.identifier.value}`),Fe))}_loadExtensionContext(ce){const me=new w.ExtensionGlobalMemento(ce,this._storage),ee=new w.ExtensionMemento(ce.identifier.value,!1,this._storage),be=new U.ExtensionSecrets(ce,this._secretState),_e=ce.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Fe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ce.identifier.value}`),Promise.all([me.whenReady,ee.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Xe,ke;const ye=(0,u.isProposedApiEnabled)(ce,"ipc")?this._initData.messagePorts?.get(_.ExtensionIdentifier.toKey(ce.identifier)):void 0;return Object.freeze({globalState:me,workspaceState:ee,secrets:be,subscriptions:[],get extensionUri(){return ce.extensionLocation},get extensionPath(){return ce.extensionLocation.fsPath},asAbsolutePath(De){return C.join(ce.extensionLocation.fsPath,De)},get storagePath(){return Be._storagePath.workspaceValue(ce)?.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(ce).fsPath},get logPath(){return C.join(Be._initData.logsLocation.fsPath,ce.identifier.value)},get logUri(){return P.URI.joinPath(Be._initData.logsLocation,ce.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(ce)},get globalStorageUri(){return Be._storagePath.globalValue(ce)},get extensionMode(){return _e},get extension(){return Xe===void 0&&(Xe=new G(Be,ce.identifier,ce,Fe,!1)),Xe},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(ce,"extensionRuntime"),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(ce)},get messagePassingProtocol(){if(!ke){if(!ye)return;const De=T.Event.buffer(T.Event.fromDOMEventEmitter(ye,"message",ae=>ae.data));ye.start(),ke={onDidReceiveMessage:De,postMessage:ye.postMessage.bind(ye)}}return ke}})})}static _callActivate(ce,me,ee,be,_e){return ee=ee||{activate:void 0,deactivate:void 0},this._callActivateOptional(ce,me,ee,be,_e).then(Fe=>new k.ActivatedExtension(!1,null,_e.build(),ee,Fe,be.subscriptions))}static _callActivateOptional(ce,me,ee,be,_e){if(typeof ee.activate=="function")try{_e.activateCallStart(),ce.trace(`ExtensionService#_callActivateOptional ${me.value}`);const Fe=typeof global=="object"?global:self,Be=ee.activate.apply(Fe,[be]);return _e.activateCallStop(),_e.activateResolveStart(),Promise.resolve(Be).then(Xe=>(_e.activateResolveStop(),Xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(ee)}_activateOneStartupFinished(ce,me){this._activateById(ce.identifier,{startup:!1,extensionId:ce.identifier,activationEvent:me}).then(void 0,ee=>{this._logService.error(ee)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const ce of this._myRegistry.getAllExtensionDescriptions())if(ce.activationEvents)for(const me of ce.activationEvents)me==="onStartupFinished"&&this._activateOneStartupFinished(ce,me)}_handleEagerExtensions(){const ce=this._activateByEvent("*",!0).then(void 0,_e=>{this._logService.error(_e)});this._register(this._extHostWorkspace.onDidChangeWorkspace(_e=>this._handleWorkspaceContainsEagerExtensions(_e.added)));const me=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ee=this._handleWorkspaceContainsEagerExtensions(me),be=Promise.all([ce,ee]).then(()=>{});return Promise.race([be,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),be}_handleWorkspaceContainsEagerExtensions(ce){return ce.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(me=>this._handleWorkspaceContainsEagerExtension(ce,me))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ce,me){if(this.isActivated(me.identifier))return;const ee=!this._initData.remote.isRemote&&!!this._initData.remote.authority,be={logService:this._logService,folders:ce.map(Fe=>Fe.uri),forceUsingSearch:ee,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Be,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Be,Xe)},_e=await(0,N.checkActivateWorkspaceContainsExtension)(be,me);if(!!_e)return this._activateById(me.identifier,{startup:!0,extensionId:me.identifier,activationEvent:_e.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ce){throw console.error(ce),ce}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ce,extensionTestsLocationURI:me}=this._initData.environment;if(!ce||!me)throw new Error(r.localize(0,null));const ee=await this._loadCommonJSModule(null,me,new k.ExtensionActivationTimesBuilder(!1));if(!ee||typeof ee.run!="function")throw new Error(r.localize(1,null,me.toString()));return new Promise((be,_e)=>{const Fe=(ke,ye)=>{ke?_e(ke):be(typeof ye=="number"&&ye>0?1:0)},Be=(0,M.originalFSPath)(me),Xe=ee.run(Be,Fe);Xe&&Xe.then&&Xe.then(()=>{be(0)}).catch(ke=>{_e(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ce,me){return this._resolvers[ce]=me,(0,A.toDisposable)(()=>{delete this._resolvers[ce]})}async _activateAndGetResolver(ce){const me=ce.indexOf("+");if(me===-1)throw new Error("Not an authority that can be resolved!");const ee=ce.substr(0,me);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ee}`,!1),{authorityPrefix:ee,resolver:this._resolvers[ee]}}async $resolveAuthority(ce,me){this._logService.info(`$resolveAuthority invoked for authority (${ge(ce)})`);const{authorityPrefix:ee,resolver:be}=await this._activateAndGetResolver(ce);if(!be)return{type:"error",error:{code:c.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ee}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(be)),S.mark(`code/extHost/willResolveAuthority/${ee}`);const _e=await be.resolve(ce,{resolveAttempt:me});S.mark(`code/extHost/didResolveAuthorityOK/${ee}`);const Fe={authority:ce,host:_e.host,port:_e.port,connectionToken:_e.connectionToken},Be={extensionHostEnv:_e.extensionHostEnv,isTrusted:_e.isTrusted,authenticationSession:_e.authenticationSessionForInitializingExtensions?{id:_e.authenticationSessionForInitializingExtensions.id,providerId:_e.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Be,tunnelInformation:{environmentTunnels:_e.environmentTunnels,features:_e.tunnelFeatures}}}}catch(_e){if(S.mark(`code/extHost/didResolveAuthorityError/${ee}`),_e instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:_e._code,message:_e._message,detail:_e._detail}};throw _e}}async $getCanonicalURI(ce,me){this._logService.info(`$getCanonicalURI invoked for authority (${ge(ce)})`);const{resolver:ee}=await this._activateAndGetResolver(ce);if(!ee)return null;const be=P.URI.revive(me);if(typeof ee.getCanonicalURI>"u")return be;const _e=await(0,y.asPromise)(()=>ee.getCanonicalURI(be));return _e||be}static _applyExtensionsDelta(ce,me,ee){const be=new d.ExtensionDescriptionRegistry(ce.getAllExtensionDescriptions());be.deltaExtensions(ee.toAdd,ee.toRemove);const _e=(0,u.extensionIdentifiersArrayToSet)(me.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of ee.myToRemove)_e.delete(_.ExtensionIdentifier.toKey(Be));for(const Be of ee.myToAdd)_e.add(_.ExtensionIdentifier.toKey(Be));const Fe=re(be,_e);return{globalRegistry:be,myExtensions:Fe}}$startExtensionHost(ce){ce.toAdd.forEach(be=>be.extensionLocation=P.URI.revive(be.extensionLocation));const{globalRegistry:me,myExtensions:ee}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ce);return this._globalRegistry.set(me.getAllExtensionDescriptions()),this._myRegistry.set(ee),this._startExtensionHost()}$activateByEvent(ce,me){return me===1?this._activateByEvent(ce,!1):this._readyToRunExtensions.wait().then(ee=>this._activateByEvent(ce,!1))}async $activate(ce,me){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ce)?(await this._activateById(ce,me),!0):!1}async $deltaExtensions(ce){ce.toAdd.forEach(Fe=>Fe.extensionLocation=P.URI.revive(Fe.extensionLocation));const{globalRegistry:me,myExtensions:ee}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ce),be=await this._createExtensionPathIndex(ee);return(await this.getExtensionPathIndex()).setSearchTree(be),this._globalRegistry.set(me.getAllExtensionDescriptions()),this._myRegistry.set(ee),Promise.resolve(void 0)}async $test_latency(ce){return ce}async $test_up(ce){return ce.byteLength}async $test_down(ce){const me=a.VSBuffer.alloc(ce),ee=Math.random()%256;for(let be=0;be<ce;be++)me.writeUInt8(ee,be);return me}async $updateRemoteConnectionData(ce){this._remoteConnectionData=ce,this._onDidChangeRemoteConnectionData.fire()}};W=ze([$e(0,i.IInstantiationService),$e(1,e.IHostUtils),$e(2,f.IExtHostRpcService),$e(3,l.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,O.ILogService),$e(6,n.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,h.IExtHostTunnelService),$e(9,v.IExtHostTerminalService),$e(10,x.IExtHostLocalizationService)],W),e.AbstractExtHostExtensionService=W;function $(Ee,ce){return{id:Ee.identifier.value,name:Ee.name,extensionVersion:Ee.version,publisherDisplayName:Ee.publisher,activationEvents:Ee.activationEvents?Ee.activationEvents.join(","):null,isBuiltin:Ee.isBuiltin,reason:ce.activationEvent,reasonId:ce.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class G{constructor(ce,me,ee,be,_e){L.set(this,void 0),R.set(this,void 0),K.set(this,void 0),Je(this,L,ce,"f"),Je(this,R,me,"f"),Je(this,K,ee.identifier,"f"),this.id=ee.identifier.value,this.extensionUri=ee.extensionLocation,this.extensionPath=C.normalize((0,M.originalFSPath)(ee.extensionLocation)),this.packageJSON=ee,this.extensionKind=be,this.isFromDifferentExtensionHost=_e}get isActive(){return Oe(this,L,"f").isActivated(Oe(this,K,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,L,"f").getExtensionExports(Oe(this,K,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,L,"f").activateByIdWithErrors(Oe(this,K,"f"),{startup:!1,extensionId:Oe(this,R,"f"),activationEvent:"api"}),this.exports}}e.Extension=G,L=new WeakMap,R=new WeakMap,K=new WeakMap;function re(Ee,ce){return Ee.getAllExtensionDescriptions().filter(me=>ce.has(_.ExtensionIdentifier.toKey(me.identifier)))}function ge(Ee){const ce=Ee.indexOf("+");return ce===-1?Ee:Ee.substring(0,ce)}class oe{constructor(ce){this._searchTree=ce}setSearchTree(ce){this._searchTree=ce}findSubstr(ce){return this._searchTree.findSubstr(ce)}forEach(ce){return this._searchTree.forEach(ce)}}e.ExtensionPaths=oe}),define(Ce[232],Ie([1,0,72,2,4,32,28,26,11,27,3,33,59,14,9]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(w,t,c,i,n,o,f){this._apiFactory=w,this._extensionRegistry=t,this._instaService=c,this._extHostConfiguration=i,this._extHostExtensionService=n,this._initData=o,this._logService=f,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const w=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,t,this._extensionRegistry,w,this._logService)),this.register(this._instaService.createInstance(g,t)),this.register(this._instaService.createInstance(u)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(_,t,this._initData.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const t of w.nodeModuleName)this._factories.set(t,w);else this._factories.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this._alternatives.push(t=>w.alternativeModuleName(t))}};l=ze([$e(2,O.IInstantiationService),$e(3,M.IExtHostConfiguration),$e(4,b.IExtHostExtensionService),$e(5,P.IExtHostInitDataService),$e(6,k.ILogService)],l),e.RequireInterceptor=l;let u=class Ji{constructor(w){if(w.environment.appRoot&&Ji.aliased.size){const t=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(w.environment.appRoot.fsPath)),c="[a-z0-9_.-]",i=`@${c}+\\/${c}+|${c}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${n}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(w){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(w));if(!t)return;const[,c,i,n]=t,o=Ji.aliased.get(i);if(o!==void 0)return console.warn(`${i} as been renamed to ${o}, please update your imports`),c+o+n}forceForwardSlashes(w){return w.replace(/\\/g,"/")}};u.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),u=ze([$e(0,P.IExtHostInitDataService)],u);class d{constructor(w,t,c,i,n){this._apiFactory=w,this._extensionPaths=t,this._extensionRegistry=c,this._configProvider=i,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(w,t){const c=this._extensionPaths.findSubstr(t);if(c){let i=this._extApiImpl.get(A.ExtensionIdentifier.toKey(c.identifier));return i||(i=this._apiFactory(c,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(c.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((n,o)=>i+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(w,t,c){this._extensionPaths=w,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(S.MainContext.MainThreadTelemetry);const{environment:i}=c,n=t.getProxy(S.MainContext.MainThreadKeytar);if(i.appRoot){let o=i.appRoot.fsPath;m.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,f)=>n.$getPassword(o,f),setPassword:(o,f,s)=>n.$setPassword(o,f,s),deletePassword:(o,f)=>n.$deletePassword(o,f),findPassword:o=>n.$findPassword(o),findCredentials(o){return n.$findCredentials(o)}}}load(w,t){const c=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:c?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(w){const t=w.length;if(t<=7||!this.alternativeNames)return;const c=t-7;if((w.charAt(c)==="/"||w.charAt(c)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.alternativeNames.has(w)))return"keytar"}};g=ze([$e(1,E.IExtHostRpcService),$e(2,P.IExtHostInitDataService)],g);let _=class{constructor(w,t,c){this._extensionPaths=w,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=c.getProxy(S.MainContext.MainThreadTelemetry);const i=c.getProxy(S.MainContext.MainThreadWindow);this._impl=(n,o)=>{const f=C.URI.parse(n);return o?this.callOriginal(n,o):f.scheme==="http"||f.scheme==="https"?i.$openUri(f,n,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this._appUriScheme?i.$openUri(f,n,{}):this.callOriginal(n,o)}}load(w,t,c){const i=this._extensionPaths.findSubstr(t);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=c(w),this._impl}callOriginal(w,t){return this.sendNoForwardTelemetry(),this._original(w,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};_=ze([$e(2,E.IExtHostRpcService)],_)}),define(Ce[103],Ie([1,0,198,7,19,59,3,50,51,33,6,31,171,32]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class p extends m.AbstractVariableResolverService{constructor(d,g,_,a,w,t,c){function i(){if(_){const n=_.activeEditor();if(n)return n.document.uri;const o=a.tabGroups.all.find(f=>f.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof O.TextDiffTabInput||o.input instanceof O.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof O.TextTabInput||o.input instanceof O.NotebookEditorTabInput||o.input instanceof O.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:n=>{const o=t.folders.filter(f=>f.name===n);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,o)=>w.getConfiguration(void 0,n).get(o),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=i();if(n)return S.normalize(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const n=i();if(n){const o=g.getWorkspaceFolder(n);if(o)return S.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(_){const n=_.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(_){const n=_.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>d.getExtension(n)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(M.env))}}let l=class extends C.Disposable{constructor(d,g,_,a,w){super(),this.extensionService=d,this.workspaceService=g,this.editorService=_,this.configurationService=a,this.editorTabs=w,this._resolver=new r.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async n=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new p(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};l=ze([$e(0,P.IExtHostExtensionService),$e(1,b.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,k.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs)],l),e.ExtHostVariableResolverProviderService=l}),define(Ce[104],Ie([1,0,15,5,10,2,3,4,51,33,11,6,31,164,166,32,103]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(i,n,o,f,s,h){this._workspaceService=n,this._extensionService=o,this._configurationService=f,this._editorTabs=s,this._variableResolver=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=i.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new _(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(T=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}asDebugSourceUri(i,n){const o=i;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let f=`debug:${encodeURIComponent(o.path||"")}`,s="?";return n&&(f+=`${s}session=${encodeURIComponent(n.id)}`,s="&"),f+=`${s}ref=${o.sourceReference}`,M.URI.parse(f)}else{if(o.path)return M.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const n=[];for(const o of i.getAllExtensionDescriptions())if(o.contributes){const f=o.contributes.debuggers;if(f&&f.length>0)for(const s of f)(0,p.isDebuggerMainContribution)(s)&&n.push(s.type)}this._debugServiceProxy.$registerDebugTypes(n)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(n=>i.push(n)),i}addBreakpoints(i){this.startBreakpoints();const n=i.filter(s=>{const h=s.id;return this._breakpoints.has(h)?!1:(this._breakpoints.set(h,s),!0)});this.fireBreakpointChanges(n,[],[]);const o=[],f=new Map;for(const s of n)if(s instanceof b.SourceBreakpoint){let h=f.get(s.location.uri.toString());h||(h={type:"sourceMulti",uri:s.location.uri,lines:[]},f.set(s.location.uri.toString(),h),o.push(h)),h.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof b.FunctionBreakpoint&&o.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(i){this.startBreakpoints();const n=i.filter(h=>this._breakpoints.delete(h.id));this.fireBreakpointChanges([],n,[]);const o=n.filter(h=>h instanceof b.SourceBreakpoint).map(h=>h.id),f=n.filter(h=>h instanceof b.FunctionBreakpoint).map(h=>h.id),s=n.filter(h=>h instanceof b.DataBreakpoint).map(h=>h.id);return this._debugServiceProxy.$unregisterBreakpoints(o,f,s)}startDebugging(i,n,o){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===b.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,debugUI:o.debugUI,suppressSaveBeforeStart:o.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,n,o){if(!n)return new b.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:f,provider:n}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,f),new b.Disposable(()=>{this._configProviders=this._configProviders.filter(s=>s.provider!==n),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(i,n,o){if(!o)return new b.Disposable(()=>{});if(!this.definesDebugType(i,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.getAdapterDescriptorFactoryByType(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:n,handle:f,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(n,f),new b.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(s=>s.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(i,n){if(!n)return new b.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:o,factory:n}),new b.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==n)})}async $runInTerminal(i,n){return Promise.resolve(void 0)}async $substituteVariables(i,n){let o;const f=await this.getFolder(i);return f&&(o={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,n)}createDebugAdapter(i,n){if(i.type==="implementation")return new w(i.implementation)}createSignService(){}async $startDASession(i,n){const o=this,f=await this.getSession(n);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const h=this.convertToDto(s),v=this.createDebugAdapter(h,f);if(!v)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const T=v;return this._debugAdapters.set(i,T),this.getDebugAdapterTrackers(f).then(N=>(N&&this._debugAdaptersTrackers.set(i,N),T.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const U=V,D={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const x=await this._signService.sign(U.arguments.value);D.body={signature:x},T.sendResponse(D)}else throw new Error("no signer")}catch(x){D.success=!1,D.message=x.message,T.sendResponse(D)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(V),V=(0,p.convertToVSCPaths)(V,!0),o._debugServiceProxy.$acceptDAMessage(i,V)}),T.onError(V=>{N&&N.onError&&N.onError(V),this._debugServiceProxy.$acceptDAError(i,V.name,V.message,V.stack)}),T.onExit(V=>{N&&N.onExit&&N.onExit((0,S.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,S.withNullAsUndefined)(V),void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),T.startSession()))})}$sendDAMessage(i,n){n=(0,p.convertToDAPaths)(n,!1);const o=this._debugAdaptersTrackers.get(i);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this._debugAdapters.get(i)?.sendMessage(n)}$stopDASession(i){const n=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),n&&n.onWillStopSession&&n.onWillStopSession();const o=this._debugAdapters.get(i);return this._debugAdapters.delete(i),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const n=[],o=[],f=[];if(i.added)for(const s of i.added){const h=s.id;if(h&&!this._breakpoints.has(h)){let v;if(s.type==="function")v=new b.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")v=new b.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const T=M.URI.revive(s.uri);v=new b.SourceBreakpoint(new b.Location(T,new b.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}v._id=h,this._breakpoints.set(h,v),n.push(v)}}if(i.removed)for(const s of i.removed){const h=this._breakpoints.get(s);h&&(this._breakpoints.delete(s),o.push(h))}if(i.changed){for(const s of i.changed)if(s.id){const h=this._breakpoints.get(s.id);if(h){if(h instanceof b.FunctionBreakpoint&&s.type==="function"){const v=h;v.enabled=s.enabled,v.condition=s.condition,v.hitCondition=s.hitCondition,v.logMessage=s.logMessage,v.functionName=s.functionName}else if(h instanceof b.SourceBreakpoint&&s.type==="source"){const v=h;v.enabled=s.enabled,v.condition=s.condition,v.hitCondition=s.hitCondition,v.logMessage=s.logMessage,v.location=new b.Location(M.URI.revive(s.uri),new b.Position(s.line,s.character))}f.push(h)}}}this.fireBreakpointChanges(n,o,f)}$provideDebugConfigurations(i,n,o){return(0,r.asPromise)(async()=>{const f=this.getConfigProviderByHandle(i);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.getFolder(n);return f.provideDebugConfigurations(s,o)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(i,n,o,f){return(0,r.asPromise)(async()=>{const s=this.getConfigProviderByHandle(i);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.getFolder(n);return s.resolveDebugConfiguration(h,o,f)})}$resolveDebugConfigurationWithSubstitutedVariables(i,n,o,f){return(0,r.asPromise)(async()=>{const s=this.getConfigProviderByHandle(i);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.getFolder(n);return s.resolveDebugConfigurationWithSubstitutedVariables(h,o,f)})}async $provideDebugAdapter(i,n){const o=this.getAdapterDescriptorFactoryByHandle(i);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(n);return this.getAdapterDescriptor(o,f).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(s)})}async $acceptDebugSessionStarted(i){const n=await this.getSession(i);this._onDidStartDebugSession.fire(n)}async $acceptDebugSessionTerminated(i){const n=await this.getSession(i);n&&(this._onDidTerminateDebugSession.fire(n),this._debugSessions.delete(n.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,n){(await this.getSession(i))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(i,n){const f={session:await this.getSession(i),event:n.event,body:n.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(i){if(i instanceof b.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof b.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof b.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof b.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const n=this._adapterFactories.filter(o=>o.type===i);if(n.length>0)return n[0].factory}getAdapterDescriptorFactoryByHandle(i){const n=this._adapterFactories.filter(o=>o.handle===i);if(n.length>0)return n[0].factory}getConfigProviderByHandle(i){const n=this._configProviders.filter(o=>o.handle===i);if(n.length>0)return n[0].provider}definesDebugType(i,n){if(i.contributes){const o=i.contributes.debuggers;if(o&&o.length>0){for(const f of o)if(f.label&&f.type&&f.type===n)return!0}}return!1}getDebugAdapterTrackers(i){const o=i.configuration.type,f=this._trackerFactories.filter(s=>s.type===o||s.type==="*").map(s=>(0,r.asPromise)(()=>s.factory.createDebugAdapterTracker(i)).then(h=>h,h=>null));return Promise.race([Promise.all(f).then(s=>{const h=s.filter(v=>!!v);if(h.length>0)return new a(h)}),new Promise((s,h)=>{const v=setTimeout(()=>{clearTimeout(v),h(new Error("timeout"))},1e3)})]).catch(s=>{})}async getAdapterDescriptor(i,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new b.DebugAdapterServer(o));if(i){const s=await this._extensionService.getExtensionRegistry();return(0,r.asPromise)(()=>i.createDebugAdapterDescriptor(n,this.daExecutableFromPackage(n,s))).then(h=>{if(h)return h})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(n,f))}daExecutableFromPackage(i,n){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,n,o){(i.length>0||n.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:n,changed:o}))}async getSession(i){if(i)if(typeof i=="string"){const n=this._debugSessions.get(i);if(n)return n}else{let n=this._debugSessions.get(i.id);if(!n){const o=await this.getFolder(i.folderUri),f=i.parent?this._debugSessions.get(i.parent):void 0;n=new g(this._debugServiceProxy,i.id,i.type,i.name,o,i.configuration,f),this._debugSessions.set(n.id,n),this._debugServiceProxy.$sessionCached(n.id)}return n}throw new Error("cannot find session")}getFolder(i){if(i){const n=M.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};d=ze([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,l.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,u.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class g{constructor(i,n,o,f,s,h,v){this._debugServiceProxy=i,this._id=n,this._type=o,this._name=f,this._workspaceFolder=s,this._configuration=h,this._parentSession=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,n){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,n)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=g;class _{constructor(i){this.value=Object.freeze({append(n){i.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.ExtHostDebugConsole=_;class a{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(n=>n.onError?n.onError(i):void 0)}onExit(i,n){this.trackers.forEach(o=>o.onExit?o.onExit(i,n):void 0)}}class w extends k.AbstractDebugAdapter{constructor(i){super(),this.implementation=i,i.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(i,n,o,f,s,h){super(i,n,o,f,s,h)}};t=ze([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,l.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,u.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[233],Ie([1,0,12,72,2,4,224,14,56,58,27,148,11,47,33]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class l{constructor(d,g,_,a,w){this._hostUtils=_,this._rpcProtocol=new y.RPCProtocol(d,null,a),g=l._transform(g,this._rpcProtocol);const t=new P.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());t.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:w}),t.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),t.set(k.IURITransformerService,new k.URITransformerService(a)),t.set(p.IHostUtils,_);const c=new b.InstantiationService(t,!0);this._logService=c.invokeFunction(f=>f.get(A.ILogService)),C.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=c.invokeFunction(f=>f.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(s,h)=>{let v="",T,N;for(const V of h)v+=`
	at ${V.toString()}`,N=V.getFileName(),!T&&N&&(T=f.findSubstr(S.URI.file(N)));return i.set(s,T),`${s.name||"Error"}: ${s.message||""}${v}`}});const n=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService),o=this._rpcProtocol.getProxy(M.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(f=>{const s=r.transformErrorForSerialization(f),h=i.get(f);h?n.$onExtensionRuntimeError(h.identifier,s):o.$onUnexpectedError(s)})}async asBrowserUri(d){const g=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return S.URI.revive(await g.$asBrowserUri(d))}terminate(d){this._extensionService.terminate(d)}static _transform(d,g){d.allExtensions.forEach(a=>{a.extensionLocation=S.URI.revive(g.transformIncomingURIs(a.extensionLocation));const w={};a.browserNlsBundleUris&&(Object.keys(a.browserNlsBundleUris).forEach(t=>w[t]=S.URI.revive(g.transformIncomingURIs(a.browserNlsBundleUris[t]))),a.browserNlsBundleUris=w)}),d.environment.appRoot=S.URI.revive(g.transformIncomingURIs(d.environment.appRoot));const _=d.environment.extensionDevelopmentLocationURI;return _&&(d.environment.extensionDevelopmentLocationURI=_.map(a=>S.URI.revive(g.transformIncomingURIs(a)))),d.environment.extensionTestsLocationURI=S.URI.revive(g.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=S.URI.revive(g.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=S.URI.revive(g.transformIncomingURIs(d.environment.workspaceStorageHome)),d.nlsBaseUrl=S.URI.revive(g.transformIncomingURIs(d.nlsBaseUrl)),d.logsLocation=S.URI.revive(g.transformIncomingURIs(d.logsLocation)),d.logFile=S.URI.revive(g.transformIncomingURIs(d.logFile)),d.workspace=g.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=l}),define(Ce[234],Ie([1,0,18,15,20,44,13,19,22,2,42]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(g,_,a,w){this.query=g,this.provider=_,this.fileUtils=a,this.processType=w,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,_){const a=this.query.folderQueries||[],w=new S.CancellationTokenSource;return _.onCancellationRequested(()=>w.cancel()),new Promise((t,c)=>{this.collector=new k(g);let i=!1;const n=(o,f)=>{if(!i&&!this.isLimitHit){const s=this.resultSize(o);l(o)&&typeof this.query.maxResults=="number"&&this.resultCount+s>this.query.maxResults&&(this.isLimitHit=!0,i=!0,w.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const h=this.resultSize(o);this.resultCount+=h,(h>0||!l(o))&&this.collector.add(o,f)}};Promise.all(a.map((o,f)=>this.searchInFolder(o,s=>n(s,f),w.token))).then(o=>{w.dispose(),this.collector.flush();const f=o.some(s=>!!s&&!!s.limitHit);t({limitHit:this.isLimitHit||f,messages:(0,r.flatten)(o.map(s=>s?.message?Array.isArray(s.message)?s.message:[s.message]:[])),stats:{type:this.processType}})},o=>{w.dispose();const f=(0,M.toErrorMessage)(o);c(new Error(f))})})}resultSize(g){return l(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,_){const a=Array.isArray(g.ranges)?g.ranges:[g.ranges],w=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:a.slice(0,_),preview:{matches:w.slice(0,_),text:g.preview.text},uri:g.uri}}async searchInFolder(g,_,a){const w=new O.QueryGlobTester(this.query,g),t=[],c={report:o=>{if(!this.validateProviderResult(o))return;const f=g.folder.scheme===y.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(o.uri))):void 0,s=E.relativePath(g.folder,o.uri);if(s){const h=w.includedInQuery(s,A.basename(s),f);(0,C.isThenable)(h)?t.push(h.then(v=>{v&&_(o)})):h&&_(o)}}},i=this.getSearchOptionsForFolder(g),n=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,c,a);return t.length&&await Promise.all(t),n}validateProviderResult(g){if(l(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const _=(0,O.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),a=(0,O.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),w={folder:P.URI.from(g.folder),excludes:a,includes:_,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return w.usePCRE2=this.query.usePCRE2,w}}e.TextSearchManager=b;function m(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class k{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new u(512,_=>this.sendItems(_))}add(g,_){this._currentFileMatch&&(this._currentFolderIdx!==_||!E.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=_,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(p(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=k;function p(d){return l(d)?{preview:{matches:(0,r.mapArrayOrNot)(d.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:d.preview.text},ranges:(0,r.mapArrayOrNot)(d.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function l(d){return!!d.preview}e.extensionResultIsMatch=l;class u{constructor(g,_){this.maxBatchSize=g,this.cb=_,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,_){!g||this.addItemToBatch(g,_)}addItems(g,_){!g||this.addItemsToBatch(g,_)}addItemToBatch(g,_){this.batch.push(g),this.batchSize+=_,this.onUpdate()}addItemsToBatch(g,_){this.batch=this.batch.concat(g),this.batchSize+=_,this.onUpdate()}onUpdate(){this.totalNumberCompleted<u.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},u.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=u,u.TIMEOUT=4e3,u.START_BATCH_AFTER_COUNT=50}),define(Ce[105],Ie([1,0,7,4,3,229,11,47,14,2,234]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let b=class{constructor(l,u,d){this.extHostRpc=l,this._uriTransformer=u,this._logService=d,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,u){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const d=this._handlePool++;return this._textSearchProvider.set(d,u),this._proxy.$registerTextSearchProvider(d,this._transformScheme(l)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}registerFileSearchProvider(l,u){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const d=this._handlePool++;return this._fileSearchProvider.set(d,u),this._proxy.$registerFileSearchProvider(d,this._transformScheme(l)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(l,u,d,g){const _=m(d),a=this._fileSearchProvider.get(l);if(a)return this._fileSearchManager.fileSearch(_,a,w=>{this._proxy.$handleFileMatch(l,u,w.map(t=>t.resource))},g);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,u,d,g){const _=this._textSearchProvider.get(l);if(!_||!_.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const a=m(d);return this.createTextSearchManager(a,_).search(t=>this._proxy.$handleTextMatch(l,u,t),g)}$enableExtensionHostSearch(){}createTextSearchManager(l,u){return new O.TextSearchManager(l,u,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};b=ze([$e(0,y.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,E.ILogService)],b),e.ExtHostSearch=b;function m(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(k),extraFileResources:p.extraFileResources&&p.extraFileResources.map(l=>P.URI.revive(l))}}e.reviveQuery=m;function k(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(Ce[235],Ie([1,0,56,100,31,97,32,37,50,53,102,104,105,70,62,67,99,52,36,69,88,51,206,14,176,103,98,68]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_,a,w,t,c,i,n,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(f.IExtHostLocalizationService,f.ExtHostLocalizationService,1),(0,r.registerSingleton)(c.ILoggerService,t.ExtHostLoggerService,1),(0,r.registerSingleton)(c.ILogService,i.ExtHostLogService,1),(0,r.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService,!1),(0,r.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,r.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,!1),(0,r.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,!1),(0,r.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService,!1),(0,r.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,!1),(0,r.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,!1),(0,r.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,!1),(0,r.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,r.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,!1),(0,r.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,!1),(0,r.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,!1),(0,r.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService,!1),(0,r.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,!1),(0,r.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow,!1),(0,r.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace,!1),(0,r.registerSingleton)(_.IExtHostSecretState,_.ExtHostSecretState,!1),(0,r.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry,!1),(0,r.registerSingleton)(o.IExtHostTelemetryLogService,o.ExtHostTelemetryLogService,!1),(0,r.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,!1),(0,r.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,!1)}),define(Ce[236],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class r{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(S){if(S&&this._dragOperations.has(S)){const M=this._dragOperations.get(S);return this._dragOperations.delete(S),M}}addDragOperationTransfer(S,M){this._dragOperations.set(S,M)}getRenderedTreeElement(S){if(this._renderedElements.has(S))return this._renderedElements.get(S)}addRenderedTreeItemElement(S,M){this._renderedElements.set(S,M)}removeRenderedTreeItemElement(S){this._renderedElements.has(S)&&this._renderedElements.delete(S)}}e.TreeviewsService=r}),define(Ce[237],Ie([1,0,135,6,22,2,5,7,15,6,10,18,8,20,236,28]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(_,a){if((0,O.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let w;return Array.isArray(_.highlights)&&(w=_.highlights.filter(t=>t.length===2&&typeof t[0]=="number"&&typeof t[1]=="number"),w=w.length?w:void 0),{label:_.label,highlights:w}}}class d{constructor(a,w,t){this._proxy=a,this.commands=w,this.logService=t,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeviewsService;function c(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:i=>c(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(n=>c(n)?this.convertArgument(n):n):i})}registerTreeDataProvider(a,w,t){const c=this.createTreeView(a,{treeDataProvider:w},t);return{dispose:()=>c.dispose()}}createTreeView(a,w,t){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=w.dragAndDropController?.dropMimeTypes??[],i=w.dragAndDropController?.dragMimeTypes??[],n=!!w.dragAndDropController?.handleDrag,o=!!w.dragAndDropController?.handleDrop,f=this.createExtHostTreeView(a,w,t),s=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:c,dragMimeTypes:i,hasHandleDrag:n,hasHandleDrop:o});return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,l.checkProposedApiEnabled)(t,"treeItemCheckbox"),f.onDidChangeCheckboxState},get message(){return f.message},set message(h){f.message=h},get title(){return f.title},set title(h){f.title=h},get description(){return f.description},set description(h){f.description=h},get badge(){return f.badge},set badge(h){h!==void 0&&P.ViewBadge.isViewBadge(h)?f.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(f.badge=void 0)},reveal:(h,v)=>f.reveal(h,v),dispose:async()=>{await s,this.treeViews.delete(a),f.dispose()}}}$getChildren(a,w){const t=this.treeViews.get(a);return t?t.getChildren(w):Promise.reject(new Error((0,r.localize)(0,null,a)))}async $handleDrop(a,w,t,c,i,n,o,f){const s=this.treeViews.get(a);if(!s)return Promise.reject(new Error((0,r.localize)(1,null,a)));const h=m.DataTransfer.toDataTransfer(t,async v=>(await this._proxy.$resolveDropFileData(a,w,v)).buffer);return o===a&&f&&await this.addAdditionalTransferItems(h,s,f,i,n),s.onDrop(h,c,i)}async addAdditionalTransferItems(a,w,t,c,i){const n=this.treeDragAndDropService.removeDragOperationTransfer(i);if(n)(await n)?.forEach((o,f)=>{o&&a.set(f,o)});else if(i&&w.handleDrag){const o=w.handleDrag(t,a,c);this.treeDragAndDropService.addDragOperationTransfer(i,o),await o}return a}async $handleDrag(a,w,t,c){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,r.localize)(2,null,a)));const n=await this.addAdditionalTransferItems(new C.DataTransfer,i,w,c,t);if(!!n)return m.DataTransfer.toDataTransferDTO(n)}async $hasResolve(a){const w=this.treeViews.get(a);if(!w)throw new Error((0,r.localize)(3,null,a));return w.hasResolve}$resolve(a,w,t){const c=this.treeViews.get(a);if(!c)throw new Error((0,r.localize)(4,null,a));return c.resolveTreeItem(w,t)}$setExpanded(a,w,t){const c=this.treeViews.get(a);if(!c)throw new Error((0,r.localize)(5,null,a));c.setExpanded(w,t)}$setSelection(a,w){const t=this.treeViews.get(a);if(!t)throw new Error((0,r.localize)(6,null,a));t.setSelection(w)}$setFocus(a,w){const t=this.treeViews.get(a);if(!t)throw new Error((0,r.localize)(7,null,a));t.setFocus(w)}$setVisible(a,w){const t=this.treeViews.get(a);if(!t)throw new Error((0,r.localize)(8,null,a));t.setVisible(w)}$changeCheckboxState(a,w){const t=this.treeViews.get(a);if(!t)throw new Error((0,r.localize)(9,null,a));t.setCheckboxState(w)}createExtHostTreeView(a,w,t){const c=new g(a,w,this._proxy,this.commands.converter,this.logService,t);return this.treeViews.set(a,c),c}convertArgument(a){const w=this.treeViews.get(a.$treeViewId);return w&&"$treeItemHandle"in a?w.getExtensionElement(a.$treeItemHandle):w&&"$focusedTreeItem"in a&&a.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=d;class g extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,O.isUndefinedOrNull)(a))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(a,w,t,c,i,n){if(super(),this.viewId=a,this.proxy=t,this.commands=c,this.logService=i,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new y.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new k.CancellationTokenSource,n.contributes&&n.contributes.views)for(const s in n.contributes.views)for(const h of n.contributes.views[s])h.id===a&&(this._title=h.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let o,f;this._register(y.Event.debounce(this._onDidChangeData.event,(s,h)=>(s||(s={message:!1,elements:[]}),h.element!==!1&&(o||(o=new Promise(v=>f=v),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(h.element)?s.elements.push(...h.element):s.elements.push(h.element)),h.message&&(s.message=!0),s),200,!0)(({message:s,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=f;return o=null,this.refresh(h).then(()=>v())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(a){const w=a?this.getExtensionElement(a):void 0;if(a&&!w)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let t=this.getChildrenNodes(a);return t||(t=await this.fetchChildrenNodes(w)),t?t.map(c=>c.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,w){w=w||{select:!0,focus:!1};const t=(0,O.isUndefinedOrNull)(w.select)?!0:w.select,c=(0,O.isUndefinedOrNull)(w.focus)?!1:w.focus,i=(0,O.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(n=>this.resolveTreeNode(a,n[n.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:n.map(f=>f.item)},{select:t,focus:c,expand:i})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:t,focus:c,expand:i})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=m.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,w){const t=this.getExtensionElement(a);t&&(w?this._onDidExpandElement.fire(Object.freeze({element:t})):this._onDidCollapseElement.fire(Object.freeze({element:t})))}setSelection(a){(0,b.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(a){this._focusedHandle=a}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(a){const w=(await Promise.all(a.map(async t=>{const c=this.getExtensionElement(t.treeItemHandle);return c?{extensionItem:c,treeItem:await this.dataProvider.getTreeItem(c),newState:t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(t=>t!==void 0);w.forEach(t=>{t.treeItem.checkboxState=t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:w.map(t=>[t.extensionItem,t.newState])})}async handleDrag(a,w,t){const c=[];for(const i of a){const n=this.getExtensionElement(i);n&&c.push(n)}if(!(!this.dndController?.handleDrag||c.length===0))return await this.dndController.handleDrag(c,w,t),w}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,w,t){const c=w?this.getExtensionElement(w):void 0;if(!(!c&&w||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(c,a,t):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,w){if(!this.dataProvider.resolveTreeItem)return;const t=this.elements.get(a);if(t){const c=this.nodes.get(t);if(c){const i=await this.dataProvider.resolveTreeItem(c.extensionItem,t,w)??c.extensionItem;return this.validateTreeItem(i),c.item.tooltip=this.getTooltip(i.tooltip),c.item.command=this.getCommand(c.disposableStore,i.command),c.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(w=>w?this.resolveUnknownParentChain(w).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(c=>(t.push(c),t))):Promise.resolve([]))}resolveParent(a){const w=this.nodes.get(a);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,w){const t=this.nodes.get(a);return t?Promise.resolve(t):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(c=>this.createHandle(a,c,w,!0)).then(c=>this.getChildren(w?w.item.handle:void 0).then(()=>{const i=this.getExtensionElement(c);if(i){const n=this.nodes.get(i);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(a){if(a){let w;if(typeof a=="string"){const t=this.getExtensionElement(a);w=t?this.nodes.get(t):void 0}else w=a;return w&&w.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const w=new k.CancellationTokenSource(this._refreshCancellationSource.token);try{const t=a?this.nodes.get(a):void 0,c=await this.dataProvider.getChildren(a);if(w.token.isCancellationRequested)return;const i=await Promise.all((0,b.coalesce)(c||[]).map(async n=>{const o=await this.dataProvider.getTreeItem(n);return o&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(n,o,t):null}));return w.token.isCancellationRequested?void 0:(0,b.coalesce)(i)}finally{w.dispose()}}refresh(a){if(a.some(t=>!t))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new k.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const t=this.getHandlesToRefresh(a);if(t.length)return this.refreshHandles(t)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const w=new Set,t=a.map(i=>this.nodes.get(i));for(const i of t)if(i&&!w.has(i.item.handle)){let n=i;for(;n&&n.parent&&t.findIndex(o=>n&&n.parent&&o&&o.item.handle===n.parent.item.handle)===-1;){const o=this.elements.get(n.parent.item.handle);n=o?this.nodes.get(o):void 0}n&&!n.parent&&w.add(i.item.handle)}const c=[];return w.forEach(i=>{const n=this.elements.get(i);if(n){const o=this.nodes.get(n);o&&(!o.parent||!w.has(o.parent.item.handle))&&c.push(i)}}),c}refreshHandles(a){const w={};return Promise.all(a.map(t=>this.refreshNode(t).then(c=>{c&&(w[t]=c.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(a){const w=this.getExtensionElement(a);if(w){const t=this.nodes.get(w);if(t)return this.clearChildren(w),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(c=>{if(c){const i=this.createTreeNode(w,c,t.parent);return this.updateNodeCache(w,i,t,t.parent),t.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,w,t){const c=this.createTreeNode(a,w,t);if(w.id&&this.elements.has(c.item.handle))throw new Error((0,r.localize)(10,null,w.id));return this.addNodeToCache(a,c),this.addNodeToParentCache(c,t),c}getTooltip(a){return P.MarkdownString.isMarkdownString(a)?m.MarkdownString.from(a):a}getCommand(a,w){return w?{...this.commands.toInternal(w,a),originalId:w.command}:void 0}getCheckbox(a){if(!a.checkboxState)return;let w,t;return typeof a.checkboxState=="number"?w=a.checkboxState:(w=a.checkboxState.state,t=a.checkboxState.tooltip),{isChecked:w===P.TreeItemCheckboxState.Checked,tooltip:t}}validateTreeItem(a){if(!P.TreeItem.isTreeItem(a,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(a,w,t){this.validateTreeItem(w);const c=new A.DisposableStore,i=this.createHandle(a,w,t),n=this.getLightIconPath(w);return{item:{handle:i,parentHandle:t?t.item.handle:void 0,label:u(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(c,w.command),contextValue:w.contextValue,icon:n,iconDark:this.getDarkIconPath(w)||n,themeIcon:this.getThemeIcon(w),collapsibleState:(0,O.isUndefinedOrNull)(w.collapsibleState)?P.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.getCheckbox(w)},extensionItem:w,parent:t,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(a){return a.iconPath instanceof P.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:w,label:t,resourceUri:c},i,n){if(w)return`${g.ID_HANDLE_PREFIX}/${w}`;const o=u(t,this.extension),f=i?i.item.handle:g.LABEL_HANDLE_PREFIX;let s=o?o.label:c?(0,S.basename)(c):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const h=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,v=this.getChildrenNodes(i)||[];let T,N=0;do{if(T=`${f}/${N}:${s}`,n||!this.elements.has(T)||h===T)break;N++}while(N<=v.length);return T}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon))return typeof a.iconPath=="string"||M.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return M.URI.isUri(a)?a:M.URI.file(a)}addNodeToCache(a,w){this.elements.set(w.item.handle,a),this.nodes.set(a,w)}updateNodeCache(a,w,t,c){this.elements.delete(w.item.handle),this.nodes.delete(a),w.item.handle!==t.item.handle&&this.elements.delete(t.item.handle),this.addNodeToCache(a,w);const i=this.getChildrenNodes(c)||[],n=i.filter(o=>o.item.handle===t.item.handle)[0];n&&i.splice(i.indexOf(n),1,w)}addNodeToParentCache(a,w){w?(w.children||(w.children=[]),w.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const w=this.nodes.get(a);if(w){if(w.children)for(const t of w.children){const c=this.elements.get(t.item.handle);c&&this.clear(c)}w.children=void 0}}else this.clearAll()}clear(a){const w=this.nodes.get(a);if(w){if(w.children)for(const t of w.children){const c=this.elements.get(t.item.handle);c&&this.clear(c)}this.nodes.delete(a),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(Ce[238],Ie([1,0,20,12,5,29,2,122,247,111,120,35,4,92,191,190,37,192,32,194,195,196,179,197,50,33,199,200,203,205,207,100,182,211,212,213,70,53,216,237,8,6,219,54,99,31,163,202,87,97,102,104,105,14,47,11,27,208,177,62,67,188,217,71,52,222,220,221,189,36,214,218,69,51,88,209,101,210,13,83,181,160,201,7,28,165,98,68]),function(ie,e,r,C,S,M,y,A,E,P,O,b,m,k,p,l,u,d,g,_,a,w,t,c,i,n,o,f,s,h,v,T,N,V,U,D,x,L,R,K,W,$,G,re,ge,oe,Ee,ce,me,ee,be,_e,Fe,Be,Xe,ke,ye,De,ae,ue,Z,J,I,B,H,j,se,le,Y,ve,pe,Me,xe,Ye,Ge,Te,rt,X,Q,he,Ue,je,Ze,Ke,Ve,it,st,dt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function _t(tt){const ut=tt.get(ye.IExtHostInitDataService),Ot=tt.get(ve.IExtHostFileSystemInfo),Ht=tt.get(H.IExtHostConsumerFileSystem),At=tt.get(n.IExtHostExtensionService),ft=tt.get(oe.IExtHostWorkspace),Ct=tt.get(Ge.IExtHostTelemetry),Lt=tt.get(g.IExtHostConfiguration),xt=tt.get(Xe.IURITransformerService),qe=tt.get(ke.IExtHostRpcService),Ft=tt.get(x.IExtHostStorage),It=tt.get(B.IExtensionStoragePaths),Nt=tt.get(Be.ILoggerService),gt=tt.get(Be.ILogService),Se=tt.get(ue.IExtHostTunnelService),Pe=tt.get(st.IExtHostTelemetryLogService),fe=tt.get(Z.IExtHostApiDeprecationService),q=tt.get(ge.IExtHostWindow),Ae=tt.get(xe.IExtHostSecretState),Le=tt.get(Ye.IExtHostEditorTabs);qe.set(m.ExtHostContext.ExtHostFileSystemInfo,Ot),qe.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Nt),qe.set(m.ExtHostContext.ExtHostWorkspace,ft),qe.set(m.ExtHostContext.ExtHostConfiguration,Lt),qe.set(m.ExtHostContext.ExtHostExtensionService,At),qe.set(m.ExtHostContext.ExtHostStorage,Ft),qe.set(m.ExtHostContext.ExtHostTunnelService,Se),qe.set(m.ExtHostContext.ExtHostWindow,q),qe.set(m.ExtHostContext.ExtHostSecretState,Ae),qe.set(m.ExtHostContext.ExtHostTelemetry,Ct),qe.set(m.ExtHostContext.ExtHostEditorTabs,Le);const nt=qe.set(m.ExtHostContext.ExtHostDecorations,tt.get(ee.IExtHostDecorations)),We=qe.set(m.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(i.IExtHostDocumentsAndEditors)),et=qe.set(m.ExtHostContext.ExtHostCommands,tt.get(u.IExtHostCommands)),lt=qe.set(m.ExtHostContext.ExtHostTerminalService,tt.get(L.IExtHostTerminalService)),mt=qe.set(m.ExtHostContext.ExtHostDebugService,tt.get(_e.IExtHostDebugService)),yt=qe.set(m.ExtHostContext.ExtHostSearch,tt.get(Fe.IExtHostSearch)),Et=qe.set(m.ExtHostContext.ExtHostTask,tt.get(be.IExtHostTask)),wt=qe.set(m.ExtHostContext.ExtHostOutputService,tt.get(T.IExtHostOutputService)),kt=qe.set(m.ExtHostContext.ExtHostLocalization,tt.get(dt.IExtHostLocalizationService)),bt=qe.set(m.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(qe)),Dt=qe.set(m.ExtHostContext.ExtHostDocuments,new c.ExtHostDocuments(qe,We)),ti=qe.set(m.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(qe,We,gt)),Xt=qe.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(gt,Dt,qe.getProxy(m.MainContext.MainThreadBulkEdits))),vt=qe.set(m.ExtHostContext.ExtHostNotebook,new De.ExtHostNotebookController(qe,et,We,Dt)),ii=qe.set(m.ExtHostContext.ExtHostNotebookDocuments,new je.ExtHostNotebookDocuments(vt)),ni=qe.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(gt,vt)),ri=qe.set(m.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(qe,ut,vt,et,gt)),pi=qe.set(m.ExtHostContext.ExtHostNotebookRenderers,new X.ExtHostNotebookRenderers(qe,vt)),Tt=qe.set(m.ExtHostContext.ExtHostEditors,new R.ExtHostEditors(qe,We)),zt=qe.set(m.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(qe.getProxy(m.MainContext.MainThreadTreeViews),et,gt)),vi=qe.set(m.ExtHostContext.ExtHostEditorInsets,new Ee.ExtHostEditorInsets(qe.getProxy(m.MainContext.MainThreadEditorInsets),Tt,ut.remote)),si=qe.set(m.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(qe,gt,Ot)),Qt=qe.set(m.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(qe,Dt,et.converter,xt)),at=qe.set(m.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(qe,xt,Dt,et,si,gt,fe)),Ei=qe.set(m.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(qe,at)),$t=qe.set(m.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(qe,gt,We)),qt=qe.set(m.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(qe,ft,et)),oi=qe.set(m.ExtHostContext.ExtHostSCM,new U.ExtHostSCM(qe,et,gt)),bi=qe.set(m.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(qe,et,Dt)),ai=qe.set(m.ExtHostContext.ExtHostProgress,new N.ExtHostProgress(qe.getProxy(m.MainContext.MainThreadProgress))),wi=qe.set(m.ExtHostContext.ExtHosLabelService,new ce.ExtHostLabelService(qe)),ci=qe.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(qe)),li=qe.set(m.ExtHostContext.ExtHostAuthentication,new J.ExtHostAuthentication(qe)),Ni=qe.set(m.ExtHostContext.ExtHostTimeline,new I.ExtHostTimeline(qe,et)),Yt=qe.set(m.ExtHostContext.ExtHostWebviews,new re.ExtHostWebviews(qe,ut.remote,ft,gt,fe)),Jt=qe.set(m.ExtHostContext.ExtHostWebviewPanels,new le.ExtHostWebviewPanels(qe,Yt,ft)),Si=qe.set(m.ExtHostContext.ExtHostCustomEditors,new se.ExtHostCustomEditors(qe,Dt,It,Yt,Jt)),_i=qe.set(m.ExtHostContext.ExtHostWebviewViews,new j.ExtHostWebviewViews(qe,Yt)),Zt=qe.set(m.ExtHostContext.ExtHostTesting,new pe.ExtHostTesting(qe,et,We)),yi=qe.set(m.ExtHostContext.ExtHostUriOpeners,new Me.ExtHostUriOpeners(qe));qe.set(m.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(qe,vt,We,et,gt));const Di=Object.values(m.ExtHostContext);qe.assertRegistered(Di);const Mi=new Y.ExtHostBulkEdits(qe,We),Li=new l.ExtHostClipboard(qe),Ci=new v.ExtHostMessageService(qe,gt),Pi=new a.ExtHostDialogs(qe),Ai=new D.ExtHostStatusBar(qe,et.converter);return p.ExtHostApiCommands.register(et),function(Ne,Ut,ui){const pt=function(){let ne=!Ne.isUnderDevelopment;function de(){ne||(gt.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")de();else{const St=ot;typeof St.scheme>"u"&&de(),typeof St.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return ot}}(),Ui={getSession(ne,de,Re){return li.getSession(Ne,ne,de,Re)},async hasSession(ne,de){return(0,Ve.checkProposedApiEnabled)(Ne,"authSession"),!!await li.getSession(Ne,ne,de,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(ne,de,Re,ot){return li.registerAuthenticationProvider(ne,de,Re,ot)}},Bi={registerCommand(ne,de,Re){return et.registerCommand(!0,ne,de,Re,void 0,Ne)},registerTextEditorCommand(ne,de,Re){return et.registerCommand(!0,ne,(...ot)=>{const St=Tt.getActiveTextEditor();if(!St){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return St.edit(Pt=>{de.apply(Re,[St,Pt,...ot])}).then(Pt=>{Pt||gt.warn("Edits from command "+ne+" were not applied.")},Pt=>{gt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ne,de,Re)=>((0,Ve.checkProposedApiEnabled)(Ne,"diffCommand"),et.registerCommand(!0,ne,async(...ot)=>{const St=We.activeEditor(!0);if(!St){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(St.id);de.apply(Re,[Pt,...ot])},void 0,void 0,Ne)),executeCommand(ne,...de){return et.executeCommand(ne,...de)},getCommands(ne=!1){return et.getCommands(ne)}},ei={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Li.value},get shell(){return lt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Ne,"envShellEvent"),lt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ne,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ne,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ne=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,de){return q.openUri(ne,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ut.environment.appUriScheme)return bt.createAppUri(ne);try{return await q.asExternalUri(ne,{allowTunneling:!!ut.remote.authority})}catch(de){if((0,he.matchesScheme)(ne,Q.Schemas.http)||(0,he.matchesScheme)(ne,Q.Schemas.https))return ne;throw de}},get remoteName(){return(0,me.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(ei);const xi={createTestController(ne,de,Re){return Zt.createTestController(ne,de,Re)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),Zt.createTestObserver()},runTests(ne){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),Zt.runTests(ne)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),Zt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),Zt.results}},di=ut.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,zi={getExtension(ne,de){(0,Ve.isProposedApiEnabled)(Ne,"extensionsAny")||(de=!1);const Re=Ut.mine.getExtensionDescription(ne);if(Re)return new n.Extension(At,Ne.identifier,Re,di,!1);if(de){const ot=Ut.all.getExtensionDescription(ne);if(ot)return new n.Extension(At,Ne.identifier,ot,di,!0)}},get all(){const ne=[];for(const de of Ut.mine.getAllExtensionDescriptions())ne.push(new n.Extension(At,Ne.identifier,de,di,!1));return ne},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Ne,"extensionsAny");const ne=new Ve.ExtensionIdentifierSet(Ut.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),de=[];for(const Re of Ut.all.getAllExtensionDescriptions()){const ot=!ne.has(Re.identifier);de.push(new n.Extension(At,Ne.identifier,Re,di,ot))}return de},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Ne,"extensionsAny")?S.Event.any(Ut.mine.onDidChange,Ut.all.onDidChange):Ut.mine.onDidChange}},$i={createDiagnosticCollection(ne){return si.createDiagnosticCollection(Ne.identifier,ne)},get onDidChangeDiagnostics(){return si.onDidChangeDiagnostics},getDiagnostics:ne=>si.getDiagnostics(ne),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(ne,de){return Qt.changeLanguage(ne.uri,de)},match(ne,de){const Re=Dt.getDocumentData(de.uri)?.notebook;return(0,O.score)(W.LanguageSelector.from(ne),de.uri,de.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(ne,de,Re){return at.registerCodeActionProvider(Ne,pt(ne),de,Re)},registerDocumentPasteEditProvider(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"documentPaste"),at.registerDocumentPasteEditProvider(Ne,pt(ne),de,Re)},registerCodeLensProvider(ne,de){return at.registerCodeLensProvider(Ne,pt(ne),de)},registerDefinitionProvider(ne,de){return at.registerDefinitionProvider(Ne,pt(ne),de)},registerDeclarationProvider(ne,de){return at.registerDeclarationProvider(Ne,pt(ne),de)},registerImplementationProvider(ne,de){return at.registerImplementationProvider(Ne,pt(ne),de)},registerTypeDefinitionProvider(ne,de){return at.registerTypeDefinitionProvider(Ne,pt(ne),de)},registerHoverProvider(ne,de){return at.registerHoverProvider(Ne,pt(ne),de,Ne.identifier)},registerEvaluatableExpressionProvider(ne,de){return at.registerEvaluatableExpressionProvider(Ne,pt(ne),de,Ne.identifier)},registerInlineValuesProvider(ne,de){return at.registerInlineValuesProvider(Ne,pt(ne),de,Ne.identifier)},registerDocumentHighlightProvider(ne,de){return at.registerDocumentHighlightProvider(Ne,pt(ne),de)},registerLinkedEditingRangeProvider(ne,de){return at.registerLinkedEditingRangeProvider(Ne,pt(ne),de)},registerReferenceProvider(ne,de){return at.registerReferenceProvider(Ne,pt(ne),de)},registerRenameProvider(ne,de){return at.registerRenameProvider(Ne,pt(ne),de)},registerDocumentSymbolProvider(ne,de,Re){return at.registerDocumentSymbolProvider(Ne,pt(ne),de,Re)},registerWorkspaceSymbolProvider(ne){return at.registerWorkspaceSymbolProvider(Ne,ne)},registerDocumentFormattingEditProvider(ne,de){return at.registerDocumentFormattingEditProvider(Ne,pt(ne),de)},registerDocumentRangeFormattingEditProvider(ne,de){return at.registerDocumentRangeFormattingEditProvider(Ne,pt(ne),de)},registerOnTypeFormattingEditProvider(ne,de,Re,...ot){return at.registerOnTypeFormattingEditProvider(Ne,pt(ne),de,[Re].concat(ot))},registerDocumentSemanticTokensProvider(ne,de,Re){return at.registerDocumentSemanticTokensProvider(Ne,pt(ne),de,Re)},registerDocumentRangeSemanticTokensProvider(ne,de,Re){return at.registerDocumentRangeSemanticTokensProvider(Ne,pt(ne),de,Re)},registerSignatureHelpProvider(ne,de,Re,...ot){return typeof Re=="object"?at.registerSignatureHelpProvider(Ne,pt(ne),de,Re):at.registerSignatureHelpProvider(Ne,pt(ne),de,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(ne,de,...Re){return at.registerCompletionItemProvider(Ne,pt(ne),de,Re)},registerInlineCompletionItemProvider(ne,de){return de.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),at.registerInlineCompletionsProvider(Ne,pt(ne),de)},registerInlineCompletionItemProviderNew(ne,de){if((0,Ve.checkProposedApiEnabled)(Ne,"inlineCompletionsNew"),de.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)(Ne,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return at.registerInlineCompletionsProviderNew(Ne,pt(ne),de)},registerDocumentLinkProvider(ne,de){return at.registerDocumentLinkProvider(Ne,pt(ne),de)},registerColorProvider(ne,de){return at.registerColorProvider(Ne,pt(ne),de)},registerFoldingRangeProvider(ne,de){return at.registerFoldingRangeProvider(Ne,pt(ne),de)},registerSelectionRangeProvider(ne,de){return at.registerSelectionRangeProvider(Ne,ne,de)},registerCallHierarchyProvider(ne,de){return at.registerCallHierarchyProvider(Ne,ne,de)},registerTypeHierarchyProvider(ne,de){return at.registerTypeHierarchyProvider(Ne,ne,de)},setLanguageConfiguration:(ne,de)=>at.setLanguageConfiguration(Ne,ne,de),getTokenInformationAtPosition(ne,de){return(0,Ve.checkProposedApiEnabled)(Ne,"tokenInformation"),Qt.tokenAtPosition(ne,de)},registerInlayHintsProvider(ne,de){return at.registerInlayHintsProvider(Ne,ne,de)},createLanguageStatusItem(ne,de){return Qt.createLanguageStatusItem(Ne,ne,de)},registerDocumentDropEditProvider(ne,de){return at.registerDocumentOnDropEditProvider(Ne,ne,de)}},Ii={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(ne,de,Re){const ot=await(y.URI.isUri(ne)?Promise.resolve(Ri.openTextDocument(ne)):Promise.resolve(ne));return Tt.showTextDocument(ot,de,Re)},createTextEditorDecorationType(ne){return Tt.createTextEditorDecorationType(Ne,ne)},onDidChangeActiveTextEditor(ne,de,Re){return Tt.onDidChangeActiveTextEditor(ne,de,Re)},onDidChangeVisibleTextEditors(ne,de,Re){return Tt.onDidChangeVisibleTextEditors(ne,de,Re)},onDidChangeTextEditorSelection(ne,de,Re){return Tt.onDidChangeTextEditorSelection(ne,de,Re)},onDidChangeTextEditorOptions(ne,de,Re){return Tt.onDidChangeTextEditorOptions(ne,de,Re)},onDidChangeTextEditorVisibleRanges(ne,de,Re){return Tt.onDidChangeTextEditorVisibleRanges(ne,de,Re)},onDidChangeTextEditorViewColumn(ne,de,Re){return Tt.onDidChangeTextEditorViewColumn(ne,de,Re)},onDidCloseTerminal(ne,de,Re){return lt.onDidCloseTerminal(ne,de,Re)},onDidOpenTerminal(ne,de,Re){return lt.onDidOpenTerminal(ne,de,Re)},onDidChangeActiveTerminal(ne,de,Re){return lt.onDidChangeActiveTerminal(ne,de,Re)},onDidChangeTerminalDimensions(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"terminalDimensions"),lt.onDidChangeTerminalDimensions(ne,de,Re)},onDidChangeTerminalState(ne,de,Re){return lt.onDidChangeTerminalState(ne,de,Re)},onDidWriteTerminalData(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),lt.onDidWriteTerminalData(ne,de,Re)},get state(){return q.state},onDidChangeWindowState(ne,de,Re){return q.onDidChangeWindowState(ne,de,Re)},showInformationMessage(ne,...de){return Ci.showMessage(Ne,M.default.Info,ne,de[0],de.slice(1))},showWarningMessage(ne,...de){return Ci.showMessage(Ne,M.default.Warning,ne,de[0],de.slice(1))},showErrorMessage(ne,...de){return Ci.showMessage(Ne,M.default.Error,ne,de[0],de.slice(1))},showQuickPick(ne,de,Re){return qt.showQuickPick(ne,de,Re)},showWorkspaceFolderPick(ne){return qt.showWorkspaceFolderPick(ne)},showInputBox(ne,de){return qt.showInput(ne,de)},showOpenDialog(ne){return Pi.showOpenDialog(ne)},showSaveDialog(ne){return Pi.showSaveDialog(ne)},createStatusBarItem(ne,de,Re){let ot,St,Pt;return typeof ne=="string"?(ot=ne,St=de,Pt=Re):(St=ne,Pt=de),Ai.createStatusBarEntry(Ne,ot,St,Pt)},setStatusBarMessage(ne,de){return Ai.setStatusBarMessage(ne,de)},withScmProgress(ne){return fe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),ai.withProgress(Ne,{location:$.ProgressLocation.SourceControl},(de,Re)=>ne({report(ot){}}))},withProgress(ne,de){return ai.withProgress(Ne,ne,de)},createOutputChannel(ne,de){return wt.createOutputChannel(ne,de,Ne)},createWebviewPanel(ne,de,Re,ot){return Jt.createWebviewPanel(Ne,ne,de,Re,ot)},createWebviewTextEditorInset(ne,de,Re,ot){return(0,Ve.checkProposedApiEnabled)(Ne,"editorInsets"),vi.createWebviewEditorInset(ne,de,Re,ot,Ne)},createTerminal(ne,de,Re){return typeof ne=="object"?"pty"in ne?lt.createExtensionTerminal(ne):lt.createTerminalFromOptions(ne):lt.createTerminal(ne,de,Re)},registerTerminalLinkProvider(ne){return lt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,de){return lt.registerProfileProvider(Ne,ne,de)},registerTreeDataProvider(ne,de){return zt.registerTreeDataProvider(ne,de,Ne)},createTreeView(ne,de){return zt.createTreeView(ne,de,Ne)},registerWebviewPanelSerializer:(ne,de)=>Jt.registerWebviewPanelSerializer(Ne,ne,de),registerCustomEditorProvider:(ne,de,Re={})=>Si.registerCustomEditorProvider(Ne,ne,de,Re),registerFileDecorationProvider(ne){return nt.registerFileDecorationProvider(ne,Ne.identifier)},registerUriHandler(ne){return bt.registerUriHandler(Ne.identifier,ne)},createQuickPick(){return qt.createQuickPick(Ne)},createInputBox(){return qt.createInputBox(Ne)},get activeColorTheme(){return ci.activeColorTheme},onDidChangeActiveColorTheme(ne,de,Re){return ci.onDidChangeActiveColorTheme(ne,de,Re)},registerWebviewViewProvider(ne,de,Re){return _i.registerWebviewViewProvider(Ne,ne,de,Re?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,de,Re){return vt.onDidChangeActiveNotebookEditor(ne,de,Re)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,de,Re){return ni.onDidChangeNotebookEditorSelection(ne,de,Re)},onDidChangeNotebookEditorVisibleRanges(ne,de,Re){return ni.onDidChangeNotebookEditorVisibleRanges(ne,de,Re)},showNotebookDocument(ne,de){return y.URI.isUri(ne)&&fe.report("window.showNotebookDocument(uri)",Ne,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),vt.showNotebookDocument(ne,de)},registerExternalUriOpener(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"externalUriOpener"),yi.registerExternalUriOpener(Ne.identifier,ne,de,Re)},get tabGroups(){return Le.tabGroups},logTelemetryToOutputChannel(ne,de){(0,Ve.checkProposedApiEnabled)(Ne,"telemetryLog"),Pe.logToTelemetryOutputChannel(Ne,ne,de)}},Ri={get rootPath(){return fe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw C.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw C.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw C.readonly()},updateWorkspaceFolders:(ne,de,...Re)=>ft.updateWorkspaceFolders(Ne,ne,de||0,...Re),onDidChangeWorkspaceFolders:function(ne,de,Re){return ft.onDidChangeWorkspace(ne,de,Re)},asRelativePath:(ne,de)=>ft.getRelativePath(ne,de),findFiles:(ne,de,Re,ot)=>ft.findFiles(ne,de,Re,Ne.identifier,ot),findTextInFiles:(ne,de,Re,ot)=>{(0,Ve.checkProposedApiEnabled)(Ne,"findTextInFiles");let St,Pt;return typeof de=="object"?(St=de,Pt=Re):(St={},Pt=de,ot=Re),ft.findTextInFiles(ne,St||{},Pt,Ne.identifier,ot)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,de){return Mi.applyWorkspaceEdit(ne,Ne,de)},createFileSystemWatcher:(ne,de,Re,ot)=>$t.createFileSystemWatcher(ft,Ne,ne,de,Re,ot),get textDocuments(){return Dt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw C.readonly()},openTextDocument(ne){let de;const Re=ne;if(typeof ne=="string")de=Promise.resolve(y.URI.file(ne));else if(y.URI.isUri(ne))de=Promise.resolve(ne);else if(!Re||typeof Re=="object")de=Dt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ot=>Dt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(ne,de,Re)=>Dt.onDidAddDocument(ne,de,Re),onDidCloseTextDocument:(ne,de,Re)=>Dt.onDidRemoveDocument(ne,de,Re),onDidChangeTextDocument:(ne,de,Re)=>Dt.onDidChangeDocument(ne,de,Re),onDidSaveTextDocument:(ne,de,Re)=>Dt.onDidSaveDocument(ne,de,Re),onWillSaveTextDocument:(ne,de,Re)=>Xt.getOnWillSaveTextDocumentEvent(Ne)(ne,de,Re),get notebookDocuments(){return vt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,de){let Re;if(y.URI.isUri(ne))Re=ne,await vt.openNotebookDocument(ne);else if(typeof ne=="string")Re=y.URI.revive(await vt.createNotebookDocument({viewType:ne,content:de}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(ne,de,Re){return ii.onDidSaveNotebookDocument(ne,de,Re)},onDidChangeNotebookDocument(ne,de,Re){return ii.onDidChangeNotebookDocument(ne,de,Re)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,de,Re,ot){return vt.registerNotebookSerializer(Ne,ne,de,Re,(0,Ve.isProposedApiEnabled)(Ne,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(ne,de,Re,ot)=>((0,Ve.checkProposedApiEnabled)(Ne,"notebookContentProvider"),fe.report("workspace.registerNotebookContentProvider",Ne,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider(Ne,ne,de,Re,(0,Ve.isProposedApiEnabled)(Ne,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(ne,de,Re)=>ui.onDidChangeConfiguration(ne,de,Re),getConfiguration(ne,de){return de=arguments.length===1?void 0:de,ui.getConfiguration(ne,de,Ne)},registerTextDocumentContentProvider(ne,de){return ti.registerTextDocumentContentProvider(ne,de)},registerTaskProvider:(ne,de)=>(fe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Ne,ne,de)),registerFileSystemProvider(ne,de,Re){return(0,Ke.combinedDisposable)(Ei.registerFileSystemProvider(Ne,ne,de,Re),Ht.addFileSystemProvider(ne,de))},get fs(){return Ht.value},registerFileSearchProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"fileSearchProvider"),yt.registerFileSearchProvider(ne,de)),registerTextSearchProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"textSearchProvider"),yt.registerTextSearchProvider(ne,de)),registerRemoteAuthorityResolver:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),At.registerRemoteAuthorityResolver(ne,de)),registerResourceLabelFormatter:ne=>((0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),wi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,de,Re)=>$t.onDidCreateFile(ne,de,Re),onDidDeleteFiles:(ne,de,Re)=>$t.onDidDeleteFile(ne,de,Re),onDidRenameFiles:(ne,de,Re)=>$t.onDidRenameFile(ne,de,Re),onWillCreateFiles:(ne,de,Re)=>$t.getOnWillCreateFileEvent(Ne)(ne,de,Re),onWillDeleteFiles:(ne,de,Re)=>$t.getOnWillDeleteFileEvent(Ne)(ne,de,Re),onWillRenameFiles:(ne,de,Re)=>$t.getOnWillRenameFileEvent(Ne)(ne,de,Re),openTunnel:ne=>((0,Ve.checkProposedApiEnabled)(Ne,"tunnels"),Se.openTunnel(Ne,ne).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Ne,"tunnels"),Se.getTunnels()},onDidChangeTunnels:(ne,de,Re)=>((0,Ve.checkProposedApiEnabled)(Ne,"tunnels"),Se.onDidChangeTunnels(ne,de,Re)),registerPortAttributesProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"portsAttributes"),Se.registerPortsAttributesProvider(ne,de)),registerTimelineProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"timeline"),Ni.registerTimelineProvider(ne,de,Ne.identifier,et.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,Ve.checkProposedApiEnabled)(Ne,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,de,Re)=>ft.onDidGrantWorkspaceTrust(ne,de,Re),registerEditSessionIdentityProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,de))},Vt={get inputBox(){return fe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),oi.getLastInputBox(Ne)},createSourceControl(ne,de,Re){return oi.createSourceControl(Ne,ne,de,Re)}},hi={createCommentController(ne,de){return bi.createCommentController(Ne,ne,de)}},Wi={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ne,de,Re){return mt.onDidStartDebugSession(ne,de,Re)},onDidTerminateDebugSession(ne,de,Re){return mt.onDidTerminateDebugSession(ne,de,Re)},onDidChangeActiveDebugSession(ne,de,Re){return mt.onDidChangeActiveDebugSession(ne,de,Re)},onDidReceiveDebugSessionCustomEvent(ne,de,Re){return mt.onDidReceiveDebugSessionCustomEvent(ne,de,Re)},onDidChangeBreakpoints(ne,de,Re){return mt.onDidChangeBreakpoints(ne,de,Re)},registerDebugConfigurationProvider(ne,de,Re){return mt.registerDebugConfigurationProvider(ne,de,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,de){return mt.registerDebugAdapterDescriptorFactory(Ne,ne,de)},registerDebugAdapterTrackerFactory(ne,de){return mt.registerDebugAdapterTrackerFactory(ne,de)},startDebugging(ne,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?mt.startDebugging(ne,de,{parentSession:Re}):mt.startDebugging(ne,de,Re||{})},stopDebugging(ne){return mt.stopDebugging(ne)},addBreakpoints(ne){return mt.addBreakpoints(ne)},removeBreakpoints(ne){return mt.removeBreakpoints(ne)},asDebugSourceUri(ne,de){return mt.asDebugSourceUri(ne,de)}},Mt={registerTaskProvider:(ne,de)=>Et.registerTaskProvider(Ne,ne,de),fetchTasks:ne=>Et.fetchTasks(ne),executeTask:ne=>Et.executeTask(Ne,ne),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ne,de,Re)=>Et.onDidStartTask(ne,de,Re),onDidEndTask:(ne,de,Re)=>Et.onDidEndTask(ne,de,Re),onDidStartTaskProcess:(ne,de,Re)=>Et.onDidStartTaskProcess(ne,de,Re),onDidEndTaskProcess:(ne,de,Re)=>Et.onDidEndTaskProcess(ne,de,Re)},fi={createNotebookController(ne,de,Re,ot,St){return ri.createNotebookController(Ne,ne,de,Re,ot,(0,Ve.isProposedApiEnabled)(Ne,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ne,de)=>vt.registerNotebookCellStatusBarItemProvider(Ne,ne,de),createRendererMessaging(ne){return pi.createRendererMessaging(Ne,ne)},onDidChangeNotebookCellExecutionState(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),ri.onDidChangeNotebookCellExecutionState(ne,de,Re)}},Hi={t(...ne){if((0,Ve.checkProposedApiEnabled)(Ne,"localization"),typeof ne[0]=="string"){const de=ne.shift(),Re=!ne||typeof ne[0]!="object"?ne:ne[0];return kt.getMessage(Ne.identifier.value,{message:de,args:Re})}return kt.getMessage(Ne.identifier.value,ne[0])},get bundle(){return(0,Ve.checkProposedApiEnabled)(Ne,"localization"),kt.getBundle(Ne.identifier.value)},get uri(){return(0,Ve.checkProposedApiEnabled)(Ne,"localization"),kt.getBundleUri(Ne.identifier.value)}};return{version:ut.version,authentication:Ui,commands:Bi,comments:hi,debug:Wi,env:ei,extensions:zi,l10n:Hi,languages:$i,notebooks:fi,scm:Vt,tasks:Mt,tests:xi,window:Ii,workspace:Ri,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CommentThreadState:$.CommentThreadState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:$.InlineCompletionTriggerKindNew,EventEmitter:S.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionItemNew:$.InlineSuggestionNew,InlineCompletionList:$.InlineSuggestionList,InlineCompletionListNew:$.InlineSuggestionsNew,Hover:$.Hover,IndentAction:P.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,SnippetTextEdit:$.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItem2:$.TreeItem,TreeItemCheckboxState:$.TreeItemCheckboxState,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:k.UIKind,Uri:y.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,DocumentDropEdit:$.DocumentDropEdit,DocumentPasteEdit:$.DocumentPasteEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,NotebookControllerAffinity2:$.NotebookControllerAffinity2,NotebookEdit:$.NotebookEdit,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:$.DataTransfer,DataTransferItem:$.DataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind,InputBoxValidationSeverity:$.InputBoxValidationSeverity,TabInputText:$.TextTabInput,TabInputTextDiff:$.TextDiffTabInput,TabInputTextMerge:$.TextMergeTabInput,TabInputCustom:$.CustomEditorTabInput,TabInputNotebook:$.NotebookEditorTabInput,TabInputNotebookDiff:$.NotebookDiffEditorTabInput,TabInputWebview:$.WebviewEditorTabInput,TabInputTerminal:$.TerminalEditorTabInput,TabInputInteractiveWindow:$.InteractiveWindowInput,TerminalExitReason:$.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=_t}),define(Ce[239],Ie([1,0,238,33,2,232,6,15,223]),function(ie,e,r,C,S,M,y,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class P extends M.RequireInterceptor{_installInterceptor(){}getModule(k,p){for(const l of this._alternatives){const u=l(k);if(u){k=u;break}}if(this._factories.has(k))return this._factories.get(k).load(k,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(E.ExtHostConsoleForwarder);const k=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(P,k,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(k){return k.browser}async _loadCommonJSModule(k,p,l){p=p.with({path:b(p.path,".js")});const u=k?.identifier.value;u&&performance.mark(`code/extHost/willFetchExtensionCode/${u}`);const d=S.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(p)),g=await fetch(d.toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u}`),g.status!==200)throw new Error(g.statusText);const _=await g.text(),a=`${p.toString(!0)}#vscode-extension`,w=`${_}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",w)}catch(o){throw console.error(u?`Loading code for extension ${u} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${p.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}k&&await this._extHostLocalizationService.initializeLocalizedMessages(k);const c={},i={exports:c},n=o=>{const f=this._fakeModules.getModule(o,p);if(f===void 0)throw new Error(`Cannot load module '${o}'`);return f};try{return l.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u}`),t(i,c,n),i.exports!==c?i.exports:c}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u}`),l.codeLoadingStop()}}async $setRemoteEnvironment(k){}async _waitForDebuggerAttachment(k=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+k;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function b(m,k){return m.endsWith(k)?m:m+k}}),define(Ce[240],Ie([1,0,56,33,71,239]),function(ie,e,r,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(C.IExtHostExtensionService,M.ExtHostExtensionService,!1),(0,r.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths,!1)}),define(Ce[248],Ie([1,0,23,5,92,233,225,19,72,13,2,235,240]),function(ie,e,r,C,S,M,y,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function k(t){return/^(file|vscode-remote):/i.test(t)}const p=fetch.bind(self);function l(t){self.fetch=async function(c,i){return c instanceof Request||k(String(c))&&(c=(await t(O.URI.parse(String(c)))).toString(!0)),p(c,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,i,n,o,f){(async()=>(k(i.toString())&&(i=(await t(O.URI.parse(i.toString()))).toString(!0)),super.open(c,i,n??!0,o,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(c,i){if(/^file:/i.test(c.toString()))c=P.FileAccess.asBrowserUri(O.URI.parse(c.toString())).toString(!0);else if(/^vscode-remote:/i.test(c.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const o=`(${function(v){function T(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const N=fetch.bind(self);self.fetch=function(U,D){return U instanceof Request?N(U,D):N(T(U),D)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,D,x,L,R){return super.open(U,T(D),x??!0,L,R)}};const V=importScripts.bind(self);self.importScripts=(...U)=>{V(...U.map(T))},V(v)}.toString()}('${c}'))`;i=i||{},i.name=i.name||A.basename(c.toString());const f=new Blob([o],{type:"application/javascript"}),s=URL.createObjectURL(f);return new t(s,i)}}else self.Worker=class extends y.NestedWorker{constructor(t,c){super(m,t,{name:A.basename(t.toString()),...c})}};const u=new class{constructor(){this.pid=void 0}exit(t){b()}async exists(t){return!0}async realpath(t){return t}};class d{constructor(){const c=new MessageChannel,i=new C.Emitter;let n=!1;m(c.port2,[c.port2]),c.port1.onmessage=o=>{const{data:f}=o;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const s=r.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,S.isMessageOfType)(s,2)){n=!0,_("received terminate message from renderer");return}i.fire(s)},this.protocol={onMessage:i.event,send:o=>{if(!n){const f=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);c.port1.postMessage(f,[f])}}}}}function g(t){return new Promise(c=>{const i=t.onMessage(n=>{i.dispose();const o=JSON.parse(n.toString());t.send((0,S.createMessageOfType)(0)),c({protocol:t,initData:o})});t.send((0,S.createMessageOfType)(1))})}let _=t=>b();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function w(){E.mark("code/extHost/willConnectToRenderer");const t=new d;return{onmessage(c){!a(c)||g(t.protocol).then(i=>{E.mark("code/extHost/didWaitForInitData");const n=new M.ExtensionHostMain(i.protocol,i.initData,u,null,c.data);l(o=>n.asBrowserUri(o)),_=o=>n.terminate(o)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bd1b7a384f8a5ab9fb5a6a0e8fea370e589f43a3/core/vs/workbench/api/worker/extensionHostWorker.js.map
